// Note: Some Emscripten settings will significantly limit the speed of the generated code.
// Note: Some Emscripten settings may limit the speed of the generated code.
// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');
// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}
// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;
if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };
  var nodeFS = require('fs');
  var nodePath = require('path');
  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };
  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };
  Module['load'] = function load(f) {
    globalEval(read(f));
  };
  Module['arguments'] = process['argv'].slice(2);
  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm
  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }
  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };
  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }
  this['Module'] = Module;
  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };
  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }
  if (typeof console !== 'undefined') {
    Module['print'] = function print(x) {
      console.log(x);
    };
    Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }
  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}
function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***
// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];
// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];
// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}
// === Auto-generated preamble library stuff ===
//========================================
// Runtime code shared with compiler
//========================================
var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?{ ?[^}]* ?}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (vararg) return 8;
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + Pointer_stringify(code) + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;
      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }
      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }
      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}
//========================================
// Runtime essentials
//========================================
var __THREW__ = 0; // Used in checking for thrown exceptions.
var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;
var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;
function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}
var globalScope = this;
// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;
// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}
// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}
// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;
// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;
// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;
var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;
// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }
  var singleType = typeof types === 'string' ? types : null;
  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }
  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }
  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }
  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];
    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }
    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }
    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later
    setValue(ret+i, curr, type);
    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }
  return ret;
}
Module['allocate'] = allocate;
function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;
  var ret = '';
  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }
  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;
// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;
  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;
// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;
// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;
  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;
// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;
function demangle(func) {
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    var i = 3;
    // params, etc.
    var basicTypes = {
      'v': 'void',
      'b': 'bool',
      'c': 'char',
      's': 'short',
      'i': 'int',
      'l': 'long',
      'f': 'float',
      'd': 'double',
      'w': 'wchar_t',
      'a': 'signed char',
      'h': 'unsigned char',
      't': 'unsigned short',
      'j': 'unsigned int',
      'm': 'unsigned long',
      'x': 'long long',
      'y': 'unsigned long long',
      'z': '...'
    };
    function dump(x) {
      //return;
      if (x) Module.print(x);
      Module.print(func);
      var pre = '';
      for (var a = 0; a < i; a++) pre += ' ';
      Module.print (pre + '^');
    }
    var subs = [];
    function parseNested() {
      i++;
      if (func[i] === 'K') i++; // ignore const
      var parts = [];
      while (func[i] !== 'E') {
        if (func[i] === 'S') { // substitution
          i++;
          var next = func.indexOf('_', i);
          var num = func.substring(i, next) || 0;
          parts.push(subs[num] || '?');
          i = next+1;
          continue;
        }
        if (func[i] === 'C') { // constructor
          parts.push(parts[parts.length-1]);
          i += 2;
          continue;
        }
        var size = parseInt(func.substr(i));
        var pre = size.toString().length;
        if (!size || !pre) { i--; break; } // counter i++ below us
        var curr = func.substr(i + pre, size);
        parts.push(curr);
        subs.push(curr);
        i += pre + size;
      }
      i++; // skip E
      return parts;
    }
    var first = true;
    function parse(rawList, limit, allowVoid) { // main parser
      limit = limit || Infinity;
      var ret = '', list = [];
      function flushList() {
        return '(' + list.join(', ') + ')';
      }
      var name;
      if (func[i] === 'N') {
        // namespaced N-E
        name = parseNested().join('::');
        limit--;
        if (limit === 0) return rawList ? [name] : name;
      } else {
        // not namespaced
        if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
        var size = parseInt(func.substr(i));
        if (size) {
          var pre = size.toString().length;
          name = func.substr(i + pre, size);
          i += pre + size;
        }
      }
      first = false;
      if (func[i] === 'I') {
        i++;
        var iList = parse(true);
        var iRet = parse(true, 1, true);
        ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
      } else {
        ret = name;
      }
      paramLoop: while (i < func.length && limit-- > 0) {
        //dump('paramLoop');
        var c = func[i++];
        if (c in basicTypes) {
          list.push(basicTypes[c]);
        } else {
          switch (c) {
            case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
            case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
            case 'L': { // literal
              i++; // skip basic type
              var end = func.indexOf('E', i);
              var size = end - i;
              list.push(func.substr(i, size));
              i += size + 2; // size + 'EE'
              break;
            }
            case 'A': { // array
              var size = parseInt(func.substr(i));
              i += size.toString().length;
              if (func[i] !== '_') throw '?';
              i++; // skip _
              list.push(parse(true, 1, true)[0] + ' [' + size + ']');
              break;
            }
            case 'E': break paramLoop;
            default: ret += '?' + c; break paramLoop;
          }
        }
      }
      if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
      return rawList ? list : ret + flushList();
    }
    return parse();
  } catch(e) {
    return func;
  }
}
function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}
function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}
// Memory management
var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}
var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;
var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk
function enlargeMemory() {
  abort('Cannot enlarge memory arrays in asm.js. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', or (2) set Module.TOTAL_MEMORY before the program runs.');
}
var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 16777216;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;
var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}
// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'Cannot fallback to non-typed array case: Code is too specialized');
var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);
// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');
Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;
function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}
var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited
var runtimeInitialized = false;
function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}
function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}
function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}
function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}
function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}
function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;
function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;
function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;
function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;
function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;
// Tools
// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;
function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;
// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;
function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;
function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;
function unSign(value, bits, ignore, sig) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore, sig) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}
if (!Math['imul']) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];
var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;
// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled
function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;
Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data
var memoryInitializer = null;
// === Body ===
STATIC_BASE = 8;
STATICTOP = STATIC_BASE + 40960;
var _stdout;
var _stdout=_stdout=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var _stdin;
var _stdin=_stdin=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var _stderr;
var _stderr=_stderr=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
/* global initializers */ __ATINIT__.push({ func: function() { runPostSets() } },{ func: function() { __GLOBAL__I_a() } });
var ___fsmu8;
var ___dso_handle;
var ___dso_handle=___dso_handle=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZTVN10__cxxabiv120__si_class_type_infoE;
__ZTVN10__cxxabiv120__si_class_type_infoE=allocate([0,0,0,0,176,121,0,0,36,1,0,0,210,0,0,0,48,0,0,0,120,1,0,0,4,0,0,0,4,0,0,0,22,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZTVN10__cxxabiv117__class_type_infoE;
__ZTVN10__cxxabiv117__class_type_infoE=allocate([0,0,0,0,192,121,0,0,36,1,0,0,144,0,0,0,48,0,0,0,120,1,0,0,4,0,0,0,14,0,0,0,6,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);
var __ZN4Sass7ContextC1ENS0_4DataE;
var __ZN4Sass7ContextD1Ev;
var __ZN4Sass13ContextualizeC1ERNS_7ContextEPNS_4EvalEPNS_11EnvironmentIPNS_8AST_NodeEEEPNS_9BacktraceEPNS_8SelectorESD_;
var __ZN4Sass13ContextualizeD1Ev;
var __ZN4Sass5ErrorC1ENS0_4TypeENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEENS_8PositionES8_;
var __ZN4Sass4EvalC1ERNS_7ContextEPNS_11EnvironmentIPNS_8AST_NodeEEEPNS_9BacktraceE;
var __ZN4Sass4EvalD1Ev;
var __ZN4Sass6ExpandC1ERNS_7ContextEPNS_4EvalEPNS_13ContextualizeEPNS_11EnvironmentIPNS_8AST_NodeEEEPNS_9BacktraceE;
var __ZN4Sass6ExtendC1ERNS_7ContextERNSt3__18multimapINS_17Compound_SelectorEPNS_16Complex_SelectorENS3_4lessIS5_EENS3_9allocatorINS3_4pairIKS5_S7_EEEEEEPNS_9BacktraceE;
var __ZN4Sass7InspectC1EPNS_7ContextE;
var __ZN4Sass7InspectD1Ev;
var __ZN4Sass17Output_CompressedC1EPNS_7ContextE;
var __ZN4Sass17Output_CompressedD1Ev;
var __ZN4Sass13Output_NestedC1EbPNS_7ContextE;
var __ZN4Sass13Output_NestedD1Ev;
var __ZN4Sass9SourceMapC1ERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE;
var __ZN4Sass9To_StringC1EPNS_7ContextE;
var __ZN4Sass9To_StringD1Ev;
var __ZNSt13runtime_errorC1EPKc;
var __ZNSt13runtime_errorD1Ev;
var __ZNSt12length_errorD1Ev;
var __ZNSt12out_of_rangeD1Ev;
var __ZNSt3__16localeC1Ev;
var __ZNSt3__16localeC1ERKS0_;
var __ZNSt3__16localeD1Ev;
var __ZNSt8bad_castC1Ev;
var __ZNSt8bad_castD1Ev;
/* memory initializer */ allocate([0,0,0,0,0,0,36,64,0,0,0,0,0,0,89,64,0,0,0,0,0,136,195,64,0,0,0,0,132,215,151,65,0,128,224,55,121,195,65,67,23,110,5,181,181,184,147,70,245,249,63,233,3,79,56,77,50,29,48,249,72,119,130,90,60,191,115,127,221,79,21,117,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,99,111,109,112,97,99,116,40,36,118,97,108,117,101,115,46,46,46,41,0,0,0,0,0,74,117,108,0,0,0,0,0,109,111,99,99,97,115,105,110,0,0,0,0,0,0,0,0,36,108,105,115,116,115,0,0,74,117,110,0,0,0,0,0,109,105,115,116,121,114,111,115,101,0,0,0,0,0,0,0,122,105,112,40,36,108,105,115,116,115,46,46,46,41,0,0,65,112,114,0,0,0,0,0,109,105,110,116,99,114,101,97,109,0,0,0,0,0,0,0,102,105,108,101,32,116,111,32,105,109,112,111,114,116,32,110,111,116,32,102,111,117,110,100,32,111,114,32,117,110,114,101,97,100,97,98,108,101,58,32,0,0,0,0,0,0,0,0,77,97,114,0,0,0,0,0,109,105,100,110,105,103,104,116,98,108,117,101,0,0,0,0,32,33,100,101,102,97,117,108,116,0,0,0,0,0,0,0,105,110,0,0,0,0,0,0,97,112,112,101,110,100,40,36,108,105,115,116,44,32,36,118,97,108,44,32,36,115,101,112,97,114,97,116,111,114,58,32,97,117,116,111,41,0,0,0,70,101,98,0,0,0,0,0,109,101,100,105,117,109,118,105,111,108,101,116,114,101,100,0,96,32,109,117,115,116,32,98,101,32,96,115,112,97,99,101,96,44,32,96,99,111,109,109,97,96,44,32,111,114,32,96,97,117,116,111,96,0,0,0,74,97,110,0,0,0,0,0,109,101,100,105,117,109,116,117,114,113,117,111,105,115,101,0,97,114,103,117,109,101,110,116,32,96,36,115,101,112,97,114,97,116,111,114,96,32,111,102,32,96,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,109,101,100,105,117,109,115,112,114,105,110,103,103,114,101,101,110,0,0,0,0,0,0,0,36,98,108,117,101,0,0,0,98,108,117,101,0,0,0,0,97,117,116,111,0,0,0,0,91,102,93,0,0,0,0,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,109,101,100,105,117,109,115,108,97,116,101,98,108,117,101,0,96,0,0,0,0,0,0,0,99,111,109,109,97,0,0,0,79,99,116,111,98,101,114,0,109,101,100,105,117,109,115,101,97,103,114,101,101,110,0,0,115,112,97,99,101,0,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,109,101,100,105,117,109,112,117,114,112,108,101,0,0,0,0,112,114,111,118,105,100,101,100,32,109,111,114,101,32,116,104,97,110,32,111,110,99,101,32,105,110,32,99,97,108,108,32,116,111,32,0,0,0,0,0,36,115,101,112,97,114,97,116,111,114,0,0,0,0,0,0,65,117,103,117,115,116,0,0,109,101,100,105,117,109,111,114,99,104,105,100,0,0,0,0,36,108,105,115,116,50,0,0,74,117,108,121,0,0,0,0,109,101,100,105,117,109,98,108,117,101,0,0,0,0,0,0,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,112,97,114,97,109,101,116,101,114,32,109,97,121,32,110,111,116,32,104,97,118,101,32,97,32,100,101,102,97,117,108,116,32,118,97,108,117,101,0,0,36,108,105,115,116,49,0,0,74,117,110,101,0,0,0,0,109,101,100,105,117,109,97,113,117,97,109,97,114,105,110,101,0,0,0,0,0,0,0,0,117,114,108,0,0,0,0,0,106,111,105,110,40,36,108,105,115,116,49,44,32,36,108,105,115,116,50,44,32,36,115,101,112,97,114,97,116,111,114,58,32,97,117,116,111,41,0,0,44,0,0,0,0,0,0,0,77,97,121,0,0,0,0,0,109,97,114,111,111,110,0,0,32,33,105,109,112,111,114,116,97,110,116,0,0,0,0,0,105,110,100,101,120,40,36,108,105,115,116,44,32,36,118,97,108,117,101,41,0,0,0,0,65,112,114,105,108,0,0,0,109,97,103,101,110,116,97,0,96,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,32,49,0,0,0,0,77,97,114,99,104,0,0,0,108,105,110,101,110,0,0,0,97,114,103,117,109,101,110,116,32,96,36,110,96,32,111,102,32,96,0,0,0,0,0,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,108,105,109,101,103,114,101,101,110,0,0,0,0,0,0,0,36,103,114,101,101,110,0,0,98,108,97,110,99,104,101,100,97,108,109,111,110,100,0,0,96,32,109,117,115,116,32,110,111,116,32,98,101,32,101,109,112,116,121,0,0,0,0,0,91,109,93,0,0,0,0,0,74,97,110,117,97,114,121,0,108,105,109,101,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,44,32,105,110,32,102,117,110,99,116,105,111,110,32,96,0,97,114,103,117,109,101,110,116,32,96,36,108,105,115,116,96,32,111,102,32,96,0,0,0,108,105,103,104,116,121,101,108,108,111,119,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,108,105,103,104,116,115,116,101,101,108,98,108,117,101,0,0,99,97,110,110,111,116,32,98,101,32,117,115,101,100,32,97,115,32,110,97,109,101,100,32,97,114,103,117,109,101,110,116,0,0,0,0,0,0,0,0,111,110,108,121,32,85,84,70,45,56,32,100,111,99,117,109,101,110,116,115,32,97,114,101,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,101,100,59,32,121,111,117,114,32,100,111,99,117,109,101,110,116,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,0,0,0,0,0,0,110,116,104,40,36,108,105,115,116,44,32,36,110,41,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,108,105,103,104,116,115,108,97,116,101,103,114,101,121,0,0,71,66,45,49,56,48,51,48,0,0,0,0,0,0,0,0,36,108,105,115,116,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,108,105,103,104,116,115,108,97,116,101,103,114,97,121,0,0,66,79,67,85,45,49,0,0,108,101,110,103,116,104,40,36,108,105,115,116,41,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,108,105,103,104,116,115,107,121,98,108,117,101,0,0,0,0,83,67,83,85,0,0,0,0,64,109,101,100,105,97,32,0,109,97,120,40,36,120,50,44,32,36,120,50,46,46,46,41,0,0,0,0,0,0,0,0,33,105,109,112,111,114,116,97,110,116,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,108,105,103,104,116,115,101,97,103,114,101,101,110,0,0,0,85,84,70,45,69,66,67,68,73,67,0,0,0,0,0,0,96,32,111,110,108,121,32,116,97,107,101,115,32,110,117,109,101,114,105,99,32,97,114,103,117,109,101,110,116,115,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,108,105,103,104,116,115,97,108,109,111,110,0,0,0,0,0,85,84,70,45,49,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,108,105,103,104,116,112,105,110,107,0,0,0,0,0,0,0,85,84,70,45,55,0,0,0,36,120,50,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,108,105,103,104,116,103,114,101,101,110,0,0,0,0,0,0,85,84,70,45,51,50,32,40,98,105,103,32,101,110,100,105,97,110,41,0,0,0,0,0,36,120,49,0,0,0,0,0,98,108,97,99,107,0,0,0,110,101,115,116,101,100,32,115,101,108,101,99,116,111,114,115,32,109,97,121,32,110,111,116,32,98,101,32,101,120,116,101,110,100,101,100,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,108,105,103,104,116,103,114,101,121,0,0,0,0,0,0,0,102,117,110,99,116,105,111,110,32,0,0,0,0,0,0,0,85,84,70,45,51,50,32,40,108,105,116,116,108,101,32,101,110,100,105,97,110,41,0,0,109,105,110,40,36,120,49,44,32,36,120,50,46,46,46,41,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,108,105,103,104,116,103,114,97,121,0,0,0,0,0,0,0,85,84,70,45,49,54,32,40,108,105,116,116,108,101,32,101,110,100,105,97,110,41,0,0,97,98,115,40,36,118,97,108,117,101,41,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,108,105,103,104,116,103,111,108,100,101,110,114,111,100,121,101,108,108,111,119,0,0,0,0,32,111,102,32,0,0,0,0,85,84,70,45,49,54,32,40,98,105,103,32,101,110,100,105,97,110,41,0,0,0,0,0,102,108,111,111,114,40,36,118,97,108,117,101,41,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,108,105,103,104,116,99,121,97,110,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,99,101,105,108,40,36,118,97,108,117,101,41,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,108,105,103,104,116,99,111,114,97,108,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,112,97,114,101,110,116,104,101,115,105,115,32,105,110,32,109,101,100,105,97,32,113,117,101,114,121,32,101,120,112,114,101,115,115,105,111,110,0,0,114,111,117,110,100,40,36,118,97,108,117,101,41,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,108,105,103,104,116,98,108,117,101,0,0,0,0,0,0,0,109,101,100,105,97,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,100,32,105,110,32,109,101,100,105,97,32,113,117,101,114,121,32,101,120,112,114,101,115,115,105,111,110,0,0,0,0,0,0,0,0,46,99,115,115,0,0,0,0,32,125,10,0,0,0,0,0,96,32,109,117,115,116,32,98,101,32,117,110,105,116,108,101,115,115,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,108,101,109,111,110,99,104,105,102,102,111,110,0,0,0,0,32,0,0,0,0,0,0,0,109,101,100,105,97,32,113,117,101,114,121,32,101,120,112,114,101,115,115,105,111,110,32,109,117,115,116,32,98,101,103,105,110,32,119,105,116,104,32,39,40,39,0,0,0,0,0,0,97,114,103,117,109,101,110,116,32,36,118,97,108,117,101,32,111,102,32,96,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,116,111,112,45,108,101,118,101,108,32,64,105,109,112,111,114,116,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,0,108,97,119,110,103,114,101,101,110,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,123,39,32,105,110,32,109,101,100,105,97,32,113,117,101,114,121,0,0,0,0,0,36,118,97,108,117,101,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,108,97,118,101,110,100,101,114,98,108,117,115,104,0,0,0,101,120,112,101,99,116,101,100,32,39,123,39,32,97,102,116,101,114,32,116,104,101,32,117,112,112,101,114,32,98,111,117,110,100,32,105,110,32,64,101,97,99,104,32,100,105,114,101,99,116,105,118,101,0,0,0,112,101,114,99,101,110,116,97,103,101,40,36,118,97,108,117,101,41,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,108,97,118,101,110,100,101,114,0,0,0,0,0,0,0,0,114,103,98,40,36,114,101,100,44,32,36,103,114,101,101,110,44,32,36,98,108,117,101,41,0,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,105,110,39,32,107,101,121,119,111,114,100,32,105,110,32,64,101,97,99,104,32,100,105,114,101,99,116,105,118,101,0,0,0,0,0,0,0,0,113,117,111,116,101,40,36,115,116,114,105,110,103,41,0,0,98,105,115,113,117,101,0,0,115,101,108,101,99,116,111,114,32,103,114,111,117,112,115,32,109,97,121,32,110,111,116,32,98,101,32,101,120,116,101,110,100,101,100,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,107,104,97,107,105,0,0,0,91,102,93,0,0,0,0,0,64,101,97,99,104,32,100,105,114,101,99,116,105,118,101,32,114,101,113,117,105,114,101,115,32,97,110,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,0,0,36,115,116,114,105,110,103,0,105,118,111,114,121,0,0,0,101,120,112,101,99,116,101,100,32,39,123,39,32,97,102,116,101,114,32,116,104,101,32,117,112,112,101,114,32,98,111,117,110,100,32,105,110,32,64,102,111,114,32,100,105,114,101,99,116,105,118,101,0,0,0,0,117,110,113,117,111,116,101,40,36,115,116,114,105,110,103,41,0,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,105,110,100,105,103,111,0,0,97,114,103,117,109,101,110,116,32,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,116,104,114,111,117,103,104,39,32,111,114,32,39,116,111,39,32,107,101,121,119,111,100,32,105,110,32,64,102,111,114,32,100,105,114,101,99,116,105,118,101,0,0,0,0,0,112,120,0,0,0,0,0,0,105,101,45,104,101,120,45,115,116,114,40,36,99,111,108,111,114,41,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,105,110,100,105,97,110,114,101,100,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,102,114,111,109,39,32,107,101,121,119,111,114,100,32,105,110,32,64,102,111,114,32,100,105,114,101,99,116,105,118,101,0,0,0,0,0,0,0,110,111,116,32,101,110,111,117,103,104,32,97,114,103,117,109,101,110,116,115,32,102,111,114,32,96,99,104,97,110,103,101,45,99,111,108,111,114,96,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,104,111,116,112,105,110,107,0,64,102,111,114,32,100,105,114,101,99,116,105,118,101,32,114,101,113,117,105,114,101,115,32,97,110,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,0,0,0,58,110,111,116,40,0,0,0,99,97,110,110,111,116,32,115,112,101,99,105,102,121,32,98,111,116,104,32,82,71,66,32,97,110,100,32,72,83,76,32,118,97,108,117,101,115,32,102,111,114,32,96,99,104,97,110,103,101,45,99,111,108,111,114,96,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,104,111,110,101,121,100,101,119,0,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,39,123,39,32,97,102,116,101,114,32,64,101,108,115,101,0,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,116,111,112,45,108,101,118,101,108,32,101,120,112,114,101,115,115,105,111,110,0,0,0,0,32,123,10,0,0,0,0,0,99,104,97,110,103,101,45,99,111,108,111,114,40,36,99,111,108,111,114,44,32,36,114,101,100,58,32,102,97,108,115,101,44,32,36,103,114,101,101,110,58,32,102,97,108,115,101,44,32,36,98,108,117,101,58,32,102,97,108,115,101,44,32,36,104,117,101,58,32,102,97,108,115,101,44,32,36,115,97,116,117,114,97,116,105,111,110,58,32,102,97,108,115,101,44,32,36,108,105,103,104,116,110,101,115,115,58,32,102,97,108,115,101,44,32,36,97,108,112,104,97,58,32,102,97,108,115,101,41,0,0,0,0,0,0,0,103,114,101,101,110,121,101,108,108,111,119,0,0,0,0,0,64,109,101,100,105,97,32,0,101,120,112,101,99,116,101,100,32,39,123,39,32,97,102,116,101,114,32,116,104,101,32,112,114,101,100,105,99,97,116,101,32,102,111,114,32,64,105,102,0,0,0,0,0,0,0,0,110,111,116,32,101,110,111,117,103,104,32,97,114,103,117,109,101,110,116,115,32,102,111,114,32,96,115,99,97,108,101,45,99,111,108,111,114,96,0,0,80,77,0,0,0,0,0,0,103,114,101,101,110,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,105,110,116,101,114,112,111,108,97,110,116,32,105,110,115,105,100,101,32,105,110,116,101,114,112,111,108,97,116,101,100,32,105,100,101,110,116,105,102,105,101,114,32,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,112,101,99,105,102,121,32,98,111,116,104,32,82,71,66,32,97,110,100,32,72,83,76,32,118,97,108,117,101,115,32,102,111,114,32,96,115,99,97,108,101,45,99,111,108,111,114,96,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,103,114,101,121,0,0,0,0,101,114,114,111,114,32,112,97,114,115,105,110,103,32,105,110,116,101,114,112,111,108,97,116,101,100,32,117,114,108,0,0,46,46,46,0,0,0,0,0,115,99,97,108,101,45,99,111,108,111,114,40,36,99,111,108,111,114,44,32,36,114,101,100,58,32,102,97,108,115,101,44,32,36,103,114,101,101,110,58,32,102,97,108,115,101,44,32,36,98,108,117,101,58,32,102,97,108,115,101,44,32,36,104,117,101,58,32,102,97,108,115,101,44,32,36,115,97,116,117,114,97,116,105,111,110,58,32,102,97,108,115,101,44,32,36,108,105,103,104,116,110,101,115,115,58,32,102,97,108,115,101,44,32,36,97,108,112,104,97,58,32,102,97,108,115,101,41,0,0,0,0,0,0,0,0,103,114,97,121,0,0,0,0,32,97,110,100,32,0,0,0,101,114,114,111,114,32,112,97,114,115,105,110,103,32,105,110,116,101,114,112,111,108,97,116,101,100,32,118,97,108,117,101,0,0,0,0,0,0,0,0,110,111,116,32,101,110,111,117,103,104,32,97,114,103,117,109,101,110,116,115,32,102,111,114,32,96,97,100,106,117,115,116,45,99,111,108,111,114,96,0,64,114,101,116,117,114,110,32,109,97,121,32,111,110,108,121,32,98,101,32,117,115,101,100,32,119,105,116,104,105,110,32,97,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,98,101,105,103,101,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,103,111,108,100,101,110,114,111,100,0,0,0,0,0,0,0,99,97,108,99,0,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,105,110,116,101,114,112,111,108,97,110,116,32,105,110,115,105,100,101,32,73,69,32,102,117,110,99,116,105,111,110,32,0,0,0,0,58,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,112,101,99,105,102,121,32,98,111,116,104,32,82,71,66,32,97,110,100,32,72,83,76,32,118,97,108,117,101,115,32,102,111,114,32,96,97,100,106,117,115,116,45,99,111,108,111,114,96,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,103,111,108,100,0,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,105,110,116,101,114,112,111,108,97,110,116,32,105,110,115,105,100,101,32,115,116,114,105,110,103,32,99,111,110,115,116,97,110,116,32,0,0,0,0,0,0,0,0,97,100,106,117,115,116,45,99,111,108,111,114,40,36,99,111,108,111,114,44,32,36,114,101,100,58,32,102,97,108,115,101,44,32,36,103,114,101,101,110,58,32,102,97,108,115,101,44,32,36,98,108,117,101,58,32,102,97,108,115,101,44,32,36,104,117,101,58,32,102,97,108,115,101,44,32,36,115,97,116,117,114,97,116,105,111,110,58,32,102,97,108,115,101,44,32,36,108,105,103,104,116,110,101,115,115,58,32,102,97,108,115,101,44,32,36,97,108,112,104,97,58,32,102,97,108,115,101,41,0,0,0,0,0,0,0,103,104,111,115,116,119,104,105,116,101,0,0,0,0,0,0,32,104,97,115,32,110,111,32,112,97,114,97,109,101,116,101,114,32,110,97,109,101,100,32,0,0,0,0,0,0,0,0,101,114,114,111,114,32,114,101,97,100,105,110,103,32,118,97,108,117,101,115,32,97,102,116,101,114,32,0,0,0,0,0,111,110,108,121,32,0,0,0,112,116,0,0,0,0,0,0,102,97,100,101,45,111,117,116,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,103,97,105,110,115,98,111,114,111,0,0,0,0,0,0,0,33,105,109,112,111,114,116,97,110,116,0,0,0,0,0,0,116,114,97,110,115,112,97,114,101,110,116,105,122,101,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,102,117,99,104,115,105,97,0,117,110,97,98,108,101,32,116,111,32,112,97,114,115,101,32,85,82,76,0,0,0,0,0,102,97,100,101,45,105,110,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,0,102,111,114,101,115,116,103,114,101,101,110,0,0,0,0,0,85,82,73,32,105,115,32,109,105,115,115,105,110,103,32,39,41,39,0,0,0,0,0,0,102,97,108,115,101,0,0,0,116,111,112,45,108,101,118,101,108,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,0,32,42,47,0,0,0,0,0,111,112,97,99,105,102,121,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,102,108,111,114,97,108,119,104,105,116,101,0,0,0,0,0,117,110,99,108,111,115,101,100,32,112,97,114,101,110,116,104,101,115,105,115,0,0,0,0,116,114,117,101,0,0,0,0,41,0,0,0,0,0,0,0,102,105,114,101,98,114,105,99,107,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,114,103,98,97,40,0,0,0,97,108,112,104,97,40,0,0,100,111,100,103,101,114,98,108,117,101,0,0,0,0,0,0,42,0,0,0,0,0,0,0,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,67,83,83,32,118,97,108,117,101,0,0,0,0,0,0,0,111,112,97,99,105,116,121,40,36,99,111,108,111,114,41,0,100,105,109,103,114,101,121,0,96,32,109,117,115,116,32,98,101,32,98,101,116,119,101,101,110,32,0,0,0,0,0,0,43,0,0,0,0,0,0,0,97,108,112,104,97,40,36,99,111,108,111,114,41,0,0,0,97,122,117,114,101,0,0,0,100,105,109,103,114,97,121,0,115,116,121,108,101,32,100,101,99,108,97,114,97,116,105,111,110,32,109,117,115,116,32,99,111,110,116,97,105,110,32,97,32,118,97,108,117,101,0,0,32,0,0,0,0,0,0,0,105,110,118,101,114,116,40,36,99,111,108,111,114,41,0,0,100,101,101,112,115,107,121,98,108,117,101,0,0,0,0,0,34,32,109,117,115,116,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,97,32,39,58,39,0,0,0,0,0,32,37,32,0,0,0,0,0,99,111,109,112,108,101,109,101,110,116,40,36,99,111,108,111,114,41,0,0,0,0,0,0,115,116,114,105,110,103,0,0,100,101,101,112,112,105,110,107,0,0,0,0,0,0,0,0,32,112,114,111,118,105,100,101,100,32,109,111,114,101,32,116,104,97,110,32,111,110,99,101,32,105,110,32,99,97,108,108,32,116,111,32,0,0,0,0,112,114,111,112,101,114,116,121,32,34,0,0,0,0,0,0,109,109,0,0,0,0,0,0,103,114,97,121,115,99,97,108,101,40,36,99,111,108,111,114,41,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,58,32,101,114,114,111,114,58,32,0,0,0,0,0,0,0,100,97,114,107,118,105,111,108,101,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,112,114,111,112,101,114,116,121,32,110,97,109,101,0,0,0,32,42,32,0,0,0,0,0,100,101,115,97,116,117,114,97,116,101,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,32,109,97,121,32,110,111,116,32,98,101,32,112,97,115,115,101,100,32,98,121,32,110,97,109,101,0,0,0,0,0,0,100,97,114,107,116,117,114,113,117,111,105,115,101,0,0,0,105,110,118,97,108,105,100,32,115,101,108,101,99,116,111,114,32,102,111,114,32,64,101,120,116,101,110,100,0,0,0,0,32,45,32,0,0,0,0,0,115,97,116,117,114,97,116,101,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,111,114,100,105,110,97,108,32,97,114,103,117,109,101,110,116,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,110,97,109,101,100,32,97,114,103,117,109,101,110,116,115,0,0,100,97,114,107,115,108,97,116,101,103,114,101,121,0,0,0,64,99,111,110,116,101,110,116,32,109,97,121,32,111,110,108,121,32,98,101,32,117,115,101,100,32,119,105,116,104,105,110,32,97,32,109,105,120,105,110,0,0,0,0,0,0,0,0,32,43,32,0,0,0,0,0,116,111,112,45,108,101,118,101,108,32,64,119,97,114,110,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,0,0,0,44,32,0,0,0,0,0,0,100,97,114,107,115,108,97,116,101,103,114,97,121,0,0,0,100,97,114,107,101,110,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,64,109,101,100,105,97,32,0,111,114,100,105,110,97,108,32,97,114,103,117,109,101,110,116,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,115,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,112,97,114,97,109,101,116,101,114,32,0,0,0,0,0,0,111,110,108,121,32,118,97,114,105,97,98,108,101,32,100,101,99,108,97,114,97,116,105,111,110,115,32,97,110,100,32,99,111,110,116,114,111,108,32,100,105,114,101,99,116,105,118,101,115,32,97,114,101,32,97,108,108,111,119,101,100,32,105,110,115,105,100,101,32,102,117,110,99,116,105,111,110,115,0,0,36,97,109,111,117,110,116,0,102,117,110,99,116,105,111,110,115,32,97,110,100,32,109,105,120,105,110,115,32,109,97,121,32,110,111,116,32,98,101,32,99,97,108,108,101,100,32,119,105,116,104,32,98,111,116,104,32,110,97,109,101,100,32,97,114,103,117,109,101,110,116,115,32,97,110,100,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,115,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,100,97,114,107,115,108,97,116,101,98,108,117,101,0,0,0,64,105,109,112,111,114,116,32,100,105,114,101,99,116,105,118,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,115,105,100,101,32,109,105,120,105,110,115,32,97,110,100,32,102,117,110,99,116,105,111,110,115,0,0,32,60,32,0,0,0,0,0,108,105,103,104,116,101,110,40,36,99,111,108,111,114,44,32,36,97,109,111,117,110,116,41,0,0,0,0,0,0,0,0,102,117,110,99,116,105,111,110,115,32,97,110,100,32,109,105,120,105,110,115,32,109,97,121,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,119,105,116,104,32,111,110,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,100,97,114,107,115,101,97,103,114,101,101,110,0,0,0,0,110,111,110,45,116,101,114,109,105,110,97,108,32,115,116,97,116,101,109,101,110,116,32,111,114,32,100,101,99,108,97,114,97,116,105,111,110,32,109,117,115,116,32,101,110,100,32,119,105,116,104,32,39,59,39,0,110,97,109,101,100,32,97,114,103,117,109,101,110,116,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,97,114,103,117,109,101,110,116,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,100,97,114,107,115,97,108,109,111,110,0,0,0,0,0,0,96,32,111,102,32,96,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,97,116,116,114,105,98,117,116,101,32,115,101,108,101,99,116,111,114,32,102,111,114,32,0,0,0,0,32,62,32,0,0,0,0,0,46,115,99,115,115,0,0,0,97,100,106,117,115,116,45,104,117,101,40,36,99,111,108,111,114,44,32,36,100,101,103,114,101,101,115,41,0,0,0,0,117,112,112,101,114,32,98,111,117,110,100,32,111,102,32,96,64,102,111,114,96,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,110,117,109,101,114,105,99,0,110,117,109,98,101,114,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,97,113,117,97,109,97,114,105,110,101,0,0,0,0,0,0,100,97,114,107,114,101,100,0,87,65,82,78,73,78,71,58,32,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,97,32,115,116,114,105,110,103,32,99,111,110,115,116,97,110,116,32,111,114,32,105,100,101,110,116,105,102,105,101,114,32,105,110,32,97,116,116,114,105,98,117,116,101,32,115,101,108,101,99,116,111,114,32,102,111,114,32,0,0,0,0,0,9,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,108,105,103,104,116,110,101,115,115,40,36,99,111,108,111,114,41,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,100,97,114,107,111,114,99,104,105,100,0,0,0,0,0,0,105,110,118,97,108,105,100,32,111,112,101,114,97,116,111,114,32,105,110,32,97,116,116,114,105,98,117,116,101,32,115,101,108,101,99,116,111,114,32,102,111,114,32,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,100,97,114,107,111,114,97,110,103,101,0,0,0,0,0,0,32,111,110,108,121,32,116,97,107,101,115,32,0,0,0,0,105,110,118,97,108,105,100,32,97,116,116,114,105,98,117,116,101,32,110,97,109,101,32,105,110,32,97,116,116,114,105,98,117,116,101,32,115,101,108,101,99,116,111,114,0,0,0,0,112,99,0,0,0,0,0,0,115,97,116,117,114,97,116,105,111,110,40,36,99,111,108,111,114,41,0,0,0,0,0,0,114,101,113,117,105,114,101,100,32,112,97,114,97,109,101,116,101,114,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,111,112,116,105,111,110,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,58,0,0,0,0,0,0,0,100,97,114,107,111,108,105,118,101,103,114,101,101,110,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,112,115,101,117,100,111,45,99,108,97,115,115,32,111,114,32,112,115,101,117,100,111,45,101,108,101,109,101,110,116,0,0,0,0,0,32,97,110,100,32,0,0,0,100,101,103,0,0,0,0,0,114,101,113,117,105,114,101,100,32,112,97,114,97,109,101,116,101,114,115,32,109,117,115,116,32,112,114,101,99,101,100,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,101,114,114,111,114,32,105,110,32,67,32,102,117,110,99,116,105,111,110,58,32,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,100,97,114,107,109,97,103,101,110,116,97,0,0,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,97,114,103,117,109,101,110,116,32,116,111,32,0,0,0,0,0,0,0,44,32,0,0,0,0,0,0,37,112,0,0,0,0,0,0,104,117,101,40,36,99,111,108,111,114,41,0,0,0,0,0,102,97,108,115,101,0,0,0,102,117,110,99,116,105,111,110,115,32,97,110,100,32,109,105,120,105,110,115,32,99,97,110,110,111,116,32,104,97,118,101,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,112,97,114,97,109,101,116,101,114,0,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,111,112,101,114,97,110,100,115,32,102,111,114,32,109,111,100,117,108,111,0,0,0,0,0,100,97,114,107,107,104,97,107,105,0,0,0,0,0,0,0,91,98,117,105,108,116,45,105,110,32,102,117,110,99,116,105,111,110,93,0,0,0,0,0,46,46,46,41,0,0,0,0,64,99,111,110,116,101,110,116,59,0,0,0,0,0,0,0,116,111,112,45,108,101,118,101,108,32,64,105,110,99,108,117,100,101,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,47,42,32,108,105,110,101,32,0,0,0,0,0,0,0,0,104,115,108,97,40,36,104,117,101,44,32,36,115,97,116,117,114,97,116,105,111,110,44,32,36,108,105,103,104,116,110,101,115,115,44,32,36,97,108,112,104,97,41,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,111,112,116,105,111,110,97,108,32,112,97,114,97,109,101,116,101,114,115,32,109,97,121,32,110,111,116,32,98,101,32,99,111,109,98,105,110,101,100,32,119,105,116,104,32,118,97,114,105,97,98,108,101,45,108,101,110,103,116,104,32,112,97,114,97,109,101,116,101,114,115,0,105,110,118,97,108,105,100,32,111,112,101,114,97,110,100,115,32,102,111,114,32,109,117,108,116,105,112,108,105,99,97,116,105,111,110,0,0,0,0,0,100,97,114,107,103,114,101,101,110,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,32,116,111,32,0,0,0,0,64,105,110,99,108,117,100,101,32,0,0,0,0,0,0,0,100,97,114,107,103,114,101,121,0,0,0,0,0,0,0,0,36,108,105,103,104,116,110,101,115,115,0,0,0,0,0,0,116,114,117,101,0,0,0,0,97,108,112,104,97,32,99,104,97,110,110,101,108,115,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,119,104,101,110,32,99,111,109,98,105,110,105,110,103,32,99,111,108,111,114,115,0,0,0,0,0,0,103,105,118,101,110,32,0,0,110,101,103,97,116,101,100,32,115,101,108,101,99,116,111,114,32,105,115,32,109,105,115,115,105,110,103,32,39,41,39,0,64,102,117,110,99,116,105,111,110,32,0,0,0,0,0,0,36,115,97,116,117,114,97,116,105,111,110,0,0,0,0,0,99,97,110,110,111,116,32,100,105,118,105,100,101,32,97,32,110,117,109,98,101,114,32,98,121,32,97,32,99,111,108,111,114,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,100,97,114,107,103,114,97,121,0,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,115,101,108,101,99,116,111,114,32,97,102,116,101,114,32,0,64,109,105,120,105,110,32,0,47,0,0,0,0,0,0,0,100,97,114,107,103,111,108,100,101,110,114,111,100,0,0,0,97,114,103,117,109,101,110,116,32,96,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,97,32,39,123,39,32,97,102,116,101,114,32,116,104,101,32,115,101,108,101,99,116,111,114,0,0,0,0,0,0,0,104,115,108,40,36,104,117,101,44,32,36,115,97,116,117,114,97,116,105,111,110,44,32,36,108,105,103,104,116,110,101,115,115,41,0,0,0,0,0,0,108,111,119,101,114,32,98,111,117,110,100,32,111,102,32,96,64,102,111,114,96,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,110,117,109,101,114,105,99,0,45,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,100,97,114,107,99,121,97,110,0,0,0,0,0,0,0,0,97,113,117,97,0,0,0,0,101,120,112,101,99,116,101,100,32,97,32,39,123,39,32,97,102,116,101,114,32,110,97,109,101,115,112,97,99,101,100,32,112,114,111,112,101,114,116,121,0,0,0,0,0,0,0,0,66,97,99,107,116,114,97,99,101,58,0,0,0,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,36,119,101,105,103,104,116,0,99,97,110,110,111,116,32,97,100,100,32,111,114,32,115,117,98,116,114,97,99,116,32,110,117,109,98,101,114,115,32,119,105,116,104,32,105,110,99,111,109,112,97,116,105,98,108,101,32,117,110,105,116,115,0,0,100,97,114,107,98,108,117,101,0,0,0,0,0,0,0,0,32,105,110,32,97,115,115,105,103,110,109,101,110,116,32,115,116,97,116,101,109,101,110,116,0,0,0,0,0,0,0,0,64,119,104,105,108,101,32,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,0,0,0,0,0,0,0,0,99,121,97,110,0,0,0,0,101,120,112,101,99,116,101,100,32,39,58,39,32,97,102,116,101,114,32,0,0,0,0,0,99,109,0,0,0,0,0,0,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,85,110,97,98,108,101,32,116,111,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,58,32,0,0,0,0,0,99,114,105,109,115,111,110,0,105,110,118,97,108,105,100,32,110,97,109,101,32,105,110,32,64,105,110,99,108,117,100,101,32,100,105,114,101,99,116,105,118,101,0,0,0,0,0,0,64,101,97,99,104,32,0,0,109,105,120,40,36,99,111,108,111,114,45,49,44,32,36,99,111,108,111,114,45,50,44,32,36,119,101,105,103,104,116,58,32,53,48,37,41,0,0,0,99,97,110,110,111,116,32,99,111,109,112,97,114,101,32,110,117,109,98,101,114,115,32,119,105,116,104,32,105,110,99,111,109,112,97,116,105,98,108,101,32,117,110,105,116,115,0,0,99,111,114,110,115,105,108,107,0,0,0,0,0,0,0,0,101,120,112,101,99,116,101,100,32,97,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,40,101,46,103,46,32,36,120,41,32,111,114,32,39,41,39,32,102,111,114,32,116,104,101,32,112,97,114,97,109,101,116,101,114,32,108,105,115,116,32,102,111,114,32,0,0,0,32,116,111,32,0,0,0,0,98,108,117,101,40,36,99,111,108,111,114,41,0,0,0,0,67,0,0,0,0,0,0,0,96,69,120,112,97,110,100,96,32,100,111,101,115,110,39,116,32,104,97,110,100,108,101,32,0,0,0,0,0,0,0,0,109,97,121,32,111,110,108,121,32,99,111,109,112,97,114,101,32,110,117,109,98,101,114,115,0,0,0,0,0,0,0,0,99,111,114,110,102,108,111,119,101,114,98,108,117,101,0,0,108,111,119,101,114,32,98,111,117,110,100,32,111,102,32,96,64,102,111,114,96,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,110,117,109,101,114,105,99,0,32,109,117,115,116,32,98,101,103,105,110,32,119,105,116,104,32,97,32,39,123,39,0,0,32,116,104,114,111,117,103,104,32,0,0,0,0,0,0,0,116,111,112,45,108,101,118,101,108,32,118,97,114,105,97,98,108,101,32,98,105,110,100,105,110,103,32,109,117,115,116,32,98,101,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,39,59,39,0,0,0,0,99,111,114,97,108,0,0,0,103,114,101,101,110,40,36,99,111,108,111,114,41,0,0,0,118,101,99,116,111,114,0,0,117,110,107,110,111,119,110,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,59,32,112,108,101,97,115,101,32,99,111,110,116,97,99,116,32,116,104,101,32,76,105,98,83,97,115,115,32,109,97,105,110,116,97,105,110,101,114,115,0,0,97,108,105,99,101,98,108,117,101,0,0,0,0,0,0,0,32,123,10,0,0,0,0,0,99,111,108,111,114,0,0,0,32,0,0,0,0,0,0,0,32,102,114,111,109,32,0,0,91,98,117,105,108,116,45,105,110,32,102,117,110,99,116,105,111,110,93,0,0,0,0,0,99,104,111,99,111,108,97,116,101,0,0,0,0,0,0,0,91,102,93,0,0,0,0,0,114,101,100,40,36,99,111,108,111,114,41,0,0,0,0,0,37,46,48,76,102,0,0,0,109,105,120,105,110,32,0,0,115,111,117,114,99,101,32,115,116,114,105,110,103,0,0,0,117,110,98,111,117,110,100,32,118,97,114,105,97,98,108,101,32,0,0,0,0,0,0,0,32,42,47,0,0,0,0,0,47,42,35,32,115,111,117,114,99,101,77,97,112,112,105,110,103,85,82,76,61,0,0,0,108,105,115,116,0,0,0,0,97,114,103,108,105,115,116,0,91,67,79,76,79,82,32,84,65,66,76,69,93,0,0,0,98,111,100,121,32,102,111,114,32,0,0,0,0,0,0,0,121,101,108,108,111,119,103,114,101,101,110,0,0,0,0,0,64,102,111,114,32,0,0,0,121,101,108,108,111,119,0,0,119,104,105,116,101,115,109,111,107,101,0,0,0,0,0,0,99,104,97,114,116,114,101,117,115,101,0,0,0,0,0,0,119,104,105,116,101,0,0,0,36,99,111,108,111,114,0,0].concat([109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,64,99,111,110,116,101,110,116,91,109,93,0,0,0,0,0,119,104,101,97,116,0,0,0,96,32,103,105,118,101,110,32,119,114,111,110,103,32,110,117,109,98,101,114,32,111,102,32,97,114,103,117,109,101,110,116,115,0,0,0,0,0,0,0,118,105,111,108,101,116,0,0,116,117,114,113,117,111,105,115,101,0,0,0,0,0,0,0,32,97,114,103,117,109,101,110,116,115,59,32,0,0,0,0,116,111,109,97,116,111,0,0,116,104,105,115,116,108,101,0,116,101,97,108,0,0,0,0,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,116,97,110,0,0,0,0,0,115,116,101,101,108,98,108,117,101,0,0,0,0,0,0,0,83,97,116,0,0,0,0,0,115,112,114,105,110,103,103,114,101,101,110,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,70,114,105,0,0,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,99,97,100,101,116,98,108,117,101,0,0,0,0,0,0,0,115,110,111,119,0,0,0,0,114,103,98,97,40,36,99,111,108,111,114,44,32,36,97,108,112,104,97,41,0,0,0,0,37,76,102,0,0,0,0,0,84,104,117,0,0,0,0,0,115,108,97,116,101,103,114,101,121,0,0,0,0,0,0,0,111,118,101,114,108,111,97,100,101,100,32,102,117,110,99,116,105,111,110,32,96,0,0,0,87,101,100,0,0,0,0,0,115,108,97,116,101,103,114,97,121,0,0,0,0,0,0,0,84,117,101,0,0,0,0,0,115,108,97,116,101,98,108,117,101,0,0,0,0,0,0,0,77,111,110,0,0,0,0,0,115,107,121,98,108,117,101,0,83,117,110,0,0,0,0,0,115,105,108,118,101,114,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,115,105,101,110,110,97,0,0,105,110,118,97,108,105,100,32,110,97,109,101,32,105,110,32,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,115,101,97,115,104,101,108,108,0,0,0,0,0,0,0,0,46,46,47,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,115,101,97,103,114,101,101,110,0,0,0,0,0,0,0,0,110,117,109,98,101,114,0,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,115,97,110,100,121,98,114,111,119,110,0,0,0,0,0,0,84,117,101,115,100,97,121,0,115,97,108,109,111,110,0,0,98,117,114,108,121,119,111,111,100,0,0,0,0,0,0,0,36,97,108,112,104,97,0,0,114,98,0,0,0,0,0,0,96,0,0,0,0,0,0,0,77,111,110,100,97,121,0,0,99,111,110,116,101,110,116,115,32,111,102,32,110,97,109,101,115,112,97,99,101,100,32,112,114,111,112,101,114,116,105,101,115,32,109,117,115,116,32,114,101,115,117,108,116,32,105,110,32,115,116,121,108,101,32,100,101,99,108,97,114,97,116,105,111,110,115,32,111,110,108,121,0,0,0,0,0,0,0,0,115,97,100,100,108,101,98,114,111,119,110,0,0,0,0,0,58,32,0,0,0,0,0,0,115,116,114,105,110,103,0,0,83,117,110,100,97,121,0,0,114,111,121,97,108,98,108,117,101,0,0,0,0,0,0,0,96,32,109,117,115,116,32,98,101,32,97,32,0,0,0,0,114,111,115,121,98,114,111,119,110,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,114,101,100,0,0,0,0,0,112,117,114,112,108,101,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,97,110,116,105,113,117,101,119,104,105,116,101,0,0,0,0,47,0,0,0,0,0,0,0,112,111,119,100,101,114,98,108,117,101,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,32,105,115,32,109,105,115,115,105,110,103,32,105,110,32,99,97,108,108,32,116,111,32,0,117,112,112,101,114,32,98,111,117,110,100,32,111,102,32,96,64,102,111,114,96,32,100,105,114,101,99,116,105,118,101,32,109,117,115,116,32,98,101,32,110,117,109,101,114,105,99,0,101,120,112,101,99,116,105,110,103,32,97,110,111,116,104,101,114,32,117,114,108,32,111,114,32,113,117,111,116,101,100,32,112,97,116,104,32,105,110,32,64,105,109,112,111,114,116,32,108,105,115,116,0,0,0,0,36,111,110,108,121,45,112,97,116,104,0,0,0,0,0,0,46,46,46,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,112,108,117,109,0,0,0,0,64,119,97,114,110,32,0,0,36,112,97,116,104,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,112,105,110,107,0,0,0,0,105,109,97,103,101,45,117,114,108,40,36,112,97,116,104,44,32,36,111,110,108,121,45,112,97,116,104,58,32,102,97,108,115,101,44,32,36,99,97,99,104,101,45,98,117,115,116,101,114,58,32,102,97,108,115,101,41,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,112,101,114,117,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,112,101,97,99,104,112,117,102,102,0,0,0,0,0,0,0,114,103,98,97,40,36,114,101,100,44,32,36,103,114,101,101,110,44,32,36,98,108,117,101,44,32,36,97,108,112,104,97,41,0,0,0,0,0,0,0,98,114,111,119,110,0,0,0,36,105,102,45,102,97,108,115,101,0,0,0,0,0,0,0,44,32,105,110,32,109,105,120,105,110,32,96,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,112,97,112,97,121,97,119,104,105,112,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,67,32,102,117,110,99,116,105,111,110,32,0,0,0,0,36,99,111,110,100,105,116,105,111,110,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,112,97,108,101,118,105,111,108,101,116,114,101,100,0,0,0,105,102,40,36,99,111,110,100,105,116,105,111,110,44,32,36,105,102,45,116,114,117,101,44,32,36,105,102,45,102,97,108,115,101,41,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,112,97,108,101,116,117,114,113,117,111,105,115,101,0,0,0,110,111,116,40,36,118,97,108,117,101,41,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,112,97,108,101,103,114,101,101,110,0,0,0,0,0,0,0,36,110,117,109,98,101,114,45,50,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,112,97,108,101,103,111,108,100,101,110,114,111,100,0,0,0,36,110,117,109,98,101,114,45,49,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,111,114,99,104,105,100,0,0,64,105,109,112,111,114,116,32,100,105,114,101,99,116,105,118,101,32,114,101,113,117,105,114,101,115,32,97,32,117,114,108,32,111,114,32,113,117,111,116,101,100,32,112,97,116,104,0,99,111,109,112,97,114,97,98,108,101,40,36,110,117,109,98,101,114,45,49,44,32,36,110,117,109,98,101,114,45,50,41,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,111,114,97,110,103,101,114,101,100,0,0,0,0,0,0,0,117,110,105,116,108,101,115,115,40,36,110,117,109,98,101,114,41,0,0,0,0,0,0,0,111,114,97,110,103,101,0,0,36,110,117,109,98,101,114,0,68,101,99,0,0,0,0,0,111,108,105,118,101,100,114,97,98,0,0,0,0,0,0,0,117,110,105,116,40,36,110,117,109,98,101,114,41,0,0,0,78,111,118,0,0,0,0,0,111,108,105,118,101,0,0,0,98,108,117,101,118,105,111,108,101,116,0,0,0,0,0,0,99,111,108,111,114,0,0,0,110,111,32,109,105,120,105,110,32,110,97,109,101,100,32,0,79,99,116,0,0,0,0,0,111,108,100,108,97,99,101,0,32,100,105,100,32,110,111,116,32,114,101,116,117,114,110,32,97,32,118,97,108,117,101,0,116,121,112,101,45,111,102,40,36,118,97,108,117,101,41,0,83,101,112,0,0,0,0,0,110,97,118,121,0,0,0,0,36,118,97,108,117,101,115,0,65,117,103,0,0,0,0,0,110,97,118,97,106,111,119,104,105,116,101,0,0,0,0,0,114,101,113,117,105,114,101,100,32,112,97,114,97,109,101,116,101,114,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,72,58,37,77,58,37,83,37,72,58,37,77,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,89,45,37,109,45,37,100,37,109,47,37,100,47,37,121,37,72,58,37,77,58,37,83,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,160,109,0,0,208,1,0,0,98,1,0,0,18,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,109,0,0,150,1,0,0,234,0,0,0,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,109,0,0,56,0,0,0,42,1,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,109,0,0,190,0,0,0,156,0,0,0,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,109,0,0,190,0,0,0,46,1,0,0,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,109,0,0,190,0,0,0,202,1,0,0,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,110,0,0,116,0,0,0,186,0,0,0,34,0,0,0,4,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,110,0,0,38,1,0,0,146,1,0,0,34,0,0,0,2,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,110,0,0,112,0,0,0,248,0,0,0,34,0,0,0,18,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,110,0,0,84,2,0,0,220,0,0,0,34,0,0,0,12,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,111,0,0,184,1,0,0,86,1,0,0,34,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,111,0,0,236,0,0,0,76,0,0,0,34,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,111,0,0,60,1,0,0,202,0,0,0,34,0,0,0,90,0,0,0,62,0,0,0,92,0,0,0,42,0,0,0,6,0,0,0,26,0,0,0,4,0,0,0,248,255,255,255,72,111,0,0,210,0,0,0,6,0,0,0,92,0,0,0,10,0,0,0,2,0,0,0,236,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,111,0,0,142,0,0,0,78,2,0,0,34,0,0,0,20,0,0,0,66,0,0,0,96,0,0,0,50,0,0,0,68,0,0,0,2,0,0,0,2,0,0,0,248,255,255,255,112,111,0,0,54,0,0,0,200,0,0,0,24,1,0,0,212,0,0,0,68,0,0,0,238,0,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,111,0,0,184,0,0,0,46,2,0,0,34,0,0,0,38,0,0,0,28,0,0,0,246,0,0,0,236,1,0,0,186,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,111,0,0,192,0,0,0,50,0,0,0,34,0,0,0,162,0,0,0,4,0,0,0,254,0,0,0,82,1,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,111,0,0,182,1,0,0,2,0,0,0,34,0,0,0,44,0,0,0,64,0,0,0,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,111,0,0,66,1,0,0,164,1,0,0,34,0,0,0,14,0,0,0,62,0,0,0,6,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,111,0,0,12,1,0,0,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,0,0,160,0,0,0,218,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,112,0,0,36,0,0,0,136,1,0,0,34,0,0,0,52,0,0,0,50,0,0,0,84,0,0,0,40,0,0,0,82,0,0,0,8,0,0,0,6,0,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,112,0,0,28,0,0,0,68,0,0,0,34,0,0,0,42,0,0,0,46,0,0,0,76,0,0,0,44,0,0,0,74,0,0,0,4,0,0,0,2,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,112,0,0,214,1,0,0,50,1,0,0,34,0,0,0,18,0,0,0,16,0,0,0,10,0,0,0,12,0,0,0,90,0,0,0,14,0,0,0,8,0,0,0,24,0,0,0,22,0,0,0,20,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,112,0,0,48,2,0,0,190,1,0,0,34,0,0,0,94,0,0,0,54,0,0,0,30,0,0,0,32,0,0,0,60,0,0,0,34,0,0,0,28,0,0,0,40,0,0,0,38,0,0,0,36,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,112,0,0,58,0,0,0,8,0,0,0,34,0,0,0,20,0,0,0,12,0,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,112,0,0,22,0,0,0,242,0,0,0,34,0,0,0,4,0,0,0,16,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,112,0,0,168,1,0,0,44,2,0,0,34,0,0,0,12,0,0,0,16,0,0,0,30,0,0,0,28,1,0,0,122,0,0,0,10,0,0,0,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,112,0,0,140,1,0,0,214,0,0,0,34,0,0,0,8,0,0,0,4,0,0,0,28,0,0,0,170,0,0,0,222,0,0,0,8,0,0,0,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,112,0,0,140,1,0,0,14,0,0,0,34,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,120,0,0,0,104,0,0,0,14,0,0,0,36,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,113,0,0,140,1,0,0,6,2,0,0,34,0,0,0,2,0,0,0,6,0,0,0,24,0,0,0,234,0,0,0,148,0,0,0,12,0,0,0,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,113,0,0,140,1,0,0,212,1,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,113,0,0,232,1,0,0,226,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,113,0,0,140,1,0,0,76,1,0,0,34,0,0,0,6,0,0,0,14,0,0,0,8,0,0,0,12,0,0,0,244,1,0,0,30,0,0,0,10,3,0,0,34,0,0,0,180,2,0,0,34,0,0,0,22,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,113,0,0,148,0,0,0,56,1,0,0,34,0,0,0,156,2,0,0,36,0,0,0,244,2,0,0,46,0,0,0,244,0,0,0,40,0,0,0,8,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,113,0,0,180,0,0,0,82,1,0,0,58,0,0,0,82,1,0,0,60,0,0,0,12,0,0,0,202,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,184,113,0,0,158,1,0,0,80,2,0,0,56,0,0,0,248,255,255,255,184,113,0,0,222,1,0,0,44,0,0,0,192,255,255,255,192,255,255,255,184,113,0,0,60,2,0,0,160,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,113,0,0,140,1,0,0,62,0,0,0,34,0,0,0,2,0,0,0,6,0,0,0,24,0,0,0,234,0,0,0,148,0,0,0,12,0,0,0,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,113,0,0,140,1,0,0,82,2,0,0,34,0,0,0,2,0,0,0,6,0,0,0,24,0,0,0,234,0,0,0,148,0,0,0,12,0,0,0,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,113,0,0,224,1,0,0,74,2,0,0,142,0,0,0,70,0,0,0,26,0,0,0,18,0,0,0,166,0,0,0,184,0,0,0,62,0,0,0,32,1,0,0,146,0,0,0,136,1,0,0,42,0,0,0,32,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,113,0,0,88,0,0,0,176,1,0,0,10,1,0,0,24,0,0,0,10,0,0,0,14,0,0,0,64,0,0,0,74,0,0,0,68,0,0,0,24,0,0,0,226,0,0,0,248,0,0,0,74,0,0,0,64,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,0,0,194,1,0,0,206,0,0,0,142,0,0,0,70,0,0,0,20,0,0,0,24,0,0,0,166,0,0,0,184,0,0,0,62,0,0,0,218,0,0,0,146,0,0,0,122,2,0,0,42,0,0,0,28,3,0,0,0,0,0,0,0,0,0,0,108,0,0,0,0,0,0,0,48,114,0,0,130,1,0,0,6,1,0,0,148,255,255,255,148,255,255,255,48,114,0,0,88,1,0,0,108,1,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,96,114,0,0,62,1,0,0,162,1,0,0,252,255,255,255,252,255,255,255,96,114,0,0,104,0,0,0,16,2,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,120,114,0,0,14,1,0,0,178,1,0,0,252,255,255,255,252,255,255,255,120,114,0,0,96,1,0,0,252,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,144,114,0,0,188,0,0,0,86,2,0,0,248,255,255,255,248,255,255,255,144,114,0,0,40,2,0,0,136,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,168,114,0,0,8,2,0,0,2,1,0,0,248,255,255,255,248,255,255,255,168,114,0,0,22,2,0,0,196,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,114,0,0,70,2,0,0,238,1,0,0,174,2,0,0,56,0,0,0,32,0,0,0,36,0,0,0,240,0,0,0,184,0,0,0,62,0,0,0,188,0,0,0,146,0,0,0,236,2,0,0,42,0,0,0,30,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,114,0,0,254,0,0,0,76,2,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,115,0,0,32,1,0,0,142,1,0,0,10,0,0,0,24,0,0,0,10,0,0,0,14,0,0,0,246,0,0,0,74,0,0,0,68,0,0,0,24,0,0,0,226,0,0,0,248,0,0,0,10,0,0,0,124,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,115,0,0,128,1,0,0,118,0,0,0,96,0,0,0,70,0,0,0,20,0,0,0,24,0,0,0,12,0,0,0,184,0,0,0,62,0,0,0,218,0,0,0,146,0,0,0,122,2,0,0,72,0,0,0,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,115,0,0,22,1,0,0,112,1,0,0,34,0,0,0,52,0,0,0,134,0,0,0,114,0,0,0,210,0,0,0,154,1,0,0,38,1,0,0,98,0,0,0,128,2,0,0,158,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,115,0,0,200,0,0,0,38,0,0,0,34,0,0,0,204,0,0,0,132,0,0,0,110,1,0,0,62,2,0,0,134,1,0,0,72,0,0,0,22,1,0,0,8,2,0,0,170,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,115,0,0,250,1,0,0,204,0,0,0,34,0,0,0,16,0,0,0,102,0,0,0,0,2,0,0,248,1,0,0,76,2,0,0,126,0,0,0,66,0,0,0,84,1,0,0,120,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,115,0,0,246,1,0,0,134,1,0,0,34,0,0,0,198,0,0,0,202,0,0,0,212,1,0,0,178,0,0,0,22,1,0,0,124,2,0,0,114,0,0,0,208,2,0,0,118,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,115,0,0,84,1,0,0,200,1,0,0,22,0,0,0,24,0,0,0,10,0,0,0,14,0,0,0,64,0,0,0,74,0,0,0,68,0,0,0,176,0,0,0,116,0,0,0,196,2,0,0,74,0,0,0,64,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,115,0,0,12,0,0,0,170,1,0,0,12,1,0,0,70,0,0,0,20,0,0,0,24,0,0,0,166,0,0,0,184,0,0,0,62,0,0,0,194,0,0,0,22,0,0,0,190,1,0,0,42,0,0,0,28,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,116,0,0,128,0,0,0,180,1,0,0,106,0,0,0,110,1,0,0,50,0,0,0,216,0,0,0,24,0,0,0,172,0,0,0,86,0,0,0,74,0,0,0,98,0,0,0,58,0,0,0,254,0,0,0,72,1,0,0,116,1,0,0,134,0,0,0,192,1,0,0,166,0,0,0,162,0,0,0,114,0,0,0,136,0,0,0,62,1,0,0,10,0,0,0,36,1,0,0,196,0,0,0,64,1,0,0,222,0,0,0,180,1,0,0,202,0,0,0,126,0,0,0,28,1,0,0,130,0,0,0,42,0,0,0,148,0,0,0,236,0,0,0,40,1,0,0,234,0,0,0,90,1,0,0,160,1,0,0,118,1,0,0,12,0,0,0,170,1,0,0,164,1,0,0,120,0,0,0,38,1,0,0,190,0,0,0,14,1,0,0,70,1,0,0,168,1,0,0,190,1,0,0,32,0,0,0,114,1,0,0,20,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,116,0,0,8,0,0,0,8,0,0,0,178,1,0,0,18,2,0,0,10,0,0,0,168,0,0,0,184,0,0,0,130,1,0,0,84,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,116,0,0,114,1,0,0,194,0,0,0,148,0,0,0,36,0,0,0,82,2,0,0,62,2,0,0,136,0,0,0,176,1,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,116,0,0,8,0,0,0,8,0,0,0,178,1,0,0,18,2,0,0,10,0,0,0,168,0,0,0,184,0,0,0,130,1,0,0,84,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,116,0,0,28,1,0,0,138,1,0,0,150,1,0,0,18,3,0,0,4,2,0,0,236,0,0,0,208,1,0,0,78,0,0,0,104,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,116,0,0,82,0,0,0,222,0,0,0,134,0,0,0,54,2,0,0,160,1,0,0,42,2,0,0,14,3,0,0,248,0,0,0,192,0,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,154,2,0,0,220,255,255,255,136,116,0,0,96,2,0,0,240,0,0,0,234,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,116,0,0,252,1,0,0,72,0,0,0,138,1,0,0,164,0,0,0,188,2,0,0,4,0,0,0,116,2,0,0,178,0,0,0,20,0,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,116,0,0,8,0,0,0,8,0,0,0,178,1,0,0,18,2,0,0,10,0,0,0,168,0,0,0,184,0,0,0,130,1,0,0,84,0,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,116,0,0,52,1,0,0,198,0,0,0,136,0,0,0,6,3,0,0,30,0,0,0,164,2,0,0,192,2,0,0,194,1,0,0,52,1,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,116,0,0,8,0,0,0,8,0,0,0,178,1,0,0,18,2,0,0,10,0,0,0,168,0,0,0,184,0,0,0,130,1,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,116,0,0,70,0,0,0,244,1,0,0,228,1,0,0,20,1,0,0,168,1,0,0,90,2,0,0,96,0,0,0,154,1,0,0,32,1,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,116,0,0,166,1,0,0,20,2,0,0,158,0,0,0,92,2,0,0,246,1,0,0,186,2,0,0,84,1,0,0,126,1,0,0,6,1,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,117,0,0,118,1,0,0,220,1,0,0,236,0,0,0,60,0,0,0,38,0,0,0,98,2,0,0,68,0,0,0,184,0,0,0,198,1,0,0,190,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,117,0,0,92,1,0,0,14,2,0,0,128,0,0,0,34,1,0,0,88,1,0,0,140,0,0,0,156,0,0,0,40,0,0,0,106,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,117,0,0,44,0,0,0,102,1,0,0,154,1,0,0,52,0,0,0,46,0,0,0,216,0,0,0,136,1,0,0,108,2,0,0,102,0,0,0,80,0,0,0,102,1,0,0,46,2,0,0,70,2,0,0,216,2,0,0,54,1,0,0,156,2,0,0,164,0,0,0,84,2,0,0,112,2,0,0,232,1,0,0,202,2,0,0,192,0,0,0,228,0,0,0,180,2,0,0,28,0,0,0,2,1,0,0,4,1,0,0,162,2,0,0,206,0,0,0,218,2,0,0,50,2,0,0,76,0,0,0,204,1,0,0,20,0,0,0,226,2,0,0,166,1,0,0,190,2,0,0,78,1,0,0,116,2,0,0,30,2,0,0,144,0,0,0,236,2,0,0,140,2,0,0,110,0,0,0,50,1,0,0,42,1,0,0,100,2,0,0,182,2,0,0,166,0,0,0,64,0,0,0,104,1,0,0,252,1,0,0,56,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,117,0,0,20,1,0,0,42,0,0,0,148,2,0,0,102,1,0,0,14,2,0,0,122,1,0,0,192,0,0,0,214,0,0,0,124,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,117,0,0,72,1,0,0,230,0,0,0,172,1,0,0,198,0,0,0,38,3,0,0,206,2,0,0,2,1,0,0,170,0,0,0,168,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,117,0,0,56,2,0,0,228,1,0,0,222,1,0,0,206,1,0,0,208,2,0,0,234,2,0,0,168,2,0,0,186,0,0,0,160,0,0,0,106,0,0,0,126,2,0,0,86,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,117,0,0,192,1,0,0,34,1,0,0,168,2,0,0,186,0,0,0,128,0,0,0,78,2,0,0,52,1,0,0,232,0,0,0,186,1,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,117,0,0,8,0,0,0,8,0,0,0,86,2,0,0,2,3,0,0,214,1,0,0,218,2,0,0,170,1,0,0,4,0,0,0,154,0,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,117,0,0,64,1,0,0,140,0,0,0,198,2,0,0,158,2,0,0,182,0,0,0,12,0,0,0,118,1,0,0,16,1,0,0,204,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,117,0,0,218,1,0,0,66,2,0,0,88,0,0,0,72,0,0,0,144,0,0,0,106,2,0,0,20,3,0,0,204,1,0,0,46,0,0,0,172,0,0,0,110,2,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,117,0,0,228,0,0,0,134,0,0,0,16,0,0,0,2,2,0,0,100,1,0,0,224,0,0,0,152,1,0,0,30,1,0,0,230,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,117,0,0,78,2,0,0,146,0,0,0,60,0,0,0,218,1,0,0,42,0,0,0,212,2,0,0,172,2,0,0,28,2,0,0,98,1,0,0,188,1,0,0,162,1,0,0,230,1,0,0,70,0,0,0,220,2,0,0,218,0,0,0,40,0,0,0,230,2,0,0,174,0,0,0,32,0,0,0,124,0,0,0,168,1,0,0,34,2,0,0,132,0,0,0,186,0,0,0,82,2,0,0,72,2,0,0,144,2,0,0,144,1,0,0,142,2,0,0,124,1,0,0,100,0,0,0,224,0,0,0,164,2,0,0,190,1,0,0,112,0,0,0,226,0,0,0,224,2,0,0,244,0,0,0,140,0,0,0,56,1,0,0,234,2,0,0,222,0,0,0,162,0,0,0,230,0,0,0,242,2,0,0,238,2,0,0,160,0,0,0,52,2,0,0,128,1,0,0,94,2,0,0,108,1,0,0,208,0,0,0,66,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,117,0,0,214,0,0,0,172,1,0,0,68,1,0,0,172,0,0,0,248,1,0,0,16,0,0,0,92,0,0,0,248,2,0,0,26,3,0,0,134,1,0,0,118,2,0,0,22,3,0,0,190,0,0,0,40,2,0,0,140,2,0,0,14,0,0,0,108,1,0,0,154,1,0,0,124,1,0,0,174,0,0,0,154,0,0,0,30,2,0,0,178,2,0,0,216,0,0,0,232,0,0,0,86,2,0,0,152,0,0,0,84,2,0,0,136,2,0,0,132,0,0,0,236,1,0,0,106,1,0,0,114,0,0,0,12,1,0,0,48,1,0,0,108,2,0,0,40,1,0,0,116,0,0,0,150,2,0,0,86,0,0,0,48,2,0,0,118,0,0,0,14,1,0,0,46,1,0,0,222,1,0,0,166,2,0,0,64,1,0,0,64,0,0,0,180,1,0,0,202,0,0,0,222,0,0,0,130,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,117,0,0,106,1,0,0,26,2,0,0,20,2,0,0,78,1,0,0,146,1,0,0,126,0,0,0,56,2,0,0,72,0,0,0,42,1,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,117,0,0,150,0,0,0,74,0,0,0,32,2,0,0,120,0,0,0,200,1,0,0,114,1,0,0,114,2,0,0,124,1,0,0,138,0,0,0,172,0,0,0,86,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,117,0,0,224,0,0,0,70,1,0,0,50,0,0,0,110,2,0,0,68,1,0,0,98,1,0,0,222,2,0,0,224,0,0,0,54,1,0,0,70,0,0,0,2,1,0,0,184,1,0,0,228,255,255,255,248,117,0,0,54,2,0,0,78,0,0,0,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,118,0,0,210,0,0,0,172,0,0,0,92,0,0,0,92,1,0,0,110,0,0,0,30,0,0,0,104,1,0,0,166,1,0,0,64,0,0,0,174,0,0,0,150,1,0,0,228,0,0,0,88,1,0,0,184,1,0,0,92,0,0,0,86,1,0,0,74,1,0,0,158,0,0,0,174,1,0,0,152,0,0,0,238,0,0,0,82,0,0,0,200,0,0,0,134,1,0,0,218,0,0,0,70,0,0,0,172,1,0,0,142,0,0,0,178,1,0,0,18,1,0,0,96,1,0,0,220,0,0,0,182,1,0,0,96,0,0,0,122,0,0,0,150,0,0,0,214,1,0,0,164,0,0,0,136,1,0,0,56,0,0,0,156,0,0,0,58,1,0,0,62,0,0,0,94,0,0,0,158,1,0,0,146,0,0,0,8,1,0,0,48,1,0,0,176,0,0,0,212,0,0,0,56,1,0,0,76,1,0,0,142,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,118,0,0,104,1,0,0,24,2,0,0,160,2,0,0,12,3,0,0,42,1,0,0,132,2,0,0,68,2,0,0,240,0,0,0,12,1,0,0,124,0,0,0,108,0,0,0,254,0,0,0,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,118,0,0,110,1,0,0,30,2,0,0,56,0,0,0,48,0,0,0,66,2,0,0,158,1,0,0,128,2,0,0,200,1,0,0,66,1,0,0,172,0,0,0,58,2,0,0,224,0,0,0,108,0,0,0,220,255,255,255,56,118,0,0,0,1,0,0,158,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,118,0,0,58,2,0,0,168,0,0,0,78,1,0,0,124,0,0,0,196,1,0,0,16,3,0,0,224,1,0,0,234,1,0,0,12,2,0,0,194,0,0,0,162,1,0,0,58,0,0,0,84,0,0,0,16,2,0,0,178,1,0,0,120,1,0,0,194,2,0,0,226,1,0,0,104,1,0,0,164,1,0,0,22,1,0,0,220,2,0,0,210,0,0,0,20,0,0,0,134,2,0,0,4,1,0,0,62,1,0,0,186,1,0,0,160,2,0,0,194,1,0,0,184,2,0,0,242,2,0,0,94,0,0,0,82,0,0,0,246,0,0,0,98,0,0,0,36,3,0,0,86,1,0,0,4,3,0,0,70,1,0,0,8,3,0,0,218,1,0,0,208,0,0,0,226,2,0,0,22,0,0,0,120,2,0,0,254,1,0,0,90,0,0,0,228,2,0,0,44,1,0,0,112,1,0,0,46,2,0,0,148,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,118,0,0,96,0,0,0,54,1,0,0,198,0,0,0,126,2,0,0,176,2,0,0,0,1,0,0,92,1,0,0,208,1,0,0,206,1,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,118,0,0,166,0,0,0,8,1,0,0,138,0,0,0,204,1,0,0,128,1,0,0,234,0,0,0,166,0,0,0,132,0,0,0,76,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,118,0,0,110,0,0,0,246,0,0,0,152,1,0,0,146,0,0,0,46,0,0,0,32,3,0,0,150,1,0,0,36,0,0,0,94,1,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,118,0,0,94,0,0,0,62,2,0,0,68,2,0,0,162,2,0,0,80,2,0,0,6,0,0,0,240,2,0,0,208,0,0,0,206,0,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,118,0,0,124,1,0,0,58,2,0,0,138,2,0,0,72,2,0,0,88,2,0,0,74,1,0,0,156,1,0,0,102,0,0,0,120,1,0,0,14,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,118,0,0,196,0,0,0,66,0,0,0,132,2,0,0,228,0,0,0,126,1,0,0,230,2,0,0,100,0,0,0,182,0,0,0,34,1,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,118,0,0,50,2,0,0,100,1,0,0,28,1,0,0,252,2,0,0,250,2,0,0,228,1,0,0,224,2,0,0,100,0,0,0,2,1,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,118,0,0,128,0,0,0,52,2,0,0,172,0,0,0,58,1,0,0,172,2,0,0,102,2,0,0,38,2,0,0,140,1,0,0,98,1,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,118,0,0,242,1,0,0,64,0,0,0,74,1,0,0,74,0,0,0,202,1,0,0,22,2,0,0,40,0,0,0,246,0,0,0,226,0,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,118,0,0,254,1,0,0,250,0,0,0,34,2,0,0,238,1,0,0,250,0,0,0,118,0,0,0,122,1,0,0,130,1,0,0,238,0,0,0,158,1,0,0,176,2,0,0,170,0,0,0,90,0,0,0,118,2,0,0,112,1,0,0,62,1,0,0,130,2,0,0,34,0,0,0,146,2,0,0,132,1,0,0,146,0,0,0,204,0,0,0,122,0,0,0,34,1,0,0,146,1,0,0,14,2,0,0,224,1,0,0,184,2,0,0,96,1,0,0,40,1,0,0,176,0,0,0,82,0,0,0,80,1,0,0,208,1,0,0,176,1,0,0,16,1,0,0,74,2,0,0,54,0,0,0,192,2,0,0,200,1,0,0,104,2,0,0,4,2,0,0,182,0,0,0,106,2,0,0,10,2,0,0,102,2,0,0,240,0,0,0,64,1,0,0,222,2,0,0,36,0,0,0,48,0,0,0,72,1,0,0,186,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,119,0,0,244,0,0,0,114,0,0,0,180,1,0,0,42,0,0,0,26,1,0,0,8,0,0,0,242,0,0,0,8,0,0,0,84,1,0,0,152,0,0,0,190,0,0,0,224,255,255,255,8,119,0,0,228,2,0,0,122,1,0,0,212,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,119,0,0,20,0,0,0,124,0,0,0,52,1,0,0,50,1,0,0,218,0,0,0,238,0,0,0,138,1,0,0,52,0,0,0,100,1,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,119,0,0,80,0,0,0,44,1,0,0,232,0,0,0,32,2,0,0,210,1,0,0,250,0,0,0,36,2,0,0,188,0,0,0,22,1,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,119,0,0,170,0,0,0,18,1,0,0,194,1,0,0,140,1,0,0,214,2,0,0,154,2,0,0,254,0,0,0,46,1,0,0,108,0,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,119,0,0,2,2,0,0,144,1,0,0,44,2,0,0,40,3,0,0,192,1,0,0,76,2,0,0,204,2,0,0,102,1,0,0,6,0,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,119,0,0,226,1,0,0,46,0,0,0,216,1,0,0,0,3,0,0,54,0,0,0,112,2,0,0,106,0,0,0,34,0,0,0,26,0,0,0,172,0,0,0,22,2,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,119,0,0,8,0,0,0,8,0,0,0,178,1,0,0,18,2,0,0,10,0,0,0,168,0,0,0,184,0,0,0,130,1,0,0,84,0,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,119,0,0,132,0,0,0,64,2,0,0,202,1,0,0,94,2,0,0,96,1,0,0,252,0,0,0,230,0,0,0,216,1,0,0,188,1,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,119,0,0,108,0,0,0,164,0,0,0,60,0,0,0,202,2,0,0,74,2,0,0,166,1,0,0,116,1,0,0,78,1,0,0,128,1,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,120,0,0,90,1,0,0,204,1,0,0,196,0,0,0,10,2,0,0,150,0,0,0,94,1,0,0,18,0,0,0,218,1,0,0,60,1,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,120,0,0,32,2,0,0,122,0,0,0,220,0,0,0,220,1,0,0,122,0,0,0,24,3,0,0,132,1,0,0,118,0,0,0,0,1,0,0,172,0,0,0,40,2,0,0,86,0,0,0])
.concat([108,0,0,0,216,255,255,255,72,120,0,0,0,1,0,0,4,2,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,120,0,0,42,2,0,0,74,1,0,0,30,0,0,0,226,0,0,0,182,2,0,0,38,1,0,0,30,1,0,0,152,1,0,0,50,1,0,0,50,0,0,0,2,2,0,0,224,255,255,255,104,120,0,0,66,0,0,0,174,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,120,0,0,68,0,0,0,174,1,0,0,156,1,0,0,2,0,0,0,226,1,0,0,24,0,0,0,58,1,0,0,76,1,0,0,148,1,0,0,84,0,0,0,104,0,0,0,152,0,0,0,18,0,0,0,150,2,0,0,116,0,0,0,194,2,0,0,70,1,0,0,202,0,0,0,156,1,0,0,192,1,0,0,44,1,0,0,160,1,0,0,16,2,0,0,246,1,0,0,64,2,0,0,30,1,0,0,122,2,0,0,36,2,0,0,58,0,0,0,188,2,0,0,150,0,0,0,232,2,0,0,62,0,0,0,42,2,0,0,182,1,0,0,214,1,0,0,244,1,0,0,136,2,0,0,12,2,0,0,206,2,0,0,194,0,0,0,140,1,0,0,88,1,0,0,178,2,0,0,120,0,0,0,200,2,0,0,196,2,0,0,92,1,0,0,196,1,0,0,188,0,0,0,92,0,0,0,46,1,0,0,134,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,120,0,0,162,0,0,0,4,1,0,0,80,2,0,0,188,0,0,0,44,0,0,0,8,2,0,0,32,0,0,0,180,0,0,0,60,0,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,120,0,0,158,0,0,0,24,0,0,0,120,0,0,0,36,1,0,0,238,2,0,0,82,1,0,0,52,0,0,0,0,2,0,0,96,2,0,0,188,1,0,0,210,2,0,0,178,0,0,0,148,0,0,0,246,2,0,0,104,2,0,0,60,2,0,0,212,1,0,0,20,2,0,0,24,1,0,0,26,0,0,0,18,1,0,0,144,2,0,0,176,1,0,0,110,0,0,0,108,0,0,0,180,0,0,0,80,0,0,0,216,1,0,0,232,2,0,0,76,1,0,0,238,1,0,0,212,0,0,0,198,1,0,0,42,3,0,0,148,1,0,0,230,1,0,0,70,0,0,0,60,1,0,0,8,1,0,0,212,2,0,0,138,0,0,0,130,1,0,0,190,2,0,0,28,0,0,0,254,2,0,0,28,1,0,0,102,0,0,0,172,1,0,0,76,0,0,0,200,0,0,0,130,2,0,0,110,1,0,0,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,120,0,0,206,1,0,0,32,0,0,0,38,0,0,0,146,2,0,0,152,2,0,0,100,2,0,0,252,1,0,0,244,0,0,0,38,0,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,220,255,255,255,184,120,0,0,164,1,0,0,26,0,0,0,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,120,0,0,126,0,0,0,236,1,0,0,98,2,0,0,80,1,0,0,28,2,0,0,66,1,0,0,206,0,0,0,4,1,0,0,112,0,0,0,38,1,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,120,0,0,116,1,0,0,240,1,0,0,78,0,0,0,170,2,0,0,62,0,0,0,200,2,0,0,242,1,0,0,44,1,0,0,116,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,120,0,0,90,0,0,0,12,2,0,0,212,0,0,0,24,2,0,0,52,2,0,0,184,1,0,0,34,0,0,0,220,1,0,0,16,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,121,0,0,126,1,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,121,0,0,214,2,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,121,0,0,94,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,121,0,0,164,1,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,121,0,0,116,1,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,121,0,0,168,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,121,0,0,0,1,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,121,0,0,126,1,0,0,30,0,0,0,170,2,0,0,142,2,0,0,50,2,0,0,6,2,0,0,16,1,0,0,212,1,0,0,48,0,0,0,94,1,0,0,228,255,255,255,64,121,0,0,48,1,0,0,54,2,0,0,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,121,0,0,100,0,0,0,68,2,0,0,174,1,0,0,142,1,0,0,216,2,0,0,182,1,0,0,34,2,0,0,80,1,0,0,252,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,121,0,0,8,0,0,0,8,0,0,0,178,1,0,0,18,2,0,0,10,0,0,0,168,0,0,0,184,0,0,0,130,1,0,0,84,0,0,0,172,0,0,0,250,1,0,0,86,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,121,0,0,254,1,0,0,176,0,0,0,8,0,0,0,174,2,0,0,134,0,0,0,56,0,0,0,232,1,0,0,148,1,0,0,18,0,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,121,0,0,24,1,0,0,186,1,0,0,152,2,0,0,160,0,0,0,138,2,0,0,144,1,0,0,2,0,0,0,24,1,0,0,112,1,0,0,70,0,0,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,121,0,0,36,1,0,0,152,1,0,0,48,0,0,0,120,1,0,0,4,0,0,0,30,0,0,0,28,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,83,116,57,101,120,99,101,112,116,105,111,110,0,0,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,50,49,95,95,98,97,115,105,99,95,115,116,114,105,110,103,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,78,83,116,51,95,95,49,49,56,98,97,115,105,99,95,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,78,83,116,51,95,95,49,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,52,83,97,115,115,57,84,111,95,83,116,114,105,110,103,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,83,116,97,116,101,109,101,110,116,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,80,97,114,97,109,101,116,101,114,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,118,69,69,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,80,78,83,95,57,83,116,97,116,101,109,101,110,116,69,69,69,0,0,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,80,78,83,95,56,83,101,108,101,99,116,111,114,69,69,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,80,78,83,95,49,48,69,120,112,114,101,115,115,105,111,110,69,69,69,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,78,83,116,51,95,95,49,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,49,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,49,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,0,0,0,0,78,52,83,97,115,115,57,79,112,101,114,97,116,105,111,110,73,49,48,83,97,115,115,95,86,97,108,117,101,69,69,0,78,52,83,97,115,115,57,72,97,115,95,66,108,111,99,107,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,69,120,116,101,110,115,105,111,110,69,0,0,0,0,0,0,0,78,52,83,97,115,115,57,65,114,103,117,109,101,110,116,115,69,0,0,0,0,0,0,0,78,52,83,97,115,115,56,86,97,114,105,97,98,108,101,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,56,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,56,65,114,103,117,109,101,110,116,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,56,65,83,84,95,78,111,100,101,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,55,87,97,114,110,105,110,103,69,0,78,52,83,97,115,115,55,84,101,120,116,117,97,108,69,0,78,52,83,97,115,115,55,82,117,108,101,115,101,116,69,0,78,52,83,97,115,115,55,80,114,111,112,115,101,116,69,0,78,52,83,97,115,115,55,73,110,115,112,101,99,116,69,0,78,52,83,97,115,115,55,67,111,110,116,101,110,116,69,0,78,52,83,97,115,115,55,67,111,109,109,101,110,116,69,0,78,52,83,97,115,115,55,66,111,111,108,101,97,110,69,0,78,52,83,97,115,115,55,65,116,95,82,117,108,101,69,0,78,52,83,97,115,115,54,83,116,114,105,110,103,69,0,0,78,52,83,97,115,115,54,82,101,116,117,114,110,69,0,0,78,52,83,97,115,115,54,78,117,109,98,101,114,69,0,0,78,52,83,97,115,115,54,73,109,112,111,114,116,69,0,0,78,52,83,97,115,115,54,69,120,116,101,110,100,69,0,0,78,52,83,97,115,115,54,69,120,112,97,110,100,69,0,0,78,52,83,97,115,115,53,87,104,105,108,101,69,0,0,0,78,52,83,97,115,115,53,69,114,114,111,114,69,0,0,0,78,52,83,97,115,115,53,67,111,108,111,114,69,0,0,0,78,52,83,97,115,115,53,66,108,111,99,107,69,0,0,0,78,52,83,97,115,115,52,84,111,95,67,69,0,0,0,0,78,52,83,97,115,115,52,78,117,108,108,69,0,0,0,0,78,52,83,97,115,115,52,76,105,115,116,69,0,0,0,0,78,52,83,97,115,115,52,69,118,97,108,69,0,0,0,0,78,52,83,97,115,115,52,69,97,99,104,69,0,0,0,0,78,52,83,97,115,115,51,70,111,114,69,0,0,0,0,0,78,52,83,97,115,115,50,73,102,69,0,0,0,0,0,0,78,52,83,97,115,115,50,50,77,101,100,105,97,95,81,117,101,114,121,95,69,120,112,114,101,115,115,105,111,110,69,0,78,52,83,97,115,115,50,48,83,101,108,101,99,116,111,114,95,80,108,97,99,101,104,111,108,100,101,114,69,0,0,0,78,52,83,97,115,115,50,48,70,117,110,99,116,105,111,110,95,67,97,108,108,95,83,99,104,101,109,97,69,0,0,0,78,52,83,97,115,115,49,56,83,101,108,101,99,116,111,114,95,82,101,102,101,114,101,110,99,101,69,0,0,0,0,0,78,52,83,97,115,115,49,56,83,101,108,101,99,116,111,114,95,81,117,97,108,105,102,105,101,114,69,0,0,0,0,0,78,52,83,97,115,115,49,56,65,116,116,114,105,98,117,116,101,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,78,52,83,97,115,115,49,55,79,117,116,112,117,116,95,67,111,109,112,114,101,115,115,101,100,69,0,0,0,0,0,0,78,52,83,97,115,115,49,55,67,111,109,112,111,117,110,100,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,78,52,83,97,115,115,49,55,66,105,110,97,114,121,95,69,120,112,114,101,115,115,105,111,110,69,0,0,0,0,0,0,78,52,83,97,115,115,49,54,85,110,97,114,121,95,69,120,112,114,101,115,115,105,111,110,69,0,0,0,0,0,0,0,78,52,83,97,115,115,49,54,78,101,103,97,116,101,100,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,78,52,83,97,115,115,49,54,67,111,109,112,108,101,120,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,78,52,83,97,115,115,49,53,83,116,114,105,110,103,95,67,111,110,115,116,97,110,116,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,49,53,83,105,109,112,108,101,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,49,53,83,101,108,101,99,116,111,114,95,83,99,104,101,109,97,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,49,53,80,115,101,117,100,111,95,83,101,108,101,99,116,111,114,69,0,0,0,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,118,78,83,95,55,73,110,115,112,101,99,116,69,69,69,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,118,78,83,95,54,69,120,116,101,110,100,69,69,69,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,118,78,83,95,49,55,79,117,116,112,117,116,95,67,111,109,112,114,101,115,115,101,100,69,69,69,0,0,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,118,78,83,95,49,51,79,117,116,112,117,116,95,78,101,115,116,101,100,69,69,69,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,80,78,83,95,57,83,116,97,116,101,109,101,110,116,69,78,83,95,54,69,120,112,97,110,100,69,69,69,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,80,78,83,95,56,83,101,108,101,99,116,111,114,69,78,83,95,49,51,67,111,110,116,101,120,116,117,97,108,105,122,101,69,69,69,0,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,80,78,83,95,49,48,69,120,112,114,101,115,115,105,111,110,69,78,83,95,52,69,118,97,108,69,69,69,0,0,0,0,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,78,83,116,51,95,95,49,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,49,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,49,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,95,57,84,111,95,83,116,114,105,110,103,69,69,69,0,78,52,83,97,115,115,49,52,79,112,101,114,97,116,105,111,110,95,67,82,84,80,73,49,48,83,97,115,115,95,86,97,108,117,101,78,83,95,52,84,111,95,67,69,69,69,0,0,78,52,83,97,115,115,49,51,84,121,112,101,95,83,101,108,101,99,116,111,114,69,0,0,78,52,83,97,115,115,49,51,83,116,114,105,110,103,95,83,99,104,101,109,97,69,0,0,78,52,83,97,115,115,49,51,83,101,108,101,99,116,111,114,95,76,105,115,116,69,0,0,78,52,83,97,115,115,49,51,79,117,116,112,117,116,95,78,101,115,116,101,100,69,0,0,78,52,83,97,115,115,49,51,70,117,110,99,116,105,111,110,95,67,97,108,108,69,0,0,78,52,83,97,115,115,49,51,67,111,110,116,101,120,116,117,97,108,105,122,101,69,0,0,78,52,83,97,115,115,49,49,77,101,100,105,97,95,81,117,101,114,121,69,0,0,0,0,78,52,83,97,115,115,49,49,77,101,100,105,97,95,66,108,111,99,107,69,0,0,0,0,78,52,83,97,115,115,49,49,73,109,112,111,114,116,95,83,116,117,98,69,0,0,0,0,78,52,83,97,115,115,49,49,68,101,99,108,97,114,97,116,105,111,110,69,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,57,83,116,97,116,101,109,101,110,116,69,69,69,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,57,80,97,114,97,109,101,116,101,114,69,69,69,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,56,65,114,103,117,109,101,110,116,69,69,69,0,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,50,50,77,101,100,105,97,95,81,117,101,114,121,95,69,120,112,114,101,115,115,105,111,110,69,69,69,0,0,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,49,54,67,111,109,112,108,101,120,95,83,101,108,101,99,116,111,114,69,69,69,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,49,53,83,105,109,112,108,101,95,83,101,108,101,99,116,111,114,69,69,69,0,0,0,0,0,78,52,83,97,115,115,49,48,86,101,99,116,111,114,105,122,101,100,73,80,78,83,95,49,48,69,120,112,114,101,115,115,105,111,110,69,69,69,0,0,78,52,83,97,115,115,49,48,80,97,114,97,109,101,116,101,114,115,69,0,0,0,0,0,78,52,83,97,115,115,49,48,77,105,120,105,110,95,67,97,108,108,69,0,0,0,0,0,78,52,83,97,115,115,49,48,69,120,112,114,101,115,115,105,111,110,69,0,0,0,0,0,78,52,83,97,115,115,49,48,68,101,102,105,110,105,116,105,111,110,69,0,0,0,0,0,78,52,83,97,115,115,49,48,65,115,115,105,103,110,109,101,110,116,69,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,0,0,0,0,16,86,0,0,0,0,0,0,32,86,0,0,0,0,0,0,48,86,0,0,152,109,0,0,0,0,0,0,0,0,0,0,64,86,0,0,152,109,0,0,0,0,0,0,0,0,0,0,80,86,0,0,152,109,0,0,0,0,0,0,0,0,0,0,104,86,0,0,240,109,0,0,0,0,0,0,0,0,0,0,128,86,0,0,240,109,0,0,0,0,0,0,0,0,0,0,152,86,0,0,152,109,0,0,0,0,0,0,0,0,0,0,168,86,0,0,232,85,0,0,192,86,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,48,115,0,0,0,0,0,0,232,85,0,0,8,87,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,56,115,0,0,0,0,0,0,232,85,0,0,80,87,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,64,115,0,0,0,0,0,0,232,85,0,0,152,87,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,72,115,0,0,0,0,0,0,0,0,0,0,224,87,0,0,248,111,0,0,0,0,0,0,0,0,0,0,16,88,0,0,248,111,0,0,0,0,0,0,232,85,0,0,64,88,0,0,0,0,0,0,1,0,0,0,72,114,0,0,0,0,0,0,232,85,0,0,88,88,0,0,0,0,0,0,1,0,0,0,72,114,0,0,0,0,0,0,232,85,0,0,112,88,0,0,0,0,0,0,1,0,0,0,80,114,0,0,0,0,0,0,232,85,0,0,136,88,0,0,0,0,0,0,1,0,0,0,80,114,0,0,0,0,0,0,232,85,0,0,160,88,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,224,115,0,0,0,8,0,0,232,85,0,0,232,88,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,224,115,0,0,0,8,0,0,232,85,0,0,48,89,0,0,0,0,0,0,3,0,0,0,48,113,0,0,2,0,0,0,0,110,0,0,2,0,0,0,152,113,0,0,0,8,0,0,232,85,0,0,120,89,0,0,0,0,0,0,3,0,0,0,48,113,0,0,2,0,0,0,0,110,0,0,2,0,0,0,160,113,0,0,0,8,0,0,0,0,0,0,192,89,0,0,48,113,0,0,0,0,0,0,0,0,0,0,216,89,0,0,48,113,0,0,0,0,0,0,232,85,0,0,240,89,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,88,114,0,0,2,0,0,0,232,85,0,0,8,90,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,88,114,0,0,2,0,0,0,0,0,0,0,32,90,0,0,0,0,0,0,56,90,0,0,208,114,0,0,0,0,0,0,232,85,0,0,88,90,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,168,110,0,0,0,0,0,0,232,85,0,0,160,90,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,192,110,0,0,0,0,0,0,232,85,0,0,232,90,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,216,110,0,0,0,0,0,0,232,85,0,0,48,91,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,240,110,0,0,0,0,0,0,0,0,0,0,120,91,0,0,48,113,0,0,0,0,0,0,0,0,0,0,144,91,0,0,48,113,0,0,0,0,0,0,232,85,0,0,168,91,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,224,114,0,0,2,0,0,0,232,85,0,0,208,91,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,224,114,0,0,2,0,0,0,232,85,0,0,248,91,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,224,114,0,0,2,0,0,0,232,85,0,0,32,92,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,224,114,0,0,2,0,0,0,0,0,0,0,72,92,0,0,64,114,0,0,0,0,0,0,0,0,0,0,96,92,0,0,48,113,0,0,0,0,0,0,232,85,0,0,120,92,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,216,115,0,0,2,0,0,0,232,85,0,0,144,92,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,216,115,0,0,2,0,0,0,0,0,0,0,168,92,0,0,0,0,0,0,208,92,0,0,0,0,0,0,248,92,0,0,0,0,0,0,32,93,0,0,0,115,0,0,0,0,0,0,0,0,0,0,64,93,0,0,16,114,0,0,0,0,0,0,0,0,0,0,136,93,0,0,16,113,0,0,0,0,0,0,0,0,0,0,176,93,0,0,16,113,0,0,0,0,0,0,0,0,0,0,216,93,0,0,0,114,0,0,0,0,0,0,0,0,0,0,32,94,0,0,0,0,0,0,88,94,0,0,0,0,0,0,144,94,0,0,232,85,0,0,176,94,0,0,3,0,0,0,2,0,0,0,168,114,0,0,2,0,0,0,120,114,0,0,2,8,0,0,0,0,0,0,224,94,0,0,168,114,0,0,0,0,0,0,0,0,0,0,16,95,0,0,0,0,0,0,48,95,0,0,0,0,0,0,80,95,0,0,0,0,0,0,112,95,0,0,232,85,0,0,136,95,0,0,0,0,0,0,1,0,0,0,136,110,0,0,3,244,255,255,232,85,0,0,184,95,0,0,0,0,0,0,1,0,0,0,152,110,0,0,3,244,255,255,232,85,0,0,232,95,0,0,0,0,0,0,1,0,0,0,136,110,0,0,3,244,255,255,232,85,0,0,24,96,0,0,0,0,0,0,1,0,0,0,152,110,0,0,3,244,255,255,0,0,0,0,72,96,0,0,0,114,0,0,0,0,0,0,0,0,0,0,120,96,0,0,192,109,0,0,0,0,0,0,0,0,0,0,144,96,0,0,232,85,0,0,168,96,0,0,0,0,0,0,1,0,0,0,144,113,0,0,0,0,0,0,0,0,0,0,232,96,0,0,8,114,0,0,0,0,0,0,0,0,0,0,0,97,0,0,248,113,0,0,0,0,0,0,0,0,0,0,32,97,0,0,0,114,0,0,0,0,0,0,0,0,0,0,64,97,0,0,0,0,0,0,96,97,0,0,0,0,0,0,128,97,0,0,0,0,0,0,160,97,0,0,232,85,0,0,192,97,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,208,115,0,0,2,0,0,0,232,85,0,0,224,97,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,208,115,0,0,2,0,0,0,232,85,0,0,0,98,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,208,115,0,0,2,0,0,0,232,85,0,0,32,98,0,0,0,0,0,0,2,0,0,0,48,113,0,0,2,0,0,0,208,115,0,0,2,0,0,0,0,0,0,0,64,98,0,0,0,0,0,0,88,98,0,0,0,0,0,0,112,98,0,0,0,0,0,0,136,98,0,0,248,113,0,0,0,0,0,0,0,0,0,0,160,98,0,0,0,114,0,0,0,0,0,0,0,0,0,0,184,98,0,0,24,120,0,0,0,0,0,0,0,0,0,0,208,98,0,0,216,116,0,0,0,0,0,0,0,0,0,0,232,98,0,0,216,116,0,0,0,0,0,0,0,0,0,0,0,99,0,0,0,0,0,0,24,99,0,0,0,0,0,0,64,99,0,0,0,0,0,0,104,99,0,0,0,0,0,0,144,99,0,0,0,0,0,0,232,99,0,0,0,0,0,0,8,100,0,0,24,116,0,0,0,0,0,0,0,0,0,0,32,100,0,0,24,116,0,0,0,0,0,0,232,85,0,0,56,100,0,0,0,0,0,0,2,0,0,0,112,121,0,0,2,0,0,0,24,121,0,0,2,36,0,0,0,0,0,0,80,100,0,0,112,121,0,0,0,0,0,0,0,0,0,0,104,100,0,0,216,116,0,0,0,0,0,0,0,0,0,0,128,100,0,0,112,121,0,0,0,0,0,0,0,0,0,0,152,100,0,0,0,0,0,0,176,100,0,0,24,116,0,0,0,0,0,0,0,0,0,0,192,100,0,0,112,121,0,0,0,0,0,0,0,0,0,0,208,100,0,0,104,116,0,0,0,0,0,0,0,0,0,0,224,100,0,0,104,116,0,0,0,0,0,0,0,0,0,0,240,100,0,0,168,119,0,0,0,0,0,0,0,0,0,0,0,101,0,0,24,116,0,0,0,0,0,0,0,0,0,0,16,101,0,0,24,116,0,0,0,0,0,0,0,0,0,0,32,101,0,0,112,121,0,0,0,0,0,0,0,0,0,0,48,101,0,0,104,116,0,0,0,0,0,0,0,0,0,0,64,101,0,0,112,121,0,0,0,0,0,0,0,0,0,0,80,101,0,0,24,116,0,0,0,0,0,0,0,0,0,0,96,101,0,0,112,121,0,0,0,0,0,0,0,0,0,0,112,101,0,0,24,116,0,0,0,0,0,0,0,0,0,0,128,101,0,0,184,119,0,0,0,0,0,0,0,0,0,0,144,101,0,0,232,119,0,0,0,0,0,0,0,0,0,0,160,101,0,0,104,116,0,0,0,0,0,0,0,0,0,0,176,101,0,0,0,0,0,0,192,101,0,0,112,121,0,0,0,0,0,0,232,85,0,0,208,101,0,0,0,0,0,0,2,0,0,0,24,116,0,0,2,0,0,0,8,121,0,0,2,28,0,0,0,0,0,0,224,101,0,0,40,120,0,0,0,0,0,0,0,0,0,0,240,101,0,0,112,121,0,0,0,0,0,0,232,85,0,0,0,102,0,0,0,0,0,0,2,0,0,0,112,121,0,0,2,0,0,0,56,121,0,0,2,36,0,0,0,0,0,0,16,102,0,0,8,120,0,0,0,0,0,0,0,0,0,0,32,102,0,0,104,116,0,0,0,0,0,0,0,0,0,0,48,102,0,0,104,116,0,0,0,0,0,0,0,0,0,0,64,102,0,0,24,116,0,0,0,0,0,0,0,0,0,0,80,102,0,0,112,121,0,0,0,0,0,0,0,0,0,0,112,102,0,0,120,119,0,0,0,0,0,0,0,0,0,0,144,102,0,0,112,121,0,0,0,0,0,0,0,0,0,0,176,102,0,0,120,119,0,0,0,0,0,0,0,0,0,0,208,102,0,0,120,119,0,0,0,0,0,0,0,0,0,0,240,102,0,0,120,119,0,0,0,0,0,0,0,0,0,0,16,103,0,0,200,119,0,0,0,0,0,0,232,85,0,0,48,103,0,0,0,0,0,0,2,0,0,0,184,116,0,0,2,0,0,0,48,121,0,0,2,32,0,0,0,0,0,0,80,103,0,0,112,121,0,0,0,0,0,0,0,0,0,0,112,103,0,0,112,121,0,0,0,0,0,0,0,0,0,0,144,103,0,0,120,119,0,0,0,0,0,0,0,0,0,0,176,103,0,0,184,116,0,0,0,0,0,0,0,0,0,0,208,103,0,0,112,117,0,0,0,0,0,0,0,0,0,0,240,103,0,0,184,116,0,0,0,0,0,0,0,0,0,0,16,104,0,0,184,116,0,0,0,0,0,0,0,0,0,0,48,104,0,0,120,119,0,0,0,0,0,0,0,0,0,0,80,104,0,0,56,116,0,0,0,0,0,0,0,0,0,0,120,104,0,0,56,116,0,0,0,0,0,0,0,0,0,0,160,104,0,0,56,116,0,0,0,0,0,0,0,0,0,0,216,104,0,0,56,116,0,0,0,0,0,0,0,0,0,0,8,105,0,0,64,116,0,0,0,0,0,0,0,0,0,0,64,105,0,0,72,116,0,0,0,0,0,0])
.concat([0,0,0,0,128,105,0,0,80,116,0,0,0,0,0,0,0,0,0,0,184,105,0,0,88,116,0,0,0,0,0,0,0,0,0,0,32,106,0,0,96,116,0,0,0,0,0,0,0,0,0,0,80,106,0,0,120,119,0,0,0,0,0,0,232,85,0,0,104,106,0,0,0,0,0,0,2,0,0,0,112,117,0,0,2,0,0,0,56,121,0,0,2,40,0,0,232,85,0,0,128,106,0,0,0,0,0,0,2,0,0,0,184,116,0,0,2,0,0,0,40,121,0,0,2,32,0,0,0,0,0,0,152,106,0,0,216,119,0,0,0,0,0,0,0,0,0,0,176,106,0,0,112,121,0,0,0,0,0,0,0,0,0,0,200,106,0,0,248,119,0,0,0,0,0,0,232,85,0,0,224,106,0,0,0,0,0,0,2,0,0,0,112,121,0,0,2,0,0,0,32,121,0,0,2,36,0,0,0,0,0,0,248,106,0,0,104,116,0,0,0,0,0,0,0,0,0,0,16,107,0,0,24,116,0,0,0,0,0,0,0,0,0,0,40,107,0,0,24,116,0,0,0,0,0,0,0,0,0,0,64,107,0,0,0,0,0,0,104,107,0,0,0,0,0,0,144,107,0,0,0,0,0,0,184,107,0,0,0,0,0,0,240,107,0,0,0,0,0,0,32,108,0,0,0,0,0,0,80,108,0,0,232,85,0,0,120,108,0,0,0,0,0,0,2,0,0,0,216,116,0,0,2,0,0,0,16,121,0,0,2,28,0,0,0,0,0,0,144,108,0,0,104,116,0,0,0,0,0,0,0,0,0,0,168,108,0,0,216,116,0,0,0,0,0,0,0,0,0,0,192,108,0,0,104,116,0,0,0,0,0,0,0,0,0,0,216,108,0,0,24,116,0,0,0,0,0,0,0,0,0,0,240,108,0,0,192,121,0,0,0,0,0,0,0,0,0,0,24,109,0,0,192,121,0,0,0,0,0,0,0,0,0,0,64,109,0,0,208,121,0,0,0,0,0,0,0,0,0,0,104,109,0,0,144,109,0,0,0,0,0,0,64,0,0,0,0,0,0,0,168,114,0,0,8,2,0,0,2,1,0,0,192,255,255,255,192,255,255,255,168,114,0,0,22,2,0,0,196,1,0,0,108,0,0,0,0,0,0,0,168,114,0,0,8,2,0,0,2,1,0,0,148,255,255,255,148,255,255,255,168,114,0,0,22,2,0,0,196,1,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,64,0,0,0,0,0,0,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,96,109,64,0,0,0,0,0,224,106,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,106,64,0,0,0,0,0,0,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,160,110,64,0,0,0,0,0,160,110,64,0,0,0,0,0,128,107,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,108,64,0,0,0,0,0,128,104,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,96,109,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,64,97,64,0,0,0,0,0,128,69,64,0,0,0,0,0,64,108,64,0,0,0,0,0,160,100,64,0,0,0,0,0,0,69,64,0,0,0,0,0,0,69,64,0,0,0,0,0,192,107,64,0,0,0,0,0,0,103,64,0,0,0,0,0,224,96,64,0,0,0,0,0,192,87,64,0,0,0,0,0,192,99,64,0,0,0,0,0,0,100,64,0,0,0,0,0,192,95,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,106,64,0,0,0,0,0,64,90,64,0,0,0,0,0,0,62,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,0,0,84,64,0,0,0,0,0,0,89,64,0,0,0,0,0,160,98,64,0,0,0,0,0,160,109,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,111,64,0,0,0,0,0,128,107,64,0,0,0,0,0,128,107,64,0,0,0,0,0,0,52,64,0,0,0,0,0,0,78,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,96,97,64,0,0,0,0,0,96,97,64,0,0,0,0,0,0,103,64,0,0,0,0,0,192,96,64,0,0,0,0,0,0,38,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,32,101,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,89,64,0,0,0,0,0,0,0,0,0,0,0,0,0,160,103,64,0,0,0,0,0,224,102,64,0,0,0,0,0,192,90,64,0,0,0,0,0,96,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,96,97,64,0,0,0,0,0,64,85,64,0,0,0,0,0,192,90,64,0,0,0,0,0,128,71,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,32,99,64,0,0,0,0,0,0,73,64,0,0,0,0,0,128,105,64,0,0,0,0,0,96,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,109,64,0,0,0,0,0,192,98,64,0,0,0,0,0,128,94,64,0,0,0,0,0,224,97,64,0,0,0,0,0,128,103,64,0,0,0,0,0,224,97,64,0,0,0,0,0,0,82,64,0,0,0,0,0,128,78,64,0,0,0,0,0,96,97,64,0,0,0,0,0,128,71,64,0,0,0,0,0,192,83,64,0,0,0,0,0,192,83,64,0,0,0,0,0,128,71,64,0,0,0,0,0,192,83,64,0,0,0,0,0,192,83,64,0,0,0,0,0,0,0,0,0,0,0,0,0,192,105,64,0,0,0,0,0,32,106,64,0,0,0,0,0,128,98,64,0,0,0,0,0,0,0,0,0,0,0,0,0,96,106,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,52,64,0,0,0,0,0,96,98,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,103,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,64,90,64,0,0,0,0,0,0,62,64,0,0,0,0,0,0,98,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,102,64,0,0,0,0,0,0,65,64,0,0,0,0,0,0,65,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,0,65,64,0,0,0,0,0,96,97,64,0,0,0,0,0,0,65,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,128,107,64,0,0,0,0,0,128,107,64,0,0,0,0,0,128,107,64,0,0,0,0,0,0,111,64,0,0,0,0,0,0,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,106,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,107,64,0,0,0,0,0,160,100,64,0,0,0,0,0,0,64,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,160,101,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,71,64,0,0,0,0,0,0,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,90,64,0,0,0,0,0,128,102,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,87,64,0,0,0,0,0,0,87,64,0,0,0,0,0,192,82,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,96,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,0,110,64,0,0,0,0,0,192,108,64,0,0,0,0,0,128,97,64,0,0,0,0,0,192,108,64,0,0,0,0,0,192,108,64,0,0,0,0,0,64,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,160,110,64,0,0,0,0,0,0,95,64,0,0,0,0,0,128,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,160,105,64,0,0,0,0,0,160,101,64,0,0,0,0,0,0,107,64,0,0,0,0,0,192,108,64,0,0,0,0,0,0,110,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,108,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,64,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,106,64,0,0,0,0,0,0,98,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,98,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,102,64,0,0,0,0,0,32,104,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,100,64,0,0,0,0,0,128,94,64,0,0,0,0,0,0,64,64,0,0,0,0,0,64,102,64,0,0,0,0,0,64,101,64,0,0,0,0,0,224,96,64,0,0,0,0,0,192,105,64,0,0,0,0,0,64,111,64,0,0,0,0,0,192,93,64,0,0,0,0,0,0,97,64,0,0,0,0,0,32,99,64,0,0,0,0,0,192,93,64,0,0,0,0,0,0,97,64,0,0,0,0,0,32,99,64,0,0,0,0,0,0,102,64,0,0,0,0,0,128,104,64,0,0,0,0,0,192,107,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,108,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,73,64,0,0,0,0,0,64,111,64,0,0,0,0,0,0,110,64,0,0,0,0,0,192,108,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,89,64,0,0,0,0,0,160,105,64,0,0,0,0,0,64,101,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,105,64,0,0,0,0,0,64,103,64,0,0,0,0,0,64,85,64,0,0,0,0,0,96,106,64,0,0,0,0,0,96,98,64,0,0,0,0,0,0,92,64,0,0,0,0,0,0,107,64,0,0,0,0,0,0,78,64,0,0,0,0,0,96,102,64,0,0,0,0,0,64,92,64,0,0,0,0,0,192,94,64,0,0,0,0,0,0,90,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,111,64,0,0,0,0,0,64,99,64,0,0,0,0,0,0,82,64,0,0,0,0,0,32,106,64,0,0,0,0,0,128,105,64,0,0,0,0,0,224,104,64,0,0,0,0,0,0,53,64,0,0,0,0,0,160,96,64,0,0,0,0,0,0,57,64,0,0,0,0,0,0,57,64,0,0,0,0,0,0,92,64,0,0,0,0,0,160,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,108,64,0,0,0,0,0,32,108,64,0,0,0,0,0,224,111,64,0,0,0,0,0,128,108,64,0,0,0,0,0,160,102,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,107,64,0,0,0,0,0,160,101,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,64,0,0,0,0,0,160,111,64,0,0,0,0,0,160,110,64,0,0,0,0,0,192,108,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,192,90,64,0,0,0,0,0,192,97,64,0,0,0,0,0,128,65,64,0,0,0,0,0,224,111,64,0,0,0,0,0,160,100,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,64,81,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,107,64,0,0,0,0,0,0,92,64,0,0,0,0,0,192,106,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,109,64,0,0,0,0,0,64,101,64,0,0,0,0,0,0,99,64,0,0,0,0,0,96,111,64,0,0,0,0,0,0,99,64,0,0,0,0,0,224,101,64,0,0,0,0,0,192,109,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,107,64,0,0,0,0,0,0,92,64,0,0,0,0,0,96,98,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,109,64,0,0,0,0,0,160,106,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,107,64,0,0,0,0,0,32,103,64,0,0,0,0,0,160,105,64,0,0,0,0,0,160,96,64,0,0,0,0,0,128,79,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,104,64,0,0,0,0,0,96,105,64,0,0,0,0,0,160,107,64,0,0,0,0,0,0,100,64,0,0,0,0,0,160,107,64,0,0,0,0,0,0,102,64,0,0,0,0,0,0,108,64,0,0,0,0,0,192,108,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,103,64,0,0,0,0,0,224,97,64,0,0,0,0,0,224,97,64,0,0,0,0,0,64,80,64,0,0,0,0,0,64,90,64,0,0,0,0,0,32,108,64,0,0,0,0,0,96,97,64,0,0,0,0,0,64,81,64,0,0,0,0,0,0,51,64,0,0,0,0,0,64,111,64,0,0,0,0,0,0,96,64,0,0,0,0,0,128,92,64,0,0,0,0,0,128,110,64,0,0,0,0,0,128,100,64,0,0,0,0,0,0,88,64,0,0,0,0,0,0,71,64,0,0,0,0,0,96,97,64,0,0,0,0,0,192,85,64,0,0,0,0,0,224,111,64,0,0,0,0,0,160,110,64,0,0,0,0,0,192,109,64,0,0,0,0,0,0,100,64,0,0,0,0,0,128,84,64,0,0,0,0,0,128,70,64,0,0,0,0,0,0,104,64,0,0,0,0,0,0,104,64,0,0,0,0,0,0,104,64,0,0,0,0,0,224,96,64,0,0,0,0,0,192,105,64,0,0,0,0,0,96,109,64,0,0,0,0,0,128,90,64,0,0,0,0,0,128,86,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,92,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,98,64,0,0,0,0,0,0,92,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,98,64,0,0,0,0,0,224,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,64,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,0,128,81,64,0,0,0,0,0,64,96,64,0,0,0,0,0,128,102,64,0,0,0,0,0,64,106,64,0,0,0,0,0,128,102,64,0,0,0,0,0,128,97,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,64,0,0,0,0,0,0,96,64,0,0,0,0,0,0,107,64,0,0,0,0,0,224,103,64,0,0,0,0,0,0,107,64,0,0,0,0,0,224,111,64,0,0,0,0,0,192,88,64,0,0,0,0,0,192,81,64,0,0,0,0,0,0,80,64,0,0,0,0,0,0,108,64,0,0,0,0,0,0,106,64,0,0,0,0,0,192,109,64,0,0,0,0,0,64,96,64,0,0,0,0,0,192,109,64,0,0,0,0,0,160,110,64,0,0,0,0,0,192,107,64,0,0,0,0,0,96,102,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,160,110,64,0,0,0,0,0,160,110,64,0,0,0,0,0,160,110,64,0,0,0,0,0,224,111,64,0,0,0,0,0,224,111,64,0,0,0,0,0,0,0,0,0,0,0,0,0,64,99,64,0,0,0,0,0,160,105,64,0,0,0,0,0,0,73,64,0,0,0,0,0,254,175,64,32,9,0,0,0,0,0,0,216,11,0,0,0,0,0,0,208,3,0,0,0,0,0,0,104,38,0,0,0,0,0,0,112,8,0,0,0,0,0,0,176,21,0,0,0,0,0,0,224,47,0,0,0,0,0,0,128,3,0,0,0,0,0,0,120,32,0,0,0,0,0,0,168,8,0,0,0,0,0,0,104,37,0,0,0,0,0,0,200,0,0,0,0,0,0,0,136,11,0,0,0,0,0,0,32,39,0,0,0,0,0,0,144,5,0,0,0,0,0,0,88,46,0,0,0,0,0,0,176,36,0,0,0,0,0,0,200,7,0,0,0,0,0,0,64,6,0,0,0,0,0,0,104,31,0,0,0,0,0,0,192,34,0,0,0,0,0,0,24,8,0,0,0,0,0,0,248,45,0,0,0,0,0,0,240,19,0,0,0,0,0,0,248,14,0,0,0,0,0,0,200,18,0,0,0,0,0,0,184,16,0,0,0,0,0,0,16,30,0,0,0,0,0,0,72,11,0,0,0,0,0,0,64,13,0,0,0,0,0,0,40,23,0,0,0,0,0,0,72,22,0,0,0,0,0,0,72,47,0,0,0,0,0,0,56,28,0,0,0,0,0,0,40,29,0,0,0,0,0,0,120,44,0,0,0,0,0,0,184,22,0,0,0,0,0,0,160,47,0,0,0,0,0,0,184,23,0,0,0,0,0,0,176,19,0,0,0,0,0,0,184,12,0,0,0,0,0,0,80,48,0,0,0,0,0,0,120,21,0,0,0,0,0,0,184,20,0,0,0,0,0,0,184,26,0,0,0,0,0,0,48,20,0,0,0,0,0,0,120,0,0,0,0,0,0,0,24,45,0,0,0,0,0,0,24,41,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,22,0,0,0,0,0,0,208,24,0,0,0,0,0,0,80,1,0,0,0,0,0,0,64,119,104,105,108,101,0,0,239,187,191,0,0,0,0,0,247,100,76,0,0,0,0,0,64,109,105,120,105,110,0,0,64,109,101,100,105,97,0,0,102,97,108,115,101,0,0,0,64,119,97,114,110,0,0,0,116,114,117,101,0,0,0,0,14,254,255,0,0,0,0,0,111,110,108,121,0,0,0,0,110,117,108,108,0,0,0,0,102,114,111,109,0,0,0,0,101,118,101,110,0,0,0,0,64,101,108,115,101,0,0,0,46,46,46,0,0,0,0,0,64,101,97,99,104,0,0,0,117,114,108,40,0,0,0,0,111,100,100,0,0,0,0,0,110,111,116,0,0,0,0,0,64,102,111,114,0,0,0,0,97,110,100,0,0,0,0,0,116,111,0,0,0,0,0,0,125,0,0,0,0,0,0,0,111,114,0,0,0,0,0,0,105,110,0,0,0,0,0,0,64,105,102,0,0,0,0,0,33,61,0,0,0,0,0,0,60,61,0,0,0,0,0,0,62,61,0,0,0,0,0,0,60,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,61,61,0,0,0,0,0,0,105,102,0,0,0,0,0,0,221,115,102,115,0,0,0,0,58,110,111,116,40,0,0,0,255,254,0,0,0,0,0,0,0,0,254,255,0,0,0,0,255,254,0,0,0,0,0,0,254,255,0,0,0,0,0,0,105,109,112,111,114,116,97,110,116,0,0,0,0,0,0,0,132,49,149,51,0,0,0,0,64,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,36,61,0,0,0,0,0,0,43,47,118,56,45,0,0,0,43,47,118,47,0,0,0,0,43,47,118,43,0,0,0,0,43,47,118,57,0,0,0,0,43,47,118,56,0,0,0,0,126,61,0,0,0,0,0,0,116,104,114,111,117,103,104,0,47,47,0,0,0,0,0,0,64,105,110,99,108,117,100,101,0,0,0,0,0,0,0,0,35,123,0,0,0,0,0,0,100,101,102,97,117,108,116,0,64,99,111,110,116,101,110,116,0,0,0,0,0,0,0,0,64,99,104,97,114,115,101,116,0,0,0,0,0,0,0,0,94,61,0,0,0,0,0,0,42,47,0,0,0,0,0,0,42,61,0,0,0,0,0,0,47,42,0,0,0,0,0,0,45,43,0,0,0,0,0,0,64,114,101,116,117,114,110,0,112,114,111,103,105,100,0,0,124,61,0,0,0,0,0,0,64,105,109,112,111,114,116,0,64,101,120,116,101,110,100,0,251,238,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,6,0,0,0,10,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,82,184,30,133,235,81,4,64,0,0,0,0,0,0,24,64,102,102,102,102,102,102,57,64,0,0,0,0,0,0,82,64,0,0,0,0,0,0,88,64,76,38,147,201,100,50,217,63,0,0,0,0,0,0,240,63,185,92,46,151,203,229,2,64,0,0,0,0,0,0,36,64,22,139,197,98,177,88,60,64,185,92,46,151,203,229,66,64,85,85,85,85,85,85,197,63,24,75,126,177,228,23,219,63,0,0,0,0,0,0,240,63,239,238,238,238,238,238,16,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,48,64,10,133,66,161,80,40,164,63,154,153,153,153,153,153,185,63,144,199,227,241,120,60,206,63,0,0,0,0,0,0,240,63,172,213,106,181,90,173,6,64,144,199,227,241,120,60,14,64,28,199,113,28,199,113,140,63,101,135,169,203,237,15,162,63,85,85,85,85,85,85,181,63,62,233,147,62,233,147,214,63,0,0,0,0,0,0,240,63,85,85,85,85,85,85,245,63,85,85,85,85,85,85,133,63,24,75,126,177,228,23,155,63,0,0,0,0,0,0,176,63,239,238,238,238,238,238,208,63,0,0,0,0,0,0,232,63,0,0,0,0,0,0,240,63,192,38,0,0,104,43,0,0,56,35,0,0,160,28,0,0,192,21,0,0,208,17,0,0,232,11,0,0,80,7,0,0,112,4,0,0,32,2,0,0,0,48,0,0,64,45,0,0,96,42,0,0,0,41,0,0,232,39,0,0,8,39,0,0,96,38,0,0,192,37,0,0,8,37,0,0,120,36,0,0,32,36,0,0,208,35,0,0,40,35,0,0,120,34,0,0,64,34,0,0,104,33,0,0,48,33,0,0,240,31,0,0,40,31,0,0,104,30,0,0,184,29,0,0,104,29,0,0,176,28,0,0,232,27,0,0,64,27,0,0,96,26,0,0,192,24,0,0,56,24,0,0,128,23,0,0,248,22,0,0,104,22,0,0,16,22,0,0,200,21,0,0,136,21,0,0,64,21,0,0,24,21,0,0,224,20,0,0,80,20,0,0,16,20,0,0,208,19,0,0,80,19,0,0,136,18,0,0,232,17,0,0,64,17,0,0,136,16,0,0,248,15,0,0,128,15,0,0,160,14,0,0,0,14,0,0,112,13,0,0,232,12,0,0,120,12,0,0,48,12,0,0,120,11,0,0,0,11,0,0,168,10,0,0,232,9,0,0,88,9,0,0,224,8,0,0,144,8,0,0,56,8,0,0,240,7,0,0,144,7,0,0,32,7,0,0,240,6,0,0,200,6,0,0,120,6,0,0,32,6,0,0,232,5,0,0,176,5,0,0,8,5,0,0,232,4,0,0,168,4,0,0,88,4,0,0,40,4,0,0,240,3,0,0,184,3,0,0,96,3,0,0,8,3,0,0,232,2,0,0,152,2,0,0,112,2,0,0,72,2,0,0,0,2,0,0,192,1,0,0,128,1,0,0,40,1,0,0,224,0,0,0,184,0,0,0,152,0,0,0,128,48,0,0,104,48,0,0,48,48,0,0,248,47,0,0,208,47,0,0,184,47,0,0,144,47,0,0,16,47,0,0,208,46,0,0,144,46,0,0,72,46,0,0,232,45,0,0,144,45,0,0,8,45,0,0,200,44,0,0,112,44,0,0,72,44,0,0,128,43,0,0,80,43,0,0,72,43,0,0,40,43,0,0,8,43,0,0,224,42,0,0,88,42,0,0,64,42,0,0,24,42,0,0,240,41,0,0,200,41,0,0,176,41,0,0,160,41,0,0,136,41,0,0,112,41,0,0,64,41,0,0,16,41,0,0,200,40,0,0,176,40,0,0,168,40,0,0,144,40,0,0,136,40,0,0,128,40,0,0,96,40,0,0,88,40,0,0,40,40,0,0,248,39,0,0,216,39,0,0,208,39,0,0,184,39,0,0,0,0,0,0])
, "i8", ALLOC_NONE, Runtime.GLOBAL_BASE)
var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);
assert(tempDoublePtr % 8 == 0);
function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much
  HEAP8[tempDoublePtr] = HEAP8[ptr];
  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];
  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];
  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];
}
function copyTempDouble(ptr) {
  HEAP8[tempDoublePtr] = HEAP8[ptr];
  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];
  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];
  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];
  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];
  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];
  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];
  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];
}
  function ___gxx_personality_v0() {
    }
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }function __ZSt9terminatev() {
      _exit(-1234);
    }
  function ___cxa_pure_virtual() {
      ABORT = true;
      throw 'Pure virtual function called!';
    }
  Module["_memcpy"] = _memcpy;var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;
  Module["_memmove"] = _memmove;var _llvm_memmove_p0i8_p0i8_i32=_memmove;
  function ___cxa_allocate_exception(size) {
      return _malloc(size);
    }
  function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr);
      } catch(e) { // XXX FIXME
      }
    }
  function _llvm_eh_exception() {
      return HEAP32[((_llvm_eh_exception.buf)>>2)];
    }
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  function ___resumeException(ptr) {
      if (HEAP32[((_llvm_eh_exception.buf)>>2)] == 0) HEAP32[((_llvm_eh_exception.buf)>>2)]=ptr;
      throw ptr;;
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = HEAP32[((_llvm_eh_exception.buf)>>2)];
      if (throwntype == -1) throwntype = HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      HEAP32[((_llvm_eh_exception.buf)>>2)]=ptr
      HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)]=type
      HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)]=destructor
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr;;
    }
  Module["_memcmp"] = _memcmp;
  var _llvm_memcpy_p0i8_p0i8_i64=_memcpy;
  function _llvm_lifetime_start() {}
  function _llvm_lifetime_end() {}
  function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      return ptr;
    }
  function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Clear type.
      HEAP32[(((_llvm_eh_exception.buf)+(4))>>2)]=0
      // Call destructor if one is registered then clear it.
      var ptr = HEAP32[((_llvm_eh_exception.buf)>>2)];
      var destructor = HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)];
      if (destructor) {
        Runtime.dynCall('vi', destructor, [ptr]);
        HEAP32[(((_llvm_eh_exception.buf)+(8))>>2)]=0
      }
      // Free ptr if it isn't null.
      if (ptr) {
        ___cxa_free_exception(ptr);
        HEAP32[((_llvm_eh_exception.buf)>>2)]=0
      }
    }
  Module["_memset"] = _memset;var _llvm_memset_p0i8_i32=_memset;
  Module["_strlen"] = _strlen;
  var _llvm_memset_p0i8_i64=_memset;
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value
      return value;
    }
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 0777, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 0777 | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },reconcile:function (src, dst, callback) {
        var total = 0;
        var create = {};
        for (var key in src.files) {
          if (!src.files.hasOwnProperty(key)) continue;
          var e = src.files[key];
          var e2 = dst.files[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create[key] = e;
            total++;
          }
        }
        var remove = {};
        for (var key in dst.files) {
          if (!dst.files.hasOwnProperty(key)) continue;
          var e = dst.files[key];
          var e2 = src.files[key];
          if (!e2) {
            remove[key] = e;
            total++;
          }
        }
        if (!total) {
          // early out
          return callback(null);
        }
        var completed = 0;
        function done(err) {
          if (err) return callback(err);
          if (++completed >= total) {
            return callback(null);
          }
        };
        // create a single transaction to handle and IDB reads / writes we'll need to do
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        transaction.onerror = function transaction_onerror() { callback(this.error); };
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
        for (var path in create) {
          if (!create.hasOwnProperty(path)) continue;
          var entry = create[path];
          if (dst.type === 'local') {
            // save file to local
            try {
              if (FS.isDir(entry.mode)) {
                FS.mkdir(path, entry.mode);
              } else if (FS.isFile(entry.mode)) {
                var stream = FS.open(path, 'w+', 0666);
                FS.write(stream, entry.contents, 0, entry.contents.length, 0, true /* canOwn */);
                FS.close(stream);
              }
              done(null);
            } catch (e) {
              return done(e);
            }
          } else {
            // save file to IDB
            var req = store.put(entry, path);
            req.onsuccess = function req_onsuccess() { done(null); };
            req.onerror = function req_onerror() { done(this.error); };
          }
        }
        for (var path in remove) {
          if (!remove.hasOwnProperty(path)) continue;
          var entry = remove[path];
          if (dst.type === 'local') {
            // delete file from local
            try {
              if (FS.isDir(entry.mode)) {
                // TODO recursive delete?
                FS.rmdir(path);
              } else if (FS.isFile(entry.mode)) {
                FS.unlink(path);
              }
              done(null);
            } catch (e) {
              return done(e);
            }
          } else {
            // delete file from IDB
            var req = store.delete(path);
            req.onsuccess = function req_onsuccess() { done(null); };
            req.onerror = function req_onerror() { done(this.error); };
          }
        }
      },getLocalSet:function (mount, callback) {
        var files = {};
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
        var check = FS.readdir(mount.mountpoint)
          .filter(isRealDir)
          .map(toAbsolute(mount.mountpoint));
        while (check.length) {
          var path = check.pop();
          var stat, node;
          try {
            var lookup = FS.lookupPath(path);
            node = lookup.node;
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path)
              .filter(isRealDir)
              .map(toAbsolute(path)));
            files[path] = { mode: stat.mode, timestamp: stat.mtime };
          } else if (FS.isFile(stat.mode)) {
            files[path] = { contents: node.contents, mode: stat.mode, timestamp: stat.mtime };
          } else {
            return callback(new Error('node type not supported'));
          }
        }
        return callback(null, { type: 'local', files: files });
      },getDB:function (name, callback) {
        // look it up in the cache
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        req.onupgradeneeded = function req_onupgradeneeded() {
          db = req.result;
          db.createObjectStore(IDBFS.DB_STORE_NAME);
        };
        req.onsuccess = function req_onsuccess() {
          db = req.result;
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function req_onerror() {
          callback(this.error);
        };
      },getRemoteSet:function (mount, callback) {
        var files = {};
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function transaction_onerror() { callback(this.error); };
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          store.openCursor().onsuccess = function store_openCursor_onsuccess(event) {
            var cursor = event.target.result;
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, files: files });
            }
            files[cursor.key] = cursor.value;
            cursor.continue();
          };
        });
      }};
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.position = position;
          return position;
        }}};
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[null],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || { recurse_count: 0 };
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
        // start at the root
        var current = FS.root;
        var current_path = '/';
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            current = current.mount.root;
          }
          // follow symlinks
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
            this.parent = null;
            this.mount = null;
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            FS.hashAddNode(this);
          };
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
          FS.FSNode.prototype = {};
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
        return new FS.FSNode(parent, name, mode, rdev);
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 1;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
        var completed = 0;
        var total = FS.mounts.length;
        function done(err) {
          if (err) {
            return callback(err);
          }
          if (++completed >= total) {
            callback(null);
          }
        };
        // sync all mounts
        for (var i = 0; i < FS.mounts.length; i++) {
          var mount = FS.mounts[i];
          if (!mount.type.syncfs) {
            done(null);
            continue;
          }
          mount.type.syncfs(mount, populate, done);
        }
      },mount:function (type, opts, mountpoint) {
        var lookup;
        if (mountpoint) {
          lookup = FS.lookupPath(mountpoint, { follow: false });
          mountpoint = lookup.path;  // use the absolute path
        }
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          root: null
        };
        // create a root node for the fs
        var root = type.mount(mount);
        root.mount = mount;
        mount.root = root;
        // assign the mount info to the mountpoint's node
        if (lookup) {
          lookup.node.mount = mount;
          lookup.node.mounted = true;
          // compatibility update FS.root if we mount to /
          if (mountpoint === '/') {
            FS.root = mount.root;
          }
        }
        // add to our cached list of mounts
        FS.mounts.push(mount);
        return root;
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 0666;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 0777;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 0666;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path, { follow: false });
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 0666 : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        } else {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0);
        } else {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=stdin.fd;
        assert(stdin.fd === 1, 'invalid handle for stdin (' + stdin.fd + ')');
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=stdout.fd;
        assert(stdout.fd === 2, 'invalid handle for stdout (' + stdout.fd + ')');
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=stderr.fd;
        assert(stderr.fd === 3, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
          this.stack = stackTrace();
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
        FS.nameTable = new Array(4096);
        FS.root = FS.createNode(null, '/', 16384 | 0777, 0);
        FS.mount(MEMFS, {}, '/');
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
        FS.ensureErrnoError();
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
              if (!hasByteServing) chunkSize = datalength;
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};function _getcwd(buf, size) {
      // char *getcwd(char *buf, size_t size);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/getcwd.html
      if (size == 0) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var cwd = FS.cwd();
      if (size < cwd.length + 1) {
        ___setErrNo(ERRNO_CODES.ERANGE);
        return 0;
      } else {
        writeAsciiToMemory(cwd, buf);
        return buf;
      }
    }
  Module["_strcpy"] = _strcpy;
  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }
  function _fmod(x, y) {
      return x % y;
    }
  function ___cxa_bad_typeid() {
  Module['printErr']('missing function: __cxa_bad_typeid'); abort(-1);
  }
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
      // Apply sign.
      ret *= multiplier;
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str
      }
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode
        HEAP32[(((buf)+(16))>>2)]=stat.nlink
        HEAP32[(((buf)+(20))>>2)]=stat.uid
        HEAP32[(((buf)+(24))>>2)]=stat.gid
        HEAP32[(((buf)+(28))>>2)]=stat.rdev
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size
        HEAP32[(((buf)+(40))>>2)]=4096
        HEAP32[(((buf)+(44))>>2)]=stat.blocks
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000)
        HEAP32[(((buf)+(52))>>2)]=0
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000)
        HEAP32[(((buf)+(60))>>2)]=0
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000)
        HEAP32[(((buf)+(68))>>2)]=0
        HEAP32[(((buf)+(72))>>2)]=stat.ino
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      _fsync(stream);
      return _close(stream);
    }
  function ___cxa_call_unexpected(exception) {
      Module.printErr('Unexpected exception thrown, this is not properly supported - aborting');
      ABORT = true;
      throw exception;
    }
  var _mkport=undefined;var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 0777, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var bytesWritten = _write(stream, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStream(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStream(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop()
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(stream, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var ret = _lseek(stream, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStream(stream);
      stream.eof = false;
      return 0;
    }var _fseeko=_fseek;
  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStream(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }var _ftello=_ftell;
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var ret = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return (ret == -1) ? 0 : ret;
    }
  var _floor=Math_floor;
  function _toupper(chr) {
      if (chr >= 97 && chr <= 122) {
        return chr - 97 + 65;
      } else {
        return chr;
      }
    }
  var _ceil=Math_ceil;
  var _fabs=Math_abs;
  function _llvm_eh_typeid_for(type) {
      return type;
    }
  function _isalpha(chr) {
      return (chr >= 97 && chr <= 122) ||
             (chr >= 65 && chr <= 90);
    }
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }
  function _isalnum(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 122) ||
             (chr >= 65 && chr <= 90);
    }
  function _pthread_mutex_lock() {}
  function _pthread_mutex_unlock() {}
  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }
  function ___cxa_guard_release() {}
  function _pthread_cond_broadcast() {
      return 0;
    }
  function _pthread_cond_wait() {
      return 0;
    }
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStream(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }
  function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStream(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }var _getc=_fgetc;
  function ___errno_location() {
      return ___errno_state;
    }
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  function _abort() {
      Module['abort']();
    }
  function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      throw HEAP32[((_llvm_eh_exception.buf)>>2)];;
    }
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = HEAPF64[(((varargs)+(argIndex))>>3)];
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+8))>>2)]];
          argIndex += 8; // each 32-bit chunk is in a 64-bit block
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Math.max(Runtime.getNativeFieldSize(type), Runtime.getAlignSize(type, null, true));
        return ret;
      }
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
          // Handle precision.
          var precisionSet = false;
          if (next == 46) {
            var precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          } else {
            var precision = 6; // Standard default.
          }
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }
  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }
  function ___cxa_guard_abort() {}
  var _isxdigit_l=_isxdigit;
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }var _isdigit_l=_isdigit;
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16)
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text)
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text)
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j]
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }
  function _catopen() { throw 'TODO: ' + aborter }
  function _catgets() { throw 'TODO: ' + aborter }
  function _catclose() { throw 'TODO: ' + aborter }
  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }
  function _freelocale(locale) {
      _free(locale);
    }
  function _isascii(chr) {
      return chr >= 0 && (chr & 0x80) == 0;
    }
  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i]
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i]
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i]
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
      var pattern = Pointer_stringify(format);
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }var _strftime_l=_strftime;
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str
      }
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }var _strtoull_l=_strtoull;
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }var _strtoll_l=_strtoll;
  function _uselocale(locale) {
      return 0;
    }
  var _llvm_va_start=undefined;
  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }
  function _llvm_va_end() {}
  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }
  function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }
  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }
  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret
      }
      return ret;
    }
  var Browser={mainLoop:{scheduler:null,shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
        // Canvas event setup
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
            var errorInfo = '?';
            function onContextCreationError(event) {
              errorInfo = event.statusMessage || errorInfo;
            }
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (window.scrollX + rect.left);
              y = t.pageY - (window.scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (window.scrollX + rect.left);
            y = event.pageY - (window.scrollY + rect.top);
          }
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};
_llvm_eh_exception.buf = allocate(12, "void*", ALLOC_STATIC);
FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);
staticSealed = true; // seal the static portion of memory
STACK_MAX = STACK_BASE + 5242880;
DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);
assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");
 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);
var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iddddiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iddddiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) {
  try {
    return Module["dynCall_iiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_vidi(index,a1,a2,a3) {
  try {
    Module["dynCall_vidi"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15) {
  try {
    Module["dynCall_viiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_ddd(index,a1,a2) {
  try {
    return Module["dynCall_ddd"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_fiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_fiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiidi(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiidi"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    Module["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_diii(index,a1,a2,a3) {
  try {
    return Module["dynCall_diii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}
function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___fsmu8|0;var p=env.__ZTVN10__cxxabiv117__class_type_infoE|0;var q=env._stdout|0;var r=env.___dso_handle|0;var s=env._stdin|0;var t=env.__ZTVN10__cxxabiv120__si_class_type_infoE|0;var u=env._stderr|0;var v=+env.NaN;var w=+env.Infinity;var x=0;var y=0;var z=0;var A=0;var B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=0;var U=global.Math.floor;var V=global.Math.abs;var W=global.Math.sqrt;var X=global.Math.pow;var Y=global.Math.cos;var Z=global.Math.sin;var _=global.Math.tan;var $=global.Math.acos;var aa=global.Math.asin;var ab=global.Math.atan;var ac=global.Math.atan2;var ad=global.Math.exp;var ae=global.Math.log;var af=global.Math.ceil;var ag=global.Math.imul;var ah=env.abort;var ai=env.assert;var aj=env.asmPrintInt;var ak=env.asmPrintFloat;var al=env.min;var am=env.invoke_iiiiiiii;var an=env.invoke_iiiiiiddi;var ao=env.invoke_viiiii;var ap=env.invoke_vi;var aq=env.invoke_vii;var ar=env.invoke_iiiiiii;var as=env.invoke_ii;var at=env.invoke_viiiddddi;var au=env.invoke_iddddiii;var av=env.invoke_iiiiiiiiiiii;var aw=env.invoke_vidi;var ax=env.invoke_iiii;var ay=env.invoke_viiiiiiiiiiiiiii;var az=env.invoke_viiiiid;var aA=env.invoke_viiiiiiii;var aB=env.invoke_viiiiii;var aC=env.invoke_ddd;var aD=env.invoke_fiii;var aE=env.invoke_viiidi;var aF=env.invoke_iid;var aG=env.invoke_viiiiiii;var aH=env.invoke_viiiiiid;var aI=env.invoke_viiiiiiiii;var aJ=env.invoke_viiiiiiiiii;var aK=env.invoke_iii;var aL=env.invoke_diii;var aM=env.invoke_dii;var aN=env.invoke_i;var aO=env.invoke_iiiiii;var aP=env.invoke_viii;var aQ=env.invoke_v;var aR=env.invoke_iiiiiiiii;var aS=env.invoke_iiiii;var aT=env.invoke_viiii;var aU=env._llvm_lifetime_end;var aV=env._lseek;var aW=env.__scanString;var aX=env._fclose;var aY=env._pthread_mutex_lock;var aZ=env.___cxa_end_catch;var a_=env._strtoull;var a$=env._fflush;var a0=env._strtol;var a1=env.__isLeapYear;var a2=env._fwrite;var a3=env._send;var a4=env._isspace;var a5=env._read;var a6=env._ceil;var a7=env._fsync;var a8=env.___cxa_guard_abort;var a9=env._newlocale;var ba=env.___gxx_personality_v0;var bb=env._pthread_cond_wait;var bc=env.___cxa_rethrow;var bd=env._fmod;var be=env.___resumeException;var bf=env._llvm_va_end;var bg=env._vsscanf;var bh=env._snprintf;var bi=env._fgetc;var bj=env.__getFloat;var bk=env._atexit;var bl=env.___cxa_free_exception;var bm=env._close;var bn=env.___setErrNo;var bo=env._isxdigit;var bp=env._ftell;var bq=env._exit;var br=env._sprintf;var bs=env._asprintf;var bt=env.___ctype_b_loc;var bu=env._freelocale;var bv=env._catgets;var bw=env.___cxa_is_number_type;var bx=env._getcwd;var by=env.___cxa_does_inherit;var bz=env.___cxa_guard_acquire;var bA=env.___cxa_begin_catch;var bB=env._recv;var bC=env.__parseInt64;var bD=env.__ZSt18uncaught_exceptionv;var bE=env.___cxa_call_unexpected;var bF=env.__exit;var bG=env._strftime;var bH=env.___cxa_throw;var bI=env._llvm_eh_exception;var bJ=env._toupper;var bK=env._pread;var bL=env._fopen;var bM=env._open;var bN=env.__arraySum;var bO=env._isalnum;var bP=env._isalpha;var bQ=env.___cxa_find_matching_catch;var bR=env._strdup;var bS=env.__formatString;var bT=env._pthread_cond_broadcast;var bU=env.__ZSt9terminatev;var bV=env._isascii;var bW=env._pthread_mutex_unlock;var bX=env._sbrk;var bY=env.___errno_location;var bZ=env._strerror;var b_=env._catclose;var b$=env._llvm_lifetime_start;var b0=env.__parseInt;var b1=env.___cxa_guard_release;var b2=env._ungetc;var b3=env._uselocale;var b4=env._vsnprintf;var b5=env._sscanf;var b6=env._sysconf;var b7=env._fread;var b8=env._abort;var b9=env._isdigit;var ca=env._strtoll;var cb=env.__addDays;var cc=env._fabs;var cd=env._floor;var ce=env.__reallyNegative;var cf=env._fseek;var cg=env.___cxa_bad_typeid;var ch=env._write;var ci=env.___cxa_allocate_exception;var cj=env._stat;var ck=env.___cxa_pure_virtual;var cl=env._vasprintf;var cm=env._catopen;var cn=env.___ctype_toupper_loc;var co=env.___ctype_tolower_loc;var cp=env._llvm_eh_typeid_for;var cq=env._pwrite;var cr=env._strerror_r;var cs=env._time;var ct=0.0;
// EMSCRIPTEN_START_FUNCS
function EU(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;E8(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!x){L=J}else{x=0;M=35;break L12}}else{L=c[I>>2]|0}if((L|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){M=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!x){P=O}else{x=0;M=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;M=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((M|0)==22){M=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}x=0;aP(80,o|0,V<<1|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,X|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){Y=y}else{Y=c[z>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){$=_}else{x=0;M=35;break}}else{$=c[J>>2]|0}if((E4($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;x=0,as(O|0,H|0)|0;if(!x){F=Z;G=H;continue}else{x=0;M=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((M|0)==35){G=bQ(-1,-1)|0;aa=K;ab=G;CP(o);CP(n);be(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(2,S|0,c[q>>2]|0,j|0,v|0)|0);if(x){x=0;break}c[k>>2]=F;G_(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{F=c[H+12>>2]|0;if((F|0)==(c[H+16>>2]|0)){G=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){ae=G}else{x=0;break L6}}else{ae=c[F>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){M=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){F=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!x){af=F}else{x=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;M=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);do{if((M|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;aa=K;ab=e;CP(o);CP(n);be(ab|0)}function EV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];EW(a,0,j,k,f,g,h);i=b;return}function EW(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==8){v=16}else if((u|0)==0){v=0}else if((u|0)==64){v=8}else{v=10}u=l|0;E8(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!x){L=J}else{x=0;M=35;break L12}}else{L=c[I>>2]|0}if((L|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){M=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!x){P=O}else{x=0;M=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;M=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((M|0)==22){M=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}x=0;aP(80,o|0,V<<1|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,X|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){Y=y}else{Y=c[z>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){$=_}else{x=0;M=35;break}}else{$=c[J>>2]|0}if((E4($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;x=0,as(O|0,H|0)|0;if(!x){F=Z;G=H;continue}else{x=0;M=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((M|0)==35){G=bQ(-1,-1)|0;aa=K;ab=G;CP(o);CP(n);be(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(28,S|0,c[q>>2]|0,j|0,v|0)|0);if(x){x=0;break}c[k>>2]=F;G_(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{F=c[H+12>>2]|0;if((F|0)==(c[H+16>>2]|0)){G=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){ae=G}else{x=0;break L6}}else{ae=c[F>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){M=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){F=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!x){af=F}else{x=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;M=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);do{if((M|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;aa=K;ab=e;CP(o);CP(n);be(ab|0)}function EX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];EY(a,0,j,k,f,g,h);i=b;return}function EY(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;E8(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!x){L=J}else{x=0;M=35;break L12}}else{L=c[I>>2]|0}if((L|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){M=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!x){P=O}else{x=0;M=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;M=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((M|0)==22){M=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}x=0;aP(80,o|0,V<<1|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,X|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){Y=y}else{Y=c[z>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){$=_}else{x=0;M=35;break}}else{$=c[J>>2]|0}if((E4($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;x=0,as(O|0,H|0)|0;if(!x){F=Z;G=H;continue}else{x=0;M=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((M|0)==35){G=bQ(-1,-1)|0;aa=K;ab=G;CP(o);CP(n);be(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(22,S|0,c[q>>2]|0,j|0,v|0)|0);G=K;if(x){x=0;break}c[k>>2]=F;c[k+4>>2]=G;G_(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{G=c[H+12>>2]|0;if((G|0)==(c[H+16>>2]|0)){F=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){ae=F}else{x=0;break L6}}else{ae=c[G>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){M=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){G=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!x){af=G}else{x=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;M=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);do{if((M|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;aa=K;ab=e;CP(o);CP(n);be(ab|0)}function EZ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];E_(a,0,j,k,f,g,h);i=b;return}function E_(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0.0,ai=0,aj=0,ak=0,al=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;y=e|0;E9(o,j,y,m,n);Ke(q|0,0,12)|0;j=p;x=0;aP(80,p|0,10,0);L1:do{if(!x){if((a[q]&1)==0){z=j+1|0;A=z;B=z;C=p+8|0}else{z=p+8|0;A=c[z>>2]|0;B=j+1|0;C=z}c[r>>2]=A;z=s|0;c[t>>2]=z;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=h|0;F=p|0;G=p+4|0;H=c[m>>2]|0;I=c[n>>2]|0;J=A;L=c[D>>2]|0;L7:while(1){do{if((L|0)==0){M=0}else{N=c[L+12>>2]|0;if((N|0)==(c[L+16>>2]|0)){O=(x=0,as(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!x){P=O}else{x=0;Q=31;break L7}}else{P=c[N>>2]|0}if((P|0)!=-1){M=L;break}c[D>>2]=0;M=0}}while(0);R=(M|0)==0;N=c[E>>2]|0;do{if((N|0)==0){Q=18}else{O=c[N+12>>2]|0;if((O|0)==(c[N+16>>2]|0)){S=(x=0,as(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(!x){T=S}else{x=0;Q=31;break L7}}else{T=c[O>>2]|0}if((T|0)==-1){c[E>>2]=0;Q=18;break}else{O=(N|0)==0;if(R^O){U=N;V=O;break}else{W=J;X=N;Y=O;break L7}}}}while(0);if((Q|0)==18){Q=0;if(R){W=J;X=0;Y=1;break}else{U=0;V=1}}N=d[q]|0;O=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((O?N>>>1:c[G>>2]|0)|0)){if(O){Z=N>>>1;_=N>>>1}else{N=c[G>>2]|0;Z=N;_=N}x=0;aP(80,p|0,Z<<1|0,0);if(x){x=0;Q=31;break}if((a[q]&1)==0){$=10}else{$=(c[F>>2]&-2)-1|0}x=0;aP(80,p|0,$|0,0);if(x){x=0;Q=31;break}if((a[q]&1)==0){aa=B}else{aa=c[C>>2]|0}c[r>>2]=aa+_;ab=aa}else{ab=J}N=M+12|0;O=c[N>>2]|0;S=M+16|0;if((O|0)==(c[S>>2]|0)){ac=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(!x){ad=ac}else{x=0;Q=31;break}}else{ad=c[O>>2]|0}if((Fa(ad,v,w,ab,r,H,I,o,z,t,u,y)|0)!=0){W=ab;X=U;Y=V;break}O=c[N>>2]|0;if((O|0)==(c[S>>2]|0)){S=c[(c[M>>2]|0)+40>>2]|0;x=0,as(S|0,M|0)|0;if(!x){J=ab;L=M;continue}else{x=0;Q=31;break}}else{c[N>>2]=O+4;J=ab;L=M;continue}}if((Q|0)==31){L=bQ(-1,-1)|0;ae=K;af=L;CP(p);CP(o);be(af|0)}L=d[o]|0;if((L&1|0)==0){ag=L>>>1}else{ag=c[o+4>>2]|0}do{if((ag|0)!=0){if((a[v]&1)==0){break}L=c[t>>2]|0;if((L-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=L+4;c[L>>2]=J}}while(0);ah=(x=0,+(+aD(2,W|0,c[r>>2]|0,k|0)));if(x){x=0;break}g[l>>2]=ah;G_(o,z,c[t>>2]|0,k);do{if(R){ai=0}else{J=c[M+12>>2]|0;if((J|0)==(c[M+16>>2]|0)){L=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(!x){aj=L}else{x=0;break L1}}else{aj=c[J>>2]|0}if((aj|0)!=-1){ai=M;break}c[D>>2]=0;ai=0}}while(0);D=(ai|0)==0;do{if(Y){Q=61}else{z=c[X+12>>2]|0;if((z|0)==(c[X+16>>2]|0)){J=(x=0,as(c[(c[X>>2]|0)+36>>2]|0,X|0)|0);if(!x){ak=J}else{x=0;break L1}}else{ak=c[z>>2]|0}if((ak|0)==-1){c[E>>2]=0;Q=61;break}if(!(D^(X|0)==0)){break}al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}}while(0);do{if((Q|0)==61){if(D){break}al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;ae=K;af=e;CP(p);CP(o);be(af|0)}function E$(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];E0(a,0,j,k,f,g,h);i=b;return}function E0(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0.0,ai=0,aj=0,ak=0,al=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;y=e|0;E9(o,j,y,m,n);Ke(q|0,0,12)|0;j=p;x=0;aP(80,p|0,10,0);L1:do{if(!x){if((a[q]&1)==0){z=j+1|0;A=z;B=z;C=p+8|0}else{z=p+8|0;A=c[z>>2]|0;B=j+1|0;C=z}c[r>>2]=A;z=s|0;c[t>>2]=z;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=g|0;F=p|0;G=p+4|0;H=c[m>>2]|0;I=c[n>>2]|0;J=A;L=c[D>>2]|0;L7:while(1){do{if((L|0)==0){M=0}else{N=c[L+12>>2]|0;if((N|0)==(c[L+16>>2]|0)){O=(x=0,as(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!x){P=O}else{x=0;Q=31;break L7}}else{P=c[N>>2]|0}if((P|0)!=-1){M=L;break}c[D>>2]=0;M=0}}while(0);R=(M|0)==0;N=c[E>>2]|0;do{if((N|0)==0){Q=18}else{O=c[N+12>>2]|0;if((O|0)==(c[N+16>>2]|0)){S=(x=0,as(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(!x){T=S}else{x=0;Q=31;break L7}}else{T=c[O>>2]|0}if((T|0)==-1){c[E>>2]=0;Q=18;break}else{O=(N|0)==0;if(R^O){U=N;V=O;break}else{W=J;X=N;Y=O;break L7}}}}while(0);if((Q|0)==18){Q=0;if(R){W=J;X=0;Y=1;break}else{U=0;V=1}}N=d[q]|0;O=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((O?N>>>1:c[G>>2]|0)|0)){if(O){Z=N>>>1;_=N>>>1}else{N=c[G>>2]|0;Z=N;_=N}x=0;aP(80,p|0,Z<<1|0,0);if(x){x=0;Q=31;break}if((a[q]&1)==0){$=10}else{$=(c[F>>2]&-2)-1|0}x=0;aP(80,p|0,$|0,0);if(x){x=0;Q=31;break}if((a[q]&1)==0){aa=B}else{aa=c[C>>2]|0}c[r>>2]=aa+_;ab=aa}else{ab=J}N=M+12|0;O=c[N>>2]|0;S=M+16|0;if((O|0)==(c[S>>2]|0)){ac=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(!x){ad=ac}else{x=0;Q=31;break}}else{ad=c[O>>2]|0}if((Fa(ad,v,w,ab,r,H,I,o,z,t,u,y)|0)!=0){W=ab;X=U;Y=V;break}O=c[N>>2]|0;if((O|0)==(c[S>>2]|0)){S=c[(c[M>>2]|0)+40>>2]|0;x=0,as(S|0,M|0)|0;if(!x){J=ab;L=M;continue}else{x=0;Q=31;break}}else{c[N>>2]=O+4;J=ab;L=M;continue}}if((Q|0)==31){L=bQ(-1,-1)|0;ae=K;af=L;CP(p);CP(o);be(af|0)}L=d[o]|0;if((L&1|0)==0){ag=L>>>1}else{ag=c[o+4>>2]|0}do{if((ag|0)!=0){if((a[v]&1)==0){break}L=c[t>>2]|0;if((L-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=L+4;c[L>>2]=J}}while(0);ah=(x=0,+(+aL(4,W|0,c[r>>2]|0,k|0)));if(x){x=0;break}h[l>>3]=ah;G_(o,z,c[t>>2]|0,k);do{if(R){ai=0}else{J=c[M+12>>2]|0;if((J|0)==(c[M+16>>2]|0)){L=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(!x){aj=L}else{x=0;break L1}}else{aj=c[J>>2]|0}if((aj|0)!=-1){ai=M;break}c[D>>2]=0;ai=0}}while(0);D=(ai|0)==0;do{if(Y){Q=61}else{z=c[X+12>>2]|0;if((z|0)==(c[X+16>>2]|0)){J=(x=0,as(c[(c[X>>2]|0)+36>>2]|0,X|0)|0);if(!x){ak=J}else{x=0;break L1}}else{ak=c[z>>2]|0}if((ak|0)==-1){c[E>>2]=0;Q=61;break}if(!(D^(X|0)==0)){break}al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}}while(0);do{if((Q|0)==61){if(D){break}al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;ae=K;af=e;CP(p);CP(o);be(af|0)}function E1(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];E2(a,0,j,k,f,g,h);i=b;return}function E2(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0.0,ai=0,aj=0,ak=0,al=0;e=i;i=i+176|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+128|0;n=e+136|0;o=e+144|0;p=e+160|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;y=e|0;E9(o,j,y,m,n);Ke(q|0,0,12)|0;j=p;x=0;aP(80,p|0,10,0);L1:do{if(!x){if((a[q]&1)==0){z=j+1|0;A=z;B=z;C=p+8|0}else{z=p+8|0;A=c[z>>2]|0;B=j+1|0;C=z}c[r>>2]=A;z=s|0;c[t>>2]=z;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=g|0;F=p|0;G=p+4|0;H=c[m>>2]|0;I=c[n>>2]|0;J=A;L=c[D>>2]|0;L7:while(1){do{if((L|0)==0){M=0}else{N=c[L+12>>2]|0;if((N|0)==(c[L+16>>2]|0)){O=(x=0,as(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(!x){P=O}else{x=0;Q=31;break L7}}else{P=c[N>>2]|0}if((P|0)!=-1){M=L;break}c[D>>2]=0;M=0}}while(0);R=(M|0)==0;N=c[E>>2]|0;do{if((N|0)==0){Q=18}else{O=c[N+12>>2]|0;if((O|0)==(c[N+16>>2]|0)){S=(x=0,as(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(!x){T=S}else{x=0;Q=31;break L7}}else{T=c[O>>2]|0}if((T|0)==-1){c[E>>2]=0;Q=18;break}else{O=(N|0)==0;if(R^O){U=N;V=O;break}else{W=J;X=N;Y=O;break L7}}}}while(0);if((Q|0)==18){Q=0;if(R){W=J;X=0;Y=1;break}else{U=0;V=1}}N=d[q]|0;O=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((O?N>>>1:c[G>>2]|0)|0)){if(O){Z=N>>>1;_=N>>>1}else{N=c[G>>2]|0;Z=N;_=N}x=0;aP(80,p|0,Z<<1|0,0);if(x){x=0;Q=31;break}if((a[q]&1)==0){$=10}else{$=(c[F>>2]&-2)-1|0}x=0;aP(80,p|0,$|0,0);if(x){x=0;Q=31;break}if((a[q]&1)==0){aa=B}else{aa=c[C>>2]|0}c[r>>2]=aa+_;ab=aa}else{ab=J}N=M+12|0;O=c[N>>2]|0;S=M+16|0;if((O|0)==(c[S>>2]|0)){ac=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(!x){ad=ac}else{x=0;Q=31;break}}else{ad=c[O>>2]|0}if((Fa(ad,v,w,ab,r,H,I,o,z,t,u,y)|0)!=0){W=ab;X=U;Y=V;break}O=c[N>>2]|0;if((O|0)==(c[S>>2]|0)){S=c[(c[M>>2]|0)+40>>2]|0;x=0,as(S|0,M|0)|0;if(!x){J=ab;L=M;continue}else{x=0;Q=31;break}}else{c[N>>2]=O+4;J=ab;L=M;continue}}if((Q|0)==31){L=bQ(-1,-1)|0;ae=K;af=L;CP(p);CP(o);be(af|0)}L=d[o]|0;if((L&1|0)==0){ag=L>>>1}else{ag=c[o+4>>2]|0}do{if((ag|0)!=0){if((a[v]&1)==0){break}L=c[t>>2]|0;if((L-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=L+4;c[L>>2]=J}}while(0);ah=(x=0,+(+aL(2,W|0,c[r>>2]|0,k|0)));if(x){x=0;break}h[l>>3]=ah;G_(o,z,c[t>>2]|0,k);do{if(R){ai=0}else{J=c[M+12>>2]|0;if((J|0)==(c[M+16>>2]|0)){L=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(!x){aj=L}else{x=0;break L1}}else{aj=c[J>>2]|0}if((aj|0)!=-1){ai=M;break}c[D>>2]=0;ai=0}}while(0);D=(ai|0)==0;do{if(Y){Q=61}else{z=c[X+12>>2]|0;if((z|0)==(c[X+16>>2]|0)){J=(x=0,as(c[(c[X>>2]|0)+36>>2]|0,X|0)|0);if(!x){ak=J}else{x=0;break L1}}else{ak=c[z>>2]|0}if((ak|0)==-1){c[E>>2]=0;Q=61;break}if(!(D^(X|0)==0)){break}al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}}while(0);do{if((Q|0)==61){if(D){break}al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;al=b|0;c[al>>2]=ai;CP(p);CP(o);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;ae=K;af=e;CP(p);CP(o);be(af|0)}function E3(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;e=i;i=i+136|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+120|0;o=i;i=i+4|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;Ke(n|0,0,12)|0;u=p;x=0;aq(346,o|0,h|0);if(x){x=0;h=bQ(-1,-1)|0;v=K;w=h;CP(n);y=w;z=0;A=y;B=v;be(A|0)}h=o|0;o=c[h>>2]|0;if((c[10068]|0)==-1){C=4}else{c[l>>2]=40272;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40272,l|0,512);if(!x){C=4}else{x=0}}L7:do{if((C|0)==4){l=(c[10069]|0)-1|0;D=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-D>>2>>>0>l>>>0){E=c[D+(l<<2)>>2]|0;if((E|0)==0){break}F=E;G=m|0;H=c[(c[E>>2]|0)+48>>2]|0;x=0,aS(H|0,F|0,31280,31306,G|0)|0;if(x){x=0;break L7}Cn(c[h>>2]|0)|0;Ke(u|0,0,12)|0;F=p;x=0;aP(80,p|0,10,0);L13:do{if(!x){if((a[u]&1)==0){H=F+1|0;I=H;J=H;L=p+8|0}else{H=p+8|0;I=c[H>>2]|0;J=F+1|0;L=H}c[q>>2]=I;H=r|0;c[s>>2]=H;c[t>>2]=0;E=f|0;M=g|0;N=p|0;O=p+4|0;P=I;Q=c[E>>2]|0;L19:while(1){do{if((Q|0)==0){R=0}else{S=c[Q+12>>2]|0;if((S|0)==(c[Q+16>>2]|0)){T=(x=0,as(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(!x){U=T}else{x=0;C=41;break L19}}else{U=c[S>>2]|0}if((U|0)!=-1){R=Q;break}c[E>>2]=0;R=0}}while(0);S=(R|0)==0;T=c[M>>2]|0;do{if((T|0)==0){C=26}else{V=c[T+12>>2]|0;if((V|0)==(c[T+16>>2]|0)){W=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!x){X=W}else{x=0;C=41;break L19}}else{X=c[V>>2]|0}if((X|0)==-1){c[M>>2]=0;C=26;break}else{if(S^(T|0)==0){break}else{Y=P;break L19}}}}while(0);if((C|0)==26){C=0;if(S){Y=P;break}}T=d[u]|0;V=(T&1|0)==0;if(((c[q>>2]|0)-P|0)==((V?T>>>1:c[O>>2]|0)|0)){if(V){Z=T>>>1;_=T>>>1}else{T=c[O>>2]|0;Z=T;_=T}x=0;aP(80,p|0,Z<<1|0,0);if(x){x=0;C=41;break}if((a[u]&1)==0){$=10}else{$=(c[N>>2]&-2)-1|0}x=0;aP(80,p|0,$|0,0);if(x){x=0;C=41;break}if((a[u]&1)==0){aa=J}else{aa=c[L>>2]|0}c[q>>2]=aa+_;ab=aa}else{ab=P}T=R+12|0;V=c[T>>2]|0;W=R+16|0;if((V|0)==(c[W>>2]|0)){ac=(x=0,as(c[(c[R>>2]|0)+36>>2]|0,R|0)|0);if(!x){ad=ac}else{x=0;C=41;break}}else{ad=c[V>>2]|0}if((E4(ad,16,ab,q,t,0,n,H,s,G)|0)!=0){Y=ab;break}V=c[T>>2]|0;if((V|0)==(c[W>>2]|0)){W=c[(c[R>>2]|0)+40>>2]|0;x=0,as(W|0,R|0)|0;if(!x){P=ab;Q=R;continue}else{x=0;C=41;break}}else{c[T>>2]=V+4;P=ab;Q=R;continue}}if((C|0)==41){Q=bQ(-1,-1)|0;ae=K;af=Q;break}a[Y+3|0]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}Q=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=Q;break}else{x=0;Q=bQ(-1,-1)|0;ae=K;af=Q;break L13}}}while(0);Q=(x=0,aS(18,Y|0,c[9712]|0,8032,(P=i,i=i+8|0,c[P>>2]=k,P)|0)|0);i=P;if(x){x=0;C=42;break}if((Q|0)!=1){c[j>>2]=4}Q=c[E>>2]|0;do{if((Q|0)==0){ag=0}else{P=c[Q+12>>2]|0;if((P|0)==(c[Q+16>>2]|0)){H=(x=0,as(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(!x){ah=H}else{x=0;C=42;break L13}}else{ah=c[P>>2]|0}if((ah|0)!=-1){ag=Q;break}c[E>>2]=0;ag=0}}while(0);E=(ag|0)==0;Q=c[M>>2]|0;do{if((Q|0)==0){C=71}else{P=c[Q+12>>2]|0;if((P|0)==(c[Q+16>>2]|0)){H=(x=0,as(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(!x){ai=H}else{x=0;C=42;break L13}}else{ai=c[P>>2]|0}if((ai|0)==-1){c[M>>2]=0;C=71;break}if(!(E^(Q|0)==0)){break}aj=b|0;c[aj>>2]=ag;CP(p);CP(n);i=e;return}}while(0);do{if((C|0)==71){if(E){break}aj=b|0;c[aj>>2]=ag;CP(p);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;aj=b|0;c[aj>>2]=ag;CP(p);CP(n);i=e;return}else{x=0;C=42}}while(0);if((C|0)==42){G=bQ(-1,-1)|0;ae=K;af=G}CP(p);v=ae;w=af;CP(n);y=w;z=0;A=y;B=v;be(A|0)}}while(0);l=ci(4)|0;JB(l);x=0;aP(144,l|0,28080,98);if(x){x=0;break}}}while(0);af=bQ(-1,-1)|0;ae=K;Cn(c[h>>2]|0)|0;v=ae;w=af;CP(n);y=w;z=0;A=y;B=v;be(A|0)}function E4(b,e,f,g,h,i,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=c[g>>2]|0;o=(n|0)==(f|0);do{if(o){p=(c[m+96>>2]|0)==(b|0);if(!p){if((c[m+100>>2]|0)!=(b|0)){break}}c[g>>2]=f+1;a[f]=p?43:45;c[h>>2]=0;q=0;return q|0}}while(0);p=d[j]|0;if((p&1|0)==0){r=p>>>1}else{r=c[j+4>>2]|0}if((r|0)!=0&(b|0)==(i|0)){i=c[l>>2]|0;if((i-k|0)>=160){q=0;return q|0}k=c[h>>2]|0;c[l>>2]=i+4;c[i>>2]=k;c[h>>2]=0;q=0;return q|0}k=m+104|0;i=m;while(1){if((i|0)==(k|0)){s=k;break}if((c[i>>2]|0)==(b|0)){s=i;break}else{i=i+4|0}}i=s-m|0;m=i>>2;if((i|0)>92){q=-1;return q|0}do{if((e|0)==8|(e|0)==10){if((m|0)<(e|0)){break}else{q=-1}return q|0}else if((e|0)==16){if((i|0)<88){break}if(o){q=-1;return q|0}if((n-f|0)>=3){q=-1;return q|0}if((a[n-1|0]|0)!=48){q=-1;return q|0}c[h>>2]=0;s=a[31280+m|0]|0;b=c[g>>2]|0;c[g>>2]=b+1;a[b]=s;q=0;return q|0}}while(0);f=a[31280+m|0]|0;c[g>>2]=n+1;a[n]=f;c[h>>2]=(c[h>>2]|0)+1;q=0;return q|0}function E5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+40|0;h=g|0;j=g+16|0;k=g+32|0;C8(k,d);d=k|0;k=c[d>>2]|0;if((c[10070]|0)==-1){l=3}else{c[j>>2]=40280;c[j+4>>2]=454;c[j+8>>2]=0;x=0;aP(2,40280,j|0,512);if(!x){l=3}else{x=0}}L3:do{if((l|0)==3){j=(c[10071]|0)-1|0;m=c[k+8>>2]|0;do{if((c[k+12>>2]|0)-m>>2>>>0>j>>>0){n=c[m+(j<<2)>>2]|0;if((n|0)==0){break}o=n;p=c[(c[n>>2]|0)+32>>2]|0;x=0,aS(p|0,o|0,31280,31306,e|0)|0;if(x){x=0;break L3}o=c[d>>2]|0;if((c[9974]|0)!=-1){c[h>>2]=39896;c[h+4>>2]=454;c[h+8>>2]=0;x=0;aP(2,39896,h|0,512);if(x){x=0;break L3}}p=(c[9975]|0)-1|0;n=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-n>>2>>>0>p>>>0){q=c[n+(p<<2)>>2]|0;if((q|0)==0){break}r=q;s=(x=0,as(c[(c[q>>2]|0)+16>>2]|0,r|0)|0);if(x){x=0;break L3}a[f]=s;x=0;aq(c[(c[q>>2]|0)+20>>2]|0,b|0,r|0);if(x){x=0;break L3}Cn(c[d>>2]|0)|0;i=g;return}}while(0);p=ci(4)|0;JB(p);x=0;aP(144,p|0,28080,98);if(x){x=0;break L3}}}while(0);j=ci(4)|0;JB(j);x=0;aP(144,j|0,28080,98);if(x){x=0;break}}}while(0);g=bQ(-1,-1)|0;Cn(c[d>>2]|0)|0;be(g|0)}function E6(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h|0;k=h+16|0;l=h+32|0;C8(l,d);d=l|0;l=c[d>>2]|0;if((c[10070]|0)==-1){m=3}else{c[k>>2]=40280;c[k+4>>2]=454;c[k+8>>2]=0;x=0;aP(2,40280,k|0,512);if(!x){m=3}else{x=0}}L3:do{if((m|0)==3){k=(c[10071]|0)-1|0;n=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-n>>2>>>0>k>>>0){o=c[n+(k<<2)>>2]|0;if((o|0)==0){break}p=o;q=c[(c[o>>2]|0)+32>>2]|0;x=0,aS(q|0,p|0,31280,31312,e|0)|0;if(x){x=0;break L3}p=c[d>>2]|0;if((c[9974]|0)!=-1){c[j>>2]=39896;c[j+4>>2]=454;c[j+8>>2]=0;x=0;aP(2,39896,j|0,512);if(x){x=0;break L3}}q=(c[9975]|0)-1|0;o=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-o>>2>>>0>q>>>0){r=c[o+(q<<2)>>2]|0;if((r|0)==0){break}s=r;t=r;u=(x=0,as(c[(c[t>>2]|0)+12>>2]|0,s|0)|0);if(x){x=0;break L3}a[f]=u;u=(x=0,as(c[(c[t>>2]|0)+16>>2]|0,s|0)|0);if(x){x=0;break L3}a[g]=u;x=0;aq(c[(c[r>>2]|0)+20>>2]|0,b|0,s|0);if(x){x=0;break L3}Cn(c[d>>2]|0)|0;i=h;return}}while(0);q=ci(4)|0;JB(q);x=0;aP(144,q|0,28080,98);if(x){x=0;break L3}}}while(0);k=ci(4)|0;JB(k);x=0;aP(144,k|0,28080,98);if(x){x=0;break}}}while(0);h=bQ(-1,-1)|0;Cn(c[d>>2]|0)|0;be(h|0)}function E7(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0;if(b<<24>>24==i<<24>>24){if((a[e]&1)==0){p=-1;return p|0}a[e]=0;i=c[h>>2]|0;c[h>>2]=i+1;a[i]=46;i=d[k]|0;if((i&1|0)==0){q=i>>>1}else{q=c[k+4>>2]|0}if((q|0)==0){p=0;return p|0}q=c[m>>2]|0;if((q-l|0)>=160){p=0;return p|0}i=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=i;p=0;return p|0}do{if(b<<24>>24==j<<24>>24){i=d[k]|0;if((i&1|0)==0){r=i>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){break}if((a[e]&1)==0){p=-1;return p|0}i=c[m>>2]|0;if((i-l|0)>=160){p=0;return p|0}q=c[n>>2]|0;c[m>>2]=i+4;c[i>>2]=q;c[n>>2]=0;p=0;return p|0}}while(0);r=o+32|0;j=o;while(1){if((j|0)==(r|0)){s=r;break}if((a[j]|0)==b<<24>>24){s=j;break}else{j=j+1|0}}j=s-o|0;if((j|0)>31){p=-1;return p|0}o=a[31280+j|0]|0;if((j|0)==22|(j|0)==23){a[f]=80;s=c[h>>2]|0;c[h>>2]=s+1;a[s]=o;p=0;return p|0}else if((j|0)==25|(j|0)==24){s=c[h>>2]|0;do{if((s|0)!=(g|0)){if((a[s-1|0]&95|0)==(a[f]&127|0)){break}else{p=-1}return p|0}}while(0);c[h>>2]=s+1;a[s]=o;p=0;return p|0}else{s=a[f]|0;do{if((o&95|0)==(s<<24>>24|0)){a[f]=s|-128;if((a[e]&1)==0){break}a[e]=0;g=d[k]|0;if((g&1|0)==0){t=g>>>1}else{t=c[k+4>>2]|0}if((t|0)==0){break}g=c[m>>2]|0;if((g-l|0)>=160){break}b=c[n>>2]|0;c[m>>2]=g+4;c[g>>2]=b}}while(0);m=c[h>>2]|0;c[h>>2]=m+1;a[m]=o;if((j|0)>21){p=0;return p|0}c[n>>2]=(c[n>>2]|0)+1;p=0;return p|0}return 0}function E8(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+40|0;g=f|0;h=f+16|0;j=f+32|0;C8(j,b);b=j|0;j=c[b>>2]|0;if((c[10068]|0)==-1){k=3}else{c[h>>2]=40272;c[h+4>>2]=454;c[h+8>>2]=0;x=0;aP(2,40272,h|0,512);if(!x){k=3}else{x=0}}L3:do{if((k|0)==3){h=(c[10069]|0)-1|0;l=c[j+8>>2]|0;do{if((c[j+12>>2]|0)-l>>2>>>0>h>>>0){m=c[l+(h<<2)>>2]|0;if((m|0)==0){break}n=m;o=c[(c[m>>2]|0)+48>>2]|0;x=0,aS(o|0,n|0,31280,31306,d|0)|0;if(x){x=0;break L3}n=c[b>>2]|0;if((c[9972]|0)!=-1){c[g>>2]=39888;c[g+4>>2]=454;c[g+8>>2]=0;x=0;aP(2,39888,g|0,512);if(x){x=0;break L3}}o=(c[9973]|0)-1|0;m=c[n+8>>2]|0;do{if((c[n+12>>2]|0)-m>>2>>>0>o>>>0){p=c[m+(o<<2)>>2]|0;if((p|0)==0){break}q=p;r=(x=0,as(c[(c[p>>2]|0)+16>>2]|0,q|0)|0);if(x){x=0;break L3}c[e>>2]=r;x=0;aq(c[(c[p>>2]|0)+20>>2]|0,a|0,q|0);if(x){x=0;break L3}Cn(c[b>>2]|0)|0;i=f;return}}while(0);o=ci(4)|0;JB(o);x=0;aP(144,o|0,28080,98);if(x){x=0;break L3}}}while(0);h=ci(4)|0;JB(h);x=0;aP(144,h|0,28080,98);if(x){x=0;break}}}while(0);f=bQ(-1,-1)|0;Cn(c[b>>2]|0)|0;be(f|0)}function E9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g|0;j=g+16|0;k=g+32|0;C8(k,b);b=k|0;k=c[b>>2]|0;if((c[10068]|0)==-1){l=3}else{c[j>>2]=40272;c[j+4>>2]=454;c[j+8>>2]=0;x=0;aP(2,40272,j|0,512);if(!x){l=3}else{x=0}}L3:do{if((l|0)==3){j=(c[10069]|0)-1|0;m=c[k+8>>2]|0;do{if((c[k+12>>2]|0)-m>>2>>>0>j>>>0){n=c[m+(j<<2)>>2]|0;if((n|0)==0){break}o=n;p=c[(c[n>>2]|0)+48>>2]|0;x=0,aS(p|0,o|0,31280,31312,d|0)|0;if(x){x=0;break L3}o=c[b>>2]|0;if((c[9972]|0)!=-1){c[h>>2]=39888;c[h+4>>2]=454;c[h+8>>2]=0;x=0;aP(2,39888,h|0,512);if(x){x=0;break L3}}p=(c[9973]|0)-1|0;n=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-n>>2>>>0>p>>>0){q=c[n+(p<<2)>>2]|0;if((q|0)==0){break}r=q;s=q;t=(x=0,as(c[(c[s>>2]|0)+12>>2]|0,r|0)|0);if(x){x=0;break L3}c[e>>2]=t;t=(x=0,as(c[(c[s>>2]|0)+16>>2]|0,r|0)|0);if(x){x=0;break L3}c[f>>2]=t;x=0;aq(c[(c[q>>2]|0)+20>>2]|0,a|0,r|0);if(x){x=0;break L3}Cn(c[b>>2]|0)|0;i=g;return}}while(0);p=ci(4)|0;JB(p);x=0;aP(144,p|0,28080,98);if(x){x=0;break L3}}}while(0);j=ci(4)|0;JB(j);x=0;aP(144,j|0,28080,98);if(x){x=0;break}}}while(0);g=bQ(-1,-1)|0;Cn(c[b>>2]|0)|0;be(g|0)}function Fa(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0;if((b|0)==(i|0)){if((a[e]&1)==0){p=-1;return p|0}a[e]=0;i=c[h>>2]|0;c[h>>2]=i+1;a[i]=46;i=d[k]|0;if((i&1|0)==0){q=i>>>1}else{q=c[k+4>>2]|0}if((q|0)==0){p=0;return p|0}q=c[m>>2]|0;if((q-l|0)>=160){p=0;return p|0}i=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=i;p=0;return p|0}do{if((b|0)==(j|0)){i=d[k]|0;if((i&1|0)==0){r=i>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){break}if((a[e]&1)==0){p=-1;return p|0}i=c[m>>2]|0;if((i-l|0)>=160){p=0;return p|0}q=c[n>>2]|0;c[m>>2]=i+4;c[i>>2]=q;c[n>>2]=0;p=0;return p|0}}while(0);r=o+128|0;j=o;while(1){if((j|0)==(r|0)){s=r;break}if((c[j>>2]|0)==(b|0)){s=j;break}else{j=j+4|0}}j=s-o|0;o=j>>2;if((j|0)>124){p=-1;return p|0}s=a[31280+o|0]|0;do{if((o|0)==22|(o|0)==23){a[f]=80}else if((o|0)==25|(o|0)==24){b=c[h>>2]|0;do{if((b|0)!=(g|0)){if((a[b-1|0]&95|0)==(a[f]&127|0)){break}else{p=-1}return p|0}}while(0);c[h>>2]=b+1;a[b]=s;p=0;return p|0}else{r=a[f]|0;if((s&95|0)!=(r<<24>>24|0)){break}a[f]=r|-128;if((a[e]&1)==0){break}a[e]=0;r=d[k]|0;if((r&1|0)==0){t=r>>>1}else{t=c[k+4>>2]|0}if((t|0)==0){break}r=c[m>>2]|0;if((r-l|0)>=160){break}q=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=q}}while(0);m=c[h>>2]|0;c[h>>2]=m+1;a[m]=s;if((j|0)>84){p=0;return p|0}c[n>>2]=(c[n>>2]|0)+1;p=0;return p|0}function Fb(a){a=a|0;Cl(a|0);J2(a);return}function Fc(a){a=a|0;Cl(a|0);return}function Fd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+48|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;if((c[f+4>>2]&1|0)==0){o=c[(c[d>>2]|0)+24>>2]|0;c[l>>2]=c[e>>2];cJ[o&127](b,d,l,f,g,h&1);i=j;return}C8(m,f);f=m|0;m=c[f>>2]|0;if((c[9974]|0)==-1){p=5}else{c[k>>2]=39896;c[k+4>>2]=454;c[k+8>>2]=0;x=0;aP(2,39896,k|0,512);if(!x){p=5}else{x=0}}do{if((p|0)==5){k=(c[9975]|0)-1|0;g=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-g>>2>>>0>k>>>0){l=c[g+(k<<2)>>2]|0;if((l|0)==0){break}d=l;Cn(c[f>>2]|0)|0;o=c[l>>2]|0;if(h){cy[c[o+24>>2]&1023](n,d)}else{cy[c[o+28>>2]&1023](n,d)}d=n;o=n;l=a[o]|0;if((l&1)==0){q=d+1|0;r=q;s=q;t=n+8|0}else{q=n+8|0;r=c[q>>2]|0;s=d+1|0;t=q}q=e|0;d=n+4|0;u=r;v=l;L20:while(1){if((v&1)==0){w=s}else{w=c[t>>2]|0}l=v&255;if((u|0)==(w+((l&1|0)==0?l>>>1:c[d>>2]|0)|0)){p=28;break}l=a[u]|0;y=c[q>>2]|0;do{if((y|0)!=0){z=y+24|0;A=c[z>>2]|0;if((A|0)!=(c[y+28>>2]|0)){c[z>>2]=A+1;a[A]=l;break}A=(x=0,aK(c[(c[y>>2]|0)+52>>2]|0,y|0,l&255|0)|0);if(x){x=0;p=27;break L20}if((A|0)!=-1){break}c[q>>2]=0}}while(0);u=u+1|0;v=a[o]|0}if((p|0)==27){o=bQ(-1,-1)|0;v=K;CP(n);B=v;C=o;D=C;E=0;F=D;G=B;be(F|0)}else if((p|0)==28){c[b>>2]=c[q>>2];CP(n);i=j;return}}}while(0);k=ci(4)|0;JB(k);x=0;aP(144,k|0,28080,98);if(x){x=0;break}}}while(0);j=bQ(-1,-1)|0;n=K;Cn(c[f>>2]|0)|0;B=n;C=j;D=C;E=0;F=D;G=B;be(F|0)}function Fe(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;d=i;i=i+80|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=j|0;a[q]=a[12856]|0;a[q+1|0]=a[12857]|0;a[q+2|0]=a[12858]|0;a[q+3|0]=a[12859]|0;a[q+4|0]=a[12860]|0;a[q+5|0]=a[12861]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=100}}while(0);u=k|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}v=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=v;break}else{x=0;v=bQ(-1,-1)|0;be(v|0)}}}while(0);v=Ff(u,12,c[9712]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+v|0;h=c[s>>2]&176;do{if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((v|0)>1&s<<24>>24==48)){y=22;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){y=22;break}w=k+2|0}else if((h|0)==32){w=q}else{y=22}}while(0);if((y|0)==22){w=u}y=l|0;C8(o,f);x=0;aG(80,u|0,w|0,q|0,y|0,m|0,n|0,o|0);if(!x){Cn(c[o>>2]|0)|0;c[p>>2]=c[e>>2];eu(b,p,y,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}else{x=0;d=bQ(-1,-1)|0;Cn(c[o>>2]|0)|0;be(d|0)}}function Ff(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+16|0;h=g|0;j=h;c[j>>2]=f;c[j+4>>2]=0;j=b3(d|0)|0;d=b4(a|0,b|0,e|0,h|0)|0;if((j|0)==0){i=g;return d|0}x=0,as(32,j|0)|0;if(!x){i=g;return d|0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function Fg(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[10070]|0)!=-1){c[n>>2]=40280;c[n+4>>2]=454;c[n+8>>2]=0;CI(40280,n,512)}n=(c[10071]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=ci(4)|0;s=r;JB(s);bH(r|0,28080,98)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=ci(4)|0;s=r;JB(s);bH(r|0,28080,98)}r=k;s=c[p>>2]|0;if((c[9974]|0)!=-1){c[m>>2]=39896;c[m+4>>2]=454;c[m+8>>2]=0;CI(39896,m,512)}m=(c[9975]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=ci(4)|0;u=t;JB(u);bH(t|0,28080,98)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=ci(4)|0;u=t;JB(u);bH(t|0,28080,98)}t=s;cy[c[(c[s>>2]|0)+20>>2]&1023](o,t);u=o;m=o;p=d[m]|0;if((p&1|0)==0){v=p>>>1}else{v=c[o+4>>2]|0}L23:do{if((v|0)==0){p=c[(c[k>>2]|0)+32>>2]|0;x=0,aS(p|0,r|0,b|0,f|0,g|0)|0;if(x){x=0;w=18;break}c[j>>2]=g+(f-b)}else{c[j>>2]=g;p=a[b]|0;if((p<<24>>24|0)==45|(p<<24>>24|0)==43){n=(x=0,aK(c[(c[k>>2]|0)+28>>2]|0,r|0,p|0)|0);if(x){x=0;w=18;break}p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n;y=b+1|0}else{y=b}do{if((f-y|0)>1){if((a[y]|0)!=48){z=y;break}n=y+1|0;p=a[n]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){z=y;break}p=k;q=(x=0,aK(c[(c[p>>2]|0)+28>>2]|0,r|0,48)|0);if(x){x=0;w=18;break L23}A=c[j>>2]|0;c[j>>2]=A+1;a[A]=q;q=(x=0,aK(c[(c[p>>2]|0)+28>>2]|0,r|0,a[n]|0)|0);if(x){x=0;w=18;break L23}n=c[j>>2]|0;c[j>>2]=n+1;a[n]=q;z=y+2|0}else{z=y}}while(0);do{if((z|0)!=(f|0)){q=f-1|0;if(z>>>0<q>>>0){B=z;C=q}else{break}do{q=a[B]|0;a[B]=a[C]|0;a[C]=q;B=B+1|0;C=C-1|0;}while(B>>>0<C>>>0)}}while(0);q=(x=0,as(c[(c[s>>2]|0)+16>>2]|0,t|0)|0);if(x){x=0;w=18;break}L42:do{if(z>>>0<f>>>0){n=u+1|0;p=k;A=o+4|0;D=o+8|0;E=0;F=0;G=z;while(1){H=(a[m]&1)==0;do{if((a[(H?n:c[D>>2]|0)+F|0]|0)==0){I=F;J=E}else{if((E|0)!=(a[(H?n:c[D>>2]|0)+F|0]|0)){I=F;J=E;break}L=c[j>>2]|0;c[j>>2]=L+1;a[L]=q;L=d[m]|0;I=(F>>>0<(((L&1|0)==0?L>>>1:c[A>>2]|0)-1|0)>>>0)+F|0;J=0}}while(0);H=(x=0,aK(c[(c[p>>2]|0)+28>>2]|0,r|0,a[G]|0)|0);if(x){x=0;break}L=c[j>>2]|0;c[j>>2]=L+1;a[L]=H;H=G+1|0;if(H>>>0<f>>>0){E=J+1|0;F=I;G=H}else{break L42}}G=bQ(-1,-1)|0;M=K;N=G;CP(o);be(N|0)}}while(0);q=g+(z-b)|0;G=c[j>>2]|0;if((q|0)==(G|0)){break}F=G-1|0;if(q>>>0<F>>>0){O=q;P=F}else{break}do{F=a[O]|0;a[O]=a[P]|0;a[P]=F;O=O+1|0;P=P-1|0;}while(O>>>0<P>>>0)}}while(0);if((w|0)==18){w=bQ(-1,-1)|0;M=K;N=w;CP(o);be(N|0)}if((e|0)==(f|0)){Q=c[j>>2]|0;c[h>>2]=Q;CP(o);i=l;return}else{Q=g+(e-b)|0;c[h>>2]=Q;CP(o);i=l;return}}function Fh(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;d=i;i=i+112|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+80|0;o=d+88|0;p=d+96|0;q=d+104|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=100}}while(0);u=l|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}t=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=t;break}else{x=0;t=bQ(-1,-1)|0;be(t|0)}}}while(0);t=Ff(u,22,c[9712]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+t|0;j=c[s>>2]&176;do{if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((t|0)>1&s<<24>>24==48)){y=22;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){y=22;break}w=l+2|0}else if((j|0)==32){w=r}else{y=22}}while(0);if((y|0)==22){w=u}y=m|0;C8(p,f);x=0;aG(80,u|0,w|0,r|0,y|0,n|0,o|0,p|0);if(!x){Cn(c[p>>2]|0)|0;c[q>>2]=c[e>>2];eu(b,q,y,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}else{x=0;d=bQ(-1,-1)|0;Cn(c[p>>2]|0)|0;be(d|0)}}function Fi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;d=i;i=i+80|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=j|0;a[q]=a[12856]|0;a[q+1|0]=a[12857]|0;a[q+2|0]=a[12858]|0;a[q+3|0]=a[12859]|0;a[q+4|0]=a[12860]|0;a[q+5|0]=a[12861]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=117}}while(0);u=k|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}v=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=v;break}else{x=0;v=bQ(-1,-1)|0;be(v|0)}}}while(0);v=Ff(u,12,c[9712]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+v|0;h=c[s>>2]&176;do{if((h|0)==32){w=q}else if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((v|0)>1&s<<24>>24==48)){y=22;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){y=22;break}w=k+2|0}else{y=22}}while(0);if((y|0)==22){w=u}y=l|0;C8(o,f);x=0;aG(80,u|0,w|0,q|0,y|0,m|0,n|0,o|0);if(!x){Cn(c[o>>2]|0)|0;c[p>>2]=c[e>>2];eu(b,p,y,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}else{x=0;d=bQ(-1,-1)|0;Cn(c[o>>2]|0)|0;be(d|0)}}function Fj(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;d=i;i=i+112|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+80|0;o=d+88|0;p=d+96|0;q=d+104|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=117}}while(0);u=l|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}t=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=t;break}else{x=0;t=bQ(-1,-1)|0;be(t|0)}}}while(0);t=Ff(u,23,c[9712]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+t|0;j=c[s>>2]&176;do{if((j|0)==32){w=r}else if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((t|0)>1&s<<24>>24==48)){y=22;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){y=22;break}w=l+2|0}else{y=22}}while(0);if((y|0)==22){w=u}y=m|0;C8(p,f);x=0;aG(80,u|0,w|0,r|0,y|0,n|0,o|0,p|0);if(!x){Cn(c[p>>2]|0)|0;c[q>>2]=c[e>>2];eu(b,q,y,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}else{x=0;d=bQ(-1,-1)|0;Cn(c[p>>2]|0)|0;be(d|0)}}function Fk(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+152|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+112|0;p=d+120|0;q=d+128|0;r=d+136|0;s=d+144|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){y=w}else{a[w]=35;y=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){if((k&1|0)==0){a[y]=97;z=0;break}else{a[y]=65;z=0;break}}else{a[y]=46;v=y+2|0;a[y+1|0]=42;if((w|0)==256){if((k&1|0)==0){a[v]=101;z=1;break}else{a[v]=69;z=1;break}}else if((w|0)==4){if((k&1|0)==0){a[v]=102;z=1;break}else{a[v]=70;z=1;break}}else{if((k&1|0)==0){a[v]=103;z=1;break}else{a[v]=71;z=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;be(l|0)}}}while(0);l=c[9712]|0;if(z){w=Ff(k,30,l,t,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0;i=A;B=w}else{w=Ff(k,30,l,t,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0;i=A;B=w}L38:do{if((B|0)>29){w=(a[40840]|0)==0;L40:do{if(z){do{if(w){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;C=K;D=l;break L40}}}while(0);l=(x=0,aS(26,m|0,c[9712]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!x){E=l;F=44}else{x=0;F=36}}else{do{if(w){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;C=K;D=l;break L40}}}while(0);l=(x=0,aS(26,m|0,c[9712]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!x){E=l;F=44}else{x=0;F=36}}}while(0);do{if((F|0)==44){w=c[m>>2]|0;if((w|0)!=0){G=E;H=w;I=w;break L38}x=0;aQ(4);if(x){x=0;F=36;break}w=c[m>>2]|0;G=E;H=w;I=w;break L38}}while(0);if((F|0)==36){w=bQ(-1,-1)|0;C=K;D=w}J=C;L=D;M=L;N=0;O=M;P=J;be(O|0)}else{G=B;H=0;I=c[m>>2]|0}}while(0);B=I+G|0;D=c[u>>2]&176;do{if((D|0)==16){u=a[I]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){Q=I+1|0;break}if(!((G|0)>1&u<<24>>24==48)){F=53;break}u=a[I+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){F=53;break}Q=I+2|0}else if((D|0)==32){Q=B}else{F=53}}while(0);if((F|0)==53){Q=I}do{if((I|0)==(k|0)){R=n|0;S=0;T=k;F=59}else{D=JW(G<<1)|0;if((D|0)!=0){R=D;S=D;T=I;F=59;break}x=0;aQ(4);if(x){x=0;U=0;F=58;break}R=0;S=0;T=c[m>>2]|0;F=59}}while(0);do{if((F|0)==59){x=0;aq(346,q|0,f|0);if(x){x=0;U=S;F=58;break}x=0;aG(86,T|0,Q|0,B|0,R|0,o|0,p|0,q|0);if(x){x=0;m=bQ(-1,-1)|0;I=K;Cn(c[q>>2]|0)|0;V=m;W=I;X=S;break}Cn(c[q>>2]|0)|0;I=e|0;c[s>>2]=c[I>>2];x=0;aG(56,r|0,s|0,R|0,c[o>>2]|0,c[p>>2]|0,f|0,g|0);if(x){x=0;U=S;F=58;break}m=c[r>>2]|0;c[I>>2]=m;c[b>>2]=m;if((S|0)!=0){JX(S)}if((H|0)==0){i=d;return}JX(H);i=d;return}}while(0);if((F|0)==58){F=bQ(-1,-1)|0;V=F;W=K;X=U}if((X|0)!=0){JX(X)}if((H|0)==0){J=W;L=V;M=L;N=0;O=M;P=J;be(O|0)}JX(H);J=W;L=V;M=L;N=0;O=M;P=J;be(O|0)}function Fl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f|0;h=g;c[h>>2]=e;c[h+4>>2]=0;h=b3(b|0)|0;b=(x=0,ax(26,a|0,d|0,g|0)|0);if(!x){if((h|0)==0){i=f;return b|0}x=0,as(32,h|0)|0;if(!x){i=f;return b|0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{x=0;b=bQ(-1,-1)|0;if((h|0)==0){be(b|0)}x=0,as(32,h|0)|0;if(!x){be(b|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}return 0}function Fm(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[10070]|0)!=-1){c[n>>2]=40280;c[n+4>>2]=454;c[n+8>>2]=0;CI(40280,n,512)}n=(c[10071]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=ci(4)|0;s=r;JB(s);bH(r|0,28080,98)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=ci(4)|0;s=r;JB(s);bH(r|0,28080,98)}r=k;s=c[p>>2]|0;if((c[9974]|0)!=-1){c[m>>2]=39896;c[m+4>>2]=454;c[m+8>>2]=0;CI(39896,m,512)}m=(c[9975]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=ci(4)|0;u=t;JB(u);bH(t|0,28080,98)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=ci(4)|0;u=t;JB(u);bH(t|0,28080,98)}t=s;cy[c[(c[s>>2]|0)+20>>2]&1023](o,t);c[j>>2]=g;u=a[b]|0;do{if((u<<24>>24|0)==45|(u<<24>>24|0)==43){m=(x=0,aK(c[(c[k>>2]|0)+28>>2]|0,r|0,u|0)|0);if(x){x=0;break}p=c[j>>2]|0;c[j>>2]=p+1;a[p]=m;v=b+1|0;w=20}else{v=b;w=20}}while(0);L22:do{if((w|0)==20){u=f;L24:do{if((u-v|0)>1){if((a[v]|0)!=48){y=v;w=34;break}m=v+1|0;p=a[m]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){y=v;w=34;break}p=k;n=(x=0,aK(c[(c[p>>2]|0)+28>>2]|0,r|0,48)|0);if(x){x=0;break L22}q=c[j>>2]|0;c[j>>2]=q+1;a[q]=n;n=v+2|0;q=(x=0,aK(c[(c[p>>2]|0)+28>>2]|0,r|0,a[m]|0)|0);if(x){x=0;break L22}m=c[j>>2]|0;c[j>>2]=m+1;a[m]=q;q=n;L30:while(1){if(q>>>0>=f>>>0){z=q;A=n;break L24}m=a[q]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}p=(x=0,ax(48,2147483647,9592,0)|0);if(x){x=0;w=31;break L30}c[9712]=p}}while(0);p=(x=0,aK(162,m<<24>>24|0,c[9712]|0)|0);if(x){x=0;w=17;break}if((p|0)==0){z=q;A=n;break L24}else{q=q+1|0}}if((w|0)==31){q=bQ(-1,-1)|0;B=K;C=q;CP(o);be(C|0)}else if((w|0)==17){q=bQ(-1,-1)|0;B=K;C=q;CP(o);be(C|0)}}else{y=v;w=34}}while(0);L44:do{if((w|0)==34){L45:while(1){w=0;if(y>>>0>=f>>>0){z=y;A=v;break L44}q=a[y]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}n=(x=0,ax(48,2147483647,9592,0)|0);if(x){x=0;w=39;break L45}c[9712]=n}}while(0);m=(x=0,aK(66,q<<24>>24|0,c[9712]|0)|0);if(x){x=0;w=16;break}if((m|0)==0){z=y;A=v;break L44}else{y=y+1|0;w=34}}if((w|0)==39){m=bQ(-1,-1)|0;B=K;C=m;CP(o);be(C|0)}else if((w|0)==16){m=bQ(-1,-1)|0;B=K;C=m;CP(o);be(C|0)}}}while(0);m=o;n=o;p=d[n]|0;if((p&1|0)==0){D=p>>>1}else{D=c[o+4>>2]|0}do{if((D|0)==0){p=c[j>>2]|0;E=c[(c[k>>2]|0)+32>>2]|0;x=0,aS(E|0,r|0,A|0,z|0,p|0)|0;if(x){x=0;break L22}c[j>>2]=(c[j>>2]|0)+(z-A)}else{do{if((A|0)!=(z|0)){p=z-1|0;if(A>>>0<p>>>0){F=A;G=p}else{break}do{p=a[F]|0;a[F]=a[G]|0;a[G]=p;F=F+1|0;G=G-1|0;}while(F>>>0<G>>>0)}}while(0);q=(x=0,as(c[(c[s>>2]|0)+16>>2]|0,t|0)|0);if(x){x=0;break L22}L72:do{if(A>>>0<z>>>0){p=m+1|0;E=o+4|0;H=o+8|0;I=k;J=0;L=0;M=A;while(1){N=(a[n]&1)==0;do{if((a[(N?p:c[H>>2]|0)+L|0]|0)>0){if((J|0)!=(a[(N?p:c[H>>2]|0)+L|0]|0)){O=L;P=J;break}Q=c[j>>2]|0;c[j>>2]=Q+1;a[Q]=q;Q=d[n]|0;O=(L>>>0<(((Q&1|0)==0?Q>>>1:c[E>>2]|0)-1|0)>>>0)+L|0;P=0}else{O=L;P=J}}while(0);N=(x=0,aK(c[(c[I>>2]|0)+28>>2]|0,r|0,a[M]|0)|0);if(x){x=0;break}Q=c[j>>2]|0;c[j>>2]=Q+1;a[Q]=N;N=M+1|0;if(N>>>0<z>>>0){J=P+1|0;L=O;M=N}else{break L72}}M=bQ(-1,-1)|0;B=K;C=M;CP(o);be(C|0)}}while(0);q=g+(A-b)|0;M=c[j>>2]|0;if((q|0)==(M|0)){break}L=M-1|0;if(q>>>0<L>>>0){R=q;S=L}else{break}do{L=a[R]|0;a[R]=a[S]|0;a[S]=L;R=R+1|0;S=S-1|0;}while(R>>>0<S>>>0)}}while(0);L90:do{if(z>>>0<f>>>0){n=k;m=z;while(1){L=a[m]|0;if(L<<24>>24==46){w=65;break}q=(x=0,aK(c[(c[n>>2]|0)+28>>2]|0,r|0,L|0)|0);if(x){x=0;w=14;break}L=c[j>>2]|0;c[j>>2]=L+1;a[L]=q;q=m+1|0;if(q>>>0<f>>>0){m=q}else{T=q;break L90}}if((w|0)==65){n=(x=0,as(c[(c[s>>2]|0)+12>>2]|0,t|0)|0);if(x){x=0;break L22}q=c[j>>2]|0;c[j>>2]=q+1;a[q]=n;T=m+1|0;break}else if((w|0)==14){n=bQ(-1,-1)|0;B=K;C=n;CP(o);be(C|0)}}else{T=z}}while(0);n=c[j>>2]|0;q=c[(c[k>>2]|0)+32>>2]|0;x=0,aS(q|0,r|0,T|0,f|0,n|0)|0;if(x){x=0;break}n=(c[j>>2]|0)+(u-T)|0;c[j>>2]=n;if((e|0)==(f|0)){U=n;c[h>>2]=U;CP(o);i=l;return}U=g+(e-b)|0;c[h>>2]=U;CP(o);i=l;return}}while(0);l=bQ(-1,-1)|0;B=K;C=l;CP(o);be(C|0)}function Fn(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+152|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+112|0;p=d+120|0;q=d+128|0;r=d+136|0;s=d+144|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){y=w}else{a[w]=35;y=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){a[y]=76;v=y+1|0;if((k&1|0)==0){a[v]=97;z=0;break}else{a[v]=65;z=0;break}}else{a[y]=46;a[y+1|0]=42;a[y+2|0]=76;v=y+3|0;if((w|0)==4){if((k&1|0)==0){a[v]=102;z=1;break}else{a[v]=70;z=1;break}}else if((w|0)==256){if((k&1|0)==0){a[v]=101;z=1;break}else{a[v]=69;z=1;break}}else{if((k&1|0)==0){a[v]=103;z=1;break}else{a[v]=71;z=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;be(l|0)}}}while(0);l=c[9712]|0;if(z){w=Ff(k,30,l,t,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0;i=A;B=w}else{w=Ff(k,30,l,t,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0;i=A;B=w}L38:do{if((B|0)>29){w=(a[40840]|0)==0;L40:do{if(z){do{if(w){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;C=K;D=l;break L40}}}while(0);l=(x=0,aS(26,m|0,c[9712]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!x){E=l;F=44}else{x=0;F=36}}else{do{if(w){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;C=K;D=l;break L40}}}while(0);l=(x=0,aS(26,m|0,c[9712]|0,t|0,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0);i=A;if(!x){E=l;F=44}else{x=0;F=36}}}while(0);do{if((F|0)==44){w=c[m>>2]|0;if((w|0)!=0){G=E;H=w;I=w;break L38}x=0;aQ(4);if(x){x=0;F=36;break}w=c[m>>2]|0;G=E;H=w;I=w;break L38}}while(0);if((F|0)==36){w=bQ(-1,-1)|0;C=K;D=w}J=C;L=D;M=L;N=0;O=M;P=J;be(O|0)}else{G=B;H=0;I=c[m>>2]|0}}while(0);B=I+G|0;D=c[u>>2]&176;do{if((D|0)==16){u=a[I]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){Q=I+1|0;break}if(!((G|0)>1&u<<24>>24==48)){F=53;break}u=a[I+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){F=53;break}Q=I+2|0}else if((D|0)==32){Q=B}else{F=53}}while(0);if((F|0)==53){Q=I}do{if((I|0)==(k|0)){R=n|0;S=0;T=k;F=59}else{D=JW(G<<1)|0;if((D|0)!=0){R=D;S=D;T=I;F=59;break}x=0;aQ(4);if(x){x=0;U=0;F=58;break}R=0;S=0;T=c[m>>2]|0;F=59}}while(0);do{if((F|0)==59){x=0;aq(346,q|0,f|0);if(x){x=0;U=S;F=58;break}x=0;aG(86,T|0,Q|0,B|0,R|0,o|0,p|0,q|0);if(x){x=0;m=bQ(-1,-1)|0;I=K;Cn(c[q>>2]|0)|0;V=m;W=I;X=S;break}Cn(c[q>>2]|0)|0;I=e|0;c[s>>2]=c[I>>2];x=0;aG(56,r|0,s|0,R|0,c[o>>2]|0,c[p>>2]|0,f|0,g|0);if(x){x=0;U=S;F=58;break}m=c[r>>2]|0;c[I>>2]=m;c[b>>2]=m;if((S|0)!=0){JX(S)}if((H|0)==0){i=d;return}JX(H);i=d;return}}while(0);if((F|0)==58){F=bQ(-1,-1)|0;V=F;W=K;X=U}if((X|0)!=0){JX(X)}if((H|0)==0){J=W;L=V;M=L;N=0;O=M;P=J;be(O|0)}JX(H);J=W;L=V;M=L;N=0;O=M;P=J;be(O|0)}function Fo(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+104|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+24|0;l=d+48|0;m=d+88|0;n=d+96|0;o=d+16|0;a[o]=a[12864]|0;a[o+1|0]=a[12865]|0;a[o+2|0]=a[12866]|0;a[o+3|0]=a[12867]|0;a[o+4|0]=a[12868]|0;a[o+5|0]=a[12869]|0;p=k|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}q=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=q;break}else{x=0;q=bQ(-1,-1)|0;be(q|0)}}}while(0);q=Ff(p,20,c[9712]|0,o,(o=i,i=i+8|0,c[o>>2]=h,o)|0)|0;i=o;o=k+q|0;h=c[f+4>>2]&176;do{if((h|0)==16){r=a[p]|0;if((r<<24>>24|0)==45|(r<<24>>24|0)==43){s=k+1|0;break}if(!((q|0)>1&r<<24>>24==48)){t=12;break}r=a[k+1|0]|0;if(!((r<<24>>24|0)==120|(r<<24>>24|0)==88)){t=12;break}s=k+2|0}else if((h|0)==32){s=o}else{t=12}}while(0);if((t|0)==12){s=p}C8(m,f);t=m|0;m=c[t>>2]|0;do{if((c[10070]|0)!=-1){c[j>>2]=40280;c[j+4>>2]=454;c[j+8>>2]=0;x=0;aP(2,40280,j|0,512);if(!x){break}else{x=0}u=bQ(-1,-1)|0;v=K;w=c[t>>2]|0;y=w|0;z=Cn(y)|0;be(u|0)}}while(0);j=(c[10071]|0)-1|0;h=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-h>>2>>>0>j>>>0){r=c[h+(j<<2)>>2]|0;if((r|0)==0){break}Cn(c[t>>2]|0)|0;A=l|0;c_[c[(c[r>>2]|0)+32>>2]&63](r,p,o,A)|0;r=l+q|0;if((s|0)==(o|0)){B=r;C=e|0;D=c[C>>2]|0;E=n|0;c[E>>2]=D;eu(b,n,A,B,r,f,g);i=d;return}B=l+(s-k)|0;C=e|0;D=c[C>>2]|0;E=n|0;c[E>>2]=D;eu(b,n,A,B,r,f,g);i=d;return}}while(0);d=ci(4)|0;JB(d);x=0;aP(144,d|0,28080,98);if(x){x=0;u=bQ(-1,-1)|0;v=K;w=c[t>>2]|0;y=w|0;z=Cn(y)|0;be(u|0)}}function Fp(a){a=a|0;Cl(a|0);J2(a);return}function Fq(a){a=a|0;Cl(a|0);return}function Fr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=i;i=i+48|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;if((c[f+4>>2]&1|0)==0){o=c[(c[d>>2]|0)+24>>2]|0;c[l>>2]=c[e>>2];cJ[o&127](b,d,l,f,g,h&1);i=j;return}C8(m,f);f=m|0;m=c[f>>2]|0;if((c[9972]|0)==-1){p=5}else{c[k>>2]=39888;c[k+4>>2]=454;c[k+8>>2]=0;x=0;aP(2,39888,k|0,512);if(!x){p=5}else{x=0}}do{if((p|0)==5){k=(c[9973]|0)-1|0;g=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-g>>2>>>0>k>>>0){l=c[g+(k<<2)>>2]|0;if((l|0)==0){break}d=l;Cn(c[f>>2]|0)|0;o=c[l>>2]|0;if(h){cy[c[o+24>>2]&1023](n,d)}else{cy[c[o+28>>2]&1023](n,d)}d=n;o=a[d]|0;if((o&1)==0){l=n+4|0;q=l;r=l;s=n+8|0}else{l=n+8|0;q=c[l>>2]|0;r=n+4|0;s=l}l=e|0;t=q;u=o;L20:while(1){if((u&1)==0){v=r}else{v=c[s>>2]|0}o=u&255;if((o&1|0)==0){w=o>>>1}else{w=c[r>>2]|0}if((t|0)==(v+(w<<2)|0)){p=31;break}o=c[t>>2]|0;y=c[l>>2]|0;do{if((y|0)!=0){z=y+24|0;A=c[z>>2]|0;if((A|0)==(c[y+28>>2]|0)){B=(x=0,aK(c[(c[y>>2]|0)+52>>2]|0,y|0,o|0)|0);if(!x){C=B}else{x=0;p=30;break L20}}else{c[z>>2]=A+4;c[A>>2]=o;C=o}if((C|0)!=-1){break}c[l>>2]=0}}while(0);t=t+4|0;u=a[d]|0}if((p|0)==30){d=bQ(-1,-1)|0;u=K;C$(n);D=u;E=d;F=E;G=0;H=F;I=D;be(H|0)}else if((p|0)==31){c[b>>2]=c[l>>2];C$(n);i=j;return}}}while(0);k=ci(4)|0;JB(k);x=0;aP(144,k|0,28080,98);if(x){x=0;break}}}while(0);j=bQ(-1,-1)|0;n=K;Cn(c[f>>2]|0)|0;D=n;E=j;F=E;G=0;H=F;I=D;be(H|0)}function Fs(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;d=i;i=i+144|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+112|0;n=d+120|0;o=d+128|0;p=d+136|0;q=j|0;a[q]=a[12856]|0;a[q+1|0]=a[12857]|0;a[q+2|0]=a[12858]|0;a[q+3|0]=a[12859]|0;a[q+4|0]=a[12860]|0;a[q+5|0]=a[12861]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==64){a[u]=111}else if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else{a[u]=100}}while(0);u=k|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}t=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=t;break}else{x=0;t=bQ(-1,-1)|0;be(t|0)}}}while(0);t=Ff(u,12,c[9712]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+t|0;h=c[s>>2]&176;do{if((h|0)==32){w=q}else if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((t|0)>1&s<<24>>24==48)){y=22;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){y=22;break}w=k+2|0}else{y=22}}while(0);if((y|0)==22){w=u}y=l|0;C8(o,f);x=0;aG(48,u|0,w|0,q|0,y|0,m|0,n|0,o|0);if(!x){Cn(c[o>>2]|0)|0;c[p>>2]=c[e>>2];Fu(b,p,y,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}else{x=0;d=bQ(-1,-1)|0;Cn(c[o>>2]|0)|0;be(d|0)}}function Ft(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[10068]|0)!=-1){c[n>>2]=40272;c[n+4>>2]=454;c[n+8>>2]=0;CI(40272,n,512)}n=(c[10069]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=ci(4)|0;s=r;JB(s);bH(r|0,28080,98)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=ci(4)|0;s=r;JB(s);bH(r|0,28080,98)}r=k;s=c[p>>2]|0;if((c[9972]|0)!=-1){c[m>>2]=39888;c[m+4>>2]=454;c[m+8>>2]=0;CI(39888,m,512)}m=(c[9973]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=ci(4)|0;u=t;JB(u);bH(t|0,28080,98)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=ci(4)|0;u=t;JB(u);bH(t|0,28080,98)}t=s;cy[c[(c[s>>2]|0)+20>>2]&1023](o,t);u=o;m=o;p=d[m]|0;if((p&1|0)==0){v=p>>>1}else{v=c[o+4>>2]|0}L23:do{if((v|0)==0){p=c[(c[k>>2]|0)+48>>2]|0;x=0,aS(p|0,r|0,b|0,f|0,g|0)|0;if(x){x=0;w=18;break}c[j>>2]=g+(f-b<<2)}else{c[j>>2]=g;p=a[b]|0;if((p<<24>>24|0)==45|(p<<24>>24|0)==43){n=(x=0,aK(c[(c[k>>2]|0)+44>>2]|0,r|0,p|0)|0);if(x){x=0;w=18;break}p=c[j>>2]|0;c[j>>2]=p+4;c[p>>2]=n;y=b+1|0}else{y=b}do{if((f-y|0)>1){if((a[y]|0)!=48){z=y;break}n=y+1|0;p=a[n]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){z=y;break}p=k;q=(x=0,aK(c[(c[p>>2]|0)+44>>2]|0,r|0,48)|0);if(x){x=0;w=18;break L23}A=c[j>>2]|0;c[j>>2]=A+4;c[A>>2]=q;q=(x=0,aK(c[(c[p>>2]|0)+44>>2]|0,r|0,a[n]|0)|0);if(x){x=0;w=18;break L23}n=c[j>>2]|0;c[j>>2]=n+4;c[n>>2]=q;z=y+2|0}else{z=y}}while(0);do{if((z|0)!=(f|0)){q=f-1|0;if(z>>>0<q>>>0){B=z;C=q}else{break}do{q=a[B]|0;a[B]=a[C]|0;a[C]=q;B=B+1|0;C=C-1|0;}while(B>>>0<C>>>0)}}while(0);q=(x=0,as(c[(c[s>>2]|0)+16>>2]|0,t|0)|0);if(x){x=0;w=18;break}L44:do{if(z>>>0<f>>>0){n=u+1|0;p=k;A=o+4|0;D=o+8|0;E=0;F=0;G=z;while(1){H=(a[m]&1)==0;do{if((a[(H?n:c[D>>2]|0)+F|0]|0)==0){I=F;J=E}else{if((E|0)!=(a[(H?n:c[D>>2]|0)+F|0]|0)){I=F;J=E;break}L=c[j>>2]|0;c[j>>2]=L+4;c[L>>2]=q;L=d[m]|0;I=(F>>>0<(((L&1|0)==0?L>>>1:c[A>>2]|0)-1|0)>>>0)+F|0;J=0}}while(0);H=(x=0,aK(c[(c[p>>2]|0)+44>>2]|0,r|0,a[G]|0)|0);if(x){x=0;break}L=c[j>>2]|0;c[j>>2]=L+4;c[L>>2]=H;H=G+1|0;if(H>>>0<f>>>0){E=J+1|0;F=I;G=H}else{break L44}}G=bQ(-1,-1)|0;M=K;N=G;CP(o);be(N|0)}}while(0);q=g+(z-b<<2)|0;G=c[j>>2]|0;if((q|0)==(G|0)){break}F=G-4|0;if(q>>>0<F>>>0){O=q;P=F}else{break}do{F=c[O>>2]|0;c[O>>2]=c[P>>2];c[P>>2]=F;O=O+4|0;P=P-4|0;}while(O>>>0<P>>>0)}}while(0);if((w|0)==18){w=bQ(-1,-1)|0;M=K;N=w;CP(o);be(N|0)}if((e|0)==(f|0)){Q=c[j>>2]|0;c[h>>2]=Q;CP(o);i=l;return}else{Q=g+(e-b<<2)|0;c[h>>2]=Q;CP(o);i=l;return}}function Fu(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[l>>2];l=k|0;m=d|0;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((cF[c[(c[d>>2]|0)+48>>2]&127](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){C_(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}g=(x=0,ax(c[(c[d>>2]|0)+48>>2]|0,d|0,r|0,q|0)|0);if(x){x=0;e=bQ(-1,-1)|0;C$(l);be(e|0)}if((g|0)==(q|0)){C$(l);break}c[m>>2]=0;c[b>>2]=0;C$(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((cF[c[(c[d>>2]|0)+48>>2]&127](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function Fv(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;d=i;i=i+232|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+200|0;o=d+208|0;p=d+216|0;q=d+224|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=100}}while(0);u=l|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}v=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=v;break}else{x=0;v=bQ(-1,-1)|0;be(v|0)}}}while(0);v=Ff(u,22,c[9712]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+v|0;j=c[s>>2]&176;do{if((j|0)==32){w=r}else if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((v|0)>1&s<<24>>24==48)){y=22;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){y=22;break}w=l+2|0}else{y=22}}while(0);if((y|0)==22){w=u}y=m|0;C8(p,f);x=0;aG(48,u|0,w|0,r|0,y|0,n|0,o|0,p|0);if(!x){Cn(c[p>>2]|0)|0;c[q>>2]=c[e>>2];Fu(b,q,y,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}else{x=0;d=bQ(-1,-1)|0;Cn(c[p>>2]|0)|0;be(d|0)}}function Fw(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;d=i;i=i+144|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+8|0;l=d+24|0;m=d+112|0;n=d+120|0;o=d+128|0;p=d+136|0;q=j|0;a[q]=a[12856]|0;a[q+1|0]=a[12857]|0;a[q+2|0]=a[12858]|0;a[q+3|0]=a[12859]|0;a[q+4|0]=a[12860]|0;a[q+5|0]=a[12861]|0;r=j+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=r}else{a[r]=43;u=j+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;u=v+1|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=117}}while(0);u=k|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}v=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=v;break}else{x=0;v=bQ(-1,-1)|0;be(v|0)}}}while(0);v=Ff(u,12,c[9712]|0,q,(q=i,i=i+8|0,c[q>>2]=h,q)|0)|0;i=q;q=k+v|0;h=c[s>>2]&176;do{if((h|0)==32){w=q}else if((h|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=k+1|0;break}if(!((v|0)>1&s<<24>>24==48)){y=22;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){y=22;break}w=k+2|0}else{y=22}}while(0);if((y|0)==22){w=u}y=l|0;C8(o,f);x=0;aG(48,u|0,w|0,q|0,y|0,m|0,n|0,o|0);if(!x){Cn(c[o>>2]|0)|0;c[p>>2]=c[e>>2];Fu(b,p,y,c[m>>2]|0,c[n>>2]|0,f,g);i=d;return}else{x=0;d=bQ(-1,-1)|0;Cn(c[o>>2]|0)|0;be(d|0)}}function Fx(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;d=i;i=i+240|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+32|0;n=d+208|0;o=d+216|0;p=d+224|0;q=d+232|0;c[k>>2]=37;c[k+4>>2]=0;r=k;k=r+1|0;s=f+4|0;t=c[s>>2]|0;if((t&2048|0)==0){u=k}else{a[k]=43;u=r+2|0}if((t&512|0)==0){v=u}else{a[u]=35;v=u+1|0}a[v]=108;a[v+1|0]=108;u=v+2|0;v=t&74;do{if((v|0)==8){if((t&16384|0)==0){a[u]=120;break}else{a[u]=88;break}}else if((v|0)==64){a[u]=111}else{a[u]=117}}while(0);u=l|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}v=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=v;break}else{x=0;v=bQ(-1,-1)|0;be(v|0)}}}while(0);v=Ff(u,23,c[9712]|0,r,(r=i,i=i+16|0,c[r>>2]=h,c[r+8>>2]=j,r)|0)|0;i=r;r=l+v|0;j=c[s>>2]&176;do{if((j|0)==16){s=a[u]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){w=l+1|0;break}if(!((v|0)>1&s<<24>>24==48)){y=22;break}s=a[l+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){y=22;break}w=l+2|0}else if((j|0)==32){w=r}else{y=22}}while(0);if((y|0)==22){w=u}y=m|0;C8(p,f);x=0;aG(48,u|0,w|0,r|0,y|0,n|0,o|0,p|0);if(!x){Cn(c[p>>2]|0)|0;c[q>>2]=c[e>>2];Fu(b,q,y,c[n>>2]|0,c[o>>2]|0,f,g);i=d;return}else{x=0;d=bQ(-1,-1)|0;Cn(c[p>>2]|0)|0;be(d|0)}}function Fy(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+320|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+280|0;p=d+288|0;q=d+296|0;r=d+304|0;s=d+312|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){y=w}else{a[w]=35;y=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){if((k&1|0)==0){a[y]=97;z=0;break}else{a[y]=65;z=0;break}}else{a[y]=46;v=y+2|0;a[y+1|0]=42;if((w|0)==4){if((k&1|0)==0){a[v]=102;z=1;break}else{a[v]=70;z=1;break}}else if((w|0)==256){if((k&1|0)==0){a[v]=101;z=1;break}else{a[v]=69;z=1;break}}else{if((k&1|0)==0){a[v]=103;z=1;break}else{a[v]=71;z=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;be(l|0)}}}while(0);l=c[9712]|0;if(z){w=Ff(k,30,l,t,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0;i=A;B=w}else{w=Ff(k,30,l,t,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0;i=A;B=w}L38:do{if((B|0)>29){w=(a[40840]|0)==0;L41:do{if(z){do{if(w){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;C=K;D=l;break L41}}}while(0);l=(x=0,aS(26,m|0,c[9712]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!x){E=l;F=44}else{x=0;F=36}}else{do{if(w){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;C=K;D=l;break L41}}}while(0);l=(x=0,aS(26,m|0,c[9712]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!x){E=l;F=44}else{x=0;F=36}}}while(0);do{if((F|0)==44){w=c[m>>2]|0;if((w|0)!=0){G=E;H=w;I=w;break L38}x=0;aQ(4);if(x){x=0;F=36;break}w=c[m>>2]|0;G=E;H=w;I=w;break L38}}while(0);if((F|0)==36){w=bQ(-1,-1)|0;C=K;D=w}J=C;L=D;M=L;N=0;O=M;P=J;be(O|0)}else{G=B;H=0;I=c[m>>2]|0}}while(0);B=I+G|0;D=c[u>>2]&176;do{if((D|0)==16){u=a[I]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){Q=I+1|0;break}if(!((G|0)>1&u<<24>>24==48)){F=53;break}u=a[I+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){F=53;break}Q=I+2|0}else if((D|0)==32){Q=B}else{F=53}}while(0);if((F|0)==53){Q=I}do{if((I|0)==(k|0)){R=n|0;S=0;T=k;F=59}else{D=JW(G<<3)|0;u=D;if((D|0)!=0){R=u;S=u;T=I;F=59;break}x=0;aQ(4);if(x){x=0;U=0;F=58;break}R=u;S=u;T=c[m>>2]|0;F=59}}while(0);do{if((F|0)==59){x=0;aq(346,q|0,f|0);if(x){x=0;U=S;F=58;break}x=0;aG(70,T|0,Q|0,B|0,R|0,o|0,p|0,q|0);if(x){x=0;m=bQ(-1,-1)|0;I=K;Cn(c[q>>2]|0)|0;V=m;W=I;X=S;break}Cn(c[q>>2]|0)|0;I=e|0;c[s>>2]=c[I>>2];x=0;aG(52,r|0,s|0,R|0,c[o>>2]|0,c[p>>2]|0,f|0,g|0);if(x){x=0;U=S;F=58;break}m=c[r>>2]|0;c[I>>2]=m;c[b>>2]=m;if((S|0)!=0){JX(S)}if((H|0)==0){i=d;return}JX(H);i=d;return}}while(0);if((F|0)==58){F=bQ(-1,-1)|0;V=F;W=K;X=U}if((X|0)!=0){JX(X)}if((H|0)==0){J=W;L=V;M=L;N=0;O=M;P=J;be(O|0)}JX(H);J=W;L=V;M=L;N=0;O=M;P=J;be(O|0)}function Fz(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;l=i;i=i+48|0;m=l|0;n=l+16|0;o=l+32|0;p=k|0;k=c[p>>2]|0;if((c[10068]|0)!=-1){c[n>>2]=40272;c[n+4>>2]=454;c[n+8>>2]=0;CI(40272,n,512)}n=(c[10069]|0)-1|0;q=c[k+8>>2]|0;if((c[k+12>>2]|0)-q>>2>>>0<=n>>>0){r=ci(4)|0;s=r;JB(s);bH(r|0,28080,98)}k=c[q+(n<<2)>>2]|0;if((k|0)==0){r=ci(4)|0;s=r;JB(s);bH(r|0,28080,98)}r=k;s=c[p>>2]|0;if((c[9972]|0)!=-1){c[m>>2]=39888;c[m+4>>2]=454;c[m+8>>2]=0;CI(39888,m,512)}m=(c[9973]|0)-1|0;p=c[s+8>>2]|0;if((c[s+12>>2]|0)-p>>2>>>0<=m>>>0){t=ci(4)|0;u=t;JB(u);bH(t|0,28080,98)}s=c[p+(m<<2)>>2]|0;if((s|0)==0){t=ci(4)|0;u=t;JB(u);bH(t|0,28080,98)}t=s;cy[c[(c[s>>2]|0)+20>>2]&1023](o,t);c[j>>2]=g;u=a[b]|0;do{if((u<<24>>24|0)==45|(u<<24>>24|0)==43){m=(x=0,aK(c[(c[k>>2]|0)+44>>2]|0,r|0,u|0)|0);if(x){x=0;break}p=c[j>>2]|0;c[j>>2]=p+4;c[p>>2]=m;v=b+1|0;w=20}else{v=b;w=20}}while(0);L22:do{if((w|0)==20){u=f;L24:do{if((u-v|0)>1){if((a[v]|0)!=48){y=v;w=34;break}m=v+1|0;p=a[m]|0;if(!((p<<24>>24|0)==120|(p<<24>>24|0)==88)){y=v;w=34;break}p=k;n=(x=0,aK(c[(c[p>>2]|0)+44>>2]|0,r|0,48)|0);if(x){x=0;break L22}q=c[j>>2]|0;c[j>>2]=q+4;c[q>>2]=n;n=v+2|0;q=(x=0,aK(c[(c[p>>2]|0)+44>>2]|0,r|0,a[m]|0)|0);if(x){x=0;break L22}m=c[j>>2]|0;c[j>>2]=m+4;c[m>>2]=q;q=n;L30:while(1){if(q>>>0>=f>>>0){z=q;A=n;break L24}m=a[q]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}p=(x=0,ax(48,2147483647,9592,0)|0);if(x){x=0;w=31;break L30}c[9712]=p}}while(0);p=(x=0,aK(162,m<<24>>24|0,c[9712]|0)|0);if(x){x=0;w=17;break}if((p|0)==0){z=q;A=n;break L24}else{q=q+1|0}}if((w|0)==31){q=bQ(-1,-1)|0;B=K;C=q;CP(o);be(C|0)}else if((w|0)==17){q=bQ(-1,-1)|0;B=K;C=q;CP(o);be(C|0)}}else{y=v;w=34}}while(0);L44:do{if((w|0)==34){L45:while(1){w=0;if(y>>>0>=f>>>0){z=y;A=v;break L44}q=a[y]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}n=(x=0,ax(48,2147483647,9592,0)|0);if(x){x=0;w=39;break L45}c[9712]=n}}while(0);m=(x=0,aK(66,q<<24>>24|0,c[9712]|0)|0);if(x){x=0;w=16;break}if((m|0)==0){z=y;A=v;break L44}else{y=y+1|0;w=34}}if((w|0)==16){m=bQ(-1,-1)|0;B=K;C=m;CP(o);be(C|0)}else if((w|0)==39){m=bQ(-1,-1)|0;B=K;C=m;CP(o);be(C|0)}}}while(0);m=o;n=o;p=d[n]|0;if((p&1|0)==0){D=p>>>1}else{D=c[o+4>>2]|0}do{if((D|0)==0){p=c[j>>2]|0;E=c[(c[k>>2]|0)+48>>2]|0;x=0,aS(E|0,r|0,A|0,z|0,p|0)|0;if(x){x=0;break L22}c[j>>2]=(c[j>>2]|0)+(z-A<<2)}else{do{if((A|0)!=(z|0)){p=z-1|0;if(A>>>0<p>>>0){F=A;G=p}else{break}do{p=a[F]|0;a[F]=a[G]|0;a[G]=p;F=F+1|0;G=G-1|0;}while(F>>>0<G>>>0)}}while(0);q=(x=0,as(c[(c[s>>2]|0)+16>>2]|0,t|0)|0);if(x){x=0;break L22}L74:do{if(A>>>0<z>>>0){p=m+1|0;E=o+4|0;H=o+8|0;I=k;J=0;L=0;M=A;while(1){N=(a[n]&1)==0;do{if((a[(N?p:c[H>>2]|0)+L|0]|0)>0){if((J|0)!=(a[(N?p:c[H>>2]|0)+L|0]|0)){O=L;P=J;break}Q=c[j>>2]|0;c[j>>2]=Q+4;c[Q>>2]=q;Q=d[n]|0;O=(L>>>0<(((Q&1|0)==0?Q>>>1:c[E>>2]|0)-1|0)>>>0)+L|0;P=0}else{O=L;P=J}}while(0);N=(x=0,aK(c[(c[I>>2]|0)+44>>2]|0,r|0,a[M]|0)|0);if(x){x=0;break}Q=c[j>>2]|0;c[j>>2]=Q+4;c[Q>>2]=N;N=M+1|0;if(N>>>0<z>>>0){J=P+1|0;L=O;M=N}else{break L74}}M=bQ(-1,-1)|0;B=K;C=M;CP(o);be(C|0)}}while(0);q=g+(A-b<<2)|0;M=c[j>>2]|0;if((q|0)==(M|0)){break}L=M-4|0;if(q>>>0<L>>>0){R=q;S=L}else{break}do{L=c[R>>2]|0;c[R>>2]=c[S>>2];c[S>>2]=L;R=R+4|0;S=S-4|0;}while(R>>>0<S>>>0)}}while(0);L90:do{if(z>>>0<f>>>0){n=k;m=z;while(1){L=a[m]|0;if(L<<24>>24==46){w=65;break}q=(x=0,aK(c[(c[n>>2]|0)+44>>2]|0,r|0,L|0)|0);if(x){x=0;w=14;break}L=c[j>>2]|0;c[j>>2]=L+4;c[L>>2]=q;q=m+1|0;if(q>>>0<f>>>0){m=q}else{T=q;break L90}}if((w|0)==14){n=bQ(-1,-1)|0;B=K;C=n;CP(o);be(C|0)}else if((w|0)==65){n=(x=0,as(c[(c[s>>2]|0)+12>>2]|0,t|0)|0);if(x){x=0;break L22}q=c[j>>2]|0;c[j>>2]=q+4;c[q>>2]=n;T=m+1|0;break}}else{T=z}}while(0);n=c[j>>2]|0;q=c[(c[k>>2]|0)+48>>2]|0;x=0,aS(q|0,r|0,T|0,f|0,n|0)|0;if(x){x=0;break}n=(c[j>>2]|0)+(u-T<<2)|0;c[j>>2]=n;if((e|0)==(f|0)){U=n;c[h>>2]=U;CP(o);i=l;return}U=g+(e-b<<2)|0;c[h>>2]=U;CP(o);i=l;return}}while(0);l=bQ(-1,-1)|0;B=K;C=l;CP(o);be(C|0)}function FA(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+320|0;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;l=d+8|0;m=d+40|0;n=d+48|0;o=d+280|0;p=d+288|0;q=d+296|0;r=d+304|0;s=d+312|0;c[k>>2]=37;c[k+4>>2]=0;t=k;k=t+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=k}else{a[k]=43;w=t+2|0}if((v&1024|0)==0){y=w}else{a[w]=35;y=w+1|0}w=v&260;k=v>>>14;do{if((w|0)==260){a[y]=76;v=y+1|0;if((k&1|0)==0){a[v]=97;z=0;break}else{a[v]=65;z=0;break}}else{a[y]=46;a[y+1|0]=42;a[y+2|0]=76;v=y+3|0;if((w|0)==4){if((k&1|0)==0){a[v]=102;z=1;break}else{a[v]=70;z=1;break}}else if((w|0)==256){if((k&1|0)==0){a[v]=101;z=1;break}else{a[v]=69;z=1;break}}else{if((k&1|0)==0){a[v]=103;z=1;break}else{a[v]=71;z=1;break}}}}while(0);k=l|0;c[m>>2]=k;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;be(l|0)}}}while(0);l=c[9712]|0;if(z){w=Ff(k,30,l,t,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0;i=A;B=w}else{w=Ff(k,30,l,t,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0;i=A;B=w}L38:do{if((B|0)>29){w=(a[40840]|0)==0;L41:do{if(z){do{if(w){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;C=K;D=l;break L41}}}while(0);l=(x=0,aS(26,m|0,c[9712]|0,t|0,(A=i,i=i+16|0,c[A>>2]=c[f+8>>2],h[A+8>>3]=j,A)|0)|0);i=A;if(!x){E=l;F=44}else{x=0;F=36}}else{do{if(w){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;C=K;D=l;break L41}}}while(0);l=(x=0,aS(26,m|0,c[9712]|0,t|0,(A=i,i=i+8|0,h[A>>3]=j,A)|0)|0);i=A;if(!x){E=l;F=44}else{x=0;F=36}}}while(0);do{if((F|0)==44){w=c[m>>2]|0;if((w|0)!=0){G=E;H=w;I=w;break L38}x=0;aQ(4);if(x){x=0;F=36;break}w=c[m>>2]|0;G=E;H=w;I=w;break L38}}while(0);if((F|0)==36){w=bQ(-1,-1)|0;C=K;D=w}J=C;L=D;M=L;N=0;O=M;P=J;be(O|0)}else{G=B;H=0;I=c[m>>2]|0}}while(0);B=I+G|0;D=c[u>>2]&176;do{if((D|0)==16){u=a[I]|0;if((u<<24>>24|0)==45|(u<<24>>24|0)==43){Q=I+1|0;break}if(!((G|0)>1&u<<24>>24==48)){F=53;break}u=a[I+1|0]|0;if(!((u<<24>>24|0)==120|(u<<24>>24|0)==88)){F=53;break}Q=I+2|0}else if((D|0)==32){Q=B}else{F=53}}while(0);if((F|0)==53){Q=I}do{if((I|0)==(k|0)){R=n|0;S=0;T=k;F=59}else{D=JW(G<<3)|0;u=D;if((D|0)!=0){R=u;S=u;T=I;F=59;break}x=0;aQ(4);if(x){x=0;U=0;F=58;break}R=u;S=u;T=c[m>>2]|0;F=59}}while(0);do{if((F|0)==59){x=0;aq(346,q|0,f|0);if(x){x=0;U=S;F=58;break}x=0;aG(70,T|0,Q|0,B|0,R|0,o|0,p|0,q|0);if(x){x=0;m=bQ(-1,-1)|0;I=K;Cn(c[q>>2]|0)|0;V=m;W=I;X=S;break}Cn(c[q>>2]|0)|0;I=e|0;c[s>>2]=c[I>>2];x=0;aG(52,r|0,s|0,R|0,c[o>>2]|0,c[p>>2]|0,f|0,g|0);if(x){x=0;U=S;F=58;break}m=c[r>>2]|0;c[I>>2]=m;c[b>>2]=m;if((S|0)!=0){JX(S)}if((H|0)==0){i=d;return}JX(H);i=d;return}}while(0);if((F|0)==58){F=bQ(-1,-1)|0;V=F;W=K;X=U}if((X|0)!=0){JX(X)}if((H|0)==0){J=W;L=V;M=L;N=0;O=M;P=J;be(O|0)}JX(H);J=W;L=V;M=L;N=0;O=M;P=J;be(O|0)}function FB(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+216|0;j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=d|0;k=d+24|0;l=d+48|0;m=d+200|0;n=d+208|0;o=d+16|0;a[o]=a[12864]|0;a[o+1|0]=a[12865]|0;a[o+2|0]=a[12866]|0;a[o+3|0]=a[12867]|0;a[o+4|0]=a[12868]|0;a[o+5|0]=a[12869]|0;p=k|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}q=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=q;break}else{x=0;q=bQ(-1,-1)|0;be(q|0)}}}while(0);q=Ff(p,20,c[9712]|0,o,(o=i,i=i+8|0,c[o>>2]=h,o)|0)|0;i=o;o=k+q|0;h=c[f+4>>2]&176;do{if((h|0)==32){r=o}else if((h|0)==16){s=a[p]|0;if((s<<24>>24|0)==45|(s<<24>>24|0)==43){r=k+1|0;break}if(!((q|0)>1&s<<24>>24==48)){t=12;break}s=a[k+1|0]|0;if(!((s<<24>>24|0)==120|(s<<24>>24|0)==88)){t=12;break}r=k+2|0}else{t=12}}while(0);if((t|0)==12){r=p}C8(m,f);t=m|0;m=c[t>>2]|0;do{if((c[10068]|0)!=-1){c[j>>2]=40272;c[j+4>>2]=454;c[j+8>>2]=0;x=0;aP(2,40272,j|0,512);if(!x){break}else{x=0}u=bQ(-1,-1)|0;v=K;w=c[t>>2]|0;y=w|0;z=Cn(y)|0;be(u|0)}}while(0);j=(c[10069]|0)-1|0;h=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-h>>2>>>0>j>>>0){s=c[h+(j<<2)>>2]|0;if((s|0)==0){break}Cn(c[t>>2]|0)|0;A=l|0;c_[c[(c[s>>2]|0)+48>>2]&63](s,p,o,A)|0;s=l+(q<<2)|0;if((r|0)==(o|0)){B=s;C=e|0;D=c[C>>2]|0;E=n|0;c[E>>2]=D;Fu(b,n,A,B,s,f,g);i=d;return}B=l+(r-k<<2)|0;C=e|0;D=c[C>>2]|0;E=n|0;c[E>>2]=D;Fu(b,n,A,B,s,f,g);i=d;return}}while(0);d=ci(4)|0;JB(d);x=0;aP(144,d|0,28080,98);if(x){x=0;u=bQ(-1,-1)|0;v=K;w=c[t>>2]|0;y=w|0;z=Cn(y)|0;be(u|0)}}function FC(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0;n=i;i=i+48|0;o=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[o>>2];o=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[o>>2];o=n|0;p=n+16|0;q=n+24|0;r=n+32|0;s=n+40|0;C8(p,h);t=p|0;p=c[t>>2]|0;do{if((c[10070]|0)!=-1){c[o>>2]=40280;c[o+4>>2]=454;c[o+8>>2]=0;x=0;aP(2,40280,o|0,512);if(!x){break}else{x=0}u=bQ(-1,-1)|0;v=K;w=c[t>>2]|0;y=w|0;z=Cn(y)|0;be(u|0)}}while(0);o=(c[10071]|0)-1|0;A=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-A>>2>>>0>o>>>0){B=c[A+(o<<2)>>2]|0;if((B|0)==0){break}C=B;Cn(c[t>>2]|0)|0;c[j>>2]=0;D=f|0;L8:do{if((l|0)==(m|0)){E=67}else{F=g|0;G=B;H=B;I=B+8|0;J=e;L=r|0;M=s|0;N=q|0;O=l;P=0;L10:while(1){Q=P;while(1){if((Q|0)!=0){E=67;break L8}R=c[D>>2]|0;do{if((R|0)==0){S=0}else{if((c[R+12>>2]|0)!=(c[R+16>>2]|0)){S=R;break}if((cA[c[(c[R>>2]|0)+36>>2]&511](R)|0)!=-1){S=R;break}c[D>>2]=0;S=0}}while(0);R=(S|0)==0;T=c[F>>2]|0;L20:do{if((T|0)==0){E=20}else{do{if((c[T+12>>2]|0)==(c[T+16>>2]|0)){if((cA[c[(c[T>>2]|0)+36>>2]&511](T)|0)!=-1){break}c[F>>2]=0;E=20;break L20}}while(0);if(R){U=T}else{E=21;break L10}}}while(0);if((E|0)==20){E=0;if(R){E=21;break L10}else{U=0}}if((cF[c[(c[G>>2]|0)+36>>2]&127](C,a[O]|0,0)|0)<<24>>24==37){E=24;break}T=a[O]|0;if(T<<24>>24>=0){V=c[I>>2]|0;if((b[V+(T<<24>>24<<1)>>1]&8192)!=0){W=O;E=35;break}}X=S+12|0;T=c[X>>2]|0;Y=S+16|0;if((T|0)==(c[Y>>2]|0)){Z=(cA[c[(c[S>>2]|0)+36>>2]&511](S)|0)&255}else{Z=a[T]|0}T=cS[c[(c[H>>2]|0)+12>>2]&1023](C,Z)|0;if(T<<24>>24==(cS[c[(c[H>>2]|0)+12>>2]&1023](C,a[O]|0)|0)<<24>>24){E=62;break}c[j>>2]=4;Q=4}L38:do{if((E|0)==24){E=0;Q=O+1|0;if((Q|0)==(m|0)){E=25;break L10}T=cF[c[(c[G>>2]|0)+36>>2]&127](C,a[Q]|0,0)|0;if((T<<24>>24|0)==69|(T<<24>>24|0)==48){_=O+2|0;if((_|0)==(m|0)){E=28;break L10}$=T;aa=cF[c[(c[G>>2]|0)+36>>2]&127](C,a[_]|0,0)|0;ab=_}else{$=0;aa=T;ab=Q}Q=c[(c[J>>2]|0)+36>>2]|0;c[L>>2]=S;c[M>>2]=U;cQ[Q&7](q,e,r,s,h,j,k,aa,$);c[D>>2]=c[N>>2];ac=ab+1|0}else if((E|0)==35){while(1){E=0;Q=W+1|0;if((Q|0)==(m|0)){ad=m;break}T=a[Q]|0;if(T<<24>>24<0){ad=Q;break}if((b[V+(T<<24>>24<<1)>>1]&8192)==0){ad=Q;break}else{W=Q;E=35}}R=S;Q=U;while(1){do{if((R|0)==0){ae=0}else{if((c[R+12>>2]|0)!=(c[R+16>>2]|0)){ae=R;break}if((cA[c[(c[R>>2]|0)+36>>2]&511](R)|0)!=-1){ae=R;break}c[D>>2]=0;ae=0}}while(0);T=(ae|0)==0;do{if((Q|0)==0){E=48}else{if((c[Q+12>>2]|0)!=(c[Q+16>>2]|0)){if(T){af=Q;break}else{ac=ad;break L38}}if((cA[c[(c[Q>>2]|0)+36>>2]&511](Q)|0)==-1){c[F>>2]=0;E=48;break}else{if(T^(Q|0)==0){af=Q;break}else{ac=ad;break L38}}}}while(0);if((E|0)==48){E=0;if(T){ac=ad;break L38}else{af=0}}_=ae+12|0;ag=c[_>>2]|0;ah=ae+16|0;if((ag|0)==(c[ah>>2]|0)){ai=(cA[c[(c[ae>>2]|0)+36>>2]&511](ae)|0)&255}else{ai=a[ag]|0}if(ai<<24>>24<0){ac=ad;break L38}if((b[(c[I>>2]|0)+(ai<<24>>24<<1)>>1]&8192)==0){ac=ad;break L38}ag=c[_>>2]|0;if((ag|0)==(c[ah>>2]|0)){cA[c[(c[ae>>2]|0)+40>>2]&511](ae)|0;R=ae;Q=af;continue}else{c[_>>2]=ag+1;R=ae;Q=af;continue}}}else if((E|0)==62){E=0;Q=c[X>>2]|0;if((Q|0)==(c[Y>>2]|0)){cA[c[(c[S>>2]|0)+40>>2]&511](S)|0}else{c[X>>2]=Q+1}ac=O+1|0}}while(0);if((ac|0)==(m|0)){E=67;break L8}O=ac;P=c[j>>2]|0}if((E|0)==21){c[j>>2]=4;aj=S;break}else if((E|0)==25){c[j>>2]=4;aj=S;break}else if((E|0)==28){c[j>>2]=4;aj=S;break}}}while(0);if((E|0)==67){aj=c[D>>2]|0}C=f|0;do{if((aj|0)!=0){if((c[aj+12>>2]|0)!=(c[aj+16>>2]|0)){break}if((cA[c[(c[aj>>2]|0)+36>>2]&511](aj)|0)!=-1){break}c[C>>2]=0}}while(0);D=c[C>>2]|0;B=(D|0)==0;P=g|0;O=c[P>>2]|0;L96:do{if((O|0)==0){E=77}else{do{if((c[O+12>>2]|0)==(c[O+16>>2]|0)){if((cA[c[(c[O>>2]|0)+36>>2]&511](O)|0)!=-1){break}c[P>>2]=0;E=77;break L96}}while(0);if(!B){break}ak=d|0;c[ak>>2]=D;i=n;return}}while(0);do{if((E|0)==77){if(B){break}ak=d|0;c[ak>>2]=D;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ak=d|0;c[ak>>2]=D;i=n;return}}while(0);n=ci(4)|0;JB(n);x=0;aP(144,n|0,28080,98);if(x){x=0;u=bQ(-1,-1)|0;v=K;w=c[t>>2]|0;y=w|0;z=Cn(y)|0;be(u|0)}}function FD(a){a=a|0;Cl(a|0);J2(a);return}function FE(a){a=a|0;Cl(a|0);return}function FF(a){a=a|0;return 2}function FG(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;c[k>>2]=c[d>>2];c[l>>2]=c[e>>2];FC(a,b,k,l,f,g,h,12848,12856);i=j;return}function FH(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+8|0;n=d+8|0;o=cA[c[(c[n>>2]|0)+20>>2]&511](n)|0;c[l>>2]=c[e>>2];c[m>>2]=c[f>>2];f=o;e=a[o]|0;if((e&1)==0){p=f+1|0;q=f+1|0}else{f=c[o+8>>2]|0;p=f;q=f}f=e&255;if((f&1|0)==0){r=f>>>1}else{r=c[o+4>>2]|0}FC(b,d,l,m,g,h,j,q,p+r|0);i=k;return}function FI(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;C8(m,f);f=m|0;m=c[f>>2]|0;do{if((c[10070]|0)!=-1){c[l>>2]=40280;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40280,l|0,512);if(!x){break}else{x=0}n=bQ(-1,-1)|0;o=K;p=c[f>>2]|0;q=p|0;r=Cn(q)|0;be(n|0)}}while(0);l=(c[10071]|0)-1|0;s=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-s>>2>>>0>l>>>0){t=c[s+(l<<2)>>2]|0;if((t|0)==0){break}Cn(c[f>>2]|0)|0;u=c[e>>2]|0;v=b+8|0;w=cA[c[c[v>>2]>>2]&511](v)|0;c[k>>2]=u;u=(En(d,k,w,w+168|0,t,g,0)|0)-w|0;if((u|0)>=168){y=d|0;z=c[y>>2]|0;A=a|0;c[A>>2]=z;i=j;return}c[h+24>>2]=((u|0)/12|0|0)%7|0;y=d|0;z=c[y>>2]|0;A=a|0;c[A>>2]=z;i=j;return}}while(0);j=ci(4)|0;JB(j);x=0;aP(144,j|0,28080,98);if(x){x=0;n=bQ(-1,-1)|0;o=K;p=c[f>>2]|0;q=p|0;r=Cn(q)|0;be(n|0)}}function FJ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;C8(m,f);f=m|0;m=c[f>>2]|0;do{if((c[10070]|0)!=-1){c[l>>2]=40280;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40280,l|0,512);if(!x){break}else{x=0}n=bQ(-1,-1)|0;o=K;p=c[f>>2]|0;q=p|0;r=Cn(q)|0;be(n|0)}}while(0);l=(c[10071]|0)-1|0;s=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-s>>2>>>0>l>>>0){t=c[s+(l<<2)>>2]|0;if((t|0)==0){break}Cn(c[f>>2]|0)|0;u=c[e>>2]|0;v=b+8|0;w=cA[c[(c[v>>2]|0)+4>>2]&511](v)|0;c[k>>2]=u;u=(En(d,k,w,w+288|0,t,g,0)|0)-w|0;if((u|0)>=288){y=d|0;z=c[y>>2]|0;A=a|0;c[A>>2]=z;i=j;return}c[h+16>>2]=((u|0)/12|0|0)%12|0;y=d|0;z=c[y>>2]|0;A=a|0;c[A>>2]=z;i=j;return}}while(0);j=ci(4)|0;JB(j);x=0;aP(144,j|0,28080,98);if(x){x=0;n=bQ(-1,-1)|0;o=K;p=c[f>>2]|0;q=p|0;r=Cn(q)|0;be(n|0)}}function FK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;b=i;i=i+32|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;l=b+24|0;C8(l,f);f=l|0;l=c[f>>2]|0;do{if((c[10070]|0)!=-1){c[k>>2]=40280;c[k+4>>2]=454;c[k+8>>2]=0;x=0;aP(2,40280,k|0,512);if(!x){break}else{x=0}m=bQ(-1,-1)|0;n=K;o=c[f>>2]|0;p=o|0;q=Cn(p)|0;be(m|0)}}while(0);k=(c[10071]|0)-1|0;r=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-r>>2>>>0>k>>>0){s=c[r+(k<<2)>>2]|0;if((s|0)==0){break}Cn(c[f>>2]|0)|0;c[j>>2]=c[e>>2];t=FP(d,j,g,s,4)|0;if((c[g>>2]&4|0)!=0){u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=b;return}if((t|0)<69){y=t+2e3|0}else{y=(t-69|0)>>>0<31>>>0?t+1900|0:t}c[h+20>>2]=y-1900;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=b;return}}while(0);b=ci(4)|0;JB(b);x=0;aP(144,b|0,28080,98);if(x){x=0;m=bQ(-1,-1)|0;n=K;o=c[f>>2]|0;p=o|0;q=Cn(p)|0;be(m|0)}}function FL(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0;l=i;i=i+328|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=l|0;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;y=l+88|0;z=l+96|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;L=l+192|0;M=l+200|0;N=l+208|0;O=l+216|0;P=l+224|0;Q=l+232|0;R=l+240|0;S=l+248|0;T=l+256|0;U=l+264|0;V=l+272|0;W=l+280|0;X=l+288|0;Y=l+296|0;Z=l+304|0;_=l+312|0;$=l+320|0;c[h>>2]=0;C8(A,g);aa=A|0;A=c[aa>>2]|0;do{if((c[10070]|0)!=-1){c[z>>2]=40280;c[z+4>>2]=454;c[z+8>>2]=0;x=0;aP(2,40280,z|0,512);if(!x){break}else{x=0}ab=bQ(-1,-1)|0;ac=K;ad=c[aa>>2]|0;ae=ad|0;af=Cn(ae)|0;be(ab|0)}}while(0);z=(c[10071]|0)-1|0;ag=c[A+8>>2]|0;do{if((c[A+12>>2]|0)-ag>>2>>>0>z>>>0){ah=c[ag+(z<<2)>>2]|0;if((ah|0)==0){break}ai=ah;Cn(c[aa>>2]|0)|0;L8:do{switch(k<<24>>24|0){case 97:case 65:{ah=c[f>>2]|0;aj=d+8|0;ak=cA[c[c[aj>>2]>>2]&511](aj)|0;c[y>>2]=ah;ah=(En(e,y,ak,ak+168|0,ai,h,0)|0)-ak|0;if((ah|0)>=168){break L8}c[j+24>>2]=((ah|0)/12|0|0)%7|0;break};case 98:case 66:case 104:{ah=c[f>>2]|0;ak=d+8|0;aj=cA[c[(c[ak>>2]|0)+4>>2]&511](ak)|0;c[w>>2]=ah;ah=(En(e,w,aj,aj+288|0,ai,h,0)|0)-aj|0;if((ah|0)>=288){break L8}c[j+16>>2]=((ah|0)/12|0|0)%12|0;break};case 99:{ah=d+8|0;aj=cA[c[(c[ah>>2]|0)+12>>2]&511](ah)|0;ah=e|0;c[C>>2]=c[ah>>2];c[D>>2]=c[f>>2];ak=aj;al=a[aj]|0;if((al&1)==0){am=ak+1|0;an=ak+1|0}else{ak=c[aj+8>>2]|0;am=ak;an=ak}ak=al&255;if((ak&1|0)==0){ao=ak>>>1}else{ao=c[aj+4>>2]|0}FC(B,d,C,D,g,h,j,an,am+ao|0);c[ah>>2]=c[B>>2];break};case 100:case 101:{ah=j+12|0;c[v>>2]=c[f>>2];aj=FP(e,v,h,ai,2)|0;ak=c[h>>2]|0;do{if((ak&4|0)==0){if((aj-1|0)>>>0>=31>>>0){break}c[ah>>2]=aj;break L8}}while(0);c[h>>2]=ak|4;break};case 68:{aj=e|0;c[F>>2]=c[aj>>2];c[G>>2]=c[f>>2];FC(E,d,F,G,g,h,j,12840,12848);c[aj>>2]=c[E>>2];break};case 70:{aj=e|0;c[I>>2]=c[aj>>2];c[J>>2]=c[f>>2];FC(H,d,I,J,g,h,j,12832,12840);c[aj>>2]=c[H>>2];break};case 72:{c[u>>2]=c[f>>2];aj=FP(e,u,h,ai,2)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(aj|0)<24){c[j+8>>2]=aj;break L8}else{c[h>>2]=ah|4;break L8}break};case 73:{ah=j+8|0;c[t>>2]=c[f>>2];aj=FP(e,t,h,ai,2)|0;al=c[h>>2]|0;do{if((al&4|0)==0){if((aj-1|0)>>>0>=12>>>0){break}c[ah>>2]=aj;break L8}}while(0);c[h>>2]=al|4;break};case 106:{c[s>>2]=c[f>>2];aj=FP(e,s,h,ai,3)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(aj|0)<366){c[j+28>>2]=aj;break L8}else{c[h>>2]=ah|4;break L8}break};case 109:{c[r>>2]=c[f>>2];ah=(FP(e,r,h,ai,2)|0)-1|0;aj=c[h>>2]|0;if((aj&4|0)==0&(ah|0)<12){c[j+16>>2]=ah;break L8}else{c[h>>2]=aj|4;break L8}break};case 77:{c[q>>2]=c[f>>2];aj=FP(e,q,h,ai,2)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(aj|0)<60){c[j+4>>2]=aj;break L8}else{c[h>>2]=ah|4;break L8}break};case 110:case 116:{c[L>>2]=c[f>>2];FM(0,e,L,h,ai);break};case 112:{c[M>>2]=c[f>>2];FN(d,j+8|0,e,M,h,ai);break};case 114:{ah=e|0;c[O>>2]=c[ah>>2];c[P>>2]=c[f>>2];FC(N,d,O,P,g,h,j,12816,12827);c[ah>>2]=c[N>>2];break};case 82:{ah=e|0;c[R>>2]=c[ah>>2];c[S>>2]=c[f>>2];FC(Q,d,R,S,g,h,j,12808,12813);c[ah>>2]=c[Q>>2];break};case 83:{c[p>>2]=c[f>>2];ah=FP(e,p,h,ai,2)|0;aj=c[h>>2]|0;if((aj&4|0)==0&(ah|0)<61){c[j>>2]=ah;break L8}else{c[h>>2]=aj|4;break L8}break};case 84:{aj=e|0;c[U>>2]=c[aj>>2];c[V>>2]=c[f>>2];FC(T,d,U,V,g,h,j,12800,12808);c[aj>>2]=c[T>>2];break};case 119:{c[o>>2]=c[f>>2];aj=FP(e,o,h,ai,1)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(aj|0)<7){c[j+24>>2]=aj;break L8}else{c[h>>2]=ah|4;break L8}break};case 120:{ah=c[(c[d>>2]|0)+20>>2]|0;c[W>>2]=c[e>>2];c[X>>2]=c[f>>2];cO[ah&127](b,d,W,X,g,h,j);i=l;return};case 88:{ah=d+8|0;aj=cA[c[(c[ah>>2]|0)+24>>2]&511](ah)|0;ah=e|0;c[Z>>2]=c[ah>>2];c[_>>2]=c[f>>2];ak=aj;ap=a[aj]|0;if((ap&1)==0){aq=ak+1|0;ar=ak+1|0}else{ak=c[aj+8>>2]|0;aq=ak;ar=ak}ak=ap&255;if((ak&1|0)==0){as=ak>>>1}else{as=c[aj+4>>2]|0}FC(Y,d,Z,_,g,h,j,ar,aq+as|0);c[ah>>2]=c[Y>>2];break};case 121:{c[n>>2]=c[f>>2];ah=FP(e,n,h,ai,4)|0;if((c[h>>2]&4|0)!=0){break L8}if((ah|0)<69){at=ah+2e3|0}else{at=(ah-69|0)>>>0<31>>>0?ah+1900|0:ah}c[j+20>>2]=at-1900;break};case 89:{c[m>>2]=c[f>>2];ah=FP(e,m,h,ai,4)|0;if((c[h>>2]&4|0)!=0){break L8}c[j+20>>2]=ah-1900;break};case 37:{c[$>>2]=c[f>>2];FO(0,e,$,h,ai);break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}}while(0);l=ci(4)|0;JB(l);x=0;aP(144,l|0,28080,98);if(x){x=0;ab=bQ(-1,-1)|0;ac=K;ad=c[aa>>2]|0;ae=ad|0;af=Cn(ae)|0;be(ab|0)}}function FM(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;j=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[j>>2];j=e|0;e=f|0;f=h+8|0;L1:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((cA[c[(c[h>>2]|0)+36>>2]&511](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;L10:do{if((l|0)==0){m=12}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if((cA[c[(c[l>>2]|0)+36>>2]&511](l)|0)!=-1){break}c[e>>2]=0;m=12;break L10}}while(0);if(h){n=l;o=0}else{p=l;q=0;break L1}}}while(0);if((m|0)==12){m=0;if(h){p=0;q=1;break}else{n=0;o=1}}l=c[j>>2]|0;r=c[l+12>>2]|0;if((r|0)==(c[l+16>>2]|0)){s=(cA[c[(c[l>>2]|0)+36>>2]&511](l)|0)&255}else{s=a[r]|0}if(s<<24>>24<0){p=n;q=o;break}if((b[(c[f>>2]|0)+(s<<24>>24<<1)>>1]&8192)==0){p=n;q=o;break}r=c[j>>2]|0;l=r+12|0;t=c[l>>2]|0;if((t|0)==(c[r+16>>2]|0)){cA[c[(c[r>>2]|0)+40>>2]&511](r)|0;continue}else{c[l>>2]=t+1;continue}}o=c[j>>2]|0;do{if((o|0)==0){u=0}else{if((c[o+12>>2]|0)!=(c[o+16>>2]|0)){u=o;break}if((cA[c[(c[o>>2]|0)+36>>2]&511](o)|0)==-1){c[j>>2]=0;u=0;break}else{u=c[j>>2]|0;break}}}while(0);j=(u|0)==0;do{if(q){m=31}else{if((c[p+12>>2]|0)!=(c[p+16>>2]|0)){if(!(j^(p|0)==0)){break}i=d;return}if((cA[c[(c[p>>2]|0)+36>>2]&511](p)|0)==-1){c[e>>2]=0;m=31;break}if(!j){break}i=d;return}}while(0);do{if((m|0)==31){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function FN(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+8|0;k=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[k>>2];k=j|0;l=a+8|0;a=cA[c[(c[l>>2]|0)+8>>2]&511](l)|0;l=d[a]|0;if((l&1|0)==0){m=l>>>1}else{m=c[a+4>>2]|0}l=d[a+12|0]|0;if((l&1|0)==0){n=l>>>1}else{n=c[a+16>>2]|0}if((m|0)==(-n|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[k>>2]=c[f>>2];f=En(e,k,a,a+24|0,h,g,0)|0;g=f-a|0;do{if((f|0)==(a|0)){if((c[b>>2]|0)!=12){break}c[b>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[b>>2]|0;if((g|0)>=12){i=j;return}c[b>>2]=g+12;i=j;return}function FO(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;h=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[h>>2];h=d|0;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((cA[c[(c[d>>2]|0)+36>>2]&511](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e|0;e=c[j>>2]|0;L8:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if((cA[c[(c[e>>2]|0)+36>>2]&511](e)|0)!=-1){break}c[j>>2]=0;k=11;break L8}}while(0);if(d){l=e;m=0}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0;m=1}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){n=(cA[c[(c[d>>2]|0)+36>>2]&511](d)|0)&255}else{n=a[e]|0}if((cF[c[(c[g>>2]|0)+36>>2]&127](g,n,0)|0)<<24>>24!=37){c[f>>2]=c[f>>2]|4;i=b;return}n=c[h>>2]|0;g=n+12|0;e=c[g>>2]|0;if((e|0)==(c[n+16>>2]|0)){cA[c[(c[n>>2]|0)+40>>2]&511](n)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){o=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){o=e;break}if((cA[c[(c[e>>2]|0)+36>>2]&511](e)|0)==-1){c[h>>2]=0;o=0;break}else{o=c[h>>2]|0;break}}}while(0);h=(o|0)==0;do{if(m){k=31}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(!(h^(l|0)==0)){break}i=b;return}if((cA[c[(c[l>>2]|0)+36>>2]&511](l)|0)==-1){c[j>>2]=0;k=31;break}if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function FP(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=d|0;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((cA[c[(c[d>>2]|0)+36>>2]&511](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e|0;e=c[l>>2]|0;L8:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if((cA[c[(c[e>>2]|0)+36>>2]&511](e)|0)!=-1){break}c[l>>2]=0;m=11;break L8}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(cA[c[(c[d>>2]|0)+36>>2]&511](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>=0){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=g;q=(cF[c[(c[d>>2]|0)+36>>2]&127](g,p,0)|0)<<24>>24;r=c[k>>2]|0;s=r+12|0;t=c[s>>2]|0;if((t|0)==(c[r+16>>2]|0)){cA[c[(c[r>>2]|0)+40>>2]&511](r)|0;u=q;v=h;w=n}else{c[s>>2]=t+1;u=q;v=h;w=n}while(1){x=u-48|0;q=v-1|0;t=c[k>>2]|0;do{if((t|0)==0){y=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){y=t;break}if((cA[c[(c[t>>2]|0)+36>>2]&511](t)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);t=(y|0)==0;if((w|0)==0){z=y;A=0}else{do{if((c[w+12>>2]|0)==(c[w+16>>2]|0)){if((cA[c[(c[w>>2]|0)+36>>2]&511](w)|0)!=-1){B=w;break}c[l>>2]=0;B=0}else{B=w}}while(0);z=c[k>>2]|0;A=B}C=(A|0)==0;if(!((t^C)&(q|0)>0)){m=41;break}s=c[z+12>>2]|0;if((s|0)==(c[z+16>>2]|0)){D=(cA[c[(c[z>>2]|0)+36>>2]&511](z)|0)&255}else{D=a[s]|0}if(D<<24>>24<0){o=x;m=57;break}if((b[(c[e>>2]|0)+(D<<24>>24<<1)>>1]&2048)==0){o=x;m=55;break}s=((cF[c[(c[d>>2]|0)+36>>2]&127](g,D,0)|0)<<24>>24)+(x*10|0)|0;r=c[k>>2]|0;E=r+12|0;F=c[E>>2]|0;if((F|0)==(c[r+16>>2]|0)){cA[c[(c[r>>2]|0)+40>>2]&511](r)|0;u=s;v=q;w=A;continue}else{c[E>>2]=F+1;u=s;v=q;w=A;continue}}if((m|0)==41){do{if((z|0)==0){G=0}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){G=z;break}if((cA[c[(c[z>>2]|0)+36>>2]&511](z)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);d=(G|0)==0;L65:do{if(C){m=51}else{do{if((c[A+12>>2]|0)==(c[A+16>>2]|0)){if((cA[c[(c[A>>2]|0)+36>>2]&511](A)|0)!=-1){break}c[l>>2]=0;m=51;break L65}}while(0);if(d){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==51){if(d){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==55){i=j;return o|0}else if((m|0)==57){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function FQ(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;l=i;i=i+48|0;m=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[m>>2];m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=l|0;n=l+16|0;o=l+24|0;p=l+32|0;q=l+40|0;C8(n,f);r=n|0;n=c[r>>2]|0;do{if((c[10068]|0)!=-1){c[m>>2]=40272;c[m+4>>2]=454;c[m+8>>2]=0;x=0;aP(2,40272,m|0,512);if(!x){break}else{x=0}s=bQ(-1,-1)|0;t=K;u=c[r>>2]|0;v=u|0;w=Cn(v)|0;be(s|0)}}while(0);m=(c[10069]|0)-1|0;y=c[n+8>>2]|0;do{if((c[n+12>>2]|0)-y>>2>>>0>m>>>0){z=c[y+(m<<2)>>2]|0;if((z|0)==0){break}A=z;Cn(c[r>>2]|0)|0;c[g>>2]=0;B=d|0;L8:do{if((j|0)==(k|0)){C=71}else{D=e|0;E=z;F=z;G=z;H=b;I=p|0;J=q|0;L=o|0;M=j;N=0;L10:while(1){O=N;while(1){if((O|0)!=0){C=71;break L8}P=c[B>>2]|0;do{if((P|0)==0){Q=0}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=cA[c[(c[P>>2]|0)+36>>2]&511](P)|0}else{S=c[R>>2]|0}if((S|0)!=-1){Q=P;break}c[B>>2]=0;Q=0}}while(0);P=(Q|0)==0;R=c[D>>2]|0;do{if((R|0)==0){C=23}else{T=c[R+12>>2]|0;if((T|0)==(c[R+16>>2]|0)){U=cA[c[(c[R>>2]|0)+36>>2]&511](R)|0}else{U=c[T>>2]|0}if((U|0)==-1){c[D>>2]=0;C=23;break}else{if(P^(R|0)==0){V=R;break}else{C=25;break L10}}}}while(0);if((C|0)==23){C=0;if(P){C=25;break L10}else{V=0}}if((cF[c[(c[E>>2]|0)+52>>2]&127](A,c[M>>2]|0,0)|0)<<24>>24==37){C=28;break}if(cF[c[(c[F>>2]|0)+12>>2]&127](A,8192,c[M>>2]|0)|0){W=M;C=38;break}X=Q+12|0;R=c[X>>2]|0;Y=Q+16|0;if((R|0)==(c[Y>>2]|0)){Z=cA[c[(c[Q>>2]|0)+36>>2]&511](Q)|0}else{Z=c[R>>2]|0}R=cS[c[(c[G>>2]|0)+28>>2]&1023](A,Z)|0;if((R|0)==(cS[c[(c[G>>2]|0)+28>>2]&1023](A,c[M>>2]|0)|0)){C=66;break}c[g>>2]=4;O=4}L42:do{if((C|0)==28){C=0;O=M+4|0;if((O|0)==(k|0)){C=29;break L10}R=cF[c[(c[E>>2]|0)+52>>2]&127](A,c[O>>2]|0,0)|0;if((R<<24>>24|0)==69|(R<<24>>24|0)==48){T=M+8|0;if((T|0)==(k|0)){C=32;break L10}_=R;$=cF[c[(c[E>>2]|0)+52>>2]&127](A,c[T>>2]|0,0)|0;aa=T}else{_=0;$=R;aa=O}O=c[(c[H>>2]|0)+36>>2]|0;c[I>>2]=Q;c[J>>2]=V;cQ[O&7](o,b,p,q,f,g,h,$,_);c[B>>2]=c[L>>2];ab=aa+4|0}else if((C|0)==38){while(1){C=0;O=W+4|0;if((O|0)==(k|0)){ac=k;break}if(cF[c[(c[F>>2]|0)+12>>2]&127](A,8192,c[O>>2]|0)|0){W=O;C=38}else{ac=O;break}}P=Q;O=V;while(1){do{if((P|0)==0){ad=0}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){ae=cA[c[(c[P>>2]|0)+36>>2]&511](P)|0}else{ae=c[R>>2]|0}if((ae|0)!=-1){ad=P;break}c[B>>2]=0;ad=0}}while(0);R=(ad|0)==0;do{if((O|0)==0){C=53}else{T=c[O+12>>2]|0;if((T|0)==(c[O+16>>2]|0)){af=cA[c[(c[O>>2]|0)+36>>2]&511](O)|0}else{af=c[T>>2]|0}if((af|0)==-1){c[D>>2]=0;C=53;break}else{if(R^(O|0)==0){ag=O;break}else{ab=ac;break L42}}}}while(0);if((C|0)==53){C=0;if(R){ab=ac;break L42}else{ag=0}}T=ad+12|0;ah=c[T>>2]|0;ai=ad+16|0;if((ah|0)==(c[ai>>2]|0)){aj=cA[c[(c[ad>>2]|0)+36>>2]&511](ad)|0}else{aj=c[ah>>2]|0}if(!(cF[c[(c[F>>2]|0)+12>>2]&127](A,8192,aj)|0)){ab=ac;break L42}ah=c[T>>2]|0;if((ah|0)==(c[ai>>2]|0)){cA[c[(c[ad>>2]|0)+40>>2]&511](ad)|0;P=ad;O=ag;continue}else{c[T>>2]=ah+4;P=ad;O=ag;continue}}}else if((C|0)==66){C=0;O=c[X>>2]|0;if((O|0)==(c[Y>>2]|0)){cA[c[(c[Q>>2]|0)+40>>2]&511](Q)|0}else{c[X>>2]=O+4}ab=M+4|0}}while(0);if((ab|0)==(k|0)){C=71;break L8}M=ab;N=c[g>>2]|0}if((C|0)==25){c[g>>2]=4;ak=Q;break}else if((C|0)==29){c[g>>2]=4;ak=Q;break}else if((C|0)==32){c[g>>2]=4;ak=Q;break}}}while(0);if((C|0)==71){ak=c[B>>2]|0}A=d|0;do{if((ak|0)!=0){z=c[ak+12>>2]|0;if((z|0)==(c[ak+16>>2]|0)){al=cA[c[(c[ak>>2]|0)+36>>2]&511](ak)|0}else{al=c[z>>2]|0}if((al|0)!=-1){break}c[A>>2]=0}}while(0);B=c[A>>2]|0;z=(B|0)==0;N=e|0;M=c[N>>2]|0;do{if((M|0)==0){C=84}else{F=c[M+12>>2]|0;if((F|0)==(c[M+16>>2]|0)){am=cA[c[(c[M>>2]|0)+36>>2]&511](M)|0}else{am=c[F>>2]|0}if((am|0)==-1){c[N>>2]=0;C=84;break}if(!(z^(M|0)==0)){break}an=a|0;c[an>>2]=B;i=l;return}}while(0);do{if((C|0)==84){if(z){break}an=a|0;c[an>>2]=B;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;an=a|0;c[an>>2]=B;i=l;return}}while(0);l=ci(4)|0;JB(l);x=0;aP(144,l|0,28080,98);if(x){x=0;s=bQ(-1,-1)|0;t=K;u=c[r>>2]|0;v=u|0;w=Cn(v)|0;be(s|0)}}function FR(a){a=a|0;Cl(a|0);J2(a);return}function FS(a){a=a|0;Cl(a|0);return}function FT(a){a=a|0;return 2}function FU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+16|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;c[k>>2]=c[d>>2];c[l>>2]=c[e>>2];FQ(a,b,k,l,f,g,h,12768,12800);i=j;return}function FV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+8|0;n=d+8|0;o=cA[c[(c[n>>2]|0)+20>>2]&511](n)|0;c[l>>2]=c[e>>2];c[m>>2]=c[f>>2];f=a[o]|0;if((f&1)==0){p=o+4|0;q=o+4|0}else{e=c[o+8>>2]|0;p=e;q=e}e=f&255;if((e&1|0)==0){r=e>>>1}else{r=c[o+4>>2]|0}FQ(b,d,l,m,g,h,j,q,p+(r<<2)|0);i=k;return}function FW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;C8(m,f);f=m|0;m=c[f>>2]|0;do{if((c[10068]|0)!=-1){c[l>>2]=40272;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40272,l|0,512);if(!x){break}else{x=0}n=bQ(-1,-1)|0;o=K;p=c[f>>2]|0;q=p|0;r=Cn(q)|0;be(n|0)}}while(0);l=(c[10069]|0)-1|0;s=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-s>>2>>>0>l>>>0){t=c[s+(l<<2)>>2]|0;if((t|0)==0){break}Cn(c[f>>2]|0)|0;u=c[e>>2]|0;v=b+8|0;w=cA[c[c[v>>2]>>2]&511](v)|0;c[k>>2]=u;u=(EM(d,k,w,w+168|0,t,g,0)|0)-w|0;if((u|0)>=168){y=d|0;z=c[y>>2]|0;A=a|0;c[A>>2]=z;i=j;return}c[h+24>>2]=((u|0)/12|0|0)%7|0;y=d|0;z=c[y>>2]|0;A=a|0;c[A>>2]=z;i=j;return}}while(0);j=ci(4)|0;JB(j);x=0;aP(144,j|0,28080,98);if(x){x=0;n=bQ(-1,-1)|0;o=K;p=c[f>>2]|0;q=p|0;r=Cn(q)|0;be(n|0)}}function FX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0;j=i;i=i+32|0;k=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[k>>2];k=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[k>>2];k=j|0;l=j+8|0;m=j+24|0;C8(m,f);f=m|0;m=c[f>>2]|0;do{if((c[10068]|0)!=-1){c[l>>2]=40272;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40272,l|0,512);if(!x){break}else{x=0}n=bQ(-1,-1)|0;o=K;p=c[f>>2]|0;q=p|0;r=Cn(q)|0;be(n|0)}}while(0);l=(c[10069]|0)-1|0;s=c[m+8>>2]|0;do{if((c[m+12>>2]|0)-s>>2>>>0>l>>>0){t=c[s+(l<<2)>>2]|0;if((t|0)==0){break}Cn(c[f>>2]|0)|0;u=c[e>>2]|0;v=b+8|0;w=cA[c[(c[v>>2]|0)+4>>2]&511](v)|0;c[k>>2]=u;u=(EM(d,k,w,w+288|0,t,g,0)|0)-w|0;if((u|0)>=288){y=d|0;z=c[y>>2]|0;A=a|0;c[A>>2]=z;i=j;return}c[h+16>>2]=((u|0)/12|0|0)%12|0;y=d|0;z=c[y>>2]|0;A=a|0;c[A>>2]=z;i=j;return}}while(0);j=ci(4)|0;JB(j);x=0;aP(144,j|0,28080,98);if(x){x=0;n=bQ(-1,-1)|0;o=K;p=c[f>>2]|0;q=p|0;r=Cn(q)|0;be(n|0)}}function FY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;b=i;i=i+32|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;l=b+24|0;C8(l,f);f=l|0;l=c[f>>2]|0;do{if((c[10068]|0)!=-1){c[k>>2]=40272;c[k+4>>2]=454;c[k+8>>2]=0;x=0;aP(2,40272,k|0,512);if(!x){break}else{x=0}m=bQ(-1,-1)|0;n=K;o=c[f>>2]|0;p=o|0;q=Cn(p)|0;be(m|0)}}while(0);k=(c[10069]|0)-1|0;r=c[l+8>>2]|0;do{if((c[l+12>>2]|0)-r>>2>>>0>k>>>0){s=c[r+(k<<2)>>2]|0;if((s|0)==0){break}Cn(c[f>>2]|0)|0;c[j>>2]=c[e>>2];t=F1(d,j,g,s,4)|0;if((c[g>>2]&4|0)!=0){u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=b;return}if((t|0)<69){y=t+2e3|0}else{y=(t-69|0)>>>0<31>>>0?t+1900|0:t}c[h+20>>2]=y-1900;u=d|0;v=c[u>>2]|0;w=a|0;c[w>>2]=v;i=b;return}}while(0);b=ci(4)|0;JB(b);x=0;aP(144,b|0,28080,98);if(x){x=0;m=bQ(-1,-1)|0;n=K;o=c[f>>2]|0;p=o|0;q=Cn(p)|0;be(m|0)}}function FZ(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0;l=i;i=i+328|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=l|0;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;y=l+88|0;z=l+96|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;L=l+192|0;M=l+200|0;N=l+208|0;O=l+216|0;P=l+224|0;Q=l+232|0;R=l+240|0;S=l+248|0;T=l+256|0;U=l+264|0;V=l+272|0;W=l+280|0;X=l+288|0;Y=l+296|0;Z=l+304|0;_=l+312|0;$=l+320|0;c[h>>2]=0;C8(A,g);aa=A|0;A=c[aa>>2]|0;do{if((c[10068]|0)!=-1){c[z>>2]=40272;c[z+4>>2]=454;c[z+8>>2]=0;x=0;aP(2,40272,z|0,512);if(!x){break}else{x=0}ab=bQ(-1,-1)|0;ac=K;ad=c[aa>>2]|0;ae=ad|0;af=Cn(ae)|0;be(ab|0)}}while(0);z=(c[10069]|0)-1|0;ag=c[A+8>>2]|0;do{if((c[A+12>>2]|0)-ag>>2>>>0>z>>>0){ah=c[ag+(z<<2)>>2]|0;if((ah|0)==0){break}ai=ah;Cn(c[aa>>2]|0)|0;L8:do{switch(k<<24>>24|0){case 73:{ah=j+8|0;c[t>>2]=c[f>>2];aj=F1(e,t,h,ai,2)|0;ak=c[h>>2]|0;do{if((ak&4|0)==0){if((aj-1|0)>>>0>=12>>>0){break}c[ah>>2]=aj;break L8}}while(0);c[h>>2]=ak|4;break};case 70:{aj=e|0;c[I>>2]=c[aj>>2];c[J>>2]=c[f>>2];FQ(H,d,I,J,g,h,j,12600,12632);c[aj>>2]=c[H>>2];break};case 109:{c[r>>2]=c[f>>2];aj=(F1(e,r,h,ai,2)|0)-1|0;ah=c[h>>2]|0;if((ah&4|0)==0&(aj|0)<12){c[j+16>>2]=aj;break L8}else{c[h>>2]=ah|4;break L8}break};case 77:{c[q>>2]=c[f>>2];ah=F1(e,q,h,ai,2)|0;aj=c[h>>2]|0;if((aj&4|0)==0&(ah|0)<60){c[j+4>>2]=ah;break L8}else{c[h>>2]=aj|4;break L8}break};case 120:{aj=c[(c[d>>2]|0)+20>>2]|0;c[W>>2]=c[e>>2];c[X>>2]=c[f>>2];cO[aj&127](b,d,W,X,g,h,j);i=l;return};case 88:{aj=d+8|0;ah=cA[c[(c[aj>>2]|0)+24>>2]&511](aj)|0;aj=e|0;c[Z>>2]=c[aj>>2];c[_>>2]=c[f>>2];al=a[ah]|0;if((al&1)==0){am=ah+4|0;an=ah+4|0}else{ao=c[ah+8>>2]|0;am=ao;an=ao}ao=al&255;if((ao&1|0)==0){ap=ao>>>1}else{ap=c[ah+4>>2]|0}FQ(Y,d,Z,_,g,h,j,an,am+(ap<<2)|0);c[aj>>2]=c[Y>>2];break};case 121:{c[n>>2]=c[f>>2];aj=F1(e,n,h,ai,4)|0;if((c[h>>2]&4|0)!=0){break L8}if((aj|0)<69){aq=aj+2e3|0}else{aq=(aj-69|0)>>>0<31>>>0?aj+1900|0:aj}c[j+20>>2]=aq-1900;break};case 89:{c[m>>2]=c[f>>2];aj=F1(e,m,h,ai,4)|0;if((c[h>>2]&4|0)!=0){break L8}c[j+20>>2]=aj-1900;break};case 37:{c[$>>2]=c[f>>2];F0(0,e,$,h,ai);break};case 97:case 65:{aj=c[f>>2]|0;ah=d+8|0;ao=cA[c[c[ah>>2]>>2]&511](ah)|0;c[y>>2]=aj;aj=(EM(e,y,ao,ao+168|0,ai,h,0)|0)-ao|0;if((aj|0)>=168){break L8}c[j+24>>2]=((aj|0)/12|0|0)%7|0;break};case 98:case 66:case 104:{aj=c[f>>2]|0;ao=d+8|0;ah=cA[c[(c[ao>>2]|0)+4>>2]&511](ao)|0;c[w>>2]=aj;aj=(EM(e,w,ah,ah+288|0,ai,h,0)|0)-ah|0;if((aj|0)>=288){break L8}c[j+16>>2]=((aj|0)/12|0|0)%12|0;break};case 82:{aj=e|0;c[R>>2]=c[aj>>2];c[S>>2]=c[f>>2];FQ(Q,d,R,S,g,h,j,12664,12684);c[aj>>2]=c[Q>>2];break};case 83:{c[p>>2]=c[f>>2];aj=F1(e,p,h,ai,2)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(aj|0)<61){c[j>>2]=aj;break L8}else{c[h>>2]=ah|4;break L8}break};case 84:{ah=e|0;c[U>>2]=c[ah>>2];c[V>>2]=c[f>>2];FQ(T,d,U,V,g,h,j,12632,12664);c[ah>>2]=c[T>>2];break};case 119:{c[o>>2]=c[f>>2];ah=F1(e,o,h,ai,1)|0;aj=c[h>>2]|0;if((aj&4|0)==0&(ah|0)<7){c[j+24>>2]=ah;break L8}else{c[h>>2]=aj|4;break L8}break};case 99:{aj=d+8|0;ah=cA[c[(c[aj>>2]|0)+12>>2]&511](aj)|0;aj=e|0;c[C>>2]=c[aj>>2];c[D>>2]=c[f>>2];ao=a[ah]|0;if((ao&1)==0){ar=ah+4|0;as=ah+4|0}else{al=c[ah+8>>2]|0;ar=al;as=al}al=ao&255;if((al&1|0)==0){at=al>>>1}else{at=c[ah+4>>2]|0}FQ(B,d,C,D,g,h,j,as,ar+(at<<2)|0);c[aj>>2]=c[B>>2];break};case 68:{aj=e|0;c[F>>2]=c[aj>>2];c[G>>2]=c[f>>2];FQ(E,d,F,G,g,h,j,12736,12768);c[aj>>2]=c[E>>2];break};case 72:{c[u>>2]=c[f>>2];aj=F1(e,u,h,ai,2)|0;ah=c[h>>2]|0;if((ah&4|0)==0&(aj|0)<24){c[j+8>>2]=aj;break L8}else{c[h>>2]=ah|4;break L8}break};case 106:{c[s>>2]=c[f>>2];ah=F1(e,s,h,ai,3)|0;aj=c[h>>2]|0;if((aj&4|0)==0&(ah|0)<366){c[j+28>>2]=ah;break L8}else{c[h>>2]=aj|4;break L8}break};case 100:case 101:{aj=j+12|0;c[v>>2]=c[f>>2];ah=F1(e,v,h,ai,2)|0;al=c[h>>2]|0;do{if((al&4|0)==0){if((ah-1|0)>>>0>=31>>>0){break}c[aj>>2]=ah;break L8}}while(0);c[h>>2]=al|4;break};case 110:case 116:{c[L>>2]=c[f>>2];F_(0,e,L,h,ai);break};case 112:{c[M>>2]=c[f>>2];F$(d,j+8|0,e,M,h,ai);break};case 114:{ah=e|0;c[O>>2]=c[ah>>2];c[P>>2]=c[f>>2];FQ(N,d,O,P,g,h,j,12688,12732);c[ah>>2]=c[N>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}}while(0);l=ci(4)|0;JB(l);x=0;aP(144,l|0,28080,98);if(x){x=0;ab=bQ(-1,-1)|0;ac=K;ad=c[aa>>2]|0;ae=ad|0;af=Cn(ae)|0;be(ab|0)}}function F_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;a=i;g=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[g>>2];g=b|0;b=d|0;d=f;L1:while(1){h=c[g>>2]|0;do{if((h|0)==0){j=1}else{k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){l=cA[c[(c[h>>2]|0)+36>>2]&511](h)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[g>>2]=0;j=1;break}else{j=(c[g>>2]|0)==0;break}}}while(0);h=c[b>>2]|0;do{if((h|0)==0){m=15}else{k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){n=cA[c[(c[h>>2]|0)+36>>2]&511](h)|0}else{n=c[k>>2]|0}if((n|0)==-1){c[b>>2]=0;m=15;break}else{k=(h|0)==0;if(j^k){o=h;p=k;break}else{q=h;r=k;break L1}}}}while(0);if((m|0)==15){m=0;if(j){q=0;r=1;break}else{o=0;p=1}}h=c[g>>2]|0;k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0)){s=cA[c[(c[h>>2]|0)+36>>2]&511](h)|0}else{s=c[k>>2]|0}if(!(cF[c[(c[d>>2]|0)+12>>2]&127](f,8192,s)|0)){q=o;r=p;break}k=c[g>>2]|0;h=k+12|0;t=c[h>>2]|0;if((t|0)==(c[k+16>>2]|0)){cA[c[(c[k>>2]|0)+40>>2]&511](k)|0;continue}else{c[h>>2]=t+4;continue}}p=c[g>>2]|0;do{if((p|0)==0){u=1}else{o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0)){v=cA[c[(c[p>>2]|0)+36>>2]&511](p)|0}else{v=c[o>>2]|0}if((v|0)==-1){c[g>>2]=0;u=1;break}else{u=(c[g>>2]|0)==0;break}}}while(0);do{if(r){m=37}else{g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){w=cA[c[(c[q>>2]|0)+36>>2]&511](q)|0}else{w=c[g>>2]|0}if((w|0)==-1){c[b>>2]=0;m=37;break}if(!(u^(q|0)==0)){break}i=a;return}}while(0);do{if((m|0)==37){if(u){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function F$(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+8|0;k=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[k>>2];k=j|0;l=a+8|0;a=cA[c[(c[l>>2]|0)+8>>2]&511](l)|0;l=d[a]|0;if((l&1|0)==0){m=l>>>1}else{m=c[a+4>>2]|0}l=d[a+12|0]|0;if((l&1|0)==0){n=l>>>1}else{n=c[a+16>>2]|0}if((m|0)==(-n|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[k>>2]=c[f>>2];f=EM(e,k,a,a+24|0,h,g,0)|0;g=f-a|0;do{if((f|0)==(a|0)){if((c[b>>2]|0)!=12){break}c[b>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[b>>2]|0;if((g|0)>=12){i=j;return}c[b>>2]=g+12;i=j;return}function F0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a=i;g=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[g>>2];g=b|0;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=cA[c[(c[b>>2]|0)+36>>2]&511](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d|0;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=cA[c[(c[d>>2]|0)+36>>2]&511](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{b=(d|0)==0;if(h^b){n=d;o=b;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0;o=1}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){p=cA[c[(c[h>>2]|0)+36>>2]&511](h)|0}else{p=c[d>>2]|0}if((cF[c[(c[f>>2]|0)+52>>2]&127](f,p,0)|0)<<24>>24!=37){c[e>>2]=c[e>>2]|4;i=a;return}p=c[g>>2]|0;f=p+12|0;d=c[f>>2]|0;if((d|0)==(c[p+16>>2]|0)){cA[c[(c[p>>2]|0)+40>>2]&511](p)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){q=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){r=cA[c[(c[d>>2]|0)+36>>2]&511](d)|0}else{r=c[f>>2]|0}if((r|0)==-1){c[g>>2]=0;q=1;break}else{q=(c[g>>2]|0)==0;break}}}while(0);do{if(o){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){s=cA[c[(c[n>>2]|0)+36>>2]&511](n)|0}else{s=c[g>>2]|0}if((s|0)==-1){c[k>>2]=0;l=38;break}if(!(q^(n|0)==0)){break}i=a;return}}while(0);do{if((l|0)==38){if(q){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function F1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;h=b;b=i;i=i+4|0;i=i+7&-8;c[b>>2]=c[h>>2];h=a|0;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=cA[c[(c[a>>2]|0)+36>>2]&511](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b|0;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=cA[c[(c[b>>2]|0)+36>>2]&511](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j^(b|0)==0){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=cA[c[(c[j>>2]|0)+36>>2]&511](j)|0}else{q=c[b>>2]|0}b=e;if(!(cF[c[(c[b>>2]|0)+12>>2]&127](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}j=e;n=(cF[c[(c[j>>2]|0)+52>>2]&127](e,q,0)|0)<<24>>24;q=c[h>>2]|0;a=q+12|0;k=c[a>>2]|0;if((k|0)==(c[q+16>>2]|0)){cA[c[(c[q>>2]|0)+40>>2]&511](q)|0;r=n;s=f;t=o}else{c[a>>2]=k+4;r=n;s=f;t=o}while(1){u=r-48|0;o=s-1|0;f=c[h>>2]|0;do{if((f|0)==0){v=0}else{n=c[f+12>>2]|0;if((n|0)==(c[f+16>>2]|0)){w=cA[c[(c[f>>2]|0)+36>>2]&511](f)|0}else{w=c[n>>2]|0}if((w|0)==-1){c[h>>2]=0;v=0;break}else{v=c[h>>2]|0;break}}}while(0);f=(v|0)==0;if((t|0)==0){x=v;y=0}else{n=c[t+12>>2]|0;if((n|0)==(c[t+16>>2]|0)){z=cA[c[(c[t>>2]|0)+36>>2]&511](t)|0}else{z=c[n>>2]|0}if((z|0)==-1){c[l>>2]=0;A=0}else{A=t}x=c[h>>2]|0;y=A}B=(y|0)==0;if(!((f^B)&(o|0)>0)){break}f=c[x+12>>2]|0;if((f|0)==(c[x+16>>2]|0)){C=cA[c[(c[x>>2]|0)+36>>2]&511](x)|0}else{C=c[f>>2]|0}if(!(cF[c[(c[b>>2]|0)+12>>2]&127](e,2048,C)|0)){p=u;m=68;break}f=((cF[c[(c[j>>2]|0)+52>>2]&127](e,C,0)|0)<<24>>24)+(u*10|0)|0;n=c[h>>2]|0;k=n+12|0;a=c[k>>2]|0;if((a|0)==(c[n+16>>2]|0)){cA[c[(c[n>>2]|0)+40>>2]&511](n)|0;r=f;s=o;t=y;continue}else{c[k>>2]=a+4;r=f;s=o;t=y;continue}}if((m|0)==68){i=g;return p|0}do{if((x|0)==0){D=1}else{t=c[x+12>>2]|0;if((t|0)==(c[x+16>>2]|0)){E=cA[c[(c[x>>2]|0)+36>>2]&511](x)|0}else{E=c[t>>2]|0}if((E|0)==-1){c[h>>2]=0;D=1;break}else{D=(c[h>>2]|0)==0;break}}}while(0);do{if(B){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){F=cA[c[(c[y>>2]|0)+36>>2]&511](y)|0}else{F=c[h>>2]|0}if((F|0)==-1){c[l>>2]=0;m=60;break}if(D^(y|0)==0){p=u}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(D){break}else{p=u}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=u;i=g;return p|0}function F2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b;e=b+8|0;f=c[e>>2]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}g=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=g;break}else{x=0}bQ(-1,-1,0)|0;bU()}}while(0);if((f|0)==(c[9712]|0)){h=b|0;Cl(h);J2(d);return}x=0;ap(584,c[e>>2]|0);if(!x){h=b|0;Cl(h);J2(d);return}else{x=0}bQ(-1,-1,0)|0;bU()}function F3(b){b=b|0;var d=0,e=0,f=0,g=0;d=b+8|0;e=c[d>>2]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}f=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=f;break}else{x=0}bQ(-1,-1,0)|0;bU()}}while(0);if((e|0)==(c[9712]|0)){g=b|0;Cl(g);return}x=0;ap(584,c[d>>2]|0);if(!x){g=b|0;Cl(g);return}else{x=0}bQ(-1,-1,0)|0;bU()}function F4(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;f=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[f>>2];f=g|0;l=g+8|0;m=l|0;n=f|0;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(k<<24>>24!=0){a[o]=k;a[p]=j}j=bG(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b|0;c[r>>2]=q;i=g;return}else{s=l;t=m}while(1){m=a[t]|0;if((s|0)==0){u=0}else{l=s+24|0;j=c[l>>2]|0;if((j|0)==(c[s+28>>2]|0)){v=cS[c[(c[s>>2]|0)+52>>2]&1023](s,m&255)|0}else{c[l>>2]=j+1;a[j]=m;v=m&255}u=(v|0)==-1?0:s}m=t+1|0;if((m|0)==(d|0)){q=u;break}else{s=u;t=m}}r=b|0;c[r>>2]=q;i=g;return}function F5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b;e=b+8|0;f=c[e>>2]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}g=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=g;break}else{x=0}bQ(-1,-1,0)|0;bU()}}while(0);if((f|0)==(c[9712]|0)){h=b|0;Cl(h);J2(d);return}x=0;ap(584,c[e>>2]|0);if(!x){h=b|0;Cl(h);J2(d);return}else{x=0}bQ(-1,-1,0)|0;bU()}function F6(b){b=b|0;var d=0,e=0,f=0,g=0;d=b+8|0;e=c[d>>2]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}f=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=f;break}else{x=0}bQ(-1,-1,0)|0;bU()}}while(0);if((e|0)==(c[9712]|0)){g=b|0;Cl(g);return}x=0;ap(584,c[d>>2]|0);if(!x){g=b|0;Cl(g);return}else{x=0}bQ(-1,-1,0)|0;bU()}function F7(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+408|0;e=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[e>>2];e=f|0;k=f+400|0;l=e|0;c[k>>2]=e+400;F8(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a|0;c[n>>2]=m;i=f;return}else{o=k;p=l}while(1){l=c[p>>2]|0;if((o|0)==0){q=0}else{k=o+24|0;d=c[k>>2]|0;if((d|0)==(c[o+28>>2]|0)){r=cS[c[(c[o>>2]|0)+52>>2]&1023](o,l)|0}else{c[k>>2]=d+4;c[d>>2]=l;r=l}q=(r|0)==-1?0:o}l=p+4|0;if((l|0)==(j|0)){m=q;break}else{o=q;p=l}}n=a|0;c[n>>2]=m;i=f;return}function F8(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j|0;l=j+112|0;m=i;i=i+4|0;i=i+7&-8;n=j+8|0;o=k|0;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(h<<24>>24!=0){a[p]=h;a[q]=g}g=b|0;bG(n|0,100,o|0,f|0,c[g>>2]|0)|0;c[l>>2]=0;c[l+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=b3(c[g>>2]|0)|0;g=(x=0,aS(16,d|0,m|0,n|0,l|0)|0);if(x){x=0;l=bQ(-1,-1)|0;if((f|0)==0){be(l|0)}x=0,as(32,f|0)|0;if(!x){be(l|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}do{if((f|0)!=0){x=0,as(32,f|0)|0;if(!x){break}else{x=0}bQ(-1,-1,0)|0;bU()}}while(0);if((g|0)==-1){GW(5840)}else{c[e>>2]=d+(g<<2);i=j;return}}function F9(a){a=a|0;Cl(a|0);J2(a);return}function Ga(a){a=a|0;Cl(a|0);return}function Gb(a){a=a|0;return 127}function Gc(a){a=a|0;return 127}function Gd(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function Ge(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function Gf(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function Gg(a,b){a=a|0;b=b|0;CN(a,1,45);return}function Gh(a){a=a|0;return 0}function Gi(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C;C=C>>8;a[c+1|0]=C;C=C>>8;a[c+2|0]=C;C=C>>8;a[c+3|0]=C;return}function Gj(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C;C=C>>8;a[c+1|0]=C;C=C>>8;a[c+2|0]=C;C=C>>8;a[c+3|0]=C;return}function Gk(a){a=a|0;Cl(a|0);J2(a);return}function Gl(a){a=a|0;Cl(a|0);return}function Gm(a){a=a|0;return 127}function Gn(a){a=a|0;return 127}function Go(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function Gp(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function Gq(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function Gr(a,b){a=a|0;b=b|0;CN(a,1,45);return}function Gs(a){a=a|0;return 0}function Gt(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C;C=C>>8;a[c+1|0]=C;C=C>>8;a[c+2|0]=C;C=C>>8;a[c+3|0]=C;return}function Gu(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C;C=C>>8;a[c+1|0]=C;C=C>>8;a[c+2|0]=C;C=C>>8;a[c+3|0]=C;return}function Gv(a){a=a|0;Cl(a|0);J2(a);return}function Gw(a){a=a|0;Cl(a|0);return}function Gx(a){a=a|0;return 2147483647}function Gy(a){a=a|0;return 2147483647}function Gz(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function GA(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function GB(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function GC(a,b){a=a|0;b=b|0;C_(a,1,45);return}function GD(a){a=a|0;return 0}function GE(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C;C=C>>8;a[c+1|0]=C;C=C>>8;a[c+2|0]=C;C=C>>8;a[c+3|0]=C;return}function GF(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C;C=C>>8;a[c+1|0]=C;C=C>>8;a[c+2|0]=C;C=C>>8;a[c+3|0]=C;return}function GG(a){a=a|0;Cl(a|0);J2(a);return}function GH(a){a=a|0;Cl(a|0);return}function GI(a){a=a|0;return 2147483647}function GJ(a){a=a|0;return 2147483647}function GK(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function GL(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function GM(a,b){a=a|0;b=b|0;Ke(a|0,0,12)|0;return}function GN(a,b){a=a|0;b=b|0;C_(a,1,45);return}function GO(a){a=a|0;return 0}function GP(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C;C=C>>8;a[c+1|0]=C;C=C>>8;a[c+2|0]=C;C=C>>8;a[c+3|0]=C;return}function GQ(b,c){b=b|0;c=c|0;c=b;C=67109634;a[c]=C;C=C>>8;a[c+1|0]=C;C=C>>8;a[c+2|0]=C;C=C>>8;a[c+3|0]=C;return}function GR(a){a=a|0;Cl(a|0);J2(a);return}function GS(a){a=a|0;Cl(a|0);return}function GT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0;d=i;i=i+280|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+120|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=d+176|0;u=m|0;v=n|0;c[v>>2]=u;w=n+4|0;c[w>>2]=548;y=m+100|0;x=0;aq(346,p|0,h|0);do{if(!x){m=p|0;z=c[m>>2]|0;if((c[10070]|0)==-1){A=4}else{c[l>>2]=40280;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40280,l|0,512);if(!x){A=4}else{x=0;A=15}}L6:do{if((A|0)==4){B=(c[10071]|0)-1|0;C=c[z+8>>2]|0;do{if((c[z+12>>2]|0)-C>>2>>>0>B>>>0){D=c[C+(B<<2)>>2]|0;if((D|0)==0){break}E=D;a[q]=0;F=f|0;c[r>>2]=c[F>>2];G=(x=0,av(4,e|0,r|0,g|0,p|0,c[h+4>>2]|0,j|0,q|0,E|0,n|0,o|0,y|0)|0);if(x){x=0;A=15;break L6}L12:do{if(G){H=s|0;I=c[(c[D>>2]|0)+32>>2]|0;x=0,aS(I|0,E|0,12584,12594,H|0)|0;if(x){x=0;A=15;break L6}I=t|0;J=c[o>>2]|0;L=c[v>>2]|0;M=J-L|0;do{if((M|0)>98){N=JW(M+2|0)|0;if((N|0)!=0){O=N;P=N;A=19;break}x=0;aQ(4);if(!x){O=0;P=0;A=19}else{x=0;Q=0;A=16}}else{O=I;P=0;A=19}}while(0);do{if((A|0)==19){if((a[q]&1)==0){R=O}else{a[O]=45;R=O+1|0}if(L>>>0<J>>>0){M=s+10|0;N=s;S=R;T=L;while(1){U=H;while(1){if((U|0)==(M|0)){V=M;break}if((a[U]|0)==(a[T]|0)){V=U;break}else{U=U+1|0}}a[S]=a[12584+(V-N)|0]|0;U=T+1|0;W=S+1|0;if(U>>>0<(c[o>>2]|0)>>>0){S=W;T=U}else{X=W;break}}}else{X=R}a[X]=0;T=b5(I|0,10544,(S=i,i=i+8|0,c[S>>2]=k,S)|0)|0;i=S;if((T|0)==1){if((P|0)==0){break L12}JX(P);break L12}T=ci(8)|0;x=0;aq(454,T|0,10248);if(x){x=0;S=bQ(-1,-1)|0;N=K;bl(T|0);Y=N;Z=S;_=P;break}x=0;aP(144,T|0,28096,336);if(x){x=0;Q=P;A=16;break}}}while(0);if((A|0)==16){I=bQ(-1,-1)|0;Y=K;Z=I;_=Q}I=Z;H=Y;if((_|0)==0){$=H;aa=I;break L6}JX(_);$=H;aa=I;break L6}}while(0);E=e|0;D=c[E>>2]|0;do{if((D|0)==0){ab=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){ab=D;break}G=(x=0,as(c[(c[D>>2]|0)+36>>2]|0,D|0)|0);if(x){x=0;A=15;break L6}if((G|0)!=-1){ab=D;break}c[E>>2]=0;ab=0}}while(0);E=(ab|0)==0;D=c[F>>2]|0;do{if((D|0)==0){A=45}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){if(E){break}else{A=47;break}}G=(x=0,as(c[(c[D>>2]|0)+36>>2]|0,D|0)|0);if(x){x=0;A=15;break L6}if((G|0)==-1){c[F>>2]=0;A=45;break}else{if(E^(D|0)==0){break}else{A=47;break}}}}while(0);if((A|0)==45){if(E){A=47}}if((A|0)==47){c[j>>2]=c[j>>2]|2}c[b>>2]=ab;Cn(c[m>>2]|0)|0;D=c[v>>2]|0;c[v>>2]=0;if((D|0)==0){i=d;return}x=0;ap(c[w>>2]|0,D|0);if(!x){i=d;return}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);B=ci(4)|0;JB(B);x=0;aP(144,B|0,28080,98);if(x){x=0;A=15;break}}}while(0);if((A|0)==15){z=bQ(-1,-1)|0;$=K;aa=z}Cn(c[m>>2]|0)|0;z=c[v>>2]|0;c[v>>2]=0;if((z|0)==0){ac=aa;ad=$}else{ae=z;af=aa;ag=$;break}ah=ac;ai=0;aj=ah;ak=ad;be(aj|0)}else{x=0;z=bQ(-1,-1)|0;c[v>>2]=0;ae=u;af=z;ag=K}}while(0);x=0;ap(c[w>>2]|0,ae|0);if(!x){ac=af;ad=ag;ah=ac;ai=0;aj=ah;ak=ad;be(aj|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function GU(a){a=a|0;return}function GV(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0;q=i;i=i+440|0;r=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[r>>2];r=q|0;s=q+400|0;t=q+408|0;u=q+416|0;v=q+424|0;w=v;y=i;i=i+12|0;i=i+7&-8;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;E=r|0;Ke(w|0,0,12)|0;F=y;G=z;H=A;I=B;Ke(F|0,0,12)|0;Ke(G|0,0,12)|0;Ke(H|0,0,12)|0;Ke(I|0,0,12)|0;x=0;aJ(4,g|0,h|0,s|0,t|0,u|0,v|0,y|0,z|0,A|0,C|0);L1:do{if(!x){h=n|0;c[o>>2]=c[h>>2];g=e|0;J=f|0;L=m+8|0;M=A+1|0;N=A+4|0;O=A+8|0;P=z+1|0;Q=z+4|0;R=z+8|0;S=(j&512|0)!=0;T=y+1|0;U=y+4|0;V=y+8|0;W=B+1|0;X=B+4|0;Y=B+8|0;Z=s+3|0;_=v+4|0;$=n+4|0;aa=p;ab=548;ac=E;ad=E;ae=r+400|0;af=0;ag=0;L4:while(1){ah=c[g>>2]|0;do{if((ah|0)==0){ai=0}else{if((c[ah+12>>2]|0)!=(c[ah+16>>2]|0)){ai=ah;break}aj=(x=0,as(c[(c[ah>>2]|0)+36>>2]|0,ah|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}if((aj|0)==-1){c[g>>2]=0;ai=0;break}else{ai=c[g>>2]|0;break}}}while(0);ah=(ai|0)==0;aj=c[J>>2]|0;do{if((aj|0)==0){am=15}else{if((c[aj+12>>2]|0)!=(c[aj+16>>2]|0)){if(ah){an=aj;break}else{ao=ab;ar=ac;at=ad;au=af;am=274;break L4}}av=(x=0,as(c[(c[aj>>2]|0)+36>>2]|0,aj|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}if((av|0)==-1){c[J>>2]=0;am=15;break}else{if(ah){an=aj;break}else{ao=ab;ar=ac;at=ad;au=af;am=274;break L4}}}}while(0);if((am|0)==15){am=0;if(ah){ao=ab;ar=ac;at=ad;au=af;am=274;break}else{an=0}}L26:do{switch(a[s+ag|0]|0){case 3:{aj=a[G]|0;av=aj&255;aw=(av&1|0)==0?av>>>1:c[Q>>2]|0;av=a[H]|0;ax=av&255;ay=(ax&1|0)==0?ax>>>1:c[N>>2]|0;if((aw|0)==(-ay|0)){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L26}ax=(aw|0)==0;aw=c[g>>2]|0;aF=c[aw+12>>2]|0;aG=c[aw+16>>2]|0;aH=(aF|0)==(aG|0);if(!(ax|(ay|0)==0)){if(aH){ay=(x=0,as(c[(c[aw>>2]|0)+36>>2]|0,aw|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}aI=c[g>>2]|0;aK=ay&255;aL=a[G]|0;aM=aI;aN=c[aI+12>>2]|0;aO=c[aI+16>>2]|0}else{aK=a[aF]|0;aL=aj;aM=aw;aN=aF;aO=aG}aG=aM+12|0;aI=(aN|0)==(aO|0);if(aK<<24>>24==(a[(aL&1)==0?P:c[R>>2]|0]|0)){if(aI){ay=c[(c[aM>>2]|0)+40>>2]|0;x=0,as(ay|0,aM|0)|0;if(x){x=0;ak=ac;al=ab;am=24;break L4}}else{c[aG>>2]=aN+1}aG=d[G]|0;az=((aG&1|0)==0?aG>>>1:c[Q>>2]|0)>>>0>1>>>0?z:af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L26}if(aI){aI=(x=0,as(c[(c[aM>>2]|0)+36>>2]|0,aM|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}aP=aI&255}else{aP=a[aN]|0}if(aP<<24>>24!=(a[(a[H]&1)==0?M:c[O>>2]|0]|0)){am=110;break L4}aI=c[g>>2]|0;aG=aI+12|0;ay=c[aG>>2]|0;if((ay|0)==(c[aI+16>>2]|0)){aR=c[(c[aI>>2]|0)+40>>2]|0;x=0,as(aR|0,aI|0)|0;if(x){x=0;ak=ac;al=ab;am=24;break L4}}else{c[aG>>2]=ay+1}a[l]=1;ay=d[H]|0;az=((ay&1|0)==0?ay>>>1:c[N>>2]|0)>>>0>1>>>0?A:af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L26}if(ax){if(aH){ax=(x=0,as(c[(c[aw>>2]|0)+36>>2]|0,aw|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}aS=ax&255;aT=a[H]|0}else{aS=a[aF]|0;aT=av}if(aS<<24>>24!=(a[(aT&1)==0?M:c[O>>2]|0]|0)){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L26}av=c[g>>2]|0;ax=av+12|0;ay=c[ax>>2]|0;if((ay|0)==(c[av+16>>2]|0)){aG=c[(c[av>>2]|0)+40>>2]|0;x=0,as(aG|0,av|0)|0;if(x){x=0;ak=ac;al=ab;am=24;break L4}}else{c[ax>>2]=ay+1}a[l]=1;ay=d[H]|0;az=((ay&1|0)==0?ay>>>1:c[N>>2]|0)>>>0>1>>>0?A:af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L26}if(aH){aH=(x=0,as(c[(c[aw>>2]|0)+36>>2]|0,aw|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}aU=aH&255;aV=a[G]|0}else{aU=a[aF]|0;aV=aj}if(aU<<24>>24!=(a[(aV&1)==0?P:c[R>>2]|0]|0)){a[l]=1;az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L26}aj=c[g>>2]|0;aF=aj+12|0;aH=c[aF>>2]|0;if((aH|0)==(c[aj+16>>2]|0)){aw=c[(c[aj>>2]|0)+40>>2]|0;x=0,as(aw|0,aj|0)|0;if(x){x=0;ak=ac;al=ab;am=24;break L4}}else{c[aF>>2]=aH+1}aH=d[G]|0;az=((aH&1|0)==0?aH>>>1:c[Q>>2]|0)>>>0>1>>>0?z:af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break};case 1:{if((ag|0)==3){ao=ab;ar=ac;at=ad;au=af;am=274;break L4}aH=c[g>>2]|0;aF=c[aH+12>>2]|0;if((aF|0)==(c[aH+16>>2]|0)){aj=(x=0,as(c[(c[aH>>2]|0)+36>>2]|0,aH|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}aW=aj&255}else{aW=a[aF]|0}aF=aW<<24>>24;aj=(x=0,as(252,aF|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}if((aj|0)==0){am=42;break L4}if((b[(c[L>>2]|0)+(aF<<1)>>1]&8192)==0){am=42;break L4}aF=c[g>>2]|0;aj=aF+12|0;aH=c[aj>>2]|0;if((aH|0)==(c[aF+16>>2]|0)){aw=(x=0,as(c[(c[aF>>2]|0)+40>>2]|0,aF|0)|0);if(x){x=0;ak=ac;al=ab;am=24;break L4}aX=aw&255}else{c[aj>>2]=aH+1;aX=a[aH]|0}x=0;aq(572,B|0,aX|0);if(!x){am=43}else{x=0;ak=ac;al=ab;am=24;break L4}break};case 0:{am=43;break};case 2:{if(!((af|0)!=0|ag>>>0<2>>>0)){if((ag|0)==2){aY=(a[Z]|0)!=0}else{aY=0}if(!(S|aY)){az=0;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L26}}aH=a[F]|0;aj=c[V>>2]|0;aw=(aH&1)==0?T:aj;L101:do{if((ag|0)==0){aZ=aw;a_=aH;a$=aj}else{if((d[s+(ag-1)|0]|0)>>>0>=2>>>0){aZ=aw;a_=aH;a$=aj;break}aF=aH&255;L104:do{if((((aF&1|0)==0?aF>>>1:c[U>>2]|0)|0)==0){a0=aw;a1=aH;a2=aj}else{ay=aw;while(1){ax=a[ay]|0;av=(x=0,as(252,ax|0)|0);if(x){x=0;am=21;break L4}if((av|0)==0){break}if((b[(c[L>>2]|0)+(ax<<1)>>1]&8192)==0){break}ax=ay+1|0;av=a[F]|0;aG=c[V>>2]|0;aI=av&255;if((ax|0)==(((av&1)==0?T:aG)+((aI&1|0)==0?aI>>>1:c[U>>2]|0)|0)){a0=ax;a1=av;a2=aG;break L104}else{ay=ax}}a0=ay;a1=a[F]|0;a2=c[V>>2]|0}}while(0);aF=(a1&1)==0?T:a2;ax=a0-aF|0;aG=a[I]|0;av=aG&255;aI=(av&1|0)==0?av>>>1:c[X>>2]|0;if(ax>>>0>aI>>>0){aZ=aF;a_=a1;a$=a2;break}av=(aG&1)==0?W:c[Y>>2]|0;aG=av+aI|0;if((a0|0)==(aF|0)){aZ=a0;a_=a1;a$=a2;break}aR=av+(aI-ax)|0;ax=aF;while(1){if((a[aR]|0)!=(a[ax]|0)){aZ=aF;a_=a1;a$=a2;break L101}aI=aR+1|0;if((aI|0)==(aG|0)){aZ=a0;a_=a1;a$=a2;break}else{aR=aI;ax=ax+1|0}}}}while(0);aw=a_&255;L118:do{if((aZ|0)==(((a_&1)==0?T:a$)+((aw&1|0)==0?aw>>>1:c[U>>2]|0)|0)){a3=aZ}else{aj=an;aH=aZ;while(1){ax=c[g>>2]|0;do{if((ax|0)==0){a4=0}else{if((c[ax+12>>2]|0)!=(c[ax+16>>2]|0)){a4=ax;break}aR=(x=0,as(c[(c[ax>>2]|0)+36>>2]|0,ax|0)|0);if(x){x=0;am=22;break L4}if((aR|0)==-1){c[g>>2]=0;a4=0;break}else{a4=c[g>>2]|0;break}}}while(0);ax=(a4|0)==0;do{if((aj|0)==0){am=141}else{if((c[aj+12>>2]|0)!=(c[aj+16>>2]|0)){if(ax){a5=aj;break}else{a3=aH;break L118}}ay=(x=0,as(c[(c[aj>>2]|0)+36>>2]|0,aj|0)|0);if(x){x=0;am=22;break L4}if((ay|0)==-1){c[J>>2]=0;am=141;break}else{if(ax){a5=aj;break}else{a3=aH;break L118}}}}while(0);if((am|0)==141){am=0;if(ax){a3=aH;break L118}else{a5=0}}ay=c[g>>2]|0;aR=c[ay+12>>2]|0;if((aR|0)==(c[ay+16>>2]|0)){aG=(x=0,as(c[(c[ay>>2]|0)+36>>2]|0,ay|0)|0);if(x){x=0;am=22;break L4}a6=aG&255}else{a6=a[aR]|0}if(a6<<24>>24!=(a[aH]|0)){a3=aH;break L118}aR=c[g>>2]|0;aG=aR+12|0;ay=c[aG>>2]|0;if((ay|0)==(c[aR+16>>2]|0)){aF=c[(c[aR>>2]|0)+40>>2]|0;x=0,as(aF|0,aR|0)|0;if(x){x=0;am=22;break L4}}else{c[aG>>2]=ay+1}ay=aH+1|0;aG=a[F]|0;aR=aG&255;if((ay|0)==(((aG&1)==0?T:c[V>>2]|0)+((aR&1|0)==0?aR>>>1:c[U>>2]|0)|0)){a3=ay;break}else{aj=a5;aH=ay}}}}while(0);if(!S){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L26}aw=a[F]|0;aH=aw&255;if((a3|0)==(((aw&1)==0?T:c[V>>2]|0)+((aH&1|0)==0?aH>>>1:c[U>>2]|0)|0)){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa}else{am=154;break L4}break};case 4:{aH=0;aw=ae;aj=ad;ay=ac;aR=ab;aG=aa;L153:while(1){aF=c[g>>2]|0;do{if((aF|0)==0){a7=0}else{if((c[aF+12>>2]|0)!=(c[aF+16>>2]|0)){a7=aF;break}aI=(x=0,as(c[(c[aF>>2]|0)+36>>2]|0,aF|0)|0);if(x){x=0;a8=ay;a9=aR;am=19;break L4}if((aI|0)==-1){c[g>>2]=0;a7=0;break}else{a7=c[g>>2]|0;break}}}while(0);aF=(a7|0)==0;aI=c[J>>2]|0;do{if((aI|0)==0){am=167}else{if((c[aI+12>>2]|0)!=(c[aI+16>>2]|0)){if(aF){break}else{break L153}}av=(x=0,as(c[(c[aI>>2]|0)+36>>2]|0,aI|0)|0);if(x){x=0;a8=ay;a9=aR;am=19;break L4}if((av|0)==-1){c[J>>2]=0;am=167;break}else{if(aF){break}else{break L153}}}}while(0);if((am|0)==167){am=0;if(aF){break}}aI=c[g>>2]|0;av=c[aI+12>>2]|0;if((av|0)==(c[aI+16>>2]|0)){ba=(x=0,as(c[(c[aI>>2]|0)+36>>2]|0,aI|0)|0);if(x){x=0;a8=ay;a9=aR;am=19;break L4}bb=ba&255}else{bb=a[av]|0}av=bb<<24>>24;ba=(x=0,as(252,av|0)|0);if(x){x=0;a8=ay;a9=aR;am=19;break L4}do{if((ba|0)==0){am=187}else{if((b[(c[L>>2]|0)+(av<<1)>>1]&2048)==0){am=187;break}aI=c[o>>2]|0;if((aI|0)==(aG|0)){bc=(c[$>>2]|0)!=548;bd=c[h>>2]|0;bf=aG-bd|0;bg=bf>>>0<2147483647>>>0?bf<<1:-1;bh=JZ(bc?bd:0,bg)|0;if((bh|0)==0){x=0;aQ(4);if(x){x=0;a8=ay;a9=aR;am=19;break L4}}do{if(bc){c[h>>2]=bh;bi=bh}else{bd=c[h>>2]|0;c[h>>2]=bh;if((bd|0)==0){bi=bh;break}x=0;ap(c[$>>2]|0,bd|0);if(x){x=0;am=184;break L4}bi=c[h>>2]|0}}while(0);c[$>>2]=504;bh=bi+bf|0;c[o>>2]=bh;bj=(c[h>>2]|0)+bg|0;bk=bh}else{bj=aG;bk=aI}c[o>>2]=bk+1;a[bk]=bb;bl=aH+1|0;bm=aw;bn=aj;bo=ay;bp=aR;bq=bj}}while(0);if((am|0)==187){am=0;av=d[w]|0;if((((av&1|0)==0?av>>>1:c[_>>2]|0)|0)==0|(aH|0)==0){break}if(bb<<24>>24!=(a[u]|0)){break}if((aj|0)==(aw|0)){av=aj-ay|0;ba=av>>>0<2147483647>>>0?av<<1:-1;aF=av>>2;if((aR|0)==548){br=0}else{br=ay}av=JZ(br,ba)|0;bh=av;if((av|0)==0){x=0;aQ(4);if(x){x=0;a8=ay;a9=aR;am=19;break L4}}bs=bh+(ba>>>2<<2)|0;bt=bh+(aF<<2)|0;bu=bh;bv=504}else{bs=aw;bt=aj;bu=ay;bv=aR}c[bt>>2]=aH;bl=0;bm=bs;bn=bt+4|0;bo=bu;bp=bv;bq=aG}bh=c[g>>2]|0;aF=bh+12|0;ba=c[aF>>2]|0;if((ba|0)==(c[bh+16>>2]|0)){av=c[(c[bh>>2]|0)+40>>2]|0;x=0,as(av|0,bh|0)|0;if(!x){aH=bl;aw=bm;aj=bn;ay=bo;aR=bp;aG=bq;continue}else{x=0;a8=bo;a9=bp;am=19;break L4}}else{c[aF>>2]=ba+1;aH=bl;aw=bm;aj=bn;ay=bo;aR=bp;aG=bq;continue}}if((ay|0)==(aj|0)|(aH|0)==0){bw=aw;bx=aj;by=ay;bz=aR}else{if((aj|0)==(aw|0)){ba=aj-ay|0;aF=ba>>>0<2147483647>>>0?ba<<1:-1;bh=ba>>2;if((aR|0)==548){bA=0}else{bA=ay}ba=JZ(bA,aF)|0;av=ba;if((ba|0)==0){x=0;aQ(4);if(x){x=0;ak=ay;al=aR;am=24;break L4}}bB=av+(aF>>>2<<2)|0;bC=av+(bh<<2)|0;bD=av;bE=504}else{bB=aw;bC=aj;bD=ay;bE=aR}c[bC>>2]=aH;bw=bB;bx=bC+4|0;by=bD;bz=bE}if((c[C>>2]|0)>0){av=c[g>>2]|0;do{if((av|0)==0){bF=0}else{if((c[av+12>>2]|0)!=(c[av+16>>2]|0)){bF=av;break}bh=(x=0,as(c[(c[av>>2]|0)+36>>2]|0,av|0)|0);if(x){x=0;ak=by;al=bz;am=24;break L4}if((bh|0)==-1){c[g>>2]=0;bF=0;break}else{bF=c[g>>2]|0;break}}}while(0);av=(bF|0)==0;aH=c[J>>2]|0;do{if((aH|0)==0){am=220}else{if((c[aH+12>>2]|0)!=(c[aH+16>>2]|0)){if(av){bG=aH;break}else{am=227;break L4}}aR=(x=0,as(c[(c[aH>>2]|0)+36>>2]|0,aH|0)|0);if(x){x=0;ak=by;al=bz;am=24;break L4}if((aR|0)==-1){c[J>>2]=0;am=220;break}else{if(av){bG=aH;break}else{am=227;break L4}}}}while(0);if((am|0)==220){am=0;if(av){am=227;break L4}else{bG=0}}aH=c[g>>2]|0;aR=c[aH+12>>2]|0;if((aR|0)==(c[aH+16>>2]|0)){ay=(x=0,as(c[(c[aH>>2]|0)+36>>2]|0,aH|0)|0);if(x){x=0;ak=by;al=bz;am=24;break L4}bH=ay&255}else{bH=a[aR]|0}if(bH<<24>>24!=(a[t]|0)){am=227;break L4}aR=c[g>>2]|0;ay=aR+12|0;aH=c[ay>>2]|0;if((aH|0)==(c[aR+16>>2]|0)){aj=c[(c[aR>>2]|0)+40>>2]|0;x=0,as(aj|0,aR|0)|0;if(!x){bI=aG;bJ=bG}else{x=0;ak=by;al=bz;am=24;break L4}}else{c[ay>>2]=aH+1;bI=aG;bJ=bG}while(1){aH=c[g>>2]|0;do{if((aH|0)==0){bK=0}else{if((c[aH+12>>2]|0)!=(c[aH+16>>2]|0)){bK=aH;break}ay=(x=0,as(c[(c[aH>>2]|0)+36>>2]|0,aH|0)|0);if(x){x=0;am=20;break L4}if((ay|0)==-1){c[g>>2]=0;bK=0;break}else{bK=c[g>>2]|0;break}}}while(0);aH=(bK|0)==0;do{if((bJ|0)==0){am=243}else{if((c[bJ+12>>2]|0)!=(c[bJ+16>>2]|0)){if(aH){bL=bJ;break}else{am=252;break L4}}ay=(x=0,as(c[(c[bJ>>2]|0)+36>>2]|0,bJ|0)|0);if(x){x=0;am=20;break L4}if((ay|0)==-1){c[J>>2]=0;am=243;break}else{if(aH){bL=bJ;break}else{am=252;break L4}}}}while(0);if((am|0)==243){am=0;if(aH){am=252;break L4}else{bL=0}}ay=c[g>>2]|0;aR=c[ay+12>>2]|0;if((aR|0)==(c[ay+16>>2]|0)){aj=(x=0,as(c[(c[ay>>2]|0)+36>>2]|0,ay|0)|0);if(x){x=0;am=20;break L4}bM=aj&255}else{bM=a[aR]|0}aR=bM<<24>>24;aj=(x=0,as(252,aR|0)|0);if(x){x=0;am=20;break L4}if((aj|0)==0){am=252;break L4}if((b[(c[L>>2]|0)+(aR<<1)>>1]&2048)==0){am=252;break L4}aR=c[o>>2]|0;if((aR|0)==(bI|0)){aj=(c[$>>2]|0)!=548;ay=c[h>>2]|0;aw=bI-ay|0;bh=aw>>>0<2147483647>>>0?aw<<1:-1;aF=JZ(aj?ay:0,bh)|0;if((aF|0)==0){x=0;aQ(4);if(x){x=0;am=20;break L4}}do{if(aj){c[h>>2]=aF;bN=aF}else{ay=c[h>>2]|0;c[h>>2]=aF;if((ay|0)==0){bN=aF;break}x=0;ap(c[$>>2]|0,ay|0);if(x){x=0;am=261;break L4}bN=c[h>>2]|0}}while(0);c[$>>2]=504;aF=bN+aw|0;c[o>>2]=aF;bO=(c[h>>2]|0)+bh|0;bP=aF}else{bO=bI;bP=aR}aF=c[g>>2]|0;aj=c[aF+12>>2]|0;if((aj|0)==(c[aF+16>>2]|0)){aH=(x=0,as(c[(c[aF>>2]|0)+36>>2]|0,aF|0)|0);if(x){x=0;am=20;break L4}bR=aH&255;bS=c[o>>2]|0}else{bR=a[aj]|0;bS=bP}c[o>>2]=bS+1;a[bS]=bR;aj=(c[C>>2]|0)-1|0;c[C>>2]=aj;aH=c[g>>2]|0;aF=aH+12|0;ay=c[aF>>2]|0;if((ay|0)==(c[aH+16>>2]|0)){ba=c[(c[aH>>2]|0)+40>>2]|0;x=0,as(ba|0,aH|0)|0;if(x){x=0;am=20;break L4}}else{c[aF>>2]=ay+1}if((aj|0)>0){bI=bO;bJ=bL}else{bT=bO;break}}}else{bT=aG}if((c[o>>2]|0)==(c[h>>2]|0)){am=272;break L4}else{az=af;aA=bw;aB=bx;aC=by;aD=bz;aE=bT}break};default:{az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa}}}while(0);L309:do{if((am|0)==43){am=0;if((ag|0)==3){ao=ab;ar=ac;at=ad;au=af;am=274;break L4}else{bV=an}while(1){ah=c[g>>2]|0;do{if((ah|0)==0){bW=0}else{if((c[ah+12>>2]|0)!=(c[ah+16>>2]|0)){bW=ah;break}av=(x=0,as(c[(c[ah>>2]|0)+36>>2]|0,ah|0)|0);if(x){x=0;am=23;break L4}if((av|0)==-1){c[g>>2]=0;bW=0;break}else{bW=c[g>>2]|0;break}}}while(0);ah=(bW|0)==0;do{if((bV|0)==0){am=56}else{if((c[bV+12>>2]|0)!=(c[bV+16>>2]|0)){if(ah){bX=bV;break}else{az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L309}}aR=(x=0,as(c[(c[bV>>2]|0)+36>>2]|0,bV|0)|0);if(x){x=0;am=23;break L4}if((aR|0)==-1){c[J>>2]=0;am=56;break}else{if(ah){bX=bV;break}else{az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L309}}}}while(0);if((am|0)==56){am=0;if(ah){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L309}else{bX=0}}aR=c[g>>2]|0;bh=c[aR+12>>2]|0;if((bh|0)==(c[aR+16>>2]|0)){aw=(x=0,as(c[(c[aR>>2]|0)+36>>2]|0,aR|0)|0);if(x){x=0;am=23;break L4}bY=aw&255}else{bY=a[bh]|0}bh=bY<<24>>24;aw=(x=0,as(252,bh|0)|0);if(x){x=0;am=23;break L4}if((aw|0)==0){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L309}if((b[(c[L>>2]|0)+(bh<<1)>>1]&8192)==0){az=af;aA=ae;aB=ad;aC=ac;aD=ab;aE=aa;break L309}bh=c[g>>2]|0;aw=bh+12|0;aR=c[aw>>2]|0;if((aR|0)==(c[bh+16>>2]|0)){av=(x=0,as(c[(c[bh>>2]|0)+40>>2]|0,bh|0)|0);if(x){x=0;am=23;break L4}bZ=av&255}else{c[aw>>2]=aR+1;bZ=a[aR]|0}x=0;aq(572,B|0,bZ|0);if(!x){bV=bX}else{x=0;am=23;break L4}}}}while(0);aG=ag+1|0;if(aG>>>0<4>>>0){aa=aE;ab=aD;ac=aC;ad=aB;ae=aA;af=az;ag=aG}else{ao=aD;ar=aC;at=aB;au=az;am=274;break}}L347:do{if((am|0)==19){ag=bQ(-1,-1)|0;b_=K;b$=ag;b0=a8;b1=a9;break L1}else if((am|0)==20){ag=bQ(-1,-1)|0;b_=K;b$=ag;b0=by;b1=bz;break L1}else if((am|0)==21){ag=bQ(-1,-1)|0;b_=K;b$=ag;b0=ac;b1=ab;break L1}else if((am|0)==22){ag=bQ(-1,-1)|0;b_=K;b$=ag;b0=ac;b1=ab;break L1}else if((am|0)==23){ag=bQ(-1,-1)|0;b_=K;b$=ag;b0=ac;b1=ab;break L1}else if((am|0)==24){ag=bQ(-1,-1)|0;b_=K;b$=ag;b0=ak;b1=al;break L1}else if((am|0)==42){c[k>>2]=c[k>>2]|4;b2=0;b3=ac;b4=ab}else if((am|0)==110){c[k>>2]=c[k>>2]|4;b2=0;b3=ac;b4=ab}else if((am|0)==154){c[k>>2]=c[k>>2]|4;b2=0;b3=ac;b4=ab}else if((am|0)==184){bQ(-1,-1,0)|0;bU();return 0}else if((am|0)==227){c[k>>2]=c[k>>2]|4;b2=0;b3=by;b4=bz}else if((am|0)==252){c[k>>2]=c[k>>2]|4;b2=0;b3=by;b4=bz}else if((am|0)==261){bQ(-1,-1,0)|0;bU();return 0}else if((am|0)==272){c[k>>2]=c[k>>2]|4;b2=0;b3=by;b4=bz}else if((am|0)==274){L363:do{if((au|0)!=0){ag=au;af=au+1|0;ae=au+8|0;ad=au+4|0;aa=1;L365:while(1){L=d[ag]|0;if((L&1|0)==0){b5=L>>>1}else{b5=c[ad>>2]|0}if(aa>>>0>=b5>>>0){break L363}L=c[g>>2]|0;do{if((L|0)==0){b6=0}else{if((c[L+12>>2]|0)!=(c[L+16>>2]|0)){b6=L;break}h=(x=0,as(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(x){x=0;am=18;break L365}if((h|0)==-1){c[g>>2]=0;b6=0;break}else{b6=c[g>>2]|0;break}}}while(0);L=(b6|0)==0;ah=c[J>>2]|0;do{if((ah|0)==0){am=292}else{if((c[ah+12>>2]|0)!=(c[ah+16>>2]|0)){if(L){break}else{am=301;break L365}}h=(x=0,as(c[(c[ah>>2]|0)+36>>2]|0,ah|0)|0);if(x){x=0;am=18;break L365}if((h|0)==-1){c[J>>2]=0;am=292;break}else{if(L){break}else{am=301;break L365}}}}while(0);if((am|0)==292){am=0;if(L){am=301;break}}ah=c[g>>2]|0;h=c[ah+12>>2]|0;if((h|0)==(c[ah+16>>2]|0)){$=(x=0,as(c[(c[ah>>2]|0)+36>>2]|0,ah|0)|0);if(x){x=0;am=18;break}b7=$&255}else{b7=a[h]|0}if((a[ag]&1)==0){b8=af}else{b8=c[ae>>2]|0}if(b7<<24>>24!=(a[b8+aa|0]|0)){am=301;break}h=aa+1|0;$=c[g>>2]|0;ah=$+12|0;_=c[ah>>2]|0;if((_|0)==(c[$+16>>2]|0)){U=c[(c[$>>2]|0)+40>>2]|0;x=0,as(U|0,$|0)|0;if(!x){aa=h;continue}else{x=0;am=18;break}}else{c[ah>>2]=_+1;aa=h;continue}}if((am|0)==18){aa=bQ(-1,-1)|0;b_=K;b$=aa;b0=ar;b1=ao;break L1}else if((am|0)==301){c[k>>2]=c[k>>2]|4;b2=0;b3=ar;b4=ao;break L347}}}while(0);if((ar|0)==(at|0)){b2=1;b3=at;b4=ao;break}c[D>>2]=0;G_(v,ar,at,D);if((c[D>>2]|0)==0){b2=1;b3=ar;b4=ao;break}c[k>>2]=c[k>>2]|4;b2=0;b3=ar;b4=ao}}while(0);CP(B);CP(A);CP(z);CP(y);CP(v);if((b3|0)==0){i=q;return b2|0}x=0;ap(b4|0,b3|0);if(!x){i=q;return b2|0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{x=0;g=bQ(-1,-1)|0;b_=K;b$=g;b0=E;b1=548}}while(0);CP(B);CP(A);CP(z);CP(y);CP(v);if((b0|0)==0){be(b$|0)}x=0;ap(b1|0,b0|0);if(!x){be(b$|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function GW(a){a=a|0;var b=0;b=ci(8)|0;x=0;aq(454,b|0,a|0);if(!x){bH(b|0,28096,336)}else{x=0;a=bQ(-1,-1)|0;bl(b|0);be(a|0)}}function GX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+160|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+120|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=m|0;t=n|0;c[t>>2]=s;u=n+4|0;c[u>>2]=548;v=m+100|0;x=0;aq(346,p|0,h|0);do{if(!x){m=p|0;w=c[m>>2]|0;if((c[10070]|0)==-1){y=4}else{c[l>>2]=40280;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40280,l|0,512);if(!x){y=4}else{x=0}}L6:do{if((y|0)==4){z=(c[10071]|0)-1|0;A=c[w+8>>2]|0;do{if((c[w+12>>2]|0)-A>>2>>>0>z>>>0){B=c[A+(z<<2)>>2]|0;if((B|0)==0){break}C=B;a[q]=0;D=f|0;E=c[D>>2]|0;c[r>>2]=E;F=(x=0,av(4,e|0,r|0,g|0,p|0,c[h+4>>2]|0,j|0,q|0,C|0,n|0,o|0,v|0)|0);if(x){x=0;break L6}if(F){F=k;if((a[F]&1)==0){a[k+1|0]=0;a[F]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}F=B;if((a[q]&1)!=0){B=(x=0,aK(c[(c[F>>2]|0)+28>>2]|0,C|0,45)|0);if(x){x=0;break L6}x=0;aq(572,k|0,B|0);if(x){x=0;break L6}}B=(x=0,aK(c[(c[F>>2]|0)+28>>2]|0,C|0,48)|0);if(x){x=0;break L6}C=c[o>>2]|0;F=C-1|0;G=c[t>>2]|0;while(1){if(G>>>0>=F>>>0){break}if((a[G]|0)==B<<24>>24){G=G+1|0}else{break}}x=0,ax(66,k|0,G|0,C|0)|0;if(x){x=0;break L6}}B=e|0;F=c[B>>2]|0;do{if((F|0)==0){H=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){H=F;break}I=(x=0,as(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(x){x=0;break L6}if((I|0)!=-1){H=F;break}c[B>>2]=0;H=0}}while(0);B=(H|0)==0;do{if((E|0)==0){y=33}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(B){break}else{y=35;break}}F=(x=0,as(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(x){x=0;break L6}if((F|0)==-1){c[D>>2]=0;y=33;break}else{if(B^(E|0)==0){break}else{y=35;break}}}}while(0);if((y|0)==33){if(B){y=35}}if((y|0)==35){c[j>>2]=c[j>>2]|2}c[b>>2]=H;Cn(c[m>>2]|0)|0;E=c[t>>2]|0;c[t>>2]=0;if((E|0)==0){i=d;return}x=0;ap(c[u>>2]|0,E|0);if(!x){i=d;return}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);z=ci(4)|0;JB(z);x=0;aP(144,z|0,28080,98);if(x){x=0;break}}}while(0);w=bQ(-1,-1)|0;z=w;w=K;Cn(c[m>>2]|0)|0;A=c[t>>2]|0;c[t>>2]=0;if((A|0)==0){J=w;L=z}else{M=A;N=w;O=z;break}P=L;Q=0;R=P;S=J;be(R|0)}else{x=0;z=bQ(-1,-1)|0;c[t>>2]=0;M=s;N=K;O=z}}while(0);x=0;ap(c[u>>2]|0,M|0);if(!x){J=N;L=O;P=L;Q=0;R=P;S=J;be(R|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function GY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=b;g=d;h=a[f]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[b+4>>2]|0}if((h&1)==0){k=10;l=h}else{h=c[b>>2]|0;k=(h&-2)-1|0;l=h&255}h=e-g|0;if((e|0)==(d|0)){return b|0}if((k-j|0)>>>0<h>>>0){CY(b,k,j+h-k|0,j,j,0,0);m=a[f]|0}else{m=l}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;l=g+1|0;if((l|0)==(e|0)){break}else{g=l;d=d+1|0}}a[n+m|0]=0;m=j+h|0;if((a[f]&1)==0){a[f]=m<<1;return b|0}else{c[b+4>>2]=m;return b|0}return 0}function GZ(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+56|0;o=n|0;p=n+16|0;q=n+32|0;r=n+40|0;s=r;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;y=i;i=i+12|0;i=i+7&-8;z=y;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;D=B;E=i;i=i+12|0;i=i+7&-8;F=E;G=i;i=i+12|0;i=i+7&-8;H=G;I=i;i=i+12|0;i=i+7&-8;J=I;if(b){b=c[d>>2]|0;if((c[10188]|0)!=-1){c[p>>2]=40752;c[p+4>>2]=454;c[p+8>>2]=0;CI(40752,p,512)}p=(c[10189]|0)-1|0;K=c[b+8>>2]|0;if((c[b+12>>2]|0)-K>>2>>>0<=p>>>0){L=ci(4)|0;M=L;JB(M);bH(L|0,28080,98)}b=c[K+(p<<2)>>2]|0;if((b|0)==0){L=ci(4)|0;M=L;JB(M);bH(L|0,28080,98)}L=b;cy[c[(c[b>>2]|0)+44>>2]&1023](q,L);M=e;C=c[q>>2]|0;a[M]=C;C=C>>8;a[M+1|0]=C;C=C>>8;a[M+2|0]=C;C=C>>8;a[M+3|0]=C;M=b;cy[c[(c[M>>2]|0)+32>>2]&1023](r,L);q=l;if((a[q]&1)==0){a[l+1|0]=0;a[q]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}x=0;aq(602,l|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];Ke(s|0,0,12)|0;CP(r);cy[c[(c[M>>2]|0)+28>>2]&1023](t,L);r=k;if((a[r]&1)==0){a[k+1|0]=0;a[r]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}x=0;aq(602,k|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[r>>2]=c[u>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];Ke(u|0,0,12)|0;CP(t);t=b;a[f]=cA[c[(c[t>>2]|0)+12>>2]&511](L)|0;a[g]=cA[c[(c[t>>2]|0)+16>>2]&511](L)|0;cy[c[(c[M>>2]|0)+20>>2]&1023](v,L);t=h;if((a[t]&1)==0){a[h+1|0]=0;a[t]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}x=0;aq(602,h|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[t>>2]=c[w>>2];c[t+4>>2]=c[w+4>>2];c[t+8>>2]=c[w+8>>2];Ke(w|0,0,12)|0;CP(v);cy[c[(c[M>>2]|0)+24>>2]&1023](y,L);M=j;if((a[M]&1)==0){a[j+1|0]=0;a[M]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}x=0;aq(602,j|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[M>>2]=c[z>>2];c[M+4>>2]=c[z+4>>2];c[M+8>>2]=c[z+8>>2];Ke(z|0,0,12)|0;CP(y);N=cA[c[(c[b>>2]|0)+36>>2]&511](L)|0;c[m>>2]=N;i=n;return}else{L=c[d>>2]|0;if((c[10190]|0)!=-1){c[o>>2]=40760;c[o+4>>2]=454;c[o+8>>2]=0;CI(40760,o,512)}o=(c[10191]|0)-1|0;d=c[L+8>>2]|0;if((c[L+12>>2]|0)-d>>2>>>0<=o>>>0){O=ci(4)|0;P=O;JB(P);bH(O|0,28080,98)}L=c[d+(o<<2)>>2]|0;if((L|0)==0){O=ci(4)|0;P=O;JB(P);bH(O|0,28080,98)}O=L;cy[c[(c[L>>2]|0)+44>>2]&1023](A,O);P=e;C=c[A>>2]|0;a[P]=C;C=C>>8;a[P+1|0]=C;C=C>>8;a[P+2|0]=C;C=C>>8;a[P+3|0]=C;P=L;cy[c[(c[P>>2]|0)+32>>2]&1023](B,O);A=l;if((a[A]&1)==0){a[l+1|0]=0;a[A]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}x=0;aq(602,l|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[A>>2]=c[D>>2];c[A+4>>2]=c[D+4>>2];c[A+8>>2]=c[D+8>>2];Ke(D|0,0,12)|0;CP(B);cy[c[(c[P>>2]|0)+28>>2]&1023](E,O);B=k;if((a[B]&1)==0){a[k+1|0]=0;a[B]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}x=0;aq(602,k|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[B>>2]=c[F>>2];c[B+4>>2]=c[F+4>>2];c[B+8>>2]=c[F+8>>2];Ke(F|0,0,12)|0;CP(E);E=L;a[f]=cA[c[(c[E>>2]|0)+12>>2]&511](O)|0;a[g]=cA[c[(c[E>>2]|0)+16>>2]&511](O)|0;cy[c[(c[P>>2]|0)+20>>2]&1023](G,O);E=h;if((a[E]&1)==0){a[h+1|0]=0;a[E]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}x=0;aq(602,h|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[E>>2]=c[H>>2];c[E+4>>2]=c[H+4>>2];c[E+8>>2]=c[H+8>>2];Ke(H|0,0,12)|0;CP(G);cy[c[(c[P>>2]|0)+24>>2]&1023](I,O);P=j;if((a[P]&1)==0){a[j+1|0]=0;a[P]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}x=0;aq(602,j|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[P>>2]=c[J>>2];c[P+4>>2]=c[J+4>>2];c[P+8>>2]=c[J+8>>2];Ke(J|0,0,12)|0;CP(I);N=cA[c[(c[L>>2]|0)+36>>2]&511](O)|0;c[m>>2]=N;i=n;return}}function G_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=b;h=b;i=a[h]|0;j=i&255;if((j&1|0)==0){k=j>>>1}else{k=c[b+4>>2]|0}if((k|0)==0){return}do{if((d|0)==(e|0)){l=i}else{k=e-4|0;if(k>>>0>d>>>0){m=d;n=k}else{l=i;break}do{k=c[m>>2]|0;c[m>>2]=c[n>>2];c[n>>2]=k;m=m+4|0;n=n-4|0;}while(m>>>0<n>>>0);l=a[h]|0}}while(0);if((l&1)==0){o=g+1|0}else{o=c[b+8>>2]|0}g=l&255;if((g&1|0)==0){p=g>>>1}else{p=c[b+4>>2]|0}b=e-4|0;e=a[o]|0;g=e<<24>>24;l=e<<24>>24<1|e<<24>>24==127;L22:do{if(b>>>0>d>>>0){e=o+p|0;h=o;n=d;m=g;i=l;while(1){if(!i){if((m|0)!=(c[n>>2]|0)){break}}k=(e-h|0)>1?h+1|0:h;j=n+4|0;q=a[k]|0;r=q<<24>>24;s=q<<24>>24<1|q<<24>>24==127;if(j>>>0<b>>>0){h=k;n=j;m=r;i=s}else{t=r;u=s;break L22}}c[f>>2]=4;return}else{t=g;u=l}}while(0);if(u){return}u=c[b>>2]|0;if(!(t>>>0<u>>>0|(u|0)==0)){return}c[f>>2]=4;return}function G$(a){a=a|0;Cl(a|0);J2(a);return}function G0(a){a=a|0;Cl(a|0);return}function G1(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;d=i;i=i+600|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+416|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=d+496|0;u=m|0;v=n|0;c[v>>2]=u;w=n+4|0;c[w>>2]=548;y=m+400|0;x=0;aq(346,p|0,h|0);do{if(!x){m=p|0;z=c[m>>2]|0;if((c[10068]|0)==-1){A=4}else{c[l>>2]=40272;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40272,l|0,512);if(!x){A=4}else{x=0;A=15}}L5:do{if((A|0)==4){B=(c[10069]|0)-1|0;C=c[z+8>>2]|0;do{if((c[z+12>>2]|0)-C>>2>>>0>B>>>0){D=c[C+(B<<2)>>2]|0;if((D|0)==0){break}E=D;a[q]=0;F=f|0;c[r>>2]=c[F>>2];G=(x=0,av(2,e|0,r|0,g|0,p|0,c[h+4>>2]|0,j|0,q|0,E|0,n|0,o|0,y|0)|0);if(x){x=0;A=15;break L5}L11:do{if(G){H=s|0;I=c[(c[D>>2]|0)+48>>2]|0;x=0,aS(I|0,E|0,12568,12578,H|0)|0;if(x){x=0;A=15;break L5}I=t|0;J=c[o>>2]|0;L=c[v>>2]|0;M=J-L|0;do{if((M|0)>392){N=JW((M>>2)+2|0)|0;if((N|0)!=0){O=N;P=N;A=19;break}x=0;aQ(4);if(!x){O=0;P=0;A=19}else{x=0;Q=0;A=16}}else{O=I;P=0;A=19}}while(0);do{if((A|0)==19){if((a[q]&1)==0){R=O}else{a[O]=45;R=O+1|0}if(L>>>0<J>>>0){M=s+40|0;N=s;S=R;T=L;while(1){U=H;while(1){if((U|0)==(M|0)){V=M;break}if((c[U>>2]|0)==(c[T>>2]|0)){V=U;break}else{U=U+4|0}}a[S]=a[12568+(V-N>>2)|0]|0;U=T+4|0;W=S+1|0;if(U>>>0<(c[o>>2]|0)>>>0){S=W;T=U}else{X=W;break}}}else{X=R}a[X]=0;T=b5(I|0,10544,(S=i,i=i+8|0,c[S>>2]=k,S)|0)|0;i=S;if((T|0)==1){if((P|0)==0){break L11}JX(P);break L11}T=ci(8)|0;x=0;aq(454,T|0,10248);if(x){x=0;S=bQ(-1,-1)|0;N=K;bl(T|0);Y=N;Z=S;_=P;break}x=0;aP(144,T|0,28096,336);if(x){x=0;Q=P;A=16;break}}}while(0);if((A|0)==16){I=bQ(-1,-1)|0;Y=K;Z=I;_=Q}I=Z;H=Y;if((_|0)==0){$=H;aa=I;break L5}JX(_);$=H;aa=I;break L5}}while(0);E=e|0;D=c[E>>2]|0;do{if((D|0)==0){ab=0}else{G=c[D+12>>2]|0;if((G|0)==(c[D+16>>2]|0)){I=(x=0,as(c[(c[D>>2]|0)+36>>2]|0,D|0)|0);if(!x){ac=I}else{x=0;A=15;break L5}}else{ac=c[G>>2]|0}if((ac|0)!=-1){ab=D;break}c[E>>2]=0;ab=0}}while(0);E=(ab|0)==0;D=c[F>>2]|0;do{if((D|0)==0){A=46}else{G=c[D+12>>2]|0;if((G|0)==(c[D+16>>2]|0)){I=(x=0,as(c[(c[D>>2]|0)+36>>2]|0,D|0)|0);if(!x){ad=I}else{x=0;A=15;break L5}}else{ad=c[G>>2]|0}if((ad|0)==-1){c[F>>2]=0;A=46;break}else{if(E^(D|0)==0){break}else{A=48;break}}}}while(0);if((A|0)==46){if(E){A=48}}if((A|0)==48){c[j>>2]=c[j>>2]|2}c[b>>2]=ab;Cn(c[m>>2]|0)|0;D=c[v>>2]|0;c[v>>2]=0;if((D|0)==0){i=d;return}x=0;ap(c[w>>2]|0,D|0);if(!x){i=d;return}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);B=ci(4)|0;JB(B);x=0;aP(144,B|0,28080,98);if(x){x=0;A=15;break}}}while(0);if((A|0)==15){z=bQ(-1,-1)|0;$=K;aa=z}Cn(c[m>>2]|0)|0;z=c[v>>2]|0;c[v>>2]=0;if((z|0)==0){ae=aa;af=$}else{ag=z;ah=aa;ai=$;break}aj=ae;ak=0;al=aj;am=af;be(al|0)}else{x=0;z=bQ(-1,-1)|0;c[v>>2]=0;ag=u;ah=z;ai=K}}while(0);x=0;ap(c[w>>2]|0,ag|0);if(!x){ae=ah;af=ai;aj=ae;ak=0;al=aj;am=af;be(al|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function G2(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aK=0,aL=0,aM=0,aN=0,aO=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0;p=i;i=i+448|0;q=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[q>>2];q=p|0;r=p+8|0;s=p+408|0;t=p+416|0;u=p+424|0;v=p+432|0;w=v;y=i;i=i+12|0;i=i+7&-8;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;c[q>>2]=o;o=r|0;Ke(w|0,0,12)|0;E=y;F=z;G=A;H=B;Ke(E|0,0,12)|0;Ke(F|0,0,12)|0;Ke(G|0,0,12)|0;Ke(H|0,0,12)|0;x=0;aJ(6,f|0,g|0,s|0,t|0,u|0,v|0,y|0,z|0,A|0,C|0);L1:do{if(!x){g=m|0;c[n>>2]=c[g>>2];f=b|0;I=e|0;J=l;L=A+4|0;M=A+8|0;N=z+4|0;O=z+8|0;P=(h&512|0)!=0;Q=y+4|0;R=y+8|0;S=B+4|0;T=B+8|0;U=s+3|0;V=v+4|0;W=548;X=o;Y=o;Z=r+400|0;_=0;$=0;L4:while(1){aa=c[f>>2]|0;do{if((aa|0)==0){ab=1}else{ac=c[aa+12>>2]|0;if((ac|0)==(c[aa+16>>2]|0)){ad=(x=0,as(c[(c[aa>>2]|0)+36>>2]|0,aa|0)|0);if(!x){ae=ad}else{x=0;af=X;ag=W;ah=25;break L4}}else{ae=c[ac>>2]|0}if((ae|0)==-1){c[f>>2]=0;ab=1;break}else{ab=(c[f>>2]|0)==0;break}}}while(0);aa=c[I>>2]|0;do{if((aa|0)==0){ah=16}else{ac=c[aa+12>>2]|0;if((ac|0)==(c[aa+16>>2]|0)){ad=(x=0,as(c[(c[aa>>2]|0)+36>>2]|0,aa|0)|0);if(!x){ai=ad}else{x=0;af=X;ag=W;ah=25;break L4}}else{ai=c[ac>>2]|0}if((ai|0)==-1){c[I>>2]=0;ah=16;break}else{if(ab^(aa|0)==0){aj=aa;break}else{ak=W;al=X;am=Y;an=_;ah=256;break L4}}}}while(0);if((ah|0)==16){ah=0;if(ab){ak=W;al=X;am=Y;an=_;ah=256;break}else{aj=0}}L28:do{switch(a[s+$|0]|0){case 3:{aa=a[F]|0;ac=aa&255;ad=(ac&1|0)==0;ao=a[G]|0;ar=ao&255;at=(ar&1|0)==0;if(((ad?ac>>>1:c[N>>2]|0)|0)==(-(at?ar>>>1:c[L>>2]|0)|0)){au=_;av=Z;aw=Y;ay=X;az=W;break L28}do{if(((ad?ac>>>1:c[N>>2]|0)|0)!=0){if(((at?ar>>>1:c[L>>2]|0)|0)==0){break}aA=c[f>>2]|0;aB=c[aA+12>>2]|0;if((aB|0)==(c[aA+16>>2]|0)){aC=(x=0,as(c[(c[aA>>2]|0)+36>>2]|0,aA|0)|0);if(x){x=0;af=X;ag=W;ah=25;break L4}aD=aC;aE=a[F]|0}else{aD=c[aB>>2]|0;aE=aa}aB=c[f>>2]|0;aC=aB+12|0;aA=c[aC>>2]|0;aF=(aA|0)==(c[aB+16>>2]|0);if((aD|0)==(c[((aE&1)==0?N:c[O>>2]|0)>>2]|0)){if(aF){aG=c[(c[aB>>2]|0)+40>>2]|0;x=0,as(aG|0,aB|0)|0;if(x){x=0;af=X;ag=W;ah=25;break L4}}else{c[aC>>2]=aA+4}aC=d[F]|0;au=((aC&1|0)==0?aC>>>1:c[N>>2]|0)>>>0>1>>>0?z:_;av=Z;aw=Y;ay=X;az=W;break L28}if(aF){aF=(x=0,as(c[(c[aB>>2]|0)+36>>2]|0,aB|0)|0);if(!x){aH=aF}else{x=0;af=X;ag=W;ah=25;break L4}}else{aH=c[aA>>2]|0}if((aH|0)!=(c[((a[G]&1)==0?L:c[M>>2]|0)>>2]|0)){ah=106;break L4}aA=c[f>>2]|0;aF=aA+12|0;aB=c[aF>>2]|0;if((aB|0)==(c[aA+16>>2]|0)){aC=c[(c[aA>>2]|0)+40>>2]|0;x=0,as(aC|0,aA|0)|0;if(x){x=0;af=X;ag=W;ah=25;break L4}}else{c[aF>>2]=aB+4}a[k]=1;aB=d[G]|0;au=((aB&1|0)==0?aB>>>1:c[L>>2]|0)>>>0>1>>>0?A:_;av=Z;aw=Y;ay=X;az=W;break L28}}while(0);ar=c[f>>2]|0;at=c[ar+12>>2]|0;aB=(at|0)==(c[ar+16>>2]|0);if(((ad?ac>>>1:c[N>>2]|0)|0)==0){if(aB){aF=(x=0,as(c[(c[ar>>2]|0)+36>>2]|0,ar|0)|0);if(x){x=0;af=X;ag=W;ah=25;break L4}aI=aF;aK=a[G]|0}else{aI=c[at>>2]|0;aK=ao}if((aI|0)!=(c[((aK&1)==0?L:c[M>>2]|0)>>2]|0)){au=_;av=Z;aw=Y;ay=X;az=W;break L28}aF=c[f>>2]|0;aA=aF+12|0;aC=c[aA>>2]|0;if((aC|0)==(c[aF+16>>2]|0)){aG=c[(c[aF>>2]|0)+40>>2]|0;x=0,as(aG|0,aF|0)|0;if(x){x=0;af=X;ag=W;ah=25;break L4}}else{c[aA>>2]=aC+4}a[k]=1;aC=d[G]|0;au=((aC&1|0)==0?aC>>>1:c[L>>2]|0)>>>0>1>>>0?A:_;av=Z;aw=Y;ay=X;az=W;break L28}if(aB){aB=(x=0,as(c[(c[ar>>2]|0)+36>>2]|0,ar|0)|0);if(x){x=0;af=X;ag=W;ah=25;break L4}aL=aB;aM=a[F]|0}else{aL=c[at>>2]|0;aM=aa}if((aL|0)!=(c[((aM&1)==0?N:c[O>>2]|0)>>2]|0)){a[k]=1;au=_;av=Z;aw=Y;ay=X;az=W;break L28}at=c[f>>2]|0;aB=at+12|0;ar=c[aB>>2]|0;if((ar|0)==(c[at+16>>2]|0)){aC=c[(c[at>>2]|0)+40>>2]|0;x=0,as(aC|0,at|0)|0;if(x){x=0;af=X;ag=W;ah=25;break L4}}else{c[aB>>2]=ar+4}ar=d[F]|0;au=((ar&1|0)==0?ar>>>1:c[N>>2]|0)>>>0>1>>>0?z:_;av=Z;aw=Y;ay=X;az=W;break};case 4:{ar=0;aB=Z;at=Y;aC=X;aA=W;L81:while(1){aF=c[f>>2]|0;do{if((aF|0)==0){aN=1}else{aG=c[aF+12>>2]|0;if((aG|0)==(c[aF+16>>2]|0)){aO=(x=0,as(c[(c[aF>>2]|0)+36>>2]|0,aF|0)|0);if(!x){aR=aO}else{x=0;aS=aC;aT=aA;ah=20;break L4}}else{aR=c[aG>>2]|0}if((aR|0)==-1){c[f>>2]=0;aN=1;break}else{aN=(c[f>>2]|0)==0;break}}}while(0);aF=c[I>>2]|0;do{if((aF|0)==0){ah=164}else{aG=c[aF+12>>2]|0;if((aG|0)==(c[aF+16>>2]|0)){aO=(x=0,as(c[(c[aF>>2]|0)+36>>2]|0,aF|0)|0);if(!x){aU=aO}else{x=0;aS=aC;aT=aA;ah=20;break L4}}else{aU=c[aG>>2]|0}if((aU|0)==-1){c[I>>2]=0;ah=164;break}else{if(aN^(aF|0)==0){break}else{break L81}}}}while(0);if((ah|0)==164){ah=0;if(aN){break}}aF=c[f>>2]|0;aG=c[aF+12>>2]|0;if((aG|0)==(c[aF+16>>2]|0)){aO=(x=0,as(c[(c[aF>>2]|0)+36>>2]|0,aF|0)|0);if(!x){aV=aO}else{x=0;aS=aC;aT=aA;ah=20;break L4}}else{aV=c[aG>>2]|0}aG=(x=0,ax(c[(c[J>>2]|0)+12>>2]|0,l|0,2048,aV|0)|0);if(x){x=0;aS=aC;aT=aA;ah=20;break L4}if(aG){aG=c[n>>2]|0;if((aG|0)==(c[q>>2]|0)){x=0;aP(90,m|0,n|0,q|0);if(x){x=0;aS=aC;aT=aA;ah=20;break L4}aW=c[n>>2]|0}else{aW=aG}c[n>>2]=aW+4;c[aW>>2]=aV;aX=ar+1|0;aY=aB;aZ=at;a_=aC;a$=aA}else{aG=d[w]|0;if((((aG&1|0)==0?aG>>>1:c[V>>2]|0)|0)==0|(ar|0)==0){break}if((aV|0)!=(c[u>>2]|0)){break}if((at|0)==(aB|0)){aG=(aA|0)!=548;aO=at-aC|0;aF=aO>>>0<2147483647>>>0?aO<<1:-1;a0=aO>>2;if(aG){a1=aC}else{a1=0}aG=JZ(a1,aF)|0;aO=aG;if((aG|0)==0){x=0;aQ(4);if(x){x=0;aS=aC;aT=aA;ah=20;break L4}}a2=aO+(aF>>>2<<2)|0;a3=aO+(a0<<2)|0;a4=aO;a5=504}else{a2=aB;a3=at;a4=aC;a5=aA}c[a3>>2]=ar;aX=0;aY=a2;aZ=a3+4|0;a_=a4;a$=a5}aO=c[f>>2]|0;a0=aO+12|0;aF=c[a0>>2]|0;if((aF|0)==(c[aO+16>>2]|0)){aG=c[(c[aO>>2]|0)+40>>2]|0;x=0,as(aG|0,aO|0)|0;if(!x){ar=aX;aB=aY;at=aZ;aC=a_;aA=a$;continue}else{x=0;aS=a_;aT=a$;ah=20;break L4}}else{c[a0>>2]=aF+4;ar=aX;aB=aY;at=aZ;aC=a_;aA=a$;continue}}if((aC|0)==(at|0)|(ar|0)==0){a6=aB;a7=at;a8=aC;a9=aA}else{if((at|0)==(aB|0)){aa=(aA|0)!=548;ao=at-aC|0;ac=ao>>>0<2147483647>>>0?ao<<1:-1;ad=ao>>2;if(aa){ba=aC}else{ba=0}aa=JZ(ba,ac)|0;ao=aa;if((aa|0)==0){x=0;aQ(4);if(x){x=0;af=aC;ag=aA;ah=25;break L4}}bb=ao+(ac>>>2<<2)|0;bc=ao+(ad<<2)|0;bd=ao;bf=504}else{bb=aB;bc=at;bd=aC;bf=aA}c[bc>>2]=ar;a6=bb;a7=bc+4|0;a8=bd;a9=bf}ao=c[C>>2]|0;if((ao|0)>0){ad=c[f>>2]|0;do{if((ad|0)==0){bg=1}else{ac=c[ad+12>>2]|0;if((ac|0)==(c[ad+16>>2]|0)){aa=(x=0,as(c[(c[ad>>2]|0)+36>>2]|0,ad|0)|0);if(!x){bh=aa}else{x=0;af=a8;ag=a9;ah=25;break L4}}else{bh=c[ac>>2]|0}if((bh|0)==-1){c[f>>2]=0;bg=1;break}else{bg=(c[f>>2]|0)==0;break}}}while(0);ad=c[I>>2]|0;do{if((ad|0)==0){ah=213}else{ar=c[ad+12>>2]|0;if((ar|0)==(c[ad+16>>2]|0)){aA=(x=0,as(c[(c[ad>>2]|0)+36>>2]|0,ad|0)|0);if(!x){bi=aA}else{x=0;af=a8;ag=a9;ah=25;break L4}}else{bi=c[ar>>2]|0}if((bi|0)==-1){c[I>>2]=0;ah=213;break}else{if(bg^(ad|0)==0){bj=ad;break}else{ah=219;break L4}}}}while(0);if((ah|0)==213){ah=0;if(bg){ah=219;break L4}else{bj=0}}ad=c[f>>2]|0;ar=c[ad+12>>2]|0;if((ar|0)==(c[ad+16>>2]|0)){aA=(x=0,as(c[(c[ad>>2]|0)+36>>2]|0,ad|0)|0);if(!x){bk=aA}else{x=0;af=a8;ag=a9;ah=25;break L4}}else{bk=c[ar>>2]|0}if((bk|0)!=(c[t>>2]|0)){ah=219;break L4}ar=c[f>>2]|0;aA=ar+12|0;ad=c[aA>>2]|0;if((ad|0)==(c[ar+16>>2]|0)){aC=c[(c[ar>>2]|0)+40>>2]|0;x=0,as(aC|0,ar|0)|0;if(!x){bl=bj;bm=ao}else{x=0;af=a8;ag=a9;ah=25;break L4}}else{c[aA>>2]=ad+4;bl=bj;bm=ao}while(1){ad=c[f>>2]|0;do{if((ad|0)==0){bn=1}else{aA=c[ad+12>>2]|0;if((aA|0)==(c[ad+16>>2]|0)){ar=(x=0,as(c[(c[ad>>2]|0)+36>>2]|0,ad|0)|0);if(!x){bo=ar}else{x=0;ah=21;break L4}}else{bo=c[aA>>2]|0}if((bo|0)==-1){c[f>>2]=0;bn=1;break}else{bn=(c[f>>2]|0)==0;break}}}while(0);do{if((bl|0)==0){ah=236}else{ad=c[bl+12>>2]|0;if((ad|0)==(c[bl+16>>2]|0)){aA=(x=0,as(c[(c[bl>>2]|0)+36>>2]|0,bl|0)|0);if(!x){bp=aA}else{x=0;ah=21;break L4}}else{bp=c[ad>>2]|0}if((bp|0)==-1){c[I>>2]=0;ah=236;break}else{if(bn^(bl|0)==0){bq=bl;break}else{ah=243;break L4}}}}while(0);if((ah|0)==236){ah=0;if(bn){ah=243;break L4}else{bq=0}}ad=c[f>>2]|0;aA=c[ad+12>>2]|0;if((aA|0)==(c[ad+16>>2]|0)){ar=(x=0,as(c[(c[ad>>2]|0)+36>>2]|0,ad|0)|0);if(!x){br=ar}else{x=0;ah=21;break L4}}else{br=c[aA>>2]|0}aA=(x=0,ax(c[(c[J>>2]|0)+12>>2]|0,l|0,2048,br|0)|0);if(x){x=0;ah=21;break L4}if(!aA){ah=243;break L4}if((c[n>>2]|0)==(c[q>>2]|0)){x=0;aP(90,m|0,n|0,q|0);if(x){x=0;ah=21;break L4}}aA=c[f>>2]|0;ar=c[aA+12>>2]|0;if((ar|0)==(c[aA+16>>2]|0)){ad=(x=0,as(c[(c[aA>>2]|0)+36>>2]|0,aA|0)|0);if(!x){bs=ad}else{x=0;ah=21;break L4}}else{bs=c[ar>>2]|0}ar=c[n>>2]|0;c[n>>2]=ar+4;c[ar>>2]=bs;ar=bm-1|0;c[C>>2]=ar;ad=c[f>>2]|0;aA=ad+12|0;aC=c[aA>>2]|0;if((aC|0)==(c[ad+16>>2]|0)){at=c[(c[ad>>2]|0)+40>>2]|0;x=0,as(at|0,ad|0)|0;if(x){x=0;ah=21;break L4}}else{c[aA>>2]=aC+4}if((ar|0)>0){bl=bq;bm=ar}else{break}}}if((c[n>>2]|0)==(c[g>>2]|0)){ah=254;break L4}else{au=_;av=a6;aw=a7;ay=a8;az=a9}break};case 2:{if(!((_|0)!=0|$>>>0<2>>>0)){if(($|0)==2){bt=(a[U]|0)!=0}else{bt=0}if(!(P|bt)){au=0;av=Z;aw=Y;ay=X;az=W;break L28}}ao=a[E]|0;ar=(ao&1)==0?Q:c[R>>2]|0;L232:do{if(($|0)==0){bu=ar;bv=ao;bw=aj}else{if((d[s+($-1)|0]|0)>>>0<2>>>0){bx=ar;by=ao}else{bu=ar;bv=ao;bw=aj;break}while(1){aC=by&255;if((bx|0)==(((by&1)==0?Q:c[R>>2]|0)+(((aC&1|0)==0?aC>>>1:c[Q>>2]|0)<<2)|0)){bz=by;break}aC=(x=0,ax(c[(c[J>>2]|0)+12>>2]|0,l|0,8192,c[bx>>2]|0)|0);if(x){x=0;ah=22;break L4}if(!aC){ah=117;break}bx=bx+4|0;by=a[E]|0}if((ah|0)==117){ah=0;bz=a[E]|0}aC=(bz&1)==0;aA=bx-(aC?Q:c[R>>2]|0)>>2;ad=a[H]|0;at=ad&255;aB=(at&1|0)==0;L242:do{if(aA>>>0<=(aB?at>>>1:c[S>>2]|0)>>>0){ac=(ad&1)==0;aa=(ac?S:c[T>>2]|0)+((aB?at>>>1:c[S>>2]|0)-aA<<2)|0;aF=(ac?S:c[T>>2]|0)+((aB?at>>>1:c[S>>2]|0)<<2)|0;if((aa|0)==(aF|0)){bu=bx;bv=bz;bw=aj;break L232}else{bA=aa;bB=aC?Q:c[R>>2]|0}while(1){if((c[bA>>2]|0)!=(c[bB>>2]|0)){break L242}aa=bA+4|0;if((aa|0)==(aF|0)){bu=bx;bv=bz;bw=aj;break L232}bA=aa;bB=bB+4|0}}}while(0);bu=aC?Q:c[R>>2]|0;bv=bz;bw=aj}}while(0);L249:while(1){ao=bv&255;if((bu|0)==(((bv&1)==0?Q:c[R>>2]|0)+(((ao&1|0)==0?ao>>>1:c[Q>>2]|0)<<2)|0)){break}ao=c[f>>2]|0;do{if((ao|0)==0){bC=1}else{ar=c[ao+12>>2]|0;if((ar|0)==(c[ao+16>>2]|0)){at=(x=0,as(c[(c[ao>>2]|0)+36>>2]|0,ao|0)|0);if(!x){bD=at}else{x=0;ah=23;break L4}}else{bD=c[ar>>2]|0}if((bD|0)==-1){c[f>>2]=0;bC=1;break}else{bC=(c[f>>2]|0)==0;break}}}while(0);do{if((bw|0)==0){ah=138}else{ao=c[bw+12>>2]|0;if((ao|0)==(c[bw+16>>2]|0)){aC=(x=0,as(c[(c[bw>>2]|0)+36>>2]|0,bw|0)|0);if(!x){bE=aC}else{x=0;ah=23;break L4}}else{bE=c[ao>>2]|0}if((bE|0)==-1){c[I>>2]=0;ah=138;break}else{if(bC^(bw|0)==0){bF=bw;break}else{break L249}}}}while(0);if((ah|0)==138){ah=0;if(bC){break}else{bF=0}}ao=c[f>>2]|0;aC=c[ao+12>>2]|0;if((aC|0)==(c[ao+16>>2]|0)){ar=(x=0,as(c[(c[ao>>2]|0)+36>>2]|0,ao|0)|0);if(!x){bG=ar}else{x=0;ah=23;break L4}}else{bG=c[aC>>2]|0}if((bG|0)!=(c[bu>>2]|0)){break}aC=c[f>>2]|0;ar=aC+12|0;ao=c[ar>>2]|0;if((ao|0)==(c[aC+16>>2]|0)){at=c[(c[aC>>2]|0)+40>>2]|0;x=0,as(at|0,aC|0)|0;if(x){x=0;ah=23;break L4}}else{c[ar>>2]=ao+4}bu=bu+4|0;bv=a[E]|0;bw=bF}if(!P){au=_;av=Z;aw=Y;ay=X;az=W;break L28}ao=a[E]|0;ar=ao&255;if((bu|0)==(((ao&1)==0?Q:c[R>>2]|0)+(((ar&1|0)==0?ar>>>1:c[Q>>2]|0)<<2)|0)){au=_;av=Z;aw=Y;ay=X;az=W}else{ah=150;break L4}break};case 1:{if(($|0)==3){ak=W;al=X;am=Y;an=_;ah=256;break L4}ar=c[f>>2]|0;ao=c[ar+12>>2]|0;if((ao|0)==(c[ar+16>>2]|0)){aC=(x=0,as(c[(c[ar>>2]|0)+36>>2]|0,ar|0)|0);if(!x){bH=aC}else{x=0;af=X;ag=W;ah=25;break L4}}else{bH=c[ao>>2]|0}ao=(x=0,ax(c[(c[J>>2]|0)+12>>2]|0,l|0,8192,bH|0)|0);if(x){x=0;af=X;ag=W;ah=25;break L4}if(!ao){ah=40;break L4}ao=c[f>>2]|0;aC=ao+12|0;ar=c[aC>>2]|0;if((ar|0)==(c[ao+16>>2]|0)){at=(x=0,as(c[(c[ao>>2]|0)+40>>2]|0,ao|0)|0);if(!x){bI=at}else{x=0;af=X;ag=W;ah=25;break L4}}else{c[aC>>2]=ar+4;bI=c[ar>>2]|0}x=0;aq(252,B|0,bI|0);if(!x){ah=41}else{x=0;af=X;ag=W;ah=25;break L4}break};case 0:{ah=41;break};default:{au=_;av=Z;aw=Y;ay=X;az=W}}}while(0);L297:do{if((ah|0)==41){ah=0;if(($|0)==3){ak=W;al=X;am=Y;an=_;ah=256;break L4}else{bJ=aj}while(1){ar=c[f>>2]|0;do{if((ar|0)==0){bK=1}else{aC=c[ar+12>>2]|0;if((aC|0)==(c[ar+16>>2]|0)){at=(x=0,as(c[(c[ar>>2]|0)+36>>2]|0,ar|0)|0);if(!x){bL=at}else{x=0;ah=24;break L4}}else{bL=c[aC>>2]|0}if((bL|0)==-1){c[f>>2]=0;bK=1;break}else{bK=(c[f>>2]|0)==0;break}}}while(0);do{if((bJ|0)==0){ah=55}else{ar=c[bJ+12>>2]|0;if((ar|0)==(c[bJ+16>>2]|0)){aC=(x=0,as(c[(c[bJ>>2]|0)+36>>2]|0,bJ|0)|0);if(!x){bM=aC}else{x=0;ah=24;break L4}}else{bM=c[ar>>2]|0}if((bM|0)==-1){c[I>>2]=0;ah=55;break}else{if(bK^(bJ|0)==0){bN=bJ;break}else{au=_;av=Z;aw=Y;ay=X;az=W;break L297}}}}while(0);if((ah|0)==55){ah=0;if(bK){au=_;av=Z;aw=Y;ay=X;az=W;break L297}else{bN=0}}ar=c[f>>2]|0;aC=c[ar+12>>2]|0;if((aC|0)==(c[ar+16>>2]|0)){at=(x=0,as(c[(c[ar>>2]|0)+36>>2]|0,ar|0)|0);if(!x){bO=at}else{x=0;ah=24;break L4}}else{bO=c[aC>>2]|0}aC=(x=0,ax(c[(c[J>>2]|0)+12>>2]|0,l|0,8192,bO|0)|0);if(x){x=0;ah=24;break L4}if(!aC){au=_;av=Z;aw=Y;ay=X;az=W;break L297}aC=c[f>>2]|0;at=aC+12|0;ar=c[at>>2]|0;if((ar|0)==(c[aC+16>>2]|0)){ao=(x=0,as(c[(c[aC>>2]|0)+40>>2]|0,aC|0)|0);if(!x){bP=ao}else{x=0;ah=24;break L4}}else{c[at>>2]=ar+4;bP=c[ar>>2]|0}x=0;aq(252,B|0,bP|0);if(!x){bJ=bN}else{x=0;ah=24;break L4}}}}while(0);ar=$+1|0;if(ar>>>0<4>>>0){W=az;X=ay;Y=aw;Z=av;_=au;$=ar}else{ak=az;al=ay;am=aw;an=au;ah=256;break}}L334:do{if((ah|0)==24){$=bQ(-1,-1)|0;bR=K;bS=$;bT=X;bV=W;break L1}else if((ah|0)==20){$=bQ(-1,-1)|0;bR=K;bS=$;bT=aS;bV=aT;break L1}else if((ah|0)==21){$=bQ(-1,-1)|0;bR=K;bS=$;bT=a8;bV=a9;break L1}else if((ah|0)==23){$=bQ(-1,-1)|0;bR=K;bS=$;bT=X;bV=W;break L1}else if((ah|0)==40){c[j>>2]=c[j>>2]|4;bW=0;bX=X;bY=W}else if((ah|0)==150){c[j>>2]=c[j>>2]|4;bW=0;bX=X;bY=W}else if((ah|0)==22){$=bQ(-1,-1)|0;bR=K;bS=$;bT=X;bV=W;break L1}else if((ah|0)==25){$=bQ(-1,-1)|0;bR=K;bS=$;bT=af;bV=ag;break L1}else if((ah|0)==219){c[j>>2]=c[j>>2]|4;bW=0;bX=a8;bY=a9}else if((ah|0)==106){c[j>>2]=c[j>>2]|4;bW=0;bX=X;bY=W}else if((ah|0)==243){c[j>>2]=c[j>>2]|4;bW=0;bX=a8;bY=a9}else if((ah|0)==254){c[j>>2]=c[j>>2]|4;bW=0;bX=a8;bY=a9}else if((ah|0)==256){L348:do{if((an|0)!=0){$=an;_=an+4|0;Z=an+8|0;Y=1;L350:while(1){J=d[$]|0;if((J&1|0)==0){bZ=J>>>1}else{bZ=c[_>>2]|0}if(Y>>>0>=bZ>>>0){break L348}J=c[f>>2]|0;do{if((J|0)==0){b_=1}else{Q=c[J+12>>2]|0;if((Q|0)==(c[J+16>>2]|0)){R=(x=0,as(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(!x){b$=R}else{x=0;ah=19;break L350}}else{b$=c[Q>>2]|0}if((b$|0)==-1){c[f>>2]=0;b_=1;break}else{b_=(c[f>>2]|0)==0;break}}}while(0);J=c[I>>2]|0;do{if((J|0)==0){ah=275}else{Q=c[J+12>>2]|0;if((Q|0)==(c[J+16>>2]|0)){R=(x=0,as(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(!x){b0=R}else{x=0;ah=19;break L350}}else{b0=c[Q>>2]|0}if((b0|0)==-1){c[I>>2]=0;ah=275;break}else{if(b_^(J|0)==0){break}else{ah=283;break L350}}}}while(0);if((ah|0)==275){ah=0;if(b_){ah=283;break}}J=c[f>>2]|0;Q=c[J+12>>2]|0;if((Q|0)==(c[J+16>>2]|0)){R=(x=0,as(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(!x){b1=R}else{x=0;ah=19;break}}else{b1=c[Q>>2]|0}if((a[$]&1)==0){b2=_}else{b2=c[Z>>2]|0}if((b1|0)!=(c[b2+(Y<<2)>>2]|0)){ah=283;break}Q=Y+1|0;R=c[f>>2]|0;J=R+12|0;P=c[J>>2]|0;if((P|0)==(c[R+16>>2]|0)){S=c[(c[R>>2]|0)+40>>2]|0;x=0,as(S|0,R|0)|0;if(!x){Y=Q;continue}else{x=0;ah=19;break}}else{c[J>>2]=P+4;Y=Q;continue}}if((ah|0)==19){Y=bQ(-1,-1)|0;bR=K;bS=Y;bT=al;bV=ak;break L1}else if((ah|0)==283){c[j>>2]=c[j>>2]|4;bW=0;bX=al;bY=ak;break L334}}}while(0);if((al|0)==(am|0)){bW=1;bX=am;bY=ak;break}c[D>>2]=0;G_(v,al,am,D);if((c[D>>2]|0)==0){bW=1;bX=al;bY=ak;break}c[j>>2]=c[j>>2]|4;bW=0;bX=al;bY=ak}}while(0);C$(B);C$(A);C$(z);C$(y);CP(v);if((bX|0)==0){i=p;return bW|0}x=0;ap(bY|0,bX|0);if(!x){i=p;return bW|0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{x=0;f=bQ(-1,-1)|0;bR=K;bS=f;bT=o;bV=548}}while(0);C$(B);C$(A);C$(z);C$(y);CP(v);if((bT|0)==0){be(bS|0)}x=0;ap(bV|0,bT|0);if(!x){be(bS|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function G3(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+456|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=d|0;m=d+16|0;n=d+416|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=m|0;t=n|0;c[t>>2]=s;u=n+4|0;c[u>>2]=548;v=m+400|0;x=0;aq(346,p|0,h|0);do{if(!x){m=p|0;w=c[m>>2]|0;if((c[10068]|0)==-1){y=4}else{c[l>>2]=40272;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40272,l|0,512);if(!x){y=4}else{x=0}}L5:do{if((y|0)==4){z=(c[10069]|0)-1|0;A=c[w+8>>2]|0;do{if((c[w+12>>2]|0)-A>>2>>>0>z>>>0){B=c[A+(z<<2)>>2]|0;if((B|0)==0){break}C=B;a[q]=0;D=f|0;E=c[D>>2]|0;c[r>>2]=E;F=(x=0,av(2,e|0,r|0,g|0,p|0,c[h+4>>2]|0,j|0,q|0,C|0,n|0,o|0,v|0)|0);if(x){x=0;break L5}if(F){F=k;if((a[F]&1)==0){c[k+4>>2]=0;a[F]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}F=B;if((a[q]&1)!=0){B=(x=0,aK(c[(c[F>>2]|0)+44>>2]|0,C|0,45)|0);if(x){x=0;break L5}x=0;aq(252,k|0,B|0);if(x){x=0;break L5}}B=(x=0,aK(c[(c[F>>2]|0)+44>>2]|0,C|0,48)|0);if(x){x=0;break L5}C=c[o>>2]|0;F=C-4|0;G=c[t>>2]|0;while(1){if(G>>>0>=F>>>0){break}if((c[G>>2]|0)==(B|0)){G=G+4|0}else{break}}x=0,ax(50,k|0,G|0,C|0)|0;if(x){x=0;break L5}}B=e|0;F=c[B>>2]|0;do{if((F|0)==0){H=0}else{I=c[F+12>>2]|0;if((I|0)==(c[F+16>>2]|0)){J=(x=0,as(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(!x){L=J}else{x=0;break L5}}else{L=c[I>>2]|0}if((L|0)!=-1){H=F;break}c[B>>2]=0;H=0}}while(0);B=(H|0)==0;do{if((E|0)==0){y=34}else{F=c[E+12>>2]|0;if((F|0)==(c[E+16>>2]|0)){C=(x=0,as(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(!x){M=C}else{x=0;break L5}}else{M=c[F>>2]|0}if((M|0)==-1){c[D>>2]=0;y=34;break}else{if(B^(E|0)==0){break}else{y=36;break}}}}while(0);if((y|0)==34){if(B){y=36}}if((y|0)==36){c[j>>2]=c[j>>2]|2}c[b>>2]=H;Cn(c[m>>2]|0)|0;E=c[t>>2]|0;c[t>>2]=0;if((E|0)==0){i=d;return}x=0;ap(c[u>>2]|0,E|0);if(!x){i=d;return}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);z=ci(4)|0;JB(z);x=0;aP(144,z|0,28080,98);if(x){x=0;break}}}while(0);w=bQ(-1,-1)|0;z=w;w=K;Cn(c[m>>2]|0)|0;A=c[t>>2]|0;c[t>>2]=0;if((A|0)==0){N=w;O=z}else{P=A;Q=w;R=z;break}S=O;T=0;U=S;V=N;be(U|0)}else{x=0;z=bQ(-1,-1)|0;c[t>>2]=0;P=s;Q=K;R=z}}while(0);x=0;ap(c[u>>2]|0,P|0);if(!x){N=Q;O=R;S=O;T=0;U=S;V=N;be(U|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function G4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=b;g=d;h=a[f]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[b+4>>2]|0}if((h&1)==0){k=1;l=h}else{h=c[b>>2]|0;k=(h&-2)-1|0;l=h&255}h=e-g>>2;if((h|0)==0){return b|0}if((k-j|0)>>>0<h>>>0){C5(b,k,j+h-k|0,j,j,0,0);m=a[f]|0}else{m=l}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{l=j+((e-4+(-g|0)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{g=m;d=d+4|0}}o=n+(l<<2)|0}c[o>>2]=0;o=j+h|0;if((a[f]&1)==0){a[f]=o<<1;return b|0}else{c[b+4>>2]=o;return b|0}return 0}function G5(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+56|0;o=n|0;p=n+16|0;q=n+32|0;r=n+40|0;s=r;t=i;i=i+12|0;i=i+7&-8;u=t;v=i;i=i+12|0;i=i+7&-8;w=v;y=i;i=i+12|0;i=i+7&-8;z=y;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;D=B;E=i;i=i+12|0;i=i+7&-8;F=E;G=i;i=i+12|0;i=i+7&-8;H=G;I=i;i=i+12|0;i=i+7&-8;J=I;if(b){b=c[d>>2]|0;if((c[10184]|0)!=-1){c[p>>2]=40736;c[p+4>>2]=454;c[p+8>>2]=0;CI(40736,p,512)}p=(c[10185]|0)-1|0;K=c[b+8>>2]|0;if((c[b+12>>2]|0)-K>>2>>>0<=p>>>0){L=ci(4)|0;M=L;JB(M);bH(L|0,28080,98)}b=c[K+(p<<2)>>2]|0;if((b|0)==0){L=ci(4)|0;M=L;JB(M);bH(L|0,28080,98)}L=b;cy[c[(c[b>>2]|0)+44>>2]&1023](q,L);M=e;C=c[q>>2]|0;a[M]=C;C=C>>8;a[M+1|0]=C;C=C>>8;a[M+2|0]=C;C=C>>8;a[M+3|0]=C;M=b;cy[c[(c[M>>2]|0)+32>>2]&1023](r,L);q=l;if((a[q]&1)==0){c[l+4>>2]=0;a[q]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}x=0;aq(498,l|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];Ke(s|0,0,12)|0;C$(r);cy[c[(c[M>>2]|0)+28>>2]&1023](t,L);r=k;if((a[r]&1)==0){c[k+4>>2]=0;a[r]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}x=0;aq(498,k|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[r>>2]=c[u>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];Ke(u|0,0,12)|0;C$(t);t=b;c[f>>2]=cA[c[(c[t>>2]|0)+12>>2]&511](L)|0;c[g>>2]=cA[c[(c[t>>2]|0)+16>>2]&511](L)|0;cy[c[(c[b>>2]|0)+20>>2]&1023](v,L);b=h;if((a[b]&1)==0){a[h+1|0]=0;a[b]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}x=0;aq(602,h|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[b>>2]=c[w>>2];c[b+4>>2]=c[w+4>>2];c[b+8>>2]=c[w+8>>2];Ke(w|0,0,12)|0;CP(v);cy[c[(c[M>>2]|0)+24>>2]&1023](y,L);M=j;if((a[M]&1)==0){c[j+4>>2]=0;a[M]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}x=0;aq(498,j|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[M>>2]=c[z>>2];c[M+4>>2]=c[z+4>>2];c[M+8>>2]=c[z+8>>2];Ke(z|0,0,12)|0;C$(y);N=cA[c[(c[t>>2]|0)+36>>2]&511](L)|0;c[m>>2]=N;i=n;return}else{L=c[d>>2]|0;if((c[10186]|0)!=-1){c[o>>2]=40744;c[o+4>>2]=454;c[o+8>>2]=0;CI(40744,o,512)}o=(c[10187]|0)-1|0;d=c[L+8>>2]|0;if((c[L+12>>2]|0)-d>>2>>>0<=o>>>0){O=ci(4)|0;P=O;JB(P);bH(O|0,28080,98)}L=c[d+(o<<2)>>2]|0;if((L|0)==0){O=ci(4)|0;P=O;JB(P);bH(O|0,28080,98)}O=L;cy[c[(c[L>>2]|0)+44>>2]&1023](A,O);P=e;C=c[A>>2]|0;a[P]=C;C=C>>8;a[P+1|0]=C;C=C>>8;a[P+2|0]=C;C=C>>8;a[P+3|0]=C;P=L;cy[c[(c[P>>2]|0)+32>>2]&1023](B,O);A=l;if((a[A]&1)==0){c[l+4>>2]=0;a[A]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}x=0;aq(498,l|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[A>>2]=c[D>>2];c[A+4>>2]=c[D+4>>2];c[A+8>>2]=c[D+8>>2];Ke(D|0,0,12)|0;C$(B);cy[c[(c[P>>2]|0)+28>>2]&1023](E,O);B=k;if((a[B]&1)==0){c[k+4>>2]=0;a[B]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}x=0;aq(498,k|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[B>>2]=c[F>>2];c[B+4>>2]=c[F+4>>2];c[B+8>>2]=c[F+8>>2];Ke(F|0,0,12)|0;C$(E);E=L;c[f>>2]=cA[c[(c[E>>2]|0)+12>>2]&511](O)|0;c[g>>2]=cA[c[(c[E>>2]|0)+16>>2]&511](O)|0;cy[c[(c[L>>2]|0)+20>>2]&1023](G,O);L=h;if((a[L]&1)==0){a[h+1|0]=0;a[L]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}x=0;aq(602,h|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[L>>2]=c[H>>2];c[L+4>>2]=c[H+4>>2];c[L+8>>2]=c[H+8>>2];Ke(H|0,0,12)|0;CP(G);cy[c[(c[P>>2]|0)+24>>2]&1023](I,O);P=j;if((a[P]&1)==0){c[j+4>>2]=0;a[P]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}x=0;aq(498,j|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[P>>2]=c[J>>2];c[P+4>>2]=c[J+4>>2];c[P+8>>2]=c[J+8>>2];Ke(J|0,0,12)|0;C$(I);N=cA[c[(c[E>>2]|0)+36>>2]&511](O)|0;c[m>>2]=N;i=n;return}}function G6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+4|0;f=(c[e>>2]|0)!=548;g=a|0;a=c[g>>2]|0;h=a;i=(c[d>>2]|0)-h|0;j=i>>>0<2147483647>>>0?i<<1:-1;i=(c[b>>2]|0)-h>>2;if(f){k=a}else{k=0}a=JZ(k,j)|0;k=a;if((a|0)==0){J7()}do{if(f){c[g>>2]=k;l=k}else{a=c[g>>2]|0;c[g>>2]=k;if((a|0)==0){l=k;break}x=0;ap(c[e>>2]|0,a|0);if(!x){l=c[g>>2]|0;break}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);c[e>>2]=504;c[b>>2]=l+(i<<2);c[d>>2]=(c[g>>2]|0)+(j>>>2<<2);return}function G7(a){a=a|0;Cl(a|0);J2(a);return}function G8(a){a=a|0;Cl(a|0);return}function G9(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,ar=0;e=i;i=i+280|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=e|0;n=e+120|0;o=e+232|0;p=e+240|0;q=e+248|0;r=e+256|0;s=e+264|0;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;y=w;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+100|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;E=e+16|0;c[n>>2]=E;F=e+128|0;G=bh(E|0,100,10032,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0;i=E;L1:do{if(G>>>0>99>>>0){do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}H=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=H;break}else{x=0;H=bQ(-1,-1)|0;I=K;J=H;L=0;M=0;N=12;break L1}}}while(0);H=(x=0,aS(26,n|0,c[9712]|0,10032,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0);i=E;if(x){x=0;O=0;P=0;N=11;break}Q=c[n>>2]|0;if((Q|0)==0){x=0;aQ(4);if(x){x=0;O=0;P=0;N=11;break}R=c[n>>2]|0}else{R=Q}Q=JW(H)|0;if((Q|0)!=0){S=Q;T=H;U=R;V=Q;N=15;break}x=0;aQ(4);if(!x){S=0;T=H;U=R;V=0;N=15}else{x=0;O=R;P=0;N=11}}else{S=F;T=G;U=0;V=0;N=15}}while(0);do{if((N|0)==15){x=0;aq(346,o|0,j|0);if(x){x=0;O=U;P=V;N=11;break}G=o|0;F=c[G>>2]|0;if((c[10070]|0)==-1){N=18}else{c[m>>2]=40280;c[m+4>>2]=454;c[m+8>>2]=0;x=0;aP(2,40280,m|0,512);if(!x){N=18}else{x=0;N=45}}L21:do{if((N|0)==18){R=(c[10071]|0)-1|0;E=c[F+8>>2]|0;do{if((c[F+12>>2]|0)-E>>2>>>0>R>>>0){H=c[E+(R<<2)>>2]|0;if((H|0)==0){break}Q=H;W=c[n>>2]|0;X=W+T|0;Y=c[(c[H>>2]|0)+32>>2]|0;x=0,aS(Y|0,Q|0,W|0,X|0,S|0)|0;if(x){x=0;N=45;break L21}if((T|0)==0){Z=0}else{Z=(a[c[n>>2]|0]|0)==45}Ke(t|0,0,12)|0;Ke(v|0,0,12)|0;Ke(y|0,0,12)|0;x=0;aJ(8,g|0,Z|0,o|0,p|0,q|0,r|0,s|0,u|0,w|0,z|0);L30:do{if(!x){X=A|0;W=c[z>>2]|0;if((T|0)>(W|0)){Y=d[y]|0;if((Y&1|0)==0){_=Y>>>1}else{_=c[w+4>>2]|0}Y=d[v]|0;if((Y&1|0)==0){$=Y>>>1}else{$=c[u+4>>2]|0}aa=(T-W<<1|1)+_+$|0}else{Y=d[y]|0;if((Y&1|0)==0){ab=Y>>>1}else{ab=c[w+4>>2]|0}Y=d[v]|0;if((Y&1|0)==0){ac=Y>>>1}else{ac=c[u+4>>2]|0}aa=ab+2+ac|0}Y=aa+W|0;do{if(Y>>>0>100>>>0){H=JW(Y)|0;if((H|0)!=0){ad=H;ae=H;break}x=0;aQ(4);if(!x){ad=0;ae=0;break}else{x=0}H=bQ(-1,-1)|0;af=K;ag=H;break L30}else{ad=X;ae=0}}while(0);x=0;ay(2,ad|0,B|0,C|0,c[j+4>>2]|0,S|0,S+T|0,Q|0,Z|0,p|0,a[q]|0,a[r]|0,s|0,u|0,w|0,W|0);do{if(!x){c[D>>2]=c[f>>2];x=0;aG(56,b|0,D|0,ad|0,c[B>>2]|0,c[C>>2]|0,j|0,k|0);if(x){x=0;break}if((ae|0)!=0){JX(ae)}CP(w);CP(u);CP(s);Cn(c[G>>2]|0)|0;if((V|0)!=0){JX(V)}if((U|0)==0){i=e;return}JX(U);i=e;return}else{x=0}}while(0);W=bQ(-1,-1)|0;X=W;W=K;if((ae|0)==0){af=W;ag=X;break}JX(ae);af=W;ag=X}else{x=0;X=bQ(-1,-1)|0;af=K;ag=X}}while(0);CP(w);CP(u);CP(s);ah=af;ai=ag;break L21}}while(0);R=ci(4)|0;JB(R);x=0;aP(144,R|0,28080,98);if(x){x=0;N=45;break}}}while(0);if((N|0)==45){F=bQ(-1,-1)|0;ah=K;ai=F}Cn(c[G>>2]|0)|0;aj=ah;ak=ai;al=U;am=V}}while(0);if((N|0)==11){V=bQ(-1,-1)|0;I=K;J=V;L=O;M=P;N=12}if((N|0)==12){aj=I;ak=J;al=L;am=M}if((am|0)!=0){JX(am)}if((al|0)==0){an=ak;ao=0;ap=an;ar=aj;be(ap|0)}JX(al);an=ak;ao=0;ap=an;ar=aj;be(ap|0)}function Ha(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;n=i;i=i+40|0;o=n|0;p=n+16|0;q=n+32|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+4|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;y=w;z=i;i=i+12|0;i=i+7&-8;A=z;B=i;i=i+12|0;i=i+7&-8;D=B;E=i;i=i+4|0;i=i+7&-8;F=E;G=i;i=i+12|0;i=i+7&-8;H=G;I=i;i=i+4|0;i=i+7&-8;J=I;K=i;i=i+12|0;i=i+7&-8;L=K;M=i;i=i+12|0;i=i+7&-8;N=M;O=i;i=i+12|0;i=i+7&-8;P=O;Q=c[e>>2]|0;if(b){if((c[10188]|0)!=-1){c[p>>2]=40752;c[p+4>>2]=454;c[p+8>>2]=0;CI(40752,p,512)}p=(c[10189]|0)-1|0;b=c[Q+8>>2]|0;if((c[Q+12>>2]|0)-b>>2>>>0<=p>>>0){R=ci(4)|0;S=R;JB(S);bH(R|0,28080,98)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){R=ci(4)|0;S=R;JB(S);bH(R|0,28080,98)}R=e;S=c[e>>2]|0;do{if(d){cy[c[S+44>>2]&1023](r,R);p=f;C=c[q>>2]|0;a[p]=C;C=C>>8;a[p+1|0]=C;C=C>>8;a[p+2|0]=C;C=C>>8;a[p+3|0]=C;cy[c[(c[e>>2]|0)+32>>2]&1023](s,R);p=l;if((a[p]&1)==0){a[l+1|0]=0;a[p]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}x=0;aq(602,l|0,0);if(!x){c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];Ke(t|0,0,12)|0;CP(s);break}else{x=0;bQ(-1,-1,0)|0;bU()}}else{cy[c[S+40>>2]&1023](v,R);p=f;C=c[u>>2]|0;a[p]=C;C=C>>8;a[p+1|0]=C;C=C>>8;a[p+2|0]=C;C=C>>8;a[p+3|0]=C;cy[c[(c[e>>2]|0)+28>>2]&1023](w,R);p=l;if((a[p]&1)==0){a[l+1|0]=0;a[p]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}x=0;aq(602,l|0,0);if(!x){c[p>>2]=c[y>>2];c[p+4>>2]=c[y+4>>2];c[p+8>>2]=c[y+8>>2];Ke(y|0,0,12)|0;CP(w);break}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);w=e;a[g]=cA[c[(c[w>>2]|0)+12>>2]&511](R)|0;a[h]=cA[c[(c[w>>2]|0)+16>>2]&511](R)|0;w=e;cy[c[(c[w>>2]|0)+20>>2]&1023](z,R);y=j;if((a[y]&1)==0){a[j+1|0]=0;a[y]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}x=0;aq(602,j|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[y>>2]=c[A>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];Ke(A|0,0,12)|0;CP(z);cy[c[(c[w>>2]|0)+24>>2]&1023](B,R);w=k;if((a[w]&1)==0){a[k+1|0]=0;a[w]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}x=0;aq(602,k|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[w>>2]=c[D>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];Ke(D|0,0,12)|0;CP(B);T=cA[c[(c[e>>2]|0)+36>>2]&511](R)|0;c[m>>2]=T;i=n;return}else{if((c[10190]|0)!=-1){c[o>>2]=40760;c[o+4>>2]=454;c[o+8>>2]=0;CI(40760,o,512)}o=(c[10191]|0)-1|0;R=c[Q+8>>2]|0;if((c[Q+12>>2]|0)-R>>2>>>0<=o>>>0){U=ci(4)|0;V=U;JB(V);bH(U|0,28080,98)}Q=c[R+(o<<2)>>2]|0;if((Q|0)==0){U=ci(4)|0;V=U;JB(V);bH(U|0,28080,98)}U=Q;V=c[Q>>2]|0;do{if(d){cy[c[V+44>>2]&1023](F,U);o=f;C=c[E>>2]|0;a[o]=C;C=C>>8;a[o+1|0]=C;C=C>>8;a[o+2|0]=C;C=C>>8;a[o+3|0]=C;cy[c[(c[Q>>2]|0)+32>>2]&1023](G,U);o=l;if((a[o]&1)==0){a[l+1|0]=0;a[o]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}x=0;aq(602,l|0,0);if(!x){c[o>>2]=c[H>>2];c[o+4>>2]=c[H+4>>2];c[o+8>>2]=c[H+8>>2];Ke(H|0,0,12)|0;CP(G);break}else{x=0;bQ(-1,-1,0)|0;bU()}}else{cy[c[V+40>>2]&1023](J,U);o=f;C=c[I>>2]|0;a[o]=C;C=C>>8;a[o+1|0]=C;C=C>>8;a[o+2|0]=C;C=C>>8;a[o+3|0]=C;cy[c[(c[Q>>2]|0)+28>>2]&1023](K,U);o=l;if((a[o]&1)==0){a[l+1|0]=0;a[o]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}x=0;aq(602,l|0,0);if(!x){c[o>>2]=c[L>>2];c[o+4>>2]=c[L+4>>2];c[o+8>>2]=c[L+8>>2];Ke(L|0,0,12)|0;CP(K);break}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);K=Q;a[g]=cA[c[(c[K>>2]|0)+12>>2]&511](U)|0;a[h]=cA[c[(c[K>>2]|0)+16>>2]&511](U)|0;K=Q;cy[c[(c[K>>2]|0)+20>>2]&1023](M,U);h=j;if((a[h]&1)==0){a[j+1|0]=0;a[h]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}x=0;aq(602,j|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[h>>2]=c[N>>2];c[h+4>>2]=c[N+4>>2];c[h+8>>2]=c[N+8>>2];Ke(N|0,0,12)|0;CP(M);cy[c[(c[K>>2]|0)+24>>2]&1023](O,U);K=k;if((a[K]&1)==0){a[k+1|0]=0;a[K]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}x=0;aq(602,k|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[K>>2]=c[P>>2];c[K+4>>2]=c[P+4>>2];c[K+8>>2]=c[P+8>>2];Ke(P|0,0,12)|0;CP(O);T=cA[c[(c[Q>>2]|0)+36>>2]&511](U)|0;c[m>>2]=T;i=n;return}}function Hb(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0;c[f>>2]=d;s=j;t=q;u=q+1|0;v=q+8|0;w=q+4|0;q=p;x=(g&512|0)==0;y=p+1|0;z=p+4|0;A=p+8|0;p=j+8|0;B=(r|0)>0;C=o;D=o+1|0;E=o+8|0;F=o+4|0;o=-r|0;G=h;h=0;while(1){L3:do{switch(a[l+h|0]|0){case 3:{H=a[t]|0;I=H&255;if((I&1|0)==0){J=I>>>1}else{J=c[w>>2]|0}if((J|0)==0){K=G;break L3}if((H&1)==0){L=u}else{L=c[v>>2]|0}H=a[L]|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=H;K=G;break};case 0:{c[e>>2]=c[f>>2];K=G;break};case 1:{c[e>>2]=c[f>>2];H=cS[c[(c[s>>2]|0)+28>>2]&1023](j,32)|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=H;K=G;break};case 2:{H=a[q]|0;I=H&255;M=(I&1|0)==0;if(M){N=I>>>1}else{N=c[z>>2]|0}if((N|0)==0|x){K=G;break L3}if((H&1)==0){O=y;P=y}else{H=c[A>>2]|0;O=H;P=H}if(M){Q=I>>>1}else{Q=c[z>>2]|0}I=O+Q|0;M=c[f>>2]|0;if((P|0)==(I|0)){R=M}else{H=P;S=M;while(1){a[S]=a[H]|0;M=H+1|0;T=S+1|0;if((M|0)==(I|0)){R=T;break}else{H=M;S=T}}}c[f>>2]=R;K=G;break};case 4:{S=c[f>>2]|0;H=k?G+1|0:G;I=H;while(1){if(I>>>0>=i>>>0){break}T=a[I]|0;if(T<<24>>24<0){break}if((b[(c[p>>2]|0)+(T<<24>>24<<1)>>1]&2048)==0){break}else{I=I+1|0}}T=I;if(B){if(I>>>0>H>>>0){M=H+(-T|0)|0;T=M>>>0<o>>>0?o:M;M=T+r|0;U=I;V=r;W=S;while(1){X=U-1|0;Y=a[X]|0;c[f>>2]=W+1;a[W]=Y;Y=V-1|0;Z=(Y|0)>0;if(!(X>>>0>H>>>0&Z)){break}U=X;V=Y;W=c[f>>2]|0}W=I+T|0;if(Z){_=M;$=W;aa=34}else{ab=0;ac=M;ad=W}}else{_=r;$=I;aa=34}if((aa|0)==34){aa=0;ab=cS[c[(c[s>>2]|0)+28>>2]&1023](j,48)|0;ac=_;ad=$}W=c[f>>2]|0;c[f>>2]=W+1;if((ac|0)>0){V=ac;U=W;while(1){a[U]=ab;Y=V-1|0;X=c[f>>2]|0;c[f>>2]=X+1;if((Y|0)>0){V=Y;U=X}else{ae=X;break}}}else{ae=W}a[ae]=m;af=ad}else{af=I}if((af|0)==(H|0)){U=cS[c[(c[s>>2]|0)+28>>2]&1023](j,48)|0;V=c[f>>2]|0;c[f>>2]=V+1;a[V]=U}else{U=a[C]|0;V=U&255;if((V&1|0)==0){ag=V>>>1}else{ag=c[F>>2]|0}if((ag|0)==0){ah=af;ai=0;aj=0;ak=-1}else{if((U&1)==0){al=D}else{al=c[E>>2]|0}ah=af;ai=0;aj=0;ak=a[al]|0}while(1){do{if((ai|0)==(ak|0)){U=c[f>>2]|0;c[f>>2]=U+1;a[U]=n;U=aj+1|0;V=a[C]|0;M=V&255;if((M&1|0)==0){am=M>>>1}else{am=c[F>>2]|0}if(U>>>0>=am>>>0){an=ak;ao=U;ap=0;break}M=(V&1)==0;if(M){aq=D}else{aq=c[E>>2]|0}if((a[aq+U|0]|0)==127){an=-1;ao=U;ap=0;break}if(M){ar=D}else{ar=c[E>>2]|0}an=a[ar+U|0]|0;ao=U;ap=0}else{an=ak;ao=aj;ap=ai}}while(0);U=ah-1|0;M=a[U]|0;V=c[f>>2]|0;c[f>>2]=V+1;a[V]=M;if((U|0)==(H|0)){break}else{ah=U;ai=ap+1|0;aj=ao;ak=an}}}I=c[f>>2]|0;if((S|0)==(I|0)){K=H;break L3}W=I-1|0;if(S>>>0<W>>>0){as=S;at=W}else{K=H;break L3}while(1){W=a[as]|0;a[as]=a[at]|0;a[at]=W;W=as+1|0;I=at-1|0;if(W>>>0<I>>>0){as=W;at=I}else{K=H;break}}break};default:{K=G}}}while(0);H=h+1|0;if(H>>>0<4>>>0){G=K;h=H}else{break}}h=a[t]|0;t=h&255;K=(t&1|0)==0;if(K){au=t>>>1}else{au=c[w>>2]|0}if(au>>>0>1>>>0){if((h&1)==0){av=u;aw=u}else{u=c[v>>2]|0;av=u;aw=u}if(K){ax=t>>>1}else{ax=c[w>>2]|0}w=av+ax|0;ax=c[f>>2]|0;av=aw+1|0;if((av|0)==(w|0)){ay=ax}else{aw=ax;ax=av;while(1){a[aw]=a[ax]|0;av=aw+1|0;t=ax+1|0;if((t|0)==(w|0)){ay=av;break}else{aw=av;ax=t}}}c[f>>2]=ay}ay=g&176;if((ay|0)==16){return}else if((ay|0)==32){c[e>>2]=c[f>>2];return}else{c[e>>2]=d;return}}function Hc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0;e=i;i=i+64|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+24|0;o=e+32|0;p=e+40|0;q=e+48|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+4|0;i=i+7&-8;y=i;i=i+100|0;i=i+7&-8;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;C8(m,h);C=m|0;D=c[C>>2]|0;if((c[10070]|0)==-1){E=3}else{c[l>>2]=40280;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40280,l|0,512);if(!x){E=3}else{x=0}}L3:do{if((E|0)==3){l=(c[10071]|0)-1|0;F=c[D+8>>2]|0;do{if((c[D+12>>2]|0)-F>>2>>>0>l>>>0){G=c[F+(l<<2)>>2]|0;if((G|0)==0){break}H=G;I=k;J=k;L=a[J]|0;M=L&255;if((M&1|0)==0){N=M>>>1}else{N=c[k+4>>2]|0}if((N|0)==0){O=0}else{if((L&1)==0){P=I+1|0}else{P=c[k+8>>2]|0}L=a[P]|0;M=(x=0,aK(c[(c[G>>2]|0)+28>>2]|0,H|0,45)|0);if(x){x=0;break L3}O=L<<24>>24==M<<24>>24}Ke(r|0,0,12)|0;Ke(t|0,0,12)|0;Ke(v|0,0,12)|0;x=0;aJ(8,g|0,O|0,m|0,n|0,o|0,p|0,q|0,s|0,u|0,w|0);L20:do{if(!x){M=y|0;L=a[J]|0;G=L&255;Q=(G&1|0)==0;if(Q){R=G>>>1}else{R=c[k+4>>2]|0}S=c[w>>2]|0;if((R|0)>(S|0)){if(Q){T=G>>>1}else{T=c[k+4>>2]|0}G=d[v]|0;if((G&1|0)==0){U=G>>>1}else{U=c[u+4>>2]|0}G=d[t]|0;if((G&1|0)==0){V=G>>>1}else{V=c[s+4>>2]|0}W=(T-S<<1|1)+U+V|0}else{G=d[v]|0;if((G&1|0)==0){X=G>>>1}else{X=c[u+4>>2]|0}G=d[t]|0;if((G&1|0)==0){Y=G>>>1}else{Y=c[s+4>>2]|0}W=X+2+Y|0}G=W+S|0;do{if(G>>>0>100>>>0){Q=JW(G)|0;if((Q|0)!=0){Z=Q;_=Q;$=L;break}x=0;aQ(4);if(!x){Z=0;_=0;$=a[J]|0;break}else{x=0;Q=bQ(-1,-1)|0;aa=K;ab=Q;break L20}}else{Z=M;_=0;$=L}}while(0);if(($&1)==0){ac=I+1|0;ad=I+1|0}else{L=c[k+8>>2]|0;ac=L;ad=L}L=$&255;if((L&1|0)==0){ae=L>>>1}else{ae=c[k+4>>2]|0}x=0;ay(2,Z|0,z|0,A|0,c[h+4>>2]|0,ad|0,ac+ae|0,H|0,O|0,n|0,a[o]|0,a[p]|0,q|0,s|0,u|0,S|0);do{if(!x){c[B>>2]=c[f>>2];x=0;aG(56,b|0,B|0,Z|0,c[z>>2]|0,c[A>>2]|0,h|0,j|0);if(x){x=0;break}if((_|0)==0){CP(u);CP(s);CP(q);af=c[C>>2]|0;ag=af|0;ah=Cn(ag)|0;i=e;return}JX(_);CP(u);CP(s);CP(q);af=c[C>>2]|0;ag=af|0;ah=Cn(ag)|0;i=e;return}else{x=0}}while(0);S=bQ(-1,-1)|0;L=S;S=K;if((_|0)==0){aa=S;ab=L;break}JX(_);aa=S;ab=L}else{x=0;L=bQ(-1,-1)|0;aa=K;ab=L}}while(0);CP(u);CP(s);CP(q);ai=aa;aj=ab;ak=c[C>>2]|0;al=ak|0;am=Cn(al)|0;an=aj;ao=0;ap=an;aq=ai;be(ap|0)}}while(0);l=ci(4)|0;JB(l);x=0;aP(144,l|0,28080,98);if(x){x=0;break}}}while(0);ab=bQ(-1,-1)|0;ai=K;aj=ab;ak=c[C>>2]|0;al=ak|0;am=Cn(al)|0;an=aj;ao=0;ap=an;aq=ai;be(ap|0)}function Hd(a){a=a|0;Cl(a|0);J2(a);return}function He(a){a=a|0;Cl(a|0);return}function Hf(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,ar=0,as=0,at=0;e=i;i=i+576|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=e|0;n=e+120|0;o=e+528|0;p=e+536|0;q=e+544|0;r=e+552|0;s=e+560|0;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;y=w;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+400|0;B=i;i=i+4|0;i=i+7&-8;C=i;i=i+4|0;i=i+7&-8;D=i;i=i+4|0;i=i+7&-8;E=e+16|0;c[n>>2]=E;F=e+128|0;G=bh(E|0,100,10032,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0;i=E;L1:do{if(G>>>0>99>>>0){do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}H=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=H;break}else{x=0;H=bQ(-1,-1)|0;I=K;J=H;L=0;M=0;N=12;break L1}}}while(0);H=(x=0,aS(26,n|0,c[9712]|0,10032,(E=i,i=i+8|0,h[E>>3]=l,E)|0)|0);i=E;if(x){x=0;O=0;P=0;N=11;break}Q=c[n>>2]|0;if((Q|0)==0){x=0;aQ(4);if(x){x=0;O=0;P=0;N=11;break}R=c[n>>2]|0}else{R=Q}Q=JW(H<<2)|0;S=Q;if((Q|0)!=0){T=S;U=H;V=R;W=S;N=15;break}x=0;aQ(4);if(!x){T=S;U=H;V=R;W=S;N=15}else{x=0;O=R;P=S;N=11}}else{T=F;U=G;V=0;W=0;N=15}}while(0);do{if((N|0)==15){x=0;aq(346,o|0,j|0);if(x){x=0;O=V;P=W;N=11;break}G=o|0;F=c[G>>2]|0;if((c[10068]|0)==-1){N=18}else{c[m>>2]=40272;c[m+4>>2]=454;c[m+8>>2]=0;x=0;aP(2,40272,m|0,512);if(!x){N=18}else{x=0;N=44}}L21:do{if((N|0)==18){R=(c[10069]|0)-1|0;E=c[F+8>>2]|0;do{if((c[F+12>>2]|0)-E>>2>>>0>R>>>0){S=c[E+(R<<2)>>2]|0;if((S|0)==0){break}H=S;Q=c[n>>2]|0;X=Q+U|0;Y=c[(c[S>>2]|0)+48>>2]|0;x=0,aS(Y|0,H|0,Q|0,X|0,T|0)|0;if(x){x=0;N=44;break L21}if((U|0)==0){Z=0}else{Z=(a[c[n>>2]|0]|0)==45}Ke(t|0,0,12)|0;Ke(v|0,0,12)|0;Ke(y|0,0,12)|0;x=0;aJ(2,g|0,Z|0,o|0,p|0,q|0,r|0,s|0,u|0,w|0,z|0);do{if(!x){X=A|0;Q=c[z>>2]|0;if((U|0)>(Q|0)){Y=d[y]|0;if((Y&1|0)==0){_=Y>>>1}else{_=c[w+4>>2]|0}Y=d[v]|0;if((Y&1|0)==0){$=Y>>>1}else{$=c[u+4>>2]|0}aa=(U-Q<<1|1)+_+$|0}else{Y=d[y]|0;if((Y&1|0)==0){ab=Y>>>1}else{ab=c[w+4>>2]|0}Y=d[v]|0;if((Y&1|0)==0){ac=Y>>>1}else{ac=c[u+4>>2]|0}aa=ab+2+ac|0}Y=aa+Q|0;do{if(Y>>>0>100>>>0){S=JW(Y<<2)|0;ad=S;if((S|0)!=0){ae=ad;af=ad;N=48;break}x=0;aQ(4);if(!x){ae=ad;af=ad;N=48}else{x=0;ag=ad}}else{ae=X;af=0;N=48}}while(0);do{if((N|0)==48){x=0;ay(4,ae|0,B|0,C|0,c[j+4>>2]|0,T|0,T+(U<<2)|0,H|0,Z|0,p|0,c[q>>2]|0,c[r>>2]|0,s|0,u|0,w|0,Q|0);if(x){x=0;ag=af;break}c[D>>2]=c[f>>2];x=0;aG(52,b|0,D|0,ae|0,c[B>>2]|0,c[C>>2]|0,j|0,k|0);if(x){x=0;ag=af;break}if((af|0)!=0){JX(af)}C$(w);C$(u);CP(s);Cn(c[G>>2]|0)|0;if((W|0)!=0){JX(W)}if((V|0)==0){i=e;return}JX(V);i=e;return}}while(0);Q=bQ(-1,-1)|0;X=Q;Q=K;if((ag|0)==0){ah=Q;ai=X;break}JX(ag);ah=Q;ai=X}else{x=0;X=bQ(-1,-1)|0;ah=K;ai=X}}while(0);C$(w);C$(u);CP(s);aj=ah;ak=ai;break L21}}while(0);R=ci(4)|0;JB(R);x=0;aP(144,R|0,28080,98);if(x){x=0;N=44;break}}}while(0);if((N|0)==44){F=bQ(-1,-1)|0;aj=K;ak=F}Cn(c[G>>2]|0)|0;al=aj;am=ak;an=V;ao=W}}while(0);if((N|0)==11){W=bQ(-1,-1)|0;I=K;J=W;L=O;M=P;N=12}if((N|0)==12){al=I;am=J;an=L;ao=M}if((ao|0)!=0){JX(ao)}if((an|0)==0){ap=am;ar=0;as=ap;at=al;be(as|0)}JX(an);ap=am;ar=0;as=ap;at=al;be(as|0)}function Hg(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;n=i;i=i+40|0;o=n|0;p=n+16|0;q=n+32|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+4|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;y=w;z=i;i=i+12|0;i=i+7&-8;A=z;B=i;i=i+12|0;i=i+7&-8;D=B;E=i;i=i+4|0;i=i+7&-8;F=E;G=i;i=i+12|0;i=i+7&-8;H=G;I=i;i=i+4|0;i=i+7&-8;J=I;K=i;i=i+12|0;i=i+7&-8;L=K;M=i;i=i+12|0;i=i+7&-8;N=M;O=i;i=i+12|0;i=i+7&-8;P=O;Q=c[e>>2]|0;if(b){if((c[10184]|0)!=-1){c[p>>2]=40736;c[p+4>>2]=454;c[p+8>>2]=0;CI(40736,p,512)}p=(c[10185]|0)-1|0;b=c[Q+8>>2]|0;if((c[Q+12>>2]|0)-b>>2>>>0<=p>>>0){R=ci(4)|0;S=R;JB(S);bH(R|0,28080,98)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){R=ci(4)|0;S=R;JB(S);bH(R|0,28080,98)}R=e;S=c[e>>2]|0;do{if(d){cy[c[S+44>>2]&1023](r,R);p=f;C=c[q>>2]|0;a[p]=C;C=C>>8;a[p+1|0]=C;C=C>>8;a[p+2|0]=C;C=C>>8;a[p+3|0]=C;cy[c[(c[e>>2]|0)+32>>2]&1023](s,R);p=l;if((a[p]&1)==0){c[l+4>>2]=0;a[p]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}x=0;aq(498,l|0,0);if(!x){c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];Ke(t|0,0,12)|0;C$(s);break}else{x=0;bQ(-1,-1,0)|0;bU()}}else{cy[c[S+40>>2]&1023](v,R);p=f;C=c[u>>2]|0;a[p]=C;C=C>>8;a[p+1|0]=C;C=C>>8;a[p+2|0]=C;C=C>>8;a[p+3|0]=C;cy[c[(c[e>>2]|0)+28>>2]&1023](w,R);p=l;if((a[p]&1)==0){c[l+4>>2]=0;a[p]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}x=0;aq(498,l|0,0);if(!x){c[p>>2]=c[y>>2];c[p+4>>2]=c[y+4>>2];c[p+8>>2]=c[y+8>>2];Ke(y|0,0,12)|0;C$(w);break}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);w=e;c[g>>2]=cA[c[(c[w>>2]|0)+12>>2]&511](R)|0;c[h>>2]=cA[c[(c[w>>2]|0)+16>>2]&511](R)|0;cy[c[(c[e>>2]|0)+20>>2]&1023](z,R);y=j;if((a[y]&1)==0){a[j+1|0]=0;a[y]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}x=0;aq(602,j|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[y>>2]=c[A>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];Ke(A|0,0,12)|0;CP(z);cy[c[(c[e>>2]|0)+24>>2]&1023](B,R);e=k;if((a[e]&1)==0){c[k+4>>2]=0;a[e]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}x=0;aq(498,k|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[e>>2]=c[D>>2];c[e+4>>2]=c[D+4>>2];c[e+8>>2]=c[D+8>>2];Ke(D|0,0,12)|0;C$(B);T=cA[c[(c[w>>2]|0)+36>>2]&511](R)|0;c[m>>2]=T;i=n;return}else{if((c[10186]|0)!=-1){c[o>>2]=40744;c[o+4>>2]=454;c[o+8>>2]=0;CI(40744,o,512)}o=(c[10187]|0)-1|0;R=c[Q+8>>2]|0;if((c[Q+12>>2]|0)-R>>2>>>0<=o>>>0){U=ci(4)|0;V=U;JB(V);bH(U|0,28080,98)}Q=c[R+(o<<2)>>2]|0;if((Q|0)==0){U=ci(4)|0;V=U;JB(V);bH(U|0,28080,98)}U=Q;V=c[Q>>2]|0;do{if(d){cy[c[V+44>>2]&1023](F,U);o=f;C=c[E>>2]|0;a[o]=C;C=C>>8;a[o+1|0]=C;C=C>>8;a[o+2|0]=C;C=C>>8;a[o+3|0]=C;cy[c[(c[Q>>2]|0)+32>>2]&1023](G,U);o=l;if((a[o]&1)==0){c[l+4>>2]=0;a[o]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}x=0;aq(498,l|0,0);if(!x){c[o>>2]=c[H>>2];c[o+4>>2]=c[H+4>>2];c[o+8>>2]=c[H+8>>2];Ke(H|0,0,12)|0;C$(G);break}else{x=0;bQ(-1,-1,0)|0;bU()}}else{cy[c[V+40>>2]&1023](J,U);o=f;C=c[I>>2]|0;a[o]=C;C=C>>8;a[o+1|0]=C;C=C>>8;a[o+2|0]=C;C=C>>8;a[o+3|0]=C;cy[c[(c[Q>>2]|0)+28>>2]&1023](K,U);o=l;if((a[o]&1)==0){c[l+4>>2]=0;a[o]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}x=0;aq(498,l|0,0);if(!x){c[o>>2]=c[L>>2];c[o+4>>2]=c[L+4>>2];c[o+8>>2]=c[L+8>>2];Ke(L|0,0,12)|0;C$(K);break}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);K=Q;c[g>>2]=cA[c[(c[K>>2]|0)+12>>2]&511](U)|0;c[h>>2]=cA[c[(c[K>>2]|0)+16>>2]&511](U)|0;cy[c[(c[Q>>2]|0)+20>>2]&1023](M,U);h=j;if((a[h]&1)==0){a[j+1|0]=0;a[h]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}x=0;aq(602,j|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[h>>2]=c[N>>2];c[h+4>>2]=c[N+4>>2];c[h+8>>2]=c[N+8>>2];Ke(N|0,0,12)|0;CP(M);cy[c[(c[Q>>2]|0)+24>>2]&1023](O,U);Q=k;if((a[Q]&1)==0){c[k+4>>2]=0;a[Q]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}x=0;aq(498,k|0,0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[Q>>2]=c[P>>2];c[Q+4>>2]=c[P+4>>2];c[Q+8>>2]=c[P+8>>2];Ke(P|0,0,12)|0;C$(O);T=cA[c[(c[K>>2]|0)+36>>2]&511](U)|0;c[m>>2]=T;i=n;return}}function Hh(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0;c[e>>2]=b;r=i;s=p;t=p+4|0;u=p+8|0;p=o;v=(f&512|0)==0;w=o+4|0;x=o+8|0;o=i;y=(q|0)>0;z=n;A=n+1|0;B=n+8|0;C=n+4|0;n=g;g=0;while(1){L3:do{switch(a[k+g|0]|0){case 0:{c[d>>2]=c[e>>2];D=n;break};case 3:{E=a[s]|0;F=E&255;if((F&1|0)==0){G=F>>>1}else{G=c[t>>2]|0}if((G|0)==0){D=n;break L3}if((E&1)==0){H=t}else{H=c[u>>2]|0}E=c[H>>2]|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=n;break};case 2:{E=a[p]|0;F=E&255;I=(F&1|0)==0;if(I){J=F>>>1}else{J=c[w>>2]|0}if((J|0)==0|v){D=n;break L3}if((E&1)==0){K=w;L=w;M=w}else{E=c[x>>2]|0;K=E;L=E;M=E}if(I){N=F>>>1}else{N=c[w>>2]|0}F=K+(N<<2)|0;I=c[e>>2]|0;if((L|0)==(F|0)){O=I}else{E=(K+(N-1<<2)+(-M|0)|0)>>>2;P=L;Q=I;while(1){c[Q>>2]=c[P>>2];R=P+4|0;if((R|0)==(F|0)){break}P=R;Q=Q+4|0}O=I+(E+1<<2)|0}c[e>>2]=O;D=n;break};case 1:{c[d>>2]=c[e>>2];Q=cS[c[(c[r>>2]|0)+44>>2]&1023](i,32)|0;P=c[e>>2]|0;c[e>>2]=P+4;c[P>>2]=Q;D=n;break};case 4:{Q=c[e>>2]|0;P=j?n+4|0:n;F=P;while(1){if(F>>>0>=h>>>0){break}if(cF[c[(c[o>>2]|0)+12>>2]&127](i,2048,c[F>>2]|0)|0){F=F+4|0}else{break}}if(y){if(F>>>0>P>>>0){E=F;I=q;do{E=E-4|0;R=c[E>>2]|0;S=c[e>>2]|0;c[e>>2]=S+4;c[S>>2]=R;I=I-1|0;T=(I|0)>0;}while(E>>>0>P>>>0&T);if(T){U=I;V=E;W=35}else{X=0;Y=I;Z=E}}else{U=q;V=F;W=35}if((W|0)==35){W=0;X=cS[c[(c[r>>2]|0)+44>>2]&1023](i,48)|0;Y=U;Z=V}R=c[e>>2]|0;c[e>>2]=R+4;if((Y|0)>0){S=Y;_=R;while(1){c[_>>2]=X;$=S-1|0;aa=c[e>>2]|0;c[e>>2]=aa+4;if(($|0)>0){S=$;_=aa}else{ab=aa;break}}}else{ab=R}c[ab>>2]=l;ac=Z}else{ac=F}if((ac|0)==(P|0)){_=cS[c[(c[r>>2]|0)+44>>2]&1023](i,48)|0;S=c[e>>2]|0;c[e>>2]=S+4;c[S>>2]=_}else{_=a[z]|0;S=_&255;if((S&1|0)==0){ad=S>>>1}else{ad=c[C>>2]|0}if((ad|0)==0){ae=ac;af=0;ag=0;ah=-1}else{if((_&1)==0){ai=A}else{ai=c[B>>2]|0}ae=ac;af=0;ag=0;ah=a[ai]|0}while(1){do{if((af|0)==(ah|0)){_=c[e>>2]|0;c[e>>2]=_+4;c[_>>2]=m;_=ag+1|0;S=a[z]|0;E=S&255;if((E&1|0)==0){aj=E>>>1}else{aj=c[C>>2]|0}if(_>>>0>=aj>>>0){ak=ah;al=_;am=0;break}E=(S&1)==0;if(E){an=A}else{an=c[B>>2]|0}if((a[an+_|0]|0)==127){ak=-1;al=_;am=0;break}if(E){ao=A}else{ao=c[B>>2]|0}ak=a[ao+_|0]|0;al=_;am=0}else{ak=ah;al=ag;am=af}}while(0);_=ae-4|0;E=c[_>>2]|0;S=c[e>>2]|0;c[e>>2]=S+4;c[S>>2]=E;if((_|0)==(P|0)){break}else{ae=_;af=am+1|0;ag=al;ah=ak}}}F=c[e>>2]|0;if((Q|0)==(F|0)){D=P;break L3}R=F-4|0;if(Q>>>0<R>>>0){ap=Q;aq=R}else{D=P;break L3}while(1){R=c[ap>>2]|0;c[ap>>2]=c[aq>>2];c[aq>>2]=R;R=ap+4|0;F=aq-4|0;if(R>>>0<F>>>0){ap=R;aq=F}else{D=P;break}}break};default:{D=n}}}while(0);P=g+1|0;if(P>>>0<4>>>0){n=D;g=P}else{break}}g=a[s]|0;s=g&255;D=(s&1|0)==0;if(D){ar=s>>>1}else{ar=c[t>>2]|0}if(ar>>>0>1>>>0){if((g&1)==0){as=t;at=t;au=t}else{g=c[u>>2]|0;as=g;at=g;au=g}if(D){av=s>>>1}else{av=c[t>>2]|0}t=as+(av<<2)|0;s=c[e>>2]|0;D=at+4|0;if((D|0)==(t|0)){aw=s}else{at=((as+(av-2<<2)+(-au|0)|0)>>>2)+1|0;au=s;av=D;while(1){c[au>>2]=c[av>>2];D=av+4|0;if((D|0)==(t|0)){break}else{au=au+4|0;av=D}}aw=s+(at<<2)|0}c[e>>2]=aw}aw=f&176;if((aw|0)==32){c[d>>2]=c[e>>2];return}else if((aw|0)==16){return}else{c[d>>2]=b;return}}function Hi(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0;e=i;i=i+64|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+24|0;o=e+32|0;p=e+40|0;q=e+48|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+4|0;i=i+7&-8;y=i;i=i+400|0;z=i;i=i+4|0;i=i+7&-8;A=i;i=i+4|0;i=i+7&-8;B=i;i=i+4|0;i=i+7&-8;C8(m,h);C=m|0;D=c[C>>2]|0;if((c[10068]|0)==-1){E=3}else{c[l>>2]=40272;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40272,l|0,512);if(!x){E=3}else{x=0}}L3:do{if((E|0)==3){l=(c[10069]|0)-1|0;F=c[D+8>>2]|0;do{if((c[D+12>>2]|0)-F>>2>>>0>l>>>0){G=c[F+(l<<2)>>2]|0;if((G|0)==0){break}H=G;I=k;J=a[I]|0;L=J&255;if((L&1|0)==0){M=L>>>1}else{M=c[k+4>>2]|0}if((M|0)==0){N=0}else{if((J&1)==0){O=k+4|0}else{O=c[k+8>>2]|0}J=c[O>>2]|0;L=(x=0,aK(c[(c[G>>2]|0)+44>>2]|0,H|0,45)|0);if(x){x=0;break L3}N=(J|0)==(L|0)}Ke(r|0,0,12)|0;Ke(t|0,0,12)|0;Ke(v|0,0,12)|0;x=0;aJ(2,g|0,N|0,m|0,n|0,o|0,p|0,q|0,s|0,u|0,w|0);do{if(!x){L=y|0;J=a[I]|0;G=J&255;P=(G&1|0)==0;if(P){Q=G>>>1}else{Q=c[k+4>>2]|0}R=c[w>>2]|0;if((Q|0)>(R|0)){if(P){S=G>>>1}else{S=c[k+4>>2]|0}G=d[v]|0;if((G&1|0)==0){T=G>>>1}else{T=c[u+4>>2]|0}G=d[t]|0;if((G&1|0)==0){U=G>>>1}else{U=c[s+4>>2]|0}V=(S-R<<1|1)+T+U|0}else{G=d[v]|0;if((G&1|0)==0){W=G>>>1}else{W=c[u+4>>2]|0}G=d[t]|0;if((G&1|0)==0){X=G>>>1}else{X=c[s+4>>2]|0}V=W+2+X|0}G=V+R|0;do{if(G>>>0>100>>>0){P=JW(G<<2)|0;Y=P;if((P|0)!=0){Z=Y;_=Y;$=J;E=46;break}x=0;aQ(4);if(x){x=0;aa=Y;break}Z=Y;_=Y;$=a[I]|0;E=46}else{Z=L;_=0;$=J;E=46}}while(0);do{if((E|0)==46){if(($&1)==0){ab=k+4|0;ac=k+4|0}else{J=c[k+8>>2]|0;ab=J;ac=J}J=$&255;if((J&1|0)==0){ad=J>>>1}else{ad=c[k+4>>2]|0}x=0;ay(4,Z|0,z|0,A|0,c[h+4>>2]|0,ac|0,ab+(ad<<2)|0,H|0,N|0,n|0,c[o>>2]|0,c[p>>2]|0,q|0,s|0,u|0,R|0);if(x){x=0;aa=_;break}c[B>>2]=c[f>>2];x=0;aG(52,b|0,B|0,Z|0,c[z>>2]|0,c[A>>2]|0,h|0,j|0);if(x){x=0;aa=_;break}if((_|0)==0){C$(u);C$(s);CP(q);ae=c[C>>2]|0;af=ae|0;ag=Cn(af)|0;i=e;return}JX(_);C$(u);C$(s);CP(q);ae=c[C>>2]|0;af=ae|0;ag=Cn(af)|0;i=e;return}}while(0);R=bQ(-1,-1)|0;J=R;R=K;if((aa|0)==0){ah=R;ai=J;break}JX(aa);ah=R;ai=J}else{x=0;J=bQ(-1,-1)|0;ah=K;ai=J}}while(0);C$(u);C$(s);CP(q);aj=ah;ak=ai;al=c[C>>2]|0;am=al|0;an=Cn(am)|0;ao=ak;ap=0;aq=ao;ar=aj;be(aq|0)}}while(0);l=ci(4)|0;JB(l);x=0;aP(144,l|0,28080,98);if(x){x=0;break}}}while(0);ai=bQ(-1,-1)|0;aj=K;ak=ai;al=c[C>>2]|0;am=al|0;an=Cn(am)|0;ao=ak;ap=0;aq=ao;ar=aj;be(aq|0)}function Hj(a){a=a|0;Cl(a|0);J2(a);return}function Hk(a){a=a|0;Cl(a|0);return}function Hl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=cm(f|0,1)|0;return d>>>(((d|0)!=-1|0)>>>0)|0}function Hm(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+16|0;j=d|0;k=j;Ke(k|0,0,12)|0;l=b;m=h;n=a[h]|0;if((n&1)==0){o=m+1|0;p=m+1|0}else{m=c[h+8>>2]|0;o=m;p=m}m=n&255;if((m&1|0)==0){q=m>>>1}else{q=c[h+4>>2]|0}h=o+q|0;do{if(p>>>0<h>>>0){q=p;do{x=0;aq(572,j|0,a[q]|0);if(x){x=0;r=12;break}q=q+1|0;}while(q>>>0<h>>>0);if((r|0)==12){q=bQ(-1,-1)|0;s=K;t=q;break}q=(e|0)==-1?-1:e<<1;if((a[k]&1)==0){u=q;r=16;break}v=c[j+8>>2]|0;w=q;r=17}else{u=(e|0)==-1?-1:e<<1;r=16}}while(0);if((r|0)==16){v=j+1|0;w=u;r=17}do{if((r|0)==17){u=(x=0,aS(32,w|0,f|0,g|0,v|0)|0);if(x){x=0;e=bQ(-1,-1)|0;s=K;t=e;break}Ke(l|0,0,12)|0;e=Kf(u|0)|0;k=u+e|0;if((e|0)>0){y=u}else{CP(j);i=d;return}while(1){x=0;aq(572,b|0,a[y]|0);if(x){x=0;break}u=y+1|0;if(u>>>0<k>>>0){y=u}else{r=25;break}}if((r|0)==25){CP(j);i=d;return}k=bQ(-1,-1)|0;u=K;CP(b);z=u;A=k;CP(j);B=A;C=0;D=B;E=z;be(D|0)}}while(0);z=s;A=t;CP(j);B=A;C=0;D=B;E=z;be(D|0)}function Hn(a,b){a=a|0;b=b|0;b_(((b|0)==-1?-1:b<<1)|0)|0;return}function Ho(a){a=a|0;Cl(a|0);J2(a);return}function Hp(a){a=a|0;Cl(a|0);return}function Hq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=cm(f|0,1)|0;return d>>>(((d|0)!=-1|0)>>>0)|0}function Hr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+224|0;j=d|0;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=r;t=i;i=i+8|0;u=i;i=i+8|0;Ke(s|0,0,12)|0;v=b;w=t|0;c[t+4>>2]=0;c[t>>2]=14680;y=a[h]|0;if((y&1)==0){z=h+4|0;A=h+4|0}else{B=c[h+8>>2]|0;z=B;A=B}B=y&255;if((B&1|0)==0){C=B>>>1}else{C=c[h+4>>2]|0}h=z+(C<<2)|0;L9:do{if(A>>>0<h>>>0){C=t;z=k|0;B=k+32|0;y=A;D=14680;L11:while(1){c[m>>2]=y;E=(x=0,aR(c[D+12>>2]|0,w|0,j|0,y|0,h|0,m|0,z|0,B|0,l|0)|0);if(x){x=0;F=24;break}G=c[m>>2]|0;if((E|0)==2|(G|0)==(y|0)){F=12;break}if(z>>>0<(c[l>>2]|0)>>>0){E=z;do{x=0;aq(572,r|0,a[E]|0);if(x){x=0;F=23;break L11}E=E+1|0;}while(E>>>0<(c[l>>2]|0)>>>0);H=c[m>>2]|0}else{H=G}if(H>>>0>=h>>>0){break L9}y=H;D=c[C>>2]|0}do{if((F|0)==12){C=ci(8)|0;x=0;aq(454,C|0,5840);if(x){x=0;D=bQ(-1,-1)|0;y=K;bl(C|0);I=y;J=D;break}x=0;aP(144,C|0,28096,336);if(x){x=0;C=bQ(-1,-1)|0;I=K;J=C;break}}else if((F|0)==24){C=bQ(-1,-1)|0;I=K;J=C}else if((F|0)==23){C=bQ(-1,-1)|0;I=K;J=C}}while(0);Cl(t|0);L=I;M=J;CP(r);N=M;O=0;P=N;Q=L;be(P|0)}}while(0);Cl(t|0);if((a[s]&1)==0){R=r+1|0}else{R=c[r+8>>2]|0}s=(x=0,aS(32,((e|0)==-1?-1:e<<1)|0,f|0,g|0,R|0)|0);if(x){x=0;R=bQ(-1,-1)|0;L=K;M=R;CP(r);N=M;O=0;P=N;Q=L;be(P|0)}Ke(v|0,0,12)|0;v=u|0;c[u+4>>2]=0;c[u>>2]=14624;R=Kf(s|0)|0;g=s+R|0;if((R|0)<1){S=u|0;Cl(S);CP(r);i=d;return}R=u;f=g;e=o|0;t=o+128|0;o=s;s=14624;L46:while(1){c[q>>2]=o;J=(x=0,aR(c[s+16>>2]|0,v|0,n|0,o|0,((f-o|0)>32?o+32|0:g)|0,q|0,e|0,t|0,p|0)|0);if(x){x=0;F=46;break}I=c[q>>2]|0;if((J|0)==2|(I|0)==(o|0)){F=35;break}if(e>>>0<(c[p>>2]|0)>>>0){J=e;do{x=0;aq(252,b|0,c[J>>2]|0);if(x){x=0;F=45;break L46}J=J+4|0;}while(J>>>0<(c[p>>2]|0)>>>0);T=c[q>>2]|0}else{T=I}if(T>>>0>=g>>>0){F=50;break}o=T;s=c[R>>2]|0}do{if((F|0)==45){R=bQ(-1,-1)|0;U=K;V=R}else if((F|0)==35){R=ci(8)|0;x=0;aq(454,R|0,5840);if(x){x=0;s=bQ(-1,-1)|0;T=K;bl(R|0);U=T;V=s;break}x=0;aP(144,R|0,28096,336);if(x){x=0;R=bQ(-1,-1)|0;U=K;V=R;break}}else if((F|0)==46){R=bQ(-1,-1)|0;U=K;V=R}else if((F|0)==50){S=u|0;Cl(S);CP(r);i=d;return}}while(0);Cl(u|0);C$(b);L=U;M=V;CP(r);N=M;O=0;P=N;Q=L;be(P|0)}function Hs(a,b){a=a|0;b=b|0;b_(((b|0)==-1?-1:b<<1)|0)|0;return}function Ht(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b>>2]=14072;d=b+8|0;e=c[d>>2]|0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}f=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=f;break}else{x=0}bQ(-1,-1,0)|0;g=b|0;Cl(g);bU()}}while(0);if((e|0)==(c[9712]|0)){h=b|0;Cl(h);return}x=0;ap(584,c[d>>2]|0);if(!x){h=b|0;Cl(h);return}else{x=0}bQ(-1,-1,0)|0;g=b|0;Cl(g);bU()}function Hu(a){a=a|0;var b=0;a=ci(8)|0;x=0;aq(604,a|0,9848);if(!x){c[a>>2]=13008;bH(a|0,28128,466)}else{x=0;b=bQ(-1,-1)|0;bl(a|0);be(b|0)}}function Hv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;i=i+448|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;y=e+272|0;z=e+288|0;A=e+304|0;B=e+320|0;C=e+336|0;D=e+352|0;E=e+368|0;F=e+384|0;G=e+400|0;H=e+416|0;I=e+432|0;c[b+4>>2]=d-1;c[b>>2]=14328;d=b+8|0;J=b+12|0;L=b+136|0;a[L]=1;M=b+24|0;N=M;c[J>>2]=N;c[d>>2]=N;c[b+16>>2]=M+112;M=28;O=N;do{if((O|0)==0){P=0}else{c[O>>2]=0;P=c[J>>2]|0}O=P+4|0;c[J>>2]=O;M=M-1|0;}while((M|0)!=0);M=b+144|0;x=0;aP(88,M|0,9592,1);if(!x){O=c[d>>2]|0;P=c[J>>2]|0;if((O|0)!=(P|0)){c[J>>2]=P+(~((P-4+(-O|0)|0)>>>2)<<2)}c[9745]=0;c[9744]=14032;if((c[9990]|0)==-1){Q=10}else{c[I>>2]=39960;c[I+4>>2]=454;c[I+8>>2]=0;x=0;aP(2,39960,I|0,512);if(!x){Q=10}else{x=0;Q=111}}L14:do{if((Q|0)==10){x=0;aP(250,b|0,38976,(c[9991]|0)-1|0);if(x){x=0;Q=111;break}c[9743]=0;c[9742]=13992;if((c[9988]|0)!=-1){c[H>>2]=39952;c[H+4>>2]=454;c[H+8>>2]=0;x=0;aP(2,39952,H|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38968,(c[9989]|0)-1|0);if(x){x=0;Q=111;break}c[9795]=0;c[9794]=14440;c[9796]=0;a[39188]=0;I=(x=0,aN(8)|0);if(x){x=0;bQ(-1,-1,0)|0;bU()}c[9796]=c[I>>2];if((c[10070]|0)!=-1){c[G>>2]=40280;c[G+4>>2]=454;c[G+8>>2]=0;x=0;aP(2,40280,G|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,39176,(c[10071]|0)-1|0);if(x){x=0;Q=111;break}c[9793]=0;c[9792]=14360;if((c[10068]|0)!=-1){c[F>>2]=40272;c[F+4>>2]=454;c[F+8>>2]=0;x=0;aP(2,40272,F|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,39168,(c[10069]|0)-1|0);if(x){x=0;Q=111;break}c[9747]=0;c[9746]=14128;if((c[9994]|0)!=-1){c[E>>2]=39976;c[E+4>>2]=454;c[E+8>>2]=0;x=0;aP(2,39976,E|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38984,(c[9995]|0)-1|0);if(x){x=0;Q=111;break}c[3139]=0;c[3138]=14072;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}I=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=I;break}else{x=0;I=bQ(-1,-1)|0;O=K;Cl(12552);R=O;S=I;break L14}}}while(0);c[3140]=c[9712];if((c[9992]|0)!=-1){c[D>>2]=39968;c[D+4>>2]=454;c[D+8>>2]=0;x=0;aP(2,39968,D|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,12552,(c[9993]|0)-1|0);if(x){x=0;Q=111;break}c[9749]=0;c[9748]=14184;if((c[9996]|0)!=-1){c[C>>2]=39984;c[C+4>>2]=454;c[C+8>>2]=0;x=0;aP(2,39984,C|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38992,(c[9997]|0)-1|0);if(x){x=0;Q=111;break}c[9751]=0;c[9750]=14240;if((c[9998]|0)!=-1){c[B>>2]=39992;c[B+4>>2]=454;c[B+8>>2]=0;x=0;aP(2,39992,B|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,39e3,(c[9999]|0)-1|0);if(x){x=0;Q=111;break}c[9725]=0;c[9724]=13536;a[38904]=46;a[38905]=44;Ke(38908,0,12)|0;if((c[9974]|0)!=-1){c[A>>2]=39896;c[A+4>>2]=454;c[A+8>>2]=0;x=0;aP(2,39896,A|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38896,(c[9975]|0)-1|0);if(x){x=0;Q=111;break}c[3131]=0;c[3130]=13488;c[3132]=46;c[3133]=44;Ke(12536,0,12)|0;if((c[9972]|0)!=-1){c[z>>2]=39888;c[z+4>>2]=454;c[z+8>>2]=0;x=0;aP(2,39888,z|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,12520,(c[9973]|0)-1|0);if(x){x=0;Q=111;break}c[9741]=0;c[9740]=13920;if((c[9986]|0)!=-1){c[y>>2]=39944;c[y+4>>2]=454;c[y+8>>2]=0;x=0;aP(2,39944,y|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38960,(c[9987]|0)-1|0);if(x){x=0;Q=111;break}c[9739]=0;c[9738]=13848;if((c[9984]|0)!=-1){c[w>>2]=39936;c[w+4>>2]=454;c[w+8>>2]=0;x=0;aP(2,39936,w|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38952,(c[9985]|0)-1|0);if(x){x=0;Q=111;break}c[9737]=0;c[9736]=13784;if((c[9982]|0)!=-1){c[v>>2]=39928;c[v+4>>2]=454;c[v+8>>2]=0;x=0;aP(2,39928,v|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38944,(c[9983]|0)-1|0);if(x){x=0;Q=111;break}c[9735]=0;c[9734]=13720;if((c[9980]|0)!=-1){c[u>>2]=39920;c[u+4>>2]=454;c[u+8>>2]=0;x=0;aP(2,39920,u|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38936,(c[9981]|0)-1|0);if(x){x=0;Q=111;break}c[9805]=0;c[9804]=15632;if((c[10190]|0)!=-1){c[t>>2]=40760;c[t+4>>2]=454;c[t+8>>2]=0;x=0;aP(2,40760,t|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,39216,(c[10191]|0)-1|0);if(x){x=0;Q=111;break}c[9803]=0;c[9802]=15568;if((c[10188]|0)!=-1){c[s>>2]=40752;c[s+4>>2]=454;c[s+8>>2]=0;x=0;aP(2,40752,s|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,39208,(c[10189]|0)-1|0);if(x){x=0;Q=111;break}c[9801]=0;c[9800]=15504;if((c[10186]|0)!=-1){c[r>>2]=40744;c[r+4>>2]=454;c[r+8>>2]=0;x=0;aP(2,40744,r|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,39200,(c[10187]|0)-1|0);if(x){x=0;Q=111;break}c[9799]=0;c[9798]=15440;if((c[10184]|0)!=-1){c[q>>2]=40736;c[q+4>>2]=454;c[q+8>>2]=0;x=0;aP(2,40736,q|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,39192,(c[10185]|0)-1|0);if(x){x=0;Q=111;break}c[9723]=0;c[9722]=13192;if((c[9962]|0)!=-1){c[p>>2]=39848;c[p+4>>2]=454;c[p+8>>2]=0;x=0;aP(2,39848,p|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38888,(c[9963]|0)-1|0);if(x){x=0;Q=111;break}c[9721]=0;c[9720]=13152;if((c[9960]|0)!=-1){c[o>>2]=39840;c[o+4>>2]=454;c[o+8>>2]=0;x=0;aP(2,39840,o|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38880,(c[9961]|0)-1|0);if(x){x=0;Q=111;break}c[9719]=0;c[9718]=13112;if((c[9958]|0)!=-1){c[n>>2]=39832;c[n+4>>2]=454;c[n+8>>2]=0;x=0;aP(2,39832,n|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38872,(c[9959]|0)-1|0);if(x){x=0;Q=111;break}c[9717]=0;c[9716]=13072;if((c[9956]|0)!=-1){c[m>>2]=39824;c[m+4>>2]=454;c[m+8>>2]=0;x=0;aP(2,39824,m|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38864,(c[9957]|0)-1|0);if(x){x=0;Q=111;break}c[3127]=0;c[3126]=13392;c[3128]=13440;if((c[9970]|0)!=-1){c[l>>2]=39880;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,39880,l|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,12504,(c[9971]|0)-1|0);if(x){x=0;Q=111;break}c[3123]=0;c[3122]=13296;c[3124]=13344;if((c[9968]|0)!=-1){c[k>>2]=39872;c[k+4>>2]=454;c[k+8>>2]=0;x=0;aP(2,39872,k|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,12488,(c[9969]|0)-1|0);if(x){x=0;Q=111;break}c[3119]=0;c[3118]=14296;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}I=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=I;break}else{x=0;I=bQ(-1,-1)|0;O=K;Cl(12472);R=O;S=I;break L14}}}while(0);c[3120]=c[9712];c[3118]=13264;if((c[9966]|0)!=-1){c[j>>2]=39864;c[j+4>>2]=454;c[j+8>>2]=0;x=0;aP(2,39864,j|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,12472,(c[9967]|0)-1|0);if(x){x=0;Q=111;break}c[3115]=0;c[3114]=14296;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}I=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=I;break}else{x=0;I=bQ(-1,-1)|0;O=K;Cl(12456);R=O;S=I;break L14}}}while(0);c[3116]=c[9712];c[3114]=13232;if((c[9964]|0)!=-1){c[h>>2]=39856;c[h+4>>2]=454;c[h+8>>2]=0;x=0;aP(2,39856,h|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,12456,(c[9965]|0)-1|0);if(x){x=0;Q=111;break}c[9733]=0;c[9732]=13624;if((c[9978]|0)!=-1){c[g>>2]=39912;c[g+4>>2]=454;c[g+8>>2]=0;x=0;aP(2,39912,g|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38928,(c[9979]|0)-1|0);if(x){x=0;Q=111;break}c[9731]=0;c[9730]=13584;if((c[9976]|0)!=-1){c[f>>2]=39904;c[f+4>>2]=454;c[f+8>>2]=0;x=0;aP(2,39904,f|0,512);if(x){x=0;Q=111;break}}x=0;aP(250,b|0,38920,(c[9977]|0)-1|0);if(x){x=0;Q=111;break}i=e;return}}while(0);if((Q|0)==111){Q=bQ(-1,-1)|0;R=K;S=Q}CP(M);T=R;U=S}else{x=0;S=bQ(-1,-1)|0;T=K;U=S}S=c[d>>2]|0;if((S|0)==0){V=b|0;Cl(V);W=U;X=0;Y=W;Z=T;be(Y|0)}d=c[J>>2]|0;if((S|0)!=(d|0)){c[J>>2]=d+(~((d-4+(-S|0)|0)>>>2)<<2)}if((S|0)==(b+24|0)){a[L]=0;V=b|0;Cl(V);W=U;X=0;Y=W;Z=T;be(Y|0)}else{J2(S);V=b|0;Cl(V);W=U;X=0;Y=W;Z=T;be(Y|0)}}function Hw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=b|0;Cm(e);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f|0;i=c[h>>2]|0;j=a-i>>2;do{if(j>>>0>d>>>0){k=i}else{l=d+1|0;if(j>>>0>=l>>>0){if(j>>>0<=l>>>0){k=i;break}m=i+(l<<2)|0;if((m|0)==(a|0)){k=i;break}c[g>>2]=a+(~((a-4+(-m|0)|0)>>>2)<<2);k=i;break}x=0;aq(184,f|0,l-j|0);if(!x){k=c[h>>2]|0;break}else{x=0}l=bQ(-1,-1)|0;if((b|0)==0){be(l|0)}Cn(e)|0;be(l|0)}}while(0);e=c[k+(d<<2)>>2]|0;if((e|0)==0){n=k;o=n+(d<<2)|0;c[o>>2]=b;return}Cn(e|0)|0;n=c[h>>2]|0;o=n+(d<<2)|0;c[o>>2]=b;return}function Hx(a){a=a|0;Hy(a);J2(a);return}function Hy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c[b>>2]=14328;d=b+12|0;e=c[d>>2]|0;f=b+8|0;g=c[f>>2]|0;if((e|0)!=(g|0)){h=0;i=g;g=e;while(1){e=c[i+(h<<2)>>2]|0;if((e|0)==0){j=g;k=i}else{Cn(e|0)|0;j=c[d>>2]|0;k=c[f>>2]|0}e=h+1|0;if(e>>>0<j-k>>2>>>0){h=e;i=k;g=j}else{break}}}CP(b+144|0);j=c[f>>2]|0;if((j|0)==0){l=b|0;Cl(l);return}f=c[d>>2]|0;if((j|0)!=(f|0)){c[d>>2]=f+(~((f-4+(-j|0)|0)>>>2)<<2)}if((j|0)==(b+24|0)){a[b+136|0]=0;l=b|0;Cl(l);return}else{J2(j);l=b|0;Cl(l);return}}function Hz(){var b=0,d=0;if((a[40824]|0)!=0){b=c[9704]|0;return b|0}if((bz(40824)|0)==0){b=c[9704]|0;return b|0}do{if((a[40832]|0)==0){if((bz(40832)|0)==0){break}x=0;aq(242,39008,1);if(!x){c[9708]=39008;c[9706]=38832;break}else{x=0;d=bQ(-1,-1)|0;be(d|0)}}}while(0);d=c[c[9706]>>2]|0;c[9710]=d;Cm(d|0);c[9704]=38840;b=c[9704]|0;return b|0}function HA(a){a=a|0;var b=0,d=0;b=(x=0,aN(4)|0);if(!x){d=c[b>>2]|0;c[a>>2]=d;Cm(d|0);return}else{x=0;bQ(-1,-1,0)|0;bU()}}function HB(a,b){a=a|0;b=b|0;var d=0;d=c[b>>2]|0;c[a>>2]=d;Cm(d|0);return}function HC(a){a=a|0;Cn(c[a>>2]|0)|0;return}function HD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d|0;f=c[a>>2]|0;a=b|0;if((c[a>>2]|0)!=-1){c[e>>2]=b;c[e+4>>2]=454;c[e+8>>2]=0;CI(a,e,512)}e=(c[b+4>>2]|0)-1|0;b=c[f+8>>2]|0;if((c[f+12>>2]|0)-b>>2>>>0<=e>>>0){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function HE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d|0;f=c[a>>2]|0;a=b|0;if((c[a>>2]|0)!=-1){c[e>>2]=b;c[e+4>>2]=454;c[e+8>>2]=0;CI(a,e,512)}e=(c[b+4>>2]|0)-1|0;b=c[f+8>>2]|0;if((c[f+12>>2]|0)-b>>2>>>0<=e>>>0){g=ci(4)|0;h=g;JB(h);bH(g|0,28080,98);return 0}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=ci(4)|0;h=g;JB(h);bH(g|0,28080,98);return 0}else{i=d;return f|0}return 0}function HF(a){a=a|0;Cl(a|0);J2(a);return}function HG(a){a=a|0;if((a|0)==0){return}cx[c[(c[a>>2]|0)+4>>2]&1023](a);return}function HH(a){a=a|0;c[a+4>>2]=(I=c[1e4]|0,c[1e4]=I+1,I)+1;return}function HI(a){a=a|0;Cl(a|0);J2(a);return}function HJ(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;if(e>>>0>=128>>>0){f=0;return f|0}a=(x=0,aN(8)|0);if(x){x=0;bQ(-1,-1,0)|0;bU();return 0}f=(b[(c[a>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;return f|0}function HK(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;if((d|0)==(e|0)){g=d;return g|0}else{h=d;i=f}while(1){f=c[h>>2]|0;if(f>>>0<128>>>0){d=(x=0,aN(8)|0);if(x){x=0;j=4;break}k=b[(c[d>>2]|0)+(f<<1)>>1]|0}else{k=0}b[i>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;j=9;break}else{h=f;i=i+2|0}}if((j|0)==4){bQ(-1,-1,0)|0;bU();return 0}else if((j|0)==9){return g|0}return 0}function HL(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((e|0)==(f|0)){g=e;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128>>>0){a=(x=0,aN(8)|0);if(x){x=0;i=4;break}if((b[(c[a>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0){g=h;i=8;break}}e=h+4|0;if((e|0)==(f|0)){g=f;i=10;break}else{h=e}}if((i|0)==4){bQ(-1,-1,0)|0;bU();return 0}else if((i|0)==8){return g|0}else if((i|0)==10){return g|0}return 0}function HM(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=e;while(1){if((a|0)==(f|0)){g=f;h=8;break}e=c[a>>2]|0;if(e>>>0>=128>>>0){g=a;h=10;break}i=(x=0,aN(8)|0);if(x){x=0;h=5;break}if((b[(c[i>>2]|0)+(e<<1)>>1]&d)<<16>>16==0){g=a;h=9;break}else{a=a+4|0}}if((h|0)==5){bQ(-1,-1,0)|0;bU();return 0}else if((h|0)==8){return g|0}else if((h|0)==9){return g|0}else if((h|0)==10){return g|0}return 0}function HN(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>=128>>>0){d=b;return d|0}a=(x=0,aN(6)|0);if(x){x=0;bQ(-1,-1,0)|0;bU();return 0}d=c[(c[a>>2]|0)+(b<<2)>>2]|0;return d|0}function HO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((b|0)==(d|0)){e=b;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128>>>0){a=(x=0,aN(6)|0);if(x){x=0;g=4;break}h=c[(c[a>>2]|0)+(b<<2)>>2]|0}else{h=b}c[f>>2]=h;b=f+4|0;if((b|0)==(d|0)){e=d;g=8;break}else{f=b}}if((g|0)==4){bQ(-1,-1,0)|0;bU();return 0}else if((g|0)==8){return e|0}return 0}function HP(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>=128>>>0){d=b;return d|0}a=(x=0,aN(2)|0);if(x){x=0;bQ(-1,-1,0)|0;bU();return 0}d=c[(c[a>>2]|0)+(b<<2)>>2]|0;return d|0}function HQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((b|0)==(d|0)){e=b;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128>>>0){a=(x=0,aN(2)|0);if(x){x=0;g=4;break}h=c[(c[a>>2]|0)+(b<<2)>>2]|0}else{h=b}c[f>>2]=h;b=f+4|0;if((b|0)==(d|0)){e=d;g=8;break}else{f=b}}if((g|0)==4){bQ(-1,-1,0)|0;bU();return 0}else if((g|0)==8){return e|0}return 0}function HR(a,b){a=a|0;b=b|0;return b<<24>>24|0}function HS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((d|0)==(e|0)){g=d;return g|0}else{h=d;i=f}while(1){c[i>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{h=f;i=i+4|0}}return g|0}function HT(a,b,c){a=a|0;b=b|0;c=c|0;return(b>>>0<128>>>0?b&255:c)|0}function HU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;if((d|0)==(e|0)){h=d;return h|0}b=((e-4+(-d|0)|0)>>>2)+1|0;i=d;j=g;while(1){g=c[i>>2]|0;a[j]=g>>>0<128>>>0?g&255:f;g=i+4|0;if((g|0)==(e|0)){break}else{i=g;j=j+1|0}}h=d+(b<<2)|0;return h|0}function HV(b){b=b|0;var d=0;c[b>>2]=14440;d=c[b+8>>2]|0;do{if((d|0)!=0){if((a[b+12|0]&1)==0){break}J3(d)}}while(0);Cl(b|0);J2(b);return}function HW(b){b=b|0;var d=0;c[b>>2]=14440;d=c[b+8>>2]|0;do{if((d|0)!=0){if((a[b+12|0]&1)==0){break}J3(d)}}while(0);Cl(b|0);return}function HX(a,b){a=a|0;b=b|0;var d=0;if(b<<24>>24<0){d=b;return d|0}a=(x=0,aN(6)|0);if(x){x=0;bQ(-1,-1,0)|0;bU();return 0}d=c[(c[a>>2]|0)+((b&255)<<2)>>2]&255;return d|0}function HY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if((d|0)==(e|0)){f=d;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24<0){h=d}else{b=(x=0,aN(6)|0);if(x){x=0;i=4;break}h=c[(c[b>>2]|0)+(d<<24>>24<<2)>>2]&255}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;i=8;break}else{g=d}}if((i|0)==8){return f|0}else if((i|0)==4){bQ(-1,-1,0)|0;bU();return 0}return 0}function HZ(a,b){a=a|0;b=b|0;var d=0;if(b<<24>>24<0){d=b;return d|0}a=(x=0,aN(2)|0);if(x){x=0;bQ(-1,-1,0)|0;bU();return 0}d=c[(c[a>>2]|0)+(b<<24>>24<<2)>>2]&255;return d|0}function H_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if((d|0)==(e|0)){f=d;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24<0){h=d}else{b=(x=0,aN(2)|0);if(x){x=0;i=4;break}h=c[(c[b>>2]|0)+(d<<24>>24<<2)>>2]&255}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;i=8;break}else{g=d}}if((i|0)==8){return f|0}else if((i|0)==4){bQ(-1,-1,0)|0;bU();return 0}return 0}function H$(a,b){a=a|0;b=b|0;return b|0}function H0(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((c|0)==(d|0)){f=c;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{g=e;h=h+1|0}}return f|0}function H1(a,b,c){a=a|0;b=b|0;c=c|0;return(b<<24>>24<0?c:b)|0}function H2(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;if((c|0)==(d|0)){g=c;return g|0}else{h=c;i=f}while(1){f=a[h]|0;a[i]=f<<24>>24<0?e:f;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{h=f;i=i+1|0}}return g|0}function H3(a){a=a|0;Cl(a|0);J2(a);return}function H4(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function H5(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function H6(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function H7(a){a=a|0;return 1}function H8(a){a=a|0;return 1}function H9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return(b>>>0<e>>>0?b:e)|0}function Ia(a){a=a|0;return 1}function Ib(a){a=a|0;Ht(a);J2(a);return}function Ic(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;l=i;i=i+8|0;m=l|0;n=m;o=i;i=i+4|0;i=i+7&-8;p=e;while(1){if((p|0)==(f|0)){q=f;break}if((c[p>>2]|0)==0){q=p;break}else{p=p+4|0}}c[k>>2]=h;c[g>>2]=e;L5:do{if((e|0)==(f|0)|(h|0)==(j|0)){r=e}else{p=d;s=j;t=b+8|0;u=o|0;v=h;w=e;y=q;while(1){z=c[p+4>>2]|0;c[m>>2]=c[p>>2];c[m+4>>2]=z;A=b3(c[t>>2]|0)|0;z=(x=0,aO(16,v|0,g|0,y-w>>2|0,s-v|0,d|0)|0);if(x){x=0;B=10;break}if((A|0)!=0){x=0,as(32,A|0)|0;if(x){x=0;B=9;break}}if((z|0)==(-1|0)){B=15;break}else if((z|0)==0){C=1;B=57;break}D=(c[k>>2]|0)+z|0;c[k>>2]=D;if((D|0)==(j|0)){B=48;break}if((y|0)==(f|0)){E=f;F=D;G=c[g>>2]|0}else{H=b3(c[t>>2]|0)|0;D=(x=0,ax(54,u|0,0,d|0)|0);if(x){x=0;B=34;break}if((H|0)!=0){x=0,as(32,H|0)|0;if(x){x=0;B=33;break}}if((D|0)==-1){C=2;B=59;break}z=c[k>>2]|0;if(D>>>0>(s-z|0)>>>0){C=1;B=60;break}L24:do{if((D|0)!=0){I=D;J=u;K=z;while(1){L=a[J]|0;c[k>>2]=K+1;a[K]=L;L=I-1|0;if((L|0)==0){break L24}I=L;J=J+1|0;K=c[k>>2]|0}}}while(0);z=(c[g>>2]|0)+4|0;c[g>>2]=z;D=z;while(1){if((D|0)==(f|0)){M=f;break}if((c[D>>2]|0)==0){M=D;break}else{D=D+4|0}}E=M;F=c[k>>2]|0;G=z}if((G|0)==(f|0)|(F|0)==(j|0)){r=G;break L5}else{v=F;w=G;y=E}}if((B|0)==10){y=bQ(-1,-1)|0;if((A|0)==0){be(y|0)}x=0,as(32,A|0)|0;if(!x){be(y|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else if((B|0)==15){c[k>>2]=v;L43:do{if((w|0)==(c[g>>2]|0)){N=w}else{y=w;u=v;while(1){s=c[y>>2]|0;O=b3(c[t>>2]|0)|0;p=(x=0,ax(54,u|0,s|0,n|0)|0);if(x){x=0;break}if((O|0)!=0){x=0,as(32,O|0)|0;if(x){x=0;B=19;break}}if((p|0)==-1){N=y;break L43}s=(c[k>>2]|0)+p|0;c[k>>2]=s;p=y+4|0;if((p|0)==(c[g>>2]|0)){N=p;break L43}else{y=p;u=s}}if((B|0)==19){bQ(-1,-1,0)|0;bU();return 0}u=bQ(-1,-1)|0;if((O|0)==0){be(u|0)}x=0,as(32,O|0)|0;if(!x){be(u|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);c[g>>2]=N;C=2;i=l;return C|0}else if((B|0)==33){bQ(-1,-1,0)|0;bU();return 0}else if((B|0)==34){t=bQ(-1,-1)|0;if((H|0)==0){be(t|0)}x=0,as(32,H|0)|0;if(!x){be(t|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else if((B|0)==48){r=c[g>>2]|0;break}else if((B|0)==57){i=l;return C|0}else if((B|0)==59){i=l;return C|0}else if((B|0)==60){i=l;return C|0}else if((B|0)==9){bQ(-1,-1,0)|0;bU();return 0}}}while(0);C=(r|0)!=(f|0)|0;i=l;return C|0}function Id(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;l=i;i=i+8|0;m=l|0;n=m;o=e;while(1){if((o|0)==(f|0)){p=f;break}if((a[o]|0)==0){p=o;break}else{o=o+1|0}}c[k>>2]=h;c[g>>2]=e;L5:do{if((e|0)==(f|0)|(h|0)==(j|0)){q=e}else{o=d;r=j;s=b+8|0;t=h;u=e;v=p;while(1){w=c[o+4>>2]|0;c[m>>2]=c[o>>2];c[m+4>>2]=w;y=v;z=b3(c[s>>2]|0)|0;w=(x=0,aO(6,t|0,g|0,y-u|0,r-t>>2|0,d|0)|0);if(x){x=0;A=10;break}if((z|0)!=0){x=0,as(32,z|0)|0;if(x){x=0;A=9;break}}if((w|0)==(-1|0)){A=15;break}else if((w|0)==0){B=2;A=56;break}C=(c[k>>2]|0)+(w<<2)|0;c[k>>2]=C;if((C|0)==(j|0)){A=47;break}w=c[g>>2]|0;if((v|0)==(f|0)){D=f;E=C;F=w}else{G=b3(c[s>>2]|0)|0;H=(x=0,aS(36,C|0,w|0,1,d|0)|0);if(x){x=0;A=37;break}if((G|0)!=0){x=0,as(32,G|0)|0;if(x){x=0;A=36;break}}if((H|0)!=0){B=2;A=60;break}c[k>>2]=(c[k>>2]|0)+4;H=(c[g>>2]|0)+1|0;c[g>>2]=H;w=H;while(1){if((w|0)==(f|0)){I=f;break}if((a[w]|0)==0){I=w;break}else{w=w+1|0}}D=I;E=c[k>>2]|0;F=H}if((F|0)==(f|0)|(E|0)==(j|0)){q=F;break L5}else{t=E;u=F;v=D}}if((A|0)==9){bQ(-1,-1,0)|0;bU();return 0}else if((A|0)==10){v=bQ(-1,-1)|0;if((z|0)==0){be(v|0)}x=0,as(32,z|0)|0;if(!x){be(v|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else if((A|0)==15){c[k>>2]=t;L37:do{if((u|0)==(c[g>>2]|0)){J=u}else{v=t;r=u;while(1){K=b3(c[s>>2]|0)|0;o=(x=0,aS(36,v|0,r|0,y-r|0,n|0)|0);if(x){x=0;A=20;break}if((K|0)!=0){x=0,as(32,K|0)|0;if(x){x=0;A=19;break}}if((o|0)==0){L=r+1|0}else if((o|0)==(-1|0)){A=26;break}else if((o|0)==(-2|0)){A=27;break}else{L=r+o|0}o=(c[k>>2]|0)+4|0;c[k>>2]=o;if((L|0)==(c[g>>2]|0)){J=L;break L37}else{v=o;r=L}}if((A|0)==19){bQ(-1,-1,0)|0;bU();return 0}else if((A|0)==20){v=bQ(-1,-1)|0;if((K|0)==0){be(v|0)}x=0,as(32,K|0)|0;if(!x){be(v|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else if((A|0)==26){c[g>>2]=r;B=2;i=l;return B|0}else if((A|0)==27){c[g>>2]=r;B=1;i=l;return B|0}}}while(0);c[g>>2]=J;B=(J|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==36){bQ(-1,-1,0)|0;bU();return 0}else if((A|0)==37){s=bQ(-1,-1)|0;if((G|0)==0){be(s|0)}x=0,as(32,G|0)|0;if(!x){be(s|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else if((A|0)==47){q=c[g>>2]|0;break}else if((A|0)==56){i=l;return B|0}else if((A|0)==60){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function Ie(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h|0;j=b3(c[b+8>>2]|0)|0;b=(x=0,ax(54,e|0,0,d|0)|0);if(x){x=0;d=bQ(-1,-1)|0;if((j|0)==0){be(d|0)}x=0,as(32,j|0)|0;if(!x){be(d|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}do{if((j|0)!=0){x=0,as(32,j|0)|0;if(!x){break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}}while(0);if((b|0)==(-1|0)|(b|0)==0){k=2;i=h;return k|0}j=b-1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=j;m=e;n=b}while(1){b=a[m]|0;c[g>>2]=n+1;a[n]=b;b=l-1|0;if((b|0)==0){k=0;break}l=b;m=m+1|0;n=c[g>>2]|0}i=h;return k|0}function If(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+8|0;a=(x=0,as(32,c[b>>2]|0)|0);do{if(!x){d=(x=0,ax(38,0,0,4)|0);if(x){x=0;bQ(-1,-1,0)|0;if((a|0)==0){bU();return 0}x=0,as(32,a|0)|0;if(!x){bU();return 0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}do{if((a|0)!=0){x=0,as(32,a|0)|0;if(!x){break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}}while(0);if((d|0)!=0){e=-1;return e|0}f=c[b>>2]|0;if((f|0)==0){e=1;return e|0}g=(x=0,as(32,f|0)|0);if(x){x=0;break}if((g|0)==0){e=0;return e|0}x=0,as(32,g|0)|0;if(!x){e=0;return e|0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{x=0}}while(0);bQ(-1,-1,0)|0;bU();return 0}function Ig(a){a=a|0;return 0}function Ih(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if((f|0)==0|(d|0)==(e|0)){g=0;return g|0}h=e;i=a+8|0;a=d;d=0;j=0;while(1){k=b3(c[i>>2]|0)|0;l=(x=0,ax(2,a|0,h-a|0,b|0)|0);if(x){x=0;m=7;break}if((k|0)!=0){x=0,as(32,k|0)|0;if(x){x=0;m=6;break}}if((l|0)==(-1|0)|(l|0)==(-2|0)){g=d;m=16;break}else if((l|0)==0){n=1;o=a+1|0}else{n=l;o=a+l|0}l=n+d|0;p=j+1|0;if(p>>>0>=f>>>0|(o|0)==(e|0)){g=l;m=18;break}else{a=o;d=l;j=p}}if((m|0)==16){return g|0}else if((m|0)==6){bQ(-1,-1,0)|0;bU();return 0}else if((m|0)==18){return g|0}else if((m|0)==7){m=bQ(-1,-1)|0;if((k|0)==0){be(m|0)}x=0,as(32,k|0)|0;if(!x){be(m|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}return 0}function Ii(a){a=a|0;var b=0,d=0;b=c[a+8>>2]|0;if((b|0)==0){d=1;return d|0}a=(x=0,as(32,b|0)|0);if(x){x=0;bQ(-1,-1,0)|0;bU();return 0}if((a|0)==0){d=4;return d|0}x=0,as(32,a|0)|0;if(!x){d=4;return d|0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function Ij(a){a=a|0;Cl(a|0);J2(a);return}function Ik(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Il(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Il(d,f,g,h,i,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0;c[g>>2]=d;c[j>>2]=h;do{if((l&2|0)!=0){if((i-h|0)<3){m=1;return m|0}else{c[j>>2]=h+1;a[h]=-17;d=c[j>>2]|0;c[j>>2]=d+1;a[d]=-69;d=c[j>>2]|0;c[j>>2]=d+1;a[d]=-65;break}}}while(0);h=f;l=c[g>>2]|0;if(l>>>0>=f>>>0){m=0;return m|0}d=i;i=l;L10:while(1){l=b[i>>1]|0;n=l&65535;if(n>>>0>k>>>0){m=2;o=33;break}do{if((l&65535)>>>0<128>>>0){p=c[j>>2]|0;if((d-p|0)<1){m=1;o=31;break L10}c[j>>2]=p+1;a[p]=l}else{if((l&65535)>>>0<2048>>>0){p=c[j>>2]|0;if((d-p|0)<2){m=1;o=37;break L10}c[j>>2]=p+1;a[p]=n>>>6|192;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n&63|128;break}if((l&65535)>>>0<55296>>>0){p=c[j>>2]|0;if((d-p|0)<3){m=1;o=39;break L10}c[j>>2]=p+1;a[p]=n>>>12|224;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n>>>6&63|128;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n&63|128;break}if((l&65535)>>>0>=56320>>>0){if((l&65535)>>>0<57344>>>0){m=2;o=35;break L10}p=c[j>>2]|0;if((d-p|0)<3){m=1;o=38;break L10}c[j>>2]=p+1;a[p]=n>>>12|224;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n>>>6&63|128;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n&63|128;break}if((h-i|0)<4){m=1;o=34;break L10}p=i+2|0;q=e[p>>1]|0;if((q&64512|0)!=56320){m=2;o=27;break L10}if((d-(c[j>>2]|0)|0)<4){m=1;o=30;break L10}r=n&960;if(((r<<10)+65536|n<<10&64512|q&1023)>>>0>k>>>0){m=2;o=28;break L10}c[g>>2]=p;p=(r>>>6)+1|0;r=c[j>>2]|0;c[j>>2]=r+1;a[r]=p>>>2|240;r=c[j>>2]|0;c[j>>2]=r+1;a[r]=n>>>2&15|p<<4&48|128;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=n<<4&48|q>>>6&15|128;p=c[j>>2]|0;c[j>>2]=p+1;a[p]=q&63|128}}while(0);n=(c[g>>2]|0)+2|0;c[g>>2]=n;if(n>>>0<f>>>0){i=n}else{m=0;o=29;break}}if((o|0)==30){return m|0}else if((o|0)==29){return m|0}else if((o|0)==27){return m|0}else if((o|0)==33){return m|0}else if((o|0)==31){return m|0}else if((o|0)==28){return m|0}else if((o|0)==35){return m|0}else if((o|0)==39){return m|0}else if((o|0)==34){return m|0}else if((o|0)==37){return m|0}else if((o|0)==38){return m|0}return 0}function Im(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=In(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function In(e,f,g,h,i,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c[g>>2]=e;c[j>>2]=h;h=c[g>>2]|0;do{if((l&4|0)==0){m=h}else{if((f-h|0)<=2){m=h;break}if((a[h]|0)!=-17){m=h;break}if((a[h+1|0]|0)!=-69){m=h;break}if((a[h+2|0]|0)!=-65){m=h;break}e=h+3|0;c[g>>2]=e;m=e}}while(0);L8:do{if(m>>>0<f>>>0){h=f;l=i;e=c[j>>2]|0;n=m;L10:while(1){if(e>>>0>=i>>>0){o=n;break L8}p=a[n]|0;q=p&255;if(q>>>0>k>>>0){r=2;s=52;break}do{if(p<<24>>24>-1){b[e>>1]=p&255;c[g>>2]=(c[g>>2]|0)+1}else{if((p&255)>>>0<194>>>0){r=2;s=54;break L10}if((p&255)>>>0<224>>>0){if((h-n|0)<2){r=1;s=48;break L10}t=d[n+1|0]|0;if((t&192|0)!=128){r=2;s=49;break L10}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=53;break L10}b[e>>1]=u;c[g>>2]=(c[g>>2]|0)+2;break}if((p&255)>>>0<240>>>0){if((h-n|0)<3){r=1;s=45;break L10}u=a[n+1|0]|0;t=a[n+2|0]|0;if((q|0)==224){if((u&-32)<<24>>24!=-96){r=2;s=46;break L10}}else if((q|0)==237){if((u&-32)<<24>>24!=-128){r=2;s=50;break L10}}else{if((u&-64)<<24>>24!=-128){r=2;s=42;break L10}}v=t&255;if((v&192|0)!=128){r=2;s=43;break L10}t=(u&255)<<6&4032|q<<12|v&63;if((t&65535)>>>0>k>>>0){r=2;s=51;break L10}b[e>>1]=t;c[g>>2]=(c[g>>2]|0)+3;break}if((p&255)>>>0>=245>>>0){r=2;s=60;break L10}if((h-n|0)<4){r=1;s=58;break L10}t=a[n+1|0]|0;v=a[n+2|0]|0;u=a[n+3|0]|0;if((q|0)==244){if((t&-16)<<24>>24!=-128){r=2;s=55;break L10}}else if((q|0)==240){if((t+112&255)>>>0>=48>>>0){r=2;s=57;break L10}}else{if((t&-64)<<24>>24!=-128){r=2;s=59;break L10}}w=v&255;if((w&192|0)!=128){r=2;s=44;break L10}v=u&255;if((v&192|0)!=128){r=2;s=56;break L10}if((l-e|0)<4){r=1;s=47;break L10}u=q&7;x=t&255;t=w<<6;y=v&63;if((x<<12&258048|u<<18|t&4032|y)>>>0>k>>>0){r=2;s=62;break L10}b[e>>1]=x<<2&60|w>>>4&3|((x>>>4&3|u<<2)<<6)+16320|55296;u=(c[j>>2]|0)+2|0;c[j>>2]=u;b[u>>1]=y|t&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);q=(c[j>>2]|0)+2|0;c[j>>2]=q;p=c[g>>2]|0;if(p>>>0<f>>>0){e=q;n=p}else{o=p;break L8}}if((s|0)==51){return r|0}else if((s|0)==52){return r|0}else if((s|0)==55){return r|0}else if((s|0)==56){return r|0}else if((s|0)==57){return r|0}else if((s|0)==46){return r|0}else if((s|0)==47){return r|0}else if((s|0)==60){return r|0}else if((s|0)==62){return r|0}else if((s|0)==42){return r|0}else if((s|0)==43){return r|0}else if((s|0)==44){return r|0}else if((s|0)==45){return r|0}else if((s|0)==48){return r|0}else if((s|0)==49){return r|0}else if((s|0)==50){return r|0}else if((s|0)==53){return r|0}else if((s|0)==54){return r|0}else if((s|0)==58){return r|0}else if((s|0)==59){return r|0}}else{o=m}}while(0);r=o>>>0<f>>>0|0;return r|0}function Io(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function Ip(a){a=a|0;return 0}function Iq(a){a=a|0;return 0}function Ir(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Is(c,d,e,1114111,0)|0}function Is(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;do{if((g&4|0)==0){h=b}else{if((c-b|0)<=2){h=b;break}if((a[b]|0)!=-17){h=b;break}if((a[b+1|0]|0)!=-69){h=b;break}h=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);L7:do{if(h>>>0<c>>>0&(e|0)!=0){g=c;i=0;j=h;L9:while(1){k=a[j]|0;l=k&255;if(l>>>0>f>>>0){m=j;break L7}do{if(k<<24>>24>-1){n=j+1|0;o=i}else{if((k&255)>>>0<194>>>0){m=j;break L7}if((k&255)>>>0<224>>>0){if((g-j|0)<2){m=j;break L7}p=d[j+1|0]|0;if((p&192|0)!=128){m=j;break L7}if((p&63|l<<6&1984)>>>0>f>>>0){m=j;break L7}n=j+2|0;o=i;break}if((k&255)>>>0<240>>>0){q=j;if((g-q|0)<3){m=j;break L7}p=a[j+1|0]|0;r=a[j+2|0]|0;if((l|0)==224){if((p&-32)<<24>>24!=-96){s=21;break L9}}else if((l|0)==237){if((p&-32)<<24>>24!=-128){s=23;break L9}}else{if((p&-64)<<24>>24!=-128){s=25;break L9}}t=r&255;if((t&192|0)!=128){m=j;break L7}if(((p&255)<<6&4032|l<<12&61440|t&63)>>>0>f>>>0){m=j;break L7}n=j+3|0;o=i;break}if((k&255)>>>0>=245>>>0){m=j;break L7}u=j;if((g-u|0)<4){m=j;break L7}if((e-i|0)>>>0<2>>>0){m=j;break L7}t=a[j+1|0]|0;p=a[j+2|0]|0;r=a[j+3|0]|0;if((l|0)==244){if((t&-16)<<24>>24!=-128){s=36;break L9}}else if((l|0)==240){if((t+112&255)>>>0>=48>>>0){s=34;break L9}}else{if((t&-64)<<24>>24!=-128){s=38;break L9}}v=p&255;if((v&192|0)!=128){m=j;break L7}p=r&255;if((p&192|0)!=128){m=j;break L7}if(((t&255)<<12&258048|l<<18&1835008|v<<6&4032|p&63)>>>0>f>>>0){m=j;break L7}n=j+4|0;o=i+1|0}}while(0);l=o+1|0;if(n>>>0<c>>>0&l>>>0<e>>>0){i=l;j=n}else{m=n;break L7}}if((s|0)==38){w=u-b|0;return w|0}else if((s|0)==21){w=q-b|0;return w|0}else if((s|0)==34){w=u-b|0;return w|0}else if((s|0)==36){w=u-b|0;return w|0}else if((s|0)==23){w=q-b|0;return w|0}else if((s|0)==25){w=q-b|0;return w|0}}else{m=h}}while(0);w=m-b|0;return w|0}function It(a){a=a|0;return 4}function Iu(a){a=a|0;Cl(a|0);J2(a);return}function Iv(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Iw(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Iw(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;c[e>>2]=b;c[h>>2]=f;do{if((j&2|0)!=0){if((g-f|0)<3){k=1;return k|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(f>>>0>=d>>>0){k=0;return k|0}j=g;g=f;L10:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>i>>>0){k=2;l=26;break}do{if(f>>>0<128>>>0){b=c[h>>2]|0;if((j-b|0)<1){k=1;l=21;break L10}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048>>>0){b=c[h>>2]|0;if((j-b|0)<2){k=1;l=20;break L10}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;m=j-b|0;if(f>>>0<65536>>>0){if((m|0)<3){k=1;l=24;break L10}c[h>>2]=b+1;a[b]=f>>>12|224;n=c[h>>2]|0;c[h>>2]=n+1;a[n]=f>>>6&63|128;n=c[h>>2]|0;c[h>>2]=n+1;a[n]=f&63|128;break}else{if((m|0)<4){k=1;l=23;break L10}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{k=0;l=25;break}}if((l|0)==26){return k|0}else if((l|0)==23){return k|0}else if((l|0)==24){return k|0}else if((l|0)==21){return k|0}else if((l|0)==20){return k|0}else if((l|0)==25){return k|0}return 0}function Ix(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b|0;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Iy(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function Iy(b,e,f,g,h,i,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c[f>>2]=b;c[i>>2]=g;g=c[f>>2]|0;do{if((k&4|0)==0){l=g}else{if((e-g|0)<=2){l=g;break}if((a[g]|0)!=-17){l=g;break}if((a[g+1|0]|0)!=-69){l=g;break}if((a[g+2|0]|0)!=-65){l=g;break}b=g+3|0;c[f>>2]=b;l=b}}while(0);L8:do{if(l>>>0<e>>>0){g=e;k=c[i>>2]|0;b=l;L10:while(1){if(k>>>0>=h>>>0){m=b;break L8}n=a[b]|0;o=n&255;do{if(n<<24>>24>-1){if(o>>>0>j>>>0){p=2;q=52;break L10}c[k>>2]=o;c[f>>2]=(c[f>>2]|0)+1}else{if((n&255)>>>0<194>>>0){p=2;q=45;break L10}if((n&255)>>>0<224>>>0){if((g-b|0)<2){p=1;q=60;break L10}r=d[b+1|0]|0;if((r&192|0)!=128){p=2;q=57;break L10}s=r&63|o<<6&1984;if(s>>>0>j>>>0){p=2;q=50;break L10}c[k>>2]=s;c[f>>2]=(c[f>>2]|0)+2;break}if((n&255)>>>0<240>>>0){if((g-b|0)<3){p=1;q=49;break L10}s=a[b+1|0]|0;r=a[b+2|0]|0;if((o|0)==237){if((s&-32)<<24>>24!=-128){p=2;q=43;break L10}}else if((o|0)==224){if((s&-32)<<24>>24!=-96){p=2;q=59;break L10}}else{if((s&-64)<<24>>24!=-128){p=2;q=56;break L10}}t=r&255;if((t&192|0)!=128){p=2;q=41;break L10}r=(s&255)<<6&4032|o<<12&61440|t&63;if(r>>>0>j>>>0){p=2;q=55;break L10}c[k>>2]=r;c[f>>2]=(c[f>>2]|0)+3;break}if((n&255)>>>0>=245>>>0){p=2;q=54;break L10}if((g-b|0)<4){p=1;q=47;break L10}r=a[b+1|0]|0;t=a[b+2|0]|0;s=a[b+3|0]|0;if((o|0)==240){if((r+112&255)>>>0>=48>>>0){p=2;q=51;break L10}}else if((o|0)==244){if((r&-16)<<24>>24!=-128){p=2;q=53;break L10}}else{if((r&-64)<<24>>24!=-128){p=2;q=58;break L10}}u=t&255;if((u&192|0)!=128){p=2;q=46;break L10}t=s&255;if((t&192|0)!=128){p=2;q=42;break L10}s=(r&255)<<12&258048|o<<18&1835008|u<<6&4032|t&63;if(s>>>0>j>>>0){p=2;q=44;break L10}c[k>>2]=s;c[f>>2]=(c[f>>2]|0)+4}}while(0);o=(c[i>>2]|0)+4|0;c[i>>2]=o;n=c[f>>2]|0;if(n>>>0<e>>>0){k=o;b=n}else{m=n;break L8}}if((q|0)==54){return p|0}else if((q|0)==55){return p|0}else if((q|0)==56){return p|0}else if((q|0)==57){return p|0}else if((q|0)==58){return p|0}else if((q|0)==59){return p|0}else if((q|0)==42){return p|0}else if((q|0)==43){return p|0}else if((q|0)==49){return p|0}else if((q|0)==50){return p|0}else if((q|0)==51){return p|0}else if((q|0)==41){return p|0}else if((q|0)==52){return p|0}else if((q|0)==53){return p|0}else if((q|0)==44){return p|0}else if((q|0)==45){return p|0}else if((q|0)==46){return p|0}else if((q|0)==47){return p|0}else if((q|0)==60){return p|0}}else{m=l}}while(0);p=m>>>0<e>>>0|0;return p|0}function Iz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function IA(a){a=a|0;return 0}function IB(a){a=a|0;return 0}function IC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ID(c,d,e,1114111,0)|0}function ID(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;do{if((g&4|0)==0){h=b}else{if((c-b|0)<=2){h=b;break}if((a[b]|0)!=-17){h=b;break}if((a[b+1|0]|0)!=-69){h=b;break}h=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);L7:do{if(h>>>0<c>>>0&(e|0)!=0){g=c;i=1;j=h;L9:while(1){k=a[j]|0;l=k&255;do{if(k<<24>>24>-1){if(l>>>0>f>>>0){m=j;break L7}n=j+1|0}else{if((k&255)>>>0<194>>>0){m=j;break L7}if((k&255)>>>0<224>>>0){if((g-j|0)<2){m=j;break L7}o=d[j+1|0]|0;if((o&192|0)!=128){m=j;break L7}if((o&63|l<<6&1984)>>>0>f>>>0){m=j;break L7}n=j+2|0;break}if((k&255)>>>0<240>>>0){p=j;if((g-p|0)<3){m=j;break L7}o=a[j+1|0]|0;q=a[j+2|0]|0;if((l|0)==224){if((o&-32)<<24>>24!=-96){r=21;break L9}}else if((l|0)==237){if((o&-32)<<24>>24!=-128){r=23;break L9}}else{if((o&-64)<<24>>24!=-128){r=25;break L9}}s=q&255;if((s&192|0)!=128){m=j;break L7}if(((o&255)<<6&4032|l<<12&61440|s&63)>>>0>f>>>0){m=j;break L7}n=j+3|0;break}if((k&255)>>>0>=245>>>0){m=j;break L7}t=j;if((g-t|0)<4){m=j;break L7}s=a[j+1|0]|0;o=a[j+2|0]|0;q=a[j+3|0]|0;if((l|0)==240){if((s+112&255)>>>0>=48>>>0){r=33;break L9}}else if((l|0)==244){if((s&-16)<<24>>24!=-128){r=35;break L9}}else{if((s&-64)<<24>>24!=-128){r=37;break L9}}u=o&255;if((u&192|0)!=128){m=j;break L7}o=q&255;if((o&192|0)!=128){m=j;break L7}if(((s&255)<<12&258048|l<<18&1835008|u<<6&4032|o&63)>>>0>f>>>0){m=j;break L7}n=j+4|0}}while(0);if(!(n>>>0<c>>>0&i>>>0<e>>>0)){m=n;break L7}i=i+1|0;j=n}if((r|0)==23){v=p-b|0;return v|0}else if((r|0)==33){v=t-b|0;return v|0}else if((r|0)==25){v=p-b|0;return v|0}else if((r|0)==21){v=p-b|0;return v|0}else if((r|0)==35){v=t-b|0;return v|0}else if((r|0)==37){v=t-b|0;return v|0}}else{m=h}}while(0);v=m-b|0;return v|0}function IE(a){a=a|0;return 4}function IF(a){a=a|0;Cl(a|0);J2(a);return}function IG(a){a=a|0;Cl(a|0);J2(a);return}function IH(a){a=a|0;c[a>>2]=13536;CP(a+12|0);Cl(a|0);J2(a);return}function II(a){a=a|0;c[a>>2]=13536;CP(a+12|0);Cl(a|0);return}function IJ(a){a=a|0;c[a>>2]=13488;CP(a+16|0);Cl(a|0);J2(a);return}function IK(a){a=a|0;c[a>>2]=13488;CP(a+16|0);Cl(a|0);return}function IL(b){b=b|0;return a[b+8|0]|0}function IM(a){a=a|0;return c[a+8>>2]|0}function IN(b){b=b|0;return a[b+9|0]|0}function IO(a){a=a|0;return c[a+12>>2]|0}function IP(a,b){a=a|0;b=b|0;CL(a,b+12|0);return}function IQ(a,b){a=a|0;b=b|0;CL(a,b+16|0);return}function IR(a,b){a=a|0;b=b|0;CM(a,8584,4);return}function IS(a,b){a=a|0;b=b|0;CZ(a,8360,Jw(8360)|0);return}function IT(a,b){a=a|0;b=b|0;CM(a,8056,5);return}function IU(a,b){a=a|0;b=b|0;CZ(a,7952,Jw(7952)|0);return}function IV(b){b=b|0;var d=0;if((a[40920]|0)!=0){d=c[9830]|0;return d|0}if((bz(40920)|0)==0){d=c[9830]|0;return d|0}do{if((a[40808]|0)==0){if((bz(40808)|0)==0){break}Ke(38360,0,168)|0;bk(444,0,r|0)|0}}while(0);x=0,aK(538,38360,11008)|0;do{if(!x){x=0,aK(538,38372,10888)|0;if(x){x=0;break}x=0,aK(538,38384,10832)|0;if(x){x=0;break}x=0,aK(538,38396,10800)|0;if(x){x=0;break}x=0,aK(538,38408,10760)|0;if(x){x=0;break}x=0,aK(538,38420,10728)|0;if(x){x=0;break}x=0,aK(538,38432,10680)|0;if(x){x=0;break}x=0,aK(538,38444,10664)|0;if(x){x=0;break}x=0,aK(538,38456,10648)|0;if(x){x=0;break}x=0,aK(538,38468,10624)|0;if(x){x=0;break}x=0,aK(538,38480,10600)|0;if(x){x=0;break}x=0,aK(538,38492,10552)|0;if(x){x=0;break}x=0,aK(538,38504,10472)|0;if(x){x=0;break}x=0,aK(538,38516,10432)|0;if(x){x=0;break}c[9830]=38360;d=c[9830]|0;return d|0}else{x=0}}while(0);d=bQ(-1,-1)|0;be(d|0);return 0}function IW(b){b=b|0;var d=0;if((a[40864]|0)!=0){d=c[9808]|0;return d|0}if((bz(40864)|0)==0){d=c[9808]|0;return d|0}do{if((a[40784]|0)==0){if((bz(40784)|0)==0){break}Ke(37616,0,168)|0;bk(540,0,r|0)|0}}while(0);x=0,aK(220,37616,12144)|0;do{if(!x){x=0,aK(220,37628,12016)|0;if(x){x=0;break}x=0,aK(220,37640,11952)|0;if(x){x=0;break}x=0,aK(220,37652,11880)|0;if(x){x=0;break}x=0,aK(220,37664,11808)|0;if(x){x=0;break}x=0,aK(220,37676,11720)|0;if(x){x=0;break}x=0,aK(220,37688,11624)|0;if(x){x=0;break}x=0,aK(220,37700,11512)|0;if(x){x=0;break}x=0,aK(220,37712,11448)|0;if(x){x=0;break}x=0,aK(220,37724,11360)|0;if(x){x=0;break}x=0,aK(220,37736,11320)|0;if(x){x=0;break}x=0,aK(220,37748,11152)|0;if(x){x=0;break}x=0,aK(220,37760,11096)|0;if(x){x=0;break}x=0,aK(220,37772,11064)|0;if(x){x=0;break}c[9808]=37616;d=c[9808]|0;return d|0}else{x=0}}while(0);d=bQ(-1,-1)|0;be(d|0);return 0}function IX(b){b=b|0;var d=0;if((a[40912]|0)!=0){d=c[9828]|0;return d|0}if((bz(40912)|0)==0){d=c[9828]|0;return d|0}do{if((a[40800]|0)==0){if((bz(40800)|0)==0){break}Ke(38072,0,288)|0;bk(550,0,r|0)|0}}while(0);x=0,aK(538,38072,1184)|0;do{if(!x){x=0,aK(538,38084,1096)|0;if(x){x=0;break}x=0,aK(538,38096,1056)|0;if(x){x=0;break}x=0,aK(538,38108,1e3)|0;if(x){x=0;break}x=0,aK(538,38120,944)|0;if(x){x=0;break}x=0,aK(538,38132,856)|0;if(x){x=0;break}x=0,aK(538,38144,768)|0;if(x){x=0;break}x=0,aK(538,38156,736)|0;if(x){x=0;break}x=0,aK(538,38168,648)|0;if(x){x=0;break}x=0,aK(538,38180,616)|0;if(x){x=0;break}x=0,aK(538,38192,568)|0;if(x){x=0;break}x=0,aK(538,38204,496)|0;if(x){x=0;break}x=0,aK(538,38216,440)|0;if(x){x=0;break}x=0,aK(538,38228,376)|0;if(x){x=0;break}x=0,aK(538,38240,288)|0;if(x){x=0;break}x=0,aK(538,38252,216)|0;if(x){x=0;break}x=0,aK(538,38264,944)|0;if(x){x=0;break}x=0,aK(538,38276,176)|0;if(x){x=0;break}x=0,aK(538,38288,144)|0;if(x){x=0;break}x=0,aK(538,38300,12408)|0;if(x){x=0;break}x=0,aK(538,38312,12384)|0;if(x){x=0;break}x=0,aK(538,38324,12328)|0;if(x){x=0;break}x=0,aK(538,38336,12272)|0;if(x){x=0;break}x=0,aK(538,38348,12232)|0;if(x){x=0;break}c[9828]=38072;d=c[9828]|0;return d|0}else{x=0}}while(0);d=bQ(-1,-1)|0;be(d|0);return 0}function IY(b){b=b|0;var d=0;if((a[40856]|0)!=0){d=c[9806]|0;return d|0}if((bz(40856)|0)==0){d=c[9806]|0;return d|0}do{if((a[40776]|0)==0){if((bz(40776)|0)==0){break}Ke(37328,0,288)|0;bk(86,0,r|0)|0}}while(0);x=0,aK(220,37328,3712)|0;do{if(!x){x=0,aK(220,37340,3544)|0;if(x){x=0;break}x=0,aK(220,37352,3416)|0;if(x){x=0;break}x=0,aK(220,37364,3280)|0;if(x){x=0;break}x=0,aK(220,37376,1808)|0;if(x){x=0;break}x=0,aK(220,37388,3096)|0;if(x){x=0;break}x=0,aK(220,37400,2912)|0;if(x){x=0;break}x=0,aK(220,37412,2784)|0;if(x){x=0;break}x=0,aK(220,37424,2632)|0;if(x){x=0;break}x=0,aK(220,37436,2504)|0;if(x){x=0;break}x=0,aK(220,37448,2352)|0;if(x){x=0;break}x=0,aK(220,37460,2232)|0;if(x){x=0;break}x=0,aK(220,37472,2176)|0;if(x){x=0;break}x=0,aK(220,37484,2088)|0;if(x){x=0;break}x=0,aK(220,37496,2016)|0;if(x){x=0;break}x=0,aK(220,37508,1920)|0;if(x){x=0;break}x=0,aK(220,37520,1808)|0;if(x){x=0;break}x=0,aK(220,37532,1760)|0;if(x){x=0;break}x=0,aK(220,37544,1720)|0;if(x){x=0;break}x=0,aK(220,37556,1640)|0;if(x){x=0;break}x=0,aK(220,37568,1552)|0;if(x){x=0;break}x=0,aK(220,37580,1496)|0;if(x){x=0;break}x=0,aK(220,37592,1440)|0;if(x){x=0;break}x=0,aK(220,37604,1272)|0;if(x){x=0;break}c[9806]=37328;d=c[9806]|0;return d|0}else{x=0}}while(0);d=bQ(-1,-1)|0;be(d|0);return 0}function IZ(b){b=b|0;var d=0,e=0,f=0;if((a[40928]|0)!=0){d=c[9832]|0;return d|0}if((bz(40928)|0)==0){d=c[9832]|0;return d|0}do{if((a[40816]|0)==0){if((bz(40816)|0)==0){break}Ke(38528,0,288)|0;bk(84,0,r|0)|0}}while(0);x=0,aK(538,38528,4224)|0;if(x){x=0;e=bQ(-1,-1)|0;f=K;be(e|0)}x=0,aK(538,38540,4080)|0;if(x){x=0;e=bQ(-1,-1)|0;f=K;be(e|0)}c[9832]=38528;d=c[9832]|0;return d|0}function I_(b){b=b|0;var d=0,e=0,f=0;if((a[40872]|0)!=0){d=c[9810]|0;return d|0}if((bz(40872)|0)==0){d=c[9810]|0;return d|0}do{if((a[40792]|0)==0){if((bz(40792)|0)==0){break}Ke(37784,0,288)|0;bk(282,0,r|0)|0}}while(0);x=0,aK(220,37784,4728)|0;if(x){x=0;e=bQ(-1,-1)|0;f=K;be(e|0)}x=0,aK(220,37796,4568)|0;if(x){x=0;e=bQ(-1,-1)|0;f=K;be(e|0)}c[9810]=37784;d=c[9810]|0;return d|0}function I$(b){b=b|0;if((a[40936]|0)!=0){return 39336}if((bz(40936)|0)==0){return 39336}x=0;aP(88,39336,7592,8);if(x){x=0;b=bQ(-1,-1)|0;be(b|0)}bk(296,39336,r|0)|0;return 39336}function I0(b){b=b|0;var c=0,d=0;if((a[40880]|0)!=0){return 39248}if((bz(40880)|0)==0){return 39248}b=(x=0,as(110,7488)|0);if(x){x=0;c=bQ(-1,-1)|0;d=K;be(c|0)}x=0;aP(66,39248,7488,b|0);if(x){x=0;c=bQ(-1,-1)|0;d=K;be(c|0)}bk(404,39248,r|0)|0;return 39248}function I1(b){b=b|0;if((a[40960]|0)!=0){return 39384}if((bz(40960)|0)==0){return 39384}x=0;aP(88,39384,7312,8);if(x){x=0;b=bQ(-1,-1)|0;be(b|0)}bk(296,39384,r|0)|0;return 39384}function I2(b){b=b|0;var c=0,d=0;if((a[40904]|0)!=0){return 39296}if((bz(40904)|0)==0){return 39296}b=(x=0,as(110,7104)|0);if(x){x=0;c=bQ(-1,-1)|0;d=K;be(c|0)}x=0;aP(66,39296,7104,b|0);if(x){x=0;c=bQ(-1,-1)|0;d=K;be(c|0)}bk(404,39296,r|0)|0;return 39296}function I3(b){b=b|0;if((a[40952]|0)!=0){return 39368}if((bz(40952)|0)==0){return 39368}x=0;aP(88,39368,6952,20);if(x){x=0;b=bQ(-1,-1)|0;be(b|0)}bk(296,39368,r|0)|0;return 39368}function I4(b){b=b|0;var c=0,d=0;if((a[40896]|0)!=0){return 39280}if((bz(40896)|0)==0){return 39280}b=(x=0,as(110,6664)|0);if(x){x=0;c=bQ(-1,-1)|0;d=K;be(c|0)}x=0;aP(66,39280,6664,b|0);if(x){x=0;c=bQ(-1,-1)|0;d=K;be(c|0)}bk(404,39280,r|0)|0;return 39280}function I5(b){b=b|0;if((a[40944]|0)!=0){return 39352}if((bz(40944)|0)==0){return 39352}x=0;aP(88,39352,6448,11);if(x){x=0;b=bQ(-1,-1)|0;be(b|0)}bk(296,39352,r|0)|0;return 39352}function I6(b){b=b|0;var c=0,d=0;if((a[40888]|0)!=0){return 39264}if((bz(40888)|0)==0){return 39264}b=(x=0,as(110,6104)|0);if(x){x=0;c=bQ(-1,-1)|0;d=K;be(c|0)}x=0;aP(66,39264,6104,b|0);if(x){x=0;c=bQ(-1,-1)|0;d=K;be(c|0)}bk(404,39264,r|0)|0;return 39264}function I7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0,m=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=bY()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;be(l|0)}}}while(0);m=+J9(b,g,c[9712]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=m;i=f;return+h}c[e>>2]=4;h=m;i=f;return+h}function I8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0,m=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=bY()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;be(l|0)}}}while(0);m=+J9(b,g,c[9712]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=m;i=f;return+h}c[e>>2]=4;h=m;i=f;return+h}function I9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0,m=0.0;f=i;i=i+8|0;g=f|0;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=bY()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}l=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=l;break}else{x=0;l=bQ(-1,-1)|0;be(l|0)}}}while(0);m=+J9(b,g,c[9712]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=m;i=f;return+h}function Ja(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g|0;do{if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0}else{if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;break}l=bY()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}n=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=n;break}else{x=0;n=bQ(-1,-1)|0;be(n|0)}}}while(0);n=a_(b|0,h|0,f|0,c[9712]|0)|0;o=c[l>>2]|0;if((o|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;break}if((o|0)!=34){j=K;k=n;break}c[e>>2]=4;j=-1;k=-1}}while(0);i=g;return(K=j,k)|0}function Jb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=bY()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}m=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=m;break}else{x=0;m=bQ(-1,-1)|0;be(m|0)}}}while(0);m=a_(b|0,h|0,f|0,c[9712]|0)|0;f=K;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>-1>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function Jc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=bY()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}m=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=m;break}else{x=0;m=bQ(-1,-1)|0;be(m|0)}}}while(0);m=a_(b|0,h|0,f|0,c[9712]|0)|0;f=K;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>-1>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function Jd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=bY()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}m=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=m;break}else{x=0;m=bQ(-1,-1)|0;be(m|0)}}}while(0);m=a_(b|0,h|0,f|0,c[9712]|0)|0;f=K;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=0;if((b|0)==34|(f>>>0>d>>>0|f>>>0==d>>>0&m>>>0>65535>>>0)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function Je(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;i=g;return(K=j,k)|0}l=bY()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}n=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=n;break}else{x=0;n=bQ(-1,-1)|0;be(n|0)}}}while(0);n=ca(b|0,h|0,f|0,c[9712]|0)|0;f=K;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;i=g;return(K=j,k)|0}if((b|0)!=34){j=f;k=n;i=g;return(K=j,k)|0}c[e>>2]=4;e=0;b=(f|0)>(e|0)|(f|0)==(e|0)&n>>>0>0>>>0;j=b?2147483647:-2147483648;k=b?-1:0;i=g;return(K=j,k)|0}function Jf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g|0;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=bY()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}m=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=m;break}else{x=0;m=bQ(-1,-1)|0;be(m|0)}}}while(0);m=ca(b|0,h|0,f|0,c[9712]|0)|0;f=K;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}d=-1;h=0;if((b|0)==34|((f|0)<(d|0)|(f|0)==(d|0)&m>>>0<-2147483648>>>0)|((f|0)>(h|0)|(f|0)==(h|0)&m>>>0>2147483647>>>0)){c[e>>2]=4;e=0;j=(f|0)>(e|0)|(f|0)==(e|0)&m>>>0>0>>>0?2147483647:-2147483648;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function Jg(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+4|0;d=(c[a>>2]|0)+(c[b+4>>2]|0)|0;a=d;e=c[b>>2]|0;if((e&1|0)==0){f=e;cx[f&1023](a);return}else{f=c[(c[d>>2]|0)+(e-1)>>2]|0;cx[f&1023](a);return}}function Jh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=b+8|0;f=b+4|0;g=c[f>>2]|0;h=c[e>>2]|0;i=g;if(h-i>>2>>>0>=d>>>0){j=d;k=g;do{if((k|0)==0){l=0}else{c[k>>2]=0;l=c[f>>2]|0}k=l+4|0;c[f>>2]=k;j=j-1|0;}while((j|0)!=0);return}j=b+16|0;k=b|0;l=c[k>>2]|0;g=i-l>>2;i=g+d|0;if(i>>>0>1073741823>>>0){Hu(0)}m=h-l|0;do{if(m>>2>>>0>536870910>>>0){n=1073741823;o=11}else{l=m>>1;h=l>>>0<i>>>0?i:l;if((h|0)==0){p=0;q=0;break}l=b+128|0;if(!((a[l]&1)==0&h>>>0<29>>>0)){n=h;o=11;break}a[l]=1;p=j;q=h}}while(0);if((o|0)==11){p=J0(n<<2)|0;q=n}n=d;d=p+(g<<2)|0;do{if((d|0)==0){r=0}else{c[d>>2]=0;r=d}d=r+4|0;n=n-1|0;}while((n|0)!=0);n=c[k>>2]|0;r=(c[f>>2]|0)-n|0;o=p+(g-(r>>2)<<2)|0;g=n;Kb(o|0,g|0,r)|0;c[k>>2]=o;c[f>>2]=d;c[e>>2]=p+(q<<2);if((n|0)==0){return}if((n|0)==(j|0)){a[b+128|0]=0;return}else{J2(g);return}}function Ji(a){a=a|0;C$(38060);C$(38048);C$(38036);C$(38024);C$(38012);C$(38e3);C$(37988);C$(37976);C$(37964);C$(37952);C$(37940);C$(37928);C$(37916);C$(37904);C$(37892);C$(37880);C$(37868);C$(37856);C$(37844);C$(37832);C$(37820);C$(37808);C$(37796);C$(37784);return}function Jj(a){a=a|0;CP(38804);CP(38792);CP(38780);CP(38768);CP(38756);CP(38744);CP(38732);CP(38720);CP(38708);CP(38696);CP(38684);CP(38672);CP(38660);CP(38648);CP(38636);CP(38624);CP(38612);CP(38600);CP(38588);CP(38576);CP(38564);CP(38552);CP(38540);CP(38528);return}function Jk(a){a=a|0;C$(37604);C$(37592);C$(37580);C$(37568);C$(37556);C$(37544);C$(37532);C$(37520);C$(37508);C$(37496);C$(37484);C$(37472);C$(37460);C$(37448);C$(37436);C$(37424);C$(37412);C$(37400);C$(37388);C$(37376);C$(37364);C$(37352);C$(37340);C$(37328);return}function Jl(a){a=a|0;CP(38348);CP(38336);CP(38324);CP(38312);CP(38300);CP(38288);CP(38276);CP(38264);CP(38252);CP(38240);CP(38228);CP(38216);CP(38204);CP(38192);CP(38180);CP(38168);CP(38156);CP(38144);CP(38132);CP(38120);CP(38108);CP(38096);CP(38084);CP(38072);return}function Jm(a){a=a|0;C$(37772);C$(37760);C$(37748);C$(37736);C$(37724);C$(37712);C$(37700);C$(37688);C$(37676);C$(37664);C$(37652);C$(37640);C$(37628);C$(37616);return}function Jn(a){a=a|0;CP(38516);CP(38504);CP(38492);CP(38480);CP(38468);CP(38456);CP(38444);CP(38432);CP(38420);CP(38408);CP(38396);CP(38384);CP(38372);CP(38360);return}function Jo(a,b,c){a=a|0;b=b|0;c=c|0;return Jp(0,a,b,(c|0)!=0?c:36824)|0}function Jp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+8|0;h=g|0;c[h>>2]=b;j=((f|0)==0?36816:f)|0;f=c[j>>2]|0;L1:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n-194|0;if(l>>>0>50>>>0){break L1}p=d+1|0;q=c[o+(l<<2)>>2]|0;r=e-1|0;break}}else{p=d;q=f;r=e}}while(0);L19:do{if((r|0)==0){s=q}else{l=a[p]|0;n=(l&255)>>>3;if((n-16|n+(q>>26))>>>0>7>>>0){break L1}else{t=p;u=q;v=r;w=l}while(1){t=t+1|0;u=(w&255)-128|u<<6;v=v-1|0;if((u|0)>=0){break}if((v|0)==0){s=u;break L19}w=a[t]|0;if(((w&255)-128|0)>>>0>63>>>0){break L1}}c[j>>2]=0;c[m>>2]=u;k=e-v|0;i=g;return k|0}}while(0);c[j>>2]=s;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(bY()|0)>>2]=84;k=-1;i=g;return k|0}
function t4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;d=i;i=i+176|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+48|0;k=d+64|0;l=d+80|0;m=d+96|0;n=d+112|0;o=d+128|0;p=d+144|0;q=d+160|0;r=b+20|0;if((xR(xP(c[r>>2]|0)|0)|0)!=0){s=sA(b)|0;t=c[b>>2]|0;u=J0(48)|0;c[f>>2]=u;v=t+4|0;w=c[v>>2]|0;if((w|0)==(c[t+8>>2]|0)){ee(t|0,f);y=c[f>>2]|0}else{if((w|0)==0){z=0}else{c[w>>2]=u;z=c[v>>2]|0}c[v>>2]=z+4;y=u}u=y;z=y;w=b+28|0;L10:do{if((a[w]&1)==0){f=g;c[f>>2]=c[w>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];A=17}else{f=c[b+36>>2]|0;B=c[b+32>>2]|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(B>>>0<11>>>0){a[g]=B<<1;C=g+1|0}else{D=B+16&-16;E=(x=0,as(230,D|0)|0);if(x){x=0;break}c[g+8>>2]=E;c[g>>2]=D|1;c[g+4>>2]=B;C=E}Kb(C|0,f|0,B)|0;a[C+B|0]=0;A=17;break L10}}while(0);B=bQ(-1,-1)|0;F=K;G=B}}while(0);do{if((A|0)==17){C=h;w=b+44|0;c[C>>2]=c[w>>2];c[C+4>>2]=c[w+4>>2];c[C+8>>2]=c[w+8>>2];x=0;aB(36,z|0,g|0,h|0,s|0,0,1);if(x){x=0;w=bQ(-1,-1)|0;C=w;w=K;if((a[g]&1)==0){F=w;G=C;break}J2(c[g+8>>2]|0);F=w;G=C;break}if((a[g]&1)==0){H=z;i=d;return H|0}J2(c[g+8>>2]|0);H=z;i=d;return H|0}}while(0);z=c[t>>2]|0;t=c[v>>2]|0;g=z;while(1){if((g|0)==(t|0)){I=t;break}if((c[g>>2]|0)==(y|0)){I=g;break}else{g=g+4|0}}g=I-z>>2;I=z+(g+1<<2)|0;y=t-I|0;Kc(z+(g<<2)|0,I|0,y|0)|0;I=z+((y>>2)+g<<2)|0;g=c[v>>2]|0;if((I|0)!=(g|0)){c[v>>2]=g+(~((g-4+(-I|0)|0)>>>2)<<2)}J2(u);J=F;L=G;M=L;N=0;O=M;P=J;be(O|0)}G=xP(c[r>>2]|0)|0;F=(a[G]|0)==40?G+1|0:0;do{if((F|0)==0){u=J0(48)|0;I=j+8|0;c[I>>2]=u;c[j>>2]=49;c[j+4>>2]=42;Kb(u|0,2560,42)|0;a[u+42|0]=0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;x=0;aP(466,b|0,j|0,k|0);if(!x){if((a[j]&1)==0){break}J2(c[I>>2]|0);break}else{x=0}u=bQ(-1,-1)|0;g=u;u=K;if((a[j]&1)==0){J=u;L=g;M=L;N=0;O=M;P=J;be(O|0)}J2(c[I>>2]|0);J=u;L=g;M=L;N=0;O=M;P=J;be(O|0)}else{g=b+48|0;u=c[g>>2]|0;I=c[r>>2]|0;L45:do{if(I>>>0<F>>>0){v=I;y=0;while(1){z=a[v]|0;if((z<<24>>24|0)==0){Q=y;break L45}else if((z<<24>>24|0)==10){R=y+1|0}else{R=y}z=v+1|0;if(z>>>0<F>>>0){v=z;y=R}else{Q=R;break}}}else{Q=0}}while(0);c[g>>2]=Q+u;y=G;v=0;while(1){z=y-1|0;if(z>>>0<I>>>0){break}if((a[z]|0)==10){break}else{y=z;v=v+1|0}}y=b+40|0;if((Q|0)!=0){c[y>>2]=1}I=c[y>>2]|0;c[b+52>>2]=I+v;u=F;g=G;c[y>>2]=u-g+v+I;I=b+56|0;c[I>>2]=g;c[I+4>>2]=u;c[r>>2]=F}}while(0);F=xP(c[r>>2]|0)|0;do{if(!((F+1|0)==0|(a[F]|0)!=41)){G=J0(64)|0;Q=l+8|0;c[Q>>2]=G;c[l>>2]=65;c[l+4>>2]=48;Kb(G|0,2408,48)|0;a[G+48|0]=0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;x=0;aP(466,b|0,l|0,m|0);if(!x){if((a[l]&1)==0){break}J2(c[Q>>2]|0);break}else{x=0}G=bQ(-1,-1)|0;R=G;G=K;if((a[l]&1)==0){J=G;L=R;M=L;N=0;O=M;P=J;be(O|0)}J2(c[Q>>2]|0);J=G;L=R;M=L;N=0;O=M;P=J;be(O|0)}}while(0);l=td(b)|0;m=xP(c[r>>2]|0)|0;F=(a[m]|0)==58?m+1|0:0;if((F|0)==0){S=0}else{R=b+48|0;G=c[R>>2]|0;Q=c[r>>2]|0;L82:do{if(Q>>>0<F>>>0){j=Q;k=0;while(1){u=a[j]|0;if((u<<24>>24|0)==0){T=k;break L82}else if((u<<24>>24|0)==10){U=k+1|0}else{U=k}u=j+1|0;if(u>>>0<F>>>0){j=u;k=U}else{T=U;break}}}else{T=0}}while(0);c[R>>2]=T+G;G=m;R=0;while(1){U=G-1|0;if(U>>>0<Q>>>0){break}if((a[U]|0)==10){break}else{G=U;R=R+1|0}}G=b+40|0;if((T|0)!=0){c[G>>2]=1}T=c[G>>2]|0;c[b+52>>2]=T+R;Q=F;U=m;c[G>>2]=Q-U+R+T;T=b+56|0;c[T>>2]=U;c[T+4>>2]=Q;c[r>>2]=F;S=s6(b)|0}F=xP(c[r>>2]|0)|0;Q=(a[F]|0)==41?F+1|0:0;do{if((Q|0)==0){T=J0(48)|0;U=n+8|0;c[U>>2]=T;c[n>>2]=49;c[n+4>>2]=46;Kb(T|0,2288,46)|0;a[T+46|0]=0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;x=0;aP(466,b|0,n|0,o|0);if(!x){if((a[n]&1)==0){break}J2(c[U>>2]|0);break}else{x=0}T=bQ(-1,-1)|0;R=T;T=K;if((a[n]&1)==0){J=T;L=R;M=L;N=0;O=M;P=J;be(O|0)}J2(c[U>>2]|0);J=T;L=R;M=L;N=0;O=M;P=J;be(O|0)}else{R=b+48|0;T=c[R>>2]|0;U=c[r>>2]|0;L99:do{if(U>>>0<Q>>>0){G=U;m=0;while(1){k=a[G]|0;if((k<<24>>24|0)==0){V=m;break L99}else if((k<<24>>24|0)==10){W=m+1|0}else{W=m}k=G+1|0;if(k>>>0<Q>>>0){G=k;m=W}else{V=W;break}}}else{V=0}}while(0);c[R>>2]=V+T;m=F;G=0;while(1){k=m-1|0;if(k>>>0<U>>>0){break}if((a[k]|0)==10){break}else{m=k;G=G+1|0}}m=b+40|0;if((V|0)!=0){c[m>>2]=1}U=c[m>>2]|0;c[b+52>>2]=U+G;T=Q;R=F;c[m>>2]=T-R+G+U;U=b+56|0;c[U>>2]=R;c[U+4>>2]=T;c[r>>2]=Q}}while(0);Q=c[b>>2]|0;r=J0(48)|0;c[e>>2]=r;F=Q+4|0;V=c[F>>2]|0;if((V|0)==(c[Q+8>>2]|0)){ee(Q|0,e);X=c[e>>2]|0}else{if((V|0)==0){Y=0}else{c[V>>2]=r;Y=c[F>>2]|0}c[F>>2]=Y+4;X=r}r=X;Y=X;V=b+28|0;L130:do{if((a[V]&1)==0){e=p;c[e>>2]=c[V>>2];c[e+4>>2]=c[V+4>>2];c[e+8>>2]=c[V+8>>2];A=93}else{e=c[b+36>>2]|0;W=c[b+32>>2]|0;do{if(W>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(W>>>0<11>>>0){a[p]=W<<1;Z=p+1|0}else{n=W+16&-16;o=(x=0,as(230,n|0)|0);if(x){x=0;break}c[p+8>>2]=o;c[p>>2]=n|1;c[p+4>>2]=W;Z=o}Kb(Z|0,e|0,W)|0;a[Z+W|0]=0;A=93;break L130}}while(0);W=bQ(-1,-1)|0;_=K;$=W}}while(0);do{if((A|0)==93){Z=q;b=l+16|0;c[Z>>2]=c[b>>2];c[Z+4>>2]=c[b+4>>2];c[Z+8>>2]=c[b+8>>2];x=0;aB(36,Y|0,p|0,q|0,l|0,S|0,0);if(x){x=0;b=bQ(-1,-1)|0;Z=b;b=K;if((a[p]&1)==0){_=b;$=Z;break}J2(c[p+8>>2]|0);_=b;$=Z;break}if((a[p]&1)==0){H=Y;i=d;return H|0}J2(c[p+8>>2]|0);H=Y;i=d;return H|0}}while(0);H=c[Q>>2]|0;Q=c[F>>2]|0;d=H;while(1){if((d|0)==(Q|0)){aa=Q;break}if((c[d>>2]|0)==(X|0)){aa=d;break}else{d=d+4|0}}d=aa-H>>2;aa=H+(d+1<<2)|0;X=Q-aa|0;Kc(H+(d<<2)|0,aa|0,X|0)|0;aa=H+((X>>2)+d<<2)|0;d=c[F>>2]|0;if((aa|0)!=(d|0)){c[F>>2]=d+(~((d-4+(-aa|0)|0)>>>2)<<2)}J2(r);J=_;L=$;M=L;N=0;O=M;P=J;be(O|0);return 0}function t5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=a[35440]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=35440;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==10){p=i+1|0}else if((n<<24>>24|0)==0){q=i;break L9}else{p=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=p}else{q=p;break}}}else{q=0}}while(0);c[g>>2]=h+q;h=e;g=0;while(1){p=h-1|0;if(p>>>0<k>>>0){break}if((a[p]|0)==10){break}else{h=p;g=g+1|0}}h=b+40|0;if((q|0)!=0){c[h>>2]=1}q=c[h>>2]|0;c[b+52>>2]=q+g;k=f;p=e;c[h>>2]=k-p+g+q;q=b+56|0;c[q>>2]=p;c[q+4>>2]=k;c[d>>2]=f;o=f;return o|0}function t6(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;j=i;i=i+48|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;Kb(m|0,e|0,12)|0;e=k;n=l;o=b|0;p=d;if((a[p]&1)==0){c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2]}else{p=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){CJ(0)}if(q>>>0<11>>>0){a[e]=q<<1;r=k+1|0}else{d=q+16&-16;s=J0(d)|0;c[k+8>>2]=s;c[k>>2]=d|1;c[k+4>>2]=q;r=s}Kb(r|0,p|0,q)|0;a[r+q|0]=0}c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];x=0;aB(6,o|0,k|0,l|0,0,0,0);if(!x){if((a[e]&1)==0){t=b|0;c[t>>2]=19208;u=b+36|0;c[u>>2]=f;v=b+40|0;c[v>>2]=g;w=b+44|0;y=h&1;a[w]=y;i=j;return}J2(c[k+8>>2]|0);t=b|0;c[t>>2]=19208;u=b+36|0;c[u>>2]=f;v=b+40|0;c[v>>2]=g;w=b+44|0;y=h&1;a[w]=y;i=j;return}else{x=0;j=bQ(-1,-1)|0;if((a[e]&1)==0){be(j|0)}J2(c[k+8>>2]|0);be(j|0)}}function t7(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xU(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function t8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=ya(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function t9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function ua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function ub(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function uc(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function ud(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+68>>2]&1023](b,a);return}function ue(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+68>>2]&1023](b,a)|0}function uf(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+68>>2]&1023](b,a)|0}function ug(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+68>>2]&1023](b,a)|0}function uh(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+68>>2]&1023](b,a)|0}function ui(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+68>>2]&511](a,d,b);return}function uj(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+68>>2]&511](a,d,b);return}function uk(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=J0(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];x=0;aT(6,m|0,k|0,l|0,h|0);if(x){x=0;h=bQ(-1,-1)|0;l=h;h=K;if((a[k]&1)==0){r=h;s=l;t=s;u=0;v=t;w=r;be(v|0)}J2(c[k+8>>2]|0);r=h;s=l;t=s;u=0;v=t;w=r;be(v|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}k=b|0;c[k>>2]=19016;l=b+32|0;h=f;if((a[h]&1)==0){m=l;c[m>>2]=c[h>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];y=b+44|0;c[y>>2]=g;i=j;return}h=c[f+8>>2]|0;m=c[f+4>>2]|0;do{if(m>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(m>>>0<11>>>0){a[l]=m<<1;z=l+1|0}else{f=m+16&-16;p=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=p;c[l>>2]=f|1;c[b+36>>2]=m;z=p}Kb(z|0,h|0,m)|0;a[z+m|0]=0;y=b+44|0;c[y>>2]=g;i=j;return}}while(0);j=bQ(-1,-1)|0;g=j;j=K;c[k>>2]=16616;if((a[b+4|0]&1)==0){r=j;s=g;t=s;u=0;v=t;w=r;be(v|0)}J2(c[b+12>>2]|0);r=j;s=g;t=s;u=0;v=t;w=r;be(v|0)}function ul(b){b=b|0;var d=0;d=b|0;c[d>>2]=19016;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function um(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=19016;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function un(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+64>>2]&1023](b,a);return}function uo(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+64>>2]&1023](b,a)|0}function up(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+64>>2]&1023](b,a)|0}function uq(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+64>>2]&1023](b,a)|0}function ur(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+64>>2]&1023](b,a)|0}function us(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+64>>2]&511](a,d,b);return}function ut(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+64>>2]&511](a,d,b);return}function uu(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=i;i=i+32|0;m=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];m=l|0;n=l+16|0;o=b|0;p=d;if((a[p]&1)==0){q=m;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2]}else{p=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){CJ(0)}if(q>>>0<11>>>0){a[m]=q<<1;r=m+1|0}else{d=q+16&-16;s=J0(d)|0;c[m+8>>2]=s;c[m>>2]=d|1;c[m+4>>2]=q;r=s}Kb(r|0,p|0,q)|0;a[r+q|0]=0}q=n;r=e;c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];x=0;aT(6,o|0,m|0,n|0,j|0);if(x){x=0;j=bQ(-1,-1)|0;n=j;j=K;if((a[m]&1)==0){t=j;u=n;v=u;w=0;y=v;z=t;be(y|0)}J2(c[m+8>>2]|0);t=j;u=n;v=u;w=0;y=v;z=t;be(y|0)}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}m=b|0;c[m>>2]=19080;n=b+32|0;j=f;if((a[j]&1)==0){o=n;c[o>>2]=c[j>>2];c[o+4>>2]=c[j+4>>2];c[o+8>>2]=c[j+8>>2];A=b+44|0;c[A>>2]=g;B=b+48|0;c[B>>2]=h;C=b+52|0;D=k&1;a[C]=D;i=l;return}j=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[n]=o<<1;E=n+1|0}else{f=o+16&-16;r=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=r;c[n>>2]=f|1;c[b+36>>2]=o;E=r}Kb(E|0,j|0,o)|0;a[E+o|0]=0;A=b+44|0;c[A>>2]=g;B=b+48|0;c[B>>2]=h;C=b+52|0;D=k&1;a[C]=D;i=l;return}}while(0);l=bQ(-1,-1)|0;D=l;l=K;c[m>>2]=16616;if((a[b+4|0]&1)==0){t=l;u=D;v=u;w=0;y=v;z=t;be(y|0)}J2(c[b+12>>2]|0);t=l;u=D;v=u;w=0;y=v;z=t;be(y|0)}function uv(b){b=b|0;var d=0;d=b|0;c[d>>2]=19080;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function uw(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=19080;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function ux(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+60>>2]&1023](b,a);return}function uy(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+60>>2]&1023](b,a)|0}function uz(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+60>>2]&1023](b,a)|0}function uA(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+60>>2]&1023](b,a)|0}function uB(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+60>>2]&1023](b,a)|0}function uC(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+60>>2]&511](a,d,b);return}function uD(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+60>>2]&511](a,d,b);return}function uE(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function uF(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function uG(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+56>>2]&1023](b,a);return}function uH(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+56>>2]&1023](b,a)|0}function uI(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+56>>2]&1023](b,a)|0}function uJ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+56>>2]&1023](b,a)|0}function uK(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+56>>2]&1023](b,a)|0}function uL(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+56>>2]&511](a,d,b);return}function uM(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+56>>2]&511](a,d,b);return}function uN(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function uO(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function uP(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+108>>2]&1023](b,a);return}function uQ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+108>>2]&1023](b,a)|0}function uR(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+108>>2]&1023](b,a)|0}function uS(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+108>>2]&1023](b,a)|0}function uT(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+108>>2]&1023](b,a)|0}function uU(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+108>>2]&511](a,d,b);return}function uV(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+108>>2]&511](a,d,b);return}function uW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=J0(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}Kb(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];x=0;aB(6,l|0,j|0,k|0,1,0,0);if(x){x=0;k=bQ(-1,-1)|0;l=k;k=K;if((a[j]&1)==0){q=k;r=l;s=r;t=0;u=s;v=q;be(u|0)}J2(c[j+8>>2]|0);q=k;r=l;s=r;t=0;u=s;v=q;be(u|0)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}j=b|0;c[j>>2]=16736;c[b+36>>2]=f;f=b+40|0;l=g;if((a[l]&1)==0){k=f;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];i=h;return}l=c[g+8>>2]|0;k=c[g+4>>2]|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(k>>>0<11>>>0){a[f]=k<<1;w=f+1|0}else{g=k+16&-16;o=(x=0,as(230,g|0)|0);if(x){x=0;break}c[b+48>>2]=o;c[f>>2]=g|1;c[b+44>>2]=k;w=o}Kb(w|0,l|0,k)|0;a[w+k|0]=0;i=h;return}}while(0);h=bQ(-1,-1)|0;k=h;h=K;c[j>>2]=16616;if((a[b+4|0]&1)==0){q=h;r=k;s=r;t=0;u=s;v=q;be(u|0)}J2(c[b+12>>2]|0);q=h;r=k;s=r;t=0;u=s;v=q;be(u|0)}function uX(b){b=b|0;var d=0;d=b|0;c[d>>2]=16736;if((a[b+40|0]&1)!=0){J2(c[b+48>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function uY(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=16736;if((a[b+40|0]&1)!=0){J2(c[b+48>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function uZ(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+116>>2]&1023](b,a);return}function u_(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+116>>2]&1023](b,a)|0}function u$(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+116>>2]&1023](b,a)|0}function u0(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+116>>2]&1023](b,a)|0}function u1(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+116>>2]&1023](b,a)|0}function u2(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+116>>2]&511](a,d,b);return}function u3(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+116>>2]&511](a,d,b);return}function u4(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function u5(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function u6(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+100>>2]&1023](b,a);return}function u7(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+100>>2]&1023](b,a)|0}function u8(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+100>>2]&1023](b,a)|0}function u9(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+100>>2]&1023](b,a)|0}function va(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+100>>2]&1023](b,a)|0}function vb(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+100>>2]&511](a,d,b);return}function vc(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+100>>2]&511](a,d,b);return}function vd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=J0(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];x=0;aB(6,k|0,h|0,j|0,0,0,0);if(x){x=0;j=bQ(-1,-1)|0;k=j;j=K;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}J2(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}h=b|0;c[h>>2]=16416;k=b+36|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;v=k+1|0}else{f=n+16&-16;m=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+44>>2]=m;c[k>>2]=f|1;c[b+40>>2]=n;v=m}Kb(v|0,j|0,n)|0;a[v+n|0]=0;i=g;return}}while(0);g=bQ(-1,-1)|0;n=g;g=K;c[h>>2]=16616;if((a[b+4|0]&1)==0){p=g;q=n;r=q;s=0;t=r;u=p;be(t|0)}J2(c[b+12>>2]|0);p=g;q=n;r=q;s=0;t=r;u=p;be(t|0)}function ve(b){b=b|0;var d=0;d=b|0;c[d>>2]=16416;if((a[b+36|0]&1)!=0){J2(c[b+44>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function vf(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=16416;if((a[b+36|0]&1)!=0){J2(c[b+44>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function vg(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+112>>2]&1023](b,a);return}function vh(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+112>>2]&1023](b,a)|0}function vi(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+112>>2]&1023](b,a)|0}function vj(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+112>>2]&1023](b,a)|0}function vk(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+112>>2]&1023](b,a)|0}function vl(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+112>>2]&511](a,d,b);return}function vm(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+112>>2]&511](a,d,b);return}function vn(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function vo(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function vp(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+96>>2]&1023](b,a);return}function vq(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+96>>2]&1023](b,a)|0}function vr(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+96>>2]&1023](b,a)|0}function vs(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+96>>2]&1023](b,a)|0}function vt(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+96>>2]&1023](b,a)|0}function vu(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+96>>2]&511](a,d,b);return}function vv(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+96>>2]&511](a,d,b);return}function vw(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function vx(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function vy(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+80>>2]&1023](b,a);return}function vz(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+80>>2]&1023](b,a)|0}function vA(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+80>>2]&1023](b,a)|0}function vB(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+80>>2]&1023](b,a)|0}function vC(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+80>>2]&1023](b,a)|0}function vD(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+80>>2]&511](a,d,b);return}function vE(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+80>>2]&511](a,d,b);return}function vF(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function vG(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function vH(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+76>>2]&1023](b,a);return}function vI(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+76>>2]&1023](b,a)|0}function vJ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+76>>2]&1023](b,a)|0}function vK(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+76>>2]&1023](b,a)|0}function vL(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+76>>2]&1023](b,a)|0}function vM(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+76>>2]&511](a,d,b);return}function vN(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+76>>2]&511](a,d,b);return}function vO(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function vP(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function vQ(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+72>>2]&1023](b,a);return}function vR(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+72>>2]&1023](b,a)|0}function vS(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+72>>2]&1023](b,a)|0}function vT(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+72>>2]&1023](b,a)|0}function vU(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+72>>2]&1023](b,a)|0}function vV(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+72>>2]&511](a,d,b);return}function vW(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+72>>2]&511](a,d,b);return}function vX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=J0(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];x=0;aP(282,m|0,k|0,l|0);if(x){x=0;l=bQ(-1,-1)|0;m=l;l=K;if((a[k]&1)==0){r=l;s=m;t=s;u=0;v=t;w=r;be(v|0)}J2(c[k+8>>2]|0);r=l;s=m;t=s;u=0;v=t;w=r;be(v|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}k=b|0;c[k>>2]=19520;m=b+32|0;l=f;L22:do{if((a[l]&1)==0){p=m;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];y=22}else{p=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[m]=o<<1;z=m+1|0}else{e=o+16&-16;n=(x=0,as(230,e|0)|0);if(x){x=0;break}c[b+40>>2]=n;c[m>>2]=e|1;c[b+36>>2]=o;z=n}Kb(z|0,p|0,o)|0;a[z+o|0]=0;y=22;break L22}}while(0);o=bQ(-1,-1)|0;A=K;B=o}}while(0);do{if((y|0)==22){z=b+44|0;f=g;L37:do{if((a[f]&1)==0){l=z;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];y=32}else{l=c[g+8>>2]|0;o=c[g+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[z]=o<<1;C=z+1|0}else{p=o+16&-16;n=(x=0,as(230,p|0)|0);if(x){x=0;break}c[b+52>>2]=n;c[z>>2]=p|1;c[b+48>>2]=o;C=n}Kb(C|0,l|0,o)|0;a[C+o|0]=0;y=32;break L37}}while(0);o=bQ(-1,-1)|0;D=K;E=o}}while(0);do{if((y|0)==32){f=b+56|0;o=h;if((a[o]&1)==0){l=f;c[l>>2]=c[o>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];i=j;return}o=c[h+8>>2]|0;l=c[h+4>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(l>>>0<11>>>0){a[f]=l<<1;F=f+1|0}else{n=l+16&-16;p=(x=0,as(230,n|0)|0);if(x){x=0;break}c[b+64>>2]=p;c[f>>2]=n|1;c[b+60>>2]=l;F=p}Kb(F|0,o|0,l)|0;a[F+l|0]=0;i=j;return}}while(0);l=bQ(-1,-1)|0;o=l;l=K;if((a[z]&1)==0){D=l;E=o;break}J2(c[b+52>>2]|0);D=l;E=o}}while(0);if((a[m]&1)==0){A=D;B=E;break}J2(c[b+40>>2]|0);A=D;B=E}}while(0);c[k>>2]=16616;if((a[b+4|0]&1)==0){r=A;s=B;t=s;u=0;v=t;w=r;be(v|0)}J2(c[b+12>>2]|0);r=A;s=B;t=s;u=0;v=t;w=r;be(v|0)}function vY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=b|0;k=d;if((a[k]&1)==0){l=g;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2]}else{k=c[d+8>>2]|0;l=c[d+4>>2]|0;if(l>>>0>4294967279>>>0){CJ(0)}if(l>>>0<11>>>0){a[g]=l<<1;m=g+1|0}else{d=l+16&-16;n=J0(d)|0;c[g+8>>2]=n;c[g>>2]=d|1;c[g+4>>2]=l;m=n}Kb(m|0,k|0,l)|0;a[m+l|0]=0}l=h;m=e;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];x=0;ao(20,j|0,g|0,h|0,0,0);if(!x){if((a[g]&1)==0){o=b|0;c[o>>2]=20216;i=f;return}J2(c[g+8>>2]|0);o=b|0;c[o>>2]=20216;i=f;return}else{x=0;f=bQ(-1,-1)|0;if((a[g]&1)==0){be(f|0)}J2(c[g+8>>2]|0);be(f|0)}}function vZ(b){b=b|0;var d=0;d=b|0;c[d>>2]=19520;if((a[b+56|0]&1)!=0){J2(c[b+64>>2]|0)}if((a[b+44|0]&1)!=0){J2(c[b+52>>2]|0)}if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function v_(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=19520;if((a[b+56|0]&1)!=0){J2(c[b+64>>2]|0)}if((a[b+44|0]&1)!=0){J2(c[b+52>>2]|0)}if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function v$(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+188>>2]&1023](b,a);return}function v0(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+188>>2]&1023](b,a)|0}function v1(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+188>>2]&1023](b,a)|0}function v2(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+188>>2]&1023](b,a)|0}function v3(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+188>>2]&1023](b,a)|0}function v4(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+188>>2]&511](a,d,b);return}function v5(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+188>>2]&511](a,d,b);return}function v6(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=J0(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}Kb(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];x=0;aP(282,l|0,j|0,k|0);if(x){x=0;k=bQ(-1,-1)|0;l=k;k=K;if((a[j]&1)==0){q=k;r=l;s=r;t=0;u=s;v=q;be(u|0)}J2(c[j+8>>2]|0);q=k;r=l;s=r;t=0;u=s;v=q;be(u|0)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}j=b|0;c[j>>2]=20328;l=b+32|0;k=f;if((a[k]&1)==0){o=l;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];w=b+44|0;c[w>>2]=g;i=h;return}k=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[l]=o<<1;y=l+1|0}else{f=o+16&-16;n=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=n;c[l>>2]=f|1;c[b+36>>2]=o;y=n}Kb(y|0,k|0,o)|0;a[y+o|0]=0;w=b+44|0;c[w>>2]=g;i=h;return}}while(0);h=bQ(-1,-1)|0;g=h;h=K;c[j>>2]=16616;if((a[b+4|0]&1)==0){q=h;r=g;s=r;t=0;u=s;v=q;be(u|0)}J2(c[b+12>>2]|0);q=h;r=g;s=r;t=0;u=s;v=q;be(u|0)}function v7(b){b=b|0;var d=0;d=b|0;c[d>>2]=20328;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function v8(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=20328;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function v9(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+192>>2]&1023](b,a);return}function wa(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+192>>2]&1023](b,a)|0}function wb(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+192>>2]&1023](b,a)|0}function wc(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+192>>2]&1023](b,a)|0}function wd(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+192>>2]&1023](b,a)|0}function we(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+192>>2]&511](a,d,b);return}function wf(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+192>>2]&511](a,d,b);return}function wg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=J0(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];x=0;aP(282,k|0,h|0,j|0);if(x){x=0;j=bQ(-1,-1)|0;k=j;j=K;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}J2(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}h=b|0;c[h>>2]=19280;k=b+32|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];v=b+29|0;a[v]=1;i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;w=k+1|0}else{f=n+16&-16;m=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=m;c[k>>2]=f|1;c[b+36>>2]=n;w=m}Kb(w|0,j|0,n)|0;a[w+n|0]=0;v=b+29|0;a[v]=1;i=g;return}}while(0);g=bQ(-1,-1)|0;v=g;g=K;c[h>>2]=16616;if((a[b+4|0]&1)==0){p=g;q=v;r=q;s=0;t=r;u=p;be(t|0)}J2(c[b+12>>2]|0);p=g;q=v;r=q;s=0;t=r;u=p;be(t|0)}function wh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=J0(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];x=0;aP(282,k|0,h|0,j|0);if(x){x=0;j=bQ(-1,-1)|0;k=j;j=K;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}J2(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}h=b|0;c[h>>2]=19464;k=b+32|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;v=k+1|0}else{f=n+16&-16;m=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=m;c[k>>2]=f|1;c[b+36>>2]=n;v=m}Kb(v|0,j|0,n)|0;a[v+n|0]=0;i=g;return}}while(0);g=bQ(-1,-1)|0;n=g;g=K;c[h>>2]=16616;if((a[b+4|0]&1)==0){p=g;q=n;r=q;s=0;t=r;u=p;be(t|0)}J2(c[b+12>>2]|0);p=g;q=n;r=q;s=0;t=r;u=p;be(t|0)}function wi(b){b=b|0;var d=0;d=b|0;c[d>>2]=19464;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function wj(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=19464;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function wk(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+184>>2]&1023](b,a);return}function wl(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+184>>2]&1023](b,a)|0}function wm(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+184>>2]&1023](b,a)|0}function wn(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+184>>2]&1023](b,a)|0}function wo(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+184>>2]&1023](b,a)|0}function wp(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+184>>2]&511](a,d,b);return}function wq(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+184>>2]&511](a,d,b);return}function wr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=J0(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];x=0;aP(282,k|0,h|0,j|0);if(x){x=0;j=bQ(-1,-1)|0;k=j;j=K;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}J2(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}h=b|0;c[h>>2]=20384;k=b+32|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;v=k+1|0}else{f=n+16&-16;m=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=m;c[k>>2]=f|1;c[b+36>>2]=n;v=m}Kb(v|0,j|0,n)|0;a[v+n|0]=0;i=g;return}}while(0);g=bQ(-1,-1)|0;n=g;g=K;c[h>>2]=16616;if((a[b+4|0]&1)==0){p=g;q=n;r=q;s=0;t=r;u=p;be(t|0)}J2(c[b+12>>2]|0);p=g;q=n;r=q;s=0;t=r;u=p;be(t|0)}function ws(b){b=b|0;var d=0;d=b|0;c[d>>2]=20384;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function wt(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=20384;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function wu(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+180>>2]&1023](b,a);return}function wv(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+180>>2]&1023](b,a)|0}function ww(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+180>>2]&1023](b,a)|0}function wx(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+180>>2]&1023](b,a)|0}function wy(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+180>>2]&1023](b,a)|0}function wz(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+180>>2]&511](a,d,b);return}function wA(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+180>>2]&511](a,d,b);return}function wB(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function wC(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function wD(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+168>>2]&1023](b,a);return}function wE(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+168>>2]&1023](b,a)|0}function wF(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+168>>2]&1023](b,a)|0}function wG(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+168>>2]&1023](b,a)|0}function wH(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+168>>2]&1023](b,a)|0}function wI(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+168>>2]&511](a,d,b);return}function wJ(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+168>>2]&511](a,d,b);return}function wK(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function wL(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function wM(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+20>>2]&1023](b,a);return}function wN(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+20>>2]&1023](b,a)|0}function wO(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+20>>2]&1023](b,a)|0}function wP(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+20>>2]&1023](b,a)|0}function wQ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+20>>2]&1023](b,a)|0}function wR(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+20>>2]&511](a,d,b);return}function wS(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+20>>2]&511](a,d,b);return}function wT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=J0(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];x=0;aP(402,m|0,k|0,l|0);if(x){x=0;l=bQ(-1,-1)|0;m=l;l=K;if((a[k]&1)==0){r=l;s=m;t=s;u=0;v=t;w=r;be(v|0)}J2(c[k+8>>2]|0);r=l;s=m;t=s;u=0;v=t;w=r;be(v|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}k=b|0;c[k>>2]=21928;m=b+28|0;l=f;if((a[l]&1)==0){p=m;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];y=b+40|0;c[y>>2]=g;z=b+44|0;A=h&1;a[z]=A;i=j;return}l=c[f+8>>2]|0;p=c[f+4>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(p>>>0<11>>>0){a[m]=p<<1;B=m+1|0}else{f=p+16&-16;o=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+36>>2]=o;c[m>>2]=f|1;c[b+32>>2]=p;B=o}Kb(B|0,l|0,p)|0;a[B+p|0]=0;y=b+40|0;c[y>>2]=g;z=b+44|0;A=h&1;a[z]=A;i=j;return}}while(0);j=bQ(-1,-1)|0;A=j;j=K;c[k>>2]=16616;if((a[b+4|0]&1)==0){r=j;s=A;t=s;u=0;v=t;w=r;be(v|0)}J2(c[b+12>>2]|0);r=j;s=A;t=s;u=0;v=t;w=r;be(v|0)}function wU(b){b=b|0;var d=0;d=b|0;c[d>>2]=21928;if((a[b+28|0]&1)!=0){J2(c[b+36>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function wV(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=21928;if((a[b+28|0]&1)!=0){J2(c[b+36>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function wW(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+36>>2]&1023](b,a);return}function wX(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+36>>2]&1023](b,a)|0}function wY(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+36>>2]&1023](b,a)|0}function wZ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+36>>2]&1023](b,a)|0}function w_(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+36>>2]&1023](b,a)|0}function w$(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+36>>2]&511](a,d,b);return}function w0(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+36>>2]&511](a,d,b);return}function w1(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0;j=i;i=i+80|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=d;if((a[p]&1)==0){q=l;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];r=a[q]|0;s=q}else{q=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){CJ(0)}if(p>>>0<11>>>0){d=p<<1&255;t=l;a[t]=d;u=l+1|0;v=d;w=t}else{t=p+16&-16;d=J0(t)|0;c[l+8>>2]=d;y=t|1;c[l>>2]=y;c[l+4>>2]=p;u=d;v=y&255;w=l}Kb(u|0,q|0,p)|0;a[u+p|0]=0;r=v;s=w}w=e;e=k;c[e>>2]=c[w>>2];c[e+4>>2]=c[w+4>>2];c[e+8>>2]=c[w+8>>2];w=k;k=b|0;c[k>>2]=16616;e=b+4|0;L12:do{if((r&1)==0){v=e;c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2]}else{v=c[l+8>>2]|0;p=c[l+4>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(p>>>0<11>>>0){a[e]=p<<1;z=e+1|0}else{u=p+16&-16;q=(x=0,as(230,u|0)|0);if(x){x=0;break}c[b+12>>2]=q;c[e>>2]=u|1;c[b+8>>2]=p;z=q}Kb(z|0,v|0,p)|0;a[z+p|0]=0;break L12}}while(0);p=bQ(-1,-1)|0;q=p;p=K;if((a[s]&1)==0){A=p;B=q;C=B;D=0;E=C;F=A;be(E|0)}J2(v);A=p;B=q;C=B;D=0;E=C;F=A;be(E|0)}}while(0);z=b+16|0;c[z>>2]=c[w>>2];c[z+4>>2]=c[w+4>>2];c[z+8>>2]=c[w+8>>2];if((a[s]&1)!=0){J2(c[l+8>>2]|0)}c[k>>2]=16136;l=b+28|0;s=f;L33:do{if((a[s]&1)==0){w=l;c[w>>2]=c[s>>2];c[w+4>>2]=c[s+4>>2];c[w+8>>2]=c[s+8>>2];G=31}else{w=c[f+8>>2]|0;r=c[f+4>>2]|0;do{if(r>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(r>>>0<11>>>0){a[l]=r<<1;H=l+1|0}else{q=r+16&-16;p=(x=0,as(230,q|0)|0);if(x){x=0;break}c[b+36>>2]=p;c[l>>2]=q|1;c[b+32>>2]=r;H=p}Kb(H|0,w|0,r)|0;a[H+r|0]=0;G=31;break L33}}while(0);r=bQ(-1,-1)|0;I=K;J=r}}while(0);do{if((G|0)==31){c[b+40>>2]=g;a[b+44|0]=h&1;if((g|0)==0|h^1){i=j;return}H=(x=0,as(230,64)|0);do{if(!x){f=m+8|0;c[f>>2]=H;c[m>>2]=65;c[m+4>>2]=54;Kb(H|0,792,54)|0;a[H+54|0]=0;s=e;L53:do{if((a[s]&1)==0){r=n;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];G=43}else{r=c[b+12>>2]|0;w=c[b+8>>2]|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(w>>>0<11>>>0){a[n]=w<<1;L=n+1|0}else{v=w+16&-16;p=(x=0,as(230,v|0)|0);if(x){x=0;break}c[n+8>>2]=p;c[n>>2]=v|1;c[n+4>>2]=w;L=p}Kb(L|0,r|0,w)|0;a[L+w|0]=0;G=43;break L53}}while(0);w=bQ(-1,-1)|0;M=K;N=w}}while(0);do{if((G|0)==43){s=o;c[s>>2]=c[z>>2];c[s+4>>2]=c[z+4>>2];c[s+8>>2]=c[z+8>>2];x=0;aP(362,m|0,n|0,o|0);if(x){x=0;s=bQ(-1,-1)|0;w=s;s=K;if((a[n]&1)==0){M=s;N=w;break}J2(c[n+8>>2]|0);M=s;N=w;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[m]&1)==0){i=j;return}J2(c[f>>2]|0);i=j;return}}while(0);if((a[m]&1)==0){O=M;P=N;break}J2(c[f>>2]|0);O=M;P=N}else{x=0;w=bQ(-1,-1)|0;O=K;P=w}}while(0);if((a[l]&1)==0){I=O;J=P;break}J2(c[b+36>>2]|0);I=O;J=P}}while(0);c[k>>2]=16616;if((a[e]&1)==0){A=I;B=J;C=B;D=0;E=C;F=A;be(E|0)}J2(c[b+12>>2]|0);A=I;B=J;C=B;D=0;E=C;F=A;be(E|0)}function w2(b){b=b|0;var d=0;d=b|0;c[d>>2]=16136;if((a[b+28|0]&1)!=0){J2(c[b+36>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function w3(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=16136;if((a[b+28|0]&1)!=0){J2(c[b+36>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function w4(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+152>>2]&1023](b,a);return}function w5(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+152>>2]&1023](b,a)|0}function w6(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+152>>2]&1023](b,a)|0}function w7(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+152>>2]&1023](b,a)|0}function w8(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+152>>2]&1023](b,a)|0}function w9(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+152>>2]&511](a,d,b);return}function xa(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+152>>2]&511](a,d,b);return}function xb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=b|0;k=d;if((a[k]&1)==0){l=g;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2]}else{k=c[d+8>>2]|0;l=c[d+4>>2]|0;if(l>>>0>4294967279>>>0){CJ(0)}if(l>>>0<11>>>0){a[g]=l<<1;m=g+1|0}else{d=l+16&-16;n=J0(d)|0;c[g+8>>2]=n;c[g>>2]=d|1;c[g+4>>2]=l;m=n}Kb(m|0,k|0,l)|0;a[m+l|0]=0}l=h;m=e;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];x=0;aP(402,j|0,g|0,h|0);if(!x){if((a[g]&1)==0){o=b|0;c[o>>2]=17640;p=b+28|0;q=p;Ke(q|0,0,24)|0;i=f;return}J2(c[g+8>>2]|0);o=b|0;c[o>>2]=17640;p=b+28|0;q=p;Ke(q|0,0,24)|0;i=f;return}else{x=0;f=bQ(-1,-1)|0;if((a[g]&1)==0){be(f|0)}J2(c[g+8>>2]|0);be(f|0)}}function xc(a){a=a|0;xl(a);return}function xd(a){a=a|0;var b=0;x=0;ap(54,a|0);if(!x){J2(a);return}else{x=0;b=bQ(-1,-1)|0;J2(a);be(b|0)}}function xe(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+40>>2]&1023](b,a);return}function xf(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+40>>2]&1023](b,a)|0}function xg(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+40>>2]&1023](b,a)|0}function xh(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+40>>2]&1023](b,a)|0}function xi(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+40>>2]&1023](b,a)|0}function xj(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+40>>2]&511](a,d,b);return}function xk(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+40>>2]&511](a,d,b);return}function xl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=b|0;c[d>>2]=17640;e=c[b+40>>2]|0;f=e;if((e|0)!=0){g=b+44|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}J2(e)}e=b+28|0;f=c[e>>2]|0;if((f|0)!=0){h=b+32|0;g=c[h>>2]|0;if((f|0)==(g|0)){i=f}else{j=g;while(1){g=j-12|0;c[h>>2]=g;if((a[g]&1)==0){k=g}else{J2(c[j-12+8>>2]|0);k=c[h>>2]|0}if((f|0)==(k|0)){break}else{j=k}}i=c[e>>2]|0}J2(i)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function xm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=J0(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];x=0;aP(402,k|0,h|0,j|0);if(x){x=0;j=bQ(-1,-1)|0;k=j;j=K;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}J2(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}h=b|0;c[h>>2]=21296;k=b+28|0;j=f;if((a[j]&1)==0){n=k;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];i=g;return}j=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(n>>>0<11>>>0){a[k]=n<<1;v=k+1|0}else{f=n+16&-16;m=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+36>>2]=m;c[k>>2]=f|1;c[b+32>>2]=n;v=m}Kb(v|0,j|0,n)|0;a[v+n|0]=0;i=g;return}}while(0);g=bQ(-1,-1)|0;n=g;g=K;c[h>>2]=16616;if((a[b+4|0]&1)==0){p=g;q=n;r=q;s=0;t=r;u=p;be(t|0)}J2(c[b+12>>2]|0);p=g;q=n;r=q;s=0;t=r;u=p;be(t|0)}function xn(b){b=b|0;var d=0;d=b|0;c[d>>2]=21296;if((a[b+28|0]&1)!=0){J2(c[b+36>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function xo(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=21296;if((a[b+28|0]&1)!=0){J2(c[b+36>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function xp(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+44>>2]&1023](b,a);return}function xq(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+44>>2]&1023](b,a)|0}function xr(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+44>>2]&1023](b,a)|0}function xs(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+44>>2]&1023](b,a)|0}function xt(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+44>>2]&1023](b,a)|0}function xu(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+44>>2]&511](a,d,b);return}function xv(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+44>>2]&511](a,d,b);return}function xw(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function xx(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function xy(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+52>>2]&1023](b,a);return}function xz(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+52>>2]&1023](b,a)|0}function xA(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+52>>2]&1023](b,a)|0}function xB(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+52>>2]&1023](b,a)|0}function xC(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+52>>2]&1023](b,a)|0}function xD(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+52>>2]&511](a,d,b);return}function xE(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+52>>2]&511](a,d,b);return}function xF(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=J0(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}Kb(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];x=0;ao(8,l|0,j|0,k|0,g|0,1);if(x){x=0;g=bQ(-1,-1)|0;k=g;g=K;if((a[j]&1)==0){q=g;r=k;s=r;t=0;u=s;v=q;be(u|0)}J2(c[j+8>>2]|0);q=g;r=k;s=r;t=0;u=s;v=q;be(u|0)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}j=b|0;c[j>>2]=20144;k=b+40|0;g=c[f>>2]|0;l=c[f+4>>2]|0;f=g;o=l-f|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[k]=o<<1;w=k+1|0}else{n=o+16&-16;e=(x=0,as(230,n|0)|0);if(x){x=0;break}c[b+48>>2]=e;c[k>>2]=n|1;c[b+44>>2]=o;w=e}if((g|0)==(l|0)){y=w;a[y]=0;i=h;return}e=l+(-f|0)|0;n=w;m=g;while(1){a[n]=a[m]|0;p=m+1|0;if((p|0)==(l|0)){break}else{n=n+1|0;m=p}}y=w+e|0;a[y]=0;i=h;return}}while(0);h=bQ(-1,-1)|0;y=h;h=K;c[j>>2]=16616;if((a[b+4|0]&1)==0){q=h;r=y;s=r;t=0;u=s;v=q;be(u|0)}J2(c[b+12>>2]|0);q=h;r=y;s=r;t=0;u=s;v=q;be(u|0)}function xG(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;g=i;i=i+8|0;h=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[h>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];h=g|0;c[b>>2]=d;d=b+4|0;j=d|0;k=b+8|0;l=b+12|0;m=b+28|0;n=e;Ke(d|0,0,24)|0;L1:do{if((a[n]&1)==0){o=m;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];p=0;q=0;r=11}else{o=c[e+8>>2]|0;s=c[e+4>>2]|0;do{if(s>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(s>>>0<11>>>0){a[m]=s<<1;t=m+1|0}else{u=s+16&-16;v=(x=0,as(230,u|0)|0);if(x){x=0;break}c[b+36>>2]=v;c[m>>2]=u|1;c[b+32>>2]=s;t=v}Kb(t|0,o|0,s)|0;a[t+s|0]=0;p=c[k>>2]|0;q=c[l>>2]|0;r=11;break L1}}while(0);s=bQ(-1,-1)|0;w=K;y=s}}while(0);do{if((r|0)==11){c[b+40>>2]=1;l=b+44|0;t=f;c[l>>2]=c[t>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[b+56>>2]=0;c[b+60>>2]=0;c[h>>2]=0;if((p|0)==(q|0)){x=0;aq(74,d|0,h|0);if(!x){i=g;return}else{x=0}t=bQ(-1,-1)|0;l=t;t=K;if((a[m]&1)==0){w=t;y=l;break}J2(c[b+36>>2]|0);w=t;y=l;break}else{if((p|0)==0){z=0}else{c[p>>2]=0;z=c[k>>2]|0}c[k>>2]=z+4;i=g;return}}}while(0);g=c[j>>2]|0;if((g|0)==0){A=y;B=0;C=A;D=w;be(C|0)}j=c[k>>2]|0;if((g|0)!=(j|0)){c[k>>2]=j+(~((j-4+(-g|0)|0)>>>2)<<2)}J2(g);A=y;B=0;C=A;D=w;be(C|0)}function xH(b){b=b|0;var c=0,d=0,e=0,f=0;c=(a4(a[b]|0)|0)==0;d=c?0:b+1|0;if((d|0)==0){e=0;return e|0}else{f=d}while(1){d=(a4(a[f]|0)|0)==0;b=d?0:f+1|0;if((b|0)==0){e=f;break}else{f=b}}return e|0}function xI(b){b=b|0;var c=0,d=0,e=0;c=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((c|0)==0){d=0;return d|0}else{e=c}while(1){c=((a[e]|0)-48|0)>>>0<10>>>0?e+1|0:0;if((c|0)==0){d=e;break}else{e=c}}return d|0}function xJ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a[35696]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35696;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);c=e<<24>>24!=0?0:d;if((c|0)==0){l=0;return l|0}else{m=c}while(1){c=a[m]|0;if((c<<24>>24|0)==10|(c<<24>>24|0)==0){l=m;break}m=m+1|0}return l|0}function xK(a){a=a|0;return xL(a)|0}function xL(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=(a4(a[b]|0)|0)==0;d=c?0:b+1|0;if((d|0)==0){e=0}else{c=d;while(1){d=(a4(a[c]|0)|0)==0;f=d?0:c+1|0;if((f|0)==0){e=c;break}else{c=f}}}c=(e|0)!=0?e:b;if((c|0)==0){g=0;return g|0}b=a[35792]|0;L8:do{if(b<<24>>24==0){h=c;i=0}else{e=c;f=35792;d=b;while(1){if((a[e]|0)!=d<<24>>24){h=e;i=d;break L8}j=e+1|0;k=f+1|0;l=a[k]|0;if(l<<24>>24==0){h=j;i=0;break}else{e=j;f=k;d=l}}}}while(0);b=i<<24>>24!=0?0:h;if((b|0)==0){g=0;return g|0}h=a[35776]|0;if(h<<24>>24==0){i=b;while(1){if((a[i]|0)==0){g=0;m=22;break}if((i|0)==0){i=i+1|0}else{g=i;m=18;break}}if((m|0)==18){return g|0}else if((m|0)==22){return g|0}}else{n=b}while(1){b=a[n]|0;if(b<<24>>24==0){g=0;m=21;break}L26:do{if(b<<24>>24==h<<24>>24){i=35776;c=n;while(1){d=c+1|0;f=i+1|0;e=a[f]|0;if(e<<24>>24==0){o=d;p=0;break L26}if((a[d]|0)==e<<24>>24){i=f;c=d}else{o=d;p=e;break}}}else{o=n;p=h}}while(0);b=p<<24>>24!=0?0:o;if((b|0)==0){n=n+1|0}else{g=b;m=19;break}}if((m|0)==21){return g|0}else if((m|0)==19){return g|0}return 0}function xM(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a[b]|0;d=b+1|0;b=c<<24>>24==34?d:0;L1:do{if((b|0)!=0){e=a[b]|0;if(e<<24>>24==0){break}else{f=b;g=e}while(1){e=f+1|0;h=g<<24>>24==34?e:0;if((h|0)==0){i=e}else{if((a[f-1|0]|0)==92){i=h}else{j=h;break}}h=a[i]|0;if(h<<24>>24==0){break L1}else{f=i;g=h}}return j|0}}while(0);g=c<<24>>24==39?d:0;if((g|0)==0){j=0;return j|0}d=a[g]|0;if(d<<24>>24==0){j=0;return j|0}else{k=g;l=d}while(1){d=k+1|0;g=l<<24>>24==39?d:0;if((g|0)==0){m=d}else{if((a[k-1|0]|0)==92){m=g}else{j=g;n=13;break}}g=a[m]|0;if(g<<24>>24==0){j=0;n=12;break}else{k=m;l=g}}if((n|0)==13){return j|0}else if((n|0)==12){return j|0}return 0}function xN(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a[35720]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35720;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);c=e<<24>>24!=0?0:d;if((c|0)==0){l=0;return l|0}d=a[35456]|0;if(d<<24>>24==0){e=c;while(1){if((a[e]|0)==0){l=0;m=18;break}if((e|0)==0){e=e+1|0}else{l=e;m=14;break}}if((m|0)==14){return l|0}else if((m|0)==18){return l|0}}else{n=c}while(1){c=a[n]|0;if(c<<24>>24==0){l=0;m=17;break}L19:do{if(c<<24>>24==d<<24>>24){e=35456;b=n;while(1){h=b+1|0;g=e+1|0;f=a[g]|0;if(f<<24>>24==0){o=h;p=0;break L19}if((a[h]|0)==f<<24>>24){e=g;b=h}else{o=h;p=f;break}}}else{o=n;p=d}}while(0);c=p<<24>>24!=0?0:o;if((c|0)==0){n=n+1|0}else{l=c;m=16;break}}if((m|0)==17){return l|0}else if((m|0)==16){return l|0}return 0}function xO(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a4(a[b]|0)|0)==0;d=c?0:b+1|0;if((d|0)==0){e=0;f=(e|0)!=0;g=f?e:b;return g|0}else{h=d}while(1){d=(a4(a[h]|0)|0)==0;c=d?0:h+1|0;if((c|0)==0){e=h;break}else{h=c}}f=(e|0)!=0;g=f?e:b;return g|0}function xP(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=(a4(a[b]|0)|0)==0;d=c?0:b+1|0;do{if((d|0)==0){c=xL(b)|0;if((c|0)!=0){e=c;break}c=a[35696]|0;L6:do{if(c<<24>>24==0){f=b;g=0}else{h=b;i=35696;j=c;while(1){if((a[h]|0)!=j<<24>>24){f=h;g=j;break L6}k=h+1|0;l=i+1|0;m=a[l]|0;if(m<<24>>24==0){f=k;g=0;break}else{h=k;i=l;j=m}}}}while(0);c=g<<24>>24!=0?0:f;if((c|0)==0){n=b;return n|0}else{o=c}while(1){c=a[o]|0;if((c<<24>>24|0)==10|(c<<24>>24|0)==0){break}o=o+1|0}if((o|0)==0){n=b}else{e=o;break}return n|0}else{c=d;while(1){j=(a4(a[c]|0)|0)==0;i=j?0:c+1|0;if((i|0)==0){e=c;break}else{c=i}}}}while(0);d=a[35696]|0;if(d<<24>>24==0){o=e;L20:while(1){b=(a4(a[o]|0)|0)==0;f=b?0:o+1|0;if((f|0)!=0){b=f;while(1){f=(a4(a[b]|0)|0)==0;g=f?0:b+1|0;if((g|0)==0){o=b;continue L20}else{b=g}}}b=xL(o)|0;if((b|0)!=0){o=b;continue}if((o|0)==0){n=0;p=31;break}else{q=o}while(1){b=a[q]|0;if((b<<24>>24|0)==10|(b<<24>>24|0)==0){break}q=q+1|0}if((q|0)==0){n=o;p=30;break}else{o=q}}if((p|0)==30){return n|0}else if((p|0)==31){return n|0}}else{r=e}L34:while(1){e=(a4(a[r]|0)|0)==0;q=e?0:r+1|0;if((q|0)!=0){e=q;while(1){q=(a4(a[e]|0)|0)==0;o=q?0:e+1|0;if((o|0)==0){r=e;continue L34}else{e=o}}}e=xL(r)|0;if((e|0)==0){s=r;t=35696;u=d}else{r=e;continue}while(1){if((a[s]|0)!=u<<24>>24){v=s;w=u;break}e=s+1|0;o=t+1|0;q=a[o]|0;if(q<<24>>24==0){v=e;w=0;break}else{s=e;t=o;u=q}}q=w<<24>>24!=0?0:v;if((q|0)==0){n=r;p=33;break}else{x=q}while(1){q=a[x]|0;if((q<<24>>24|0)==10|(q<<24>>24|0)==0){break}x=x+1|0}if((x|0)==0){n=r;p=29;break}else{r=x}}if((p|0)==33){return n|0}else if((p|0)==29){return n|0}return 0}function xQ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a[b]|0)==45?b+1|0:0;d=(c|0)!=0?c:b;if((d|0)==0){e=0;return e|0}b=(bP(a[d]|0)|0)==0;c=d+1|0;f=b?0:c;do{if((f|0)==0){b=a[d]|0;g=b<<24>>24==95?c:0;if((g|0)!=0){h=g;break}g=b<<24>>24==92?c:0;if((g|0)==0){e=0;return e|0}b=(a[g]|0)!=0?g+1|0:g;if((b|0)==0){e=0}else{h=b;break}return e|0}else{h=f}}while(0);e=y5(h)|0;return e|0}function xR(a){a=a|0;var b=0,c=0,d=0;b=y3(a)|0;if((b|0)==0){c=0;return c|0}else{d=b}while(1){b=y3(d)|0;if((b|0)==0){c=d;break}else{d=b}}return c|0}function xS(a){a=a|0;var b=0,c=0,d=0;b=y1(a)|0;if((b|0)==0){c=0;return c|0}else{d=b}while(1){b=y1(d)|0;if((b|0)==0){c=d;break}else{d=b}}return c|0}function xT(a){a=a|0;var b=0,c=0,d=0;b=y_(a)|0;if((b|0)==0){c=0;return c|0}else{d=b}while(1){b=y_(d)|0;if((b|0)==0){c=d;break}else{d=b}}return c|0}function xU(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a[b]|0)==64?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==45?c+1|0:0;e=(b|0)!=0?b:c;if((e|0)==0){d=0;return d|0}c=(bP(a[e]|0)|0)==0;b=e+1|0;f=c?0:b;do{if((f|0)==0){c=a[e]|0;g=c<<24>>24==95?b:0;if((g|0)!=0){h=g;break}g=c<<24>>24==92?b:0;if((g|0)==0){d=0;return d|0}c=(a[g]|0)!=0?g+1|0:g;if((c|0)==0){d=0}else{h=c;break}return d|0}else{h=f}}while(0);d=y5(h)|0;return d|0}function xV(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35832]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35832;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function xW(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35312]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35312;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function xX(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35304]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35304;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function xY(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35616]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35616;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function xZ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35808]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35808;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x_(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35704]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35704;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x$(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35736]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35736;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x0(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35840]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35840;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x1(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35480]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35480;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x2(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35384]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35384;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x3(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35432]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35432;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x4(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35368]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35368;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x5(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35448]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35448;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x6(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35688]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35688;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x7(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35400]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35400;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x8(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35472]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35472;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function x9(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35280]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35280;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function ya(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35328]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35328;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yb(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35360]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35360;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yc(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=yZ(b)|0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==45?c+1|0:0;e=(b|0)!=0?b:c;if((e|0)==0){d=0;return d|0}c=(bP(a[e]|0)|0)==0;b=e+1|0;f=c?0:b;do{if((f|0)==0){c=a[e]|0;g=c<<24>>24==95?b:0;if((g|0)!=0){h=g;break}g=c<<24>>24==92?b:0;if((g|0)==0){d=0;return d|0}c=(a[g]|0)!=0?g+1|0:g;if((c|0)==0){d=0}else{h=c;break}return d|0}else{h=f}}while(0);d=y5(h)|0;return d|0}function yd(b){b=b|0;var c=0,d=0;c=yZ(b)|0;if((c|0)==0){d=0;return d|0}d=(a[c]|0)==42?c+1|0:0;return d|0}function ye(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a[b]|0)==35?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(bO(a[c]|0)|0)==0;e=c+1|0;f=b?0:e;do{if((f|0)==0){b=a[c]|0;g=b<<24>>24==45?e:0;if((g|0)!=0){h=g;break}g=b<<24>>24==95?e:0;if((g|0)==0){d=0}else{h=g;break}return d|0}else{h=f}}while(0);while(1){f=(bO(a[h]|0)|0)==0;e=h+1|0;c=f?0:e;if((c|0)!=0){h=c;continue}c=a[h]|0;f=c<<24>>24==45?e:0;if((f|0)!=0){h=f;continue}f=c<<24>>24==95?e:0;if((f|0)==0){d=h;break}else{h=f}}return d|0}function yf(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a[b]|0)==46?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==45?c+1|0:0;e=(b|0)!=0?b:c;if((e|0)==0){d=0;return d|0}c=(bP(a[e]|0)|0)==0;b=e+1|0;f=c?0:b;do{if((f|0)==0){c=a[e]|0;g=c<<24>>24==95?b:0;if((g|0)!=0){h=g;break}g=c<<24>>24==92?b:0;if((g|0)==0){d=0;return d|0}c=(a[g]|0)!=0?g+1|0:g;if((c|0)==0){d=0}else{h=c;break}return d|0}else{h=f}}while(0);d=y5(h)|0;return d|0}function yg(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a[b]|0)==37?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==45?c+1|0:0;e=(b|0)!=0?b:c;if((e|0)==0){d=0;return d|0}c=(bP(a[e]|0)|0)==0;b=e+1|0;f=c?0:b;do{if((f|0)==0){c=a[e]|0;g=c<<24>>24==95?b:0;if((g|0)!=0){h=g;break}g=c<<24>>24==92?b:0;if((g|0)==0){d=0;return d|0}c=(a[g]|0)!=0?g+1|0:g;if((c|0)==0){d=0}else{h=c;break}return d|0}else{h=f}}while(0);d=y5(h)|0;return d|0}function yh(b){b=b|0;var c=0,d=0,e=0;c=35800;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}return(e?0:b+1|0)|0}function yi(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=35800;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=e?0:b+1|0;e=(c|0)!=0?c:b;if((e|0)==0){f=0;return f|0}b=a[e]|0;c=((b<<24>>24)-48|0)>>>0<10>>>0?e+1|0:0;d=(c|0)==0;if(d){g=e;h=b}else{b=c;while(1){e=a[b]|0;i=((e<<24>>24)-48|0)>>>0<10>>>0?b+1|0:0;if((i|0)==0){g=b;h=e;break}else{b=i}}}b=h<<24>>24==46?g+1|0:0;do{if((b|0)!=0){g=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((g|0)==0){break}else{j=g}while(1){g=((a[j]|0)-48|0)>>>0<10>>>0?j+1|0:0;if((g|0)==0){f=j;break}else{j=g}}return f|0}}while(0);if(d){f=0;return f|0}else{k=c}while(1){c=((a[k]|0)-48|0)>>>0<10>>>0?k+1|0:0;if((c|0)==0){f=k;break}else{k=c}}return f|0}function yj(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=35800;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=b+1|0;d=e?0:c;e=(d|0)!=0?d:b;do{if((e|0)==0){f=35800}else{d=((a[e]|0)-48|0)>>>0<10>>>0?e+1|0:0;if((d|0)==0){f=35800;break}else{g=d}while(1){d=((a[g]|0)-48|0)>>>0<10>>>0?g+1|0:0;if((d|0)==0){h=g;break}else{g=d}}return h|0}}while(0);while(1){g=a[f]|0;if(g<<24>>24==0){h=0;i=10;break}if((a[b]|0)==g<<24>>24){h=c;i=12;break}else{f=f+1|0}}if((i|0)==10){return h|0}else if((i|0)==12){return h|0}return 0}function yk(a){a=a|0;return yl(a)|0}function yl(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=35800;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=e?0:b+1|0;e=(c|0)!=0?c:b;if((e|0)==0){f=0;return f|0}b=((a[e]|0)-48|0)>>>0<10>>>0?e+1|0:0;if((b|0)==0){g=0}else{c=b;while(1){b=((a[c]|0)-48|0)>>>0<10>>>0?c+1|0:0;if((b|0)==0){g=c;break}else{c=b}}}c=(g|0)!=0?g:e;if((c|0)==0){f=0;return f|0}e=(a[c]|0)==110?c+1|0:0;if((e|0)==0){f=0;return f|0}c=(a4(a[e]|0)|0)==0;g=c?0:e+1|0;if((g|0)==0){h=0}else{c=g;while(1){g=(a4(a[c]|0)|0)==0;b=g?0:c+1|0;if((b|0)==0){h=c;break}else{c=b}}}c=(h|0)!=0?h:e;if((c|0)==0){f=0;return f|0}else{i=35800}while(1){e=a[i]|0;if(e<<24>>24==0){j=1;break}if((a[c]|0)==e<<24>>24){j=0;break}else{i=i+1|0}}i=j?0:c+1|0;if((i|0)==0){f=0;return f|0}c=(a4(a[i]|0)|0)==0;j=c?0:i+1|0;if((j|0)==0){k=0}else{c=j;while(1){j=(a4(a[c]|0)|0)==0;e=j?0:c+1|0;if((e|0)==0){k=c;break}else{c=e}}}c=(k|0)!=0?k:i;if((c|0)==0){f=0;return f|0}i=((a[c]|0)-48|0)>>>0<10>>>0?c+1|0:0;if((i|0)==0){f=0;return f|0}else{l=i}while(1){i=((a[l]|0)-48|0)>>>0<10>>>0?l+1|0:0;if((i|0)==0){f=l;break}else{l=i}}return f|0}function ym(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=35800;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=e?0:b+1|0;e=(c|0)!=0?c:b;if((e|0)==0){f=0;return f|0}b=a[e]|0;c=((b<<24>>24)-48|0)>>>0<10>>>0?e+1|0:0;d=(c|0)==0;if(d){g=e;h=b}else{b=c;while(1){e=a[b]|0;i=((e<<24>>24)-48|0)>>>0<10>>>0?b+1|0:0;if((i|0)==0){g=b;h=e;break}else{b=i}}}b=h<<24>>24==46?g+1|0:0;do{if((b|0)==0){j=10}else{g=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((g|0)==0){j=10;break}else{k=g}while(1){g=a[k]|0;h=((g<<24>>24)-48|0)>>>0<10>>>0?k+1|0:0;if((h|0)==0){l=k;m=g;break}else{k=h}}}}while(0);if((j|0)==10){if(d){f=0;return f|0}else{d=c;while(1){c=a[d]|0;j=((c<<24>>24)-48|0)>>>0<10>>>0?d+1|0:0;if((j|0)==0){l=d;m=c;break}else{d=j}}}}f=m<<24>>24==37?l+1|0:0;return f|0}function yn(a){a=a|0;return yo(a)|0}function yo(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=35800;while(1){d=a[c]|0;if(d<<24>>24==0){e=1;break}if((a[b]|0)==d<<24>>24){e=0;break}else{c=c+1|0}}c=e?0:b+1|0;e=(c|0)!=0?c:b;if((e|0)==0){f=0;return f|0}b=a[e]|0;c=((b<<24>>24)-48|0)>>>0<10>>>0?e+1|0:0;d=(c|0)==0;if(d){g=e;h=b}else{b=c;while(1){e=a[b]|0;i=((e<<24>>24)-48|0)>>>0<10>>>0?b+1|0:0;if((i|0)==0){g=b;h=e;break}else{b=i}}}b=h<<24>>24==46?g+1|0:0;do{if((b|0)==0){j=10}else{g=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((g|0)==0){j=10;break}else{k=g}while(1){g=a[k]|0;h=((g<<24>>24)-48|0)>>>0<10>>>0?k+1|0:0;if((h|0)==0){l=k;m=g;break}else{k=h}}}}while(0);if((j|0)==10){if(d){f=0;return f|0}else{d=c;while(1){c=a[d]|0;j=((c<<24>>24)-48|0)>>>0<10>>>0?d+1|0:0;if((j|0)==0){l=d;m=c;break}else{d=j}}}}d=m<<24>>24==45?l+1|0:0;m=(d|0)!=0?d:l;if((m|0)==0){f=0;return f|0}l=(bP(a[m]|0)|0)==0;d=m+1|0;j=l?0:d;do{if((j|0)==0){l=a[m]|0;c=l<<24>>24==95?d:0;if((c|0)!=0){n=c;break}c=l<<24>>24==92?d:0;if((c|0)==0){f=0;return f|0}l=(a[c]|0)!=0?c+1|0:c;if((l|0)==0){f=0}else{n=l;break}return f|0}else{n=j}}while(0);f=y5(n)|0;return f|0}function yp(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=(a[b]|0)==35?b+1|0:0;do{if((c|0)==0){d=0}else{e=(bo(a[c]|0)|0)==0;f=e?0:c+1|0;if((f|0)==0){d=0;break}else{g=f}while(1){f=(bo(a[g]|0)|0)==0;e=f?0:g+1|0;if((e|0)==0){d=g;break}else{g=e}}}}while(0);g=d-b|0;return((g|0)!=4&(g|0)!=7?0:d)|0}function yq(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35408]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35408;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yr(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=(a[b]|0)==45?b+1|0:0;d=(c|0)!=0?c:b;L1:do{if((d|0)==0){e=0}else{c=(bP(a[d]|0)|0)==0;f=d+1|0;g=c?0:f;do{if((g|0)==0){c=a[d]|0;h=c<<24>>24==95?f:0;if((h|0)!=0){i=h;break}h=c<<24>>24==92?f:0;if((h|0)==0){e=0;break L1}c=(a[h]|0)!=0?h+1|0:h;if((c|0)==0){e=0;break L1}else{i=c}}else{i=g}}while(0);g=y5(i)|0;if((g|0)==0){e=0;break}e=(a[g]|0)==58?g+1|0:0}}while(0);i=(e|0)!=0?e:b;if((i|0)==0){j=0;return j|0}b=yY(i)|0;if((b|0)==0){j=0;return j|0}i=(a[b]|0)==47?b+1|0:0;j=(i|0)!=0?i:b;return j|0}function ys(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=(a[b]|0)==45?b+1|0:0;d=(c|0)!=0?c:b;L1:do{if((d|0)==0){e=0}else{c=(bP(a[d]|0)|0)==0;f=d+1|0;g=c?0:f;do{if((g|0)==0){c=a[d]|0;h=c<<24>>24==95?f:0;if((h|0)!=0){i=h;break}h=c<<24>>24==92?f:0;if((h|0)==0){e=0;break L1}c=(a[h]|0)!=0?h+1|0:h;if((c|0)==0){e=0;break L1}else{i=c}}else{i=g}}while(0);g=y5(i)|0;if((g|0)==0){e=0;break}e=(a[g]|0)==58?g+1|0:0}}while(0);i=(e|0)!=0?e:b;if((i|0)==0){j=0;return j|0}b=y$(i)|0;if((b|0)==0){j=0;return j|0}else{k=b}while(1){b=y$(k)|0;if((b|0)==0){j=k;break}else{k=b}}return j|0}function yt(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=(a[b]|0)==33?b+1|0:0;if((c|0)==0){d=0;return d|0}b=xP(c)|0;if((b|0)==0){d=0;return d|0}c=a[35592]|0;L7:do{if(c<<24>>24==0){e=b;f=0}else{g=b;h=35592;i=c;while(1){if((a[g]|0)!=i<<24>>24){e=g;f=i;break L7}j=g+1|0;k=h+1|0;l=a[k]|0;if(l<<24>>24==0){e=j;f=0;break}else{g=j;h=k;i=l}}}}while(0);d=f<<24>>24!=0?0:e;return d|0}function yu(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=(a[b]|0)==33?b+1|0:0;if((c|0)==0){d=0;return d|0}b=xP(c)|0;if((b|0)==0){d=0;return d|0}c=a[35728]|0;L7:do{if(c<<24>>24==0){e=b;f=0}else{g=b;h=35728;i=c;while(1){if((a[g]|0)!=i<<24>>24){e=g;f=i;break L7}j=g+1|0;k=h+1|0;l=a[k]|0;if(l<<24>>24==0){e=j;f=0;break}else{g=j;h=k;i=l}}}}while(0);d=f<<24>>24!=0?0:e;return d|0}function yv(b){b=b|0;var c=0,d=0;c=(a[b]|0)==58?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(a[c]|0)==58?c+1|0:0;d=(b|0)!=0?b:c;return d|0}function yw(b){b=b|0;var c=0,d=0,e=0;c=y3(b)|0;if((c|0)==0){d=0;return d|0}else{e=c}while(1){c=y3(e)|0;if((c|0)==0){break}else{e=c}}d=(a[e]|0)==40?e+1|0:0;return d|0}function yx(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a[b]|0)==45?b+1|0:0;d=(c|0)!=0?c:b;if((d|0)==0){e=0;return e|0}b=(bP(a[d]|0)|0)==0;c=d+1|0;f=b?0:c;do{if((f|0)==0){b=a[d]|0;g=b<<24>>24==95?c:0;if((g|0)!=0){h=g;break}g=b<<24>>24==92?c:0;if((g|0)==0){e=0;return e|0}b=(a[g]|0)!=0?g+1|0:g;if((b|0)==0){e=0}else{h=b;break}return e|0}else{h=f}}while(0);f=y5(h)|0;if((f|0)==0){e=0;return e|0}e=(a[f]|0)==40?f+1|0:0;return e|0}function yy(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35552]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35552;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yz(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35376]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35376;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yA(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35416]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35416;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yB(b){b=b|0;return((a[b]|0)==61?b+1|0:0)|0}function yC(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35680]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35680;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yD(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35824]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35824;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yE(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35768]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35768;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yF(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35632]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35632;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yG(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35784]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35784;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yH(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=(a[b]|0)==36?b+1|0:0;if((c|0)==0){d=0;return d|0}b=(bO(a[c]|0)|0)==0;e=c+1|0;f=b?0:e;do{if((f|0)==0){b=a[c]|0;g=b<<24>>24==45?e:0;if((g|0)!=0){h=g;break}g=b<<24>>24==95?e:0;if((g|0)==0){d=0}else{h=g;break}return d|0}else{h=f}}while(0);while(1){f=(bO(a[h]|0)|0)==0;e=h+1|0;c=f?0:e;if((c|0)!=0){h=c;continue}c=a[h]|0;f=c<<24>>24==45?e:0;if((f|0)!=0){h=f;continue}f=c<<24>>24==95?e:0;if((f|0)==0){d=h;break}else{h=f}}return d|0}function yI(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35336]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35336;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yJ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35320]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35320;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yK(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35440]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35440;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yL(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35464]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35464;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yM(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35528]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35528;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yN(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35488]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35488;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yO(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35520]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35520;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yP(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35504]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35504;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yQ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35512]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35512;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yR(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=a[35496]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35496;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);return(e<<24>>24!=0?0:d)|0}function yS(a){a=a|0;return yT(a)|0}function yT(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a[35816]|0;L1:do{if(c<<24>>24==0){d=b;e=0}else{f=b;g=35816;h=c;while(1){if((a[f]|0)!=h<<24>>24){d=f;e=h;break L1}i=f+1|0;j=g+1|0;k=a[j]|0;if(k<<24>>24==0){d=i;e=0;break}else{f=i;g=j;h=k}}}}while(0);c=e<<24>>24!=0?0:d;if((c|0)==0){l=0;return l|0}d=(a[c]|0)==58?c+1|0:0;if((d|0)==0){l=0;return l|0}c=yX(d)|0;if((c|0)==0){l=0;return l|0}d=(a[c]|0)==46?c+1|0:0;if((d|0)==0){l=0;return l|0}c=yX(d)|0;if((c|0)==0){l=0;return l|0}else{m=c}while(1){c=a[m]|0;n=m+1|0;d=c<<24>>24==46?n:0;if((d|0)==0){o=c;break}c=yX(d)|0;if((c|0)==0){p=11;break}else{m=c}}do{if((p|0)==11){if((m|0)==0){l=0;return l|0}else{o=a[m]|0;break}}}while(0);m=o<<24>>24==40?n:0;if((m|0)==0){l=0;return l|0}n=a[m]|0;if(n<<24>>24==0){l=0;return l|0}else{q=m;r=n}while(1){n=q+1|0;m=r<<24>>24==59?n:0;if((m|0)==0){s=n}else{if((a[q-1|0]|0)==92){s=m}else{l=m;p=27;break}}m=a[s]|0;if(m<<24>>24==0){l=0;p=28;break}else{q=s;r=m}}if((p|0)==27){return l|0}else if((p|0)==28){return l|0}return 0}function yU(a){a=a|0;return yV(a)|0}function yV(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=b+1|0;d=(a[b]|0)==36?c:0;L1:do{if((d|0)==0){e=9}else{f=(bO(a[d]|0)|0)==0;g=d+1|0;h=f?0:g;do{if((h|0)==0){f=a[d]|0;i=f<<24>>24==45?g:0;if((i|0)!=0){j=i;break}i=f<<24>>24==95?g:0;if((i|0)==0){e=9;break L1}else{j=i}}else{j=h}}while(0);while(1){h=(bO(a[j]|0)|0)==0;g=j+1|0;i=h?0:g;if((i|0)!=0){j=i;continue}i=a[j]|0;h=i<<24>>24==45?g:0;if((h|0)!=0){j=h;continue}h=i<<24>>24==95?g:0;if((h|0)==0){break}else{j=h}}if((j|0)==0){e=9}else{k=j}}}while(0);L11:do{if((e|0)==9){j=y3(b)|0;if((j|0)!=0){d=j;while(1){j=y3(d)|0;if((j|0)==0){k=d;break L11}else{d=j}}}d=(a[b]|0)==45?c:0;j=(d|0)!=0?d:b;if((j|0)==0){l=0;return l|0}d=(bP(a[j]|0)|0)==0;h=j+1|0;g=d?0:h;do{if((g|0)==0){d=a[j]|0;i=d<<24>>24==95?h:0;if((i|0)!=0){m=i;break}i=d<<24>>24==92?h:0;if((i|0)==0){l=0;return l|0}d=(a[i]|0)!=0?i+1|0:i;if((d|0)==0){l=0}else{m=d;break}return l|0}else{m=g}}while(0);g=y5(m)|0;if((g|0)==0){l=0}else{k=g;break}return l|0}}while(0);m=xP(k)|0;if((m|0)==0){l=0;return l|0}k=(a[m]|0)==61?m+1|0:0;if((k|0)==0){l=0;return l|0}m=xP(k)|0;if((m|0)==0){l=0;return l|0}l=yW(m)|0;return l|0}function yW(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=b+1|0;d=(a[b]|0)==36?c:0;L1:do{if((d|0)!=0){e=(bO(a[d]|0)|0)==0;f=d+1|0;g=e?0:f;do{if((g|0)==0){e=a[d]|0;h=e<<24>>24==45?f:0;if((h|0)!=0){i=h;break}h=e<<24>>24==95?f:0;if((h|0)==0){break L1}else{i=h}}else{i=g}}while(0);while(1){g=(bO(a[i]|0)|0)==0;f=i+1|0;h=g?0:f;if((h|0)!=0){i=h;continue}h=a[i]|0;g=h<<24>>24==45?f:0;if((g|0)!=0){i=g;continue}g=h<<24>>24==95?f:0;if((g|0)==0){break}else{i=g}}if((i|0)==0){break}else{j=i}return j|0}}while(0);i=y3(b)|0;if((i|0)!=0){d=i;while(1){i=y3(d)|0;if((i|0)==0){j=d;break}else{d=i}}return j|0}d=(a[b]|0)==45?c:0;i=(d|0)!=0?d:b;L18:do{if((i|0)==0){k=35800}else{d=(bP(a[i]|0)|0)==0;g=i+1|0;f=d?0:g;do{if((f|0)==0){d=a[i]|0;h=d<<24>>24==95?g:0;if((h|0)!=0){l=h;break}h=d<<24>>24==92?g:0;if((h|0)==0){k=35800;break L18}d=(a[h]|0)!=0?h+1|0:h;if((d|0)==0){k=35800;break L18}else{l=d}}else{l=f}}while(0);f=y5(l)|0;if((f|0)==0){k=35800;break}else{j=f}return j|0}}while(0);while(1){l=a[k]|0;if(l<<24>>24==0){m=0;break}if((a[b]|0)==l<<24>>24){m=c;break}else{k=k+1|0}}k=(m|0)!=0?m:b;if((k|0)==0){j=0;return j|0}b=a[k]|0;m=((b<<24>>24)-48|0)>>>0<10>>>0?k+1|0:0;c=(m|0)==0;if(c){n=k;o=b}else{b=m;while(1){k=a[b]|0;l=((k<<24>>24)-48|0)>>>0<10>>>0?b+1|0:0;if((l|0)==0){n=b;o=k;break}else{b=l}}}b=o<<24>>24==46?n+1|0:0;do{if((b|0)!=0){n=((a[b]|0)-48|0)>>>0<10>>>0?b+1|0:0;if((n|0)==0){break}else{p=n}while(1){n=((a[p]|0)-48|0)>>>0<10>>>0?p+1|0:0;if((n|0)==0){j=p;break}else{p=n}}return j|0}}while(0);if(c){j=0;return j|0}else{q=m}while(1){m=((a[q]|0)-48|0)>>>0<10>>>0?q+1|0:0;if((m|0)==0){j=q;break}else{q=m}}return j|0}function yX(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=y3(b)|0;if((c|0)!=0){d=c;while(1){c=y3(d)|0;if((c|0)==0){e=d;break}else{d=c}}return e|0}d=(a[b]|0)==45?b+1|0:0;c=(d|0)!=0?d:b;if((c|0)==0){e=0;return e|0}b=(bP(a[c]|0)|0)==0;d=c+1|0;f=b?0:d;do{if((f|0)==0){b=a[c]|0;g=b<<24>>24==95?d:0;if((g|0)!=0){h=g;break}g=b<<24>>24==92?d:0;if((g|0)==0){e=0;return e|0}b=(a[g]|0)!=0?g+1|0:g;if((b|0)==0){e=0}else{h=b;break}return e|0}else{h=f}}while(0);e=y5(h)|0;return e|0}function yY(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=(a[b]|0)==47?b+1|0:0;if((c|0)==0){d=b}else{b=c;while(1){c=(a[b]|0)==47?b+1|0:0;if((c|0)==0){d=b;break}else{b=c}}}b=y_(d)|0;if((b|0)==0){e=0;return e|0}else{f=b}while(1){b=y_(f)|0;if((b|0)==0){g=f;break}else{f=b}}while(1){f=(a[g]|0)==47?g+1|0:0;if((f|0)==0){h=g}else{b=f;while(1){f=(a[b]|0)==47?b+1|0:0;if((f|0)==0){h=b;break}else{b=f}}}b=y_(h)|0;if((b|0)==0){e=g;i=11;break}else{j=b}while(1){b=y_(j)|0;if((b|0)==0){break}else{j=b}}if((j|0)==0){e=g;i=12;break}else{g=j}}if((i|0)==12){return e|0}else if((i|0)==11){return e|0}return 0}function yZ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=7}else{d=(bP(a[e]|0)|0)==0;g=e+1|0;h=d?0:g;do{if((h|0)==0){d=a[e]|0;i=d<<24>>24==95?g:0;if((i|0)!=0){j=i;break}i=d<<24>>24==92?g:0;if((i|0)==0){f=7;break L1}d=(a[i]|0)!=0?i+1|0:i;if((d|0)==0){f=7;break L1}else{j=d}}else{j=h}}while(0);h=y5(j)|0;if((h|0)==0){f=7}else{k=h}}}while(0);if((f|0)==7){k=(a[b]|0)==42?c:0}c=(k|0)!=0?k:b;if((c|0)==0){l=0;m=(l|0)!=0;n=m?l:b;return n|0}l=(a[c]|0)==124?c+1|0:0;m=(l|0)!=0;n=m?l:b;return n|0}function y_(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=35800}else{d=(bP(a[e]|0)|0)==0;g=e+1|0;h=d?0:g;do{if((h|0)==0){d=a[e]|0;i=d<<24>>24==95?g:0;if((i|0)!=0){j=i;break}i=d<<24>>24==92?g:0;if((i|0)==0){f=35800;break L1}d=(a[i]|0)!=0?i+1|0:i;if((d|0)==0){f=35800;break L1}else{j=d}}else{j=h}}while(0);h=y5(j)|0;if((h|0)==0){f=35800;break}else{k=h}return k|0}}while(0);while(1){j=a[f]|0;if(j<<24>>24==0){l=0;break}if((a[b]|0)==j<<24>>24){l=c;break}else{f=f+1|0}}f=(l|0)!=0?l:b;do{if((f|0)!=0){l=a[f]|0;j=((l<<24>>24)-48|0)>>>0<10>>>0?f+1|0:0;e=(j|0)==0;if(e){m=f;n=l}else{l=j;while(1){h=a[l]|0;g=((h<<24>>24)-48|0)>>>0<10>>>0?l+1|0:0;if((g|0)==0){m=l;n=h;break}else{l=g}}}l=n<<24>>24==46?m+1|0:0;do{if((l|0)!=0){g=((a[l]|0)-48|0)>>>0<10>>>0?l+1|0:0;if((g|0)==0){break}else{o=g}while(1){g=((a[o]|0)-48|0)>>>0<10>>>0?o+1|0:0;if((g|0)==0){k=o;break}else{o=g}}return k|0}}while(0);if(e){break}else{p=j}while(1){l=((a[p]|0)-48|0)>>>0<10>>>0?p+1|0:0;if((l|0)==0){k=p;break}else{p=l}}return k|0}}while(0);k=(a[b]|0)==46?c:0;return k|0}function y$(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=y0(b)|0;do{if((c|0)==0){if((b|0)==0){d=0}else{e=b;break}return d|0}else{f=c;while(1){g=y0(f)|0;if((g|0)==0){e=f;break}else{f=g}}}}while(0);c=a[35720]|0;L7:do{if(c<<24>>24==0){h=e;i=0}else{b=e;f=35720;g=c;while(1){if((a[b]|0)!=g<<24>>24){h=b;i=g;break L7}j=b+1|0;k=f+1|0;l=a[k]|0;if(l<<24>>24==0){h=j;i=0;break}else{b=j;f=k;g=l}}}}while(0);c=i<<24>>24!=0?0:h;if((c|0)==0){d=0;return d|0}h=a[35456]|0;L15:do{if(h<<24>>24==0){i=c;while(1){if((a[i]|0)==0){d=0;break}if((i|0)==0){i=i+1|0}else{m=i;break L15}}return d|0}else{i=c;while(1){e=a[i]|0;if(e<<24>>24==0){d=0;break}L23:do{if(e<<24>>24==h<<24>>24){g=35456;f=i;while(1){b=f+1|0;l=g+1|0;k=a[l]|0;if(k<<24>>24==0){n=b;o=0;break L23}if((a[b]|0)==k<<24>>24){g=l;f=b}else{n=b;o=k;break}}}else{n=i;o=h}}while(0);e=o<<24>>24!=0?0:n;if((e|0)==0){i=i+1|0}else{m=e;break L15}}return d|0}}while(0);n=y0(m)|0;if((n|0)==0){d=m;return d|0}else{p=n}while(1){n=y0(p)|0;if((n|0)==0){d=p;break}else{p=n}}return d|0}function y0(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=35800}else{d=(bP(a[e]|0)|0)==0;g=e+1|0;h=d?0:g;do{if((h|0)==0){d=a[e]|0;i=d<<24>>24==95?g:0;if((i|0)!=0){j=i;break}i=d<<24>>24==92?g:0;if((i|0)==0){f=35800;break L1}d=(a[i]|0)!=0?i+1|0:i;if((d|0)==0){f=35800;break L1}else{j=d}}else{j=h}}while(0);h=y5(j)|0;if((h|0)==0){f=35800;break}else{k=h}return k|0}}while(0);while(1){j=a[f]|0;if(j<<24>>24==0){l=0;break}if((a[b]|0)==j<<24>>24){l=c;break}else{f=f+1|0}}f=(l|0)!=0?l:b;do{if((f|0)!=0){l=a[f]|0;j=((l<<24>>24)-48|0)>>>0<10>>>0?f+1|0:0;e=(j|0)==0;if(e){m=f;n=l}else{l=j;while(1){h=a[l]|0;g=((h<<24>>24)-48|0)>>>0<10>>>0?l+1|0:0;if((g|0)==0){m=l;n=h;break}else{l=g}}}l=n<<24>>24==46?m+1|0:0;do{if((l|0)!=0){g=((a[l]|0)-48|0)>>>0<10>>>0?l+1|0:0;if((g|0)==0){break}else{o=g}while(1){g=((a[o]|0)-48|0)>>>0<10>>>0?o+1|0:0;if((g|0)==0){k=o;break}else{o=g}}return k|0}}while(0);if(e){break}else{p=j}while(1){l=((a[p]|0)-48|0)>>>0<10>>>0?p+1|0:0;if((l|0)==0){k=p;break}else{p=l}}return k|0}}while(0);p=a[b]|0;b=p<<24>>24==46?c:0;if((b|0)!=0){k=b;return k|0}k=p<<24>>24==47?c:0;return k|0}function y1(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=y2(b)|0;do{if((c|0)==0){if((b|0)==0){d=0}else{e=b;break}return d|0}else{f=c;while(1){g=y2(f)|0;if((g|0)==0){e=f;break}else{f=g}}}}while(0);c=a[35720]|0;L7:do{if(c<<24>>24==0){h=e;i=0}else{b=e;f=35720;g=c;while(1){if((a[b]|0)!=g<<24>>24){h=b;i=g;break L7}j=b+1|0;k=f+1|0;l=a[k]|0;if(l<<24>>24==0){h=j;i=0;break}else{b=j;f=k;g=l}}}}while(0);c=i<<24>>24!=0?0:h;if((c|0)==0){d=0;return d|0}h=a[35456]|0;L15:do{if(h<<24>>24==0){i=c;while(1){if((a[i]|0)==0){d=0;break}if((i|0)==0){i=i+1|0}else{m=i;break L15}}return d|0}else{i=c;while(1){e=a[i]|0;if(e<<24>>24==0){d=0;break}L19:do{if(e<<24>>24==h<<24>>24){g=35456;f=i;while(1){b=f+1|0;l=g+1|0;k=a[l]|0;if(k<<24>>24==0){n=b;o=0;break L19}if((a[b]|0)==k<<24>>24){g=l;f=b}else{n=b;o=k;break}}}else{n=i;o=h}}while(0);e=o<<24>>24!=0?0:n;if((e|0)==0){i=i+1|0}else{m=e;break L15}}return d|0}}while(0);n=y2(m)|0;if((n|0)==0){d=m;return d|0}else{p=n}while(1){n=y2(p)|0;if((n|0)==0){d=p;break}else{p=n}}return d|0}function y2(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=35800}else{d=(bP(a[e]|0)|0)==0;g=e+1|0;h=d?0:g;do{if((h|0)==0){d=a[e]|0;i=d<<24>>24==95?g:0;if((i|0)!=0){j=i;break}i=d<<24>>24==92?g:0;if((i|0)==0){f=35800;break L1}d=(a[i]|0)!=0?i+1|0:i;if((d|0)==0){f=35800;break L1}else{j=d}}else{j=h}}while(0);h=y5(j)|0;if((h|0)==0){f=35800;break}else{k=h}return k|0}}while(0);while(1){j=a[f]|0;if(j<<24>>24==0){l=0;break}if((a[b]|0)==j<<24>>24){l=c;break}else{f=f+1|0}}f=(l|0)!=0?l:b;do{if((f|0)!=0){l=a[f]|0;j=((l<<24>>24)-48|0)>>>0<10>>>0?f+1|0:0;e=(j|0)==0;if(e){m=f;n=l}else{l=j;while(1){h=a[l]|0;g=((h<<24>>24)-48|0)>>>0<10>>>0?l+1|0:0;if((g|0)==0){m=l;n=h;break}else{l=g}}}l=n<<24>>24==46?m+1|0:0;do{if((l|0)==0){o=15}else{g=((a[l]|0)-48|0)>>>0<10>>>0?l+1|0:0;if((g|0)==0){o=15;break}else{p=g}while(1){g=a[p]|0;h=((g<<24>>24)-48|0)>>>0<10>>>0?p+1|0:0;if((h|0)==0){q=p;r=g;break}else{p=h}}}}while(0);if((o|0)==15){if(e){break}else{s=j}while(1){l=a[s]|0;h=((l<<24>>24)-48|0)>>>0<10>>>0?s+1|0:0;if((h|0)==0){q=s;r=l;break}else{s=h}}}j=r<<24>>24==37?q+1|0:0;if((j|0)==0){break}else{k=j}return k|0}}while(0);q=yo(b)|0;if((q|0)!=0){k=q;return k|0}q=(a[b]|0)==35?c:0;do{if((q|0)==0){t=0}else{r=(bo(a[q]|0)|0)==0;s=r?0:q+1|0;if((s|0)==0){t=0;break}else{u=s}while(1){s=(bo(a[u]|0)|0)==0;r=s?0:u+1|0;if((r|0)==0){t=u;break}else{u=r}}}}while(0);u=t-b|0;q=(u|0)!=4&(u|0)!=7?0:t;if((q|0)==0){v=35800}else{k=q;return k|0}while(1){q=a[v]|0;if(q<<24>>24==0){w=0;break}if((a[b]|0)==q<<24>>24){w=c;break}else{v=v+1|0}}v=(w|0)!=0?w:b;do{if((v|0)!=0){w=a[v]|0;q=((w<<24>>24)-48|0)>>>0<10>>>0?v+1|0:0;t=(q|0)==0;if(t){x=v;y=w}else{w=q;while(1){u=a[w]|0;r=((u<<24>>24)-48|0)>>>0<10>>>0?w+1|0:0;if((r|0)==0){x=w;y=u;break}else{w=r}}}w=y<<24>>24==46?x+1|0:0;do{if((w|0)!=0){r=((a[w]|0)-48|0)>>>0<10>>>0?w+1|0:0;if((r|0)==0){break}else{z=r}while(1){r=((a[z]|0)-48|0)>>>0<10>>>0?z+1|0:0;if((r|0)==0){k=z;break}else{z=r}}return k|0}}while(0);if(t){break}else{A=q}while(1){w=((a[A]|0)-48|0)>>>0<10>>>0?A+1|0:0;if((w|0)==0){k=A;break}else{A=w}}return k|0}}while(0);A=a[b]|0;b=A<<24>>24==34?c:0;L60:do{if((b|0)!=0){z=a[b]|0;if(z<<24>>24==0){break}else{B=b;C=z}while(1){z=B+1|0;x=C<<24>>24==34?z:0;if((x|0)==0){D=z}else{if((a[B-1|0]|0)==92){D=x}else{k=x;break}}x=a[D]|0;if(x<<24>>24==0){break L60}else{B=D;C=x}}return k|0}}while(0);C=A<<24>>24==39?c:0;if((C|0)==0){k=0;return k|0}c=a[C]|0;if(c<<24>>24==0){k=0;return k|0}else{E=C;F=c}while(1){c=E+1|0;C=F<<24>>24==39?c:0;if((C|0)==0){G=c}else{if((a[E-1|0]|0)==92){G=C}else{k=C;o=53;break}}C=a[G]|0;if(C<<24>>24==0){k=0;o=54;break}else{E=G;F=C}}if((o|0)==53){return k|0}else if((o|0)==54){return k|0}return 0}function y3(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=7}else{d=(bP(a[e]|0)|0)==0;g=e+1|0;h=d?0:g;do{if((h|0)==0){d=a[e]|0;i=d<<24>>24==95?g:0;if((i|0)!=0){j=i;break}i=d<<24>>24==92?g:0;if((i|0)==0){f=7;break L1}d=(a[i]|0)!=0?i+1|0:i;if((d|0)==0){f=7;break L1}else{j=d}}else{j=h}}while(0);h=y5(j)|0;if((h|0)==0){f=7}else{k=h;f=8}}}while(0);if((f|0)==7){j=a[b]|0;e=j<<24>>24==45?c:0;if((e|0)==0){l=b;m=j}else{k=e;f=8}}if((f|0)==8){L11:while(1){f=0;e=k+1|0;j=(a[k]|0)==45?e:0;b=(j|0)!=0?j:k;L13:do{if((b|0)!=0){j=(bP(a[b]|0)|0)==0;c=b+1|0;h=j?0:c;do{if((h|0)==0){j=a[b]|0;g=j<<24>>24==95?c:0;if((g|0)!=0){n=g;break}g=j<<24>>24==92?c:0;if((g|0)==0){break L13}j=(a[g]|0)!=0?g+1|0:g;if((j|0)==0){break L13}else{n=j}}else{n=h}}while(0);h=y5(n)|0;if((h|0)!=0){k=h;f=8;continue L11}}}while(0);b=a[k]|0;h=b<<24>>24==45?e:0;if((h|0)==0){l=k;m=b;break}else{k=h;f=8}}}if((l|0)==0){o=0;return o|0}f=a[35720]|0;L25:do{if(f<<24>>24==0){p=l;q=0}else{k=l;n=35720;h=f;b=m;while(1){if(b<<24>>24!=h<<24>>24){p=k;q=h;break L25}c=k+1|0;j=n+1|0;g=a[j]|0;if(g<<24>>24==0){p=c;q=0;break L25}k=c;n=j;h=g;b=a[c]|0}}}while(0);m=q<<24>>24!=0?0:p;if((m|0)==0){o=0;return o|0}p=a[35456]|0;L34:do{if(p<<24>>24==0){q=m;while(1){if((a[q]|0)==0){o=0;break}if((q|0)==0){q=q+1|0}else{r=q;break L34}}return o|0}else{q=m;while(1){f=a[q]|0;if(f<<24>>24==0){o=0;break}L42:do{if(f<<24>>24==p<<24>>24){l=35456;b=q;while(1){h=b+1|0;n=l+1|0;k=a[n]|0;if(k<<24>>24==0){s=h;t=0;break L42}if((a[h]|0)==k<<24>>24){l=n;b=h}else{s=h;t=k;break}}}else{s=q;t=p}}while(0);f=t<<24>>24!=0?0:s;if((f|0)==0){q=q+1|0}else{r=f;break L34}}return o|0}}while(0);s=y4(r)|0;if((s|0)==0){o=r;return o|0}else{u=s}while(1){s=y4(u)|0;if((s|0)==0){o=u;break}else{u=s}}return o|0}function y4(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=b+1|0;d=(a[b]|0)==45?c:0;e=(d|0)!=0?d:b;L1:do{if((e|0)==0){f=35800}else{d=(bP(a[e]|0)|0)==0;g=e+1|0;h=d?0:g;do{if((h|0)==0){d=a[e]|0;i=d<<24>>24==95?g:0;if((i|0)!=0){j=i;break}i=d<<24>>24==92?g:0;if((i|0)==0){f=35800;break L1}d=(a[i]|0)!=0?i+1|0:i;if((d|0)==0){f=35800;break L1}else{j=d}}else{j=h}}while(0);h=y5(j)|0;if((h|0)==0){f=35800;break}else{k=h}return k|0}}while(0);while(1){j=a[f]|0;if(j<<24>>24==0){l=0;break}if((a[b]|0)==j<<24>>24){l=c;break}else{f=f+1|0}}f=(l|0)!=0?l:b;do{if((f|0)!=0){l=a[f]|0;j=((l<<24>>24)-48|0)>>>0<10>>>0?f+1|0:0;e=(j|0)==0;if(e){m=f;n=l}else{l=j;while(1){h=a[l]|0;g=((h<<24>>24)-48|0)>>>0<10>>>0?l+1|0:0;if((g|0)==0){m=l;n=h;break}else{l=g}}}l=n<<24>>24==46?m+1|0:0;do{if((l|0)!=0){g=((a[l]|0)-48|0)>>>0<10>>>0?l+1|0:0;if((g|0)==0){break}else{o=g}while(1){g=((a[o]|0)-48|0)>>>0<10>>>0?o+1|0:0;if((g|0)==0){k=o;break}else{o=g}}return k|0}}while(0);if(e){break}else{p=j}while(1){l=((a[p]|0)-48|0)>>>0<10>>>0?p+1|0:0;if((l|0)==0){k=p;break}else{p=l}}return k|0}}while(0);k=(a[b]|0)==45?c:0;return k|0}function y5(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=(bO(a[b]|0)|0)==0;d=b+1|0;e=c?0:d;do{if((e|0)==0){c=a[b]|0;f=c<<24>>24==45?d:0;if((f|0)!=0){g=f;break}f=c<<24>>24==95?d:0;if((f|0)!=0){g=f;break}f=c<<24>>24==92?d:0;if((f|0)==0){h=b;return h|0}c=(a[f]|0)!=0?f+1|0:f;if((c|0)==0){h=b}else{g=c;break}return h|0}else{g=e}}while(0);while(1){e=(bO(a[g]|0)|0)==0;b=g+1|0;d=e?0:b;if((d|0)!=0){g=d;continue}d=a[g]|0;e=d<<24>>24==45?b:0;if((e|0)!=0){g=e;continue}e=d<<24>>24==95?b:0;if((e|0)!=0){g=e;continue}e=d<<24>>24==92?b:0;if((e|0)==0){h=g;i=13;break}b=(a[e]|0)!=0?e+1|0:e;if((b|0)==0){h=g;i=12;break}else{g=b}}if((i|0)==12){return h|0}else if((i|0)==13){return h|0}return 0}function y6(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=b;return}function y7(a,b,d){a=a|0;b=+b;d=d|0;c[a>>2]=1;h[a+8>>3]=b;c[a+16>>2]=bR(d|0)|0;return}function y8(a,b,d,e,f){a=a|0;b=+b;d=+d;e=+e;f=+f;c[a>>2]=2;h[a+8>>3]=b;h[a+16>>3]=d;h[a+24>>3]=e;h[a+32>>3]=f;return}function y9(a,b){a=a|0;b=b|0;c[a>>2]=3;c[a+4>>2]=bR(b|0)|0;return}function za(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[a>>2]=4;c[a+8>>2]=b;c[e+4>>2]=d;c[e+12>>2]=JW(b*40|0)|0;return}function zb(a){a=a|0;c[a>>2]=5;return}function zc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0;c[b>>2]=c[d>>2];e=b+4|0;f=d+4|0;if((a[f]&1)==0){g=e;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2]}else{f=c[d+12>>2]|0;g=c[d+8>>2]|0;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){a[e]=g<<1;h=e+1|0}else{i=g+16&-16;j=J0(i)|0;c[b+12>>2]=j;c[e>>2]=i|1;c[b+8>>2]=g;h=j}Kb(h|0,f|0,g)|0;a[h+g|0]=0}g=b+16|0;h=d+16|0;L12:do{if((a[h]&1)==0){f=g;c[f>>2]=c[h>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];k=19}else{f=c[d+24>>2]|0;j=c[d+20>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(j>>>0<11>>>0){a[g]=j<<1;l=g+1|0}else{i=j+16&-16;m=(x=0,as(230,i|0)|0);if(x){x=0;break}c[b+24>>2]=m;c[g>>2]=i|1;c[b+20>>2]=j;l=m}Kb(l|0,f|0,j)|0;a[l+j|0]=0;k=19;break L12}}while(0);j=bQ(-1,-1)|0;n=K;o=j}}while(0);do{if((k|0)==19){c[b+28>>2]=c[d+28>>2];c[b+32>>2]=c[d+32>>2];l=b+36|0;x=0;aq(292,l|0,d+36|0);do{if(!x){a[b+48|0]=a[d+48|0]&1;a[b+49|0]=a[d+49|0]&1;c[b+52>>2]=c[d+52>>2];h=b+56|0;j=d+56|0;if((a[j]&1)==0){f=h;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];return}j=c[d+64>>2]|0;f=c[d+60>>2]|0;do{if(f>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(f>>>0<11>>>0){a[h]=f<<1;p=h+1|0}else{m=f+16&-16;i=(x=0,as(230,m|0)|0);if(x){x=0;break}c[b+64>>2]=i;c[h>>2]=m|1;c[b+60>>2]=f;p=i}Kb(p|0,j|0,f)|0;a[p+f|0]=0;return}}while(0);f=bQ(-1,-1)|0;j=f;f=K;h=l|0;i=c[h>>2]|0;if((i|0)==0){q=f;r=j;break}m=b+40|0;s=c[m>>2]|0;if((i|0)==(s|0)){t=i}else{u=s;while(1){s=u-12|0;c[m>>2]=s;if((a[s]&1)==0){v=s}else{J2(c[u-12+8>>2]|0);v=c[m>>2]|0}if((i|0)==(v|0)){break}else{u=v}}t=c[h>>2]|0}J2(t);q=f;r=j}else{x=0;u=bQ(-1,-1)|0;q=K;r=u}}while(0);if((a[g]&1)==0){n=q;o=r;break}J2(c[b+24>>2]|0);n=q;o=r}}while(0);if((a[e]&1)==0){w=o;y=0;z=w;A=n;be(z|0)}J2(c[b+12>>2]|0);w=o;y=0;z=w;A=n;be(z|0)}function zd(){return JY(1,44)|0}function ze(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;if((b|0)!=0){JX(b)}b=c[a+28>>2]|0;if((b|0)!=0){JX(b)}b=c[a+36>>2]|0;d=c[a+40>>2]|0;if((b|0)==0){e=a;JX(e);return}if((d|0)>0){f=0;do{JX(c[b+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(d|0))}JX(b);e=a;JX(e);return}function zf(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=b|0;h=c[g>>2]|0;i=(c[b+4>>2]|0)-h|0;b=(i|0)/12|0;j=JW(b<<2)|0;if((i|0)>0){k=0;l=h}else{c[e>>2]=j;c[f>>2]=b;return}while(1){h=l+(k*12|0)|0;i=h;m=d[i]|0;if((m&1|0)==0){n=m>>>1}else{n=c[l+(k*12|0)+4>>2]|0}m=JW(n+1|0)|0;o=j+(k<<2)|0;c[o>>2]=m;p=a[i]|0;if((p&1)==0){q=h+1|0;r=h+1|0}else{h=c[l+(k*12|0)+8>>2]|0;q=h;r=h}h=p&255;if((h&1|0)==0){s=h>>>1}else{s=c[l+(k*12|0)+4>>2]|0}h=q+s|0;if((r|0)==(h|0)){t=l;u=p}else{p=r;i=m;while(1){a[i]=a[p]|0;m=p+1|0;if((m|0)==(h|0)){break}else{p=m;i=i+1|0}}i=c[g>>2]|0;t=i;u=a[i+(k*12|0)|0]|0}i=u&255;if((i&1|0)==0){v=i>>>1}else{v=c[t+(k*12|0)+4>>2]|0}a[(c[o>>2]|0)+v|0]=0;i=k+1|0;if((i|0)>=(b|0)){break}k=i;l=c[g>>2]|0}c[e>>2]=j;c[f>>2]=b;return}function zg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0;d=i;i=i+32|0;e=d|0;f=d+8|0;g=d+16|0;h=g;j=i;i=i+12|0;i=i+7&-8;k=j;l=i;i=i+196|0;i=i+7&-8;m=i;i=i+68|0;i=i+7&-8;n=i;i=i+68|0;i=i+7&-8;o=i;i=i+12|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+144|0;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+144|0;u=i;i=i+12|0;i=i+7&-8;v=n+36|0;w=n+40|0;Ke(n|0,0,68)|0;c[n>>2]=c[b>>2];y=o;a[y]=0;a[o+1|0]=0;z=n+4|0;x=0,aK(346,z|0,o|0)|0;L1:do{if(!x){c[n+52>>2]=c[b+8>>2];a[n+48|0]=(c[b+12>>2]|0)==1|0;a[n+49|0]=0;A=c[b+20>>2]|0;B=Kf(A|0)|0;if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;C=54;break}return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{E=B+16&-16;F=(x=0,as(230,E|0)|0);if(x){x=0;C=54;break}c[p+8>>2]=F;c[p>>2]=E|1;c[p+4>>2]=B;D=F}Kb(D|0,A|0,B)|0;a[D+B|0]=0;B=n+16|0;x=0,aK(346,B|0,p|0)|0;L12:do{if(!x){c[n+28>>2]=c[b+16>>2];c[n+32>>2]=0;x=0;aP(140,n+36|0,0,0);do{if(!x){x=0;aq(356,m|0,n|0);if(x){x=0;break}x=0;aq(530,l|0,m|0);if(x){x=0;A=bQ(-1,-1,30176,28064)|0;F=A;A=K;if((a[m+56|0]&1)!=0){J2(c[m+64>>2]|0)}E=m+36|0;G=c[E>>2]|0;if((G|0)!=0){H=m+40|0;I=c[H>>2]|0;if((G|0)==(I|0)){J=G}else{L=I;while(1){I=L-12|0;c[H>>2]=I;if((a[I]&1)==0){M=I}else{J2(c[L-12+8>>2]|0);M=c[H>>2]|0}if((G|0)==(M|0)){break}else{L=M}}J=c[E>>2]|0}J2(J)}if((a[m+16|0]&1)!=0){J2(c[m+24>>2]|0)}if((a[m+4|0]&1)==0){N=A;O=F;break L12}J2(c[m+12>>2]|0);N=A;O=F;break L12}if((a[m+56|0]&1)!=0){J2(c[m+64>>2]|0)}L=m+36|0;G=c[L>>2]|0;if((G|0)!=0){H=m+40|0;I=c[H>>2]|0;if((G|0)==(I|0)){P=G}else{Q=I;while(1){I=Q-12|0;c[H>>2]=I;if((a[I]&1)==0){R=I}else{J2(c[Q-12+8>>2]|0);R=c[H>>2]|0}if((G|0)==(R|0)){break}else{Q=R}}P=c[L>>2]|0}J2(P)}if((a[m+16|0]&1)!=0){J2(c[m+24>>2]|0)}if((a[m+4|0]&1)!=0){J2(c[m+12>>2]|0)}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}if((a[y]&1)!=0){J2(c[o+8>>2]|0)}if((a[n+56|0]&1)!=0){J2(c[n+64>>2]|0)}Q=c[v>>2]|0;if((Q|0)!=0){G=c[w>>2]|0;if((Q|0)==(G|0)){S=Q}else{H=G;while(1){G=H-12|0;c[w>>2]=G;if((a[G]&1)==0){T=G}else{J2(c[H-12+8>>2]|0);T=c[w>>2]|0}if((Q|0)==(T|0)){break}else{H=T}}S=c[v>>2]|0}J2(S)}if((a[B]&1)!=0){J2(c[n+24>>2]|0)}if((a[z]&1)!=0){J2(c[n+12>>2]|0)}H=(x=0,as(130,l|0)|0);do{if(!x){c[b+4>>2]=H;c[b+28>>2]=0;c[b+24>>2]=0;x=0;aq(14,q|0,l|0);if(x){x=0;break}zf(q,b+36|0,b+40|0);Q=q|0;L=c[Q>>2]|0;if((L|0)!=0){G=q+4|0;F=c[G>>2]|0;if((L|0)==(F|0)){U=L}else{A=F;while(1){F=A-12|0;c[G>>2]=F;if((a[F]&1)==0){V=F}else{J2(c[A-12+8>>2]|0);V=c[G>>2]|0}if((L|0)==(V|0)){break}else{A=V}}U=c[Q>>2]|0}J2(U)}x=0;ap(314,l|0);if(!x){i=d;return 0}else{x=0;A=bQ(-1,-1,30176,28064)|0;W=K;X=A;C=88;break L1}}else{x=0}}while(0);H=bQ(-1,-1,30176,28064)|0;A=K;x=0;ap(314,l|0);if(!x){W=A;X=H;C=88;break L1}else{x=0;break L1}}else{x=0}}while(0);H=bQ(-1,-1,30176,28064)|0;N=K;O=H}else{x=0;H=bQ(-1,-1,30176,28064)|0;N=K;O=H}}while(0);if((a[p]&1)==0){Y=N;Z=O;C=72;break}J2(c[p+8>>2]|0);Y=N;Z=O;C=72}else{x=0;C=54}}while(0);if((C|0)==54){O=bQ(-1,-1,30176,28064)|0;Y=K;Z=O;C=72}do{if((C|0)==72){if((a[y]&1)!=0){J2(c[o+8>>2]|0)}if((a[n+56|0]&1)!=0){J2(c[n+64>>2]|0)}O=c[v>>2]|0;if((O|0)!=0){N=c[w>>2]|0;if((O|0)==(N|0)){_=O}else{p=N;while(1){N=p-12|0;c[w>>2]=N;if((a[N]&1)==0){$=N}else{J2(c[p-12+8>>2]|0);$=c[w>>2]|0}if((O|0)==($|0)){break}else{p=$}}_=c[v>>2]|0}J2(_)}if((a[n+16|0]&1)!=0){J2(c[n+24>>2]|0)}if((a[z]&1)==0){W=Y;X=Z;C=88;break}J2(c[n+12>>2]|0);W=Y;X=Z;C=88}}while(0);L131:do{if((C|0)==88){if((W|0)!=(cp(30176)|0)){if((W|0)!=(cp(28064)|0)){aa=W;ab=X;ac=ab;ad=0;ae=ac;af=aa;be(ae|0)}Z=bA(X|0)|0;Y=Z;n=r+64|0;z=r|0;_=r+8|0;v=_|0;c[v>>2]=14576;$=r+12|0;c[z>>2]=31212;w=r+64|0;c[w>>2]=31232;c[r+4>>2]=0;x=0;aq(200,r+64|0,$|0);L138:do{if(!x){c[r+136>>2]=0;c[r+140>>2]=-1;o=r+8|0;c[z>>2]=14556;c[n>>2]=14596;c[v>>2]=14576;y=$|0;c[y>>2]=14880;p=r+16|0;HA(p);Ke(r+20|0,0,24)|0;c[y>>2]=14736;O=r+44|0;Ke(r+44|0,0,16)|0;c[r+60>>2]=24;Ke(h|0,0,12)|0;x=0;aq(214,$|0,g|0);if(x){x=0;N=bQ(-1,-1)|0;l=K;if((a[h]&1)!=0){J2(c[g+8>>2]|0)}if((a[O]&1)!=0){J2(c[r+52>>2]|0)}c[y>>2]=14880;x=0;ap(388,p|0);if(!x){ag=N;ah=l;C=142;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}if((a[h]&1)!=0){J2(c[g+8>>2]|0)}l=(x=0,aK(112,_|0,9304)|0);L153:do{if(!x){N=cA[c[(c[Z>>2]|0)+8>>2]&511](Y)|0;y=(x=0,aK(112,l|0,N|0)|0);if(x){x=0;C=170;break}x=0;aq(346,e|0,y+(c[(c[y>>2]|0)-12>>2]|0)|0);if(x){x=0;C=170;break}N=(x=0,aK(196,e|0,40280)|0);do{if(!x){U=(x=0,aK(c[(c[N>>2]|0)+28>>2]|0,N|0,10)|0);if(x){x=0;break}x=0;ap(388,e|0);if(x){x=0;C=170;break L153}x=0,aK(240,y|0,U|0)|0;if(x){x=0;C=170;break L153}x=0,as(56,y|0)|0;if(x){x=0;C=170;break L153}x=0;aq(560,s|0,$|0);if(x){x=0;C=170;break L153}U=s;if((a[U]&1)==0){ai=s+1|0}else{ai=c[s+8>>2]|0}c[b+28>>2]=bR(ai|0)|0;if((a[U]&1)!=0){J2(c[s+8>>2]|0)}c[b+24>>2]=1;c[b+4>>2]=0;c[z>>2]=14556;c[w>>2]=14596;c[o>>2]=14576;U=r+12|0;c[U>>2]=14736;if((a[O]&1)!=0){J2(c[r+52>>2]|0)}c[U>>2]=14880;x=0;ap(388,p|0);if(x){x=0;U=bQ(-1,-1)|0;V=K;x=0;ap(268,r+64|0);if(!x){aj=V;ak=U;C=169;break L138}else{x=0}bQ(-1,-1,0)|0;bU();return 0}x=0;ap(268,r+64|0);if(x){x=0;U=bQ(-1,-1)|0;aj=K;ak=U;C=169;break L138}aZ();i=d;return 0}else{x=0}}while(0);y=bQ(-1,-1)|0;N=K;x=0;ap(388,e|0);if(!x){al=N;am=y;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{x=0;C=170}}while(0);if((C|0)==170){l=bQ(-1,-1)|0;al=K;am=l}l=am;y=al;c[z>>2]=14556;c[w>>2]=14596;c[o>>2]=14576;N=r+12|0;c[N>>2]=14736;if((a[O]&1)!=0){J2(c[r+52>>2]|0)}c[N>>2]=14880;x=0;ap(388,p|0);if(!x){x=0;ap(268,r+64|0);if(!x){an=y;ao=l;break}else{x=0;break L131}}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,r+64|0);if(!x){bU();return 0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{x=0;l=bQ(-1,-1)|0;ag=l;ah=K;C=142}}while(0);do{if((C|0)==142){x=0;ap(268,n|0);if(!x){aj=ah;ak=ag;C=169;break}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);if((C|0)==169){an=aj;ao=ak}x=0;aQ(2);if(!x){aa=an;ab=ao}else{x=0;break}ac=ab;ad=0;ae=ac;af=aa;be(ae|0)}n=bA(X|0)|0;w=t+64|0;z=t|0;$=t+8|0;Y=$|0;c[Y>>2]=14576;Z=t+12|0;c[z>>2]=31212;_=t+64|0;c[_>>2]=31232;c[t+4>>2]=0;x=0;aq(200,t+64|0,Z|0);L207:do{if(!x){c[t+136>>2]=0;c[t+140>>2]=-1;v=t+8|0;c[z>>2]=14556;c[w>>2]=14596;c[Y>>2]=14576;l=Z|0;c[l>>2]=14880;y=t+16|0;HA(y);Ke(t+20|0,0,24)|0;c[l>>2]=14736;N=t+44|0;Ke(t+44|0,0,16)|0;c[t+60>>2]=24;Ke(k|0,0,12)|0;x=0;aq(214,Z|0,j|0);if(x){x=0;U=bQ(-1,-1)|0;V=K;if((a[k]&1)!=0){J2(c[j+8>>2]|0)}if((a[N]&1)!=0){J2(c[t+52>>2]|0)}c[l>>2]=14880;x=0;ap(388,y|0);if(!x){ar=U;at=V;C=100;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}if((a[k]&1)!=0){J2(c[j+8>>2]|0)}V=(x=0,aK(802,$|0,n+4|0)|0);L222:do{if(!x){U=(x=0,aK(112,V|0,7776)|0);if(x){x=0;C=180;break}l=(x=0,aK(312,U|0,c[n+20>>2]|0)|0);if(x){x=0;C=180;break}U=(x=0,aK(112,l|0,5864)|0);if(x){x=0;C=180;break}l=(x=0,aK(802,U|0,n+28|0)|0);if(x){x=0;C=180;break}x=0;aq(346,f|0,l+(c[(c[l>>2]|0)-12>>2]|0)|0);if(x){x=0;C=180;break}U=(x=0,aK(196,f|0,40280)|0);do{if(!x){q=(x=0,aK(c[(c[U>>2]|0)+28>>2]|0,U|0,10)|0);if(x){x=0;break}x=0;ap(388,f|0);if(x){x=0;C=180;break L222}x=0,aK(240,l|0,q|0)|0;if(x){x=0;C=180;break L222}x=0,as(56,l|0)|0;if(x){x=0;C=180;break L222}x=0;aq(560,u|0,Z|0);if(x){x=0;C=180;break L222}q=u;if((a[q]&1)==0){au=u+1|0}else{au=c[u+8>>2]|0}c[b+28>>2]=bR(au|0)|0;if((a[q]&1)!=0){J2(c[u+8>>2]|0)}c[b+24>>2]=1;c[b+4>>2]=0;c[z>>2]=14556;c[_>>2]=14596;c[v>>2]=14576;q=t+12|0;c[q>>2]=14736;if((a[N]&1)!=0){J2(c[t+52>>2]|0)}c[q>>2]=14880;x=0;ap(388,y|0);if(x){x=0;q=bQ(-1,-1)|0;S=K;x=0;ap(268,t+64|0);if(!x){av=S;aw=q;C=179;break L207}else{x=0}bQ(-1,-1,0)|0;bU();return 0}x=0;ap(268,t+64|0);if(x){x=0;q=bQ(-1,-1)|0;av=K;aw=q;C=179;break L207}aZ();i=d;return 0}else{x=0}}while(0);l=bQ(-1,-1)|0;U=K;x=0;ap(388,f|0);if(!x){ax=U;ay=l;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{x=0;C=180}}while(0);if((C|0)==180){V=bQ(-1,-1)|0;ax=K;ay=V}V=ay;p=ax;c[z>>2]=14556;c[_>>2]=14596;c[v>>2]=14576;O=t+12|0;c[O>>2]=14736;if((a[N]&1)!=0){J2(c[t+52>>2]|0)}c[O>>2]=14880;x=0;ap(388,y|0);if(!x){x=0;ap(268,t+64|0);if(!x){az=p;aA=V;break}else{x=0;break L131}}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,t+64|0);if(!x){bU();return 0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{x=0;V=bQ(-1,-1)|0;ar=V;at=K;C=100}}while(0);do{if((C|0)==100){x=0;ap(268,w|0);if(!x){av=at;aw=ar;C=179;break}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);if((C|0)==179){az=av;aA=aw}x=0;aQ(2);if(!x){aa=az;ab=aA}else{x=0;break}ac=ab;ad=0;ae=ac;af=aa;be(ae|0)}}while(0);bQ(-1,-1,0)|0;bU();return 0}function zh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=b|0;f=b+4|0;g=b+12|0;h=b+16|0;Ke(b|0,0,28)|0;c[b+28>>2]=1;c[b+32>>2]=1;i=b+36|0;j=d;if((a[j]&1)==0){k=i;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];return}j=c[d+8>>2]|0;k=c[d+4>>2]|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(k>>>0<11>>>0){a[i]=k<<1;l=i+1|0}else{d=k+16&-16;m=(x=0,as(230,d|0)|0);if(x){x=0;break}c[b+44>>2]=m;c[i>>2]=d|1;c[b+40>>2]=k;l=m}Kb(l|0,j|0,k)|0;a[l+k|0]=0;return}}while(0);k=bQ(-1,-1)|0;l=c[g>>2]|0;g=l;if((l|0)!=0){j=c[h>>2]|0;if((l|0)!=(j|0)){c[h>>2]=j+(~(((j-24+(-g|0)|0)>>>0)/24|0)*24|0)}J2(l)}l=c[e>>2]|0;if((l|0)==0){be(k|0)}g=c[f>>2]|0;if((l|0)==(g|0)){n=l}else{j=g;while(1){g=j-12|0;c[f>>2]=g;if((a[g]&1)==0){o=g}else{J2(c[j-12+8>>2]|0);o=c[f>>2]|0}if((l|0)==(o|0)){break}else{j=o}}n=c[e>>2]|0}J2(n);be(k|0)}function zi(a){a=a|0;var b=0;b=a+28|0;c[b>>2]=(c[b>>2]|0)+1;c[a+32>>2]=1;return}function zj(a){a=a|0;var b=0;b=a+28|0;c[b>>2]=(c[b>>2]|0)-1;c[a+32>>2]=1;return}function zk(a,b){a=a|0;b=b|0;var e=0,f=0;e=d[b]|0;if((e&1|0)==0){f=e>>>1}else{f=c[b+4>>2]|0}b=a+32|0;c[b>>2]=(c[b>>2]|0)+f;return}function zl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=d|0;f=b+16|0;b=e;c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];f=e;b=e+12|0;g=a+24|0;c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];g=a+16|0;b=c[g>>2]|0;if((b|0)==(c[a+20>>2]|0)){zm(a+12|0,e);i=d;return}if((b|0)==0){h=0}else{e=b;c[e>>2]=c[f>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];h=c[g>>2]|0}c[g>>2]=h+24;i=d;return}function zm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=(h|0)/24|0;j=i+1|0;if(j>>>0>178956970>>>0){Hu(0)}k=a+8|0;a=((c[k>>2]|0)-g|0)/24|0;if(a>>>0>89478484>>>0){l=178956970;m=5}else{g=a<<1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l*24|0)|0;o=l}l=n+(i*24|0)|0;if((l|0)!=0){m=l;l=b;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];c[m+16>>2]=c[l+16>>2];c[m+20>>2]=c[l+20>>2]}l=n+((((h|0)/-24|0)+i|0)*24|0)|0;i=f;Kb(l|0,i|0,h)|0;c[e>>2]=l;c[d>>2]=n+(j*24|0);c[k>>2]=n+(o*24|0);if((f|0)==0){return}J2(i);return}function zn(b,c,d){b=b|0;c=c|0;d=d|0;y6(b,a[d+36|0]&1);return}function zo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;d=i;i=i+16|0;f=d|0;g=+h[e+40>>3];h9(f,e);e=f;if((a[e]&1)==0){j=f+1|0}else{j=c[f+8>>2]|0}x=0;aw(2,b|0,+g,j|0);if(!x){if((a[e]&1)==0){i=d;return}J2(c[f+8>>2]|0);i=d;return}else{x=0;d=bQ(-1,-1)|0;if((a[e]&1)==0){be(d|0)}J2(c[f+8>>2]|0);be(d|0)}}function zp(a,b,c){a=a|0;b=b|0;c=c|0;y8(a,+h[c+40>>3],+h[c+48>>3],+h[c+56>>3],+h[c+64>>3]);return}function zq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;f=d|0;g=e+40|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[e+48>>2]|0;g=c[e+44>>2]|0;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){e=g<<1&255;l=f;a[l]=e;m=f+1|0;n=e;o=l}else{l=g+16&-16;e=J0(l)|0;c[f+8>>2]=e;p=l|1;c[f>>2]=p;c[f+4>>2]=g;m=e;n=p&255;o=f}Kb(m|0,h|0,g)|0;a[m+g|0]=0;j=n;k=o}if((j&1)==0){q=f+1|0}else{q=c[f+8>>2]|0}x=0;aq(536,b|0,q|0);if(!x){if((a[k]&1)==0){i=d;return}J2(c[f+8>>2]|0);i=d;return}else{x=0;d=bQ(-1,-1)|0;if((a[k]&1)==0){be(d|0)}J2(c[f+8>>2]|0);be(d|0)}}function zr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+40|0;f=e|0;g=d+44|0;h=d+40|0;za(a,(c[g>>2]|0)-(c[h>>2]|0)>>2,(c[d+52>>2]|0)!=1|0);d=c[h>>2]|0;j=(c[g>>2]|0)-d>>2;if((j|0)==0){i=e;return}g=a+12|0;a=b|0;b=f;k=0;l=d;while(1){d=(c[g>>2]|0)+(k*40|0)|0;m=c[l+(k<<2)>>2]|0;cX[c[(c[m>>2]|0)+32>>2]&511](f,m|0,a);m=d;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];c[m+16>>2]=c[b+16>>2];c[m+20>>2]=c[b+20>>2];c[m+24>>2]=c[b+24>>2];c[m+28>>2]=c[b+28>>2];c[m+32>>2]=c[b+32>>2];c[m+36>>2]=c[b+36>>2];m=k+1|0;if(m>>>0>=j>>>0){break}k=m;l=c[h>>2]|0}i=e;return}function zs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+40|0;f=e|0;g=d+44|0;h=d+40|0;za(a,(c[g>>2]|0)-(c[h>>2]|0)>>2,0);d=c[h>>2]|0;j=(c[g>>2]|0)-d>>2;if((j|0)==0){i=e;return}g=a+12|0;a=b|0;b=f;k=0;l=d;while(1){d=(c[g>>2]|0)+(k*40|0)|0;m=c[l+(k<<2)>>2]|0;cX[c[(c[m>>2]|0)+32>>2]&511](f,m,a);m=d;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];c[m+16>>2]=c[b+16>>2];c[m+20>>2]=c[b+20>>2];c[m+24>>2]=c[b+24>>2];c[m+28>>2]=c[b+28>>2];c[m+32>>2]=c[b+32>>2];c[m+36>>2]=c[b+36>>2];m=k+1|0;if(m>>>0>=j>>>0){break}k=m;l=c[h>>2]|0}i=e;return}function zt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[d+36>>2]|0;cX[c[(c[e>>2]|0)+32>>2]&511](a,e|0,b|0);return}function zu(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zv(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zw(a){a=a|0;return}function zx(a){a=a|0;J2(a);return}function zy(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zz(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zA(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zB(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zC(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zD(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zE(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zF(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zG(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zH(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zI(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zJ(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zK(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zL(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zM(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zN(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zO(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zP(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zQ(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zR(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zS(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zT(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zU(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zV(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zW(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zX(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zY(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function zZ(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z_(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z$(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z0(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z1(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z2(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z3(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z4(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z5(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z6(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z7(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z8(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function z9(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function Aa(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function Ab(a,b,c){a=a|0;b=b|0;c=c|0;zb(a);return}function Ac(a,b){a=a|0;b=b|0;c[a>>2]=15840;c[a+4>>2]=b;return}function Ad(a){a=a|0;J2(a);return}function Ae(a){a=a|0;return}function Af(a,b,c){a=a|0;b=b|0;c=c|0;BP(a,b,c);return}function Ag(a,b,c){a=a|0;b=b|0;c=c|0;BO(a,b,c);return}function Ah(a,b,c){a=a|0;b=b|0;c=c|0;BN(a,b,c);return}function Ai(a,b,c){a=a|0;b=b|0;c=c|0;BM(a,b,c);return}function Aj(a,b,c){a=a|0;b=b|0;c=c|0;BL(a,b,c);return}function Ak(a,b,c){a=a|0;b=b|0;c=c|0;BK(a,b,c);return}function Al(a,b,c){a=a|0;b=b|0;c=c|0;BJ(a,b,c);return}function Am(a,b,c){a=a|0;b=b|0;c=c|0;BI(a,b,c);return}function An(a,b,c){a=a|0;b=b|0;c=c|0;BH(a,b,c);return}function Ao(a,b,c){a=a|0;b=b|0;c=c|0;BG(a,b,c);return}function Ap(a,b,c){a=a|0;b=b|0;c=c|0;BF(a,b,c);return}function Aq(a,b,c){a=a|0;b=b|0;c=c|0;BE(a,b,c);return}function Ar(a,b,c){a=a|0;b=b|0;c=c|0;BD(a,b,c);return}function As(a,b,c){a=a|0;b=b|0;c=c|0;BC(a,b,c);return}function At(a,b,c){a=a|0;b=b|0;c=c|0;BB(a,b,c);return}function Au(a,b,c){a=a|0;b=b|0;c=c|0;BA(a,b,c);return}function Av(a,b,c){a=a|0;b=b|0;c=c|0;Bz(a,b,c);return}function Aw(a,b,c){a=a|0;b=b|0;c=c|0;By(a,b,c);return}function Ax(a,b,c){a=a|0;b=b|0;c=c|0;Bx(a,b,c);return}function Ay(a,b,c){a=a|0;b=b|0;c=c|0;Bw(a,b,c);return}function Az(a,b,c){a=a|0;b=b|0;c=c|0;Bv(a,b,c);return}function AA(a,b,c){a=a|0;b=b|0;c=c|0;Bu(a,b,c);return}function AB(a,b,c){a=a|0;b=b|0;c=c|0;Bt(a,b,c);return}function AC(a,b,c){a=a|0;b=b|0;c=c|0;Bs(a,b,c);return}function AD(a,b,c){a=a|0;b=b|0;c=c|0;Br(a,b,c);return}function AE(a,b,c){a=a|0;b=b|0;c=c|0;Bq(a,b,c);return}function AF(a,b,c){a=a|0;b=b|0;c=c|0;Bp(a,b,c);return}function AG(a,b,c){a=a|0;b=b|0;c=c|0;Bo(a,b,c);return}function AH(a,b,c){a=a|0;b=b|0;c=c|0;Bn(a,b,c);return}function AI(a,b,c){a=a|0;b=b|0;c=c|0;Bm(a,b,c);return}function AJ(a,b,c){a=a|0;b=b|0;c=c|0;Bl(a,b,c);return}function AK(a,b,c){a=a|0;b=b|0;c=c|0;Bk(a,b,c);return}function AL(a,b,c){a=a|0;b=b|0;c=c|0;Bj(a,b,c);return}function AM(a,b,c){a=a|0;b=b|0;c=c|0;Bi(a,b,c);return}function AN(a,b,c){a=a|0;b=b|0;c=c|0;Bh(a,b,c);return}function AO(b,c,d){b=b|0;c=c|0;d=d|0;a[b]=0;a[b+1|0]=0;return}function AP(a,b,c){a=a|0;b=b|0;c=c|0;Bg(a,b,c);return}function AQ(a,b,c){a=a|0;b=b|0;c=c|0;Bf(a,b,c);return}function AR(a,b,c){a=a|0;b=b|0;c=c|0;Be(a,b,c);return}function AS(a,b,c){a=a|0;b=b|0;c=c|0;Bd(a,b,c);return}function AT(a,b,c){a=a|0;b=b|0;c=c|0;Bc(a,b,c);return}function AU(a,b,c){a=a|0;b=b|0;c=c|0;Bb(a,b,c);return}function AV(a,b,c){a=a|0;b=b|0;c=c|0;Ba(a,b,c);return}function AW(a,b,c){a=a|0;b=b|0;c=c|0;A9(a,b,c);return}function AX(a,b,c){a=a|0;b=b|0;c=c|0;A8(a,b,c);return}function AY(a,b,c){a=a|0;b=b|0;c=c|0;A7(a,b,c);return}function AZ(a,b,c){a=a|0;b=b|0;c=c|0;A6(a,b,c);return}function A_(a,b,c){a=a|0;b=b|0;c=c|0;A5(a,b,c);return}function A$(a,b,c){a=a|0;b=b|0;c=c|0;A4(a,b,c);return}function A0(a,b,c){a=a|0;b=b|0;c=c|0;A3(a,b,c);return}function A1(a,b,c){a=a|0;b=b|0;c=c|0;A2(a,b,c);return}function A2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function A3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function A4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function A5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function A6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function A7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function A8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function A9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Ba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Be(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bm(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Br(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bs(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function By(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function Bz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+24|0;g=f|0;pk(g,c[d+4>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=g+4|0;if((a[e]&1)==0){d=b;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];pm(g);i=f;return}e=c[g+12>>2]|0;d=c[g+8>>2]|0;if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}if(d>>>0<11>>>0){a[b]=d<<1;h=b+1|0}else{j=d+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+8>>2]=k;c[b>>2]=j|1;c[b+4>>2]=d;h=k}Kb(h|0,e|0,d)|0;a[h+d|0]=0;pm(g);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;x=0;ap(358,g|0);if(!x){be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function BQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b;e=a[b]|0;f=e&255;g=(f&1|0)==0;if(g){h=f>>>1}else{h=c[b+4>>2]|0}i=(e&1)==0;if(i){j=d+1|0}else{j=c[b+8>>2]|0}e=h>>>0>2>>>0;do{if((Kd(j|0,328,(e?2:h)|0)|0)==0){if(h>>>0>1>>>0&(e^1)){k=0}else{break}return k|0}}while(0);if(g){l=f>>>1}else{l=c[b+4>>2]|0}if(i){m=d+1|0}else{m=c[b+8>>2]|0}e=l>>>0>2>>>0;do{if((Kd(m|0,9280,(e?2:l)|0)|0)==0){if(l>>>0>1>>>0&(e^1)){k=1}else{break}return k|0}}while(0);if(g){n=f>>>1}else{n=c[b+4>>2]|0}if(i){o=d+1|0}else{o=c[b+8>>2]|0}e=n>>>0>2>>>0;do{if((Kd(o|0,7688,(e?2:n)|0)|0)==0){if(n>>>0>1>>>0&(e^1)){k=2}else{break}return k|0}}while(0);if(g){p=f>>>1}else{p=c[b+4>>2]|0}if(i){q=d+1|0}else{q=c[b+8>>2]|0}e=p>>>0>2>>>0;do{if((Kd(q|0,5808,(e?2:p)|0)|0)==0){if(p>>>0>1>>>0&(e^1)){k=3}else{break}return k|0}}while(0);if(g){r=f>>>1}else{r=c[b+4>>2]|0}if(i){s=d+1|0}else{s=c[b+8>>2]|0}e=r>>>0>2>>>0;do{if((Kd(s|0,5032,(e?2:r)|0)|0)==0){if(r>>>0>1>>>0&(e^1)){k=4}else{break}return k|0}}while(0);if(g){t=f>>>1}else{t=c[b+4>>2]|0}if(i){u=d+1|0}else{u=c[b+8>>2]|0}b=t>>>0>2>>>0;d=Kd(u|0,3384,(b?2:t)|0)|0;if((d|0)==0){v=t>>>0<2>>>0?-1:b&1}else{v=d}k=(v|0)==0?5:6;return k|0}function BR(a,b){a=a|0;b=b|0;var c=0,d=0.0;c=BQ(a)|0;a=BQ(b)|0;if((c|0)==6|(a|0)==6){d=0.0;return+d}d=+h[35912+(c*48|0)+(a<<3)>>3];return+d}function BS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b|0;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;Cc(39648,h,39776);c[10160]=15148;c[10162]=15168;c[10161]=0;x=0;aq(200,40648,39648);if(x){x=0;j=bQ(-1,-1)|0;C7(40648);be(j|0)}c[10180]=0;c[10181]=-1;j=c[q>>2]|0;c[9888]=14880;HA(39556);Ke(39560,0,24)|0;c[9888]=15368;c[9896]=j;HB(g,39556);k=(x=0,aK(196,g|0,39976)|0);if(x){x=0;l=bQ(-1,-1)|0;HC(g);c[9888]=14880;HC(39556);be(l|0)}l=k;HC(g);c[9897]=l;c[9898]=39784;a[39596]=(cA[c[(c[k>>2]|0)+28>>2]&511](l)|0)&1;c[10094]=15052;c[10095]=15072;x=0;aq(200,40380,39552);if(x){x=0;l=bQ(-1,-1)|0;C7(40380);be(l|0)}c[10113]=0;c[10114]=-1;l=c[u>>2]|0;c[9900]=14880;HA(39604);Ke(39608,0,24)|0;c[9900]=15368;c[9908]=l;HB(f,39604);k=(x=0,aK(196,f|0,39976)|0);if(x){x=0;g=bQ(-1,-1)|0;HC(f);c[9900]=14880;HC(39604);be(g|0)}g=k;HC(f);c[9909]=g;c[9910]=39792;a[39644]=(cA[c[(c[k>>2]|0)+28>>2]&511](g)|0)&1;c[10138]=15052;c[10139]=15072;x=0;aq(200,40556,39600);if(x){x=0;g=bQ(-1,-1)|0;C7(40556);be(g|0)}c[10157]=0;c[10158]=-1;g=c[(c[(c[10138]|0)-12>>2]|0)+40576>>2]|0;c[10116]=15052;c[10117]=15072;x=0;aq(200,40468,g|0);if(x){x=0;g=bQ(-1,-1)|0;C7(40468);be(g|0)}c[10135]=0;c[10136]=-1;c[(c[(c[10160]|0)-12>>2]|0)+40712>>2]=40376;g=(c[(c[10138]|0)-12>>2]|0)+40556|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[10138]|0)-12>>2]|0)+40624>>2]=40376;B_(39496,h,39800);c[10072]=15100;c[10074]=15120;c[10073]=0;x=0;aq(200,40296,39496);if(x){x=0;h=bQ(-1,-1)|0;C7(40296);be(h|0)}c[10092]=0;c[10093]=-1;c[9850]=14808;HA(39404);Ke(39408,0,24)|0;c[9850]=15296;c[9858]=j;HB(e,39404);j=(x=0,aK(196,e|0,39968)|0);if(x){x=0;h=bQ(-1,-1)|0;HC(e);c[9850]=14808;HC(39404);be(h|0)}h=j;HC(e);c[9859]=h;c[9860]=39808;a[39444]=(cA[c[(c[j>>2]|0)+28>>2]&511](h)|0)&1;c[10002]=15004;c[10003]=15024;x=0;aq(200,40012,39400);if(x){x=0;h=bQ(-1,-1)|0;C7(40012);be(h|0)}c[10021]=0;c[10022]=-1;c[9862]=14808;HA(39452);Ke(39456,0,24)|0;c[9862]=15296;c[9870]=l;HB(d,39452);l=(x=0,aK(196,d|0,39968)|0);if(x){x=0;h=bQ(-1,-1)|0;HC(d);c[9862]=14808;HC(39452);be(h|0)}h=l;HC(d);c[9871]=h;c[9872]=39816;a[39492]=(cA[c[(c[l>>2]|0)+28>>2]&511](h)|0)&1;c[10046]=15004;c[10047]=15024;x=0;aq(200,40188,39448);if(x){x=0;h=bQ(-1,-1)|0;C7(40188);be(h|0)}c[10065]=0;c[10066]=-1;h=c[(c[(c[10046]|0)-12>>2]|0)+40208>>2]|0;c[10024]=15004;c[10025]=15024;x=0;aq(200,40100,h|0);if(!x){c[10043]=0;c[10044]=-1;c[(c[(c[10072]|0)-12>>2]|0)+40360>>2]=40008;h=(c[(c[10046]|0)-12>>2]|0)+40188|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[10046]|0)-12>>2]|0)+40256>>2]=40008;i=b;return}else{x=0;b=bQ(-1,-1)|0;C7(40100);be(b|0)}}function BT(a){a=a|0;x=0,as(56,40376)|0;do{if(!x){x=0,as(56,40464)|0;if(x){x=0;break}x=0,as(156,40008)|0;if(x){x=0;break}x=0,as(156,40096)|0;if(x){x=0;break}return}else{x=0}}while(0);bQ(-1,-1,0)|0;bU()}function BU(a){a=a|0;c[a>>2]=14808;HC(a+4|0);return}function BV(a){a=a|0;c[a>>2]=14808;HC(a+4|0);J2(a);return}function BW(b,d){b=b|0;d=d|0;var e=0;cA[c[(c[b>>2]|0)+24>>2]&511](b)|0;e=HE(d,39968)|0;d=e;c[b+36>>2]=d;a[b+44|0]=(cA[c[(c[e>>2]|0)+28>>2]&511](d)|0)&1;return}function BX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b|0;e=b+8|0;f=a+36|0;g=a+40|0;h=d|0;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=cW[c[(c[a>>2]|0)+20>>2]&31](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((a2(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=6;break}if((l|0)==2){m=-1;n=7;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((a$(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==7){i=b;return m|0}else if((n|0)==6){i=b;return m|0}return 0}function BY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if((a[b+44|0]&1)!=0){f=a2(d|0,4,e|0,c[b+32>>2]|0)|0;return f|0}g=b;if((e|0)>0){h=d;i=0}else{f=0;return f|0}while(1){if((cS[c[(c[g>>2]|0)+52>>2]&1023](b,c[h>>2]|0)|0)==-1){f=i;j=9;break}d=i+1|0;if((d|0)<(e|0)){h=h+4|0;i=d}else{f=d;j=7;break}}if((j|0)==7){return f|0}else if((j|0)==9){return f|0}return 0}function BZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;L1:do{if(!k){c[g>>2]=d;if((a[b+44|0]&1)!=0){if((a2(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f|0;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=cZ[c[(c[u>>2]|0)+12>>2]&31](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=14;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(v>>>0>=2>>>0){l=-1;w=18;break}v=(c[h>>2]|0)-r|0;if((a2(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=16;break}if(u){t=u?c[j>>2]|0:t}else{break L1}}if((w|0)==14){i=e;return l|0}else if((w|0)==16){i=e;return l|0}else if((w|0)==7){if((a2(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==18){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function B_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;g=f|0;h=b|0;c[h>>2]=14808;j=b+4|0;HA(j);Ke(b+8|0,0,24)|0;c[h>>2]=15696;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;HB(g,j);e=(x=0,aK(196,g|0,39968)|0);if(x){x=0;k=bQ(-1,-1)|0;l=K;HC(g);c[h>>2]=14808;HC(j);be(k|0)}d=e;m=b+36|0;c[m>>2]=d;n=b+44|0;c[n>>2]=cA[c[(c[e>>2]|0)+24>>2]&511](d)|0;d=c[m>>2]|0;a[b+53|0]=(cA[c[(c[d>>2]|0)+28>>2]&511](d)|0)&1;if((c[n>>2]|0)<=8){HC(g);i=f;return}x=0;ap(52,80);if(!x){HC(g);i=f;return}else{x=0;k=bQ(-1,-1)|0;l=K;HC(g);c[h>>2]=14808;HC(j);be(k|0)}}function B$(a){a=a|0;c[a>>2]=14808;HC(a+4|0);return}function B0(a){a=a|0;c[a>>2]=14808;HC(a+4|0);J2(a);return}function B1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=HE(d,39968)|0;d=e;f=b+36|0;c[f>>2]=d;g=b+44|0;c[g>>2]=cA[c[(c[e>>2]|0)+24>>2]&511](d)|0;d=c[f>>2]|0;a[b+53|0]=(cA[c[(c[d>>2]|0)+28>>2]&511](d)|0)&1;if((c[g>>2]|0)<=8){return}GW(80);return}function B2(a){a=a|0;return B5(a,0)|0}function B3(a){a=a|0;return B5(a,1)|0}function B4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]&1)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;L8:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f|0;q=cZ[c[(c[o>>2]|0)+12>>2]&31](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==2|(q|0)==1){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(o>>>0<=p>>>0){break L8}r=o-1|0;c[g>>2]=r;if((b2(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function B5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]&1)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;L8:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=bi(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break L8}}i=e;return n|0}}while(0);L15:do{if((a[b+53|0]&1)==0){l=b+40|0;m=b+36|0;o=f|0;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=cZ[c[(c[t>>2]|0)+16>>2]&31](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=27;break}else if((x|0)!=1){z=r;break L15}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=28;break}v=bi(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=26;break}a[w]=v;r=r+1|0}if((y|0)==28){i=e;return n|0}else if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==27){i=e;return n|0}else if((y|0)==26){i=e;return n|0}}else{c[g>>2]=a[f|0]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b-1|0;if((b2(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=29;break}else{b=z}}if((y|0)==29){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function B6(a){a=a|0;c[a>>2]=14880;HC(a+4|0);return}function B7(a){a=a|0;c[a>>2]=14880;HC(a+4|0);J2(a);return}function B8(b,d){b=b|0;d=d|0;var e=0;cA[c[(c[b>>2]|0)+24>>2]&511](b)|0;e=HE(d,39976)|0;d=e;c[b+36>>2]=d;a[b+44|0]=(cA[c[(c[e>>2]|0)+28>>2]&511](d)|0)&1;return}function B9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b|0;e=b+8|0;f=a+36|0;g=a+40|0;h=d|0;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=cW[c[(c[a>>2]|0)+20>>2]&31](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((a2(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=8;break}if((l|0)==2){m=-1;n=6;break}else if((l|0)!=1){n=4;break}}if((n|0)==6){i=b;return m|0}else if((n|0)==8){i=b;return m|0}else if((n|0)==4){m=((a$(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}return 0}function Ca(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;if((a[b+44|0]&1)!=0){g=a2(e|0,1,f|0,c[b+32>>2]|0)|0;return g|0}h=b;if((f|0)>0){i=e;j=0}else{g=0;return g|0}while(1){if((cS[c[(c[h>>2]|0)+52>>2]&1023](b,d[i]|0)|0)==-1){g=j;k=8;break}e=j+1|0;if((e|0)<(f|0)){i=i+1|0;j=e}else{g=e;k=10;break}}if((k|0)==10){return g|0}else if((k|0)==8){return g|0}return 0}function Cb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;L1:do{if(!k){a[g]=d;if((a[b+44|0]&1)!=0){if((a2(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f|0;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=cZ[c[(c[u>>2]|0)+12>>2]&31](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=16;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(v>>>0>=2>>>0){l=-1;w=14;break}v=(c[h>>2]|0)-r|0;if((a2(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=18;break}if(u){t=u?c[j>>2]|0:t}else{break L1}}if((w|0)==7){if((a2(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==18){i=e;return l|0}else if((w|0)==14){i=e;return l|0}else if((w|0)==16){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Cc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;g=f|0;h=b|0;c[h>>2]=14880;j=b+4|0;HA(j);Ke(b+8|0,0,24)|0;c[h>>2]=15768;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;HB(g,j);e=(x=0,aK(196,g|0,39976)|0);if(x){x=0;k=bQ(-1,-1)|0;l=K;HC(g);c[h>>2]=14880;HC(j);be(k|0)}d=e;m=b+36|0;c[m>>2]=d;n=b+44|0;c[n>>2]=cA[c[(c[e>>2]|0)+24>>2]&511](d)|0;d=c[m>>2]|0;a[b+53|0]=(cA[c[(c[d>>2]|0)+28>>2]&511](d)|0)&1;if((c[n>>2]|0)<=8){HC(g);i=f;return}x=0;ap(52,80);if(!x){HC(g);i=f;return}else{x=0;k=bQ(-1,-1)|0;l=K;HC(g);c[h>>2]=14880;HC(j);be(k|0)}}function Cd(a){a=a|0;c[a>>2]=14880;HC(a+4|0);return}function Ce(a){a=a|0;c[a>>2]=14880;HC(a+4|0);J2(a);return}function Cf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=HE(d,39976)|0;d=e;f=b+36|0;c[f>>2]=d;g=b+44|0;c[g>>2]=cA[c[(c[e>>2]|0)+24>>2]&511](d)|0;d=c[f>>2]|0;a[b+53|0]=(cA[c[(c[d>>2]|0)+28>>2]&511](d)|0)&1;if((c[g>>2]|0)<=8){return}GW(80);return}function Cg(a){a=a|0;return Cj(a,0)|0}function Ch(a){a=a|0;return Cj(a,1)|0}function Ci(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]&1)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;L8:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f|0;q=cZ[c[(c[o>>2]|0)+12>>2]&31](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==2|(q|0)==1){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(o>>>0<=p>>>0){break L8}r=o-1|0;c[g>>2]=r;if((b2(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function Cj(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f|0;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]&1)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;L8:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=bi(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break L8}}i=f;return o|0}}while(0);L15:do{if((a[b+53|0]&1)==0){m=b+40|0;n=b+36|0;p=g|0;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=cZ[c[(c[u>>2]|0)+16>>2]&31](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=26;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break L15}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=31;break}w=bi(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=28;break}a[x]=w;s=s+1|0}if((z|0)==26){i=f;return o|0}else if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==31){i=f;return o|0}else if((z|0)==28){i=f;return o|0}}else{a[h]=a[g|0]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k-1|0;if((b2(d[g+j|0]|0|0,c[l>>2]|0)|0)==-1){o=-1;z=27;break}else{k=j}}if((z|0)==27){i=f;return o|0}else if((z|0)==21){B=a[h]|0;break}}}while(0);o=B&255;i=f;return o|0}function Ck(){BS(0);bk(102,40728,r|0)|0;return}function Cl(a){a=a|0;return}function Cm(a){a=a|0;var b=0;b=a+4|0;I=c[b>>2]|0,c[b>>2]=I+1,I;return}function Cn(a){a=a|0;var b=0,d=0;b=a+4|0;if(((I=c[b>>2]|0,c[b>>2]=I+ -1,I)|0)!=0){d=0;return d|0}cx[c[(c[a>>2]|0)+8>>2]&1023](a);d=1;return d|0}function Co(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a>>2]=13040;d=a+4|0;if((d|0)==0){return}a=Kf(b|0)|0;e=J1(a+13|0)|0;c[e+4>>2]=a;c[e>>2]=a;f=e+12|0;c[d>>2]=f;c[e+8>>2]=0;Kb(f|0,b|0,a+1|0)|0;return}function Cp(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=13040;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;J2(e);return}d=(c[b>>2]|0)-12|0;if((d|0)==0){e=a;J2(e);return}J3(d);e=a;J2(e);return}function Cq(a){a=a|0;var b=0;c[a>>2]=13040;b=a+4|0;a=(c[b>>2]|0)-4|0;if(((I=c[a>>2]|0,c[a>>2]=I+ -1,I)-1|0)>=0){return}a=(c[b>>2]|0)-12|0;if((a|0)==0){return}J3(a);return}function Cr(a){a=a|0;return c[a+4>>2]|0}function Cs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;c[b>>2]=12944;e=b+4|0;if((e|0)==0){return}if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=Kf(f|0)|0;b=J1(d+13|0)|0;c[b+4>>2]=d;c[b>>2]=d;g=b+12|0;c[e>>2]=g;c[b+8>>2]=0;Kb(g|0,f|0,d+1|0)|0;return}function Ct(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a>>2]=12944;d=a+4|0;if((d|0)==0){return}a=Kf(b|0)|0;e=J1(a+13|0)|0;c[e+4>>2]=a;c[e>>2]=a;f=e+12|0;c[d>>2]=f;c[e+8>>2]=0;Kb(f|0,b|0,a+1|0)|0;return}function Cu(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=12944;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;J2(e);return}d=(c[b>>2]|0)-12|0;if((d|0)==0){e=a;J2(e);return}J3(d);e=a;J2(e);return}function Cv(a){a=a|0;var b=0;c[a>>2]=12944;b=a+4|0;a=(c[b>>2]|0)-4|0;if(((I=c[a>>2]|0,c[a>>2]=I+ -1,I)-1|0)>=0){return}a=(c[b>>2]|0)-12|0;if((a|0)==0){return}J3(a);return}function Cw(a){a=a|0;return c[a+4>>2]|0}function Cx(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=13040;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;J2(e);return}d=(c[b>>2]|0)-12|0;if((d|0)==0){e=a;J2(e);return}J3(d);e=a;J2(e);return}function Cy(a){a=a|0;var b=0,d=0,e=0;c[a>>2]=13040;b=a+4|0;d=(c[b>>2]|0)-4|0;if(((I=c[d>>2]|0,c[d>>2]=I+ -1,I)-1|0)>=0){e=a;J2(e);return}d=(c[b>>2]|0)-12|0;if((d|0)==0){e=a;J2(e);return}J3(d);e=a;J2(e);return}function Cz(a){a=a|0;return}function CA(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;return}function CB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e|0;cX[c[(c[a>>2]|0)+12>>2]&511](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function CC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if((c[b+4>>2]|0)!=(a|0)){e=0;return e|0}e=(c[b>>2]|0)==(d|0);return e|0}function CD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;d=bZ(e|0)|0;e=Kf(d|0)|0;if(e>>>0>4294967279>>>0){CJ(0)}if(e>>>0<11>>>0){a[b]=e<<1;f=b+1|0;Kb(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}else{h=e+16&-16;i=J0(h)|0;c[b+8>>2]=i;c[b>>2]=h|1;c[b+4>>2]=e;f=i;Kb(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}}function CE(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=f;j=i;i=i+12|0;i=i+7&-8;k=e|0;l=c[k>>2]|0;do{if((l|0)!=0){m=d[h]|0;if((m&1|0)==0){n=m>>>1}else{n=c[f+4>>2]|0}if((n|0)==0){o=l}else{CW(f,8760,2)|0;o=c[k>>2]|0}m=c[e+4>>2]|0;cX[c[(c[m>>2]|0)+24>>2]&511](j,m,o);m=j;p=a[m]|0;if((p&1)==0){q=j+1|0}else{q=c[j+8>>2]|0}r=p&255;if((r&1|0)==0){s=r>>>1}else{s=c[j+4>>2]|0}x=0,ax(64,f|0,q|0,s|0)|0;if(!x){if((a[m]&1)==0){break}J2(c[j+8>>2]|0);break}else{x=0}r=bQ(-1,-1)|0;if((a[m]&1)==0){be(r|0)}J2(c[j+8>>2]|0);be(r|0)}}while(0);j=b;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];Ke(h|0,0,12)|0;i=g;return}function CF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+32|0;g=d;d=i;i=i+8|0;c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];g=f|0;h=f+16|0;j=Kf(e|0)|0;if(j>>>0>4294967279>>>0){CJ(0)}if(j>>>0<11>>>0){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=J0(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}Kb(k|0,e|0,j)|0;a[k+j|0]=0;x=0;aP(242,g|0,d|0,h|0);do{if(!x){x=0;aq(98,b|0,g|0);if(x){x=0;j=bQ(-1,-1)|0;k=j;j=K;if((a[g]&1)==0){n=j;o=k;break}J2(c[g+8>>2]|0);n=j;o=k;break}if((a[g]&1)!=0){J2(c[g+8>>2]|0)}if((a[h]&1)==0){p=b|0;c[p>>2]=15264;q=b+8|0;r=d;s=q;t=r|0;u=c[t>>2]|0;v=r+4|0;w=c[v>>2]|0;y=s|0;c[y>>2]=u;z=s+4|0;c[z>>2]=w;i=f;return}J2(c[h+8>>2]|0);p=b|0;c[p>>2]=15264;q=b+8|0;r=d;s=q;t=r|0;u=c[t>>2]|0;v=r+4|0;w=c[v>>2]|0;y=s|0;c[y>>2]=u;z=s+4|0;c[z>>2]=w;i=f;return}else{x=0;k=bQ(-1,-1)|0;n=K;o=k}}while(0);if((a[h]&1)==0){A=o;B=0;C=A;D=n;be(C|0)}J2(c[h+8>>2]|0);A=o;B=0;C=A;D=n;be(C|0)}function CG(a){a=a|0;Cv(a|0);J2(a);return}function CH(a){a=a|0;Cv(a|0);return}function CI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e;if((c[a>>2]|0)==1){do{bb(39728,39704)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)!=0){f;return}c[a>>2]=1;x=0,as(250,39704)|0;do{if(!x){x=0;ap(d|0,b|0);if(x){x=0;break}x=0,as(14,39704)|0;if(x){x=0;break}c[a>>2]=-1;x=0,as(250,39704)|0;if(x){x=0;break}x=0,as(214,39728)|0;if(x){x=0;break}return}else{x=0}}while(0);b=bQ(-1,-1,0)|0;bA(b|0)|0;x=0,as(14,39704)|0;do{if(!x){c[a>>2]=0;x=0,as(250,39704)|0;if(x){x=0;break}x=0,as(214,39728)|0;if(x){x=0;break}x=0;aQ(6);if(x){x=0;break}}else{x=0}}while(0);a=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(a|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function CJ(a){a=a|0;var b=0;a=ci(8)|0;x=0;aq(604,a|0,1200);if(!x){c[a>>2]=13008;bH(a|0,28128,466)}else{x=0;b=bQ(-1,-1)|0;bl(a|0);be(b|0)}}function CK(a){a=a|0;var b=0;a=ci(8)|0;x=0;aq(604,a|0,1200);if(!x){c[a>>2]=12976;bH(a|0,28112,10)}else{x=0;b=bQ(-1,-1)|0;bl(a|0);be(b|0)}}function CL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=d;if((a[e]&1)==0){f=b;c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];return}e=c[d+8>>2]|0;f=c[d+4>>2]|0;if(f>>>0>4294967279>>>0){CJ(0)}if(f>>>0<11>>>0){a[b]=f<<1;g=b+1|0}else{d=f+16&-16;h=J0(d)|0;c[b+8>>2]=h;c[b>>2]=d|1;c[b+4>>2]=f;g=h}Kb(g|0,e|0,f)|0;a[g+f|0]=0;return}function CM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(e>>>0>4294967279>>>0){CJ(0)}if(e>>>0<11>>>0){a[b]=e<<1;f=b+1|0;Kb(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}else{h=e+16&-16;i=J0(h)|0;c[b+8>>2]=i;c[b>>2]=h|1;c[b+4>>2]=e;f=i;Kb(f|0,d|0,e)|0;g=f+e|0;a[g]=0;return}}function CN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if(d>>>0>4294967279>>>0){CJ(0)}if(d>>>0<11>>>0){a[b]=d<<1;f=b+1|0}else{g=d+16&-16;h=J0(g)|0;c[b+8>>2]=h;c[b>>2]=g|1;c[b+4>>2]=d;f=h}Ke(f|0,e|0,d|0)|0;a[f+d|0]=0;return}function CO(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=a[d]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}if(i>>>0<e>>>0){CK(0)}if((g&1)==0){j=d+1|0}else{j=c[d+8>>2]|0}d=j+e|0;j=i-e|0;e=j>>>0<f>>>0?j:f;if(e>>>0>4294967279>>>0){CJ(0)}if(e>>>0<11>>>0){a[b]=e<<1;k=b+1|0;Kb(k|0,d|0,e)|0;l=k+e|0;a[l]=0;return}else{f=e+16&-16;j=J0(f)|0;c[b+8>>2]=j;c[b>>2]=f|1;c[b+4>>2]=e;k=j;Kb(k|0,d|0,e)|0;l=k+e|0;a[l]=0;return}}function CP(b){b=b|0;if((a[b]&1)==0){return}J2(c[b+8>>2]|0);return}function CQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;if((b|0)==(d|0)){return b|0}e=a[d]|0;if((e&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}g=e&255;if((g&1|0)==0){h=g>>>1}else{h=c[d+4>>2]|0}d=b;g=b;e=a[g]|0;if((e&1)==0){i=10;j=e}else{e=c[b>>2]|0;i=(e&-2)-1|0;j=e&255}if(i>>>0<h>>>0){e=j&255;if((e&1|0)==0){k=e>>>1}else{k=c[b+4>>2]|0}CX(b,i,h-i|0,k,0,k,h,f);return b|0}if((j&1)==0){l=d+1|0}else{l=c[b+8>>2]|0}Kc(l|0,f|0,h|0)|0;a[l+h|0]=0;if((a[g]&1)==0){a[g]=h<<1;return b|0}else{c[b+4>>2]=h;return b|0}return 0}function CR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=Kf(d|0)|0;f=b;g=b;h=a[g]|0;if((h&1)==0){i=10;j=h}else{h=c[b>>2]|0;i=(h&-2)-1|0;j=h&255}if(i>>>0<e>>>0){h=j&255;if((h&1|0)==0){k=h>>>1}else{k=c[b+4>>2]|0}CX(b,i,e-i|0,k,0,k,e,d);return b|0}if((j&1)==0){l=f+1|0}else{l=c[b+8>>2]|0}Kc(l|0,d|0,e|0)|0;a[l+e|0]=0;if((a[g]&1)==0){a[g]=e<<1;return b|0}else{c[b+4>>2]=e;return b|0}return 0}function CS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b;g=a[f]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[b+4>>2]|0}if(i>>>0<d>>>0){CT(b,d-i|0,e)|0;return}if((g&1)==0){a[b+1+d|0]=0;a[f]=d<<1;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;return}}function CT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;if((d|0)==0){return b|0}f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}if((h-j|0)>>>0<d>>>0){CY(b,h,d-h+j|0,j,j,0,0);k=a[f]|0}else{k=i}if((k&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}Ke(l+j|0,e|0,d|0)|0;e=j+d|0;if((a[f]&1)==0){a[f]=e<<1}else{c[b+4>>2]=e}a[l+e|0]=0;return b|0}function CU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(d>>>0>4294967279>>>0){CJ(0)}e=b;f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}g=j>>>0>d>>>0?j:d;if(g>>>0<11>>>0){k=11}else{k=g+16&-16}g=k-1|0;if((g|0)==(h|0)){return}if((g|0)==10){l=e+1|0;m=c[b+8>>2]|0;n=1;o=0}else{do{if(g>>>0>h>>>0){p=J0(k)|0}else{d=(x=0,as(230,k|0)|0);if(!x){p=d;break}else{x=0}d=bQ(-1,-1,0)|0;bA(d|0)|0;aZ();return}}while(0);h=i&1;if(h<<24>>24==0){q=e+1|0}else{q=c[b+8>>2]|0}l=p;m=q;n=h<<24>>24!=0;o=1}h=i&255;if((h&1|0)==0){r=h>>>1}else{r=c[b+4>>2]|0}Kb(l|0,m|0,r+1|0)|0;if(n){J2(m)}if(o){c[b>>2]=k|1;c[b+4>>2]=j;c[b+8>>2]=l;return}else{a[f]=j<<1;return}}function CV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b;f=a[e]|0;if((f&1)==0){g=(f&255)>>>1;h=10}else{g=c[b+4>>2]|0;h=(c[b>>2]&-2)-1|0}if((g|0)==(h|0)){CY(b,h,1,h,h,0,0);i=a[e]|0}else{i=f}if((i&1)==0){a[e]=(g<<1)+2;j=b+1|0;k=g+1|0;l=j+g|0;a[l]=d;m=j+k|0;a[m]=0;return}else{e=c[b+8>>2]|0;i=g+1|0;c[b+4>>2]=i;j=e;k=i;l=j+g|0;a[l]=d;m=j+k|0;a[m]=0;return}}function CW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b;g=a[f]|0;if((g&1)==0){h=10;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}if((h-j|0)>>>0<e>>>0){CX(b,h,e-h+j|0,j,j,0,e,d);return b|0}if((e|0)==0){return b|0}if((i&1)==0){k=b+1|0}else{k=c[b+8>>2]|0}Kb(k+j|0,d|0,e)|0;d=j+e|0;if((a[f]&1)==0){a[f]=d<<1}else{c[b+4>>2]=d}a[k+d|0]=0;return b|0}function CX(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((-18-d|0)>>>0<e>>>0){CJ(0)}if((a[b]&1)==0){k=b+1|0}else{k=c[b+8>>2]|0}do{if(d>>>0<2147483623>>>0){l=e+d|0;m=d<<1;n=l>>>0<m>>>0?m:l;if(n>>>0<11>>>0){o=11;break}o=n+16&-16}else{o=-17}}while(0);e=J0(o)|0;if((g|0)!=0){Kb(e|0,k|0,g)|0}if((i|0)!=0){Kb(e+g|0,j|0,i)|0}j=f-h|0;if((j|0)!=(g|0)){Kb(e+(i+g)|0,k+(h+g)|0,j-g|0)|0}if((d|0)==10){p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+s|0;a[u]=0;return}J2(k);p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+s|0;a[u]=0;return}function CY(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((-17-d|0)>>>0<e>>>0){CJ(0)}if((a[b]&1)==0){j=b+1|0}else{j=c[b+8>>2]|0}do{if(d>>>0<2147483623>>>0){k=e+d|0;l=d<<1;m=k>>>0<l>>>0?l:k;if(m>>>0<11>>>0){n=11;break}n=m+16&-16}else{n=-17}}while(0);e=J0(n)|0;if((g|0)!=0){Kb(e|0,j|0,g)|0}m=f-h|0;if((m|0)!=(g|0)){Kb(e+(i+g)|0,j+(h+g)|0,m-g|0)|0}if((d|0)==10){o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}J2(j);o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}function CZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(e>>>0>1073741807>>>0){CJ(0)}if(e>>>0<2>>>0){a[b]=e<<1;f=b+4|0;g=Jx(f,d,e)|0;h=f+(e<<2)|0;c[h>>2]=0;return}else{i=e+4&-4;j=J0(i<<2)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=e;f=j;g=Jx(f,d,e)|0;h=f+(e<<2)|0;c[h>>2]=0;return}}function C_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(d>>>0>1073741807>>>0){CJ(0)}if(d>>>0<2>>>0){a[b]=d<<1;f=b+4|0;g=Jz(f,e,d)|0;h=f+(d<<2)|0;c[h>>2]=0;return}else{i=d+4&-4;j=J0(i<<2)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=d;f=j;g=Jz(f,e,d)|0;h=f+(d<<2)|0;c[h>>2]=0;return}}function C$(b){b=b|0;if((a[b]&1)==0){return}J2(c[b+8>>2]|0);return}function C0(a,b){a=a|0;b=b|0;return C1(a,b,Jw(b)|0)|0}function C1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b;g=a[f]|0;if((g&1)==0){h=1;i=g}else{g=c[b>>2]|0;h=(g&-2)-1|0;i=g&255}if(h>>>0<e>>>0){g=i&255;if((g&1|0)==0){j=g>>>1}else{j=c[b+4>>2]|0}C4(b,h,e-h|0,j,0,j,e,d);return b|0}if((i&1)==0){k=b+4|0}else{k=c[b+8>>2]|0}Jy(k,d,e)|0;c[k+(e<<2)>>2]=0;if((a[f]&1)==0){a[f]=e<<1;return b|0}else{c[b+4>>2]=e;return b|0}return 0}function C2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(d>>>0>1073741807>>>0){CJ(0)}e=b;f=a[e]|0;if((f&1)==0){g=1;h=f}else{f=c[b>>2]|0;g=(f&-2)-1|0;h=f&255}f=h&255;if((f&1|0)==0){i=f>>>1}else{i=c[b+4>>2]|0}f=i>>>0>d>>>0?i:d;if(f>>>0<2>>>0){j=2}else{j=f+4&-4}f=j-1|0;if((f|0)==(g|0)){return}if((f|0)==1){k=b+4|0;l=c[b+8>>2]|0;m=1;n=0}else{d=j<<2;do{if(f>>>0>g>>>0){o=J0(d)|0}else{p=(x=0,as(230,d|0)|0);if(!x){o=p;break}else{x=0}p=bQ(-1,-1,0)|0;bA(p|0)|0;aZ();return}}while(0);d=h&1;if(d<<24>>24==0){q=b+4|0}else{q=c[b+8>>2]|0}k=o;l=q;m=d<<24>>24!=0;n=1}d=k;k=h&255;if((k&1|0)==0){r=k>>>1}else{r=c[b+4>>2]|0}Jx(d,l,r+1|0)|0;if(m){J2(l)}if(n){c[b>>2]=j|1;c[b+4>>2]=i;c[b+8>>2]=d;return}else{a[e]=i<<1;return}}function C3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b;f=a[e]|0;if((f&1)==0){g=(f&255)>>>1;h=1}else{g=c[b+4>>2]|0;h=(c[b>>2]&-2)-1|0}if((g|0)==(h|0)){C5(b,h,1,h,h,0,0);i=a[e]|0}else{i=f}if((i&1)==0){a[e]=(g<<1)+2;j=b+4|0;k=g+1|0;l=j+(g<<2)|0;c[l>>2]=d;m=j+(k<<2)|0;c[m>>2]=0;return}else{e=c[b+8>>2]|0;i=g+1|0;c[b+4>>2]=i;j=e;k=i;l=j+(g<<2)|0;c[l>>2]=d;m=j+(k<<2)|0;c[m>>2]=0;return}}function C4(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((1073741806-d|0)>>>0<e>>>0){CJ(0)}if((a[b]&1)==0){k=b+4|0}else{k=c[b+8>>2]|0}do{if(d>>>0<536870887>>>0){l=e+d|0;m=d<<1;n=l>>>0<m>>>0?m:l;if(n>>>0<2>>>0){o=2;break}o=n+4&-4}else{o=1073741807}}while(0);e=J0(o<<2)|0;if((g|0)!=0){Jx(e,k,g)|0}if((i|0)!=0){Jx(e+(g<<2)|0,j,i)|0}j=f-h|0;if((j|0)!=(g|0)){Jx(e+(i+g<<2)|0,k+(h+g<<2)|0,j-g|0)|0}if((d|0)==1){p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+(s<<2)|0;c[u>>2]=0;return}J2(k);p=b+8|0;c[p>>2]=e;q=o|1;r=b|0;c[r>>2]=q;s=j+i|0;t=b+4|0;c[t>>2]=s;u=e+(s<<2)|0;c[u>>2]=0;return}function C5(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((1073741807-d|0)>>>0<e>>>0){CJ(0)}if((a[b]&1)==0){j=b+4|0}else{j=c[b+8>>2]|0}do{if(d>>>0<536870887>>>0){k=e+d|0;l=d<<1;m=k>>>0<l>>>0?l:k;if(m>>>0<2>>>0){n=2;break}n=m+4&-4}else{n=1073741807}}while(0);e=J0(n<<2)|0;if((g|0)!=0){Jx(e,j,g)|0}m=f-h|0;if((m|0)!=(g|0)){Jx(e+(i+g<<2)|0,j+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}J2(j);o=b+8|0;c[o>>2]=e;p=n|1;q=b|0;c[q>>2]=p;return}function C6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e|0;g=(c[b+24>>2]|0)==0;if(g){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((g&1|d)&c[b+20>>2]|0)==0){i=e;return}e=ci(16)|0;do{if((a[40848]|0)==0){if((bz(40848)|0)==0){break}c[9714]=14504;bk(180,38856,r|0)|0}}while(0);b=Kj(38856,0,32)|0;c[f>>2]=b&0|1;c[f+4>>2]=K|0;x=0;aP(418,e|0,f|0,9088);if(!x){c[e>>2]=13688;bH(e|0,28672,160)}else{x=0;f=bQ(-1,-1)|0;bl(e|0);be(f|0)}}function C7(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=13664;b=c[a+40>>2]|0;d=a+32|0;e=a+36|0;L1:do{if((b|0)!=0){f=b;while(1){f=f-1|0;x=0;aP(c[(c[d>>2]|0)+(f<<2)>>2]|0,0,a|0,c[(c[e>>2]|0)+(f<<2)>>2]|0);if(x){x=0;break}if((f|0)==0){break L1}}bQ(-1,-1,0)|0;bU()}}while(0);HC(a+28|0);JX(c[d>>2]|0);JX(c[e>>2]|0);JX(c[a+48>>2]|0);JX(c[a+60>>2]|0);return}function C8(a,b){a=a|0;b=b|0;HB(a,b+28|0);return}function C9(a,b){a=a|0;b=b|0;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;Ke(a+32|0,0,40)|0;if((b|0)==0){return}HA(b);return}function Da(a){a=a|0;c[a>>2]=14880;HC(a+4|0);J2(a);return}function Db(a){a=a|0;c[a>>2]=14880;HC(a+4|0);return}function Dc(a,b){a=a|0;b=b|0;return}function Dd(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function De(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function Df(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;b=d;d=i;i=i+16|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=a;c[b>>2]=0;c[b+4>>2]=0;b=a+8|0;c[b>>2]=-1;c[b+4>>2]=-1;i=e;return}function Dg(a){a=a|0;return 0}function Dh(a){a=a|0;return 0}function Di(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=b;if((e|0)<=0){g=0;return g|0}h=b+12|0;i=b+16|0;j=d;d=0;while(1){k=c[h>>2]|0;if(k>>>0<(c[i>>2]|0)>>>0){c[h>>2]=k+1;l=a[k]|0}else{k=cA[c[(c[f>>2]|0)+40>>2]&511](b)|0;if((k|0)==-1){g=d;m=9;break}l=k&255}a[j]=l;k=d+1|0;if((k|0)<(e|0)){j=j+1|0;d=k}else{g=k;m=10;break}}if((m|0)==9){return g|0}else if((m|0)==10){return g|0}return 0}function Dj(a){a=a|0;return-1|0}function Dk(a){a=a|0;var b=0,e=0;if((cA[c[(c[a>>2]|0)+36>>2]&511](a)|0)==-1){b=-1;return b|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+1;b=d[a]|0;return b|0}function Dl(a,b){a=a|0;b=b|0;return-1|0}function Dm(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=b;if((f|0)<=0){h=0;return h|0}i=b+24|0;j=b+28|0;k=0;l=e;while(1){e=c[i>>2]|0;if(e>>>0<(c[j>>2]|0)>>>0){m=a[l]|0;c[i>>2]=e+1;a[e]=m}else{if((cS[c[(c[g>>2]|0)+52>>2]&1023](b,d[l]|0)|0)==-1){h=k;n=10;break}}m=k+1|0;if((m|0)<(f|0)){k=m;l=l+1|0}else{h=m;n=9;break}}if((n|0)==9){return h|0}else if((n|0)==10){return h|0}return 0}function Dn(a,b){a=a|0;b=b|0;return-1|0}function Do(a){a=a|0;c[a>>2]=14808;HC(a+4|0);J2(a);return}function Dp(a){a=a|0;c[a>>2]=14808;HC(a+4|0);return}function Dq(a,b){a=a|0;b=b|0;return}function Dr(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function Ds(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function Dt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;b=d;d=i;i=i+16|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=a;c[b>>2]=0;c[b+4>>2]=0;b=a+8|0;c[b>>2]=-1;c[b+4>>2]=-1;i=e;return}function Du(a){a=a|0;return 0}function Dv(a){a=a|0;return 0}function Dw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a;if((d|0)<=0){f=0;return f|0}g=a+12|0;h=a+16|0;i=b;b=0;while(1){j=c[g>>2]|0;if(j>>>0<(c[h>>2]|0)>>>0){c[g>>2]=j+4;k=c[j>>2]|0}else{j=cA[c[(c[e>>2]|0)+40>>2]&511](a)|0;if((j|0)==-1){f=b;l=10;break}else{k=j}}c[i>>2]=k;j=b+1|0;if((j|0)<(d|0)){i=i+4|0;b=j}else{f=j;l=8;break}}if((l|0)==10){return f|0}else if((l|0)==8){return f|0}return 0}function Dx(a){a=a|0;return-1|0}function Dy(a){a=a|0;var b=0,d=0;if((cA[c[(c[a>>2]|0)+36>>2]&511](a)|0)==-1){b=-1;return b|0}d=a+12|0;a=c[d>>2]|0;c[d>>2]=a+4;b=c[a>>2]|0;return b|0}function Dz(a,b){a=a|0;b=b|0;return-1|0}function DA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a;if((d|0)<=0){f=0;return f|0}g=a+24|0;h=a+28|0;i=0;j=b;while(1){b=c[g>>2]|0;if(b>>>0<(c[h>>2]|0)>>>0){k=c[j>>2]|0;c[g>>2]=b+4;c[b>>2]=k}else{if((cS[c[(c[e>>2]|0)+52>>2]&1023](a,c[j>>2]|0)|0)==-1){f=i;l=10;break}}k=i+1|0;if((k|0)<(d|0)){i=k;j=j+4|0}else{f=k;l=9;break}}if((l|0)==9){return f|0}else if((l|0)==10){return f|0}return 0}function DB(a,b){a=a|0;b=b|0;return-1|0}function DC(a){a=a|0;C7(a+8|0);J2(a);return}function DD(a){a=a|0;C7(a+8|0);return}function DE(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;C7(b+(d+8)|0);J2(b+d|0);return}function DF(a){a=a|0;C7(a+((c[(c[a>>2]|0)-12>>2]|0)+8)|0);return}function DG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+8|0;e=d|0;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;if((c[h+(g+24)>>2]|0)==0){i=d;return b|0}j=e|0;a[j]=0;c[e+4>>2]=b;do{if((c[h+(g+16)>>2]|0)==0){k=c[h+(g+72)>>2]|0;do{if((k|0)==0){l=5}else{x=0,as(56,k|0)|0;if(!x){l=5;break}else{x=0}m=bQ(-1,-1,0)|0;n=m}}while(0);if((l|0)==5){a[j]=1;k=c[h+((c[(c[f>>2]|0)-12>>2]|0)+24)>>2]|0;m=(x=0,as(c[(c[k>>2]|0)+24>>2]|0,k|0)|0);if(!x){if((m|0)!=-1){break}m=c[(c[f>>2]|0)-12>>2]|0;x=0;aq(362,h+m|0,c[h+(m+16)>>2]|1|0);if(!x){break}else{x=0}}else{x=0}m=bQ(-1,-1,0)|0;DU(e);n=m}bA(n|0)|0;m=c[(c[f>>2]|0)-12>>2]|0;k=h+(m+16)|0;c[k>>2]=c[k>>2]|1;if((c[h+(m+20)>>2]&1|0)==0){aZ();i=d;return b|0}x=0;aQ(6);if(!x){return 0}else{x=0}m=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(m|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);DU(e);i=d;return b|0}function DH(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){return}else{bc()}}function DI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a+4|0;c[e>>2]=0;f=a;g=c[(c[f>>2]|0)-12>>2]|0;h=a;i=c[h+(g+16)>>2]|0;do{if((i|0)==0){j=c[h+(g+72)>>2]|0;if((j|0)==0){k=g}else{x=0,as(56,j|0)|0;if(x){x=0;break}k=c[(c[f>>2]|0)-12>>2]|0}if((c[h+(k+16)>>2]|0)!=0){l=k;m=16;break}j=c[h+(k+24)>>2]|0;n=(x=0,ax(c[(c[j>>2]|0)+32>>2]|0,j|0,b|0,d|0)|0);if(x){x=0;break}c[e>>2]=n;if((n|0)==(d|0)){return a|0}n=c[(c[f>>2]|0)-12>>2]|0;x=0;aq(362,h+n|0,c[h+(n+16)>>2]|6|0);if(x){x=0;break}return a|0}else{x=0;aq(362,h+g|0,i|4|0);if(x){x=0;break}l=c[(c[f>>2]|0)-12>>2]|0;m=16}}while(0);do{if((m|0)==16){x=0;aq(362,h+l|0,c[h+(l+16)>>2]|4|0);if(x){x=0;break}return a|0}}while(0);l=bQ(-1,-1,0)|0;bA(l|0)|0;l=c[(c[f>>2]|0)-12>>2]|0;f=h+(l+16)|0;c[f>>2]=c[f>>2]|1;if((c[h+(l+20)>>2]&1|0)==0){aZ();return a|0}x=0;aQ(6);if(!x){return 0}else{x=0}a=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(a|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function DJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d|0;f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;b=c[h+(g+16)>>2]|0;do{if((b|0)==0){j=c[h+(g+72)>>2]|0;if((j|0)==0){k=g}else{x=0,as(56,j|0)|0;if(x){x=0;break}k=c[(c[f>>2]|0)-12>>2]|0}if((c[h+(k+16)>>2]|0)!=0){i=d;return}j=c[h+(k+24)>>2]|0;x=0;aB(c[(c[j>>2]|0)+16>>2]|0,e|0,j|0,0,0,1,8);if(x){x=0;break}j=a;l=e;c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=d;return}else{x=0;aq(362,h+g|0,b|4|0);if(x){x=0;break}i=d;return}}while(0);b=bQ(-1,-1,0)|0;bA(b|0)|0;b=c[(c[f>>2]|0)-12>>2]|0;f=h+(b+16)|0;c[f>>2]=c[f>>2]|1;if((c[h+(b+20)>>2]&1|0)==0){aZ();i=d;return}x=0;aQ(6);if(x){x=0}d=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(d|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function DK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+16|0;g=f|0;h=a;j=c[(c[h>>2]|0)-12>>2]|0;k=a;l=c[k+(j+16)>>2]|0;do{if((l|0)==0){m=c[k+(j+72)>>2]|0;if((m|0)==0){n=j}else{x=0,as(56,m|0)|0;if(x){x=0;break}n=c[(c[h>>2]|0)-12>>2]|0}if((c[k+(n+16)>>2]|0)!=0){i=f;return a|0}m=c[k+(n+24)>>2]|0;x=0;aB(c[(c[m>>2]|0)+16>>2]|0,g|0,m|0,b|0,d|0,e|0,8);if(x){x=0;break}m=g+8|0;if(!((c[m>>2]|0)==(-1|0)&(c[m+4>>2]|0)==(-1|0))){i=f;return a|0}m=c[(c[h>>2]|0)-12>>2]|0;x=0;aq(362,k+m|0,c[k+(m+16)>>2]|4|0);if(x){x=0;break}i=f;return a|0}else{x=0;aq(362,k+j|0,l|4|0);if(x){x=0;break}i=f;return a|0}}while(0);l=bQ(-1,-1,0)|0;bA(l|0)|0;l=c[(c[h>>2]|0)-12>>2]|0;h=k+(l+16)|0;c[h>>2]=c[h>>2]|1;if((c[k+(l+20)>>2]&1|0)==0){aZ();i=f;return a|0}x=0;aQ(6);if(!x){return 0}else{x=0}a=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(a|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function DL(a){a=a|0;C7(a+8|0);J2(a);return}function DM(a){a=a|0;C7(a+8|0);return}function DN(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;C7(b+(d+8)|0);J2(b+d|0);return}function DO(a){a=a|0;C7(a+((c[(c[a>>2]|0)-12>>2]|0)+8)|0);return}function DP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+8|0;e=d|0;f=b;g=c[(c[f>>2]|0)-12>>2]|0;h=b;if((c[h+(g+24)>>2]|0)==0){i=d;return b|0}j=e|0;a[j]=0;c[e+4>>2]=b;do{if((c[h+(g+16)>>2]|0)==0){k=c[h+(g+72)>>2]|0;do{if((k|0)==0){l=5}else{x=0,as(156,k|0)|0;if(!x){l=5;break}else{x=0}m=bQ(-1,-1,0)|0;n=m}}while(0);if((l|0)==5){a[j]=1;k=c[h+((c[(c[f>>2]|0)-12>>2]|0)+24)>>2]|0;m=(x=0,as(c[(c[k>>2]|0)+24>>2]|0,k|0)|0);if(!x){if((m|0)!=-1){break}m=c[(c[f>>2]|0)-12>>2]|0;x=0;aq(362,h+m|0,c[h+(m+16)>>2]|1|0);if(!x){break}else{x=0}}else{x=0}m=bQ(-1,-1,0)|0;D1(e);n=m}bA(n|0)|0;m=c[(c[f>>2]|0)-12>>2]|0;k=h+(m+16)|0;c[k>>2]=c[k>>2]|1;if((c[h+(m+20)>>2]&1|0)==0){aZ();i=d;return b|0}x=0;aQ(6);if(!x){return 0}else{x=0}m=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(m|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);D1(e);i=d;return b|0}function DQ(a){a=a|0;C7(a+4|0);J2(a);return}function DR(a){a=a|0;C7(a+4|0);return}function DS(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;C7(b+(d+4)|0);J2(b+d|0);return}function DT(a){a=a|0;C7(a+((c[(c[a>>2]|0)-12>>2]|0)+4)|0);return}function DU(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+4|0;a=c[b>>2]|0;d=c[(c[a>>2]|0)-12>>2]|0;e=a;if((c[e+(d+24)>>2]|0)==0){return}if((c[e+(d+16)>>2]|0)!=0){return}if((c[e+(d+4)>>2]&8192|0)==0){return}if(bD()|0){return}d=c[b>>2]|0;e=c[d+((c[(c[d>>2]|0)-12>>2]|0)+24)>>2]|0;d=(x=0,as(c[(c[e>>2]|0)+24>>2]|0,e|0)|0);do{if(!x){if((d|0)!=-1){return}e=c[b>>2]|0;a=c[(c[e>>2]|0)-12>>2]|0;f=e;x=0;aq(362,f+a|0,c[f+(a+16)>>2]|1|0);if(x){x=0;break}return}else{x=0}}while(0);b=bQ(-1,-1,0)|0;bA(b|0)|0;x=0;aQ(2);if(!x){return}else{x=0;bQ(-1,-1,0)|0;bU()}}function DV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=h|0;a[l]=0;c[h+4>>2]=b;m=b;n=c[(c[m>>2]|0)-12>>2]|0;o=b;do{if((c[o+(n+16)>>2]|0)==0){p=c[o+(n+72)>>2]|0;do{if((p|0)==0){q=4}else{x=0,as(56,p|0)|0;if(!x){q=4;break}else{x=0}r=bQ(-1,-1,0)|0;s=r}}while(0);if((q|0)==4){a[l]=1;HB(j,o+((c[(c[m>>2]|0)-12>>2]|0)+28)|0);p=(x=0,aK(196,j|0,39928)|0);if(!x){r=p;HC(j);t=c[(c[m>>2]|0)-12>>2]|0;u=c[o+(t+24)>>2]|0;v=o+t|0;w=o+(t+76)|0;y=c[w>>2]|0;z=y&255;L10:do{if((y|0)==-1){HB(g,o+(t+28)|0);A=(x=0,aK(196,g|0,40280)|0);do{if(!x){B=(x=0,aK(c[(c[A>>2]|0)+28>>2]|0,A|0,32)|0);if(x){x=0;break}HC(g);c[w>>2]=B<<24>>24;C=B;q=10;break L10}else{x=0}}while(0);A=bQ(-1,-1,0)|0;B=K;HC(g);D=B;E=A}else{C=z;q=10}}while(0);if((q|0)==10){z=c[(c[p>>2]|0)+24>>2]|0;c[f>>2]=u;x=0;aB(z|0,k|0,r|0,f|0,v|0,C|0,d|0);if(!x){if((c[k>>2]|0)!=0){break}z=c[(c[m>>2]|0)-12>>2]|0;x=0;aq(362,o+z|0,c[o+(z+16)>>2]|5|0);if(!x){break}else{x=0}}else{x=0}z=bQ(-1,-1,0)|0;D=K;E=z}F=E}else{x=0;z=bQ(-1,-1,0)|0;HC(j);F=z}DU(h);s=F}bA(s|0)|0;z=c[(c[m>>2]|0)-12>>2]|0;w=o+(z+16)|0;c[w>>2]=c[w>>2]|1;if((c[o+(z+20)>>2]&1|0)==0){aZ();i=e;return b|0}x=0;aQ(6);if(!x){return 0}else{x=0}z=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(z|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);DU(h);i=e;return b|0}function DW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=h|0;a[l]=0;c[h+4>>2]=b;m=b;n=c[(c[m>>2]|0)-12>>2]|0;o=b;do{if((c[o+(n+16)>>2]|0)==0){p=c[o+(n+72)>>2]|0;do{if((p|0)==0){q=4}else{x=0,as(56,p|0)|0;if(!x){q=4;break}else{x=0}r=bQ(-1,-1,0)|0;s=r}}while(0);if((q|0)==4){a[l]=1;HB(j,o+((c[(c[m>>2]|0)-12>>2]|0)+28)|0);p=(x=0,aK(196,j|0,39928)|0);if(!x){r=p;HC(j);t=c[(c[m>>2]|0)-12>>2]|0;u=c[o+(t+24)>>2]|0;v=o+t|0;w=o+(t+76)|0;y=c[w>>2]|0;z=y&255;L10:do{if((y|0)==-1){HB(g,o+(t+28)|0);A=(x=0,aK(196,g|0,40280)|0);do{if(!x){B=(x=0,aK(c[(c[A>>2]|0)+28>>2]|0,A|0,32)|0);if(x){x=0;break}HC(g);c[w>>2]=B<<24>>24;C=B;q=10;break L10}else{x=0}}while(0);A=bQ(-1,-1,0)|0;B=K;HC(g);D=B;E=A}else{C=z;q=10}}while(0);if((q|0)==10){z=c[(c[p>>2]|0)+24>>2]|0;c[f>>2]=u;x=0;aB(z|0,k|0,r|0,f|0,v|0,C|0,d|0);if(!x){if((c[k>>2]|0)!=0){break}z=c[(c[m>>2]|0)-12>>2]|0;x=0;aq(362,o+z|0,c[o+(z+16)>>2]|5|0);if(!x){break}else{x=0}}else{x=0}z=bQ(-1,-1,0)|0;D=K;E=z}F=E}else{x=0;z=bQ(-1,-1,0)|0;HC(j);F=z}DU(h);s=F}bA(s|0)|0;z=c[(c[m>>2]|0)-12>>2]|0;w=o+(z+16)|0;c[w>>2]=c[w>>2]|1;if((c[o+(z+20)>>2]&1|0)==0){aZ();i=e;return b|0}x=0;aQ(6);if(!x){return 0}else{x=0}z=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(z|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);DU(h);i=e;return b|0}function DX(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=h|0;a[l]=0;c[h+4>>2]=b;m=b;n=c[(c[m>>2]|0)-12>>2]|0;o=b;do{if((c[o+(n+16)>>2]|0)==0){p=c[o+(n+72)>>2]|0;do{if((p|0)==0){q=4}else{x=0,as(56,p|0)|0;if(!x){q=4;break}else{x=0}r=bQ(-1,-1,0)|0;s=r}}while(0);if((q|0)==4){a[l]=1;HB(j,o+((c[(c[m>>2]|0)-12>>2]|0)+28)|0);p=(x=0,aK(196,j|0,39928)|0);if(!x){r=p;HC(j);t=c[(c[m>>2]|0)-12>>2]|0;u=c[o+(t+24)>>2]|0;v=o+t|0;w=o+(t+76)|0;y=c[w>>2]|0;z=y&255;L10:do{if((y|0)==-1){HB(g,o+(t+28)|0);A=(x=0,aK(196,g|0,40280)|0);do{if(!x){B=(x=0,aK(c[(c[A>>2]|0)+28>>2]|0,A|0,32)|0);if(x){x=0;break}HC(g);c[w>>2]=B<<24>>24;C=B;q=10;break L10}else{x=0}}while(0);A=bQ(-1,-1,0)|0;B=K;HC(g);D=B;E=A}else{C=z;q=10}}while(0);if((q|0)==10){z=c[(c[p>>2]|0)+32>>2]|0;c[f>>2]=u;x=0;az(z|0,k|0,r|0,f|0,v|0,C|0,+d);if(!x){if((c[k>>2]|0)!=0){break}z=c[(c[m>>2]|0)-12>>2]|0;x=0;aq(362,o+z|0,c[o+(z+16)>>2]|5|0);if(!x){break}else{x=0}}else{x=0}z=bQ(-1,-1,0)|0;D=K;E=z}F=E}else{x=0;z=bQ(-1,-1,0)|0;HC(j);F=z}DU(h);s=F}bA(s|0)|0;z=c[(c[m>>2]|0)-12>>2]|0;w=o+(z+16)|0;c[w>>2]=c[w>>2]|1;if((c[o+(z+20)>>2]&1|0)==0){aZ();i=e;return b|0}x=0;aQ(6);if(!x){return 0}else{x=0}z=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(z|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);DU(h);i=e;return b|0}function DY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e|0;g=f|0;a[g]=0;c[f+4>>2]=b;h=b;j=c[(c[h>>2]|0)-12>>2]|0;k=b;do{if((c[k+(j+16)>>2]|0)==0){l=c[k+(j+72)>>2]|0;do{if((l|0)==0){m=4}else{x=0,as(56,l|0)|0;if(!x){m=4;break}else{x=0}n=bQ(-1,-1,0)|0;o=n}}while(0);if((m|0)==4){a[g]=1;l=c[k+((c[(c[h>>2]|0)-12>>2]|0)+24)>>2]|0;n=l;do{if((l|0)==0){p=n;m=9}else{q=l+24|0;r=c[q>>2]|0;if((r|0)==(c[l+28>>2]|0)){s=(x=0,aK(c[(c[l>>2]|0)+52>>2]|0,n|0,d&255|0)|0);if(!x){t=s}else{x=0;break}}else{c[q>>2]=r+1;a[r]=d;t=d&255}p=(t|0)==-1?0:n;m=9}}while(0);if((m|0)==9){if((p|0)!=0){break}n=c[(c[h>>2]|0)-12>>2]|0;x=0;aq(362,k+n|0,c[k+(n+16)>>2]|1|0);if(!x){break}else{x=0}}n=bQ(-1,-1,0)|0;DU(f);o=n}bA(o|0)|0;n=c[(c[h>>2]|0)-12>>2]|0;l=k+(n+16)|0;c[l>>2]=c[l>>2]|1;if((c[k+(n+20)>>2]&1|0)==0){aZ();i=e;return b|0}x=0;aQ(6);if(!x){return 0}else{x=0}n=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(n|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);DU(f);i=e;return b|0}function DZ(a){a=a|0;C7(a+4|0);J2(a);return}function D_(a){a=a|0;C7(a+4|0);return}function D$(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;C7(b+(d+4)|0);J2(b+d|0);return}function D0(a){a=a|0;C7(a+((c[(c[a>>2]|0)-12>>2]|0)+4)|0);return}function D1(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+4|0;a=c[b>>2]|0;d=c[(c[a>>2]|0)-12>>2]|0;e=a;if((c[e+(d+24)>>2]|0)==0){return}if((c[e+(d+16)>>2]|0)!=0){return}if((c[e+(d+4)>>2]&8192|0)==0){return}if(bD()|0){return}d=c[b>>2]|0;e=c[d+((c[(c[d>>2]|0)-12>>2]|0)+24)>>2]|0;d=(x=0,as(c[(c[e>>2]|0)+24>>2]|0,e|0)|0);do{if(!x){if((d|0)!=-1){return}e=c[b>>2]|0;a=c[(c[e>>2]|0)-12>>2]|0;f=e;x=0;aq(362,f+a|0,c[f+(a+16)>>2]|1|0);if(x){x=0;break}return}else{x=0}}while(0);b=bQ(-1,-1,0)|0;bA(b|0)|0;x=0;aQ(2);if(!x){return}else{x=0;bQ(-1,-1,0)|0;bU()}}function D2(a){a=a|0;return 10480}function D3(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)==1){CM(a,11472,35);return}else{CD(a,b|0,c);return}}function D4(a){a=a|0;Cz(a|0);return}function D5(a){a=a|0;CH(a|0);J2(a);return}function D6(a){a=a|0;CH(a|0);return}function D7(a){a=a|0;C7(a);J2(a);return}function D8(a){a=a|0;Cz(a|0);J2(a);return}function D9(a){a=a|0;Cl(a|0);J2(a);return}function Ea(a){a=a|0;Cl(a|0);return}function Eb(a){a=a|0;Cl(a|0);return}function Ec(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;L1:do{if((e|0)==(f|0)){g=c}else{b=c;h=e;while(1){if((b|0)==(d|0)){i=-1;j=11;break}k=a[b]|0;l=a[h]|0;if(k<<24>>24<l<<24>>24){i=-1;j=9;break}if(l<<24>>24<k<<24>>24){i=1;j=10;break}k=b+1|0;l=h+1|0;if((l|0)==(f|0)){g=k;break L1}else{b=k;h=l}}if((j|0)==11){return i|0}else if((j|0)==10){return i|0}else if((j|0)==9){return i|0}}}while(0);i=(g|0)!=(d|0)|0;return i|0}function Ed(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;d=e;g=f-d|0;if(g>>>0>4294967279>>>0){CJ(b)}if(g>>>0<11>>>0){a[b]=g<<1;h=b+1|0}else{i=g+16&-16;j=J0(i)|0;c[b+8>>2]=j;c[b>>2]=i|1;c[b+4>>2]=g;h=j}if((e|0)==(f|0)){k=h;a[k]=0;return}j=f+(-d|0)|0;d=h;g=e;while(1){a[d]=a[g]|0;e=g+1|0;if((e|0)==(f|0)){break}else{d=d+1|0;g=e}}k=h+j|0;a[k]=0;return}function Ee(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;if((c|0)==(d|0)){e=0;return e|0}else{f=c;g=0}while(1){c=(a[f]|0)+(g<<4)|0;b=c&-268435456;h=(b>>>24|b)^c;c=f+1|0;if((c|0)==(d|0)){e=h;break}else{f=c;g=h}}return e|0}function Ef(a){a=a|0;Cl(a|0);J2(a);return}function Eg(a){a=a|0;Cl(a|0);return}function Eh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;L1:do{if((e|0)==(f|0)){g=b}else{a=b;h=e;while(1){if((a|0)==(d|0)){i=-1;j=9;break}k=c[a>>2]|0;l=c[h>>2]|0;if((k|0)<(l|0)){i=-1;j=8;break}if((l|0)<(k|0)){i=1;j=10;break}k=a+4|0;l=h+4|0;if((l|0)==(f|0)){g=k;break L1}else{a=k;h=l}}if((j|0)==8){return i|0}else if((j|0)==9){return i|0}else if((j|0)==10){return i|0}}}while(0);i=(g|0)!=(d|0)|0;return i|0}function Ei(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;d=e;g=f-d|0;h=g>>2;if(h>>>0>1073741807>>>0){CJ(b)}if(h>>>0<2>>>0){a[b]=g>>>1;i=b+4|0}else{g=h+4&-4;j=J0(g<<2)|0;c[b+8>>2]=j;c[b>>2]=g|1;c[b+4>>2]=h;i=j}if((e|0)==(f|0)){k=i;c[k>>2]=0;return}j=(f-4+(-d|0)|0)>>>2;d=i;h=e;while(1){c[d>>2]=c[h>>2];e=h+4|0;if((e|0)==(f|0)){break}else{d=d+4|0;h=e}}k=i+(j+1<<2)|0;c[k>>2]=0;return}function Ej(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((b|0)==(d|0)){e=0;return e|0}else{f=b;g=0}while(1){b=(c[f>>2]|0)+(g<<4)|0;a=b&-268435456;h=(a>>>24|a)^b;b=f+4|0;if((b|0)==(d|0)){e=h;break}else{f=b;g=h}}return e|0}function Ek(a){a=a|0;Cl(a|0);J2(a);return}function El(a){a=a|0;Cl(a|0);return}function Em(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;k=i;i=i+112|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+40|0;p=k+48|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+104|0;if((c[g+4>>2]&1|0)==0){c[n>>2]=-1;v=c[(c[d>>2]|0)+16>>2]|0;w=e|0;c[p>>2]=c[w>>2];c[q>>2]=c[f>>2];cO[v&127](o,d,p,q,g,h,n);q=c[o>>2]|0;c[w>>2]=q;w=c[n>>2]|0;if((w|0)==0){a[j]=0}else if((w|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=q;i=k;return}C8(r,g);q=r|0;r=c[q>>2]|0;if((c[10070]|0)==-1){y=9}else{c[m>>2]=40280;c[m+4>>2]=454;c[m+8>>2]=0;x=0;aP(2,40280,m|0,512);if(!x){y=9}else{x=0}}do{if((y|0)==9){m=(c[10071]|0)-1|0;w=c[r+8>>2]|0;do{if((c[r+12>>2]|0)-w>>2>>>0>m>>>0){n=c[w+(m<<2)>>2]|0;if((n|0)==0){break}o=n;Cn(c[q>>2]|0)|0;C8(s,g);n=s|0;p=c[n>>2]|0;if((c[9974]|0)==-1){y=15}else{c[l>>2]=39896;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,39896,l|0,512);if(!x){y=15}else{x=0}}do{if((y|0)==15){d=(c[9975]|0)-1|0;v=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-v>>2>>>0>d>>>0){z=c[v+(d<<2)>>2]|0;if((z|0)==0){break}A=z;Cn(c[n>>2]|0)|0;B=t|0;C=z;x=0;aq(c[(c[C>>2]|0)+24>>2]|0,B|0,A|0);do{if(!x){z=t+12|0;x=0;aq(c[(c[C>>2]|0)+28>>2]|0,z|0,A|0);if(x){x=0;D=z;break}c[u>>2]=c[f>>2];z=(x=0,am(4,e|0,u|0,B|0,t+24|0,o|0,h|0,1)|0);if(!x){a[j]=(z|0)==(B|0)|0;c[b>>2]=c[e>>2];CP(t+12|0);CP(t|0);i=k;return}else{x=0;z=bQ(-1,-1)|0;E=K;CP(t+12|0);CP(t|0);F=z;G=E;H=F;I=0;J=H;L=G;be(J|0)}}else{x=0;D=B}}while(0);A=bQ(-1,-1)|0;C=A;A=K;if((B|0)==(D|0)){F=C;G=A;H=F;I=0;J=H;L=G;be(J|0)}else{M=D}while(1){E=M-12|0;CP(E);if((E|0)==(B|0)){F=C;G=A;break}else{M=E}}H=F;I=0;J=H;L=G;be(J|0)}}while(0);d=ci(4)|0;JB(d);x=0;aP(144,d|0,28080,98);if(x){x=0;break}}}while(0);o=bQ(-1,-1)|0;p=K;Cn(c[n>>2]|0)|0;F=o;G=p;H=F;I=0;J=H;L=G;be(J|0)}}while(0);m=ci(4)|0;JB(m);x=0;aP(144,m|0,28080,98);if(x){x=0;break}}}while(0);M=bQ(-1,-1)|0;D=K;Cn(c[q>>2]|0)|0;F=M;G=D;H=F;I=0;J=H;L=G;be(J|0)}function En(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;l=i;i=i+104|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=(g-f|0)/12|0;n=l|0;do{if(m>>>0>100>>>0){o=JW(m)|0;if((o|0)!=0){p=o;q=o;break}x=0;aQ(4);if(!x){p=0;q=0;break}else{x=0}o=bQ(-1,-1)|0;r=K;s=o;be(s|0)}else{p=n;q=0}}while(0);n=(f|0)==(g|0);if(n){t=m;u=0}else{o=m;m=0;v=p;w=f;while(1){y=d[w]|0;if((y&1|0)==0){z=y>>>1}else{z=c[w+4>>2]|0}if((z|0)==0){a[v]=2;A=m+1|0;B=o-1|0}else{a[v]=1;A=m;B=o}y=w+12|0;if((y|0)==(g|0)){t=B;u=A;break}else{o=B;m=A;v=v+1|0;w=y}}}w=b|0;b=e|0;e=h;v=0;A=u;u=t;L19:while(1){t=c[w>>2]|0;do{if((t|0)==0){C=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){C=t;break}m=(x=0,as(c[(c[t>>2]|0)+36>>2]|0,t|0)|0);if(x){x=0;D=6;break L19}if((m|0)==-1){c[w>>2]=0;C=0;break}else{C=c[w>>2]|0;break}}}while(0);t=(C|0)==0;m=c[b>>2]|0;if((m|0)==0){E=C;F=0}else{do{if((c[m+12>>2]|0)==(c[m+16>>2]|0)){B=(x=0,as(c[(c[m>>2]|0)+36>>2]|0,m|0)|0);if(x){x=0;D=6;break L19}if((B|0)!=-1){G=m;break}c[b>>2]=0;G=0}else{G=m}}while(0);E=c[w>>2]|0;F=G}H=(F|0)==0;if(!((t^H)&(u|0)!=0)){D=81;break}m=c[E+12>>2]|0;if((m|0)==(c[E+16>>2]|0)){B=(x=0,as(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(x){x=0;D=6;break}I=B&255}else{I=a[m]|0}if(k){J=I}else{m=(x=0,aK(c[(c[e>>2]|0)+12>>2]|0,h|0,I|0)|0);if(!x){J=m}else{x=0;D=6;break}}do{if(n){L=A;M=u}else{m=v+1|0;L48:do{if(k){B=u;o=A;z=p;y=0;N=f;while(1){do{if((a[z]|0)==1){O=N;if((a[O]&1)==0){P=N+1|0}else{P=c[N+8>>2]|0}if(J<<24>>24!=(a[P+v|0]|0)){a[z]=0;Q=y;R=o;S=B-1|0;break}T=d[O]|0;if((T&1|0)==0){U=T>>>1}else{U=c[N+4>>2]|0}if((U|0)!=(m|0)){Q=1;R=o;S=B;break}a[z]=2;Q=1;R=o+1|0;S=B-1|0}else{Q=y;R=o;S=B}}while(0);T=N+12|0;if((T|0)==(g|0)){V=S;W=R;X=Q;break L48}B=S;o=R;z=z+1|0;y=Q;N=T}}else{N=u;y=A;z=p;o=0;B=f;while(1){do{if((a[z]|0)==1){T=B;if((a[T]&1)==0){Y=B+1|0}else{Y=c[B+8>>2]|0}O=(x=0,aK(c[(c[e>>2]|0)+12>>2]|0,h|0,a[Y+v|0]|0)|0);if(x){x=0;D=5;break L19}if(J<<24>>24!=O<<24>>24){a[z]=0;Z=o;_=y;$=N-1|0;break}O=d[T]|0;if((O&1|0)==0){aa=O>>>1}else{aa=c[B+4>>2]|0}if((aa|0)!=(m|0)){Z=1;_=y;$=N;break}a[z]=2;Z=1;_=y+1|0;$=N-1|0}else{Z=o;_=y;$=N}}while(0);O=B+12|0;if((O|0)==(g|0)){V=$;W=_;X=Z;break L48}N=$;y=_;z=z+1|0;o=Z;B=O}}}while(0);if(!X){L=W;M=V;break}m=c[w>>2]|0;B=m+12|0;o=c[B>>2]|0;if((o|0)==(c[m+16>>2]|0)){z=c[(c[m>>2]|0)+40>>2]|0;x=0,as(z|0,m|0)|0;if(x){x=0;D=6;break L19}}else{c[B>>2]=o+1}if((W+V|0)>>>0<2>>>0|n){L=W;M=V;break}o=v+1|0;B=W;m=p;z=f;while(1){do{if((a[m]|0)==2){y=d[z]|0;if((y&1|0)==0){ab=y>>>1}else{ab=c[z+4>>2]|0}if((ab|0)==(o|0)){ac=B;break}a[m]=0;ac=B-1|0}else{ac=B}}while(0);y=z+12|0;if((y|0)==(g|0)){L=ac;M=V;break}else{B=ac;m=m+1|0;z=y}}}}while(0);v=v+1|0;A=L;u=M}if((D|0)==6){M=bQ(-1,-1)|0;ad=K;ae=M}else if((D|0)==81){do{if((E|0)==0){af=0;D=87}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){af=E;D=87;break}M=(x=0,as(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(x){x=0;break}if((M|0)==-1){c[w>>2]=0;af=0;D=87;break}else{af=c[w>>2]|0;D=87;break}}}while(0);L114:do{if((D|0)==87){w=(af|0)==0;do{if(H){D=93}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(w){break}else{D=95;break}}E=(x=0,as(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(x){x=0;break L114}if((E|0)==-1){c[b>>2]=0;D=93;break}else{if(w^(F|0)==0){break}else{D=95;break}}}}while(0);if((D|0)==93){if(w){D=95}}if((D|0)==95){c[j>>2]=c[j>>2]|2}L130:do{if(n){D=100}else{E=f;M=p;while(1){if((a[M]|0)==2){ag=E;break L130}u=E+12|0;if((u|0)==(g|0)){D=100;break L130}E=u;M=M+1|0}}}while(0);if((D|0)==100){c[j>>2]=c[j>>2]|4;ag=g}if((q|0)==0){i=l;return ag|0}JX(q);i=l;return ag|0}}while(0);ag=bQ(-1,-1)|0;ad=K;ae=ag}else if((D|0)==5){D=bQ(-1,-1)|0;ad=K;ae=D}if((q|0)==0){r=ad;s=ae;be(s|0)}JX(q);r=ad;s=ae;be(s|0);return 0}function Eo(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Ep(a,0,j,k,f,g,h);i=b;return}function Ep(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==8){v=16}else if((u|0)==64){v=8}else if((u|0)==0){v=0}else{v=10}u=l|0;E5(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(x){x=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);L=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(L){M=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(x){x=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(L^R){M=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(L){O=F;P=0;Q=1;break}else{M=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}x=0;aP(80,o|0,S<<1|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,U|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){V=y}else{V=c[z>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((EH(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=M;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;x=0,as(X|0,H|0)|0;if(!x){F=W;G=H;continue}else{x=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bQ(-1,-1)|0;_=K;$=G;CP(o);CP(n);be($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(38,O|0,c[q>>2]|0,j|0,v|0)|0);if(x){x=0;break}c[k>>2]=F;G_(n,l,c[s>>2]|0,j);do{if(L){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}F=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;break L6}if((F|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(x=0,as(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(x){x=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;_=K;$=e;CP(o);CP(n);be($|0)}function Eq(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Er(a,0,j,k,f,g,h);i=b;return}function Er(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;E5(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(x){x=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);L=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(L){M=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(x){x=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(L^R){M=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(L){O=F;P=0;Q=1;break}else{M=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}x=0;aP(80,o|0,S<<1|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,U|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){V=y}else{V=c[z>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((EH(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=M;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;x=0,as(X|0,H|0)|0;if(!x){F=W;G=H;continue}else{x=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bQ(-1,-1)|0;_=K;$=G;CP(o);CP(n);be($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(4,O|0,c[q>>2]|0,j|0,v|0)|0);G=K;if(x){x=0;break}c[k>>2]=F;c[k+4>>2]=G;G_(n,l,c[s>>2]|0,j);do{if(L){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}G=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;break L6}if((G|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(x=0,as(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(x){x=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;_=K;$=e;CP(o);CP(n);be($|0)}function Es(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Et(a,0,j,k,f,g,h);i=b;return}function Et(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;f=i;i=i+72|0;m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=f|0;n=f+32|0;o=f+40|0;p=f+56|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=c[j+4>>2]&74;if((v|0)==8){w=16}else if((v|0)==64){w=8}else if((v|0)==0){w=0}else{w=10}v=m|0;E5(o,j,v,n);Ke(q|0,0,12)|0;j=p;x=0;aP(80,p|0,10,0);L6:do{if(!x){if((a[q]&1)==0){m=j+1|0;y=m;z=m;A=p+8|0}else{m=p+8|0;y=c[m>>2]|0;z=j+1|0;A=m}c[r>>2]=y;m=s|0;c[t>>2]=m;c[u>>2]=0;B=g|0;C=h|0;D=p|0;E=p+4|0;F=a[n]|0;G=y;H=c[B>>2]|0;L12:while(1){do{if((H|0)==0){I=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){I=H;break}J=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;L=34;break L12}if((J|0)!=-1){I=H;break}c[B>>2]=0;I=0}}while(0);M=(I|0)==0;J=c[C>>2]|0;do{if((J|0)==0){L=21}else{if((c[J+12>>2]|0)!=(c[J+16>>2]|0)){if(M){N=J;O=0;break}else{P=G;Q=J;R=0;break L12}}S=(x=0,as(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(x){x=0;L=34;break L12}if((S|0)==-1){c[C>>2]=0;L=21;break}else{S=(J|0)==0;if(M^S){N=J;O=S;break}else{P=G;Q=J;R=S;break L12}}}}while(0);if((L|0)==21){L=0;if(M){P=G;Q=0;R=1;break}else{N=0;O=1}}J=d[q]|0;S=(J&1|0)==0;if(((c[r>>2]|0)-G|0)==((S?J>>>1:c[E>>2]|0)|0)){if(S){T=J>>>1;U=J>>>1}else{J=c[E>>2]|0;T=J;U=J}x=0;aP(80,p|0,T<<1|0,0);if(x){x=0;L=34;break}if((a[q]&1)==0){V=10}else{V=(c[D>>2]&-2)-1|0}x=0;aP(80,p|0,V|0,0);if(x){x=0;L=34;break}if((a[q]&1)==0){W=z}else{W=c[A>>2]|0}c[r>>2]=W+U;X=W}else{X=G}J=I+12|0;S=c[J>>2]|0;Y=I+16|0;if((S|0)==(c[Y>>2]|0)){Z=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(x){x=0;L=34;break}_=Z&255}else{_=a[S]|0}if((EH(_,w,X,r,u,F,o,m,t,v)|0)!=0){P=X;Q=N;R=O;break}S=c[J>>2]|0;if((S|0)==(c[Y>>2]|0)){Y=c[(c[I>>2]|0)+40>>2]|0;x=0,as(Y|0,I|0)|0;if(!x){G=X;H=I;continue}else{x=0;L=34;break}}else{c[J>>2]=S+1;G=X;H=I;continue}}if((L|0)==34){H=bQ(-1,-1)|0;$=K;aa=H;CP(p);CP(o);be(aa|0)}H=d[o]|0;if((H&1|0)==0){ab=H>>>1}else{ab=c[o+4>>2]|0}do{if((ab|0)!=0){H=c[t>>2]|0;if((H-s|0)>=160){break}G=c[u>>2]|0;c[t>>2]=H+4;c[H>>2]=G}}while(0);G=(x=0,aS(6,P|0,c[r>>2]|0,k|0,w|0)|0);if(x){x=0;break}b[l>>1]=G;G_(o,m,c[t>>2]|0,k);do{if(M){ac=0}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){ac=I;break}G=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(x){x=0;break L6}if((G|0)!=-1){ac=I;break}c[B>>2]=0;ac=0}}while(0);B=(ac|0)==0;L75:do{if(R){L=62}else{do{if((c[Q+12>>2]|0)==(c[Q+16>>2]|0)){m=(x=0,as(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(x){x=0;break L6}if((m|0)!=-1){break}c[C>>2]=0;L=62;break L75}}while(0);if(!(B^(Q|0)==0)){break}ad=e|0;c[ad>>2]=ac;CP(p);CP(o);i=f;return}}while(0);do{if((L|0)==62){if(B){break}ad=e|0;c[ad>>2]=ac;CP(p);CP(o);i=f;return}}while(0);c[k>>2]=c[k>>2]|2;ad=e|0;c[ad>>2]=ac;CP(p);CP(o);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;$=K;aa=f;CP(p);CP(o);be(aa|0)}function Eu(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Ev(a,0,j,k,f,g,h);i=b;return}function Ev(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;E5(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(x){x=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);L=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(L){M=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(x){x=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(L^R){M=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(L){O=F;P=0;Q=1;break}else{M=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}x=0;aP(80,o|0,S<<1|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,U|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){V=y}else{V=c[z>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((EH(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=M;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;x=0,as(X|0,H|0)|0;if(!x){F=W;G=H;continue}else{x=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bQ(-1,-1)|0;_=K;$=G;CP(o);CP(n);be($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(2,O|0,c[q>>2]|0,j|0,v|0)|0);if(x){x=0;break}c[k>>2]=F;G_(n,l,c[s>>2]|0,j);do{if(L){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}F=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;break L6}if((F|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(x=0,as(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(x){x=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;_=K;$=e;CP(o);CP(n);be($|0)}function Ew(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Ex(a,0,j,k,f,g,h);i=b;return}function Ex(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==8){v=16}else if((u|0)==64){v=8}else if((u|0)==0){v=0}else{v=10}u=l|0;E5(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(x){x=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);L=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(L){M=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(x){x=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(L^R){M=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(L){O=F;P=0;Q=1;break}else{M=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}x=0;aP(80,o|0,S<<1|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,U|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){V=y}else{V=c[z>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((EH(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=M;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;x=0,as(X|0,H|0)|0;if(!x){F=W;G=H;continue}else{x=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bQ(-1,-1)|0;_=K;$=G;CP(o);CP(n);be($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(28,O|0,c[q>>2]|0,j|0,v|0)|0);if(x){x=0;break}c[k>>2]=F;G_(n,l,c[s>>2]|0,j);do{if(L){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}F=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;break L6}if((F|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(x=0,as(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(x){x=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;_=K;$=e;CP(o);CP(n);be($|0)}function Ey(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];Ez(a,0,j,k,f,g,h);i=b;return}function Ez(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+72|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+32|0;n=e+40|0;o=e+56|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==64){v=8}else if((u|0)==0){v=0}else if((u|0)==8){v=16}else{v=10}u=l|0;E5(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=a[m]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{if((c[G+12>>2]|0)!=(c[G+16>>2]|0)){H=G;break}I=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(x){x=0;J=34;break L12}if((I|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);L=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){J=21}else{if((c[I+12>>2]|0)!=(c[I+16>>2]|0)){if(L){M=I;N=0;break}else{O=F;P=I;Q=0;break L12}}R=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(x){x=0;J=34;break L12}if((R|0)==-1){c[B>>2]=0;J=21;break}else{R=(I|0)==0;if(L^R){M=I;N=R;break}else{O=F;P=I;Q=R;break L12}}}}while(0);if((J|0)==21){J=0;if(L){O=F;P=0;Q=1;break}else{M=0;N=1}}I=d[p]|0;R=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((R?I>>>1:c[D>>2]|0)|0)){if(R){S=I>>>1;T=I>>>1}else{I=c[D>>2]|0;S=I;T=I}x=0;aP(80,o|0,S<<1|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){U=10}else{U=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,U|0,0);if(x){x=0;J=34;break}if((a[p]&1)==0){V=y}else{V=c[z>>2]|0}c[q>>2]=V+T;W=V}else{W=F}I=H+12|0;R=c[I>>2]|0;X=H+16|0;if((R|0)==(c[X>>2]|0)){Y=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;J=34;break}Z=Y&255}else{Z=a[R]|0}if((EH(Z,v,W,q,t,E,n,l,s,u)|0)!=0){O=W;P=M;Q=N;break}R=c[I>>2]|0;if((R|0)==(c[X>>2]|0)){X=c[(c[H>>2]|0)+40>>2]|0;x=0,as(X|0,H|0)|0;if(!x){F=W;G=H;continue}else{x=0;J=34;break}}else{c[I>>2]=R+1;F=W;G=H;continue}}if((J|0)==34){G=bQ(-1,-1)|0;_=K;$=G;CP(o);CP(n);be($|0)}G=d[n]|0;if((G&1|0)==0){aa=G>>>1}else{aa=c[n+4>>2]|0}do{if((aa|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(22,O|0,c[q>>2]|0,j|0,v|0)|0);G=K;if(x){x=0;break}c[k>>2]=F;c[k+4>>2]=G;G_(n,l,c[s>>2]|0,j);do{if(L){ab=0}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){ab=H;break}G=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(x){x=0;break L6}if((G|0)!=-1){ab=H;break}c[A>>2]=0;ab=0}}while(0);A=(ab|0)==0;L75:do{if(Q){J=62}else{do{if((c[P+12>>2]|0)==(c[P+16>>2]|0)){l=(x=0,as(c[(c[P>>2]|0)+36>>2]|0,P|0)|0);if(x){x=0;break L6}if((l|0)!=-1){break}c[B>>2]=0;J=62;break L75}}while(0);if(!(A^(P|0)==0)){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);do{if((J|0)==62){if(A){break}ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ac=b|0;c[ac>>2]=ab;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;_=K;$=e;CP(o);CP(n);be($|0)}function EA(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];EB(a,0,j,k,f,g,h);i=b;return}function EB(b,e,f,h,j,k,l){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0.0,ag=0,ah=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;y=e|0;E6(o,j,y,m,n);Ke(q|0,0,12)|0;j=p;x=0;aP(80,p|0,10,0);L1:do{if(!x){if((a[q]&1)==0){z=j+1|0;A=z;B=z;C=p+8|0}else{z=p+8|0;A=c[z>>2]|0;B=j+1|0;C=z}c[r>>2]=A;z=s|0;c[t>>2]=z;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=h|0;F=p|0;G=p+4|0;H=a[m]|0;I=a[n]|0;J=A;L=c[D>>2]|0;L7:while(1){do{if((L|0)==0){M=0}else{if((c[L+12>>2]|0)!=(c[L+16>>2]|0)){M=L;break}N=(x=0,as(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(x){x=0;O=30;break L7}if((N|0)!=-1){M=L;break}c[D>>2]=0;M=0}}while(0);P=(M|0)==0;N=c[E>>2]|0;do{if((N|0)==0){O=17}else{if((c[N+12>>2]|0)!=(c[N+16>>2]|0)){if(P){Q=N;R=0;break}else{S=J;T=N;U=0;break L7}}V=(x=0,as(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(x){x=0;O=30;break L7}if((V|0)==-1){c[E>>2]=0;O=17;break}else{V=(N|0)==0;if(P^V){Q=N;R=V;break}else{S=J;T=N;U=V;break L7}}}}while(0);if((O|0)==17){O=0;if(P){S=J;T=0;U=1;break}else{Q=0;R=1}}N=d[q]|0;V=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((V?N>>>1:c[G>>2]|0)|0)){if(V){W=N>>>1;X=N>>>1}else{N=c[G>>2]|0;W=N;X=N}x=0;aP(80,p|0,W<<1|0,0);if(x){x=0;O=30;break}if((a[q]&1)==0){Y=10}else{Y=(c[F>>2]&-2)-1|0}x=0;aP(80,p|0,Y|0,0);if(x){x=0;O=30;break}if((a[q]&1)==0){Z=B}else{Z=c[C>>2]|0}c[r>>2]=Z+X;_=Z}else{_=J}N=M+12|0;V=c[N>>2]|0;$=M+16|0;if((V|0)==(c[$>>2]|0)){aa=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(x){x=0;O=30;break}ab=aa&255}else{ab=a[V]|0}if((E7(ab,v,w,_,r,H,I,o,z,t,u,y)|0)!=0){S=_;T=Q;U=R;break}V=c[N>>2]|0;if((V|0)==(c[$>>2]|0)){$=c[(c[M>>2]|0)+40>>2]|0;x=0,as($|0,M|0)|0;if(!x){J=_;L=M;continue}else{x=0;O=30;break}}else{c[N>>2]=V+1;J=_;L=M;continue}}if((O|0)==30){L=bQ(-1,-1)|0;ac=K;ad=L;CP(p);CP(o);be(ad|0)}L=d[o]|0;if((L&1|0)==0){ae=L>>>1}else{ae=c[o+4>>2]|0}do{if((ae|0)!=0){if((a[v]&1)==0){break}L=c[t>>2]|0;if((L-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=L+4;c[L>>2]=J}}while(0);af=(x=0,+(+aD(2,S|0,c[r>>2]|0,k|0)));if(x){x=0;break}g[l>>2]=af;G_(o,z,c[t>>2]|0,k);do{if(P){ag=0}else{if((c[M+12>>2]|0)!=(c[M+16>>2]|0)){ag=M;break}J=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(x){x=0;break L1}if((J|0)!=-1){ag=M;break}c[D>>2]=0;ag=0}}while(0);D=(ag|0)==0;L71:do{if(U){O=59}else{do{if((c[T+12>>2]|0)==(c[T+16>>2]|0)){z=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(x){x=0;break L1}if((z|0)!=-1){break}c[E>>2]=0;O=59;break L71}}while(0);if(!(D^(T|0)==0)){break}ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}}while(0);do{if((O|0)==59){if(D){break}ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;ac=K;ad=e;CP(p);CP(o);be(ad|0)}function EC(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];ED(a,0,j,k,f,g,h);i=b;return}function ED(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0.0,ag=0,ah=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;y=e|0;E6(o,j,y,m,n);Ke(q|0,0,12)|0;j=p;x=0;aP(80,p|0,10,0);L1:do{if(!x){if((a[q]&1)==0){z=j+1|0;A=z;B=z;C=p+8|0}else{z=p+8|0;A=c[z>>2]|0;B=j+1|0;C=z}c[r>>2]=A;z=s|0;c[t>>2]=z;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=g|0;F=p|0;G=p+4|0;H=a[m]|0;I=a[n]|0;J=A;L=c[D>>2]|0;L7:while(1){do{if((L|0)==0){M=0}else{if((c[L+12>>2]|0)!=(c[L+16>>2]|0)){M=L;break}N=(x=0,as(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(x){x=0;O=30;break L7}if((N|0)!=-1){M=L;break}c[D>>2]=0;M=0}}while(0);P=(M|0)==0;N=c[E>>2]|0;do{if((N|0)==0){O=17}else{if((c[N+12>>2]|0)!=(c[N+16>>2]|0)){if(P){Q=N;R=0;break}else{S=J;T=N;U=0;break L7}}V=(x=0,as(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(x){x=0;O=30;break L7}if((V|0)==-1){c[E>>2]=0;O=17;break}else{V=(N|0)==0;if(P^V){Q=N;R=V;break}else{S=J;T=N;U=V;break L7}}}}while(0);if((O|0)==17){O=0;if(P){S=J;T=0;U=1;break}else{Q=0;R=1}}N=d[q]|0;V=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((V?N>>>1:c[G>>2]|0)|0)){if(V){W=N>>>1;X=N>>>1}else{N=c[G>>2]|0;W=N;X=N}x=0;aP(80,p|0,W<<1|0,0);if(x){x=0;O=30;break}if((a[q]&1)==0){Y=10}else{Y=(c[F>>2]&-2)-1|0}x=0;aP(80,p|0,Y|0,0);if(x){x=0;O=30;break}if((a[q]&1)==0){Z=B}else{Z=c[C>>2]|0}c[r>>2]=Z+X;_=Z}else{_=J}N=M+12|0;V=c[N>>2]|0;$=M+16|0;if((V|0)==(c[$>>2]|0)){aa=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(x){x=0;O=30;break}ab=aa&255}else{ab=a[V]|0}if((E7(ab,v,w,_,r,H,I,o,z,t,u,y)|0)!=0){S=_;T=Q;U=R;break}V=c[N>>2]|0;if((V|0)==(c[$>>2]|0)){$=c[(c[M>>2]|0)+40>>2]|0;x=0,as($|0,M|0)|0;if(!x){J=_;L=M;continue}else{x=0;O=30;break}}else{c[N>>2]=V+1;J=_;L=M;continue}}if((O|0)==30){L=bQ(-1,-1)|0;ac=K;ad=L;CP(p);CP(o);be(ad|0)}L=d[o]|0;if((L&1|0)==0){ae=L>>>1}else{ae=c[o+4>>2]|0}do{if((ae|0)!=0){if((a[v]&1)==0){break}L=c[t>>2]|0;if((L-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=L+4;c[L>>2]=J}}while(0);af=(x=0,+(+aL(4,S|0,c[r>>2]|0,k|0)));if(x){x=0;break}h[l>>3]=af;G_(o,z,c[t>>2]|0,k);do{if(P){ag=0}else{if((c[M+12>>2]|0)!=(c[M+16>>2]|0)){ag=M;break}J=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(x){x=0;break L1}if((J|0)!=-1){ag=M;break}c[D>>2]=0;ag=0}}while(0);D=(ag|0)==0;L71:do{if(U){O=59}else{do{if((c[T+12>>2]|0)==(c[T+16>>2]|0)){z=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(x){x=0;break L1}if((z|0)!=-1){break}c[E>>2]=0;O=59;break L71}}while(0);if(!(D^(T|0)==0)){break}ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}}while(0);do{if((O|0)==59){if(D){break}ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;ac=K;ad=e;CP(p);CP(o);be(ad|0)}function EE(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];EF(a,0,j,k,f,g,h);i=b;return}function EF(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0.0,ag=0,ah=0;e=i;i=i+80|0;m=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[m>>2];m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=e+32|0;n=e+40|0;o=e+48|0;p=e+64|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=i;i=i+1|0;i=i+7&-8;w=i;i=i+1|0;i=i+7&-8;y=e|0;E6(o,j,y,m,n);Ke(q|0,0,12)|0;j=p;x=0;aP(80,p|0,10,0);L1:do{if(!x){if((a[q]&1)==0){z=j+1|0;A=z;B=z;C=p+8|0}else{z=p+8|0;A=c[z>>2]|0;B=j+1|0;C=z}c[r>>2]=A;z=s|0;c[t>>2]=z;c[u>>2]=0;a[v]=1;a[w]=69;D=f|0;E=g|0;F=p|0;G=p+4|0;H=a[m]|0;I=a[n]|0;J=A;L=c[D>>2]|0;L7:while(1){do{if((L|0)==0){M=0}else{if((c[L+12>>2]|0)!=(c[L+16>>2]|0)){M=L;break}N=(x=0,as(c[(c[L>>2]|0)+36>>2]|0,L|0)|0);if(x){x=0;O=30;break L7}if((N|0)!=-1){M=L;break}c[D>>2]=0;M=0}}while(0);P=(M|0)==0;N=c[E>>2]|0;do{if((N|0)==0){O=17}else{if((c[N+12>>2]|0)!=(c[N+16>>2]|0)){if(P){Q=N;R=0;break}else{S=J;T=N;U=0;break L7}}V=(x=0,as(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(x){x=0;O=30;break L7}if((V|0)==-1){c[E>>2]=0;O=17;break}else{V=(N|0)==0;if(P^V){Q=N;R=V;break}else{S=J;T=N;U=V;break L7}}}}while(0);if((O|0)==17){O=0;if(P){S=J;T=0;U=1;break}else{Q=0;R=1}}N=d[q]|0;V=(N&1|0)==0;if(((c[r>>2]|0)-J|0)==((V?N>>>1:c[G>>2]|0)|0)){if(V){W=N>>>1;X=N>>>1}else{N=c[G>>2]|0;W=N;X=N}x=0;aP(80,p|0,W<<1|0,0);if(x){x=0;O=30;break}if((a[q]&1)==0){Y=10}else{Y=(c[F>>2]&-2)-1|0}x=0;aP(80,p|0,Y|0,0);if(x){x=0;O=30;break}if((a[q]&1)==0){Z=B}else{Z=c[C>>2]|0}c[r>>2]=Z+X;_=Z}else{_=J}N=M+12|0;V=c[N>>2]|0;$=M+16|0;if((V|0)==(c[$>>2]|0)){aa=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(x){x=0;O=30;break}ab=aa&255}else{ab=a[V]|0}if((E7(ab,v,w,_,r,H,I,o,z,t,u,y)|0)!=0){S=_;T=Q;U=R;break}V=c[N>>2]|0;if((V|0)==(c[$>>2]|0)){$=c[(c[M>>2]|0)+40>>2]|0;x=0,as($|0,M|0)|0;if(!x){J=_;L=M;continue}else{x=0;O=30;break}}else{c[N>>2]=V+1;J=_;L=M;continue}}if((O|0)==30){L=bQ(-1,-1)|0;ac=K;ad=L;CP(p);CP(o);be(ad|0)}L=d[o]|0;if((L&1|0)==0){ae=L>>>1}else{ae=c[o+4>>2]|0}do{if((ae|0)!=0){if((a[v]&1)==0){break}L=c[t>>2]|0;if((L-s|0)>=160){break}J=c[u>>2]|0;c[t>>2]=L+4;c[L>>2]=J}}while(0);af=(x=0,+(+aL(2,S|0,c[r>>2]|0,k|0)));if(x){x=0;break}h[l>>3]=af;G_(o,z,c[t>>2]|0,k);do{if(P){ag=0}else{if((c[M+12>>2]|0)!=(c[M+16>>2]|0)){ag=M;break}J=(x=0,as(c[(c[M>>2]|0)+36>>2]|0,M|0)|0);if(x){x=0;break L1}if((J|0)!=-1){ag=M;break}c[D>>2]=0;ag=0}}while(0);D=(ag|0)==0;L71:do{if(U){O=59}else{do{if((c[T+12>>2]|0)==(c[T+16>>2]|0)){z=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(x){x=0;break L1}if((z|0)!=-1){break}c[E>>2]=0;O=59;break L71}}while(0);if(!(D^(T|0)==0)){break}ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}}while(0);do{if((O|0)==59){if(D){break}ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}}while(0);c[k>>2]=c[k>>2]|2;ah=b|0;c[ah>>2]=ag;CP(p);CP(o);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;ac=K;ad=e;CP(p);CP(o);be(ad|0)}function EG(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0;e=i;i=i+64|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+16|0;n=e+48|0;o=i;i=i+4|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;Ke(n|0,0,12)|0;u=p;x=0;aq(346,o|0,h|0);if(x){x=0;h=bQ(-1,-1)|0;v=K;w=h;CP(n);y=w;z=0;A=y;B=v;be(A|0)}h=o|0;o=c[h>>2]|0;if((c[10070]|0)==-1){C=4}else{c[l>>2]=40280;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,40280,l|0,512);if(!x){C=4}else{x=0}}L7:do{if((C|0)==4){l=(c[10071]|0)-1|0;D=c[o+8>>2]|0;do{if((c[o+12>>2]|0)-D>>2>>>0>l>>>0){E=c[D+(l<<2)>>2]|0;if((E|0)==0){break}F=E;G=m|0;H=c[(c[E>>2]|0)+32>>2]|0;x=0,aS(H|0,F|0,31280,31306,G|0)|0;if(x){x=0;break L7}Cn(c[h>>2]|0)|0;Ke(u|0,0,12)|0;F=p;x=0;aP(80,p|0,10,0);L13:do{if(!x){if((a[u]&1)==0){H=F+1|0;I=H;J=H;L=p+8|0}else{H=p+8|0;I=c[H>>2]|0;J=F+1|0;L=H}c[q>>2]=I;H=r|0;c[s>>2]=H;c[t>>2]=0;E=f|0;M=g|0;N=p|0;O=p+4|0;P=I;Q=c[E>>2]|0;L19:while(1){do{if((Q|0)==0){R=0}else{if((c[Q+12>>2]|0)!=(c[Q+16>>2]|0)){R=Q;break}S=(x=0,as(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(x){x=0;C=40;break L19}if((S|0)!=-1){R=Q;break}c[E>>2]=0;R=0}}while(0);S=(R|0)==0;T=c[M>>2]|0;do{if((T|0)==0){C=25}else{if((c[T+12>>2]|0)!=(c[T+16>>2]|0)){if(S){break}else{U=P;break L19}}V=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(x){x=0;C=40;break L19}if((V|0)==-1){c[M>>2]=0;C=25;break}else{if(S^(T|0)==0){break}else{U=P;break L19}}}}while(0);if((C|0)==25){C=0;if(S){U=P;break}}T=d[u]|0;V=(T&1|0)==0;if(((c[q>>2]|0)-P|0)==((V?T>>>1:c[O>>2]|0)|0)){if(V){W=T>>>1;X=T>>>1}else{T=c[O>>2]|0;W=T;X=T}x=0;aP(80,p|0,W<<1|0,0);if(x){x=0;C=40;break}if((a[u]&1)==0){Y=10}else{Y=(c[N>>2]&-2)-1|0}x=0;aP(80,p|0,Y|0,0);if(x){x=0;C=40;break}if((a[u]&1)==0){Z=J}else{Z=c[L>>2]|0}c[q>>2]=Z+X;_=Z}else{_=P}T=R+12|0;V=c[T>>2]|0;$=R+16|0;if((V|0)==(c[$>>2]|0)){aa=(x=0,as(c[(c[R>>2]|0)+36>>2]|0,R|0)|0);if(x){x=0;C=40;break}ab=aa&255}else{ab=a[V]|0}if((EH(ab,16,_,q,t,0,n,H,s,G)|0)!=0){U=_;break}V=c[T>>2]|0;if((V|0)==(c[$>>2]|0)){$=c[(c[R>>2]|0)+40>>2]|0;x=0,as($|0,R|0)|0;if(!x){P=_;Q=R;continue}else{x=0;C=40;break}}else{c[T>>2]=V+1;P=_;Q=R;continue}}if((C|0)==40){Q=bQ(-1,-1)|0;ac=K;ad=Q;break}a[U+3|0]=0;do{if((a[40840]|0)==0){if((bz(40840)|0)==0){break}Q=(x=0,ax(48,2147483647,9592,0)|0);if(!x){c[9712]=Q;break}else{x=0;Q=bQ(-1,-1)|0;ac=K;ad=Q;break L13}}}while(0);Q=(x=0,aS(18,U|0,c[9712]|0,8032,(P=i,i=i+8|0,c[P>>2]=k,P)|0)|0);i=P;if(x){x=0;C=41;break}if((Q|0)!=1){c[j>>2]=4}Q=c[E>>2]|0;do{if((Q|0)==0){ae=0}else{if((c[Q+12>>2]|0)!=(c[Q+16>>2]|0)){ae=Q;break}P=(x=0,as(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(x){x=0;C=41;break L13}if((P|0)!=-1){ae=Q;break}c[E>>2]=0;ae=0}}while(0);E=(ae|0)==0;Q=c[M>>2]|0;do{if((Q|0)==0){C=70}else{if((c[Q+12>>2]|0)!=(c[Q+16>>2]|0)){if(!E){break}af=b|0;c[af>>2]=ae;CP(p);CP(n);i=e;return}P=(x=0,as(c[(c[Q>>2]|0)+36>>2]|0,Q|0)|0);if(x){x=0;C=41;break L13}if((P|0)==-1){c[M>>2]=0;C=70;break}if(!(E^(Q|0)==0)){break}af=b|0;c[af>>2]=ae;CP(p);CP(n);i=e;return}}while(0);do{if((C|0)==70){if(E){break}af=b|0;c[af>>2]=ae;CP(p);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;af=b|0;c[af>>2]=ae;CP(p);CP(n);i=e;return}else{x=0;C=41}}while(0);if((C|0)==41){G=bQ(-1,-1)|0;ac=K;ad=G}CP(p);v=ac;w=ad;CP(n);y=w;z=0;A=y;B=v;be(A|0)}}while(0);l=ci(4)|0;JB(l);x=0;aP(144,l|0,28080,98);if(x){x=0;break}}}while(0);ad=bQ(-1,-1)|0;ac=K;Cn(c[h>>2]|0)|0;v=ac;w=ad;CP(n);y=w;z=0;A=y;B=v;be(A|0)}function EH(b,e,f,g,h,i,j,k,l,m){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=c[g>>2]|0;o=(n|0)==(f|0);do{if(o){p=(a[m+24|0]|0)==b<<24>>24;if(!p){if((a[m+25|0]|0)!=b<<24>>24){break}}c[g>>2]=f+1;a[f]=p?43:45;c[h>>2]=0;q=0;return q|0}}while(0);p=d[j]|0;if((p&1|0)==0){r=p>>>1}else{r=c[j+4>>2]|0}if((r|0)!=0&b<<24>>24==i<<24>>24){i=c[l>>2]|0;if((i-k|0)>=160){q=0;return q|0}k=c[h>>2]|0;c[l>>2]=i+4;c[i>>2]=k;c[h>>2]=0;q=0;return q|0}k=m+26|0;i=m;while(1){if((i|0)==(k|0)){s=k;break}if((a[i]|0)==b<<24>>24){s=i;break}else{i=i+1|0}}i=s-m|0;if((i|0)>23){q=-1;return q|0}do{if((e|0)==8|(e|0)==10){if((i|0)<(e|0)){break}else{q=-1}return q|0}else if((e|0)==16){if((i|0)<22){break}if(o){q=-1;return q|0}if((n-f|0)>=3){q=-1;return q|0}if((a[n-1|0]|0)!=48){q=-1;return q|0}c[h>>2]=0;m=a[31280+i|0]|0;s=c[g>>2]|0;c[g>>2]=s+1;a[s]=m;q=0;return q|0}}while(0);f=a[31280+i|0]|0;c[g>>2]=n+1;a[n]=f;c[h>>2]=(c[h>>2]|0)+1;q=0;return q|0}function EI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f|0;h=g;c[h>>2]=e;c[h+4>>2]=0;h=b3(b|0)|0;b=bg(a|0,d|0,g|0)|0;if((h|0)==0){i=f;return b|0}x=0,as(32,h|0)|0;if(!x){i=f;return b|0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function EJ(a){a=a|0;Cl(a|0);J2(a);return}function EK(a){a=a|0;Cl(a|0);return}function EL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;k=i;i=i+112|0;l=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[l>>2];l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+40|0;p=k+48|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+104|0;if((c[g+4>>2]&1|0)==0){c[n>>2]=-1;v=c[(c[d>>2]|0)+16>>2]|0;w=e|0;c[p>>2]=c[w>>2];c[q>>2]=c[f>>2];cO[v&127](o,d,p,q,g,h,n);q=c[o>>2]|0;c[w>>2]=q;w=c[n>>2]|0;if((w|0)==0){a[j]=0}else if((w|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=q;i=k;return}C8(r,g);q=r|0;r=c[q>>2]|0;if((c[10068]|0)==-1){y=9}else{c[m>>2]=40272;c[m+4>>2]=454;c[m+8>>2]=0;x=0;aP(2,40272,m|0,512);if(!x){y=9}else{x=0}}do{if((y|0)==9){m=(c[10069]|0)-1|0;w=c[r+8>>2]|0;do{if((c[r+12>>2]|0)-w>>2>>>0>m>>>0){n=c[w+(m<<2)>>2]|0;if((n|0)==0){break}o=n;Cn(c[q>>2]|0)|0;C8(s,g);n=s|0;p=c[n>>2]|0;if((c[9972]|0)==-1){y=15}else{c[l>>2]=39888;c[l+4>>2]=454;c[l+8>>2]=0;x=0;aP(2,39888,l|0,512);if(!x){y=15}else{x=0}}do{if((y|0)==15){d=(c[9973]|0)-1|0;v=c[p+8>>2]|0;do{if((c[p+12>>2]|0)-v>>2>>>0>d>>>0){z=c[v+(d<<2)>>2]|0;if((z|0)==0){break}A=z;Cn(c[n>>2]|0)|0;B=t|0;C=z;x=0;aq(c[(c[C>>2]|0)+24>>2]|0,B|0,A|0);do{if(!x){z=t+12|0;x=0;aq(c[(c[C>>2]|0)+28>>2]|0,z|0,A|0);if(x){x=0;D=z;break}c[u>>2]=c[f>>2];z=(x=0,am(2,e|0,u|0,B|0,t+24|0,o|0,h|0,1)|0);if(!x){a[j]=(z|0)==(B|0)|0;c[b>>2]=c[e>>2];C$(t+12|0);C$(t|0);i=k;return}else{x=0;z=bQ(-1,-1)|0;E=K;C$(t+12|0);C$(t|0);F=z;G=E;H=F;I=0;J=H;L=G;be(J|0)}}else{x=0;D=B}}while(0);A=bQ(-1,-1)|0;C=A;A=K;if((B|0)==(D|0)){F=C;G=A;H=F;I=0;J=H;L=G;be(J|0)}else{M=D}while(1){E=M-12|0;C$(E);if((E|0)==(B|0)){F=C;G=A;break}else{M=E}}H=F;I=0;J=H;L=G;be(J|0)}}while(0);d=ci(4)|0;JB(d);x=0;aP(144,d|0,28080,98);if(x){x=0;break}}}while(0);o=bQ(-1,-1)|0;p=K;Cn(c[n>>2]|0)|0;F=o;G=p;H=F;I=0;J=H;L=G;be(J|0)}}while(0);m=ci(4)|0;JB(m);x=0;aP(144,m|0,28080,98);if(x){x=0;break}}}while(0);M=bQ(-1,-1)|0;D=K;Cn(c[q>>2]|0)|0;F=M;G=D;H=F;I=0;J=H;L=G;be(J|0)}function EM(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;l=i;i=i+104|0;m=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[m>>2];m=(g-f|0)/12|0;n=l|0;do{if(m>>>0>100>>>0){o=JW(m)|0;if((o|0)!=0){p=o;q=o;break}x=0;aQ(4);if(!x){p=0;q=0;break}else{x=0}o=bQ(-1,-1)|0;r=K;s=o;be(s|0)}else{p=n;q=0}}while(0);n=(f|0)==(g|0);if(n){t=m;u=0}else{o=m;m=0;v=p;w=f;while(1){y=d[w]|0;if((y&1|0)==0){z=y>>>1}else{z=c[w+4>>2]|0}if((z|0)==0){a[v]=2;A=m+1|0;B=o-1|0}else{a[v]=1;A=m;B=o}y=w+12|0;if((y|0)==(g|0)){t=B;u=A;break}else{o=B;m=A;v=v+1|0;w=y}}}w=b|0;b=e|0;e=h;v=0;A=u;u=t;L19:while(1){t=c[w>>2]|0;do{if((t|0)==0){C=0}else{m=c[t+12>>2]|0;if((m|0)==(c[t+16>>2]|0)){B=(x=0,as(c[(c[t>>2]|0)+36>>2]|0,t|0)|0);if(!x){D=B}else{x=0;E=6;break L19}}else{D=c[m>>2]|0}if((D|0)==-1){c[w>>2]=0;C=0;break}else{C=c[w>>2]|0;break}}}while(0);t=(C|0)==0;m=c[b>>2]|0;if((m|0)==0){F=C;G=0}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){o=(x=0,as(c[(c[m>>2]|0)+36>>2]|0,m|0)|0);if(!x){H=o}else{x=0;E=6;break}}else{H=c[B>>2]|0}if((H|0)==-1){c[b>>2]=0;I=0}else{I=m}F=c[w>>2]|0;G=I}J=(G|0)==0;if(!((t^J)&(u|0)!=0)){E=82;break}t=c[F+12>>2]|0;if((t|0)==(c[F+16>>2]|0)){m=(x=0,as(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(!x){L=m}else{x=0;E=6;break}}else{L=c[t>>2]|0}if(k){M=L}else{t=(x=0,aK(c[(c[e>>2]|0)+28>>2]|0,h|0,L|0)|0);if(!x){M=t}else{x=0;E=6;break}}do{if(n){N=A;O=u}else{t=v+1|0;L51:do{if(k){m=u;B=A;o=p;z=0;y=f;while(1){do{if((a[o]|0)==1){P=y;if((a[P]&1)==0){Q=y+4|0}else{Q=c[y+8>>2]|0}if((M|0)!=(c[Q+(v<<2)>>2]|0)){a[o]=0;R=z;S=B;T=m-1|0;break}U=d[P]|0;if((U&1|0)==0){V=U>>>1}else{V=c[y+4>>2]|0}if((V|0)!=(t|0)){R=1;S=B;T=m;break}a[o]=2;R=1;S=B+1|0;T=m-1|0}else{R=z;S=B;T=m}}while(0);U=y+12|0;if((U|0)==(g|0)){W=T;X=S;Y=R;break L51}m=T;B=S;o=o+1|0;z=R;y=U}}else{y=u;z=A;o=p;B=0;m=f;while(1){do{if((a[o]|0)==1){U=m;if((a[U]&1)==0){Z=m+4|0}else{Z=c[m+8>>2]|0}P=(x=0,aK(c[(c[e>>2]|0)+28>>2]|0,h|0,c[Z+(v<<2)>>2]|0)|0);if(x){x=0;E=5;break L19}if((M|0)!=(P|0)){a[o]=0;_=B;$=z;aa=y-1|0;break}P=d[U]|0;if((P&1|0)==0){ab=P>>>1}else{ab=c[m+4>>2]|0}if((ab|0)!=(t|0)){_=1;$=z;aa=y;break}a[o]=2;_=1;$=z+1|0;aa=y-1|0}else{_=B;$=z;aa=y}}while(0);P=m+12|0;if((P|0)==(g|0)){W=aa;X=$;Y=_;break L51}y=aa;z=$;o=o+1|0;B=_;m=P}}}while(0);if(!Y){N=X;O=W;break}t=c[w>>2]|0;m=t+12|0;B=c[m>>2]|0;if((B|0)==(c[t+16>>2]|0)){o=c[(c[t>>2]|0)+40>>2]|0;x=0,as(o|0,t|0)|0;if(x){x=0;E=6;break L19}}else{c[m>>2]=B+4}if((X+W|0)>>>0<2>>>0|n){N=X;O=W;break}B=v+1|0;m=X;t=p;o=f;while(1){do{if((a[t]|0)==2){z=d[o]|0;if((z&1|0)==0){ac=z>>>1}else{ac=c[o+4>>2]|0}if((ac|0)==(B|0)){ad=m;break}a[t]=0;ad=m-1|0}else{ad=m}}while(0);z=o+12|0;if((z|0)==(g|0)){N=ad;O=W;break}else{m=ad;t=t+1|0;o=z}}}}while(0);v=v+1|0;A=N;u=O}if((E|0)==6){O=bQ(-1,-1)|0;ae=K;af=O}else if((E|0)==5){O=bQ(-1,-1)|0;ae=K;af=O}else if((E|0)==82){do{if((F|0)==0){ag=1;E=89}else{O=c[F+12>>2]|0;if((O|0)==(c[F+16>>2]|0)){u=(x=0,as(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(!x){ah=u}else{x=0;break}}else{ah=c[O>>2]|0}if((ah|0)==-1){c[w>>2]=0;ag=1;E=89;break}else{ag=(c[w>>2]|0)==0;E=89;break}}}while(0);L120:do{if((E|0)==89){do{if(J){E=95}else{w=c[G+12>>2]|0;if((w|0)==(c[G+16>>2]|0)){ah=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!x){ai=ah}else{x=0;break L120}}else{ai=c[w>>2]|0}if((ai|0)==-1){c[b>>2]=0;E=95;break}else{if(ag^(G|0)==0){break}else{E=97;break}}}}while(0);if((E|0)==95){if(ag){E=97}}if((E|0)==97){c[j>>2]=c[j>>2]|2}L136:do{if(n){E=102}else{w=f;ah=p;while(1){if((a[ah]|0)==2){aj=w;break L136}F=w+12|0;if((F|0)==(g|0)){E=102;break L136}w=F;ah=ah+1|0}}}while(0);if((E|0)==102){c[j>>2]=c[j>>2]|4;aj=g}if((q|0)==0){i=l;return aj|0}JX(q);i=l;return aj|0}}while(0);aj=bQ(-1,-1)|0;ae=K;af=aj}if((q|0)==0){r=ae;s=af;be(s|0)}JX(q);r=ae;s=af;be(s|0);return 0}function EN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];EO(a,0,j,k,f,g,h);i=b;return}function EO(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==8){v=16}else if((u|0)==0){v=0}else if((u|0)==64){v=8}else{v=10}u=l|0;E8(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!x){L=J}else{x=0;M=35;break L12}}else{L=c[I>>2]|0}if((L|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){M=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!x){P=O}else{x=0;M=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;M=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((M|0)==22){M=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}x=0;aP(80,o|0,V<<1|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,X|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){Y=y}else{Y=c[z>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){$=_}else{x=0;M=35;break}}else{$=c[J>>2]|0}if((E4($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;x=0,as(O|0,H|0)|0;if(!x){F=Z;G=H;continue}else{x=0;M=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((M|0)==35){G=bQ(-1,-1)|0;aa=K;ab=G;CP(o);CP(n);be(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(38,S|0,c[q>>2]|0,j|0,v|0)|0);if(x){x=0;break}c[k>>2]=F;G_(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{F=c[H+12>>2]|0;if((F|0)==(c[H+16>>2]|0)){G=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){ae=G}else{x=0;break L6}}else{ae=c[F>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){M=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){F=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!x){af=F}else{x=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;M=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);do{if((M|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;aa=K;ab=e;CP(o);CP(n);be(ab|0)}function EP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];EQ(a,0,j,k,f,g,h);i=b;return}function EQ(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;e=i;i=i+144|0;l=f;f=i;i=i+4|0;i=i+7&-8;c[f>>2]=c[l>>2];l=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[l>>2];l=e|0;m=e+104|0;n=e+112|0;o=e+128|0;p=o;q=i;i=i+4|0;i=i+7&-8;r=i;i=i+160|0;s=i;i=i+4|0;i=i+7&-8;t=i;i=i+4|0;i=i+7&-8;u=c[h+4>>2]&74;if((u|0)==0){v=0}else if((u|0)==64){v=8}else if((u|0)==8){v=16}else{v=10}u=l|0;E8(n,h,u,m);Ke(p|0,0,12)|0;h=o;x=0;aP(80,o|0,10,0);L6:do{if(!x){if((a[p]&1)==0){l=h+1|0;w=l;y=l;z=o+8|0}else{l=o+8|0;w=c[l>>2]|0;y=h+1|0;z=l}c[q>>2]=w;l=r|0;c[s>>2]=l;c[t>>2]=0;A=f|0;B=g|0;C=o|0;D=o+4|0;E=c[m>>2]|0;F=w;G=c[A>>2]|0;L12:while(1){do{if((G|0)==0){H=0}else{I=c[G+12>>2]|0;if((I|0)==(c[G+16>>2]|0)){J=(x=0,as(c[(c[G>>2]|0)+36>>2]|0,G|0)|0);if(!x){L=J}else{x=0;M=35;break L12}}else{L=c[I>>2]|0}if((L|0)!=-1){H=G;break}c[A>>2]=0;H=0}}while(0);N=(H|0)==0;I=c[B>>2]|0;do{if((I|0)==0){M=22}else{J=c[I+12>>2]|0;if((J|0)==(c[I+16>>2]|0)){O=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!x){P=O}else{x=0;M=35;break L12}}else{P=c[J>>2]|0}if((P|0)==-1){c[B>>2]=0;M=22;break}else{J=(I|0)==0;if(N^J){Q=I;R=J;break}else{S=F;T=I;U=J;break L12}}}}while(0);if((M|0)==22){M=0;if(N){S=F;T=0;U=1;break}else{Q=0;R=1}}I=d[p]|0;J=(I&1|0)==0;if(((c[q>>2]|0)-F|0)==((J?I>>>1:c[D>>2]|0)|0)){if(J){V=I>>>1;W=I>>>1}else{I=c[D>>2]|0;V=I;W=I}x=0;aP(80,o|0,V<<1|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){X=10}else{X=(c[C>>2]&-2)-1|0}x=0;aP(80,o|0,X|0,0);if(x){x=0;M=35;break}if((a[p]&1)==0){Y=y}else{Y=c[z>>2]|0}c[q>>2]=Y+W;Z=Y}else{Z=F}I=H+12|0;J=c[I>>2]|0;O=H+16|0;if((J|0)==(c[O>>2]|0)){_=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){$=_}else{x=0;M=35;break}}else{$=c[J>>2]|0}if((E4($,v,Z,q,t,E,n,l,s,u)|0)!=0){S=Z;T=Q;U=R;break}J=c[I>>2]|0;if((J|0)==(c[O>>2]|0)){O=c[(c[H>>2]|0)+40>>2]|0;x=0,as(O|0,H|0)|0;if(!x){F=Z;G=H;continue}else{x=0;M=35;break}}else{c[I>>2]=J+4;F=Z;G=H;continue}}if((M|0)==35){G=bQ(-1,-1)|0;aa=K;ab=G;CP(o);CP(n);be(ab|0)}G=d[n]|0;if((G&1|0)==0){ac=G>>>1}else{ac=c[n+4>>2]|0}do{if((ac|0)!=0){G=c[s>>2]|0;if((G-r|0)>=160){break}F=c[t>>2]|0;c[s>>2]=G+4;c[G>>2]=F}}while(0);F=(x=0,aS(4,S|0,c[q>>2]|0,j|0,v|0)|0);G=K;if(x){x=0;break}c[k>>2]=F;c[k+4>>2]=G;G_(n,l,c[s>>2]|0,j);do{if(N){ad=0}else{G=c[H+12>>2]|0;if((G|0)==(c[H+16>>2]|0)){F=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){ae=F}else{x=0;break L6}}else{ae=c[G>>2]|0}if((ae|0)!=-1){ad=H;break}c[A>>2]=0;ad=0}}while(0);A=(ad|0)==0;do{if(U){M=64}else{l=c[T+12>>2]|0;if((l|0)==(c[T+16>>2]|0)){G=(x=0,as(c[(c[T>>2]|0)+36>>2]|0,T|0)|0);if(!x){af=G}else{x=0;break L6}}else{af=c[l>>2]|0}if((af|0)==-1){c[B>>2]=0;M=64;break}if(!(A^(T|0)==0)){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);do{if((M|0)==64){if(A){break}ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;ag=b|0;c[ag>>2]=ad;CP(o);CP(n);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;aa=K;ab=e;CP(o);CP(n);be(ab|0)}function ER(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];ES(a,0,j,k,f,g,h);i=b;return}function ES(e,f,g,h,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0;f=i;i=i+144|0;m=g;g=i;i=i+4|0;i=i+7&-8;c[g>>2]=c[m>>2];m=h;h=i;i=i+4|0;i=i+7&-8;c[h>>2]=c[m>>2];m=f|0;n=f+104|0;o=f+112|0;p=f+128|0;q=p;r=i;i=i+4|0;i=i+7&-8;s=i;i=i+160|0;t=i;i=i+4|0;i=i+7&-8;u=i;i=i+4|0;i=i+7&-8;v=c[j+4>>2]&74;if((v|0)==8){w=16}else if((v|0)==0){w=0}else if((v|0)==64){w=8}else{w=10}v=m|0;E8(o,j,v,n);Ke(q|0,0,12)|0;j=p;x=0;aP(80,p|0,10,0);L6:do{if(!x){if((a[q]&1)==0){m=j+1|0;y=m;z=m;A=p+8|0}else{m=p+8|0;y=c[m>>2]|0;z=j+1|0;A=m}c[r>>2]=y;m=s|0;c[t>>2]=m;c[u>>2]=0;B=g|0;C=h|0;D=p|0;E=p+4|0;F=c[n>>2]|0;G=y;H=c[B>>2]|0;L12:while(1){do{if((H|0)==0){I=0}else{J=c[H+12>>2]|0;if((J|0)==(c[H+16>>2]|0)){L=(x=0,as(c[(c[H>>2]|0)+36>>2]|0,H|0)|0);if(!x){M=L}else{x=0;N=35;break L12}}else{M=c[J>>2]|0}if((M|0)!=-1){I=H;break}c[B>>2]=0;I=0}}while(0);O=(I|0)==0;J=c[C>>2]|0;do{if((J|0)==0){N=22}else{L=c[J+12>>2]|0;if((L|0)==(c[J+16>>2]|0)){P=(x=0,as(c[(c[J>>2]|0)+36>>2]|0,J|0)|0);if(!x){Q=P}else{x=0;N=35;break L12}}else{Q=c[L>>2]|0}if((Q|0)==-1){c[C>>2]=0;N=22;break}else{L=(J|0)==0;if(O^L){R=J;S=L;break}else{T=G;U=J;V=L;break L12}}}}while(0);if((N|0)==22){N=0;if(O){T=G;U=0;V=1;break}else{R=0;S=1}}J=d[q]|0;L=(J&1|0)==0;if(((c[r>>2]|0)-G|0)==((L?J>>>1:c[E>>2]|0)|0)){if(L){W=J>>>1;X=J>>>1}else{J=c[E>>2]|0;W=J;X=J}x=0;aP(80,p|0,W<<1|0,0);if(x){x=0;N=35;break}if((a[q]&1)==0){Y=10}else{Y=(c[D>>2]&-2)-1|0}x=0;aP(80,p|0,Y|0,0);if(x){x=0;N=35;break}if((a[q]&1)==0){Z=z}else{Z=c[A>>2]|0}c[r>>2]=Z+X;_=Z}else{_=G}J=I+12|0;L=c[J>>2]|0;P=I+16|0;if((L|0)==(c[P>>2]|0)){$=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!x){aa=$}else{x=0;N=35;break}}else{aa=c[L>>2]|0}if((E4(aa,w,_,r,u,F,o,m,t,v)|0)!=0){T=_;U=R;V=S;break}L=c[J>>2]|0;if((L|0)==(c[P>>2]|0)){P=c[(c[I>>2]|0)+40>>2]|0;x=0,as(P|0,I|0)|0;if(!x){G=_;H=I;continue}else{x=0;N=35;break}}else{c[J>>2]=L+4;G=_;H=I;continue}}if((N|0)==35){H=bQ(-1,-1)|0;ab=K;ac=H;CP(p);CP(o);be(ac|0)}H=d[o]|0;if((H&1|0)==0){ad=H>>>1}else{ad=c[o+4>>2]|0}do{if((ad|0)!=0){H=c[t>>2]|0;if((H-s|0)>=160){break}G=c[u>>2]|0;c[t>>2]=H+4;c[H>>2]=G}}while(0);G=(x=0,aS(6,T|0,c[r>>2]|0,k|0,w|0)|0);if(x){x=0;break}b[l>>1]=G;G_(o,m,c[t>>2]|0,k);do{if(O){ae=0}else{G=c[I+12>>2]|0;if((G|0)==(c[I+16>>2]|0)){H=(x=0,as(c[(c[I>>2]|0)+36>>2]|0,I|0)|0);if(!x){af=H}else{x=0;break L6}}else{af=c[G>>2]|0}if((af|0)!=-1){ae=I;break}c[B>>2]=0;ae=0}}while(0);B=(ae|0)==0;do{if(V){N=64}else{m=c[U+12>>2]|0;if((m|0)==(c[U+16>>2]|0)){G=(x=0,as(c[(c[U>>2]|0)+36>>2]|0,U|0)|0);if(!x){ag=G}else{x=0;break L6}}else{ag=c[m>>2]|0}if((ag|0)==-1){c[C>>2]=0;N=64;break}if(!(B^(U|0)==0)){break}ah=e|0;c[ah>>2]=ae;CP(p);CP(o);i=f;return}}while(0);do{if((N|0)==64){if(B){break}ah=e|0;c[ah>>2]=ae;CP(p);CP(o);i=f;return}}while(0);c[k>>2]=c[k>>2]|2;ah=e|0;c[ah>>2]=ae;CP(p);CP(o);i=f;return}else{x=0}}while(0);f=bQ(-1,-1)|0;ab=K;ac=f;CP(p);CP(o);be(ac|0)}function ET(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;b=i;i=i+16|0;j=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[j>>2];j=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[j>>2];j=b|0;k=b+8|0;c[j>>2]=c[d>>2];c[k>>2]=c[e>>2];EU(a,0,j,k,f,g,h);i=b;return}
function kO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0;e=i;i=i+176|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+48|0;m=e+56|0;n=e+64|0;o=e+80|0;p=e+88|0;q=e+96|0;r=e+112|0;s=e+128|0;t=e+144|0;u=e+160|0;v=b+32|0;w=c[d+32>>2]|0;c[p>>2]=w;y=b+36|0;z=c[y>>2]|0;if((z|0)==(c[b+40>>2]|0)){lN(v,p)}else{if((z|0)==0){A=0}else{c[z>>2]=w;A=c[y>>2]|0}c[y>>2]=A+4}A=c[d+28>>2]|0;w=cS[c[(c[A>>2]|0)+16>>2]&1023](A,b|0)|0;A=cA[c[(c[w>>2]|0)+40>>2]&511](w)|0;w=c[(c[b+24>>2]|0)-4>>2]|0;z=A+32|0;p=c[z>>2]|0;B=(c[A+36>>2]|0)-p>>2;if((B|0)==0){C=c[y>>2]|0;D=C-4|0;c[y>>2]=D;i=e;return 0}A=b+4|0;E=d+4|0;F=q;G=d+16|0;H=v|0;v=w+28|0;I=w+36|0;J=w+40|0;L=w+32|0;w=v;M=r;N=r+8|0;O=d+12|0;P=d+8|0;d=r+1|0;Q=r|0;R=r+4|0;S=q+8|0;T=q+1|0;U=q|0;V=q+4|0;W=s+8|0;X=s|0;Y=s+4|0;Z=t;_=u;$=b+56|0;b=s;aa=t+8|0;ab=t+1|0;ac=t|0;ad=t+4|0;ae=0;af=p;L11:while(1){p=c[af+(ae<<2)>>2]|0;if((p|0)==0){ag=9;break}do{if((c[(c[(c[p>>2]|0)-4>>2]|0)+4>>2]|0)==27432){ah=c[A>>2]|0;ai=J0(60)|0;c[o>>2]=ai;aj=ah+4|0;ak=c[aj>>2]|0;if((ak|0)==(c[ah+8>>2]|0)){ee(ah|0,o);al=c[o>>2]|0}else{if((ak|0)==0){am=0}else{c[ak>>2]=ai;am=c[aj>>2]|0}c[aj>>2]=am+4;al=ai}an=al;if((a[E]&1)==0){c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2]}else{ai=c[O>>2]|0;ak=c[P>>2]|0;if(ak>>>0>4294967279>>>0){ag=19;break L11}if(ak>>>0<11>>>0){a[F]=ak<<1;ar=T}else{at=ak+16&-16;au=(x=0,as(230,at|0)|0);if(x){x=0;ag=67;break L11}c[S>>2]=au;c[U>>2]=at|1;c[V>>2]=ak;ar=au}Kb(ar|0,ai|0,ak)|0;a[ar+ak|0]=0}ak=n;c[ak>>2]=c[G>>2];c[ak+4>>2]=c[G+4>>2];c[ak+8>>2]=c[G+8>>2];x=0;aB(2,al|0,q|0,n|0,0,0,0);if(x){x=0;ag=70;break L11}if((a[F]&1)!=0){J2(c[S>>2]|0)}ak=c[y>>2]|0;ai=al+40|0;au=ai;do{if((c[H>>2]|0)==(ak|0)){at=c[p+28>>2]|0;c[g>>2]=at;av=ai+8|0;aw=c[av>>2]|0;ax=aw;if((aw|0)==(c[ai+12>>2]|0)){eq(ai+4|0,g);ay=c[g>>2]|0}else{if((aw|0)==0){az=0}else{c[ax>>2]=at;az=c[av>>2]|0}c[av>>2]=az+4;ay=at}cy[c[c[ai>>2]>>2]&1023](au,ay)}else{at=c[ak-4>>2]|0;c[m>>2]=at;av=ai+8|0;ax=c[av>>2]|0;aw=ax;aA=ai+12|0;if((ax|0)==(c[aA>>2]|0)){eq(ai+4|0,m);aC=c[m>>2]|0}else{if((ax|0)==0){aD=0}else{c[aw>>2]=at;aD=c[av>>2]|0}c[av>>2]=aD+4;aC=at}cy[c[c[ai>>2]>>2]&1023](au,aC);aE=c[A>>2]|0;at=J0(52)|0;c[l>>2]=at;aF=aE+4|0;aw=c[aF>>2]|0;if((aw|0)==(c[aE+8>>2]|0)){ee(aE|0,l);aG=c[l>>2]|0}else{if((aw|0)==0){aH=0}else{c[aw>>2]=at;aH=c[aF>>2]|0}c[aF>>2]=aH+4;aG=at}aI=aG;if((a[E]&1)==0){c[M>>2]=c[E>>2];c[M+4>>2]=c[E+4>>2];c[M+8>>2]=c[E+8>>2]}else{at=c[O>>2]|0;aw=c[P>>2]|0;if(aw>>>0>4294967279>>>0){ag=43;break L11}if(aw>>>0<11>>>0){a[M]=aw<<1;aJ=d}else{ax=aw+16&-16;aK=(x=0,as(230,ax|0)|0);if(x){x=0;ag=78;break L11}c[N>>2]=aK;c[Q>>2]=ax|1;c[R>>2]=aw;aJ=aK}Kb(aJ|0,at|0,aw)|0;a[aJ+aw|0]=0}aw=k;c[aw>>2]=c[G>>2];c[aw+4>>2]=c[G+4>>2];c[aw+8>>2]=c[G+8>>2];x=0;ao(34,aG|0,r|0,k|0,8992,0);if(x){x=0;aL=1;ag=81;break L11}aw=aG;c[j>>2]=aw;at=c[av>>2]|0;aK=at;if((at|0)==(c[aA>>2]|0)){x=0;aq(370,ai+4|0,j|0);if(x){x=0;aL=0;ag=81;break L11}aM=c[j>>2]|0}else{if((at|0)==0){aN=0}else{c[aK>>2]=aw;aN=c[av>>2]|0}c[av>>2]=aN+4;aM=aw}x=0;aq(c[c[ai>>2]>>2]|0,au|0,aM|0);if(x){x=0;aL=0;ag=81;break L11}aw=c[p+28>>2]|0;c[h>>2]=aw;aK=c[av>>2]|0;at=aK;if((aK|0)==(c[aA>>2]|0)){x=0;aq(370,ai+4|0,h|0);if(x){x=0;aL=0;ag=81;break L11}aO=c[h>>2]|0}else{if((aK|0)==0){aP=0}else{c[at>>2]=aw;aP=c[av>>2]|0}c[av>>2]=aP+4;aO=aw}x=0;aq(c[c[ai>>2]>>2]|0,au|0,aO|0);if(x){x=0;aL=0;ag=81;break L11}if((a[M]&1)==0){break}J2(c[N>>2]|0)}}while(0);c[p+28>>2]=al;c[f>>2]=p;au=c[I>>2]|0;if((au|0)==(c[J>>2]|0)){lM(L,f);aQ=c[f>>2]|0}else{if((au|0)==0){aR=0}else{c[au>>2]=p;aR=c[I>>2]|0}c[I>>2]=aR+4;aQ=p}cy[c[c[w>>2]>>2]&1023](v,aQ)}else{au=J0(80)|0;c[W>>2]=au;c[X>>2]=81;c[Y>>2]=72;Kb(au|0,10896,72)|0;a[au+72|0]=0;au=p+4|0;if((a[au]&1)==0){c[Z>>2]=c[au>>2];c[Z+4>>2]=c[au+4>>2];c[Z+8>>2]=c[au+8>>2]}else{au=c[p+12>>2]|0;ai=c[p+8>>2]|0;if(ai>>>0>4294967279>>>0){ag=105;break L11}if(ai>>>0<11>>>0){a[Z]=ai<<1;aS=ab}else{ak=ai+16&-16;aw=(x=0,as(230,ak|0)|0);if(x){x=0;ag=117;break L11}c[aa>>2]=aw;c[ac>>2]=ak|1;c[ad>>2]=ai;aS=aw}Kb(aS|0,au|0,ai)|0;a[aS+ai|0]=0}ai=p+16|0;c[_>>2]=c[ai>>2];c[_+4>>2]=c[ai+4>>2];c[_+8>>2]=c[ai+8>>2];x=0;aT(42,s|0,t|0,u|0,c[$>>2]|0);if(x){x=0;ag=120;break L11}if((a[Z]&1)!=0){J2(c[aa>>2]|0)}if((a[b]&1)==0){break}J2(c[W>>2]|0)}}while(0);p=ae+1|0;if(p>>>0>=B>>>0){ag=128;break}ae=p;af=c[z>>2]|0}do{if((ag|0)==81){z=bQ(-1,-1)|0;af=z;z=K;if((a[M]&1)==0){if(aL){aU=af;aV=z;ag=84;break}else{aW=z;aX=af}aY=aX;aZ=0;a_=aY;a$=aW;be(a_|0)}else{J2(c[N>>2]|0);if(aL){aU=af;aV=z;ag=84;break}else{aW=z;aX=af}aY=aX;aZ=0;a_=aY;a$=aW;be(a_|0)}}else if((ag|0)==43){x=0;ap(232,0);if(!x){return 0}else{x=0;af=bQ(-1,-1)|0;a0=K;a1=af;ag=80;break}}else if((ag|0)==117){af=bQ(-1,-1)|0;a2=K;a3=af;ag=119}else if((ag|0)==120){af=bQ(-1,-1)|0;z=af;af=K;if((a[Z]&1)==0){a4=af;a5=z;ag=122;break}J2(c[aa>>2]|0);a4=af;a5=z;ag=122}else if((ag|0)==70){z=bQ(-1,-1)|0;af=z;z=K;if((a[F]&1)==0){a6=z;a7=af;ag=72;break}J2(c[S>>2]|0);a6=z;a7=af;ag=72}else if((ag|0)==78){af=bQ(-1,-1)|0;a0=K;a1=af;ag=80}else if((ag|0)==19){x=0;ap(232,0);if(!x){return 0}else{x=0;af=bQ(-1,-1)|0;a8=K;a9=af;ag=69;break}}else if((ag|0)==105){x=0;ap(232,0);if(!x){return 0}else{x=0;af=bQ(-1,-1)|0;a2=K;a3=af;ag=119;break}}else if((ag|0)==67){af=bQ(-1,-1)|0;a8=K;a9=af;ag=69}else if((ag|0)==128){C=c[y>>2]|0;D=C-4|0;c[y>>2]=D;i=e;return 0}else if((ag|0)==9){cg();return 0}}while(0);if((ag|0)==80){aU=a1;aV=a0;ag=84}else if((ag|0)==119){a4=a2;a5=a3;ag=122}else if((ag|0)==69){a6=a8;a7=a9;ag=72}if((ag|0)==122){if((a[b]&1)==0){aW=a4;aX=a5;aY=aX;aZ=0;a_=aY;a$=aW;be(a_|0)}J2(c[W>>2]|0);aW=a4;aX=a5;aY=aX;aZ=0;a_=aY;a$=aW;be(a_|0)}else if((ag|0)==72){a5=c[ah>>2]|0;ah=c[aj>>2]|0;a4=a5;while(1){if((a4|0)==(ah|0)){ba=ah;break}if((c[a4>>2]|0)==(al|0)){ba=a4;break}else{a4=a4+4|0}}a4=ba-a5>>2;ba=a5+(a4+1<<2)|0;al=ah-ba|0;Kc(a5+(a4<<2)|0,ba|0,al|0)|0;ba=a5+((al>>2)+a4<<2)|0;a4=c[aj>>2]|0;if((ba|0)!=(a4|0)){c[aj>>2]=a4+(~((a4-4+(-ba|0)|0)>>>2)<<2)}J2(an);aW=a6;aX=a7;aY=aX;aZ=0;a_=aY;a$=aW;be(a_|0)}else if((ag|0)==84){ag=c[aE>>2]|0;aE=c[aF>>2]|0;a7=ag;while(1){if((a7|0)==(aE|0)){bb=aE;break}if((c[a7>>2]|0)==(aG|0)){bb=a7;break}else{a7=a7+4|0}}a7=bb-ag>>2;bb=ag+(a7+1<<2)|0;aG=aE-bb|0;Kc(ag+(a7<<2)|0,bb|0,aG|0)|0;bb=ag+((aG>>2)+a7<<2)|0;a7=c[aF>>2]|0;if((bb|0)!=(a7|0)){c[aF>>2]=a7+(~((a7-4+(-bb|0)|0)>>>2)<<2)}J2(aI);aW=aV;aX=aU;aY=aX;aZ=0;a_=aY;a$=aW;be(a_|0)}return 0}function kP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=i;i=i+88|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+72|0;m=c[d+32>>2]|0;n=c[(c[m>>2]|0)+20>>2]|0;o=hz(c[b+8>>2]|0,c[b+16>>2]|0,c[b+56>>2]|0)|0;p=cS[n&1023](m,o)|0;o=c[b+4>>2]|0;m=J0(40)|0;c[j>>2]=m;n=o+4|0;q=c[n>>2]|0;if((q|0)==(c[o+8>>2]|0)){ee(o|0,j);r=c[j>>2]|0}else{if((q|0)==0){s=0}else{c[q>>2]=m;s=c[n>>2]|0}c[n>>2]=s+4;r=m}m=r;s=d+4|0;L8:do{if((a[s]&1)==0){q=k;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];t=16}else{q=c[d+12>>2]|0;j=c[d+8>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){a[k]=j<<1;u=k+1|0}else{v=j+16&-16;w=(x=0,as(230,v|0)|0);if(x){x=0;break}c[k+8>>2]=w;c[k>>2]=v|1;c[k+4>>2]=j;u=w}Kb(u|0,q|0,j)|0;a[u+j|0]=0;t=16;break L8}}while(0);j=bQ(-1,-1)|0;y=K;z=j}}while(0);do{if((t|0)==16){u=l;s=d+16|0;c[u>>2]=c[s>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];s=c[d+28>>2]|0;j=(x=0,aK(c[(c[s>>2]|0)+16>>2]|0,s|0,b|0)|0);do{if(!x){s=(x=0,as(c[(c[j>>2]|0)+40>>2]|0,j|0)|0);if(x){x=0;t=37;break}q=h;c[q>>2]=c[u>>2];c[q+4>>2]=c[u+4>>2];c[q+8>>2]=c[u+8>>2];w=f;v=g;A=r;B=k;C=a[B]|0;D=(C&1)==0;if(D){c[w>>2]=c[B>>2];c[w+4>>2]=c[B+4>>2];c[w+8>>2]=c[B+8>>2]}else{B=c[k+8>>2]|0;E=c[k+4>>2]|0;if(E>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;t=37;break}return 0}if(E>>>0<11>>>0){a[w]=E<<1;F=f+1|0}else{G=E+16&-16;H=(x=0,as(230,G|0)|0);if(x){x=0;t=37;break}c[f+8>>2]=H;c[f>>2]=G|1;c[f+4>>2]=E;F=H}Kb(F|0,B|0,E)|0;a[F+E|0]=0}c[v>>2]=c[q>>2];c[v+4>>2]=c[q+4>>2];c[v+8>>2]=c[q+8>>2];x=0;aT(6,A|0,f|0,g|0,s|0);if(x){x=0;s=bQ(-1,-1)|0;A=K;if((a[w]&1)==0){I=A;J=s;L=C;break}J2(c[f+8>>2]|0);I=A;J=s;L=C;break}if((a[w]&1)!=0){J2(c[f+8>>2]|0)}c[r>>2]=21232;c[r+32>>2]=p;w=r+36|0;c[w>>2]=0;if(D){M=b+48|0;N=c[M>>2]|0;O=N-4|0;P=c[O>>2]|0;Q=P;c[w>>2]=Q;R=r;i=e;return R|0}J2(c[k+8>>2]|0);M=b+48|0;N=c[M>>2]|0;O=N-4|0;P=c[O>>2]|0;Q=P;c[w>>2]=Q;R=r;i=e;return R|0}else{x=0;t=37}}while(0);if((t|0)==37){u=bQ(-1,-1)|0;I=K;J=u;L=a[k]|0}u=J;j=I;if((L&1)==0){y=j;z=u;break}J2(c[k+8>>2]|0);y=j;z=u}}while(0);k=c[o>>2]|0;o=c[n>>2]|0;L=k;while(1){if((L|0)==(o|0)){S=o;break}if((c[L>>2]|0)==(r|0)){S=L;break}else{L=L+4|0}}L=S-k>>2;S=k+(L+1<<2)|0;r=o-S|0;Kc(k+(L<<2)|0,S|0,r|0)|0;S=k+((r>>2)+L<<2)|0;L=c[n>>2]|0;if((S|0)==(L|0)){J2(m);T=z;U=0;V=T;W=y;be(V|0)}c[n>>2]=L+(~((L-4+(-S|0)|0)>>>2)<<2);J2(m);T=z;U=0;V=T;W=y;be(V|0);return 0}function kQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+64|0;m=c[d+28>>2]|0;c[h>>2]=0;n=b+48|0;o=c[n>>2]|0;if((o|0)==(c[b+52>>2]|0)){lP(b+44|0,h)}else{if((o|0)==0){p=0}else{c[o>>2]=0;p=c[n>>2]|0}c[n>>2]=p+4}p=c[d+44>>2]|0;if((p|0)==0){q=0}else{o=c[(c[p>>2]|0)+24>>2]|0;h=ga(c[b+12>>2]|0,0,c[b+16>>2]|0,c[b+56>>2]|0,0,0)|0;q=cS[o&1023](p|0,h)|0}if((m|0)==0){r=0}else{h=cS[c[(c[m>>2]|0)+16>>2]&1023](m,b|0)|0;r=cA[c[(c[h>>2]|0)+40>>2]&511](h)|0}h=c[b+4>>2]|0;b=J0(48)|0;c[g>>2]=b;m=h+4|0;p=c[m>>2]|0;if((p|0)==(c[h+8>>2]|0)){ee(h|0,g);s=c[g>>2]|0}else{if((p|0)==0){t=0}else{c[p>>2]=b;t=c[m>>2]|0}c[m>>2]=t+4;s=b}b=s;t=s;p=d+4|0;L21:do{if((a[p]&1)==0){g=j;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];u=25}else{g=c[d+12>>2]|0;o=c[d+8>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[j]=o<<1;v=j+1|0}else{w=o+16&-16;y=(x=0,as(230,w|0)|0);if(x){x=0;break}c[j+8>>2]=y;c[j>>2]=w|1;c[j+4>>2]=o;v=y}Kb(v|0,g|0,o)|0;a[v+o|0]=0;u=25;break L21}}while(0);o=bQ(-1,-1)|0;z=K;A=o}}while(0);do{if((u|0)==25){v=k;p=d+16|0;c[v>>2]=c[p>>2];c[v+4>>2]=c[p+4>>2];c[v+8>>2]=c[p+8>>2];p=d+32|0;L36:do{if((a[p]&1)==0){o=l;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];u=35}else{o=c[d+40>>2]|0;g=c[d+36>>2]|0;do{if(g>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(g>>>0<11>>>0){a[l]=g<<1;B=l+1|0}else{y=g+16&-16;w=(x=0,as(230,y|0)|0);if(x){x=0;break}c[l+8>>2]=w;c[l>>2]=y|1;c[l+4>>2]=g;B=w}Kb(B|0,o|0,g)|0;a[B+g|0]=0;u=35;break L36}}while(0);g=bQ(-1,-1)|0;C=K;D=g}}while(0);do{if((u|0)==35){p=f;c[p>>2]=c[v>>2];c[p+4>>2]=c[v+4>>2];c[p+8>>2]=c[v+8>>2];x=0;aB(8,t|0,j|0,f|0,l|0,q|0,r|0);if(x){x=0;p=bQ(-1,-1)|0;g=p;p=K;if((a[l]&1)==0){C=p;D=g;break}J2(c[l+8>>2]|0);C=p;D=g;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}if((a[j]&1)==0){E=c[n>>2]|0;F=E-4|0;c[n>>2]=F;G=s;i=e;return G|0}J2(c[j+8>>2]|0);E=c[n>>2]|0;F=E-4|0;c[n>>2]=F;G=s;i=e;return G|0}}while(0);if((a[j]&1)==0){z=C;A=D;break}J2(c[j+8>>2]|0);z=C;A=D}}while(0);D=c[h>>2]|0;h=c[m>>2]|0;C=D;while(1){if((C|0)==(h|0)){H=h;break}if((c[C>>2]|0)==(s|0)){H=C;break}else{C=C+4|0}}C=H-D>>2;H=D+(C+1<<2)|0;s=h-H|0;Kc(D+(C<<2)|0,H|0,s|0)|0;H=D+((s>>2)+C<<2)|0;C=c[m>>2]|0;if((H|0)==(C|0)){J2(b);I=A;J=0;L=I;M=z;be(L|0)}c[m>>2]=C+(~((C-4+(-H|0)|0)>>>2)<<2);J2(b);I=A;J=0;L=I;M=z;be(L|0);return 0}function kR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+88|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+72|0;m=c[d+28>>2]|0;n=c[(c[m>>2]|0)+20>>2]|0;o=b+8|0;p=b+16|0;q=b+56|0;r=hz(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;s=cS[n&1023](m,r)|0;r=c[b+4>>2]|0;b=J0(40)|0;c[j>>2]=b;m=r+4|0;n=c[m>>2]|0;if((n|0)==(c[r+8>>2]|0)){ee(r|0,j);t=c[j>>2]|0}else{if((n|0)==0){u=0}else{c[n>>2]=b;u=c[m>>2]|0}c[m>>2]=u+4;t=b}b=t;u=d+4|0;L8:do{if((a[u]&1)==0){n=k;c[n>>2]=c[u>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2];v=16}else{n=c[d+12>>2]|0;j=c[d+8>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){a[k]=j<<1;w=k+1|0}else{y=j+16&-16;z=(x=0,as(230,y|0)|0);if(x){x=0;break}c[k+8>>2]=z;c[k>>2]=y|1;c[k+4>>2]=j;w=z}Kb(w|0,n|0,j)|0;a[w+j|0]=0;v=16;break L8}}while(0);j=bQ(-1,-1)|0;A=K;B=j}}while(0);do{if((v|0)==16){w=l;u=d+16|0;c[w>>2]=c[u>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];u=c[d+32>>2]|0;j=c[(c[u>>2]|0)+20>>2]|0;n=(x=0,ax(32,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0);do{if(!x){z=(x=0,aK(j|0,u|0,n|0)|0);if(x){x=0;v=37;break}y=a[d+36|0]&1;C=h;c[C>>2]=c[w>>2];c[C+4>>2]=c[w+4>>2];c[C+8>>2]=c[w+8>>2];D=f;E=g;F=t;G=k;H=a[G]|0;I=(H&1)==0;if(I){c[D>>2]=c[G>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2]}else{G=c[k+8>>2]|0;J=c[k+4>>2]|0;if(J>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;v=37;break}return 0}if(J>>>0<11>>>0){a[D]=J<<1;L=f+1|0}else{M=J+16&-16;N=(x=0,as(230,M|0)|0);if(x){x=0;v=37;break}c[f+8>>2]=N;c[f>>2]=M|1;c[f+4>>2]=J;L=N}Kb(L|0,G|0,J)|0;a[L+J|0]=0}c[E>>2]=c[C>>2];c[E+4>>2]=c[C+4>>2];c[E+8>>2]=c[C+8>>2];x=0;aP(402,F|0,f|0,g|0);if(x){x=0;C=bQ(-1,-1)|0;E=K;if((a[D]&1)==0){O=E;P=C;Q=H;break}J2(c[f+8>>2]|0);O=E;P=C;Q=H;break}if((a[D]&1)!=0){J2(c[f+8>>2]|0)}c[t>>2]=21360;c[t+28>>2]=s;c[t+32>>2]=z;a[t+36|0]=y;if(I){i=e;return F|0}J2(c[k+8>>2]|0);i=e;return F|0}else{x=0;v=37}}while(0);if((v|0)==37){w=bQ(-1,-1)|0;O=K;P=w;Q=a[k]|0}w=P;n=O;if((Q&1)==0){A=n;B=w;break}J2(c[k+8>>2]|0);A=n;B=w}}while(0);k=c[r>>2]|0;r=c[m>>2]|0;Q=k;while(1){if((Q|0)==(r|0)){R=r;break}if((c[Q>>2]|0)==(t|0)){R=Q;break}else{Q=Q+4|0}}Q=R-k>>2;R=k+(Q+1<<2)|0;t=r-R|0;Kc(k+(Q<<2)|0,R|0,t|0)|0;R=k+((t>>2)+Q<<2)|0;Q=c[m>>2]|0;if((R|0)==(Q|0)){J2(b);S=B;T=0;U=S;V=A;be(U|0)}c[m>>2]=Q+(~((Q-4+(-R|0)|0)>>>2)<<2);J2(b);S=B;T=0;U=S;V=A;be(U|0);return 0}function kS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+28|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+36>>2]|0;j=c[d+32>>2]|0;if(j>>>0>4294967279>>>0){CJ(0);return 0}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=J0(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}Kb(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+16|0;q=c[r>>2]|0;do{if((l&1)==0){j=g;c[j>>2]=c[m>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];t=19}else{j=c[f+8>>2]|0;p=c[f+4>>2]|0;if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;t=39;break}return 0}if(p>>>0<11>>>0){a[g]=p<<1;u=g+1|0}else{k=p+16&-16;s=(x=0,as(230,k|0)|0);if(x){x=0;t=39;break}c[g+8>>2]=s;c[g>>2]=k|1;c[g+4>>2]=p;u=s}Kb(u|0,j|0,p)|0;a[u+p|0]=0;t=19}}while(0);L24:do{if((t|0)==19){u=(x=0,aK(556,q|0,g|0)|0);if(x){x=0;l=bQ(-1,-1)|0;p=l;l=K;if((a[g]&1)==0){v=p;w=l;break}J2(c[g+8>>2]|0);v=p;w=l;break}if((a[g]&1)!=0){J2(c[g+8>>2]|0)}do{if(u){if((a[d+44|0]&1)!=0){break}l=c[d+40>>2]|0;p=c[(c[l>>2]|0)+20>>2]|0;j=(x=0,ax(32,c[b+8>>2]|0,c[r>>2]|0,c[b+56>>2]|0)|0);if(x){x=0;t=39;break L24}s=(x=0,aK(p|0,l|0,j|0)|0);if(x){x=0;t=39;break L24}j=s|0;s=c[r>>2]|0;if((a[m]&1)==0){l=h;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2]}else{l=c[f+8>>2]|0;p=c[f+4>>2]|0;if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;t=39;break L24}return 0}if(p>>>0<11>>>0){a[h]=p<<1;y=h+1|0}else{k=p+16&-16;n=(x=0,as(230,k|0)|0);if(x){x=0;t=39;break L24}c[h+8>>2]=n;c[h>>2]=k|1;c[h+4>>2]=p;y=n}Kb(y|0,l|0,p)|0;a[y+p|0]=0}p=(x=0,aK(88,s|0,h|0)|0);if(!x){c[p>>2]=j;if((a[h]&1)==0){break}J2(c[h+8>>2]|0);break}else{x=0;j=bQ(-1,-1)|0;p=j;j=K;if((a[h]&1)==0){v=p;w=j;break L24}J2(c[h+8>>2]|0);v=p;w=j;break L24}}else{j=c[d+40>>2]|0;p=c[(c[j>>2]|0)+20>>2]|0;s=(x=0,ax(32,c[b+8>>2]|0,c[r>>2]|0,c[b+56>>2]|0)|0);if(x){x=0;t=39;break L24}l=(x=0,aK(p|0,j|0,s|0)|0);if(x){x=0;t=39;break L24}s=(x=0,aK(176,c[r>>2]|0,f|0)|0);if(x){x=0;t=39;break L24}c[s>>2]=l}}while(0);if((a[m]&1)==0){i=e;return 0}J2(c[f+8>>2]|0);i=e;return 0}}while(0);if((t|0)==39){t=bQ(-1,-1)|0;v=t;w=K}if((a[m]&1)==0){z=v;A=0;B=z;C=w;be(B|0)}J2(c[f+8>>2]|0);z=v;A=0;B=z;C=w;be(B|0);return 0}function kT(a,b){a=a|0;b=b|0;return b|0}function kU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0;e=i;i=i+24|0;f=e|0;g=e+8|0;h=(c[b+4>>2]|0)+52|0;j=d+28|0;if((a[j]&1)==0){k=g;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2]}else{j=c[d+36>>2]|0;k=c[d+32>>2]|0;if(k>>>0>4294967279>>>0){CJ(0);return 0}if(k>>>0<11>>>0){a[g]=k<<1;l=g+1|0}else{d=k+16&-16;m=J0(d)|0;c[g+8>>2]=m;c[g>>2]=d|1;c[g+4>>2]=k;l=m}Kb(l|0,j|0,k)|0;a[l+k|0]=0}k=(x=0,aK(506,h|0,g|0)|0);L12:do{if(!x){h=c[k>>2]|0;l=c[(c[b+24>>2]|0)-4>>2]|0;j=h+32|0;m=c[j>>2]|0;d=(c[h+36>>2]|0)-m>>2;L15:do{if((d|0)!=0){h=b|0;n=l+28|0;o=l+36|0;p=l+40|0;q=l+32|0;r=n;s=0;t=m;while(1){u=c[t+(s<<2)>>2]|0;v=(x=0,aK(c[(c[u>>2]|0)+16>>2]|0,u|0,h|0)|0);if(x){x=0;break}if((v|0)!=0){c[f>>2]=v;u=c[o>>2]|0;if((u|0)==(c[p>>2]|0)){x=0;aq(476,q|0,f|0);if(x){x=0;break}w=c[f>>2]|0}else{if((u|0)==0){y=0}else{c[u>>2]=v;y=c[o>>2]|0}c[o>>2]=y+4;w=v}x=0;aq(c[c[r>>2]>>2]|0,n|0,w|0);if(x){x=0;break}}v=s+1|0;if(v>>>0>=d>>>0){break L15}s=v;t=c[j>>2]|0}t=bQ(-1,-1)|0;z=K;A=t;break L12}}while(0);if((a[g]&1)==0){i=e;return 0}J2(c[g+8>>2]|0);i=e;return 0}else{x=0;j=bQ(-1,-1)|0;z=K;A=j}}while(0);if((a[g]&1)==0){be(A|0)}J2(c[g+8>>2]|0);be(A|0);return 0}function kV(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[(c[b>>2]|0)+20>>2]|0;e=hz(c[a+8>>2]|0,c[a+16>>2]|0,c[a+56>>2]|0)|0;cS[d&1023](b,e)|0;return 0}function kW(a,b){a=a|0;b=b|0;return b|0}function kX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+16|0;e=d|0;f=d+8|0;g=c[b+28>>2]|0;h=c[(c[g>>2]|0)+20>>2]|0;j=hz(c[a+8>>2]|0,c[a+16>>2]|0,c[a+56>>2]|0)|0;k=cS[h&1023](g|0,j)|0;if(cA[c[(c[k>>2]|0)+36>>2]&511](k)|0){k=c[b+32>>2]|0;j=c[(c[a+24>>2]|0)-4>>2]|0;g=k+32|0;h=c[g>>2]|0;l=(c[k+36>>2]|0)-h>>2;if((l|0)==0){i=d;return 0}k=a|0;m=j+28|0;n=j+36|0;o=j+40|0;p=j+32|0;j=m;q=0;r=h;while(1){h=c[r+(q<<2)>>2]|0;s=cS[c[(c[h>>2]|0)+16>>2]&1023](h|0,k)|0;if((s|0)!=0){c[e>>2]=s;h=c[n>>2]|0;if((h|0)==(c[o>>2]|0)){lM(p,e);t=c[e>>2]|0}else{if((h|0)==0){u=0}else{c[h>>2]=s;u=c[n>>2]|0}c[n>>2]=u+4;t=s}cy[c[c[j>>2]>>2]&1023](m,t)}s=q+1|0;if(s>>>0>=l>>>0){break}q=s;r=c[g>>2]|0}i=d;return 0}g=c[b+36>>2]|0;if((g|0)==0){i=d;return 0}b=c[(c[a+24>>2]|0)-4>>2]|0;r=g+32|0;q=c[r>>2]|0;l=(c[g+36>>2]|0)-q>>2;if((l|0)==0){i=d;return 0}g=a|0;a=b+28|0;t=b+36|0;m=b+40|0;j=b+32|0;b=a;u=0;n=q;while(1){q=c[n+(u<<2)>>2]|0;e=cS[c[(c[q>>2]|0)+16>>2]&1023](q|0,g)|0;if((e|0)!=0){c[f>>2]=e;q=c[t>>2]|0;if((q|0)==(c[m>>2]|0)){lM(j,f);v=c[f>>2]|0}else{if((q|0)==0){w=0}else{c[q>>2]=e;w=c[t>>2]|0}c[t>>2]=w+4;v=e}cy[c[c[b>>2]>>2]&1023](a,v)}e=u+1|0;if(e>>>0>=l>>>0){break}u=e;n=c[r>>2]|0}i=d;return 0}function kY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0.0,aa=0.0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0.0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0;e=i;i=i+280|0;f=e|0;g=e+16|0;j=e+24|0;k=e+32|0;l=e+48|0;m=e+56|0;n=e+72|0;o=e+88|0;p=e+104|0;q=e+120|0;r=e+136|0;s=e+152|0;t=e+168|0;u=e+184|0;v=e+200|0;w=e+216|0;y=e+232|0;z=e+248|0;A=e+264|0;B=d+32|0;if((a[B]&1)==0){C=m;c[C>>2]=c[B>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2]}else{B=c[d+40>>2]|0;C=c[d+36>>2]|0;if(C>>>0>4294967279>>>0){CJ(0);return 0}if(C>>>0<11>>>0){a[m]=C<<1;D=m+1|0}else{E=C+16&-16;F=J0(E)|0;c[m+8>>2]=F;c[m>>2]=E|1;c[m+4>>2]=C;D=F}Kb(D|0,B|0,C)|0;a[D+C|0]=0}C=c[d+44>>2]|0;D=c[(c[C>>2]|0)+20>>2]|0;B=b+8|0;F=b+16|0;E=b+56|0;G=(x=0,ax(32,c[B>>2]|0,c[F>>2]|0,c[E>>2]|0)|0);L12:do{if(!x){H=(x=0,aK(D|0,C|0,G|0)|0);if(x){x=0;I=28;break}L15:do{if((c[H+32>>2]|0)!=2){J=(x=0,as(230,48)|0);if(x){x=0;I=28;break L12}L=n+8|0;c[L>>2]=J;c[n>>2]=49;c[n+4>>2]=47;Kb(J|0,8936,47)|0;a[J+47|0]=0;J=H+4|0;L18:do{if((a[J]&1)==0){M=o;c[M>>2]=c[J>>2];c[M+4>>2]=c[J+4>>2];c[M+8>>2]=c[J+8>>2];I=23}else{M=c[H+12>>2]|0;N=c[H+8>>2]|0;do{if(N>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(N>>>0<11>>>0){a[o]=N<<1;O=o+1|0}else{P=N+16&-16;Q=(x=0,as(230,P|0)|0);if(x){x=0;break}c[o+8>>2]=Q;c[o>>2]=P|1;c[o+4>>2]=N;O=Q}Kb(O|0,M|0,N)|0;a[O+N|0]=0;I=23;break L18}}while(0);N=bQ(-1,-1)|0;R=N;S=K}}while(0);do{if((I|0)==23){J=p;N=H+16|0;c[J>>2]=c[N>>2];c[J+4>>2]=c[N+4>>2];c[J+8>>2]=c[N+8>>2];x=0;aT(42,n|0,o|0,p|0,c[E>>2]|0);if(x){x=0;N=bQ(-1,-1)|0;J=N;N=K;if((a[o]&1)==0){R=J;S=N;break}J2(c[o+8>>2]|0);R=J;S=N;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)==0){break L15}J2(c[L>>2]|0);break L15}}while(0);if((a[n]&1)==0){T=R;U=S;break L12}J2(c[L>>2]|0);T=R;U=S;break L12}}while(0);N=c[d+48>>2]|0;J=c[(c[N>>2]|0)+20>>2]|0;M=(x=0,ax(32,c[B>>2]|0,c[F>>2]|0,c[E>>2]|0)|0);if(x){x=0;I=28;break}Q=(x=0,aK(J|0,N|0,M|0)|0);if(x){x=0;I=28;break}L46:do{if((c[Q+32>>2]|0)!=2){M=(x=0,as(230,48)|0);if(x){x=0;I=28;break L12}N=q+8|0;c[N>>2]=M;c[q>>2]=49;c[q+4>>2]=47;Kb(M|0,7256,47)|0;a[M+47|0]=0;M=Q+4|0;L49:do{if((a[M]&1)==0){J=r;c[J>>2]=c[M>>2];c[J+4>>2]=c[M+4>>2];c[J+8>>2]=c[M+8>>2];I=48}else{J=c[Q+12>>2]|0;P=c[Q+8>>2]|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(P>>>0<11>>>0){a[r]=P<<1;V=r+1|0}else{W=P+16&-16;X=(x=0,as(230,W|0)|0);if(x){x=0;break}c[r+8>>2]=X;c[r>>2]=W|1;c[r+4>>2]=P;V=X}Kb(V|0,J|0,P)|0;a[V+P|0]=0;I=48;break L49}}while(0);P=bQ(-1,-1)|0;Y=P;Z=K}}while(0);do{if((I|0)==48){M=s;L=Q+16|0;c[M>>2]=c[L>>2];c[M+4>>2]=c[L+4>>2];c[M+8>>2]=c[L+8>>2];x=0;aT(42,q|0,r|0,s|0,c[E>>2]|0);if(x){x=0;L=bQ(-1,-1)|0;M=L;L=K;if((a[r]&1)==0){Y=M;Z=L;break}J2(c[r+8>>2]|0);Y=M;Z=L;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){break L46}J2(c[N>>2]|0);break L46}}while(0);if((a[q]&1)==0){T=Y;U=Z;break L12}J2(c[N>>2]|0);T=Y;U=Z;break L12}}while(0);_=+h[H+40>>3];$=+h[Q+40>>3];if((a[d+52|0]&1)==0){aa=$}else{aa=$+1.0}L=t+4|0;c[L>>2]=0;c[t+8>>2]=0;c[t>>2]=L;L=t+12|0;c[L>>2]=0;M=b+4|0;P=c[M>>2]|0;J=(x=0,as(230,72)|0);L78:do{if(!x){X=J;c[l>>2]=X;W=P+4|0;ab=c[W>>2]|0;if((ab|0)==(c[P+8>>2]|0)){x=0;aq(376,P|0,l|0);if(x){x=0;I=148;break}ac=c[l>>2]|0}else{if((ab|0)==0){ad=0}else{c[ab>>2]=X;ad=c[W>>2]|0}c[W>>2]=ad+4;ac=X}X=ac;ab=ac;ae=H+4|0;L88:do{if((a[ae]&1)==0){af=u;c[af>>2]=c[ae>>2];c[af+4>>2]=c[ae+4>>2];c[af+8>>2]=c[ae+8>>2];I=77}else{af=c[H+12>>2]|0;ag=c[H+8>>2]|0;do{if(ag>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ag>>>0<11>>>0){a[u]=ag<<1;ah=u+1|0}else{ai=ag+16&-16;aj=(x=0,as(230,ai|0)|0);if(x){x=0;break}c[u+8>>2]=aj;c[u>>2]=ai|1;c[u+4>>2]=ag;ah=aj}Kb(ah|0,af|0,ag)|0;a[ah+ag|0]=0;I=77;break L88}}while(0);ag=bQ(-1,-1)|0;ak=K;al=ag}}while(0);do{if((I|0)==77){N=H+16|0;ag=k;c[ag>>2]=c[N>>2];c[ag+4>>2]=c[N+4>>2];c[ag+8>>2]=c[N+8>>2];ag=v;a[ag]=0;a[v+1|0]=0;x=0;aE(2,ab|0,u|0,k|0,+_,v|0);do{if(!x){af=m;aj=(a[af]&1)==0;if(aj){ai=w;c[ai>>2]=c[af>>2];c[ai+4>>2]=c[af+4>>2];c[ai+8>>2]=c[af+8>>2]}else{ai=c[m+8>>2]|0;am=c[m+4>>2]|0;if(am>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;an=0;I=151;break}return 0}if(am>>>0<11>>>0){a[w]=am<<1;ao=w+1|0}else{ar=am+16&-16;at=(x=0,as(230,ar|0)|0);if(x){x=0;an=0;I=151;break}c[w+8>>2]=at;c[w>>2]=ar|1;c[w+4>>2]=am;ao=at}Kb(ao|0,ai|0,am)|0;a[ao+am|0]=0}am=(x=0,aK(88,t|0,w|0)|0);if(x){x=0;ai=bQ(-1,-1)|0;at=ai;ai=K;if((a[w]&1)==0){au=at;av=ai;aw=0;break}J2(c[w+8>>2]|0);au=at;av=ai;aw=0;break}c[am>>2]=ac;if((a[w]&1)!=0){J2(c[w+8>>2]|0)}if((a[ag]&1)!=0){J2(c[v+8>>2]|0)}if((a[u]&1)!=0){J2(c[u+8>>2]|0)}am=c[F>>2]|0;c[L>>2]=am;c[F>>2]=t;ai=c[d+28>>2]|0;L131:do{if(_<aa){at=b+24|0;ar=ai+36|0;ay=ai+32|0;az=y;aA=z;aB=z+1|0;aC=A;aD=y+8|0;aF=z+8|0;aG=A+8|0;aH=m+8|0;aI=m+4|0;aJ=A+1|0;aL=A|0;aM=A+4|0;aN=H+12|0;aO=H+8|0;aP=y+1|0;aQ=y|0;aR=y+4|0;aS=b|0;$=_;L133:while(1){aU=c[(c[at>>2]|0)-4>>2]|0;aV=c[ay>>2]|0;aW=(c[ar>>2]|0)-aV>>2;L135:do{if((aW|0)!=0){aX=aU+28|0;aY=aU+36|0;aZ=aU+40|0;a_=aU+32|0;a$=aX;a0=0;a1=aV;while(1){a2=c[a1+(a0<<2)>>2]|0;a3=(x=0,aK(c[(c[a2>>2]|0)+16>>2]|0,a2|0,aS|0)|0);if(x){x=0;I=146;break L133}if((a3|0)!=0){c[j>>2]=a3;a2=c[aY>>2]|0;if((a2|0)==(c[aZ>>2]|0)){x=0;aq(476,a_|0,j|0);if(x){x=0;I=146;break L133}a4=c[j>>2]|0}else{if((a2|0)==0){a5=0}else{c[a2>>2]=a3;a5=c[aY>>2]|0}c[aY>>2]=a5+4;a4=a3}x=0;aq(c[c[a$>>2]>>2]|0,aX|0,a4|0);if(x){x=0;I=146;break L133}}a3=a0+1|0;if(a3>>>0>=aW>>>0){break L135}a0=a3;a1=c[ay>>2]|0}}}while(0);a6=c[M>>2]|0;aW=(x=0,as(230,72)|0);if(x){x=0;I=147;break}aV=aW;c[g>>2]=aV;a7=a6+4|0;aW=c[a7>>2]|0;if((aW|0)==(c[a6+8>>2]|0)){x=0;aq(376,a6|0,g|0);if(x){x=0;I=147;break}a8=c[g>>2]|0}else{if((aW|0)==0){a9=0}else{c[aW>>2]=aV;a9=c[a7>>2]|0}c[a7>>2]=a9+4;a8=aV}ba=a8;aV=a8;if((a[ae]&1)==0){c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2]}else{aW=c[aN>>2]|0;aU=c[aO>>2]|0;if(aU>>>0>4294967279>>>0){I=120;break}if(aU>>>0<11>>>0){a[az]=aU<<1;bb=aP}else{a1=aU+16&-16;a0=(x=0,as(230,a1|0)|0);if(x){x=0;I=165;break}c[aD>>2]=a0;c[aQ>>2]=a1|1;c[aR>>2]=aU;bb=a0}Kb(bb|0,aW|0,aU)|0;a[bb+aU|0]=0}aU=f;c[aU>>2]=c[N>>2];c[aU+4>>2]=c[N+4>>2];c[aU+8>>2]=c[N+8>>2];bc=$+1.0;a[aA]=0;a[aB]=0;x=0;aE(2,aV|0,y|0,f|0,+bc,z|0);if(x){x=0;bd=1;I=168;break}aV=c[F>>2]|0;if(aj){c[aC>>2]=c[af>>2];c[aC+4>>2]=c[af+4>>2];c[aC+8>>2]=c[af+8>>2]}else{aU=c[aH>>2]|0;aW=c[aI>>2]|0;if(aW>>>0>4294967279>>>0){I=131;break}if(aW>>>0<11>>>0){a[aC]=aW<<1;bf=aJ}else{a0=aW+16&-16;a1=(x=0,as(230,a0|0)|0);if(x){x=0;bd=0;I=168;break}c[aG>>2]=a1;c[aL>>2]=a0|1;c[aM>>2]=aW;bf=a1}Kb(bf|0,aU|0,aW)|0;a[bf+aW|0]=0}aW=(x=0,aK(88,aV|0,A|0)|0);if(x){x=0;I=171;break}c[aW>>2]=a8;if((a[aC]&1)!=0){J2(c[aG>>2]|0)}if((a[aA]&1)!=0){J2(c[aF>>2]|0)}if((a[az]&1)!=0){J2(c[aD>>2]|0)}if(bc<aa){$=bc}else{I=184;break}}do{if((I|0)==120){x=0;ap(232,0);if(!x){return 0}else{x=0;aM=bQ(-1,-1)|0;bg=K;bh=aM;I=167;break}}else if((I|0)==131){x=0;ap(232,0);if(!x){return 0}else{x=0;aM=bQ(-1,-1)|0;bi=K;bj=aM;bk=0;I=170;break}}else if((I|0)==146){aM=bQ(-1,-1)|0;bl=K;bm=aM;I=149;break L78}else if((I|0)==147){aM=bQ(-1,-1)|0;bl=K;bm=aM;I=149;break L78}else if((I|0)==165){aM=bQ(-1,-1)|0;bg=K;bh=aM;I=167}else if((I|0)==168){aM=bQ(-1,-1)|0;bi=K;bj=aM;bk=bd;I=170}else if((I|0)==171){aM=bQ(-1,-1)|0;aL=aM;aM=K;if((a[aC]&1)==0){bn=aL;bo=0;bp=aM;I=173;break}J2(c[aG>>2]|0);bn=aL;bo=0;bp=aM;I=173}else if((I|0)==184){bq=c[L>>2]|0;break L131}}while(0);if((I|0)==167){br=bg;bs=bh}else if((I|0)==170){bn=bj;bo=bk;bp=bi;I=173}do{if((I|0)==173){if((a[aA]&1)!=0){J2(c[aF>>2]|0)}if((a[az]&1)==0){if(bo){br=bp;bs=bn;break}else{bt=bn;bu=bp;break L78}}else{J2(c[aD>>2]|0);if(bo){br=bp;bs=bn;break}else{bt=bn;bu=bp;break L78}}}}while(0);aD=c[a6>>2]|0;az=c[a7>>2]|0;aF=aD;while(1){if((aF|0)==(az|0)){bv=az;break}if((c[aF>>2]|0)==(a8|0)){bv=aF;break}else{aF=aF+4|0}}aF=bv-aD>>2;aA=aD+(aF+1<<2)|0;aG=az-aA|0;Kc(aD+(aF<<2)|0,aA|0,aG|0)|0;aA=aD+((aG>>2)+aF<<2)|0;aF=c[a7>>2]|0;if((aA|0)!=(aF|0)){c[a7>>2]=aF+(~((aF-4+(-aA|0)|0)>>>2)<<2)}J2(ba);bt=bs;bu=br;break L78}else{bq=am}}while(0);c[F>>2]=bq;fQ(t|0,c[t+4>>2]|0);if(aj){i=e;return 0}J2(c[m+8>>2]|0);i=e;return 0}else{x=0;an=1;I=151}}while(0);if((I|0)==151){N=bQ(-1,-1)|0;au=N;av=K;aw=an}if((a[ag]&1)!=0){J2(c[v+8>>2]|0)}if((a[u]&1)==0){if(aw){ak=av;al=au;break}else{bt=au;bu=av;break L78}}else{J2(c[u+8>>2]|0);if(aw){ak=av;al=au;break}else{bt=au;bu=av;break L78}}}}while(0);ae=c[P>>2]|0;ab=c[W>>2]|0;N=ae;while(1){if((N|0)==(ab|0)){bw=ab;break}if((c[N>>2]|0)==(ac|0)){bw=N;break}else{N=N+4|0}}N=bw-ae>>2;am=ae+(N+1<<2)|0;af=ab-am|0;Kc(ae+(N<<2)|0,am|0,af|0)|0;am=ae+((af>>2)+N<<2)|0;N=c[W>>2]|0;if((am|0)!=(N|0)){c[W>>2]=N+(~((N-4+(-am|0)|0)>>>2)<<2)}J2(X);bt=al;bu=ak}else{x=0;I=148}}while(0);if((I|0)==148){P=bQ(-1,-1)|0;bl=K;bm=P;I=149}if((I|0)==149){bt=bm;bu=bl}fQ(t|0,c[t+4>>2]|0);T=bt;U=bu}else{x=0;I=28}}while(0);if((I|0)==28){I=bQ(-1,-1)|0;T=I;U=K}if((a[m]&1)==0){bx=T;by=0;bz=bx;bA=U;be(bz|0)}J2(c[m+8>>2]|0);bx=T;by=0;bz=bx;bA=U;be(bz|0);return 0}function kZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0;e=i;i=i+120|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=e+56|0;m=e+72|0;n=e+88|0;o=e+104|0;p=d+32|0;if((a[p]&1)==0){q=k;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2]}else{p=c[d+40>>2]|0;q=c[d+36>>2]|0;if(q>>>0>4294967279>>>0){CJ(0);return 0}if(q>>>0<11>>>0){a[k]=q<<1;r=k+1|0}else{s=q+16&-16;t=J0(s)|0;c[k+8>>2]=t;c[k>>2]=s|1;c[k+4>>2]=q;r=t}Kb(r|0,p|0,q)|0;a[r+q|0]=0}q=c[d+44>>2]|0;r=c[(c[q>>2]|0)+20>>2]|0;p=b+8|0;t=b+16|0;s=b+56|0;u=(x=0,ax(32,c[p>>2]|0,c[t>>2]|0,c[s>>2]|0)|0);L12:do{if(!x){v=(x=0,aK(r|0,q|0,u|0)|0);if(x){x=0;w=39;break}L15:do{if((c[v+32>>2]|0)==5){y=v}else{z=c[b+4>>2]|0;A=(x=0,as(230,60)|0);if(x){x=0;w=39;break L12}B=A;c[j>>2]=B;A=z+4|0;C=c[A>>2]|0;if((C|0)==(c[z+8>>2]|0)){x=0;aq(376,z|0,j|0);if(x){x=0;w=39;break L12}D=c[j>>2]|0}else{if((C|0)==0){E=0}else{c[C>>2]=B;E=c[A>>2]|0}c[A>>2]=E+4;D=B}B=D;C=D;F=v+4|0;L27:do{if((a[F]&1)==0){G=l;c[G>>2]=c[F>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];w=29}else{G=c[v+12>>2]|0;H=c[v+8>>2]|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(H>>>0<11>>>0){a[l]=H<<1;I=l+1|0}else{J=H+16&-16;L=(x=0,as(230,J|0)|0);if(x){x=0;break}c[l+8>>2]=L;c[l>>2]=J|1;c[l+4>>2]=H;I=L}Kb(I|0,G|0,H)|0;a[I+H|0]=0;w=29;break L27}}while(0);H=bQ(-1,-1)|0;M=H;N=K}}while(0);do{if((w|0)==29){F=v+16|0;H=h;c[H>>2]=c[F>>2];c[H+4>>2]=c[F+4>>2];c[H+8>>2]=c[F+8>>2];x=0;aB(34,C|0,l|0,h|0,1,1,0);if(x){x=0;F=bQ(-1,-1)|0;H=F;F=K;if((a[l]&1)==0){M=H;N=F;break}J2(c[l+8>>2]|0);M=H;N=F;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}F=D+36|0;H=F;c[g>>2]=v;G=F+8|0;L=G;J=c[L>>2]|0;if((J|0)==(c[F+12>>2]|0)){x=0;aq(370,F+4|0,g|0);if(x){x=0;w=39;break L12}O=c[g>>2]|0}else{if((J|0)==0){P=0}else{c[J>>2]=v;P=c[L>>2]|0}c[G>>2]=P+4;O=v}x=0;aq(c[c[F>>2]>>2]|0,H|0,O|0);if(!x){y=C;break L15}else{x=0;w=39;break L12}}}while(0);C=c[z>>2]|0;H=c[A>>2]|0;F=C;while(1){if((F|0)==(H|0)){Q=H;break}if((c[F>>2]|0)==(D|0)){Q=F;break}else{F=F+4|0}}F=Q-C>>2;z=C+(F+1<<2)|0;G=H-z|0;Kc(C+(F<<2)|0,z|0,G|0)|0;z=C+((G>>2)+F<<2)|0;F=c[A>>2]|0;if((z|0)!=(F|0)){c[A>>2]=F+(~((F-4+(-z|0)|0)>>>2)<<2)}J2(B);R=M;S=N;break L12}}while(0);v=m+4|0;c[v>>2]=0;c[m+8>>2]=0;c[m>>2]=v;v=m+12|0;c[v>>2]=0;z=k;F=(a[z]&1)==0;do{if(F){G=n;c[G>>2]=c[z>>2];c[G+4>>2]=c[z+4>>2];c[G+8>>2]=c[z+8>>2];w=60}else{G=c[k+8>>2]|0;L=c[k+4>>2]|0;if(L>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;w=97;break}return 0}if(L>>>0<11>>>0){a[n]=L<<1;T=n+1|0}else{J=L+16&-16;U=(x=0,as(230,J|0)|0);if(x){x=0;w=97;break}c[n+8>>2]=U;c[n>>2]=J|1;c[n+4>>2]=L;T=U}Kb(T|0,G|0,L)|0;a[T+L|0]=0;w=60}}while(0);L78:do{if((w|0)==60){L=(x=0,aK(88,m|0,n|0)|0);if(x){x=0;G=bQ(-1,-1)|0;U=G;G=K;if((a[n]&1)==0){V=U;W=G;break}J2(c[n+8>>2]|0);V=U;W=G;break}c[L>>2]=0;if((a[n]&1)!=0){J2(c[n+8>>2]|0)}L=c[t>>2]|0;c[v>>2]=L;c[t>>2]=m;G=c[d+28>>2]|0;U=y+40|0;J=c[U>>2]|0;X=(c[y+44>>2]|0)-J>>2;do{if((X|0)==0){Y=L}else{Z=o;_=b+24|0;$=G+36|0;aa=G+32|0;ab=b|0;ac=o+8|0;ad=k+8|0;ae=k+4|0;af=o+1|0;ag=o|0;ah=o+4|0;ai=0;aj=J;ak=m;L89:while(1){al=c[aj+(ai<<2)>>2]|0;am=c[(c[al>>2]|0)+20>>2]|0;an=(x=0,ax(32,c[p>>2]|0,ak|0,c[s>>2]|0)|0);if(x){x=0;w=96;break}ao=(x=0,aK(am|0,al|0,an|0)|0);if(x){x=0;w=96;break}an=ao|0;ao=c[t>>2]|0;if(F){c[Z>>2]=c[z>>2];c[Z+4>>2]=c[z+4>>2];c[Z+8>>2]=c[z+8>>2]}else{al=c[ad>>2]|0;am=c[ae>>2]|0;if(am>>>0>4294967279>>>0){w=70;break}if(am>>>0<11>>>0){a[Z]=am<<1;ar=af}else{at=am+16&-16;au=(x=0,as(230,at|0)|0);if(x){x=0;w=96;break}c[ac>>2]=au;c[ag>>2]=at|1;c[ah>>2]=am;ar=au}Kb(ar|0,al|0,am)|0;a[ar+am|0]=0}am=(x=0,aK(88,ao|0,o|0)|0);if(x){x=0;w=101;break}c[am>>2]=an;if((a[Z]&1)!=0){J2(c[ac>>2]|0)}an=c[(c[_>>2]|0)-4>>2]|0;am=c[aa>>2]|0;ao=(c[$>>2]|0)-am>>2;L107:do{if((ao|0)!=0){al=an+28|0;au=an+36|0;at=an+40|0;av=an+32|0;aw=al;ay=0;az=am;while(1){aA=c[az+(ay<<2)>>2]|0;aC=(x=0,aK(c[(c[aA>>2]|0)+16>>2]|0,aA|0,ab|0)|0);if(x){x=0;w=95;break L89}if((aC|0)!=0){c[f>>2]=aC;aA=c[au>>2]|0;if((aA|0)==(c[at>>2]|0)){x=0;aq(476,av|0,f|0);if(x){x=0;w=95;break L89}aD=c[f>>2]|0}else{if((aA|0)==0){aE=0}else{c[aA>>2]=aC;aE=c[au>>2]|0}c[au>>2]=aE+4;aD=aC}x=0;aq(c[c[aw>>2]>>2]|0,al|0,aD|0);if(x){x=0;w=95;break L89}}aC=ay+1|0;if(aC>>>0>=ao>>>0){break L107}ay=aC;az=c[aa>>2]|0}}}while(0);ao=ai+1|0;if(ao>>>0>=X>>>0){w=103;break}ai=ao;aj=c[U>>2]|0;ak=c[t>>2]|0}if((w|0)==70){x=0;ap(232,0);if(x){x=0;w=97;break L78}return 0}else if((w|0)==95){ak=bQ(-1,-1)|0;aF=K;aG=ak;w=98;break L78}else if((w|0)==96){ak=bQ(-1,-1)|0;aF=K;aG=ak;w=98;break L78}else if((w|0)==101){ak=bQ(-1,-1)|0;aj=ak;ak=K;if((a[Z]&1)==0){V=aj;W=ak;break L78}J2(c[ac>>2]|0);V=aj;W=ak;break L78}else if((w|0)==103){Y=c[v>>2]|0;break}}}while(0);c[t>>2]=Y;fQ(m|0,c[m+4>>2]|0);if(F){i=e;return 0}J2(c[k+8>>2]|0);i=e;return 0}}while(0);if((w|0)==97){F=bQ(-1,-1)|0;aF=K;aG=F;w=98}if((w|0)==98){V=aG;W=aF}fQ(m|0,c[m+4>>2]|0);R=V;S=W}else{x=0;w=39}}while(0);if((w|0)==39){w=bQ(-1,-1)|0;R=w;S=K}if((a[k]&1)==0){aH=R;aI=0;aJ=aH;aL=S;be(aJ|0)}J2(c[k+8>>2]|0);aH=R;aI=0;aJ=aH;aL=S;be(aJ|0);return 0}function k_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d|0;f=c[b+32>>2]|0;g=c[b+28>>2]|0;b=f|0;h=f;f=a+8|0;j=a+16|0;k=a+56|0;l=a+24|0;m=g+36|0;n=g+32|0;g=a|0;L1:while(1){a=c[(c[h>>2]|0)+20>>2]|0;o=hz(c[f>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;p=cS[a&1023](b,o)|0;if(!(cA[c[(c[p>>2]|0)+36>>2]&511](p)|0)){break}p=c[(c[l>>2]|0)-4>>2]|0;o=c[n>>2]|0;a=(c[m>>2]|0)-o>>2;if((a|0)==0){continue}q=p+28|0;r=p+36|0;s=p+40|0;t=p+32|0;p=q;u=0;v=o;while(1){o=c[v+(u<<2)>>2]|0;w=cS[c[(c[o>>2]|0)+16>>2]&1023](o|0,g)|0;if((w|0)!=0){c[e>>2]=w;o=c[r>>2]|0;if((o|0)==(c[s>>2]|0)){lM(t,e);x=c[e>>2]|0}else{if((o|0)==0){y=0}else{c[o>>2]=w;y=c[r>>2]|0}c[r>>2]=y+4;x=w}cy[c[c[p>>2]>>2]&1023](q,x)}w=u+1|0;if(w>>>0>=a>>>0){continue L1}u=w;v=c[n>>2]|0}}i=d;return 0}function k$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=J0(48)|0;k=f+8|0;c[k>>2]=j;c[f>>2]=49;c[f+4>>2]=42;Kb(j|0,4512,42)|0;a[j+42|0]=0;j=d+4|0;L1:do{if((a[j]&1)==0){l=g;c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];m=11}else{l=c[d+12>>2]|0;n=c[d+8>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(n>>>0<11>>>0){a[g]=n<<1;o=g+1|0}else{p=n+16&-16;q=(x=0,as(230,p|0)|0);if(x){x=0;break}c[g+8>>2]=q;c[g>>2]=p|1;c[g+4>>2]=n;o=q}Kb(o|0,l|0,n)|0;a[o+n|0]=0;m=11;break L1}}while(0);n=bQ(-1,-1)|0;r=K;s=n}}while(0);do{if((m|0)==11){o=h;j=d+16|0;c[o>>2]=c[j>>2];c[o+4>>2]=c[j+4>>2];c[o+8>>2]=c[j+8>>2];x=0;aT(42,f|0,g|0,h|0,c[b+56>>2]|0);if(x){x=0;j=bQ(-1,-1)|0;o=j;j=K;if((a[g]&1)==0){r=j;s=o;break}J2(c[g+8>>2]|0);r=j;s=o;break}if((a[g]&1)!=0){J2(c[g+8>>2]|0)}if((a[f]&1)==0){i=e;return 0}J2(c[k>>2]|0);i=e;return 0}}while(0);if((a[f]&1)==0){t=s;u=0;v=t;w=r;be(v|0)}J2(c[k>>2]|0);t=s;u=0;v=t;w=r;be(v|0);return 0}function k0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,aq=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0;e=i;i=i+328|0;f=e|0;g=e+8|0;h=e+64|0;j=e+80|0;k=e+96|0;l=e+112|0;m=e+128|0;n=e+144|0;o=e+160|0;p=e+216|0;q=e+272|0;r=e+320|0;s=c[(c[b+48>>2]|0)-4>>2]|0;if((s|0)==0){i=e;return 0}t=c[d+28>>2]|0;d=c[(c[t>>2]|0)+24>>2]|0;u=b+56|0;v=ga(c[b+12>>2]|0,0,c[b+16>>2]|0,c[u>>2]|0,0,0)|0;w=cS[d&1023](t|0,v)|0;v=w+36|0;L4:do{if(((c[w+40>>2]|0)-(c[v>>2]|0)|0)!=4){t=J0(48)|0;d=h+8|0;c[d>>2]=t;c[h>>2]=49;c[h+4>>2]=35;Kb(t|0,3056,35)|0;a[t+35|0]=0;t=w+4|0;L6:do{if((a[t]&1)==0){y=j;c[y>>2]=c[t>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];z=13}else{y=c[w+12>>2]|0;A=c[w+8>>2]|0;do{if(A>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(A>>>0<11>>>0){a[j]=A<<1;B=j+1|0}else{C=A+16&-16;D=(x=0,as(230,C|0)|0);if(x){x=0;break}c[j+8>>2]=D;c[j>>2]=C|1;c[j+4>>2]=A;B=D}Kb(B|0,y|0,A)|0;a[B+A|0]=0;z=13;break L6}}while(0);A=bQ(-1,-1)|0;E=A;F=K}}while(0);do{if((z|0)==13){t=k;A=w+16|0;c[t>>2]=c[A>>2];c[t+4>>2]=c[A+4>>2];c[t+8>>2]=c[A+8>>2];x=0;aT(42,h|0,j|0,k|0,c[u>>2]|0);if(x){x=0;A=bQ(-1,-1)|0;t=A;A=K;if((a[j]&1)==0){E=t;F=A;break}J2(c[j+8>>2]|0);E=t;F=A;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}if((a[h]&1)==0){break L4}J2(c[d>>2]|0);break L4}}while(0);if((a[h]&1)==0){G=E;H=F;I=G;J=0;L=I;M=H;be(L|0)}J2(c[d>>2]|0);G=E;H=F;I=G;J=0;L=I;M=H;be(L|0)}}while(0);F=c[c[v>>2]>>2]|0;v=F+36|0;if((c[v>>2]|0)==0){z=25}else{if((c[F+40>>2]|0)!=0){z=25}}L37:do{if((z|0)==25){E=J0(48)|0;h=l+8|0;c[h>>2]=E;c[l>>2]=49;c[l+4>>2]=36;Kb(E|0,1880,36)|0;a[E+36|0]=0;E=F+4|0;L39:do{if((a[E]&1)==0){j=m;c[j>>2]=c[E>>2];c[j+4>>2]=c[E+4>>2];c[j+8>>2]=c[E+8>>2];z=35}else{j=c[F+12>>2]|0;k=c[F+8>>2]|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(k>>>0<11>>>0){a[m]=k<<1;N=m+1|0}else{w=k+16&-16;B=(x=0,as(230,w|0)|0);if(x){x=0;break}c[m+8>>2]=B;c[m>>2]=w|1;c[m+4>>2]=k;N=B}Kb(N|0,j|0,k)|0;a[N+k|0]=0;z=35;break L39}}while(0);k=bQ(-1,-1)|0;O=k;P=K}}while(0);do{if((z|0)==35){E=n;d=F+16|0;c[E>>2]=c[d>>2];c[E+4>>2]=c[d+4>>2];c[E+8>>2]=c[d+8>>2];x=0;aT(42,l|0,m|0,n|0,c[u>>2]|0);if(x){x=0;d=bQ(-1,-1)|0;E=d;d=K;if((a[m]&1)==0){O=E;P=d;break}J2(c[m+8>>2]|0);O=E;P=d;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}if((a[l]&1)==0){break L37}J2(c[h>>2]|0);break L37}}while(0);if((a[l]&1)==0){G=O;H=P;I=G;J=0;L=I;M=H;be(L|0)}J2(c[h>>2]|0);G=O;H=P;I=G;J=0;L=I;M=H;be(L|0)}}while(0);P=c[v>>2]|0;v=s+36|0;O=(c[s+40>>2]|0)-(c[v>>2]|0)>>2;if((O|0)==0){i=e;return 0}s=p|0;l=p+4|0;m=q+4|0;u=l;n=p+16|0;F=q+16|0;N=p+28|0;d=q+28|0;E=p+29|0;k=q+29|0;j=p+32|0;B=p+36|0;w=p+40|0;A=p+44|0;t=q+40|0;y=q+36|0;D=p+48|0;C=o|0;Q=o+4|0;R=Q;S=o+16|0;T=o+28|0;U=o+29|0;V=o+32|0;W=o+36|0;X=o+40|0;Y=o+44|0;Z=o+48|0;_=g|0;$=g+4|0;aa=$;ab=g+16|0;ac=g+28|0;ad=g+29|0;ae=g+32|0;af=g+36|0;ag=g+40|0;ah=g+44|0;ai=b+60|0;b=g+48|0;aj=q+32|0;ak=q|0;al=q+12|0;am=p+12|0;an=o+12|0;ao=g+12|0;aq=o+8|0;o=$+1|0;ar=$|0;$=g+8|0;at=p+8|0;p=Q+1|0;au=Q|0;Q=q+8|0;av=l+1|0;aw=l|0;l=0;L71:while(1){mg(q,P);ax=c[(c[v>>2]|0)+(l<<2)>>2]|0;c[s>>2]=16616;ay=(a[m]&1)==0;if(ay){c[u>>2]=c[m>>2];c[u+4>>2]=c[m+4>>2];c[u+8>>2]=c[m+8>>2]}else{az=c[al>>2]|0;aA=c[Q>>2]|0;if(aA>>>0>4294967279>>>0){z=50;break}if(aA>>>0<11>>>0){a[u]=aA<<1;aB=av}else{aC=aA+16&-16;aD=(x=0,as(230,aC|0)|0);if(x){x=0;z=151;break}c[am>>2]=aD;c[aw>>2]=aC|1;c[at>>2]=aA;aB=aD}Kb(aB|0,az|0,aA)|0;a[aB+aA|0]=0}c[n>>2]=c[F>>2];c[n+4>>2]=c[F+4>>2];c[n+8>>2]=c[F+8>>2];c[s>>2]=16488;aA=a[d]&1;a[N]=aA;az=a[k]&1;a[E]=az;c[j>>2]=21584;c[B>>2]=0;c[w>>2]=0;c[A>>2]=0;aD=c[t>>2]|0;aC=c[y>>2]|0;aE=aD-aC|0;aF=aE>>2;do{if((aF|0)==0){aG=0;aH=0;aI=aC}else{if(aF>>>0>1073741823>>>0){z=59;break L71}aJ=(x=0,as(230,aE|0)|0);if(x){x=0;z=66;break L71}aK=aJ;c[w>>2]=aK;c[B>>2]=aK;c[A>>2]=aK+(aF<<2);if((aC|0)==(aD|0)){aG=aK;aH=aK;aI=aD;break}else{aL=aC;aM=aK}while(1){if((aM|0)==0){aN=0}else{c[aM>>2]=c[aL>>2];aN=aM}aJ=aN+4|0;c[w>>2]=aJ;aO=aL+4|0;if((aO|0)==(aD|0)){aG=aJ;aH=aK;aI=aC;break}else{aL=aO;aM=aJ}}}}while(0);c[s>>2]=19808;c[j>>2]=19860;c[D>>2]=ax;c[C>>2]=16616;aC=(a[u]&1)==0;if(aC){c[R>>2]=c[u>>2];c[R+4>>2]=c[u+4>>2];c[R+8>>2]=c[u+8>>2]}else{aF=c[am>>2]|0;aE=c[at>>2]|0;if(aE>>>0>4294967279>>>0){z=73;break}if(aE>>>0<11>>>0){a[R]=aE<<1;aQ=p}else{h=aE+16&-16;aK=(x=0,as(230,h|0)|0);if(x){x=0;z=154;break}c[an>>2]=aK;c[au>>2]=h|1;c[aq>>2]=aE;aQ=aK}Kb(aQ|0,aF|0,aE)|0;a[aQ+aE|0]=0}c[S>>2]=c[n>>2];c[S+4>>2]=c[n+4>>2];c[S+8>>2]=c[n+8>>2];c[C>>2]=16488;a[T]=aA;a[U]=az;c[V>>2]=21584;c[W>>2]=0;c[X>>2]=0;c[Y>>2]=0;aE=aH;aF=aG-aE|0;aK=aF>>2;do{if((aK|0)==0){aR=0;aS=0}else{if(aK>>>0>1073741823>>>0){z=82;break L71}h=(x=0,as(230,aF|0)|0);if(x){x=0;z=89;break L71}aJ=h;c[X>>2]=aJ;c[W>>2]=aJ;c[Y>>2]=aJ+(aK<<2);if((aH|0)==(aG|0)){aR=aJ;aS=aJ;break}else{aU=aH;aV=aJ}while(1){if((aV|0)==0){aW=0}else{c[aV>>2]=c[aU>>2];aW=aV}h=aW+4|0;c[X>>2]=h;aO=aU+4|0;if((aO|0)==(aG|0)){aR=h;aS=aJ;break}else{aU=aO;aV=h}}}}while(0);c[C>>2]=19808;c[V>>2]=19860;c[Z>>2]=ax;c[_>>2]=16616;aX=(a[R]&1)==0;if(aX){c[aa>>2]=c[R>>2];c[aa+4>>2]=c[R+4>>2];c[aa+8>>2]=c[R+8>>2]}else{aK=c[an>>2]|0;aF=c[aq>>2]|0;if(aF>>>0>4294967279>>>0){z=96;break}if(aF>>>0<11>>>0){a[aa]=aF<<1;aY=o}else{aJ=aF+16&-16;h=(x=0,as(230,aJ|0)|0);if(x){x=0;z=157;break}c[ao>>2]=h;c[ar>>2]=aJ|1;c[$>>2]=aF;aY=h}Kb(aY|0,aK|0,aF)|0;a[aY+aF|0]=0}c[ab>>2]=c[S>>2];c[ab+4>>2]=c[S+4>>2];c[ab+8>>2]=c[S+8>>2];c[_>>2]=16488;a[ac]=aA;a[ad]=az;c[ae>>2]=21584;c[af>>2]=0;c[ag>>2]=0;c[ah>>2]=0;aZ=aS;aF=aR-aZ|0;aK=aF>>2;do{if((aK|0)!=0){if(aK>>>0>1073741823>>>0){z=105;break L71}h=(x=0,as(230,aF|0)|0);if(x){x=0;z=112;break L71}aJ=h;c[ag>>2]=aJ;c[af>>2]=aJ;c[ah>>2]=aJ+(aK<<2);if((aS|0)==(aR|0)){break}else{a_=aS;a$=aJ}do{if((a$|0)==0){a0=0}else{c[a$>>2]=c[a_>>2];a0=c[ag>>2]|0}a$=a0+4|0;c[ag>>2]=a$;a_=a_+4|0;}while((a_|0)!=(aR|0))}}while(0);c[_>>2]=19808;c[ae>>2]=19860;c[b>>2]=ax;x=0;aP(400,f|0,ai|0,g|0);if(x){x=0;z=126;break}c[ae>>2]=21584;aK=c[af>>2]|0;aF=aK;if((aK|0)!=0){az=c[ag>>2]|0;if((aK|0)!=(az|0)){c[ag>>2]=az+(~((az-4+(-aF|0)|0)>>>2)<<2)}J2(aK)}c[_>>2]=16616;if((a[aa]&1)!=0){J2(c[ao>>2]|0)}c[V>>2]=21584;if((aS|0)!=0){if((aS|0)!=(aR|0)){c[X>>2]=aR+(~((aR-4+(-aZ|0)|0)>>>2)<<2)}J2(aS)}c[C>>2]=16616;if(!aX){J2(c[an>>2]|0)}c[j>>2]=21584;if((aH|0)!=0){if((aH|0)!=(aG|0)){c[w>>2]=aG+(~((aG-4+(-aE|0)|0)>>>2)<<2)}J2(aH)}c[s>>2]=16616;if(!aC){J2(c[am>>2]|0)}c[aj>>2]=21584;aK=aI;if((aI|0)!=0){if((aI|0)!=(aD|0)){c[t>>2]=aD+(~((aD-4+(-aK|0)|0)>>>2)<<2)}J2(aI)}c[ak>>2]=16616;if(!ay){J2(c[al>>2]|0)}Ac(r,0);Ae(r);aK=l+1|0;if(aK>>>0<O>>>0){l=aK}else{z=180;break}}do{if((z|0)==151){l=bQ(-1,-1)|0;a1=K;a2=l;z=153}else if((z|0)==154){l=bQ(-1,-1)|0;a3=K;a4=l;z=156}else if((z|0)==157){l=bQ(-1,-1)|0;a5=K;a6=l;z=159}else if((z|0)==126){l=bQ(-1,-1)|0;O=K;c[ae>>2]=21584;r=c[af>>2]|0;aI=r;if((r|0)!=0){aH=c[ag>>2]|0;if((r|0)!=(aH|0)){c[ag>>2]=aH+(~((aH-4+(-aI|0)|0)>>>2)<<2)}J2(r)}c[_>>2]=16616;if((a[aa]&1)==0){a7=O;a8=l;a9=aZ;z=160;break}J2(c[ao>>2]|0);a7=O;a8=l;a9=aZ;z=160}else if((z|0)==50){x=0;ap(232,0);if(!x){return 0}else{x=0;l=bQ(-1,-1)|0;a1=K;a2=l;z=153;break}}else if((z|0)==59){x=0;ap(152,0);if(!x){return 0}else{x=0;l=bQ(-1,-1)|0;ba=K;bb=l;z=68;break}}else if((z|0)==66){l=bQ(-1,-1)|0;ba=K;bb=l;z=68}else if((z|0)==73){x=0;ap(232,0);if(!x){return 0}else{x=0;l=bQ(-1,-1)|0;a3=K;a4=l;z=156;break}}else if((z|0)==82){x=0;ap(152,0);if(!x){return 0}else{x=0;l=bQ(-1,-1)|0;bc=K;bd=l;z=91;break}}else if((z|0)==89){l=bQ(-1,-1)|0;bc=K;bd=l;z=91}else if((z|0)==96){x=0;ap(232,0);if(!x){return 0}else{x=0;l=bQ(-1,-1)|0;a5=K;a6=l;z=159;break}}else if((z|0)==105){x=0;ap(152,0);if(!x){return 0}else{x=0}l=bQ(-1,-1)|0;O=K;r=c[af>>2]|0;if((r|0)==0){bf=O;bg=l;z=117;break}aI=c[ag>>2]|0;if((r|0)!=(aI|0)){c[ag>>2]=aI+(~((aI-4+(-r|0)|0)>>>2)<<2)}J2(r);bf=O;bg=l;z=117}else if((z|0)==112){l=bQ(-1,-1)|0;bf=K;bg=l;z=117}else if((z|0)==180){i=e;return 0}}while(0);do{if((z|0)==159){a7=a5;a8=a6;a9=aS;z=160}else if((z|0)==68){c[s>>2]=16616;if((a[u]&1)==0){a1=ba;a2=bb;z=153;break}J2(c[am>>2]|0);a1=ba;a2=bb;z=153}else if((z|0)==91){c[C>>2]=16616;if((a[R]&1)==0){a3=bc;a4=bd;z=156;break}J2(c[an>>2]|0);a3=bc;a4=bd;z=156}else if((z|0)==117){c[_>>2]=16616;if((a[aa]&1)==0){a7=bf;a8=bg;a9=aZ;z=160;break}J2(c[ao>>2]|0);a7=bf;a8=bg;a9=aZ;z=160}}while(0);do{if((z|0)==153){bh=a2;bi=a1}else if((z|0)==156){bj=a4;bk=a3;z=166}else if((z|0)==160){aZ=a8;bg=a7;c[V>>2]=21584;if((aS|0)!=0){if((aS|0)!=(aR|0)){c[X>>2]=aR+(~((aR-4+(-a9|0)|0)>>>2)<<2)}J2(aS)}c[C>>2]=16616;if(aX){bj=aZ;bk=bg;z=166;break}J2(c[an>>2]|0);bj=aZ;bk=bg;z=166}}while(0);do{if((z|0)==166){c[j>>2]=21584;an=c[B>>2]|0;aX=an;if((an|0)!=0){C=c[w>>2]|0;if((an|0)!=(C|0)){c[w>>2]=C+(~((C-4+(-aX|0)|0)>>>2)<<2)}J2(an)}c[s>>2]=16616;if((a[u]&1)==0){bh=bj;bi=bk;break}J2(c[am>>2]|0);bh=bj;bi=bk}}while(0);c[aj>>2]=21584;aj=c[y>>2]|0;y=aj;if((aj|0)!=0){bk=c[t>>2]|0;if((aj|0)!=(bk|0)){c[t>>2]=bk+(~((bk-4+(-y|0)|0)>>>2)<<2)}J2(aj)}c[ak>>2]=16616;if(ay){G=bh;H=bi;I=G;J=0;L=I;M=H;be(L|0)}J2(c[al>>2]|0);G=bh;H=bi;I=G;J=0;L=I;M=H;be(L|0);return 0}function k1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+24|0;j=c[b+4>>2]|0;k=J0(72)|0;c[f>>2]=k;l=j+4|0;m=c[l>>2]|0;if((m|0)==(c[j+8>>2]|0)){ee(j|0,f);n=c[f>>2]|0}else{if((m|0)==0){o=0}else{c[m>>2]=k;o=c[l>>2]|0}c[l>>2]=o+4;n=k}k=n;x=0;aq(626,n|0,d|0);if(x){x=0;o=bQ(-1,-1)|0;m=o;o=K;f=c[j>>2]|0;j=c[l>>2]|0;p=f;while(1){if((p|0)==(j|0)){q=j;break}if((c[p>>2]|0)==(n|0)){q=p;break}else{p=p+4|0}}p=q-f>>2;q=f+(p+1<<2)|0;r=j-q|0;Kc(f+(p<<2)|0,q|0,r|0)|0;q=f+((r>>2)+p<<2)|0;p=c[l>>2]|0;if((q|0)!=(p|0)){c[l>>2]=p+(~((p-4+(-q|0)|0)>>>2)<<2)}J2(k);s=o;t=m;u=t;v=0;w=u;y=s;be(w|0)}m=b+16|0;b=c[m>>2]|0;o=d+32|0;if((a[o]&1)==0){k=h;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];z=a[k]|0;A=k}else{k=c[d+40>>2]|0;o=c[d+36>>2]|0;if(o>>>0>4294967279>>>0){CJ(0);return 0}if(o>>>0<11>>>0){q=o<<1&255;p=h;a[p]=q;B=h+1|0;C=q;D=p}else{p=o+16&-16;q=J0(p)|0;c[h+8>>2]=q;l=p|1;c[h>>2]=l;c[h+4>>2]=o;B=q;C=l&255;D=h}Kb(B|0,k|0,o)|0;a[B+o|0]=0;z=C;A=D}D=((c[d+52>>2]|0)==0?1176:560)|0;d=g;Ke(d|0,0,12)|0;C=z&255;if((C&1|0)==0){E=C>>>1}else{E=c[h+4>>2]|0}if((z&1)==0){F=h+1|0}else{F=c[h+8>>2]|0}z=E+3|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=29;break}return 0}else{if(z>>>0<11>>>0){a[d]=E<<1;H=g+1|0}else{C=E+19&-16;o=(x=0,as(230,C|0)|0);if(x){x=0;G=29;break}c[g+8>>2]=o;c[g>>2]=C|1;c[g+4>>2]=E;H=o}Kb(H|0,F|0,E)|0;a[H+E|0]=0;x=0,ax(64,g|0,D|0,3)|0;if(x){x=0;G=29;break}o=(x=0,aK(176,b|0,g|0)|0);if(x){x=0;C=bQ(-1,-1)|0;B=C;C=K;if((a[d]&1)==0){I=C;J=B;break}J2(c[g+8>>2]|0);I=C;J=B;break}c[o>>2]=n;if((a[d]&1)!=0){J2(c[g+8>>2]|0)}if((a[A]&1)==0){L=c[m>>2]|0;M=n+48|0;N=L;c[M>>2]=N;i=e;return 0}J2(c[h+8>>2]|0);L=c[m>>2]|0;M=n+48|0;N=L;c[M>>2]=N;i=e;return 0}}while(0);if((G|0)==29){G=bQ(-1,-1)|0;e=K;if((a[d]&1)!=0){J2(c[g+8>>2]|0)}I=e;J=G}if((a[A]&1)==0){s=I;t=J;u=t;v=0;w=u;y=s;be(w|0)}J2(c[h+8>>2]|0);s=I;t=J;u=t;v=0;w=u;y=s;be(w|0);return 0}function k2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0;e=i;i=i+448|0;f=e|0;g=e+8|0;h=e+24|0;j=e+40|0;k=e+48|0;l=e+56|0;m=e+72|0;n=e+88|0;o=e+104|0;p=e+120|0;q=e+136|0;r=e+152|0;s=e+168|0;t=e+184|0;u=e+200|0;v=e+240|0;w=e+256|0;y=e+272|0;z=e+288|0;A=e+304|0;B=e+320|0;D=e+336|0;E=e+352|0;F=e+368|0;G=e+384|0;H=e+400|0;I=e+416|0;J=e+432|0;L=d+32|0;if((a[L]&1)==0){M=n;c[M>>2]=c[L>>2];c[M+4>>2]=c[L+4>>2];c[M+8>>2]=c[L+8>>2];N=a[M]|0;O=M}else{M=c[d+40>>2]|0;P=c[d+36>>2]|0;if(P>>>0>4294967279>>>0){CJ(0);return 0}if(P>>>0<11>>>0){Q=P<<1&255;R=n;a[R]=Q;S=n+1|0;T=Q;U=R}else{R=P+16&-16;Q=J0(R)|0;c[n+8>>2]=Q;V=R|1;c[n>>2]=V;c[n+4>>2]=P;S=Q;T=V&255;U=n}Kb(S|0,M|0,P)|0;a[S+P|0]=0;N=T;O=U}U=m;Ke(U|0,0,12)|0;T=N&255;if((T&1|0)==0){W=T>>>1}else{W=c[n+4>>2]|0}if((N&1)==0){X=n+1|0}else{X=c[n+8>>2]|0}N=W+3|0;do{if(N>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(N>>>0<11>>>0){a[U]=W<<1;Y=m+1|0}else{T=W+19&-16;P=(x=0,as(230,T|0)|0);if(x){x=0;break}c[m+8>>2]=P;c[m>>2]=T|1;c[m+4>>2]=W;Y=P}Kb(Y|0,X|0,W)|0;a[Y+W|0]=0;x=0,ax(64,m|0,1176,3)|0;if(x){x=0;break}if((a[O]&1)!=0){J2(c[n+8>>2]|0)}P=b+16|0;T=c[P>>2]|0;do{if((a[U]&1)==0){S=o;c[S>>2]=c[U>>2];c[S+4>>2]=c[U+4>>2];c[S+8>>2]=c[U+8>>2];Z=37}else{S=c[m+8>>2]|0;M=c[m+4>>2]|0;if(M>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=86;break}return 0}if(M>>>0<11>>>0){a[o]=M<<1;_=o+1|0}else{V=M+16&-16;Q=(x=0,as(230,V|0)|0);if(x){x=0;Z=86;break}c[o+8>>2]=Q;c[o>>2]=V|1;c[o+4>>2]=M;_=Q}Kb(_|0,S|0,M)|0;a[_+M|0]=0;Z=37}}while(0);L45:do{if((Z|0)==37){M=(x=0,aK(556,T|0,o|0)|0);if(x){x=0;S=bQ(-1,-1)|0;Q=S;S=K;if((a[o]&1)==0){$=Q;aa=S;break}J2(c[o+8>>2]|0);$=Q;aa=S;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}L54:do{if(!M){if((a[L]&1)==0){S=q;c[S>>2]=c[L>>2];c[S+4>>2]=c[L+4>>2];c[S+8>>2]=c[L+8>>2];ab=a[S]|0;ac=S}else{S=c[d+40>>2]|0;Q=c[d+36>>2]|0;if(Q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=86;break L45}return 0}if(Q>>>0<11>>>0){V=Q<<1&255;R=q;a[R]=V;ad=q+1|0;ae=V;af=R}else{R=Q+16&-16;V=(x=0,as(230,R|0)|0);if(x){x=0;Z=86;break L45}c[q+8>>2]=V;ag=R|1;c[q>>2]=ag;c[q+4>>2]=Q;ad=V;ae=ag&255;af=q}Kb(ad|0,S|0,Q)|0;a[ad+Q|0]=0;ab=ae;ac=af}Q=p;Ke(Q|0,0,12)|0;S=q;ag=ab&255;if((ag&1|0)==0){ah=ag>>>1}else{ah=c[q+4>>2]|0}ag=ah+15|0;do{if(ag>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=65;break}return 0}else{if(ag>>>0<11>>>0){a[Q]=30;ai=p+1|0}else{V=ah+31&-16;R=(x=0,as(230,V|0)|0);if(x){x=0;Z=65;break}c[p+8>>2]=R;c[p>>2]=V|1;c[p+4>>2]=15;ai=R}Kb(ai|0,12312,15)|0;a[ai+15|0]=0;if((a[ac]&1)==0){aj=S+1|0}else{aj=c[q+8>>2]|0}x=0,ax(64,p|0,aj|0,ah|0)|0;if(x){x=0;Z=65;break}R=d+4|0;L87:do{if((a[R]&1)==0){V=r;c[V>>2]=c[R>>2];c[V+4>>2]=c[R+4>>2];c[V+8>>2]=c[R+8>>2];Z=77}else{V=c[d+12>>2]|0;ak=c[d+8>>2]|0;do{if(ak>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ak>>>0<11>>>0){a[r]=ak<<1;al=r+1|0}else{am=ak+16&-16;an=(x=0,as(230,am|0)|0);if(x){x=0;break}c[r+8>>2]=an;c[r>>2]=am|1;c[r+4>>2]=ak;al=an}Kb(al|0,V|0,ak)|0;a[al+ak|0]=0;Z=77;break L87}}while(0);ak=bQ(-1,-1)|0;ar=ak;at=K}}while(0);do{if((Z|0)==77){R=s;ak=d+16|0;c[R>>2]=c[ak>>2];c[R+4>>2]=c[ak+4>>2];c[R+8>>2]=c[ak+8>>2];x=0;aT(42,p|0,r|0,s|0,c[b+56>>2]|0);if(x){x=0;ak=bQ(-1,-1)|0;R=ak;ak=K;if((a[r]&1)==0){ar=R;at=ak;break}J2(c[r+8>>2]|0);ar=R;at=ak;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}if((a[Q]&1)!=0){J2(c[p+8>>2]|0)}if((a[ac]&1)==0){break L54}J2(c[q+8>>2]|0);break L54}}while(0);if((a[Q]&1)==0){au=ar;av=at;break}J2(c[p+8>>2]|0);au=ar;av=at}}while(0);if((Z|0)==65){S=bQ(-1,-1)|0;ag=K;if((a[Q]&1)!=0){J2(c[p+8>>2]|0)}au=S;av=ag}if((a[ac]&1)==0){$=au;aa=av;break L45}J2(c[q+8>>2]|0);$=au;aa=av;break L45}}while(0);M=c[P>>2]|0;if((a[U]&1)==0){ag=t;c[ag>>2]=c[U>>2];c[ag+4>>2]=c[U+4>>2];c[ag+8>>2]=c[U+8>>2]}else{ag=c[m+8>>2]|0;S=c[m+4>>2]|0;if(S>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=86;break}return 0}if(S>>>0<11>>>0){a[t]=S<<1;aw=t+1|0}else{ak=S+16&-16;R=(x=0,as(230,ak|0)|0);if(x){x=0;Z=86;break}c[t+8>>2]=R;c[t>>2]=ak|1;c[t+4>>2]=S;aw=R}Kb(aw|0,ag|0,S)|0;a[aw+S|0]=0}S=(x=0,aK(88,M|0,t|0)|0);if(x){x=0;M=bQ(-1,-1)|0;ag=M;M=K;if((a[t]&1)==0){$=ag;aa=M;break}J2(c[t+8>>2]|0);$=ag;aa=M;break}M=c[S>>2]|0;if((a[t]&1)!=0){J2(c[t+8>>2]|0)}S=c[M+28>>2]|0;ag=c[M+44>>2]|0;R=c[d+44>>2]|0;ak=c[(c[R>>2]|0)+20>>2]|0;V=b+8|0;an=b+56|0;am=(x=0,ax(32,c[V>>2]|0,c[P>>2]|0,c[an>>2]|0)|0);if(x){x=0;Z=86;break}ay=(x=0,aK(ak|0,R|0,am|0)|0);if(x){x=0;Z=86;break}am=ay;ay=c[an>>2]|0;R=d+4|0;if((a[R]&1)==0){ak=v;c[ak>>2]=c[R>>2];c[ak+4>>2]=c[R+4>>2];c[ak+8>>2]=c[R+8>>2]}else{ak=c[d+12>>2]|0;az=c[d+8>>2]|0;if(az>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=86;break}return 0}if(az>>>0<11>>>0){a[v]=az<<1;aA=v+1|0}else{aC=az+16&-16;aD=(x=0,as(230,aC|0)|0);if(x){x=0;Z=86;break}c[v+8>>2]=aD;c[v>>2]=aC|1;c[v+4>>2]=az;aA=aD}Kb(aA|0,ak|0,az)|0;a[aA+az|0]=0}az=w;ak=d+16|0;c[az>>2]=c[ak>>2];c[az+4>>2]=c[ak+4>>2];c[az+8>>2]=c[ak+8>>2];L158:do{if((a[L]&1)==0){aD=A;c[aD>>2]=c[L>>2];c[aD+4>>2]=c[L+4>>2];c[aD+8>>2]=c[L+8>>2];aE=a[aD]|0;aF=aD;Z=132}else{aD=c[d+40>>2]|0;aC=c[d+36>>2]|0;do{if(aC>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aC>>>0<11>>>0){aH=aC<<1&255;aI=A;a[aI]=aH;aJ=A+1|0;aL=aH;aM=aI}else{aI=aC+16&-16;aH=(x=0,as(230,aI|0)|0);if(x){x=0;break}c[A+8>>2]=aH;aN=aI|1;c[A>>2]=aN;c[A+4>>2]=aC;aJ=aH;aL=aN&255;aM=A}Kb(aJ|0,aD|0,aC)|0;a[aJ+aC|0]=0;aE=aL;aF=aM;Z=132;break L158}}while(0);aC=bQ(-1,-1)|0;aO=aC;aQ=K}}while(0);do{if((Z|0)==132){aC=z;Ke(aC|0,0,12)|0;aD=A;Q=aE&255;if((Q&1|0)==0){aR=Q>>>1}else{aR=c[A+4>>2]|0}Q=aR+12|0;do{if(Q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=146;break}return 0}else{if(Q>>>0<11>>>0){a[aC]=24;aS=z+1|0}else{aN=aR+28&-16;aH=(x=0,as(230,aN|0)|0);if(x){x=0;Z=146;break}c[z+8>>2]=aH;c[z>>2]=aN|1;c[z+4>>2]=12;aS=aH}Kb(aS|0,11608,12)|0;a[aS+12|0]=0;if((a[aF]&1)==0){aU=aD+1|0}else{aU=c[A+8>>2]|0}x=0,ax(64,z|0,aU|0,aR|0)|0;if(x){x=0;Z=146;break}aH=y;Ke(aH|0,0,12)|0;aN=a[aC]|0;aI=aN&255;if((aI&1|0)==0){aV=aI>>>1}else{aV=c[z+4>>2]|0}if((aN&1)==0){aW=z+1|0}else{aW=c[z+8>>2]|0}aN=aV+1|0;do{if(aN>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=162;break}return 0}else{if(aN>>>0<11>>>0){a[aH]=aV<<1;aX=y+1|0}else{aI=aV+17&-16;aY=(x=0,as(230,aI|0)|0);if(x){x=0;Z=162;break}c[y+8>>2]=aY;c[y>>2]=aI|1;c[y+4>>2]=aV;aX=aY}Kb(aX|0,aW|0,aV)|0;a[aX+aV|0]=0;x=0,ax(64,y|0,10880,1)|0;if(x){x=0;Z=162;break}aY=l;c[aY>>2]=c[az>>2];c[aY+4>>2]=c[az+4>>2];c[aY+8>>2]=c[az+8>>2];x=0;ao(24,u|0,ay|0,v|0,l|0,y|0);if(x){x=0;aY=bQ(-1,-1)|0;aI=aY;aY=K;if((a[aH]&1)==0){aZ=aI;a_=aY;break}J2(c[y+8>>2]|0);aZ=aI;a_=aY;break}if((a[aH]&1)!=0){J2(c[y+8>>2]|0)}if((a[aC]&1)!=0){J2(c[z+8>>2]|0)}if((a[aF]&1)!=0){J2(c[A+8>>2]|0)}if((a[v]&1)!=0){J2(c[v+8>>2]|0)}c[an>>2]=u;aY=B+4|0;c[aY>>2]=0;c[B+8>>2]=0;c[B>>2]=aY;aY=B+12|0;c[aY>>2]=0;c[aY>>2]=c[M+48>>2];aY=d+28|0;L225:do{if((c[aY>>2]|0)==0){Z=260}else{aI=b+4|0;a$=c[aI>>2]|0;a0=(x=0,as(230,72)|0);if(x){x=0;Z=234;break}a1=a0;c[k>>2]=a1;a0=a$+4|0;a2=c[a0>>2]|0;if((a2|0)==(c[a$+8>>2]|0)){x=0;aq(376,a$|0,k|0);if(x){x=0;Z=234;break}a3=c[k>>2]|0}else{if((a2|0)==0){a4=0}else{c[a2>>2]=a1;a4=c[a0>>2]|0}c[a0>>2]=a4+4;a3=a1}a1=a3;a2=a3;L236:do{if((a[R]&1)==0){a5=D;c[a5>>2]=c[R>>2];c[a5+4>>2]=c[R+4>>2];c[a5+8>>2]=c[R+8>>2];Z=191}else{a5=c[d+12>>2]|0;a6=c[d+8>>2]|0;do{if(a6>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(a6>>>0<11>>>0){a[D]=a6<<1;a7=D+1|0}else{a8=a6+16&-16;a9=(x=0,as(230,a8|0)|0);if(x){x=0;break}c[D+8>>2]=a9;c[D>>2]=a8|1;c[D+4>>2]=a6;a7=a9}Kb(a7|0,a5|0,a6)|0;a[a7+a6|0]=0;Z=191;break L236}}while(0);a6=bQ(-1,-1)|0;ba=a6;bb=K}}while(0);do{if((Z|0)==191){a6=E;c[a6>>2]=c[ak>>2];c[a6+4>>2]=c[ak+4>>2];c[a6+8>>2]=c[ak+8>>2];a5=F;a9=F;a[a9]=16;a8=a5+1|0;bc=a8|0;C=1852793664;a[bc]=C;C=C>>8;a[bc+1|0]=C;C=C>>8;a[bc+2|0]=C;C=C>>8;a[bc+3|0]=C;bc=a8+4|0;C=1953391988;a[bc]=C;C=C>>8;a[bc+1|0]=C;C=C>>8;a[bc+2|0]=C;C=C>>8;a[bc+3|0]=C;a[a5+9|0]=0;a5=c[aI>>2]|0;bc=(x=0,as(230,48)|0);L251:do{if(!x){a8=bc;c[j>>2]=a8;bd=a5+4|0;bf=c[bd>>2]|0;if((bf|0)==(c[a5+8>>2]|0)){x=0;aq(376,a5|0,j|0);if(x){x=0;Z=237;break}bg=c[j>>2]|0}else{if((bf|0)==0){bh=0}else{c[bf>>2]=a8;bh=c[bd>>2]|0}c[bd>>2]=bh+4;bg=a8}a8=bg;bf=bg;L261:do{if((a[R]&1)==0){bi=G;c[bi>>2]=c[R>>2];c[bi+4>>2]=c[R+4>>2];c[bi+8>>2]=c[R+8>>2];Z=208}else{bi=c[d+12>>2]|0;bj=c[d+8>>2]|0;do{if(bj>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bj>>>0<11>>>0){a[G]=bj<<1;bk=G+1|0}else{bl=bj+16&-16;bm=(x=0,as(230,bl|0)|0);if(x){x=0;break}c[G+8>>2]=bm;c[G>>2]=bl|1;c[G+4>>2]=bj;bk=bm}Kb(bk|0,bi|0,bj)|0;a[bk+bj|0]=0;Z=208;break L261}}while(0);bj=bQ(-1,-1)|0;bn=K;bo=bj}}while(0);do{if((Z|0)==208){bj=h;c[bj>>2]=c[ak>>2];c[bj+4>>2]=c[ak+4>>2];c[bj+8>>2]=c[ak+8>>2];x=0;aP(452,bf|0,G|0,h|0);do{if(!x){bj=c[aY>>2]|0;bi=g;c[bi>>2]=c[a6>>2];c[bi+4>>2]=c[a6+4>>2];c[bi+8>>2]=c[a6+8>>2];x=0;aG(4,a2|0,D|0,g|0,F|0,bf|0,bj|0,0);if(x){x=0;bp=0;break}if((a[G]&1)!=0){J2(c[G+8>>2]|0)}if((a[a9]&1)!=0){J2(c[F+8>>2]|0)}if((a[D]&1)!=0){J2(c[D+8>>2]|0)}c[a3+48>>2]=c[P>>2];bj=(x=0,as(230,16)|0);if(x){x=0;Z=234;break L225}bi=H+8|0;c[bi>>2]=bj;c[H>>2]=17;c[H+4>>2]=11;Kb(bj|0,10264,11)|0;a[bj+11|0]=0;bj=(x=0,aK(176,B|0,H|0)|0);if(!x){c[bj>>2]=a3;if((a[H]&1)==0){Z=260;break L225}J2(c[bi>>2]|0);Z=260;break L225}else{x=0;bj=bQ(-1,-1)|0;bm=bj;bj=K;if((a[H]&1)==0){bq=bm;br=bj;break L225}J2(c[bi>>2]|0);bq=bm;br=bj;break L225}}else{x=0;bp=1}}while(0);bj=bQ(-1,-1)|0;bm=bj;bj=K;if((a[G]&1)==0){if(bp){bn=bj;bo=bm;break}else{bs=bm;bt=bj;break L251}}else{J2(c[G+8>>2]|0);if(bp){bn=bj;bo=bm;break}else{bs=bm;bt=bj;break L251}}}}while(0);bf=c[a5>>2]|0;bj=c[bd>>2]|0;bm=bf;while(1){if((bm|0)==(bj|0)){bu=bj;break}if((c[bm>>2]|0)==(bg|0)){bu=bm;break}else{bm=bm+4|0}}bm=bu-bf>>2;bi=bf+(bm+1<<2)|0;bl=bj-bi|0;Kc(bf+(bm<<2)|0,bi|0,bl|0)|0;bi=bf+((bl>>2)+bm<<2)|0;bm=c[bd>>2]|0;if((bi|0)!=(bm|0)){c[bd>>2]=bm+(~((bm-4+(-bi|0)|0)>>>2)<<2)}J2(a8);bs=bo;bt=bn}else{x=0;Z=237}}while(0);if((Z|0)==237){a5=bQ(-1,-1)|0;bs=a5;bt=K}if((a[a9]&1)!=0){J2(c[F+8>>2]|0)}if((a[D]&1)==0){ba=bs;bb=bt;break}J2(c[D+8>>2]|0);ba=bs;bb=bt}}while(0);a2=c[a$>>2]|0;aI=c[a0>>2]|0;a5=a2;while(1){if((a5|0)==(aI|0)){bv=aI;break}if((c[a5>>2]|0)==(a3|0)){bv=a5;break}else{a5=a5+4|0}}a5=bv-a2>>2;a$=a2+(a5+1<<2)|0;a6=aI-a$|0;Kc(a2+(a5<<2)|0,a$|0,a6|0)|0;a$=a2+((a6>>2)+a5<<2)|0;a5=c[a0>>2]|0;if((a$|0)!=(a5|0)){c[a0>>2]=a5+(~((a5-4+(-a$|0)|0)>>>2)<<2)}J2(a1);bq=ba;br=bb}}while(0);L321:do{if((Z|0)==260){if((a[L]&1)==0){aY=J;c[aY>>2]=c[L>>2];c[aY+4>>2]=c[L+4>>2];c[aY+8>>2]=c[L+8>>2];bw=a[aY]|0;bx=aY}else{aY=c[d+40>>2]|0;a$=c[d+36>>2]|0;if(a$>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=234;break}return 0}if(a$>>>0<11>>>0){a5=a$<<1&255;a6=J;a[a6]=a5;by=J+1|0;bz=a5;bA=a6}else{a6=a$+16&-16;a5=(x=0,as(230,a6|0)|0);if(x){x=0;Z=234;break}c[J+8>>2]=a5;bc=a6|1;c[J>>2]=bc;c[J+4>>2]=a$;by=a5;bz=bc&255;bA=J}Kb(by|0,aY|0,a$)|0;a[by+a$|0]=0;bw=bz;bx=bA}a$=I;Ke(a$|0,0,12)|0;aY=J;bc=bw&255;if((bc&1|0)==0){bB=bc>>>1}else{bB=c[J+4>>2]|0}bc=bB+6|0;do{if(bc>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=284;break}return 0}else{if(bc>>>0<11>>>0){a[a$]=12;bC=I+1|0}else{a5=bB+22&-16;a6=(x=0,as(230,a5|0)|0);if(x){x=0;Z=284;break}c[I+8>>2]=a6;c[I>>2]=a5|1;c[I+4>>2]=6;bC=a6}a[bC]=a[10040]|0;a[bC+1|0]=a[10041]|0;a[bC+2|0]=a[10042]|0;a[bC+3|0]=a[10043]|0;a[bC+4|0]=a[10044]|0;a[bC+5|0]=a[10045]|0;a[bC+6|0]=0;if((a[bx]&1)==0){bD=aY+1|0}else{bD=c[J+8>>2]|0}x=0,ax(64,I|0,bD|0,bB|0)|0;if(x){x=0;Z=284;break}x=0;aB(22,I|0,ag|0,am|0,c[b+4>>2]|0,B|0,c[V>>2]|0);if(x){x=0;a6=bQ(-1,-1)|0;a5=a6;a6=K;if((a[a$]&1)==0){bE=a5;bF=a6;break}J2(c[I+8>>2]|0);bE=a5;bF=a6;break}if((a[a$]&1)!=0){J2(c[I+8>>2]|0)}if((a[bx]&1)!=0){J2(c[J+8>>2]|0)}a6=c[P>>2]|0;c[P>>2]=B;a5=c[(c[b+24>>2]|0)-4>>2]|0;bi=S+32|0;bm=c[bi>>2]|0;bl=(c[S+36>>2]|0)-bm>>2;L364:do{if((bl|0)!=0){bG=b|0;bH=a5+28|0;bI=a5+36|0;bJ=a5+40|0;bK=a5+32|0;bL=bH;bM=0;bN=bm;while(1){bO=c[bN+(bM<<2)>>2]|0;bP=(x=0,aK(c[(c[bO>>2]|0)+16>>2]|0,bO|0,bG|0)|0);if(x){x=0;break}if((bP|0)!=0){c[f>>2]=bP;bO=c[bI>>2]|0;if((bO|0)==(c[bJ>>2]|0)){x=0;aq(476,bK|0,f|0);if(x){x=0;break}bR=c[f>>2]|0}else{if((bO|0)==0){bS=0}else{c[bO>>2]=bP;bS=c[bI>>2]|0}c[bI>>2]=bS+4;bR=bP}x=0;aq(c[c[bL>>2]>>2]|0,bH|0,bR|0);if(x){x=0;break}}bP=bM+1|0;if(bP>>>0>=bl>>>0){break L364}bM=bP;bN=c[bi>>2]|0}bN=bQ(-1,-1)|0;bT=K;bU=bN;Z=235;break L321}}while(0);c[P>>2]=a6;c[an>>2]=c[u>>2];fQ(B|0,c[B+4>>2]|0);if((a[u+28|0]&1)!=0){J2(c[u+36>>2]|0)}if((a[u+4|0]&1)!=0){J2(c[u+12>>2]|0)}if((a[U]&1)==0){i=e;return 0}J2(c[m+8>>2]|0);i=e;return 0}}while(0);if((Z|0)==284){aY=bQ(-1,-1)|0;bc=K;if((a[a$]&1)!=0){J2(c[I+8>>2]|0)}bE=aY;bF=bc}if((a[bx]&1)==0){bq=bE;br=bF;break}J2(c[J+8>>2]|0);bq=bE;br=bF}}while(0);if((Z|0)==234){bc=bQ(-1,-1)|0;bT=K;bU=bc;Z=235}if((Z|0)==235){bq=bU;br=bT}fQ(B|0,c[B+4>>2]|0);if((a[u+28|0]&1)!=0){J2(c[u+36>>2]|0)}if((a[u+4|0]&1)==0){$=bq;aa=br;break L45}J2(c[u+12>>2]|0);$=bq;aa=br;break L45}}while(0);if((Z|0)==162){aN=bQ(-1,-1)|0;bc=K;if((a[aH]&1)!=0){J2(c[y+8>>2]|0)}aZ=aN;a_=bc}if((a[aC]&1)==0){bV=aZ;bW=a_;break}J2(c[z+8>>2]|0);bV=aZ;bW=a_}}while(0);if((Z|0)==146){aD=bQ(-1,-1)|0;Q=K;if((a[aC]&1)!=0){J2(c[z+8>>2]|0)}bV=aD;bW=Q}if((a[aF]&1)==0){aO=bV;aQ=bW;break}J2(c[A+8>>2]|0);aO=bV;aQ=bW}}while(0);if((a[v]&1)==0){$=aO;aa=aQ;break}J2(c[v+8>>2]|0);$=aO;aa=aQ}}while(0);if((Z|0)==86){P=bQ(-1,-1)|0;$=P;aa=K}if((a[U]&1)==0){bX=$;bY=aa;bZ=bX;b_=0;b$=bZ;b0=bY;be(b$|0)}J2(c[m+8>>2]|0);bX=$;bY=aa;bZ=bX;b_=0;b$=bZ;b0=bY;be(b$|0)}}while(0);aa=bQ(-1,-1)|0;$=K;if((a[U]&1)!=0){J2(c[m+8>>2]|0)}m=aa;aa=$;if((a[O]&1)==0){bX=m;bY=aa;bZ=bX;b_=0;b$=bZ;b0=bY;be(b$|0)}J2(c[n+8>>2]|0);bX=m;bY=aa;bZ=bX;b_=0;b$=bZ;b0=bY;be(b$|0);return 0}function k3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;e=i;i=i+128|0;f=e|0;g=e+16|0;h=e+32|0;j=e+40|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=e+112|0;p=c[b+16>>2]|0;q=J0(16)|0;r=k+8|0;c[r>>2]=q;c[k>>2]=17;c[k+4>>2]=11;Kb(q|0,10264,11)|0;a[q+11|0]=0;q=(x=0,aK(556,p|0,k|0)|0);if(x){x=0;p=bQ(-1,-1)|0;s=p;p=K;if((a[k]&1)==0){t=p;u=s;v=u;w=0;y=v;z=t;be(y|0)}J2(c[r>>2]|0);t=p;u=s;v=u;w=0;y=v;z=t;be(y|0)}if((a[k]&1)!=0){J2(c[r>>2]|0)}if(!q){A=0;i=e;return A|0}q=b+4|0;r=c[q>>2]|0;k=J0(48)|0;c[j>>2]=k;s=r+4|0;p=c[s>>2]|0;if((p|0)==(c[r+8>>2]|0)){ee(r|0,j);B=c[j>>2]|0}else{if((p|0)==0){D=0}else{c[p>>2]=k;D=c[s>>2]|0}c[s>>2]=D+4;B=k}k=B;D=B;p=d+4|0;L21:do{if((a[p]&1)==0){j=l;c[j>>2]=c[p>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];E=22}else{j=c[d+12>>2]|0;F=c[d+8>>2]|0;do{if(F>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(F>>>0<11>>>0){a[l]=F<<1;G=l+1|0}else{H=F+16&-16;I=(x=0,as(230,H|0)|0);if(x){x=0;break}c[l+8>>2]=I;c[l>>2]=H|1;c[l+4>>2]=F;G=I}Kb(G|0,j|0,F)|0;a[G+F|0]=0;E=22;break L21}}while(0);F=bQ(-1,-1)|0;J=K;L=F}}while(0);do{if((E|0)==22){G=m;F=d+16|0;c[G>>2]=c[F>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];j=n;I=n;a[I]=16;H=j+1|0;M=H|0;C=1852793664;a[M]=C;C=C>>8;a[M+1|0]=C;C=C>>8;a[M+2|0]=C;C=C>>8;a[M+3|0]=C;M=H+4|0;C=1953391988;a[M]=C;C=C>>8;a[M+1|0]=C;C=C>>8;a[M+2|0]=C;C=C>>8;a[M+3|0]=C;a[j+9|0]=0;j=c[q>>2]|0;M=(x=0,as(230,56)|0);L36:do{if(!x){H=M;c[h>>2]=H;N=j+4|0;O=c[N>>2]|0;if((O|0)==(c[j+8>>2]|0)){x=0;aq(376,j|0,h|0);if(x){x=0;E=49;break}P=c[h>>2]|0}else{if((O|0)==0){Q=0}else{c[O>>2]=H;Q=c[N>>2]|0}c[N>>2]=Q+4;P=H}H=P;O=P;L46:do{if((a[p]&1)==0){R=o;c[R>>2]=c[p>>2];c[R+4>>2]=c[p+4>>2];c[R+8>>2]=c[p+8>>2];E=39}else{R=c[d+12>>2]|0;S=c[d+8>>2]|0;do{if(S>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(S>>>0<11>>>0){a[o]=S<<1;T=o+1|0}else{U=S+16&-16;V=(x=0,as(230,U|0)|0);if(x){x=0;break}c[o+8>>2]=V;c[o>>2]=U|1;c[o+4>>2]=S;T=V}Kb(T|0,R|0,S)|0;a[T+S|0]=0;E=39;break L46}}while(0);S=bQ(-1,-1)|0;W=S;X=K}}while(0);do{if((E|0)==39){S=g;c[S>>2]=c[F>>2];c[S+4>>2]=c[F+4>>2];c[S+8>>2]=c[F+8>>2];x=0;aP(44,O|0,o|0,g|0);do{if(!x){S=f;c[S>>2]=c[G>>2];c[S+4>>2]=c[G+4>>2];c[S+8>>2]=c[G+8>>2];x=0;aB(38,D|0,l|0,f|0,n|0,O|0,0);if(x){x=0;Y=0;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[I]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}A=cS[c[(c[B>>2]|0)+16>>2]&1023](D,b|0)|0;i=e;return A|0}else{x=0;Y=1}}while(0);S=bQ(-1,-1)|0;R=S;S=K;if((a[o]&1)==0){if(Y){W=R;X=S;break}else{Z=S;_=R;break L36}}else{J2(c[o+8>>2]|0);if(Y){W=R;X=S;break}else{Z=S;_=R;break L36}}}}while(0);O=c[j>>2]|0;R=c[N>>2]|0;S=O;while(1){if((S|0)==(R|0)){$=R;break}if((c[S>>2]|0)==(P|0)){$=S;break}else{S=S+4|0}}S=$-O>>2;V=O+(S+1<<2)|0;U=R-V|0;Kc(O+(S<<2)|0,V|0,U|0)|0;V=O+((U>>2)+S<<2)|0;S=c[N>>2]|0;if((V|0)!=(S|0)){c[N>>2]=S+(~((S-4+(-V|0)|0)>>>2)<<2)}J2(H);Z=X;_=W}else{x=0;E=49}}while(0);if((E|0)==49){j=bQ(-1,-1)|0;Z=K;_=j}if((a[I]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)==0){J=Z;L=_;break}J2(c[l+8>>2]|0);J=Z;L=_}}while(0);_=c[r>>2]|0;r=c[s>>2]|0;Z=_;while(1){if((Z|0)==(r|0)){aa=r;break}if((c[Z>>2]|0)==(B|0)){aa=Z;break}else{Z=Z+4|0}}Z=aa-_>>2;aa=_+(Z+1<<2)|0;B=r-aa|0;Kc(_+(Z<<2)|0,aa|0,B|0)|0;aa=_+((B>>2)+Z<<2)|0;Z=c[s>>2]|0;if((aa|0)!=(Z|0)){c[s>>2]=Z+(~((Z-4+(-aa|0)|0)>>>2)<<2)}J2(k);t=J;u=L;v=u;w=0;y=v;z=t;be(y|0);return 0}function k4(a,b){a=a|0;b=b|0;return lB(a,b)|0}function k5(a){a=a|0;fR(a);return}function k6(a){a=a|0;var b=0;x=0;ap(530,a|0);if(!x){J2(a);return}else{x=0;b=bQ(-1,-1)|0;J2(a);be(b|0)}}function k7(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function k8(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function k9(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function la(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lb(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lc(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function ld(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function le(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lf(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lg(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lh(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function li(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lj(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lk(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function ll(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lm(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function ln(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lo(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lp(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lq(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lr(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function ls(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lt(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lu(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lv(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lw(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lx(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function ly(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lz(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lA(a,b){a=a|0;b=b|0;return lB(a,b|0)|0}function lB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0;e=i;i=i+160|0;f=e|0;g=e+16|0;h=e+32|0;j=e+40|0;k=e+56|0;l=e+64|0;m=e+80|0;n=e+96|0;o=e+112|0;p=e+128|0;q=e+144|0;r=J0(64)|0;s=l+8|0;c[s>>2]=r;c[l>>2]=65;c[l+4>>2]=62;Kb(r|0,9856,62)|0;a[r+62|0]=0;r=d+4|0;L1:do{if((a[r]&1)==0){t=m;c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];u=11}else{t=c[d+12>>2]|0;v=c[d+8>>2]|0;do{if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(v>>>0<11>>>0){a[m]=v<<1;w=m+1|0}else{y=v+16&-16;z=(x=0,as(230,y|0)|0);if(x){x=0;break}c[m+8>>2]=z;c[m>>2]=y|1;c[m+4>>2]=v;w=z}Kb(w|0,t|0,v)|0;a[w+v|0]=0;u=11;break L1}}while(0);v=bQ(-1,-1)|0;A=v;B=K}}while(0);do{if((u|0)==11){w=n;r=d+16|0;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];x=0;aT(42,l|0,m|0,n|0,c[b+56>>2]|0);if(x){x=0;r=bQ(-1,-1)|0;w=r;r=K;if((a[m]&1)==0){A=w;B=r;break}J2(c[m+8>>2]|0);A=w;B=r;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}if((a[l]&1)!=0){J2(c[s>>2]|0)}r=b+4|0;w=c[r>>2]|0;v=J0(52)|0;c[k>>2]=v;t=w+4|0;z=c[t>>2]|0;if((z|0)==(c[w+8>>2]|0)){ee(w|0,k);C=c[k>>2]|0}else{if((z|0)==0){D=0}else{c[z>>2]=v;D=c[t>>2]|0}c[t>>2]=D+4;C=v}v=C;z=C;y=o;a[y]=0;a[o+1|0]=0;E=(x=0,as(230,32)|0);if(!x){Kb(E|0,9600,24)|0;a[E+24|0]=0;L35:do{if((d|0)==0){x=0;aQ(10);if(!x){return 0}else{x=0;F=bQ(-1,-1)|0;G=K;H=F;u=58;break}}else{F=c[(c[(c[d>>2]|0)-4>>2]|0)+4>>2]|0;I=p;Ke(I|0,0,12)|0;J=Kf(F|0)|0;L=J+24|0;do{if(L>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(L>>>0<11>>>0){a[I]=48;M=p+1|0}else{N=J+40&-16;O=(x=0,as(230,N|0)|0);if(x){x=0;break}c[p+8>>2]=O;c[p>>2]=N|1;c[p+4>>2]=24;M=O}Kb(M|0,E|0,24)|0;a[M+24|0]=0;x=0,ax(64,p|0,F|0,J|0)|0;if(x){x=0;break}c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;x=0;ao(26,z|0,o|0,j|0,p|0,0);if(x){x=0;O=bQ(-1,-1)|0;N=O;O=K;if((a[I]&1)==0){P=N;Q=O;break L35}J2(c[p+8>>2]|0);P=N;Q=O;break L35}if((a[I]&1)!=0){J2(c[p+8>>2]|0)}J2(E);if((a[y]&1)!=0){J2(c[o+8>>2]|0)}O=c[r>>2]|0;N=J0(32)|0;c[h>>2]=N;R=O+4|0;S=c[R>>2]|0;if((S|0)==(c[O+8>>2]|0)){ee(O|0,h);T=c[h>>2]|0}else{if((S|0)==0){U=0}else{c[S>>2]=N;U=c[R>>2]|0}c[R>>2]=U+4;T=N}N=T;S=q;a[S]=0;a[q+1|0]=0;V=f;W=T;c[V>>2]=c[S>>2];c[V+4>>2]=c[S+4>>2];c[V+8>>2]=c[S+8>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;x=0;aP(402,W|0,f|0,g|0);if(!x){if((a[V]&1)==0){X=T|0;c[X>>2]=16672;Y=T+28|0;Z=C;c[Y>>2]=Z;i=e;return W|0}J2(c[f+8>>2]|0);X=T|0;c[X>>2]=16672;Y=T+28|0;Z=C;c[Y>>2]=Z;i=e;return W|0}else{x=0}W=bQ(-1,-1)|0;S=K;if((a[V]&1)!=0){J2(c[f+8>>2]|0)}V=W;W=S;S=c[O>>2]|0;O=c[R>>2]|0;_=S;while(1){if((_|0)==(O|0)){$=O;break}if((c[_>>2]|0)==(T|0)){$=_;break}else{_=_+4|0}}_=$-S>>2;aa=S+(_+1<<2)|0;ab=O-aa|0;Kc(S+(_<<2)|0,aa|0,ab|0)|0;aa=S+((ab>>2)+_<<2)|0;_=c[R>>2]|0;if((aa|0)!=(_|0)){c[R>>2]=_+(~((_-4+(-aa|0)|0)>>>2)<<2)}J2(N);ac=V;ad=W;ae=ac;af=0;ag=ae;ah=ad;be(ag|0)}}while(0);J=bQ(-1,-1)|0;F=K;if((a[I]&1)==0){G=F;H=J;u=58;break}J2(c[p+8>>2]|0);G=F;H=J;u=58}}while(0);if((u|0)==58){P=H;Q=G}J2(E);ai=P;aj=Q}else{x=0;r=bQ(-1,-1)|0;ai=r;aj=K}if((a[y]&1)!=0){J2(c[o+8>>2]|0)}r=c[w>>2]|0;z=c[t>>2]|0;J=r;while(1){if((J|0)==(z|0)){ak=z;break}if((c[J>>2]|0)==(C|0)){ak=J;break}else{J=J+4|0}}J=ak-r>>2;w=r+(J+1<<2)|0;y=z-w|0;Kc(r+(J<<2)|0,w|0,y|0)|0;w=r+((y>>2)+J<<2)|0;J=c[t>>2]|0;if((w|0)!=(J|0)){c[t>>2]=J+(~((J-4+(-w|0)|0)>>>2)<<2)}J2(v);ac=ai;ad=aj;ae=ac;af=0;ag=ae;ah=ad;be(ag|0)}}while(0);if((a[l]&1)==0){ac=A;ad=B;ae=ac;af=0;ag=ae;ah=ad;be(ag|0)}J2(c[s>>2]|0);ac=A;ad=B;ae=ac;af=0;ag=ae;ah=ad;be(ag|0);return 0}function lC(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function lD(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function lE(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+48>>2]&1023](b,a);return}function lF(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+48>>2]&1023](b,a)|0}function lG(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+48>>2]&1023](b,a)|0}function lH(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+48>>2]&1023](b,a)|0}function lI(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+48>>2]&1023](b,a)|0}function lJ(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+48>>2]&511](a,d,b);return}function lK(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+48>>2]&511](a,d,b);return}function lL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=b+4|0;f=e|0;g=c[f>>2]|0;if((g|0)==0){h=f;i=e}else{e=d|0;f=g;while(1){if(dh(e,f+16|0)|0){g=f|0;j=c[g>>2]|0;if((j|0)==0){h=g;i=f;break}else{f=j;continue}}else{j=f+4|0;g=c[j>>2]|0;if((g|0)==0){h=j;i=f;break}else{f=g;continue}}}}f=J0(68)|0;e=f;g=f+16|0;do{if((g|0)!=0){x=0;aq(322,g|0,d|0);if(!x){c[f+64>>2]=c[d+48>>2];break}else{x=0}j=bQ(-1,-1)|0;if((f|0)==0){be(j|0)}J2(f);be(j|0)}}while(0);d=f;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=i;c[h>>2]=d;i=b|0;f=c[c[i>>2]>>2]|0;if((f|0)==0){k=d}else{c[i>>2]=f;k=c[h>>2]|0}es(c[b+4>>2]|0,k);k=b+8|0;c[k>>2]=(c[k>>2]|0)+1;c[a>>2]=e;return}function lM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function lN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function lO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function lP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function lQ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=J0(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];x=0;aT(6,m|0,k|0,l|0,h|0);if(x){x=0;h=bQ(-1,-1)|0;l=h;h=K;if((a[k]&1)==0){r=h;s=l;t=s;u=0;v=t;w=r;be(v|0)}J2(c[k+8>>2]|0);r=h;s=l;t=s;u=0;v=t;w=r;be(v|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}k=b|0;c[k>>2]=21728;l=b+32|0;h=f;if((a[h]&1)==0){m=l;c[m>>2]=c[h>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];y=b+44|0;c[y>>2]=g;i=j;return}h=c[f+8>>2]|0;m=c[f+4>>2]|0;do{if(m>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(m>>>0<11>>>0){a[l]=m<<1;z=l+1|0}else{f=m+16&-16;p=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=p;c[l>>2]=f|1;c[b+36>>2]=m;z=p}Kb(z|0,h|0,m)|0;a[z+m|0]=0;y=b+44|0;c[y>>2]=g;i=j;return}}while(0);j=bQ(-1,-1)|0;g=j;j=K;c[k>>2]=16616;if((a[b+4|0]&1)==0){r=j;s=g;t=s;u=0;v=t;w=r;be(v|0)}J2(c[b+12>>2]|0);r=j;s=g;t=s;u=0;v=t;w=r;be(v|0)}function lR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=J0(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];x=0;aP(402,k|0,h|0,j|0);if(!x){if((a[h]&1)==0){p=b|0;c[p>>2]=16192;q=b+28|0;c[q>>2]=f;i=g;return}J2(c[h+8>>2]|0);p=b|0;c[p>>2]=16192;q=b+28|0;c[q>>2]=f;i=g;return}else{x=0;g=bQ(-1,-1)|0;if((a[h]&1)==0){be(g|0)}J2(c[h+8>>2]|0);be(g|0)}}function lS(b){b=b|0;var d=0;d=b|0;c[d>>2]=21728;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function lT(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=21728;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function lU(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+88>>2]&1023](b,a);return}function lV(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+88>>2]&1023](b,a)|0}function lW(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+88>>2]&1023](b,a)|0}function lX(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+88>>2]&1023](b,a)|0}function lY(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+88>>2]&1023](b,a)|0}function lZ(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+88>>2]&511](a,d,b);return}function l_(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+88>>2]&511](a,d,b);return}function l$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=d;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+8>>2]|0;j=c[d+4>>2]|0;if(j>>>0>4294967279>>>0){CJ(0)}if(j>>>0<11>>>0){d=j<<1&255;n=h;a[n]=d;o=h+1|0;p=d;q=n}else{n=j+16&-16;d=J0(n)|0;c[h+8>>2]=d;r=n|1;c[h>>2]=r;c[h+4>>2]=j;o=d;p=r&255;q=h}Kb(o|0,k|0,j)|0;a[o+j|0]=0;l=p;m=q}q=e;e=g;c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];q=g;g=b|0;c[g>>2]=16616;e=b+4|0;L12:do{if((l&1)==0){p=e;c[p>>2]=c[m>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2]}else{p=c[h+8>>2]|0;j=c[h+4>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(j>>>0<11>>>0){a[e]=j<<1;s=e+1|0}else{o=j+16&-16;k=(x=0,as(230,o|0)|0);if(x){x=0;break}c[b+12>>2]=k;c[e>>2]=o|1;c[b+8>>2]=j;s=k}Kb(s|0,p|0,j)|0;a[s+j|0]=0;break L12}}while(0);j=bQ(-1,-1)|0;if((a[m]&1)==0){be(j|0)}J2(p);be(j|0)}}while(0);s=b+16|0;c[s>>2]=c[q>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];if((a[m]&1)==0){t=b+28|0;u=b+32|0;c[u>>2]=0;v=b+36|0;c[v>>2]=0;w=b+40|0;c[w>>2]=0;c[g>>2]=21648;c[t>>2]=21696;y=b+44|0;a[y]=0;z=b+45|0;a[z]=0;i=f;return}J2(c[h+8>>2]|0);t=b+28|0;u=b+32|0;c[u>>2]=0;v=b+36|0;c[v>>2]=0;w=b+40|0;c[w>>2]=0;c[g>>2]=21648;c[t>>2]=21696;y=b+44|0;a[y]=0;z=b+45|0;a[z]=0;i=f;return}function l0(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+28>>2]=21456;d=c[b+32>>2]|0;e=d;if((d|0)!=0){f=b+36|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function l1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+28>>2]=21456;d=c[b+32>>2]|0;e=d;if((d|0)!=0){f=b+36|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){h=b;J2(h);return}J2(c[b+12>>2]|0);h=b;J2(h);return}function l2(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+156>>2]&1023](b,a);return}function l3(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+156>>2]&1023](b,a)|0}function l4(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+156>>2]&1023](b,a)|0}function l5(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+156>>2]&1023](b,a)|0}function l6(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+156>>2]&1023](b,a)|0}function l7(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+156>>2]&511](a,d,b);return}function l8(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+156>>2]&511](a,d,b);return}function l9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+240|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;if((c[d+40>>2]|0)!=0){L3:do{if((a[b+45|0]&1)!=0){v=J0(80)|0;w=f+8|0;c[w>>2]=v;c[f>>2]=81;c[f+4>>2]=71;Kb(v|0,8384,71)|0;a[v+71|0]=0;v=d+4|0;L5:do{if((a[v]&1)==0){y=g;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];z=13}else{y=c[d+12>>2]|0;A=c[d+8>>2]|0;do{if(A>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(A>>>0<11>>>0){a[g]=A<<1;B=g+1|0}else{C=A+16&-16;D=(x=0,as(230,C|0)|0);if(x){x=0;break}c[g+8>>2]=D;c[g>>2]=C|1;c[g+4>>2]=A;B=D}Kb(B|0,y|0,A)|0;a[B+A|0]=0;z=13;break L5}}while(0);A=bQ(-1,-1)|0;E=K;F=A}}while(0);do{if((z|0)==13){v=h;A=d+16|0;c[v>>2]=c[A>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];x=0;aP(362,f|0,g|0,h|0);if(x){x=0;A=bQ(-1,-1)|0;v=A;A=K;if((a[g]&1)==0){E=A;F=v;break}J2(c[g+8>>2]|0);E=A;F=v;break}if((a[g]&1)!=0){J2(c[g+8>>2]|0)}if((a[f]&1)==0){break L3}J2(c[w>>2]|0);break L3}}while(0);if((a[f]&1)==0){G=E;H=F;I=H;J=0;L=I;M=G;be(L|0)}J2(c[w>>2]|0);G=E;H=F;I=H;J=0;L=I;M=G;be(L|0)}}while(0);a[b+44|0]=1;i=e;return}F=b+45|0;E=(a[F]&1)!=0;if((a[d+44|0]&1)!=0){L38:do{if(E){f=J0(80)|0;g=j+8|0;c[g>>2]=f;c[j>>2]=81;c[j+4>>2]=72;Kb(f|0,8064,72)|0;a[f+72|0]=0;f=d+4|0;L40:do{if((a[f]&1)==0){h=k;c[h>>2]=c[f>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];z=36}else{h=c[d+12>>2]|0;B=c[d+8>>2]|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(B>>>0<11>>>0){a[k]=B<<1;N=k+1|0}else{v=B+16&-16;A=(x=0,as(230,v|0)|0);if(x){x=0;break}c[k+8>>2]=A;c[k>>2]=v|1;c[k+4>>2]=B;N=A}Kb(N|0,h|0,B)|0;a[N+B|0]=0;z=36;break L40}}while(0);B=bQ(-1,-1)|0;O=K;P=B}}while(0);do{if((z|0)==36){f=l;w=d+16|0;c[f>>2]=c[w>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];x=0;aP(362,j|0,k|0,l|0);if(x){x=0;w=bQ(-1,-1)|0;f=w;w=K;if((a[k]&1)==0){O=w;P=f;break}J2(c[k+8>>2]|0);O=w;P=f;break}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((a[j]&1)==0){break L38}J2(c[g>>2]|0);break L38}}while(0);if((a[j]&1)==0){G=O;H=P;I=H;J=0;L=I;M=G;be(L|0)}J2(c[g>>2]|0);G=O;H=P;I=H;J=0;L=I;M=G;be(L|0)}}while(0);L69:do{if((a[b+44|0]&1)!=0){P=J0(80)|0;O=m+8|0;c[O>>2]=P;c[m>>2]=81;c[m+4>>2]=71;Kb(P|0,8384,71)|0;a[P+71|0]=0;P=d+4|0;L71:do{if((a[P]&1)==0){j=n;c[j>>2]=c[P>>2];c[j+4>>2]=c[P+4>>2];c[j+8>>2]=c[P+8>>2];z=57}else{j=c[d+12>>2]|0;k=c[d+8>>2]|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(k>>>0<11>>>0){a[n]=k<<1;Q=n+1|0}else{l=k+16&-16;N=(x=0,as(230,l|0)|0);if(x){x=0;break}c[n+8>>2]=N;c[n>>2]=l|1;c[n+4>>2]=k;Q=N}Kb(Q|0,j|0,k)|0;a[Q+k|0]=0;z=57;break L71}}while(0);k=bQ(-1,-1)|0;R=K;S=k}}while(0);do{if((z|0)==57){P=o;g=d+16|0;c[P>>2]=c[g>>2];c[P+4>>2]=c[g+4>>2];c[P+8>>2]=c[g+8>>2];x=0;aP(362,m|0,n|0,o|0);if(x){x=0;g=bQ(-1,-1)|0;P=g;g=K;if((a[n]&1)==0){R=g;S=P;break}J2(c[n+8>>2]|0);R=g;S=P;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[m]&1)==0){break L69}J2(c[O>>2]|0);break L69}}while(0);if((a[m]&1)==0){G=R;H=S;I=H;J=0;L=I;M=G;be(L|0)}J2(c[O>>2]|0);G=R;H=S;I=H;J=0;L=I;M=G;be(L|0)}}while(0);a[F]=1;i=e;return}L102:do{if(E){F=J0(64)|0;S=p+8|0;c[S>>2]=F;c[p>>2]=65;c[p+4>>2]=59;Kb(F|0,7864,59)|0;a[F+59|0]=0;F=d+4|0;L104:do{if((a[F]&1)==0){R=q;c[R>>2]=c[F>>2];c[R+4>>2]=c[F+4>>2];c[R+8>>2]=c[F+8>>2];z=79}else{R=c[d+12>>2]|0;m=c[d+8>>2]|0;do{if(m>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(m>>>0<11>>>0){a[q]=m<<1;T=q+1|0}else{n=m+16&-16;o=(x=0,as(230,n|0)|0);if(x){x=0;break}c[q+8>>2]=o;c[q>>2]=n|1;c[q+4>>2]=m;T=o}Kb(T|0,R|0,m)|0;a[T+m|0]=0;z=79;break L104}}while(0);m=bQ(-1,-1)|0;U=K;V=m}}while(0);do{if((z|0)==79){F=r;O=d+16|0;c[F>>2]=c[O>>2];c[F+4>>2]=c[O+4>>2];c[F+8>>2]=c[O+8>>2];x=0;aP(362,p|0,q|0,r|0);if(x){x=0;O=bQ(-1,-1)|0;F=O;O=K;if((a[q]&1)==0){U=O;V=F;break}J2(c[q+8>>2]|0);U=O;V=F;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((a[p]&1)==0){break L102}J2(c[S>>2]|0);break L102}}while(0);if((a[p]&1)==0){G=U;H=V;I=H;J=0;L=I;M=G;be(L|0)}J2(c[S>>2]|0);G=U;H=V;I=H;J=0;L=I;M=G;be(L|0)}}while(0);if((a[b+44|0]&1)==0){i=e;return}b=J0(64)|0;V=s+8|0;c[V>>2]=b;c[s>>2]=65;c[s+4>>2]=52;Kb(b|0,7720,52)|0;a[b+52|0]=0;b=d+4|0;L136:do{if((a[b]&1)==0){U=t;c[U>>2]=c[b>>2];c[U+4>>2]=c[b+4>>2];c[U+8>>2]=c[b+8>>2];z=100}else{U=c[d+12>>2]|0;p=c[d+8>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(p>>>0<11>>>0){a[t]=p<<1;W=t+1|0}else{q=p+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;break}c[t+8>>2]=r;c[t>>2]=q|1;c[t+4>>2]=p;W=r}Kb(W|0,U|0,p)|0;a[W+p|0]=0;z=100;break L136}}while(0);p=bQ(-1,-1)|0;X=K;Y=p}}while(0);do{if((z|0)==100){W=u;b=d+16|0;c[W>>2]=c[b>>2];c[W+4>>2]=c[b+4>>2];c[W+8>>2]=c[b+8>>2];x=0;aP(362,s|0,t|0,u|0);if(x){x=0;b=bQ(-1,-1)|0;W=b;b=K;if((a[t]&1)==0){X=b;Y=W;break}J2(c[t+8>>2]|0);X=b;Y=W;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}if((a[s]&1)==0){i=e;return}J2(c[V>>2]|0);i=e;return}}while(0);if((a[s]&1)==0){G=X;H=Y;I=H;J=0;L=I;M=G;be(L|0)}J2(c[V>>2]|0);G=X;H=Y;I=H;J=0;L=I;M=G;be(L|0)}function ma(a,b){a=a|0;b=b|0;l9(a-48+20|0,b);return}function mb(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-48+20|0;c[d+28>>2]=21456;b=c[d+32>>2]|0;e=b;if((b|0)!=0){f=d+36|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){return}J2(c[d+12>>2]|0);return}function mc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-48+20|0;c[d+28>>2]=21456;b=c[d+32>>2]|0;e=b;if((b|0)!=0){f=d+36|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){h=d;J2(h);return}J2(c[d+12>>2]|0);h=d;J2(h);return}function md(a,b){a=a|0;b=b|0;return}function me(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=i;i=i+32|0;l=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=b|0;o=d;if((a[o]&1)==0){p=l;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{o=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){CJ(0)}if(p>>>0<11>>>0){a[l]=p<<1;q=l+1|0}else{d=p+16&-16;r=J0(d)|0;c[l+8>>2]=r;c[l>>2]=d|1;c[l+4>>2]=p;q=r}Kb(q|0,o|0,p)|0;a[q+p|0]=0}p=m;q=e;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];x=0;aT(6,n|0,l|0,m|0,h|0);if(x){x=0;h=bQ(-1,-1)|0;m=h;h=K;if((a[l]&1)==0){s=h;t=m;u=t;v=0;w=u;y=s;be(w|0)}J2(c[l+8>>2]|0);s=h;t=m;u=t;v=0;w=u;y=s;be(w|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}l=b|0;c[l>>2]=21864;m=b+32|0;h=f;if((a[h]&1)==0){n=m;c[n>>2]=c[h>>2];c[n+4>>2]=c[h+4>>2];c[n+8>>2]=c[h+8>>2];z=b+44|0;c[z>>2]=g;A=b+48|0;c[A>>2]=0;B=b+52|0;c[B>>2]=j;C=b+56|0;c[C>>2]=0;D=b+60|0;c[D>>2]=0;E=b+64|0;a[E]=0;F=b+68|0;c[F>>2]=0;i=k;return}h=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(n>>>0<11>>>0){a[m]=n<<1;G=m+1|0}else{f=n+16&-16;q=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=q;c[m>>2]=f|1;c[b+36>>2]=n;G=q}Kb(G|0,h|0,n)|0;a[G+n|0]=0;z=b+44|0;c[z>>2]=g;A=b+48|0;c[A>>2]=0;B=b+52|0;c[B>>2]=j;C=b+56|0;c[C>>2]=0;D=b+60|0;c[D>>2]=0;E=b+64|0;a[E]=0;F=b+68|0;c[F>>2]=0;i=k;return}}while(0);k=bQ(-1,-1)|0;F=k;k=K;c[l>>2]=16616;if((a[b+4|0]&1)==0){s=k;t=F;u=t;v=0;w=u;y=s;be(w|0)}J2(c[b+12>>2]|0);s=k;t=F;u=t;v=0;w=u;y=s;be(w|0)}function mf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=b|0;c[e>>2]=16616;f=b+4|0;g=d+4|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2]}else{g=c[d+12>>2]|0;h=c[d+8>>2]|0;if(h>>>0>4294967279>>>0){CJ(0)}if(h>>>0<11>>>0){a[f]=h<<1;i=f+1|0}else{j=h+16&-16;k=J0(j)|0;c[b+12>>2]=k;c[f>>2]=j|1;c[b+8>>2]=h;i=k}Kb(i|0,g|0,h)|0;a[i+h|0]=0}h=b+16|0;i=d+16|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];c[e>>2]=16192;c[b+28>>2]=c[d+28>>2];c[e>>2]=21864;i=b+32|0;h=d+32|0;L12:do{if((a[h]&1)==0){g=i;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2]}else{g=c[d+40>>2]|0;k=c[d+36>>2]|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(k>>>0<11>>>0){a[i]=k<<1;l=i+1|0}else{j=k+16&-16;m=(x=0,as(230,j|0)|0);if(x){x=0;break}c[b+40>>2]=m;c[i>>2]=j|1;c[b+36>>2]=k;l=m}Kb(l|0,g|0,k)|0;a[l+k|0]=0;break L12}}while(0);k=bQ(-1,-1)|0;c[e>>2]=16616;if((a[f]&1)==0){be(k|0)}J2(c[b+12>>2]|0);be(k|0)}}while(0);c[b+44>>2]=c[d+44>>2];c[b+48>>2]=c[d+48>>2];c[b+52>>2]=c[d+52>>2];c[b+56>>2]=c[d+56>>2];c[b+60>>2]=c[d+60>>2];a[b+64|0]=a[d+64|0]&1;c[b+68>>2]=c[d+68>>2];return}function mg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=b|0;c[e>>2]=16616;f=b+4|0;g=d+4|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2]}else{g=c[d+12>>2]|0;h=c[d+8>>2]|0;if(h>>>0>4294967279>>>0){CJ(0)}if(h>>>0<11>>>0){a[f]=h<<1;i=f+1|0}else{j=h+16&-16;k=J0(j)|0;c[b+12>>2]=k;c[f>>2]=j|1;c[b+8>>2]=h;i=k}Kb(i|0,g|0,h)|0;a[i+h|0]=0}h=b+16|0;i=d+16|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];c[e>>2]=16488;a[b+28|0]=a[d+28|0]&1;a[b+29|0]=a[d+29|0]&1;i=b+32|0;c[i>>2]=21584;x=0;aq(234,b+36|0,d+36|0);if(!x){c[e>>2]=19808;c[i>>2]=19860;return}else{x=0}i=bQ(-1,-1)|0;c[e>>2]=16616;if((a[f]&1)==0){be(i|0)}J2(c[b+12>>2]|0);be(i|0)}function mh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a|0;c[d>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;a=b+4|0;g=b|0;b=(c[a>>2]|0)-(c[g>>2]|0)|0;h=b>>2;if((h|0)==0){return}do{if(h>>>0>1073741823>>>0){x=0;ap(152,0);if(x){x=0;break}}else{i=(x=0,as(230,b|0)|0);if(x){x=0;break}j=i;c[e>>2]=j;c[d>>2]=j;c[f>>2]=j+(h<<2);i=c[g>>2]|0;k=c[a>>2]|0;if((i|0)==(k|0)){return}else{l=i;m=j}do{if((m|0)==0){n=0}else{c[m>>2]=c[l>>2];n=c[e>>2]|0}m=n+4|0;c[e>>2]=m;l=l+4|0;}while((l|0)!=(k|0));return}}while(0);l=bQ(-1,-1)|0;m=c[d>>2]|0;if((m|0)==0){be(l|0)}d=c[e>>2]|0;if((m|0)!=(d|0)){c[e>>2]=d+(~((d-4+(-m|0)|0)>>>2)<<2)}J2(m);be(l|0)}function mi(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function mj(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function mk(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+32>>2]&1023](b,a);return}function ml(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+32>>2]&1023](b,a)|0}function mm(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+32>>2]&1023](b,a)|0}function mn(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+32>>2]&1023](b,a)|0}function mo(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+32>>2]&1023](b,a)|0}function mp(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+32>>2]&511](a,d,b);return}function mq(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+32>>2]&511](a,d,b);return}function mr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=J0(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];x=0;aT(6,m|0,k|0,l|0,h|0);if(x){x=0;h=bQ(-1,-1)|0;l=h;h=K;if((a[k]&1)==0){r=h;s=l;t=s;u=0;v=t;w=r;be(v|0)}J2(c[k+8>>2]|0);r=h;s=l;t=s;u=0;v=t;w=r;be(v|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}k=b|0;c[k>>2]=17368;l=b+32|0;h=f;if((a[h]&1)==0){m=l;c[m>>2]=c[h>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];y=b+44|0;c[y>>2]=g;i=j;return}h=c[f+8>>2]|0;m=c[f+4>>2]|0;do{if(m>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(m>>>0<11>>>0){a[l]=m<<1;z=l+1|0}else{f=m+16&-16;p=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+40>>2]=p;c[l>>2]=f|1;c[b+36>>2]=m;z=p}Kb(z|0,h|0,m)|0;a[z+m|0]=0;y=b+44|0;c[y>>2]=g;i=j;return}}while(0);j=bQ(-1,-1)|0;g=j;j=K;c[k>>2]=16616;if((a[b+4|0]&1)==0){r=j;s=g;t=s;u=0;v=t;w=r;be(v|0)}J2(c[b+12>>2]|0);r=j;s=g;t=s;u=0;v=t;w=r;be(v|0)}function ms(b){b=b|0;var d=0;d=b|0;c[d>>2]=17368;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function mt(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=17368;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function mu(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+28>>2]&1023](b,a);return}function mv(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+28>>2]&1023](b,a)|0}function mw(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+28>>2]&1023](b,a)|0}function mx(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+28>>2]&1023](b,a)|0}function my(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+28>>2]&1023](b,a)|0}function mz(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+28>>2]&511](a,d,b);return}function mA(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+28>>2]&511](a,d,b);return}function mB(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function mC(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function mD(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+24>>2]&1023](b,a);return}function mE(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+24>>2]&1023](b,a)|0}function mF(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+24>>2]&1023](b,a)|0}function mG(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+24>>2]&1023](b,a)|0}function mH(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+24>>2]&1023](b,a)|0}function mI(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+24>>2]&511](a,d,b);return}function mJ(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+24>>2]&511](a,d,b);return}function mK(a){a=a|0;return 1}function mL(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function mM(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function mN(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+16>>2]&1023](b,a);return}function mO(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+16>>2]&1023](b,a)|0}function mP(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+16>>2]&1023](b,a)|0}function mQ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+16>>2]&1023](b,a)|0}function mR(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+16>>2]&1023](b,a)|0}function mS(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+16>>2]&511](a,d,b);return}function mT(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+16>>2]&511](a,d,b);return}function mU(a){a=a|0;return 1}function mV(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=J0(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}Kb(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];x=0;aP(402,l|0,j|0,k|0);if(x){x=0;k=bQ(-1,-1)|0;l=k;k=K;if((a[j]&1)==0){q=k;r=l;s=r;t=0;u=s;v=q;be(u|0)}J2(c[j+8>>2]|0);q=k;r=l;s=r;t=0;u=s;v=q;be(u|0)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}j=b+28|0;c[j>>2]=21424;l=b+32|0;c[l>>2]=0;k=b+36|0;c[k>>2]=0;o=b+40|0;c[o>>2]=0;if((f|0)==0){w=b|0;c[w>>2]=18304;c[j>>2]=18360;y=b+44|0;z=g&1;a[y]=z;A=b+45|0;a[A]=0;B=b+46|0;a[B]=0;i=h;return}n=(x=0,as(230,f<<2|0)|0);if(!x){e=n;c[l>>2]=e;c[k>>2]=e;c[o>>2]=e+(f<<2);w=b|0;c[w>>2]=18304;c[j>>2]=18360;y=b+44|0;z=g&1;a[y]=z;A=b+45|0;a[A]=0;B=b+46|0;a[B]=0;i=h;return}else{x=0}h=bQ(-1,-1)|0;B=h;h=K;c[b>>2]=16616;if((a[b+4|0]&1)==0){q=h;r=B;s=r;t=0;u=s;v=q;be(u|0)}J2(c[b+12>>2]|0);q=h;r=B;s=r;t=0;u=s;v=q;be(u|0)}function mW(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+28>>2]=21424;d=c[b+32>>2]|0;e=d;if((d|0)!=0){f=b+36|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function mX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+28>>2]=21424;d=c[b+32>>2]|0;e=d;if((d|0)!=0){f=b+36|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){h=b;J2(h);return}J2(c[b+12>>2]|0);h=b;J2(h);return}function mY(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+12>>2]&1023](b,a);return}function mZ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+12>>2]&1023](b,a)|0}function m_(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+12>>2]&1023](b,a)|0}function m$(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+12>>2]&1023](b,a)|0}function m0(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+12>>2]&1023](b,a)|0}function m1(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+12>>2]&511](a,d,b);return}function m2(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+12>>2]&511](a,d,b);return}function m3(a){a=a|0;return a|0}function m4(b,d){b=b|0;d=d|0;if(cA[c[(c[d>>2]|0)+36>>2]&511](d)|0){a[b+45|0]=1;return}else{a[b+46|0]=1;return}}function m5(b,d){b=b|0;d=d|0;var e=0;e=b-48+20|0;if(cA[c[(c[d>>2]|0)+36>>2]&511](d)|0){a[e+45|0]=1;return}else{a[e+46|0]=1;return}}function m6(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-48+20|0;c[d+28>>2]=21424;b=c[d+32>>2]|0;e=b;if((b|0)!=0){f=d+36|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){return}J2(c[d+12>>2]|0);return}function m7(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-48+20|0;c[d+28>>2]=21424;b=c[d+32>>2]|0;e=b;if((b|0)!=0){f=d+36|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){h=d;J2(h);return}J2(c[d+12>>2]|0);h=d;J2(h);return}function m8(a,b){a=a|0;b=b|0;return}function m9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=17704;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;return}function na(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=b+32|0;e=c[d>>2]|0;f=(c[b+36>>2]|0)-e>>2;if((f|0)==0){return}b=a|0;a=0;g=e;while(1){e=c[g+(a<<2)>>2]|0;cy[c[(c[e>>2]|0)+8>>2]&1023](e|0,b);e=a+1|0;if(e>>>0>=f>>>0){break}a=e;g=c[d>>2]|0}return}function nb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0;e=i;i=i+200|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=e+56|0;m=e+64|0;n=e+72|0;o=e+88|0;p=e+96|0;q=e+112|0;r=e+128|0;s=e+144|0;t=e+176|0;u=e+192|0;v=d+32|0;w=c[v>>2]|0;y=w;z=(a[w+29|0]&1)==0;A=b+4|0;B=c[A>>2]|0;C=J0(48)|0;c[o>>2]=C;D=B+4|0;E=c[D>>2]|0;if((E|0)==(c[B+8>>2]|0)){ee(B|0,o);F=c[o>>2]|0}else{if((E|0)==0){G=0}else{c[E>>2]=C;G=c[D>>2]|0}c[D>>2]=G+4;F=C}C=F;L8:do{if(z){G=F;E=w+4|0;L10:do{if((a[E]&1)==0){o=t;c[o>>2]=c[E>>2];c[o+4>>2]=c[E+4>>2];c[o+8>>2]=c[E+8>>2];H=108}else{o=c[w+12>>2]|0;I=c[w+8>>2]|0;do{if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(I>>>0<11>>>0){a[t]=I<<1;J=t+1|0}else{L=I+16&-16;M=(x=0,as(230,L|0)|0);if(x){x=0;break}c[t+8>>2]=M;c[t>>2]=L|1;c[t+4>>2]=I;J=M}Kb(J|0,o|0,I)|0;a[J+I|0]=0;H=108;break L10}}while(0);I=bQ(-1,-1)|0;N=I;O=K}}while(0);do{if((H|0)==108){E=w+16|0;I=h;c[I>>2]=c[E>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];E=w+40|0;I=w+36|0;x=0;aT(54,G|0,t|0,h|0,(c[E>>2]|0)-(c[I>>2]|0)>>2|0);if(x){x=0;o=bQ(-1,-1)|0;M=o;o=K;if((a[t]&1)==0){N=M;O=o;break}J2(c[t+8>>2]|0);N=M;O=o;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}o=c[I>>2]|0;M=(c[E>>2]|0)-o>>2;if((M|0)==0){P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;V=b|0;cy[U&1023](Q,V);i=e;return}E=F+32|0;L=E;W=F+40|0;X=E+12|0;Y=F+36|0;Z=E;E=b+8|0;_=0;$=0;aa=o;L35:while(1){o=c[aa+(_<<2)>>2]|0;c[g>>2]=o;ab=c[W>>2]|0;ac=ab;if((ac|0)==(c[X>>2]|0)){g$(Y,g);ad=c[g>>2]|0}else{if((ab|0)==0){ae=0}else{c[ac>>2]=o;ae=c[W>>2]|0}c[W>>2]=ae+4;ad=o}cy[c[c[Z>>2]>>2]&1023](L,ad);ac=di(o)|0;Ac(u,0);do{if((ac|0)==0){af=$}else{ab=(x=0,aK(430,c[E>>2]|0,ac|0)|0);if(x){x=0;H=163;break L35}if((ab|0)==0){af=$;break}ab=(c[E>>2]|0)+4|0;ag=ab;ah=c[ab>>2]|0;L48:do{if((ah|0)==0){ai=ag}else{ab=ah;aj=ag;while(1){ak=ab;while(1){al=(x=0,aK(78,ak+16|0,ac|0)|0);if(x){x=0;H=159;break L35}am=ak;if(!al){break}al=c[ak+4>>2]|0;if((al|0)==0){ai=aj;break L48}else{ak=al}}al=c[ak>>2]|0;if((al|0)==0){ai=am;break}else{ab=al;aj=am}}}}while(0);ag=(c[E>>2]|0)+4|0;ah=ag;aj=c[ag>>2]|0;L57:do{if((aj|0)==0){an=ah}else{ag=aj;ab=ah;while(1){al=ag;while(1){ao=(x=0,aK(78,ac|0,al+16|0)|0);if(x){x=0;H=160;break L35}ar=al;if(ao){break}ao=c[al+4>>2]|0;if((ao|0)==0){an=ab;break L57}else{al=ao}}ak=c[al>>2]|0;if((ak|0)==0){an=ar;break}else{ag=ak;ab=ar}}}}while(0);if((ai|0)==(an|0)){af=$;break}else{at=ai}while(1){ah=(x=0,ax(16,b|0,o|0,c[at+64>>2]|0)|0);if(x){x=0;H=162;break L35}aj=(ah|0)==0?0:ah+32|0;ah=aj+4|0;ab=c[ah>>2]|0;ag=(c[aj+8>>2]|0)-ab>>2;L69:do{if((ag|0)!=0){aj=0;ak=ab;while(1){ao=c[ak+(aj<<2)>>2]|0;c[f>>2]=ao;au=c[W>>2]|0;av=au;if((av|0)==(c[X>>2]|0)){x=0;aq(270,Y|0,f|0);if(x){x=0;H=161;break L35}aw=c[f>>2]|0}else{if((au|0)==0){ay=0}else{c[av>>2]=ao;ay=c[W>>2]|0}c[W>>2]=ay+4;aw=ao}x=0;aq(c[c[Z>>2]>>2]|0,L|0,aw|0);if(x){x=0;H=161;break L35}ao=aj+1|0;if(ao>>>0>=ag>>>0){break L69}aj=ao;ak=c[ah>>2]|0}}}while(0);ah=c[at+4>>2]|0;if((ah|0)==0){ag=at|0;while(1){ab=c[ag+8>>2]|0;if((ag|0)==(c[ab>>2]|0)){az=ab;break}else{ag=ab}}}else{ag=ah;while(1){ab=c[ag>>2]|0;if((ab|0)==0){az=ag;break}else{ag=ab}}}ag=az;if((ag|0)==(an|0)){af=1;break}else{at=ag}}}}while(0);Ae(u);o=_+1|0;if(o>>>0>=M>>>0){H=167;break}_=o;$=af;aa=c[I>>2]|0}if((H|0)==160){I=bQ(-1,-1)|0;aA=K;aB=I}else if((H|0)==161){I=bQ(-1,-1)|0;aA=K;aB=I}else if((H|0)==162){I=bQ(-1,-1)|0;aA=K;aB=I}else if((H|0)==163){I=bQ(-1,-1)|0;aA=K;aB=I}else if((H|0)==167){if(af){aC=G;break L8}P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;V=b|0;cy[U&1023](Q,V);i=e;return}else if((H|0)==159){I=bQ(-1,-1)|0;aA=K;aB=I}x=0;ap(436,u|0);if(!x){aD=aB;aE=aA;aF=aD;aG=0;aH=aF;aI=aE;be(aH|0)}else{x=0;aJ=bQ(-1,-1,0)|0;aL=K;bU()}}}while(0);G=c[B>>2]|0;I=c[D>>2]|0;aa=G;while(1){if((aa|0)==(I|0)){aM=I;break}if((c[aa>>2]|0)==(F|0)){aM=aa;break}else{aa=aa+4|0}}aa=aM-G>>2;$=G+(aa+1<<2)|0;_=I-$|0;Kc(G+(aa<<2)|0,$|0,_|0)|0;$=G+((_>>2)+aa<<2)|0;aa=c[D>>2]|0;if(($|0)!=(aa|0)){c[D>>2]=aa+(~((aa-4+(-$|0)|0)>>>2)<<2)}J2(C);aD=N;aE=O;aF=aD;aG=0;aH=aF;aI=aE;be(aH|0)}else{$=F;aa=w+4|0;L114:do{if((a[aa]&1)==0){_=p;c[_>>2]=c[aa>>2];c[_+4>>2]=c[aa+4>>2];c[_+8>>2]=c[aa+8>>2];H=17}else{_=c[w+12>>2]|0;M=c[w+8>>2]|0;do{if(M>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(M>>>0<11>>>0){a[p]=M<<1;aN=p+1|0}else{L=M+16&-16;Z=(x=0,as(230,L|0)|0);if(x){x=0;break}c[p+8>>2]=Z;c[p>>2]=L|1;c[p+4>>2]=M;aN=Z}Kb(aN|0,_|0,M)|0;a[aN+M|0]=0;H=17;break L114}}while(0);M=bQ(-1,-1)|0;aO=M;aP=K}}while(0);do{if((H|0)==17){G=w+16|0;I=n;c[I>>2]=c[G>>2];c[I+4>>2]=c[G+4>>2];c[I+8>>2]=c[G+8>>2];x=0;aT(38,$|0,p|0,n|0,1);if(x){x=0;I=bQ(-1,-1)|0;M=I;I=K;if((a[p]&1)==0){aO=M;aP=I;break}J2(c[p+8>>2]|0);aO=M;aP=I;break}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}I=F+32|0;M=I;_=cA[c[(c[w>>2]|0)+36>>2]&511](y)|0;c[m>>2]=_;Z=F+40|0;L=c[Z>>2]|0;W=L;if((W|0)==(c[I+12>>2]|0)){g_(F+36|0,m);aQ=c[m>>2]|0}else{if((L|0)==0){aR=0}else{c[W>>2]=_;aR=c[Z>>2]|0}c[Z>>2]=aR+4;aQ=_}cy[c[c[I>>2]>>2]&1023](M,aQ);M=b+8|0;if((n0(c[M>>2]|0,$)|0)==0){P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;V=b|0;cy[U&1023](Q,V);i=e;return}I=c[A>>2]|0;_=J0(48)|0;c[l>>2]=_;Z=I+4|0;W=c[Z>>2]|0;if((W|0)==(c[I+8>>2]|0)){ee(I|0,l);aS=c[l>>2]|0}else{if((W|0)==0){aU=0}else{c[W>>2]=_;aU=c[Z>>2]|0}c[Z>>2]=aU+4;aS=_}_=aS;W=aS;L153:do{if((a[aa]&1)==0){L=q;c[L>>2]=c[aa>>2];c[L+4>>2]=c[aa+4>>2];c[L+8>>2]=c[aa+8>>2];H=41}else{L=c[w+12>>2]|0;Y=c[w+8>>2]|0;do{if(Y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(Y>>>0<11>>>0){a[q]=Y<<1;aV=q+1|0}else{X=Y+16&-16;E=(x=0,as(230,X|0)|0);if(x){x=0;break}c[q+8>>2]=E;c[q>>2]=X|1;c[q+4>>2]=Y;aV=E}Kb(aV|0,L|0,Y)|0;a[aV+Y|0]=0;H=41;break L153}}while(0);Y=bQ(-1,-1)|0;aW=Y;aX=K}}while(0);do{if((H|0)==41){Y=r;c[Y>>2]=c[G>>2];c[Y+4>>2]=c[G+4>>2];c[Y+8>>2]=c[G+8>>2];L=(x=0,aK(430,c[M>>2]|0,$|0)|0);do{if(!x){E=k;c[E>>2]=c[Y>>2];c[E+4>>2]=c[Y+4>>2];c[E+8>>2]=c[Y+8>>2];x=0;aT(54,W|0,q|0,k|0,L|0);if(x){x=0;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}E=(c[M>>2]|0)+4|0;X=E;o=c[E>>2]|0;L174:do{if((o|0)==0){aY=X}else{E=o;ac=X;while(1){ag=E;while(1){aZ=ag;if(!(dh(ag+16|0,$)|0)){break}ah=c[ag+4>>2]|0;if((ah|0)==0){aY=ac;break L174}else{ag=ah}}ah=c[ag>>2]|0;if((ah|0)==0){aY=aZ;break}else{E=ah;ac=aZ}}}}while(0);X=(c[M>>2]|0)+4|0;o=X;ac=c[X>>2]|0;L182:do{if((ac|0)==0){a_=o}else{X=ac;E=o;while(1){ah=X;while(1){a$=ah;if(dh($,ah+16|0)|0){break}ab=c[ah+4>>2]|0;if((ab|0)==0){a_=E;break L182}else{ah=ab}}ag=c[ah>>2]|0;if((ag|0)==0){a_=a$;break}else{X=ag;E=a$}}}}while(0);if((aY|0)==(a_|0)){a[aS+29|0]=0;P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;V=b|0;cy[U&1023](Q,V);i=e;return}o=b+12|0;ac=F;E=w;X=s|0;ag=aS+32|0;ab=ag;ak=aS+40|0;aj=ag+12|0;al=aS+36|0;ao=ag;ag=aY;L194:while(1){f7(s,c[A>>2]|0,0,0,c[o>>2]|0,ac,c[ag+64>>2]|0);av=(x=0,aK(c[(c[E>>2]|0)+24>>2]|0,y|0,X|0)|0);if(x){x=0;H=95;break}if((av|0)==0){a0=0}else{a0=av+32|0}av=a0+4|0;au=c[av>>2]|0;a1=(c[a0+8>>2]|0)-au>>2;L200:do{if((a1|0)!=0){a2=0;a3=au;while(1){a4=c[a3+(a2<<2)>>2]|0;c[j>>2]=a4;a5=c[ak>>2]|0;a6=a5;if((a6|0)==(c[aj>>2]|0)){x=0;aq(270,al|0,j|0);if(x){x=0;H=94;break L194}a7=c[j>>2]|0}else{if((a5|0)==0){a8=0}else{c[a6>>2]=a4;a8=c[ak>>2]|0}c[ak>>2]=a8+4;a7=a4}x=0;aq(c[c[ao>>2]>>2]|0,ab|0,a7|0);if(x){x=0;H=94;break L194}a4=a2+1|0;if(a4>>>0>=a1>>>0){break L200}a2=a4;a3=c[av>>2]|0}}}while(0);f9(s);av=c[ag+4>>2]|0;if((av|0)==0){a1=ag|0;while(1){au=c[a1+8>>2]|0;if((a1|0)==(c[au>>2]|0)){a9=au;break}else{a1=au}}}else{a1=av;while(1){au=c[a1>>2]|0;if((au|0)==0){a9=a1;break}else{a1=au}}}a1=a9;if((a1|0)==(a_|0)){H=97;break}else{ag=a1}}if((H|0)==94){ag=bQ(-1,-1)|0;ba=K;bb=ag}else if((H|0)==95){ag=bQ(-1,-1)|0;ba=K;bb=ag}else if((H|0)==97){a[aS+29|0]=0;aC=W;break L8}x=0;ap(24,s|0);if(!x){aD=bb;aE=ba;aF=aD;aG=0;aH=aF;aI=aE;be(aH|0)}else{x=0;aJ=bQ(-1,-1,0)|0;aL=K;bU()}}else{x=0}}while(0);L=bQ(-1,-1)|0;Y=L;L=K;if((a[q]&1)==0){aW=Y;aX=L;break}J2(c[q+8>>2]|0);aW=Y;aX=L}}while(0);W=c[I>>2]|0;M=c[Z>>2]|0;G=W;while(1){if((G|0)==(M|0)){bc=M;break}if((c[G>>2]|0)==(aS|0)){bc=G;break}else{G=G+4|0}}G=bc-W>>2;I=W+(G+1<<2)|0;L=M-I|0;Kc(W+(G<<2)|0,I|0,L|0)|0;I=W+((L>>2)+G<<2)|0;G=c[Z>>2]|0;if((I|0)!=(G|0)){c[Z>>2]=G+(~((G-4+(-I|0)|0)>>>2)<<2)}J2(_);aD=aW;aE=aX;aF=aD;aG=0;aH=aF;aI=aE;be(aH|0)}}while(0);$=c[B>>2]|0;aa=c[D>>2]|0;I=$;while(1){if((I|0)==(aa|0)){bd=aa;break}if((c[I>>2]|0)==(F|0)){bd=I;break}else{I=I+4|0}}I=bd-$>>2;G=$+(I+1<<2)|0;L=aa-G|0;Kc($+(I<<2)|0,G|0,L|0)|0;G=$+((L>>2)+I<<2)|0;I=c[D>>2]|0;if((G|0)!=(I|0)){c[D>>2]=I+(~((I-4+(-G|0)|0)>>>2)<<2)}J2(C);aD=aO;aE=aP;aF=aD;aG=0;aH=aF;aI=aE;be(aH|0)}}while(0);c[v>>2]=aC;P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;V=b|0;cy[U&1023](Q,V);i=e;return}function nc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0;f=i;i=i+136|0;g=f|0;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+48|0;n=f+56|0;o=f+72|0;p=f+80|0;q=f+88|0;r=f+104|0;s=f+120|0;Ac(p,0);t=b+4|0;b=c[t>>2]|0;u=(x=0,as(230,48)|0);L1:do{if(!x){v=u;c[o>>2]=v;w=b+4|0;y=c[w>>2]|0;if((y|0)==(c[b+8>>2]|0)){x=0;aq(376,b|0,o|0);if(x){x=0;z=63;break}A=c[o>>2]|0}else{if((y|0)==0){B=0}else{c[y>>2]=v;B=c[w>>2]|0}c[w>>2]=B+4;A=v}v=A;y=A;C=d+4|0;L11:do{if((a[C]&1)==0){D=q;c[D>>2]=c[C>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];z=18}else{D=c[d+12>>2]|0;E=c[d+8>>2]|0;do{if(E>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(E>>>0<11>>>0){a[q]=E<<1;F=q+1|0}else{G=E+16&-16;H=(x=0,as(230,G|0)|0);if(x){x=0;break}c[q+8>>2]=H;c[q>>2]=G|1;c[q+4>>2]=E;F=H}Kb(F|0,D|0,E)|0;a[F+E|0]=0;z=18;break L11}}while(0);E=bQ(-1,-1)|0;I=E;J=K}}while(0);do{if((z|0)==18){C=d+16|0;E=n;c[E>>2]=c[C>>2];c[E+4>>2]=c[C+4>>2];c[E+8>>2]=c[C+8>>2];x=0;aT(54,y|0,q|0,n|0,0);if(x){x=0;C=bQ(-1,-1)|0;E=C;C=K;if((a[q]&1)==0){I=E;J=C;break}J2(c[q+8>>2]|0);I=E;J=C;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}C=(x=0,aK(50,d|0,c[t>>2]|0)|0);if(x){x=0;z=63;break L1}E=(x=0,aK(50,e|0,c[t>>2]|0)|0);if(x){x=0;z=63;break L1}D=(C|0)!=0;if((E|0)==0|D^1){if(!D){D=A+32|0;H=D;c[g>>2]=e;G=A+40|0;L=c[G>>2]|0;M=L;if((M|0)==(c[D+12>>2]|0)){x=0;aq(270,A+36|0,g|0);if(x){x=0;z=63;break L1}N=c[g>>2]|0}else{if((L|0)==0){O=0}else{c[M>>2]=e;O=c[G>>2]|0}c[G>>2]=O+4;N=e}x=0;aq(c[c[D>>2]>>2]|0,H|0,N|0);if(x){x=0;z=63;break L1}Ae(p);i=f;return y|0}H=(x=0,as(126,C|0)|0);if(x){x=0;z=63;break L1}c[H+40>>2]=e;H=A+32|0;D=H;c[h>>2]=C;G=A+40|0;M=c[G>>2]|0;L=M;if((L|0)==(c[H+12>>2]|0)){x=0;aq(270,A+36|0,h|0);if(x){x=0;z=63;break L1}P=c[h>>2]|0}else{if((M|0)==0){Q=0}else{c[L>>2]=C;Q=c[G>>2]|0}c[G>>2]=Q+4;P=C}x=0;aq(c[c[H>>2]>>2]|0,D|0,P|0);if(x){x=0;z=63;break L1}Ae(p);i=f;return y|0}D=c[t>>2]|0;H=(x=0,as(230,44)|0);if(x){x=0;z=63;break L1}G=H;c[m>>2]=G;H=D+4|0;L=c[H>>2]|0;if((L|0)==(c[D+8>>2]|0)){x=0;aq(376,D|0,m|0);if(x){x=0;z=63;break L1}R=c[m>>2]|0}else{if((L|0)==0){S=0}else{c[L>>2]=G;S=c[H>>2]|0}c[H>>2]=S+4;R=G}G=R;L=R;M=A+4|0;L69:do{if((a[M]&1)==0){T=r;c[T>>2]=c[M>>2];c[T+4>>2]=c[M+4>>2];c[T+8>>2]=c[M+8>>2];z=41}else{T=c[A+12>>2]|0;U=c[A+8>>2]|0;do{if(U>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(U>>>0<11>>>0){a[r]=U<<1;V=r+1|0}else{W=U+16&-16;X=(x=0,as(230,W|0)|0);if(x){x=0;break}c[r+8>>2]=X;c[r>>2]=W|1;c[r+4>>2]=U;V=X}Kb(V|0,T|0,U)|0;a[V+U|0]=0;z=41;break L69}}while(0);U=bQ(-1,-1)|0;Y=U;Z=K}}while(0);do{if((z|0)==41){M=s;U=A+16|0;c[M>>2]=c[U>>2];c[M+4>>2]=c[U+4>>2];c[M+8>>2]=c[U+8>>2];U=(x=0,as(76,e|0)|0);do{if(!x){T=l;c[T>>2]=c[M>>2];c[T+4>>2]=c[M+4>>2];c[T+8>>2]=c[M+8>>2];x=0;aB(18,L|0,r|0,l|0,0,U|0,0);if(x){x=0;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}T=(x=0,as(126,C|0)|0);if(x){x=0;z=63;break L1}c[T+40>>2]=e;T=A+32|0;X=T;c[k>>2]=C;W=A+40|0;_=c[W>>2]|0;$=_;aa=T+12|0;if(($|0)==(c[aa>>2]|0)){x=0;aq(270,A+36|0,k|0);if(x){x=0;z=63;break L1}ab=c[k>>2]|0}else{if((_|0)==0){ac=0}else{c[$>>2]=C;ac=c[W>>2]|0}c[W>>2]=ac+4;ab=C}$=T;x=0;aq(c[c[$>>2]>>2]|0,X|0,ab|0);if(x){x=0;z=63;break L1}T=(x=0,aK(50,d|0,c[t>>2]|0)|0);if(x){x=0;z=63;break L1}_=(x=0,as(126,T|0)|0);if(x){x=0;z=63;break L1}c[_+40>>2]=L;_=(x=0,as(126,E|0)|0);if(x){x=0;z=63;break L1}c[_+40>>2]=T;c[j>>2]=E;T=c[W>>2]|0;_=T;if((_|0)==(c[aa>>2]|0)){x=0;aq(270,A+36|0,j|0);if(x){x=0;z=63;break L1}ad=c[j>>2]|0}else{if((T|0)==0){ae=0}else{c[_>>2]=E;ae=c[W>>2]|0}c[W>>2]=ae+4;ad=E}x=0;aq(c[c[$>>2]>>2]|0,X|0,ad|0);if(x){x=0;z=63;break L1}Ae(p);i=f;return y|0}else{x=0}}while(0);U=bQ(-1,-1)|0;M=U;U=K;if((a[r]&1)==0){Y=M;Z=U;break}J2(c[r+8>>2]|0);Y=M;Z=U}}while(0);E=c[D>>2]|0;L=c[H>>2]|0;C=E;while(1){if((C|0)==(L|0)){af=L;break}if((c[C>>2]|0)==(R|0)){af=C;break}else{C=C+4|0}}C=af-E>>2;D=E+(C+1<<2)|0;U=L-D|0;Kc(E+(C<<2)|0,D|0,U|0)|0;D=E+((U>>2)+C<<2)|0;C=c[H>>2]|0;if((D|0)!=(C|0)){c[H>>2]=C+(~((C-4+(-D|0)|0)>>>2)<<2)}J2(G);ag=Y;ah=Z;break L1}}while(0);y=c[b>>2]|0;D=c[w>>2]|0;C=y;while(1){if((C|0)==(D|0)){ai=D;break}if((c[C>>2]|0)==(A|0)){ai=C;break}else{C=C+4|0}}C=ai-y>>2;U=y+(C+1<<2)|0;M=D-U|0;Kc(y+(C<<2)|0,U|0,M|0)|0;U=y+((M>>2)+C<<2)|0;C=c[w>>2]|0;if((U|0)!=(C|0)){c[w>>2]=C+(~((C-4+(-U|0)|0)>>>2)<<2)}J2(v);ag=I;ah=J}else{x=0;z=63}}while(0);if((z|0)==63){z=bQ(-1,-1)|0;ag=z;ah=K}x=0;ap(436,p|0);if(!x){be(ag|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function nd(a,b){a=a|0;b=b|0;var d=0;d=c[b+28>>2]|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d,a|0);return}function ne(a,b){a=a|0;b=b|0;var d=0;d=c[b+28>>2]|0;if((d|0)==0){return}cy[c[(c[d>>2]|0)+8>>2]&1023](d,a|0);return}function nf(a,b){a=a|0;b=b|0;return}function ng(a){a=a|0;return}function nh(a){a=a|0;J2(a);return}function ni(a,b){a=a|0;b=b|0;return}function nj(a,b){a=a|0;b=b|0;return}function nk(a,b){a=a|0;b=b|0;return}function nl(a,b){a=a|0;b=b|0;return}function nm(a,b){a=a|0;b=b|0;return}function nn(a,b){a=a|0;b=b|0;return}function no(a,b){a=a|0;b=b|0;return}function np(a,b){a=a|0;b=b|0;return}function nq(a,b){a=a|0;b=b|0;return}function nr(a,b){a=a|0;b=b|0;return}function ns(a,b){a=a|0;b=b|0;return}function nt(a,b){a=a|0;b=b|0;return}function nu(a,b){a=a|0;b=b|0;return}function nv(a,b){a=a|0;b=b|0;return}function nw(a,b){a=a|0;b=b|0;return}function nx(a,b){a=a|0;b=b|0;return}function ny(a,b){a=a|0;b=b|0;return}function nz(a,b){a=a|0;b=b|0;return}function nA(a,b){a=a|0;b=b|0;return}function nB(a,b){a=a|0;b=b|0;return}function nC(a,b){a=a|0;b=b|0;return}function nD(a,b){a=a|0;b=b|0;return}function nE(a,b){a=a|0;b=b|0;return}function nF(a,b){a=a|0;b=b|0;return}function nG(a,b){a=a|0;b=b|0;return}function nH(a,b){a=a|0;b=b|0;return}function nI(a,b){a=a|0;b=b|0;return}function nJ(a,b){a=a|0;b=b|0;return}function nK(a,b){a=a|0;b=b|0;return}function nL(a,b){a=a|0;b=b|0;return}function nM(a,b){a=a|0;b=b|0;return}function nN(a,b){a=a|0;b=b|0;return}function nO(a,b){a=a|0;b=b|0;return}function nP(a,b){a=a|0;b=b|0;return}function nQ(a,b){a=a|0;b=b|0;return}function nR(a,b){a=a|0;b=b|0;return}function nS(a,b){a=a|0;b=b|0;return}function nT(a,b){a=a|0;b=b|0;return}function nU(a,b){a=a|0;b=b|0;return}function nV(a,b){a=a|0;b=b|0;return}function nW(a,b){a=a|0;b=b|0;return}function nX(a,b){a=a|0;b=b|0;return}function nY(a,b){a=a|0;b=b|0;return}function nZ(a,b){a=a|0;b=b|0;return}function n_(a,b){a=a|0;b=b|0;return}function n$(a,b){a=a|0;b=b|0;return}function n0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=d|0;e=d;L1:while(1){f=a;while(1){g=c[f>>2]|0;h=g;if((g|0)==0){i=0;j=25;break L1}d=g+16|0;if(dh(b,d)|0){break}f=g+4|0;if(!(dh(d,b)|0)){break L1}}a=g|0;e=h}if((j|0)==25){return i|0}j=c[g>>2]|0;L11:do{if((j|0)==0){k=h}else{g=j;a=h;while(1){d=g;while(1){l=d;if(!(dh(d+16|0,b)|0)){break}m=c[d+4>>2]|0;if((m|0)==0){k=a;break L11}else{d=m}}m=c[d>>2]|0;if((m|0)==0){k=l;break}else{g=m;a=l}}}}while(0);l=c[f>>2]|0;L19:do{if((l|0)==0){n=e}else{f=l;h=e;while(1){j=f;while(1){o=j;if(dh(b,j+16|0)|0){break}a=c[j+4>>2]|0;if((a|0)==0){n=h;break L19}else{j=a}}d=c[j>>2]|0;if((d|0)==0){n=o;break}else{f=d;h=o}}}}while(0);if((k|0)==(n|0)){i=0;return i|0}else{p=k;q=0}while(1){k=q+1|0;o=c[p+4>>2]|0;if((o|0)==0){b=p|0;while(1){e=c[b+8>>2]|0;if((b|0)==(c[e>>2]|0)){r=e;break}else{b=e}}}else{b=o;while(1){e=c[b>>2]|0;if((e|0)==0){r=b;break}else{b=e}}}b=r;if((b|0)==(n|0)){i=k;break}else{p=b;q=k}}return i|0}function n1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=d;f=d;g=a[f]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}h=g&1;L5:do{if((i|0)!=0){if(h<<24>>24==0){j=e+1|0}else{j=c[d+8>>2]|0}g=j+i|0;do{if((g|0)==(j|0)){break L5}g=g-1|0;}while((a[g]|0)!=47);k=g-j|0;if((k|0)==-1){break}CO(b,d,k+1|0,-1,0);return}}while(0);if(h<<24>>24==0){h=b;c[h>>2]=c[f>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];return}f=c[d+8>>2]|0;h=c[d+4>>2]|0;if(h>>>0>4294967279>>>0){CJ(0)}if(h>>>0<11>>>0){a[b]=h<<1;l=b+1|0}else{d=h+16&-16;j=J0(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=h;l=j}Kb(l|0,f|0,h)|0;a[l+h|0]=0;return}function n2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=d;f=a[d]|0;g=f&255;if((g&1|0)==0){h=g>>>1}else{h=c[d+4>>2]|0}L5:do{if((h|0)!=0){if((f&1)==0){i=e+1|0}else{i=c[d+8>>2]|0}g=i+h|0;do{if((g|0)==(i|0)){break L5}g=g-1|0;}while((a[g]|0)!=47);j=g-i|0;if((j|0)==-1){break}CO(b,d,0,j+1|0,0);return}}while(0);a[b]=0;a[b+1|0]=0;return}function n3(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=i;i=i+48|0;h=g|0;j=g+16|0;k=g+32|0;l=e;m=e;n=a[m]|0;o=n&255;p=(o&1|0)==0;if(p){q=o>>>1}else{q=c[e+4>>2]|0}r=f;s=a[r]|0;if((q|0)==0){if((s&1)==0){q=b;c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];i=g;return}q=c[f+8>>2]|0;t=c[f+4>>2]|0;if(t>>>0>4294967279>>>0){CJ(0)}if(t>>>0<11>>>0){a[b]=t<<1;u=b+1|0}else{v=t+16&-16;w=J0(v)|0;c[b+8>>2]=w;c[b>>2]=v|1;c[b+4>>2]=t;u=w}Kb(u|0,q|0,t)|0;a[u+t|0]=0;i=g;return}t=s&255;if((t&1|0)==0){y=t>>>1}else{y=c[f+4>>2]|0}if((y|0)==0){if((n&1)==0){y=b;c[y>>2]=c[m>>2];c[y+4>>2]=c[m+4>>2];c[y+8>>2]=c[m+8>>2];i=g;return}y=c[e+8>>2]|0;t=c[e+4>>2]|0;if(t>>>0>4294967279>>>0){CJ(0)}if(t>>>0<11>>>0){a[b]=t<<1;z=b+1|0}else{u=t+16&-16;q=J0(u)|0;c[b+8>>2]=q;c[b>>2]=u|1;c[b+4>>2]=t;z=q}Kb(z|0,y|0,t)|0;a[z+t|0]=0;i=g;return}t=(s&1)==0;if(t){A=f+1|0}else{A=c[f+8>>2]|0}if((a[A]|0)==47){if(t){t=b;c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];i=g;return}t=c[f+8>>2]|0;A=c[f+4>>2]|0;if(A>>>0>4294967279>>>0){CJ(0)}if(A>>>0<11>>>0){a[b]=A<<1;B=b+1|0}else{s=A+16&-16;z=J0(s)|0;c[b+8>>2]=z;c[b>>2]=s|1;c[b+4>>2]=A;B=z}Kb(B|0,t|0,A)|0;a[B+A|0]=0;i=g;return}if(p){C=o>>>1}else{C=c[e+4>>2]|0}p=(n&1)==0;if(p){D=l+1|0}else{D=c[e+8>>2]|0}if((a[D+(C-1)|0]|0)!=47){if(p){E=o>>>1;F=10}else{E=c[e+4>>2]|0;F=(c[e>>2]&-2)-1|0}if((E|0)==(F|0)){CY(e,F,1,F,F,0,0);G=a[m]|0}else{G=n}if((G&1)==0){a[m]=(E<<1)+2;H=l+1|0;I=E+1|0}else{G=c[e+8>>2]|0;n=E+1|0;c[e+4>>2]=n;H=G;I=n}a[H+E|0]=47;a[H+I|0]=0}I=h;H=h+1|0;E=j;n=k;G=k+8|0;F=l+1|0;l=e+8|0;o=e+4|0;p=j+8|0;C=h+8|0;D=h+4|0;A=f+4|0;while(1){B=d[r]|0;if((B&1|0)==0){J=B>>>1}else{J=c[A>>2]|0}if(J>>>0<=3>>>0){L=83;break}CO(h,f,0,3,0);B=a[I]|0;t=B&255;z=(t&1|0)==0?t>>>1:c[D>>2]|0;t=(B&1)==0;B=z>>>0>3>>>0;s=Kd((t?H:c[C>>2]|0)|0,10752,(B?3:z)|0)|0;if((s|0)==0){M=z>>>0<3>>>0?-1:B&1}else{M=s}s=(M|0)==0;if(t){if(!s){L=83;break}}else{J2(c[C>>2]|0);if(!s){L=83;break}}CO(j,f,3,-1,0);x=0,aK(346,f|0,j|0)|0;if(x){x=0;L=79;break}if((a[E]&1)!=0){J2(c[p>>2]|0)}s=a[m]|0;t=s&255;if((t&1|0)==0){B=t>>>1;N=t>>>1;O=B;P=B}else{B=c[o>>2]|0;N=B;O=B;P=B}L102:do{if((N|0)==0){Q=0}else{if((s&1)==0){R=F}else{R=c[l>>2]|0}B=R+(N>>>0>(P-2|0)>>>0?O-1|0:N)|0;do{if((B|0)==(R|0)){Q=0;break L102}B=B-1|0;}while((a[B]|0)!=47);Q=1-R+B|0}}while(0);CO(k,e,0,Q,0);x=0,aK(346,e|0,k|0)|0;if(x){x=0;L=81;break}if((a[n]&1)==0){continue}J2(c[G>>2]|0)}if((L|0)==79){k=bQ(-1,-1)|0;Q=k;k=K;if((a[E]&1)==0){S=k;T=Q;U=T;V=0;W=U;X=S;be(W|0)}J2(c[p>>2]|0);S=k;T=Q;U=T;V=0;W=U;X=S;be(W|0)}else if((L|0)==81){Q=bQ(-1,-1)|0;k=Q;Q=K;if((a[n]&1)==0){S=Q;T=k;U=T;V=0;W=U;X=S;be(W|0)}J2(c[G>>2]|0);S=Q;T=k;U=T;V=0;W=U;X=S;be(W|0)}else if((L|0)==83){hV(b,e,f);i=g;return}}function n4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;f=i;i=i+32|0;g=f|0;h=f+16|0;j=d;k=(a[j]&1)==0;if(k){l=d+1|0}else{l=c[d+8>>2]|0}if((a[l]|0)==47){if(k){l=b;c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];i=f;return}l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[b]=m<<1;n=b+1|0}else{o=m+16&-16;p=J0(o)|0;c[b+8>>2]=p;c[b>>2]=o|1;c[b+4>>2]=m;n=p}Kb(n|0,l|0,m)|0;a[n+m|0]=0;i=f;return}m=e;if((a[m]&1)==0){n=g;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[e+8>>2]|0;n=c[e+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[g]=n<<1;q=g+1|0}else{e=n+16&-16;l=J0(e)|0;c[g+8>>2]=l;c[g>>2]=e|1;c[g+4>>2]=n;q=l}Kb(q|0,m|0,n)|0;a[q+n|0]=0}L31:do{if(k){n=h;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];r=31}else{n=c[d+8>>2]|0;q=c[d+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(q>>>0<11>>>0){a[h]=q<<1;s=h+1|0}else{m=q+16&-16;l=(x=0,as(230,m|0)|0);if(x){x=0;break}c[h+8>>2]=l;c[h>>2]=m|1;c[h+4>>2]=q;s=l}Kb(s|0,n|0,q)|0;a[s+q|0]=0;r=31;break L31}}while(0);q=bQ(-1,-1)|0;t=K;u=q}}while(0);do{if((r|0)==31){x=0;aP(22,b|0,g|0,h|0);if(x){x=0;s=bQ(-1,-1)|0;d=s;s=K;if((a[h]&1)==0){t=s;u=d;break}J2(c[h+8>>2]|0);t=s;u=d;break}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}if((a[g]&1)==0){i=f;return}J2(c[g+8>>2]|0);i=f;return}}while(0);if((a[g]&1)==0){v=u;w=0;y=v;z=t;be(y|0)}J2(c[g+8>>2]|0);v=u;w=0;y=v;z=t;be(y|0)}function n5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,aq=0,ar=0;g=i;i=i+64|0;h=g|0;j=g+16|0;k=g+32|0;l=g+48|0;n4(h,d,f);x=0;aP(324,j|0,e|0,f|0);do{if(!x){f=k;a[f]=0;e=k+1|0;a[e]=0;d=l;a[d]=0;m=l+1|0;a[m]=0;n=h;o=h;p=a[o]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[h+4>>2]|0}q=j;s=j;t=a[s]|0;u=t&255;if((u&1|0)==0){v=u>>>1}else{v=c[j+4>>2]|0}u=v>>>0<r>>>0?v:r;L11:do{if((u|0)==0){w=0;y=n+1|0;z=h+8|0}else{A=n+1|0;B=(t&1)==0;C=q+1|0;D=h+8|0;E=c[D>>2]|0;F=c[j+8>>2]|0;if((p&1)==0){G=0;H=0;while(1){if((a[n+1+H|0]|0)!=(a[(B?C:F)+H|0]|0)){w=G;y=A;z=D;break L11}I=H+1|0;J=(a[n+1+H|0]|0)==47?I:G;if(I>>>0<u>>>0){G=J;H=I}else{w=J;y=A;z=D;break}}}else{H=0;G=0;while(1){if((a[E+G|0]|0)!=(a[(B?C:F)+G|0]|0)){w=H;y=A;z=D;break L11}J=G+1|0;I=(a[E+G|0]|0)==47?J:H;if(J>>>0<u>>>0){H=I;G=J}else{w=I;y=A;z=D;break}}}}}while(0);u=k+8|0;n=k|0;t=k+4|0;D=h+4|0;A=w;G=p;while(1){H=G&255;if(A>>>0>=((H&1|0)==0?H>>>1:c[D>>2]|0)>>>0){L=22;break}if((G&1)==0){M=y}else{M=c[z>>2]|0}H=a[M+A|0]|0;E=a[f]|0;if((E&1)==0){N=(E&255)>>>1;O=10;P=E}else{F=c[n>>2]|0;N=c[t>>2]|0;O=(F&-2)-1|0;P=F&255}if((N|0)==(O|0)){if((O|0)==-17){L=30;break}F=(P&1)==0?e:c[u>>2]|0;do{if(O>>>0<2147483623>>>0){C=O+1|0;B=O<<1;I=C>>>0<B>>>0?B:C;if(I>>>0<11>>>0){Q=11;break}Q=I+16&-16}else{Q=-17}}while(0);I=(x=0,as(230,Q|0)|0);if(x){x=0;L=17;break}Kb(I|0,F|0,O)|0;if((O|0)!=10){J2(F)}c[u>>2]=I;I=Q|1;c[n>>2]=I;R=I&255}else{R=E}if((R&1)==0){a[f]=(N<<1)+2;S=e;T=N+1|0}else{I=c[u>>2]|0;C=N+1|0;c[t>>2]=C;S=I;T=C}a[S+N|0]=H;a[S+T|0]=0;A=A+1|0;G=a[o]|0}do{if((L|0)==22){G=q+1|0;A=l+8|0;n=l|0;D=l+4|0;p=j+8|0;C=j+4|0;I=w;while(1){B=a[s]|0;J=B&255;if(I>>>0>=((J&1|0)==0?J>>>1:c[C>>2]|0)>>>0){L=44;break}J=a[((B&1)==0?G:c[p>>2]|0)+I|0]|0;B=a[d]|0;if((B&1)==0){U=(B&255)>>>1;V=10;W=B}else{X=c[n>>2]|0;U=c[D>>2]|0;V=(X&-2)-1|0;W=X&255}if((U|0)==(V|0)){if((V|0)==-17){L=52;break}X=(W&1)==0?m:c[A>>2]|0;do{if(V>>>0<2147483623>>>0){Y=V+1|0;Z=V<<1;_=Y>>>0<Z>>>0?Z:Y;if(_>>>0<11>>>0){$=11;break}$=_+16&-16}else{$=-17}}while(0);_=(x=0,as(230,$|0)|0);if(x){x=0;L=16;break}Kb(_|0,X|0,V)|0;if((V|0)!=10){J2(X)}c[A>>2]=_;_=$|1;c[n>>2]=_;aa=_&255}else{aa=B}if((aa&1)==0){a[d]=(U<<1)+2;ab=m;ac=U+1|0}else{_=c[A>>2]|0;Y=U+1|0;c[D>>2]=Y;ab=_;ac=Y}a[ab+U|0]=J;a[ab+ac|0]=0;I=I+1|0}if((L|0)==52){x=0;ap(232,0);if(x){x=0;L=18;break}}else if((L|0)==44){I=a[d]|0;n=I&255;G=n>>>1;C=c[A>>2]|0;H=c[D>>2]|0;L77:do{if((n&1|0)==0){E=0;F=0;while(1){if(E>>>0>=G>>>0){ad=F;break L77}Y=((a[((I&1)==0?m:C)+E|0]|0)==47)+F|0;E=E+1|0;F=Y}}else{F=0;E=0;while(1){if(F>>>0>=H>>>0){ad=E;break L77}J=((a[((I&1)==0?m:C)+F|0]|0)==47)+E|0;F=F+1|0;E=J}}}while(0);C=b;a[C]=0;a[b+1|0]=0;L85:do{if((ad|0)==0){L=74}else{I=0;while(1){x=0,ax(64,b|0,10752,3)|0;if(x){x=0;break}H=I+1|0;if(H>>>0<ad>>>0){I=H}else{L=74;break L85}}I=bQ(-1,-1)|0;ae=K;af=I}}while(0);do{if((L|0)==74){I=a[f]|0;H=(I&1)==0?e:c[u>>2]|0;G=I&255;I=(G&1|0)==0?G>>>1:c[t>>2]|0;x=0,ax(64,b|0,H|0,I|0)|0;if(x){x=0;I=bQ(-1,-1)|0;ae=K;af=I;break}if((a[d]&1)!=0){J2(c[A>>2]|0)}if((a[f]&1)!=0){J2(c[u>>2]|0)}if((a[s]&1)!=0){J2(c[p>>2]|0)}if((a[o]&1)==0){i=g;return}J2(c[z>>2]|0);i=g;return}}while(0);p=af;A=ae;if((a[C]&1)==0){ag=p;ah=A;break}J2(c[b+8>>2]|0);ag=p;ah=A;break}else if((L|0)==16){A=bQ(-1,-1)|0;ai=K;aj=A;L=19;break}}else if((L|0)==30){x=0;ap(232,0);if(x){x=0;L=18;break}}else if((L|0)==17){A=bQ(-1,-1)|0;ai=K;aj=A;L=19}}while(0);if((L|0)==18){t=bQ(-1,-1)|0;ai=K;aj=t;L=19}if((L|0)==19){ag=aj;ah=ai}if((a[d]&1)!=0){J2(c[l+8>>2]|0)}if((a[f]&1)!=0){J2(c[u>>2]|0)}if((a[s]&1)==0){ak=ag;al=ah;am=o;break}J2(c[j+8>>2]|0);ak=ag;al=ah;am=o}else{x=0;t=bQ(-1,-1)|0;ak=t;al=K;am=h}}while(0);if((a[am]&1)==0){an=ak;ao=0;aq=an;ar=al;be(aq|0)}J2(c[h+8>>2]|0);an=ak;ao=0;aq=an;ar=al;be(aq|0)}function n6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0;e=i;i=i+224|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;CQ(d,b)|0;u=d;if((a[u]&1)==0){v=f;c[v>>2]=c[u>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2]}else{v=c[d+8>>2]|0;w=c[d+4>>2]|0;if(w>>>0>4294967279>>>0){CJ(0);return 0}if(w>>>0<11>>>0){a[f]=w<<1;y=f+1|0}else{z=w+16&-16;A=J0(z)|0;c[f+8>>2]=A;c[f>>2]=z|1;c[f+4>>2]=w;y=A}Kb(y|0,v|0,w)|0;a[y+w|0]=0}w=(x=0,as(268,f|0)|0);if(x){x=0;y=bQ(-1,-1)|0;v=y;y=K;if((a[f]&1)==0){B=y;C=v;D=C;E=0;F=D;G=B;be(F|0)}J2(c[f+8>>2]|0);B=y;C=v;D=C;E=0;F=D;G=B;be(F|0)}if((a[f]&1)!=0){J2(c[f+8>>2]|0)}if((w|0)!=0){H=w;i=e;return H|0}w=b;f=a[w]|0;if((f&1)==0){v=h;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];I=a[v]|0;J=v}else{v=c[b+8>>2]|0;y=c[b+4>>2]|0;if(y>>>0>4294967279>>>0){CJ(0);return 0}if(y>>>0<11>>>0){A=y<<1&255;z=h;a[z]=A;L=h+1|0;M=A;N=z}else{z=y+16&-16;A=J0(z)|0;c[h+8>>2]=A;O=z|1;c[h>>2]=O;c[h+4>>2]=y;L=A;M=O&255;N=h}Kb(L|0,v|0,y)|0;a[L+y|0]=0;I=M;J=N}N=h;M=I&255;if((M&1|0)==0){P=M>>>1}else{P=c[h+4>>2]|0}L40:do{if((P|0)==0){Q=32}else{if((I&1)==0){R=N+1|0}else{R=c[h+8>>2]|0}M=R+P|0;do{if((M|0)==(R|0)){Q=32;break L40}M=M-1|0;}while((a[M]|0)!=47);y=M-R|0;if((y|0)==-1){Q=32;break}L=y+1|0;y=I&255;if((y&1|0)==0){S=y>>>1}else{S=c[h+4>>2]|0}if((I&1)==0){T=N+1|0}else{T=c[h+8>>2]|0}y=S>>>0<L>>>0?S:L;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[g]=y<<1;U=g+1|0}else{L=y+16&-16;v=(x=0,as(230,L|0)|0);if(x){x=0;break}c[g+8>>2]=v;c[g>>2]=L|1;c[g+4>>2]=y;U=v}Kb(U|0,T|0,y)|0;a[U+y|0]=0;break L40}}while(0);y=bQ(-1,-1)|0;M=y;y=K;if((a[J]&1)==0){B=y;C=M;D=C;E=0;F=D;G=B;be(F|0)}J2(c[h+8>>2]|0);B=y;C=M;D=C;E=0;F=D;G=B;be(F|0)}}while(0);if((Q|0)==32){a[g]=0;a[g+1|0]=0}if((I&1)==0){V=f}else{J2(c[h+8>>2]|0);V=a[w]|0}L79:do{if((V&1)==0){h=k;c[h>>2]=c[w>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];Q=59}else{h=c[b+8>>2]|0;f=c[b+4>>2]|0;do{if(f>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(f>>>0<11>>>0){a[k]=f<<1;W=k+1|0}else{I=f+16&-16;J=(x=0,as(230,I|0)|0);if(x){x=0;break}c[k+8>>2]=J;c[k>>2]=I|1;c[k+4>>2]=f;W=J}Kb(W|0,h|0,f)|0;a[W+f|0]=0;Q=59;break L79}}while(0);f=bQ(-1,-1)|0;X=K;Y=f}}while(0);do{if((Q|0)==59){x=0;aq(106,j|0,k|0);if(x){x=0;W=bQ(-1,-1)|0;b=W;W=K;if((a[k]&1)==0){X=W;Y=b;break}J2(c[k+8>>2]|0);X=W;Y=b;break}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}b=l;Ke(b|0,0,12)|0;W=j;w=j;V=a[w]|0;f=V&255;if((f&1|0)==0){Z=f>>>1}else{Z=c[j+4>>2]|0}f=Z+1|0;do{if(f>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Q=76;break}return 0}else{if(f>>>0<11>>>0){a[b]=2;_=l+1|0}else{h=Z+17&-16;J=(x=0,as(230,h|0)|0);if(x){x=0;Q=76;break}c[l+8>>2]=J;c[l>>2]=h|1;c[l+4>>2]=1;_=J}a[_]=95;a[_+1|0]=0;if((V&1)==0){$=W+1|0}else{$=c[j+8>>2]|0}x=0,ax(64,l|0,$|0,Z|0)|0;if(x){x=0;Q=76;break}x=0;aP(194,m|0,g|0,l|0);L119:do{if(!x){x=0,aK(346,d|0,m|0)|0;if(x){x=0;J=bQ(-1,-1)|0;h=J;J=K;if((a[m]&1)==0){aa=J;ab=h;break}J2(c[m+8>>2]|0);aa=J;ab=h;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}if((a[u]&1)==0){h=n;c[h>>2]=c[u>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2]}else{h=c[d+8>>2]|0;J=c[d+4>>2]|0;if(J>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Q=173;break}return 0}if(J>>>0<11>>>0){a[n]=J<<1;ac=n+1|0}else{I=J+16&-16;U=(x=0,as(230,I|0)|0);if(x){x=0;Q=173;break}c[n+8>>2]=U;c[n>>2]=I|1;c[n+4>>2]=J;ac=U}Kb(ac|0,h|0,J)|0;a[ac+J|0]=0}J=(x=0,as(268,n|0)|0);if(x){x=0;h=bQ(-1,-1)|0;U=h;h=K;if((a[n]&1)==0){aa=h;ab=U;break}J2(c[n+8>>2]|0);aa=h;ab=U;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}L148:do{if((J|0)==0){U=o;Ke(U|0,0,12)|0;h=a[b]|0;I=h&255;if((I&1|0)==0){ad=I>>>1}else{ad=c[l+4>>2]|0}if((h&1)==0){ae=l+1|0}else{ae=c[l+8>>2]|0}h=ad+5|0;do{if(h>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(h>>>0<11>>>0){a[U]=ad<<1;af=o+1|0}else{I=ad+21&-16;T=(x=0,as(230,I|0)|0);if(x){x=0;break}c[o+8>>2]=T;c[o>>2]=I|1;c[o+4>>2]=ad;af=T}Kb(af|0,ae|0,ad)|0;a[af+ad|0]=0;x=0,ax(64,o|0,7216,5)|0;if(x){x=0;break}x=0;aP(194,p|0,g|0,o|0);L168:do{if(!x){x=0,aK(346,d|0,p|0)|0;if(x){x=0;T=bQ(-1,-1)|0;I=T;T=K;if((a[p]&1)==0){ag=T;ah=I;break}J2(c[p+8>>2]|0);ag=T;ah=I;break}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}if((a[u]&1)==0){I=q;c[I>>2]=c[u>>2];c[I+4>>2]=c[u+4>>2];c[I+8>>2]=c[u+8>>2]}else{I=c[d+8>>2]|0;T=c[d+4>>2]|0;if(T>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Q=179;break}return 0}if(T>>>0<11>>>0){a[q]=T<<1;ai=q+1|0}else{S=T+16&-16;N=(x=0,as(230,S|0)|0);if(x){x=0;Q=179;break}c[q+8>>2]=N;c[q>>2]=S|1;c[q+4>>2]=T;ai=N}Kb(ai|0,I|0,T)|0;a[ai+T|0]=0}T=(x=0,as(268,q|0)|0);if(x){x=0;I=bQ(-1,-1)|0;N=I;I=K;if((a[q]&1)==0){ag=I;ah=N;break}J2(c[q+8>>2]|0);ag=I;ah=N;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}L197:do{if((T|0)==0){N=r;Ke(N|0,0,12)|0;I=a[w]|0;S=I&255;if((S&1|0)==0){aj=S>>>1}else{aj=c[j+4>>2]|0}if((I&1)==0){ak=W+1|0}else{ak=c[j+8>>2]|0}I=aj+5|0;do{if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(I>>>0<11>>>0){a[N]=aj<<1;al=r+1|0}else{S=aj+21&-16;R=(x=0,as(230,S|0)|0);if(x){x=0;break}c[r+8>>2]=R;c[r>>2]=S|1;c[r+4>>2]=aj;al=R}Kb(al|0,ak|0,aj)|0;a[al+aj|0]=0;x=0,ax(64,r|0,7216,5)|0;if(x){x=0;break}x=0;aP(194,s|0,g|0,r|0);do{if(!x){x=0,aK(346,d|0,s|0)|0;if(x){x=0;R=bQ(-1,-1)|0;S=R;R=K;if((a[s]&1)==0){am=R;an=S;break}J2(c[s+8>>2]|0);am=R;an=S;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}if((a[u]&1)==0){S=t;c[S>>2]=c[u>>2];c[S+4>>2]=c[u+4>>2];c[S+8>>2]=c[u+8>>2]}else{S=c[d+8>>2]|0;R=c[d+4>>2]|0;if(R>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Q=185;break}return 0}if(R>>>0<11>>>0){a[t]=R<<1;ao=t+1|0}else{P=R+16&-16;M=(x=0,as(230,P|0)|0);if(x){x=0;Q=185;break}c[t+8>>2]=M;c[t>>2]=P|1;c[t+4>>2]=R;ao=M}Kb(ao|0,S|0,R)|0;a[ao+R|0]=0}R=(x=0,as(268,t|0)|0);if(x){x=0;S=bQ(-1,-1)|0;M=S;S=K;if((a[t]&1)==0){am=S;an=M;break}J2(c[t+8>>2]|0);am=S;an=M;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}if((a[N]&1)==0){ar=R;break L197}J2(c[r+8>>2]|0);ar=R;break L197}else{x=0;Q=185}}while(0);if((Q|0)==185){R=bQ(-1,-1)|0;am=K;an=R}if((a[N]&1)==0){ag=am;ah=an;break L168}J2(c[r+8>>2]|0);ag=am;ah=an;break L168}}while(0);I=bQ(-1,-1)|0;R=K;if((a[N]&1)==0){at=R;au=I;Q=180;break L168}J2(c[r+8>>2]|0);at=R;au=I;Q=180;break L168}else{ar=T}}while(0);if((a[U]&1)==0){av=ar;break L148}J2(c[o+8>>2]|0);av=ar;break L148}else{x=0;Q=179}}while(0);if((Q|0)==179){T=bQ(-1,-1)|0;at=K;au=T;Q=180}if((Q|0)==180){ag=at;ah=au}if((a[U]&1)==0){aa=ag;ab=ah;break L119}J2(c[o+8>>2]|0);aa=ag;ab=ah;break L119}}while(0);h=bQ(-1,-1)|0;T=K;if((a[U]&1)==0){aw=T;ay=h;Q=174;break L119}J2(c[o+8>>2]|0);aw=T;ay=h;Q=174;break L119}else{av=J}}while(0);if((a[b]&1)!=0){J2(c[l+8>>2]|0)}if((a[w]&1)!=0){J2(c[j+8>>2]|0)}if((a[g]&1)==0){H=av;i=e;return H|0}J2(c[g+8>>2]|0);H=av;i=e;return H|0}else{x=0;Q=173}}while(0);if((Q|0)==173){J=bQ(-1,-1)|0;aw=K;ay=J;Q=174}if((Q|0)==174){aa=aw;ab=ay}if((a[b]&1)==0){az=aa;aA=ab;break}J2(c[l+8>>2]|0);az=aa;aA=ab}}while(0);if((Q|0)==76){W=bQ(-1,-1)|0;V=K;if((a[b]&1)!=0){J2(c[l+8>>2]|0)}az=V;aA=W}if((a[w]&1)==0){X=az;Y=aA;break}J2(c[j+8>>2]|0);X=az;Y=aA}}while(0);if((a[g]&1)==0){B=X;C=Y;D=C;E=0;F=D;G=B;be(F|0)}J2(c[g+8>>2]|0);B=X;C=Y;D=C;E=0;F=D;G=B;be(F|0);return 0}function n7(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+288|0;e=d|0;f=d+80|0;g=d+272|0;h=b;j=b;if((a[j]&1)==0){k=h+1|0}else{k=c[b+8>>2]|0}if((cj(k|0,e|0)|0)==-1){l=0;i=d;return l|0}if((c[e+12>>2]&61440|0)==16384){l=0;i=d;return l|0}if((a[j]&1)==0){m=h+1|0}else{m=c[b+8>>2]|0}b=f;h=f+108|0;j=f|0;e=f;k=f+8|0;n=f;c[j>>2]=31252;o=f+108|0;c[o>>2]=31272;c[f+4>>2]=0;x=0;aq(200,f+108|0,k|0);L15:do{if(!x){c[f+180>>2]=0;c[f+184>>2]=-1;c[j>>2]=14956;c[h>>2]=14976;x=0;ap(6,k|0);if(x){x=0;p=bQ(-1,-1)|0;q=p;r=K;break}p=f+72|0;do{if((c[p>>2]|0)==0){s=bL(m|0,10872)|0;c[p>>2]=s;if((s|0)==0){t=15;break}c[f+96>>2]=14;if((cf(s|0,0,2)|0)==0){break}aX(c[p>>2]|0)|0;c[p>>2]=0;t=15}else{t=15}}while(0);do{if((t|0)==15){s=c[(c[n>>2]|0)-12>>2]|0;x=0;aq(362,b+s|0,c[b+(s+16)>>2]|4|0);if(!x){break}else{x=0}s=bQ(-1,-1)|0;u=K;x=0;ap(216,k|0);if(!x){q=s;r=u;break L15}else{x=0}v=bQ(-1,-1,0)|0;w=K;bU();return 0}}while(0);L29:do{if((c[p>>2]|0)==0){y=0}else{x=0;aq(716,g|0,e|0);L31:do{if(!x){u=c[g+8>>2]|0;s=(x=0,as(80,u+1|0)|0);if(x){x=0;t=33;break}z=0;A=0;x=0,aS(24,e|0,z|0,A|0,0)|0;if(x){x=0;t=33;break}x=0,ax(52,e|0,s|0,u|0)|0;if(x){x=0;t=33;break}a[s+u|0]=0;u=c[p>>2]|0;do{if((u|0)!=0){A=(x=0,as(c[(c[k>>2]|0)+24>>2]|0,k|0)|0);if(x){x=0;z=bQ(-1,-1)|0;B=K;aX(u|0)|0;C=B;D=z;break L31}if((aX(u|0)|0)!=0){break}c[p>>2]=0;if((A|0)==0){y=s;break L29}}}while(0);u=c[(c[n>>2]|0)-12>>2]|0;x=0;aq(362,b+u|0,c[b+(u+16)>>2]|4|0);if(!x){y=s;break L29}else{x=0;t=33}}else{x=0;t=33}}while(0);if((t|0)==33){u=bQ(-1,-1)|0;C=K;D=u}c[j>>2]=14956;c[o>>2]=14976;x=0;ap(216,k|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,f+108|0);if(!x){bU();return 0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}x=0;ap(268,f+108|0);if(!x){be(D|0)}else{x=0}bQ(-1,-1,0)|0;bU();return 0}}while(0);c[j>>2]=14956;c[o>>2]=14976;x=0;ap(216,k|0);if(!x){C7(f+108|0);l=y;i=d;return l|0}else{x=0}p=bQ(-1,-1)|0;x=0;ap(268,f+108|0);if(!x){be(p|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{x=0;p=bQ(-1,-1)|0;q=p;r=K}}while(0);x=0;ap(268,h|0);if(!x){be(q|0)}else{x=0;v=bQ(-1,-1,0)|0;w=K;bU();return 0}return 0}function n8(a){a=a|0;var b=0;c[a>>2]=14956;c[a+108>>2]=14976;x=0;ap(216,a+8|0);if(!x){C7(a+108|0);return}else{x=0}b=bQ(-1,-1)|0;x=0;ap(268,a+108|0);if(!x){be(b|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function n9(a){a=a|0;od(a);return}function oa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;c[a>>2]=14956;c[a+108>>2]=14976;x=0;ap(216,a+8|0);if(x){x=0;b=bQ(-1,-1)|0;d=K;x=0;ap(268,a+108|0);if(!x){e=d;f=b;g=a;J2(g);be(f|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,a+108|0);if(!x){J2(a);return}else{x=0}b=bQ(-1,-1)|0;e=K;f=b;g=a;J2(g);be(f|0)}function ob(a){a=a|0;var b=0,d=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;c[b+d>>2]=14956;a=b+(d+108)|0;c[a>>2]=14976;x=0;ap(216,b+(d+8)|0);if(!x){C7(a);return}else{x=0}d=bQ(-1,-1)|0;x=0;ap(268,a|0);if(!x){be(d|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function oc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a;d=c[(c[a>>2]|0)-12>>2]|0;a=b+d|0;c[a>>2]=14956;e=b+(d+108)|0;c[e>>2]=14976;x=0;ap(216,b+(d+8)|0);if(x){x=0;d=bQ(-1,-1)|0;b=K;x=0;ap(268,e|0);if(!x){f=b;g=d;J2(a);be(g|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,e|0);if(!x){J2(a);return}else{x=0}e=bQ(-1,-1)|0;f=K;g=e;J2(a);be(g|0)}function od(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b|0;c[d>>2]=15192;e=b+64|0;f=c[e>>2]|0;do{if((f|0)!=0){x=0,as(240,b|0)|0;if(!x){if((aX(f|0)|0)!=0){break}c[e>>2]=0;break}else{x=0}g=bQ(-1,-1,0)|0;aX(f|0)|0;bA(g|0)|0;x=0;aQ(2);if(!x){break}else{x=0}g=bQ(-1,-1)|0;c[d>>2]=14880;x=0;ap(388,b+4|0);if(!x){be(g|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);do{if((a[b+96|0]&1)!=0){f=c[b+32>>2]|0;if((f|0)==0){break}J3(f)}}while(0);if((a[b+97|0]&1)==0){c[d>>2]=14880;h=b+4|0;HC(h);return}f=c[b+56>>2]|0;if((f|0)==0){c[d>>2]=14880;h=b+4|0;HC(h);return}J3(f);c[d>>2]=14880;h=b+4|0;HC(h);return}function oe(a){a=a|0;var b=0;x=0;ap(216,a|0);if(!x){J2(a);return}else{x=0;b=bQ(-1,-1)|0;J2(a);be(b|0)}}function of(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;cA[c[(c[b>>2]|0)+24>>2]&511](b)|0;e=HE(d,39976)|0;d=e;c[b+68>>2]=d;f=b+98|0;g=a[f]&1;h=cA[c[(c[e>>2]|0)+28>>2]&511](d)|0;a[f]=h&1;if((g&255|0)==(h&1|0)){return}g=b+96|0;Ke(b+8|0,0,24)|0;f=(a[g]&1)!=0;if(h){h=b+32|0;do{if(f){d=c[h>>2]|0;if((d|0)==0){break}J3(d)}}while(0);d=b+97|0;a[g]=a[d]&1;e=b+60|0;c[b+52>>2]=c[e>>2];i=b+56|0;c[h>>2]=c[i>>2];c[e>>2]=0;c[i>>2]=0;a[d]=0;return}do{if(!f){d=b+32|0;i=c[d>>2]|0;if((i|0)==(b+44|0)){break}e=c[b+52>>2]|0;c[b+60>>2]=e;c[b+56>>2]=i;a[b+97|0]=0;c[d>>2]=J1(e)|0;a[g]=1;return}}while(0);g=c[b+52>>2]|0;c[b+60>>2]=g;c[b+56>>2]=J1(g)|0;a[b+97|0]=1;return}function og(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b|0;g=b+96|0;Ke(b+8|0,0,24)|0;do{if((a[g]&1)!=0){h=c[b+32>>2]|0;if((h|0)==0){break}J3(h)}}while(0);h=b+97|0;do{if((a[h]&1)!=0){i=c[b+56>>2]|0;if((i|0)==0){break}J3(i)}}while(0);i=b+52|0;c[i>>2]=e;do{if(e>>>0>8>>>0){j=a[b+98|0]|0;if((j&1)==0|(d|0)==0){c[b+32>>2]=J1(e)|0;a[g]=1;k=j;break}else{c[b+32>>2]=d;a[g]=0;k=j;break}}else{c[b+32>>2]=b+44;c[i>>2]=8;a[g]=0;k=a[b+98|0]|0}}while(0);if((k&1)!=0){c[b+60>>2]=0;c[b+56>>2]=0;a[h]=0;return f|0}k=(e|0)<8?8:e;c[b+60>>2]=k;if((d|0)!=0&k>>>0>7>>>0){c[b+56>>2]=d;a[h]=0;return f|0}else{c[b+56>>2]=J1(k)|0;a[h]=1;return f|0}return 0}function oh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;g=c[b+68>>2]|0;if((g|0)==0){h=ci(4)|0;JB(h);bH(h|0,28080,98)}h=cA[c[(c[g>>2]|0)+24>>2]&511](g)|0;g=b+64|0;do{if((c[g>>2]|0)!=0){i=(h|0)>0;if(!(i|(d|0)==0&(e|0)==0)){break}if((cA[c[(c[b>>2]|0)+24>>2]&511](b)|0)!=0){break}if(f>>>0>=3>>>0){j=a;c[j>>2]=0;c[j+4>>2]=0;j=a+8|0;c[j>>2]=-1;c[j+4>>2]=-1;return}j=c[g>>2]|0;if(i){i=Kr(h,(h|0)<0|0?-1:0,d,e)|0;k=i}else{k=0}if((cf(j|0,k|0,f|0)|0)==0){j=bp(c[g>>2]|0)|0;i=b+72|0;l=c[i+4>>2]|0;m=a;c[m>>2]=c[i>>2];c[m+4>>2]=l;l=a+8|0;c[l>>2]=j;c[l+4>>2]=(j|0)<0|0?-1:0;return}else{j=a;c[j>>2]=0;c[j+4>>2]=0;j=a+8|0;c[j>>2]=-1;c[j+4>>2]=-1;return}}}while(0);b=a;c[b>>2]=0;c[b+4>>2]=0;b=a+8|0;c[b>>2]=-1;c[b+4>>2]=-1;return}function oi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;e=i;f=d;d=i;i=i+16|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];f=b+64|0;do{if((c[f>>2]|0)!=0){if((cA[c[(c[b>>2]|0)+24>>2]&511](b)|0)!=0){break}if((cf(c[f>>2]|0,c[d+8>>2]|0,0)|0)==0){g=d;h=c[g+4>>2]|0;j=b+72|0;c[j>>2]=c[g>>2];c[j+4>>2]=h;h=a;j=d;c[h>>2]=c[j>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];i=e;return}else{j=a;c[j>>2]=0;c[j+4>>2]=0;j=a+8|0;c[j>>2]=-1;c[j+4>>2]=-1;i=e;return}}}while(0);d=a;c[d>>2]=0;c[d+4>>2]=0;d=a+8|0;c[d>>2]=-1;c[d+4>>2]=-1;i=e;return}function oj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+16|0;e=d|0;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=ci(4)|0;JB(m);bH(m|0,28080,98);return 0}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;c[f>>2]=c[o>>2];c[f+4>>2]=p;do{if((a[b+98|0]&1)==0){p=cA[c[(c[l>>2]|0)+24>>2]&511](l)|0;o=b+36|0;q=c[o>>2]|0;r=(c[b+40>>2]|0)-q|0;if((p|0)>0){s=(ag((c[b+16>>2]|0)-(c[b+12>>2]|0)|0,p)|0)+r|0;t=0;break}p=c[b+12>>2]|0;if((p|0)==(c[b+16>>2]|0)){s=r;t=0;break}u=c[k>>2]|0;v=b+32|0;w=cW[c[(c[u>>2]|0)+32>>2]&31](u,g,c[v>>2]|0,q,p-(c[b+8>>2]|0)|0)|0;s=r-w+(c[o>>2]|0)-(c[v>>2]|0)|0;t=1}else{s=(c[b+16>>2]|0)-(c[b+12>>2]|0)|0;t=0}}while(0);if((cf(c[h>>2]|0,-s|0,1)|0)!=0){j=-1;i=d;return j|0}if(t){v=b+72|0;o=c[f+4>>2]|0;c[v>>2]=c[f>>2];c[v+4>>2]=o}o=c[b+32>>2]|0;c[b+40>>2]=o;c[b+36>>2]=o;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[m>>2]=0}else{do{if((c[b+24>>2]|0)!=(c[b+20>>2]|0)){if((cS[c[(c[b>>2]|0)+52>>2]&1023](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);o=b+72|0;v=b+32|0;w=b+52|0;while(1){r=c[k>>2]|0;p=c[v>>2]|0;q=cW[c[(c[r>>2]|0)+20>>2]&31](r,o,p,p+(c[w>>2]|0)|0,e)|0;p=c[v>>2]|0;r=(c[e>>2]|0)-p|0;if((a2(p|0,1,r|0,c[h>>2]|0)|0)!=(r|0)){j=-1;x=24;break}if((q|0)==2){j=-1;x=29;break}else if((q|0)!=1){x=10;break}}if((x|0)==24){i=d;return j|0}else if((x|0)==10){if((a$(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((x|0)==29){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function ok(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+16|0;f=e|0;g=e+8|0;h=b+64|0;if((c[h>>2]|0)==0){j=-1;i=e;return j|0}k=b+92|0;if((c[k>>2]&8|0)==0){c[b+24>>2]=0;c[b+20>>2]=0;c[b+28>>2]=0;if((a[b+98|0]&1)==0){l=c[b+56>>2]|0;m=l+(c[b+60>>2]|0)|0;c[b+8>>2]=l;c[b+12>>2]=m;c[b+16>>2]=m;n=m}else{m=c[b+32>>2]|0;l=m+(c[b+52>>2]|0)|0;c[b+8>>2]=m;c[b+12>>2]=l;c[b+16>>2]=l;n=l}c[k>>2]=8;o=1;p=n;q=b+12|0}else{n=b+12|0;o=0;p=c[n>>2]|0;q=n}if((p|0)==0){n=f+1|0;c[b+8>>2]=f;c[q>>2]=n;c[b+16>>2]=n;r=n}else{r=p}p=c[b+16>>2]|0;if(o){s=0}else{o=(p-(c[b+8>>2]|0)|0)/2|0;s=o>>>0>4>>>0?4:o}o=b+16|0;do{if((r|0)==(p|0)){n=b+8|0;Kc(c[n>>2]|0,r+(-s|0)|0,s|0)|0;if((a[b+98|0]&1)!=0){k=c[n>>2]|0;l=b7(k+s|0,1,(c[o>>2]|0)-s-k|0,c[h>>2]|0)|0;if((l|0)==0){t=-1;u=n;break}k=c[n>>2]|0;m=k+s|0;c[q>>2]=m;c[o>>2]=k+(l+s);t=d[m]|0;u=n;break}m=b+32|0;l=b+36|0;k=c[l>>2]|0;v=b+40|0;Kc(c[m>>2]|0,k|0,(c[v>>2]|0)-k|0)|0;k=c[m>>2]|0;w=k+((c[v>>2]|0)-(c[l>>2]|0))|0;c[l>>2]=w;if((k|0)==(b+44|0)){x=8}else{x=c[b+52>>2]|0}y=k+x|0;c[v>>2]=y;k=b+60|0;z=(c[k>>2]|0)-s|0;A=y-w|0;y=b+72|0;B=y;C=b+80|0;D=c[B+4>>2]|0;c[C>>2]=c[B>>2];c[C+4>>2]=D;D=b7(w|0,1,(A>>>0<z>>>0?A:z)|0,c[h>>2]|0)|0;if((D|0)==0){t=-1;u=n;break}z=c[b+68>>2]|0;if((z|0)==0){A=ci(4)|0;JB(A);bH(A|0,28080,98);return 0}A=(c[l>>2]|0)+D|0;c[v>>2]=A;D=c[n>>2]|0;if((cZ[c[(c[z>>2]|0)+16>>2]&31](z,y,c[m>>2]|0,A,l,D+s|0,D+(c[k>>2]|0)|0,g)|0)==3){k=c[m>>2]|0;m=c[v>>2]|0;c[n>>2]=k;c[q>>2]=k;c[o>>2]=m;t=d[k]|0;u=n;break}k=c[g>>2]|0;m=c[n>>2]|0;v=m+s|0;if((k|0)==(v|0)){t=-1;u=n;break}c[n>>2]=m;c[q>>2]=v;c[o>>2]=k;t=d[v]|0;u=n}else{t=d[r]|0;u=b+8|0}}while(0);if((c[u>>2]|0)!=(f|0)){j=t;i=e;return j|0}c[u>>2]=0;c[q>>2]=0;c[o>>2]=0;j=t;i=e;return j|0}function ol(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((c[b+64>>2]|0)==0){e=-1;return e|0}f=b+12|0;g=c[f>>2]|0;if((c[b+8>>2]|0)>>>0>=g>>>0){e=-1;return e|0}if((d|0)==-1){c[f>>2]=g-1;e=0;return e|0}h=g-1|0;do{if((c[b+88>>2]&16|0)==0){if((d<<24>>24|0)==(a[h]|0)){break}else{e=-1}return e|0}}while(0);c[f>>2]=h;a[h]=d;e=d;return e|0}function om(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+24|0;f=e|0;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}l=b+92|0;if((c[l>>2]&16|0)==0){c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;m=c[b+52>>2]|0;do{if(m>>>0>8>>>0){if((a[b+98|0]&1)==0){n=c[b+56>>2]|0;o=n+((c[b+60>>2]|0)-1)|0;c[b+24>>2]=n;c[b+20>>2]=n;c[b+28>>2]=o;p=n;q=o;break}else{o=c[b+32>>2]|0;n=o+(m-1)|0;c[b+24>>2]=o;c[b+20>>2]=o;c[b+28>>2]=n;p=o;q=n;break}}else{c[b+24>>2]=0;c[b+20>>2]=0;c[b+28>>2]=0;p=0;q=0}}while(0);c[l>>2]=16;r=p;s=q;t=b+20|0;u=b+28|0}else{q=b+20|0;p=b+28|0;r=c[q>>2]|0;s=c[p>>2]|0;t=q;u=p}p=(d|0)==-1;q=b+24|0;l=c[q>>2]|0;if(p){v=r;w=l}else{if((l|0)==0){c[q>>2]=f;c[t>>2]=f;c[u>>2]=f+1;x=f}else{x=l}a[x]=d;x=(c[q>>2]|0)+1|0;c[q>>2]=x;v=c[t>>2]|0;w=x}x=b+24|0;if((w|0)!=(v|0)){L23:do{if((a[b+98|0]&1)==0){q=b+32|0;l=c[q>>2]|0;c[g>>2]=l;f=b+68|0;m=c[f>>2]|0;if((m|0)==0){y=ci(4)|0;z=y;JB(z);bH(y|0,28080,98);return 0}n=b+72|0;o=b+52|0;A=m;m=v;B=w;C=l;while(1){l=cZ[c[(c[A>>2]|0)+12>>2]&31](A,n,m,B,h,C,C+(c[o>>2]|0)|0,g)|0;D=c[t>>2]|0;if((c[h>>2]|0)==(D|0)){k=-1;E=37;break}if((l|0)==3){E=22;break}if(l>>>0>=2>>>0){k=-1;E=36;break}F=c[q>>2]|0;G=(c[g>>2]|0)-F|0;if((a2(F|0,1,G|0,c[j>>2]|0)|0)!=(G|0)){k=-1;E=33;break}if((l|0)!=1){break L23}l=c[h>>2]|0;G=c[x>>2]|0;c[t>>2]=l;c[u>>2]=G;F=l+(G-l)|0;c[x>>2]=F;G=c[f>>2]|0;if((G|0)==0){E=39;break}A=G;m=l;B=F;C=c[q>>2]|0}if((E|0)==22){q=(c[x>>2]|0)-D|0;if((a2(D|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((E|0)==36){i=e;return k|0}else if((E|0)==37){i=e;return k|0}else if((E|0)==39){y=ci(4)|0;z=y;JB(z);bH(y|0,28080,98);return 0}else if((E|0)==33){i=e;return k|0}}else{q=w-v|0;if((a2(v|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);c[x>>2]=r;c[t>>2]=r;c[u>>2]=s}k=p?0:d;i=e;return k|0}function on(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+16|0;e=d|0;f=d+8|0;g=b|0;c[g>>2]=14880;h=b+4|0;HA(h);Ke(b+8|0,0,24)|0;c[g>>2]=15192;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;j=b+68|0;k=b+98|0;Ke(b+52|0,0,47)|0;HB(e,h);l=(x=0,aK(170,e|0,39976)|0);if(x){x=0;m=bQ(-1,-1)|0;bE(m|0)}x=0;ap(388,e|0);L4:do{if(!x){do{if(l){HB(f,h);e=(x=0,aK(196,f|0,39976)|0);if(!x){c[j>>2]=e;x=0;ap(388,f|0);if(x){x=0;n=8;break L4}e=c[j>>2]|0;a[k]=(cA[c[(c[e>>2]|0)+28>>2]&511](e)|0)&1;break}else{x=0;e=bQ(-1,-1)|0;m=K;x=0;ap(388,f|0);if(!x){o=m;p=e;break L4}else{x=0}q=bQ(-1,-1,0)|0;r=K;bU()}}}while(0);e=c[(c[b>>2]|0)+12>>2]|0;x=0,ax(e|0,b|0,0,4096)|0;if(x){x=0;n=8;break}i=d;return}else{x=0;n=8}}while(0);if((n|0)==8){n=bQ(-1,-1)|0;o=K;p=n}c[g>>2]=14880;x=0;ap(388,h|0);if(!x){be(p|0)}else{x=0;q=bQ(-1,-1,0)|0;r=K;bU()}}function oo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+168|0;g=f|0;h=f+16|0;j=f+24|0;k=f+88|0;l=f+104|0;m=f+120|0;n=f+136|0;o=f+152|0;p=J0(32)|0;q=k+8|0;c[q>>2]=p;c[k>>2]=33;c[k+4>>2]=19;Kb(p|0,8192,19)|0;a[p+19|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;x=0;ao(2,j|0,b|0,e|0,k|0,l|0);if(x){x=0;l=bQ(-1,-1)|0;p=l;l=K;if((a[k]&1)==0){r=p;s=l;t=r;u=0;v=t;w=s;be(v|0)}J2(c[q>>2]|0);r=p;s=l;t=r;u=0;v=t;w=s;be(v|0)}if((a[k]&1)!=0){J2(c[q>>2]|0)}q=j+20|0;k=(x=0,as(60,c[q>>2]|0)|0);do{if(!x){l=(x=0,as(196,k|0)|0);if(x){x=0;y=53;break}if((l|0)==0){z=c[j+56>>2]|0;A=c[j+60>>2]|0}else{p=j+48|0;B=c[p>>2]|0;C=c[q>>2]|0;L16:do{if(C>>>0<l>>>0){D=C;E=0;while(1){F=a[D]|0;if((F<<24>>24|0)==0){G=E;break L16}else if((F<<24>>24|0)==10){H=E+1|0}else{H=E}F=D+1|0;if(F>>>0<l>>>0){D=F;E=H}else{G=H;break}}}else{G=0}}while(0);c[p>>2]=G+B;E=k;D=0;while(1){F=E-1|0;if(F>>>0<C>>>0){break}if((a[F]|0)==10){break}else{E=F;D=D+1|0}}E=j+40|0;if((G|0)!=0){c[E>>2]=1}C=c[E>>2]|0;c[j+52>>2]=C+D;B=l;p=k;c[E>>2]=B-p+D+C;C=j+56|0;c[C>>2]=p;c[C+4>>2]=B;c[q>>2]=l;z=k;A=l}B=A-z|0;if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;y=53;break}return 0}if(B>>>0<11>>>0){C=B<<1&255;a[m]=C;I=m+1|0;J=C}else{C=B+16&-16;p=(x=0,as(230,C|0)|0);if(x){x=0;y=53;break}c[m+8>>2]=p;E=C|1;c[m>>2]=E;c[m+4>>2]=B;I=p;J=E&255}Kb(I|0,z|0,B)|0;a[I+B|0]=0;B=(x=0,as(112,j|0)|0);do{if(!x){E=(x=0,as(230,72)|0);if(x){x=0;y=54;break}p=E;c[h>>2]=p;E=e+4|0;C=c[E>>2]|0;if((C|0)==(c[e+8>>2]|0)){x=0;aq(376,e|0,h|0);if(x){x=0;y=54;break}L=c[h>>2]|0}else{if((C|0)==0){M=0}else{c[C>>2]=p;M=c[E>>2]|0}c[E>>2]=M+4;L=p}p=L;C=L;F=(x=0,as(230,32)|0);do{if(!x){N=n+8|0;c[N>>2]=F;c[n>>2]=33;c[n+4>>2]=19;Kb(F|0,8192,19)|0;a[F+19|0]=0;L54:do{if((J&1)==0){O=m;P=o;c[P>>2]=c[O>>2];c[P+4>>2]=c[O+4>>2];c[P+8>>2]=c[O+8>>2];y=44}else{O=c[m+8>>2]|0;P=c[m+4>>2]|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(P>>>0<11>>>0){a[o]=P<<1;Q=o+1|0}else{R=P+16&-16;S=(x=0,as(230,R|0)|0);if(x){x=0;break}c[o+8>>2]=S;c[o>>2]=R|1;c[o+4>>2]=P;Q=S}Kb(Q|0,O|0,P)|0;a[Q+P|0]=0;y=44;break L54}}while(0);P=bQ(-1,-1)|0;T=P;U=K}}while(0);do{if((y|0)==44){c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;x=0;aA(16,C|0,n|0,g|0,b|0,o|0,B|0,d|0,0);if(x){x=0;P=bQ(-1,-1)|0;O=P;P=K;if((a[o]&1)==0){T=O;U=P;break}J2(c[o+8>>2]|0);T=O;U=P;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)!=0){J2(c[N>>2]|0)}if((J&1)!=0){J2(c[m+8>>2]|0)}if((a[j+28|0]&1)!=0){J2(c[j+36>>2]|0)}P=c[j+4>>2]|0;if((P|0)==0){i=f;return C|0}O=j+8|0;S=c[O>>2]|0;if((P|0)!=(S|0)){c[O>>2]=S+(~((S-4+(-P|0)|0)>>>2)<<2)}J2(P);i=f;return C|0}}while(0);if((a[n]&1)==0){V=T;W=U;break}J2(c[N>>2]|0);V=T;W=U}else{x=0;P=bQ(-1,-1)|0;V=P;W=K}}while(0);C=c[e>>2]|0;F=c[E>>2]|0;P=C;while(1){if((P|0)==(F|0)){X=F;break}if((c[P>>2]|0)==(L|0)){X=P;break}else{P=P+4|0}}P=X-C>>2;S=C+(P+1<<2)|0;O=F-S|0;Kc(C+(P<<2)|0,S|0,O|0)|0;S=C+((O>>2)+P<<2)|0;P=c[E>>2]|0;if((S|0)!=(P|0)){c[E>>2]=P+(~((P-4+(-S|0)|0)>>>2)<<2)}J2(p);Y=V;Z=W}else{x=0;y=54}}while(0);if((y|0)==54){B=bQ(-1,-1)|0;Y=B;Z=K}if((J&1)==0){_=Y;$=Z;break}J2(c[m+8>>2]|0);_=Y;$=Z}else{x=0;y=53}}while(0);if((y|0)==53){y=bQ(-1,-1)|0;_=y;$=K}if((a[j+28|0]&1)!=0){J2(c[j+36>>2]|0)}y=c[j+4>>2]|0;if((y|0)==0){r=_;s=$;t=r;u=0;v=t;w=s;be(v|0)}Z=j+8|0;j=c[Z>>2]|0;if((y|0)!=(j|0)){c[Z>>2]=j+(~((j-4+(-y|0)|0)>>>2)<<2)}J2(y);r=_;s=$;t=r;u=0;v=t;w=s;be(v|0);return 0}function op(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;m=i;i=i+16|0;n=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=m|0;o=n;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+144|0;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=p;v=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];u=oq(b,d,e,f,p,l)|0;w=+h[u+40>>3];if(!(w<j|w>k)){i=m;return u|0}p=q+64|0;d=q|0;g=q+8|0;y=g|0;c[y>>2]=14576;z=q+12|0;c[d>>2]=31212;A=q+64|0;c[A>>2]=31232;c[q+4>>2]=0;x=0;aq(200,q+64|0,z|0);do{if(!x){c[q+136>>2]=0;c[q+140>>2]=-1;B=q+8|0;c[d>>2]=14556;c[p>>2]=14596;c[y>>2]=14576;C=z|0;c[C>>2]=14880;D=q+16|0;HA(D);Ke(q+20|0,0,24)|0;c[C>>2]=14736;E=q+44|0;Ke(q+44|0,0,16)|0;c[q+60>>2]=24;Ke(o|0,0,12)|0;x=0;aq(214,z|0,n|0);if(x){x=0;F=bQ(-1,-1)|0;G=K;if((a[o]&1)!=0){J2(c[n+8>>2]|0)}if((a[E]&1)!=0){J2(c[q+52>>2]|0)}c[C>>2]=14880;x=0;ap(388,D|0);if(!x){H=F;I=G;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}if((a[o]&1)!=0){J2(c[n+8>>2]|0)}G=g;F=(x=0,aK(112,G|0,8840)|0);do{if(!x){C=(x=0,aK(802,F|0,b|0)|0);if(x){x=0;J=47;break}L=(x=0,aK(112,C|0,7160)|0);if(x){x=0;J=47;break}C=(x=0,aK(112,L|0,e|0)|0);if(x){x=0;J=47;break}x=0,aK(112,C|0,5520)|0;if(x){x=0;J=47;break}C=(x=0,aF(2,G|0,+j)|0);if(x){x=0;J=47;break}L=(x=0,aK(112,C|0,4424)|0);if(x){x=0;J=47;break}x=0,aF(2,L|0,+k)|0;if(x){x=0;J=47;break}x=0;aq(560,r|0,z|0);if(x){x=0;J=47;break}L=f;L30:do{if((a[L]&1)==0){C=s;c[C>>2]=c[L>>2];c[C+4>>2]=c[L+4>>2];c[C+8>>2]=c[L+8>>2];J=35}else{C=c[f+8>>2]|0;M=c[f+4>>2]|0;do{if(M>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(M>>>0<11>>>0){a[s]=M<<1;N=s+1|0}else{O=M+16&-16;P=(x=0,as(230,O|0)|0);if(x){x=0;break}c[s+8>>2]=P;c[s>>2]=O|1;c[s+4>>2]=M;N=P}Kb(N|0,C|0,M)|0;a[N+M|0]=0;J=35;break L30}}while(0);M=bQ(-1,-1)|0;Q=K;R=M}}while(0);do{if((J|0)==35){L=t;c[L>>2]=c[v>>2];c[L+4>>2]=c[v+4>>2];c[L+8>>2]=c[v+8>>2];x=0;aT(42,r|0,s|0,t|0,l|0);if(x){x=0;L=bQ(-1,-1)|0;M=L;L=K;if((a[s]&1)==0){Q=L;R=M;break}J2(c[s+8>>2]|0);Q=L;R=M;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}c[d>>2]=14556;c[A>>2]=14596;c[B>>2]=14576;M=q+12|0;c[M>>2]=14736;if((a[E]&1)!=0){J2(c[q+52>>2]|0)}c[M>>2]=14880;x=0;ap(388,D|0);if(!x){C7(q+64|0);i=m;return u|0}else{x=0}M=bQ(-1,-1)|0;x=0;ap(268,q+64|0);if(!x){be(M|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);if((a[r]&1)==0){S=Q;T=R;break}J2(c[r+8>>2]|0);S=Q;T=R}else{x=0;J=47}}while(0);if((J|0)==47){G=bQ(-1,-1)|0;S=K;T=G}c[d>>2]=14556;c[A>>2]=14596;c[B>>2]=14576;G=q+12|0;c[G>>2]=14736;if((a[E]&1)!=0){J2(c[q+52>>2]|0)}c[G>>2]=14880;x=0;ap(388,D|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,q+64|0);if(!x){bU();return 0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}x=0;ap(268,q+64|0);if(!x){be(T|0)}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{x=0;G=bQ(-1,-1)|0;H=G;I=K}}while(0);x=0;ap(268,p|0);if(!x){be(H|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function oq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){CJ(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=J0(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}Kb(t|0,r|0,s)|0;a[t+s|0]=0}s=(x=0,aK(88,d|0,k|0)|0);if(x){x=0;d=bQ(-1,-1)|0;t=d;d=K;if((a[k]&1)==0){w=d;y=t;z=y;A=0;B=z;C=w;be(B|0)}J2(c[k+8>>2]|0);w=d;y=t;z=y;A=0;B=z;C=w;be(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=JP(t,29912,30096,-1)|0}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;Kb(k+1|0,8840,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){F=q>>>1}else{F=c[b+4>>2]|0}x=0,ax(64,l|0,E|0,F|0)|0;do{if(!x){x=0,ax(64,l|0,7160,6)|0;if(x){x=0;G=57;break}F=Kf(e|0)|0;x=0,ax(64,l|0,e|0,F|0)|0;if(x){x=0;G=57;break}x=0,ax(64,l|0,11032,12)|0;if(x){x=0;G=57;break}F=m;E=m;a[E]=12;b=F+1|0;a[b]=a[10792]|0;a[b+1|0]=a[10793]|0;a[b+2|0]=a[10794]|0;a[b+3|0]=a[10795]|0;a[b+4|0]=a[10796]|0;a[b+5|0]=a[10797]|0;a[F+7|0]=0;x=0,ax(64,l|0,b|0,6)|0;if(x){x=0;b=bQ(-1,-1)|0;F=b;b=K;if((a[E]&1)==0){H=b;I=F;break}J2(c[m+8>>2]|0);H=b;I=F;break}if((a[E]&1)!=0){J2(c[m+8>>2]|0)}if((a[t]&1)==0){E=n;c[E>>2]=c[t>>2];c[E+4>>2]=c[t+4>>2];c[E+8>>2]=c[t+8>>2]}else{E=c[l+8>>2]|0;F=c[l+4>>2]|0;if(F>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=57;break}return 0}if(F>>>0<11>>>0){a[n]=F<<1;J=n+1|0}else{b=F+16&-16;q=(x=0,as(230,b|0)|0);if(x){x=0;G=57;break}c[n+8>>2]=q;c[n>>2]=b|1;c[n+4>>2]=F;J=q}Kb(J|0,E|0,F)|0;a[J+F|0]=0}F=f;L61:do{if((a[F]&1)==0){E=o;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];G=50}else{E=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;L=o+1|0}else{b=q+16&-16;k=(x=0,as(230,b|0)|0);if(x){x=0;break}c[o+8>>2]=k;c[o>>2]=b|1;c[o+4>>2]=q;L=k}Kb(L|0,E|0,q)|0;a[L+q|0]=0;G=50;break L61}}while(0);q=bQ(-1,-1)|0;M=K;N=q}}while(0);do{if((G|0)==50){F=p;q=g;c[F>>2]=c[q>>2];c[F+4>>2]=c[q+4>>2];c[F+8>>2]=c[q+8>>2];x=0;aT(42,n|0,o|0,p|0,h|0);if(x){x=0;q=bQ(-1,-1)|0;F=q;q=K;if((a[o]&1)==0){M=q;N=F;break}J2(c[o+8>>2]|0);M=q;N=F;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}J2(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){H=M;I=N;break}J2(c[n+8>>2]|0);H=M;I=N}else{x=0;G=57}}while(0);if((G|0)==57){G=bQ(-1,-1)|0;H=K;I=G}if((a[t]&1)==0){w=H;y=I;z=y;A=0;B=z;C=w;be(B|0)}J2(c[l+8>>2]|0);w=H;y=I;z=y;A=0;B=z;C=w;be(B|0);return 0}function or(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;k=i;i=i+168|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=k+152|0;w=J0(88)|0;c[m>>2]=w;y=d+4|0;z=c[y>>2]|0;if((z|0)==(c[d+8>>2]|0)){ee(d|0,m);A=c[m>>2]|0}else{if((z|0)==0){B=0}else{c[z>>2]=w;B=c[y>>2]|0}c[y>>2]=B+4;A=w}w=A;B=A;z=f;L8:do{if((a[z]&1)==0){m=n;c[m>>2]=c[z>>2];c[m+4>>2]=c[z+4>>2];c[m+8>>2]=c[z+8>>2];D=16}else{m=c[f+8>>2]|0;E=c[f+4>>2]|0;do{if(E>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(E>>>0<11>>>0){a[n]=E<<1;F=n+1|0}else{G=E+16&-16;H=(x=0,as(230,G|0)|0);if(x){x=0;break}c[n+8>>2]=H;c[n>>2]=G|1;c[n+4>>2]=E;F=H}Kb(F|0,m|0,E)|0;a[F+E|0]=0;D=16;break L8}}while(0);E=bQ(-1,-1)|0;I=K;J=E}}while(0);do{if((D|0)==16){F=o;z=g;c[F>>2]=c[z>>2];c[F+4>>2]=c[z+4>>2];c[F+8>>2]=c[z+8>>2];E=p;m=p;a[m]=8;H=E+1|0;C=1684369956;a[H]=C;C=C>>8;a[H+1|0]=C;C=C>>8;a[H+2|0]=C;C=C>>8;a[H+3|0]=C;a[E+5|0]=0;E=q;c[E>>2]=c[z>>2];c[E+4>>2]=c[z+4>>2];c[E+8>>2]=c[z+8>>2];E=(x=0,an(2,p|0,b|0,e|0,f|0,q|0,+0.0,+255.0,j|0)|0);do{if(!x){L=+h[E+40>>3];H=r;G=r;a[G]=12;M=H+1|0;a[M]=a[1128]|0;a[M+1|0]=a[1129]|0;a[M+2|0]=a[1130]|0;a[M+3|0]=a[1131]|0;a[M+4|0]=a[1132]|0;a[M+5|0]=a[1133]|0;a[H+7|0]=0;H=s;c[H>>2]=c[z>>2];c[H+4>>2]=c[z+4>>2];c[H+8>>2]=c[z+8>>2];H=(x=0,an(2,r|0,b|0,e|0,f|0,s|0,+0.0,+255.0,j|0)|0);do{if(!x){N=+h[H+40>>3];M=t;O=t;a[O]=10;P=M+1|0;a[P]=a[536]|0;a[P+1|0]=a[537]|0;a[P+2|0]=a[538]|0;a[P+3|0]=a[539]|0;a[P+4|0]=a[540]|0;a[M+6|0]=0;M=u;c[M>>2]=c[z>>2];c[M+4>>2]=c[z+4>>2];c[M+8>>2]=c[z+8>>2];M=(x=0,an(2,t|0,b|0,e|0,f|0,u|0,+0.0,+255.0,j|0)|0);do{if(!x){Q=+h[M+40>>3];P=v;a[P]=0;a[v+1|0]=0;R=l;c[R>>2]=c[F>>2];c[R+4>>2]=c[F+4>>2];c[R+8>>2]=c[F+8>>2];x=0;at(2,B|0,n|0,l|0,+L,+N,+Q,+1.0,v|0);if(x){x=0;R=bQ(-1,-1)|0;S=R;R=K;if((a[P]&1)==0){T=R;U=S;break}J2(c[v+8>>2]|0);T=R;U=S;break}S=A;if((a[P]&1)!=0){J2(c[v+8>>2]|0)}if((a[O]&1)!=0){J2(c[t+8>>2]|0)}if((a[G]&1)!=0){J2(c[r+8>>2]|0)}if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return S|0}J2(c[n+8>>2]|0);i=k;return S|0}else{x=0;S=bQ(-1,-1)|0;T=K;U=S}}while(0);if((a[O]&1)==0){V=T;W=U;break}J2(c[t+8>>2]|0);V=T;W=U}else{x=0;M=bQ(-1,-1)|0;V=K;W=M}}while(0);if((a[G]&1)==0){X=V;Y=W;break}J2(c[r+8>>2]|0);X=V;Y=W}else{x=0;H=bQ(-1,-1)|0;X=K;Y=H}}while(0);if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){I=X;J=Y;break}J2(c[n+8>>2]|0);I=X;J=Y}}while(0);Y=c[d>>2]|0;d=c[y>>2]|0;X=Y;while(1){if((X|0)==(d|0)){Z=d;break}if((c[X>>2]|0)==(A|0)){Z=X;break}else{X=X+4|0}}X=Z-Y>>2;Z=Y+(X+1<<2)|0;A=d-Z|0;Kc(Y+(X<<2)|0,Z|0,A|0)|0;Z=Y+((A>>2)+X<<2)|0;X=c[y>>2]|0;if((Z|0)==(X|0)){J2(w);_=J;$=0;aa=_;ab=I;be(aa|0)}c[y>>2]=X+(~((X-4+(-Z|0)|0)>>>2)<<2);J2(w);_=J;$=0;aa=_;ab=I;be(aa|0);return 0}function os(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0,S=0.0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0;k=i;i=i+200|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=k+152|0;w=k+168|0;y=k+184|0;z=J0(88)|0;c[m>>2]=z;A=d+4|0;B=c[A>>2]|0;if((B|0)==(c[d+8>>2]|0)){ee(d|0,m);D=c[m>>2]|0}else{if((B|0)==0){E=0}else{c[B>>2]=z;E=c[A>>2]|0}c[A>>2]=E+4;D=z}z=D;E=D;B=f;L8:do{if((a[B]&1)==0){m=n;c[m>>2]=c[B>>2];c[m+4>>2]=c[B+4>>2];c[m+8>>2]=c[B+8>>2];F=16}else{m=c[f+8>>2]|0;G=c[f+4>>2]|0;do{if(G>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(G>>>0<11>>>0){a[n]=G<<1;H=n+1|0}else{I=G+16&-16;J=(x=0,as(230,I|0)|0);if(x){x=0;break}c[n+8>>2]=J;c[n>>2]=I|1;c[n+4>>2]=G;H=J}Kb(H|0,m|0,G)|0;a[H+G|0]=0;F=16;break L8}}while(0);G=bQ(-1,-1)|0;L=K;M=G}}while(0);do{if((F|0)==16){H=o;B=g;c[H>>2]=c[B>>2];c[H+4>>2]=c[B+4>>2];c[H+8>>2]=c[B+8>>2];G=p;m=p;a[m]=8;J=G+1|0;C=1684369956;a[J]=C;C=C>>8;a[J+1|0]=C;C=C>>8;a[J+2|0]=C;C=C>>8;a[J+3|0]=C;a[G+5|0]=0;G=q;c[G>>2]=c[B>>2];c[G+4>>2]=c[B+4>>2];c[G+8>>2]=c[B+8>>2];G=(x=0,an(2,p|0,b|0,e|0,f|0,q|0,+0.0,+255.0,j|0)|0);do{if(!x){N=+h[G+40>>3];J=r;I=r;a[I]=12;O=J+1|0;a[O]=a[1128]|0;a[O+1|0]=a[1129]|0;a[O+2|0]=a[1130]|0;a[O+3|0]=a[1131]|0;a[O+4|0]=a[1132]|0;a[O+5|0]=a[1133]|0;a[J+7|0]=0;J=s;c[J>>2]=c[B>>2];c[J+4>>2]=c[B+4>>2];c[J+8>>2]=c[B+8>>2];J=(x=0,an(2,r|0,b|0,e|0,f|0,s|0,+0.0,+255.0,j|0)|0);do{if(!x){P=+h[J+40>>3];O=t;Q=t;a[Q]=10;R=O+1|0;a[R]=a[536]|0;a[R+1|0]=a[537]|0;a[R+2|0]=a[538]|0;a[R+3|0]=a[539]|0;a[R+4|0]=a[540]|0;a[O+6|0]=0;O=u;c[O>>2]=c[B>>2];c[O+4>>2]=c[B+4>>2];c[O+8>>2]=c[B+8>>2];O=(x=0,an(2,t|0,b|0,e|0,f|0,u|0,+0.0,+255.0,j|0)|0);do{if(!x){S=+h[O+40>>3];R=v;T=v;a[T]=12;U=R+1|0;a[U]=a[10864]|0;a[U+1|0]=a[10865]|0;a[U+2|0]=a[10866]|0;a[U+3|0]=a[10867]|0;a[U+4|0]=a[10868]|0;a[U+5|0]=a[10869]|0;a[R+7|0]=0;R=w;c[R>>2]=c[B>>2];c[R+4>>2]=c[B+4>>2];c[R+8>>2]=c[B+8>>2];R=(x=0,an(2,v|0,b|0,e|0,f|0,w|0,+0.0,+1.0,j|0)|0);do{if(!x){V=+h[R+40>>3];U=y;a[U]=0;a[y+1|0]=0;W=l;c[W>>2]=c[H>>2];c[W+4>>2]=c[H+4>>2];c[W+8>>2]=c[H+8>>2];x=0;at(2,E|0,n|0,l|0,+N,+P,+S,+V,y|0);if(x){x=0;W=bQ(-1,-1)|0;X=W;W=K;if((a[U]&1)==0){Y=W;Z=X;break}J2(c[y+8>>2]|0);Y=W;Z=X;break}X=D;if((a[U]&1)!=0){J2(c[y+8>>2]|0)}if((a[T]&1)!=0){J2(c[v+8>>2]|0)}if((a[Q]&1)!=0){J2(c[t+8>>2]|0)}if((a[I]&1)!=0){J2(c[r+8>>2]|0)}if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return X|0}J2(c[n+8>>2]|0);i=k;return X|0}else{x=0;X=bQ(-1,-1)|0;Y=K;Z=X}}while(0);if((a[T]&1)==0){_=Y;$=Z;break}J2(c[v+8>>2]|0);_=Y;$=Z}else{x=0;R=bQ(-1,-1)|0;_=K;$=R}}while(0);if((a[Q]&1)==0){aa=_;ab=$;break}J2(c[t+8>>2]|0);aa=_;ab=$}else{x=0;O=bQ(-1,-1)|0;aa=K;ab=O}}while(0);if((a[I]&1)==0){ac=aa;ad=ab;break}J2(c[r+8>>2]|0);ac=aa;ad=ab}else{x=0;J=bQ(-1,-1)|0;ac=K;ad=J}}while(0);if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){L=ac;M=ad;break}J2(c[n+8>>2]|0);L=ac;M=ad}}while(0);ad=c[d>>2]|0;d=c[A>>2]|0;ac=ad;while(1){if((ac|0)==(d|0)){ae=d;break}if((c[ac>>2]|0)==(D|0)){ae=ac;break}else{ac=ac+4|0}}ac=ae-ad>>2;ae=ad+(ac+1<<2)|0;D=d-ae|0;Kc(ad+(ac<<2)|0,ae|0,D|0)|0;ae=ad+((D>>2)+ac<<2)|0;ac=c[A>>2]|0;if((ae|0)==(ac|0)){J2(z);af=M;ag=0;ah=af;ai=L;be(ah|0)}c[A>>2]=ac+(~((ac-4+(-ae|0)|0)>>>2)<<2);J2(z);af=M;ag=0;ah=af;ai=L;be(ah|0);return 0}function ot(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=m;t=m;a[t]=12;u=s+1|0;a[u]=a[10240]|0;a[u+1|0]=a[10241]|0;a[u+2|0]=a[10242]|0;a[u+3|0]=a[10243]|0;a[u+4|0]=a[10244]|0;a[u+5|0]=a[10245]|0;a[s+7|0]=0;s=n;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(x=0,ar(100,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(x){x=0;n=bQ(-1,-1)|0;g=n;n=K;if((a[t]&1)==0){v=g;w=n;y=v;z=0;A=y;B=w;be(A|0)}J2(c[m+8>>2]|0);v=g;w=n;y=v;z=0;A=y;B=w;be(A|0)}if((a[t]&1)!=0){J2(c[m+8>>2]|0)}m=J0(88)|0;c[l>>2]=m;t=d+4|0;n=c[t>>2]|0;if((n|0)==(c[d+8>>2]|0)){ee(d|0,l);C=c[l>>2]|0}else{if((n|0)==0){D=0}else{c[n>>2]=m;D=c[t>>2]|0}c[t>>2]=D+4;C=m}m=C;x=0;aq(600,C|0,s|0);if(x){x=0;s=bQ(-1,-1)|0;D=s;s=K;n=c[d>>2]|0;d=c[t>>2]|0;l=n;while(1){if((l|0)==(d|0)){E=d;break}if((c[l>>2]|0)==(C|0)){E=l;break}else{l=l+4|0}}l=E-n>>2;E=n+(l+1<<2)|0;g=d-E|0;Kc(n+(l<<2)|0,E|0,g|0)|0;E=n+((g>>2)+l<<2)|0;l=c[t>>2]|0;if((E|0)!=(l|0)){c[t>>2]=l+(~((l-4+(-E|0)|0)>>>2)<<2)}J2(m);v=D;w=s;y=v;z=0;A=y;B=w;be(A|0)}s=o;D=o;a[D]=12;m=s+1|0;a[m]=a[10864]|0;a[m+1|0]=a[10865]|0;a[m+2|0]=a[10866]|0;a[m+3|0]=a[10867]|0;a[m+4|0]=a[10868]|0;a[m+5|0]=a[10869]|0;a[s+7|0]=0;s=p;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];u=(x=0,an(2,o|0,b|0,e|0,f|0,p|0,+0.0,+1.0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;p=j;j=K;if((a[D]&1)==0){v=p;w=j;y=v;z=0;A=y;B=w;be(A|0)}J2(c[o+8>>2]|0);v=p;w=j;y=v;z=0;A=y;B=w;be(A|0)}h[C+64>>3]=+h[u+40>>3];if((a[D]&1)!=0){J2(c[o+8>>2]|0)}o=r;a[o]=0;a[r+1|0]=0;D=(x=0,aK(346,C+72|0,r|0)|0);do{if(!x){u=D;if((a[u]&1)==0){j=q;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];F=a[j]|0}else{j=c[D+8>>2]|0;u=c[D+4>>2]|0;if(u>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(u>>>0<11>>>0){p=u<<1&255;a[q]=p;G=q+1|0;H=p}else{p=u+16&-16;f=(x=0,as(230,p|0)|0);if(x){x=0;break}c[q+8>>2]=f;e=p|1;c[q>>2]=e;c[q+4>>2]=u;G=f;H=e&255}Kb(G|0,j|0,u)|0;a[G+u|0]=0;F=H}if((F&1)!=0){J2(c[q+8>>2]|0)}if((a[o]&1)==0){I=C;i=k;return I|0}J2(c[r+8>>2]|0);I=C;i=k;return I|0}else{x=0}}while(0);I=bQ(-1,-1)|0;k=I;I=K;if((a[o]&1)==0){v=k;w=I;y=v;z=0;A=y;B=w;be(A|0)}J2(c[r+8>>2]|0);v=k;w=I;y=v;z=0;A=y;B=w;be(A|0);return 0}function ou(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){CJ(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=J0(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}Kb(t|0,r|0,s)|0;a[t+s|0]=0}s=(x=0,aK(88,d|0,k|0)|0);if(x){x=0;d=bQ(-1,-1)|0;t=d;d=K;if((a[k]&1)==0){w=d;y=t;z=y;A=0;B=z;C=w;be(B|0)}J2(c[k+8>>2]|0);w=d;y=t;z=y;A=0;B=z;C=w;be(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=JP(t,29912,30184,-1)|0}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;Kb(k+1|0,8840,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){F=q>>>1}else{F=c[b+4>>2]|0}x=0,ax(64,l|0,E|0,F|0)|0;do{if(!x){x=0,ax(64,l|0,7160,6)|0;if(x){x=0;G=57;break}F=Kf(e|0)|0;x=0,ax(64,l|0,e|0,F|0)|0;if(x){x=0;G=57;break}x=0,ax(64,l|0,11032,12)|0;if(x){x=0;G=57;break}F=m;E=m;a[E]=10;b=F+1|0;a[b]=a[12304]|0;a[b+1|0]=a[12305]|0;a[b+2|0]=a[12306]|0;a[b+3|0]=a[12307]|0;a[b+4|0]=a[12308]|0;a[F+6|0]=0;x=0,ax(64,l|0,b|0,5)|0;if(x){x=0;b=bQ(-1,-1)|0;F=b;b=K;if((a[E]&1)==0){H=b;I=F;break}J2(c[m+8>>2]|0);H=b;I=F;break}if((a[E]&1)!=0){J2(c[m+8>>2]|0)}if((a[t]&1)==0){E=n;c[E>>2]=c[t>>2];c[E+4>>2]=c[t+4>>2];c[E+8>>2]=c[t+8>>2]}else{E=c[l+8>>2]|0;F=c[l+4>>2]|0;if(F>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=57;break}return 0}if(F>>>0<11>>>0){a[n]=F<<1;J=n+1|0}else{b=F+16&-16;q=(x=0,as(230,b|0)|0);if(x){x=0;G=57;break}c[n+8>>2]=q;c[n>>2]=b|1;c[n+4>>2]=F;J=q}Kb(J|0,E|0,F)|0;a[J+F|0]=0}F=f;L61:do{if((a[F]&1)==0){E=o;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];G=50}else{E=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;L=o+1|0}else{b=q+16&-16;k=(x=0,as(230,b|0)|0);if(x){x=0;break}c[o+8>>2]=k;c[o>>2]=b|1;c[o+4>>2]=q;L=k}Kb(L|0,E|0,q)|0;a[L+q|0]=0;G=50;break L61}}while(0);q=bQ(-1,-1)|0;M=K;N=q}}while(0);do{if((G|0)==50){F=p;q=g;c[F>>2]=c[q>>2];c[F+4>>2]=c[q+4>>2];c[F+8>>2]=c[q+8>>2];x=0;aT(42,n|0,o|0,p|0,h|0);if(x){x=0;q=bQ(-1,-1)|0;F=q;q=K;if((a[o]&1)==0){M=q;N=F;break}J2(c[o+8>>2]|0);M=q;N=F;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}J2(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){H=M;I=N;break}J2(c[n+8>>2]|0);H=M;I=N}else{x=0;G=57}}while(0);if((G|0)==57){G=bQ(-1,-1)|0;H=K;I=G}if((a[t]&1)==0){w=H;y=I;z=y;A=0;B=z;C=w;be(B|0)}J2(c[l+8>>2]|0);w=H;y=I;z=y;A=0;B=z;C=w;be(B|0);return 0}function ov(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=J0(72)|0;c[m>>2]=s;t=d+4|0;u=c[t>>2]|0;if((u|0)==(c[d+8>>2]|0)){ee(d|0,m);v=c[m>>2]|0}else{if((u|0)==0){w=0}else{c[u>>2]=s;w=c[t>>2]|0}c[t>>2]=w+4;v=s}s=v;w=v;u=f;L8:do{if((a[u]&1)==0){m=n;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];y=16}else{m=c[f+8>>2]|0;z=c[f+4>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[n]=z<<1;A=n+1|0}else{B=z+16&-16;C=(x=0,as(230,B|0)|0);if(x){x=0;break}c[n+8>>2]=C;c[n>>2]=B|1;c[n+4>>2]=z;A=C}Kb(A|0,m|0,z)|0;a[A+z|0]=0;y=16;break L8}}while(0);z=bQ(-1,-1)|0;D=K;E=z}}while(0);do{if((y|0)==16){A=o;u=g;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];z=p;m=p;a[m]=12;C=z+1|0;a[C]=a[10240]|0;a[C+1|0]=a[10241]|0;a[C+2|0]=a[10242]|0;a[C+3|0]=a[10243]|0;a[C+4|0]=a[10244]|0;a[C+5|0]=a[10245]|0;a[z+7|0]=0;z=q;c[z>>2]=c[u>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];u=(x=0,ar(100,p|0,b|0,e|0,f|0,q|0,j|0)|0);do{if(!x){F=+h[u+40>>3];z=r;a[z]=0;a[r+1|0]=0;C=l;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];x=0;aE(2,w|0,n|0,l|0,+F,r|0);if(x){x=0;C=bQ(-1,-1)|0;B=C;C=K;if((a[z]&1)==0){G=C;H=B;break}J2(c[r+8>>2]|0);G=C;H=B;break}B=v;if((a[z]&1)!=0){J2(c[r+8>>2]|0)}if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return B|0}J2(c[n+8>>2]|0);i=k;return B|0}else{x=0;B=bQ(-1,-1)|0;G=K;H=B}}while(0);if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){D=G;E=H;break}J2(c[n+8>>2]|0);D=G;E=H}}while(0);H=c[d>>2]|0;d=c[t>>2]|0;G=H;while(1){if((G|0)==(d|0)){I=d;break}if((c[G>>2]|0)==(v|0)){I=G;break}else{G=G+4|0}}G=I-H>>2;I=H+(G+1<<2)|0;v=d-I|0;Kc(H+(G<<2)|0,I|0,v|0)|0;I=H+((v>>2)+G<<2)|0;G=c[t>>2]|0;if((I|0)==(G|0)){J2(s);J=E;L=0;M=J;N=D;be(M|0)}c[t>>2]=G+(~((G-4+(-I|0)|0)>>>2)<<2);J2(s);J=E;L=0;M=J;N=D;be(M|0);return 0}function ow(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=J0(72)|0;c[m>>2]=s;t=d+4|0;u=c[t>>2]|0;if((u|0)==(c[d+8>>2]|0)){ee(d|0,m);v=c[m>>2]|0}else{if((u|0)==0){w=0}else{c[u>>2]=s;w=c[t>>2]|0}c[t>>2]=w+4;v=s}s=v;w=v;u=f;L8:do{if((a[u]&1)==0){m=n;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];y=16}else{m=c[f+8>>2]|0;z=c[f+4>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[n]=z<<1;A=n+1|0}else{B=z+16&-16;C=(x=0,as(230,B|0)|0);if(x){x=0;break}c[n+8>>2]=C;c[n>>2]=B|1;c[n+4>>2]=z;A=C}Kb(A|0,m|0,z)|0;a[A+z|0]=0;y=16;break L8}}while(0);z=bQ(-1,-1)|0;D=K;E=z}}while(0);do{if((y|0)==16){A=o;u=g;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];z=p;m=p;a[m]=12;C=z+1|0;a[C]=a[10240]|0;a[C+1|0]=a[10241]|0;a[C+2|0]=a[10242]|0;a[C+3|0]=a[10243]|0;a[C+4|0]=a[10244]|0;a[C+5|0]=a[10245]|0;a[z+7|0]=0;z=q;c[z>>2]=c[u>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];u=(x=0,ar(100,p|0,b|0,e|0,f|0,q|0,j|0)|0);do{if(!x){F=+h[u+48>>3];z=r;a[z]=0;a[r+1|0]=0;C=l;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];x=0;aE(2,w|0,n|0,l|0,+F,r|0);if(x){x=0;C=bQ(-1,-1)|0;B=C;C=K;if((a[z]&1)==0){G=C;H=B;break}J2(c[r+8>>2]|0);G=C;H=B;break}B=v;if((a[z]&1)!=0){J2(c[r+8>>2]|0)}if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return B|0}J2(c[n+8>>2]|0);i=k;return B|0}else{x=0;B=bQ(-1,-1)|0;G=K;H=B}}while(0);if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){D=G;E=H;break}J2(c[n+8>>2]|0);D=G;E=H}}while(0);H=c[d>>2]|0;d=c[t>>2]|0;G=H;while(1){if((G|0)==(d|0)){I=d;break}if((c[G>>2]|0)==(v|0)){I=G;break}else{G=G+4|0}}G=I-H>>2;I=H+(G+1<<2)|0;v=d-I|0;Kc(H+(G<<2)|0,I|0,v|0)|0;I=H+((v>>2)+G<<2)|0;G=c[t>>2]|0;if((I|0)==(G|0)){J2(s);J=E;L=0;M=J;N=D;be(M|0)}c[t>>2]=G+(~((G-4+(-I|0)|0)>>>2)<<2);J2(s);J=E;L=0;M=J;N=D;be(M|0);return 0}function ox(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=J0(72)|0;c[m>>2]=s;t=d+4|0;u=c[t>>2]|0;if((u|0)==(c[d+8>>2]|0)){ee(d|0,m);v=c[m>>2]|0}else{if((u|0)==0){w=0}else{c[u>>2]=s;w=c[t>>2]|0}c[t>>2]=w+4;v=s}s=v;w=v;u=f;L8:do{if((a[u]&1)==0){m=n;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];y=16}else{m=c[f+8>>2]|0;z=c[f+4>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[n]=z<<1;A=n+1|0}else{B=z+16&-16;C=(x=0,as(230,B|0)|0);if(x){x=0;break}c[n+8>>2]=C;c[n>>2]=B|1;c[n+4>>2]=z;A=C}Kb(A|0,m|0,z)|0;a[A+z|0]=0;y=16;break L8}}while(0);z=bQ(-1,-1)|0;D=K;E=z}}while(0);do{if((y|0)==16){A=o;u=g;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];z=p;m=p;a[m]=12;C=z+1|0;a[C]=a[10240]|0;a[C+1|0]=a[10241]|0;a[C+2|0]=a[10242]|0;a[C+3|0]=a[10243]|0;a[C+4|0]=a[10244]|0;a[C+5|0]=a[10245]|0;a[z+7|0]=0;z=q;c[z>>2]=c[u>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];u=(x=0,ar(100,p|0,b|0,e|0,f|0,q|0,j|0)|0);do{if(!x){F=+h[u+56>>3];z=r;a[z]=0;a[r+1|0]=0;C=l;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];x=0;aE(2,w|0,n|0,l|0,+F,r|0);if(x){x=0;C=bQ(-1,-1)|0;B=C;C=K;if((a[z]&1)==0){G=C;H=B;break}J2(c[r+8>>2]|0);G=C;H=B;break}B=v;if((a[z]&1)!=0){J2(c[r+8>>2]|0)}if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){i=k;return B|0}J2(c[n+8>>2]|0);i=k;return B|0}else{x=0;B=bQ(-1,-1)|0;G=K;H=B}}while(0);if((a[m]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){D=G;E=H;break}J2(c[n+8>>2]|0);D=G;E=H}}while(0);H=c[d>>2]|0;d=c[t>>2]|0;G=H;while(1){if((G|0)==(d|0)){I=d;break}if((c[G>>2]|0)==(v|0)){I=G;break}else{G=G+4|0}}G=I-H>>2;I=H+(G+1<<2)|0;v=d-I|0;Kc(H+(G<<2)|0,I|0,v|0)|0;I=H+((v>>2)+G<<2)|0;G=c[t>>2]|0;if((I|0)==(G|0)){J2(s);J=E;L=0;M=J;N=D;be(M|0)}c[t>>2]=G+(~((G-4+(-I|0)|0)>>>2)<<2);J2(s);J=E;L=0;M=J;N=D;be(M|0);return 0}function oy(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,V=0.0,W=0;k=i;i=i+152|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=n;w=n;a[w]=16;y=v+1|0;z=y|0;C=1819239204;a[z]=C;C=C>>8;a[z+1|0]=C;C=C>>8;a[z+2|0]=C;C=C>>8;a[z+3|0]=C;z=y+4|0;C=825061999;a[z]=C;C=C>>8;a[z+1|0]=C;C=C>>8;a[z+2|0]=C;C=C>>8;a[z+3|0]=C;a[v+9|0]=0;v=o;z=g;c[v>>2]=c[z>>2];c[v+4>>2]=c[z+4>>2];c[v+8>>2]=c[z+8>>2];v=(x=0,ar(100,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(x){x=0;o=bQ(-1,-1)|0;g=o;o=K;if((a[w]&1)==0){A=g;B=o;D=A;E=0;F=D;G=B;be(F|0)}J2(c[n+8>>2]|0);A=g;B=o;D=A;E=0;F=D;G=B;be(F|0)}if((a[w]&1)!=0){J2(c[n+8>>2]|0)}n=p;w=p;a[w]=16;o=n+1|0;g=o|0;C=1819239204;a[g]=C;C=C>>8;a[g+1|0]=C;C=C>>8;a[g+2|0]=C;C=C>>8;a[g+3|0]=C;g=o+4|0;C=841839215;a[g]=C;C=C>>8;a[g+1|0]=C;C=C>>8;a[g+2|0]=C;C=C>>8;a[g+3|0]=C;a[n+9|0]=0;n=q;c[n>>2]=c[z>>2];c[n+4>>2]=c[z+4>>2];c[n+8>>2]=c[z+8>>2];n=(x=0,ar(100,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(x){x=0;q=bQ(-1,-1)|0;g=q;q=K;if((a[w]&1)==0){A=g;B=q;D=A;E=0;F=D;G=B;be(F|0)}J2(c[p+8>>2]|0);A=g;B=q;D=A;E=0;F=D;G=B;be(F|0)}if((a[w]&1)!=0){J2(c[p+8>>2]|0)}p=r;a[p]=14;w=r+1|0;a[w]=a[9104]|0;a[w+1|0]=a[9105]|0;a[w+2|0]=a[9106]|0;a[w+3|0]=a[9107]|0;a[w+4|0]=a[9108]|0;a[w+5|0]=a[9109]|0;a[w+6|0]=a[9110]|0;w=r+8|0;a[w]=0;q=s;c[q>>2]=c[z>>2];c[q+4>>2]=c[z+4>>2];c[q+8>>2]=c[z+8>>2];q=(x=0,an(2,r|0,b|0,e|0,f|0,s|0,+0.0,+100.0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;s=j;j=K;if((a[p]&1)==0){A=s;B=j;D=A;E=0;F=D;G=B;be(F|0)}J2(c[w>>2]|0);A=s;B=j;D=A;E=0;F=D;G=B;be(F|0)}if((a[p]&1)!=0){J2(c[w>>2]|0)}H=+h[q+40>>3]/100.0;I=H*2.0+-1.0;q=v+64|0;w=n+64|0;J=+h[q>>3]- +h[w>>3];L=I*J;if(L==-1.0){M=I}else{M=(I+J)/(L+1.0)}L=(M+1.0)*.5;M=1.0-L;p=J0(88)|0;c[m>>2]=p;j=d+4|0;s=c[j>>2]|0;if((s|0)==(c[d+8>>2]|0)){ee(d|0,m);N=c[m>>2]|0}else{if((s|0)==0){O=0}else{c[s>>2]=p;O=c[j>>2]|0}c[j>>2]=O+4;N=p}p=N;O=N;s=f;L41:do{if((a[s]&1)==0){m=t;c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];P=27}else{m=c[f+8>>2]|0;e=c[f+4>>2]|0;do{if(e>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(e>>>0<11>>>0){a[t]=e<<1;Q=t+1|0}else{b=e+16&-16;r=(x=0,as(230,b|0)|0);if(x){x=0;break}c[t+8>>2]=r;c[t>>2]=b|1;c[t+4>>2]=e;Q=r}Kb(Q|0,m|0,e)|0;a[Q+e|0]=0;P=27;break L41}}while(0);e=bQ(-1,-1)|0;R=e;S=K}}while(0);do{if((P|0)==27){Q=l;c[Q>>2]=c[z>>2];c[Q+4>>2]=c[z+4>>2];c[Q+8>>2]=c[z+8>>2];J=+U(L*+h[v+40>>3]+M*+h[n+40>>3]);I=+U(L*+h[v+48>>3]+M*+h[n+48>>3]);T=+U(L*+h[v+56>>3]+M*+h[n+56>>3]);V=H*+h[q>>3]+(1.0-H)*+h[w>>3];Q=u;a[Q]=0;a[u+1|0]=0;x=0;at(2,O|0,t|0,l|0,+J,+I,+T,+V,u|0);if(x){x=0;f=bQ(-1,-1)|0;s=f;f=K;if((a[Q]&1)!=0){J2(c[u+8>>2]|0)}if((a[t]&1)==0){R=s;S=f;break}J2(c[t+8>>2]|0);R=s;S=f;break}f=N;if((a[Q]&1)!=0){J2(c[u+8>>2]|0)}if((a[t]&1)==0){i=k;return f|0}J2(c[t+8>>2]|0);i=k;return f|0}}while(0);k=c[d>>2]|0;d=c[j>>2]|0;t=k;while(1){if((t|0)==(d|0)){W=d;break}if((c[t>>2]|0)==(N|0)){W=t;break}else{t=t+4|0}}t=W-k>>2;W=k+(t+1<<2)|0;N=d-W|0;Kc(k+(t<<2)|0,W|0,N|0)|0;W=k+((N>>2)+t<<2)|0;t=c[j>>2]|0;if((W|0)!=(t|0)){c[j>>2]=t+(~((t-4+(-W|0)|0)>>>2)<<2)}J2(p);A=R;B=S;D=A;E=0;F=D;G=B;be(F|0);return 0}function oz(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;var e=0.0,f=0.0,g=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;e=b/255.0;b=c/255.0;c=d/255.0;d=b<c?c:b;f=e<d?d:e;d=c<b?c:b;g=d<e?d:e;d=f-g;i=f+g;j=i*.5;L1:do{if(f==g){k=0.0;l=0.0}else{if(j<.5){m=i}else{m=2.0-f-g}n=d/m;o=d*.5;p=(o+(f-e)/6.0)/d;q=(o+(f-b)/6.0)/d;r=(o+(f-c)/6.0)/d;do{if(e==f){s=r-q}else{if(b==f){s=p+.3333333333333333-r;break}if(c!=f){k=0.0;l=n;break L1}s=q+.6666666666666666-p}}while(0);if(s<0.0){k=s+1.0;l=n;break}if(s<=1.0){k=s;l=n;break}k=s+-1.0;l=n}}while(0);h[a>>3]=+((~~(k*360.0)|0)%360|0|0);h[a+8>>3]=l*100.0;h[a+16>>3]=j*100.0;return}function oA(b,d,e,f,g,h,j){b=+b;d=+d;e=+e;f=+f;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+56|0;l=j;j=i;i=i+12|0;i=i+7&-8;c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=+((((~~b|0)%360|0)+360|0)%360|0|0)/360.0;b=d/100.0;d=e/100.0;if(d>.5){q=b+d-b*d}else{q=d*(b+1.0)}b=d*2.0-q;d=p+.3333333333333333;if(d<0.0){r=d+1.0}else{r=d}if(r>1.0){s=r+-1.0}else{s=r}do{if(s*6.0<1.0){t=b+(q-b)*s*6.0}else{if(s*2.0<1.0){t=q;break}if(s*3.0>=2.0){t=b;break}t=b+(q-b)*(.6666666666666666-s)*6.0}}while(0);s=t*255.0;if(p<0.0){u=p+1.0}else{u=p}if(u>1.0){v=u+-1.0}else{v=u}do{if(v*6.0<1.0){w=b+(q-b)*v*6.0}else{if(v*2.0<1.0){w=q;break}if(v*3.0>=2.0){w=b;break}w=b+(q-b)*(.6666666666666666-v)*6.0}}while(0);v=w*255.0;w=p+-.3333333333333333;if(w<0.0){y=w+1.0}else{y=w}if(y>1.0){z=y+-1.0}else{z=y}do{if(z*6.0<1.0){A=b+(q-b)*z*6.0}else{if(z*2.0<1.0){A=q;break}if(z*3.0>=2.0){A=b;break}A=b+(q-b)*(.6666666666666666-z)*6.0}}while(0);z=A*255.0;B=J0(88)|0;c[m>>2]=B;C=g+4|0;D=c[C>>2]|0;if((D|0)==(c[g+8>>2]|0)){ee(g|0,m);E=c[m>>2]|0}else{if((D|0)==0){F=0}else{c[D>>2]=B;F=c[C>>2]|0}c[C>>2]=F+4;E=B}B=E;F=E;D=h;L48:do{if((a[D]&1)==0){m=n;c[m>>2]=c[D>>2];c[m+4>>2]=c[D+4>>2];c[m+8>>2]=c[D+8>>2];G=46}else{m=c[h+8>>2]|0;H=c[h+4>>2]|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(H>>>0<11>>>0){a[n]=H<<1;I=n+1|0}else{J=H+16&-16;L=(x=0,as(230,J|0)|0);if(x){x=0;break}c[n+8>>2]=L;c[n>>2]=J|1;c[n+4>>2]=H;I=L}Kb(I|0,m|0,H)|0;a[I+H|0]=0;G=46;break L48}}while(0);H=bQ(-1,-1)|0;M=K;N=H}}while(0);do{if((G|0)==46){I=j;h=l;c[h>>2]=c[I>>2];c[h+4>>2]=c[I+4>>2];c[h+8>>2]=c[I+8>>2];I=o;a[I]=0;a[o+1|0]=0;x=0;at(2,F|0,n|0,l|0,+s,+v,+z,+f,o|0);if(x){x=0;h=bQ(-1,-1)|0;D=h;h=K;if((a[I]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)==0){M=h;N=D;break}J2(c[n+8>>2]|0);M=h;N=D;break}if((a[I]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)==0){i=k;return F|0}J2(c[n+8>>2]|0);i=k;return F|0}}while(0);F=c[g>>2]|0;g=c[C>>2]|0;k=F;while(1){if((k|0)==(g|0)){O=g;break}if((c[k>>2]|0)==(E|0)){O=k;break}else{k=k+4|0}}k=O-F>>2;O=F+(k+1<<2)|0;E=g-O|0;Kc(F+(k<<2)|0,O|0,E|0)|0;O=F+((E>>2)+k<<2)|0;k=c[C>>2]|0;if((O|0)==(k|0)){J2(B);P=N;Q=0;R=P;S=M;be(R|0)}c[C>>2]=k+(~((k-4+(-O|0)|0)>>>2)<<2);J2(B);P=N;Q=0;R=P;S=M;be(R|0);return 0}function oB(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,y=0.0,z=0,A=0,B=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;k=i;i=i+112|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+80|0;r=k+96|0;s=l;t=l;a[t]=8;u=s+1|0;C=1702193188;a[u]=C;C=C>>8;a[u+1|0]=C;C=C>>8;a[u+2|0]=C;C=C>>8;a[u+3|0]=C;a[s+5|0]=0;s=m;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(x=0,ar(40,l|0,b|0,e|0,f|0,m|0,j|0)|0);do{if(!x){v=+h[s+40>>3];m=(x=0,as(230,16)|0);if(x){x=0;w=13;break}g=n+8|0;c[g>>2]=m;c[n>>2]=17;c[n+4>>2]=11;Kb(m|0,8704,11)|0;a[m+11|0]=0;m=o;c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];m=(x=0,an(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);do{if(!x){y=+h[m+40>>3];z=p;A=p;a[A]=20;Kb(z+1|0,8568,10)|0;a[z+11|0]=0;z=q;c[z>>2]=c[u>>2];c[z+4>>2]=c[u+4>>2];c[z+8>>2]=c[u+8>>2];z=(x=0,an(2,p|0,b|0,e|0,f|0,q|0,+0.0,+100.0,j|0)|0);do{if(!x){B=+h[z+40>>3];D=r;c[D>>2]=c[u>>2];c[D+4>>2]=c[u+4>>2];c[D+8>>2]=c[u+8>>2];D=(x=0,au(2,+v,+y,+B,+1.0,d|0,f|0,r|0)|0);if(x){x=0;break}E=D|0;if((a[A]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)!=0){J2(c[g>>2]|0)}if((a[t]&1)==0){i=k;return E|0}J2(c[l+8>>2]|0);i=k;return E|0}else{x=0}}while(0);z=bQ(-1,-1)|0;E=z;z=K;if((a[A]&1)==0){F=z;G=E;break}J2(c[p+8>>2]|0);F=z;G=E}else{x=0;E=bQ(-1,-1)|0;F=K;G=E}}while(0);if((a[n]&1)==0){H=F;I=G;break}J2(c[g>>2]|0);H=F;I=G}else{x=0;w=13}}while(0);if((w|0)==13){w=bQ(-1,-1)|0;H=K;I=w}if((a[t]&1)==0){J=I;L=0;M=J;N=H;be(M|0)}J2(c[l+8>>2]|0);J=I;L=0;M=J;N=H;be(M|0);return 0}function oC(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0.0,z=0,A=0.0,B=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;k=i;i=i+144|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+80|0;r=k+96|0;s=k+112|0;t=k+128|0;u=l;v=l;a[v]=8;w=u+1|0;C=1702193188;a[w]=C;C=C>>8;a[w+1|0]=C;C=C>>8;a[w+2|0]=C;C=C>>8;a[w+3|0]=C;a[u+5|0]=0;u=m;w=g;c[u>>2]=c[w>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];u=(x=0,ar(40,l|0,b|0,e|0,f|0,m|0,j|0)|0);do{if(!x){y=+h[u+40>>3];m=(x=0,as(230,16)|0);if(x){x=0;z=16;break}g=n+8|0;c[g>>2]=m;c[n>>2]=17;c[n+4>>2]=11;Kb(m|0,8704,11)|0;a[m+11|0]=0;m=o;c[m>>2]=c[w>>2];c[m+4>>2]=c[w+4>>2];c[m+8>>2]=c[w+8>>2];m=(x=0,an(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);do{if(!x){A=+h[m+40>>3];B=p;D=p;a[D]=20;Kb(B+1|0,8568,10)|0;a[B+11|0]=0;B=q;c[B>>2]=c[w>>2];c[B+4>>2]=c[w+4>>2];c[B+8>>2]=c[w+8>>2];B=(x=0,an(2,p|0,b|0,e|0,f|0,q|0,+0.0,+100.0,j|0)|0);do{if(!x){E=+h[B+40>>3];F=r;G=r;a[G]=12;H=F+1|0;a[H]=a[10864]|0;a[H+1|0]=a[10865]|0;a[H+2|0]=a[10866]|0;a[H+3|0]=a[10867]|0;a[H+4|0]=a[10868]|0;a[H+5|0]=a[10869]|0;a[F+7|0]=0;F=s;c[F>>2]=c[w>>2];c[F+4>>2]=c[w+4>>2];c[F+8>>2]=c[w+8>>2];F=(x=0,an(2,r|0,b|0,e|0,f|0,s|0,+0.0,+1.0,j|0)|0);do{if(!x){I=+h[F+40>>3];H=t;c[H>>2]=c[w>>2];c[H+4>>2]=c[w+4>>2];c[H+8>>2]=c[w+8>>2];H=(x=0,au(2,+y,+A,+E,+I,d|0,f|0,t|0)|0);if(x){x=0;break}J=H|0;if((a[G]&1)!=0){J2(c[r+8>>2]|0)}if((a[D]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)!=0){J2(c[g>>2]|0)}if((a[v]&1)==0){i=k;return J|0}J2(c[l+8>>2]|0);i=k;return J|0}else{x=0}}while(0);F=bQ(-1,-1)|0;J=F;F=K;if((a[G]&1)==0){L=F;M=J;break}J2(c[r+8>>2]|0);L=F;M=J}else{x=0;J=bQ(-1,-1)|0;L=K;M=J}}while(0);if((a[D]&1)==0){N=L;O=M;break}J2(c[p+8>>2]|0);N=L;O=M}else{x=0;B=bQ(-1,-1)|0;N=K;O=B}}while(0);if((a[n]&1)==0){P=N;Q=O;break}J2(c[g>>2]|0);P=N;Q=O}else{x=0;z=16}}while(0);if((z|0)==16){z=bQ(-1,-1)|0;P=K;Q=z}if((a[v]&1)==0){R=Q;S=0;T=R;U=P;be(T|0)}J2(c[l+8>>2]|0);R=Q;S=0;T=R;U=P;be(T|0);return 0}function oD(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;k=i;i=i+112|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+80|0;r=k+96|0;s=n;t=n;a[t]=12;u=s+1|0;a[u]=a[10240]|0;a[u+1|0]=a[10241]|0;a[u+2|0]=a[10242]|0;a[u+3|0]=a[10243]|0;a[u+4|0]=a[10244]|0;a[u+5|0]=a[10245]|0;a[s+7|0]=0;s=o;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(x=0,ar(100,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;o=j;j=K;if((a[t]&1)==0){v=j;w=o;y=w;z=0;A=y;B=v;be(A|0)}J2(c[n+8>>2]|0);v=j;w=o;y=w;z=0;A=y;B=v;be(A|0)}if((a[t]&1)!=0){J2(c[n+8>>2]|0)}oz(p,+h[s+40>>3],+h[s+48>>3],+h[s+56>>3]);s=J0(72)|0;c[m>>2]=s;n=d+4|0;t=c[n>>2]|0;if((t|0)==(c[d+8>>2]|0)){ee(d|0,m);C=c[m>>2]|0}else{if((t|0)==0){D=0}else{c[t>>2]=s;D=c[n>>2]|0}c[n>>2]=D+4;C=s}s=C;D=C;t=f;L18:do{if((a[t]&1)==0){m=q;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];E=19}else{m=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[q]=o<<1;F=q+1|0}else{j=o+16&-16;e=(x=0,as(230,j|0)|0);if(x){x=0;break}c[q+8>>2]=e;c[q>>2]=j|1;c[q+4>>2]=o;F=e}Kb(F|0,m|0,o)|0;a[F+o|0]=0;E=19;break L18}}while(0);o=bQ(-1,-1)|0;G=K;H=o}}while(0);do{if((E|0)==19){F=l;c[F>>2]=c[u>>2];c[F+4>>2]=c[u+4>>2];c[F+8>>2]=c[u+8>>2];I=+h[p>>3];F=r;a[F]=6;f=r+1|0;a[f]=a[7856]|0;a[f+1|0]=a[7857]|0;a[f+2|0]=a[7858]|0;a[r+4|0]=0;x=0;aE(2,D|0,q|0,l|0,+I,r|0);if(x){x=0;f=bQ(-1,-1)|0;t=f;f=K;if((a[F]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){G=f;H=t;break}J2(c[q+8>>2]|0);G=f;H=t;break}t=C;if((a[F]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){i=k;return t|0}J2(c[q+8>>2]|0);i=k;return t|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;q=k;while(1){if((q|0)==(d|0)){J=d;break}if((c[q>>2]|0)==(C|0)){J=q;break}else{q=q+4|0}}q=J-k>>2;J=k+(q+1<<2)|0;C=d-J|0;Kc(k+(q<<2)|0,J|0,C|0)|0;J=k+((C>>2)+q<<2)|0;q=c[n>>2]|0;if((J|0)!=(q|0)){c[n>>2]=q+(~((q-4+(-J|0)|0)>>>2)<<2)}J2(s);v=G;w=H;y=w;z=0;A=y;B=v;be(A|0);return 0}function oE(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;k=i;i=i+112|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+80|0;r=k+96|0;s=n;t=n;a[t]=12;u=s+1|0;a[u]=a[10240]|0;a[u+1|0]=a[10241]|0;a[u+2|0]=a[10242]|0;a[u+3|0]=a[10243]|0;a[u+4|0]=a[10244]|0;a[u+5|0]=a[10245]|0;a[s+7|0]=0;s=o;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(x=0,ar(100,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;o=j;j=K;if((a[t]&1)==0){v=j;w=o;y=w;z=0;A=y;B=v;be(A|0)}J2(c[n+8>>2]|0);v=j;w=o;y=w;z=0;A=y;B=v;be(A|0)}if((a[t]&1)!=0){J2(c[n+8>>2]|0)}oz(p,+h[s+40>>3],+h[s+48>>3],+h[s+56>>3]);s=J0(72)|0;c[m>>2]=s;n=d+4|0;t=c[n>>2]|0;if((t|0)==(c[d+8>>2]|0)){ee(d|0,m);C=c[m>>2]|0}else{if((t|0)==0){D=0}else{c[t>>2]=s;D=c[n>>2]|0}c[n>>2]=D+4;C=s}s=C;D=C;t=f;L18:do{if((a[t]&1)==0){m=q;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];E=19}else{m=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[q]=o<<1;F=q+1|0}else{j=o+16&-16;e=(x=0,as(230,j|0)|0);if(x){x=0;break}c[q+8>>2]=e;c[q>>2]=j|1;c[q+4>>2]=o;F=e}Kb(F|0,m|0,o)|0;a[F+o|0]=0;E=19;break L18}}while(0);o=bQ(-1,-1)|0;G=K;H=o}}while(0);do{if((E|0)==19){F=l;c[F>>2]=c[u>>2];c[F+4>>2]=c[u+4>>2];c[F+8>>2]=c[u+8>>2];I=+h[p+8>>3];F=r;f=r;a[f]=2;a[F+1|0]=37;a[F+2|0]=0;x=0;aE(2,D|0,q|0,l|0,+I,r|0);if(x){x=0;F=bQ(-1,-1)|0;t=F;F=K;if((a[f]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){G=F;H=t;break}J2(c[q+8>>2]|0);G=F;H=t;break}t=C;if((a[f]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){i=k;return t|0}J2(c[q+8>>2]|0);i=k;return t|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;q=k;while(1){if((q|0)==(d|0)){J=d;break}if((c[q>>2]|0)==(C|0)){J=q;break}else{q=q+4|0}}q=J-k>>2;J=k+(q+1<<2)|0;C=d-J|0;Kc(k+(q<<2)|0,J|0,C|0)|0;J=k+((C>>2)+q<<2)|0;q=c[n>>2]|0;if((J|0)!=(q|0)){c[n>>2]=q+(~((q-4+(-J|0)|0)>>>2)<<2)}J2(s);v=G;w=H;y=w;z=0;A=y;B=v;be(A|0);return 0}function oF(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;k=i;i=i+112|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+80|0;r=k+96|0;s=n;t=n;a[t]=12;u=s+1|0;a[u]=a[10240]|0;a[u+1|0]=a[10241]|0;a[u+2|0]=a[10242]|0;a[u+3|0]=a[10243]|0;a[u+4|0]=a[10244]|0;a[u+5|0]=a[10245]|0;a[s+7|0]=0;s=o;u=g;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];s=(x=0,ar(100,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;o=j;j=K;if((a[t]&1)==0){v=j;w=o;y=w;z=0;A=y;B=v;be(A|0)}J2(c[n+8>>2]|0);v=j;w=o;y=w;z=0;A=y;B=v;be(A|0)}if((a[t]&1)!=0){J2(c[n+8>>2]|0)}oz(p,+h[s+40>>3],+h[s+48>>3],+h[s+56>>3]);s=J0(72)|0;c[m>>2]=s;n=d+4|0;t=c[n>>2]|0;if((t|0)==(c[d+8>>2]|0)){ee(d|0,m);C=c[m>>2]|0}else{if((t|0)==0){D=0}else{c[t>>2]=s;D=c[n>>2]|0}c[n>>2]=D+4;C=s}s=C;D=C;t=f;L18:do{if((a[t]&1)==0){m=q;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];E=19}else{m=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[q]=o<<1;F=q+1|0}else{j=o+16&-16;e=(x=0,as(230,j|0)|0);if(x){x=0;break}c[q+8>>2]=e;c[q>>2]=j|1;c[q+4>>2]=o;F=e}Kb(F|0,m|0,o)|0;a[F+o|0]=0;E=19;break L18}}while(0);o=bQ(-1,-1)|0;G=K;H=o}}while(0);do{if((E|0)==19){F=l;c[F>>2]=c[u>>2];c[F+4>>2]=c[u+4>>2];c[F+8>>2]=c[u+8>>2];I=+h[p+16>>3];F=r;f=r;a[f]=2;a[F+1|0]=37;a[F+2|0]=0;x=0;aE(2,D|0,q|0,l|0,+I,r|0);if(x){x=0;F=bQ(-1,-1)|0;t=F;F=K;if((a[f]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){G=F;H=t;break}J2(c[q+8>>2]|0);G=F;H=t;break}t=C;if((a[f]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){i=k;return t|0}J2(c[q+8>>2]|0);i=k;return t|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;q=k;while(1){if((q|0)==(d|0)){J=d;break}if((c[q>>2]|0)==(C|0)){J=q;break}else{q=q+4|0}}q=J-k>>2;J=k+(q+1<<2)|0;C=d-J|0;Kc(k+(q<<2)|0,J|0,C|0)|0;J=k+((C>>2)+q<<2)|0;q=c[n>>2]|0;if((J|0)!=(q|0)){c[n>>2]=q+(~((q-4+(-J|0)|0)>>>2)<<2)}J2(s);v=G;w=H;y=w;z=0;A=y;B=v;be(A|0);return 0}function oG(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0.0,D=0.0,E=0.0,F=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10240]|0;a[t+1|0]=a[10241]|0;a[t+2|0]=a[10242]|0;a[t+3|0]=a[10243]|0;a[t+4|0]=a[10244]|0;a[t+5|0]=a[10245]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(x=0,ar(100,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(x){x=0;m=bQ(-1,-1)|0;g=m;m=K;if((a[s]&1)==0){u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}J2(c[l+8>>2]|0);u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}if((a[s]&1)!=0){J2(c[l+8>>2]|0)}l=n;s=n;a[s]=16;m=l+1|0;g=m|0;C=1734698020;a[g]=C;C=C>>8;a[g+1|0]=C;C=C>>8;a[g+2|0]=C;C=C>>8;a[g+3|0]=C;g=m+4|0;C=1936024946;a[g]=C;C=C>>8;a[g+1|0]=C;C=C>>8;a[g+2|0]=C;C=C>>8;a[g+3|0]=C;a[l+9|0]=0;l=o;c[l>>2]=c[t>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];l=(x=0,ar(40,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(!x){if((a[s]&1)!=0){J2(c[n+8>>2]|0)}oz(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p>>3]+ +h[l+40>>3];D=+h[p+8>>3];E=+h[p+16>>3];F=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=oA(B,D,E,F,d,f,q)|0;i=k;return t|0}else{x=0}t=bQ(-1,-1)|0;k=t;t=K;if((a[s]&1)==0){u=k;v=t;w=u;y=0;z=w;A=v;be(z|0)}J2(c[n+8>>2]|0);u=k;v=t;w=u;y=0;z=w;A=v;be(z|0);return 0}function oH(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10240]|0;a[t+1|0]=a[10241]|0;a[t+2|0]=a[10242]|0;a[t+3|0]=a[10243]|0;a[t+4|0]=a[10244]|0;a[t+5|0]=a[10245]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(x=0,ar(100,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(x){x=0;m=bQ(-1,-1)|0;g=m;m=K;if((a[s]&1)==0){u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}J2(c[l+8>>2]|0);u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}if((a[s]&1)!=0){J2(c[l+8>>2]|0)}l=n;a[l]=14;s=n+1|0;a[s]=a[6560]|0;a[s+1|0]=a[6561]|0;a[s+2|0]=a[6562]|0;a[s+3|0]=a[6563]|0;a[s+4|0]=a[6564]|0;a[s+5|0]=a[6565]|0;a[s+6|0]=a[6566]|0;s=n+8|0;a[s]=0;m=o;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];m=(x=0,an(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);if(!x){if((a[l]&1)!=0){J2(c[s>>2]|0)}oz(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p+16>>3];C=+h[p>>3];D=+h[p+8>>3];E=(B<0.0?0.0:B)+ +h[m+40>>3];B=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=oA(C,D,E,B,d,f,q)|0;i=k;return t|0}else{x=0}t=bQ(-1,-1)|0;k=t;t=K;if((a[l]&1)==0){u=k;v=t;w=u;y=0;z=w;A=v;be(z|0)}J2(c[s>>2]|0);u=k;v=t;w=u;y=0;z=w;A=v;be(z|0);return 0}function oI(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10240]|0;a[t+1|0]=a[10241]|0;a[t+2|0]=a[10242]|0;a[t+3|0]=a[10243]|0;a[t+4|0]=a[10244]|0;a[t+5|0]=a[10245]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(x=0,ar(100,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(x){x=0;m=bQ(-1,-1)|0;g=m;m=K;if((a[s]&1)==0){u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}J2(c[l+8>>2]|0);u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}if((a[s]&1)!=0){J2(c[l+8>>2]|0)}l=n;a[l]=14;s=n+1|0;a[s]=a[6560]|0;a[s+1|0]=a[6561]|0;a[s+2|0]=a[6562]|0;a[s+3|0]=a[6563]|0;a[s+4|0]=a[6564]|0;a[s+5|0]=a[6565]|0;a[s+6|0]=a[6566]|0;s=n+8|0;a[s]=0;m=o;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];m=(x=0,an(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);if(!x){if((a[l]&1)!=0){J2(c[s>>2]|0)}oz(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p+16>>3];C=+h[p>>3];D=+h[p+8>>3];E=(B>100.0?100.0:B)- +h[m+40>>3];B=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=oA(C,D,E,B,d,f,q)|0;i=k;return t|0}else{x=0}t=bQ(-1,-1)|0;k=t;t=K;if((a[l]&1)==0){u=k;v=t;w=u;y=0;z=w;A=v;be(z|0)}J2(c[s>>2]|0);u=k;v=t;w=u;y=0;z=w;A=v;be(z|0);return 0}function oJ(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10240]|0;a[t+1|0]=a[10241]|0;a[t+2|0]=a[10242]|0;a[t+3|0]=a[10243]|0;a[t+4|0]=a[10244]|0;a[t+5|0]=a[10245]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(x=0,ar(100,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(x){x=0;m=bQ(-1,-1)|0;g=m;m=K;if((a[s]&1)==0){u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}J2(c[l+8>>2]|0);u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}if((a[s]&1)!=0){J2(c[l+8>>2]|0)}l=n;a[l]=14;s=n+1|0;a[s]=a[6560]|0;a[s+1|0]=a[6561]|0;a[s+2|0]=a[6562]|0;a[s+3|0]=a[6563]|0;a[s+4|0]=a[6564]|0;a[s+5|0]=a[6565]|0;a[s+6|0]=a[6566]|0;s=n+8|0;a[s]=0;m=o;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];m=(x=0,an(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);if(!x){if((a[l]&1)!=0){J2(c[s>>2]|0)}oz(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p+8>>3];C=+h[p>>3];D=(B<0.0?0.0:B)+ +h[m+40>>3];B=+h[p+16>>3];E=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=oA(C,D,B,E,d,f,q)|0;i=k;return t|0}else{x=0}t=bQ(-1,-1)|0;k=t;t=K;if((a[l]&1)==0){u=k;v=t;w=u;y=0;z=w;A=v;be(z|0)}J2(c[s>>2]|0);u=k;v=t;w=u;y=0;z=w;A=v;be(z|0);return 0}function oK(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0;k=i;i=i+104|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=k+88|0;r=l;s=l;a[s]=12;t=r+1|0;a[t]=a[10240]|0;a[t+1|0]=a[10241]|0;a[t+2|0]=a[10242]|0;a[t+3|0]=a[10243]|0;a[t+4|0]=a[10244]|0;a[t+5|0]=a[10245]|0;a[r+7|0]=0;r=m;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(x=0,ar(100,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(x){x=0;m=bQ(-1,-1)|0;g=m;m=K;if((a[s]&1)==0){u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}J2(c[l+8>>2]|0);u=g;v=m;w=u;y=0;z=w;A=v;be(z|0)}if((a[s]&1)!=0){J2(c[l+8>>2]|0)}l=n;a[l]=14;s=n+1|0;a[s]=a[6560]|0;a[s+1|0]=a[6561]|0;a[s+2|0]=a[6562]|0;a[s+3|0]=a[6563]|0;a[s+4|0]=a[6564]|0;a[s+5|0]=a[6565]|0;a[s+6|0]=a[6566]|0;s=n+8|0;a[s]=0;m=o;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];m=(x=0,an(2,n|0,b|0,e|0,f|0,o|0,+0.0,+100.0,j|0)|0);if(!x){if((a[l]&1)!=0){J2(c[s>>2]|0)}oz(p,+h[r+40>>3],+h[r+48>>3],+h[r+56>>3]);B=+h[p+8>>3];C=+h[p>>3];D=(B>100.0?100.0:B)- +h[m+40>>3];B=+h[p+16>>3];E=+h[r+64>>3];r=q;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];t=oA(C,D,B,E,d,f,q)|0;i=k;return t|0}else{x=0}t=bQ(-1,-1)|0;k=t;t=K;if((a[l]&1)==0){u=k;v=t;w=u;y=0;z=w;A=v;be(z|0)}J2(c[s>>2]|0);u=k;v=t;w=u;y=0;z=w;A=v;be(z|0);return 0}function oL(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+56|0;p=l;q=l;a[q]=12;r=p+1|0;a[r]=a[10240]|0;a[r+1|0]=a[10241]|0;a[r+2|0]=a[10242]|0;a[r+3|0]=a[10243]|0;a[r+4|0]=a[10244]|0;a[r+5|0]=a[10245]|0;a[p+7|0]=0;p=m;r=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];p=(x=0,ar(100,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(!x){if((a[q]&1)!=0){J2(c[l+8>>2]|0)}oz(n,+h[p+40>>3],+h[p+48>>3],+h[p+56>>3]);s=+h[n>>3];t=+h[n+16>>3];u=+h[p+64>>3];p=o;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];r=oA(s,0.0,t,u,d,f,o)|0;i=k;return r|0}else{x=0}r=bQ(-1,-1)|0;if((a[q]&1)==0){be(r|0)}J2(c[l+8>>2]|0);be(r|0);return 0}function oM(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+56|0;p=l;q=l;a[q]=12;r=p+1|0;a[r]=a[10240]|0;a[r+1|0]=a[10241]|0;a[r+2|0]=a[10242]|0;a[r+3|0]=a[10243]|0;a[r+4|0]=a[10244]|0;a[r+5|0]=a[10245]|0;a[p+7|0]=0;p=m;r=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];p=(x=0,ar(100,l|0,b|0,e|0,f|0,m|0,j|0)|0);if(!x){if((a[q]&1)!=0){J2(c[l+8>>2]|0)}oz(n,+h[p+40>>3],+h[p+48>>3],+h[p+56>>3]);s=+h[n>>3]+-180.0;t=+h[n+8>>3];u=+h[n+16>>3];v=+h[p+64>>3];p=o;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];r=oA(s,t,u,v,d,f,o)|0;i=k;return r|0}else{x=0}r=bQ(-1,-1)|0;if((a[q]&1)==0){be(r|0)}J2(c[l+8>>2]|0);be(r|0);return 0}function oN(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,L=0.0,M=0;k=i;i=i+88|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=n;s=n;a[s]=12;t=r+1|0;a[t]=a[10240]|0;a[t+1|0]=a[10241]|0;a[t+2|0]=a[10242]|0;a[t+3|0]=a[10243]|0;a[t+4|0]=a[10244]|0;a[t+5|0]=a[10245]|0;a[r+7|0]=0;r=o;t=g;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];r=(x=0,ar(100,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;o=j;j=K;if((a[s]&1)==0){u=j;v=o;w=v;y=0;z=w;A=u;be(z|0)}J2(c[n+8>>2]|0);u=j;v=o;w=v;y=0;z=w;A=u;be(z|0)}if((a[s]&1)!=0){J2(c[n+8>>2]|0)}n=J0(88)|0;c[m>>2]=n;s=d+4|0;o=c[s>>2]|0;if((o|0)==(c[d+8>>2]|0)){ee(d|0,m);B=c[m>>2]|0}else{if((o|0)==0){C=0}else{c[o>>2]=n;C=c[s>>2]|0}c[s>>2]=C+4;B=n}n=B;C=B;o=f;L18:do{if((a[o]&1)==0){m=p;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];D=19}else{m=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){a[p]=j<<1;E=p+1|0}else{e=j+16&-16;b=(x=0,as(230,e|0)|0);if(x){x=0;break}c[p+8>>2]=b;c[p>>2]=e|1;c[p+4>>2]=j;E=b}Kb(E|0,m|0,j)|0;a[E+j|0]=0;D=19;break L18}}while(0);j=bQ(-1,-1)|0;F=K;G=j}}while(0);do{if((D|0)==19){E=l;c[E>>2]=c[t>>2];c[E+4>>2]=c[t+4>>2];c[E+8>>2]=c[t+8>>2];H=255.0- +h[r+40>>3];I=255.0- +h[r+48>>3];J=255.0- +h[r+56>>3];L=+h[r+64>>3];E=q;a[E]=0;a[q+1|0]=0;x=0;at(2,C|0,p|0,l|0,+H,+I,+J,+L,q|0);if(x){x=0;f=bQ(-1,-1)|0;o=f;f=K;if((a[E]&1)!=0){J2(c[q+8>>2]|0)}if((a[p]&1)==0){F=f;G=o;break}J2(c[p+8>>2]|0);F=f;G=o;break}o=B;if((a[E]&1)!=0){J2(c[q+8>>2]|0)}if((a[p]&1)==0){i=k;return o|0}J2(c[p+8>>2]|0);i=k;return o|0}}while(0);k=c[d>>2]|0;d=c[s>>2]|0;p=k;while(1){if((p|0)==(d|0)){M=d;break}if((c[p>>2]|0)==(B|0)){M=p;break}else{p=p+4|0}}p=M-k>>2;M=k+(p+1<<2)|0;B=d-M|0;Kc(k+(p<<2)|0,M|0,B|0)|0;M=k+((B>>2)+p<<2)|0;p=c[s>>2]|0;if((M|0)!=(p|0)){c[s>>2]=p+(~((p-4+(-M|0)|0)>>>2)<<2)}J2(n);u=F;v=G;w=v;y=0;z=w;A=u;be(z|0);return 0}function oO(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,aq=0,at=0,au=0,av=0,aw=0,ay=0,az=0;k=i;i=i+224|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;y=k+176|0;z=k+192|0;A=k+208|0;B=p;C=p;a[C]=12;D=B+1|0;a[D]=a[10240]|0;a[D+1|0]=a[10241]|0;a[D+2|0]=a[10242]|0;a[D+3|0]=a[10243]|0;a[D+4|0]=a[10244]|0;a[D+5|0]=a[10245]|0;a[B+7|0]=0;B=(x=0,aK(88,b|0,p|0)|0);if(x){x=0;D=bQ(-1,-1)|0;E=D;D=K;if((a[C]&1)==0){F=D;G=E;H=G;I=0;J=H;L=F;be(J|0)}J2(c[p+8>>2]|0);F=D;G=E;H=G;I=0;J=H;L=F;be(J|0)}E=c[B>>2]|0;if((E|0)==0){M=0}else{M=JP(E,29912,30568,-1)|0}if((a[C]&1)!=0){J2(c[p+8>>2]|0)}if((M|0)==0){p=J0(72)|0;c[m>>2]=p;C=d+4|0;E=c[C>>2]|0;if((E|0)==(c[d+8>>2]|0)){ee(d|0,m);N=c[m>>2]|0}else{if((E|0)==0){O=0}else{c[E>>2]=p;O=c[C>>2]|0}c[C>>2]=O+4;N=p}p=N;O=N;E=f;L23:do{if((a[E]&1)==0){m=v;c[m>>2]=c[E>>2];c[m+4>>2]=c[E+4>>2];c[m+8>>2]=c[E+8>>2];P=108}else{m=c[f+8>>2]|0;B=c[f+4>>2]|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(B>>>0<11>>>0){a[v]=B<<1;Q=v+1|0}else{D=B+16&-16;R=(x=0,as(230,D|0)|0);if(x){x=0;break}c[v+8>>2]=R;c[v>>2]=D|1;c[v+4>>2]=B;Q=R}Kb(Q|0,m|0,B)|0;a[Q+B|0]=0;P=108;break L23}}while(0);B=bQ(-1,-1)|0;S=K;T=B}}while(0);do{if((P|0)==108){Q=w;E=g;c[Q>>2]=c[E>>2];c[Q+4>>2]=c[E+4>>2];c[Q+8>>2]=c[E+8>>2];B=y;m=y;a[m]=12;R=B+1|0;a[R]=a[10240]|0;a[R+1|0]=a[10241]|0;a[R+2|0]=a[10242]|0;a[R+3|0]=a[10243]|0;a[R+4|0]=a[10244]|0;a[R+5|0]=a[10245]|0;a[B+7|0]=0;B=z;c[B>>2]=c[E>>2];c[B+4>>2]=c[E+4>>2];c[B+8>>2]=c[E+8>>2];E=(x=0,ar(100,y|0,b|0,e|0,f|0,z|0,j|0)|0);do{if(!x){U=+h[E+64>>3];B=A;a[B]=0;a[A+1|0]=0;R=l;c[R>>2]=c[Q>>2];c[R+4>>2]=c[Q+4>>2];c[R+8>>2]=c[Q+8>>2];x=0;aE(2,O|0,v|0,l|0,+U,A|0);if(x){x=0;R=bQ(-1,-1)|0;D=R;R=K;if((a[B]&1)==0){V=R;W=D;break}J2(c[A+8>>2]|0);V=R;W=D;break}if((a[B]&1)!=0){J2(c[A+8>>2]|0)}if((a[m]&1)!=0){J2(c[y+8>>2]|0)}if((a[v]&1)==0){X=p;Y=X;i=k;return Y|0}J2(c[v+8>>2]|0);X=p;Y=X;i=k;return Y|0}else{x=0;B=bQ(-1,-1)|0;V=K;W=B}}while(0);if((a[m]&1)!=0){J2(c[y+8>>2]|0)}if((a[v]&1)==0){S=V;T=W;break}J2(c[v+8>>2]|0);S=V;T=W}}while(0);W=c[d>>2]|0;V=c[C>>2]|0;v=W;while(1){if((v|0)==(V|0)){Z=V;break}if((c[v>>2]|0)==(N|0)){Z=v;break}else{v=v+4|0}}v=Z-W>>2;Z=W+(v+1<<2)|0;N=V-Z|0;Kc(W+(v<<2)|0,Z|0,N|0)|0;Z=W+((N>>2)+v<<2)|0;v=c[C>>2]|0;if((Z|0)!=(v|0)){c[C>>2]=v+(~((v-4+(-Z|0)|0)>>>2)<<2)}J2(p);F=S;G=T;H=G;I=0;J=H;L=F;be(J|0)}T=J0(52)|0;c[o>>2]=T;S=d+4|0;p=c[S>>2]|0;if((p|0)==(c[d+8>>2]|0)){ee(d|0,o);_=c[o>>2]|0}else{if((p|0)==0){$=0}else{c[p>>2]=T;$=c[S>>2]|0}c[S>>2]=$+4;_=T}T=_;$=_;p=f;L77:do{if((a[p]&1)==0){o=q;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];P=24}else{o=c[f+8>>2]|0;Z=c[f+4>>2]|0;do{if(Z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(Z>>>0<11>>>0){a[q]=Z<<1;aa=q+1|0}else{v=Z+16&-16;C=(x=0,as(230,v|0)|0);if(x){x=0;break}c[q+8>>2]=C;c[q>>2]=v|1;c[q+4>>2]=Z;aa=C}Kb(aa|0,o|0,Z)|0;a[aa+Z|0]=0;P=24;break L77}}while(0);Z=bQ(-1,-1)|0;ab=Z;ac=K}}while(0);do{if((P|0)==24){aa=r;f=g;c[aa>>2]=c[f>>2];c[aa+4>>2]=c[f+4>>2];c[aa+8>>2]=c[f+8>>2];f=M+40|0;L92:do{if((a[f]&1)==0){p=u;c[p>>2]=c[f>>2];c[p+4>>2]=c[f+4>>2];c[p+8>>2]=c[f+8>>2];ad=a[p]|0;ae=p;P=34}else{p=c[M+48>>2]|0;Z=c[M+44>>2]|0;do{if(Z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(Z>>>0<11>>>0){o=Z<<1&255;m=u;a[m]=o;af=u+1|0;ag=o;ah=m}else{m=Z+16&-16;o=(x=0,as(230,m|0)|0);if(x){x=0;break}c[u+8>>2]=o;C=m|1;c[u>>2]=C;c[u+4>>2]=Z;af=o;ag=C&255;ah=u}Kb(af|0,p|0,Z)|0;a[af+Z|0]=0;ad=ag;ae=ah;P=34;break L92}}while(0);Z=bQ(-1,-1)|0;ai=K;aj=Z}}while(0);do{if((P|0)==34){f=t;Ke(f|0,0,12)|0;Z=u;p=ad&255;if((p&1|0)==0){ak=p>>>1}else{ak=c[u+4>>2]|0}p=ak+6|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;P=48;break}return 0}else{if(p>>>0<11>>>0){a[f]=12;al=t+1|0}else{C=ak+22&-16;o=(x=0,as(230,C|0)|0);if(x){x=0;P=48;break}c[t+8>>2]=o;c[t>>2]=C|1;c[t+4>>2]=6;al=o}a[al]=a[5432]|0;a[al+1|0]=a[5433]|0;a[al+2|0]=a[5434]|0;a[al+3|0]=a[5435]|0;a[al+4|0]=a[5436]|0;a[al+5|0]=a[5437]|0;a[al+6|0]=0;if((a[ae]&1)==0){am=Z+1|0}else{am=c[u+8>>2]|0}x=0,ax(64,t|0,am|0,ak|0)|0;if(x){x=0;P=48;break}o=s;Ke(o|0,0,12)|0;C=a[f]|0;m=C&255;if((m&1|0)==0){an=m>>>1}else{an=c[t+4>>2]|0}if((C&1)==0){aq=t+1|0}else{aq=c[t+8>>2]|0}C=an+1|0;do{if(C>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;P=64;break}return 0}else{if(C>>>0<11>>>0){a[o]=an<<1;at=s+1|0}else{m=an+17&-16;v=(x=0,as(230,m|0)|0);if(x){x=0;P=64;break}c[s+8>>2]=v;c[s>>2]=m|1;c[s+4>>2]=an;at=v}Kb(at|0,aq|0,an)|0;a[at+an|0]=0;x=0,ax(64,s|0,5392,1)|0;if(x){x=0;P=64;break}v=n;c[v>>2]=c[aa>>2];c[v+4>>2]=c[aa+4>>2];c[v+8>>2]=c[aa+8>>2];x=0;ao(26,$|0,q|0,n|0,s|0,0);if(x){x=0;v=bQ(-1,-1)|0;m=v;v=K;if((a[o]&1)==0){au=v;av=m;break}J2(c[s+8>>2]|0);au=v;av=m;break}if((a[o]&1)!=0){J2(c[s+8>>2]|0)}if((a[f]&1)!=0){J2(c[t+8>>2]|0)}if((a[ae]&1)!=0){J2(c[u+8>>2]|0)}if((a[q]&1)==0){X=T;Y=X;i=k;return Y|0}J2(c[q+8>>2]|0);X=T;Y=X;i=k;return Y|0}}while(0);if((P|0)==64){C=bQ(-1,-1)|0;m=K;if((a[o]&1)!=0){J2(c[s+8>>2]|0)}au=m;av=C}if((a[f]&1)==0){aw=au;ay=av;break}J2(c[t+8>>2]|0);aw=au;ay=av}}while(0);if((P|0)==48){Z=bQ(-1,-1)|0;p=K;if((a[f]&1)!=0){J2(c[t+8>>2]|0)}aw=p;ay=Z}if((a[ae]&1)==0){ai=aw;aj=ay;break}J2(c[u+8>>2]|0);ai=aw;aj=ay}}while(0);if((a[q]&1)==0){ab=aj;ac=ai;break}J2(c[q+8>>2]|0);ab=aj;ac=ai}}while(0);ai=c[d>>2]|0;d=c[S>>2]|0;aj=ai;while(1){if((aj|0)==(d|0)){az=d;break}if((c[aj>>2]|0)==(_|0)){az=aj;break}else{aj=aj+4|0}}aj=az-ai>>2;az=ai+(aj+1<<2)|0;_=d-az|0;Kc(ai+(aj<<2)|0,az|0,_|0)|0;az=ai+((_>>2)+aj<<2)|0;aj=c[S>>2]|0;if((az|0)!=(aj|0)){c[S>>2]=aj+(~((aj-4+(-az|0)|0)>>>2)<<2)}J2(T);F=ac;G=ab;H=G;I=0;J=H;L=F;be(J|0);return 0}function oP(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,L=0,M=0.0,N=0.0,O=0;k=i;i=i+120|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=n;u=n;a[u]=12;v=t+1|0;a[v]=a[10240]|0;a[v+1|0]=a[10241]|0;a[v+2|0]=a[10242]|0;a[v+3|0]=a[10243]|0;a[v+4|0]=a[10244]|0;a[v+5|0]=a[10245]|0;a[t+7|0]=0;t=o;v=g;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];t=(x=0,ar(100,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(x){x=0;o=bQ(-1,-1)|0;g=o;o=K;if((a[u]&1)==0){w=g;y=o;z=w;A=0;B=z;C=y;be(B|0)}J2(c[n+8>>2]|0);w=g;y=o;z=w;A=0;B=z;C=y;be(B|0)}if((a[u]&1)!=0){J2(c[n+8>>2]|0)}D=+h[t+64>>3];n=p;a[n]=14;u=p+1|0;a[u]=a[6560]|0;a[u+1|0]=a[6561]|0;a[u+2|0]=a[6562]|0;a[u+3|0]=a[6563]|0;a[u+4|0]=a[6564]|0;a[u+5|0]=a[6565]|0;a[u+6|0]=a[6566]|0;u=p+8|0;a[u]=0;o=q;c[o>>2]=c[v>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];o=(x=0,an(2,p|0,b|0,e|0,f|0,q|0,+0.0,+1.0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;q=j;j=K;if((a[n]&1)==0){w=q;y=j;z=w;A=0;B=z;C=y;be(B|0)}J2(c[u>>2]|0);w=q;y=j;z=w;A=0;B=z;C=y;be(B|0)}E=D+ +h[o+40>>3];if((a[n]&1)!=0){J2(c[u>>2]|0)}u=J0(88)|0;c[m>>2]=u;n=d+4|0;o=c[n>>2]|0;if((o|0)==(c[d+8>>2]|0)){ee(d|0,m);F=c[m>>2]|0}else{if((o|0)==0){G=0}else{c[o>>2]=u;G=c[n>>2]|0}c[n>>2]=G+4;F=u}u=F;G=F;o=f;L28:do{if((a[o]&1)==0){m=r;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];H=22}else{m=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){a[r]=j<<1;I=r+1|0}else{q=j+16&-16;e=(x=0,as(230,q|0)|0);if(x){x=0;break}c[r+8>>2]=e;c[r>>2]=q|1;c[r+4>>2]=j;I=e}Kb(I|0,m|0,j)|0;a[I+j|0]=0;H=22;break L28}}while(0);j=bQ(-1,-1)|0;J=j;L=K}}while(0);do{if((H|0)==22){I=l;c[I>>2]=c[v>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];D=+h[t+40>>3];M=+h[t+48>>3];N=+h[t+56>>3];I=s;a[I]=0;a[s+1|0]=0;x=0;at(2,G|0,r|0,l|0,+D,+M,+N,+(E>1.0?1.0:E),s|0);if(x){x=0;f=bQ(-1,-1)|0;o=f;f=K;if((a[I]&1)!=0){J2(c[s+8>>2]|0)}if((a[r]&1)==0){J=o;L=f;break}J2(c[r+8>>2]|0);J=o;L=f;break}f=F;if((a[I]&1)!=0){J2(c[s+8>>2]|0)}if((a[r]&1)==0){i=k;return f|0}J2(c[r+8>>2]|0);i=k;return f|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;r=k;while(1){if((r|0)==(d|0)){O=d;break}if((c[r>>2]|0)==(F|0)){O=r;break}else{r=r+4|0}}r=O-k>>2;O=k+(r+1<<2)|0;F=d-O|0;Kc(k+(r<<2)|0,O|0,F|0)|0;O=k+((F>>2)+r<<2)|0;r=c[n>>2]|0;if((O|0)!=(r|0)){c[n>>2]=r+(~((r-4+(-O|0)|0)>>>2)<<2)}J2(u);w=J;y=L;z=w;A=0;B=z;C=y;be(B|0);return 0}function oQ(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,L=0,M=0.0,N=0.0,O=0;k=i;i=i+120|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=n;u=n;a[u]=12;v=t+1|0;a[v]=a[10240]|0;a[v+1|0]=a[10241]|0;a[v+2|0]=a[10242]|0;a[v+3|0]=a[10243]|0;a[v+4|0]=a[10244]|0;a[v+5|0]=a[10245]|0;a[t+7|0]=0;t=o;v=g;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];t=(x=0,ar(100,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(x){x=0;o=bQ(-1,-1)|0;g=o;o=K;if((a[u]&1)==0){w=g;y=o;z=w;A=0;B=z;C=y;be(B|0)}J2(c[n+8>>2]|0);w=g;y=o;z=w;A=0;B=z;C=y;be(B|0)}if((a[u]&1)!=0){J2(c[n+8>>2]|0)}D=+h[t+64>>3];n=p;a[n]=14;u=p+1|0;a[u]=a[6560]|0;a[u+1|0]=a[6561]|0;a[u+2|0]=a[6562]|0;a[u+3|0]=a[6563]|0;a[u+4|0]=a[6564]|0;a[u+5|0]=a[6565]|0;a[u+6|0]=a[6566]|0;u=p+8|0;a[u]=0;o=q;c[o>>2]=c[v>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];o=(x=0,an(2,p|0,b|0,e|0,f|0,q|0,+0.0,+1.0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;q=j;j=K;if((a[n]&1)==0){w=q;y=j;z=w;A=0;B=z;C=y;be(B|0)}J2(c[u>>2]|0);w=q;y=j;z=w;A=0;B=z;C=y;be(B|0)}E=D- +h[o+40>>3];if((a[n]&1)!=0){J2(c[u>>2]|0)}u=J0(88)|0;c[m>>2]=u;n=d+4|0;o=c[n>>2]|0;if((o|0)==(c[d+8>>2]|0)){ee(d|0,m);F=c[m>>2]|0}else{if((o|0)==0){G=0}else{c[o>>2]=u;G=c[n>>2]|0}c[n>>2]=G+4;F=u}u=F;G=F;o=f;L28:do{if((a[o]&1)==0){m=r;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];H=22}else{m=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){a[r]=j<<1;I=r+1|0}else{q=j+16&-16;e=(x=0,as(230,q|0)|0);if(x){x=0;break}c[r+8>>2]=e;c[r>>2]=q|1;c[r+4>>2]=j;I=e}Kb(I|0,m|0,j)|0;a[I+j|0]=0;H=22;break L28}}while(0);j=bQ(-1,-1)|0;J=j;L=K}}while(0);do{if((H|0)==22){I=l;c[I>>2]=c[v>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];D=+h[t+40>>3];M=+h[t+48>>3];N=+h[t+56>>3];I=s;a[I]=0;a[s+1|0]=0;x=0;at(2,G|0,r|0,l|0,+D,+M,+N,+(E<0.0?0.0:E),s|0);if(x){x=0;f=bQ(-1,-1)|0;o=f;f=K;if((a[I]&1)!=0){J2(c[s+8>>2]|0)}if((a[r]&1)==0){J=o;L=f;break}J2(c[r+8>>2]|0);J=o;L=f;break}f=F;if((a[I]&1)!=0){J2(c[s+8>>2]|0)}if((a[r]&1)==0){i=k;return f|0}J2(c[r+8>>2]|0);i=k;return f|0}}while(0);k=c[d>>2]|0;d=c[n>>2]|0;r=k;while(1){if((r|0)==(d|0)){O=d;break}if((c[r>>2]|0)==(F|0)){O=r;break}else{r=r+4|0}}r=O-k>>2;O=k+(r+1<<2)|0;F=d-O|0;Kc(k+(r<<2)|0,O|0,F|0)|0;O=k+((F>>2)+r<<2)|0;r=c[n>>2]|0;if((O|0)!=(r|0)){c[n>>2]=r+(~((r-4+(-O|0)|0)>>>2)<<2)}J2(u);w=J;y=L;z=w;A=0;B=z;C=y;be(B|0);return 0}function oR(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0.0,an=0.0,ao=0.0,aq=0.0,au=0.0,av=0.0,aw=0.0,ax=0.0,ay=0,az=0,aA=0.0,aB=0.0,aC=0.0,aD=0.0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0;k=i;i=i+424|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;y=k+176|0;z=k+192|0;A=k+208|0;B=k+224|0;D=k+240|0;E=k+256|0;F=k+272|0;G=k+288|0;H=k+312|0;I=k+328|0;J=k+344|0;L=k+360|0;M=k+376|0;N=k+392|0;O=k+408|0;P=p;Q=p;a[Q]=12;R=P+1|0;a[R]=a[10240]|0;a[R+1|0]=a[10241]|0;a[R+2|0]=a[10242]|0;a[R+3|0]=a[10243]|0;a[R+4|0]=a[10244]|0;a[R+5|0]=a[10245]|0;a[P+7|0]=0;P=q;R=g;c[P>>2]=c[R>>2];c[P+4>>2]=c[R+4>>2];c[P+8>>2]=c[R+8>>2];P=(x=0,ar(100,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;q=j;j=K;if((a[Q]&1)==0){S=q;T=j;U=S;V=0;W=U;X=T;be(W|0)}J2(c[p+8>>2]|0);S=q;T=j;U=S;V=0;W=U;X=T;be(W|0)}if((a[Q]&1)!=0){J2(c[p+8>>2]|0)}p=r;Q=r;a[Q]=8;j=p+1|0;C=1684369956;a[j]=C;C=C>>8;a[j+1|0]=C;C=C>>8;a[j+2|0]=C;C=C>>8;a[j+3|0]=C;a[p+5|0]=0;p=(x=0,aK(88,b|0,r|0)|0);if(x){x=0;j=bQ(-1,-1)|0;q=j;j=K;if((a[Q]&1)==0){S=q;T=j;U=S;V=0;W=U;X=T;be(W|0)}J2(c[r+8>>2]|0);S=q;T=j;U=S;V=0;W=U;X=T;be(W|0)}j=c[p>>2]|0;if((j|0)==0){Y=0}else{Y=JP(j,29912,30096,-1)|0}if((a[Q]&1)!=0){J2(c[r+8>>2]|0)}r=s;Q=s;a[Q]=12;j=r+1|0;a[j]=a[1128]|0;a[j+1|0]=a[1129]|0;a[j+2|0]=a[1130]|0;a[j+3|0]=a[1131]|0;a[j+4|0]=a[1132]|0;a[j+5|0]=a[1133]|0;a[r+7|0]=0;r=(x=0,aK(88,b|0,s|0)|0);if(x){x=0;j=bQ(-1,-1)|0;p=j;j=K;if((a[Q]&1)==0){S=p;T=j;U=S;V=0;W=U;X=T;be(W|0)}J2(c[s+8>>2]|0);S=p;T=j;U=S;V=0;W=U;X=T;be(W|0)}j=c[r>>2]|0;if((j|0)==0){Z=0}else{Z=JP(j,29912,30096,-1)|0}if((a[Q]&1)!=0){J2(c[s+8>>2]|0)}s=t;Q=t;a[Q]=10;j=s+1|0;a[j]=a[536]|0;a[j+1|0]=a[537]|0;a[j+2|0]=a[538]|0;a[j+3|0]=a[539]|0;a[j+4|0]=a[540]|0;a[s+6|0]=0;s=(x=0,aK(88,b|0,t|0)|0);if(x){x=0;j=bQ(-1,-1)|0;r=j;j=K;if((a[Q]&1)==0){S=r;T=j;U=S;V=0;W=U;X=T;be(W|0)}J2(c[t+8>>2]|0);S=r;T=j;U=S;V=0;W=U;X=T;be(W|0)}j=c[s>>2]|0;if((j|0)==0){_=0}else{_=JP(j,29912,30096,-1)|0}if((a[Q]&1)!=0){J2(c[t+8>>2]|0)}t=u;Q=u;a[Q]=8;j=t+1|0;C=1702193188;a[j]=C;C=C>>8;a[j+1|0]=C;C=C>>8;a[j+2|0]=C;C=C>>8;a[j+3|0]=C;a[t+5|0]=0;t=(x=0,aK(88,b|0,u|0)|0);if(x){x=0;j=bQ(-1,-1)|0;s=j;j=K;if((a[Q]&1)==0){S=s;T=j;U=S;V=0;W=U;X=T;be(W|0)}J2(c[u+8>>2]|0);S=s;T=j;U=S;V=0;W=U;X=T;be(W|0)}j=c[t>>2]|0;if((j|0)==0){$=0}else{$=JP(j,29912,30096,-1)|0}if((a[Q]&1)!=0){J2(c[u+8>>2]|0)}u=J0(16)|0;Q=v+8|0;c[Q>>2]=u;c[v>>2]=17;c[v+4>>2]=11;Kb(u|0,8704,11)|0;a[u+11|0]=0;u=(x=0,aK(88,b|0,v|0)|0);if(x){x=0;j=bQ(-1,-1)|0;t=j;j=K;if((a[v]&1)==0){S=t;T=j;U=S;V=0;W=U;X=T;be(W|0)}J2(c[Q>>2]|0);S=t;T=j;U=S;V=0;W=U;X=T;be(W|0)}j=c[u>>2]|0;if((j|0)==0){aa=0}else{aa=JP(j,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[Q>>2]|0)}Q=w;v=w;a[v]=20;Kb(Q+1|0,8568,10)|0;a[Q+11|0]=0;Q=(x=0,aK(88,b|0,w|0)|0);if(x){x=0;j=bQ(-1,-1)|0;u=j;j=K;if((a[v]&1)==0){S=u;T=j;U=S;V=0;W=U;X=T;be(W|0)}J2(c[w+8>>2]|0);S=u;T=j;U=S;V=0;W=U;X=T;be(W|0)}j=c[Q>>2]|0;if((j|0)==0){ab=0}else{ab=JP(j,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[w+8>>2]|0)}w=y;v=y;a[v]=12;j=w+1|0;a[j]=a[10864]|0;a[j+1|0]=a[10865]|0;a[j+2|0]=a[10866]|0;a[j+3|0]=a[10867]|0;a[j+4|0]=a[10868]|0;a[j+5|0]=a[10869]|0;a[w+7|0]=0;w=(x=0,aK(88,b|0,y|0)|0);if(x){x=0;b=bQ(-1,-1)|0;j=b;b=K;if((a[v]&1)==0){S=j;T=b;U=S;V=0;W=U;X=T;be(W|0)}J2(c[y+8>>2]|0);S=j;T=b;U=S;V=0;W=U;X=T;be(W|0)}b=c[w>>2]|0;if((b|0)==0){ac=0}else{ac=JP(b,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[y+8>>2]|0)}y=(Y|0)!=0;v=(Z|0)==0;b=(_|0)!=0|(y|v^1);w=($|0)!=0;j=(aa|0)==0;Q=(ab|0)!=0|(w|j^1);L102:do{if(b&Q){u=J0(64)|0;t=z+8|0;c[t>>2]=u;c[z>>2]=65;c[z+4>>2]=57;Kb(u|0,4664,57)|0;a[u+57|0]=0;u=f;L104:do{if((a[u]&1)==0){s=A;c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];ad=66}else{s=c[f+8>>2]|0;r=c[f+4>>2]|0;do{if(r>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(r>>>0<11>>>0){a[A]=r<<1;ae=A+1|0}else{p=r+16&-16;q=(x=0,as(230,p|0)|0);if(x){x=0;break}c[A+8>>2]=q;c[A>>2]=p|1;c[A+4>>2]=r;ae=q}Kb(ae|0,s|0,r)|0;a[ae+r|0]=0;ad=66;break L104}}while(0);r=bQ(-1,-1)|0;af=r;ag=K}}while(0);do{if((ad|0)==66){u=B;c[u>>2]=c[R>>2];c[u+4>>2]=c[R+4>>2];c[u+8>>2]=c[R+8>>2];x=0;aP(362,z|0,A|0,B|0);if(x){x=0;u=bQ(-1,-1)|0;r=u;u=K;if((a[A]&1)==0){af=r;ag=u;break}J2(c[A+8>>2]|0);af=r;ag=u;break}if((a[A]&1)!=0){J2(c[A+8>>2]|0)}if((a[z]&1)==0){break L102}J2(c[t>>2]|0);break L102}}while(0);if((a[z]&1)==0){S=af;T=ag;U=S;V=0;W=U;X=T;be(W|0)}J2(c[t>>2]|0);S=af;T=ag;U=S;V=0;W=U;X=T;be(W|0)}}while(0);if(b){b=J0(88)|0;c[o>>2]=b;ag=d+4|0;af=c[ag>>2]|0;if((af|0)==(c[d+8>>2]|0)){ee(d|0,o);ah=c[o>>2]|0}else{if((af|0)==0){ai=0}else{c[af>>2]=b;ai=c[ag>>2]|0}c[ag>>2]=ai+4;ah=b}b=ah;ai=ah;af=f;L142:do{if((a[af]&1)==0){o=D;c[o>>2]=c[af>>2];c[o+4>>2]=c[af+4>>2];c[o+8>>2]=c[af+8>>2];ad=92}else{o=c[f+8>>2]|0;z=c[f+4>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[D]=z<<1;aj=D+1|0}else{A=z+16&-16;B=(x=0,as(230,A|0)|0);if(x){x=0;break}c[D+8>>2]=B;c[D>>2]=A|1;c[D+4>>2]=z;aj=B}Kb(aj|0,o|0,z)|0;a[aj+z|0]=0;ad=92;break L142}}while(0);z=bQ(-1,-1)|0;ak=z;al=K}}while(0);do{if((ad|0)==92){aj=E;c[aj>>2]=c[R>>2];c[aj+4>>2]=c[R+4>>2];c[aj+8>>2]=c[R+8>>2];if(y){am=+h[Y+40>>3]}else{am=0.0}an=+h[P+40>>3]+am;if(v){ao=0.0}else{ao=+h[Z+40>>3]}aq=+h[P+48>>3]+ao;if((_|0)==0){au=0.0}else{au=+h[_+40>>3]}av=+h[P+56>>3]+au;if((ac|0)==0){aw=0.0}else{aw=+h[ac+40>>3]}ax=+h[P+64>>3]+aw;af=F;a[af]=0;a[F+1|0]=0;z=n;c[z>>2]=c[aj>>2];c[z+4>>2]=c[aj+4>>2];c[z+8>>2]=c[aj+8>>2];x=0;at(2,ai|0,D|0,n|0,+an,+aq,+av,+ax,F|0);if(x){x=0;aj=bQ(-1,-1)|0;z=aj;aj=K;if((a[af]&1)!=0){J2(c[F+8>>2]|0)}if((a[D]&1)==0){ak=z;al=aj;break}J2(c[D+8>>2]|0);ak=z;al=aj;break}if((a[af]&1)!=0){J2(c[F+8>>2]|0)}af=ah;if((a[D]&1)==0){ay=af;i=k;return ay|0}J2(c[D+8>>2]|0);ay=af;i=k;return ay|0}}while(0);D=c[d>>2]|0;F=c[ag>>2]|0;n=D;while(1){if((n|0)==(F|0)){az=F;break}if((c[n>>2]|0)==(ah|0)){az=n;break}else{n=n+4|0}}n=az-D>>2;az=D+(n+1<<2)|0;ah=F-az|0;Kc(D+(n<<2)|0,az|0,ah|0)|0;az=D+((ah>>2)+n<<2)|0;n=c[ag>>2]|0;if((az|0)!=(n|0)){c[ag>>2]=n+(~((n-4+(-az|0)|0)>>>2)<<2)}J2(b);S=ak;T=al;U=S;V=0;W=U;X=T;be(W|0)}if(Q){oz(G,+h[P+40>>3],+h[P+48>>3],+h[P+56>>3]);if(w){aA=+h[$+40>>3]}else{aA=0.0}aw=+h[G>>3]+aA;if(j){aB=0.0}else{aB=+h[aa+40>>3]}aA=+h[G+8>>3]+aB;if((ab|0)==0){aC=0.0}else{aC=+h[ab+40>>3]}aB=+h[G+16>>3]+aC;if((ac|0)==0){aD=0.0}else{aD=+h[ac+40>>3]}aC=+h[P+64>>3]+aD;G=H;c[G>>2]=c[R>>2];c[G+4>>2]=c[R+4>>2];c[G+8>>2]=c[R+8>>2];ay=oA(aw,aA,aB,aC,d,f,H)|0;i=k;return ay|0}if((ac|0)==0){H=J0(48)|0;G=M+8|0;c[G>>2]=H;c[M>>2]=49;c[M+4>>2]=39;Kb(H|0,4472,39)|0;a[H+39|0]=0;H=f;L211:do{if((a[H]&1)==0){ab=N;c[ab>>2]=c[H>>2];c[ab+4>>2]=c[H+4>>2];c[ab+8>>2]=c[H+8>>2];ad=168}else{ab=c[f+8>>2]|0;aa=c[f+4>>2]|0;do{if(aa>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aa>>>0<11>>>0){a[N]=aa<<1;aE=N+1|0}else{j=aa+16&-16;$=(x=0,as(230,j|0)|0);if(x){x=0;break}c[N+8>>2]=$;c[N>>2]=j|1;c[N+4>>2]=aa;aE=$}Kb(aE|0,ab|0,aa)|0;a[aE+aa|0]=0;ad=168;break L211}}while(0);aa=bQ(-1,-1)|0;aF=aa;aG=K}}while(0);do{if((ad|0)==168){aE=O;c[aE>>2]=c[R>>2];c[aE+4>>2]=c[R+4>>2];c[aE+8>>2]=c[R+8>>2];x=0;aP(362,M|0,N|0,O|0);if(x){x=0;aE=bQ(-1,-1)|0;H=aE;aE=K;if((a[N]&1)==0){aF=H;aG=aE;break}J2(c[N+8>>2]|0);aF=H;aG=aE;break}if((a[N]&1)!=0){J2(c[N+8>>2]|0)}if((a[M]&1)!=0){J2(c[G>>2]|0)}ay=P|0;i=k;return ay|0}}while(0);if((a[M]&1)==0){S=aF;T=aG;U=S;V=0;W=U;X=T;be(W|0)}J2(c[G>>2]|0);S=aF;T=aG;U=S;V=0;W=U;X=T;be(W|0)}aG=J0(88)|0;c[l>>2]=aG;aF=d+4|0;G=c[aF>>2]|0;if((G|0)==(c[d+8>>2]|0)){ee(d|0,l);aH=c[l>>2]|0}else{if((G|0)==0){aI=0}else{c[G>>2]=aG;aI=c[aF>>2]|0}c[aF>>2]=aI+4;aH=aG}aG=aH;aI=aH;G=f;L250:do{if((a[G]&1)==0){l=I;c[l>>2]=c[G>>2];c[l+4>>2]=c[G+4>>2];c[l+8>>2]=c[G+8>>2];ad=142}else{l=c[f+8>>2]|0;M=c[f+4>>2]|0;do{if(M>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(M>>>0<11>>>0){a[I]=M<<1;aJ=I+1|0}else{N=M+16&-16;O=(x=0,as(230,N|0)|0);if(x){x=0;break}c[I+8>>2]=O;c[I>>2]=N|1;c[I+4>>2]=M;aJ=O}Kb(aJ|0,l|0,M)|0;a[aJ+M|0]=0;ad=142;break L250}}while(0);M=bQ(-1,-1)|0;aL=M;aM=K}}while(0);do{if((ad|0)==142){aJ=J;c[aJ>>2]=c[R>>2];c[aJ+4>>2]=c[R+4>>2];c[aJ+8>>2]=c[R+8>>2];aC=+h[P+40>>3];aB=+h[P+48>>3];aA=+h[P+56>>3];aw=+h[P+64>>3]+ +h[ac+40>>3];f=L;a[f]=0;a[L+1|0]=0;G=m;c[G>>2]=c[aJ>>2];c[G+4>>2]=c[aJ+4>>2];c[G+8>>2]=c[aJ+8>>2];x=0;at(2,aI|0,I|0,m|0,+aC,+aB,+aA,+aw,L|0);if(x){x=0;aJ=bQ(-1,-1)|0;G=aJ;aJ=K;if((a[f]&1)!=0){J2(c[L+8>>2]|0)}if((a[I]&1)==0){aL=G;aM=aJ;break}J2(c[I+8>>2]|0);aL=G;aM=aJ;break}if((a[f]&1)!=0){J2(c[L+8>>2]|0)}f=aH;if((a[I]&1)==0){ay=f;i=k;return ay|0}J2(c[I+8>>2]|0);ay=f;i=k;return ay|0}}while(0);ay=c[d>>2]|0;d=c[aF>>2]|0;k=ay;while(1){if((k|0)==(d|0)){aN=d;break}if((c[k>>2]|0)==(aH|0)){aN=k;break}else{k=k+4|0}}k=aN-ay>>2;aN=ay+(k+1<<2)|0;aH=d-aN|0;Kc(ay+(k<<2)|0,aN|0,aH|0)|0;aN=ay+((aH>>2)+k<<2)|0;k=c[aF>>2]|0;if((aN|0)!=(k|0)){c[aF>>2]=k+(~((k-4+(-aN|0)|0)>>>2)<<2)}J2(aG);S=aL;T=aM;U=S;V=0;W=U;X=T;be(W|0);return 0}function oS(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,ao=0,aq=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0.0,aF=0.0,aG=0.0,aH=0.0,aI=0.0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0.0,aR=0.0,aS=0.0,aT=0.0,aU=0.0,aV=0.0,aW=0.0,aX=0,aY=0,aZ=0.0,a_=0.0,a$=0.0,a0=0.0,a1=0.0,a2=0.0,a3=0.0,a4=0.0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0.0,bf=0;k=i;i=i+712|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+32|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;y=k+176|0;z=k+192|0;A=k+208|0;B=k+224|0;D=k+240|0;E=k+256|0;F=k+272|0;G=k+288|0;H=k+304|0;I=k+320|0;J=k+336|0;L=k+352|0;M=k+368|0;N=k+384|0;O=k+400|0;P=k+416|0;Q=k+432|0;R=k+448|0;S=k+464|0;T=k+480|0;U=k+496|0;V=k+512|0;W=k+528|0;X=k+544|0;Y=k+568|0;Z=k+584|0;_=k+600|0;$=k+616|0;aa=k+632|0;ab=k+648|0;ac=k+664|0;ad=k+680|0;ae=k+696|0;af=p;ag=p;a[ag]=12;ah=af+1|0;a[ah]=a[10240]|0;a[ah+1|0]=a[10241]|0;a[ah+2|0]=a[10242]|0;a[ah+3|0]=a[10243]|0;a[ah+4|0]=a[10244]|0;a[ah+5|0]=a[10245]|0;a[af+7|0]=0;af=q;ah=g;c[af>>2]=c[ah>>2];c[af+4>>2]=c[ah+4>>2];c[af+8>>2]=c[ah+8>>2];af=(x=0,ar(100,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(x){x=0;q=bQ(-1,-1)|0;g=q;q=K;if((a[ag]&1)==0){ai=g;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[p+8>>2]|0);ai=g;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}if((a[ag]&1)!=0){J2(c[p+8>>2]|0)}p=r;ag=r;a[ag]=8;q=p+1|0;C=1684369956;a[q]=C;C=C>>8;a[q+1|0]=C;C=C>>8;a[q+2|0]=C;C=C>>8;a[q+3|0]=C;a[p+5|0]=0;p=(x=0,aK(88,b|0,r|0)|0);if(x){x=0;q=bQ(-1,-1)|0;g=q;q=K;if((a[ag]&1)==0){ai=g;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[r+8>>2]|0);ai=g;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}q=c[p>>2]|0;if((q|0)==0){aq=0}else{aq=JP(q,29912,30096,-1)|0}if((a[ag]&1)!=0){J2(c[r+8>>2]|0)}r=s;ag=s;a[ag]=12;q=r+1|0;a[q]=a[1128]|0;a[q+1|0]=a[1129]|0;a[q+2|0]=a[1130]|0;a[q+3|0]=a[1131]|0;a[q+4|0]=a[1132]|0;a[q+5|0]=a[1133]|0;a[r+7|0]=0;r=(x=0,aK(88,b|0,s|0)|0);if(x){x=0;q=bQ(-1,-1)|0;p=q;q=K;if((a[ag]&1)==0){ai=p;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[s+8>>2]|0);ai=p;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}q=c[r>>2]|0;if((q|0)==0){au=0}else{au=JP(q,29912,30096,-1)|0}if((a[ag]&1)!=0){J2(c[s+8>>2]|0)}s=t;ag=t;a[ag]=10;q=s+1|0;a[q]=a[536]|0;a[q+1|0]=a[537]|0;a[q+2|0]=a[538]|0;a[q+3|0]=a[539]|0;a[q+4|0]=a[540]|0;a[s+6|0]=0;s=(x=0,aK(88,b|0,t|0)|0);if(x){x=0;q=bQ(-1,-1)|0;r=q;q=K;if((a[ag]&1)==0){ai=r;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[t+8>>2]|0);ai=r;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}q=c[s>>2]|0;if((q|0)==0){av=0}else{av=JP(q,29912,30096,-1)|0}if((a[ag]&1)!=0){J2(c[t+8>>2]|0)}t=u;ag=u;a[ag]=8;q=t+1|0;C=1702193188;a[q]=C;C=C>>8;a[q+1|0]=C;C=C>>8;a[q+2|0]=C;C=C>>8;a[q+3|0]=C;a[t+5|0]=0;t=(x=0,aK(88,b|0,u|0)|0);if(x){x=0;q=bQ(-1,-1)|0;s=q;q=K;if((a[ag]&1)==0){ai=s;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[u+8>>2]|0);ai=s;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}q=c[t>>2]|0;if((q|0)==0){aw=0}else{aw=JP(q,29912,30096,-1)|0}if((a[ag]&1)!=0){J2(c[u+8>>2]|0)}u=J0(16)|0;ag=v+8|0;c[ag>>2]=u;c[v>>2]=17;c[v+4>>2]=11;Kb(u|0,8704,11)|0;a[u+11|0]=0;u=(x=0,aK(88,b|0,v|0)|0);if(x){x=0;q=bQ(-1,-1)|0;t=q;q=K;if((a[v]&1)==0){ai=t;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[ag>>2]|0);ai=t;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}q=c[u>>2]|0;if((q|0)==0){ax=0}else{ax=JP(q,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[ag>>2]|0)}ag=w;v=w;a[v]=20;Kb(ag+1|0,8568,10)|0;a[ag+11|0]=0;ag=(x=0,aK(88,b|0,w|0)|0);if(x){x=0;q=bQ(-1,-1)|0;u=q;q=K;if((a[v]&1)==0){ai=u;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[w+8>>2]|0);ai=u;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}q=c[ag>>2]|0;if((q|0)==0){ay=0}else{ay=JP(q,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[w+8>>2]|0)}w=y;v=y;a[v]=12;q=w+1|0;a[q]=a[10864]|0;a[q+1|0]=a[10865]|0;a[q+2|0]=a[10866]|0;a[q+3|0]=a[10867]|0;a[q+4|0]=a[10868]|0;a[q+5|0]=a[10869]|0;a[w+7|0]=0;w=(x=0,aK(88,b|0,y|0)|0);if(x){x=0;q=bQ(-1,-1)|0;ag=q;q=K;if((a[v]&1)==0){ai=ag;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[y+8>>2]|0);ai=ag;aj=q;ak=ai;al=0;am=ak;ao=aj;be(am|0)}q=c[w>>2]|0;if((q|0)==0){az=0}else{az=JP(q,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[y+8>>2]|0)}y=(aq|0)!=0;aq=(au|0)==0;au=(av|0)!=0|(y|aq^1);v=(aw|0)!=0;aw=(ax|0)==0;ax=(ay|0)!=0|(v|aw^1);L102:do{if(au&ax){q=J0(64)|0;w=z+8|0;c[w>>2]=q;c[z>>2]=65;c[z+4>>2]=56;Kb(q|0,4160,56)|0;a[q+56|0]=0;q=f;L104:do{if((a[q]&1)==0){ag=A;c[ag>>2]=c[q>>2];c[ag+4>>2]=c[q+4>>2];c[ag+8>>2]=c[q+8>>2];aA=66}else{ag=c[f+8>>2]|0;u=c[f+4>>2]|0;do{if(u>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(u>>>0<11>>>0){a[A]=u<<1;aB=A+1|0}else{t=u+16&-16;s=(x=0,as(230,t|0)|0);if(x){x=0;break}c[A+8>>2]=s;c[A>>2]=t|1;c[A+4>>2]=u;aB=s}Kb(aB|0,ag|0,u)|0;a[aB+u|0]=0;aA=66;break L104}}while(0);u=bQ(-1,-1)|0;aC=u;aD=K}}while(0);do{if((aA|0)==66){q=B;c[q>>2]=c[ah>>2];c[q+4>>2]=c[ah+4>>2];c[q+8>>2]=c[ah+8>>2];x=0;aP(362,z|0,A|0,B|0);if(x){x=0;q=bQ(-1,-1)|0;u=q;q=K;if((a[A]&1)==0){aC=u;aD=q;break}J2(c[A+8>>2]|0);aC=u;aD=q;break}if((a[A]&1)!=0){J2(c[A+8>>2]|0)}if((a[z]&1)==0){break L102}J2(c[w>>2]|0);break L102}}while(0);if((a[z]&1)==0){ai=aC;aj=aD;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[w>>2]|0);ai=aC;aj=aD;ak=ai;al=0;am=ak;ao=aj;be(am|0)}}while(0);if(au){do{if(y){au=D;aD=D;a[aD]=8;aC=au+1|0;C=1684369956;a[aC]=C;C=C>>8;a[aC+1|0]=C;C=C>>8;a[aC+2|0]=C;C=C>>8;a[aC+3|0]=C;a[au+5|0]=0;au=E;c[au>>2]=c[ah>>2];c[au+4>>2]=c[ah+4>>2];c[au+8>>2]=c[ah+8>>2];au=(x=0,an(2,D|0,b|0,e|0,f|0,E|0,+-100.0,+100.0,j|0)|0);if(!x){aE=+h[au+40>>3]/100.0;if((a[aD]&1)==0){aF=aE;break}J2(c[D+8>>2]|0);aF=aE;break}else{x=0}au=bQ(-1,-1)|0;aC=au;au=K;if((a[aD]&1)==0){ai=aC;aj=au;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[D+8>>2]|0);ai=aC;aj=au;ak=ai;al=0;am=ak;ao=aj;be(am|0)}else{aF=0.0}}while(0);do{if(aq){aG=0.0}else{D=F;E=F;a[E]=12;y=D+1|0;a[y]=a[1128]|0;a[y+1|0]=a[1129]|0;a[y+2|0]=a[1130]|0;a[y+3|0]=a[1131]|0;a[y+4|0]=a[1132]|0;a[y+5|0]=a[1133]|0;a[D+7|0]=0;D=G;c[D>>2]=c[ah>>2];c[D+4>>2]=c[ah+4>>2];c[D+8>>2]=c[ah+8>>2];D=(x=0,an(2,F|0,b|0,e|0,f|0,G|0,+-100.0,+100.0,j|0)|0);if(!x){aE=+h[D+40>>3]/100.0;if((a[E]&1)==0){aG=aE;break}J2(c[F+8>>2]|0);aG=aE;break}else{x=0}D=bQ(-1,-1)|0;y=D;D=K;if((a[E]&1)==0){ai=y;aj=D;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[F+8>>2]|0);ai=y;aj=D;ak=ai;al=0;am=ak;ao=aj;be(am|0)}}while(0);do{if((av|0)==0){aH=0.0}else{F=H;G=H;a[G]=10;aq=F+1|0;a[aq]=a[536]|0;a[aq+1|0]=a[537]|0;a[aq+2|0]=a[538]|0;a[aq+3|0]=a[539]|0;a[aq+4|0]=a[540]|0;a[F+6|0]=0;F=I;c[F>>2]=c[ah>>2];c[F+4>>2]=c[ah+4>>2];c[F+8>>2]=c[ah+8>>2];F=(x=0,an(2,H|0,b|0,e|0,f|0,I|0,+-100.0,+100.0,j|0)|0);if(!x){aE=+h[F+40>>3]/100.0;if((a[G]&1)==0){aH=aE;break}J2(c[H+8>>2]|0);aH=aE;break}else{x=0}F=bQ(-1,-1)|0;aq=F;F=K;if((a[G]&1)==0){ai=aq;aj=F;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[H+8>>2]|0);ai=aq;aj=F;ak=ai;al=0;am=ak;ao=aj;be(am|0)}}while(0);do{if((az|0)==0){aI=0.0}else{H=J;I=J;a[I]=12;av=H+1|0;a[av]=a[10864]|0;a[av+1|0]=a[10865]|0;a[av+2|0]=a[10866]|0;a[av+3|0]=a[10867]|0;a[av+4|0]=a[10868]|0;a[av+5|0]=a[10869]|0;a[H+7|0]=0;H=L;c[H>>2]=c[ah>>2];c[H+4>>2]=c[ah+4>>2];c[H+8>>2]=c[ah+8>>2];H=(x=0,an(2,J|0,b|0,e|0,f|0,L|0,+-100.0,+100.0,j|0)|0);if(!x){aE=+h[H+40>>3]/100.0;if((a[I]&1)==0){aI=aE;break}J2(c[J+8>>2]|0);aI=aE;break}else{x=0}H=bQ(-1,-1)|0;av=H;H=K;if((a[I]&1)==0){ai=av;aj=H;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[J+8>>2]|0);ai=av;aj=H;ak=ai;al=0;am=ak;ao=aj;be(am|0)}}while(0);J=J0(88)|0;c[n>>2]=J;L=d+4|0;H=c[L>>2]|0;if((H|0)==(c[d+8>>2]|0)){ee(d|0,n);aJ=c[n>>2]|0}else{if((H|0)==0){aL=0}else{c[H>>2]=J;aL=c[L>>2]|0}c[L>>2]=aL+4;aJ=J}J=aJ;aL=aJ;H=f;L186:do{if((a[H]&1)==0){n=M;c[n>>2]=c[H>>2];c[n+4>>2]=c[H+4>>2];c[n+8>>2]=c[H+8>>2];aA=108}else{n=c[f+8>>2]|0;av=c[f+4>>2]|0;do{if(av>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(av>>>0<11>>>0){a[M]=av<<1;aM=M+1|0}else{I=av+16&-16;F=(x=0,as(230,I|0)|0);if(x){x=0;break}c[M+8>>2]=F;c[M>>2]=I|1;c[M+4>>2]=av;aM=F}Kb(aM|0,n|0,av)|0;a[aM+av|0]=0;aA=108;break L186}}while(0);av=bQ(-1,-1)|0;aN=av;aO=K}}while(0);do{if((aA|0)==108){aM=N;c[aM>>2]=c[ah>>2];c[aM+4>>2]=c[ah+4>>2];c[aM+8>>2]=c[ah+8>>2];aE=+h[af+40>>3];if(aF>0.0){aQ=255.0-aE}else{aQ=aE}aR=+h[af+48>>3];if(aG>0.0){aS=255.0-aR}else{aS=aR}aT=+h[af+56>>3];if(aH>0.0){aU=255.0-aT}else{aU=aT}aV=+h[af+64>>3];if(aI>0.0){aW=1.0-aV}else{aW=aV}H=O;a[H]=0;a[O+1|0]=0;av=l;c[av>>2]=c[aM>>2];c[av+4>>2]=c[aM+4>>2];c[av+8>>2]=c[aM+8>>2];x=0;at(2,aL|0,M|0,l|0,+(aE+aF*aQ),+(aR+aG*aS),+(aT+aH*aU),+(aV+aI*aW),O|0);if(x){x=0;aM=bQ(-1,-1)|0;av=aM;aM=K;if((a[H]&1)!=0){J2(c[O+8>>2]|0)}if((a[M]&1)==0){aN=av;aO=aM;break}J2(c[M+8>>2]|0);aN=av;aO=aM;break}if((a[H]&1)!=0){J2(c[O+8>>2]|0)}H=aJ;if((a[M]&1)==0){aX=H;i=k;return aX|0}J2(c[M+8>>2]|0);aX=H;i=k;return aX|0}}while(0);M=c[d>>2]|0;O=c[L>>2]|0;l=M;while(1){if((l|0)==(O|0)){aY=O;break}if((c[l>>2]|0)==(aJ|0)){aY=l;break}else{l=l+4|0}}l=aY-M>>2;aY=M+(l+1<<2)|0;aJ=O-aY|0;Kc(M+(l<<2)|0,aY|0,aJ|0)|0;aY=M+((aJ>>2)+l<<2)|0;l=c[L>>2]|0;if((aY|0)!=(l|0)){c[L>>2]=l+(~((l-4+(-aY|0)|0)>>>2)<<2)}J2(J);ai=aN;aj=aO;ak=ai;al=0;am=ak;ao=aj;be(am|0)}if(ax){do{if(v){ax=P;aO=P;a[aO]=8;aN=ax+1|0;C=1702193188;a[aN]=C;C=C>>8;a[aN+1|0]=C;C=C>>8;a[aN+2|0]=C;C=C>>8;a[aN+3|0]=C;a[ax+5|0]=0;ax=Q;c[ax>>2]=c[ah>>2];c[ax+4>>2]=c[ah+4>>2];c[ax+8>>2]=c[ah+8>>2];ax=(x=0,an(2,P|0,b|0,e|0,f|0,Q|0,+-100.0,+100.0,j|0)|0);if(!x){aW=+h[ax+40>>3]/100.0;if((a[aO]&1)==0){aZ=aW;break}J2(c[P+8>>2]|0);aZ=aW;break}else{x=0}ax=bQ(-1,-1)|0;aN=ax;ax=K;if((a[aO]&1)==0){ai=aN;aj=ax;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[P+8>>2]|0);ai=aN;aj=ax;ak=ai;al=0;am=ak;ao=aj;be(am|0)}else{aZ=0.0}}while(0);do{if(aw){a_=0.0}else{P=J0(16)|0;Q=R+8|0;c[Q>>2]=P;c[R>>2]=17;c[R+4>>2]=11;Kb(P|0,8704,11)|0;a[P+11|0]=0;P=S;c[P>>2]=c[ah>>2];c[P+4>>2]=c[ah+4>>2];c[P+8>>2]=c[ah+8>>2];P=(x=0,an(2,R|0,b|0,e|0,f|0,S|0,+-100.0,+100.0,j|0)|0);if(!x){aW=+h[P+40>>3]/100.0;if((a[R]&1)==0){a_=aW;break}J2(c[Q>>2]|0);a_=aW;break}else{x=0}P=bQ(-1,-1)|0;v=P;P=K;if((a[R]&1)==0){ai=v;aj=P;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[Q>>2]|0);ai=v;aj=P;ak=ai;al=0;am=ak;ao=aj;be(am|0)}}while(0);do{if((ay|0)==0){a$=0.0}else{R=T;S=T;a[S]=20;Kb(R+1|0,8568,10)|0;a[R+11|0]=0;R=U;c[R>>2]=c[ah>>2];c[R+4>>2]=c[ah+4>>2];c[R+8>>2]=c[ah+8>>2];R=(x=0,an(2,T|0,b|0,e|0,f|0,U|0,+-100.0,+100.0,j|0)|0);if(!x){aW=+h[R+40>>3]/100.0;if((a[S]&1)==0){a$=aW;break}J2(c[T+8>>2]|0);a$=aW;break}else{x=0}R=bQ(-1,-1)|0;aw=R;R=K;if((a[S]&1)==0){ai=aw;aj=R;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[T+8>>2]|0);ai=aw;aj=R;ak=ai;al=0;am=ak;ao=aj;be(am|0)}}while(0);do{if((az|0)==0){a0=0.0}else{T=V;U=V;a[U]=12;ay=T+1|0;a[ay]=a[10864]|0;a[ay+1|0]=a[10865]|0;a[ay+2|0]=a[10866]|0;a[ay+3|0]=a[10867]|0;a[ay+4|0]=a[10868]|0;a[ay+5|0]=a[10869]|0;a[T+7|0]=0;T=W;c[T>>2]=c[ah>>2];c[T+4>>2]=c[ah+4>>2];c[T+8>>2]=c[ah+8>>2];T=(x=0,an(2,V|0,b|0,e|0,f|0,W|0,+-100.0,+100.0,j|0)|0);if(!x){aW=+h[T+40>>3]/100.0;if((a[U]&1)==0){a0=aW;break}J2(c[V+8>>2]|0);a0=aW;break}else{x=0}T=bQ(-1,-1)|0;ay=T;T=K;if((a[U]&1)==0){ai=ay;aj=T;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[V+8>>2]|0);ai=ay;aj=T;ak=ai;al=0;am=ak;ao=aj;be(am|0)}}while(0);V=af+40|0;oz(X,+h[V>>3],+h[af+48>>3],+h[af+56>>3]);W=X|0;aW=+h[W>>3];if(aZ>0.0){a1=360.0-aW}else{a1=aW}aI=aW+aZ*a1;h[W>>3]=aI;W=X+8|0;a1=+h[W>>3];if(a_>0.0){a2=100.0-a1}else{a2=a1}aZ=a1+a_*a2;h[W>>3]=aZ;W=X+16|0;a2=+h[W>>3];if(a$>0.0){a3=100.0-a2}else{a3=a2}a_=a2+a$*a3;h[W>>3]=a_;a3=+h[af+64>>3];if(a0>0.0){a4=1.0-a3}else{a4=+h[V>>3]}V=Y;c[V>>2]=c[ah>>2];c[V+4>>2]=c[ah+4>>2];c[V+8>>2]=c[ah+8>>2];aX=oA(aI,aZ,a_,a3+a0*a4,d,f,Y)|0;i=k;return aX|0}if((az|0)==0){az=J0(48)|0;Y=ac+8|0;c[Y>>2]=az;c[ac>>2]=49;c[ac+4>>2]=38;Kb(az|0,4040,38)|0;a[az+38|0]=0;az=f;L300:do{if((a[az]&1)==0){V=ad;c[V>>2]=c[az>>2];c[V+4>>2]=c[az+4>>2];c[V+8>>2]=c[az+8>>2];aA=224}else{V=c[f+8>>2]|0;W=c[f+4>>2]|0;do{if(W>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(W>>>0<11>>>0){a[ad]=W<<1;a5=ad+1|0}else{X=W+16&-16;T=(x=0,as(230,X|0)|0);if(x){x=0;break}c[ad+8>>2]=T;c[ad>>2]=X|1;c[ad+4>>2]=W;a5=T}Kb(a5|0,V|0,W)|0;a[a5+W|0]=0;aA=224;break L300}}while(0);W=bQ(-1,-1)|0;a6=W;a7=K}}while(0);do{if((aA|0)==224){a5=ae;c[a5>>2]=c[ah>>2];c[a5+4>>2]=c[ah+4>>2];c[a5+8>>2]=c[ah+8>>2];x=0;aP(362,ac|0,ad|0,ae|0);if(x){x=0;a5=bQ(-1,-1)|0;az=a5;a5=K;if((a[ad]&1)==0){a6=az;a7=a5;break}J2(c[ad+8>>2]|0);a6=az;a7=a5;break}if((a[ad]&1)!=0){J2(c[ad+8>>2]|0)}if((a[ac]&1)!=0){J2(c[Y>>2]|0)}aX=af|0;i=k;return aX|0}}while(0);if((a[ac]&1)==0){ai=a6;aj=a7;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[Y>>2]|0);ai=a6;aj=a7;ak=ai;al=0;am=ak;ao=aj;be(am|0)}a7=Z;a6=Z;a[a6]=12;Y=a7+1|0;a[Y]=a[10864]|0;a[Y+1|0]=a[10865]|0;a[Y+2|0]=a[10866]|0;a[Y+3|0]=a[10867]|0;a[Y+4|0]=a[10868]|0;a[Y+5|0]=a[10869]|0;a[a7+7|0]=0;a7=_;c[a7>>2]=c[ah>>2];c[a7+4>>2]=c[ah+4>>2];c[a7+8>>2]=c[ah+8>>2];a7=(x=0,an(2,Z|0,b|0,e|0,f|0,_|0,+-100.0,+100.0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;_=j;j=K;if((a[a6]&1)==0){ai=_;aj=j;ak=ai;al=0;am=ak;ao=aj;be(am|0)}J2(c[Z+8>>2]|0);ai=_;aj=j;ak=ai;al=0;am=ak;ao=aj;be(am|0)}a4=+h[a7+40>>3]/100.0;if((a[a6]&1)!=0){J2(c[Z+8>>2]|0)}Z=J0(88)|0;c[m>>2]=Z;a6=d+4|0;a7=c[a6>>2]|0;if((a7|0)==(c[d+8>>2]|0)){ee(d|0,m);a8=c[m>>2]|0}else{if((a7|0)==0){a9=0}else{c[a7>>2]=Z;a9=c[a6>>2]|0}c[a6>>2]=a9+4;a8=Z}Z=a8;a9=a8;a7=f;L349:do{if((a[a7]&1)==0){m=$;c[m>>2]=c[a7>>2];c[m+4>>2]=c[a7+4>>2];c[m+8>>2]=c[a7+8>>2];aA=194}else{m=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){a[$]=j<<1;ba=$+1|0}else{_=j+16&-16;e=(x=0,as(230,_|0)|0);if(x){x=0;break}c[$+8>>2]=e;c[$>>2]=_|1;c[$+4>>2]=j;ba=e}Kb(ba|0,m|0,j)|0;a[ba+j|0]=0;aA=194;break L349}}while(0);j=bQ(-1,-1)|0;bb=j;bc=K}}while(0);do{if((aA|0)==194){ba=aa;c[ba>>2]=c[ah>>2];c[ba+4>>2]=c[ah+4>>2];c[ba+8>>2]=c[ah+8>>2];a0=+h[af+40>>3];a3=+h[af+48>>3];a_=+h[af+56>>3];aZ=+h[af+64>>3];if(a4>0.0){bd=1.0-aZ}else{bd=aZ}f=ab;a[f]=0;a[ab+1|0]=0;a7=o;c[a7>>2]=c[ba>>2];c[a7+4>>2]=c[ba+4>>2];c[a7+8>>2]=c[ba+8>>2];x=0;at(2,a9|0,$|0,o|0,+a0,+a3,+a_,+(aZ+a4*bd),ab|0);if(x){x=0;ba=bQ(-1,-1)|0;a7=ba;ba=K;if((a[f]&1)!=0){J2(c[ab+8>>2]|0)}if((a[$]&1)==0){bb=a7;bc=ba;break}J2(c[$+8>>2]|0);bb=a7;bc=ba;break}if((a[f]&1)!=0){J2(c[ab+8>>2]|0)}f=a8;if((a[$]&1)==0){aX=f;i=k;return aX|0}J2(c[$+8>>2]|0);aX=f;i=k;return aX|0}}while(0);aX=c[d>>2]|0;d=c[a6>>2]|0;k=aX;while(1){if((k|0)==(d|0)){bf=d;break}if((c[k>>2]|0)==(a8|0)){bf=k;break}else{k=k+4|0}}k=bf-aX>>2;bf=aX+(k+1<<2)|0;a8=d-bf|0;Kc(aX+(k<<2)|0,bf|0,a8|0)|0;bf=aX+((a8>>2)+k<<2)|0;k=c[a6>>2]|0;if((bf|0)!=(k|0)){c[a6>>2]=k+(~((k-4+(-bf|0)|0)>>>2)<<2)}J2(Z);ai=bb;aj=bc;ak=ai;al=0;am=ak;ao=aj;be(am|0);return 0}function oT(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,ao=0,aq=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0.0,aM=0,aN=0,aO=0,aQ=0,aR=0.0,aS=0,aT=0,aU=0,aV=0,aW=0.0,aX=0,aY=0,aZ=0,a_=0,a$=0.0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0.0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0;k=i;i=i+664|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;y=k+176|0;z=k+192|0;A=k+208|0;B=k+224|0;D=k+240|0;E=k+256|0;F=k+272|0;G=k+288|0;H=k+304|0;I=k+320|0;J=k+336|0;L=k+352|0;M=k+368|0;N=k+384|0;O=k+400|0;P=k+416|0;Q=k+440|0;R=k+456|0;S=k+472|0;T=k+488|0;U=k+504|0;V=k+520|0;W=k+536|0;X=k+552|0;Y=k+568|0;Z=k+584|0;_=k+600|0;$=k+616|0;aa=k+632|0;ab=k+648|0;ac=p;ad=p;a[ad]=12;ae=ac+1|0;a[ae]=a[10240]|0;a[ae+1|0]=a[10241]|0;a[ae+2|0]=a[10242]|0;a[ae+3|0]=a[10243]|0;a[ae+4|0]=a[10244]|0;a[ae+5|0]=a[10245]|0;a[ac+7|0]=0;ac=q;ae=g;c[ac>>2]=c[ae>>2];c[ac+4>>2]=c[ae+4>>2];c[ac+8>>2]=c[ae+8>>2];ac=(x=0,ar(100,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(x){x=0;q=bQ(-1,-1)|0;g=q;q=K;if((a[ad]&1)==0){af=g;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[p+8>>2]|0);af=g;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}if((a[ad]&1)!=0){J2(c[p+8>>2]|0)}p=r;ad=r;a[ad]=8;q=p+1|0;C=1684369956;a[q]=C;C=C>>8;a[q+1|0]=C;C=C>>8;a[q+2|0]=C;C=C>>8;a[q+3|0]=C;a[p+5|0]=0;p=(x=0,aK(88,b|0,r|0)|0);if(x){x=0;q=bQ(-1,-1)|0;g=q;q=K;if((a[ad]&1)==0){af=g;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[r+8>>2]|0);af=g;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}q=c[p>>2]|0;if((q|0)==0){al=0}else{al=JP(q,29912,30096,-1)|0}if((a[ad]&1)!=0){J2(c[r+8>>2]|0)}r=s;ad=s;a[ad]=12;q=r+1|0;a[q]=a[1128]|0;a[q+1|0]=a[1129]|0;a[q+2|0]=a[1130]|0;a[q+3|0]=a[1131]|0;a[q+4|0]=a[1132]|0;a[q+5|0]=a[1133]|0;a[r+7|0]=0;r=(x=0,aK(88,b|0,s|0)|0);if(x){x=0;q=bQ(-1,-1)|0;p=q;q=K;if((a[ad]&1)==0){af=p;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[s+8>>2]|0);af=p;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}q=c[r>>2]|0;if((q|0)==0){am=0}else{am=JP(q,29912,30096,-1)|0}if((a[ad]&1)!=0){J2(c[s+8>>2]|0)}s=t;ad=t;a[ad]=10;q=s+1|0;a[q]=a[536]|0;a[q+1|0]=a[537]|0;a[q+2|0]=a[538]|0;a[q+3|0]=a[539]|0;a[q+4|0]=a[540]|0;a[s+6|0]=0;s=(x=0,aK(88,b|0,t|0)|0);if(x){x=0;q=bQ(-1,-1)|0;r=q;q=K;if((a[ad]&1)==0){af=r;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[t+8>>2]|0);af=r;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}q=c[s>>2]|0;if((q|0)==0){ao=0}else{ao=JP(q,29912,30096,-1)|0}if((a[ad]&1)!=0){J2(c[t+8>>2]|0)}t=u;ad=u;a[ad]=8;q=t+1|0;C=1702193188;a[q]=C;C=C>>8;a[q+1|0]=C;C=C>>8;a[q+2|0]=C;C=C>>8;a[q+3|0]=C;a[t+5|0]=0;t=(x=0,aK(88,b|0,u|0)|0);if(x){x=0;q=bQ(-1,-1)|0;s=q;q=K;if((a[ad]&1)==0){af=s;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[u+8>>2]|0);af=s;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}q=c[t>>2]|0;if((q|0)==0){aq=0}else{aq=JP(q,29912,30096,-1)|0}if((a[ad]&1)!=0){J2(c[u+8>>2]|0)}u=J0(16)|0;ad=v+8|0;c[ad>>2]=u;c[v>>2]=17;c[v+4>>2]=11;Kb(u|0,8704,11)|0;a[u+11|0]=0;u=(x=0,aK(88,b|0,v|0)|0);if(x){x=0;q=bQ(-1,-1)|0;t=q;q=K;if((a[v]&1)==0){af=t;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[ad>>2]|0);af=t;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}q=c[u>>2]|0;if((q|0)==0){au=0}else{au=JP(q,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[ad>>2]|0)}ad=w;v=w;a[v]=20;Kb(ad+1|0,8568,10)|0;a[ad+11|0]=0;ad=(x=0,aK(88,b|0,w|0)|0);if(x){x=0;q=bQ(-1,-1)|0;u=q;q=K;if((a[v]&1)==0){af=u;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[w+8>>2]|0);af=u;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}q=c[ad>>2]|0;if((q|0)==0){av=0}else{av=JP(q,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[w+8>>2]|0)}w=y;v=y;a[v]=12;q=w+1|0;a[q]=a[10864]|0;a[q+1|0]=a[10865]|0;a[q+2|0]=a[10866]|0;a[q+3|0]=a[10867]|0;a[q+4|0]=a[10868]|0;a[q+5|0]=a[10869]|0;a[w+7|0]=0;w=(x=0,aK(88,b|0,y|0)|0);if(x){x=0;q=bQ(-1,-1)|0;ad=q;q=K;if((a[v]&1)==0){af=ad;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[y+8>>2]|0);af=ad;ag=q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}q=c[w>>2]|0;if((q|0)==0){aw=0}else{aw=JP(q,29912,30096,-1)|0}if((a[v]&1)!=0){J2(c[y+8>>2]|0)}y=(al|0)!=0;al=(am|0)==0;am=(ao|0)!=0|(y|al^1);v=(aq|0)!=0;q=(au|0)==0;au=(av|0)!=0|(v|q^1);L102:do{if(am&au){w=J0(64)|0;ad=z+8|0;c[ad>>2]=w;c[z>>2]=65;c[z+4>>2]=57;Kb(w|0,3648,57)|0;a[w+57|0]=0;w=f;L104:do{if((a[w]&1)==0){u=A;c[u>>2]=c[w>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];ax=66}else{u=c[f+8>>2]|0;t=c[f+4>>2]|0;do{if(t>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(t>>>0<11>>>0){a[A]=t<<1;ay=A+1|0}else{s=t+16&-16;r=(x=0,as(230,s|0)|0);if(x){x=0;break}c[A+8>>2]=r;c[A>>2]=s|1;c[A+4>>2]=t;ay=r}Kb(ay|0,u|0,t)|0;a[ay+t|0]=0;ax=66;break L104}}while(0);t=bQ(-1,-1)|0;az=t;aA=K}}while(0);do{if((ax|0)==66){w=B;c[w>>2]=c[ae>>2];c[w+4>>2]=c[ae+4>>2];c[w+8>>2]=c[ae+8>>2];x=0;aP(362,z|0,A|0,B|0);if(x){x=0;w=bQ(-1,-1)|0;t=w;w=K;if((a[A]&1)==0){az=t;aA=w;break}J2(c[A+8>>2]|0);az=t;aA=w;break}if((a[A]&1)!=0){J2(c[A+8>>2]|0)}if((a[z]&1)==0){break L102}J2(c[ad>>2]|0);break L102}}while(0);if((a[z]&1)==0){af=az;ag=aA;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[ad>>2]|0);af=az;ag=aA;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}}while(0);if(am){am=J0(88)|0;c[o>>2]=am;aA=d+4|0;az=c[aA>>2]|0;if((az|0)==(c[d+8>>2]|0)){ee(d|0,o);aB=c[o>>2]|0}else{if((az|0)==0){aC=0}else{c[az>>2]=am;aC=c[aA>>2]|0}c[aA>>2]=aC+4;aB=am}am=aB;aC=aB;az=f;L142:do{if((a[az]&1)==0){o=D;c[o>>2]=c[az>>2];c[o+4>>2]=c[az+4>>2];c[o+8>>2]=c[az+8>>2];ax=92}else{o=c[f+8>>2]|0;z=c[f+4>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[D]=z<<1;aD=D+1|0}else{A=z+16&-16;B=(x=0,as(230,A|0)|0);if(x){x=0;break}c[D+8>>2]=B;c[D>>2]=A|1;c[D+4>>2]=z;aD=B}Kb(aD|0,o|0,z)|0;a[aD+z|0]=0;ax=92;break L142}}while(0);z=bQ(-1,-1)|0;aE=z;aF=K}}while(0);do{if((ax|0)==92){aD=E;c[aD>>2]=c[ae>>2];c[aD+4>>2]=c[ae+4>>2];c[aD+8>>2]=c[ae+8>>2];do{if(y){az=F;a[F]=8;z=az+1|0;C=1684369956;a[z]=C;C=C>>8;a[z+1|0]=C;C=C>>8;a[z+2|0]=C;C=C>>8;a[z+3|0]=C;a[az+5|0]=0;az=G;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];az=(x=0,an(2,F|0,b|0,e|0,f|0,G|0,+0.0,+255.0,j|0)|0);if(!x){aG=az+40|0;aH=1;ax=97;break}else{x=0;az=bQ(-1,-1)|0;aI=K;aJ=az;ax=142;break}}else{aG=ac+40|0;aH=0;ax=97}}while(0);L163:do{if((ax|0)==97){aL=+h[aG>>3];do{if(al){aM=ac+48|0;aN=0;ax=102}else{az=H;a[H]=12;z=az+1|0;a[z]=a[1128]|0;a[z+1|0]=a[1129]|0;a[z+2|0]=a[1130]|0;a[z+3|0]=a[1131]|0;a[z+4|0]=a[1132]|0;a[z+5|0]=a[1133]|0;a[az+7|0]=0;az=I;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];az=(x=0,an(2,H|0,b|0,e|0,f|0,I|0,+0.0,+255.0,j|0)|0);if(!x){aM=az+40|0;aN=1;ax=102;break}else{x=0;az=bQ(-1,-1)|0;aO=K;aQ=az;ax=139;break}}}while(0);L171:do{if((ax|0)==102){aR=+h[aM>>3];do{if((ao|0)==0){aS=ac+56|0;aT=0;ax=107}else{az=J;a[J]=10;z=az+1|0;a[z]=a[536]|0;a[z+1|0]=a[537]|0;a[z+2|0]=a[538]|0;a[z+3|0]=a[539]|0;a[z+4|0]=a[540]|0;a[az+6|0]=0;az=L;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];az=(x=0,an(2,J|0,b|0,e|0,f|0,L|0,+0.0,+255.0,j|0)|0);if(!x){aS=az+40|0;aT=1;ax=107;break}else{x=0;az=bQ(-1,-1)|0;aU=K;aV=az;ax=136;break}}}while(0);L179:do{if((ax|0)==107){aW=+h[aS>>3];do{if((aw|0)==0){aX=ac+64|0;aY=0;ax=112}else{az=M;a[M]=12;z=az+1|0;a[z]=a[10864]|0;a[z+1|0]=a[10865]|0;a[z+2|0]=a[10866]|0;a[z+3|0]=a[10867]|0;a[z+4|0]=a[10868]|0;a[z+5|0]=a[10869]|0;a[az+7|0]=0;az=N;c[az>>2]=c[ae>>2];c[az+4>>2]=c[ae+4>>2];c[az+8>>2]=c[ae+8>>2];az=(x=0,an(2,M|0,b|0,e|0,f|0,N|0,+0.0,+255.0,j|0)|0);if(!x){aX=az+40|0;aY=1;ax=112;break}else{x=0;az=bQ(-1,-1)|0;aZ=K;a_=az;ax=133;break}}}while(0);do{if((ax|0)==112){a$=+h[aX>>3];az=O;a[az]=0;a[O+1|0]=0;z=n;c[z>>2]=c[aD>>2];c[z+4>>2]=c[aD+4>>2];c[z+8>>2]=c[aD+8>>2];x=0;at(2,aC|0,D|0,n|0,+aL,+aR,+aW,+a$,O|0);if(x){x=0;z=bQ(-1,-1)|0;o=z;z=K;if((a[az]&1)==0){if(aY){aZ=z;a_=o;ax=133;break}else{a0=o;a1=z;break}}else{J2(c[O+8>>2]|0);if(aY){aZ=z;a_=o;ax=133;break}else{a0=o;a1=z;break}}}z=aB;if((a[az]&1)!=0){J2(c[O+8>>2]|0)}do{if(aY){if((a[M]&1)==0){break}J2(c[M+8>>2]|0)}}while(0);do{if(aT){if((a[J]&1)==0){break}J2(c[J+8>>2]|0)}}while(0);do{if(aN){if((a[H]&1)==0){break}J2(c[H+8>>2]|0)}}while(0);do{if(aH){if((a[F]&1)==0){break}J2(c[F+8>>2]|0)}}while(0);if((a[D]&1)==0){a2=z;i=k;return a2|0}J2(c[D+8>>2]|0);a2=z;i=k;return a2|0}}while(0);do{if((ax|0)==133){if((a[M]&1)==0){a0=a_;a1=aZ;break}J2(c[M+8>>2]|0);if(aT){aU=aZ;aV=a_;ax=136;break L179}else{a3=a_;a4=aZ;break L179}}}while(0);if(aT){aU=a1;aV=a0;ax=136}else{a3=a0;a4=a1}}}while(0);do{if((ax|0)==136){if((a[J]&1)==0){a3=aV;a4=aU;break}J2(c[J+8>>2]|0);if(aN){aO=aU;aQ=aV;ax=139;break L171}else{a5=aV;a6=aU;break L171}}}while(0);if(aN){aO=a4;aQ=a3;ax=139}else{a5=a3;a6=a4}}}while(0);do{if((ax|0)==139){if((a[H]&1)==0){a5=aQ;a6=aO;break}J2(c[H+8>>2]|0);if(aH){aI=aO;aJ=aQ;ax=142;break L163}else{a7=aQ;a8=aO;break L163}}}while(0);if(aH){aI=a6;aJ=a5;ax=142}else{a7=a5;a8=a6}}}while(0);do{if((ax|0)==142){if((a[F]&1)==0){a7=aJ;a8=aI;break}J2(c[F+8>>2]|0);a7=aJ;a8=aI}}while(0);if((a[D]&1)==0){aE=a7;aF=a8;break}J2(c[D+8>>2]|0);aE=a7;aF=a8}}while(0);a8=c[d>>2]|0;a7=c[aA>>2]|0;D=a8;while(1){if((D|0)==(a7|0)){a9=a7;break}if((c[D>>2]|0)==(aB|0)){a9=D;break}else{D=D+4|0}}D=a9-a8>>2;a9=a8+(D+1<<2)|0;aB=a7-a9|0;Kc(a8+(D<<2)|0,a9|0,aB|0)|0;a9=a8+((aB>>2)+D<<2)|0;D=c[aA>>2]|0;if((a9|0)!=(D|0)){c[aA>>2]=D+(~((D-4+(-a9|0)|0)>>>2)<<2)}J2(am);af=aE;ag=aF;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}if(au){oz(P,+h[ac+40>>3],+h[ac+48>>3],+h[ac+56>>3]);if(v){h[P>>3]=+((((~~+h[aq+40>>3]|0)%360|0)+360|0)%360|0|0)/360.0}do{if(!q){aq=J0(16)|0;v=Q+8|0;c[v>>2]=aq;c[Q>>2]=17;c[Q+4>>2]=11;Kb(aq|0,8704,11)|0;a[aq+11|0]=0;aq=R;c[aq>>2]=c[ae>>2];c[aq+4>>2]=c[ae+4>>2];c[aq+8>>2]=c[ae+8>>2];aq=(x=0,an(2,Q|0,b|0,e|0,f|0,R|0,+0.0,+100.0,j|0)|0);if(!x){h[P+8>>3]=+h[aq+40>>3];if((a[Q]&1)==0){break}J2(c[v>>2]|0);break}else{x=0}aq=bQ(-1,-1)|0;au=aq;aq=K;if((a[Q]&1)==0){af=au;ag=aq;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[v>>2]|0);af=au;ag=aq;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}}while(0);do{if((av|0)!=0){Q=S;R=S;a[R]=20;Kb(Q+1|0,8568,10)|0;a[Q+11|0]=0;Q=T;c[Q>>2]=c[ae>>2];c[Q+4>>2]=c[ae+4>>2];c[Q+8>>2]=c[ae+8>>2];Q=(x=0,an(2,S|0,b|0,e|0,f|0,T|0,+0.0,+100.0,j|0)|0);if(!x){h[P+16>>3]=+h[Q+40>>3];if((a[R]&1)==0){break}J2(c[S+8>>2]|0);break}else{x=0}Q=bQ(-1,-1)|0;q=Q;Q=K;if((a[R]&1)==0){af=q;ag=Q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[S+8>>2]|0);af=q;ag=Q;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}}while(0);do{if((aw|0)==0){ba=+h[ac+64>>3]}else{S=U;T=U;a[T]=12;av=S+1|0;a[av]=a[10864]|0;a[av+1|0]=a[10865]|0;a[av+2|0]=a[10866]|0;a[av+3|0]=a[10867]|0;a[av+4|0]=a[10868]|0;a[av+5|0]=a[10869]|0;a[S+7|0]=0;S=V;c[S>>2]=c[ae>>2];c[S+4>>2]=c[ae+4>>2];c[S+8>>2]=c[ae+8>>2];S=(x=0,an(2,U|0,b|0,e|0,f|0,V|0,+0.0,+1.0,j|0)|0);if(!x){aL=+h[S+40>>3];if((a[T]&1)==0){ba=aL;break}J2(c[U+8>>2]|0);ba=aL;break}else{x=0}S=bQ(-1,-1)|0;av=S;S=K;if((a[T]&1)==0){af=av;ag=S;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[U+8>>2]|0);af=av;ag=S;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}}while(0);aL=+h[P>>3];aR=+h[P+8>>3];aW=+h[P+16>>3];P=W;c[P>>2]=c[ae>>2];c[P+4>>2]=c[ae+4>>2];c[P+8>>2]=c[ae+8>>2];a2=oA(aL,aR,aW,ba,d,f,W)|0;i=k;return a2|0}if((aw|0)==0){aw=J0(48)|0;W=$+8|0;c[W>>2]=aw;c[$>>2]=49;c[$+4>>2]=39;Kb(aw|0,3504,39)|0;a[aw+39|0]=0;aw=f;L288:do{if((a[aw]&1)==0){P=aa;c[P>>2]=c[aw>>2];c[P+4>>2]=c[aw+4>>2];c[P+8>>2]=c[aw+8>>2];ax=222}else{P=c[f+8>>2]|0;U=c[f+4>>2]|0;do{if(U>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(U>>>0<11>>>0){a[aa]=U<<1;bb=aa+1|0}else{V=U+16&-16;S=(x=0,as(230,V|0)|0);if(x){x=0;break}c[aa+8>>2]=S;c[aa>>2]=V|1;c[aa+4>>2]=U;bb=S}Kb(bb|0,P|0,U)|0;a[bb+U|0]=0;ax=222;break L288}}while(0);U=bQ(-1,-1)|0;bc=U;bd=K}}while(0);do{if((ax|0)==222){bb=ab;c[bb>>2]=c[ae>>2];c[bb+4>>2]=c[ae+4>>2];c[bb+8>>2]=c[ae+8>>2];x=0;aP(362,$|0,aa|0,ab|0);if(x){x=0;bb=bQ(-1,-1)|0;aw=bb;bb=K;if((a[aa]&1)==0){bc=aw;bd=bb;break}J2(c[aa+8>>2]|0);bc=aw;bd=bb;break}if((a[aa]&1)!=0){J2(c[aa+8>>2]|0)}if((a[$]&1)!=0){J2(c[W>>2]|0)}a2=ac|0;i=k;return a2|0}}while(0);if((a[$]&1)==0){af=bc;ag=bd;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[W>>2]|0);af=bc;ag=bd;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}bd=X;bc=X;a[bc]=12;W=bd+1|0;a[W]=a[10864]|0;a[W+1|0]=a[10865]|0;a[W+2|0]=a[10866]|0;a[W+3|0]=a[10867]|0;a[W+4|0]=a[10868]|0;a[W+5|0]=a[10869]|0;a[bd+7|0]=0;bd=Y;c[bd>>2]=c[ae>>2];c[bd+4>>2]=c[ae+4>>2];c[bd+8>>2]=c[ae+8>>2];bd=(x=0,an(2,X|0,b|0,e|0,f|0,Y|0,+0.0,+1.0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;Y=j;j=K;if((a[bc]&1)==0){af=Y;ag=j;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}J2(c[X+8>>2]|0);af=Y;ag=j;ah=af;ai=0;aj=ah;ak=ag;be(aj|0)}ba=+h[bd+40>>3];if((a[bc]&1)!=0){J2(c[X+8>>2]|0)}X=J0(88)|0;c[l>>2]=X;bc=d+4|0;bd=c[bc>>2]|0;if((bd|0)==(c[d+8>>2]|0)){ee(d|0,l);bf=c[l>>2]|0}else{if((bd|0)==0){bg=0}else{c[bd>>2]=X;bg=c[bc>>2]|0}c[bc>>2]=bg+4;bf=X}X=bf;bg=bf;bd=f;L337:do{if((a[bd]&1)==0){l=Z;c[l>>2]=c[bd>>2];c[l+4>>2]=c[bd+4>>2];c[l+8>>2]=c[bd+8>>2];ax=194}else{l=c[f+8>>2]|0;j=c[f+4>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){a[Z]=j<<1;bh=Z+1|0}else{Y=j+16&-16;e=(x=0,as(230,Y|0)|0);if(x){x=0;break}c[Z+8>>2]=e;c[Z>>2]=Y|1;c[Z+4>>2]=j;bh=e}Kb(bh|0,l|0,j)|0;a[bh+j|0]=0;ax=194;break L337}}while(0);j=bQ(-1,-1)|0;bi=j;bj=K}}while(0);do{if((ax|0)==194){bh=m;c[bh>>2]=c[ae>>2];c[bh+4>>2]=c[ae+4>>2];c[bh+8>>2]=c[ae+8>>2];aW=+h[ac+40>>3];aR=+h[ac+48>>3];aL=+h[ac+56>>3];bh=_;a[bh]=0;a[_+1|0]=0;x=0;at(2,bg|0,Z|0,m|0,+aW,+aR,+aL,+ba,_|0);if(x){x=0;f=bQ(-1,-1)|0;bd=f;f=K;if((a[bh]&1)!=0){J2(c[_+8>>2]|0)}if((a[Z]&1)==0){bi=bd;bj=f;break}J2(c[Z+8>>2]|0);bi=bd;bj=f;break}if((a[bh]&1)!=0){J2(c[_+8>>2]|0)}bh=bf;if((a[Z]&1)==0){a2=bh;i=k;return a2|0}J2(c[Z+8>>2]|0);a2=bh;i=k;return a2|0}}while(0);a2=c[d>>2]|0;d=c[bc>>2]|0;k=a2;while(1){if((k|0)==(d|0)){bk=d;break}if((c[k>>2]|0)==(bf|0)){bk=k;break}else{k=k+4|0}}k=bk-a2>>2;bk=a2+(k+1<<2)|0;bf=d-bk|0;Kc(a2+(k<<2)|0,bk|0,bf|0)|0;bk=a2+((bf>>2)+k<<2)|0;k=c[bc>>2]|0;if((bk|0)!=(k|0)){c[bc>>2]=k+(~((k-4+(-bk|0)|0)>>>2)<<2)}J2(X);af=bi;ag=bj;ah=af;ai=0;aj=ah;ak=ag;be(aj|0);return 0}
function c0(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function c1(){return i|0}function c2(a){a=a|0;i=a}function c3(a,b){a=a|0;b=b|0;if((x|0)==0){x=a;y=b}}function c4(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function c5(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function c6(a){a=a|0;K=a}function c7(a){a=a|0;L=a}function c8(a){a=a|0;M=a}function c9(a){a=a|0;N=a}function da(a){a=a|0;O=a}function db(a){a=a|0;P=a}function dc(a){a=a|0;Q=a}function dd(a){a=a|0;R=a}function de(a){a=a|0;S=a}function df(a){a=a|0;T=a}function dg(){c[7012]=p+8;c[7014]=p+8;c[7016]=t+8;c[7020]=t+8;c[7024]=t+8;c[7028]=t+8;c[7032]=t+8;c[7036]=t+8;c[7040]=p+8;c[7074]=t+8;c[7078]=t+8;c[7142]=t+8;c[7146]=t+8;c[7166]=p+8;c[7168]=t+8;c[7204]=t+8;c[7208]=t+8;c[7244]=t+8;c[7248]=t+8;c[7268]=p+8;c[7270]=p+8;c[7272]=p+8;c[7274]=t+8;c[7278]=t+8;c[7282]=t+8;c[7286]=t+8;c[7290]=t+8;c[7294]=p+8;c[7296]=p+8;c[7298]=p+8;c[7308]=t+8;c[7312]=p+8;c[7314]=p+8;c[7316]=p+8;c[7318]=p+8;c[7344]=t+8;c[7348]=t+8;c[7352]=p+8;c[7360]=t+8;c[7364]=t+8;c[7368]=t+8;c[7372]=p+8;c[7374]=p+8;c[7376]=p+8;c[7378]=p+8;c[7412]=p+8;c[7414]=p+8;c[7416]=p+8;c[7418]=t+8;c[7422]=t+8;c[7426]=t+8;c[7430]=t+8;c[7434]=t+8;c[7438]=p+8;c[7440]=p+8;c[7442]=p+8;c[7444]=p+8;c[7446]=p+8;c[7448]=p+8;c[7450]=t+8;c[7454]=t+8;c[7466]=t+8;c[7470]=t+8;c[7474]=t+8;c[7478]=p+8;c[7480]=t+8;c[7484]=t+8;c[7488]=t+8;c[7492]=t+8;c[7496]=t+8;c[7500]=t+8;c[7504]=t+8;c[7508]=t+8;c[7512]=t+8;c[7516]=t+8;c[7520]=t+8;c[7524]=t+8;c[7528]=t+8;c[7532]=t+8;c[7536]=t+8;c[7540]=t+8;c[7544]=p+8;c[7546]=t+8;c[7558]=t+8;c[7562]=t+8;c[7574]=t+8;c[7578]=t+8;c[7582]=t+8;c[7586]=t+8;c[7590]=t+8;c[7594]=t+8;c[7598]=t+8;c[7602]=t+8;c[7606]=t+8;c[7610]=t+8;c[7614]=t+8;c[7626]=t+8;c[7630]=t+8;c[7634]=t+8;c[7638]=t+8;c[7642]=t+8;c[7646]=t+8;c[7650]=t+8;c[7654]=t+8;c[7658]=t+8;c[7662]=t+8;c[7666]=t+8;c[7670]=t+8;c[7674]=t+8;c[7678]=t+8;c[7682]=t+8;c[7686]=t+8;c[7690]=t+8;c[7694]=t+8;c[7714]=t+8;c[7718]=t+8;c[7722]=t+8;c[7734]=t+8;c[7738]=t+8;c[7742]=t+8;c[7746]=p+8;c[7748]=p+8;c[7750]=p+8;c[7752]=p+8;c[7754]=p+8;c[7756]=p+8;c[7758]=p+8;c[7768]=t+8;c[7772]=t+8;c[7776]=t+8;c[7780]=t+8;c[7784]=t+8;c[7788]=t+8;c[7792]=t+8;c[7796]=t+8}function dh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+24|0;Ac(f,0);j=f|0;x=0;aP(c[(c[b>>2]|0)+28>>2]|0,g|0,b|0,j|0);do{if(!x){x=0;aP(c[(c[d>>2]|0)+28>>2]|0,h|0,d|0,j|0);if(x){x=0;b=bQ(-1,-1)|0;k=b;b=K;if((a[g]&1)==0){l=b;m=k;break}J2(c[g+8>>2]|0);l=b;m=k;break}k=g;b=a[k]|0;n=b&255;if((n&1|0)==0){o=n>>>1}else{o=c[g+4>>2]|0}n=a[h]|0;p=n&255;if((p&1|0)==0){q=p>>>1}else{q=c[h+4>>2]|0}if((b&1)==0){r=g+1|0}else{r=c[g+8>>2]|0}p=(n&1)==0;if(p){s=h+1|0}else{s=c[h+8>>2]|0}n=Kd(r|0,s|0,(q>>>0<o>>>0?q:o)|0)|0;t=(n|0)==0?o>>>0<q>>>0:(n|0)<0;if(p){u=b}else{J2(c[h+8>>2]|0);u=a[k]|0}if((u&1)==0){Ae(f);i=e;return t|0}J2(c[g+8>>2]|0);Ae(f);i=e;return t|0}else{x=0;t=bQ(-1,-1)|0;l=K;m=t}}while(0);x=0;ap(436,f|0);if(!x){be(m|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function di(a){a=a|0;var b=0;b=a;while(1){a=c[b+40>>2]|0;if((a|0)==0){break}else{b=a}}return c[b+36>>2]|0}function dj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+56|0;f=e|0;g=e+16|0;h=e+24|0;j=e+40|0;k=b+40|0;l=c[k>>2]|0;if((l|0)==0){m=0;i=e;return m|0}n=b+36|0;if((c[n>>2]|0)==0){m=dj(l,d)|0;i=e;return m|0}l=J0(44)|0;c[g>>2]=l;o=d+4|0;p=c[o>>2]|0;if((p|0)==(c[d+8>>2]|0)){ee(d|0,g);q=c[g>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=l;r=c[o>>2]|0}c[o>>2]=r+4;q=l}l=q;r=q;p=b+4|0;L15:do{if((a[p]&1)==0){g=h;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];s=19}else{g=c[b+12>>2]|0;t=c[b+8>>2]|0;do{if(t>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(t>>>0<11>>>0){a[h]=t<<1;u=h+1|0}else{v=t+16&-16;w=(x=0,as(230,v|0)|0);if(x){x=0;break}c[h+8>>2]=w;c[h>>2]=v|1;c[h+4>>2]=t;u=w}Kb(u|0,g|0,t)|0;a[u+t|0]=0;s=19;break L15}}while(0);t=bQ(-1,-1)|0;y=K;z=t}}while(0);do{if((s|0)==19){u=j;p=b+16|0;c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];p=c[b+32>>2]|0;t=c[n>>2]|0;g=(x=0,aK(50,c[k>>2]|0,d|0)|0);do{if(!x){w=f;c[w>>2]=c[u>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];x=0;aB(18,r|0,h|0,f|0,p|0,t|0,g|0);if(x){x=0;break}if((a[h]&1)==0){m=r;i=e;return m|0}J2(c[h+8>>2]|0);m=r;i=e;return m|0}else{x=0}}while(0);g=bQ(-1,-1)|0;t=g;g=K;if((a[h]&1)==0){y=g;z=t;break}J2(c[h+8>>2]|0);y=g;z=t}}while(0);h=c[d>>2]|0;d=c[o>>2]|0;m=h;while(1){if((m|0)==(d|0)){A=d;break}if((c[m>>2]|0)==(q|0)){A=m;break}else{m=m+4|0}}m=A-h>>2;A=h+(m+1<<2)|0;q=d-A|0;Kc(h+(m<<2)|0,A|0,q|0)|0;A=h+((q>>2)+m<<2)|0;m=c[o>>2]|0;if((A|0)==(m|0)){J2(l);B=z;C=0;D=B;E=y;be(D|0)}c[o>>2]=m+(~((m-4+(-A|0)|0)>>>2)<<2);J2(l);B=z;C=0;D=B;E=y;be(D|0);return 0}function dk(a){a=a|0;var b=0;b=a;while(1){a=c[b+40>>2]|0;if((a|0)==0){break}else{b=a}}return b|0}function dl(a){a=a|0;return 0}function dm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;if((a[b+29|0]&1)==0){d=0;return d|0}e=c[b+36>>2]|0;f=(c[b+40>>2]|0)-e>>2;b=0;while(1){if(b>>>0>=f>>>0){d=0;g=8;break}h=c[e+(b<<2)>>2]|0;if((a[h+29|0]&1)==0){b=b+1|0}else{break}}if((g|0)==8){return d|0}d=cA[c[(c[h>>2]|0)+36>>2]&511](h)|0;return d|0}function dn(b){b=b|0;var d=0,e=0;if((a[b+29|0]&1)==0){d=0;return d|0}e=c[b+36>>2]|0;do{if((e|0)!=0){if((a[e+29|0]&1)==0){break}d=cA[c[(c[e>>2]|0)+36>>2]&511](e)|0;return d|0}}while(0);e=c[b+40>>2]|0;if((e|0)==0){d=0;return d|0}if((a[e+29|0]&1)==0){d=0;return d|0}d=cA[c[(c[e>>2]|0)+36>>2]&511](e)|0;return d|0}function dp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;if((a[b+29|0]&1)==0){d=0;return d|0}e=c[b+36>>2]|0;f=(c[b+40>>2]|0)-e>>2;b=0;while(1){if(b>>>0>=f>>>0){d=0;g=8;break}h=c[e+(b<<2)>>2]|0;if((a[h+29|0]&1)==0){b=b+1|0}else{break}}if((g|0)==8){return d|0}d=cA[c[(c[h>>2]|0)+36>>2]&511](h|0)|0;return d|0}function dq(a){a=a|0;return a|0}function dr(a,b){a=a|0;b=b|0;cy[c[c[b>>2]>>2]&1023](b,a);return}function ds(a,b){a=a|0;b=b|0;return cS[c[c[b>>2]>>2]&1023](b,a)|0}function dt(a,b){a=a|0;b=b|0;return cS[c[c[b>>2]>>2]&1023](b,a)|0}function du(a,b){a=a|0;b=b|0;return cS[c[c[b>>2]>>2]&1023](b,a)|0}function dv(a,b){a=a|0;b=b|0;return cS[c[c[b>>2]>>2]&1023](b,a)|0}function dw(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[c[d>>2]>>2]&511](a,d,b);return}function dx(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[c[d>>2]>>2]&511](a,d,b);return}function dy(b){b=b|0;var d=0;d=b|0;c[d>>2]=19280;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function dz(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=19280;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function dA(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+176>>2]&1023](b,a);return}function dB(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+176>>2]&1023](b,a)|0}function dC(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+176>>2]&1023](b,a)|0}function dD(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+176>>2]&1023](b,a)|0}function dE(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+176>>2]&1023](b,a)|0}function dF(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+176>>2]&511](a,d,b);return}function dG(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+176>>2]&511](a,d,b);return}function dH(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+32>>2]=21584;d=c[b+36>>2]|0;e=d;if((d|0)!=0){f=b+40|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function dI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+32>>2]=21584;d=c[b+36>>2]|0;e=d;if((d|0)!=0){f=b+40|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){h=b;J2(h);return}J2(c[b+12>>2]|0);h=b;J2(h);return}function dJ(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+200>>2]&1023](b,a);return}function dK(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+200>>2]&1023](b,a)|0}function dL(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+200>>2]&1023](b,a)|0}function dM(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+200>>2]&1023](b,a)|0}function dN(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+200>>2]&1023](b,a)|0}function dO(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+200>>2]&511](a,d,b);return}function dP(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+200>>2]&511](a,d,b);return}function dQ(b,c){b=b|0;c=c|0;if((a[c+28|0]&1)!=0){a[b+28|0]=1}if((a[c+29|0]&1)==0){return}a[b+29|0]=1;return}function dR(b,c){b=b|0;c=c|0;var d=0;d=b-48+16|0;if((a[c+28|0]&1)!=0){a[d+28|0]=1}if((a[c+29|0]&1)==0){return}a[d+29|0]=1;return}function dS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-48+16|0;c[d+32>>2]=21584;e=c[d+36>>2]|0;f=e;if((e|0)!=0){g=d+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}J2(e)}c[d>>2]=16616;if((a[b-48+20|0]&1)==0){return}J2(c[d+12>>2]|0);return}function dT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b-48+16|0;c[d+32>>2]=21584;e=c[d+36>>2]|0;f=e;if((e|0)!=0){g=d+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}J2(e)}c[d>>2]=16616;if((a[b-48+20|0]&1)==0){i=d;J2(i);return}J2(c[d+12>>2]|0);i=d;J2(i);return}function dU(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function dV(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function dW(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+204>>2]&1023](b,a);return}function dX(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+204>>2]&1023](b,a)|0}function dY(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+204>>2]&1023](b,a)|0}function dZ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+204>>2]&1023](b,a)|0}function d_(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+204>>2]&1023](b,a)|0}function d$(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+204>>2]&511](a,d,b);return}function d0(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+204>>2]&511](a,d,b);return}function d1(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+32>>2]=21552;d=c[b+36>>2]|0;e=d;if((d|0)!=0){f=b+40|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function d2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+32>>2]=21552;d=c[b+36>>2]|0;e=d;if((d|0)!=0){f=b+40|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){h=b;J2(h);return}J2(c[b+12>>2]|0);h=b;J2(h);return}function d3(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+208>>2]&1023](b,a);return}function d4(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+208>>2]&1023](b,a)|0}function d5(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+208>>2]&1023](b,a)|0}function d6(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+208>>2]&1023](b,a)|0}function d7(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+208>>2]&1023](b,a)|0}function d8(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+208>>2]&511](a,d,b);return}function d9(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+208>>2]&511](a,d,b);return}function ea(b,c){b=b|0;c=c|0;if((a[c+28|0]&1)!=0){a[b+28|0]=1}if((a[c+29|0]&1)==0){return}a[b+29|0]=1;return}function eb(b,c){b=b|0;c=c|0;var d=0;d=b-48+16|0;if((a[c+28|0]&1)!=0){a[d+28|0]=1}if((a[c+29|0]&1)==0){return}a[d+29|0]=1;return}function ec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-48+16|0;c[d+32>>2]=21552;e=c[d+36>>2]|0;f=e;if((e|0)!=0){g=d+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}J2(e)}c[d>>2]=16616;if((a[b-48+20|0]&1)==0){return}J2(c[d+12>>2]|0);return}function ed(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b-48+16|0;c[d+32>>2]=21552;e=c[d+36>>2]|0;f=e;if((e|0)!=0){g=d+40|0;h=c[g>>2]|0;if((e|0)!=(h|0)){c[g>>2]=h+(~((h-4+(-f|0)|0)>>>2)<<2)}J2(e)}c[d>>2]=16616;if((a[b-48+20|0]&1)==0){i=d;J2(i);return}J2(c[d+12>>2]|0);i=d;J2(i);return}function ee(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function ef(a,b){a=a|0;b=b|0;return}function eg(a,b){a=a|0;b=b|0;return}function eh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=J0(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];x=0;ao(20,m|0,k|0,l|0,0,0);if(x){x=0;l=bQ(-1,-1)|0;if((a[k]&1)==0){be(l|0)}J2(c[k+8>>2]|0);be(l|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}c[b>>2]=20088;c[b+32>>2]=f;c[b+36>>2]=g;c[b+40>>2]=h;f=(g|0)!=0;if(f){if((a[g+28|0]&1)==0){r=14}else{r=16}}else{r=14}do{if((r|0)==14){if((h|0)==0){break}if((a[h+28|0]&1)!=0){r=16}}}while(0);if((r|0)==16){a[b+28|0]=1}if(f){if((a[g+29|0]&1)==0){r=21}}else{r=21}do{if((r|0)==21){if((h|0)==0){i=j;return}if((a[h+29|0]&1)!=0){break}i=j;return}}while(0);a[b+29|0]=1;i=j;return}function ei(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=d;if((a[l]&1)==0){m=k;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];n=a[m]|0;o=m}else{m=c[d+8>>2]|0;l=c[d+4>>2]|0;if(l>>>0>4294967279>>>0){CJ(0)}if(l>>>0<11>>>0){d=l<<1&255;p=k;a[p]=d;q=k+1|0;r=d;s=p}else{p=l+16&-16;d=J0(p)|0;c[k+8>>2]=d;t=p|1;c[k>>2]=t;c[k+4>>2]=l;q=d;r=t&255;s=k}Kb(q|0,m|0,l)|0;a[q+l|0]=0;n=r;o=s}s=e;e=j;c[e>>2]=c[s>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];s=j;j=b|0;c[j>>2]=16616;e=b+4|0;L12:do{if((n&1)==0){r=e;c[r>>2]=c[o>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2]}else{r=c[k+8>>2]|0;l=c[k+4>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(l>>>0<11>>>0){a[e]=l<<1;u=e+1|0}else{q=l+16&-16;m=(x=0,as(230,q|0)|0);if(x){x=0;break}c[b+12>>2]=m;c[e>>2]=q|1;c[b+8>>2]=l;u=m}Kb(u|0,r|0,l)|0;a[u+l|0]=0;break L12}}while(0);l=bQ(-1,-1)|0;if((a[o]&1)==0){be(l|0)}J2(r);be(l|0)}}while(0);u=b+16|0;c[u>>2]=c[s>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];if((a[o]&1)==0){c[j>>2]=16488;v=b+28|0;w=f&1;a[v]=w;y=b+29|0;z=g&1;a[y]=z;i=h;return}J2(c[k+8>>2]|0);c[j>>2]=16488;v=b+28|0;w=f&1;a[v]=w;y=b+29|0;z=g&1;a[y]=z;i=h;return}function ej(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ee=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0,eo=0,eq=0,er=0,es=0,eu=0,ev=0,ew=0,ex=0,ey=0,ez=0,eA=0,eB=0,eC=0,eD=0,eE=0,eF=0,eG=0,eH=0,eI=0,eJ=0,eL=0,eM=0,eN=0,eO=0,eP=0,eQ=0,eR=0,eS=0,eT=0,eU=0,eV=0,eW=0,eX=0,eY=0,eZ=0,e_=0,e$=0,e0=0,e1=0,e2=0,e3=0,e4=0,e5=0,e6=0,e7=0,e8=0,e9=0,fa=0,fb=0,fc=0,fd=0,fe=0,ff=0,fg=0,fh=0,fi=0,fj=0,fk=0,fl=0,fm=0,fn=0,fo=0,fp=0,fq=0,fr=0,fs=0,ft=0,fu=0,fv=0,fw=0,fx=0,fy=0,fz=0,fA=0,fB=0,fC=0,fD=0,fE=0,fF=0,fG=0,fH=0,fI=0,fJ=0,fK=0,fL=0,fM=0,fN=0,fO=0,fP=0,fQ=0,fR=0,fS=0,fT=0,fU=0,fV=0,fW=0,fX=0,fY=0,fZ=0,f_=0,f$=0,f0=0,f1=0,f2=0,f3=0,f4=0,f5=0,f6=0,f7=0,f8=0,f9=0,ga=0,gb=0,gc=0,gd=0,ge=0,gf=0,gg=0,gh=0,gi=0,gj=0,gk=0,gl=0,gm=0,gn=0,go=0,gp=0,gq=0,gr=0,gs=0,gt=0,gu=0,gv=0,gw=0,gx=0,gy=0,gz=0,gA=0,gB=0,gC=0,gD=0,gE=0,gF=0,gG=0,gH=0,gI=0,gJ=0,gK=0,gL=0,gM=0,gN=0,gO=0,gP=0,gQ=0,gR=0,gS=0,gT=0,gU=0,gV=0,gW=0,gX=0,gY=0,gZ=0,g_=0,g$=0,g0=0,g1=0,g2=0,g3=0,g4=0,g5=0,g6=0,g7=0,g8=0,g9=0,ha=0,hb=0,hc=0,hd=0,he=0,hf=0,hg=0,hh=0,hi=0,hj=0,hk=0,hl=0,hm=0,hn=0,ho=0,hp=0,hq=0,hr=0,hs=0,ht=0,hu=0,hv=0,hw=0,hx=0,hy=0,hz=0,hA=0,hB=0;j=i;i=i+80|0;k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;o=j+48|0;p=j+56|0;q=j+64|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=s;u=i;i=i+12|0;i=i+7&-8;v=u;w=i;i=i+12|0;i=i+7&-8;y=w;z=i;i=i+12|0;i=i+7&-8;A=z;B=i;i=i+12|0;i=i+7&-8;C=B;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+144|0;G=i;i=i+12|0;i=i+7&-8;H=i;i=i+12|0;i=i+7&-8;I=i;i=i+12|0;i=i+7&-8;J=i;i=i+12|0;i=i+7&-8;L=i;i=i+12|0;i=i+7&-8;M=i;i=i+12|0;i=i+7&-8;N=i;i=i+12|0;i=i+7&-8;O=i;i=i+12|0;i=i+7&-8;P=i;i=i+12|0;i=i+7&-8;Q=i;i=i+12|0;i=i+7&-8;R=i;i=i+12|0;i=i+7&-8;S=i;i=i+144|0;T=i;i=i+12|0;i=i+7&-8;U=i;i=i+12|0;i=i+7&-8;V=i;i=i+12|0;i=i+7&-8;W=i;i=i+12|0;i=i+7&-8;X=i;i=i+12|0;i=i+7&-8;Y=i;i=i+12|0;i=i+7&-8;Z=i;i=i+12|0;i=i+7&-8;_=i;i=i+12|0;i=i+7&-8;$=i;i=i+12|0;i=i+7&-8;aa=i;i=i+144|0;ab=i;i=i+12|0;i=i+7&-8;ac=i;i=i+12|0;i=i+7&-8;ad=i;i=i+12|0;i=i+7&-8;ae=i;i=i+12|0;i=i+7&-8;af=i;i=i+12|0;i=i+7&-8;ag=i;i=i+144|0;ah=i;i=i+12|0;i=i+7&-8;ai=i;i=i+12|0;i=i+7&-8;aj=i;i=i+12|0;i=i+7&-8;ak=i;i=i+12|0;i=i+7&-8;al=i;i=i+12|0;i=i+7&-8;am=i;i=i+144|0;an=i;i=i+12|0;i=i+7&-8;ao=i;i=i+12|0;i=i+7&-8;ar=i;i=i+12|0;i=i+7&-8;at=i;i=i+12|0;i=i+7&-8;au=i;i=i+12|0;i=i+7&-8;av=i;i=i+8|0;aw=i;i=i+12|0;i=i+7&-8;ay=i;i=i+12|0;i=i+7&-8;az=i;i=i+12|0;i=i+7&-8;aA=i;i=i+12|0;i=i+7&-8;aC=i;i=i+144|0;aD=i;i=i+12|0;i=i+7&-8;aE=i;i=i+12|0;i=i+7&-8;aF=i;i=i+12|0;i=i+7&-8;aG=i;i=i+12|0;i=i+7&-8;aH=D|0;aI=D+4|0;c[aI>>2]=0;c[D+8>>2]=0;c[D>>2]=aI;aI=d+36|0;aJ=c[aI>>2]|0;aL=d+32|0;d=c[aL>>2]|0;aM=aJ-d>>2;do{if((aM|0)==0){aN=aJ;aO=d;aQ=27}else{aR=E;aS=E+8|0;aT=E+1|0;aU=E|0;aV=E+4|0;aW=0;aX=d;while(1){aY=c[aX+(aW<<2)>>2]|0;aZ=aY+28|0;if((a[aZ]&1)==0){c[aR>>2]=c[aZ>>2];c[aR+4>>2]=c[aZ+4>>2];c[aR+8>>2]=c[aZ+8>>2]}else{aZ=c[aY+36>>2]|0;a_=c[aY+32>>2]|0;if(a_>>>0>4294967279>>>0){aQ=6;break}if(a_>>>0<11>>>0){a[aR]=a_<<1;a$=aT}else{a0=a_+16&-16;a1=(x=0,as(230,a0|0)|0);if(x){x=0;aQ=21;break}c[aS>>2]=a1;c[aU>>2]=a0|1;c[aV>>2]=a_;a$=a1}Kb(a$|0,aZ|0,a_)|0;a[a$+a_|0]=0}a_=(x=0,aK(142,D|0,E|0)|0);if(x){x=0;aQ=24;break}c[a_>>2]=aY;if((a[aR]&1)!=0){J2(c[aS>>2]|0)}aY=aW+1|0;if(aY>>>0>=aM>>>0){aQ=26;break}aW=aY;aX=c[aL>>2]|0}if((aQ|0)==26){aN=c[aI>>2]|0;aO=c[aL>>2]|0;aQ=27;break}else if((aQ|0)==21){aX=bQ(-1,-1)|0;a2=K;a3=aX;break}else if((aQ|0)==24){aX=bQ(-1,-1)|0;aW=aX;aX=K;if((a[aR]&1)==0){a4=aX;a5=aW;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[aS>>2]|0);a4=aX;a5=aW;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==6){x=0;ap(232,0);if(x){x=0;aQ=22;break}}}}while(0);L30:do{if((aQ|0)==27){aI=aN-aO>>2;aM=e+40|0;E=(c[e+44>>2]|0)-(c[aM>>2]|0)>>2;L32:do{if((E|0)==0){bd=0;aQ=30}else{a$=Z;d=$;aJ=aa+64|0;aW=aJ|0;aX=aa|0;aV=aa+8|0;aU=aV|0;aT=aa+12|0;aY=aa+64|0;a_=aa+4|0;aZ=aT;a1=aa+8|0;a0=aT|0;bf=aa+16|0;bg=aa+20|0;bh=aa+60|0;bi=aV;aV=ab;bj=ad;bk=ae;bl=ac;bm=aa+12|0;bn=aa+44|0;bo=aa+64|0;bp=aa+52|0;bq=ac+8|0;br=ad+8|0;bs=ad+1|0;bt=ad|0;bu=ad+4|0;bv=ab+8|0;bw=ab+1|0;bx=ab|0;by=ab+4|0;bz=w+8|0;bA=af;bB=al;bC=g|0;bD=g|0;bE=au;bF=au+8|0;bG=au+1|0;bH=au|0;bI=au+4|0;bJ=am+64|0;bK=bJ|0;bL=am|0;bM=am+8|0;bN=bM|0;bO=am+12|0;bP=am+64|0;bR=am+4|0;bS=bO;bT=am+8|0;bV=bO|0;bW=am+16|0;bX=am+20|0;bY=am+60|0;bZ=bM;bM=an;b_=ar;b$=at;b0=ao;b1=am+12|0;b2=am+44|0;b3=am+64|0;b4=am+52|0;b5=ao+8|0;b6=ar+8|0;b7=ar+1|0;b8=ar|0;b9=ar+4|0;ca=an+8|0;cb=an+1|0;cc=an|0;cd=an+4|0;ce=s+8|0;cf=al+8|0;cg=al+1|0;ch=al|0;ci=al+4|0;cj=ag+64|0;ck=cj|0;cl=ag|0;cm=ag+8|0;cn=cm|0;co=ag+12|0;cp=ag+64|0;cq=ag+4|0;cr=co;cs=ag+8|0;ct=co|0;cu=ag+16|0;cv=ag+20|0;cw=ag+60|0;cx=cm;cm=ah;cy=aj;cz=ak;cA=ai;cB=ag+12|0;cC=ag+44|0;cD=ag+64|0;cE=ag+52|0;cF=ai+8|0;cG=aj+8|0;cH=aj+1|0;cI=aj|0;cJ=aj+4|0;cK=ah+8|0;cL=ah+1|0;cM=ah|0;cN=ah+4|0;cO=u+8|0;cP=af+8|0;cQ=af+1|0;cR=af|0;cS=af+4|0;cT=$+8|0;cU=$+1|0;cV=$|0;cW=$+4|0;cX=Z+8|0;cY=Z+4|0;cZ=Z+1|0;c_=Z|0;c$=N;c0=f+4|0;c1=f+8|0;c2=f|0;c3=O;c4=P;c5=P+8|0;c6=P+1|0;c7=P|0;c8=P+4|0;c9=O+8|0;da=O+1|0;db=O|0;dc=O+4|0;dd=Q;de=Q+8|0;df=Q+1|0;dg=Q|0;dh=Q+4|0;di=N+8|0;dj=N+1|0;dk=N|0;dl=N+4|0;dm=F+64|0;dn=dm|0;dp=F|0;dq=F+8|0;dr=dq|0;ds=F+12|0;dt=F+64|0;du=F+4|0;dv=ds;dw=F+8|0;dx=ds|0;dy=F+16|0;dz=F+20|0;dA=F+60|0;dB=dq;dq=e+4|0;dC=H;dD=I;dE=e+16|0;dF=G;dG=F+12|0;dH=F+44|0;dI=F+64|0;dJ=F+52|0;dK=G+8|0;dL=H+8|0;dM=e+12|0;dN=e+8|0;dO=H+1|0;dP=H|0;dQ=H+4|0;dR=B+8|0;dS=_;dT=_+8|0;dU=_+1|0;dV=_|0;dW=_+4|0;dX=R;dY=aI-1|0;dZ=X;d_=X+8|0;d$=X+1|0;d0=X|0;d1=X+4|0;d2=Y;d3=Y+8|0;d4=Y+1|0;d5=Y|0;d6=Y+4|0;d7=S+64|0;d8=d7|0;d9=S|0;ea=S+8|0;eb=ea|0;ec=S+12|0;ed=S+64|0;ee=S+4|0;ef=ec;eg=S+8|0;eh=ec|0;ei=S+16|0;ej=S+20|0;ek=S+60|0;el=ea;ea=T;em=V;en=W;eo=U;eq=S+12|0;er=S+44|0;es=S+64|0;eu=S+52|0;ev=U+8|0;ew=V+8|0;ex=V+1|0;ey=V|0;ez=V+4|0;eA=T+8|0;eB=T+1|0;eC=T|0;eD=T+4|0;eE=z+8|0;eF=R+8|0;eG=R+1|0;eH=R|0;eI=R+4|0;eJ=J;eL=M;eM=M+8|0;eN=M+1|0;eO=M|0;eP=M+4|0;eQ=L;eR=L+8|0;eS=L+1|0;eT=L|0;eU=L+4|0;eV=J+8|0;eW=J+1|0;eX=J|0;eY=J+4|0;eZ=F+44|0;e_=aa+44|0;e$=ag+44|0;e0=am+44|0;e1=S+44|0;e2=0;e3=0;L34:while(1){e4=e2>>>0<aI>>>0;e5=e3;L36:while(1){if(!e4){c[dr>>2]=14576;c[dp>>2]=31212;c[dt>>2]=31232;c[du>>2]=0;x=0;aq(200,F+64|0,dv|0);if(x){x=0;aQ=43;break L34}c[F+136>>2]=0;c[F+140>>2]=-1;c[dp>>2]=14556;c[dn>>2]=14596;c[dr>>2]=14576;c[dx>>2]=14880;HA(dy);Ke(dz|0,0,24)|0;c[dx>>2]=14736;Ke(eZ|0,0,16)|0;c[dA>>2]=24;Ke(C|0,0,12)|0;x=0;aq(214,ds|0,B|0);if(x){x=0;aQ=37;break L34}if((a[C]&1)!=0){J2(c[dR>>2]|0)}e6=(x=0,aK(802,dB|0,b|0)|0);if(x){x=0;aQ=75;break L34}e7=(x=0,aK(112,e6|0,7624)|0);if(x){x=0;aQ=75;break L34}e6=(x=0,aK(312,e7|0,aI|0)|0);if(x){x=0;aQ=75;break L34}e7=(x=0,aK(112,e6|0,10352)|0);if(x){x=0;aQ=75;break L34}e6=(x=0,aK(112,e7|0,8648)|0);if(x){x=0;aQ=75;break L34}x=0,aK(312,e6|0,E|0)|0;if(x){x=0;aQ=75;break L34}x=0;aq(560,G|0,ds|0);if(x){x=0;aQ=75;break L34}if((a[dq]&1)==0){c[dC>>2]=c[dq>>2];c[dC+4>>2]=c[dq+4>>2];c[dC+8>>2]=c[dq+8>>2]}else{e6=c[dM>>2]|0;e7=c[dN>>2]|0;if(e7>>>0>4294967279>>>0){aQ=57;break L34}if(e7>>>0<11>>>0){a[dC]=e7<<1;e8=dO}else{e9=e7+16&-16;fa=(x=0,as(230,e9|0)|0);if(x){x=0;aQ=76;break L34}c[dL>>2]=fa;c[dP>>2]=e9|1;c[dQ>>2]=e7;e8=fa}Kb(e8|0,e6|0,e7)|0;a[e8+e7|0]=0}c[dD>>2]=c[dE>>2];c[dD+4>>2]=c[dE+4>>2];c[dD+8>>2]=c[dE+8>>2];x=0;aP(362,G|0,H|0,I|0);if(x){x=0;aQ=79;break L34}if((a[dC]&1)!=0){J2(c[dL>>2]|0)}if((a[dF]&1)!=0){J2(c[dK>>2]|0)}c[dp>>2]=14556;c[dt>>2]=14596;c[dw>>2]=14576;c[dG>>2]=14736;if((a[dH]&1)!=0){J2(c[dJ>>2]|0)}c[dG>>2]=14880;x=0;ap(388,dy|0);if(x){x=0;aQ=73;break L34}x=0;ap(268,dI|0);if(x){x=0;aQ=19;break L34}}fb=c[(c[aL>>2]|0)+(e2<<2)>>2]|0;fc=c[(c[aM>>2]|0)+(e5<<2)>>2]|0;e7=(a[fc+52|0]&1)==0;e6=a[fb+44|0]|0;if(!e7){if((e6&1)!=0){aQ=91;break}}do{if((e6&1)==0){if(!e7){aQ=235;break L36}fa=fc+40|0;if((a[fa]&1)==0){c[a$>>2]=c[fa>>2];c[a$+4>>2]=c[fa+4>>2];c[a$+8>>2]=c[fa+8>>2];fd=a[a$]|0}else{e9=c[fc+48>>2]|0;fe=c[fc+44>>2]|0;if(fe>>>0>4294967279>>>0){aQ=355;break L34}if(fe>>>0<11>>>0){ff=fe<<1&255;a[a$]=ff;fg=cZ;fh=ff}else{ff=fe+16&-16;fi=(x=0,as(230,ff|0)|0);if(x){x=0;aQ=19;break L34}c[cX>>2]=fi;fj=ff|1;c[c_>>2]=fj;c[cY>>2]=fe;fg=fi;fh=fj&255}Kb(fg|0,e9|0,fe)|0;a[fg+fe|0]=0;fd=fh}fe=fd&255;e9=(fe&1|0)==0?fe>>>1:c[cY>>2]|0;if((fd&1)!=0){J2(c[cX>>2]|0)}if((e9|0)==0){aQ=365;break L36}if((a[fa]&1)==0){c[d>>2]=c[fa>>2];c[d+4>>2]=c[fa+4>>2];c[d+8>>2]=c[fa+8>>2];fk=a[d]|0}else{e9=c[fc+48>>2]|0;fe=c[fc+44>>2]|0;if(fe>>>0>4294967279>>>0){aQ=384;break L34}if(fe>>>0<11>>>0){fj=fe<<1&255;a[d]=fj;fl=cU;fm=fj}else{fj=fe+16&-16;fi=(x=0,as(230,fj|0)|0);if(x){x=0;aQ=19;break L34}c[cT>>2]=fi;ff=fj|1;c[cV>>2]=ff;c[cW>>2]=fe;fl=fi;fm=ff&255}Kb(fl|0,e9|0,fe)|0;a[fl+fe|0]=0;fk=fm}fe=ep(aH,$)|0;if((fk&1)!=0){J2(c[cT>>2]|0)}if((fe|0)==0){c[aU>>2]=14576;c[aX>>2]=31212;c[aY>>2]=31232;c[a_>>2]=0;x=0;aq(200,aa+64|0,aZ|0);if(x){x=0;aQ=404;break L34}c[aa+136>>2]=0;c[aa+140>>2]=-1;c[aX>>2]=14556;c[aW>>2]=14596;c[aU>>2]=14576;c[a0>>2]=14880;HA(bf);Ke(bg|0,0,24)|0;c[a0>>2]=14736;Ke(e_|0,0,16)|0;c[bh>>2]=24;Ke(y|0,0,12)|0;x=0;aq(214,aT|0,w|0);if(x){x=0;aQ=398;break L34}if((a[y]&1)!=0){J2(c[bz>>2]|0)}fe=(x=0,aK(802,bi|0,b|0)|0);if(x){x=0;aQ=445;break L34}e9=(x=0,aK(112,fe|0,4960)|0);if(x){x=0;aQ=445;break L34}if((a[fa]&1)==0){c[aV>>2]=c[fa>>2];c[aV+4>>2]=c[fa+4>>2];c[aV+8>>2]=c[fa+8>>2]}else{fe=c[fc+48>>2]|0;ff=c[fc+44>>2]|0;if(ff>>>0>4294967279>>>0){aQ=413;break L34}if(ff>>>0<11>>>0){a[aV]=ff<<1;fn=bw}else{fi=ff+16&-16;fj=(x=0,as(230,fi|0)|0);if(x){x=0;aQ=445;break L34}c[bv>>2]=fj;c[bx>>2]=fi|1;c[by>>2]=ff;fn=fj}Kb(fn|0,fe|0,ff)|0;a[fn+ff|0]=0}x=0,aK(802,e9|0,ab|0)|0;if(x){x=0;aQ=448;break L34}if((a[aV]&1)!=0){J2(c[bv>>2]|0)}x=0;aq(560,ac|0,aT|0);if(x){x=0;aQ=445;break L34}e9=fc+4|0;if((a[e9]&1)==0){c[bj>>2]=c[e9>>2];c[bj+4>>2]=c[e9+4>>2];c[bj+8>>2]=c[e9+8>>2]}else{e9=c[fc+12>>2]|0;ff=c[fc+8>>2]|0;if(ff>>>0>4294967279>>>0){aQ=427;break L34}if(ff>>>0<11>>>0){a[bj]=ff<<1;fo=bs}else{fe=ff+16&-16;fj=(x=0,as(230,fe|0)|0);if(x){x=0;aQ=450;break L34}c[br>>2]=fj;c[bt>>2]=fe|1;c[bu>>2]=ff;fo=fj}Kb(fo|0,e9|0,ff)|0;a[fo+ff|0]=0}ff=fc+16|0;c[bk>>2]=c[ff>>2];c[bk+4>>2]=c[ff+4>>2];c[bk+8>>2]=c[ff+8>>2];x=0;aP(362,ac|0,ad|0,ae|0);if(x){x=0;aQ=453;break L34}if((a[bj]&1)!=0){J2(c[br>>2]|0)}if((a[bl]&1)!=0){J2(c[bq>>2]|0)}c[aX>>2]=14556;c[aY>>2]=14596;c[a1>>2]=14576;c[bm>>2]=14736;if((a[bn]&1)!=0){J2(c[bp>>2]|0)}c[bm>>2]=14880;x=0;ap(388,bf|0);if(x){x=0;aQ=443;break L34}x=0;ap(268,bo|0);if(x){x=0;aQ=19;break L34}}if((a[fa]&1)==0){c[bA>>2]=c[fa>>2];c[bA+4>>2]=c[fa+4>>2];c[bA+8>>2]=c[fa+8>>2]}else{ff=c[fc+48>>2]|0;e9=c[fc+44>>2]|0;if(e9>>>0>4294967279>>>0){aQ=466;break L34}if(e9>>>0<11>>>0){a[bA]=e9<<1;fp=cQ}else{fj=e9+16&-16;fe=(x=0,as(230,fj|0)|0);if(x){x=0;aQ=19;break L34}c[cP>>2]=fe;c[cR>>2]=fj|1;c[cS>>2]=e9;fp=fe}Kb(fp|0,ff|0,e9)|0;a[fp+e9|0]=0}e9=(x=0,aK(142,D|0,af|0)|0);if(x){x=0;aQ=530;break L34}ff=(a[(c[e9>>2]|0)+44|0]&1)==0;if((a[bA]&1)!=0){J2(c[cP>>2]|0)}if(!ff){c[cn>>2]=14576;c[cl>>2]=31212;c[cp>>2]=31232;c[cq>>2]=0;x=0;aq(200,ag+64|0,cr|0);if(x){x=0;aQ=487;break L34}c[ag+136>>2]=0;c[ag+140>>2]=-1;c[cl>>2]=14556;c[ck>>2]=14596;c[cn>>2]=14576;c[ct>>2]=14880;HA(cu);Ke(cv|0,0,24)|0;c[ct>>2]=14736;Ke(e$|0,0,16)|0;c[cw>>2]=24;Ke(v|0,0,12)|0;x=0;aq(214,co|0,u|0);if(x){x=0;aQ=481;break L34}if((a[v]&1)!=0){J2(c[cO>>2]|0)}ff=(x=0,aK(112,cx|0,3312)|0);if(x){x=0;aQ=532;break L34}if((a[fa]&1)==0){c[cm>>2]=c[fa>>2];c[cm+4>>2]=c[fa+4>>2];c[cm+8>>2]=c[fa+8>>2]}else{e9=c[fc+48>>2]|0;fe=c[fc+44>>2]|0;if(fe>>>0>4294967279>>>0){aQ=495;break L34}if(fe>>>0<11>>>0){a[cm]=fe<<1;fq=cL}else{fj=fe+16&-16;fi=(x=0,as(230,fj|0)|0);if(x){x=0;aQ=532;break L34}c[cK>>2]=fi;c[cM>>2]=fj|1;c[cN>>2]=fe;fq=fi}Kb(fq|0,e9|0,fe)|0;a[fq+fe|0]=0}fe=(x=0,aK(802,ff|0,ah|0)|0);if(x){x=0;aQ=535;break L34}ff=(x=0,aK(112,fe|0,2128)|0);if(x){x=0;aQ=535;break L34}fe=(x=0,aK(802,ff|0,b|0)|0);if(x){x=0;aQ=535;break L34}x=0,aK(112,fe|0,1304)|0;if(x){x=0;aQ=535;break L34}if((a[cm]&1)!=0){J2(c[cK>>2]|0)}x=0;aq(560,ai|0,co|0);if(x){x=0;aQ=532;break L34}fe=fc+4|0;if((a[fe]&1)==0){c[cy>>2]=c[fe>>2];c[cy+4>>2]=c[fe+4>>2];c[cy+8>>2]=c[fe+8>>2]}else{fe=c[fc+12>>2]|0;ff=c[fc+8>>2]|0;if(ff>>>0>4294967279>>>0){aQ=512;break L34}if(ff>>>0<11>>>0){a[cy]=ff<<1;fr=cH}else{e9=ff+16&-16;fi=(x=0,as(230,e9|0)|0);if(x){x=0;aQ=537;break L34}c[cG>>2]=fi;c[cI>>2]=e9|1;c[cJ>>2]=ff;fr=fi}Kb(fr|0,fe|0,ff)|0;a[fr+ff|0]=0}ff=fc+16|0;c[cz>>2]=c[ff>>2];c[cz+4>>2]=c[ff+4>>2];c[cz+8>>2]=c[ff+8>>2];x=0;aP(362,ai|0,aj|0,ak|0);if(x){x=0;aQ=540;break L34}if((a[cy]&1)!=0){J2(c[cG>>2]|0)}if((a[cA]&1)!=0){J2(c[cF>>2]|0)}c[cl>>2]=14556;c[cp>>2]=14596;c[cs>>2]=14576;c[cB>>2]=14736;if((a[cC]&1)!=0){J2(c[cE>>2]|0)}c[cB>>2]=14880;x=0;ap(388,cu|0);if(x){x=0;aQ=528;break L34}x=0;ap(268,cD|0);if(x){x=0;aQ=19;break L34}}if((a[fa]&1)==0){c[bB>>2]=c[fa>>2];c[bB+4>>2]=c[fa+4>>2];c[bB+8>>2]=c[fa+8>>2];fs=a[bB]|0}else{ff=c[fc+48>>2]|0;fe=c[fc+44>>2]|0;if(fe>>>0>4294967279>>>0){aQ=553;break L34}if(fe>>>0<11>>>0){fi=fe<<1&255;a[bB]=fi;ft=cg;fu=fi}else{fi=fe+16&-16;e9=(x=0,as(230,fi|0)|0);if(x){x=0;aQ=19;break L34}c[cf>>2]=e9;fj=fi|1;c[ch>>2]=fj;c[ci>>2]=fe;ft=e9;fu=fj&255}Kb(ft|0,ff|0,fe)|0;a[ft+fe|0]=0;fs=fu}fe=(et(bC,al)|0)==0;if((fs&1)!=0){J2(c[cf>>2]|0)}if(!fe){c[bN>>2]=14576;c[bL>>2]=31212;c[bP>>2]=31232;c[bR>>2]=0;x=0;aq(200,am+64|0,bS|0);if(x){x=0;aQ=573;break L34}c[am+136>>2]=0;c[am+140>>2]=-1;c[bL>>2]=14556;c[bK>>2]=14596;c[bN>>2]=14576;c[bV>>2]=14880;HA(bW);Ke(bX|0,0,24)|0;c[bV>>2]=14736;Ke(e0|0,0,16)|0;c[bY>>2]=24;Ke(t|0,0,12)|0;x=0;aq(214,bO|0,s|0);if(x){x=0;aQ=567;break L34}if((a[t]&1)!=0){J2(c[ce>>2]|0)}fe=(x=0,aK(112,bZ|0,6464)|0);if(x){x=0;aQ=615;break L34}ff=fb+28|0;if((a[ff]&1)==0){c[bM>>2]=c[ff>>2];c[bM+4>>2]=c[ff+4>>2];c[bM+8>>2]=c[ff+8>>2]}else{ff=c[fb+36>>2]|0;fj=c[fb+32>>2]|0;if(fj>>>0>4294967279>>>0){aQ=581;break L34}if(fj>>>0<11>>>0){a[bM]=fj<<1;fv=cb}else{e9=fj+16&-16;fi=(x=0,as(230,e9|0)|0);if(x){x=0;aQ=615;break L34}c[ca>>2]=fi;c[cc>>2]=e9|1;c[cd>>2]=fj;fv=fi}Kb(fv|0,ff|0,fj)|0;a[fv+fj|0]=0}fj=(x=0,aK(802,fe|0,an|0)|0);if(x){x=0;aQ=618;break L34}fe=(x=0,aK(112,fj|0,680)|0);if(x){x=0;aQ=618;break L34}x=0,aK(802,fe|0,b|0)|0;if(x){x=0;aQ=618;break L34}if((a[bM]&1)!=0){J2(c[ca>>2]|0)}x=0;aq(560,ao|0,bO|0);if(x){x=0;aQ=615;break L34}fe=fc+4|0;if((a[fe]&1)==0){c[b_>>2]=c[fe>>2];c[b_+4>>2]=c[fe+4>>2];c[b_+8>>2]=c[fe+8>>2]}else{fe=c[fc+12>>2]|0;fj=c[fc+8>>2]|0;if(fj>>>0>4294967279>>>0){aQ=597;break L34}if(fj>>>0<11>>>0){a[b_]=fj<<1;fw=b7}else{ff=fj+16&-16;fi=(x=0,as(230,ff|0)|0);if(x){x=0;aQ=620;break L34}c[b6>>2]=fi;c[b8>>2]=ff|1;c[b9>>2]=fj;fw=fi}Kb(fw|0,fe|0,fj)|0;a[fw+fj|0]=0}fj=fc+16|0;c[b$>>2]=c[fj>>2];c[b$+4>>2]=c[fj+4>>2];c[b$+8>>2]=c[fj+8>>2];x=0;aP(362,ao|0,ar|0,at|0);if(x){x=0;aQ=623;break L34}if((a[b_]&1)!=0){J2(c[b6>>2]|0)}if((a[b0]&1)!=0){J2(c[b5>>2]|0)}c[bL>>2]=14556;c[bP>>2]=14596;c[bT>>2]=14576;c[b1>>2]=14736;if((a[b2]&1)!=0){J2(c[b4>>2]|0)}c[b1>>2]=14880;x=0;ap(388,bW|0);if(x){x=0;aQ=613;break L34}x=0;ap(268,b3|0);if(x){x=0;aQ=19;break L34}}fj=c[fc+36>>2]|0;if((a[fa]&1)==0){c[bE>>2]=c[fa>>2];c[bE+4>>2]=c[fa+4>>2];c[bE+8>>2]=c[fa+8>>2]}else{fa=c[fc+48>>2]|0;fe=c[fc+44>>2]|0;if(fe>>>0>4294967279>>>0){aQ=636;break L34}if(fe>>>0<11>>>0){a[bE]=fe<<1;fx=bG}else{fi=fe+16&-16;ff=(x=0,as(230,fi|0)|0);if(x){x=0;aQ=19;break L34}c[bF>>2]=ff;c[bH>>2]=fi|1;c[bI>>2]=fe;fx=ff}Kb(fx|0,fa|0,fe)|0;a[fx+fe|0]=0}fe=(x=0,aK(176,bD|0,au|0)|0);if(x){x=0;aQ=646;break L34}c[fe>>2]=fj;if((a[bE]&1)==0){break}J2(c[bF>>2]|0)}else{fj=fb+28|0;if((a[fj]&1)==0){c[c$>>2]=c[fj>>2];c[c$+4>>2]=c[fj+4>>2];c[c$+8>>2]=c[fj+8>>2];fy=a[c$]|0}else{fe=c[fb+36>>2]|0;fa=c[fb+32>>2]|0;if(fa>>>0>4294967279>>>0){aQ=155;break L34}if(fa>>>0<11>>>0){ff=fa<<1&255;a[c$]=ff;fz=dj;fA=ff}else{ff=fa+16&-16;fi=(x=0,as(230,ff|0)|0);if(x){x=0;aQ=19;break L34}c[di>>2]=fi;e9=ff|1;c[dk>>2]=e9;c[dl>>2]=fa;fz=fi;fA=e9&255}Kb(fz|0,fe|0,fa)|0;a[fz+fa|0]=0;fy=fA}fa=(et(bC,N)|0)==0;if((fy&1)!=0){J2(c[di>>2]|0)}do{if(fa){fe=(x=0,as(230,60)|0);if(x){x=0;aQ=19;break L34}e9=fe;c[o>>2]=e9;fe=c[c0>>2]|0;if((fe|0)==(c[c1>>2]|0)){x=0;aq(376,c2|0,o|0);if(x){x=0;aQ=19;break L34}fB=c[o>>2]|0}else{if((fe|0)==0){fC=0}else{c[fe>>2]=e9;fC=c[c0>>2]|0}c[c0>>2]=fC+4;fB=e9}fD=fB;e9=fB;fe=fb+4|0;if((a[fe]&1)==0){c[c3>>2]=c[fe>>2];c[c3+4>>2]=c[fe+4>>2];c[c3+8>>2]=c[fe+8>>2]}else{fe=c[fb+12>>2]|0;fi=c[fb+8>>2]|0;if(fi>>>0>4294967279>>>0){aQ=175;break L34}if(fi>>>0<11>>>0){a[c3]=fi<<1;fE=da}else{ff=fi+16&-16;fF=(x=0,as(230,ff|0)|0);if(x){x=0;aQ=198;break L34}c[c9>>2]=fF;c[db>>2]=ff|1;c[dc>>2]=fi;fE=fF}Kb(fE|0,fe|0,fi)|0;a[fE+fi|0]=0}fi=fb+16|0;fe=n;c[fe>>2]=c[fi>>2];c[fe+4>>2]=c[fi+4>>2];c[fe+8>>2]=c[fi+8>>2];x=0;aB(34,e9|0,O|0,n|0,0,1,1);if(x){x=0;aQ=201;break L34}if((a[c3]&1)!=0){J2(c[c9>>2]|0)}if((a[fj]&1)==0){c[c4>>2]=c[fj>>2];c[c4+4>>2]=c[fj+4>>2];c[c4+8>>2]=c[fj+8>>2]}else{fi=c[fb+36>>2]|0;fe=c[fb+32>>2]|0;if(fe>>>0>4294967279>>>0){aQ=188;break L34}if(fe>>>0<11>>>0){a[c4]=fe<<1;fG=c6}else{fF=fe+16&-16;ff=(x=0,as(230,fF|0)|0);if(x){x=0;aQ=19;break L34}c[c5>>2]=ff;c[c7>>2]=fF|1;c[c8>>2]=fe;fG=ff}Kb(fG|0,fi|0,fe)|0;a[fG+fe|0]=0}fe=(x=0,aK(176,bD|0,P|0)|0);if(x){x=0;aQ=209;break L34}c[fe>>2]=fB;if((a[c4]&1)==0){fH=e9;break}J2(c[c5>>2]|0);fH=e9}else{if((a[fj]&1)==0){c[dd>>2]=c[fj>>2];c[dd+4>>2]=c[fj+4>>2];c[dd+8>>2]=c[fj+8>>2]}else{e9=c[fb+36>>2]|0;fe=c[fb+32>>2]|0;if(fe>>>0>4294967279>>>0){aQ=214;break L34}if(fe>>>0<11>>>0){a[dd]=fe<<1;fI=df}else{fi=fe+16&-16;ff=(x=0,as(230,fi|0)|0);if(x){x=0;aQ=19;break L34}c[de>>2]=ff;c[dg>>2]=fi|1;c[dh>>2]=fe;fI=ff}Kb(fI|0,e9|0,fe)|0;a[fI+fe|0]=0}fe=(x=0,aK(176,bD|0,Q|0)|0);if(x){x=0;aQ=224;break L34}e9=c[fe>>2]|0;if((a[dd]&1)==0){fH=e9;break}J2(c[de>>2]|0);fH=e9}}while(0);fj=fH+36|0;fa=c[fc+36>>2]|0;c[m>>2]=fa;e9=fH+44|0;fe=c[e9>>2]|0;if((fe|0)==(c[fH+48>>2]|0)){x=0;aq(370,fH+40|0,m|0);if(x){x=0;aQ=19;break L34}fJ=c[m>>2]|0}else{if((fe|0)==0){fK=0}else{c[fe>>2]=fa;fK=c[e9>>2]|0}c[e9>>2]=fK+4;fJ=fa}x=0;aq(c[c[fj>>2]>>2]|0,fj|0,fJ|0);if(x){x=0;aQ=19;break L34}}}while(0);e7=e5+1|0;if(e7>>>0<E>>>0){e5=e7}else{bd=e2;aQ=30;break L32}}do{if((aQ|0)==91){aQ=0;e4=fb+28|0;if((a[e4]&1)==0){c[eJ>>2]=c[e4>>2];c[eJ+4>>2]=c[e4+4>>2];c[eJ+8>>2]=c[e4+8>>2];fL=a[eJ]|0}else{e7=c[fb+36>>2]|0;e6=c[fb+32>>2]|0;if(e6>>>0>4294967279>>>0){aQ=94;break L34}if(e6>>>0<11>>>0){fj=e6<<1&255;a[eJ]=fj;fM=eW;fN=fj}else{fj=e6+16&-16;fa=(x=0,as(230,fj|0)|0);if(x){x=0;aQ=20;break L34}c[eV>>2]=fa;e9=fj|1;c[eX>>2]=e9;c[eY>>2]=e6;fM=fa;fN=e9&255}Kb(fM|0,e7|0,e6)|0;a[fM+e6|0]=0;fL=fN}e6=(et(bC,J)|0)==0;if((fL&1)!=0){J2(c[eV>>2]|0)}do{if(e6){e7=c[fc+36>>2]|0;if((a[e4]&1)==0){c[eL>>2]=c[e4>>2];c[eL+4>>2]=c[e4+4>>2];c[eL+8>>2]=c[e4+8>>2]}else{e9=c[fb+36>>2]|0;fa=c[fb+32>>2]|0;if(fa>>>0>4294967279>>>0){aQ=137;break L34}if(fa>>>0<11>>>0){a[eL]=fa<<1;fO=eN}else{fj=fa+16&-16;fe=(x=0,as(230,fj|0)|0);if(x){x=0;aQ=20;break L34}c[eM>>2]=fe;c[eO>>2]=fj|1;c[eP>>2]=fa;fO=fe}Kb(fO|0,e9|0,fa)|0;a[fO+fa|0]=0}fa=(x=0,aK(176,bD|0,M|0)|0);if(x){x=0;aQ=147;break L34}c[fa>>2]=e7;if((a[eL]&1)==0){break}J2(c[eM>>2]|0)}else{if((a[e4]&1)==0){c[eQ>>2]=c[e4>>2];c[eQ+4>>2]=c[e4+4>>2];c[eQ+8>>2]=c[e4+8>>2]}else{e7=c[fb+36>>2]|0;fa=c[fb+32>>2]|0;if(fa>>>0>4294967279>>>0){aQ=107;break L34}if(fa>>>0<11>>>0){a[eQ]=fa<<1;fP=eS}else{e9=fa+16&-16;fe=(x=0,as(230,e9|0)|0);if(x){x=0;aQ=20;break L34}c[eR>>2]=fe;c[eT>>2]=e9|1;c[eU>>2]=fa;fP=fe}Kb(fP|0,e7|0,fa)|0;a[fP+fa|0]=0}fa=(x=0,aK(176,bD|0,L|0)|0);if(x){x=0;aQ=131;break L34}e7=(c[fa>>2]|0)+36|0;fa=e7;fe=c[fc+36>>2]|0;if((fe|0)==0){fQ=0}else{fQ=fe+36|0}fe=fQ+4|0;e9=c[fe>>2]|0;fj=(c[fQ+8>>2]|0)-e9>>2;L392:do{if((fj|0)!=0){ff=e7+8|0;fi=ff;fF=e7+12|0;fR=e7+4|0;fS=e7;fT=0;fU=e9;while(1){fV=c[fU+(fT<<2)>>2]|0;c[p>>2]=fV;fW=c[fi>>2]|0;if((fW|0)==(c[fF>>2]|0)){x=0;aq(370,fR|0,p|0);if(x){x=0;aQ=130;break L34}fX=c[p>>2]|0}else{if((fW|0)==0){fY=0}else{c[fW>>2]=fV;fY=c[fi>>2]|0}c[ff>>2]=fY+4;fX=fV}x=0;aq(c[c[fS>>2]>>2]|0,fa|0,fX|0);if(x){x=0;aQ=130;break L34}fV=fT+1|0;if(fV>>>0>=fj>>>0){break L392}fT=fV;fU=c[fe>>2]|0}}}while(0);if((a[eQ]&1)==0){break}J2(c[eR>>2]|0)}}while(0);fZ=e5+1|0}else if((aQ|0)==235){aQ=0;e4=fb+28|0;if((a[e4]&1)==0){c[dX>>2]=c[e4>>2];c[dX+4>>2]=c[e4+4>>2];c[dX+8>>2]=c[e4+8>>2];f_=a[dX]|0}else{e6=c[fb+36>>2]|0;fe=c[fb+32>>2]|0;if(fe>>>0>4294967279>>>0){aQ=238;break L34}if(fe>>>0<11>>>0){fj=fe<<1&255;a[dX]=fj;f$=eG;f0=fj}else{fj=fe+16&-16;fa=(x=0,as(230,fj|0)|0);if(x){x=0;aQ=20;break L34}c[eF>>2]=fa;e9=fj|1;c[eH>>2]=e9;c[eI>>2]=fe;f$=fa;f0=e9&255}Kb(f$|0,e6|0,fe)|0;a[f$+fe|0]=0;f_=f0}fe=(et(bC,R)|0)==0;if((f_&1)!=0){J2(c[eF>>2]|0)}if(!fe){c[eb>>2]=14576;c[d9>>2]=31212;c[ed>>2]=31232;c[ee>>2]=0;x=0;aq(200,S+64|0,ef|0);if(x){x=0;aQ=258;break L34}c[S+136>>2]=0;c[S+140>>2]=-1;c[d9>>2]=14556;c[d8>>2]=14596;c[eb>>2]=14576;c[eh>>2]=14880;HA(ei);Ke(ej|0,0,24)|0;c[eh>>2]=14736;Ke(e1|0,0,16)|0;c[ek>>2]=24;Ke(A|0,0,12)|0;x=0;aq(214,ec|0,z|0);if(x){x=0;aQ=252;break L34}if((a[A]&1)!=0){J2(c[eE>>2]|0)}fe=(x=0,aK(112,el|0,6464)|0);if(x){x=0;aQ=300;break L34}if((a[e4]&1)==0){c[ea>>2]=c[e4>>2];c[ea+4>>2]=c[e4+4>>2];c[ea+8>>2]=c[e4+8>>2]}else{e6=c[fb+36>>2]|0;e9=c[fb+32>>2]|0;if(e9>>>0>4294967279>>>0){aQ=266;break L34}if(e9>>>0<11>>>0){a[ea]=e9<<1;f1=eB}else{fa=e9+16&-16;fj=(x=0,as(230,fa|0)|0);if(x){x=0;aQ=300;break L34}c[eA>>2]=fj;c[eC>>2]=fa|1;c[eD>>2]=e9;f1=fj}Kb(f1|0,e6|0,e9)|0;a[f1+e9|0]=0}e9=(x=0,aK(802,fe|0,T|0)|0);if(x){x=0;aQ=303;break L34}fe=(x=0,aK(112,e9|0,5752)|0);if(x){x=0;aQ=303;break L34}x=0,aK(802,fe|0,b|0)|0;if(x){x=0;aQ=303;break L34}if((a[ea]&1)!=0){J2(c[eA>>2]|0)}x=0;aq(560,U|0,ec|0);if(x){x=0;aQ=300;break L34}fe=fc+4|0;if((a[fe]&1)==0){c[em>>2]=c[fe>>2];c[em+4>>2]=c[fe+4>>2];c[em+8>>2]=c[fe+8>>2]}else{fe=c[fc+12>>2]|0;e9=c[fc+8>>2]|0;if(e9>>>0>4294967279>>>0){aQ=282;break L34}if(e9>>>0<11>>>0){a[em]=e9<<1;f2=ex}else{e6=e9+16&-16;fj=(x=0,as(230,e6|0)|0);if(x){x=0;aQ=305;break L34}c[ew>>2]=fj;c[ey>>2]=e6|1;c[ez>>2]=e9;f2=fj}Kb(f2|0,fe|0,e9)|0;a[f2+e9|0]=0}e9=fc+16|0;c[en>>2]=c[e9>>2];c[en+4>>2]=c[e9+4>>2];c[en+8>>2]=c[e9+8>>2];x=0;aP(362,U|0,V|0,W|0);if(x){x=0;aQ=308;break L34}if((a[em]&1)!=0){J2(c[ew>>2]|0)}if((a[eo]&1)!=0){J2(c[ev>>2]|0)}c[d9>>2]=14556;c[ed>>2]=14596;c[eg>>2]=14576;c[eq>>2]=14736;if((a[er]&1)!=0){J2(c[eu>>2]|0)}c[eq>>2]=14880;x=0;ap(388,ei|0);if(x){x=0;aQ=298;break L34}x=0;ap(268,es|0);if(x){x=0;aQ=20;break L34}}e9=c[fc+36>>2]|0;if((e2|0)==(dY|0)){fe=e9|0;if((a[e4]&1)==0){c[dZ>>2]=c[e4>>2];c[dZ+4>>2]=c[e4+4>>2];c[dZ+8>>2]=c[e4+8>>2]}else{fj=c[fb+36>>2]|0;e6=c[fb+32>>2]|0;if(e6>>>0>4294967279>>>0){aQ=322;break L34}if(e6>>>0<11>>>0){a[dZ]=e6<<1;f3=d$}else{fa=e6+16&-16;e7=(x=0,as(230,fa|0)|0);if(x){x=0;aQ=20;break L34}c[d_>>2]=e7;c[d0>>2]=fa|1;c[d1>>2]=e6;f3=e7}Kb(f3|0,fj|0,e6)|0;a[f3+e6|0]=0}e6=(x=0,aK(176,bD|0,X|0)|0);if(x){x=0;aQ=333;break L34}c[e6>>2]=fe;if((a[dZ]&1)!=0){J2(c[d_>>2]|0)}fZ=e5+1|0;break}fe=e9+40|0;e6=c[c[fe>>2]>>2]|0;if((a[e4]&1)==0){c[d2>>2]=c[e4>>2];c[d2+4>>2]=c[e4+4>>2];c[d2+8>>2]=c[e4+8>>2]}else{e4=c[fb+36>>2]|0;fj=c[fb+32>>2]|0;if(fj>>>0>4294967279>>>0){aQ=338;break L34}if(fj>>>0<11>>>0){a[d2]=fj<<1;f4=d4}else{e7=fj+16&-16;fa=(x=0,as(230,e7|0)|0);if(x){x=0;aQ=20;break L34}c[d3>>2]=fa;c[d5>>2]=e7|1;c[d6>>2]=fj;f4=fa}Kb(f4|0,e4|0,fj)|0;a[f4+fj|0]=0}fj=(x=0,aK(176,bD|0,Y|0)|0);if(x){x=0;aQ=350;break L34}c[fj>>2]=e6;if((a[d2]&1)!=0){J2(c[d3>>2]|0)}e6=c[fe>>2]|0;fe=e6+4|0;fj=e9+44|0;e9=fj;e4=(c[e9>>2]|0)-fe|0;Kc(e6|0,fe|0,e4|0)|0;fe=e6+(e4>>2<<2)|0;e4=c[e9>>2]|0;if((fe|0)==(e4|0)){fZ=e5;break}else{f5=e4}while(1){e4=f5-4|0;c[fj>>2]=e4;if((fe|0)==(e4|0)){fZ=e5;break}else{f5=e4}}}else if((aQ|0)==365){aQ=0;fe=c[fc+36>>2]|0;fj=fb+28|0;if((a[fj]&1)==0){c[dS>>2]=c[fj>>2];c[dS+4>>2]=c[fj+4>>2];c[dS+8>>2]=c[fj+8>>2]}else{fj=c[fb+36>>2]|0;e4=c[fb+32>>2]|0;if(e4>>>0>4294967279>>>0){aQ=368;break L34}if(e4>>>0<11>>>0){a[dS]=e4<<1;f6=dU}else{e9=e4+16&-16;e6=(x=0,as(230,e9|0)|0);if(x){x=0;aQ=20;break L34}c[dT>>2]=e6;c[dV>>2]=e9|1;c[dW>>2]=e4;f6=e6}Kb(f6|0,fj|0,e4)|0;a[f6+e4|0]=0}e4=(x=0,aK(176,bD|0,_|0)|0);if(x){x=0;aQ=379;break L34}c[e4>>2]=fe;if((a[dS]&1)!=0){J2(c[dT>>2]|0)}fZ=e5+1|0}}while(0);e5=e2+1|0;if(fZ>>>0<E>>>0){e2=e5;e3=fZ}else{bd=e5;aQ=30;break L32}}do{if((aQ|0)==37){e3=bQ(-1,-1)|0;e2=K;if((a[C]&1)!=0){J2(c[dR>>2]|0)}if((a[dH]&1)!=0){J2(c[dJ>>2]|0)}c[dx>>2]=14880;x=0;ap(388,dy|0);if(!x){f7=e2;f8=e3;aQ=44;break}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==20){e3=bQ(-1,-1)|0;a2=K;a3=e3;break L30}else if((aQ|0)==19){e3=bQ(-1,-1)|0;a2=K;a3=e3;break L30}else if((aQ|0)==43){e3=bQ(-1,-1)|0;f7=K;f8=e3;aQ=44}else if((aQ|0)==57){x=0;ap(232,0);if(x){x=0;e3=bQ(-1,-1)|0;f9=K;ga=e3;aQ=78;break}}else if((aQ|0)==73){e3=bQ(-1,-1)|0;e2=K;x=0;ap(268,dI|0);if(!x){a2=e2;a3=e3;break L30}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==75){e3=bQ(-1,-1)|0;gb=K;gc=e3;aQ=83}else if((aQ|0)==76){e3=bQ(-1,-1)|0;f9=K;ga=e3;aQ=78}else if((aQ|0)==79){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[dC]&1)==0){gd=e3;ge=e2;aQ=81;break}J2(c[dL>>2]|0);gd=e3;ge=e2;aQ=81}else if((aQ|0)==94){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==107){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==130){e2=bQ(-1,-1)|0;gf=K;gg=e2;aQ=132}else if((aQ|0)==131){e2=bQ(-1,-1)|0;gf=K;gg=e2;aQ=132}else if((aQ|0)==137){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==147){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[eL]&1)==0){a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[eM>>2]|0);a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==155){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==175){x=0;ap(232,0);if(x){x=0;e3=bQ(-1,-1)|0;gh=K;gi=e3;aQ=200;break}}else if((aQ|0)==188){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==198){e3=bQ(-1,-1)|0;gh=K;gi=e3;aQ=200}else if((aQ|0)==201){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[c3]&1)==0){gj=e3;gk=e2;aQ=203;break}J2(c[c9>>2]|0);gj=e3;gk=e2;aQ=203}else if((aQ|0)==209){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[c4]&1)==0){a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[c5>>2]|0);a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==214){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==224){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[dd]&1)==0){a4=e3;a5=e2;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[de>>2]|0);a4=e3;a5=e2;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==238){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==252){e2=bQ(-1,-1)|0;e3=K;if((a[A]&1)!=0){J2(c[eE>>2]|0)}if((a[er]&1)!=0){J2(c[eu>>2]|0)}c[eh>>2]=14880;x=0;ap(388,ei|0);if(!x){gl=e2;gm=e3;aQ=259;break}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==258){e3=bQ(-1,-1)|0;gl=e3;gm=K;aQ=259}else if((aQ|0)==266){x=0;ap(232,0);if(x){x=0;e3=bQ(-1,-1)|0;gn=K;go=e3;aQ=302;break}}else if((aQ|0)==282){x=0;ap(232,0);if(x){x=0;e3=bQ(-1,-1)|0;gp=K;gq=e3;aQ=307;break}}else if((aQ|0)==298){e3=bQ(-1,-1)|0;e2=K;x=0;ap(268,es|0);if(!x){a2=e2;a3=e3;break L30}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==300){e3=bQ(-1,-1)|0;gn=K;go=e3;aQ=302}else if((aQ|0)==303){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[ea]&1)==0){gr=e3;gs=e2;aQ=312;break}J2(c[eA>>2]|0);gr=e3;gs=e2;aQ=312}else if((aQ|0)==305){e2=bQ(-1,-1)|0;gp=K;gq=e2;aQ=307}else if((aQ|0)==308){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[em]&1)==0){gt=e2;gu=e3;aQ=310;break}J2(c[ew>>2]|0);gt=e2;gu=e3;aQ=310}else if((aQ|0)==322){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==333){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[dZ]&1)==0){a4=e3;a5=e2;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[d_>>2]|0);a4=e3;a5=e2;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==338){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==350){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[d2]&1)==0){a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[d3>>2]|0);a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==355){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==368){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==379){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[dS]&1)==0){a4=e3;a5=e2;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[dT>>2]|0);a4=e3;a5=e2;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==384){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==398){e2=bQ(-1,-1)|0;e3=K;if((a[y]&1)!=0){J2(c[bz>>2]|0)}if((a[bn]&1)!=0){J2(c[bp>>2]|0)}c[a0>>2]=14880;x=0;ap(388,bf|0);if(!x){gv=e2;gw=e3;aQ=405;break}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==404){e3=bQ(-1,-1)|0;gv=e3;gw=K;aQ=405}else if((aQ|0)==413){x=0;ap(232,0);if(x){x=0;e3=bQ(-1,-1)|0;gx=K;gy=e3;aQ=447;break}}else if((aQ|0)==427){x=0;ap(232,0);if(x){x=0;e3=bQ(-1,-1)|0;gz=K;gA=e3;aQ=452;break}}else if((aQ|0)==443){e3=bQ(-1,-1)|0;e2=K;x=0;ap(268,bo|0);if(!x){a2=e2;a3=e3;break L30}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==445){e3=bQ(-1,-1)|0;gx=K;gy=e3;aQ=447}else if((aQ|0)==448){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[aV]&1)==0){gB=e3;gC=e2;aQ=457;break}J2(c[bv>>2]|0);gB=e3;gC=e2;aQ=457}else if((aQ|0)==450){e2=bQ(-1,-1)|0;gz=K;gA=e2;aQ=452}else if((aQ|0)==453){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[bj]&1)==0){gD=e2;gE=e3;aQ=455;break}J2(c[br>>2]|0);gD=e2;gE=e3;aQ=455}else if((aQ|0)==466){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==481){e3=bQ(-1,-1)|0;e2=K;if((a[v]&1)!=0){J2(c[cO>>2]|0)}if((a[cC]&1)!=0){J2(c[cE>>2]|0)}c[ct>>2]=14880;x=0;ap(388,cu|0);if(!x){gF=e3;gG=e2;aQ=488;break}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==487){e2=bQ(-1,-1)|0;gF=e2;gG=K;aQ=488}else if((aQ|0)==495){x=0;ap(232,0);if(x){x=0;e2=bQ(-1,-1)|0;gH=K;gI=e2;aQ=534;break}}else if((aQ|0)==512){x=0;ap(232,0);if(x){x=0;e2=bQ(-1,-1)|0;gJ=K;gK=e2;aQ=539;break}}else if((aQ|0)==528){e2=bQ(-1,-1)|0;e3=K;x=0;ap(268,cD|0);if(!x){a2=e3;a3=e2;break L30}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==530){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[bA]&1)==0){a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[cP>>2]|0);a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==532){e3=bQ(-1,-1)|0;gH=K;gI=e3;aQ=534}else if((aQ|0)==535){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[cm]&1)==0){gL=e3;gM=e2;aQ=544;break}J2(c[cK>>2]|0);gL=e3;gM=e2;aQ=544}else if((aQ|0)==537){e2=bQ(-1,-1)|0;gJ=K;gK=e2;aQ=539}else if((aQ|0)==540){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[cy]&1)==0){gN=e2;gO=e3;aQ=542;break}J2(c[cG>>2]|0);gN=e2;gO=e3;aQ=542}else if((aQ|0)==553){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==567){e3=bQ(-1,-1)|0;e2=K;if((a[t]&1)!=0){J2(c[ce>>2]|0)}if((a[b2]&1)!=0){J2(c[b4>>2]|0)}c[bV>>2]=14880;x=0;ap(388,bW|0);if(!x){gP=e3;gQ=e2;aQ=574;break}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==573){e2=bQ(-1,-1)|0;gP=e2;gQ=K;aQ=574}else if((aQ|0)==581){x=0;ap(232,0);if(x){x=0;e2=bQ(-1,-1)|0;gR=K;gS=e2;aQ=617;break}}else if((aQ|0)==597){x=0;ap(232,0);if(x){x=0;e2=bQ(-1,-1)|0;gT=K;gU=e2;aQ=622;break}}else if((aQ|0)==613){e2=bQ(-1,-1)|0;e3=K;x=0;ap(268,b3|0);if(!x){a2=e3;a3=e2;break L30}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==615){e2=bQ(-1,-1)|0;gR=K;gS=e2;aQ=617}else if((aQ|0)==618){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[bM]&1)==0){gV=e2;gW=e3;aQ=627;break}J2(c[ca>>2]|0);gV=e2;gW=e3;aQ=627}else if((aQ|0)==620){e3=bQ(-1,-1)|0;gT=K;gU=e3;aQ=622}else if((aQ|0)==623){e3=bQ(-1,-1)|0;e2=e3;e3=K;if((a[b_]&1)==0){gX=e3;gY=e2;aQ=625;break}J2(c[b6>>2]|0);gX=e3;gY=e2;aQ=625}else if((aQ|0)==636){x=0;ap(232,0);if(x){x=0;aQ=22;break L30}}else if((aQ|0)==646){e2=bQ(-1,-1)|0;e3=e2;e2=K;if((a[bE]&1)==0){a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[bF>>2]|0);a4=e2;a5=e3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}}while(0);if((aQ|0)==44){x=0;ap(268,dm|0);if(!x){a2=f7;a3=f8;break L30}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==78){gd=f9;ge=ga;aQ=81}else if((aQ|0)==132){bF=gg;bE=gf;if((a[eQ]&1)==0){a4=bE;a5=bF;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}J2(c[eR>>2]|0);a4=bE;a5=bF;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==200){gj=gh;gk=gi;aQ=203}else if((aQ|0)==259){x=0;ap(268,d7|0);if(!x){a2=gm;a3=gl;break L30}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==302){gr=gn;gs=go;aQ=312}else if((aQ|0)==307){gt=gp;gu=gq;aQ=310}else if((aQ|0)==405){x=0;ap(268,aJ|0);if(!x){a2=gw;a3=gv;break L30}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==447){gB=gx;gC=gy;aQ=457}else if((aQ|0)==452){gD=gz;gE=gA;aQ=455}else if((aQ|0)==488){x=0;ap(268,cj|0);if(!x){a2=gG;a3=gF;break L30}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==534){gL=gH;gM=gI;aQ=544}else if((aQ|0)==539){gN=gJ;gO=gK;aQ=542}else if((aQ|0)==574){x=0;ap(268,bJ|0);if(!x){a2=gQ;a3=gP;break L30}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==617){gV=gR;gW=gS;aQ=627}else if((aQ|0)==622){gX=gT;gY=gU;aQ=625}do{if((aQ|0)==81){if((a[dF]&1)==0){gb=gd;gc=ge;aQ=83;break}J2(c[dK>>2]|0);gb=gd;gc=ge;aQ=83}else if((aQ|0)==203){bF=c[f>>2]|0;bE=c[c0>>2]|0;b6=bF;while(1){if((b6|0)==(bE|0)){gZ=bE;break}if((c[b6>>2]|0)==(fB|0)){gZ=b6;break}else{b6=b6+4|0}}b6=gZ-bF>>2;b_=bF+(b6+1<<2)|0;ca=bE-b_|0;Kc(bF+(b6<<2)|0,b_|0,ca|0)|0;b_=bF+((ca>>2)+b6<<2)|0;b6=c[c0>>2]|0;if((b_|0)!=(b6|0)){c[c0>>2]=b6+(~((b6-4+(-b_|0)|0)>>>2)<<2)}J2(fD);a4=gj;a5=gk;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else if((aQ|0)==310){if((a[eo]&1)==0){gr=gt;gs=gu;aQ=312;break}J2(c[ev>>2]|0);gr=gt;gs=gu;aQ=312}else if((aQ|0)==455){if((a[bl]&1)==0){gB=gD;gC=gE;aQ=457;break}J2(c[bq>>2]|0);gB=gD;gC=gE;aQ=457}else if((aQ|0)==542){if((a[cA]&1)==0){gL=gN;gM=gO;aQ=544;break}J2(c[cF>>2]|0);gL=gN;gM=gO;aQ=544}else if((aQ|0)==625){if((a[b0]&1)==0){gV=gX;gW=gY;aQ=627;break}J2(c[b5>>2]|0);gV=gX;gW=gY;aQ=627}}while(0);if((aQ|0)==83){c[dp>>2]=14556;c[dt>>2]=14596;c[dw>>2]=14576;c[dG>>2]=14736;if((a[dH]&1)!=0){J2(c[dJ>>2]|0)}c[dG>>2]=14880;x=0;ap(388,dy|0);if(!x){x=0;ap(268,dI|0);if(!x){a4=gb;a5=gc}else{x=0;break}a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,dI|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==312){c[d9>>2]=14556;c[ed>>2]=14596;c[eg>>2]=14576;c[eq>>2]=14736;if((a[er]&1)!=0){J2(c[eu>>2]|0)}c[eq>>2]=14880;x=0;ap(388,ei|0);if(!x){x=0;ap(268,es|0);if(!x){a4=gr;a5=gs}else{x=0;break}a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,es|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==457){c[aX>>2]=14556;c[aY>>2]=14596;c[a1>>2]=14576;c[bm>>2]=14736;if((a[bn]&1)!=0){J2(c[bp>>2]|0)}c[bm>>2]=14880;x=0;ap(388,bf|0);if(!x){x=0;ap(268,bo|0);if(!x){a4=gB;a5=gC}else{x=0;break}a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,bo|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==544){c[cl>>2]=14556;c[cp>>2]=14596;c[cs>>2]=14576;c[cB>>2]=14736;if((a[cC]&1)!=0){J2(c[cE>>2]|0)}c[cB>>2]=14880;x=0;ap(388,cu|0);if(!x){x=0;ap(268,cD|0);if(!x){a4=gL;a5=gM}else{x=0;break}a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,cD|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==627){c[bL>>2]=14556;c[bP>>2]=14596;c[bT>>2]=14576;c[b1>>2]=14736;if((a[b2]&1)!=0){J2(c[b4>>2]|0)}c[b1>>2]=14880;x=0;ap(388,bW|0);if(!x){x=0;ap(268,b3|0);if(!x){a4=gV;a5=gW}else{x=0;break}a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,b3|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}}}while(0);L845:do{if((aQ|0)==30){if(bd>>>0>=aI>>>0){g_=D+4|0;g$=c[g_>>2]|0;g0=g$;eK(aH,g0);i=j;return}E=aw;aM=g|0;aS=aC+64|0;aR=aS|0;b5=aC|0;b0=aC+8|0;cF=b0|0;cA=aC+12|0;bq=aC+64|0;bl=aC+4|0;ev=cA;eo=aC+8|0;c0=cA|0;dK=aC+16|0;dF=aC+20|0;bJ=aC+60|0;cj=b0;b0=aD;aJ=e+4|0;d7=aF;eR=aG;eQ=e+16|0;dm=aE;b_=aC+12|0;b6=aC+44|0;ca=aC+64|0;bM=aC+52|0;bV=aE+8|0;ce=aF+8|0;cG=e+12|0;cy=e+8|0;cK=aF+1|0;cm=aF|0;cP=aF+4|0;bA=aD+8|0;ct=aD+1|0;cO=aD|0;br=aD+4|0;bj=q+8|0;bv=h+8|0;aV=h+12|0;a0=g|0;bz=aA;dT=aA+8|0;dS=aA+1|0;d3=aA|0;d2=aA+4|0;d_=f+4|0;dZ=f+8|0;ew=f|0;em=ay;eA=az;ea=ay+8|0;eh=az+8|0;eE=az+1|0;de=az|0;dd=az+4|0;c5=ay+1|0;c4=ay|0;c9=ay+4|0;c3=aw+8|0;eM=aw+1|0;eL=aw|0;dL=aw+4|0;dC=aC+44|0;dx=bd;L850:while(1){x=0;aq(276,av|0,0);if(x){x=0;aQ=18;break}dR=c[(c[aL>>2]|0)+(dx<<2)>>2]|0;e3=dR+28|0;if((a[e3]&1)==0){c[E>>2]=c[e3>>2];c[E+4>>2]=c[e3+4>>2];c[E+8>>2]=c[e3+8>>2];g1=a[E]|0}else{e2=c[dR+36>>2]|0;bD=c[dR+32>>2]|0;if(bD>>>0>4294967279>>>0){aQ=652;break}if(bD>>>0<11>>>0){dW=bD<<1&255;a[E]=dW;g2=eM;g3=dW}else{dW=bD+16&-16;dV=(x=0,as(230,dW|0)|0);if(x){x=0;aQ=696;break}c[c3>>2]=dV;dU=dW|1;c[eL>>2]=dU;c[dL>>2]=bD;g2=dV;g3=dU&255}Kb(g2|0,e2|0,bD)|0;a[g2+bD|0]=0;g1=g3}bD=(et(aM,aw)|0)==0;if((g1&1)!=0){J2(c[c3>>2]|0)}do{if(bD){if((a[dR+44|0]&1)!=0){e2=(x=0,as(230,60)|0);if(x){x=0;aQ=696;break L850}dU=e2;c[l>>2]=dU;e2=c[d_>>2]|0;if((e2|0)==(c[dZ>>2]|0)){x=0;aq(376,ew|0,l|0);if(x){x=0;aQ=696;break L850}g4=c[l>>2]|0}else{if((e2|0)==0){g5=0}else{c[e2>>2]=dU;g5=c[d_>>2]|0}c[d_>>2]=g5+4;g4=dU}g6=g4;dU=dR+4|0;if((a[dU]&1)==0){c[em>>2]=c[dU>>2];c[em+4>>2]=c[dU+4>>2];c[em+8>>2]=c[dU+8>>2]}else{dU=c[dR+12>>2]|0;e2=c[dR+8>>2]|0;if(e2>>>0>4294967279>>>0){aQ=673;break L850}if(e2>>>0<11>>>0){a[em]=e2<<1;g7=c5}else{dV=e2+16&-16;dW=(x=0,as(230,dV|0)|0);if(x){x=0;aQ=699;break L850}c[ea>>2]=dW;c[c4>>2]=dV|1;c[c9>>2]=e2;g7=dW}Kb(g7|0,dU|0,e2)|0;a[g7+e2|0]=0}e2=dR+16|0;dU=k;c[dU>>2]=c[e2>>2];c[dU+4>>2]=c[e2+4>>2];c[dU+8>>2]=c[e2+8>>2];x=0;aB(34,g4|0,ay|0,k|0,0,1,1);if(x){x=0;g8=1;aQ=702;break L850}if((a[e3]&1)==0){c[eA>>2]=c[e3>>2];c[eA+4>>2]=c[e3+4>>2];c[eA+8>>2]=c[e3+8>>2]}else{e2=c[dR+36>>2]|0;dU=c[dR+32>>2]|0;if(dU>>>0>4294967279>>>0){aQ=684;break L850}if(dU>>>0<11>>>0){a[eA]=dU<<1;g9=eE}else{dW=dU+16&-16;dV=(x=0,as(230,dW|0)|0);if(x){x=0;g8=0;aQ=702;break L850}c[eh>>2]=dV;c[de>>2]=dW|1;c[dd>>2]=dU;g9=dV}Kb(g9|0,e2|0,dU)|0;a[g9+dU|0]=0}dU=(x=0,aK(176,a0|0,az|0)|0);if(x){x=0;aQ=705;break L850}c[dU>>2]=g4;if((a[eA]&1)!=0){J2(c[eh>>2]|0)}if((a[em]&1)==0){break}J2(c[ea>>2]|0);break}dU=c[dR+40>>2]|0;if((dU|0)!=0){e2=c[bv>>2]|0;dV=c[aV>>2]|0;dW=c[(c[dU>>2]|0)+20>>2]|0;d6=(x=0,ax(32,h|0,g|0,dV|0)|0);if(x){x=0;aQ=696;break L850}d5=(x=0,aK(dW|0,dU|0,d6|0)|0);if(x){x=0;aQ=696;break L850}c[bv>>2]=e2;c[aV>>2]=dV;dV=d5|0;if((a[e3]&1)==0){c[bz>>2]=c[e3>>2];c[bz+4>>2]=c[e3+4>>2];c[bz+8>>2]=c[e3+8>>2]}else{d5=c[dR+36>>2]|0;e2=c[dR+32>>2]|0;if(e2>>>0>4294967279>>>0){aQ=722;break L850}if(e2>>>0<11>>>0){a[bz]=e2<<1;ha=dS}else{d6=e2+16&-16;dU=(x=0,as(230,d6|0)|0);if(x){x=0;aQ=696;break L850}c[dT>>2]=dU;c[d3>>2]=d6|1;c[d2>>2]=e2;ha=dU}Kb(ha|0,d5|0,e2)|0;a[ha+e2|0]=0}e2=(x=0,aK(176,a0|0,aA|0)|0);if(x){x=0;aQ=732;break L850}c[e2>>2]=dV;if((a[bz]&1)==0){break}J2(c[dT>>2]|0);break}c[cF>>2]=14576;c[b5>>2]=31212;c[bq>>2]=31232;c[bl>>2]=0;x=0;aq(200,aC+64|0,ev|0);if(x){x=0;aQ=744;break L850}c[aC+136>>2]=0;c[aC+140>>2]=-1;c[b5>>2]=14556;c[aR>>2]=14596;c[cF>>2]=14576;c[c0>>2]=14880;HA(dK);Ke(dF|0,0,24)|0;c[c0>>2]=14736;Ke(dC|0,0,16)|0;c[bJ>>2]=24;Ke(r|0,0,12)|0;x=0;aq(214,cA|0,q|0);if(x){x=0;aQ=738;break L850}if((a[r]&1)!=0){J2(c[bj>>2]|0)}dV=(x=0,aK(112,cj|0,12432)|0);if(x){x=0;aQ=786;break L850}if((a[e3]&1)==0){c[b0>>2]=c[e3>>2];c[b0+4>>2]=c[e3+4>>2];c[b0+8>>2]=c[e3+8>>2]}else{e2=c[dR+36>>2]|0;d5=c[dR+32>>2]|0;if(d5>>>0>4294967279>>>0){aQ=752;break L850}if(d5>>>0<11>>>0){a[b0]=d5<<1;hb=ct}else{dU=d5+16&-16;d6=(x=0,as(230,dU|0)|0);if(x){x=0;aQ=786;break L850}c[bA>>2]=d6;c[cO>>2]=dU|1;c[br>>2]=d5;hb=d6}Kb(hb|0,e2|0,d5)|0;a[hb+d5|0]=0}d5=(x=0,aK(802,dV|0,aD|0)|0);if(x){x=0;aQ=789;break L850}dV=(x=0,aK(112,d5|0,11168)|0);if(x){x=0;aQ=789;break L850}x=0,aK(802,dV|0,b|0)|0;if(x){x=0;aQ=789;break L850}if((a[b0]&1)!=0){J2(c[bA>>2]|0)}x=0;aq(560,aE|0,cA|0);if(x){x=0;aQ=786;break L850}if((a[aJ]&1)==0){c[d7>>2]=c[aJ>>2];c[d7+4>>2]=c[aJ+4>>2];c[d7+8>>2]=c[aJ+8>>2]}else{dV=c[cG>>2]|0;d5=c[cy>>2]|0;if(d5>>>0>4294967279>>>0){aQ=768;break L850}if(d5>>>0<11>>>0){a[d7]=d5<<1;hc=cK}else{e2=d5+16&-16;d6=(x=0,as(230,e2|0)|0);if(x){x=0;aQ=791;break L850}c[ce>>2]=d6;c[cm>>2]=e2|1;c[cP>>2]=d5;hc=d6}Kb(hc|0,dV|0,d5)|0;a[hc+d5|0]=0}c[eR>>2]=c[eQ>>2];c[eR+4>>2]=c[eQ+4>>2];c[eR+8>>2]=c[eQ+8>>2];x=0;aP(362,aE|0,aF|0,aG|0);if(x){x=0;aQ=794;break L850}if((a[d7]&1)!=0){J2(c[ce>>2]|0)}if((a[dm]&1)!=0){J2(c[bV>>2]|0)}c[b5>>2]=14556;c[bq>>2]=14596;c[eo>>2]=14576;c[b_>>2]=14736;if((a[b6]&1)!=0){J2(c[bM>>2]|0)}c[b_>>2]=14880;x=0;ap(388,dK|0);if(x){x=0;aQ=784;break L850}x=0;ap(268,ca|0);if(x){x=0;aQ=696;break L850}}}while(0);x=0;ap(436,av|0);if(x){x=0;aQ=18;break}dR=dx+1|0;if(dR>>>0<aI>>>0){dx=dR}else{aQ=812;break}}do{if((aQ|0)==18){dx=bQ(-1,-1)|0;a2=K;a3=dx;break L30}else if((aQ|0)==652){x=0;ap(232,0);if(x){x=0;aQ=697;break}}else if((aQ|0)==673){x=0;ap(232,0);if(x){x=0;dx=bQ(-1,-1)|0;hd=K;he=dx;aQ=701;break}}else if((aQ|0)==684){x=0;ap(232,0);if(x){x=0;dx=bQ(-1,-1)|0;hf=K;hg=dx;hh=0;aQ=704;break}}else if((aQ|0)==696){dx=bQ(-1,-1)|0;hi=K;hj=dx;aQ=698}else if((aQ|0)==699){dx=bQ(-1,-1)|0;hd=K;he=dx;aQ=701}else if((aQ|0)==702){dx=bQ(-1,-1)|0;hf=K;hg=dx;hh=g8;aQ=704}else if((aQ|0)==705){dx=bQ(-1,-1)|0;eQ=dx;dx=K;if((a[eA]&1)==0){hk=0;hl=dx;hm=eQ;aQ=707;break}J2(c[eh>>2]|0);hk=0;hl=dx;hm=eQ;aQ=707}else if((aQ|0)==722){x=0;ap(232,0);if(x){x=0;aQ=697;break}}else if((aQ|0)==732){eQ=bQ(-1,-1)|0;dx=eQ;eQ=K;if((a[bz]&1)==0){hn=eQ;ho=dx;break}J2(c[dT>>2]|0);hn=eQ;ho=dx}else if((aQ|0)==738){dx=bQ(-1,-1)|0;eQ=K;if((a[r]&1)!=0){J2(c[bj>>2]|0)}if((a[b6]&1)!=0){J2(c[bM>>2]|0)}c[c0>>2]=14880;x=0;ap(388,dK|0);if(!x){hp=dx;hq=eQ;aQ=745;break}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==744){eQ=bQ(-1,-1)|0;hp=eQ;hq=K;aQ=745}else if((aQ|0)==752){x=0;ap(232,0);if(x){x=0;eQ=bQ(-1,-1)|0;hr=K;hs=eQ;aQ=788;break}}else if((aQ|0)==768){x=0;ap(232,0);if(x){x=0;eQ=bQ(-1,-1)|0;ht=K;hu=eQ;aQ=793;break}}else if((aQ|0)==784){eQ=bQ(-1,-1)|0;dx=K;x=0;ap(268,ca|0);if(!x){hi=dx;hj=eQ;aQ=698;break}else{x=0}bQ(-1,-1,0)|0;bU()}else if((aQ|0)==786){eQ=bQ(-1,-1)|0;hr=K;hs=eQ;aQ=788}else if((aQ|0)==789){eQ=bQ(-1,-1)|0;dx=eQ;eQ=K;if((a[b0]&1)==0){hv=eQ;hw=dx;aQ=798;break}J2(c[bA>>2]|0);hv=eQ;hw=dx;aQ=798}else if((aQ|0)==791){dx=bQ(-1,-1)|0;ht=K;hu=dx;aQ=793}else if((aQ|0)==794){dx=bQ(-1,-1)|0;eQ=dx;dx=K;if((a[d7]&1)==0){hx=dx;hy=eQ;aQ=796;break}J2(c[ce>>2]|0);hx=dx;hy=eQ;aQ=796}else if((aQ|0)==812){g_=D+4|0;g$=c[g_>>2]|0;g0=g$;eK(aH,g0);i=j;return}}while(0);do{if((aQ|0)==697){ce=bQ(-1,-1)|0;hi=K;hj=ce;aQ=698}else if((aQ|0)==701){hz=he;hA=hd;aQ=710}else if((aQ|0)==704){hk=hh;hl=hf;hm=hg;aQ=707}else if((aQ|0)==745){x=0;ap(268,aS|0);if(!x){hi=hq;hj=hp;aQ=698;break}else{x=0;bQ(-1,-1,0)|0;bU()}}else if((aQ|0)==788){hv=hr;hw=hs;aQ=798}else if((aQ|0)==793){hx=ht;hy=hu;aQ=796}}while(0);do{if((aQ|0)==698){hn=hi;ho=hj}else if((aQ|0)==707){if((a[em]&1)==0){if(hk){hz=hm;hA=hl;aQ=710;break}else{hn=hl;ho=hm;break}}else{J2(c[ea>>2]|0);if(hk){hz=hm;hA=hl;aQ=710;break}else{hn=hl;ho=hm;break}}}else if((aQ|0)==796){if((a[dm]&1)==0){hv=hx;hw=hy;aQ=798;break}J2(c[bV>>2]|0);hv=hx;hw=hy;aQ=798}}while(0);do{if((aQ|0)==710){bV=c[f>>2]|0;dm=c[d_>>2]|0;ea=bV;while(1){if((ea|0)==(dm|0)){hB=dm;break}if((c[ea>>2]|0)==(g4|0)){hB=ea;break}else{ea=ea+4|0}}ea=hB-bV>>2;em=bV+(ea+1<<2)|0;aS=dm-em|0;Kc(bV+(ea<<2)|0,em|0,aS|0)|0;em=bV+((aS>>2)+ea<<2)|0;ea=c[d_>>2]|0;if((em|0)!=(ea|0)){c[d_>>2]=ea+(~((ea-4+(-em|0)|0)>>>2)<<2)}J2(g6);hn=hA;ho=hz}else if((aQ|0)==798){c[b5>>2]=14556;c[bq>>2]=14596;c[eo>>2]=14576;c[b_>>2]=14736;if((a[b6]&1)!=0){J2(c[bM>>2]|0)}c[b_>>2]=14880;x=0;ap(388,dK|0);if(!x){x=0;ap(268,ca|0);if(!x){hn=hv;ho=hw;break}else{x=0;break L845}}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,ca|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);x=0;ap(436,av|0);if(!x){a4=hn;a5=ho}else{x=0;break}a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}}while(0);bQ(-1,-1,0)|0;bU()}}while(0);if((aQ|0)==22){aQ=bQ(-1,-1)|0;a2=K;a3=aQ}a4=a2;a5=a3;a6=D+4|0;a7=c[a6>>2]|0;a8=a7;eK(aH,a8);a9=a5;ba=0;bb=a9;bc=a4;be(bb|0)}function ek(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+8|0;f=e|0;g=ev(b,f,d)|0;h=c[g>>2]|0;if((h|0)!=0){j=h;k=j+28|0;i=e;return k|0}h=J0(32)|0;l=h;m=h+16|0;L4:do{if((m|0)!=0){n=d;if((a[n]&1)==0){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];break}n=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[m]=o<<1;p=h+17|0}else{q=o+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;break}c[h+24>>2]=r;c[m>>2]=q|1;c[h+20>>2]=o;p=r}Kb(p|0,n|0,o)|0;a[p+o|0]=0;break L4}}while(0);o=bQ(-1,-1)|0;if((h|0)==0){be(o|0)}J2(h);be(o|0)}}while(0);p=h+28|0;if((p|0)!=0){c[p>>2]=0}p=c[f>>2]|0;f=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=p;c[g>>2]=f;p=b|0;h=c[c[p>>2]>>2]|0;if((h|0)==0){s=f}else{c[p>>2]=h;s=c[g>>2]|0}es(c[b+4>>2]|0,s);s=b+8|0;c[s>>2]=(c[s>>2]|0)+1;j=l;k=j+28|0;i=e;return k|0}function el(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=g|0;a[k]=0;c[g+4>>2]=b;l=b;m=c[(c[l>>2]|0)-12>>2]|0;n=b;L1:do{if((c[n+(m+16)>>2]|0)==0){o=c[n+(m+72)>>2]|0;if((o|0)!=0){x=0,as(56,o|0)|0;if(x){x=0;p=15;break}}a[k]=1;o=Kf(d|0)|0;q=c[(c[l>>2]|0)-12>>2]|0;c[h>>2]=c[n+(q+24)>>2];r=d+o|0;o=(c[n+(q+4)>>2]&176|0)==32?r:d;s=n+q|0;t=n+(q+76)|0;q=c[t>>2]|0;u=q&255;L6:do{if((q|0)==-1){x=0;aq(346,f|0,s|0);if(x){x=0;p=16;break}v=(x=0,aK(196,f|0,40280)|0);do{if(!x){w=(x=0,aK(c[(c[v>>2]|0)+28>>2]|0,v|0,32)|0);if(x){x=0;break}x=0;ap(388,f|0);if(x){x=0;p=16;break L6}c[t>>2]=w<<24>>24;y=w;p=12;break L6}else{x=0}}while(0);v=bQ(-1,-1,0)|0;w=K;x=0;ap(388,f|0);if(!x){z=w;A=v;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{y=u;p=12}}while(0);do{if((p|0)==12){x=0;aG(56,j|0,h|0,d|0,o|0,r|0,s|0,y|0);if(x){x=0;p=16;break}if((c[j>>2]|0)!=0){p=18;break L1}u=c[(c[l>>2]|0)-12>>2]|0;x=0;aq(362,n+u|0,c[n+(u+16)>>2]|5|0);if(!x){p=18;break L1}else{x=0;p=16}}}while(0);if((p|0)==16){s=bQ(-1,-1,0)|0;z=K;A=s}x=0;ap(138,g|0);if(!x){B=A;break}else{x=0}C=bQ(-1,-1,0)|0;D=K;bU();return 0}else{p=18}}while(0);do{if((p|0)==18){x=0;ap(138,g|0);if(x){x=0;p=15;break}i=e;return b|0}}while(0);if((p|0)==15){p=bQ(-1,-1,0)|0;B=p}bA(B|0)|0;x=0;ap(178,n+(c[(c[l>>2]|0)-12>>2]|0)|0);if(!x){aZ();i=e;return b|0}else{x=0}b=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(b|0)}else{x=0;C=bQ(-1,-1,0)|0;D=K;bU();return 0}return 0}function em(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0;e=i;i=i+32|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=g|0;a[k]=0;c[g+4>>2]=b;l=b;m=c[(c[l>>2]|0)-12>>2]|0;n=b;L1:do{if((c[n+(m+16)>>2]|0)==0){o=c[n+(m+72)>>2]|0;if((o|0)!=0){x=0,as(56,o|0)|0;if(x){x=0;p=30;break}}a[k]=1;o=d;q=a[d]|0;r=q&255;if((r&1|0)==0){s=r>>>1}else{s=c[d+4>>2]|0}r=c[(c[l>>2]|0)-12>>2]|0;c[h>>2]=c[n+(r+24)>>2];t=(q&1)==0;if(t){u=o+1|0}else{u=c[d+8>>2]|0}do{if((c[n+(r+4)>>2]&176|0)==32){if(t){v=o+1+s|0;p=18;break}else{w=(c[d+8>>2]|0)+s|0;p=17;break}}else{if(t){v=o+1|0;p=18;break}else{w=c[d+8>>2]|0;p=17;break}}}while(0);if((p|0)==17){y=c[d+8>>2]|0;z=w}else if((p|0)==18){y=o+1|0;z=v}t=y+s|0;q=n+r|0;A=n+(r+76)|0;B=c[A>>2]|0;C=B&255;L27:do{if((B|0)==-1){x=0;aq(346,f|0,q|0);if(x){x=0;p=31;break}D=(x=0,aK(196,f|0,40280)|0);do{if(!x){E=(x=0,aK(c[(c[D>>2]|0)+28>>2]|0,D|0,32)|0);if(x){x=0;break}x=0;ap(388,f|0);if(x){x=0;p=31;break L27}c[A>>2]=E<<24>>24;F=E;p=27;break L27}else{x=0}}while(0);D=bQ(-1,-1,0)|0;E=K;x=0;ap(388,f|0);if(!x){G=E;H=D;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{F=C;p=27}}while(0);do{if((p|0)==27){x=0;aG(56,j|0,h|0,u|0,z|0,t|0,q|0,F|0);if(x){x=0;p=31;break}if((c[j>>2]|0)!=0){p=33;break L1}C=c[(c[l>>2]|0)-12>>2]|0;x=0;aq(362,n+C|0,c[n+(C+16)>>2]|5|0);if(!x){p=33;break L1}else{x=0;p=31}}}while(0);if((p|0)==31){q=bQ(-1,-1,0)|0;G=K;H=q}x=0;ap(138,g|0);if(!x){I=H;break}else{x=0}J=bQ(-1,-1,0)|0;L=K;bU();return 0}else{p=33}}while(0);do{if((p|0)==33){x=0;ap(138,g|0);if(x){x=0;p=30;break}i=e;return b|0}}while(0);if((p|0)==30){p=bQ(-1,-1,0)|0;I=p}bA(I|0)|0;x=0;ap(178,n+(c[(c[l>>2]|0)-12>>2]|0)|0);if(!x){aZ();i=e;return b|0}else{x=0}b=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(b|0)}else{x=0;J=bQ(-1,-1,0)|0;L=K;bU();return 0}return 0}function en(b){b=b|0;var d=0;c[b>>2]=14556;c[b+64>>2]=14596;c[b+8>>2]=14576;d=b+12|0;c[d>>2]=14736;if((a[b+44|0]&1)!=0){J2(c[b+52>>2]|0)}c[d>>2]=14880;x=0;ap(388,b+16|0);if(!x){C7(b+64|0);return}else{x=0}d=bQ(-1,-1)|0;x=0;ap(268,b+64|0);if(!x){be(d|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function eo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+8|0;f=e|0;g=er(b,f,d)|0;h=c[g>>2]|0;if((h|0)!=0){j=h;k=j+28|0;i=e;return k|0}h=J0(32)|0;l=h;m=h+16|0;L4:do{if((m|0)!=0){n=d;if((a[n]&1)==0){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];break}n=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[m]=o<<1;p=h+17|0}else{q=o+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;break}c[h+24>>2]=r;c[m>>2]=q|1;c[h+20>>2]=o;p=r}Kb(p|0,n|0,o)|0;a[p+o|0]=0;break L4}}while(0);o=bQ(-1,-1)|0;if((h|0)==0){be(o|0)}J2(h);be(o|0)}}while(0);p=h+28|0;if((p|0)!=0){c[p>>2]=0}p=c[f>>2]|0;f=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=p;c[g>>2]=f;p=b|0;h=c[c[p>>2]>>2]|0;if((h|0)==0){s=f}else{c[p>>2]=h;s=c[g>>2]|0}es(c[b+4>>2]|0,s);s=b+8|0;c[s>>2]=(c[s>>2]|0)+1;j=l;k=j+28|0;i=e;return k|0}function ep(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=Kd(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==16){t=0;u=d|0}else if((t|0)==17){t=0;if(o){v=e>>>1}else{v=c[d+20>>2]|0}if(h){w=i}else{w=c[k>>2]|0}if(r){x=m+1|0}else{x=c[d+24>>2]|0}if(g){y=b}else{y=c[j>>2]|0}m=Kd(x|0,y|0,(w>>>0<v>>>0?w:v)|0)|0;if((m|0)==0){if(v>>>0>=w>>>0){f=1;t=36;break}}else{if((m|0)>=0){f=1;t=35;break}}u=d+4|0}m=c[u>>2]|0;if((m|0)==0){f=0;t=33;break}else{d=m}}if((t|0)==33){return f|0}else if((t|0)==35){return f|0}else if((t|0)==36){return f|0}return 0}function eq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function er(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=(f&1|0)==0;j=f>>>1;f=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;e=g;while(1){g=e+16|0;if(i){m=j}else{m=c[l>>2]|0}n=g;o=a[g]|0;g=o&255;p=(g&1|0)==0;if(p){q=g>>>1}else{q=c[e+20>>2]|0}if(f){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=Kd(r|0,t|0,(q>>>0<m>>>0?q:m)|0)|0;if((o|0)==0){if(m>>>0<q>>>0){u=16}}else{if((o|0)<0){u=16}}if((u|0)==16){u=0;v=e|0;o=c[v>>2]|0;if((o|0)==0){u=17;break}else{e=o;continue}}if(p){w=g>>>1}else{w=c[e+20>>2]|0}if(i){x=j}else{x=c[l>>2]|0}if(s){y=n+1|0}else{y=c[e+24>>2]|0}if(f){z=b}else{z=c[k>>2]|0}n=Kd(y|0,z|0,(x>>>0<w>>>0?x:w)|0)|0;if((n|0)==0){if(w>>>0>=x>>>0){u=33;break}}else{if((n|0)>=0){u=33;break}}A=e+4|0;n=c[A>>2]|0;if((n|0)==0){u=32;break}else{e=n}}if((u|0)==17){c[d>>2]=e;h=v;return h|0}else if((u|0)==33){c[d>>2]=e;h=d;return h|0}else if((u|0)==32){c[d>>2]=e;h=A;return h|0}return 0}function es(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=(d|0)==(b|0);a[d+12|0]=e&1;if(e){return}else{f=d}while(1){g=f+8|0;h=c[g>>2]|0;d=h+12|0;if((a[d]&1)!=0){i=40;break}j=h+8|0;k=c[j>>2]|0;e=c[k>>2]|0;if((h|0)==(e|0)){l=c[k+4>>2]|0;if((l|0)==0){i=7;break}m=l+12|0;if((a[m]&1)!=0){i=7;break}a[d]=1;a[k+12|0]=(k|0)==(b|0)|0;a[m]=1}else{if((e|0)==0){i=24;break}m=e+12|0;if((a[m]&1)!=0){i=24;break}a[d]=1;a[k+12|0]=(k|0)==(b|0)|0;a[m]=1}if((k|0)==(b|0)){i=42;break}else{f=k}}if((i|0)==7){if((f|0)==(c[h>>2]|0)){n=h;o=k}else{b=h+4|0;m=c[b>>2]|0;d=m|0;e=c[d>>2]|0;c[b>>2]=e;if((e|0)==0){p=k}else{c[e+8>>2]=h;p=c[j>>2]|0}e=m+8|0;c[e>>2]=p;p=c[j>>2]|0;b=p|0;if((c[b>>2]|0)==(h|0)){c[b>>2]=m}else{c[p+4>>2]=m}c[d>>2]=h;c[j>>2]=m;n=m;o=c[e>>2]|0}a[n+12|0]=1;a[o+12|0]=0;n=o|0;e=c[n>>2]|0;m=e+4|0;d=c[m>>2]|0;c[n>>2]=d;if((d|0)!=0){c[d+8>>2]=o}d=o+8|0;c[e+8>>2]=c[d>>2];n=c[d>>2]|0;p=n|0;if((c[p>>2]|0)==(o|0)){c[p>>2]=e}else{c[n+4>>2]=e}c[m>>2]=o;c[d>>2]=e;return}else if((i|0)==40){return}else if((i|0)==42){return}else if((i|0)==24){i=h|0;if((f|0)==(c[i>>2]|0)){e=f+4|0;d=c[e>>2]|0;c[i>>2]=d;if((d|0)==0){q=k}else{c[d+8>>2]=h;q=c[j>>2]|0}c[g>>2]=q;q=c[j>>2]|0;d=q|0;if((c[d>>2]|0)==(h|0)){c[d>>2]=f}else{c[q+4>>2]=f}c[e>>2]=h;c[j>>2]=f;r=f;s=c[g>>2]|0}else{r=h;s=k}a[r+12|0]=1;a[s+12|0]=0;r=s+4|0;k=c[r>>2]|0;h=k|0;g=c[h>>2]|0;c[r>>2]=g;if((g|0)!=0){c[g+8>>2]=s}g=s+8|0;c[k+8>>2]=c[g>>2];r=c[g>>2]|0;f=r|0;if((c[f>>2]|0)==(s|0)){c[f>>2]=k}else{c[r+4>>2]=k}c[h>>2]=s;c[g>>2]=k;return}}function et(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=Kd(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==16){t=0;u=d|0}else if((t|0)==17){t=0;if(o){v=e>>>1}else{v=c[d+20>>2]|0}if(h){w=i}else{w=c[k>>2]|0}if(r){x=m+1|0}else{x=c[d+24>>2]|0}if(g){y=b}else{y=c[j>>2]|0}m=Kd(x|0,y|0,(w>>>0<v>>>0?w:v)|0)|0;if((m|0)==0){if(v>>>0>=w>>>0){f=1;t=33;break}}else{if((m|0)>=0){f=1;t=36;break}}u=d+4|0}m=c[u>>2]|0;if((m|0)==0){f=0;t=34;break}else{d=m}}if((t|0)==36){return f|0}else if((t|0)==33){return f|0}else if((t|0)==34){return f|0}return 0}function eu(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+16|0;l=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[l>>2];l=k|0;m=d|0;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g|0;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;do{if((h|0)>0){if((cF[c[(c[d>>2]|0)+48>>2]&127](d,e,h)|0)==(h|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){if(q>>>0<11>>>0){h=q<<1&255;e=l;a[e]=h;r=l+1|0;s=h;t=e}else{e=q+16&-16;h=J0(e)|0;c[l+8>>2]=h;g=e|1;c[l>>2]=g;c[l+4>>2]=q;r=h;s=g&255;t=l}Ke(r|0,j|0,q|0)|0;a[r+q|0]=0;if((s&1)==0){u=l+1|0}else{u=c[l+8>>2]|0}g=(x=0,ax(c[(c[d>>2]|0)+48>>2]|0,d|0,u|0,q|0)|0);if(x){x=0;h=bQ(-1,-1)|0;if((a[t]&1)==0){be(h|0)}J2(c[l+8>>2]|0);be(h|0)}if((g|0)==(q|0)){if((a[t]&1)==0){break}J2(c[l+8>>2]|0);break}c[m>>2]=0;c[b>>2]=0;if((a[t]&1)==0){i=k;return}J2(c[l+8>>2]|0);i=k;return}}while(0);l=n-o|0;do{if((l|0)>0){if((cF[c[(c[d>>2]|0)+48>>2]&127](d,f,l)|0)==(l|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function ev(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=f>>>1;j=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;L5:do{if((f&1|0)==0){e=g;while(1){m=e+16|0;n=m;o=a[m]|0;m=o&255;p=(m&1|0)==0;if(p){q=m>>>1}else{q=c[e+20>>2]|0}if(j){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=Kd(r|0,t|0,(q>>>0<i>>>0?q:i)|0)|0;if((o|0)==0){if(i>>>0<q>>>0){u=26}}else{if((o|0)<0){u=26}}if((u|0)==26){u=0;o=e|0;v=c[o>>2]|0;if((v|0)==0){w=e;x=o;u=39;break}else{e=v;continue}}if(p){y=m>>>1}else{y=c[e+20>>2]|0}if(s){z=n+1|0}else{z=c[e+24>>2]|0}if(j){A=b}else{A=c[k>>2]|0}n=Kd(z|0,A|0,(i>>>0<y>>>0?i:y)|0)|0;if((n|0)==0){if(y>>>0>=i>>>0){B=e;u=53;break L5}}else{if((n|0)>=0){B=e;u=53;break L5}}n=e+4|0;s=c[n>>2]|0;if((s|0)==0){C=e;D=n;u=52;break}else{e=s}}}else{e=g;while(1){s=e+16|0;n=c[l>>2]|0;m=s;p=a[s]|0;s=p&255;v=(s&1|0)==0;if(v){E=s>>>1}else{E=c[e+20>>2]|0}if(j){F=b}else{F=c[k>>2]|0}o=(p&1)==0;if(o){G=m+1|0}else{G=c[e+24>>2]|0}p=Kd(F|0,G|0,(E>>>0<n>>>0?E:n)|0)|0;if((p|0)==0){if(n>>>0<E>>>0){u=38}}else{if((p|0)<0){u=38}}if((u|0)==38){u=0;p=e|0;n=c[p>>2]|0;if((n|0)==0){w=e;x=p;u=39;break}else{e=n;continue}}if(v){H=s>>>1}else{H=c[e+20>>2]|0}s=c[l>>2]|0;if(o){I=m+1|0}else{I=c[e+24>>2]|0}if(j){J=b}else{J=c[k>>2]|0}m=Kd(I|0,J|0,(s>>>0<H>>>0?s:H)|0)|0;if((m|0)==0){if(H>>>0>=s>>>0){B=e;u=53;break L5}}else{if((m|0)>=0){B=e;u=53;break L5}}m=e+4|0;s=c[m>>2]|0;if((s|0)==0){C=e;D=m;u=52;break}else{e=s}}}}while(0);if((u|0)==52){c[d>>2]=C;h=D;return h|0}else if((u|0)==53){c[d>>2]=B;h=d;return h|0}else if((u|0)==39){c[d>>2]=w;h=x;return h|0}return 0}function ew(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=b;f=c[d+48>>2]|0;if((f&16|0)!=0){g=d+44|0;h=c[g>>2]|0;i=c[d+24>>2]|0;if(h>>>0<i>>>0){c[g>>2]=i;j=i}else{j=h}h=c[d+20>>2]|0;i=h;g=j-i|0;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){a[e]=g<<1;k=b+1|0}else{l=g+16&-16;m=J0(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=g;k=m}if((h|0)==(j|0)){n=k}else{m=j+(-i|0)|0;i=k;g=h;while(1){a[i]=a[g]|0;h=g+1|0;if((h|0)==(j|0)){break}else{i=i+1|0;g=h}}n=k+m|0}a[n]=0;return}if((f&8|0)==0){Ke(e|0,0,12)|0;return}f=c[d+8>>2]|0;n=c[d+16>>2]|0;d=f;m=n-d|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[e]=m<<1;o=b+1|0}else{e=m+16&-16;k=J0(e)|0;c[b+8>>2]=k;c[b>>2]=e|1;c[b+4>>2]=m;o=k}if((f|0)==(n|0)){p=o}else{k=n+(-d|0)|0;d=o;m=f;while(1){a[d]=a[m]|0;f=m+1|0;if((f|0)==(n|0)){break}else{d=d+1|0;m=f}}p=o+k|0}a[p]=0;return}function ex(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b>>2]=14556;c[b+64>>2]=14596;c[b+8>>2]=14576;d=b+12|0;c[d>>2]=14736;if((a[b+44|0]&1)!=0){J2(c[b+52>>2]|0)}c[d>>2]=14880;x=0;ap(388,b+16|0);if(x){x=0;d=bQ(-1,-1)|0;e=K;x=0;ap(268,b+64|0);if(!x){f=e;g=d;h=b;J2(h);be(g|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,b+64|0);if(!x){J2(b);return}else{x=0}d=bQ(-1,-1)|0;f=K;g=d;h=b;J2(h);be(g|0)}function ey(b){b=b|0;var d=0,e=0;d=b-144+136|0;c[d>>2]=14556;b=d+64|0;c[b>>2]=14596;c[d+8>>2]=14576;e=d+12|0;c[e>>2]=14736;if((a[d+44|0]&1)!=0){J2(c[d+52>>2]|0)}c[e>>2]=14880;x=0;ap(388,d+16|0);if(!x){C7(b);return}else{x=0}d=bQ(-1,-1)|0;x=0;ap(268,b|0);if(!x){be(d|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function ez(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b-144+136|0;c[d>>2]=14556;b=d+64|0;c[b>>2]=14596;c[d+8>>2]=14576;e=d+12|0;c[e>>2]=14736;if((a[d+44|0]&1)!=0){J2(c[d+52>>2]|0)}c[e>>2]=14880;x=0;ap(388,d+16|0);if(x){x=0;e=bQ(-1,-1)|0;f=K;x=0;ap(268,b|0);if(!x){g=f;h=e;i=d;J2(i);be(h|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,b|0);if(!x){J2(d);return}else{x=0}b=bQ(-1,-1)|0;g=K;h=b;i=d;J2(i);be(h|0)}function eA(b){b=b|0;var d=0,e=0,f=0;d=b;e=c[(c[b>>2]|0)-12>>2]|0;c[d+e>>2]=14556;b=d+(e+64)|0;c[b>>2]=14596;c[d+(e+8)>>2]=14576;f=d+(e+12)|0;c[f>>2]=14736;if((a[d+(e+44)|0]&1)!=0){J2(c[d+(e+52)>>2]|0)}c[f>>2]=14880;x=0;ap(388,d+(e+16)|0);if(!x){C7(b);return}else{x=0}e=bQ(-1,-1)|0;x=0;ap(268,b|0);if(!x){be(e|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function eB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b;e=c[(c[b>>2]|0)-12>>2]|0;b=d+e|0;c[b>>2]=14556;f=d+(e+64)|0;c[f>>2]=14596;c[d+(e+8)>>2]=14576;g=d+(e+12)|0;c[g>>2]=14736;if((a[d+(e+44)|0]&1)!=0){J2(c[d+(e+52)>>2]|0)}c[g>>2]=14880;x=0;ap(388,d+(e+16)|0);if(x){x=0;e=bQ(-1,-1)|0;d=K;x=0;ap(268,f|0);if(!x){h=d;i=e;J2(b);be(i|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,f|0);if(!x){J2(b);return}else{x=0}f=bQ(-1,-1)|0;h=K;i=f;J2(b);be(i|0)}function eC(b){b=b|0;var d=0;d=b|0;c[d>>2]=14736;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=14880;HC(b+4|0);return}function eD(b){b=b|0;var d=0;d=b|0;c[d>>2]=14736;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=14880;x=0;ap(388,b+4|0);if(!x){J2(b);return}else{x=0;d=bQ(-1,-1)|0;J2(b);be(d|0)}}function eE(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=d+44|0;j=c[i>>2]|0;k=d+24|0;l=c[k>>2]|0;if(j>>>0<l>>>0){c[i>>2]=l;m=l}else{m=j}j=h&24;do{if((j|0)==24){if((g|0)==2){n=11;break}else if((g|0)==0){o=0;p=0;break}else if((g|0)!=1){n=15;break}i=b;c[i>>2]=0;c[i+4>>2]=0;i=b+8|0;c[i>>2]=-1;c[i+4>>2]=-1;return}else if((j|0)==0){i=b;c[i>>2]=0;c[i+4>>2]=0;i=b+8|0;c[i>>2]=-1;c[i+4>>2]=-1;return}else{if((g|0)==2){n=11;break}else if((g|0)==0){o=0;p=0;break}else if((g|0)!=1){n=15;break}if((h&8|0)==0){i=l-(c[d+20>>2]|0)|0;o=(i|0)<0|0?-1:0;p=i;break}else{i=(c[d+12>>2]|0)-(c[d+8>>2]|0)|0;o=(i|0)<0|0?-1:0;p=i;break}}}while(0);if((n|0)==15){g=b;c[g>>2]=0;c[g+4>>2]=0;g=b+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}if((n|0)==11){n=d+32|0;if((a[n]&1)==0){q=n+1|0}else{q=c[d+40>>2]|0}n=m-q|0;o=(n|0)<0|0?-1:0;p=n}n=Kh(p,o,e,f)|0;f=K;e=0;do{if(!((f|0)<(e|0)|(f|0)==(e|0)&n>>>0<0>>>0)){o=d+32|0;if((a[o]&1)==0){r=o+1|0}else{r=c[d+40>>2]|0}o=m-r|0;p=(o|0)<0|0?-1:0;if((p|0)<(f|0)|(p|0)==(f|0)&o>>>0<n>>>0){break}o=h&8;do{if(!((n|0)==0&(f|0)==0)){do{if((o|0)!=0){if((c[d+12>>2]|0)!=0){break}p=b;c[p>>2]=0;c[p+4>>2]=0;p=b+8|0;c[p>>2]=-1;c[p+4>>2]=-1;return}}while(0);if(!((h&16|0)!=0&(l|0)==0)){break}p=b;c[p>>2]=0;c[p+4>>2]=0;p=b+8|0;c[p>>2]=-1;c[p+4>>2]=-1;return}}while(0);if((o|0)!=0){c[d+12>>2]=(c[d+8>>2]|0)+n;c[d+16>>2]=m}if((h&16|0)!=0){c[k>>2]=(c[d+20>>2]|0)+n}p=b;c[p>>2]=0;c[p+4>>2]=0;p=b+8|0;c[p>>2]=n;c[p+4>>2]=f;return}}while(0);f=b;c[f>>2]=0;c[f+4>>2]=0;f=b+8|0;c[f>>2]=-1;c[f+4>>2]=-1;return}function eF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=d;d=i;i=i+16|0;c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];g=d+8|0;cJ[c[(c[b>>2]|0)+16>>2]&127](a,b,c[g>>2]|0,c[g+4>>2]|0,0,e);i=f;return}function eG(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,i=0;b=a+44|0;e=c[b>>2]|0;f=c[a+24>>2]|0;if(e>>>0<f>>>0){c[b>>2]=f;g=f}else{g=e}if((c[a+48>>2]&8|0)==0){h=-1;return h|0}e=a+16|0;f=c[e>>2]|0;b=c[a+12>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;i=g}else{i=f}if(b>>>0>=i>>>0){h=-1;return h|0}h=d[b]|0;return h|0}function eH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=b+44|0;f=c[e>>2]|0;g=c[b+24>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;h=g}else{h=f}f=b+8|0;g=c[f>>2]|0;e=b+12|0;i=c[e>>2]|0;if(g>>>0>=i>>>0){j=-1;return j|0}if((d|0)==-1){c[f>>2]=g;c[e>>2]=i-1;c[b+16>>2]=h;j=0;return j|0}k=i-1|0;do{if((c[b+48>>2]&16|0)==0){if((d<<24>>24|0)==(a[k]|0)){break}else{j=-1}return j|0}}while(0);c[f>>2]=g;c[e>>2]=k;c[b+16>>2]=h;a[k]=d;j=d;return j|0}function eI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;if((d|0)==-1){e=0;return e|0}f=b|0;g=b+12|0;h=b+8|0;i=(c[g>>2]|0)-(c[h>>2]|0)|0;j=b+24|0;k=c[j>>2]|0;l=b+28|0;m=c[l>>2]|0;L4:do{if((k|0)==(m|0)){n=b+48|0;if((c[n>>2]&16|0)==0){e=-1;return e|0}o=b+20|0;p=c[o>>2]|0;q=k-p|0;r=b+44|0;s=(c[r>>2]|0)-p|0;p=b+32|0;t=p;u=p;v=a[u]|0;if((v&1)==0){w=(v&255)>>>1;y=10}else{w=c[b+36>>2]|0;y=(c[p>>2]&-2)-1|0}do{if((w|0)==(y|0)){x=0;aG(46,p|0,y|0,1,y|0,y|0,0,0);if(x){x=0;break}z=a[u]|0;A=11}else{z=v;A=11}}while(0);L16:do{if((A|0)==11){if((z&1)==0){a[u]=(w<<1)+2;B=t+1|0;C=w+1|0}else{v=c[b+40>>2]|0;D=w+1|0;c[b+36>>2]=D;B=v;C=D}a[B+w|0]=0;a[B+C|0]=0;D=a[u]|0;if((D&1)==0){E=10;F=D}else{D=c[p>>2]|0;E=(D&-2)-1|0;F=D&255}D=F&255;if((D&1|0)==0){G=D>>>1}else{G=c[b+36>>2]|0}do{if(G>>>0<E>>>0){D=E-G|0;x=0,ax(58,p|0,D|0,0)|0;if(x){x=0;break L16}}else{if((F&1)==0){a[t+1+E|0]=0;a[u]=E<<1;break}else{a[(c[b+40>>2]|0)+E|0]=0;c[b+36>>2]=E;break}}}while(0);D=a[u]|0;if((D&1)==0){H=t+1|0}else{H=c[b+40>>2]|0}v=D&255;if((v&1|0)==0){I=v>>>1}else{I=c[b+36>>2]|0}v=H+I|0;c[o>>2]=H;c[l>>2]=v;D=H+q|0;c[j>>2]=D;J=H+s|0;c[r>>2]=J;K=D;L=v;M=J;N=n;break L4}}while(0);n=bQ(-1,-1,0)|0;bA(n|0)|0;aZ();e=-1;return e|0}else{K=k;L=m;M=c[b+44>>2]|0;N=b+48|0}}while(0);m=K+1|0;k=m>>>0<M>>>0?M:m;c[b+44>>2]=k;if((c[N>>2]&8|0)!=0){N=b+32|0;if((a[N]&1)==0){O=N+1|0}else{O=c[b+40>>2]|0}c[h>>2]=O;c[g>>2]=O+i;c[b+16>>2]=k}if((K|0)==(L|0)){e=cS[c[(c[b>>2]|0)+52>>2]&1023](f,d&255)|0;return e|0}else{c[j>>2]=m;a[K]=d;e=d&255;return e|0}return 0}function eJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=b+32|0;do{if((e|0)!=(d|0)){f=a[d]|0;if((f&1)==0){g=d+1|0}else{g=c[d+8>>2]|0}h=f&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}h=e;f=e;j=a[f]|0;if((j&1)==0){k=10;l=j}else{j=c[e>>2]|0;k=(j&-2)-1|0;l=j&255}if(k>>>0<i>>>0){j=l&255;if((j&1|0)==0){m=j>>>1}else{m=c[b+36>>2]|0}CX(e,k,i-k|0,m,0,m,i,g);break}if((l&1)==0){n=h+1|0}else{n=c[b+40>>2]|0}Kc(n|0,g|0,i|0)|0;a[n+i|0]=0;if((a[f]&1)==0){a[f]=i<<1;break}else{c[b+36>>2]=i;break}}}while(0);i=b+44|0;c[i>>2]=0;n=b+48|0;g=c[n>>2]|0;if((g&8|0)!=0){l=e;m=a[e]|0;k=(m&1)==0;if(k){o=l+1|0}else{o=c[b+40>>2]|0}d=m&255;if((d&1|0)==0){p=d>>>1}else{p=c[b+36>>2]|0}d=o+p|0;c[i>>2]=d;if(k){q=l+1|0;r=l+1|0}else{l=c[b+40>>2]|0;q=l;r=l}c[b+8>>2]=r;c[b+12>>2]=q;c[b+16>>2]=d}if((g&16|0)==0){return}g=e;d=e;q=a[d]|0;r=q&255;if((r&1|0)==0){s=r>>>1}else{s=c[b+36>>2]|0}if((q&1)==0){c[i>>2]=g+1+s;t=10;u=q}else{c[i>>2]=(c[b+40>>2]|0)+s;i=c[e>>2]|0;t=(i&-2)-1|0;u=i&255}i=u&255;if((i&1|0)==0){v=i>>>1}else{v=c[b+36>>2]|0}do{if(v>>>0<t>>>0){CT(e,t-v|0,0)|0}else{if((u&1)==0){a[g+1+t|0]=0;a[d]=t<<1;break}else{a[(c[b+40>>2]|0)+t|0]=0;c[b+36>>2]=t;break}}}while(0);t=a[d]|0;if((t&1)==0){w=g+1|0;x=g+1|0}else{g=c[b+40>>2]|0;w=g;x=g}g=t&255;if((g&1|0)==0){y=g>>>1}else{y=c[b+36>>2]|0}g=b+24|0;c[g>>2]=x;c[b+20>>2]=x;c[b+28>>2]=w+y;if((c[n>>2]&3|0)==0){return}c[g>>2]=x+s;return}function eK(b,d){b=b|0;d=d|0;if((d|0)==0){return}eK(b,c[d>>2]|0);eK(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){J2(c[d+24>>2]|0)}J2(d);return}function eL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=J0(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];x=0;aB(6,m|0,k|0,l|0,0,0,0);if(x){x=0;l=bQ(-1,-1)|0;m=l;l=K;if((a[k]&1)==0){r=l;s=m;t=s;u=0;v=t;w=r;be(v|0)}J2(c[k+8>>2]|0);r=l;s=m;t=s;u=0;v=t;w=r;be(v|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}k=b+36|0;c[k>>2]=21616;m=b+40|0;c[m>>2]=0;l=b+44|0;c[l>>2]=0;p=b+48|0;c[p>>2]=0;if((f|0)==0){y=b|0;c[y>>2]=18696;c[k>>2]=18756;z=b+52|0;c[z>>2]=g;A=b+56|0;B=h&1;a[A]=B;C=b+32|0;c[C>>2]=5;i=j;return}o=(x=0,as(230,f<<2|0)|0);if(!x){e=o;c[m>>2]=e;c[l>>2]=e;c[p>>2]=e+(f<<2);y=b|0;c[y>>2]=18696;c[k>>2]=18756;z=b+52|0;c[z>>2]=g;A=b+56|0;B=h&1;a[A]=B;C=b+32|0;c[C>>2]=5;i=j;return}else{x=0}j=bQ(-1,-1)|0;C=j;j=K;c[b>>2]=16616;if((a[b+4|0]&1)==0){r=j;s=C;t=s;u=0;v=t;w=r;be(v|0)}J2(c[b+12>>2]|0);r=j;s=C;t=s;u=0;v=t;w=r;be(v|0)}function eM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=d;if((a[m]&1)==0){n=l;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];o=a[n]|0;p=n}else{n=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){d=m<<1&255;q=l;a[q]=d;r=l+1|0;s=d;t=q}else{q=m+16&-16;d=J0(q)|0;c[l+8>>2]=d;u=q|1;c[l>>2]=u;c[l+4>>2]=m;r=d;s=u&255;t=l}Kb(r|0,n|0,m)|0;a[r+m|0]=0;o=s;p=t}t=e;e=k;c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];t=k;k=b|0;c[k>>2]=16616;e=b+4|0;L12:do{if((o&1)==0){s=e;c[s>>2]=c[p>>2];c[s+4>>2]=c[p+4>>2];c[s+8>>2]=c[p+8>>2]}else{s=c[l+8>>2]|0;m=c[l+4>>2]|0;do{if(m>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(m>>>0<11>>>0){a[e]=m<<1;v=e+1|0}else{r=m+16&-16;n=(x=0,as(230,r|0)|0);if(x){x=0;break}c[b+12>>2]=n;c[e>>2]=r|1;c[b+8>>2]=m;v=n}Kb(v|0,s|0,m)|0;a[v+m|0]=0;break L12}}while(0);m=bQ(-1,-1)|0;if((a[p]&1)==0){be(m|0)}J2(s);be(m|0)}}while(0);v=b+16|0;c[v>>2]=c[t>>2];c[v+4>>2]=c[t+4>>2];c[v+8>>2]=c[t+8>>2];if((a[p]&1)==0){c[k>>2]=21792;w=b+28|0;y=f&1;a[w]=y;z=b+29|0;A=g&1;a[z]=A;B=b+32|0;c[B>>2]=h;i=j;return}J2(c[l+8>>2]|0);c[k>>2]=21792;w=b+28|0;y=f&1;a[w]=y;z=b+29|0;A=g&1;a[z]=A;B=b+32|0;c[B>>2]=h;i=j;return}function eN(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+36>>2]=21616;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function eO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+36>>2]=21616;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){h=b;J2(h);return}J2(c[b+12>>2]|0);h=b;J2(h);return}function eP(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+92>>2]&1023](b,a);return}function eQ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+92>>2]&1023](b,a)|0}function eR(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+92>>2]&1023](b,a)|0}function eS(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+92>>2]&1023](b,a)|0}function eT(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+92>>2]&1023](b,a)|0}function eU(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+92>>2]&511](a,d,b);return}function eV(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+92>>2]&511](a,d,b);return}function eW(a){a=a|0;return 1}function eX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(a[d+56|0]&1)!=0?10128:10120;d=Kf(e|0)|0;if(d>>>0>4294967279>>>0){CJ(0)}if(d>>>0<11>>>0){a[b]=d<<1;f=b+1|0;Kb(f|0,e|0,d)|0;g=f+d|0;a[g]=0;return}else{h=d+16&-16;i=J0(h)|0;c[b+8>>2]=i;c[b>>2]=h|1;c[b+4>>2]=d;f=i;Kb(f|0,e|0,d)|0;g=f+d|0;a[g]=0;return}}function eY(a){a=a|0;return(c[a+44>>2]|0)==(c[a+40>>2]|0)|0}function eZ(a){a=a|0;return 0}function e_(a,b){a=a|0;b=b|0;return}function e$(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-60+24|0;c[d+36>>2]=21616;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){return}J2(c[d+12>>2]|0);return}function e0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-60+24|0;c[d+36>>2]=21616;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){h=d;J2(h);return}J2(c[d+12>>2]|0);h=d;J2(h);return}function e1(b,c){b=b|0;c=c|0;a[b]=0;a[b+1|0]=0;return}function e2(a){a=a|0;return 0}function e3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0;e=i;i=i+96|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=b|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=c[d>>2];n=b+16|0;c[n>>2]=0;o=b+20|0;c[o>>2]=0;c[b+24>>2]=0;p=b+28|0;x=0;aq(292,p|0,d+36|0);do{if(!x){q=b+40|0;c[q>>2]=0;r=b+44|0;c[r>>2]=0;c[b+48>>2]=0;s=b+52|0;t=s|0;u=b+56|0;c[u>>2]=0;c[b+60>>2]=0;c[s>>2]=u;u=b+64|0;s=d+4|0;L3:do{if((a[s]&1)==0){v=g;c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];w=12}else{v=c[d+12>>2]|0;y=c[d+8>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(y>>>0<11>>>0){a[g]=y<<1;z=g+1|0}else{A=y+16&-16;B=(x=0,as(230,A|0)|0);if(x){x=0;break}c[g+8>>2]=B;c[g>>2]=A|1;c[g+4>>2]=y;z=B}Kb(z|0,v|0,y)|0;a[z+y|0]=0;w=12;break L3}}while(0);y=bQ(-1,-1)|0;C=K;D=y}}while(0);L16:do{if((w|0)==12){x=0;aq(106,f|0,g|0);do{if(!x){x=0;aq(12,u|0,f|0);if(x){x=0;y=bQ(-1,-1)|0;v=y;y=K;if((a[f]&1)==0){E=y;F=v;break}J2(c[f+8>>2]|0);E=y;F=v;break}if((a[f]&1)!=0){J2(c[f+8>>2]|0)}if((a[g]&1)!=0){J2(c[g+8>>2]|0)}v=b+116|0;y=d+16|0;L30:do{if((a[y]&1)==0){B=v;c[B>>2]=c[y>>2];c[B+4>>2]=c[y+4>>2];c[B+8>>2]=c[y+8>>2];w=28}else{B=c[d+24>>2]|0;A=c[d+20>>2]|0;do{if(A>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(A>>>0<11>>>0){a[v]=A<<1;G=v+1|0}else{H=A+16&-16;I=(x=0,as(230,H|0)|0);if(x){x=0;break}c[b+124>>2]=I;c[v>>2]=H|1;c[b+120>>2]=A;G=I}Kb(G|0,B|0,A)|0;a[G+A|0]=0;w=28;break L30}}while(0);A=bQ(-1,-1)|0;J=K;L=A}}while(0);do{if((w|0)==28){a[b+128|0]=a[d+48|0]&1;a[b+129|0]=a[d+49|0]&1;c[b+132>>2]=c[d+52>>2];y=b+136|0;A=d+56|0;L45:do{if((a[A]&1)==0){B=y;c[B>>2]=c[A>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2];w=38}else{B=c[d+64>>2]|0;I=c[d+60>>2]|0;do{if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(I>>>0<11>>>0){a[y]=I<<1;M=y+1|0}else{H=I+16&-16;N=(x=0,as(230,H|0)|0);if(x){x=0;break}c[b+144>>2]=N;c[y>>2]=H|1;c[b+140>>2]=I;M=N}Kb(M|0,B|0,I)|0;a[M+I|0]=0;w=38;break L45}}while(0);I=bQ(-1,-1)|0;O=K;P=I}}while(0);do{if((w|0)==38){A=b+148|0;I=b+152|0;c[I>>2]=0;c[b+156>>2]=0;c[A>>2]=I;I=b+160|0;B=b+164|0;c[B>>2]=0;c[b+168>>2]=0;c[I>>2]=B;B=b+172|0;N=b+176|0;H=b+184|0;Q=A|0;A=I|0;Ke(B|0,0,24)|0;x=0;aq(274,h|0,0);L60:do{if(!x){x=0,aK(346,H|0,h|0)|0;if(x){x=0;I=bQ(-1,-1)|0;R=I;I=K;if((a[h]&1)==0){S=I;T=R;break}J2(c[h+8>>2]|0);S=I;T=R;break}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}x=0;aq(496,b|0,c[d+28>>2]|0);if(x){x=0;w=96;break}x=0;aq(264,b|0,0);if(x){x=0;w=96;break}x=0;ap(266,b|0);if(x){x=0;w=96;break}if((a[s]&1)==0){R=j;c[R>>2]=c[s>>2];c[R+4>>2]=c[s+4>>2];c[R+8>>2]=c[s+8>>2];U=a[R]|0;V=R}else{R=c[d+12>>2]|0;I=c[d+8>>2]|0;if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;w=96;break}}if(I>>>0<11>>>0){W=I<<1&255;X=j;a[X]=W;Y=j+1|0;Z=W;_=X}else{X=I+16&-16;W=(x=0,as(230,X|0)|0);if(x){x=0;w=96;break}c[j+8>>2]=W;$=X|1;c[j>>2]=$;c[j+4>>2]=I;Y=W;Z=$&255;_=j}Kb(Y|0,R|0,I)|0;a[Y+I|0]=0;U=Z;V=_}I=U&255;if((I&1|0)==0){aa=I>>>1}else{aa=c[j+4>>2]|0}L89:do{if((aa|0)!=0){I=(U&1)==0;L91:do{if(I){R=l;c[R>>2]=c[V>>2];c[R+4>>2]=c[V+4>>2];c[R+8>>2]=c[V+8>>2];w=69}else{R=c[j+8>>2]|0;$=c[j+4>>2]|0;do{if($>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if($>>>0<11>>>0){a[l]=$<<1;ab=l+1|0}else{W=$+16&-16;X=(x=0,as(230,W|0)|0);if(x){x=0;break}c[l+8>>2]=X;c[l>>2]=W|1;c[l+4>>2]=$;ab=X}Kb(ab|0,R|0,$)|0;a[ab+$|0]=0;w=69;break L91}}while(0);$=bQ(-1,-1)|0;ac=K;ad=$}}while(0);do{if((w|0)==69){x=0;aP(364,k|0,b|0,l|0);if(x){x=0;$=bQ(-1,-1)|0;R=$;$=K;if((a[l]&1)==0){ac=$;ad=R;break}J2(c[l+8>>2]|0);ac=$;ad=R;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}R=a[k]|0;$=R&255;if(($&1|0)==0){ae=$>>>1}else{ae=c[k+4>>2]|0}if((ae|0)!=0){if((R&1)==0){break L89}J2(c[k+8>>2]|0);break L89}$=ci(12)|0;L121:do{if(I){c[$>>2]=c[V>>2];c[$+4>>2]=c[V+4>>2];c[$+8>>2]=c[V+8>>2];w=86}else{X=c[j+8>>2]|0;W=c[j+4>>2]|0;do{if(W>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(W>>>0<11>>>0){a[$]=W<<1;af=$+1|0}else{ag=W+16&-16;ah=(x=0,as(230,ag|0)|0);if(x){x=0;break}c[$+8>>2]=ah;c[$>>2]=ag|1;c[$+4>>2]=W;af=ah}Kb(af|0,X|0,W)|0;a[af+W|0]=0;w=86;break L121}}while(0);W=bQ(-1,-1)|0;X=K;bl($|0);ai=X;aj=W}}while(0);do{if((w|0)==86){x=0;aP(144,$|0,29416,296);if(x){x=0;W=bQ(-1,-1)|0;ai=K;aj=W;break}}}while(0);if((R&1)==0){ac=ai;ad=aj;break}J2(c[k+8>>2]|0);ac=ai;ad=aj}}while(0);if(I){S=ac;T=ad;break L60}J2(c[j+8>>2]|0);S=ac;T=ad;break L60}}while(0);if((U&1)==0){i=e;return}J2(c[j+8>>2]|0);i=e;return}else{x=0;w=96}}while(0);if((w|0)==96){$=bQ(-1,-1)|0;S=K;T=$}if((a[H]&1)!=0){J2(c[b+192>>2]|0)}$=c[B>>2]|0;if(($|0)!=0){W=c[N>>2]|0;if(($|0)==(W|0)){ak=$}else{X=W;while(1){W=X-12|0;c[N>>2]=W;if((a[W]&1)==0){al=W}else{J2(c[X-12+8>>2]|0);al=c[N>>2]|0}if(($|0)==(al|0)){break}else{X=al}}ak=c[B>>2]|0}J2(ak)}f6(A,c[b+164>>2]|0);f5(Q,c[b+152>>2]|0);if((a[y]&1)==0){O=S;P=T;break}J2(c[b+144>>2]|0);O=S;P=T}}while(0);if((a[v]&1)==0){J=O;L=P;break}J2(c[b+124>>2]|0);J=O;L=P}}while(0);x=0;ap(154,u|0);if(!x){C=J;D=L;break L16}else{x=0}am=bQ(-1,-1,0)|0;an=K;bU()}else{x=0;v=bQ(-1,-1)|0;E=K;F=v}}while(0);if((a[g]&1)==0){C=E;D=F;break}J2(c[g+8>>2]|0);C=E;D=F}}while(0);f3(t,c[b+56>>2]|0);u=c[q>>2]|0;if((u|0)!=0){s=c[r>>2]|0;if((u|0)==(s|0)){ao=u}else{v=s;while(1){s=v-16|0;c[r>>2]=s;if((a[s]&1)==0){ar=s}else{J2(c[v-16+8>>2]|0);ar=c[r>>2]|0}if((u|0)==(ar|0)){break}else{v=ar}}ao=c[q>>2]|0}J2(ao)}v=p|0;u=c[v>>2]|0;if((u|0)==0){at=C;au=D;break}r=b+32|0;t=c[r>>2]|0;if((u|0)==(t|0)){av=u}else{s=t;while(1){t=s-12|0;c[r>>2]=t;if((a[t]&1)==0){aw=t}else{J2(c[s-12+8>>2]|0);aw=c[r>>2]|0}if((u|0)==(aw|0)){break}else{s=aw}}av=c[v>>2]|0}J2(av);at=C;au=D}else{x=0;s=bQ(-1,-1)|0;at=K;au=s}}while(0);at=c[n>>2]|0;n=at;if((at|0)!=0){D=c[o>>2]|0;if((at|0)!=(D|0)){c[o>>2]=D+(~((D-4+(-n|0)|0)>>>2)<<2)}J2(at)}x=0;ap(286,m|0);if(!x){be(au|0)}else{x=0;am=bQ(-1,-1,0)|0;an=K;bU()}}function e4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+1024|0;e=bx(d|0,1024)|0;f=Kf(e|0)|0;if(f>>>0>4294967279>>>0){CJ(0)}if(f>>>0<11>>>0){g=f<<1&255;h=b;j=b;a[j]=g;k=h+1|0;l=g;m=h;n=j}else{j=f+16&-16;h=J0(j)|0;c[b+8>>2]=h;g=j|1;c[b>>2]=g;c[b+4>>2]=f;k=h;l=g&255;m=b;n=b}Kb(k|0,e|0,f)|0;a[k+f|0]=0;f=l&255;if((f&1|0)==0){o=f>>>1}else{o=c[b+4>>2]|0}if((l&1)==0){p=m+1|0}else{p=c[b+8>>2]|0}if((a[p+(o-1)|0]|0)==47){i=d;return}if((l&1)==0){q=(l&255)>>>1;r=10}else{q=c[b+4>>2]|0;r=(c[b>>2]&-2)-1|0}do{if((q|0)==(r|0)){x=0;aG(46,b|0,r|0,1,r|0,r|0,0,0);if(!x){s=a[n]|0;break}else{x=0}o=bQ(-1,-1)|0;if((a[n]&1)==0){be(o|0)}J2(c[b+8>>2]|0);be(o|0)}else{s=l}}while(0);if((s&1)==0){a[n]=(q<<1)+2;t=m+1|0;u=q+1|0}else{m=c[b+8>>2]|0;n=q+1|0;c[b+4>>2]=n;t=m;u=n}a[t+q|0]=47;a[t+u|0]=0;i=d;return}function e5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=b+28|0;j=b+184|0;k=b+32|0;l=c[k>>2]|0;m=b+36|0;if((l|0)==(c[m>>2]|0)){fB(h,j)}else{do{if((l|0)!=0){n=j;if((a[n]&1)==0){o=l;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];break}n=c[b+192>>2]|0;o=c[b+188>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[l]=o<<1;p=l+1|0}else{q=o+16&-16;r=J0(q)|0;c[l+8>>2]=r;c[l>>2]=q|1;c[l+4>>2]=o;p=r}Kb(p|0,n|0,o)|0;a[p+o|0]=0}}while(0);c[k>>2]=(c[k>>2]|0)+12}if((d|0)==0){i=e;return}else{s=d}while(1){t=a[s]|0;if((t<<24>>24|0)==58|(t<<24>>24|0)==0){break}s=s+1|0}p=t<<24>>24!=0?s:0;L24:do{if((p|0)==0){u=d}else{s=f;t=f+1|0;l=f+8|0;b=f+4|0;j=f|0;o=d;n=p;L26:while(1){r=n-o|0;if(r>>>0>4294967279>>>0){v=19;break}if(r>>>0<11>>>0){q=r<<1&255;a[s]=q;w=t;y=q}else{q=r+16&-16;z=J0(q)|0;c[l>>2]=z;A=q|1;c[j>>2]=A;c[b>>2]=r;w=z;y=A&255}Kb(w|0,o|0,r)|0;a[w+r|0]=0;r=y&255;do{if((((r&1|0)==0?r>>>1:c[b>>2]|0)|0)!=0){A=y&255;if((a[((y&1)==0?t:c[l>>2]|0)+(((A&1|0)==0?A>>>1:c[b>>2]|0)-1)|0]|0)!=47){if((y&1)==0){B=(y&255)>>>1;C=10;D=y}else{A=c[j>>2]|0;B=c[b>>2]|0;C=(A&-2)-1|0;D=A&255}if((B|0)==(C|0)){if((C|0)==-17){v=30;break L26}A=(D&1)==0?t:c[l>>2]|0;do{if(C>>>0<2147483623>>>0){z=C+1|0;q=C<<1;E=z>>>0<q>>>0?q:z;if(E>>>0<11>>>0){F=11;break}F=E+16&-16}else{F=-17}}while(0);E=(x=0,as(230,F|0)|0);if(x){x=0;v=43;break L26}Kb(E|0,A|0,C)|0;if((C|0)!=10){J2(A)}c[l>>2]=E;E=F|1;c[j>>2]=E;G=E&255}else{G=y}if((G&1)==0){a[s]=(B<<1)+2;H=t;I=B+1|0}else{E=c[l>>2]|0;z=B+1|0;c[b>>2]=z;H=E;I=z}a[H+B|0]=47;a[H+I|0]=0}z=c[k>>2]|0;if((z|0)==(c[m>>2]|0)){x=0;aq(282,h|0,f|0);if(!x){break}else{x=0;v=43;break L26}}do{if((z|0)!=0){if((a[s]&1)==0){E=z;c[E>>2]=c[s>>2];c[E+4>>2]=c[s+4>>2];c[E+8>>2]=c[s+8>>2];break}E=c[l>>2]|0;q=c[b>>2]|0;if(q>>>0>4294967279>>>0){v=52;break L26}if(q>>>0<11>>>0){a[z]=q<<1;J=z+1|0}else{L=q+16&-16;M=(x=0,as(230,L|0)|0);if(x){x=0;v=43;break L26}c[z+8>>2]=M;c[z>>2]=L|1;c[z+4>>2]=q;J=M}Kb(J|0,E|0,q)|0;a[J+q|0]=0}}while(0);c[k>>2]=(c[k>>2]|0)+12}}while(0);r=n+1|0;z=r;while(1){N=a[z]|0;if((N<<24>>24|0)==58|(N<<24>>24|0)==0){break}z=z+1|0}A=N<<24>>24!=0?z:0;if((a[s]&1)!=0){J2(c[l>>2]|0)}if((A|0)==0){u=r;break L24}else{o=r;n=A}}do{if((v|0)==19){CJ(0)}else if((v|0)==30){x=0;ap(232,0);if(x){x=0;v=44;break}}else if((v|0)==52){x=0;ap(232,0);if(x){x=0;v=44;break}}else if((v|0)==43){n=bQ(-1,-1)|0;O=K;P=n}}while(0);if((v|0)==44){n=bQ(-1,-1)|0;O=K;P=n}n=P;o=O;if((a[s]&1)==0){Q=o;R=n;S=R;T=0;U=S;V=Q;be(U|0)}J2(c[l>>2]|0);Q=o;R=n;S=R;T=0;U=S;V=Q;be(U|0)}}while(0);O=Kf(u|0)|0;if(O>>>0>4294967279>>>0){CJ(0)}if(O>>>0<11>>>0){P=O<<1&255;N=g;J=g;a[J]=P;W=N+1|0;X=P;Y=N;Z=J}else{J=O+16&-16;N=J0(J)|0;c[g+8>>2]=N;P=J|1;c[g>>2]=P;c[g+4>>2]=O;W=N;X=P&255;Y=g;Z=g}Kb(W|0,u|0,O)|0;a[W+O|0]=0;O=X&255;if((O&1|0)==0){_=O>>>1}else{_=c[g+4>>2]|0}L107:do{if((_|0)!=0){if((X&1)==0){$=Y+1|0}else{$=c[g+8>>2]|0}O=X&255;if((O&1|0)==0){aa=O>>>1}else{aa=c[g+4>>2]|0}do{if((a[$+(aa-1)|0]|0)==47){v=106}else{if((X&1)==0){ab=(X&255)>>>1;ac=10;ad=X}else{O=c[g>>2]|0;ab=c[g+4>>2]|0;ac=(O&-2)-1|0;ad=O&255}if((ab|0)==(ac|0)){if((ac|0)==-17){x=0;ap(232,0);if(x){x=0;break}}if((ad&1)==0){ae=Y+1|0}else{ae=c[g+8>>2]|0}do{if(ac>>>0<2147483623>>>0){O=ac+1|0;W=ac<<1;u=O>>>0<W>>>0?W:O;if(u>>>0<11>>>0){af=11;break}af=u+16&-16}else{af=-17}}while(0);r=(x=0,as(230,af|0)|0);if(x){x=0;break}Kb(r|0,ae|0,ac)|0;if((ac|0)!=10){J2(ae)}c[g+8>>2]=r;r=af|1;c[g>>2]=r;ag=r&255}else{ag=X}if((ag&1)==0){a[Z]=(ab<<1)+2;ah=Y+1|0;ai=ab+1|0}else{r=c[g+8>>2]|0;z=ab+1|0;c[g+4>>2]=z;ah=r;ai=z}a[ah+ab|0]=47;a[ah+ai|0]=0;v=106}}while(0);L146:do{if((v|0)==106){l=c[k>>2]|0;if((l|0)==(c[m>>2]|0)){x=0;aq(282,h|0,g|0);if(!x){break L107}else{x=0;break}}do{if((l|0)!=0){if((a[Z]&1)==0){s=l;c[s>>2]=c[Z>>2];c[s+4>>2]=c[Z+4>>2];c[s+8>>2]=c[Z+8>>2];break}s=c[g+8>>2]|0;z=c[g+4>>2]|0;if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break L146}}if(z>>>0<11>>>0){a[l]=z<<1;aj=l+1|0}else{r=z+16&-16;u=(x=0,as(230,r|0)|0);if(x){x=0;break L146}c[l+8>>2]=u;c[l>>2]=r|1;c[l+4>>2]=z;aj=u}Kb(aj|0,s|0,z)|0;a[aj+z|0]=0}}while(0);c[k>>2]=(c[k>>2]|0)+12;break L107}}while(0);l=bQ(-1,-1)|0;z=l;l=K;if((a[Z]&1)==0){Q=l;R=z;S=R;T=0;U=S;V=Q;be(U|0)}J2(c[g+8>>2]|0);Q=l;R=z;S=R;T=0;U=S;V=Q;be(U|0)}}while(0);if((a[Z]&1)==0){i=e;return}J2(c[g+8>>2]|0);i=e;return}function e6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+16|0;e=d|0;e4(e,0);f=b+32|0;g=c[f>>2]|0;L1:do{if((g|0)==(c[b+36>>2]|0)){x=0;aq(282,b+28|0,e|0);if(x){x=0;h=33}}else{do{if((g|0)!=0){j=e;if((a[j]&1)==0){k=g;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];break}j=c[e+8>>2]|0;k=c[e+4>>2]|0;if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;h=33;break L1}}if(k>>>0<11>>>0){a[g]=k<<1;l=g+1|0}else{m=k+16&-16;n=(x=0,as(230,m|0)|0);if(x){x=0;h=33;break L1}c[g+8>>2]=n;c[g>>2]=m|1;c[g+4>>2]=k;l=n}Kb(l|0,j|0,k)|0;a[l+k|0]=0}}while(0);c[f>>2]=(c[f>>2]|0)+12}}while(0);if((h|0)==33){h=bQ(-1,-1)|0;if((a[e]&1)==0){be(h|0)}J2(c[e+8>>2]|0);be(h|0)}if((a[e]&1)!=0){J2(c[e+8>>2]|0)}e=c[f>>2]|0;f=e-12|0;h=a[f]|0;l=(h&1)==0;if(l){o=f+1|0}else{o=c[e-12+8>>2]|0}f=h&255;if((f&1|0)==0){p=f>>>1}else{p=c[e-12+4>>2]|0}if((a[o+(p-1)|0]|0)==47){i=d;return}p=e-12|0;o=p;if(l){q=f>>>1;r=10}else{q=c[e-12+4>>2]|0;r=(c[p>>2]&-2)-1|0}if((q|0)==(r|0)){CY(p,r,1,r,r,0,0);s=a[o]|0}else{s=h}if((s&1)==0){a[o]=(q<<1)+2;t=p+1|0;u=q+1|0}else{p=c[e-12+8>>2]|0;o=q+1|0;c[e-12+4>>2]=o;t=p;u=o}a[t+q|0]=47;a[t+u|0]=0;i=d;return}function e7(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;d=i;i=i+80|0;e=d|0;f=d+16|0;g=d+24|0;j=d+40|0;k=d+56|0;l=d+72|0;m=c[9050]|0;if((m|0)==0){i=d;return}n=g;o=g+1|0;p=b+4|0;q=b+8|0;r=b|0;s=j+8|0;t=j|0;u=j+4|0;v=k;w=k+1|0;y=e|0;z=e+4|0;A=e+8|0;B=j;C=b+148|0;D=b+160|0;E=g+8|0;F=k+8|0;G=g|0;H=g+4|0;I=0;J=m;while(1){m=Kf(J|0)|0;if(m>>>0>4294967279>>>0){L=4;break}if(m>>>0<11>>>0){a[n]=m<<1;M=o}else{N=m+16&-16;O=J0(N)|0;c[E>>2]=O;c[G>>2]=N|1;c[H>>2]=m;M=O}Kb(M|0,J|0,m)|0;a[M+m|0]=0;m=(x=0,as(230,88)|0);if(x){x=0;L=27;break}O=m;c[f>>2]=O;m=c[p>>2]|0;if((m|0)==(c[q>>2]|0)){x=0;aq(376,r|0,f|0);if(x){x=0;L=27;break}P=c[f>>2]|0}else{if((m|0)==0){Q=0}else{c[m>>2]=O;Q=c[p>>2]|0}c[p>>2]=Q+4;P=O}R=P;O=P;m=(x=0,as(230,16)|0);if(x){x=0;L=28;break}c[s>>2]=m;c[t>>2]=17;c[u>>2]=13;Kb(m|0,10136,13)|0;a[m+13|0]=0;m=I*3|0;S=+h[31320+(m<<3)>>3];T=+h[31320+(m+1<<3)>>3];U=+h[31320+(m+2<<3)>>3];a[v]=0;a[w]=0;c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;x=0;at(2,O|0,j|0,e|0,+S,+T,+U,+1.0,k|0);if(x){x=0;L=29;break}if((a[v]&1)!=0){J2(c[F>>2]|0)}if((a[B]&1)!=0){J2(c[s>>2]|0)}m=(x=0,aK(262,C|0,g|0)|0);if(x){x=0;L=27;break}c[m>>2]=O;c[l>>2]=~~(U+ +(~~(T*256.0+ +(~~(S*65536.0)|0))|0));O=(x=0,aK(710,D|0,l|0)|0);if(x){x=0;L=27;break}x=0,aK(346,O|0,g|0)|0;if(x){x=0;L=27;break}O=I+1|0;if((a[n]&1)!=0){J2(c[E>>2]|0)}m=c[36200+(O<<2)>>2]|0;if((m|0)==0){L=44;break}else{I=O;J=m}}do{if((L|0)==4){CJ(0)}else if((L|0)==27){J=bQ(-1,-1)|0;V=K;W=J}else if((L|0)==28){J=bQ(-1,-1)|0;X=K;Y=J;L=33}else if((L|0)==29){J=bQ(-1,-1)|0;I=J;J=K;if((a[v]&1)!=0){J2(c[F>>2]|0)}if((a[B]&1)==0){X=J;Y=I;L=33;break}J2(c[s>>2]|0);X=J;Y=I;L=33}else if((L|0)==44){i=d;return}}while(0);if((L|0)==33){L=c[b>>2]|0;b=c[p>>2]|0;d=L;while(1){if((d|0)==(b|0)){Z=b;break}if((c[d>>2]|0)==(P|0)){Z=d;break}else{d=d+4|0}}d=Z-L>>2;Z=L+(d+1<<2)|0;P=b-Z|0;Kc(L+(d<<2)|0,Z|0,P|0)|0;Z=L+((P>>2)+d<<2)|0;d=c[p>>2]|0;if((Z|0)!=(d|0)){c[p>>2]=d+(~((d-4+(-Z|0)|0)>>>2)<<2)}J2(R);V=X;W=Y}if((a[n]&1)==0){_=W;$=0;aa=_;ab=V;be(aa|0)}J2(c[E>>2]|0);_=W;$=0;aa=_;ab=V;be(aa|0)}function e8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0;f=i;i=i+16|0;g=f|0;h=g;j=i;i=i+12|0;i=i+7&-8;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+4|0;i=i+7&-8;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;Ke(h|0,0,12)|0;s=b;t=d+28|0;u=((c[d+32>>2]|0)-(c[t>>2]|0)|0)/12|0;v=k;w=e;y=l;z=d+172|0;A=d+176|0;B=d+180|0;C=d+52|0;D=C|0;E=j;F=m;G=d+20|0;H=d+24|0;I=d+16|0;J=d+40|0;L=q;M=p;N=p+12|0;O=o;P=o+12|0;Q=d+44|0;R=d+48|0;S=d+64|0;T=d+136|0;U=d+184|0;V=d+68|0;W=d+72|0;d=r;X=j+8|0;Y=j+4|0;Z=b+1|0;_=b+8|0;$=b|0;aa=b+4|0;b=r+8|0;ab=r+4|0;ac=q+8|0;ad=p+8|0;ae=o+8|0;af=o+4|0;ag=p+4|0;ah=o+1|0;ai=o|0;aj=q+4|0;ak=p+1|0;al=p|0;p=q+1|0;am=q|0;q=g+8|0;an=g+4|0;ao=m+8|0;ar=m+1|0;at=m|0;au=m+4|0;av=k+8|0;aw=l+8|0;ax=e+8|0;ay=e+4|0;e=l+1|0;az=l|0;aA=l+4|0;aB=k+1|0;aC=k|0;aD=k+4|0;aE=0;L1:while(1){if(aE>>>0>=u>>>0){aF=204;break}aG=c[t>>2]|0;aH=aG+(aE*12|0)|0;if((a[aH]&1)==0){c[v>>2]=c[aH>>2];c[v+4>>2]=c[aH+4>>2];c[v+8>>2]=c[aH+8>>2]}else{aH=c[aG+(aE*12|0)+8>>2]|0;aI=c[aG+(aE*12|0)+4>>2]|0;if(aI>>>0>4294967279>>>0){aF=6;break}if(aI>>>0<11>>>0){a[v]=aI<<1;aJ=aB}else{aG=aI+16&-16;aL=(x=0,as(230,aG|0)|0);if(x){x=0;aF=53;break}c[av>>2]=aL;c[aC>>2]=aG|1;c[aD>>2]=aI;aJ=aL}Kb(aJ|0,aH|0,aI)|0;a[aJ+aI|0]=0}if((a[w]&1)==0){c[y>>2]=c[w>>2];c[y+4>>2]=c[w+4>>2];c[y+8>>2]=c[w+8>>2]}else{aI=c[ax>>2]|0;aH=c[ay>>2]|0;if(aH>>>0>4294967279>>>0){aF=16;break}if(aH>>>0<11>>>0){a[y]=aH<<1;aM=e}else{aL=aH+16&-16;aG=(x=0,as(230,aL|0)|0);if(x){x=0;aF=56;break}c[aw>>2]=aG;c[az>>2]=aL|1;c[aA>>2]=aH;aM=aG}Kb(aM|0,aI|0,aH)|0;a[aM+aH|0]=0}x=0;aP(22,j|0,k|0,l|0);if(x){x=0;aF=59;break}if((a[y]&1)!=0){J2(c[aw>>2]|0)}if((a[v]&1)!=0){J2(c[av>>2]|0)}aH=c[A>>2]|0;if((aH|0)==(c[B>>2]|0)){x=0;aq(282,z|0,j|0);if(x){x=0;aF=63;break}}else{do{if((aH|0)!=0){if((a[E]&1)==0){aI=aH;c[aI>>2]=c[E>>2];c[aI+4>>2]=c[E+4>>2];c[aI+8>>2]=c[E+8>>2];break}aI=c[X>>2]|0;aG=c[Y>>2]|0;if(aG>>>0>4294967279>>>0){aF=33;break L1}if(aG>>>0<11>>>0){a[aH]=aG<<1;aN=aH+1|0}else{aL=aG+16&-16;aO=(x=0,as(230,aL|0)|0);if(x){x=0;aF=63;break L1}c[aH+8>>2]=aO;c[aH>>2]=aL|1;c[aH+4>>2]=aG;aN=aO}Kb(aN|0,aI|0,aG)|0;a[aN+aG|0]=0}}while(0);c[A>>2]=(c[A>>2]|0)+12}aH=(fs(D,j)|0)==0;aG=a[E]|0;aI=(aG&1)==0;do{if(aH){if(aI){c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2]}else{aO=c[X>>2]|0;aL=c[Y>>2]|0;if(aL>>>0>4294967279>>>0){aF=69;break L1}if(aL>>>0<11>>>0){a[F]=aL<<1;aQ=ar}else{aR=aL+16&-16;aS=(x=0,as(230,aR|0)|0);if(x){x=0;aF=63;break L1}c[ao>>2]=aS;c[at>>2]=aR|1;c[au>>2]=aL;aQ=aS}Kb(aQ|0,aO|0,aL)|0;a[aQ+aL|0]=0}aL=(x=0,aK(328,m|0,g|0)|0);if(x){x=0;aF=179;break L1}if((a[F]&1)!=0){J2(c[ao>>2]|0)}if((aL|0)==0){aU=0;aV=a[E]|0;break}c[n>>2]=aL;aO=c[G>>2]|0;if((aO|0)==(c[H>>2]|0)){x=0;aq(26,I|0,n|0);if(x){x=0;aF=63;break L1}}else{if((aO|0)==0){aW=0}else{c[aO>>2]=aL;aW=c[G>>2]|0}c[G>>2]=aW+4}aO=c[A>>2]|0;if((aO|0)==(c[B>>2]|0)){x=0;aq(282,z|0,g|0);if(x){x=0;aF=63;break L1}}else{do{if((aO|0)!=0){if((a[h]&1)==0){aS=aO;c[aS>>2]=c[h>>2];c[aS+4>>2]=c[h+4>>2];c[aS+8>>2]=c[h+8>>2];break}aS=c[q>>2]|0;aR=c[an>>2]|0;if(aR>>>0>4294967279>>>0){aF=91;break L1}if(aR>>>0<11>>>0){a[aO]=aR<<1;aX=aO+1|0}else{aY=aR+16&-16;aZ=(x=0,as(230,aY|0)|0);if(x){x=0;aF=63;break L1}c[aO+8>>2]=aZ;c[aO>>2]=aY|1;c[aO+4>>2]=aR;aX=aZ}Kb(aX|0,aS|0,aR)|0;a[aX+aR|0]=0}}while(0);c[A>>2]=(c[A>>2]|0)+12}if((a[E]&1)==0){c[L>>2]=c[E>>2];c[L+4>>2]=c[E+4>>2];c[L+8>>2]=c[E+8>>2];a_=a[L]|0}else{aO=c[X>>2]|0;aR=c[Y>>2]|0;if(aR>>>0>4294967279>>>0){aF=103;break L1}if(aR>>>0<11>>>0){aS=aR<<1&255;a[L]=aS;a$=p;a0=aS}else{aS=aR+16&-16;aZ=(x=0,as(230,aS|0)|0);if(x){x=0;aF=63;break L1}c[ac>>2]=aZ;aY=aS|1;c[am>>2]=aY;c[aj>>2]=aR;a$=aZ;a0=aY&255}Kb(a$|0,aO|0,aR)|0;a[a$+aR|0]=0;a_=a0}if((a_&1)==0){c[M>>2]=c[L>>2];c[M+4>>2]=c[L+4>>2];c[M+8>>2]=c[L+8>>2];a1=a[M]|0}else{aR=c[ac>>2]|0;aO=c[aj>>2]|0;if(aO>>>0>4294967279>>>0){aF=113;break L1}if(aO>>>0<11>>>0){aY=aO<<1&255;a[M]=aY;a2=ak;a3=aY}else{aY=aO+16&-16;aZ=(x=0,as(230,aY|0)|0);if(x){x=0;aF=181;break L1}c[ad>>2]=aZ;aS=aY|1;c[al>>2]=aS;c[ag>>2]=aO;a2=aZ;a3=aS&255}Kb(a2|0,aR|0,aO)|0;a[a2+aO|0]=0;a1=a3}c[N>>2]=aL;if((a1&1)==0){c[O>>2]=c[M>>2];c[O+4>>2]=c[M+4>>2];c[O+8>>2]=c[M+8>>2]}else{aO=c[ad>>2]|0;aR=c[ag>>2]|0;if(aR>>>0>4294967279>>>0){aF=123;break L1}if(aR>>>0<11>>>0){a[O]=aR<<1;a4=ah}else{aS=aR+16&-16;aZ=(x=0,as(230,aS|0)|0);if(x){x=0;aF=184;break L1}c[ae>>2]=aZ;c[ai>>2]=aS|1;c[af>>2]=aR;a4=aZ}Kb(a4|0,aO|0,aR)|0;a[a4+aR|0]=0}c[P>>2]=aL;aR=c[Q>>2]|0;if((aR|0)==(c[R>>2]|0)){x=0;aq(518,J|0,o|0);if(x){x=0;aF=187;break L1}}else{if((aR|0)==0){a5=0}else{a6=a[O]|0;if((a6&1)==0){aO=aR;c[aO>>2]=c[O>>2];c[aO+4>>2]=c[O+4>>2];c[aO+8>>2]=c[O+8>>2]}else{aO=c[ae>>2]|0;aZ=c[af>>2]|0;if(aZ>>>0>4294967279>>>0){aF=135;break L1}if(aZ>>>0<11>>>0){a[aR]=aZ<<1;a7=aR+1|0}else{aS=aZ+16&-16;aY=(x=0,as(230,aS|0)|0);if(x){x=0;aF=187;break L1}c[aR+8>>2]=aY;c[aR>>2]=aS|1;c[aR+4>>2]=aZ;a7=aY}Kb(a7|0,aO|0,aZ)|0;a[a7+aZ|0]=0}c[aR+12>>2]=aL;a5=c[Q>>2]|0}c[Q>>2]=a5+16}if((a[O]&1)!=0){J2(c[ae>>2]|0)}if((a1&1)!=0){J2(c[ad>>2]|0)}if((a_&1)!=0){J2(c[ac>>2]|0)}x=0;aT(40,r|0,g|0,T|0,U|0);if(x){x=0;aF=63;break L1}aR=c[V>>2]|0;if((aR|0)==(c[W>>2]|0)){x=0;aq(282,S|0,r|0);if(x){x=0;aF=195;break L1}}else{do{if((aR|0)!=0){if((a[d]&1)==0){aZ=aR;c[aZ>>2]=c[d>>2];c[aZ+4>>2]=c[d+4>>2];c[aZ+8>>2]=c[d+8>>2];break}aZ=c[b>>2]|0;aO=c[ab>>2]|0;if(aO>>>0>4294967279>>>0){aF=157;break L1}if(aO>>>0<11>>>0){a[aR]=aO<<1;a8=aR+1|0}else{aY=aO+16&-16;aS=(x=0,as(230,aY|0)|0);if(x){x=0;aF=195;break L1}c[aR+8>>2]=aS;c[aR>>2]=aY|1;c[aR+4>>2]=aO;a8=aS}Kb(a8|0,aZ|0,aO)|0;a[a8+aO|0]=0}}while(0);c[V>>2]=(c[V>>2]|0)+12}if((a[d]&1)!=0){J2(c[b>>2]|0)}aR=(x=0,aK(506,C|0,j|0)|0);if(x){x=0;aF=63;break L1}c[aR>>2]=0;aR=a[E]|0;if((aR&1)==0){c[s>>2]=c[E>>2];c[s+4>>2]=c[E+4>>2];c[s+8>>2]=c[E+8>>2];aU=1;aV=aR;break}aL=c[X>>2]|0;aO=c[Y>>2]|0;if(aO>>>0>4294967279>>>0){aF=172;break L1}if(aO>>>0<11>>>0){a[s]=aO<<1;a9=Z}else{aZ=aO+16&-16;aS=(x=0,as(230,aZ|0)|0);if(x){x=0;aF=63;break L1}c[_>>2]=aS;c[$>>2]=aZ|1;c[aa>>2]=aO;a9=aS}Kb(a9|0,aL|0,aO)|0;a[a9+aO|0]=0;aU=1;aV=aR}else{if(aI){c[s>>2]=c[E>>2];c[s+4>>2]=c[E+4>>2];c[s+8>>2]=c[E+8>>2];aU=1;aV=aG;break}aR=c[X>>2]|0;aO=c[Y>>2]|0;if(aO>>>0>4294967279>>>0){aF=46;break L1}if(aO>>>0<11>>>0){a[s]=aO<<1;ba=Z}else{aL=aO+16&-16;aS=(x=0,as(230,aL|0)|0);if(x){x=0;aF=63;break L1}c[_>>2]=aS;c[$>>2]=aL|1;c[aa>>2]=aO;ba=aS}Kb(ba|0,aR|0,aO)|0;a[ba+aO|0]=0;aU=1;aV=aG}}while(0);if((aV&1)!=0){J2(c[X>>2]|0)}if((aU|0)==0){aE=aE+1|0}else{aF=205;break}}do{if((aF|0)==69){x=0;ap(232,0);if(x){x=0;aF=64;break}}else if((aF|0)==46){x=0;ap(232,0);if(x){x=0;aF=64;break}}else if((aF|0)==16){x=0;ap(232,0);if(x){x=0;aE=bQ(-1,-1)|0;bb=K;bc=aE;aF=58;break}}else if((aF|0)==6){x=0;ap(232,0);if(x){x=0;aE=bQ(-1,-1)|0;bd=K;bf=aE;aF=55;break}}else if((aF|0)==56){aE=bQ(-1,-1)|0;bb=K;bc=aE;aF=58}else if((aF|0)==63){aE=bQ(-1,-1)|0;bg=K;bh=aE;aF=65}else if((aF|0)==172){x=0;ap(232,0);if(x){x=0;aF=64;break}}else if((aF|0)==179){aE=bQ(-1,-1)|0;aU=aE;aE=K;if((a[F]&1)==0){bi=aE;bj=aU;aF=202;break}J2(c[ao>>2]|0);bi=aE;bj=aU;aF=202}else if((aF|0)==181){aU=bQ(-1,-1)|0;bk=K;bl=aU;aF=183}else if((aF|0)==123){x=0;ap(232,0);if(x){x=0;aU=bQ(-1,-1)|0;bm=K;bn=aU;aF=186;break}}else if((aF|0)==59){aU=bQ(-1,-1)|0;aE=aU;aU=K;if((a[y]&1)==0){bo=aU;bp=aE;aF=61;break}J2(c[aw>>2]|0);bo=aU;bp=aE;aF=61}else if((aF|0)==103){x=0;ap(232,0);if(x){x=0;aF=64;break}}else if((aF|0)==135){x=0;ap(232,0);if(x){x=0;aE=bQ(-1,-1)|0;bq=K;br=aE;bs=a6;aF=189;break}}else if((aF|0)==184){aE=bQ(-1,-1)|0;bm=K;bn=aE;aF=186}else if((aF|0)==187){aE=bQ(-1,-1)|0;bq=K;br=aE;bs=a[O]|0;aF=189}else if((aF|0)==195){aE=bQ(-1,-1)|0;bt=K;bu=aE;aF=197}else if((aF|0)==33){x=0;ap(232,0);if(x){x=0;aF=64;break}}else if((aF|0)==204){Ke(s|0,0,12)|0;aF=205}else if((aF|0)==157){x=0;ap(232,0);if(x){x=0;aE=bQ(-1,-1)|0;bt=K;bu=aE;aF=197;break}}else if((aF|0)==113){x=0;ap(232,0);if(x){x=0;aE=bQ(-1,-1)|0;bk=K;bl=aE;aF=183;break}}else if((aF|0)==91){x=0;ap(232,0);if(x){x=0;aF=64;break}}else if((aF|0)==53){aE=bQ(-1,-1)|0;bd=K;bf=aE;aF=55}}while(0);do{if((aF|0)==55){bv=bd;bw=bf}else if((aF|0)==64){s=bQ(-1,-1)|0;bg=K;bh=s;aF=65}else if((aF|0)==58){bo=bb;bp=bc;aF=61}else if((aF|0)==183){bx=bk;by=bl;aF=193}else if((aF|0)==186){bz=bm;bA=bn;aF=191}else if((aF|0)==189){s=br;O=bq;if((bs&1)==0){bz=O;bA=s;aF=191;break}J2(c[ae>>2]|0);bz=O;bA=s;aF=191}else if((aF|0)==197){s=bu;O=bt;if((a[d]&1)==0){bi=O;bj=s;aF=202;break}J2(c[b>>2]|0);bi=O;bj=s;aF=202}else if((aF|0)==205){if((a[h]&1)==0){i=f;return}J2(c[q>>2]|0);i=f;return}}while(0);do{if((aF|0)==61){if((a[v]&1)==0){bv=bo;bw=bp;break}J2(c[av>>2]|0);bv=bo;bw=bp}else if((aF|0)==191){if((a1&1)==0){bx=bz;by=bA;aF=193;break}J2(c[ad>>2]|0);bx=bz;by=bA;aF=193}else if((aF|0)==65){bi=bg;bj=bh;aF=202}}while(0);do{if((aF|0)==193){if((a_&1)==0){bi=bx;bj=by;aF=202;break}J2(c[ac>>2]|0);bi=bx;bj=by;aF=202}}while(0);do{if((aF|0)==202){if((a[E]&1)==0){bv=bi;bw=bj;break}J2(c[X>>2]|0);bv=bi;bw=bj}}while(0);if((a[h]&1)==0){bB=bw;bC=0;bD=bB;bE=bv;be(bD|0)}J2(c[q>>2]|0);bB=bw;bC=0;bD=bB;bE=bv;be(bD|0)}function e9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b+20|0;e=c[d>>2]|0;f=b+16|0;g=c[f>>2]|0;if((e|0)!=(g|0)){h=0;i=g;g=e;while(1){e=c[i+(h<<2)>>2]|0;if((e|0)==0){j=g;k=i}else{J3(e);j=c[d>>2]|0;k=c[f>>2]|0}e=h+1|0;if(e>>>0<j-k>>2>>>0){h=e;i=k;g=j}else{break}}}if((a[b+184|0]&1)!=0){J2(c[b+192>>2]|0)}j=b+172|0;g=c[j>>2]|0;if((g|0)!=0){k=b+176|0;i=c[k>>2]|0;if((g|0)==(i|0)){l=g}else{h=i;while(1){i=h-12|0;c[k>>2]=i;if((a[i]&1)==0){m=i}else{J2(c[h-12+8>>2]|0);m=c[k>>2]|0}if((g|0)==(m|0)){break}else{h=m}}l=c[j>>2]|0}J2(l)}f6(b+160|0,c[b+164>>2]|0);f5(b+148|0,c[b+152>>2]|0);if((a[b+136|0]&1)!=0){J2(c[b+144>>2]|0)}if((a[b+116|0]&1)!=0){J2(c[b+124>>2]|0)}x=0;ap(154,b+64|0);if(!x){f3(b+52|0,c[b+56>>2]|0);l=b+40|0;j=c[l>>2]|0;if((j|0)!=0){m=b+44|0;h=c[m>>2]|0;if((j|0)==(h|0)){n=j}else{g=h;while(1){h=g-16|0;c[m>>2]=h;if((a[h]&1)==0){o=h}else{J2(c[g-16+8>>2]|0);o=c[m>>2]|0}if((j|0)==(o|0)){break}else{g=o}}n=c[l>>2]|0}J2(n)}n=b+28|0;l=c[n>>2]|0;if((l|0)!=0){o=b+32|0;g=c[o>>2]|0;if((l|0)==(g|0)){p=l}else{j=g;while(1){g=j-12|0;c[o>>2]=g;if((a[g]&1)==0){q=g}else{J2(c[j-12+8>>2]|0);q=c[o>>2]|0}if((l|0)==(q|0)){break}else{j=q}}p=c[n>>2]|0}J2(p)}p=c[f>>2]|0;if((p|0)==0){r=b|0;fu(r);return}n=c[d>>2]|0;if((p|0)!=(n|0)){c[d>>2]=n+(~((n-4+(-p|0)|0)>>>2)<<2)}J2(p);r=b|0;fu(r);return}else{x=0}r=bQ(-1,-1)|0;f3(b+52|0,c[b+56>>2]|0);p=b+40|0;n=c[p>>2]|0;if((n|0)!=0){q=b+44|0;j=c[q>>2]|0;if((n|0)==(j|0)){s=n}else{l=j;while(1){j=l-16|0;c[q>>2]=j;if((a[j]&1)==0){t=j}else{J2(c[l-16+8>>2]|0);t=c[q>>2]|0}if((n|0)==(t|0)){break}else{l=t}}s=c[p>>2]|0}J2(s)}s=b+28|0;p=c[s>>2]|0;if((p|0)!=0){t=b+32|0;l=c[t>>2]|0;if((p|0)==(l|0)){u=p}else{n=l;while(1){l=n-12|0;c[t>>2]=l;if((a[l]&1)==0){v=l}else{J2(c[n-12+8>>2]|0);v=c[t>>2]|0}if((p|0)==(v|0)){break}else{n=v}}u=c[s>>2]|0}J2(u)}u=c[f>>2]|0;f=u;if((u|0)!=0){s=c[d>>2]|0;if((u|0)!=(s|0)){c[d>>2]=s+(~((s-4+(-f|0)|0)>>>2)<<2)}J2(u)}x=0;ap(286,b|0);if(!x){be(r|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function fa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+8|0;f=e|0;g=ft(b,f,d)|0;h=c[g>>2]|0;if((h|0)!=0){j=h;k=j+28|0;i=e;return k|0}h=J0(32)|0;l=h;m=h+16|0;L4:do{if((m|0)!=0){n=d;if((a[n]&1)==0){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];break}n=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[m]=o<<1;p=h+17|0}else{q=o+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;break}c[h+24>>2]=r;c[m>>2]=q|1;c[h+20>>2]=o;p=r}Kb(p|0,n|0,o)|0;a[p+o|0]=0;break L4}}while(0);o=bQ(-1,-1)|0;if((h|0)==0){be(o|0)}J2(h);be(o|0)}}while(0);p=h+28|0;if((p|0)!=0){c[p>>2]=0}p=c[f>>2]|0;f=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=p;c[g>>2]=f;p=b|0;h=c[c[p>>2]>>2]|0;if((h|0)==0){s=f}else{c[p>>2]=h;s=c[g>>2]|0}es(c[b+4>>2]|0,s);s=b+8|0;c[s>>2]=(c[s>>2]|0)+1;j=l;k=j+28|0;i=e;return k|0}function fb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d|0;f=a+4|0;g=f|0;h=c[g>>2]|0;do{if((h|0)==0){j=f;c[e>>2]=j;k=g;l=j}else{j=c[b>>2]|0;m=h;while(1){n=c[m+16>>2]|0;if((j|0)<(n|0)){o=m|0;p=c[o>>2]|0;if((p|0)==0){q=5;break}else{m=p;continue}}if((n|0)>=(j|0)){q=9;break}r=m+4|0;n=c[r>>2]|0;if((n|0)==0){q=8;break}else{m=n}}if((q|0)==8){c[e>>2]=m;k=r;l=m;break}else if((q|0)==5){c[e>>2]=m;k=o;l=m;break}else if((q|0)==9){c[e>>2]=m;k=e;l=m;break}}}while(0);e=c[k>>2]|0;if((e|0)!=0){s=e;t=s+20|0;i=d;return t|0}e=J0(32)|0;q=e+16|0;if((q|0)!=0){c[q>>2]=c[b>>2]}b=e+20|0;if((b|0)!=0){Ke(b|0,0,12)|0}b=e;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=l;c[k>>2]=b;l=a|0;q=c[c[l>>2]>>2]|0;if((q|0)==0){u=b}else{c[l>>2]=q;u=c[k>>2]|0}es(c[a+4>>2]|0,u);u=a+8|0;c[u>>2]=(c[u>>2]|0)+1;s=e;t=s+20|0;i=d;return t|0}function fc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+8|0;f=e|0;g=fp(b,f,d)|0;h=c[g>>2]|0;if((h|0)!=0){j=h;k=j+28|0;i=e;return k|0}h=J0(32)|0;l=h;m=h+16|0;L4:do{if((m|0)!=0){n=d;if((a[n]&1)==0){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];break}n=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[m]=o<<1;p=h+17|0}else{q=o+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;break}c[h+24>>2]=r;c[m>>2]=q|1;c[h+20>>2]=o;p=r}Kb(p|0,n|0,o)|0;a[p+o|0]=0;break L4}}while(0);o=bQ(-1,-1)|0;if((h|0)==0){be(o|0)}J2(h);be(o|0)}}while(0);p=h+28|0;if((p|0)!=0){c[p>>2]=0}p=c[f>>2]|0;f=h;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=p;c[g>>2]=f;p=b|0;h=c[c[p>>2]>>2]|0;if((h|0)==0){s=f}else{c[p>>2]=h;s=c[g>>2]|0}es(c[b+4>>2]|0,s);s=b+8|0;c[s>>2]=(c[s>>2]|0)+1;j=l;k=j+28|0;i=e;return k|0}function fd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0;g=i;i=i+16|0;h=g|0;j=h;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=i;i=i+4|0;i=i+7&-8;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+12|0;i=i+7&-8;w=i;i=i+12|0;i=i+7&-8;y=i;i=i+4|0;i=i+7&-8;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;Ke(j|0,0,12)|0;D=b;E=e;L1:do{if((a[E]&1)==0){F=l;c[F>>2]=c[E>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];G=11}else{F=c[e+8>>2]|0;H=c[e+4>>2]|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(H>>>0<11>>>0){a[l]=H<<1;I=l+1|0}else{J=H+16&-16;L=(x=0,as(230,J|0)|0);if(x){x=0;break}c[l+8>>2]=L;c[l>>2]=J|1;c[l+4>>2]=H;I=L}Kb(I|0,F|0,H)|0;a[I+H|0]=0;G=11;break L1}}while(0);H=bQ(-1,-1)|0;M=K;N=H}}while(0);L14:do{if((G|0)==11){I=f;L16:do{if((a[I]&1)==0){e=m;c[e>>2]=c[I>>2];c[e+4>>2]=c[I+4>>2];c[e+8>>2]=c[I+8>>2];G=21}else{e=c[f+8>>2]|0;E=c[f+4>>2]|0;do{if(E>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(E>>>0<11>>>0){a[m]=E<<1;O=m+1|0}else{H=E+16&-16;F=(x=0,as(230,H|0)|0);if(x){x=0;break}c[m+8>>2]=F;c[m>>2]=H|1;c[m+4>>2]=E;O=F}Kb(O|0,e|0,E)|0;a[O+E|0]=0;G=21;break L16}}while(0);E=bQ(-1,-1)|0;P=K;Q=E}}while(0);do{if((G|0)==21){x=0;aP(22,k|0,l|0,m|0);if(x){x=0;E=bQ(-1,-1)|0;e=E;E=K;if((a[m]&1)==0){P=E;Q=e;break}J2(c[m+8>>2]|0);P=E;Q=e;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}e=d+52|0;E=e|0;F=(fs(E,k)|0)==0;H=k;L=(a[H]&1)==0;L41:do{if(F){if(L){J=n;c[J>>2]=c[H>>2];c[J+4>>2]=c[H+4>>2];c[J+8>>2]=c[H+8>>2]}else{J=c[k+8>>2]|0;R=c[k+4>>2]|0;if(R>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=44;break}}if(R>>>0<11>>>0){a[n]=R<<1;S=n+1|0}else{T=R+16&-16;U=(x=0,as(230,T|0)|0);if(x){x=0;G=44;break}c[n+8>>2]=U;c[n>>2]=T|1;c[n+4>>2]=R;S=U}Kb(S|0,J|0,R)|0;a[S+R|0]=0}R=(x=0,aK(328,n|0,h|0)|0);if(x){x=0;J=bQ(-1,-1)|0;U=J;J=K;if((a[n]&1)==0){V=J;W=U;break}J2(c[n+8>>2]|0);V=J;W=U;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((R|0)!=0){c[o>>2]=R;U=d+20|0;J=c[U>>2]|0;if((J|0)==(c[d+24>>2]|0)){x=0;aq(26,d+16|0,o|0);if(x){x=0;G=44;break}}else{if((J|0)==0){X=0}else{c[J>>2]=R;X=c[U>>2]|0}c[U>>2]=X+4}U=d+176|0;J=c[U>>2]|0;if((J|0)==(c[d+180>>2]|0)){x=0;aq(282,d+172|0,h|0);if(x){x=0;G=44;break}}else{do{if((J|0)!=0){if((a[j]&1)==0){T=J;c[T>>2]=c[j>>2];c[T+4>>2]=c[j+4>>2];c[T+8>>2]=c[j+8>>2];break}T=c[h+8>>2]|0;Y=c[h+4>>2]|0;if(Y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=44;break L41}}if(Y>>>0<11>>>0){a[J]=Y<<1;Z=J+1|0}else{_=Y+16&-16;$=(x=0,as(230,_|0)|0);if(x){x=0;G=44;break L41}c[J+8>>2]=$;c[J>>2]=_|1;c[J+4>>2]=Y;Z=$}Kb(Z|0,T|0,Y)|0;a[Z+Y|0]=0}}while(0);c[U>>2]=(c[U>>2]|0)+12}J=d+40|0;if((a[H]&1)==0){Y=r;c[Y>>2]=c[H>>2];c[Y+4>>2]=c[H+4>>2];c[Y+8>>2]=c[H+8>>2];aa=a[Y]|0;ab=Y}else{Y=c[k+8>>2]|0;T=c[k+4>>2]|0;if(T>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=44;break}}if(T>>>0<11>>>0){$=T<<1&255;_=r;a[_]=$;ac=r+1|0;ad=$;ae=_}else{_=T+16&-16;$=(x=0,as(230,_|0)|0);if(x){x=0;G=44;break}c[r+8>>2]=$;af=_|1;c[r>>2]=af;c[r+4>>2]=T;ac=$;ad=af&255;ae=r}Kb(ac|0,Y|0,T)|0;a[ac+T|0]=0;aa=ad;ab=ae}L117:do{if((aa&1)==0){T=q;c[T>>2]=c[ab>>2];c[T+4>>2]=c[ab+4>>2];c[T+8>>2]=c[ab+8>>2];ag=a[T]|0;ah=T;G=99}else{T=c[r+8>>2]|0;Y=c[r+4>>2]|0;do{if(Y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(Y>>>0<11>>>0){af=Y<<1&255;$=q;a[$]=af;ai=q+1|0;aj=af;ak=$}else{$=Y+16&-16;af=(x=0,as(230,$|0)|0);if(x){x=0;break}c[q+8>>2]=af;_=$|1;c[q>>2]=_;c[q+4>>2]=Y;ai=af;aj=_&255;ak=q}Kb(ai|0,T|0,Y)|0;a[ai+Y|0]=0;ag=aj;ah=ak;G=99;break L117}}while(0);Y=bQ(-1,-1)|0;al=K;am=Y}}while(0);do{if((G|0)==99){c[q+12>>2]=R;L132:do{if((ag&1)==0){U=p;c[U>>2]=c[ah>>2];c[U+4>>2]=c[ah+4>>2];c[U+8>>2]=c[ah+8>>2];G=109}else{U=c[q+8>>2]|0;Y=c[q+4>>2]|0;do{if(Y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(Y>>>0<11>>>0){a[p]=Y<<1;an=p+1|0}else{T=Y+16&-16;_=(x=0,as(230,T|0)|0);if(x){x=0;break}c[p+8>>2]=_;c[p>>2]=T|1;c[p+4>>2]=Y;an=_}Kb(an|0,U|0,Y)|0;a[an+Y|0]=0;G=109;break L132}}while(0);Y=bQ(-1,-1)|0;ao=K;ar=Y}}while(0);do{if((G|0)==109){c[p+12>>2]=R;Y=d+44|0;U=c[Y>>2]|0;do{if((U|0)==(c[d+48>>2]|0)){x=0;aq(518,J|0,p|0);if(x){x=0;G=162}}else{if((U|0)==0){at=0}else{_=p;if((a[_]&1)==0){T=U;c[T>>2]=c[_>>2];c[T+4>>2]=c[_+4>>2];c[T+8>>2]=c[_+8>>2]}else{_=c[p+8>>2]|0;T=c[p+4>>2]|0;if(T>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=162;break}}if(T>>>0<11>>>0){a[U]=T<<1;au=U+1|0}else{af=T+16&-16;$=(x=0,as(230,af|0)|0);if(x){x=0;G=162;break}c[U+8>>2]=$;c[U>>2]=af|1;c[U+4>>2]=T;au=$}Kb(au|0,_|0,T)|0;a[au+T|0]=0}c[U+12>>2]=R;at=c[Y>>2]|0}c[Y>>2]=at+16}}while(0);if((G|0)==162){Y=bQ(-1,-1)|0;U=Y;Y=K;if((a[p]&1)==0){ao=Y;ar=U;break}J2(c[p+8>>2]|0);ao=Y;ar=U;break}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}if((ag&1)!=0){J2(c[q+8>>2]|0)}if((a[ab]&1)!=0){J2(c[r+8>>2]|0)}x=0;aT(40,s|0,h|0,d+136|0,d+184|0);if(x){x=0;G=44;break L41}U=d+68|0;Y=c[U>>2]|0;L180:do{if((Y|0)==(c[d+72>>2]|0)){x=0;aq(282,d+64|0,s|0);if(x){x=0;G=168}}else{do{if((Y|0)!=0){T=s;if((a[T]&1)==0){_=Y;c[_>>2]=c[T>>2];c[_+4>>2]=c[T+4>>2];c[_+8>>2]=c[T+8>>2];break}T=c[s+8>>2]|0;_=c[s+4>>2]|0;if(_>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=168;break L180}}if(_>>>0<11>>>0){a[Y]=_<<1;av=Y+1|0}else{$=_+16&-16;af=(x=0,as(230,$|0)|0);if(x){x=0;G=168;break L180}c[Y+8>>2]=af;c[Y>>2]=$|1;c[Y+4>>2]=_;av=af}Kb(av|0,T|0,_)|0;a[av+_|0]=0}}while(0);c[U>>2]=(c[U>>2]|0)+12}}while(0);if((G|0)==168){U=bQ(-1,-1)|0;Y=U;U=K;if((a[s]&1)==0){V=U;W=Y;break L41}J2(c[s+8>>2]|0);V=U;W=Y;break L41}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}Y=(x=0,aK(506,e|0,k|0)|0);if(x){x=0;G=44;break L41}c[Y>>2]=0;if((a[H]&1)==0){c[D>>2]=c[H>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];G=357;break L41}Y=c[k+8>>2]|0;U=c[k+4>>2]|0;if(U>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=44;break L41}}if(U>>>0<11>>>0){a[D]=U<<1;aw=b+1|0}else{_=U+16&-16;T=(x=0,as(230,_|0)|0);if(x){x=0;G=44;break L41}c[b+8>>2]=T;c[b>>2]=_|1;c[b+4>>2]=U;aw=T}Kb(aw|0,Y|0,U)|0;a[aw+U|0]=0;G=357;break L41}}while(0);if((ag&1)==0){al=ao;am=ar;break}J2(c[q+8>>2]|0);al=ao;am=ar}}while(0);if((a[ab]&1)==0){V=al;W=am;break}J2(c[r+8>>2]|0);V=al;W=am;break}R=d+28|0;J=((c[d+32>>2]|0)-(c[R>>2]|0)|0)/12|0;U=u;Y=v;T=t;_=w;af=d+20|0;$=d+24|0;ax=d+16|0;ay=d+176|0;az=d+180|0;aA=d+172|0;aB=d+40|0;aC=B;aD=A;aE=A+12|0;aF=z;aG=z+12|0;aH=d+44|0;aI=d+48|0;aJ=d+64|0;aL=d+136|0;aM=d+184|0;aN=d+68|0;aO=d+72|0;aQ=C;aR=t+8|0;aS=t+4|0;aU=b+1|0;aV=b+8|0;aW=b|0;aX=b+4|0;aY=C+8|0;aZ=C+4|0;a_=B+8|0;a$=A+8|0;a0=z+8|0;a1=z+4|0;a2=A+4|0;a3=z+1|0;a4=z|0;a5=B+4|0;a6=A+1|0;a7=A|0;a8=B+1|0;a9=B|0;ba=h+8|0;bb=h+4|0;bc=w+8|0;bd=w+1|0;bf=w|0;bg=w+4|0;bh=u+8|0;bi=v+8|0;bj=f+8|0;bk=f+4|0;bl=v+1|0;bm=v|0;bn=v+4|0;bo=u+1|0;bp=u|0;bq=u+4|0;br=0;L223:while(1){if(br>>>0>=J>>>0){G=356;break}bs=c[R>>2]|0;bt=bs+(br*12|0)|0;if((a[bt]&1)==0){c[U>>2]=c[bt>>2];c[U+4>>2]=c[bt+4>>2];c[U+8>>2]=c[bt+8>>2]}else{bt=c[bs+(br*12|0)+8>>2]|0;bu=c[bs+(br*12|0)+4>>2]|0;if(bu>>>0>4294967279>>>0){G=175;break}if(bu>>>0<11>>>0){a[U]=bu<<1;bv=bo}else{bs=bu+16&-16;bw=(x=0,as(230,bs|0)|0);if(x){x=0;G=43;break}c[bh>>2]=bw;c[bp>>2]=bs|1;c[bq>>2]=bu;bv=bw}Kb(bv|0,bt|0,bu)|0;a[bv+bu|0]=0}if((a[I]&1)==0){c[Y>>2]=c[I>>2];c[Y+4>>2]=c[I+4>>2];c[Y+8>>2]=c[I+8>>2]}else{bu=c[bj>>2]|0;bt=c[bk>>2]|0;if(bt>>>0>4294967279>>>0){G=185;break}if(bt>>>0<11>>>0){a[Y]=bt<<1;bx=bl}else{bw=bt+16&-16;bs=(x=0,as(230,bw|0)|0);if(x){x=0;G=208;break}c[bi>>2]=bs;c[bm>>2]=bw|1;c[bn>>2]=bt;bx=bs}Kb(bx|0,bu|0,bt)|0;a[bx+bt|0]=0}x=0;aP(22,t|0,u|0,v|0);if(x){x=0;G=211;break}if((a[Y]&1)!=0){J2(c[bi>>2]|0)}if((a[U]&1)!=0){J2(c[bh>>2]|0)}bt=(fs(E,t)|0)==0;bu=a[T]|0;bs=(bu&1)==0;do{if(bt){if(bs){c[_>>2]=c[T>>2];c[_+4>>2]=c[T+4>>2];c[_+8>>2]=c[T+8>>2]}else{bw=c[aR>>2]|0;by=c[aS>>2]|0;if(by>>>0>4294967279>>>0){G=221;break L223}if(by>>>0<11>>>0){a[_]=by<<1;bz=bd}else{bA=by+16&-16;bB=(x=0,as(230,bA|0)|0);if(x){x=0;G=215;break L223}c[bc>>2]=bB;c[bf>>2]=bA|1;c[bg>>2]=by;bz=bB}Kb(bz|0,bw|0,by)|0;a[bz+by|0]=0}by=(x=0,aK(328,w|0,h|0)|0);if(x){x=0;G=331;break L223}if((a[_]&1)!=0){J2(c[bc>>2]|0)}if((by|0)==0){bC=0;bD=a[T]|0;break}c[y>>2]=by;bw=c[af>>2]|0;if((bw|0)==(c[$>>2]|0)){x=0;aq(26,ax|0,y|0);if(x){x=0;G=215;break L223}}else{if((bw|0)==0){bE=0}else{c[bw>>2]=by;bE=c[af>>2]|0}c[af>>2]=bE+4}bw=c[ay>>2]|0;if((bw|0)==(c[az>>2]|0)){x=0;aq(282,aA|0,h|0);if(x){x=0;G=215;break L223}}else{do{if((bw|0)!=0){if((a[j]&1)==0){bB=bw;c[bB>>2]=c[j>>2];c[bB+4>>2]=c[j+4>>2];c[bB+8>>2]=c[j+8>>2];break}bB=c[ba>>2]|0;bA=c[bb>>2]|0;if(bA>>>0>4294967279>>>0){G=243;break L223}if(bA>>>0<11>>>0){a[bw]=bA<<1;bF=bw+1|0}else{bG=bA+16&-16;bH=(x=0,as(230,bG|0)|0);if(x){x=0;G=215;break L223}c[bw+8>>2]=bH;c[bw>>2]=bG|1;c[bw+4>>2]=bA;bF=bH}Kb(bF|0,bB|0,bA)|0;a[bF+bA|0]=0}}while(0);c[ay>>2]=(c[ay>>2]|0)+12}if((a[T]&1)==0){c[aC>>2]=c[T>>2];c[aC+4>>2]=c[T+4>>2];c[aC+8>>2]=c[T+8>>2];bI=a[aC]|0}else{bw=c[aR>>2]|0;bA=c[aS>>2]|0;if(bA>>>0>4294967279>>>0){G=255;break L223}if(bA>>>0<11>>>0){bB=bA<<1&255;a[aC]=bB;bJ=a8;bK=bB}else{bB=bA+16&-16;bH=(x=0,as(230,bB|0)|0);if(x){x=0;G=215;break L223}c[a_>>2]=bH;bG=bB|1;c[a9>>2]=bG;c[a5>>2]=bA;bJ=bH;bK=bG&255}Kb(bJ|0,bw|0,bA)|0;a[bJ+bA|0]=0;bI=bK}if((bI&1)==0){c[aD>>2]=c[aC>>2];c[aD+4>>2]=c[aC+4>>2];c[aD+8>>2]=c[aC+8>>2];bL=a[aD]|0}else{bA=c[a_>>2]|0;bw=c[a5>>2]|0;if(bw>>>0>4294967279>>>0){G=265;break L223}if(bw>>>0<11>>>0){bG=bw<<1&255;a[aD]=bG;bM=a6;bN=bG}else{bG=bw+16&-16;bH=(x=0,as(230,bG|0)|0);if(x){x=0;G=333;break L223}c[a$>>2]=bH;bB=bG|1;c[a7>>2]=bB;c[a2>>2]=bw;bM=bH;bN=bB&255}Kb(bM|0,bA|0,bw)|0;a[bM+bw|0]=0;bL=bN}c[aE>>2]=by;if((bL&1)==0){c[aF>>2]=c[aD>>2];c[aF+4>>2]=c[aD+4>>2];c[aF+8>>2]=c[aD+8>>2]}else{bw=c[a$>>2]|0;bA=c[a2>>2]|0;if(bA>>>0>4294967279>>>0){G=275;break L223}if(bA>>>0<11>>>0){a[aF]=bA<<1;bO=a3}else{bB=bA+16&-16;bH=(x=0,as(230,bB|0)|0);if(x){x=0;G=336;break L223}c[a0>>2]=bH;c[a4>>2]=bB|1;c[a1>>2]=bA;bO=bH}Kb(bO|0,bw|0,bA)|0;a[bO+bA|0]=0}c[aG>>2]=by;bA=c[aH>>2]|0;if((bA|0)==(c[aI>>2]|0)){x=0;aq(518,aB|0,z|0);if(x){x=0;G=339;break L223}}else{if((bA|0)==0){bP=0}else{bR=a[aF]|0;if((bR&1)==0){bw=bA;c[bw>>2]=c[aF>>2];c[bw+4>>2]=c[aF+4>>2];c[bw+8>>2]=c[aF+8>>2]}else{bw=c[a0>>2]|0;bH=c[a1>>2]|0;if(bH>>>0>4294967279>>>0){G=287;break L223}if(bH>>>0<11>>>0){a[bA]=bH<<1;bS=bA+1|0}else{bB=bH+16&-16;bG=(x=0,as(230,bB|0)|0);if(x){x=0;G=339;break L223}c[bA+8>>2]=bG;c[bA>>2]=bB|1;c[bA+4>>2]=bH;bS=bG}Kb(bS|0,bw|0,bH)|0;a[bS+bH|0]=0}c[bA+12>>2]=by;bP=c[aH>>2]|0}c[aH>>2]=bP+16}if((a[aF]&1)!=0){J2(c[a0>>2]|0)}if((bL&1)!=0){J2(c[a$>>2]|0)}if((bI&1)!=0){J2(c[a_>>2]|0)}x=0;aT(40,C|0,h|0,aL|0,aM|0);if(x){x=0;G=215;break L223}bA=c[aN>>2]|0;if((bA|0)==(c[aO>>2]|0)){x=0;aq(282,aJ|0,C|0);if(x){x=0;G=347;break L223}}else{do{if((bA|0)!=0){if((a[aQ]&1)==0){bH=bA;c[bH>>2]=c[aQ>>2];c[bH+4>>2]=c[aQ+4>>2];c[bH+8>>2]=c[aQ+8>>2];break}bH=c[aY>>2]|0;bw=c[aZ>>2]|0;if(bw>>>0>4294967279>>>0){G=309;break L223}if(bw>>>0<11>>>0){a[bA]=bw<<1;bT=bA+1|0}else{bG=bw+16&-16;bB=(x=0,as(230,bG|0)|0);if(x){x=0;G=347;break L223}c[bA+8>>2]=bB;c[bA>>2]=bG|1;c[bA+4>>2]=bw;bT=bB}Kb(bT|0,bH|0,bw)|0;a[bT+bw|0]=0}}while(0);c[aN>>2]=(c[aN>>2]|0)+12}if((a[aQ]&1)!=0){J2(c[aY>>2]|0)}bA=(x=0,aK(506,e|0,t|0)|0);if(x){x=0;G=215;break L223}c[bA>>2]=0;bA=a[T]|0;if((bA&1)==0){c[D>>2]=c[T>>2];c[D+4>>2]=c[T+4>>2];c[D+8>>2]=c[T+8>>2];bC=1;bD=bA;break}by=c[aR>>2]|0;bw=c[aS>>2]|0;if(bw>>>0>4294967279>>>0){G=324;break L223}if(bw>>>0<11>>>0){a[D]=bw<<1;bU=aU}else{bH=bw+16&-16;bB=(x=0,as(230,bH|0)|0);if(x){x=0;G=215;break L223}c[aV>>2]=bB;c[aW>>2]=bH|1;c[aX>>2]=bw;bU=bB}Kb(bU|0,by|0,bw)|0;a[bU+bw|0]=0;bC=1;bD=bA}else{if(bs){c[D>>2]=c[T>>2];c[D+4>>2]=c[T+4>>2];c[D+8>>2]=c[T+8>>2];bC=1;bD=bu;break}bA=c[aR>>2]|0;bw=c[aS>>2]|0;if(bw>>>0>4294967279>>>0){G=201;break L223}if(bw>>>0<11>>>0){a[D]=bw<<1;bV=aU}else{by=bw+16&-16;bB=(x=0,as(230,by|0)|0);if(x){x=0;G=215;break L223}c[aV>>2]=bB;c[aW>>2]=by|1;c[aX>>2]=bw;bV=bB}Kb(bV|0,bA|0,bw)|0;a[bV+bw|0]=0;bC=1;bD=bu}}while(0);if((bD&1)!=0){J2(c[aR>>2]|0)}if((bC|0)==0){br=br+1|0}else{G=357;break L41}}do{if((G|0)==43){br=bQ(-1,-1)|0;bW=K;bX=br;G=45;break L41}else if((G|0)==175){x=0;ap(232,0);if(x){x=0;G=44;break L41}}else if((G|0)==185){x=0;ap(232,0);if(x){x=0;br=bQ(-1,-1)|0;bY=K;bZ=br;G=210;break}}else if((G|0)==201){x=0;ap(232,0);if(x){x=0;G=216;break}}else if((G|0)==208){br=bQ(-1,-1)|0;bY=K;bZ=br;G=210}else if((G|0)==211){br=bQ(-1,-1)|0;aX=br;br=K;if((a[Y]&1)==0){b_=br;b$=aX;G=213;break}J2(c[bi>>2]|0);b_=br;b$=aX;G=213}else if((G|0)==215){aX=bQ(-1,-1)|0;b0=K;b1=aX;G=217}else if((G|0)==221){x=0;ap(232,0);if(x){x=0;G=216;break}}else if((G|0)==243){x=0;ap(232,0);if(x){x=0;G=216;break}}else if((G|0)==255){x=0;ap(232,0);if(x){x=0;G=216;break}}else if((G|0)==265){x=0;ap(232,0);if(x){x=0;aX=bQ(-1,-1)|0;b2=K;b3=aX;G=335;break}}else if((G|0)==275){x=0;ap(232,0);if(x){x=0;aX=bQ(-1,-1)|0;b4=K;b5=aX;G=338;break}}else if((G|0)==287){x=0;ap(232,0);if(x){x=0;aX=bQ(-1,-1)|0;b6=K;b7=aX;b8=bR;G=341;break}}else if((G|0)==309){x=0;ap(232,0);if(x){x=0;aX=bQ(-1,-1)|0;b9=K;ca=aX;G=349;break}}else if((G|0)==324){x=0;ap(232,0);if(x){x=0;G=216;break}}else if((G|0)==331){aX=bQ(-1,-1)|0;br=aX;aX=K;if((a[_]&1)==0){cb=aX;cc=br;break}J2(c[bc>>2]|0);cb=aX;cc=br}else if((G|0)==333){br=bQ(-1,-1)|0;b2=K;b3=br;G=335}else if((G|0)==336){br=bQ(-1,-1)|0;b4=K;b5=br;G=338}else if((G|0)==339){br=bQ(-1,-1)|0;b6=K;b7=br;b8=a[aF]|0;G=341}else if((G|0)==347){br=bQ(-1,-1)|0;b9=K;ca=br;G=349}else if((G|0)==356){Ke(D|0,0,12)|0;G=357;break L41}}while(0);do{if((G|0)==210){b_=bY;b$=bZ;G=213}else if((G|0)==216){aF=bQ(-1,-1)|0;b0=K;b1=aF;G=217}else if((G|0)==335){cd=b2;ce=b3;G=345}else if((G|0)==338){cf=b4;cg=b5;G=343}else if((G|0)==341){aF=b7;bc=b6;if((b8&1)==0){cf=bc;cg=aF;G=343;break}J2(c[a0>>2]|0);cf=bc;cg=aF;G=343}else if((G|0)==349){aF=ca;bc=b9;if((a[aQ]&1)==0){cb=bc;cc=aF;break}J2(c[aY>>2]|0);cb=bc;cc=aF}}while(0);do{if((G|0)==213){if((a[U]&1)==0){V=b_;W=b$;break L41}J2(c[bh>>2]|0);V=b_;W=b$;break L41}else if((G|0)==217){cb=b0;cc=b1}else if((G|0)==343){if((bL&1)==0){cd=cf;ce=cg;G=345;break}J2(c[a$>>2]|0);cd=cf;ce=cg;G=345}}while(0);do{if((G|0)==345){if((bI&1)==0){cb=cd;cc=ce;break}J2(c[a_>>2]|0);cb=cd;cc=ce}}while(0);if((a[T]&1)==0){V=cb;W=cc;break}J2(c[aR>>2]|0);V=cb;W=cc}else{if(L){c[D>>2]=c[H>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];G=357;break}a_=c[k+8>>2]|0;a$=c[k+4>>2]|0;if(a$>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=44;break}}if(a$>>>0<11>>>0){a[D]=a$<<1;ch=b+1|0}else{bh=a$+16&-16;U=(x=0,as(230,bh|0)|0);if(x){x=0;G=44;break}c[b+8>>2]=U;c[b>>2]=bh|1;c[b+4>>2]=a$;ch=U}Kb(ch|0,a_|0,a$)|0;a[ch+a$|0]=0;G=357}}while(0);if((G|0)==44){L=bQ(-1,-1)|0;bW=K;bX=L;G=45}else if((G|0)==357){if((a[H]&1)!=0){J2(c[k+8>>2]|0)}if((a[j]&1)==0){i=g;return}J2(c[h+8>>2]|0);i=g;return}if((G|0)==45){V=bW;W=bX}if((a[H]&1)==0){M=V;N=W;break L14}J2(c[k+8>>2]|0);M=V;N=W;break L14}}while(0);if((a[l]&1)==0){M=P;N=Q;break}J2(c[l+8>>2]|0);M=P;N=Q}}while(0);if((a[j]&1)==0){ci=N;cj=0;ck=ci;cl=M;be(ck|0)}J2(c[h+8>>2]|0);ci=N;cj=0;ck=ci;cl=M;be(ck|0)}function fe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0;d=i;i=i+504|0;e=d|0;f=d+16|0;g=d+80|0;h=d+96|0;j=d+112|0;k=d+128|0;l=d+168|0;m=d+184|0;n=d+200|0;o=d+216|0;p=d+248|0;q=d+320|0;r=d+352|0;s=d+368|0;t=d+392|0;u=d+408|0;v=d+424|0;w=d+456|0;y=d+472|0;z=d+488|0;A=b+44|0;B=b+40|0;C=c[B>>2]|0;L1:do{if((c[A>>2]|0)==(C|0)){D=0}else{E=g;F=h|0;G=h+4|0;H=h+8|0;I=b+52|0;J=f+28|0;L=f+4|0;M=f+8|0;N=f+36|0;O=g+8|0;P=g+1|0;Q=g|0;R=g+4|0;S=0;T=0;U=C;while(1){V=c[U+(S<<4)+12>>2]|0;W=U+(S<<4)|0;if((a[W]&1)==0){c[E>>2]=c[W>>2];c[E+4>>2]=c[W+4>>2];c[E+8>>2]=c[W+8>>2]}else{W=c[U+(S<<4)+8>>2]|0;X=c[U+(S<<4)+4>>2]|0;if(X>>>0>4294967279>>>0){Y=6;break}if(X>>>0<11>>>0){a[E]=X<<1;Z=P}else{_=X+16&-16;$=J0(_)|0;c[O>>2]=$;c[Q>>2]=_|1;c[R>>2]=X;Z=$}Kb(Z|0,W|0,X)|0;a[Z+X|0]=0}X=S+1|0;c[F>>2]=X;c[G>>2]=1;c[H>>2]=1;x=0;ao(2,f|0,V|0,b|0,g|0,h|0);if(x){x=0;Y=16;break}if((a[E]&1)!=0){J2(c[O>>2]|0)}V=(x=0,as(260,f|0)|0);if(x){x=0;Y=18;break}W=(S|0)==0?V:T;$=(x=0,aK(506,I|0,(c[B>>2]|0)+(S<<4)|0)|0);if(x){x=0;Y=18;break}c[$>>2]=V;if((a[J]&1)!=0){J2(c[N>>2]|0)}V=c[L>>2]|0;$=V;if((V|0)!=0){_=c[M>>2]|0;if((V|0)!=(_|0)){c[M>>2]=_+(~((_-4+(-$|0)|0)>>>2)<<2)}J2(V)}V=c[B>>2]|0;if(X>>>0<(c[A>>2]|0)-V>>4>>>0){S=X;T=W;U=V}else{D=W;break L1}}if((Y|0)==16){U=bQ(-1,-1)|0;T=U;U=K;if((a[E]&1)==0){aa=U;ab=T;ac=ab;ad=0;ae=ac;af=aa;be(ae|0)}J2(c[O>>2]|0);aa=U;ab=T;ac=ab;ad=0;ae=ac;af=aa;be(ae|0)}else if((Y|0)==18){T=bQ(-1,-1)|0;U=T;T=K;if((a[J]&1)!=0){J2(c[N>>2]|0)}S=c[L>>2]|0;if((S|0)==0){aa=T;ab=U;ac=ab;ad=0;ae=ac;af=aa;be(ae|0)}I=c[M>>2]|0;if((S|0)!=(I|0)){c[M>>2]=I+(~((I-4+(-S|0)|0)>>>2)<<2)}J2(S);aa=T;ab=U;ac=ab;ad=0;ae=ac;af=aa;be(ae|0)}else if((Y|0)==6){CJ(0);return 0}}}while(0);A=j+4|0;c[A>>2]=0;c[j+8>>2]=0;c[j>>2]=A;c[j+12>>2]=0;A=l;a[A]=0;a[l+1|0]=0;B=m;a[B]=0;a[m+1|0]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;x=0;ao(24,k|0,0,l|0,e|0,m|0);do{if(!x){if((a[B]&1)!=0){J2(c[m+8>>2]|0)}if((a[A]&1)!=0){J2(c[l+8>>2]|0)}x=0;aq(538,b|0,j|0);L56:do{if(!x){x=0;aT(48,n|0,b|0,j|0,k|0);if(x){x=0;Y=50;break}x=0;aG(58,o|0,b|0,n|0,j|0,k|0,0,0);L59:do{if(!x){x=0;aB(48,p|0,b|0,n|0,o|0,j|0,k|0);L61:do{if(!x){x=0;aP(14,q|0,0,0);L63:do{if(!x){e=(x=0,aK(c[(c[D>>2]|0)+16>>2]|0,D|0,p|0)|0);L65:do{if(!x){f=(x=0,as(c[(c[e>>2]|0)+40>>2]|0,e|0)|0);if(x){x=0;Y=54;break}do{if((c[p+68>>2]|0)!=0){x=0;aT(32,r|0,b|0,p+60|0,k|0);if(x){x=0;Y=54;break L65}x=0;aq(c[(c[f>>2]|0)+8>>2]|0,f|0,r|0);if(!x){break}else{x=0}h=bQ(-1,-1)|0;ag=K;ah=h;break L65}}while(0);L73:do{if((c[b+132>>2]|0)==3){x=0;aq(288,s|0,b|0);if(x){x=0;Y=54;break L65}x=0;aq(c[(c[f>>2]|0)+8>>2]|0,f|0,s|0);do{if(!x){h=s+4|0;if((a[h]&1)==0){g=t;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2]}else{h=c[s+12>>2]|0;g=c[s+8>>2]|0;if(g>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Y=80;break}return 0}if(g>>>0<11>>>0){a[t]=g<<1;ai=t+1|0}else{Z=g+16&-16;C=(x=0,as(230,Z|0)|0);if(x){x=0;Y=80;break}c[t+8>>2]=C;c[t>>2]=Z|1;c[t+4>>2]=g;ai=C}Kb(ai|0,h|0,g)|0;a[ai+g|0]=0}do{if((a[b+129|0]&1)==0){Y=84}else{x=0;aP(28,u|0,0,b+136|0);if(x){x=0;Y=81;break}g=u;h=a[g]|0;if((h&1)==0){aj=u+1|0}else{aj=c[u+8>>2]|0}C=h&255;if((C&1|0)==0){ak=C>>>1}else{ak=c[u+4>>2]|0}x=0,ax(64,t|0,aj|0,ak|0)|0;if(!x){if((a[g]&1)==0){Y=84;break}J2(c[u+8>>2]|0);Y=84;break}else{x=0;C=bQ(-1,-1)|0;h=C;C=K;if((a[g]&1)==0){al=C;am=h;break}J2(c[u+8>>2]|0);al=C;am=h;break}}}while(0);do{if((Y|0)==84){h=t;if((a[h]&1)==0){an=t+1|0}else{an=c[t+8>>2]|0}C=(x=0,as(232,an|0)|0);if(x){x=0;Y=81;break}if((a[h]&1)!=0){J2(c[t+8>>2]|0)}x=0;ap(250,s|0);if(!x){ar=C;break L73}else{x=0;Y=54;break L65}}}while(0);if((Y|0)==81){C=bQ(-1,-1)|0;al=K;am=C}if((a[t]&1)==0){at=al;au=am;break}J2(c[t+8>>2]|0);at=al;au=am}else{x=0;Y=80}}while(0);if((Y|0)==80){C=bQ(-1,-1)|0;at=K;au=C}x=0;ap(250,s|0);if(!x){ag=at;ah=au;break L65}else{x=0}av=bQ(-1,-1,0)|0;aw=K;bU();return 0}else{x=0;aP(14,v|0,(a[b+128|0]&1)!=0|0,b|0);if(x){x=0;Y=54;break L65}x=0;aq(c[(c[f>>2]|0)+8>>2]|0,f|0,v|0);do{if(!x){C=v+4|0;if((a[C]&1)==0){h=w;c[h>>2]=c[C>>2];c[h+4>>2]=c[C+4>>2];c[h+8>>2]=c[C+8>>2]}else{C=c[v+12>>2]|0;h=c[v+8>>2]|0;if(h>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Y=135;break}return 0}if(h>>>0<11>>>0){a[w]=h<<1;ay=w+1|0}else{g=h+16&-16;Z=(x=0,as(230,g|0)|0);if(x){x=0;Y=135;break}c[w+8>>2]=Z;c[w>>2]=g|1;c[w+4>>2]=h;ay=Z}Kb(ay|0,C|0,h)|0;a[ay+h|0]=0}L91:do{if((a[b+129|0]&1)==0){Y=142}else{x=0;aP(28,z|0,0,b+136|0);if(x){x=0;Y=136;break}h=y;Ke(h|0,0,12)|0;C=z;Z=z;g=a[Z]|0;U=g&255;if((U&1|0)==0){az=U>>>1}else{az=c[z+4>>2]|0}U=az+1|0;do{if(U>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Y=122;break}return 0}else{if(U>>>0<11>>>0){a[h]=2;aA=y+1|0}else{T=az+17&-16;S=(x=0,as(230,T|0)|0);if(x){x=0;Y=122;break}c[y+8>>2]=S;c[y>>2]=T|1;c[y+4>>2]=1;aA=S}a[aA]=10;a[aA+1|0]=0;if((g&1)==0){aC=C+1|0}else{aC=c[z+8>>2]|0}x=0,ax(64,y|0,aC|0,az|0)|0;if(x){x=0;Y=122;break}S=a[h]|0;if((S&1)==0){aD=y+1|0}else{aD=c[y+8>>2]|0}T=S&255;if((T&1|0)==0){aE=T>>>1}else{aE=c[y+4>>2]|0}x=0,ax(64,w|0,aD|0,aE|0)|0;if(x){x=0;T=bQ(-1,-1)|0;S=T;T=K;if((a[h]&1)==0){aF=T;aH=S;break}J2(c[y+8>>2]|0);aF=T;aH=S;break}if((a[h]&1)!=0){J2(c[y+8>>2]|0)}if((a[Z]&1)==0){Y=142;break L91}J2(c[z+8>>2]|0);Y=142;break L91}}while(0);if((Y|0)==122){C=bQ(-1,-1)|0;g=K;if((a[h]&1)!=0){J2(c[y+8>>2]|0)}aF=g;aH=C}if((a[Z]&1)==0){aI=aF;aJ=aH;break}J2(c[z+8>>2]|0);aI=aF;aJ=aH}}while(0);do{if((Y|0)==142){C=w;if((a[C]&1)==0){aL=w+1|0}else{aL=c[w+8>>2]|0}g=(x=0,as(232,aL|0)|0);if(x){x=0;Y=136;break}if((a[C]&1)!=0){J2(c[w+8>>2]|0)}x=0;ap(430,v|0);if(!x){ar=g;break L73}else{x=0;Y=54;break L65}}}while(0);if((Y|0)==136){g=bQ(-1,-1)|0;aI=K;aJ=g}if((a[w]&1)==0){aM=aI;aN=aJ;break}J2(c[w+8>>2]|0);aM=aI;aN=aJ}else{x=0;Y=135}}while(0);if((Y|0)==135){g=bQ(-1,-1)|0;aM=K;aN=g}x=0;ap(430,v|0);if(!x){ag=aM;ah=aN;break L65}else{x=0}av=bQ(-1,-1,0)|0;aw=K;bU();return 0}}while(0);x=0;ap(430,q|0);if(x){x=0;Y=53;break L63}x=0;ap(530,p|0);if(x){x=0;Y=52;break L61}x=0;ap(24,o|0);if(x){x=0;Y=51;break L59}x=0;ap(168,n|0);if(x){x=0;Y=50;break L56}if((a[k+28|0]&1)!=0){J2(c[k+36>>2]|0)}if((a[k+4|0]&1)==0){aO=j|0;aQ=j+4|0;aR=c[aQ>>2]|0;aS=aR;fQ(aO,aS);i=d;return ar|0}J2(c[k+12>>2]|0);aO=j|0;aQ=j+4|0;aR=c[aQ>>2]|0;aS=aR;fQ(aO,aS);i=d;return ar|0}else{x=0;Y=54}}while(0);if((Y|0)==54){e=bQ(-1,-1)|0;ag=K;ah=e}x=0;ap(430,q|0);if(!x){aU=ag;aV=ah;break}else{x=0}av=bQ(-1,-1,0)|0;aw=K;bU();return 0}else{x=0;Y=53}}while(0);if((Y|0)==53){e=bQ(-1,-1)|0;aU=K;aV=e}x=0;ap(530,p|0);if(!x){aW=aU;aX=aV;break}else{x=0}av=bQ(-1,-1,0)|0;aw=K;bU();return 0}else{x=0;Y=52}}while(0);if((Y|0)==52){e=bQ(-1,-1)|0;aW=K;aX=e}x=0;ap(24,o|0);if(!x){aY=aW;aZ=aX;break}else{x=0}av=bQ(-1,-1,0)|0;aw=K;bU();return 0}else{x=0;Y=51}}while(0);if((Y|0)==51){e=bQ(-1,-1)|0;aY=K;aZ=e}x=0;ap(168,n|0);if(!x){a_=aY;a$=aZ;break}else{x=0}av=bQ(-1,-1,0)|0;aw=K;bU();return 0}else{x=0;Y=50}}while(0);if((Y|0)==50){M=bQ(-1,-1)|0;a_=K;a$=M}if((a[k+28|0]&1)!=0){J2(c[k+36>>2]|0)}if((a[k+4|0]&1)==0){a0=a_;a1=a$;break}J2(c[k+12>>2]|0);a0=a_;a1=a$}else{x=0;M=bQ(-1,-1)|0;L=M;M=K;if((a[B]&1)!=0){J2(c[m+8>>2]|0)}if((a[A]&1)==0){a0=M;a1=L;break}J2(c[l+8>>2]|0);a0=M;a1=L}}while(0);fQ(j|0,c[j+4>>2]|0);aa=a0;ab=a1;ac=ab;ad=0;ae=ac;af=aa;be(ae|0);return 0}function ff(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e|0;fk(b,c[8738]|0,104,d);g=f;h=f;a[h]=8;j=g+1|0;C=1633838962;a[j]=C;C=C>>8;a[j+1|0]=C;C=C>>8;a[j+2|0]=C;C=C>>8;a[j+3|0]=C;a[g+5|0]=0;x=0;aP(378,b|0,f|0,d|0);if(!x){if((a[h]&1)!=0){J2(c[f+8>>2]|0)}fm(b,c[8808]|0,22,4,d);fm(b,c[8810]|0,90,2,d);fk(b,c[8740]|0,58,d);fk(b,c[8720]|0,36,d);fk(b,c[8734]|0,8,d);fk(b,c[8746]|0,48,d);fk(b,c[8754]|0,2,d);fk(b,c[8730]|0,6,d);fk(b,c[8752]|0,68,d);fk(b,c[8768]|0,56,d);fk(b,c[8782]|0,70,d);fk(b,c[8780]|0,28,d);fk(b,c[8802]|0,38,d);fk(b,c[8816]|0,66,d);fk(b,c[8790]|0,42,d);fk(b,c[8774]|0,78,d);fk(b,c[8786]|0,18,d);fk(b,c[8776]|0,10,d);fk(b,c[8814]|0,32,d);fk(b,c[8724]|0,80,d);fk(b,c[8798]|0,80,d);fk(b,c[8800]|0,110,d);fk(b,c[8804]|0,110,d);fk(b,c[8760]|0,24,d);fk(b,c[8792]|0,24,d);fk(b,c[8764]|0,52,d);fk(b,c[8766]|0,64,d);fk(b,c[8762]|0,96,d);fk(b,c[8772]|0,16,d);fk(b,c[8794]|0,74,d);fk(b,c[8716]|0,26,d);fk(b,c[8770]|0,20,d);fk(b,c[8714]|0,88,d);fk(b,c[8732]|0,94,d);fk(b,c[8722]|0,54,d);fk(b,c[8756]|0,44,d);fk(b,c[8748]|0,86,d);fk(b,c[8750]|0,4,d);fk(b,c[8812]|0,106,d);fk(b,c[8742]|0,72,d);fk(b,c[8718]|0,30,d);fk(b,c[8728]|0,60,d);fk(b,c[8818]|0,112,d);fk(b,c[8806]|0,14,d);fk(b,c[8736]|0,84,d);fk(b,c[8796]|0,46,d);fk(b,c[8726]|0,92,d);fk(b,c[8788]|0,34,d);fk(b,c[8778]|0,62,d);fk(b,c[8744]|0,82,d);fk(b,c[8758]|0,76,d);fk(b,c[8784]|0,12,d);i=e;return}else{x=0}e=bQ(-1,-1)|0;if((a[h]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function fg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0;d=i;i=i+48|0;f=d|0;g=d+16|0;h=d+32|0;j=e;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2]}else{j=c[e+8>>2]|0;k=c[e+4>>2]|0;if(k>>>0>4294967279>>>0){CJ(0)}if(k>>>0<11>>>0){a[h]=k<<1;l=h+1|0}else{e=k+16&-16;m=J0(e)|0;c[h+8>>2]=m;c[h>>2]=e|1;c[h+4>>2]=k;l=m}Kb(l|0,j|0,k)|0;a[l+k|0]=0}x=0;aq(106,g|0,h|0);do{if(!x){k=f;Ke(k|0,0,12)|0;l=g;j=g;m=a[j]|0;e=m&255;if((e&1|0)==0){n=e>>>1}else{n=c[g+4>>2]|0}e=n+21|0;do{if(e>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;o=24;break}}else{if(e>>>0<11>>>0){a[k]=42;p=f+1|0}else{q=n+37&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;o=24;break}c[f+8>>2]=r;c[f>>2]=q|1;c[f+4>>2]=21;p=r}Kb(p|0,10096,21)|0;a[p+21|0]=0;if((m&1)==0){s=l+1|0}else{s=c[g+8>>2]|0}x=0,ax(64,f|0,s|0,n|0)|0;if(x){x=0;o=24;break}x=0;aP(388,b|0,f|0,10088);if(x){x=0;r=bQ(-1,-1)|0;q=r;r=K;if((a[k]&1)==0){t=r;u=q;break}J2(c[f+8>>2]|0);t=r;u=q;break}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}if((a[j]&1)!=0){J2(c[g+8>>2]|0)}if((a[h]&1)==0){i=d;return}J2(c[h+8>>2]|0);i=d;return}}while(0);if((o|0)==24){l=bQ(-1,-1)|0;m=K;if((a[k]&1)!=0){J2(c[f+8>>2]|0)}t=m;u=l}if((a[j]&1)==0){v=t;w=u;break}J2(c[g+8>>2]|0);v=t;w=u}else{x=0;l=bQ(-1,-1)|0;v=K;w=l}}while(0);if((a[h]&1)==0){y=w;z=0;A=y;B=v;be(A|0)}J2(c[h+8>>2]|0);y=w;z=0;A=y;B=v;be(A|0)}function fh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=b;Ke(f|0,0,12)|0;g=a[d]|0;h=g&255;if((h&1|0)==0){i=h>>>1}else{i=c[d+4>>2]|0}h=Kf(e|0)|0;if((g&1)==0){j=d+1|0}else{j=c[d+8>>2]|0}d=h+i|0;do{if(d>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(d>>>0<11>>>0){a[f]=i<<1;k=b+1|0}else{g=d+16&-16;l=(x=0,as(230,g|0)|0);if(x){x=0;break}c[b+8>>2]=l;c[b>>2]=g|1;c[b+4>>2]=i;k=l}Kb(k|0,j|0,i)|0;a[k+i|0]=0;x=0,ax(64,b|0,e|0,h|0)|0;if(x){x=0;break}return}}while(0);h=bQ(-1,-1)|0;if((a[f]&1)==0){be(h|0)}J2(c[b+8>>2]|0);be(h|0)}function fi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+16|0;e=d|0;f=b+12|0;g=c[f>>2]|0;if((g|0)==0){h=0;i=d;return h|0}j=b+40|0;k=c[j>>2]|0;l=b+44|0;m=c[l>>2]|0;if((k|0)==(m|0)){n=g}else{g=m;while(1){m=g-16|0;c[l>>2]=m;if((a[m]&1)==0){o=m}else{J2(c[g-16+8>>2]|0);o=c[l>>2]|0}if((k|0)==(o|0)){break}else{g=o}}n=c[f>>2]|0}f=J0(16)|0;o=e+8|0;c[o>>2]=f;c[e>>2]=17;c[e+4>>2]=13;Kb(f|0,10048,13)|0;a[f+13|0]=0;g=e+12|0;c[g>>2]=n;do{if((k|0)==(c[b+48>>2]|0)){x=0;aq(518,j|0,e|0);if(x){x=0;p=16;break}if((a[e]&1)!=0){p=14}}else{if((k|0)==0){q=0}else{n=(x=0,as(230,16)|0);if(x){x=0;p=16;break}c[k+8>>2]=n;c[k>>2]=17;c[k+4>>2]=13;Kb(n|0,f|0,13)|0;a[n+13|0]=0;c[k+12>>2]=c[g>>2];q=c[l>>2]|0}c[l>>2]=q+16;p=14}}while(0);if((p|0)==16){q=bQ(-1,-1)|0;if((a[e]&1)==0){be(q|0)}J2(c[o>>2]|0);be(q|0)}else if((p|0)==14){J2(c[o>>2]|0)}h=fe(b)|0;i=d;return h|0}function fj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+32|0;j=d+172|0;k=j|0;l=d+176|0;fv(c[k>>2]|0,c[l>>2]|0,e+24|0);d=c[l>>2]|0;c[f>>2]=c[k>>2];c[g>>2]=d;fo(h,f,g,e+16|0);g=c[h>>2]|0;h=c[l>>2]|0;f=c[k>>2]|0;k=f;d=g;m=(d-k|0)/12|0;n=f+(m*12|0)|0;if((g|0)==(h|0)){fC(b,j);i=e;return}g=((h-d|0)/12|0)+m|0;d=f+(g*12|0)|0;if((d|0)==(h|0)){o=n;p=h}else{q=h+(~g*12|0)+(-k|0)|0;k=m+1|0;m=n;n=d;while(1){CQ(m,n)|0;d=n+12|0;if((d|0)==(h|0)){break}else{m=m+12|0;n=d}}o=f+((k+((q>>>0)/12|0)|0)*12|0)|0;p=c[l>>2]|0}if((o|0)==(p|0)){fC(b,j);i=e;return}else{r=p}while(1){p=r-12|0;c[l>>2]=p;if((a[p]&1)==0){s=p}else{J2(c[r-12+8>>2]|0);s=c[l>>2]|0}if((o|0)==(s|0)){break}else{r=s}}fC(b,j);i=e;return}function fk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0;g=i;i=i+32|0;h=g|0;j=g+16|0;k=oo(d,e,b)|0;c[k+48>>2]=f;b=k|0;e=k+32|0;if((a[e]&1)==0){d=j;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];l=a[d]|0;m=d}else{d=c[k+40>>2]|0;e=c[k+36>>2]|0;if(e>>>0>4294967279>>>0){CJ(0)}if(e>>>0<11>>>0){k=e<<1&255;n=j;a[n]=k;o=j+1|0;p=k;q=n}else{n=e+16&-16;k=J0(n)|0;c[j+8>>2]=k;r=n|1;c[j>>2]=r;c[j+4>>2]=e;o=k;p=r&255;q=j}Kb(o|0,d|0,e)|0;a[o+e|0]=0;l=p;m=q}q=h;Ke(q|0,0,12)|0;p=l&255;if((p&1|0)==0){s=p>>>1}else{s=c[j+4>>2]|0}if((l&1)==0){t=j+1|0}else{t=c[j+8>>2]|0}l=s+3|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;u=23;break}}else{if(l>>>0<11>>>0){a[q]=s<<1;v=h+1|0}else{p=s+19&-16;e=(x=0,as(230,p|0)|0);if(x){x=0;u=23;break}c[h+8>>2]=e;c[h>>2]=p|1;c[h+4>>2]=s;v=e}Kb(v|0,t|0,s)|0;a[v+s|0]=0;x=0,ax(64,h|0,10008,3)|0;if(x){x=0;u=23;break}e=(x=0,aK(88,f|0,h|0)|0);if(x){x=0;p=bQ(-1,-1)|0;o=p;p=K;if((a[q]&1)==0){w=p;y=o;break}J2(c[h+8>>2]|0);w=p;y=o;break}c[e>>2]=b;if((a[q]&1)!=0){J2(c[h+8>>2]|0)}if((a[m]&1)==0){i=g;return}J2(c[j+8>>2]|0);i=g;return}}while(0);if((u|0)==23){u=bQ(-1,-1)|0;g=K;if((a[q]&1)!=0){J2(c[h+8>>2]|0)}w=g;y=u}if((a[m]&1)==0){z=y;A=0;B=z;C=w;be(B|0)}J2(c[j+8>>2]|0);z=y;A=0;B=z;C=w;be(B|0)}function fl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e|0;g=b|0;if((et(b|0,d)|0)!=0){h=eo(g,d)|0;i=e;return h|0}j=c[b+12>>2]|0;if((j|0)==0){h=eo(g,d)|0;i=e;return h|0}g=d;if((a[g]&1)==0){b=f;c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2]}else{g=c[d+8>>2]|0;b=c[d+4>>2]|0;if(b>>>0>4294967279>>>0){CJ(0);return 0}if(b>>>0<11>>>0){a[f]=b<<1;k=f+1|0}else{d=b+16&-16;l=J0(d)|0;c[f+8>>2]=l;c[f>>2]=d|1;c[f+4>>2]=b;k=l}Kb(k|0,g|0,b)|0;a[k+b|0]=0}b=(x=0,aK(88,j|0,f|0)|0);if(!x){if((a[f]&1)==0){h=b;i=e;return h|0}J2(c[f+8>>2]|0);h=b;i=e;return h|0}else{x=0;h=bQ(-1,-1)|0;if((a[f]&1)==0){be(h|0)}J2(c[f+8>>2]|0);be(h|0)}return 0}function fm(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;h=i;i=i+16|0;j=h|0;k=j;l=i;i=i+144|0;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=oo(d,e,b)|0;b=l+64|0;e=l|0;d=l+8|0;p=d|0;c[p>>2]=14576;q=l+12|0;c[e>>2]=31212;r=l+64|0;c[r>>2]=31232;c[l+4>>2]=0;x=0;aq(200,l+64|0,q|0);do{if(!x){c[l+136>>2]=0;c[l+140>>2]=-1;s=l+8|0;c[e>>2]=14556;c[b>>2]=14596;c[p>>2]=14576;t=q|0;c[t>>2]=14880;u=l+16|0;HA(u);v=l+20|0;Ke(v|0,0,24)|0;c[t>>2]=14736;w=l+44|0;y=l+56|0;z=l+60|0;Ke(l+44|0,0,16)|0;c[z>>2]=24;Ke(k|0,0,12)|0;x=0;aq(214,q|0,j|0);if(x){x=0;A=bQ(-1,-1)|0;B=K;if((a[k]&1)!=0){J2(c[j+8>>2]|0)}if((a[w]&1)!=0){J2(c[l+52>>2]|0)}c[t>>2]=14880;x=0;ap(388,u|0);if(!x){C=A;D=B;break}else{x=0}bQ(-1,-1,0)|0;bU()}if((a[k]&1)!=0){J2(c[j+8>>2]|0)}B=o+32|0;do{if((a[B]&1)==0){A=m;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];E=25}else{A=c[o+40>>2]|0;t=c[o+36>>2]|0;if(t>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;E=69;break}}if(t>>>0<11>>>0){a[m]=t<<1;F=m+1|0}else{G=t+16&-16;H=(x=0,as(230,G|0)|0);if(x){x=0;E=69;break}c[m+8>>2]=H;c[m>>2]=G|1;c[m+4>>2]=t;F=H}Kb(F|0,A|0,t)|0;a[F+t|0]=0;E=25}}while(0);L29:do{if((E|0)==25){B=(x=0,aK(802,d|0,m|0)|0);do{if(!x){t=(x=0,aK(112,B|0,10008)|0);if(x){x=0;break}x=0,aK(312,t|0,f|0)|0;if(x){x=0;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}c[o+48>>2]=g;t=o|0;A=n;H=c[z>>2]|0;do{if((H&16|0)==0){if((H&8|0)==0){Ke(A|0,0,12)|0;break}G=c[v>>2]|0;I=c[l+28>>2]|0;J=G;L=I-J|0;if(L>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;E=69;break L29}}if(L>>>0<11>>>0){a[A]=L<<1;M=n+1|0}else{N=L+16&-16;O=(x=0,as(230,N|0)|0);if(x){x=0;E=69;break L29}c[n+8>>2]=O;c[n>>2]=N|1;c[n+4>>2]=L;M=O}if((G|0)==(I|0)){P=M}else{O=I+(-J|0)|0;J=M;L=G;while(1){a[J]=a[L]|0;G=L+1|0;if((G|0)==(I|0)){break}else{J=J+1|0;L=G}}P=M+O|0}a[P]=0}else{L=c[y>>2]|0;J=c[l+36>>2]|0;if(L>>>0<J>>>0){c[y>>2]=J;Q=J}else{Q=L}L=c[l+32>>2]|0;J=L;I=Q-J|0;if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;E=69;break L29}}if(I>>>0<11>>>0){a[A]=I<<1;R=n+1|0}else{G=I+16&-16;N=(x=0,as(230,G|0)|0);if(x){x=0;E=69;break L29}c[n+8>>2]=N;c[n>>2]=G|1;c[n+4>>2]=I;R=N}if((L|0)==(Q|0)){S=R}else{N=Q+(-J|0)|0;J=R;I=L;while(1){a[J]=a[I]|0;L=I+1|0;if((L|0)==(Q|0)){break}else{J=J+1|0;I=L}}S=R+N|0}a[S]=0}}while(0);H=(x=0,aK(88,g|0,n|0)|0);if(x){x=0;I=bQ(-1,-1)|0;J=I;I=K;if((a[A]&1)==0){T=I;U=J;break L29}J2(c[n+8>>2]|0);T=I;U=J;break L29}c[H>>2]=t;if((a[A]&1)!=0){J2(c[n+8>>2]|0)}c[e>>2]=14556;c[r>>2]=14596;c[s>>2]=14576;H=l+12|0;c[H>>2]=14736;if((a[w]&1)!=0){J2(c[l+52>>2]|0)}c[H>>2]=14880;x=0;ap(388,u|0);if(!x){C7(l+64|0);i=h;return}else{x=0}H=bQ(-1,-1)|0;x=0;ap(268,l+64|0);if(!x){be(H|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}else{x=0}}while(0);B=bQ(-1,-1)|0;H=B;B=K;if((a[m]&1)==0){T=B;U=H;break}J2(c[m+8>>2]|0);T=B;U=H}}while(0);if((E|0)==69){y=bQ(-1,-1)|0;T=K;U=y}c[e>>2]=14556;c[r>>2]=14596;c[s>>2]=14576;y=l+12|0;c[y>>2]=14736;if((a[w]&1)!=0){J2(c[l+52>>2]|0)}c[y>>2]=14880;x=0;ap(388,u|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,l+64|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,l+64|0);if(!x){be(U|0)}else{x=0}bQ(-1,-1,0)|0;bU()}else{x=0;y=bQ(-1,-1)|0;C=y;D=K}}while(0);x=0;ap(268,b|0);if(!x){be(C|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function fn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+72|0;g=f|0;h=f+16|0;j=f+24|0;k=f+40|0;l=f+56|0;m=J0(72)|0;c[h>>2]=m;n=b+4|0;o=c[n>>2]|0;if((o|0)==(c[b+8>>2]|0)){ee(b|0,h);p=c[h>>2]|0}else{if((o|0)==0){q=0}else{c[o>>2]=m;q=c[n>>2]|0}c[n>>2]=q+4;p=m}m=p;q=p;o=(x=0,as(230,32)|0);do{if(!x){h=j+8|0;c[h>>2]=o;c[j>>2]=33;c[j+4>>2]=19;Kb(o|0,9968,19)|0;a[o+19|0]=0;r=d;L10:do{if((a[r]&1)==0){s=k;c[s>>2]=c[r>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2];t=17}else{s=c[d+8>>2]|0;u=c[d+4>>2]|0;do{if(u>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(u>>>0<11>>>0){a[k]=u<<1;v=k+1|0}else{w=u+16&-16;y=(x=0,as(230,w|0)|0);if(x){x=0;break}c[k+8>>2]=y;c[k>>2]=w|1;c[k+4>>2]=u;v=y}Kb(v|0,s|0,u)|0;a[v+u|0]=0;t=17;break L10}}while(0);u=bQ(-1,-1)|0;z=K;A=u}}while(0);do{if((t|0)==17){c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;x=0;aA(16,q|0,j|0,g|0,0,k|0,0,0,1);if(x){x=0;r=bQ(-1,-1)|0;u=r;r=K;if((a[k]&1)==0){z=r;A=u;break}J2(c[k+8>>2]|0);z=r;A=u;break}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((a[j]&1)!=0){J2(c[h>>2]|0)}fh(l,d,10008);u=(x=0,aK(88,e|0,l|0)|0);if(!x){c[u>>2]=p;if((a[l]&1)==0){i=f;return}J2(c[l+8>>2]|0);i=f;return}else{x=0;u=bQ(-1,-1)|0;r=u;u=K;if((a[l]&1)==0){B=u;C=r;D=C;E=0;F=D;G=B;be(F|0)}J2(c[l+8>>2]|0);B=u;C=r;D=C;E=0;F=D;G=B;be(F|0)}}}while(0);if((a[j]&1)==0){H=z;I=A;break}J2(c[h>>2]|0);H=z;I=A}else{x=0;r=bQ(-1,-1)|0;H=K;I=r}}while(0);A=c[b>>2]|0;b=c[n>>2]|0;z=A;while(1){if((z|0)==(b|0)){J=b;break}if((c[z>>2]|0)==(p|0)){J=z;break}else{z=z+4|0}}z=J-A>>2;J=A+(z+1<<2)|0;p=b-J|0;Kc(A+(z<<2)|0,J|0,p|0)|0;J=A+((p>>2)+z<<2)|0;z=c[n>>2]|0;if((J|0)!=(z|0)){c[n>>2]=z+(~((z-4+(-J|0)|0)>>>2)<<2)}J2(m);B=H;C=I;D=C;E=0;F=D;G=B;be(F|0)}function fo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;h=d;d=i;i=i+4|0;i=i+7&-8;c[d>>2]=c[h>>2];h=e;e=i;i=i+4|0;i=i+7&-8;c[e>>2]=c[h>>2];h=f;f=i;i=i+1|0;i=i+7&-8;a[f]=a[h]|0;h=d|0;d=c[h>>2]|0;f=c[e>>2]|0;L1:do{if((d|0)==(f|0)){j=d}else{e=d+12|0;if((e|0)!=(f|0)){k=d;l=e;e=a[d]|0;while(1){m=k;n=e&255;if((n&1|0)==0){o=n>>>1}else{o=c[k+4>>2]|0}n=l;p=a[l]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[k+16>>2]|0}L15:do{if((o|0)==(r|0)){q=(a[k]&1)==0;if(q){s=m+1|0}else{s=c[k+8>>2]|0}if((p&1)==0){t=n+1|0}else{t=c[k+20>>2]|0}if(!q){if((Kd(s|0,t|0,o|0)|0)==0){j=k;break L1}else{break}}if((o|0)==0){j=k;break L1}else{u=t;v=s;w=o}while(1){if((a[v]|0)!=(a[u]|0)){break L15}q=w-1|0;if((q|0)==0){j=k;break L1}else{u=u+1|0;v=v+1|0;w=q}}}}while(0);n=l+12|0;if((n|0)==(f|0)){break}else{k=l;l=n;e=p}}}c[h>>2]=f;x=f;y=b|0;c[y>>2]=x;i=g;return}}while(0);c[h>>2]=j;if((j|0)==(f|0)){x=f;y=b|0;c[y>>2]=x;i=g;return}w=j+24|0;if((w|0)==(f|0)){z=j}else{v=j+12|0;u=w;w=j;while(1){j=w;o=a[w]|0;s=o&255;if((s&1|0)==0){A=s>>>1}else{A=c[w+4>>2]|0}s=u;t=a[u]|0;r=t&255;if((r&1|0)==0){B=r>>>1}else{B=c[v+16>>2]|0}L50:do{if((A|0)==(B|0)){r=(o&1)==0;if(r){C=j+1|0}else{C=c[w+8>>2]|0}if((t&1)==0){D=s+1|0}else{D=c[v+20>>2]|0}if(!r){if((Kd(C|0,D|0,A|0)|0)==0){E=w;break}else{F=45;break}}if((A|0)==0){E=w;break}else{G=D;H=C;I=A}while(1){if((a[H]|0)!=(a[G]|0)){F=45;break L50}r=I-1|0;if((r|0)==0){E=w;break}else{G=G+1|0;H=H+1|0;I=r}}}else{F=45}}while(0);if((F|0)==45){F=0;s=w+12|0;c[h>>2]=s;CQ(s,u)|0;E=s}s=u+12|0;if((s|0)==(f|0)){z=E;break}else{v=u;u=s;w=E}}}E=z+12|0;c[h>>2]=E;x=E;y=b|0;c[y>>2]=x;i=g;return}function fp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=(f&1|0)==0;j=f>>>1;f=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;e=g;while(1){g=e+16|0;if(i){m=j}else{m=c[l>>2]|0}n=g;o=a[g]|0;g=o&255;p=(g&1|0)==0;if(p){q=g>>>1}else{q=c[e+20>>2]|0}if(f){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=Kd(r|0,t|0,(q>>>0<m>>>0?q:m)|0)|0;if((o|0)==0){if(m>>>0<q>>>0){u=16}}else{if((o|0)<0){u=16}}if((u|0)==16){u=0;v=e|0;o=c[v>>2]|0;if((o|0)==0){u=17;break}else{e=o;continue}}if(p){w=g>>>1}else{w=c[e+20>>2]|0}if(i){x=j}else{x=c[l>>2]|0}if(s){y=n+1|0}else{y=c[e+24>>2]|0}if(f){z=b}else{z=c[k>>2]|0}n=Kd(y|0,z|0,(x>>>0<w>>>0?x:w)|0)|0;if((n|0)==0){if(w>>>0>=x>>>0){u=33;break}}else{if((n|0)>=0){u=33;break}}A=e+4|0;n=c[A>>2]|0;if((n|0)==0){u=32;break}else{e=n}}if((u|0)==33){c[d>>2]=e;h=d;return h|0}else if((u|0)==17){c[d>>2]=e;h=v;return h|0}else if((u|0)==32){c[d>>2]=e;h=A;return h|0}return 0}function fq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=b+4|0;f=c[e>>2]|0;g=b|0;h=c[g>>2]|0;i=h;j=f-i>>4;k=j+1|0;if(k>>>0>268435455>>>0){Hu(0)}l=b+8|0;b=(c[l>>2]|0)-i|0;if(b>>4>>>0>134217726>>>0){m=268435455;n=5}else{i=b>>3;b=i>>>0<k>>>0?k:i;if((b|0)==0){o=0;p=0}else{m=b;n=5}}if((n|0)==5){o=J0(m<<4)|0;p=m}m=o+(j<<4)|0;b=o+(p<<4)|0;L9:do{if((m|0)==0){q=f;n=18}else{p=d;L11:do{if((a[p]&1)==0){i=m;c[i>>2]=c[p>>2];c[i+4>>2]=c[p+4>>2];c[i+8>>2]=c[p+8>>2];r=f}else{i=c[d+8>>2]|0;s=c[d+4>>2]|0;do{if(s>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(s>>>0<11>>>0){a[m]=s<<1;t=m+1|0}else{u=s+16&-16;v=(x=0,as(230,u|0)|0);if(x){x=0;break}c[o+(j<<4)+8>>2]=v;c[m>>2]=u|1;c[o+(j<<4)+4>>2]=s;t=v}Kb(t|0,i|0,s)|0;a[t+s|0]=0;r=c[e>>2]|0;break L11}}while(0);s=bQ(-1,-1)|0;w=K;y=s;break L9}}while(0);c[o+(j<<4)+12>>2]=c[d+12>>2];q=r;n=18}}while(0);L25:do{if((n|0)==18){r=o+(k<<4)|0;L27:do{if((q|0)==(h|0)){c[g>>2]=m;c[e>>2]=r;c[l>>2]=b;z=h}else{d=q;j=m;while(1){A=j-16|0;t=d-16|0;if((A|0)!=0){f=t;if((a[f]&1)==0){p=A;c[p>>2]=c[f>>2];c[p+4>>2]=c[f+4>>2];c[p+8>>2]=c[f+8>>2]}else{f=c[d-16+8>>2]|0;p=c[d-16+4>>2]|0;if(p>>>0>4294967279>>>0){n=24;break}if(p>>>0<11>>>0){a[A]=p<<1;B=A+1|0}else{s=p+16&-16;i=(x=0,as(230,s|0)|0);if(x){x=0;n=41;break}c[j-16+8>>2]=i;c[A>>2]=s|1;c[j-16+4>>2]=p;B=i}Kb(B|0,f|0,p)|0;a[B+p|0]=0}c[j-16+12>>2]=c[d-16+12>>2]}if((t|0)==(h|0)){n=33;break}else{d=t;j=A}}do{if((n|0)==41){d=bQ(-1,-1)|0;C=K;D=d}else if((n|0)==24){x=0;ap(232,0);if(x){x=0;d=bQ(-1,-1)|0;C=K;D=d;break}}else if((n|0)==33){d=c[g>>2]|0;t=c[e>>2]|0;c[g>>2]=A;c[e>>2]=r;c[l>>2]=b;if((d|0)==(t|0)){z=d;break L27}else{E=t}while(1){t=E-16|0;if((a[t]&1)!=0){J2(c[E-16+8>>2]|0)}if((d|0)==(t|0)){z=d;break L27}else{E=t}}}}while(0);if((j|0)==(r|0)){w=C;y=D;break L25}else{F=r}while(1){d=F-16|0;if((a[d]&1)!=0){J2(c[F-16+8>>2]|0)}if((j|0)==(d|0)){w=C;y=D;break L25}else{F=d}}}}while(0);if((z|0)==0){return}J2(z);return}}while(0);if((o|0)==0){be(y|0)}J2(o);be(y|0)}function fr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function fs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=Kd(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==16){t=0;u=d|0}else if((t|0)==17){t=0;if(o){v=e>>>1}else{v=c[d+20>>2]|0}if(h){w=i}else{w=c[k>>2]|0}if(r){x=m+1|0}else{x=c[d+24>>2]|0}if(g){y=b}else{y=c[j>>2]|0}m=Kd(x|0,y|0,(w>>>0<v>>>0?w:v)|0)|0;if((m|0)==0){if(v>>>0>=w>>>0){f=1;t=36;break}}else{if((m|0)>=0){f=1;t=34;break}}u=d+4|0}m=c[u>>2]|0;if((m|0)==0){f=0;t=35;break}else{d=m}}if((t|0)==35){return f|0}else if((t|0)==36){return f|0}else if((t|0)==34){return f|0}return 0}function ft(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=b+4|0;b=f|0;g=c[b>>2]|0;if((g|0)==0){c[d>>2]=f;h=b;return h|0}b=a[e]|0;f=b&255;i=f>>>1;j=(b&1)==0;b=e+1|0;k=e+8|0;l=e+4|0;L5:do{if((f&1|0)==0){e=g;while(1){m=e+16|0;n=m;o=a[m]|0;m=o&255;p=(m&1|0)==0;if(p){q=m>>>1}else{q=c[e+20>>2]|0}if(j){r=b}else{r=c[k>>2]|0}s=(o&1)==0;if(s){t=n+1|0}else{t=c[e+24>>2]|0}o=Kd(r|0,t|0,(q>>>0<i>>>0?q:i)|0)|0;if((o|0)==0){if(i>>>0<q>>>0){u=26}}else{if((o|0)<0){u=26}}if((u|0)==26){u=0;o=e|0;v=c[o>>2]|0;if((v|0)==0){w=e;x=o;u=39;break}else{e=v;continue}}if(p){y=m>>>1}else{y=c[e+20>>2]|0}if(s){z=n+1|0}else{z=c[e+24>>2]|0}if(j){A=b}else{A=c[k>>2]|0}n=Kd(z|0,A|0,(i>>>0<y>>>0?i:y)|0)|0;if((n|0)==0){if(y>>>0>=i>>>0){B=e;u=53;break L5}}else{if((n|0)>=0){B=e;u=53;break L5}}n=e+4|0;s=c[n>>2]|0;if((s|0)==0){C=e;D=n;u=52;break}else{e=s}}}else{e=g;while(1){s=e+16|0;n=c[l>>2]|0;m=s;p=a[s]|0;s=p&255;v=(s&1|0)==0;if(v){E=s>>>1}else{E=c[e+20>>2]|0}if(j){F=b}else{F=c[k>>2]|0}o=(p&1)==0;if(o){G=m+1|0}else{G=c[e+24>>2]|0}p=Kd(F|0,G|0,(E>>>0<n>>>0?E:n)|0)|0;if((p|0)==0){if(n>>>0<E>>>0){u=38}}else{if((p|0)<0){u=38}}if((u|0)==38){u=0;p=e|0;n=c[p>>2]|0;if((n|0)==0){w=e;x=p;u=39;break}else{e=n;continue}}if(v){H=s>>>1}else{H=c[e+20>>2]|0}s=c[l>>2]|0;if(o){I=m+1|0}else{I=c[e+24>>2]|0}if(j){J=b}else{J=c[k>>2]|0}m=Kd(I|0,J|0,(s>>>0<H>>>0?s:H)|0)|0;if((m|0)==0){if(H>>>0>=s>>>0){B=e;u=53;break L5}}else{if((m|0)>=0){B=e;u=53;break L5}}m=e+4|0;s=c[m>>2]|0;if((s|0)==0){C=e;D=m;u=52;break}else{e=s}}}}while(0);if((u|0)==52){c[d>>2]=C;h=D;return h|0}else if((u|0)==39){c[d>>2]=w;h=x;return h|0}else if((u|0)==53){c[d>>2]=B;h=d;return h|0}return 0}function fu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;b=a+4|0;d=a|0;a=c[d>>2]|0;e=(c[b>>2]|0)-a>>2;L1:do{if((e|0)==0){f=a}else{g=0;h=a;while(1){i=c[h+(g<<2)>>2]|0;if((i|0)!=0){x=0;ap(c[(c[i>>2]|0)+4>>2]|0,i|0);if(x){x=0;break}}i=g+1|0;j=c[d>>2]|0;if(i>>>0<e>>>0){g=i;h=j}else{f=j;break L1}}h=bQ(-1,-1)|0;g=c[d>>2]|0;if((g|0)==0){be(h|0)}j=c[b>>2]|0;if((g|0)!=(j|0)){c[b>>2]=j+(~((j-4+(-g|0)|0)>>>2)<<2)}J2(g);be(h|0)}}while(0);if((f|0)==0){return}d=c[b>>2]|0;if((f|0)!=(d|0)){c[b>>2]=d+(~((d-4+(-f|0)|0)>>>2)<<2)}J2(f);return}function fv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0;f=i;i=i+96|0;g=f+80|0;h=f|0;j=f+16|0;k=f+32|0;l=f+48|0;m=f+64|0;n=d;d=b;L1:while(1){b=d;o=d;p=d+1|0;q=d+12|0;r=d+8|0;s=d+4|0;t=n;L3:while(1){u=t;v=u-b|0;switch((v|0)/12|0|0){case 5:{w=21;break L1;break};case 2:{w=4;break L1;break};case 3:{w=19;break L1;break};case 4:{w=20;break L1;break};case 0:case 1:{w=176;break L1;break};default:{}}if((v|0)<84){w=23;break L1}x=t-12|0;y=(v|0)/24|0;z=d+(y*12|0)|0;if((v|0)>11988){A=(v|0)/48|0;B=fy(d,d+(A*12|0)|0,z,d+((A+y|0)*12|0)|0,x,0)|0}else{B=fw(d,z,x,0)|0}A=a[o]|0;C=A&255;D=(C&1|0)==0;if(D){E=C>>>1}else{E=c[s>>2]|0}v=z;F=a[z]|0;G=F&255;H=(G&1|0)==0;if(H){I=G>>>1}else{I=c[d+(y*12|0)+4>>2]|0}J=(A&1)==0;if(J){K=p}else{K=c[r>>2]|0}A=(F&1)==0;if(A){L=v+1|0}else{L=c[d+(y*12|0)+8>>2]|0}F=Kd(K|0,L|0,(I>>>0<E>>>0?I:E)|0)|0;if((F|0)==0){if(E>>>0<I>>>0){M=x;N=B}else{w=41}}else{if((F|0)<0){M=x;N=B}else{w=41}}if((w|0)==41){w=0;F=t-24|0;if((d|0)==(F|0)){break}O=G>>>1;G=v+1|0;v=d+(y*12|0)+8|0;P=d+(y*12|0)+4|0;y=x;Q=F;while(1){R=Q;F=a[R]|0;S=F&255;if((S&1|0)==0){T=S>>>1}else{T=c[y-12+4>>2]|0}if(H){U=O}else{U=c[P>>2]|0}if((F&1)==0){V=Q+1|0}else{V=c[y-12+8>>2]|0}if(A){W=G}else{W=c[v>>2]|0}F=Kd(V|0,W|0,(U>>>0<T>>>0?U:T)|0)|0;if((F|0)==0){if(T>>>0<U>>>0){break}}else{if((F|0)<0){break}}F=Q-12|0;if((d|0)==(F|0)){break L3}else{y=Q;Q=F}}c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[o>>2]=c[R>>2];c[o+4>>2]=c[R+4>>2];c[o+8>>2]=c[R+8>>2];c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];c[R+8>>2]=c[k+8>>2];M=Q;N=B+1|0}L54:do{if(q>>>0<M>>>0){y=M;v=q;G=N;A=z;while(1){P=a[A]|0;O=P&255;H=(O&1|0)==0;F=O>>>1;O=(P&1)==0;P=A+1|0;S=A+8|0;X=A+4|0;Y=v;while(1){Z=Y;_=a[Z]|0;$=_&255;if(($&1|0)==0){aa=$>>>1}else{aa=c[Y+4>>2]|0}if(H){ab=F}else{ab=c[X>>2]|0}if((_&1)==0){ac=Y+1|0}else{ac=c[Y+8>>2]|0}if(O){ad=P}else{ad=c[S>>2]|0}_=Kd(ac|0,ad|0,(ab>>>0<aa>>>0?ab:aa)|0)|0;if((_|0)==0){if(aa>>>0>=ab>>>0){ae=y;break}}else{if((_|0)>=0){ae=y;break}}Y=Y+12|0}while(1){af=ae-12|0;ag=af;_=a[ag]|0;$=_&255;if(($&1|0)==0){ah=$>>>1}else{ah=c[ae-12+4>>2]|0}if(H){ai=F}else{ai=c[X>>2]|0}if((_&1)==0){aj=af+1|0}else{aj=c[ae-12+8>>2]|0}if(O){ak=P}else{ak=c[S>>2]|0}_=Kd(aj|0,ak|0,(ai>>>0<ah>>>0?ai:ah)|0)|0;if((_|0)==0){if(ah>>>0<ai>>>0){break}else{ae=af;continue}}else{if((_|0)>-1){ae=af;continue}else{break}}}if(Y>>>0>af>>>0){al=Y;am=G;an=A;break L54}c[j>>2]=c[Z>>2];c[j+4>>2]=c[Z+4>>2];c[j+8>>2]=c[Z+8>>2];c[Z>>2]=c[ag>>2];c[Z+4>>2]=c[ag+4>>2];c[Z+8>>2]=c[ag+8>>2];c[ag>>2]=c[j>>2];c[ag+4>>2]=c[j+4>>2];c[ag+8>>2]=c[j+8>>2];y=af;v=Y+12|0;G=G+1|0;A=(A|0)==(Y|0)?af:A}}else{al=q;am=N;an=z}}while(0);do{if((al|0)==(an|0)){ao=am}else{z=an;Q=a[z]|0;A=Q&255;if((A&1|0)==0){ap=A>>>1}else{ap=c[an+4>>2]|0}A=al;G=a[A]|0;v=G&255;if((v&1|0)==0){aq=v>>>1}else{aq=c[al+4>>2]|0}if((Q&1)==0){ar=an+1|0}else{ar=c[an+8>>2]|0}if((G&1)==0){as=al+1|0}else{as=c[al+8>>2]|0}G=Kd(ar|0,as|0,(aq>>>0<ap>>>0?aq:ap)|0)|0;if((G|0)==0){if(ap>>>0>=aq>>>0){ao=am;break}}else{if((G|0)>=0){ao=am;break}}c[h>>2]=c[A>>2];c[h+4>>2]=c[A+4>>2];c[h+8>>2]=c[A+8>>2];c[A>>2]=c[z>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];c[z>>2]=c[h>>2];c[z+4>>2]=c[h+4>>2];c[z+8>>2]=c[h+8>>2];ao=am+1|0}}while(0);do{if((ao|0)==0){z=fA(d,al,0)|0;A=al+12|0;if(fA(A,t,0)|0){if(z){w=183;break L1}else{t=al;continue L3}}else{if(z){n=t;d=A;continue L1}else{break}}}}while(0);A=al;if((A-b|0)<(u-A|0)){w=173;break}fv(al+12|0,t,e);t=al}if((w|0)==173){w=0;fv(d,al,e);n=t;d=al+12|0;continue}if(D){at=C>>>1}else{at=c[s>>2]|0}b=x;A=a[b]|0;z=A&255;if((z&1|0)==0){au=z>>>1}else{au=c[t-12+4>>2]|0}if(J){av=p}else{av=c[r>>2]|0}if((A&1)==0){aw=x+1|0}else{aw=c[t-12+8>>2]|0}A=Kd(av|0,aw|0,(au>>>0<at>>>0?au:at)|0)|0;if((A|0)==0){if(at>>>0<au>>>0){ax=q}else{w=57}}else{if((A|0)<0){ax=q}else{w=57}}if((w|0)==57){w=0;if((q|0)==(x|0)){w=185;break}A=C>>>1;z=q;while(1){if(D){ay=A}else{ay=c[s>>2]|0}az=z;G=a[az]|0;Q=G&255;if((Q&1|0)==0){aA=Q>>>1}else{aA=c[z+4>>2]|0}if(J){aB=p}else{aB=c[r>>2]|0}if((G&1)==0){aC=z+1|0}else{aC=c[z+8>>2]|0}G=Kd(aB|0,aC|0,(aA>>>0<ay>>>0?aA:ay)|0)|0;if((G|0)==0){if(ay>>>0<aA>>>0){break}}else{if((G|0)<0){break}}G=z+12|0;if((G|0)==(x|0)){w=186;break L1}else{z=G}}c[m>>2]=c[az>>2];c[m+4>>2]=c[az+4>>2];c[m+8>>2]=c[az+8>>2];c[az>>2]=c[b>>2];c[az+4>>2]=c[b+4>>2];c[az+8>>2]=c[b+8>>2];c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];ax=z+12|0}if((ax|0)==(x|0)){w=187;break}else{aD=x;aE=ax}while(1){A=a[o]|0;G=A&255;Q=(G&1|0)==0;v=G>>>1;G=(A&1)==0;A=aE;while(1){if(Q){aF=v}else{aF=c[s>>2]|0}aG=A;y=a[aG]|0;S=y&255;if((S&1|0)==0){aH=S>>>1}else{aH=c[A+4>>2]|0}if(G){aI=p}else{aI=c[r>>2]|0}if((y&1)==0){aJ=A+1|0}else{aJ=c[A+8>>2]|0}y=Kd(aI|0,aJ|0,(aH>>>0<aF>>>0?aH:aF)|0)|0;if((y|0)==0){if(aF>>>0<aH>>>0){aK=aD;break}}else{if((y|0)<=-1){aK=aD;break}}A=A+12|0}while(1){aL=aK-12|0;if(Q){aM=v}else{aM=c[s>>2]|0}aN=aL;u=a[aN]|0;y=u&255;if((y&1|0)==0){aO=y>>>1}else{aO=c[aK-12+4>>2]|0}if(G){aP=p}else{aP=c[r>>2]|0}if((u&1)==0){aQ=aL+1|0}else{aQ=c[aK-12+8>>2]|0}u=Kd(aP|0,aQ|0,(aO>>>0<aM>>>0?aO:aM)|0)|0;if((u|0)==0){if(aM>>>0<aO>>>0){aK=aL;continue}else{break}}else{if((u|0)<0){aK=aL;continue}else{break}}}if(A>>>0>=aL>>>0){n=t;d=A;continue L1}c[l>>2]=c[aG>>2];c[l+4>>2]=c[aG+4>>2];c[l+8>>2]=c[aG+8>>2];c[aG>>2]=c[aN>>2];c[aG+4>>2]=c[aN+4>>2];c[aG+8>>2]=c[aN+8>>2];c[aN>>2]=c[l>>2];c[aN+4>>2]=c[l+4>>2];c[aN+8>>2]=c[l+8>>2];aD=aL;aE=A+12|0}}if((w|0)==21){fy(d,q,d+24|0,d+36|0,t-12|0,0)|0;i=f;return}else if((w|0)==4){aE=t-12|0;aL=aE;aD=a[aL]|0;l=aD&255;if((l&1|0)==0){aR=l>>>1}else{aR=c[t-12+4>>2]|0}l=a[o]|0;aN=l&255;if((aN&1|0)==0){aS=aN>>>1}else{aS=c[s>>2]|0}if((aD&1)==0){aT=aE+1|0}else{aT=c[t-12+8>>2]|0}if((l&1)==0){aU=p}else{aU=c[r>>2]|0}r=Kd(aT|0,aU|0,(aS>>>0<aR>>>0?aS:aR)|0)|0;do{if((r|0)==0){if(aR>>>0<aS>>>0){break}i=f;return}else{if((r|0)<0){break}i=f;return}}while(0);r=g;c[r>>2]=c[o>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[o>>2]=c[aL>>2];c[o+4>>2]=c[aL+4>>2];c[o+8>>2]=c[aL+8>>2];c[aL>>2]=c[r>>2];c[aL+4>>2]=c[r+4>>2];c[aL+8>>2]=c[r+8>>2];i=f;return}else if((w|0)==19){fw(d,q,t-12|0,0)|0;i=f;return}else if((w|0)==20){fx(d,q,d+24|0,t-12|0,0)|0;i=f;return}else if((w|0)==176){i=f;return}else if((w|0)==183){i=f;return}else if((w|0)==185){i=f;return}else if((w|0)==186){i=f;return}else if((w|0)==187){i=f;return}else if((w|0)==23){fz(d,t,0);i=f;return}}function fw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+80|0;g=f|0;h=f+16|0;j=f+32|0;k=f+48|0;l=f+64|0;m=d;n=d;o=a[n]|0;p=o&255;q=(p&1|0)==0;if(q){r=p>>>1}else{r=c[d+4>>2]|0}s=b;t=b;u=a[t]|0;v=u&255;if((v&1|0)==0){w=v>>>1}else{w=c[b+4>>2]|0}v=(o&1)==0;if(v){x=m+1|0}else{x=c[d+8>>2]|0}if((u&1)==0){y=s+1|0}else{y=c[b+8>>2]|0}u=Kd(x|0,y|0,(w>>>0<r>>>0?w:r)|0)|0;if((u|0)==0){y=e;x=e;o=a[x]|0;z=o&255;A=(z&1|0)==0;if(r>>>0<w>>>0){B=y;C=x;D=z;E=A;F=o;G=47}else{H=y;I=x;J=z;K=A;L=o;G=16}}else{o=e;A=e;z=a[A]|0;x=z&255;y=(x&1|0)==0;if((u|0)<0){B=o;C=A;D=x;E=y;F=z;G=47}else{H=o;I=A;J=x;K=y;L=z;G=16}}if((G|0)==47){if(E){M=D>>>1}else{M=c[e+4>>2]|0}if(q){N=p>>>1}else{N=c[d+4>>2]|0}if((F&1)==0){O=B+1|0}else{O=c[e+8>>2]|0}if(v){P=m+1|0}else{P=c[d+8>>2]|0}F=Kd(O|0,P|0,(N>>>0<M>>>0?N:M)|0)|0;if((F|0)==0){if(M>>>0<N>>>0){G=62}}else{if((F|0)<0){G=62}}if((G|0)==62){F=j;c[F>>2]=c[t>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2];c[t>>2]=c[C>>2];c[t+4>>2]=c[C+4>>2];c[t+8>>2]=c[C+8>>2];c[C>>2]=c[F>>2];c[C+4>>2]=c[F+4>>2];c[C+8>>2]=c[F+8>>2];Q=1;i=f;return Q|0}F=h;c[F>>2]=c[t>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2];c[t>>2]=c[n>>2];c[t+4>>2]=c[n+4>>2];c[t+8>>2]=c[n+8>>2];c[n>>2]=c[F>>2];c[n+4>>2]=c[F+4>>2];c[n+8>>2]=c[F+8>>2];F=a[C]|0;h=F&255;if((h&1|0)==0){R=h>>>1}else{R=c[e+4>>2]|0}h=a[n]|0;j=h&255;if((j&1|0)==0){S=j>>>1}else{S=c[d+4>>2]|0}if((F&1)==0){T=B+1|0}else{T=c[e+8>>2]|0}if((h&1)==0){U=m+1|0}else{U=c[d+8>>2]|0}h=Kd(T|0,U|0,(S>>>0<R>>>0?S:R)|0)|0;do{if((h|0)==0){if(R>>>0<S>>>0){break}else{Q=1}i=f;return Q|0}else{if((h|0)<0){break}else{Q=1}i=f;return Q|0}}while(0);h=g;c[h>>2]=c[n>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];c[n>>2]=c[C>>2];c[n+4>>2]=c[C+4>>2];c[n+8>>2]=c[C+8>>2];c[C>>2]=c[h>>2];c[C+4>>2]=c[h+4>>2];c[C+8>>2]=c[h+8>>2];Q=2;i=f;return Q|0}else if((G|0)==16){if(K){V=J>>>1}else{V=c[e+4>>2]|0}if(q){W=p>>>1}else{W=c[d+4>>2]|0}if((L&1)==0){X=H+1|0}else{X=c[e+8>>2]|0}if(v){Y=m+1|0}else{Y=c[d+8>>2]|0}v=Kd(X|0,Y|0,(W>>>0<V>>>0?W:V)|0)|0;do{if((v|0)==0){if(V>>>0<W>>>0){break}else{Q=0}i=f;return Q|0}else{if((v|0)<0){break}else{Q=0}i=f;return Q|0}}while(0);v=l;c[v>>2]=c[n>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[n>>2]=c[I>>2];c[n+4>>2]=c[I+4>>2];c[n+8>>2]=c[I+8>>2];c[I>>2]=c[v>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];v=a[n]|0;I=v&255;if((I&1|0)==0){Z=I>>>1}else{Z=c[d+4>>2]|0}I=a[t]|0;l=I&255;if((l&1|0)==0){_=l>>>1}else{_=c[b+4>>2]|0}if((v&1)==0){$=m+1|0}else{$=c[d+8>>2]|0}if((I&1)==0){aa=s+1|0}else{aa=c[b+8>>2]|0}b=Kd($|0,aa|0,(_>>>0<Z>>>0?_:Z)|0)|0;do{if((b|0)==0){if(Z>>>0<_>>>0){break}else{Q=1}i=f;return Q|0}else{if((b|0)<0){break}else{Q=1}i=f;return Q|0}}while(0);b=k;c[b>>2]=c[t>>2];c[b+4>>2]=c[t+4>>2];c[b+8>>2]=c[t+8>>2];c[t>>2]=c[n>>2];c[t+4>>2]=c[n+4>>2];c[t+8>>2]=c[n+8>>2];c[n>>2]=c[b>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];Q=2;i=f;return Q|0}return 0}function fx(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+48|0;h=g|0;j=g+16|0;k=g+32|0;l=fw(b,d,e,0)|0;m=f;n=a[m]|0;o=n&255;if((o&1|0)==0){p=o>>>1}else{p=c[f+4>>2]|0}o=e;q=e;r=a[q]|0;s=r&255;if((s&1|0)==0){t=s>>>1}else{t=c[e+4>>2]|0}if((n&1)==0){u=f+1|0}else{u=c[f+8>>2]|0}if((r&1)==0){v=o+1|0}else{v=c[e+8>>2]|0}r=Kd(u|0,v|0,(t>>>0<p>>>0?t:p)|0)|0;do{if((r|0)==0){if(p>>>0<t>>>0){break}else{w=l}i=g;return w|0}else{if((r|0)<0){break}else{w=l}i=g;return w|0}}while(0);r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[q>>2]=c[m>>2];c[q+4>>2]=c[m+4>>2];c[q+8>>2]=c[m+8>>2];c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];r=l+1|0;m=a[q]|0;k=m&255;if((k&1|0)==0){x=k>>>1}else{x=c[e+4>>2]|0}k=d;t=d;p=a[t]|0;v=p&255;if((v&1|0)==0){y=v>>>1}else{y=c[d+4>>2]|0}if((m&1)==0){z=o+1|0}else{z=c[e+8>>2]|0}if((p&1)==0){A=k+1|0}else{A=c[d+8>>2]|0}p=Kd(z|0,A|0,(y>>>0<x>>>0?y:x)|0)|0;do{if((p|0)==0){if(x>>>0<y>>>0){break}else{w=r}i=g;return w|0}else{if((p|0)<0){break}else{w=r}i=g;return w|0}}while(0);r=j;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[t>>2]=c[q>>2];c[t+4>>2]=c[q+4>>2];c[t+8>>2]=c[q+8>>2];c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];r=l+2|0;q=a[t]|0;j=q&255;if((j&1|0)==0){B=j>>>1}else{B=c[d+4>>2]|0}j=b;p=a[j]|0;y=p&255;if((y&1|0)==0){C=y>>>1}else{C=c[b+4>>2]|0}if((q&1)==0){D=k+1|0}else{D=c[d+8>>2]|0}if((p&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}b=Kd(D|0,E|0,(C>>>0<B>>>0?C:B)|0)|0;do{if((b|0)==0){if(B>>>0<C>>>0){break}else{w=r}i=g;return w|0}else{if((b|0)<0){break}else{w=r}i=g;return w|0}}while(0);r=h;c[r>>2]=c[j>>2];c[r+4>>2]=c[j+4>>2];c[r+8>>2]=c[j+8>>2];c[j>>2]=c[t>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];w=l+3|0;i=g;return w|0}function fy(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=i;i=i+64|0;j=h|0;k=h+16|0;l=h+32|0;m=h+48|0;n=fx(b,d,e,f,0)|0;o=g;p=a[o]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[g+4>>2]|0}q=f;s=f;t=a[s]|0;u=t&255;if((u&1|0)==0){v=u>>>1}else{v=c[f+4>>2]|0}if((p&1)==0){w=g+1|0}else{w=c[g+8>>2]|0}if((t&1)==0){x=q+1|0}else{x=c[f+8>>2]|0}t=Kd(w|0,x|0,(v>>>0<r>>>0?v:r)|0)|0;do{if((t|0)==0){if(r>>>0<v>>>0){break}else{y=n}i=h;return y|0}else{if((t|0)<0){break}else{y=n}i=h;return y|0}}while(0);t=m;c[t>>2]=c[s>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];c[s>>2]=c[o>>2];c[s+4>>2]=c[o+4>>2];c[s+8>>2]=c[o+8>>2];c[o>>2]=c[t>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];t=n+1|0;o=a[s]|0;m=o&255;if((m&1|0)==0){z=m>>>1}else{z=c[f+4>>2]|0}m=e;v=e;r=a[v]|0;x=r&255;if((x&1|0)==0){A=x>>>1}else{A=c[e+4>>2]|0}if((o&1)==0){B=q+1|0}else{B=c[f+8>>2]|0}if((r&1)==0){C=m+1|0}else{C=c[e+8>>2]|0}r=Kd(B|0,C|0,(A>>>0<z>>>0?A:z)|0)|0;do{if((r|0)==0){if(z>>>0<A>>>0){break}else{y=t}i=h;return y|0}else{if((r|0)<0){break}else{y=t}i=h;return y|0}}while(0);t=l;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];t=n+2|0;s=a[v]|0;l=s&255;if((l&1|0)==0){D=l>>>1}else{D=c[e+4>>2]|0}l=d;r=d;A=a[r]|0;z=A&255;if((z&1|0)==0){E=z>>>1}else{E=c[d+4>>2]|0}if((s&1)==0){F=m+1|0}else{F=c[e+8>>2]|0}if((A&1)==0){G=l+1|0}else{G=c[d+8>>2]|0}A=Kd(F|0,G|0,(E>>>0<D>>>0?E:D)|0)|0;do{if((A|0)==0){if(D>>>0<E>>>0){break}else{y=t}i=h;return y|0}else{if((A|0)<0){break}else{y=t}i=h;return y|0}}while(0);t=k;c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];c[r>>2]=c[v>>2];c[r+4>>2]=c[v+4>>2];c[r+8>>2]=c[v+8>>2];c[v>>2]=c[t>>2];c[v+4>>2]=c[t+4>>2];c[v+8>>2]=c[t+8>>2];t=n+3|0;v=a[r]|0;k=v&255;if((k&1|0)==0){H=k>>>1}else{H=c[d+4>>2]|0}k=b;A=a[k]|0;E=A&255;if((E&1|0)==0){I=E>>>1}else{I=c[b+4>>2]|0}if((v&1)==0){J=l+1|0}else{J=c[d+8>>2]|0}if((A&1)==0){K=b+1|0}else{K=c[b+8>>2]|0}b=Kd(J|0,K|0,(I>>>0<H>>>0?I:H)|0)|0;do{if((b|0)==0){if(H>>>0<I>>>0){break}else{y=t}i=h;return y|0}else{if((b|0)<0){break}else{y=t}i=h;return y|0}}while(0);t=j;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];c[t+8>>2]=c[k+8>>2];c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];y=n+4|0;i=h;return y|0}function fz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+16|0;f=e|0;g=b+24|0;fw(b,b+12|0,g,0)|0;h=b+36|0;if((h|0)==(d|0)){i=e;return}j=f;k=f+1|0;l=f+8|0;m=f|0;n=f+4|0;o=g;g=h;L4:while(1){h=g;p=a[h]|0;q=p&255;if((q&1|0)==0){r=q>>>1}else{r=c[g+4>>2]|0}q=a[o]|0;s=q&255;if((s&1|0)==0){t=s>>>1}else{t=c[o+4>>2]|0}s=(p&1)==0;if(s){u=g+1|0}else{u=c[g+8>>2]|0}if((q&1)==0){v=o+1|0}else{v=c[o+8>>2]|0}q=Kd(u|0,v|0,(t>>>0<r>>>0?t:r)|0)|0;if((q|0)==0){if(r>>>0<t>>>0){w=18}}else{if((q|0)<0){w=18}}do{if((w|0)==18){w=0;if(s){c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];y=o;z=g}else{q=c[g+8>>2]|0;p=c[g+4>>2]|0;if(p>>>0>4294967279>>>0){w=21;break L4}if(p>>>0<11>>>0){a[j]=p<<1;A=k}else{B=p+16&-16;C=J0(B)|0;c[l>>2]=C;c[m>>2]=B|1;c[n>>2]=p;A=C}Kb(A|0,q|0,p)|0;a[A+p|0]=0;y=o;z=g}while(1){x=0,aK(346,z|0,y|0)|0;if(x){x=0;w=40;break L4}if((y|0)==(b|0)){D=b;break}p=y-12|0;q=a[j]|0;C=q&255;B=(C&1|0)==0?C>>>1:c[n>>2]|0;C=a[p]|0;E=C&255;if((E&1|0)==0){F=E>>>1}else{F=c[y-12+4>>2]|0}if((C&1)==0){G=p+1|0}else{G=c[y-12+8>>2]|0}C=Kd(((q&1)==0?k:c[l>>2]|0)|0,G|0,(F>>>0<B>>>0?F:B)|0)|0;if((C|0)==0){if(B>>>0<F>>>0){z=y;y=p;continue}else{D=y;break}}else{if((C|0)<0){z=y;y=p;continue}else{D=y;break}}}x=0,aK(346,D|0,f|0)|0;if(x){x=0;w=41;break L4}if((a[j]&1)==0){break}J2(c[l>>2]|0)}}while(0);h=g+12|0;if((h|0)==(d|0)){w=49;break}else{o=g;g=h}}if((w|0)==21){CJ(0)}else if((w|0)==40){g=bQ(-1,-1)|0;H=K;I=g}else if((w|0)==41){g=bQ(-1,-1)|0;H=K;I=g}else if((w|0)==49){i=e;return}if((a[j]&1)==0){be(I|0)}J2(c[l>>2]|0);be(I|0)}function fA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+32|0;f=e|0;g=e+16|0;switch((d-b|0)/12|0|0){case 2:{h=d-12|0;j=h;k=a[j]|0;l=k&255;if((l&1|0)==0){m=l>>>1}else{m=c[d-12+4>>2]|0}l=b;n=a[l]|0;o=n&255;if((o&1|0)==0){p=o>>>1}else{p=c[b+4>>2]|0}if((k&1)==0){q=h+1|0}else{q=c[d-12+8>>2]|0}if((n&1)==0){r=b+1|0}else{r=c[b+8>>2]|0}n=Kd(q|0,r|0,(p>>>0<m>>>0?p:m)|0)|0;do{if((n|0)==0){if(m>>>0<p>>>0){break}else{s=1}i=e;return s|0}else{if((n|0)<0){break}else{s=1}i=e;return s|0}}while(0);n=f;c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];s=1;i=e;return s|0};case 3:{fw(b,b+12|0,d-12|0,0)|0;s=1;i=e;return s|0};case 4:{fx(b,b+12|0,b+24|0,d-12|0,0)|0;s=1;i=e;return s|0};case 0:case 1:{s=1;i=e;return s|0};case 5:{fy(b,b+12|0,b+24|0,b+36|0,d-12|0,0)|0;s=1;i=e;return s|0};default:{n=b+24|0;fw(b,b+12|0,n,0)|0;j=b+36|0;if((j|0)==(d|0)){s=1;i=e;return s|0}l=g;f=g+1|0;p=g+8|0;m=g|0;r=g+4|0;q=0;h=n;n=0;k=j;L30:while(1){j=k;o=a[j]|0;t=o&255;if((t&1|0)==0){u=t>>>1}else{u=c[k+4>>2]|0}t=a[h]|0;v=t&255;if((v&1|0)==0){w=v>>>1}else{w=c[h+4>>2]|0}v=(o&1)==0;if(v){y=k+1|0}else{y=c[k+8>>2]|0}if((t&1)==0){z=h+1|0}else{z=c[h+8>>2]|0}t=Kd(y|0,z|0,(w>>>0<u>>>0?w:u)|0)|0;if((t|0)==0){if(u>>>0<w>>>0){A=38}else{B=k;C=n;D=q}}else{if((t|0)<0){A=38}else{B=k;C=n;D=q}}if((A|0)==38){A=0;if(v){c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];E=h;F=k}else{j=c[k+8>>2]|0;v=c[k+4>>2]|0;if(v>>>0>4294967279>>>0){A=41;break}if(v>>>0<11>>>0){a[l]=v<<1;G=f}else{t=v+16&-16;o=J0(t)|0;c[p>>2]=o;c[m>>2]=t|1;c[r>>2]=v;G=o}Kb(G|0,j|0,v)|0;a[G+v|0]=0;E=h;F=k}while(1){x=0,aK(346,F|0,E|0)|0;if(x){x=0;A=60;break L30}if((E|0)==(b|0)){H=b;break}v=E-12|0;j=a[l]|0;o=j&255;t=(o&1|0)==0?o>>>1:c[r>>2]|0;o=a[v]|0;I=o&255;if((I&1|0)==0){J=I>>>1}else{J=c[E-12+4>>2]|0}if((o&1)==0){L=v+1|0}else{L=c[E-12+8>>2]|0}o=Kd(((j&1)==0?f:c[p>>2]|0)|0,L|0,(J>>>0<t>>>0?J:t)|0)|0;if((o|0)==0){if(t>>>0<J>>>0){F=E;E=v;continue}else{H=E;break}}else{if((o|0)<0){F=E;E=v;continue}else{H=E;break}}}x=0,aK(346,H|0,g|0)|0;if(x){x=0;A=61;break}v=n+1|0;if((v|0)==8){o=k+12|0;M=1;N=o;O=(o|0)==(d|0)}else{M=0;N=k;O=q}if((a[l]&1)!=0){J2(c[p>>2]|0)}if(M){s=O;A=71;break}else{B=N;C=v;D=O}}v=B+12|0;if((v|0)==(d|0)){s=1;A=72;break}else{q=D;h=B;n=C;k=v}}if((A|0)==72){i=e;return s|0}else if((A|0)==61){k=bQ(-1,-1)|0;P=K;Q=k}else if((A|0)==60){k=bQ(-1,-1)|0;P=K;Q=k}else if((A|0)==41){CJ(0);return 0}else if((A|0)==71){i=e;return s|0}if((a[l]&1)==0){be(Q|0)}J2(c[p>>2]|0);be(Q|0)}}return 0}function fB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;e=b+4|0;f=c[e>>2]|0;g=b|0;h=c[g>>2]|0;i=h;j=(f-i|0)/12|0;k=j+1|0;if(k>>>0>357913941>>>0){Hu(0)}l=b+8|0;b=((c[l>>2]|0)-i|0)/12|0;if(b>>>0>178956969>>>0){m=357913941;n=5}else{i=b<<1;b=i>>>0<k>>>0?k:i;if((b|0)==0){o=0;p=0}else{m=b;n=5}}if((n|0)==5){o=J0(m*12|0)|0;p=m}m=o+(j*12|0)|0;b=o+(p*12|0)|0;L9:do{if((m|0)==0){q=f;n=17}else{p=d;if((a[p]&1)==0){i=m;c[i>>2]=c[p>>2];c[i+4>>2]=c[p+4>>2];c[i+8>>2]=c[p+8>>2];q=f;n=17;break}p=c[d+8>>2]|0;i=c[d+4>>2]|0;do{if(i>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(i>>>0<11>>>0){a[m]=i<<1;r=m+1|0}else{s=i+16&-16;t=(x=0,as(230,s|0)|0);if(x){x=0;break}c[o+(j*12|0)+8>>2]=t;c[m>>2]=s|1;c[o+(j*12|0)+4>>2]=i;r=t}Kb(r|0,p|0,i)|0;a[r+i|0]=0;q=c[e>>2]|0;n=17;break L9}}while(0);i=bQ(-1,-1)|0;u=K;v=i}}while(0);L24:do{if((n|0)==17){r=o+(k*12|0)|0;L26:do{if((q|0)==(h|0)){c[g>>2]=m;c[e>>2]=r;c[l>>2]=b;w=h}else{j=q;d=m;L28:while(1){y=d-12|0;f=j-12|0;do{if((y|0)!=0){i=f;if((a[i]&1)==0){p=y;c[p>>2]=c[i>>2];c[p+4>>2]=c[i+4>>2];c[p+8>>2]=c[i+8>>2];break}i=c[j-12+8>>2]|0;p=c[j-12+4>>2]|0;if(p>>>0>4294967279>>>0){n=23;break L28}if(p>>>0<11>>>0){a[y]=p<<1;z=y+1|0}else{t=p+16&-16;s=(x=0,as(230,t|0)|0);if(x){x=0;n=39;break L28}c[d-12+8>>2]=s;c[y>>2]=t|1;c[d-12+4>>2]=p;z=s}Kb(z|0,i|0,p)|0;a[z+p|0]=0}}while(0);if((f|0)==(h|0)){n=31;break}else{j=f;d=y}}do{if((n|0)==23){x=0;ap(232,0);if(x){x=0;j=bQ(-1,-1)|0;A=K;B=j;break}}else if((n|0)==31){j=c[g>>2]|0;p=c[e>>2]|0;c[g>>2]=y;c[e>>2]=r;c[l>>2]=b;if((j|0)==(p|0)){w=j;break L26}else{C=p}while(1){p=C-12|0;if((a[p]&1)!=0){J2(c[C-12+8>>2]|0)}if((j|0)==(p|0)){w=j;break L26}else{C=p}}}else if((n|0)==39){j=bQ(-1,-1)|0;A=K;B=j}}while(0);if((d|0)==(r|0)){u=A;v=B;break L24}else{D=r}while(1){j=D-12|0;if((a[j]&1)!=0){J2(c[D-12+8>>2]|0)}if((d|0)==(j|0)){u=A;v=B;break L24}else{D=j}}}}while(0);if((w|0)==0){return}J2(w);return}}while(0);if((o|0)==0){be(v|0)}J2(o);be(v|0)}function fC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=b|0;c[e>>2]=0;f=b+4|0;c[f>>2]=0;g=b+8|0;c[g>>2]=0;b=d+4|0;h=c[b>>2]|0;i=d|0;d=c[i>>2]|0;if((h|0)==(d|0)){return}j=h-d|0;d=(j|0)/12|0;do{if(d>>>0>357913941>>>0){x=0;ap(152,0);if(x){x=0;k=20;break}}else{h=(x=0,as(230,j|0)|0);if(x){x=0;k=20;break}l=h;c[f>>2]=l;c[e>>2]=l;c[g>>2]=l+(d*12|0);h=c[i>>2]|0;m=c[b>>2]|0;if((h|0)==(m|0)){return}else{n=h;o=l}L9:while(1){do{if((o|0)!=0){l=n;if((a[l]&1)==0){h=o;c[h>>2]=c[l>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];break}l=c[n+8>>2]|0;h=c[n+4>>2]|0;if(h>>>0>4294967279>>>0){k=11;break L9}if(h>>>0<11>>>0){a[o]=h<<1;p=o+1|0}else{q=h+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;k=19;break L9}c[o+8>>2]=r;c[o>>2]=q|1;c[o+4>>2]=h;p=r}Kb(p|0,l|0,h)|0;a[p+h|0]=0}}while(0);h=(c[f>>2]|0)+12|0;c[f>>2]=h;l=n+12|0;if((l|0)==(m|0)){k=31;break}else{n=l;o=h}}if((k|0)==19){m=bQ(-1,-1)|0;s=K;t=m;break}else if((k|0)==31){return}else if((k|0)==11){x=0;ap(232,0);if(x){x=0;k=20;break}}}}while(0);if((k|0)==20){k=bQ(-1,-1)|0;s=K;t=k}k=c[e>>2]|0;if((k|0)==0){be(t|0)}s=c[f>>2]|0;if((k|0)==(s|0)){u=k}else{o=s;while(1){s=o-12|0;c[f>>2]=s;if((a[s]&1)==0){v=s}else{J2(c[o-12+8>>2]|0);v=c[f>>2]|0}if((k|0)==(v|0)){break}else{o=v}}u=c[e>>2]|0}J2(u);be(t|0)}function fD(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;l=i;i=i+64|0;m=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];m=l|0;n=l+16|0;o=l+32|0;p=l+48|0;q=d;if((a[q]&1)==0){r=p;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];s=a[r]|0;t=r}else{r=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){CJ(0)}if(q>>>0<11>>>0){d=q<<1&255;u=p;a[u]=d;v=p+1|0;w=d;y=u}else{u=q+16&-16;d=J0(u)|0;c[p+8>>2]=d;z=u|1;c[p>>2]=z;c[p+4>>2]=q;v=d;w=z&255;y=p}Kb(v|0,r|0,q)|0;a[v+q|0]=0;s=w;t=y}y=e;e=o;c[e>>2]=c[y>>2];c[e+4>>2]=c[y+4>>2];c[e+8>>2]=c[y+8>>2];y=o;o=m;e=n;w=b|0;L12:do{if((s&1)==0){c[o>>2]=c[t>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];A=19}else{q=c[p+8>>2]|0;v=c[p+4>>2]|0;do{if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(v>>>0<11>>>0){a[o]=v<<1;B=m+1|0}else{r=v+16&-16;z=(x=0,as(230,r|0)|0);if(x){x=0;break}c[m+8>>2]=z;c[m>>2]=r|1;c[m+4>>2]=v;B=z}Kb(B|0,q|0,v)|0;a[B+v|0]=0;A=19;break L12}}while(0);v=bQ(-1,-1)|0;C=K;D=v}}while(0);do{if((A|0)==19){c[e>>2]=c[y>>2];c[e+4>>2]=c[y+4>>2];c[e+8>>2]=c[y+8>>2];x=0;aP(402,w|0,m|0,n|0);if(x){x=0;B=bQ(-1,-1)|0;s=K;if((a[o]&1)==0){C=s;D=B;break}J2(c[m+8>>2]|0);C=s;D=B;break}if((a[o]&1)!=0){J2(c[m+8>>2]|0)}B=b|0;c[B>>2]=16192;c[b+28>>2]=0;if((a[t]&1)!=0){J2(c[p+8>>2]|0)}c[B>>2]=21864;s=b+32|0;v=g;if((a[v]&1)==0){q=s;c[q>>2]=c[v>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];E=b+44|0;c[E>>2]=h;F=b+48|0;c[F>>2]=0;G=b+52|0;c[G>>2]=1;H=b+56|0;c[H>>2]=j;I=b+60|0;c[I>>2]=0;J=b+64|0;L=k&1;a[J]=L;M=b+68|0;c[M>>2]=f;i=l;return}v=c[g+8>>2]|0;q=c[g+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(q>>>0<11>>>0){a[s]=q<<1;N=s+1|0}else{z=q+16&-16;r=(x=0,as(230,z|0)|0);if(x){x=0;break}c[b+40>>2]=r;c[s>>2]=z|1;c[b+36>>2]=q;N=r}Kb(N|0,v|0,q)|0;a[N+q|0]=0;E=b+44|0;c[E>>2]=h;F=b+48|0;c[F>>2]=0;G=b+52|0;c[G>>2]=1;H=b+56|0;c[H>>2]=j;I=b+60|0;c[I>>2]=0;J=b+64|0;L=k&1;a[J]=L;M=b+68|0;c[M>>2]=f;i=l;return}}while(0);q=bQ(-1,-1)|0;v=q;q=K;c[B>>2]=16616;if((a[b+4|0]&1)==0){O=q;P=v;Q=P;R=0;S=Q;T=O;be(S|0)}J2(c[b+12>>2]|0);O=q;P=v;Q=P;R=0;S=Q;T=O;be(S|0)}}while(0);b=D;D=C;if((a[t]&1)==0){O=D;P=b;Q=P;R=0;S=Q;T=O;be(S|0)}J2(c[p+8>>2]|0);O=D;P=b;Q=P;R=0;S=Q;T=O;be(S|0)}function fE(b){b=b|0;var d=0;d=b|0;c[d>>2]=21864;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function fF(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=21864;if((a[b+32|0]&1)!=0){J2(c[b+40>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function fG(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+84>>2]&1023](b,a);return}function fH(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+84>>2]&1023](b,a)|0}function fI(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+84>>2]&1023](b,a)|0}function fJ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+84>>2]&1023](b,a)|0}function fK(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+84>>2]&1023](b,a)|0}function fL(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+84>>2]&511](a,d,b);return}function fM(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+84>>2]&511](a,d,b);return}function fN(a){a=a|0;return 0}function fO(a){a=a|0;return 0}function fP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=d;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+8>>2]|0;j=c[d+4>>2]|0;if(j>>>0>4294967279>>>0){CJ(0)}if(j>>>0<11>>>0){d=j<<1&255;n=h;a[n]=d;o=h+1|0;p=d;q=n}else{n=j+16&-16;d=J0(n)|0;c[h+8>>2]=d;r=n|1;c[h>>2]=r;c[h+4>>2]=j;o=d;p=r&255;q=h}Kb(o|0,k|0,j)|0;a[o+j|0]=0;l=p;m=q}q=e;e=g;c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];q=g;g=b|0;c[g>>2]=16616;e=b+4|0;L12:do{if((l&1)==0){p=e;c[p>>2]=c[m>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2]}else{p=c[h+8>>2]|0;j=c[h+4>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(j>>>0<11>>>0){a[e]=j<<1;s=e+1|0}else{o=j+16&-16;k=(x=0,as(230,o|0)|0);if(x){x=0;break}c[b+12>>2]=k;c[e>>2]=o|1;c[b+8>>2]=j;s=k}Kb(s|0,p|0,j)|0;a[s+j|0]=0;break L12}}while(0);j=bQ(-1,-1)|0;if((a[m]&1)==0){be(j|0)}J2(p);be(j|0)}}while(0);s=b+16|0;c[s>>2]=c[q>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];if((a[m]&1)==0){c[g>>2]=16072;i=f;return}J2(c[h+8>>2]|0);c[g>>2]=16072;i=f;return}function fQ(b,d){b=b|0;d=d|0;if((d|0)==0){return}fQ(b,c[d>>2]|0);fQ(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){J2(c[d+24>>2]|0)}J2(d);return}function fR(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=17936;fS(a+60|0,c[a+64>>2]|0);b=c[a+44>>2]|0;d=b;if((b|0)!=0){e=a+48|0;f=c[e>>2]|0;if((b|0)!=(f|0)){c[e>>2]=f+(~((f-4+(-d|0)|0)>>>2)<<2)}J2(b)}b=c[a+32>>2]|0;d=b;if((b|0)!=0){f=a+36|0;e=c[f>>2]|0;if((b|0)!=(e|0)){c[f>>2]=e+(~((e-4+(-d|0)|0)>>>2)<<2)}J2(b)}b=c[a+20>>2]|0;if((b|0)==0){return}d=a+24|0;a=c[d>>2]|0;if((b|0)!=(a|0)){c[d>>2]=a+(~((a-4+(-b|0)|0)>>>2)<<2)}J2(b);return}function fS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)==0){return}fS(b,c[d>>2]|0);fS(b,c[d+4>>2]|0);c[d+48>>2]=21584;b=c[d+52>>2]|0;e=b;if((b|0)!=0){f=d+56|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d+16>>2]=16616;if((a[d+20|0]&1)!=0){J2(c[d+28>>2]|0)}J2(d);return}function fT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;j=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[b>>2]=d;d=b+4|0;j=e;if((a[j]&1)==0){k=d;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2]}else{j=c[e+8>>2]|0;k=c[e+4>>2]|0;if(k>>>0>4294967279>>>0){CJ(0)}if(k>>>0<11>>>0){a[d]=k<<1;l=d+1|0}else{e=k+16&-16;m=J0(e)|0;c[b+12>>2]=m;c[d>>2]=e|1;c[b+8>>2]=k;l=m}Kb(l|0,j|0,k)|0;a[l+k|0]=0}k=b+16|0;l=f;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=b+28|0;k=g;if((a[k]&1)==0){f=l;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];i=h;return}k=c[g+8>>2]|0;f=c[g+4>>2]|0;do{if(f>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(f>>>0<11>>>0){a[l]=f<<1;n=l+1|0}else{g=f+16&-16;j=(x=0,as(230,g|0)|0);if(x){x=0;break}c[b+36>>2]=j;c[l>>2]=g|1;c[b+32>>2]=f;n=j}Kb(n|0,k|0,f)|0;a[n+f|0]=0;i=h;return}}while(0);h=bQ(-1,-1)|0;if((a[d]&1)==0){be(h|0)}J2(c[b+12>>2]|0);be(h|0)}function fU(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=+f;g=+g;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0;m=i;i=i+32|0;n=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];n=m|0;o=m+16|0;p=b|0;q=d;if((a[q]&1)==0){r=n;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{q=c[d+8>>2]|0;r=c[d+4>>2]|0;if(r>>>0>4294967279>>>0){CJ(0)}if(r>>>0<11>>>0){a[n]=r<<1;s=n+1|0}else{d=r+16&-16;t=J0(d)|0;c[n+8>>2]=t;c[n>>2]=d|1;c[n+4>>2]=r;s=t}Kb(s|0,q|0,r)|0;a[s+r|0]=0}r=o;s=e;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];x=0;aB(6,p|0,n|0,o|0,0,0,0);if(x){x=0;o=bQ(-1,-1)|0;p=o;o=K;if((a[n]&1)==0){u=o;v=p;w=v;y=0;z=w;A=u;be(z|0)}J2(c[n+8>>2]|0);u=o;v=p;w=v;y=0;z=w;A=u;be(z|0)}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}n=b|0;c[n>>2]=18232;h[b+40>>3]=f;h[b+48>>3]=g;h[b+56>>3]=j;h[b+64>>3]=k;p=b+72|0;o=l;if((a[o]&1)==0){s=p;c[s>>2]=c[o>>2];c[s+4>>2]=c[o+4>>2];c[s+8>>2]=c[o+8>>2];B=b+32|0;c[B>>2]=3;i=m;return}o=c[l+8>>2]|0;s=c[l+4>>2]|0;do{if(s>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(s>>>0<11>>>0){a[p]=s<<1;C=p+1|0}else{l=s+16&-16;r=(x=0,as(230,l|0)|0);if(x){x=0;break}c[b+80>>2]=r;c[p>>2]=l|1;c[b+76>>2]=s;C=r}Kb(C|0,o|0,s)|0;a[C+s|0]=0;B=b+32|0;c[B>>2]=3;i=m;return}}while(0);m=bQ(-1,-1)|0;B=m;m=K;c[n>>2]=16616;if((a[b+4|0]&1)==0){u=m;v=B;w=v;y=0;z=w;A=u;be(z|0)}J2(c[b+12>>2]|0);u=m;v=B;w=v;y=0;z=w;A=u;be(z|0)}function fV(b){b=b|0;var d=0;d=b|0;c[d>>2]=18232;if((a[b+72|0]&1)!=0){J2(c[b+80>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function fW(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=18232;if((a[b+72|0]&1)!=0){J2(c[b+80>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function fX(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+124>>2]&1023](b,a);return}function fY(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+124>>2]&1023](b,a)|0}function fZ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+124>>2]&1023](b,a)|0}function f_(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+124>>2]&1023](b,a)|0}function f$(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+124>>2]&1023](b,a)|0}function f0(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+124>>2]&511](a,d,b);return}function f1(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+124>>2]&511](a,d,b);return}function f2(b,c){b=b|0;c=c|0;c=b;a[b]=10;b=c+1|0;a[b]=a[9944]|0;a[b+1|0]=a[9945]|0;a[b+2|0]=a[9946]|0;a[b+3|0]=a[9947]|0;a[b+4|0]=a[9948]|0;a[c+6|0]=0;return}function f3(b,d){b=b|0;d=d|0;if((d|0)==0){return}f3(b,c[d>>2]|0);f3(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){J2(c[d+24>>2]|0)}J2(d);return}function f4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;if((a[b+36|0]&1)!=0){J2(c[b+44>>2]|0)}d=c[b+12>>2]|0;e=d;if((d|0)!=0){f=b+16|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~(((g-24+(-e|0)|0)>>>0)/24|0)*24|0)}J2(d)}d=b|0;e=c[d>>2]|0;if((e|0)==0){return}g=b+4|0;b=c[g>>2]|0;if((e|0)==(b|0)){h=e}else{f=b;while(1){b=f-12|0;c[g>>2]=b;if((a[b]&1)==0){i=b}else{J2(c[f-12+8>>2]|0);i=c[g>>2]|0}if((e|0)==(i|0)){break}else{f=i}}h=c[d>>2]|0}J2(h);return}function f5(b,d){b=b|0;d=d|0;if((d|0)==0){return}f5(b,c[d>>2]|0);f5(b,c[d+4>>2]|0);if((a[d+16|0]&1)!=0){J2(c[d+24>>2]|0)}J2(d);return}function f6(b,d){b=b|0;d=d|0;if((d|0)==0){return}f6(b,c[d>>2]|0);f6(b,c[d+4>>2]|0);if((a[d+20|0]&1)!=0){J2(c[d+28>>2]|0)}J2(d);return}function f7(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;c[a>>2]=20912;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;c[a+16>>2]=0;c[a+20>>2]=f;c[a+24>>2]=g;c[a+28>>2]=h;return}function f8(a){a=a|0;J2(a);return}function f9(a){a=a|0;return}function ga(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;c[a+16>>2]=b;c[a+12>>2]=d;c[a+20>>2]=e;c[a+24>>2]=f;c[a+28>>2]=g;return a|0}function gb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0;e=i;i=i+120|0;f=e|0;g=e+8|0;h=e+24|0;j=e+88|0;k=e+104|0;Ac(f,0);l=c[d+32>>2]|0;m=c[(c[l>>2]|0)+20>>2]|0;n=(x=0,ax(32,c[b+8>>2]|0,c[b+12>>2]|0,c[b+20>>2]|0)|0);do{if(!x){o=(x=0,aK(m|0,l|0,n|0)|0);if(x){x=0;p=50;break}x=0;aP(c[(c[o>>2]|0)+28>>2]|0,g|0,o|0,f|0);if(x){x=0;p=50;break}o=g;q=g;r=a[q]|0;if((r&1)==0){s=(r&255)>>>1;t=10;u=r}else{v=c[g>>2]|0;s=c[g+4>>2]|0;t=(v&-2)-1|0;u=v&255}do{if((s|0)==(t|0)){if((t|0)==-17){x=0;ap(232,0);if(x){x=0;p=51;break}return 0}if((u&1)==0){w=o+1|0}else{w=c[g+8>>2]|0}do{if(t>>>0<2147483623>>>0){v=t+1|0;y=t<<1;z=v>>>0<y>>>0?y:v;if(z>>>0<11>>>0){A=11;break}A=z+16&-16}else{A=-17}}while(0);z=(x=0,as(230,A|0)|0);if(x){x=0;p=51;break}Kb(z|0,w|0,t)|0;if((t|0)!=10){J2(w)}c[g+8>>2]=z;z=A|1;c[g>>2]=z;B=z&255;p=21}else{B=r;p=21}}while(0);L27:do{if((p|0)==21){if((B&1)==0){a[q]=(s<<1)+2;C=o+1|0;D=s+1|0}else{r=c[g+8>>2]|0;z=s+1|0;c[g+4>>2]=z;C=r;D=z}a[C+s|0]=123;a[C+D|0]=0;if((a[q]&1)==0){E=o+1|0}else{E=c[g+8>>2]|0}z=c[b+4>>2]|0;r=d+4|0;if((a[r]&1)==0){v=j;c[v>>2]=c[r>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2]}else{r=c[d+12>>2]|0;v=c[d+8>>2]|0;if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;p=51;break}return 0}if(v>>>0<11>>>0){a[j]=v<<1;F=j+1|0}else{y=v+16&-16;G=(x=0,as(230,y|0)|0);if(x){x=0;p=51;break}c[j+8>>2]=G;c[j>>2]=y|1;c[j+4>>2]=v;F=G}Kb(F|0,r|0,v)|0;a[F+v|0]=0}v=k;r=d+16|0;c[v>>2]=c[r>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2];x=0;ao(2,h|0,E|0,z|0,j|0,k|0);do{if(!x){z=(x=0,as(44,h|0)|0);if(x){x=0;r=bQ(-1,-1)|0;v=r;r=K;if((a[h+28|0]&1)!=0){J2(c[h+36>>2]|0)}G=c[h+4>>2]|0;if((G|0)==0){H=v;I=r;break}y=h+8|0;J=c[y>>2]|0;if((G|0)!=(J|0)){c[y>>2]=J+(~((J-4+(-G|0)|0)>>>2)<<2)}J2(G);H=v;I=r;break}if((a[h+28|0]&1)!=0){J2(c[h+36>>2]|0)}r=c[h+4>>2]|0;v=r;if((r|0)!=0){G=h+8|0;J=c[G>>2]|0;if((r|0)!=(J|0)){c[G>>2]=J+(~((J-4+(-v|0)|0)>>>2)<<2)}J2(r)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}r=(x=0,aK(c[(c[z>>2]|0)+24>>2]|0,z|0,b|0)|0);if(x){x=0;p=51;break L27}if((a[q]&1)==0){Ae(f);i=e;return r|0}J2(c[g+8>>2]|0);Ae(f);i=e;return r|0}else{x=0;r=bQ(-1,-1)|0;H=r;I=K}}while(0);if((a[j]&1)==0){L=H;M=I;break}J2(c[j+8>>2]|0);L=H;M=I}}while(0);if((p|0)==51){o=bQ(-1,-1)|0;L=o;M=K}if((a[q]&1)==0){N=L;O=M;break}J2(c[g+8>>2]|0);N=L;O=M}else{x=0;p=50}}while(0);if((p|0)==50){p=bQ(-1,-1)|0;N=p;O=K}x=0;ap(436,f|0);if(!x){be(N|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function gc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ah=0,ai=0,aj=0;e=i;i=i+88|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=e+72|0;n=b+16|0;o=c[n>>2]|0;p=(o|0)==0;q=c[b+4>>2]|0;r=J0(48)|0;c[k>>2]=r;s=q+4|0;t=c[s>>2]|0;if((t|0)==(c[q+8>>2]|0)){ee(q|0,k);u=c[k>>2]|0}else{if((t|0)==0){v=0}else{c[t>>2]=r;v=c[s>>2]|0}c[s>>2]=v+4;u=r}r=u;v=u;t=d+4|0;k=(a[t]&1)==0;if(p){L10:do{if(k){p=m;c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];w=51}else{p=c[d+12>>2]|0;y=c[d+8>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[m]=y<<1;z=m+1|0}else{A=y+16&-16;B=(x=0,as(230,A|0)|0);if(x){x=0;break}c[m+8>>2]=B;c[m>>2]=A|1;c[m+4>>2]=y;z=B}Kb(z|0,p|0,y)|0;a[z+y|0]=0;w=51;break L10}}while(0);y=bQ(-1,-1)|0;C=y;D=K}}while(0);do{if((w|0)==51){z=d+16|0;y=f;c[y>>2]=c[z>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];z=d+40|0;y=d+36|0;x=0;aT(54,v|0,m|0,f|0,(c[z>>2]|0)-(c[y>>2]|0)>>2|0);if(x){x=0;p=bQ(-1,-1)|0;B=p;p=K;if((a[m]&1)==0){C=B;D=p;break}J2(c[m+8>>2]|0);C=B;D=p;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}p=c[y>>2]|0;B=(c[z>>2]|0)-p>>2;if((B|0)==0){E=u+40|0;F=c[E>>2]|0;G=u+36|0;H=G;I=c[H>>2]|0;J=I;L=(F|0)!=(J|0);M=L?v:0;N=M|0;i=e;return N|0}z=b|0;A=u+32|0;O=A;P=u+40|0;Q=A+12|0;R=u+36|0;S=A;A=0;T=p;while(1){p=c[T+(A<<2)>>2]|0;U=cS[c[(c[p>>2]|0)+24>>2]&1023](p,z)|0;if((U|0)!=0){p=U;c[h>>2]=p;U=c[P>>2]|0;V=U;if((V|0)==(c[Q>>2]|0)){g$(R,h);W=c[h>>2]|0}else{if((U|0)==0){X=0}else{c[V>>2]=p;X=c[P>>2]|0}c[P>>2]=X+4;W=p}cy[c[c[S>>2]>>2]&1023](O,W)}p=A+1|0;if(p>>>0>=B>>>0){break}A=p;T=c[y>>2]|0}E=u+40|0;F=c[E>>2]|0;G=u+36|0;H=G;I=c[H>>2]|0;J=I;L=(F|0)!=(J|0);M=L?v:0;N=M|0;i=e;return N|0}}while(0);W=c[q>>2]|0;X=c[s>>2]|0;h=W;while(1){if((h|0)==(X|0)){Y=X;break}if((c[h>>2]|0)==(u|0)){Y=h;break}else{h=h+4|0}}h=Y-W>>2;Y=W+(h+1<<2)|0;m=X-Y|0;Kc(W+(h<<2)|0,Y|0,m|0)|0;Y=W+((m>>2)+h<<2)|0;h=c[s>>2]|0;if((Y|0)!=(h|0)){c[s>>2]=h+(~((h-4+(-Y|0)|0)>>>2)<<2)}J2(r);Z=C;_=D;$=Z;aa=0;ab=$;ac=_;be(ab|0)}L59:do{if(k){D=l;c[D>>2]=c[t>>2];c[D+4>>2]=c[t+4>>2];c[D+8>>2]=c[t+8>>2];w=17}else{D=c[d+12>>2]|0;C=c[d+8>>2]|0;do{if(C>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(C>>>0<11>>>0){a[l]=C<<1;ad=l+1|0}else{Y=C+16&-16;h=(x=0,as(230,Y|0)|0);if(x){x=0;break}c[l+8>>2]=h;c[l>>2]=Y|1;c[l+4>>2]=C;ad=h}Kb(ad|0,D|0,C)|0;a[ad+C|0]=0;w=17;break L59}}while(0);C=bQ(-1,-1)|0;ae=C;af=K}}while(0);do{if((w|0)==17){ad=d+16|0;t=j;c[t>>2]=c[ad>>2];c[t+4>>2]=c[ad+4>>2];c[t+8>>2]=c[ad+8>>2];ad=o+40|0;t=o+36|0;k=d+40|0;C=d+36|0;D=ag((c[k>>2]|0)-(c[C>>2]|0)>>2,(c[ad>>2]|0)-(c[t>>2]|0)>>2)|0;x=0;aT(54,v|0,l|0,j|0,D|0);if(x){x=0;D=bQ(-1,-1)|0;h=D;D=K;if((a[l]&1)==0){ae=h;af=D;break}J2(c[l+8>>2]|0);ae=h;af=D;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}D=(c[ad>>2]|0)-(c[t>>2]|0)>>2;if((D|0)==0){E=u+40|0;F=c[E>>2]|0;G=u+36|0;H=G;I=c[H>>2]|0;J=I;L=(F|0)!=(J|0);M=L?v:0;N=M|0;i=e;return N|0}ad=b|0;h=u+32|0;Y=h;m=u+40|0;W=h+12|0;X=u+36|0;f=h;h=0;do{y=(c[k>>2]|0)-(c[C>>2]|0)>>2;if((y|0)!=0){T=0;do{c[n>>2]=c[(c[t>>2]|0)+(h<<2)>>2];A=c[(c[C>>2]|0)+(T<<2)>>2]|0;B=cS[c[(c[A>>2]|0)+24>>2]&1023](A,ad)|0;if((B|0)!=0){A=B;c[g>>2]=A;B=c[m>>2]|0;O=B;if((O|0)==(c[W>>2]|0)){g$(X,g);ah=c[g>>2]|0}else{if((B|0)==0){ai=0}else{c[O>>2]=A;ai=c[m>>2]|0}c[m>>2]=ai+4;ah=A}cy[c[c[f>>2]>>2]&1023](Y,ah)}T=T+1|0;}while(T>>>0<y>>>0)}h=h+1|0;}while(h>>>0<D>>>0);E=u+40|0;F=c[E>>2]|0;G=u+36|0;H=G;I=c[H>>2]|0;J=I;L=(F|0)!=(J|0);M=L?v:0;N=M|0;i=e;return N|0}}while(0);N=c[q>>2]|0;q=c[s>>2]|0;e=N;while(1){if((e|0)==(q|0)){aj=q;break}if((c[e>>2]|0)==(u|0)){aj=e;break}else{e=e+4|0}}e=aj-N>>2;aj=N+(e+1<<2)|0;u=q-aj|0;Kc(N+(e<<2)|0,aj|0,u|0)|0;aj=N+((u>>2)+e<<2)|0;e=c[s>>2]|0;if((aj|0)!=(e|0)){c[s>>2]=e+(~((e-4+(-aj|0)|0)>>>2)<<2)}J2(r);Z=ae;_=af;$=Z;aa=0;ab=$;ac=_;be(ab|0);return 0}function gd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;e=i;i=i+16|0;f=e|0;g=e+8|0;Ac(g,0);h=c[b+4>>2]|0;j=(x=0,as(230,44)|0);L1:do{if(!x){k=j;c[f>>2]=k;l=h+4|0;m=c[l>>2]|0;if((m|0)==(c[h+8>>2]|0)){x=0;aq(376,h|0,f|0);if(x){x=0;n=21;break}o=c[f>>2]|0}else{if((m|0)==0){p=0}else{c[m>>2]=k;p=c[l>>2]|0}c[l>>2]=p+4;o=k}k=o;m=o;q=o|0;c[q>>2]=16616;r=o+4|0;s=d+4|0;L11:do{if((a[s]&1)==0){t=r;c[t>>2]=c[s>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2]}else{t=c[d+12>>2]|0;u=c[d+8>>2]|0;do{if(u>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(u>>>0<11>>>0){a[r]=u<<1;v=r+1|0}else{w=u+16&-16;y=(x=0,as(230,w|0)|0);if(x){x=0;break}c[o+12>>2]=y;c[r>>2]=w|1;c[o+8>>2]=u;v=y}Kb(v|0,t|0,u)|0;a[v+u|0]=0;break L11}}while(0);u=bQ(-1,-1)|0;t=u;u=K;y=c[h>>2]|0;w=c[l>>2]|0;z=y;while(1){if((z|0)==(w|0)){A=w;break}if((c[z>>2]|0)==(o|0)){A=z;break}else{z=z+4|0}}z=A-y>>2;B=y+(z+1<<2)|0;C=w-B|0;Kc(y+(z<<2)|0,B|0,C|0)|0;B=y+((C>>2)+z<<2)|0;z=c[l>>2]|0;if((B|0)!=(z|0)){c[l>>2]=z+(~((z-4+(-B|0)|0)>>>2)<<2)}J2(k);D=u;E=t;break L1}}while(0);k=o+16|0;l=d+16|0;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[q>>2]=16488;a[o+28|0]=a[d+28|0]&1;a[m+29|0]=a[d+29|0]&1;c[q>>2]=20088;l=o+32|0;c[l>>2]=c[d+32>>2];k=o+36|0;r=k;s=d+36|0;B=c[s>>2]|0;c[k>>2]=B;z=o+40|0;C=d+40|0;F=c[C>>2]|0;G=F;c[z>>2]=G;if((B|0)==0){H=F;I=0;J=G}else{G=c[s>>2]|0;s=(x=0,aK(c[(c[G>>2]|0)+24>>2]|0,G|0,b|0)|0);if(x){x=0;n=21;break}c[k>>2]=s;k=c[z>>2]|0;H=k;I=s;J=k}if((H|0)==0){L=I;M=J}else{k=c[C>>2]|0;C=(x=0,aK(c[(c[k>>2]|0)+24>>2]|0,k|0,b|0)|0);if(x){x=0;n=21;break}k=C;c[z>>2]=k;L=c[r>>2]|0;M=k}do{if((L|0)==0){if((c[l>>2]|0)!=0){break}N=M;Ae(g);i=e;return N|0}}while(0);N=o;Ae(g);i=e;return N|0}else{x=0;n=21}}while(0);if((n|0)==21){n=bQ(-1,-1)|0;D=K;E=n}x=0;ap(436,g|0);if(!x){be(E|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function ge(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=i;i=i+88|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=e+40|0;l=e+56|0;m=e+72|0;Ac(j,0);n=b+24|0;do{if((c[n>>2]|0)==0){o=35}else{p=b+28|0;if((c[p>>2]|0)==0){o=35;break}q=j|0;x=0;aP(c[(c[d>>2]|0)+28>>2]|0,k|0,d|0,q|0);if(x){x=0;o=31;break}r=c[n>>2]|0;x=0;aP(c[(c[r>>2]|0)+28>>2]|0,l|0,r|0,q|0);if(x){x=0;q=bQ(-1,-1)|0;r=q;q=K;if((a[k]&1)==0){s=q;t=r;break}J2(c[k+8>>2]|0);s=q;t=r;break}r=k;q=k;u=a[q]|0;v=u&255;if((v&1|0)==0){w=v>>>1}else{w=c[k+4>>2]|0}v=l;y=a[l]|0;z=y&255;if((z&1|0)==0){A=z>>>1}else{A=c[l+4>>2]|0}L17:do{if((w|0)==(A|0)){z=(u&1)==0;if(z){B=r+1|0}else{B=c[k+8>>2]|0}C=y&1;if(C<<24>>24==0){D=v+1|0}else{D=c[l+8>>2]|0}if(!z){E=(Kd(B|0,D|0,w|0)|0)==0;F=C;break}if((w|0)==0){E=1;F=C;break}else{G=D;H=B;I=w}while(1){if((a[H]|0)!=(a[G]|0)){E=0;F=C;break L17}z=I-1|0;if((z|0)==0){E=1;F=C;break}else{G=G+1|0;H=H+1|0;I=z}}}else{E=0;F=y&1}}while(0);if(F<<24>>24==0){J=u}else{J2(c[l+8>>2]|0);J=a[q]|0}if((J&1)==0){if(!E){o=35;break}}else{J2(c[k+8>>2]|0);if(!E){o=35;break}}L=c[p>>2]|0;Ae(j);i=e;return L|0}}while(0);L43:do{if((o|0)==35){E=c[b+4>>2]|0;k=(x=0,as(230,48)|0);if(x){x=0;o=31;break}J=k;c[h>>2]=J;k=E+4|0;l=c[k>>2]|0;if((l|0)==(c[E+8>>2]|0)){x=0;aq(376,E|0,h|0);if(x){x=0;o=31;break}M=c[h>>2]|0}else{if((l|0)==0){N=0}else{c[l>>2]=J;N=c[k>>2]|0}c[k>>2]=N+4;M=J}J=M;l=M;F=d+4|0;L54:do{if((a[F]&1)==0){I=m;c[I>>2]=c[F>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];o=52}else{I=c[d+12>>2]|0;H=c[d+8>>2]|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(H>>>0<11>>>0){a[m]=H<<1;O=m+1|0}else{G=H+16&-16;w=(x=0,as(230,G|0)|0);if(x){x=0;break}c[m+8>>2]=w;c[m>>2]=G|1;c[m+4>>2]=H;O=w}Kb(O|0,I|0,H)|0;a[O+H|0]=0;o=52;break L54}}while(0);H=bQ(-1,-1)|0;P=K;Q=H}}while(0);do{if((o|0)==52){F=d+16|0;p=g;c[p>>2]=c[F>>2];c[p+4>>2]=c[F+4>>2];c[p+8>>2]=c[F+8>>2];F=d+40|0;p=d+36|0;x=0;aT(38,l|0,m|0,g|0,(c[F>>2]|0)-(c[p>>2]|0)>>2|0);if(x){x=0;q=bQ(-1,-1)|0;u=q;q=K;if((a[m]&1)==0){P=q;Q=u;break}J2(c[m+8>>2]|0);P=q;Q=u;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}u=c[p>>2]|0;q=(c[F>>2]|0)-u>>2;L76:do{if((q|0)==0){R=M+40|0;S=M+36|0}else{F=b|0;H=M+32|0;I=H;w=M+40|0;G=H+12|0;B=M+36|0;D=B;A=H;H=0;n=u;while(1){y=c[n+(H<<2)>>2]|0;v=(x=0,aK(c[(c[y>>2]|0)+24>>2]|0,y|0,F|0)|0);if(x){x=0;break}if((v|0)!=0){y=v;c[f>>2]=y;v=c[w>>2]|0;r=v;if((r|0)==(c[G>>2]|0)){x=0;aq(722,D|0,f|0);if(x){x=0;break}T=c[f>>2]|0}else{if((v|0)==0){U=0}else{c[r>>2]=y;U=c[w>>2]|0}c[w>>2]=U+4;T=y}x=0;aq(c[c[A>>2]>>2]|0,I|0,T|0);if(x){x=0;break}}y=H+1|0;if(y>>>0>=q>>>0){R=w;S=B;break L76}H=y;n=c[p>>2]|0}n=bQ(-1,-1)|0;V=K;W=n;o=32;break L43}}while(0);L=((c[R>>2]|0)!=(c[S>>2]|0)?l:0)|0;Ae(j);i=e;return L|0}}while(0);l=c[E>>2]|0;p=c[k>>2]|0;q=l;while(1){if((q|0)==(p|0)){X=p;break}if((c[q>>2]|0)==(M|0)){X=q;break}else{q=q+4|0}}q=X-l>>2;E=l+(q+1<<2)|0;u=p-E|0;Kc(l+(q<<2)|0,E|0,u|0)|0;E=l+((u>>2)+q<<2)|0;q=c[k>>2]|0;if((E|0)!=(q|0)){c[k>>2]=q+(~((q-4+(-E|0)|0)>>>2)<<2)}J2(J);s=P;t=Q}}while(0);if((o|0)==31){Q=bQ(-1,-1)|0;V=K;W=Q;o=32}if((o|0)==32){s=V;t=W}x=0;ap(436,j|0);if(!x){be(t|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function gf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+56|0;f=e|0;g=e+16|0;h=e+24|0;j=e+40|0;k=b+16|0;l=c[k>>2]|0;c[k>>2]=0;m=c[b+4>>2]|0;n=J0(36)|0;c[g>>2]=n;o=m+4|0;p=c[o>>2]|0;if((p|0)==(c[m+8>>2]|0)){ee(m|0,g);q=c[g>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=n;r=c[o>>2]|0}c[o>>2]=r+4;q=n}n=q;r=q;p=d+4|0;L8:do{if((a[p]&1)==0){g=h;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];s=16}else{g=c[d+12>>2]|0;t=c[d+8>>2]|0;do{if(t>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(t>>>0<11>>>0){a[h]=t<<1;u=h+1|0}else{v=t+16&-16;w=(x=0,as(230,v|0)|0);if(x){x=0;break}c[h+8>>2]=w;c[h>>2]=v|1;c[h+4>>2]=t;u=w}Kb(u|0,g|0,t)|0;a[u+t|0]=0;s=16;break L8}}while(0);t=bQ(-1,-1)|0;y=K;z=t}}while(0);do{if((s|0)==16){u=j;p=d+16|0;c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];p=c[d+32>>2]|0;t=(x=0,aK(c[(c[p>>2]|0)+24>>2]|0,p|0,b|0)|0);do{if(!x){p=f;c[p>>2]=c[u>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];x=0;aT(52,r|0,h|0,f|0,t|0);if(x){x=0;break}if((a[h]&1)==0){c[k>>2]=l;A=q;i=e;return A|0}J2(c[h+8>>2]|0);c[k>>2]=l;A=q;i=e;return A|0}else{x=0}}while(0);t=bQ(-1,-1)|0;u=t;t=K;if((a[h]&1)==0){y=t;z=u;break}J2(c[h+8>>2]|0);y=t;z=u}}while(0);h=c[m>>2]|0;m=c[o>>2]|0;A=h;while(1){if((A|0)==(m|0)){B=m;break}if((c[A>>2]|0)==(q|0)){B=A;break}else{A=A+4|0}}A=B-h>>2;B=h+(A+1<<2)|0;q=m-B|0;Kc(h+(A<<2)|0,B|0,q|0)|0;B=h+((q>>2)+A<<2)|0;A=c[o>>2]|0;if((B|0)==(A|0)){J2(n);C=z;D=0;E=C;F=y;be(E|0)}c[o>>2]=A+(~((A-4+(-B|0)|0)>>>2)<<2);J2(n);C=z;D=0;E=C;F=y;be(E|0);return 0}function gg(a,b){a=a|0;b=b|0;return b|0}function gh(a,b){a=a|0;b=b|0;return b|0}function gi(a,b){a=a|0;b=b|0;return b|0}function gj(a,b){a=a|0;b=b|0;return b|0}function gk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+24|0;Ac(f,0);j=b+24|0;L1:do{if((c[j>>2]|0)!=0){k=b+28|0;if((c[k>>2]|0)==0){break}l=f|0;x=0;aP(c[(c[d>>2]|0)+28>>2]|0,g|0,d|0,l|0);do{if(!x){m=c[j>>2]|0;x=0;aP(c[(c[m>>2]|0)+28>>2]|0,h|0,m|0,l|0);if(x){x=0;m=bQ(-1,-1)|0;n=m;m=K;if((a[g]&1)==0){o=m;p=n;break}J2(c[g+8>>2]|0);o=m;p=n;break}n=g;m=g;q=a[m]|0;r=q&255;if((r&1|0)==0){s=r>>>1}else{s=c[g+4>>2]|0}r=h;t=a[h]|0;u=t&255;if((u&1|0)==0){v=u>>>1}else{v=c[h+4>>2]|0}L18:do{if((s|0)==(v|0)){u=(q&1)==0;if(u){w=n+1|0}else{w=c[g+8>>2]|0}y=t&1;if(y<<24>>24==0){z=r+1|0}else{z=c[h+8>>2]|0}if(!u){A=(Kd(w|0,z|0,s|0)|0)==0;B=y;break}if((s|0)==0){A=1;B=y;break}else{C=z;D=w;E=s}while(1){if((a[D]|0)!=(a[C]|0)){A=0;B=y;break L18}u=E-1|0;if((u|0)==0){A=1;B=y;break}else{C=C+1|0;D=D+1|0;E=u}}}else{A=0;B=t&1}}while(0);if(B<<24>>24==0){F=q}else{J2(c[h+8>>2]|0);F=a[m]|0}if((F&1)==0){if(!A){break L1}}else{J2(c[g+8>>2]|0);if(!A){break L1}}G=c[k>>2]|0;Ae(f);i=e;return G|0}else{x=0;t=bQ(-1,-1)|0;o=K;p=t}}while(0);x=0;ap(436,f|0);if(!x){be(p|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);G=d|0;Ae(f);i=e;return G|0}function gl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e|0;g=b+16|0;if((c[g>>2]|0)==0){h=0;i=e;return h|0}j=c[b+4>>2]|0;b=J0(36)|0;c[f>>2]=b;k=j+4|0;l=c[k>>2]|0;if((l|0)==(c[j+8>>2]|0)){ee(j|0,f);m=c[f>>2]|0}else{if((l|0)==0){n=0}else{c[l>>2]=b;n=c[k>>2]|0}c[k>>2]=n+4;m=b}b=m;n=m;l=m|0;c[l>>2]=16616;f=m+4|0;o=d+4|0;L11:do{if((a[o]&1)==0){p=f;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{p=c[d+12>>2]|0;q=c[d+8>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[f]=q<<1;r=f+1|0}else{s=q+16&-16;t=(x=0,as(230,s|0)|0);if(x){x=0;break}c[m+12>>2]=t;c[f>>2]=s|1;c[m+8>>2]=q;r=t}Kb(r|0,p|0,q)|0;a[r+q|0]=0;break L11}}while(0);q=bQ(-1,-1)|0;p=c[j>>2]|0;t=c[k>>2]|0;s=p;while(1){if((s|0)==(t|0)){u=t;break}if((c[s>>2]|0)==(m|0)){u=s;break}else{s=s+4|0}}s=u-p>>2;v=p+(s+1<<2)|0;w=t-v|0;Kc(p+(s<<2)|0,v|0,w|0)|0;v=p+((w>>2)+s<<2)|0;s=c[k>>2]|0;if((v|0)==(s|0)){J2(b);be(q|0)}c[k>>2]=s+(~((s-4+(-v|0)|0)>>>2)<<2);J2(b);be(q|0)}}while(0);b=m+16|0;k=d+16|0;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[l>>2]=16488;a[m+28|0]=a[d+28|0]&1;a[n+29|0]=a[d+29|0]&1;c[l>>2]=19408;l=m+32|0;c[l>>2]=c[d+32>>2];c[l>>2]=c[g>>2];h=m;i=e;return h|0}function gm(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gn(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function go(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gp(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gq(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gr(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gs(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gt(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gu(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gv(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gw(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gx(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gy(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gz(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gA(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gB(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gC(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gD(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gE(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gF(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gG(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gH(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gI(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gJ(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gK(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gL(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gM(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gN(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gO(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gP(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gQ(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gR(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gS(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gT(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gU(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gV(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gW(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gX(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gY(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function gZ(a,b){a=a|0;b=b|0;return c[a+16>>2]|0}function g_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function g$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function g0(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function g1(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function g2(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+172>>2]&1023](b,a);return}function g3(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+172>>2]&1023](b,a)|0}function g4(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+172>>2]&1023](b,a)|0}function g5(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+172>>2]&1023](b,a)|0}function g6(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+172>>2]&1023](b,a)|0}function g7(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+172>>2]&511](a,d,b);return}function g8(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+172>>2]&511](a,d,b);return}function g9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0;g=i;i=i+64|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=g+32|0;l=g+48|0;m=d;if((a[m]&1)==0){n=l;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];o=a[n]|0;p=n}else{n=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){d=m<<1&255;q=l;a[q]=d;r=l+1|0;s=d;t=q}else{q=m+16&-16;d=J0(q)|0;c[l+8>>2]=d;u=q|1;c[l>>2]=u;c[l+4>>2]=m;r=d;s=u&255;t=l}Kb(r|0,n|0,m)|0;a[r+m|0]=0;o=s;p=t}t=e;e=k;c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];t=k;k=h;e=j;s=b|0;L12:do{if((o&1)==0){c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];v=19}else{m=c[l+8>>2]|0;r=c[l+4>>2]|0;do{if(r>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(r>>>0<11>>>0){a[k]=r<<1;w=h+1|0}else{n=r+16&-16;u=(x=0,as(230,n|0)|0);if(x){x=0;break}c[h+8>>2]=u;c[h>>2]=n|1;c[h+4>>2]=r;w=u}Kb(w|0,m|0,r)|0;a[w+r|0]=0;v=19;break L12}}while(0);r=bQ(-1,-1)|0;y=K;z=r}}while(0);do{if((v|0)==19){c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];x=0;ao(20,s|0,h|0,j|0,0,0);if(x){x=0;w=bQ(-1,-1)|0;o=K;if((a[k]&1)==0){y=o;z=w;break}J2(c[h+8>>2]|0);y=o;z=w;break}if((a[k]&1)!=0){J2(c[h+8>>2]|0)}w=b|0;c[w>>2]=20216;if((a[p]&1)==0){c[w>>2]=20032;A=b+32|0;c[A>>2]=f;i=g;return}J2(c[l+8>>2]|0);c[w>>2]=20032;A=b+32|0;c[A>>2]=f;i=g;return}}while(0);if((a[p]&1)==0){be(z|0)}J2(c[l+8>>2]|0);be(z|0)}function ha(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function hb(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function hc(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+196>>2]&1023](b,a);return}function hd(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+196>>2]&1023](b,a)|0}function he(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+196>>2]&1023](b,a)|0}function hf(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+196>>2]&1023](b,a)|0}function hg(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+196>>2]&1023](b,a)|0}function hh(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+196>>2]&511](a,d,b);return}function hi(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+196>>2]&511](a,d,b);return}function hj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=J0(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];x=0;ao(20,k|0,h|0,j|0,0,0);if(x){x=0;j=bQ(-1,-1)|0;k=j;j=K;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}J2(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}h=b+32|0;c[h>>2]=21584;k=b+36|0;c[k>>2]=0;j=b+40|0;c[j>>2]=0;n=b+44|0;c[n>>2]=0;if((f|0)==0){v=b|0;c[v>>2]=19808;c[h>>2]=19860;i=g;return}m=(x=0,as(230,f<<2|0)|0);if(!x){e=m;c[k>>2]=e;c[j>>2]=e;c[n>>2]=e+(f<<2);v=b|0;c[v>>2]=19808;c[h>>2]=19860;i=g;return}else{x=0}g=bQ(-1,-1)|0;h=g;g=K;c[b>>2]=16616;if((a[b+4|0]&1)==0){p=g;q=h;r=q;s=0;t=r;u=p;be(t|0)}J2(c[b+12>>2]|0);p=g;q=h;r=q;s=0;t=r;u=p;be(t|0)}function hk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+32|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=b|0;l=d;if((a[l]&1)==0){m=h;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[d+8>>2]|0;m=c[d+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[h]=m<<1;n=h+1|0}else{d=m+16&-16;o=J0(d)|0;c[h+8>>2]=o;c[h>>2]=d|1;c[h+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=j;n=e;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];x=0;ao(20,k|0,h|0,j|0,0,0);if(x){x=0;j=bQ(-1,-1)|0;k=j;j=K;if((a[h]&1)==0){p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}J2(c[h+8>>2]|0);p=j;q=k;r=q;s=0;t=r;u=p;be(t|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}h=b+32|0;c[h>>2]=21552;k=b+36|0;c[k>>2]=0;j=b+40|0;c[j>>2]=0;n=b+44|0;c[n>>2]=0;if((f|0)==0){v=b|0;c[v>>2]=20528;c[h>>2]=20580;i=g;return}m=(x=0,as(230,f<<2|0)|0);if(!x){e=m;c[k>>2]=e;c[j>>2]=e;c[n>>2]=e+(f<<2);v=b|0;c[v>>2]=20528;c[h>>2]=20580;i=g;return}else{x=0}g=bQ(-1,-1)|0;h=g;g=K;c[b>>2]=16616;if((a[b+4|0]&1)==0){p=g;q=h;r=q;s=0;t=r;u=p;be(t|0)}J2(c[b+12>>2]|0);p=g;q=h;r=q;s=0;t=r;u=p;be(t|0)}function hl(a){a=a|0;var b=0;b=JW((Kf(a|0)|0)+1|0)|0;Kg(b|0,a|0)|0;return b|0}function hm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=zd()|0;c[g+8>>2]=b;c[g+12>>2]=d;c[g+16>>2]=e;c[g+20>>2]=0;c[g>>2]=a;zg(g)|0;a=c[g+4>>2]|0;if((a|0)==0){h=0}else{h=bR(a|0)|0}if((c[g+24>>2]|0)==0){i=0;c[f>>2]=i;ze(g);return h|0}i=bR(c[g+28>>2]|0)|0;c[f>>2]=i;ze(g);return h|0}function hn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;j=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[b>>2]=d;d=b+4|0;j=e;if((a[j]&1)==0){k=d;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2]}else{j=c[e+8>>2]|0;k=c[e+4>>2]|0;if(k>>>0>4294967279>>>0){CJ(0)}if(k>>>0<11>>>0){a[d]=k<<1;l=d+1|0}else{e=k+16&-16;m=J0(e)|0;c[b+12>>2]=m;c[d>>2]=e|1;c[b+8>>2]=k;l=m}Kb(l|0,j|0,k)|0;a[l+k|0]=0}k=b+16|0;l=f;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=b+28|0;k=g;if((a[k]&1)==0){f=l;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];i=h;return}k=c[g+8>>2]|0;f=c[g+4>>2]|0;do{if(f>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(f>>>0<11>>>0){a[l]=f<<1;n=l+1|0}else{g=f+16&-16;j=(x=0,as(230,g|0)|0);if(x){x=0;break}c[b+36>>2]=j;c[l>>2]=g|1;c[b+32>>2]=f;n=j}Kb(n|0,k|0,f)|0;a[n+f|0]=0;i=h;return}}while(0);h=bQ(-1,-1)|0;if((a[d]&1)==0){be(h|0)}J2(c[b+12>>2]|0);be(h|0)}function ho(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+48|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=f+32|0;f=ci(40)|0;k=f;l=d;L1:do{if((a[l]&1)==0){m=g;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];n=11}else{m=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[g]=o<<1;p=g+1|0}else{q=o+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;break}c[g+8>>2]=r;c[g>>2]=q|1;c[g+4>>2]=o;p=r}Kb(p|0,m|0,o)|0;a[p+o|0]=0;n=11;break L1}}while(0);o=bQ(-1,-1)|0;s=o;t=K}}while(0);do{if((n|0)==11){p=h;d=e;c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];d=b;L16:do{if((a[d]&1)==0){p=j;c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];n=21}else{p=c[b+8>>2]|0;l=c[b+4>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(l>>>0<11>>>0){a[j]=l<<1;u=j+1|0}else{o=l+16&-16;m=(x=0,as(230,o|0)|0);if(x){x=0;break}c[j+8>>2]=m;c[j>>2]=o|1;c[j+4>>2]=l;u=m}Kb(u|0,p|0,l)|0;a[u+l|0]=0;n=21;break L16}}while(0);l=bQ(-1,-1)|0;v=1;w=K;y=l}}while(0);do{if((n|0)==21){x=0;ao(32,k|0,2,g|0,h|0,j|0);do{if(!x){x=0;aP(144,f|0,30176,350);if(x){x=0;z=0;break}}else{x=0;z=1}}while(0);d=bQ(-1,-1)|0;l=d;d=K;if((a[j]&1)==0){v=z;w=d;y=l;break}J2(c[j+8>>2]|0);v=z;w=d;y=l}}while(0);if((a[g]&1)==0){if(v){s=y;t=w;break}else{A=y;B=w}C=A;D=0;E=C;F=B;be(E|0)}else{J2(c[g+8>>2]|0);if(v){s=y;t=w;break}else{A=y;B=w}C=A;D=0;E=C;F=B;be(E|0)}}}while(0);bl(f|0);A=s;B=t;C=A;D=0;E=C;F=B;be(E|0)}function hp(b){b=b|0;if((a[b+28|0]&1)!=0){J2(c[b+36>>2]|0)}if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function hq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;h=i;i=i+168|0;j=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=h+32|0;m=h+72|0;n=h+88|0;o=h+104|0;p=h+120|0;q=h+136|0;r=h+152|0;h=e;s=e;t=a[s]|0;u=t&255;if((u&1|0)==0){v=u>>>1}else{v=c[e+4>>2]|0}do{if((v|0)!=0){if((t&1)==0){w=h+1|0}else{w=c[e+8>>2]|0}if((xM(w)|0)==0){break}u=d[s]|0;if((u&1|0)==0){y=u>>>1}else{y=c[e+4>>2]|0}CO(k,e,1,y-1|0,0);u=k;z=a[u]|0;if((z&1)==0){A=k+1|0}else{A=c[k+8>>2]|0}B=z&255;if((B&1|0)==0){C=B>>>1}else{C=c[k+4>>2]|0}B=a[s]|0;if((B&1)==0){D=10;E=B}else{B=c[e>>2]|0;D=(B&-2)-1|0;E=B&255}do{if(D>>>0<C>>>0){B=E&255;if((B&1|0)==0){F=B>>>1}else{F=c[e+4>>2]|0}x=0;aA(8,e|0,D|0,C-D|0,F|0,0,F|0,C|0,A|0);if(!x){G=a[u]|0;break}else{x=0}B=bQ(-1,-1)|0;H=B;B=K;if((a[u]&1)==0){I=B;J=H;L=J;M=0;N=L;O=I;be(N|0)}J2(c[k+8>>2]|0);I=B;J=H;L=J;M=0;N=L;O=I;be(N|0)}else{if((E&1)==0){P=h+1|0}else{P=c[e+8>>2]|0}Kc(P|0,A|0,C|0)|0;a[P+C|0]=0;if((a[s]&1)==0){a[s]=C<<1;G=z;break}else{c[e+4>>2]=C;G=z;break}}}while(0);if((G&1)==0){break}J2(c[k+8>>2]|0)}}while(0);if((a[s]&1)==0){k=m;c[k>>2]=c[s>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2]}else{k=c[e+8>>2]|0;G=c[e+4>>2]|0;if(G>>>0>4294967279>>>0){CJ(0)}if(G>>>0<11>>>0){a[m]=G<<1;Q=m+1|0}else{C=G+16&-16;P=J0(C)|0;c[m+8>>2]=P;c[m>>2]=C|1;c[m+4>>2]=G;Q=P}Kb(Q|0,k|0,G)|0;a[Q+G|0]=0}G=f;f=j;c[f>>2]=c[G>>2];c[f+4>>2]=c[G+4>>2];c[f+8>>2]=c[G+8>>2];f=n;a[f]=0;a[n+1|0]=0;x=0;ao(24,l|0,g|0,m|0,j|0,n|0);if(x){x=0;j=bQ(-1,-1)|0;g=j;j=K;if((a[f]&1)!=0){J2(c[n+8>>2]|0)}if((a[m]&1)==0){I=j;J=g;L=J;M=0;N=L;O=I;be(N|0)}J2(c[m+8>>2]|0);I=j;J=g;L=J;M=0;N=L;O=I;be(N|0)}if((a[f]&1)!=0){J2(c[n+8>>2]|0)}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}x=0;aP(54,o|0,l|0,0);L78:do{if(!x){m=o;n=a[m]|0;if((n&1)==0){R=o+1|0}else{R=c[o+8>>2]|0}f=n&255;if((f&1|0)==0){S=f>>>1}else{S=c[o+4>>2]|0}x=0,ax(64,b|0,R|0,S|0)|0;if(x){x=0;f=bQ(-1,-1)|0;n=f;f=K;if((a[m]&1)==0){T=f;U=n;break}J2(c[o+8>>2]|0);T=f;U=n;break}if((a[m]&1)!=0){J2(c[o+8>>2]|0)}m=ci(40)|0;n=m;L96:do{if((a[s]&1)==0){f=p;c[f>>2]=c[s>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];V=69}else{f=c[e+8>>2]|0;g=c[e+4>>2]|0;do{if(g>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(g>>>0<11>>>0){a[p]=g<<1;W=p+1|0}else{j=g+16&-16;Q=(x=0,as(230,j|0)|0);if(x){x=0;break}c[p+8>>2]=Q;c[p>>2]=j|1;c[p+4>>2]=g;W=Q}Kb(W|0,f|0,g)|0;a[W+g|0]=0;V=69;break L96}}while(0);g=bQ(-1,-1)|0;X=g;Y=K}}while(0);do{if((V|0)==69){g=q;c[g>>2]=c[G>>2];c[g+4>>2]=c[G+4>>2];c[g+8>>2]=c[G+8>>2];g=b;L111:do{if((a[g]&1)==0){f=r;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];V=79}else{f=c[b+8>>2]|0;Q=c[b+4>>2]|0;do{if(Q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(Q>>>0<11>>>0){a[r]=Q<<1;Z=r+1|0}else{j=Q+16&-16;k=(x=0,as(230,j|0)|0);if(x){x=0;break}c[r+8>>2]=k;c[r>>2]=j|1;c[r+4>>2]=Q;Z=k}Kb(Z|0,f|0,Q)|0;a[Z+Q|0]=0;V=79;break L111}}while(0);Q=bQ(-1,-1)|0;_=1;$=K;aa=Q}}while(0);do{if((V|0)==79){x=0;ao(32,n|0,2,p|0,q|0,r|0);do{if(!x){x=0;aP(144,m|0,30176,350);if(x){x=0;ab=0;break}}else{x=0;ab=1}}while(0);g=bQ(-1,-1)|0;Q=g;g=K;if((a[r]&1)==0){_=ab;$=g;aa=Q;break}J2(c[r+8>>2]|0);_=ab;$=g;aa=Q}}while(0);if((a[p]&1)==0){if(_){X=aa;Y=$;break}else{T=$;U=aa;break L78}}else{J2(c[p+8>>2]|0);if(_){X=aa;Y=$;break}else{T=$;U=aa;break L78}}}}while(0);bl(m|0);T=Y;U=X}else{x=0;n=bQ(-1,-1)|0;T=K;U=n}}while(0);if((a[l+28|0]&1)!=0){J2(c[l+36>>2]|0)}if((a[l+4|0]&1)==0){I=T;J=U;L=J;M=0;N=L;O=I;be(N|0)}J2(c[l+12>>2]|0);I=T;J=U;L=J;M=0;N=L;O=I;be(N|0)}function hr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;f=i;i=i+32|0;g=f|0;h=f+8|0;j=f+16|0;k=j;l=i;i=i+144|0;m=l+64|0;n=l|0;o=l+8|0;p=o|0;c[p>>2]=14576;q=l+12|0;c[n>>2]=31212;r=l+64|0;c[r>>2]=31232;c[l+4>>2]=0;x=0;aq(200,l+64|0,q|0);do{if(!x){c[l+136>>2]=0;c[l+140>>2]=-1;s=l+8|0;c[n>>2]=14556;c[m>>2]=14596;c[p>>2]=14576;t=q|0;c[t>>2]=14880;u=l+16|0;HA(u);v=l+20|0;Ke(v|0,0,24)|0;c[t>>2]=14736;w=l+44|0;y=l+56|0;z=l+60|0;Ke(l+44|0,0,16)|0;c[z>>2]=24;Ke(k|0,0,12)|0;x=0;aq(214,q|0,j|0);if(x){x=0;A=bQ(-1,-1)|0;B=K;if((a[k]&1)!=0){J2(c[j+8>>2]|0)}if((a[w]&1)!=0){J2(c[l+52>>2]|0)}c[t>>2]=14880;x=0;ap(388,u|0);if(!x){C=A;D=B;break}else{x=0}bQ(-1,-1,0)|0;bU()}if((a[k]&1)!=0){J2(c[j+8>>2]|0)}L17:do{if(e){E=16}else{B=o;x=0;aq(346,h|0,o+(c[(c[o>>2]|0)-12>>2]|0)|0);if(x){x=0;E=28;break}A=(x=0,aK(196,h|0,40280)|0);do{if(!x){t=(x=0,aK(c[(c[A>>2]|0)+28>>2]|0,A|0,10)|0);if(x){x=0;break}x=0;ap(388,h|0);if(x){x=0;E=28;break L17}x=0,aK(240,B|0,t|0)|0;if(x){x=0;E=28;break L17}x=0,as(56,B|0)|0;if(x){x=0;E=28;break L17}x=0,aK(112,B|0,9072)|0;if(!x){E=16;break L17}else{x=0;E=28;break L17}}else{x=0}}while(0);B=bQ(-1,-1)|0;A=K;x=0;ap(388,h|0);if(!x){F=A;G=B;break}else{x=0}bQ(-1,-1,0)|0;bU()}}while(0);L28:do{if((E|0)==16){B=d|0;L30:do{if((c[B>>2]|0)!=0){A=o;t=o;H=o;I=e?5624:36848;J=d;L=B;while(1){x=0;aq(346,g|0,H+(c[(c[t>>2]|0)-12>>2]|0)|0);if(x){x=0;E=27;break}M=(x=0,aK(196,g|0,40280)|0);if(x){x=0;break}N=(x=0,aK(c[(c[M>>2]|0)+28>>2]|0,M|0,10)|0);if(x){x=0;break}x=0;ap(388,g|0);if(x){x=0;E=27;break}x=0,aK(240,A|0,N|0)|0;if(x){x=0;E=27;break}x=0,as(56,A|0)|0;if(x){x=0;E=27;break}N=(x=0,aK(112,A|0,7440)|0);if(x){x=0;E=27;break}M=(x=0,aK(112,N|0,I|0)|0);if(x){x=0;E=27;break}N=(x=0,aK(802,M|0,J+4|0)|0);if(x){x=0;E=27;break}M=(x=0,aK(112,N|0,4656)|0);if(x){x=0;E=27;break}N=(x=0,aK(312,M|0,c[J+20>>2]|0)|0);if(x){x=0;E=27;break}x=0,aK(802,N|0,(c[L>>2]|0)+28|0)|0;if(x){x=0;E=27;break}J=c[L>>2]|0;L=J|0;if((c[L>>2]|0)==0){break L30}}if((E|0)==27){L=bQ(-1,-1)|0;F=K;G=L;break L28}L=bQ(-1,-1)|0;J=K;x=0;ap(388,g|0);if(!x){F=J;G=L;break L28}else{x=0}bQ(-1,-1,0)|0;bU()}}while(0);B=b;L=c[z>>2]|0;do{if((L&16|0)==0){if((L&8|0)==0){Ke(B|0,0,12)|0;break}J=c[v>>2]|0;I=c[l+28>>2]|0;A=J;t=I-A|0;if(t>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;E=28;break L28}}if(t>>>0<11>>>0){a[B]=t<<1;O=b+1|0}else{H=t+16&-16;N=(x=0,as(230,H|0)|0);if(x){x=0;E=28;break L28}c[b+8>>2]=N;c[b>>2]=H|1;c[b+4>>2]=t;O=N}if((J|0)==(I|0)){P=O}else{N=I+(-A|0)|0;A=O;t=J;while(1){a[A]=a[t]|0;J=t+1|0;if((J|0)==(I|0)){break}else{A=A+1|0;t=J}}P=O+N|0}a[P]=0}else{t=c[y>>2]|0;A=c[l+36>>2]|0;if(t>>>0<A>>>0){c[y>>2]=A;Q=A}else{Q=t}t=c[l+32>>2]|0;A=t;I=Q-A|0;if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;E=28;break L28}}if(I>>>0<11>>>0){a[B]=I<<1;R=b+1|0}else{J=I+16&-16;H=(x=0,as(230,J|0)|0);if(x){x=0;E=28;break L28}c[b+8>>2]=H;c[b>>2]=J|1;c[b+4>>2]=I;R=H}if((t|0)==(Q|0)){S=R}else{H=Q+(-A|0)|0;A=R;I=t;while(1){a[A]=a[I]|0;t=I+1|0;if((t|0)==(Q|0)){break}else{A=A+1|0;I=t}}S=R+H|0}a[S]=0}}while(0);c[n>>2]=14556;c[r>>2]=14596;c[s>>2]=14576;B=l+12|0;c[B>>2]=14736;if((a[w]&1)!=0){J2(c[l+52>>2]|0)}c[B>>2]=14880;x=0;ap(388,u|0);if(!x){C7(l+64|0);i=f;return}else{x=0}B=bQ(-1,-1)|0;x=0;ap(268,l+64|0);if(!x){be(B|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);if((E|0)==28){y=bQ(-1,-1)|0;F=K;G=y}c[n>>2]=14556;c[r>>2]=14596;c[s>>2]=14576;y=l+12|0;c[y>>2]=14736;if((a[w]&1)!=0){J2(c[l+52>>2]|0)}c[y>>2]=14880;x=0;ap(388,u|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,l+64|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,l+64|0);if(!x){be(G|0)}else{x=0}bQ(-1,-1,0)|0;bU()}else{x=0;y=bQ(-1,-1)|0;C=y;D=K}}while(0);x=0;ap(268,m|0);if(!x){be(C|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function hs(a,b){a=+a;b=+b;return+(a+b)}function ht(a,b){a=+a;b=+b;return+(a-b)}function hu(a,b){a=+a;b=+b;return+(a*b)}function hv(a,b){a=+a;b=+b;return+(a/b)}function hw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=18784;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;return}function hx(a){a=a|0;J2(a);return}function hy(a){a=a|0;return}function hz(a,b,d){a=a|0;b=b|0;d=d|0;c[a+8>>2]=b;c[a+12>>2]=d;return a|0}function hA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=b+32|0;e=(c[b+36>>2]|0)-(c[d>>2]|0)>>2;b=a|0;a=0;while(1){if(a>>>0>=e>>>0){f=0;g=6;break}h=c[(c[d>>2]|0)+(a<<2)>>2]|0;i=cS[c[(c[h>>2]|0)+20>>2]&1023](h|0,b)|0;if((i|0)==0){a=a+1|0}else{f=i;g=5;break}}if((g|0)==5){return f|0}else if((g|0)==6){return f|0}return 0}function hB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+28|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+36>>2]|0;j=c[d+32>>2]|0;if(j>>>0>4294967279>>>0){CJ(0);return 0}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=J0(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}Kb(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+8|0;q=c[r>>2]|0;do{if((l&1)==0){j=g;c[j>>2]=c[m>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];t=19}else{j=c[f+8>>2]|0;p=c[f+4>>2]|0;if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;t=38;break}return 0}if(p>>>0<11>>>0){a[g]=p<<1;u=g+1|0}else{k=p+16&-16;s=(x=0,as(230,k|0)|0);if(x){x=0;t=38;break}c[g+8>>2]=s;c[g>>2]=k|1;c[g+4>>2]=p;u=s}Kb(u|0,j|0,p)|0;a[u+p|0]=0;t=19}}while(0);L24:do{if((t|0)==19){u=(x=0,aK(556,q|0,g|0)|0);if(x){x=0;l=bQ(-1,-1)|0;p=l;l=K;if((a[g]&1)==0){v=p;w=l;break}J2(c[g+8>>2]|0);v=p;w=l;break}if((a[g]&1)!=0){J2(c[g+8>>2]|0)}do{if(u){if((a[d+44|0]&1)!=0){break}l=c[d+40>>2]|0;p=(x=0,aK(c[(c[l>>2]|0)+20>>2]|0,l|0,b|0)|0);if(x){x=0;t=38;break L24}l=p|0;p=c[r>>2]|0;if((a[m]&1)==0){j=h;c[j>>2]=c[m>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2]}else{j=c[f+8>>2]|0;s=c[f+4>>2]|0;if(s>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;t=38;break L24}return 0}if(s>>>0<11>>>0){a[h]=s<<1;y=h+1|0}else{k=s+16&-16;n=(x=0,as(230,k|0)|0);if(x){x=0;t=38;break L24}c[h+8>>2]=n;c[h>>2]=k|1;c[h+4>>2]=s;y=n}Kb(y|0,j|0,s)|0;a[y+s|0]=0}s=(x=0,aK(88,p|0,h|0)|0);if(!x){c[s>>2]=l;if((a[h]&1)==0){break}J2(c[h+8>>2]|0);break}else{x=0;l=bQ(-1,-1)|0;s=l;l=K;if((a[h]&1)==0){v=s;w=l;break L24}J2(c[h+8>>2]|0);v=s;w=l;break L24}}else{l=c[d+40>>2]|0;s=(x=0,aK(c[(c[l>>2]|0)+20>>2]|0,l|0,b|0)|0);if(x){x=0;t=38;break L24}l=(x=0,aK(176,c[r>>2]|0,f|0)|0);if(x){x=0;t=38;break L24}c[l>>2]=s}}while(0);if((a[m]&1)==0){i=e;return 0}J2(c[f+8>>2]|0);i=e;return 0}}while(0);if((t|0)==38){t=bQ(-1,-1)|0;v=t;w=K}if((a[m]&1)==0){z=v;A=0;B=z;C=w;be(B|0)}J2(c[f+8>>2]|0);z=v;A=0;B=z;C=w;be(B|0);return 0}function hC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e|0;if((et(b|0,d)|0)!=0){g=1;i=e;return g|0}h=c[b+12>>2]|0;if((h|0)==0){g=0;i=e;return g|0}b=d;if((a[b]&1)==0){j=f;c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2]}else{b=c[d+8>>2]|0;j=c[d+4>>2]|0;if(j>>>0>4294967279>>>0){CJ(0);return 0}if(j>>>0<11>>>0){a[f]=j<<1;k=f+1|0}else{d=j+16&-16;l=J0(d)|0;c[f+8>>2]=l;c[f>>2]=d|1;c[f+4>>2]=j;k=l}Kb(k|0,b|0,j)|0;a[k+j|0]=0}j=(x=0,aK(556,h|0,f|0)|0);if(!x){if((a[f]&1)==0){g=j;i=e;return g|0}J2(c[f+8>>2]|0);g=j;i=e;return g|0}else{x=0;g=bQ(-1,-1)|0;if((a[f]&1)==0){be(g|0)}J2(c[f+8>>2]|0);be(g|0)}return 0}function hD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[b+28>>2]|0;e=a|0;a=cS[c[(c[d>>2]|0)+20>>2]&1023](d|0,e)|0;if(cA[c[(c[a>>2]|0)+36>>2]&511](a)|0){a=c[b+32>>2]|0;f=cS[c[(c[a>>2]|0)+20>>2]&1023](a,e)|0;return f|0}a=c[b+36>>2]|0;if((a|0)==0){f=0;return f|0}f=cS[c[(c[a>>2]|0)+20>>2]&1023](a,e)|0;return f|0}function hE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0.0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0;e=i;i=i+272|0;f=e|0;g=e+16|0;j=e+24|0;k=e+40|0;l=e+48|0;m=e+64|0;n=e+80|0;o=e+96|0;p=e+112|0;q=e+128|0;r=e+144|0;s=e+160|0;t=e+176|0;u=e+192|0;v=e+208|0;w=e+224|0;y=e+240|0;z=e+256|0;A=d+32|0;if((a[A]&1)==0){B=l;c[B>>2]=c[A>>2];c[B+4>>2]=c[A+4>>2];c[B+8>>2]=c[A+8>>2]}else{A=c[d+40>>2]|0;B=c[d+36>>2]|0;if(B>>>0>4294967279>>>0){CJ(0);return 0}if(B>>>0<11>>>0){a[l]=B<<1;C=l+1|0}else{D=B+16&-16;E=J0(D)|0;c[l+8>>2]=E;c[l>>2]=D|1;c[l+4>>2]=B;C=E}Kb(C|0,A|0,B)|0;a[C+B|0]=0}B=c[d+44>>2]|0;C=b|0;A=(x=0,aK(c[(c[B>>2]|0)+20>>2]|0,B|0,C|0)|0);L12:do{if(!x){L14:do{if((c[A+32>>2]|0)!=2){B=(x=0,as(230,48)|0);if(x){x=0;F=27;break L12}E=m+8|0;c[E>>2]=B;c[m>>2]=49;c[m+4>>2]=47;Kb(B|0,9680,47)|0;a[B+47|0]=0;B=A+4|0;L17:do{if((a[B]&1)==0){D=n;c[D>>2]=c[B>>2];c[D+4>>2]=c[B+4>>2];c[D+8>>2]=c[B+8>>2];F=22}else{D=c[A+12>>2]|0;G=c[A+8>>2]|0;do{if(G>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(G>>>0<11>>>0){a[n]=G<<1;H=n+1|0}else{I=G+16&-16;J=(x=0,as(230,I|0)|0);if(x){x=0;break}c[n+8>>2]=J;c[n>>2]=I|1;c[n+4>>2]=G;H=J}Kb(H|0,D|0,G)|0;a[H+G|0]=0;F=22;break L17}}while(0);G=bQ(-1,-1)|0;L=G;M=K}}while(0);do{if((F|0)==22){B=o;G=A+16|0;c[B>>2]=c[G>>2];c[B+4>>2]=c[G+4>>2];c[B+8>>2]=c[G+8>>2];x=0;aP(362,m|0,n|0,o|0);if(x){x=0;G=bQ(-1,-1)|0;B=G;G=K;if((a[n]&1)==0){L=B;M=G;break}J2(c[n+8>>2]|0);L=B;M=G;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[m]&1)==0){break L14}J2(c[E>>2]|0);break L14}}while(0);if((a[m]&1)==0){N=L;O=M;break L12}J2(c[E>>2]|0);N=L;O=M;break L12}}while(0);G=c[d+48>>2]|0;B=(x=0,aK(c[(c[G>>2]|0)+20>>2]|0,G|0,C|0)|0);if(x){x=0;F=27;break}L44:do{if((c[B+32>>2]|0)!=2){G=(x=0,as(230,48)|0);if(x){x=0;F=27;break L12}D=p+8|0;c[D>>2]=G;c[p>>2]=49;c[p+4>>2]=47;Kb(G|0,11192,47)|0;a[G+47|0]=0;G=B+4|0;L47:do{if((a[G]&1)==0){J=q;c[J>>2]=c[G>>2];c[J+4>>2]=c[G+4>>2];c[J+8>>2]=c[G+8>>2];F=46}else{J=c[B+12>>2]|0;I=c[B+8>>2]|0;do{if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(I>>>0<11>>>0){a[q]=I<<1;P=q+1|0}else{Q=I+16&-16;R=(x=0,as(230,Q|0)|0);if(x){x=0;break}c[q+8>>2]=R;c[q>>2]=Q|1;c[q+4>>2]=I;P=R}Kb(P|0,J|0,I)|0;a[P+I|0]=0;F=46;break L47}}while(0);I=bQ(-1,-1)|0;S=I;T=K}}while(0);do{if((F|0)==46){G=r;E=B+16|0;c[G>>2]=c[E>>2];c[G+4>>2]=c[E+4>>2];c[G+8>>2]=c[E+8>>2];x=0;aP(362,p|0,q|0,r|0);if(x){x=0;E=bQ(-1,-1)|0;G=E;E=K;if((a[q]&1)==0){S=G;T=E;break}J2(c[q+8>>2]|0);S=G;T=E;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((a[p]&1)==0){break L44}J2(c[D>>2]|0);break L44}}while(0);if((a[p]&1)==0){N=S;O=T;break L12}J2(c[D>>2]|0);N=S;O=T;break L12}}while(0);U=+h[A+40>>3];V=+h[B+40>>3];if((a[d+52|0]&1)==0){W=V}else{W=V+1.0}E=s+4|0;c[E>>2]=0;c[s+8>>2]=0;c[s>>2]=E;E=s+12|0;c[E>>2]=0;G=b+4|0;I=c[G>>2]|0;J=(x=0,as(230,72)|0);L76:do{if(!x){R=J;c[k>>2]=R;Q=I+4|0;X=c[Q>>2]|0;if((X|0)==(c[I+8>>2]|0)){x=0;aq(376,I|0,k|0);if(x){x=0;F=98;break}Y=c[k>>2]|0}else{if((X|0)==0){Z=0}else{c[X>>2]=R;Z=c[Q>>2]|0}c[Q>>2]=Z+4;Y=R}R=Y;X=Y;_=A+4|0;L86:do{if((a[_]&1)==0){$=t;c[$>>2]=c[_>>2];c[$+4>>2]=c[_+4>>2];c[$+8>>2]=c[_+8>>2];F=75}else{$=c[A+12>>2]|0;aa=c[A+8>>2]|0;do{if(aa>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aa>>>0<11>>>0){a[t]=aa<<1;ab=t+1|0}else{ac=aa+16&-16;ad=(x=0,as(230,ac|0)|0);if(x){x=0;break}c[t+8>>2]=ad;c[t>>2]=ac|1;c[t+4>>2]=aa;ab=ad}Kb(ab|0,$|0,aa)|0;a[ab+aa|0]=0;F=75;break L86}}while(0);aa=bQ(-1,-1)|0;ae=K;af=aa}}while(0);do{if((F|0)==75){D=A+16|0;aa=j;c[aa>>2]=c[D>>2];c[aa+4>>2]=c[D+4>>2];c[aa+8>>2]=c[D+8>>2];aa=u;a[aa]=0;a[u+1|0]=0;x=0;aE(2,X|0,t|0,j|0,+U,u|0);do{if(!x){$=l;ad=(a[$]&1)==0;if(ad){ac=v;c[ac>>2]=c[$>>2];c[ac+4>>2]=c[$+4>>2];c[ac+8>>2]=c[$+8>>2]}else{ac=c[l+8>>2]|0;ag=c[l+4>>2]|0;if(ag>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;ah=0;F=101;break}return 0}if(ag>>>0<11>>>0){a[v]=ag<<1;ai=v+1|0}else{aj=ag+16&-16;ak=(x=0,as(230,aj|0)|0);if(x){x=0;ah=0;F=101;break}c[v+8>>2]=ak;c[v>>2]=aj|1;c[v+4>>2]=ag;ai=ak}Kb(ai|0,ac|0,ag)|0;a[ai+ag|0]=0}ag=(x=0,aK(88,s|0,v|0)|0);if(x){x=0;ac=bQ(-1,-1)|0;ak=ac;ac=K;if((a[v]&1)==0){al=ak;am=ac;an=0;break}J2(c[v+8>>2]|0);al=ak;am=ac;an=0;break}c[ag>>2]=Y;if((a[v]&1)!=0){J2(c[v+8>>2]|0)}if((a[aa]&1)!=0){J2(c[u+8>>2]|0)}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}ag=b+8|0;c[E>>2]=c[ag>>2];c[ag>>2]=s;ac=c[d+28>>2]|0;L129:do{if(U<W){ak=ac;aj=w;ao=y;ar=y+1|0;at=z;au=w+8|0;av=y+8|0;aw=z+8|0;ax=l+8|0;ay=l+4|0;az=z+1|0;aA=z|0;aB=z+4|0;aC=A+12|0;aD=A+8|0;aF=w+1|0;aG=w|0;aH=w+4|0;V=U;while(1){aI=(x=0,aK(c[(c[ak>>2]|0)+20>>2]|0,ac|0,C|0)|0);if(x){x=0;F=97;break}if((aI|0)!=0){aJ=aI;break L129}aL=c[G>>2]|0;aI=(x=0,as(230,72)|0);if(x){x=0;F=97;break}aM=aI;c[g>>2]=aM;aN=aL+4|0;aI=c[aN>>2]|0;if((aI|0)==(c[aL+8>>2]|0)){x=0;aq(376,aL|0,g|0);if(x){x=0;F=97;break}aO=c[g>>2]|0}else{if((aI|0)==0){aQ=0}else{c[aI>>2]=aM;aQ=c[aN>>2]|0}c[aN>>2]=aQ+4;aO=aM}aR=aO;aM=aO;if((a[_]&1)==0){c[aj>>2]=c[_>>2];c[aj+4>>2]=c[_+4>>2];c[aj+8>>2]=c[_+8>>2]}else{aI=c[aC>>2]|0;aS=c[aD>>2]|0;if(aS>>>0>4294967279>>>0){F=125;break}if(aS>>>0<11>>>0){a[aj]=aS<<1;aT=aF}else{aU=aS+16&-16;aV=(x=0,as(230,aU|0)|0);if(x){x=0;F=151;break}c[au>>2]=aV;c[aG>>2]=aU|1;c[aH>>2]=aS;aT=aV}Kb(aT|0,aI|0,aS)|0;a[aT+aS|0]=0}aS=f;c[aS>>2]=c[D>>2];c[aS+4>>2]=c[D+4>>2];c[aS+8>>2]=c[D+8>>2];aW=V+1.0;a[ao]=0;a[ar]=0;x=0;aE(2,aM|0,w|0,f|0,+aW,y|0);if(x){x=0;aX=1;F=154;break}aM=c[ag>>2]|0;if(ad){c[at>>2]=c[$>>2];c[at+4>>2]=c[$+4>>2];c[at+8>>2]=c[$+8>>2]}else{aS=c[ax>>2]|0;aI=c[ay>>2]|0;if(aI>>>0>4294967279>>>0){F=136;break}if(aI>>>0<11>>>0){a[at]=aI<<1;aY=az}else{aV=aI+16&-16;aU=(x=0,as(230,aV|0)|0);if(x){x=0;aX=0;F=154;break}c[aw>>2]=aU;c[aA>>2]=aV|1;c[aB>>2]=aI;aY=aU}Kb(aY|0,aS|0,aI)|0;a[aY+aI|0]=0}aI=(x=0,aK(88,aM|0,z|0)|0);if(x){x=0;F=157;break}c[aI>>2]=aO;if((a[at]&1)!=0){J2(c[aw>>2]|0)}if((a[ao]&1)!=0){J2(c[av>>2]|0)}if((a[aj]&1)!=0){J2(c[au>>2]|0)}if(aW<W){V=aW}else{aJ=0;break L129}}do{if((F|0)==136){x=0;ap(232,0);if(!x){return 0}else{x=0;aB=bQ(-1,-1)|0;aZ=K;a_=aB;a$=0;F=156;break}}else if((F|0)==151){aB=bQ(-1,-1)|0;a0=K;a1=aB;F=153}else if((F|0)==154){aB=bQ(-1,-1)|0;aZ=K;a_=aB;a$=aX;F=156}else if((F|0)==157){aB=bQ(-1,-1)|0;aA=aB;aB=K;if((a[at]&1)==0){a2=aA;a3=0;a4=aB;F=159;break}J2(c[aw>>2]|0);a2=aA;a3=0;a4=aB;F=159}else if((F|0)==125){x=0;ap(232,0);if(!x){return 0}else{x=0;aB=bQ(-1,-1)|0;a0=K;a1=aB;F=153;break}}else if((F|0)==97){aB=bQ(-1,-1)|0;a5=K;a6=aB;F=99;break L76}}while(0);if((F|0)==153){a7=a0;a8=a1}else if((F|0)==156){a2=a_;a3=a$;a4=aZ;F=159}do{if((F|0)==159){if((a[ao]&1)!=0){J2(c[av>>2]|0)}if((a[aj]&1)==0){if(a3){a7=a4;a8=a2;break}else{a9=a2;ba=a4;break L76}}else{J2(c[au>>2]|0);if(a3){a7=a4;a8=a2;break}else{a9=a2;ba=a4;break L76}}}}while(0);au=c[aL>>2]|0;aj=c[aN>>2]|0;av=au;while(1){if((av|0)==(aj|0)){bb=aj;break}if((c[av>>2]|0)==(aO|0)){bb=av;break}else{av=av+4|0}}av=bb-au>>2;ao=au+(av+1<<2)|0;aw=aj-ao|0;Kc(au+(av<<2)|0,ao|0,aw|0)|0;ao=au+((aw>>2)+av<<2)|0;av=c[aN>>2]|0;if((ao|0)!=(av|0)){c[aN>>2]=av+(~((av-4+(-ao|0)|0)>>>2)<<2)}J2(aR);a9=a8;ba=a7;break L76}else{aJ=0}}while(0);c[ag>>2]=c[E>>2];fQ(s|0,c[s+4>>2]|0);if(ad){i=e;return aJ|0}J2(c[l+8>>2]|0);i=e;return aJ|0}else{x=0;ah=1;F=101}}while(0);if((F|0)==101){D=bQ(-1,-1)|0;al=D;am=K;an=ah}if((a[aa]&1)!=0){J2(c[u+8>>2]|0)}if((a[t]&1)==0){if(an){ae=am;af=al;break}else{a9=al;ba=am;break L76}}else{J2(c[t+8>>2]|0);if(an){ae=am;af=al;break}else{a9=al;ba=am;break L76}}}}while(0);_=c[I>>2]|0;X=c[Q>>2]|0;D=_;while(1){if((D|0)==(X|0)){bc=X;break}if((c[D>>2]|0)==(Y|0)){bc=D;break}else{D=D+4|0}}D=bc-_>>2;$=_+(D+1<<2)|0;ac=X-$|0;Kc(_+(D<<2)|0,$|0,ac|0)|0;$=_+((ac>>2)+D<<2)|0;D=c[Q>>2]|0;if(($|0)!=(D|0)){c[Q>>2]=D+(~((D-4+(-$|0)|0)>>>2)<<2)}J2(R);a9=af;ba=ae}else{x=0;F=98}}while(0);if((F|0)==98){I=bQ(-1,-1)|0;a5=K;a6=I;F=99}if((F|0)==99){a9=a6;ba=a5}fQ(s|0,c[s+4>>2]|0);N=a9;O=ba}else{x=0;F=27}}while(0);if((F|0)==27){F=bQ(-1,-1)|0;N=F;O=K}if((a[l]&1)==0){bd=N;bf=0;bg=bd;bh=O;be(bg|0)}J2(c[l+8>>2]|0);bd=N;bf=0;bg=bd;bh=O;be(bg|0);return 0}function hF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;e=i;i=i+112|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=d+32|0;if((a[o]&1)==0){p=j;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{o=c[d+40>>2]|0;p=c[d+36>>2]|0;if(p>>>0>4294967279>>>0){CJ(0);return 0}if(p>>>0<11>>>0){a[j]=p<<1;q=j+1|0}else{r=p+16&-16;s=J0(r)|0;c[j+8>>2]=s;c[j>>2]=r|1;c[j+4>>2]=p;q=s}Kb(q|0,o|0,p)|0;a[q+p|0]=0}p=c[d+44>>2]|0;q=b|0;o=(x=0,aK(c[(c[p>>2]|0)+20>>2]|0,p|0,q|0)|0);L12:do{if(!x){L14:do{if((c[o+32>>2]|0)==5){t=o}else{p=c[b+4>>2]|0;s=(x=0,as(230,60)|0);if(x){x=0;u=38;break L12}r=s;c[h>>2]=r;s=p+4|0;v=c[s>>2]|0;if((v|0)==(c[p+8>>2]|0)){x=0;aq(376,p|0,h|0);if(x){x=0;u=38;break L12}w=c[h>>2]|0}else{if((v|0)==0){y=0}else{c[v>>2]=r;y=c[s>>2]|0}c[s>>2]=y+4;w=r}r=w;v=w;z=o+4|0;L25:do{if((a[z]&1)==0){A=k;c[A>>2]=c[z>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];u=28}else{A=c[o+12>>2]|0;B=c[o+8>>2]|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(B>>>0<11>>>0){a[k]=B<<1;C=k+1|0}else{D=B+16&-16;E=(x=0,as(230,D|0)|0);if(x){x=0;break}c[k+8>>2]=E;c[k>>2]=D|1;c[k+4>>2]=B;C=E}Kb(C|0,A|0,B)|0;a[C+B|0]=0;u=28;break L25}}while(0);B=bQ(-1,-1)|0;F=B;G=K}}while(0);do{if((u|0)==28){z=o+16|0;B=g;c[B>>2]=c[z>>2];c[B+4>>2]=c[z+4>>2];c[B+8>>2]=c[z+8>>2];x=0;aB(34,v|0,k|0,g|0,1,1,0);if(x){x=0;z=bQ(-1,-1)|0;B=z;z=K;if((a[k]&1)==0){F=B;G=z;break}J2(c[k+8>>2]|0);F=B;G=z;break}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}z=w+36|0;B=z;c[f>>2]=o;A=z+8|0;E=A;D=c[E>>2]|0;if((D|0)==(c[z+12>>2]|0)){x=0;aq(370,z+4|0,f|0);if(x){x=0;u=38;break L12}H=c[f>>2]|0}else{if((D|0)==0){I=0}else{c[D>>2]=o;I=c[E>>2]|0}c[A>>2]=I+4;H=o}x=0;aq(c[c[z>>2]>>2]|0,B|0,H|0);if(!x){t=v;break L14}else{x=0;u=38;break L12}}}while(0);v=c[p>>2]|0;B=c[s>>2]|0;z=v;while(1){if((z|0)==(B|0)){J=B;break}if((c[z>>2]|0)==(w|0)){J=z;break}else{z=z+4|0}}z=J-v>>2;p=v+(z+1<<2)|0;A=B-p|0;Kc(v+(z<<2)|0,p|0,A|0)|0;p=v+((A>>2)+z<<2)|0;z=c[s>>2]|0;if((p|0)!=(z|0)){c[s>>2]=z+(~((z-4+(-p|0)|0)>>>2)<<2)}J2(r);L=F;M=G;break L12}}while(0);p=l+4|0;c[p>>2]=0;c[l+8>>2]=0;c[l>>2]=p;p=l+12|0;c[p>>2]=0;z=j;A=(a[z]&1)==0;do{if(A){E=m;c[E>>2]=c[z>>2];c[E+4>>2]=c[z+4>>2];c[E+8>>2]=c[z+8>>2];u=59}else{E=c[j+8>>2]|0;D=c[j+4>>2]|0;if(D>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;u=80;break}return 0}if(D>>>0<11>>>0){a[m]=D<<1;N=m+1|0}else{O=D+16&-16;P=(x=0,as(230,O|0)|0);if(x){x=0;u=80;break}c[m+8>>2]=P;c[m>>2]=O|1;c[m+4>>2]=D;N=P}Kb(N|0,E|0,D)|0;a[N+D|0]=0;u=59}}while(0);do{if((u|0)==59){D=(x=0,aK(88,l|0,m|0)|0);if(x){x=0;E=bQ(-1,-1)|0;P=E;E=K;if((a[m]&1)==0){Q=P;R=E;break}J2(c[m+8>>2]|0);Q=P;R=E;break}c[D>>2]=0;if((a[m]&1)!=0){J2(c[m+8>>2]|0)}D=b+8|0;c[p>>2]=c[D>>2];c[D>>2]=l;E=c[d+28>>2]|0;P=t+40|0;O=(c[t+44>>2]|0)-(c[P>>2]|0)>>2;S=n;T=E;U=n+8|0;V=j+8|0;W=j+4|0;X=n+1|0;Y=n|0;Z=n+4|0;_=0;while(1){if(_>>>0>=O>>>0){$=0;u=86;break}aa=c[(c[P>>2]|0)+(_<<2)>>2]|0;ab=c[D>>2]|0;if(A){c[S>>2]=c[z>>2];c[S+4>>2]=c[z+4>>2];c[S+8>>2]=c[z+8>>2]}else{ac=c[V>>2]|0;ad=c[W>>2]|0;if(ad>>>0>4294967279>>>0){u=67;break}if(ad>>>0<11>>>0){a[S]=ad<<1;ae=X}else{af=ad+16&-16;ag=(x=0,as(230,af|0)|0);if(x){x=0;u=79;break}c[U>>2]=ag;c[Y>>2]=af|1;c[Z>>2]=ad;ae=ag}Kb(ae|0,ac|0,ad)|0;a[ae+ad|0]=0}ad=(x=0,aK(88,ab|0,n|0)|0);if(x){x=0;u=84;break}c[ad>>2]=aa;if((a[S]&1)!=0){J2(c[U>>2]|0)}aa=(x=0,aK(c[(c[T>>2]|0)+20>>2]|0,E|0,q|0)|0);if(x){x=0;u=79;break}if((aa|0)==0){_=_+1|0}else{$=aa;u=86;break}}if((u|0)==67){x=0;ap(232,0);if(x){x=0;u=80;break}return 0}else if((u|0)==79){_=bQ(-1,-1)|0;ah=K;ai=_;u=81;break}else if((u|0)==84){_=bQ(-1,-1)|0;E=_;_=K;if((a[S]&1)==0){Q=E;R=_;break}J2(c[U>>2]|0);Q=E;R=_;break}else if((u|0)==86){c[D>>2]=c[p>>2];fQ(l|0,c[l+4>>2]|0);if(A){i=e;return $|0}J2(c[V>>2]|0);i=e;return $|0}}}while(0);if((u|0)==80){A=bQ(-1,-1)|0;ah=K;ai=A;u=81}if((u|0)==81){Q=ai;R=ah}fQ(l|0,c[l+4>>2]|0);L=Q;M=R}else{x=0;u=38}}while(0);if((u|0)==38){u=bQ(-1,-1)|0;L=u;M=K}if((a[j]&1)==0){aj=L;ak=0;al=aj;am=M;be(al|0)}J2(c[j+8>>2]|0);aj=L;ak=0;al=aj;am=M;be(al|0);return 0}function hG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=c[b+32>>2]|0;e=c[b+28>>2]|0;b=e;f=d|0;g=d;d=a|0;while(1){a=cS[c[(c[g>>2]|0)+20>>2]&1023](f,d)|0;if(!(cA[c[(c[a>>2]|0)+36>>2]&511](a)|0)){h=0;i=5;break}a=cS[c[(c[b>>2]|0)+20>>2]&1023](e,d)|0;if((a|0)!=0){h=a;i=6;break}}if((i|0)==5){return h|0}else if((i|0)==6){return h|0}return 0}function hH(a,b){a=a|0;b=b|0;var d=0;d=c[b+28>>2]|0;return cS[c[(c[d>>2]|0)+20>>2]&1023](d|0,a|0)|0}
function oU(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,at=0,au=0,av=0,aw=0,ax=0;k=i;i=i+40|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=n;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+144|0;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+12|0;i=i+7&-8;w=p;y=p;a[y]=12;z=w+1|0;a[z]=a[10240]|0;a[z+1|0]=a[10241]|0;a[z+2|0]=a[10242]|0;a[z+3|0]=a[10243]|0;a[z+4|0]=a[10244]|0;a[z+5|0]=a[10245]|0;a[w+7|0]=0;w=q;z=g;c[w>>2]=c[z>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];w=(x=0,ar(100,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;q=j;j=K;if((a[y]&1)==0){A=j;B=q;C=B;D=0;E=C;F=A;be(E|0)}J2(c[p+8>>2]|0);A=j;B=q;C=B;D=0;E=C;F=A;be(E|0)}if((a[y]&1)!=0){J2(c[p+8>>2]|0)}G=+h[w+40>>3];if(G>255.0){H=255.5}else{H=(G<0.0?0.0:G)+.5}G=+h[w+48>>3];if(G>255.0){I=255.5}else{I=(G<0.0?0.0:G)+.5}G=+h[w+56>>3];if(G>255.0){J=255.5}else{J=(G<0.0?0.0:G)+.5}G=+h[w+64>>3];if(G>1.0){L=255.5}else{L=(G<0.0?0.0:G*255.0)+.5}w=r+64|0;p=r|0;y=r+8|0;q=y|0;c[q>>2]=14576;j=r+12|0;c[p>>2]=31212;e=r+64|0;c[e>>2]=31232;c[r+4>>2]=0;x=0;aq(200,r+64|0,j|0);do{if(!x){c[r+136>>2]=0;c[r+140>>2]=-1;b=r+8|0;c[p>>2]=14556;c[w>>2]=14596;c[q>>2]=14576;g=j|0;c[g>>2]=14880;M=r+16|0;HA(M);Ke(r+20|0,0,24)|0;c[g>>2]=14736;N=r+44|0;Ke(r+44|0,0,16)|0;c[r+60>>2]=24;Ke(o|0,0,12)|0;x=0;aq(214,j|0,n|0);if(x){x=0;O=bQ(-1,-1)|0;P=K;if((a[o]&1)!=0){J2(c[n+8>>2]|0)}if((a[N]&1)!=0){J2(c[r+52>>2]|0)}c[g>>2]=14880;x=0;ap(388,M|0);if(!x){Q=O;R=P;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}if((a[o]&1)!=0){J2(c[n+8>>2]|0)}P=y;O=(x=0,aK(104,P|0,35)|0);do{if(!x){g=O;S=O;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;c[S+((c[(c[g>>2]|0)-12>>2]|0)+76)>>2]=48;g=y;S=y;T=S+((c[(c[g>>2]|0)-12>>2]|0)+4)|0;c[T>>2]=c[T>>2]&-75|8;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;T=~~+U(L);x=0,aK(310,P|0,T|0)|0;if(x){x=0;V=41;break}T=S+((c[(c[g>>2]|0)-12>>2]|0)+4)|0;c[T>>2]=c[T>>2]&-75|8;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;T=~~+U(H);x=0,aK(310,P|0,T|0)|0;if(x){x=0;V=41;break}T=S+((c[(c[g>>2]|0)-12>>2]|0)+4)|0;c[T>>2]=c[T>>2]&-75|8;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;T=~~+U(I);x=0,aK(310,P|0,T|0)|0;if(x){x=0;V=41;break}T=S+((c[(c[g>>2]|0)-12>>2]|0)+4)|0;c[T>>2]=c[T>>2]&-75|8;c[S+((c[(c[g>>2]|0)-12>>2]|0)+12)>>2]=2;g=~~+U(J);x=0,aK(310,P|0,g|0)|0;if(x){x=0;V=41;break}x=0;aq(560,s|0,j|0);if(x){x=0;V=41;break}g=s;S=a[g]|0;T=S&255;if((T&1|0)==0){W=T>>>1}else{W=c[s+4>>2]|0}L49:do{if((W|0)==0){V=45}else{T=(S&1)==0;X=s+1|0;Y=s+8|0;Z=0;while(1){_=(x=0,as(290,a[(T?X:c[Y>>2]|0)+Z|0]|0)|0);if(x){x=0;break}a[(T?X:c[Y>>2]|0)+Z|0]=_;_=Z+1|0;if(_>>>0<W>>>0){Z=_}else{V=45;break L49}}Z=bQ(-1,-1)|0;$=K;aa=Z;V=44}}while(0);L55:do{if((V|0)==45){Z=(x=0,as(230,52)|0);do{if(!x){Y=Z;c[m>>2]=Y;X=d+4|0;T=c[X>>2]|0;if((T|0)==(c[d+8>>2]|0)){x=0;aq(376,d|0,m|0);if(x){x=0;break}ab=c[m>>2]|0}else{if((T|0)==0){ac=0}else{c[T>>2]=Y;ac=c[X>>2]|0}c[X>>2]=ac+4;ab=Y}Y=ab;T=ab;_=f;L67:do{if((a[_]&1)==0){ad=t;c[ad>>2]=c[_>>2];c[ad+4>>2]=c[_+4>>2];c[ad+8>>2]=c[_+8>>2];V=62}else{ad=c[f+8>>2]|0;ae=c[f+4>>2]|0;do{if(ae>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ae>>>0<11>>>0){a[t]=ae<<1;af=t+1|0}else{ag=ae+16&-16;ah=(x=0,as(230,ag|0)|0);if(x){x=0;break}c[t+8>>2]=ah;c[t>>2]=ag|1;c[t+4>>2]=ae;af=ah}Kb(af|0,ad|0,ae)|0;a[af+ae|0]=0;V=62;break L67}}while(0);ae=bQ(-1,-1)|0;ai=K;aj=ae}}while(0);do{if((V|0)==62){_=u;c[_>>2]=c[z>>2];c[_+4>>2]=c[z+4>>2];c[_+8>>2]=c[z+8>>2];ae=(S&1)==0;L82:do{if(ae){ad=v;c[ad>>2]=c[g>>2];c[ad+4>>2]=c[g+4>>2];c[ad+8>>2]=c[g+8>>2];V=72}else{ad=c[s+8>>2]|0;ah=c[s+4>>2]|0;do{if(ah>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ah>>>0<11>>>0){a[v]=ah<<1;ak=v+1|0}else{ag=ah+16&-16;al=(x=0,as(230,ag|0)|0);if(x){x=0;break}c[v+8>>2]=al;c[v>>2]=ag|1;c[v+4>>2]=ah;ak=al}Kb(ak|0,ad|0,ah)|0;a[ak+ah|0]=0;V=72;break L82}}while(0);ah=bQ(-1,-1)|0;am=K;an=ah}}while(0);do{if((V|0)==72){ah=l;c[ah>>2]=c[_>>2];c[ah+4>>2]=c[_+4>>2];c[ah+8>>2]=c[_+8>>2];x=0;ao(26,T|0,t|0,l|0,v|0,0);if(x){x=0;ah=bQ(-1,-1)|0;ad=ah;ah=K;if((a[v]&1)==0){am=ah;an=ad;break}J2(c[v+8>>2]|0);am=ah;an=ad;break}if((a[v]&1)!=0){J2(c[v+8>>2]|0)}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}if(!ae){J2(c[s+8>>2]|0)}c[p>>2]=14556;c[e>>2]=14596;c[b>>2]=14576;ad=r+12|0;c[ad>>2]=14736;if((a[N]&1)!=0){J2(c[r+52>>2]|0)}c[ad>>2]=14880;x=0;ap(388,M|0);if(!x){C7(r+64|0);i=k;return ab|0}else{x=0}ad=bQ(-1,-1)|0;x=0;ap(268,r+64|0);if(!x){be(ad|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);if((a[t]&1)==0){ai=am;aj=an;break}J2(c[t+8>>2]|0);ai=am;aj=an}}while(0);T=c[d>>2]|0;ae=c[X>>2]|0;_=T;while(1){if((_|0)==(ae|0)){at=ae;break}if((c[_>>2]|0)==(ab|0)){at=_;break}else{_=_+4|0}}_=at-T>>2;ad=T+(_+1<<2)|0;ah=ae-ad|0;Kc(T+(_<<2)|0,ad|0,ah|0)|0;ad=T+((ah>>2)+_<<2)|0;_=c[X>>2]|0;if((ad|0)!=(_|0)){c[X>>2]=_+(~((_-4+(-ad|0)|0)>>>2)<<2)}J2(Y);au=ai;av=aj;break L55}else{x=0}}while(0);Z=bQ(-1,-1)|0;$=K;aa=Z;V=44}}while(0);if((V|0)==44){au=$;av=aa}if((S&1)==0){aw=au;ax=av;break}J2(c[s+8>>2]|0);aw=au;ax=av}else{x=0;V=41}}while(0);if((V|0)==41){P=bQ(-1,-1)|0;aw=K;ax=P}c[p>>2]=14556;c[e>>2]=14596;c[b>>2]=14576;P=r+12|0;c[P>>2]=14736;if((a[N]&1)!=0){J2(c[r+52>>2]|0)}c[P>>2]=14880;x=0;ap(388,M|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,r+64|0);if(!x){bU();return 0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}x=0;ap(268,r+64|0);if(!x){A=aw;B=ax;C=B;D=0;E=C;F=A;be(E|0)}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{x=0;P=bQ(-1,-1)|0;Q=P;R=K}}while(0);x=0;ap(268,w|0);if(!x){be(Q|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function oV(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=i;i=i+128|0;e=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];e=h|0;j=h+16|0;k=h+24|0;l=h+32|0;m=h+48|0;n=h+64|0;o=h+80|0;p=h+96|0;q=h+112|0;Ac(k,0);r=l;a[r]=14;s=l+1|0;a[s]=a[3184]|0;a[s+1|0]=a[3185]|0;a[s+2|0]=a[3186]|0;a[s+3|0]=a[3187]|0;a[s+4|0]=a[3188]|0;a[s+5|0]=a[3189]|0;a[s+6|0]=a[3190]|0;s=l+8|0;a[s]=0;t=(x=0,aK(88,b|0,l|0)|0);do{if(!x){l=c[t>>2]|0;if((a[r]&1)!=0){J2(c[s>>2]|0)}x=0;aP(c[(c[l>>2]|0)+28>>2]|0,n|0,l|0,k|0);if(x){x=0;l=bQ(-1,-1)|0;u=l;v=K;break}x=0;aq(180,m|0,n|0);if(x){x=0;l=bQ(-1,-1)|0;b=l;l=K;if((a[n]&1)==0){u=b;v=l;break}J2(c[n+8>>2]|0);u=b;v=l;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}l=(x=0,as(230,52)|0);do{if(!x){b=l;c[j>>2]=b;w=d+4|0;y=c[w>>2]|0;if((y|0)==(c[d+8>>2]|0)){x=0;aq(376,d|0,j|0);if(x){x=0;z=47;break}A=c[j>>2]|0}else{if((y|0)==0){B=0}else{c[y>>2]=b;B=c[w>>2]|0}c[w>>2]=B+4;A=b}b=A;y=A;C=f;L26:do{if((a[C]&1)==0){D=o;c[D>>2]=c[C>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];z=25}else{D=c[f+8>>2]|0;E=c[f+4>>2]|0;do{if(E>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(E>>>0<11>>>0){a[o]=E<<1;F=o+1|0}else{G=E+16&-16;H=(x=0,as(230,G|0)|0);if(x){x=0;break}c[o+8>>2]=H;c[o>>2]=G|1;c[o+4>>2]=E;F=H}Kb(F|0,D|0,E)|0;a[F+E|0]=0;z=25;break L26}}while(0);E=bQ(-1,-1)|0;I=E;J=K}}while(0);do{if((z|0)==25){C=p;E=g;c[C>>2]=c[E>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];E=m;L41:do{if((a[E]&1)==0){D=q;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];z=35}else{D=c[m+8>>2]|0;H=c[m+4>>2]|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(H>>>0<11>>>0){a[q]=H<<1;L=q+1|0}else{G=H+16&-16;M=(x=0,as(230,G|0)|0);if(x){x=0;break}c[q+8>>2]=M;c[q>>2]=G|1;c[q+4>>2]=H;L=M}Kb(L|0,D|0,H)|0;a[L+H|0]=0;z=35;break L41}}while(0);H=bQ(-1,-1)|0;N=H;O=K}}while(0);do{if((z|0)==35){H=e;c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];x=0;ao(26,y|0,o|0,e|0,q|0,0);if(x){x=0;H=bQ(-1,-1)|0;D=H;H=K;if((a[q]&1)==0){N=D;O=H;break}J2(c[q+8>>2]|0);N=D;O=H;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}H=A;a[A+28|0]=1;if((a[E]&1)==0){Ae(k);i=h;return H|0}J2(c[m+8>>2]|0);Ae(k);i=h;return H|0}}while(0);if((a[o]&1)==0){I=N;J=O;break}J2(c[o+8>>2]|0);I=N;J=O}}while(0);y=c[d>>2]|0;E=c[w>>2]|0;C=y;while(1){if((C|0)==(E|0)){P=E;break}if((c[C>>2]|0)==(A|0)){P=C;break}else{C=C+4|0}}C=P-y>>2;H=y+(C+1<<2)|0;D=E-H|0;Kc(y+(C<<2)|0,H|0,D|0)|0;H=y+((D>>2)+C<<2)|0;C=c[w>>2]|0;if((H|0)!=(C|0)){c[w>>2]=C+(~((C-4+(-H|0)|0)>>>2)<<2)}J2(b);Q=I;R=J}else{x=0;z=47}}while(0);if((z|0)==47){l=bQ(-1,-1)|0;Q=l;R=K}if((a[m]&1)==0){u=Q;v=R;break}J2(c[m+8>>2]|0);u=Q;v=R}else{x=0;l=bQ(-1,-1)|0;H=l;l=K;if((a[r]&1)==0){u=H;v=l;break}J2(c[s>>2]|0);u=H;v=l}}while(0);x=0;ap(436,k|0);if(!x){be(u|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function oW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=i;i=i+128|0;e=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];e=h|0;j=h+16|0;k=h+24|0;l=h+32|0;m=h+48|0;n=h+64|0;o=h+80|0;p=h+96|0;q=h+112|0;Ac(k,0);r=l;a[r]=14;s=l+1|0;a[s]=a[3184]|0;a[s+1|0]=a[3185]|0;a[s+2|0]=a[3186]|0;a[s+3|0]=a[3187]|0;a[s+4|0]=a[3188]|0;a[s+5|0]=a[3189]|0;a[s+6|0]=a[3190]|0;s=l+8|0;a[s]=0;t=(x=0,aK(88,b|0,l|0)|0);do{if(!x){l=c[t>>2]|0;if((a[r]&1)!=0){J2(c[s>>2]|0)}x=0;aP(c[(c[l>>2]|0)+28>>2]|0,n|0,l|0,k|0);if(x){x=0;l=bQ(-1,-1)|0;u=l;v=K;break}x=0;aP(266,m|0,n|0,34);if(x){x=0;l=bQ(-1,-1)|0;b=l;l=K;if((a[n]&1)==0){u=b;v=l;break}J2(c[n+8>>2]|0);u=b;v=l;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}l=(x=0,as(230,52)|0);do{if(!x){b=l;c[j>>2]=b;w=d+4|0;y=c[w>>2]|0;if((y|0)==(c[d+8>>2]|0)){x=0;aq(376,d|0,j|0);if(x){x=0;z=47;break}A=c[j>>2]|0}else{if((y|0)==0){B=0}else{c[y>>2]=b;B=c[w>>2]|0}c[w>>2]=B+4;A=b}b=A;y=A;C=f;L28:do{if((a[C]&1)==0){D=o;c[D>>2]=c[C>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];z=25}else{D=c[f+8>>2]|0;E=c[f+4>>2]|0;do{if(E>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(E>>>0<11>>>0){a[o]=E<<1;F=o+1|0}else{G=E+16&-16;H=(x=0,as(230,G|0)|0);if(x){x=0;break}c[o+8>>2]=H;c[o>>2]=G|1;c[o+4>>2]=E;F=H}Kb(F|0,D|0,E)|0;a[F+E|0]=0;z=25;break L28}}while(0);E=bQ(-1,-1)|0;I=E;J=K}}while(0);do{if((z|0)==25){C=p;E=g;c[C>>2]=c[E>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];E=m;L43:do{if((a[E]&1)==0){D=q;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];z=35}else{D=c[m+8>>2]|0;H=c[m+4>>2]|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(H>>>0<11>>>0){a[q]=H<<1;L=q+1|0}else{G=H+16&-16;M=(x=0,as(230,G|0)|0);if(x){x=0;break}c[q+8>>2]=M;c[q>>2]=G|1;c[q+4>>2]=H;L=M}Kb(L|0,D|0,H)|0;a[L+H|0]=0;z=35;break L43}}while(0);H=bQ(-1,-1)|0;N=H;O=K}}while(0);do{if((z|0)==35){H=e;c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];x=0;ao(26,y|0,o|0,e|0,q|0,0);if(x){x=0;H=bQ(-1,-1)|0;D=H;H=K;if((a[q]&1)==0){N=D;O=H;break}J2(c[q+8>>2]|0);N=D;O=H;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}H=A;a[A+28|0]=1;if((a[E]&1)==0){Ae(k);i=h;return H|0}J2(c[m+8>>2]|0);Ae(k);i=h;return H|0}}while(0);if((a[o]&1)==0){I=N;J=O;break}J2(c[o+8>>2]|0);I=N;J=O}}while(0);y=c[d>>2]|0;E=c[w>>2]|0;C=y;while(1){if((C|0)==(E|0)){P=E;break}if((c[C>>2]|0)==(A|0)){P=C;break}else{C=C+4|0}}C=P-y>>2;H=y+(C+1<<2)|0;D=E-H|0;Kc(y+(C<<2)|0,H|0,D|0)|0;H=y+((D>>2)+C<<2)|0;C=c[w>>2]|0;if((H|0)!=(C|0)){c[w>>2]=C+(~((C-4+(-H|0)|0)>>>2)<<2)}J2(b);Q=I;R=J}else{x=0;z=47}}while(0);if((z|0)==47){l=bQ(-1,-1)|0;Q=l;R=K}if((a[m]&1)==0){u=Q;v=R;break}J2(c[m+8>>2]|0);u=Q;v=R}else{x=0;l=bQ(-1,-1)|0;H=l;l=K;if((a[r]&1)==0){u=H;v=l;break}J2(c[s>>2]|0);u=H;v=l}}while(0);x=0;ap(436,k|0);if(!x){be(u|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function oX(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0.0,ag=0;k=i;i=i+168|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+24|0;o=k+40|0;p=k+56|0;q=k+72|0;r=k+88|0;s=k+104|0;t=k+120|0;u=k+136|0;v=k+152|0;w=n;y=n;a[y]=12;z=w+1|0;a[z]=a[2776]|0;a[z+1|0]=a[2777]|0;a[z+2|0]=a[2778]|0;a[z+3|0]=a[2779]|0;a[z+4|0]=a[2780]|0;a[z+5|0]=a[2781]|0;a[w+7|0]=0;w=o;z=g;c[w>>2]=c[z>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];w=(x=0,ar(40,n|0,b|0,e|0,f|0,o|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;o=j;j=K;if((a[y]&1)==0){A=j;B=o;C=B;D=0;E=C;F=A;be(E|0)}J2(c[n+8>>2]|0);A=j;B=o;C=B;D=0;E=C;F=A;be(E|0)}if((a[y]&1)!=0){J2(c[n+8>>2]|0)}if((c[w+48>>2]|0)==(c[w+52>>2]|0)){if((c[w+60>>2]|0)!=(c[w+64>>2]|0)){G=6}}else{G=6}L13:do{if((G|0)==6){n=Kf(e|0)|0;if(n>>>0>4294967279>>>0){CJ(0);return 0}if(n>>>0<11>>>0){y=n<<1&255;o=r;j=r;a[j]=y;H=o+1|0;I=y;J=o;L=j}else{j=n+16&-16;o=J0(j)|0;c[r+8>>2]=o;y=j|1;c[r>>2]=y;c[r+4>>2]=n;H=o;I=y&255;J=r;L=r}Kb(H|0,e|0,n)|0;a[H+n|0]=0;n=q;Ke(n|0,0,12)|0;y=I&255;if((y&1|0)==0){M=y>>>1}else{M=c[r+4>>2]|0}y=M+20|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=25;break}return 0}else{if(y>>>0<11>>>0){a[n]=40;N=q+1|0}else{o=M+36&-16;j=(x=0,as(230,o|0)|0);if(x){x=0;G=25;break}c[q+8>>2]=j;c[q>>2]=o|1;c[q+4>>2]=20;N=j}Kb(N|0,2608,20)|0;a[N+20|0]=0;if((I&1)==0){O=J+1|0}else{O=c[r+8>>2]|0}x=0,ax(64,q|0,O|0,M|0)|0;if(x){x=0;G=25;break}j=p;Ke(j|0,0,12)|0;o=a[n]|0;b=o&255;if((b&1|0)==0){P=b>>>1}else{P=c[q+4>>2]|0}if((o&1)==0){Q=q+1|0}else{Q=c[q+8>>2]|0}o=P+18|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=41;break}return 0}else{if(o>>>0<11>>>0){a[j]=P<<1;R=p+1|0}else{b=P+34&-16;g=(x=0,as(230,b|0)|0);if(x){x=0;G=41;break}c[p+8>>2]=g;c[p>>2]=b|1;c[p+4>>2]=P;R=g}Kb(R|0,Q|0,P)|0;a[R+P|0]=0;x=0,ax(64,p|0,2480,18)|0;if(x){x=0;G=41;break}g=f;L56:do{if((a[g]&1)==0){b=s;c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];G=53}else{b=c[f+8>>2]|0;S=c[f+4>>2]|0;do{if(S>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(S>>>0<11>>>0){a[s]=S<<1;T=s+1|0}else{U=S+16&-16;V=(x=0,as(230,U|0)|0);if(x){x=0;break}c[s+8>>2]=V;c[s>>2]=U|1;c[s+4>>2]=S;T=V}Kb(T|0,b|0,S)|0;a[T+S|0]=0;G=53;break L56}}while(0);S=bQ(-1,-1)|0;W=K;X=S}}while(0);do{if((G|0)==53){g=t;c[g>>2]=c[z>>2];c[g+4>>2]=c[z+4>>2];c[g+8>>2]=c[z+8>>2];x=0;aP(362,p|0,s|0,t|0);if(x){x=0;g=bQ(-1,-1)|0;S=g;g=K;if((a[s]&1)==0){W=g;X=S;break}J2(c[s+8>>2]|0);W=g;X=S;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}if((a[j]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)!=0){J2(c[q+8>>2]|0)}if((a[L]&1)==0){break L13}J2(c[r+8>>2]|0);break L13}}while(0);if((a[j]&1)==0){Y=W;Z=X;break}J2(c[p+8>>2]|0);Y=W;Z=X}}while(0);if((G|0)==41){o=bQ(-1,-1)|0;S=K;if((a[j]&1)!=0){J2(c[p+8>>2]|0)}Y=S;Z=o}if((a[n]&1)==0){_=Y;$=Z;break}J2(c[q+8>>2]|0);_=Y;$=Z}}while(0);if((G|0)==25){y=bQ(-1,-1)|0;o=K;if((a[n]&1)!=0){J2(c[q+8>>2]|0)}_=o;$=y}if((a[L]&1)==0){A=_;B=$;C=B;D=0;E=C;F=A;be(E|0)}J2(c[r+8>>2]|0);A=_;B=$;C=B;D=0;E=C;F=A;be(E|0)}}while(0);$=J0(72)|0;c[m>>2]=$;_=d+4|0;r=c[_>>2]|0;if((r|0)==(c[d+8>>2]|0)){ee(d|0,m);aa=c[m>>2]|0}else{if((r|0)==0){ab=0}else{c[r>>2]=$;ab=c[_>>2]|0}c[_>>2]=ab+4;aa=$}$=aa;ab=aa;r=f;L114:do{if((a[r]&1)==0){m=u;c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];G=90}else{m=c[f+8>>2]|0;L=c[f+4>>2]|0;do{if(L>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(L>>>0<11>>>0){a[u]=L<<1;ac=u+1|0}else{q=L+16&-16;Z=(x=0,as(230,q|0)|0);if(x){x=0;break}c[u+8>>2]=Z;c[u>>2]=q|1;c[u+4>>2]=L;ac=Z}Kb(ac|0,m|0,L)|0;a[ac+L|0]=0;G=90;break L114}}while(0);L=bQ(-1,-1)|0;ad=K;ae=L}}while(0);do{if((G|0)==90){ac=l;c[ac>>2]=c[z>>2];c[ac+4>>2]=c[z+4>>2];c[ac+8>>2]=c[z+8>>2];af=+h[w+40>>3]*100.0;ac=v;f=v;a[f]=2;a[ac+1|0]=37;a[ac+2|0]=0;x=0;aE(2,ab|0,u|0,l|0,+af,v|0);if(x){x=0;ac=bQ(-1,-1)|0;r=ac;ac=K;if((a[f]&1)!=0){J2(c[v+8>>2]|0)}if((a[u]&1)==0){ad=ac;ae=r;break}J2(c[u+8>>2]|0);ad=ac;ae=r;break}r=aa;if((a[f]&1)!=0){J2(c[v+8>>2]|0)}if((a[u]&1)==0){i=k;return r|0}J2(c[u+8>>2]|0);i=k;return r|0}}while(0);k=c[d>>2]|0;d=c[_>>2]|0;u=k;while(1){if((u|0)==(d|0)){ag=d;break}if((c[u>>2]|0)==(aa|0)){ag=u;break}else{u=u+4|0}}u=ag-k>>2;ag=k+(u+1<<2)|0;aa=d-ag|0;Kc(k+(u<<2)|0,ag|0,aa|0)|0;ag=k+((aa>>2)+u<<2)|0;u=c[_>>2]|0;if((ag|0)!=(u|0)){c[_>>2]=u+(~((u-4+(-ag|0)|0)>>>2)<<2)}J2($);A=ad;B=ae;C=B;D=0;E=C;F=A;be(E|0);return 0}function oY(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0.0,N=0.0,O=0.0,P=0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=m;r=m;a[r]=12;s=q+1|0;a[s]=a[2776]|0;a[s+1|0]=a[2777]|0;a[s+2|0]=a[2778]|0;a[s+3|0]=a[2779]|0;a[s+4|0]=a[2780]|0;a[s+5|0]=a[2781]|0;a[q+7|0]=0;q=n;s=g;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];q=(x=0,ar(40,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;n=j;j=K;if((a[r]&1)==0){t=n;u=j;v=t;w=0;y=v;z=u;be(y|0)}J2(c[m+8>>2]|0);t=n;u=j;v=t;w=0;y=v;z=u;be(y|0)}if((a[r]&1)!=0){J2(c[m+8>>2]|0)}m=J0(72)|0;c[l>>2]=m;r=d+4|0;j=c[r>>2]|0;if((j|0)==(c[d+8>>2]|0)){ee(d|0,l);A=c[l>>2]|0}else{if((j|0)==0){B=0}else{c[j>>2]=m;B=c[r>>2]|0}c[r>>2]=B+4;A=m}m=A;x=0;aq(550,A|0,q|0);if(x){x=0;q=bQ(-1,-1)|0;B=q;q=K;j=c[d>>2]|0;d=c[r>>2]|0;l=j;while(1){if((l|0)==(d|0)){C=d;break}if((c[l>>2]|0)==(A|0)){C=l;break}else{l=l+4|0}}l=C-j>>2;C=j+(l+1<<2)|0;n=d-C|0;Kc(j+(l<<2)|0,C|0,n|0)|0;C=j+((n>>2)+l<<2)|0;l=c[r>>2]|0;if((C|0)!=(l|0)){c[r>>2]=l+(~((l-4+(-C|0)|0)>>>2)<<2)}J2(m);t=B;u=q;v=t;w=0;y=v;z=u;be(y|0)}q=f;if((a[q]&1)==0){B=p;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2]}else{q=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){CJ(0);return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{f=B+16&-16;m=J0(f)|0;c[p+8>>2]=m;c[p>>2]=f|1;c[p+4>>2]=B;D=m}Kb(D|0,q|0,B)|0;a[D+B|0]=0}B=(x=0,aK(346,A+4|0,p|0)|0);do{if(!x){D=B;if((a[D]&1)==0){q=o;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];E=a[q]|0}else{q=c[B+8>>2]|0;D=c[B+4>>2]|0;if(D>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(D>>>0<11>>>0){m=D<<1&255;a[o]=m;F=o+1|0;G=m}else{m=D+16&-16;f=(x=0,as(230,m|0)|0);if(x){x=0;break}c[o+8>>2]=f;C=m|1;c[o>>2]=C;c[o+4>>2]=D;F=f;G=C&255}Kb(F|0,q|0,D)|0;a[F+D|0]=0;E=G}if((E&1)!=0){J2(c[o+8>>2]|0)}if((a[p]&1)==0){H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;L=J;M=+h[L>>3];N=M+.5;O=+U(N);h[L>>3]=O;P=A;i=k;return P|0}J2(c[p+8>>2]|0);H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;L=J;M=+h[L>>3];N=M+.5;O=+U(N);h[L>>3]=O;P=A;i=k;return P|0}else{x=0}}while(0);P=bQ(-1,-1)|0;k=P;P=K;if((a[p]&1)==0){t=k;u=P;v=t;w=0;y=v;z=u;be(y|0)}J2(c[p+8>>2]|0);t=k;u=P;v=t;w=0;y=v;z=u;be(y|0);return 0}function oZ(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0.0,N=0.0,O=0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=m;r=m;a[r]=12;s=q+1|0;a[s]=a[2776]|0;a[s+1|0]=a[2777]|0;a[s+2|0]=a[2778]|0;a[s+3|0]=a[2779]|0;a[s+4|0]=a[2780]|0;a[s+5|0]=a[2781]|0;a[q+7|0]=0;q=n;s=g;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];q=(x=0,ar(40,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;n=j;j=K;if((a[r]&1)==0){t=n;u=j;v=t;w=0;y=v;z=u;be(y|0)}J2(c[m+8>>2]|0);t=n;u=j;v=t;w=0;y=v;z=u;be(y|0)}if((a[r]&1)!=0){J2(c[m+8>>2]|0)}m=J0(72)|0;c[l>>2]=m;r=d+4|0;j=c[r>>2]|0;if((j|0)==(c[d+8>>2]|0)){ee(d|0,l);A=c[l>>2]|0}else{if((j|0)==0){B=0}else{c[j>>2]=m;B=c[r>>2]|0}c[r>>2]=B+4;A=m}m=A;x=0;aq(550,A|0,q|0);if(x){x=0;q=bQ(-1,-1)|0;B=q;q=K;j=c[d>>2]|0;d=c[r>>2]|0;l=j;while(1){if((l|0)==(d|0)){C=d;break}if((c[l>>2]|0)==(A|0)){C=l;break}else{l=l+4|0}}l=C-j>>2;C=j+(l+1<<2)|0;n=d-C|0;Kc(j+(l<<2)|0,C|0,n|0)|0;C=j+((n>>2)+l<<2)|0;l=c[r>>2]|0;if((C|0)!=(l|0)){c[r>>2]=l+(~((l-4+(-C|0)|0)>>>2)<<2)}J2(m);t=B;u=q;v=t;w=0;y=v;z=u;be(y|0)}q=f;if((a[q]&1)==0){B=p;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2]}else{q=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){CJ(0);return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{f=B+16&-16;m=J0(f)|0;c[p+8>>2]=m;c[p>>2]=f|1;c[p+4>>2]=B;D=m}Kb(D|0,q|0,B)|0;a[D+B|0]=0}B=(x=0,aK(346,A+4|0,p|0)|0);do{if(!x){D=B;if((a[D]&1)==0){q=o;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];E=a[q]|0}else{q=c[B+8>>2]|0;D=c[B+4>>2]|0;if(D>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(D>>>0<11>>>0){m=D<<1&255;a[o]=m;F=o+1|0;G=m}else{m=D+16&-16;f=(x=0,as(230,m|0)|0);if(x){x=0;break}c[o+8>>2]=f;C=m|1;c[o>>2]=C;c[o+4>>2]=D;F=f;G=C&255}Kb(F|0,q|0,D)|0;a[F+D|0]=0;E=G}if((E&1)!=0){J2(c[o+8>>2]|0)}if((a[p]&1)==0){H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;L=J;M=+h[L>>3];N=+af(M);h[L>>3]=N;O=A;i=k;return O|0}J2(c[p+8>>2]|0);H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;L=J;M=+h[L>>3];N=+af(M);h[L>>3]=N;O=A;i=k;return O|0}else{x=0}}while(0);O=bQ(-1,-1)|0;k=O;O=K;if((a[p]&1)==0){t=k;u=O;v=t;w=0;y=v;z=u;be(y|0)}J2(c[p+8>>2]|0);t=k;u=O;v=t;w=0;y=v;z=u;be(y|0);return 0}function o_(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0.0,N=0.0,O=0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=m;r=m;a[r]=12;s=q+1|0;a[s]=a[2776]|0;a[s+1|0]=a[2777]|0;a[s+2|0]=a[2778]|0;a[s+3|0]=a[2779]|0;a[s+4|0]=a[2780]|0;a[s+5|0]=a[2781]|0;a[q+7|0]=0;q=n;s=g;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];q=(x=0,ar(40,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;n=j;j=K;if((a[r]&1)==0){t=n;u=j;v=t;w=0;y=v;z=u;be(y|0)}J2(c[m+8>>2]|0);t=n;u=j;v=t;w=0;y=v;z=u;be(y|0)}if((a[r]&1)!=0){J2(c[m+8>>2]|0)}m=J0(72)|0;c[l>>2]=m;r=d+4|0;j=c[r>>2]|0;if((j|0)==(c[d+8>>2]|0)){ee(d|0,l);A=c[l>>2]|0}else{if((j|0)==0){B=0}else{c[j>>2]=m;B=c[r>>2]|0}c[r>>2]=B+4;A=m}m=A;x=0;aq(550,A|0,q|0);if(x){x=0;q=bQ(-1,-1)|0;B=q;q=K;j=c[d>>2]|0;d=c[r>>2]|0;l=j;while(1){if((l|0)==(d|0)){C=d;break}if((c[l>>2]|0)==(A|0)){C=l;break}else{l=l+4|0}}l=C-j>>2;C=j+(l+1<<2)|0;n=d-C|0;Kc(j+(l<<2)|0,C|0,n|0)|0;C=j+((n>>2)+l<<2)|0;l=c[r>>2]|0;if((C|0)!=(l|0)){c[r>>2]=l+(~((l-4+(-C|0)|0)>>>2)<<2)}J2(m);t=B;u=q;v=t;w=0;y=v;z=u;be(y|0)}q=f;if((a[q]&1)==0){B=p;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2]}else{q=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){CJ(0);return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{f=B+16&-16;m=J0(f)|0;c[p+8>>2]=m;c[p>>2]=f|1;c[p+4>>2]=B;D=m}Kb(D|0,q|0,B)|0;a[D+B|0]=0}B=(x=0,aK(346,A+4|0,p|0)|0);do{if(!x){D=B;if((a[D]&1)==0){q=o;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];E=a[q]|0}else{q=c[B+8>>2]|0;D=c[B+4>>2]|0;if(D>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(D>>>0<11>>>0){m=D<<1&255;a[o]=m;F=o+1|0;G=m}else{m=D+16&-16;f=(x=0,as(230,m|0)|0);if(x){x=0;break}c[o+8>>2]=f;C=m|1;c[o>>2]=C;c[o+4>>2]=D;F=f;G=C&255}Kb(F|0,q|0,D)|0;a[F+D|0]=0;E=G}if((E&1)!=0){J2(c[o+8>>2]|0)}if((a[p]&1)==0){H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;L=J;M=+h[L>>3];N=+U(M);h[L>>3]=N;O=A;i=k;return O|0}J2(c[p+8>>2]|0);H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;L=J;M=+h[L>>3];N=+U(M);h[L>>3]=N;O=A;i=k;return O|0}else{x=0}}while(0);O=bQ(-1,-1)|0;k=O;O=K;if((a[p]&1)==0){t=k;u=O;v=t;w=0;y=v;z=u;be(y|0)}J2(c[p+8>>2]|0);t=k;u=O;v=t;w=0;y=v;z=u;be(y|0);return 0}function o$(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0.0,N=0.0,O=0;k=i;i=i+72|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+40|0;p=k+56|0;q=m;r=m;a[r]=12;s=q+1|0;a[s]=a[2776]|0;a[s+1|0]=a[2777]|0;a[s+2|0]=a[2778]|0;a[s+3|0]=a[2779]|0;a[s+4|0]=a[2780]|0;a[s+5|0]=a[2781]|0;a[q+7|0]=0;q=n;s=g;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];q=(x=0,ar(40,m|0,b|0,e|0,f|0,n|0,j|0)|0);if(x){x=0;j=bQ(-1,-1)|0;n=j;j=K;if((a[r]&1)==0){t=n;u=j;v=t;w=0;y=v;z=u;be(y|0)}J2(c[m+8>>2]|0);t=n;u=j;v=t;w=0;y=v;z=u;be(y|0)}if((a[r]&1)!=0){J2(c[m+8>>2]|0)}m=J0(72)|0;c[l>>2]=m;r=d+4|0;j=c[r>>2]|0;if((j|0)==(c[d+8>>2]|0)){ee(d|0,l);A=c[l>>2]|0}else{if((j|0)==0){B=0}else{c[j>>2]=m;B=c[r>>2]|0}c[r>>2]=B+4;A=m}m=A;x=0;aq(550,A|0,q|0);if(x){x=0;q=bQ(-1,-1)|0;B=q;q=K;j=c[d>>2]|0;d=c[r>>2]|0;l=j;while(1){if((l|0)==(d|0)){C=d;break}if((c[l>>2]|0)==(A|0)){C=l;break}else{l=l+4|0}}l=C-j>>2;C=j+(l+1<<2)|0;n=d-C|0;Kc(j+(l<<2)|0,C|0,n|0)|0;C=j+((n>>2)+l<<2)|0;l=c[r>>2]|0;if((C|0)!=(l|0)){c[r>>2]=l+(~((l-4+(-C|0)|0)>>>2)<<2)}J2(m);t=B;u=q;v=t;w=0;y=v;z=u;be(y|0)}q=f;if((a[q]&1)==0){B=p;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2]}else{q=c[f+8>>2]|0;B=c[f+4>>2]|0;if(B>>>0>4294967279>>>0){CJ(0);return 0}if(B>>>0<11>>>0){a[p]=B<<1;D=p+1|0}else{f=B+16&-16;m=J0(f)|0;c[p+8>>2]=m;c[p>>2]=f|1;c[p+4>>2]=B;D=m}Kb(D|0,q|0,B)|0;a[D+B|0]=0}B=(x=0,aK(346,A+4|0,p|0)|0);do{if(!x){D=B;if((a[D]&1)==0){q=o;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];E=a[q]|0}else{q=c[B+8>>2]|0;D=c[B+4>>2]|0;if(D>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(D>>>0<11>>>0){m=D<<1&255;a[o]=m;F=o+1|0;G=m}else{m=D+16&-16;f=(x=0,as(230,m|0)|0);if(x){x=0;break}c[o+8>>2]=f;C=m|1;c[o>>2]=C;c[o+4>>2]=D;F=f;G=C&255}Kb(F|0,q|0,D)|0;a[F+D|0]=0;E=G}if((E&1)!=0){J2(c[o+8>>2]|0)}if((a[p]&1)==0){H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;L=J;M=+h[L>>3];N=+V(+M);h[L>>3]=N;O=A;i=k;return O|0}J2(c[p+8>>2]|0);H=A+16|0;I=H;c[I>>2]=c[s>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];J=A+40|0;L=J;M=+h[L>>3];N=+V(+M);h[L>>3]=N;O=A;i=k;return O|0}else{x=0}}while(0);O=bQ(-1,-1)|0;k=O;O=K;if((a[p]&1)==0){t=k;u=O;v=t;w=0;y=v;z=u;be(y|0)}J2(c[p+8>>2]|0);t=k;u=O;v=t;w=0;y=v;z=u;be(y|0);return 0}function o0(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,aq=0,at=0,au=0,av=0;j=i;i=i+144|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=j+96|0;r=j+112|0;s=j+128|0;t=k;a[t]=6;u=k+1|0;a[u]=a[1864]|0;a[u+1|0]=a[1865]|0;a[u+2|0]=a[1866]|0;a[k+4|0]=0;u=l;v=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];u=(x=0,ar(40,k|0,b|0,e|0,f|0,l|0,h|0)|0);if(x){x=0;l=bQ(-1,-1)|0;g=l;l=K;if((a[t]&1)==0){w=g;y=l;z=w;A=0;B=z;C=y;be(B|0)}J2(c[k+8>>2]|0);w=g;y=l;z=w;A=0;B=z;C=y;be(B|0)}if((a[t]&1)!=0){J2(c[k+8>>2]|0)}k=m;a[k]=6;t=m+1|0;a[t]=a[1800]|0;a[t+1|0]=a[1801]|0;a[t+2|0]=a[1802]|0;a[m+4|0]=0;t=n;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];t=(x=0,ar(50,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(x){x=0;h=bQ(-1,-1)|0;n=h;h=K;if((a[k]&1)==0){w=n;y=h;z=w;A=0;B=z;C=y;be(B|0)}J2(c[m+8>>2]|0);w=n;y=h;z=w;A=0;B=z;C=y;be(B|0)}if((a[k]&1)!=0){J2(c[m+8>>2]|0)}m=t+40|0;k=c[m>>2]|0;h=(c[t+44>>2]|0)-k>>2;if((h|0)==0){D=u;E=D|0;i=j;return E|0}t=q;n=q+1|0;b=p;l=p+1|0;g=o;F=o+1|0;G=f;H=r;I=s;J=q+8|0;L=p+8|0;M=o+8|0;N=r+8|0;O=f+8|0;P=f+4|0;f=r+1|0;Q=r|0;R=r+4|0;S=o|0;T=o+4|0;U=p+4|0;V=p|0;W=q+4|0;X=q|0;q=u;u=0;Y=k;L24:while(1){k=c[Y+(u<<2)>>2]|0;if((k|0)==0){Z=15}else{_=JP(k,31088,30096,-1)|0;if((_|0)==0){Z=15}else{$=_}}do{if((Z|0)==15){Z=0;_=Kf(e|0)|0;if(_>>>0>4294967279>>>0){Z=16;break L24}if(_>>>0<11>>>0){k=_<<1&255;a[t]=k;aa=n;ab=k}else{k=_+16&-16;ac=J0(k)|0;c[J>>2]=ac;ad=k|1;c[X>>2]=ad;c[W>>2]=_;aa=ac;ab=ad&255}Kb(aa|0,e|0,_)|0;a[aa+_|0]=0;Ke(b|0,0,12)|0;_=ab&255;ad=(_&1|0)==0?_>>>1:c[W>>2]|0;_=ad+1|0;if(_>>>0>4294967279>>>0){Z=21;break L24}if(_>>>0<11>>>0){a[b]=2;ae=l}else{_=ad+17&-16;ac=(x=0,as(230,_|0)|0);if(x){x=0;Z=28;break L24}c[L>>2]=ac;c[V>>2]=_|1;c[U>>2]=1;ae=ac}a[ae]=96;a[ae+1|0]=0;ac=(ab&1)==0?n:c[J>>2]|0;x=0,ax(64,p|0,ac|0,ad|0)|0;if(x){x=0;Z=28;break L24}Ke(g|0,0,12)|0;ad=a[b]|0;ac=ad&255;_=(ac&1|0)==0?ac>>>1:c[U>>2]|0;ac=(ad&1)==0?l:c[L>>2]|0;ad=_+30|0;if(ad>>>0>4294967279>>>0){Z=33;break L24}if(ad>>>0<11>>>0){a[g]=_<<1;af=F}else{ad=_+46&-16;k=(x=0,as(230,ad|0)|0);if(x){x=0;Z=40;break L24}c[M>>2]=k;c[S>>2]=ad|1;c[T>>2]=_;af=k}Kb(af|0,ac|0,_)|0;a[af+_|0]=0;x=0,ax(64,o|0,1688,30)|0;if(x){x=0;Z=40;break L24}if((a[G]&1)==0){c[H>>2]=c[G>>2];c[H+4>>2]=c[G+4>>2];c[H+8>>2]=c[G+8>>2]}else{_=c[O>>2]|0;ac=c[P>>2]|0;if(ac>>>0>4294967279>>>0){Z=47;break L24}if(ac>>>0<11>>>0){a[H]=ac<<1;ag=f}else{k=ac+16&-16;ad=(x=0,as(230,k|0)|0);if(x){x=0;Z=65;break L24}c[N>>2]=ad;c[Q>>2]=k|1;c[R>>2]=ac;ag=ad}Kb(ag|0,_|0,ac)|0;a[ag+ac|0]=0}c[I>>2]=c[v>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];x=0;aP(362,o|0,r|0,s|0);if(x){x=0;Z=68;break L24}if((a[H]&1)!=0){J2(c[N>>2]|0)}if((a[g]&1)!=0){J2(c[M>>2]|0)}if((a[b]&1)!=0){J2(c[L>>2]|0)}if((a[t]&1)==0){$=0;break}J2(c[J>>2]|0);$=0}}while(0);ac=hN($|0,q|0,d)|0;_=ac?$:q;ac=u+1|0;if(ac>>>0>=h>>>0){D=_;Z=81;break}q=_;u=ac;Y=c[m>>2]|0}do{if((Z|0)==21){x=0;ap(232,0);if(!x){return 0}else{x=0;m=bQ(-1,-1)|0;ah=K;ai=m;Z=30;break}}else if((Z|0)==28){m=bQ(-1,-1)|0;ah=K;ai=m;Z=30}else if((Z|0)==33){x=0;ap(232,0);if(!x){return 0}else{x=0;m=bQ(-1,-1)|0;aj=K;ak=m;Z=42;break}}else if((Z|0)==40){m=bQ(-1,-1)|0;aj=K;ak=m;Z=42}else if((Z|0)==47){x=0;ap(232,0);if(!x){return 0}else{x=0;m=bQ(-1,-1)|0;al=K;am=m;Z=67;break}}else if((Z|0)==16){CJ(0);return 0}else if((Z|0)==65){m=bQ(-1,-1)|0;al=K;am=m;Z=67}else if((Z|0)==68){m=bQ(-1,-1)|0;Y=m;m=K;if((a[H]&1)==0){an=Y;ao=m;Z=70;break}J2(c[N>>2]|0);an=Y;ao=m;Z=70}else if((Z|0)==81){E=D|0;i=j;return E|0}}while(0);if((Z|0)==30){if((a[b]&1)!=0){J2(c[L>>2]|0)}aq=ai;at=ah}else if((Z|0)==42){if((a[g]&1)!=0){J2(c[M>>2]|0)}au=ak;av=aj;Z=72}else if((Z|0)==67){an=am;ao=al;Z=70}do{if((Z|0)==70){if((a[g]&1)==0){au=an;av=ao;Z=72;break}J2(c[M>>2]|0);au=an;av=ao;Z=72}}while(0);do{if((Z|0)==72){if((a[b]&1)==0){aq=au;at=av;break}J2(c[L>>2]|0);aq=au;at=av}}while(0);if((a[t]&1)==0){w=aq;y=at;z=w;A=0;B=z;C=y;be(B|0)}J2(c[J>>2]|0);w=aq;y=at;z=w;A=0;B=z;C=y;be(B|0);return 0}function o1(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){CJ(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=J0(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}Kb(t|0,r|0,s)|0;a[t+s|0]=0}s=(x=0,aK(88,d|0,k|0)|0);if(x){x=0;d=bQ(-1,-1)|0;t=d;d=K;if((a[k]&1)==0){w=d;y=t;z=y;A=0;B=z;D=w;be(B|0)}J2(c[k+8>>2]|0);w=d;y=t;z=y;A=0;B=z;D=w;be(B|0)}t=c[s>>2]|0;if((t|0)==0){E=0}else{E=JP(t,29912,30264,-1)|0}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((E|0)!=0){i=j;return E|0}k=l;t=l;a[t]=20;Kb(k+1|0,8840,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){F=b+1|0}else{F=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){G=q>>>1}else{G=c[b+4>>2]|0}x=0,ax(64,l|0,F|0,G|0)|0;do{if(!x){x=0,ax(64,l|0,7160,6)|0;if(x){x=0;H=57;break}G=Kf(e|0)|0;x=0,ax(64,l|0,e|0,G|0)|0;if(x){x=0;H=57;break}x=0,ax(64,l|0,11032,12)|0;if(x){x=0;H=57;break}G=m;F=m;a[F]=8;b=G+1|0;q=b;C=1953720684;a[q]=C;C=C>>8;a[q+1|0]=C;C=C>>8;a[q+2|0]=C;C=C>>8;a[q+3|0]=C;a[G+5|0]=0;x=0,ax(64,l|0,b|0,4)|0;if(x){x=0;b=bQ(-1,-1)|0;G=b;b=K;if((a[F]&1)==0){I=b;J=G;break}J2(c[m+8>>2]|0);I=b;J=G;break}if((a[F]&1)!=0){J2(c[m+8>>2]|0)}if((a[t]&1)==0){F=n;c[F>>2]=c[t>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2]}else{F=c[l+8>>2]|0;G=c[l+4>>2]|0;if(G>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;H=57;break}return 0}if(G>>>0<11>>>0){a[n]=G<<1;L=n+1|0}else{b=G+16&-16;q=(x=0,as(230,b|0)|0);if(x){x=0;H=57;break}c[n+8>>2]=q;c[n>>2]=b|1;c[n+4>>2]=G;L=q}Kb(L|0,F|0,G)|0;a[L+G|0]=0}G=f;L61:do{if((a[G]&1)==0){F=o;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];H=50}else{F=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;M=o+1|0}else{b=q+16&-16;k=(x=0,as(230,b|0)|0);if(x){x=0;break}c[o+8>>2]=k;c[o>>2]=b|1;c[o+4>>2]=q;M=k}Kb(M|0,F|0,q)|0;a[M+q|0]=0;H=50;break L61}}while(0);q=bQ(-1,-1)|0;N=K;O=q}}while(0);do{if((H|0)==50){G=p;q=g;c[G>>2]=c[q>>2];c[G+4>>2]=c[q+4>>2];c[G+8>>2]=c[q+8>>2];x=0;aT(42,n|0,o|0,p|0,h|0);if(x){x=0;q=bQ(-1,-1)|0;G=q;q=K;if((a[o]&1)==0){N=q;O=G;break}J2(c[o+8>>2]|0);N=q;O=G;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return E|0}J2(c[l+8>>2]|0);i=j;return E|0}}while(0);if((a[n]&1)==0){I=N;J=O;break}J2(c[n+8>>2]|0);I=N;J=O}else{x=0;H=57}}while(0);if((H|0)==57){H=bQ(-1,-1)|0;I=K;J=H}if((a[t]&1)==0){w=I;y=J;z=y;A=0;B=z;D=w;be(B|0)}J2(c[l+8>>2]|0);w=I;y=J;z=y;A=0;B=z;D=w;be(B|0);return 0}function o2(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,aq=0,at=0,au=0,av=0;j=i;i=i+144|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=j+96|0;r=j+112|0;s=j+128|0;t=k;a[t]=6;u=k+1|0;a[u]=a[1864]|0;a[u+1|0]=a[1865]|0;a[u+2|0]=a[1866]|0;a[k+4|0]=0;u=l;v=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];u=(x=0,ar(40,k|0,b|0,e|0,f|0,l|0,h|0)|0);if(x){x=0;l=bQ(-1,-1)|0;g=l;l=K;if((a[t]&1)==0){w=g;y=l;z=w;A=0;B=z;C=y;be(B|0)}J2(c[k+8>>2]|0);w=g;y=l;z=w;A=0;B=z;C=y;be(B|0)}if((a[t]&1)!=0){J2(c[k+8>>2]|0)}k=m;a[k]=6;t=m+1|0;a[t]=a[1800]|0;a[t+1|0]=a[1801]|0;a[t+2|0]=a[1802]|0;a[m+4|0]=0;t=n;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];t=(x=0,ar(50,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(x){x=0;h=bQ(-1,-1)|0;n=h;h=K;if((a[k]&1)==0){w=n;y=h;z=w;A=0;B=z;C=y;be(B|0)}J2(c[m+8>>2]|0);w=n;y=h;z=w;A=0;B=z;C=y;be(B|0)}if((a[k]&1)!=0){J2(c[m+8>>2]|0)}m=t+40|0;k=c[m>>2]|0;h=(c[t+44>>2]|0)-k>>2;if((h|0)==0){D=u;E=D|0;i=j;return E|0}t=q;n=q+1|0;b=p;l=p+1|0;g=o;F=o+1|0;G=f;H=r;I=s;J=q+8|0;L=p+8|0;M=o+8|0;N=r+8|0;O=f+8|0;P=f+4|0;f=r+1|0;Q=r|0;R=r+4|0;S=o|0;T=o+4|0;U=p+4|0;V=p|0;W=q+4|0;X=q|0;q=u;u=0;Y=k;L24:while(1){k=c[Y+(u<<2)>>2]|0;if((k|0)==0){Z=15}else{_=JP(k,31088,30096,-1)|0;if((_|0)==0){Z=15}else{$=_}}do{if((Z|0)==15){Z=0;_=Kf(e|0)|0;if(_>>>0>4294967279>>>0){Z=16;break L24}if(_>>>0<11>>>0){k=_<<1&255;a[t]=k;aa=n;ab=k}else{k=_+16&-16;ac=J0(k)|0;c[J>>2]=ac;ad=k|1;c[X>>2]=ad;c[W>>2]=_;aa=ac;ab=ad&255}Kb(aa|0,e|0,_)|0;a[aa+_|0]=0;Ke(b|0,0,12)|0;_=ab&255;ad=(_&1|0)==0?_>>>1:c[W>>2]|0;_=ad+1|0;if(_>>>0>4294967279>>>0){Z=21;break L24}if(_>>>0<11>>>0){a[b]=2;ae=l}else{_=ad+17&-16;ac=(x=0,as(230,_|0)|0);if(x){x=0;Z=28;break L24}c[L>>2]=ac;c[V>>2]=_|1;c[U>>2]=1;ae=ac}a[ae]=96;a[ae+1|0]=0;ac=(ab&1)==0?n:c[J>>2]|0;x=0,ax(64,p|0,ac|0,ad|0)|0;if(x){x=0;Z=28;break L24}Ke(g|0,0,12)|0;ad=a[b]|0;ac=ad&255;_=(ac&1|0)==0?ac>>>1:c[U>>2]|0;ac=(ad&1)==0?l:c[L>>2]|0;ad=_+30|0;if(ad>>>0>4294967279>>>0){Z=33;break L24}if(ad>>>0<11>>>0){a[g]=_<<1;af=F}else{ad=_+46&-16;k=(x=0,as(230,ad|0)|0);if(x){x=0;Z=40;break L24}c[M>>2]=k;c[S>>2]=ad|1;c[T>>2]=_;af=k}Kb(af|0,ac|0,_)|0;a[af+_|0]=0;x=0,ax(64,o|0,1688,30)|0;if(x){x=0;Z=40;break L24}if((a[G]&1)==0){c[H>>2]=c[G>>2];c[H+4>>2]=c[G+4>>2];c[H+8>>2]=c[G+8>>2]}else{_=c[O>>2]|0;ac=c[P>>2]|0;if(ac>>>0>4294967279>>>0){Z=47;break L24}if(ac>>>0<11>>>0){a[H]=ac<<1;ag=f}else{k=ac+16&-16;ad=(x=0,as(230,k|0)|0);if(x){x=0;Z=65;break L24}c[N>>2]=ad;c[Q>>2]=k|1;c[R>>2]=ac;ag=ad}Kb(ag|0,_|0,ac)|0;a[ag+ac|0]=0}c[I>>2]=c[v>>2];c[I+4>>2]=c[v+4>>2];c[I+8>>2]=c[v+8>>2];x=0;aP(362,o|0,r|0,s|0);if(x){x=0;Z=68;break L24}if((a[H]&1)!=0){J2(c[N>>2]|0)}if((a[g]&1)!=0){J2(c[M>>2]|0)}if((a[b]&1)!=0){J2(c[L>>2]|0)}if((a[t]&1)==0){$=0;break}J2(c[J>>2]|0);$=0}}while(0);ac=hN(q|0,$|0,d)|0;_=ac?$:q;ac=u+1|0;if(ac>>>0>=h>>>0){D=_;Z=80;break}q=_;u=ac;Y=c[m>>2]|0}do{if((Z|0)==65){m=bQ(-1,-1)|0;ah=K;ai=m;Z=67}else if((Z|0)==68){m=bQ(-1,-1)|0;Y=m;m=K;if((a[H]&1)==0){aj=Y;ak=m;Z=70;break}J2(c[N>>2]|0);aj=Y;ak=m;Z=70}else if((Z|0)==40){m=bQ(-1,-1)|0;al=K;am=m;Z=42}else if((Z|0)==47){x=0;ap(232,0);if(!x){return 0}else{x=0;m=bQ(-1,-1)|0;ah=K;ai=m;Z=67;break}}else if((Z|0)==21){x=0;ap(232,0);if(!x){return 0}else{x=0;m=bQ(-1,-1)|0;an=K;ao=m;Z=30;break}}else if((Z|0)==28){m=bQ(-1,-1)|0;an=K;ao=m;Z=30}else if((Z|0)==16){CJ(0);return 0}else if((Z|0)==33){x=0;ap(232,0);if(!x){return 0}else{x=0;m=bQ(-1,-1)|0;al=K;am=m;Z=42;break}}else if((Z|0)==80){E=D|0;i=j;return E|0}}while(0);if((Z|0)==67){aj=ai;ak=ah;Z=70}else if((Z|0)==42){if((a[g]&1)!=0){J2(c[M>>2]|0)}aq=am;at=al;Z=72}else if((Z|0)==30){if((a[b]&1)!=0){J2(c[L>>2]|0)}au=ao;av=an}do{if((Z|0)==70){if((a[g]&1)==0){aq=aj;at=ak;Z=72;break}J2(c[M>>2]|0);aq=aj;at=ak;Z=72}}while(0);do{if((Z|0)==72){if((a[b]&1)==0){au=aq;av=at;break}J2(c[L>>2]|0);au=aq;av=at}}while(0);if((a[t]&1)==0){w=au;y=av;z=w;A=0;B=z;C=y;be(B|0)}J2(c[J>>2]|0);w=au;y=av;z=w;A=0;B=z;C=y;be(B|0);return 0}function o3(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0;h=i;i=i+88|0;e=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];e=h|0;j=h+16|0;k=h+24|0;l=h+40|0;m=h+56|0;n=h+72|0;o=k;p=k;a[p]=10;q=o+1|0;a[q]=a[1488]|0;a[q+1|0]=a[1489]|0;a[q+2|0]=a[1490]|0;a[q+3|0]=a[1491]|0;a[q+4|0]=a[1492]|0;a[o+6|0]=0;o=(x=0,aK(88,b|0,k|0)|0);if(x){x=0;b=bQ(-1,-1)|0;q=b;b=K;if((a[p]&1)==0){r=b;s=q;t=s;u=0;v=t;w=r;be(v|0)}J2(c[k+8>>2]|0);r=b;s=q;t=s;u=0;v=t;w=r;be(v|0)}q=c[o>>2]|0;if((q|0)==0){y=0}else{y=JP(q,29912,30264,-1)|0}if((a[p]&1)!=0){J2(c[k+8>>2]|0)}k=J0(72)|0;c[j>>2]=k;p=d+4|0;q=c[p>>2]|0;if((q|0)==(c[d+8>>2]|0)){ee(d|0,j);z=c[j>>2]|0}else{if((q|0)==0){A=0}else{c[q>>2]=k;A=c[p>>2]|0}c[p>>2]=A+4;z=k}k=z;A=z;q=f;L21:do{if((a[q]&1)==0){j=l;c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];B=23}else{j=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){a[l]=o<<1;C=l+1|0}else{b=o+16&-16;D=(x=0,as(230,b|0)|0);if(x){x=0;break}c[l+8>>2]=D;c[l>>2]=b|1;c[l+4>>2]=o;C=D}Kb(C|0,j|0,o)|0;a[C+o|0]=0;B=23;break L21}}while(0);o=bQ(-1,-1)|0;E=K;F=o}}while(0);do{if((B|0)==23){C=m;f=g;c[C>>2]=c[f>>2];c[C+4>>2]=c[f+4>>2];c[C+8>>2]=c[f+8>>2];if((y|0)==0){G=1.0}else{G=+((c[y+44>>2]|0)-(c[y+40>>2]|0)>>2>>>0>>>0)}f=n;a[f]=0;a[n+1|0]=0;q=e;c[q>>2]=c[C>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];x=0;aE(2,A|0,l|0,e|0,+G,n|0);if(x){x=0;C=bQ(-1,-1)|0;q=C;C=K;if((a[f]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)==0){E=C;F=q;break}J2(c[l+8>>2]|0);E=C;F=q;break}q=z;if((a[f]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)==0){i=h;return q|0}J2(c[l+8>>2]|0);i=h;return q|0}}while(0);h=c[d>>2]|0;d=c[p>>2]|0;l=h;while(1){if((l|0)==(d|0)){H=d;break}if((c[l>>2]|0)==(z|0)){H=l;break}else{l=l+4|0}}l=H-h>>2;H=h+(l+1<<2)|0;z=d-H|0;Kc(h+(l<<2)|0,H|0,z|0)|0;H=h+((z>>2)+l<<2)|0;l=c[p>>2]|0;if((H|0)!=(l|0)){c[p>>2]=l+(~((l-4+(-H|0)|0)>>>2)<<2)}J2(k);r=E;s=F;t=s;u=0;v=t;w=r;be(v|0);return 0}function o4(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0.0,aD=0.0,aE=0.0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0;k=i;i=i+288|0;l=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];l=k|0;m=k+8|0;n=k+24|0;o=k+32|0;p=k+48|0;q=k+64|0;r=k+80|0;s=k+96|0;t=k+112|0;u=k+128|0;v=k+144|0;w=k+160|0;y=k+176|0;z=k+192|0;A=k+208|0;B=k+224|0;D=k+240|0;E=k+256|0;F=k+272|0;G=o;H=o;a[H]=10;I=G+1|0;a[I]=a[1488]|0;a[I+1|0]=a[1489]|0;a[I+2|0]=a[1490]|0;a[I+3|0]=a[1491]|0;a[I+4|0]=a[1492]|0;a[G+6|0]=0;G=(x=0,aK(88,b|0,o|0)|0);if(x){x=0;I=bQ(-1,-1)|0;J=I;I=K;if((a[H]&1)==0){L=I;M=J;N=M;O=0;P=N;Q=L;be(P|0)}J2(c[o+8>>2]|0);L=I;M=J;N=M;O=0;P=N;Q=L;be(P|0)}J=c[G>>2]|0;if((J|0)==0){R=0}else{R=JP(J,29912,30264,-1)|0}if((a[H]&1)!=0){J2(c[o+8>>2]|0)}o=p;H=p;a[H]=4;J=o+1|0;C=28196;a[J]=C;C=C>>8;a[J+1|0]=C;a[o+3|0]=0;o=q;J=g;c[o>>2]=c[J>>2];c[o+4>>2]=c[J+4>>2];c[o+8>>2]=c[J+8>>2];o=(x=0,ar(40,p|0,b|0,e|0,f|0,q|0,j|0)|0);if(x){x=0;q=bQ(-1,-1)|0;g=q;q=K;if((a[H]&1)==0){L=q;M=g;N=M;O=0;P=N;Q=L;be(P|0)}J2(c[p+8>>2]|0);L=q;M=g;N=M;O=0;P=N;Q=L;be(P|0)}if((a[H]&1)!=0){J2(c[p+8>>2]|0)}L24:do{if((R|0)==0){p=J0(60)|0;c[n>>2]=p;H=d+4|0;g=c[H>>2]|0;if((g|0)==(c[d+8>>2]|0)){ee(d|0,n);S=c[n>>2]|0}else{if((g|0)==0){T=0}else{c[g>>2]=p;T=c[H>>2]|0}c[H>>2]=T+4;S=p}p=S;g=S;q=f;L33:do{if((a[q]&1)==0){G=r;c[G>>2]=c[q>>2];c[G+4>>2]=c[q+4>>2];c[G+8>>2]=c[q+8>>2];V=27}else{G=c[f+8>>2]|0;I=c[f+4>>2]|0;do{if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(I>>>0<11>>>0){a[r]=I<<1;W=r+1|0}else{X=I+16&-16;Y=(x=0,as(230,X|0)|0);if(x){x=0;break}c[r+8>>2]=Y;c[r>>2]=X|1;c[r+4>>2]=I;W=Y}Kb(W|0,G|0,I)|0;a[W+I|0]=0;V=27;break L33}}while(0);I=bQ(-1,-1)|0;Z=K;_=I}}while(0);do{if((V|0)==27){q=m;c[q>>2]=c[J>>2];c[q+4>>2]=c[J+4>>2];c[q+8>>2]=c[J+8>>2];x=0;aB(34,g|0,r|0,m|0,1,0,0);if(x){x=0;q=bQ(-1,-1)|0;I=q;q=K;if((a[r]&1)==0){Z=q;_=I;break}J2(c[r+8>>2]|0);Z=q;_=I;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}I=s;q=s;a[q]=10;G=I+1|0;a[G]=a[1488]|0;a[G+1|0]=a[1489]|0;a[G+2|0]=a[1490]|0;a[G+3|0]=a[1491]|0;a[G+4|0]=a[1492]|0;a[I+6|0]=0;I=t;c[I>>2]=c[J>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];I=(x=0,ar(108,s|0,b|0,e|0,f|0,t|0,j|0)|0);do{if(!x){G=S+36|0;Y=G;c[l>>2]=I;X=G+8|0;$=X;aa=c[$>>2]|0;if((aa|0)==(c[G+12>>2]|0)){x=0;aq(370,G+4|0,l|0);if(x){x=0;break}ab=c[l>>2]|0}else{if((aa|0)==0){ac=0}else{c[aa>>2]=I;ac=c[$>>2]|0}c[X>>2]=ac+4;ab=I}x=0;aq(c[c[G>>2]>>2]|0,Y|0,ab|0);if(x){x=0;break}if((a[q]&1)==0){ad=g;break L24}J2(c[s+8>>2]|0);ad=g;break L24}else{x=0}}while(0);I=bQ(-1,-1)|0;Y=I;I=K;if((a[q]&1)==0){L=I;M=Y;N=M;O=0;P=N;Q=L;be(P|0)}J2(c[s+8>>2]|0);L=I;M=Y;N=M;O=0;P=N;Q=L;be(P|0)}}while(0);g=c[d>>2]|0;Y=c[H>>2]|0;I=g;while(1){if((I|0)==(Y|0)){ae=Y;break}if((c[I>>2]|0)==(S|0)){ae=I;break}else{I=I+4|0}}I=ae-g>>2;G=g+(I+1<<2)|0;X=Y-G|0;Kc(g+(I<<2)|0,G|0,X|0)|0;G=g+((X>>2)+I<<2)|0;I=c[H>>2]|0;if((G|0)!=(I|0)){c[H>>2]=I+(~((I-4+(-G|0)|0)>>>2)<<2)}J2(p);L=Z;M=_;N=M;O=0;P=N;Q=L;be(P|0)}else{ad=R}}while(0);R=ad+40|0;L82:do{if((c[R>>2]|0)==(c[ad+44>>2]|0)){_=Kf(e|0)|0;if(_>>>0>4294967279>>>0){CJ(0);return 0}if(_>>>0<11>>>0){Z=_<<1&255;ae=w;S=w;a[S]=Z;af=ae+1|0;ag=Z;ah=ae;ai=S}else{S=_+16&-16;ae=J0(S)|0;c[w+8>>2]=ae;Z=S|1;c[w>>2]=Z;c[w+4>>2]=_;af=ae;ag=Z&255;ah=w;ai=w}Kb(af|0,e|0,_)|0;a[af+_|0]=0;_=v;Ke(_|0,0,12)|0;Z=ag&255;if((Z&1|0)==0){aj=Z>>>1}else{aj=c[w+4>>2]|0}Z=aj+21|0;do{if(Z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;V=73;break}return 0}else{if(Z>>>0<11>>>0){a[_]=42;ak=v+1|0}else{ae=aj+37&-16;S=(x=0,as(230,ae|0)|0);if(x){x=0;V=73;break}c[v+8>>2]=S;c[v>>2]=ae|1;c[v+4>>2]=21;ak=S}Kb(ak|0,1232,21)|0;a[ak+21|0]=0;if((ag&1)==0){al=ah+1|0}else{al=c[w+8>>2]|0}x=0,ax(64,v|0,al|0,aj|0)|0;if(x){x=0;V=73;break}S=u;Ke(S|0,0,12)|0;ae=a[_]|0;d=ae&255;if((d&1|0)==0){am=d>>>1}else{am=c[v+4>>2]|0}if((ae&1)==0){an=v+1|0}else{an=c[v+8>>2]|0}ae=am+19|0;do{if(ae>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;V=89;break}return 0}else{if(ae>>>0<11>>>0){a[S]=am<<1;ao=u+1|0}else{d=am+35&-16;s=(x=0,as(230,d|0)|0);if(x){x=0;V=89;break}c[u+8>>2]=s;c[u>>2]=d|1;c[u+4>>2]=am;ao=s}Kb(ao|0,an|0,am)|0;a[ao+am|0]=0;x=0,ax(64,u|0,1152,19)|0;if(x){x=0;V=89;break}s=f;L125:do{if((a[s]&1)==0){d=y;c[d>>2]=c[s>>2];c[d+4>>2]=c[s+4>>2];c[d+8>>2]=c[s+8>>2];V=101}else{d=c[f+8>>2]|0;ab=c[f+4>>2]|0;do{if(ab>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ab>>>0<11>>>0){a[y]=ab<<1;at=y+1|0}else{ac=ab+16&-16;l=(x=0,as(230,ac|0)|0);if(x){x=0;break}c[y+8>>2]=l;c[y>>2]=ac|1;c[y+4>>2]=ab;at=l}Kb(at|0,d|0,ab)|0;a[at+ab|0]=0;V=101;break L125}}while(0);ab=bQ(-1,-1)|0;au=K;av=ab}}while(0);do{if((V|0)==101){s=z;c[s>>2]=c[J>>2];c[s+4>>2]=c[J+4>>2];c[s+8>>2]=c[J+8>>2];x=0;aP(362,u|0,y|0,z|0);if(x){x=0;s=bQ(-1,-1)|0;ab=s;s=K;if((a[y]&1)==0){au=s;av=ab;break}J2(c[y+8>>2]|0);au=s;av=ab;break}if((a[y]&1)!=0){J2(c[y+8>>2]|0)}if((a[S]&1)!=0){J2(c[u+8>>2]|0)}if((a[_]&1)!=0){J2(c[v+8>>2]|0)}if((a[ai]&1)==0){break L82}J2(c[w+8>>2]|0);break L82}}while(0);if((a[S]&1)==0){aw=au;ay=av;break}J2(c[u+8>>2]|0);aw=au;ay=av}}while(0);if((V|0)==89){ae=bQ(-1,-1)|0;q=K;if((a[S]&1)!=0){J2(c[u+8>>2]|0)}aw=q;ay=ae}if((a[_]&1)==0){az=aw;aA=ay;break}J2(c[v+8>>2]|0);az=aw;aA=ay}}while(0);if((V|0)==73){Z=bQ(-1,-1)|0;p=K;if((a[_]&1)!=0){J2(c[v+8>>2]|0)}az=p;aA=Z}if((a[ai]&1)==0){L=az;M=aA;N=M;O=0;P=N;Q=L;be(P|0)}J2(c[w+8>>2]|0);L=az;M=aA;N=M;O=0;P=N;Q=L;be(P|0)}}while(0);aA=o+40|0;if(+h[aA>>3]>=1.0){aC=+h[aA>>3];aD=aC+-1.0;aE=+U(aD);aF=~~aE;aG=c[R>>2]|0;aH=aG+(aF<<2)|0;aI=c[aH>>2]|0;i=k;return aI|0}o=Kf(e|0)|0;if(o>>>0>4294967279>>>0){CJ(0);return 0}if(o>>>0<11>>>0){az=o<<1&255;w=D;ai=D;a[ai]=az;aJ=w+1|0;aL=az;aM=w;aN=ai}else{ai=o+16&-16;w=J0(ai)|0;c[D+8>>2]=w;az=ai|1;c[D>>2]=az;c[D+4>>2]=o;aJ=w;aL=az&255;aM=D;aN=D}Kb(aJ|0,e|0,o)|0;a[aJ+o|0]=0;o=B;Ke(o|0,0,12)|0;aJ=aL&255;if((aJ&1|0)==0){aO=aJ>>>1}else{aO=c[D+4>>2]|0}aJ=aO+18|0;do{if(aJ>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;V=141;break}return 0}else{if(aJ>>>0<11>>>0){a[o]=36;aQ=B+1|0}else{e=aO+34&-16;az=(x=0,as(230,e|0)|0);if(x){x=0;V=141;break}c[B+8>>2]=az;c[B>>2]=e|1;c[B+4>>2]=18;aQ=az}Kb(aQ|0,1072,18)|0;a[aQ+18|0]=0;if((aL&1)==0){aR=aM+1|0}else{aR=c[D+8>>2]|0}x=0,ax(64,B|0,aR|0,aO|0)|0;if(x){x=0;V=141;break}az=A;Ke(az|0,0,12)|0;e=a[o]|0;w=e&255;if((w&1|0)==0){aS=w>>>1}else{aS=c[B+4>>2]|0}if((e&1)==0){aT=B+1|0}else{aT=c[B+8>>2]|0}e=aS+36|0;do{if(e>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;V=157;break}return 0}else{if(e>>>0<11>>>0){a[az]=aS<<1;aU=A+1|0}else{w=aS+52&-16;ai=(x=0,as(230,w|0)|0);if(x){x=0;V=157;break}c[A+8>>2]=ai;c[A>>2]=w|1;c[A+4>>2]=aS;aU=ai}Kb(aU|0,aT|0,aS)|0;a[aU+aS|0]=0;x=0,ax(64,A|0,1016,36)|0;if(x){x=0;V=157;break}ai=f;L222:do{if((a[ai]&1)==0){w=E;c[w>>2]=c[ai>>2];c[w+4>>2]=c[ai+4>>2];c[w+8>>2]=c[ai+8>>2];V=169}else{w=c[f+8>>2]|0;v=c[f+4>>2]|0;do{if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(v>>>0<11>>>0){a[E]=v<<1;aV=E+1|0}else{ay=v+16&-16;aw=(x=0,as(230,ay|0)|0);if(x){x=0;break}c[E+8>>2]=aw;c[E>>2]=ay|1;c[E+4>>2]=v;aV=aw}Kb(aV|0,w|0,v)|0;a[aV+v|0]=0;V=169;break L222}}while(0);v=bQ(-1,-1)|0;aW=K;aX=v}}while(0);do{if((V|0)==169){ai=F;c[ai>>2]=c[J>>2];c[ai+4>>2]=c[J+4>>2];c[ai+8>>2]=c[J+8>>2];x=0;aP(362,A|0,E|0,F|0);if(x){x=0;ai=bQ(-1,-1)|0;S=ai;ai=K;if((a[E]&1)==0){aW=ai;aX=S;break}J2(c[E+8>>2]|0);aW=ai;aX=S;break}if((a[E]&1)!=0){J2(c[E+8>>2]|0)}if((a[az]&1)!=0){J2(c[A+8>>2]|0)}if((a[o]&1)!=0){J2(c[B+8>>2]|0)}if((a[aN]&1)==0){aC=+h[aA>>3];aD=aC+-1.0;aE=+U(aD);aF=~~aE;aG=c[R>>2]|0;aH=aG+(aF<<2)|0;aI=c[aH>>2]|0;i=k;return aI|0}J2(c[D+8>>2]|0);aC=+h[aA>>3];aD=aC+-1.0;aE=+U(aD);aF=~~aE;aG=c[R>>2]|0;aH=aG+(aF<<2)|0;aI=c[aH>>2]|0;i=k;return aI|0}}while(0);if((a[az]&1)==0){aY=aW;aZ=aX;break}J2(c[A+8>>2]|0);aY=aW;aZ=aX}}while(0);if((V|0)==157){e=bQ(-1,-1)|0;_=K;if((a[az]&1)!=0){J2(c[A+8>>2]|0)}aY=_;aZ=e}if((a[o]&1)==0){a_=aY;a$=aZ;break}J2(c[B+8>>2]|0);a_=aY;a$=aZ}}while(0);if((V|0)==141){V=bQ(-1,-1)|0;aZ=K;if((a[o]&1)!=0){J2(c[B+8>>2]|0)}a_=aZ;a$=V}if((a[aN]&1)==0){L=a_;M=a$;N=M;O=0;P=N;Q=L;be(P|0)}J2(c[D+8>>2]|0);L=a_;M=a$;N=M;O=0;P=N;Q=L;be(P|0);return 0}function o5(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){CJ(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=J0(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}Kb(t|0,r|0,s)|0;a[t+s|0]=0}s=(x=0,aK(88,d|0,k|0)|0);if(x){x=0;d=bQ(-1,-1)|0;t=d;d=K;if((a[k]&1)==0){w=d;y=t;z=y;A=0;B=z;C=w;be(B|0)}J2(c[k+8>>2]|0);w=d;y=t;z=y;A=0;B=z;C=w;be(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=JP(t,29912,31088,-1)|0}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;Kb(k+1|0,8840,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){F=q>>>1}else{F=c[b+4>>2]|0}x=0,ax(64,l|0,E|0,F|0)|0;do{if(!x){x=0,ax(64,l|0,7160,6)|0;if(x){x=0;G=57;break}F=Kf(e|0)|0;x=0,ax(64,l|0,e|0,F|0)|0;if(x){x=0;G=57;break}x=0,ax(64,l|0,11032,12)|0;if(x){x=0;G=57;break}F=m;a[F]=0;E=m+1|0;a[E]=0;x=0,ax(64,l|0,E|0,0)|0;if(x){x=0;E=bQ(-1,-1)|0;b=E;E=K;if((a[F]&1)==0){H=E;I=b;break}J2(c[m+8>>2]|0);H=E;I=b;break}if((a[F]&1)!=0){J2(c[m+8>>2]|0)}if((a[t]&1)==0){F=n;c[F>>2]=c[t>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2]}else{F=c[l+8>>2]|0;b=c[l+4>>2]|0;if(b>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=57;break}return 0}if(b>>>0<11>>>0){a[n]=b<<1;J=n+1|0}else{E=b+16&-16;q=(x=0,as(230,E|0)|0);if(x){x=0;G=57;break}c[n+8>>2]=q;c[n>>2]=E|1;c[n+4>>2]=b;J=q}Kb(J|0,F|0,b)|0;a[J+b|0]=0}b=f;L61:do{if((a[b]&1)==0){F=o;c[F>>2]=c[b>>2];c[F+4>>2]=c[b+4>>2];c[F+8>>2]=c[b+8>>2];G=50}else{F=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;L=o+1|0}else{E=q+16&-16;k=(x=0,as(230,E|0)|0);if(x){x=0;break}c[o+8>>2]=k;c[o>>2]=E|1;c[o+4>>2]=q;L=k}Kb(L|0,F|0,q)|0;a[L+q|0]=0;G=50;break L61}}while(0);q=bQ(-1,-1)|0;M=K;N=q}}while(0);do{if((G|0)==50){b=p;q=g;c[b>>2]=c[q>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];x=0;aT(42,n|0,o|0,p|0,h|0);if(x){x=0;q=bQ(-1,-1)|0;b=q;q=K;if((a[o]&1)==0){M=q;N=b;break}J2(c[o+8>>2]|0);M=q;N=b;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}J2(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){H=M;I=N;break}J2(c[n+8>>2]|0);H=M;I=N}else{x=0;G=57}}while(0);if((G|0)==57){G=bQ(-1,-1)|0;H=K;I=G}if((a[t]&1)==0){w=H;y=I;z=y;A=0;B=z;C=w;be(B|0)}J2(c[l+8>>2]|0);w=H;y=I;z=y;A=0;B=z;C=w;be(B|0);return 0}function o6(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;j=i;i=i+224|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;p=j+56|0;q=j+64|0;r=j+80|0;s=j+96|0;t=j+112|0;u=j+128|0;v=j+144|0;w=j+160|0;y=j+176|0;z=j+192|0;A=j+208|0;B=q;C=q;a[C]=10;D=B+1|0;a[D]=a[1488]|0;a[D+1|0]=a[1489]|0;a[D+2|0]=a[1490]|0;a[D+3|0]=a[1491]|0;a[D+4|0]=a[1492]|0;a[B+6|0]=0;B=(x=0,aK(88,b|0,q|0)|0);if(x){x=0;D=bQ(-1,-1)|0;E=D;D=K;if((a[C]&1)==0){F=D;G=E;H=G;I=0;J=H;L=F;be(J|0)}J2(c[q+8>>2]|0);F=D;G=E;H=G;I=0;J=H;L=F;be(J|0)}E=c[B>>2]|0;if((E|0)==0){M=0}else{M=JP(E,29912,30264,-1)|0}if((a[C]&1)!=0){J2(c[q+8>>2]|0)}q=r;C=r;a[C]=12;E=q+1|0;a[E]=a[2776]|0;a[E+1|0]=a[2777]|0;a[E+2|0]=a[2778]|0;a[E+3|0]=a[2779]|0;a[E+4|0]=a[2780]|0;a[E+5|0]=a[2781]|0;a[q+7|0]=0;q=s;E=g;c[q>>2]=c[E>>2];c[q+4>>2]=c[E+4>>2];c[q+8>>2]=c[E+8>>2];q=(x=0,ar(108,r|0,b|0,e|0,f|0,s|0,h|0)|0);if(x){x=0;s=bQ(-1,-1)|0;g=s;s=K;if((a[C]&1)==0){F=s;G=g;H=G;I=0;J=H;L=F;be(J|0)}J2(c[r+8>>2]|0);F=s;G=g;H=G;I=0;J=H;L=F;be(J|0)}if((a[C]&1)!=0){J2(c[r+8>>2]|0)}L24:do{if((M|0)==0){r=J0(60)|0;c[p>>2]=r;C=d+4|0;g=c[C>>2]|0;if((g|0)==(c[d+8>>2]|0)){ee(d|0,p);N=c[p>>2]|0}else{if((g|0)==0){O=0}else{c[g>>2]=r;O=c[C>>2]|0}c[C>>2]=O+4;N=r}r=N;g=N;s=f;L33:do{if((a[s]&1)==0){B=t;c[B>>2]=c[s>>2];c[B+4>>2]=c[s+4>>2];c[B+8>>2]=c[s+8>>2];P=27}else{B=c[f+8>>2]|0;D=c[f+4>>2]|0;do{if(D>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(D>>>0<11>>>0){a[t]=D<<1;Q=t+1|0}else{R=D+16&-16;S=(x=0,as(230,R|0)|0);if(x){x=0;break}c[t+8>>2]=S;c[t>>2]=R|1;c[t+4>>2]=D;Q=S}Kb(Q|0,B|0,D)|0;a[Q+D|0]=0;P=27;break L33}}while(0);D=bQ(-1,-1)|0;T=K;U=D}}while(0);do{if((P|0)==27){s=o;c[s>>2]=c[E>>2];c[s+4>>2]=c[E+4>>2];c[s+8>>2]=c[E+8>>2];x=0;aB(34,g|0,t|0,o|0,1,0,0);if(x){x=0;s=bQ(-1,-1)|0;D=s;s=K;if((a[t]&1)==0){T=s;U=D;break}J2(c[t+8>>2]|0);T=s;U=D;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}D=u;s=u;a[s]=10;B=D+1|0;a[B]=a[1488]|0;a[B+1|0]=a[1489]|0;a[B+2|0]=a[1490]|0;a[B+3|0]=a[1491]|0;a[B+4|0]=a[1492]|0;a[D+6|0]=0;D=v;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];D=(x=0,ar(108,u|0,b|0,e|0,f|0,v|0,h|0)|0);do{if(!x){B=N+36|0;S=B;c[n>>2]=D;R=B+8|0;V=R;W=c[V>>2]|0;if((W|0)==(c[B+12>>2]|0)){x=0;aq(370,B+4|0,n|0);if(x){x=0;break}X=c[n>>2]|0}else{if((W|0)==0){Y=0}else{c[W>>2]=D;Y=c[V>>2]|0}c[R>>2]=Y+4;X=D}x=0;aq(c[c[B>>2]>>2]|0,S|0,X|0);if(x){x=0;break}if((a[s]&1)==0){Z=g;break L24}J2(c[u+8>>2]|0);Z=g;break L24}else{x=0}}while(0);D=bQ(-1,-1)|0;S=D;D=K;if((a[s]&1)==0){F=D;G=S;H=G;I=0;J=H;L=F;be(J|0)}J2(c[u+8>>2]|0);F=D;G=S;H=G;I=0;J=H;L=F;be(J|0)}}while(0);g=c[d>>2]|0;S=c[C>>2]|0;D=g;while(1){if((D|0)==(S|0)){_=S;break}if((c[D>>2]|0)==(N|0)){_=D;break}else{D=D+4|0}}D=_-g>>2;B=g+(D+1<<2)|0;R=S-B|0;Kc(g+(D<<2)|0,B|0,R|0)|0;B=g+((R>>2)+D<<2)|0;D=c[C>>2]|0;if((B|0)!=(D|0)){c[C>>2]=D+(~((D-4+(-B|0)|0)>>>2)<<2)}J2(r);F=T;G=U;H=G;I=0;J=H;L=F;be(J|0)}else{Z=M}}while(0);M=Z+40|0;U=(c[Z+44>>2]|0)-(c[M>>2]|0)>>2;Z=0;while(1){if(Z>>>0>=U>>>0){P=87;break}$=Z+1|0;if(hM(c[(c[M>>2]|0)+(Z<<2)>>2]|0,q,d)|0){break}else{Z=$}}if((P|0)==87){Z=J0(40)|0;c[k>>2]=Z;q=d+4|0;M=c[q>>2]|0;if((M|0)==(c[d+8>>2]|0)){ee(d|0,k);aa=c[k>>2]|0}else{if((M|0)==0){ab=0}else{c[M>>2]=Z;ab=c[q>>2]|0}c[q>>2]=ab+4;aa=Z}Z=aa;ab=f;L94:do{if((a[ab]&1)==0){M=z;c[M>>2]=c[ab>>2];c[M+4>>2]=c[ab+4>>2];c[M+8>>2]=c[ab+8>>2];P=102}else{M=c[f+8>>2]|0;k=c[f+4>>2]|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(k>>>0<11>>>0){a[z]=k<<1;ac=z+1|0}else{U=k+16&-16;T=(x=0,as(230,U|0)|0);if(x){x=0;break}c[z+8>>2]=T;c[z>>2]=U|1;c[z+4>>2]=k;ac=T}Kb(ac|0,M|0,k)|0;a[ac+k|0]=0;P=102;break L94}}while(0);k=bQ(-1,-1)|0;ad=K;ae=k}}while(0);do{if((P|0)==102){ac=A;c[ac>>2]=c[E>>2];c[ac+4>>2]=c[E+4>>2];c[ac+8>>2]=c[E+8>>2];x=0;aT(4,aa|0,z|0,A|0,0);if(x){x=0;ac=bQ(-1,-1)|0;ab=ac;ac=K;if((a[z]&1)==0){ad=ac;ae=ab;break}J2(c[z+8>>2]|0);ad=ac;ae=ab;break}if((a[z]&1)==0){af=Z;ag=af;i=j;return ag|0}J2(c[z+8>>2]|0);af=Z;ag=af;i=j;return ag|0}}while(0);z=c[d>>2]|0;A=c[q>>2]|0;ab=z;while(1){if((ab|0)==(A|0)){ah=A;break}if((c[ab>>2]|0)==(aa|0)){ah=ab;break}else{ab=ab+4|0}}ab=ah-z>>2;ah=z+(ab+1<<2)|0;aa=A-ah|0;Kc(z+(ab<<2)|0,ah|0,aa|0)|0;ah=z+((aa>>2)+ab<<2)|0;ab=c[q>>2]|0;if((ah|0)!=(ab|0)){c[q>>2]=ab+(~((ab-4+(-ah|0)|0)>>>2)<<2)}J2(Z);F=ad;G=ae;H=G;I=0;J=H;L=F;be(J|0)}ae=J0(72)|0;c[m>>2]=ae;ad=d+4|0;Z=c[ad>>2]|0;if((Z|0)==(c[d+8>>2]|0)){ee(d|0,m);ai=c[m>>2]|0}else{if((Z|0)==0){aj=0}else{c[Z>>2]=ae;aj=c[ad>>2]|0}c[ad>>2]=aj+4;ai=ae}ae=ai;aj=ai;Z=f;L134:do{if((a[Z]&1)==0){m=w;c[m>>2]=c[Z>>2];c[m+4>>2]=c[Z+4>>2];c[m+8>>2]=c[Z+8>>2];P=71}else{m=c[f+8>>2]|0;ah=c[f+4>>2]|0;do{if(ah>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ah>>>0<11>>>0){a[w]=ah<<1;ak=w+1|0}else{ab=ah+16&-16;q=(x=0,as(230,ab|0)|0);if(x){x=0;break}c[w+8>>2]=q;c[w>>2]=ab|1;c[w+4>>2]=ah;ak=q}Kb(ak|0,m|0,ah)|0;a[ak+ah|0]=0;P=71;break L134}}while(0);ah=bQ(-1,-1)|0;al=K;am=ah}}while(0);do{if((P|0)==71){ak=l;c[ak>>2]=c[E>>2];c[ak+4>>2]=c[E+4>>2];c[ak+8>>2]=c[E+8>>2];ak=y;a[ak]=0;a[y+1|0]=0;x=0;aE(2,aj|0,w|0,l|0,+(+($>>>0>>>0)),y|0);if(x){x=0;f=bQ(-1,-1)|0;Z=f;f=K;if((a[ak]&1)!=0){J2(c[y+8>>2]|0)}if((a[w]&1)==0){al=f;am=Z;break}J2(c[w+8>>2]|0);al=f;am=Z;break}if((a[ak]&1)!=0){J2(c[y+8>>2]|0)}if((a[w]&1)==0){af=ae;ag=af;i=j;return ag|0}J2(c[w+8>>2]|0);af=ae;ag=af;i=j;return ag|0}}while(0);ag=c[d>>2]|0;d=c[ad>>2]|0;j=ag;while(1){if((j|0)==(d|0)){an=d;break}if((c[j>>2]|0)==(ai|0)){an=j;break}else{j=j+4|0}}j=an-ag>>2;an=ag+(j+1<<2)|0;ai=d-an|0;Kc(ag+(j<<2)|0,an|0,ai|0)|0;an=ag+((ai>>2)+j<<2)|0;j=c[ad>>2]|0;if((an|0)!=(j|0)){c[ad>>2]=j+(~((j-4+(-an|0)|0)>>>2)<<2)}J2(ae);F=al;G=am;H=G;I=0;J=H;L=F;be(J|0);return 0}function o7(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0;j=i;i=i+392|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+16|0;n=j+32|0;o=j+40|0;p=j+48|0;q=j+64|0;r=j+72|0;s=j+80|0;t=j+96|0;u=j+104|0;v=j+120|0;w=j+136|0;y=j+152|0;z=j+168|0;A=j+184|0;B=j+200|0;C=j+216|0;D=j+232|0;E=j+248|0;F=j+264|0;G=j+280|0;H=j+296|0;I=j+312|0;J=j+328|0;L=j+344|0;M=j+360|0;N=j+376|0;O=u;P=u;a[P]=12;Q=O+1|0;a[Q]=a[848]|0;a[Q+1|0]=a[849]|0;a[Q+2|0]=a[850]|0;a[Q+3|0]=a[851]|0;a[Q+4|0]=a[852]|0;a[Q+5|0]=a[853]|0;a[O+7|0]=0;O=(x=0,aK(88,b|0,u|0)|0);if(x){x=0;Q=bQ(-1,-1)|0;R=Q;Q=K;if((a[P]&1)==0){S=R;T=Q;U=S;V=0;W=U;X=T;be(W|0)}J2(c[u+8>>2]|0);S=R;T=Q;U=S;V=0;W=U;X=T;be(W|0)}Q=c[O>>2]|0;if((Q|0)==0){Y=0}else{Y=JP(Q,29912,30264,-1)|0}if((a[P]&1)!=0){J2(c[u+8>>2]|0)}u=v;P=v;a[P]=12;Q=u+1|0;a[Q]=a[760]|0;a[Q+1|0]=a[761]|0;a[Q+2|0]=a[762]|0;a[Q+3|0]=a[763]|0;a[Q+4|0]=a[764]|0;a[Q+5|0]=a[765]|0;a[u+7|0]=0;u=(x=0,aK(88,b|0,v|0)|0);if(x){x=0;Q=bQ(-1,-1)|0;O=Q;Q=K;if((a[P]&1)==0){S=O;T=Q;U=S;V=0;W=U;X=T;be(W|0)}J2(c[v+8>>2]|0);S=O;T=Q;U=S;V=0;W=U;X=T;be(W|0)}Q=c[u>>2]|0;if((Q|0)==0){Z=0}else{Z=JP(Q,29912,30264,-1)|0}if((a[P]&1)!=0){J2(c[v+8>>2]|0)}v=w;P=w;a[P]=20;Kb(v+1|0,720,10)|0;a[v+11|0]=0;v=y;Q=g;c[v>>2]=c[Q>>2];c[v+4>>2]=c[Q+4>>2];c[v+8>>2]=c[Q+8>>2];v=(x=0,ar(98,w|0,b|0,e|0,f|0,y|0,h|0)|0);if(x){x=0;y=bQ(-1,-1)|0;g=y;y=K;if((a[P]&1)==0){S=g;T=y;U=S;V=0;W=U;X=T;be(W|0)}J2(c[w+8>>2]|0);S=g;T=y;U=S;V=0;W=U;X=T;be(W|0)}if((a[P]&1)!=0){J2(c[w+8>>2]|0)}L37:do{if((Y|0)==0){w=J0(60)|0;c[t>>2]=w;P=d+4|0;y=c[P>>2]|0;g=d+8|0;if((y|0)==(c[g>>2]|0)){ee(d|0,t);_=c[t>>2]|0}else{if((y|0)==0){$=0}else{c[y>>2]=w;$=c[P>>2]|0}c[P>>2]=$+4;_=w}w=_;y=_;u=f;L48:do{if((a[u]&1)==0){O=z;c[O>>2]=c[u>>2];c[O+4>>2]=c[u+4>>2];c[O+8>>2]=c[u+8>>2];aa=34}else{O=c[f+8>>2]|0;R=c[f+4>>2]|0;do{if(R>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(R>>>0<11>>>0){a[z]=R<<1;ab=z+1|0}else{ac=R+16&-16;ad=(x=0,as(230,ac|0)|0);if(x){x=0;break}c[z+8>>2]=ad;c[z>>2]=ac|1;c[z+4>>2]=R;ab=ad}Kb(ab|0,O|0,R)|0;a[ab+R|0]=0;aa=34;break L48}}while(0);R=bQ(-1,-1)|0;ae=R;af=K}}while(0);do{if((aa|0)==34){u=s;c[u>>2]=c[Q>>2];c[u+4>>2]=c[Q+4>>2];c[u+8>>2]=c[Q+8>>2];x=0;aB(34,y|0,z|0,s|0,1,0,0);if(x){x=0;u=bQ(-1,-1)|0;R=u;u=K;if((a[z]&1)==0){ae=R;af=u;break}J2(c[z+8>>2]|0);ae=R;af=u;break}if((a[z]&1)!=0){J2(c[z+8>>2]|0)}u=A;R=A;a[R]=12;O=u+1|0;a[O]=a[848]|0;a[O+1|0]=a[849]|0;a[O+2|0]=a[850]|0;a[O+3|0]=a[851]|0;a[O+4|0]=a[852]|0;a[O+5|0]=a[853]|0;a[u+7|0]=0;u=B;c[u>>2]=c[Q>>2];c[u+4>>2]=c[Q+4>>2];c[u+8>>2]=c[Q+8>>2];u=(x=0,ar(108,A|0,b|0,e|0,f|0,B|0,h|0)|0);do{if(!x){O=_+36|0;ad=O;c[r>>2]=u;ac=O+8|0;ag=ac;ah=c[ag>>2]|0;if((ah|0)==(c[O+12>>2]|0)){x=0;aq(370,O+4|0,r|0);if(x){x=0;break}ai=c[r>>2]|0}else{if((ah|0)==0){aj=0}else{c[ah>>2]=u;aj=c[ag>>2]|0}c[ac>>2]=aj+4;ai=u}x=0;aq(c[c[O>>2]>>2]|0,ad|0,ai|0);if(x){x=0;break}if((a[R]&1)!=0){J2(c[A+8>>2]|0)}if((Z|0)==0){ak=0;al=y;am=P;an=g;aa=64;break L37}ao=Z;at=c[Z+52>>2]|0;au=y;break L37}else{x=0}}while(0);u=bQ(-1,-1)|0;ad=u;u=K;if((a[R]&1)==0){S=ad;T=u;U=S;V=0;W=U;X=T;be(W|0)}J2(c[A+8>>2]|0);S=ad;T=u;U=S;V=0;W=U;X=T;be(W|0)}}while(0);y=c[d>>2]|0;g=c[P>>2]|0;u=y;while(1){if((u|0)==(g|0)){av=g;break}if((c[u>>2]|0)==(_|0)){av=u;break}else{u=u+4|0}}u=av-y>>2;ad=y+(u+1<<2)|0;O=g-ad|0;Kc(y+(u<<2)|0,ad|0,O|0)|0;ad=y+((O>>2)+u<<2)|0;u=c[P>>2]|0;if((ad|0)!=(u|0)){c[P>>2]=u+(~((u-4+(-ad|0)|0)>>>2)<<2)}J2(w);S=ae;T=af;U=S;V=0;W=U;X=T;be(W|0)}else{ad=c[Y+52>>2]|0;if((Z|0)!=0){ao=Z;at=ad;au=Y;break}ak=ad;al=Y;am=d+4|0;an=d+8|0;aa=64}}while(0);L99:do{if((aa|0)==64){Y=J0(60)|0;c[q>>2]=Y;Z=c[am>>2]|0;if((Z|0)==(c[an>>2]|0)){ee(d|0,q);aw=c[q>>2]|0}else{if((Z|0)==0){ay=0}else{c[Z>>2]=Y;ay=c[am>>2]|0}c[am>>2]=ay+4;aw=Y}Y=aw;Z=aw;af=f;L108:do{if((a[af]&1)==0){ae=C;c[ae>>2]=c[af>>2];c[ae+4>>2]=c[af+4>>2];c[ae+8>>2]=c[af+8>>2];aa=79}else{ae=c[f+8>>2]|0;av=c[f+4>>2]|0;do{if(av>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(av>>>0<11>>>0){a[C]=av<<1;az=C+1|0}else{_=av+16&-16;A=(x=0,as(230,_|0)|0);if(x){x=0;break}c[C+8>>2]=A;c[C>>2]=_|1;c[C+4>>2]=av;az=A}Kb(az|0,ae|0,av)|0;a[az+av|0]=0;aa=79;break L108}}while(0);av=bQ(-1,-1)|0;aA=av;aC=K}}while(0);do{if((aa|0)==79){af=p;c[af>>2]=c[Q>>2];c[af+4>>2]=c[Q+4>>2];c[af+8>>2]=c[Q+8>>2];x=0;aB(34,Z|0,C|0,p|0,1,0,0);if(x){x=0;af=bQ(-1,-1)|0;w=af;af=K;if((a[C]&1)==0){aA=w;aC=af;break}J2(c[C+8>>2]|0);aA=w;aC=af;break}if((a[C]&1)!=0){J2(c[C+8>>2]|0)}af=D;w=D;a[w]=12;P=af+1|0;a[P]=a[760]|0;a[P+1|0]=a[761]|0;a[P+2|0]=a[762]|0;a[P+3|0]=a[763]|0;a[P+4|0]=a[764]|0;a[P+5|0]=a[765]|0;a[af+7|0]=0;af=E;c[af>>2]=c[Q>>2];c[af+4>>2]=c[Q+4>>2];c[af+8>>2]=c[Q+8>>2];af=(x=0,ar(108,D|0,b|0,e|0,f|0,E|0,h|0)|0);do{if(!x){P=aw+36|0;y=P;c[o>>2]=af;g=P+8|0;av=g;ae=c[av>>2]|0;if((ae|0)==(c[P+12>>2]|0)){x=0;aq(370,P+4|0,o|0);if(x){x=0;break}aD=c[o>>2]|0}else{if((ae|0)==0){aE=0}else{c[ae>>2]=af;aE=c[av>>2]|0}c[g>>2]=aE+4;aD=af}x=0;aq(c[c[P>>2]>>2]|0,y|0,aD|0);if(x){x=0;break}if((a[w]&1)==0){ao=Z;at=ak;au=al;break L99}J2(c[D+8>>2]|0);ao=Z;at=ak;au=al;break L99}else{x=0}}while(0);af=bQ(-1,-1)|0;y=af;af=K;if((a[w]&1)==0){S=y;T=af;U=S;V=0;W=U;X=T;be(W|0)}J2(c[D+8>>2]|0);S=y;T=af;U=S;V=0;W=U;X=T;be(W|0)}}while(0);Z=c[d>>2]|0;af=c[am>>2]|0;y=Z;while(1){if((y|0)==(af|0)){aF=af;break}if((c[y>>2]|0)==(aw|0)){aF=y;break}else{y=y+4|0}}y=aF-Z>>2;P=Z+(y+1<<2)|0;g=af-P|0;Kc(Z+(y<<2)|0,P|0,g|0)|0;P=Z+((g>>2)+y<<2)|0;y=c[am>>2]|0;if((P|0)!=(y|0)){c[am>>2]=y+(~((y-4+(-P|0)|0)>>>2)<<2)}J2(Y);S=aA;T=aC;U=S;V=0;W=U;X=T;be(W|0)}}while(0);aC=au+36|0;aA=ao+36|0;am=((c[ao+44>>2]|0)-(c[ao+40>>2]|0)>>2)+((c[au+44>>2]|0)-(c[au+40>>2]|0)>>2)|0;aF=v+40|0;if((a[aF]&1)==0){aw=G;c[aw>>2]=c[aF>>2];c[aw+4>>2]=c[aF+4>>2];c[aw+8>>2]=c[aF+8>>2]}else{aF=c[v+48>>2]|0;aw=c[v+44>>2]|0;if(aw>>>0>4294967279>>>0){CJ(0);return 0}if(aw>>>0<11>>>0){a[G]=aw<<1;aG=G+1|0}else{v=aw+16&-16;D=J0(v)|0;c[G+8>>2]=D;c[G>>2]=v|1;c[G+4>>2]=aw;aG=D}Kb(aG|0,aF|0,aw)|0;a[aG+aw|0]=0}x=0;aq(180,F|0,G|0);if(x){x=0;aw=bQ(-1,-1)|0;aG=aw;aw=K;if((a[G]&1)==0){S=aG;T=aw;U=S;V=0;W=U;X=T;be(W|0)}J2(c[G+8>>2]|0);S=aG;T=aw;U=S;V=0;W=U;X=T;be(W|0)}if((a[G]&1)!=0){J2(c[G+8>>2]|0)}G=F;aw=F;aG=a[aw]|0;aF=aG&255;D=(aF&1|0)==0;if(D){aH=aF>>>1}else{aH=c[F+4>>2]|0}v=(aG&1)==0;if(v){aI=G+1|0}else{aI=c[F+8>>2]|0}aG=aH>>>0>5>>>0;if((Kd(aI|0,640,(aG?5:aH)|0)|0)==0){if(aH>>>0>4>>>0&(aG^1)){aJ=0;aa=213}else{aa=124}}else{aa=124}L188:do{if((aa|0)==124){if(D){aL=aF>>>1}else{aL=c[F+4>>2]|0}if(v){aM=G+1|0}else{aM=c[F+8>>2]|0}aG=aL>>>0>5>>>0;if((Kd(aM|0,608,(aG?5:aL)|0)|0)==0){if(aL>>>0>4>>>0&(aG^1)){aJ=1;aa=213;break}}if(D){aN=aF>>>1}else{aN=c[F+4>>2]|0}if(v){aO=G+1|0}else{aO=c[F+8>>2]|0}aG=aN>>>0>4>>>0;if((Kd(aO|0,552,(aG?4:aN)|0)|0)==0){if(aN>>>0>3>>>0&(aG^1)){aJ=at;aa=213;break}}aG=Kf(e|0)|0;if(aG>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;aa=200;break}return 0}if(aG>>>0<11>>>0){aH=aG<<1&255;aI=J;al=J;a[al]=aH;aQ=aI+1|0;aR=aH;aS=aI;aT=al}else{al=aG+16&-16;aI=(x=0,as(230,al|0)|0);if(x){x=0;aa=200;break}c[J+8>>2]=aI;aH=al|1;c[J>>2]=aH;c[J+4>>2]=aG;aQ=aI;aR=aH&255;aS=J;aT=J}Kb(aQ|0,e|0,aG)|0;a[aQ+aG|0]=0;aG=I;Ke(aG|0,0,12)|0;aH=aR&255;if((aH&1|0)==0){aU=aH>>>1}else{aU=c[J+4>>2]|0}aH=aU+26|0;do{if(aH>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;aa=161;break}return 0}else{if(aH>>>0<11>>>0){a[aG]=52;aV=I+1|0}else{aI=aU+42&-16;al=(x=0,as(230,aI|0)|0);if(x){x=0;aa=161;break}c[I+8>>2]=al;c[I>>2]=aI|1;c[I+4>>2]=26;aV=al}Kb(aV|0,464,26)|0;a[aV+26|0]=0;if((aR&1)==0){aW=aS+1|0}else{aW=c[J+8>>2]|0}x=0,ax(64,I|0,aW|0,aU|0)|0;if(x){x=0;aa=161;break}al=H;Ke(al|0,0,12)|0;aI=a[aG]|0;ak=aI&255;if((ak&1|0)==0){aX=ak>>>1}else{aX=c[I+4>>2]|0}if((aI&1)==0){aY=I+1|0}else{aY=c[I+8>>2]|0}aI=aX+37|0;do{if(aI>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;aa=177;break}return 0}else{if(aI>>>0<11>>>0){a[al]=aX<<1;aZ=H+1|0}else{ak=aX+53&-16;aD=(x=0,as(230,ak|0)|0);if(x){x=0;aa=177;break}c[H+8>>2]=aD;c[H>>2]=ak|1;c[H+4>>2]=aX;aZ=aD}Kb(aZ|0,aY|0,aX)|0;a[aZ+aX|0]=0;x=0,ax(64,H|0,400,37)|0;if(x){x=0;aa=177;break}aD=f;L257:do{if((a[aD]&1)==0){ak=L;c[ak>>2]=c[aD>>2];c[ak+4>>2]=c[aD+4>>2];c[ak+8>>2]=c[aD+8>>2];aa=189}else{ak=c[f+8>>2]|0;aE=c[f+4>>2]|0;do{if(aE>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aE>>>0<11>>>0){a[L]=aE<<1;a_=L+1|0}else{o=aE+16&-16;h=(x=0,as(230,o|0)|0);if(x){x=0;break}c[L+8>>2]=h;c[L>>2]=o|1;c[L+4>>2]=aE;a_=h}Kb(a_|0,ak|0,aE)|0;a[a_+aE|0]=0;aa=189;break L257}}while(0);aE=bQ(-1,-1)|0;a$=aE;a0=K}}while(0);do{if((aa|0)==189){aD=M;c[aD>>2]=c[Q>>2];c[aD+4>>2]=c[Q+4>>2];c[aD+8>>2]=c[Q+8>>2];x=0;aP(362,H|0,L|0,M|0);if(x){x=0;aD=bQ(-1,-1)|0;aE=aD;aD=K;if((a[L]&1)==0){a$=aE;a0=aD;break}J2(c[L+8>>2]|0);a$=aE;a0=aD;break}if((a[L]&1)!=0){J2(c[L+8>>2]|0)}if((a[al]&1)!=0){J2(c[H+8>>2]|0)}if((a[aG]&1)!=0){J2(c[I+8>>2]|0)}if((a[aT]&1)==0){aJ=at;aa=213;break L188}J2(c[J+8>>2]|0);aJ=at;aa=213;break L188}}while(0);if((a[al]&1)==0){a1=a$;a2=a0;break}J2(c[H+8>>2]|0);a1=a$;a2=a0}}while(0);if((aa|0)==177){aI=bQ(-1,-1)|0;w=K;if((a[al]&1)!=0){J2(c[H+8>>2]|0)}a1=aI;a2=w}if((a[aG]&1)==0){a3=a1;a4=a2;break}J2(c[I+8>>2]|0);a3=a1;a4=a2}}while(0);if((aa|0)==161){aH=bQ(-1,-1)|0;Y=K;if((a[aG]&1)!=0){J2(c[I+8>>2]|0)}a3=aH;a4=Y}if((a[aT]&1)==0){a5=a3;a6=a4;break}J2(c[J+8>>2]|0);a5=a3;a6=a4}}while(0);L302:do{if((aa|0)==213){a4=(x=0,as(230,60)|0);if(x){x=0;aa=200;break}a3=a4;c[n>>2]=a3;a4=d+4|0;J=c[a4>>2]|0;if((J|0)==(c[d+8>>2]|0)){x=0;aq(376,d|0,n|0);if(x){x=0;aa=200;break}a7=c[n>>2]|0}else{if((J|0)==0){a8=0}else{c[J>>2]=a3;a8=c[a4>>2]|0}c[a4>>2]=a8+4;a7=a3}a3=a7;J=f;L313:do{if((a[J]&1)==0){aT=N;c[aT>>2]=c[J>>2];c[aT+4>>2]=c[J+4>>2];c[aT+8>>2]=c[J+8>>2];aa=230}else{aT=c[f+8>>2]|0;I=c[f+4>>2]|0;do{if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(I>>>0<11>>>0){a[N]=I<<1;a9=N+1|0}else{a2=I+16&-16;a1=(x=0,as(230,a2|0)|0);if(x){x=0;break}c[N+8>>2]=a1;c[N>>2]=a2|1;c[N+4>>2]=I;a9=a1}Kb(a9|0,aT|0,I)|0;a[a9+I|0]=0;aa=230;break L313}}while(0);I=bQ(-1,-1)|0;ba=I;bb=K}}while(0);do{if((aa|0)==230){J=m;c[J>>2]=c[Q>>2];c[J+4>>2]=c[Q+4>>2];c[J+8>>2]=c[Q+8>>2];x=0;aB(34,a7|0,N|0,m|0,am|0,aJ|0,0);if(x){x=0;J=bQ(-1,-1)|0;aG=J;J=K;if((a[N]&1)==0){ba=aG;bb=J;break}J2(c[N+8>>2]|0);ba=aG;bb=J;break}if((a[N]&1)!=0){J2(c[N+8>>2]|0)}J=a7+36|0;aG=J;I=(au|0)==0?0:aC;aT=I+4|0;al=c[aT>>2]|0;a1=(c[I+8>>2]|0)-al>>2;L335:do{if((a1|0)!=0){I=J+8|0;a2=I;H=J+12|0;a0=J+4|0;a$=J;at=0;L=al;while(1){M=c[L+(at<<2)>>2]|0;c[l>>2]=M;a_=c[a2>>2]|0;if((a_|0)==(c[H>>2]|0)){x=0;aq(370,a0|0,l|0);if(x){x=0;break}bc=c[l>>2]|0}else{if((a_|0)==0){bd=0}else{c[a_>>2]=M;bd=c[a2>>2]|0}c[I>>2]=bd+4;bc=M}x=0;aq(c[c[a$>>2]>>2]|0,aG|0,bc|0);if(x){x=0;break}M=at+1|0;if(M>>>0>=a1>>>0){break L335}at=M;L=c[aT>>2]|0}L=bQ(-1,-1)|0;bf=K;bg=L;aa=201;break L302}}while(0);aT=(ao|0)==0?0:aA;a1=aT+4|0;al=c[a1>>2]|0;L=(c[aT+8>>2]|0)-al>>2;L351:do{if((L|0)!=0){aT=J+8|0;at=aT;a$=J+12|0;I=J+4|0;a2=J;a0=0;H=al;while(1){M=c[H+(a0<<2)>>2]|0;c[k>>2]=M;a_=c[at>>2]|0;if((a_|0)==(c[a$>>2]|0)){x=0;aq(370,I|0,k|0);if(x){x=0;break}bh=c[k>>2]|0}else{if((a_|0)==0){bi=0}else{c[a_>>2]=M;bi=c[at>>2]|0}c[aT>>2]=bi+4;bh=M}x=0;aq(c[c[a2>>2]>>2]|0,aG|0,bh|0);if(x){x=0;break}M=a0+1|0;if(M>>>0>=L>>>0){break L351}a0=M;H=c[a1>>2]|0}H=bQ(-1,-1)|0;bf=K;bg=H;aa=201;break L302}}while(0);a1=a7;if((a[aw]&1)==0){i=j;return a1|0}J2(c[F+8>>2]|0);i=j;return a1|0}}while(0);a1=c[d>>2]|0;L=c[a4>>2]|0;aG=a1;while(1){if((aG|0)==(L|0)){bj=L;break}if((c[aG>>2]|0)==(a7|0)){bj=aG;break}else{aG=aG+4|0}}aG=bj-a1>>2;al=a1+(aG+1<<2)|0;J=L-al|0;Kc(a1+(aG<<2)|0,al|0,J|0)|0;al=a1+((J>>2)+aG<<2)|0;aG=c[a4>>2]|0;if((al|0)!=(aG|0)){c[a4>>2]=aG+(~((aG-4+(-al|0)|0)>>>2)<<2)}J2(a3);a5=ba;a6=bb}}while(0);if((aa|0)==200){bb=bQ(-1,-1)|0;bf=K;bg=bb;aa=201}if((aa|0)==201){a5=bg;a6=bf}if((a[aw]&1)==0){S=a5;T=a6;U=S;V=0;W=U;X=T;be(W|0)}J2(c[F+8>>2]|0);S=a5;T=a6;U=S;V=0;W=U;X=T;be(W|0);return 0}function o8(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;j=i;i=i+96|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+64|0;p=j+80|0;q=b;if((a[q]&1)==0){r=k;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2]}else{r=c[b+8>>2]|0;s=c[b+4>>2]|0;if(s>>>0>4294967279>>>0){CJ(0);return 0}if(s>>>0<11>>>0){a[k]=s<<1;t=k+1|0}else{u=s+16&-16;v=J0(u)|0;c[k+8>>2]=v;c[k>>2]=u|1;c[k+4>>2]=s;t=v}Kb(t|0,r|0,s)|0;a[t+s|0]=0}s=(x=0,aK(88,d|0,k|0)|0);if(x){x=0;d=bQ(-1,-1)|0;t=d;d=K;if((a[k]&1)==0){w=d;y=t;z=y;A=0;B=z;C=w;be(B|0)}J2(c[k+8>>2]|0);w=d;y=t;z=y;A=0;B=z;C=w;be(B|0)}t=c[s>>2]|0;if((t|0)==0){D=0}else{D=JP(t,29912,30568,-1)|0}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((D|0)!=0){i=j;return D|0}k=l;t=l;a[t]=20;Kb(k+1|0,8840,10)|0;a[k+11|0]=0;k=a[q]|0;if((k&1)==0){E=b+1|0}else{E=c[b+8>>2]|0}q=k&255;if((q&1|0)==0){F=q>>>1}else{F=c[b+4>>2]|0}x=0,ax(64,l|0,E|0,F|0)|0;do{if(!x){x=0,ax(64,l|0,7160,6)|0;if(x){x=0;G=57;break}F=Kf(e|0)|0;x=0,ax(64,l|0,e|0,F|0)|0;if(x){x=0;G=57;break}x=0,ax(64,l|0,11032,12)|0;if(x){x=0;G=57;break}F=m;E=m;a[E]=12;b=F+1|0;a[b]=a[11e3]|0;a[b+1|0]=a[11001]|0;a[b+2|0]=a[11002]|0;a[b+3|0]=a[11003]|0;a[b+4|0]=a[11004]|0;a[b+5|0]=a[11005]|0;a[F+7|0]=0;x=0,ax(64,l|0,b|0,6)|0;if(x){x=0;b=bQ(-1,-1)|0;F=b;b=K;if((a[E]&1)==0){H=b;I=F;break}J2(c[m+8>>2]|0);H=b;I=F;break}if((a[E]&1)!=0){J2(c[m+8>>2]|0)}if((a[t]&1)==0){E=n;c[E>>2]=c[t>>2];c[E+4>>2]=c[t+4>>2];c[E+8>>2]=c[t+8>>2]}else{E=c[l+8>>2]|0;F=c[l+4>>2]|0;if(F>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=57;break}return 0}if(F>>>0<11>>>0){a[n]=F<<1;J=n+1|0}else{b=F+16&-16;q=(x=0,as(230,b|0)|0);if(x){x=0;G=57;break}c[n+8>>2]=q;c[n>>2]=b|1;c[n+4>>2]=F;J=q}Kb(J|0,E|0,F)|0;a[J+F|0]=0}F=f;L61:do{if((a[F]&1)==0){E=o;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];G=50}else{E=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[o]=q<<1;L=o+1|0}else{b=q+16&-16;k=(x=0,as(230,b|0)|0);if(x){x=0;break}c[o+8>>2]=k;c[o>>2]=b|1;c[o+4>>2]=q;L=k}Kb(L|0,E|0,q)|0;a[L+q|0]=0;G=50;break L61}}while(0);q=bQ(-1,-1)|0;M=K;N=q}}while(0);do{if((G|0)==50){F=p;q=g;c[F>>2]=c[q>>2];c[F+4>>2]=c[q+4>>2];c[F+8>>2]=c[q+8>>2];x=0;aT(42,n|0,o|0,p|0,h|0);if(x){x=0;q=bQ(-1,-1)|0;F=q;q=K;if((a[o]&1)==0){M=q;N=F;break}J2(c[o+8>>2]|0);M=q;N=F;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[t]&1)==0){i=j;return D|0}J2(c[l+8>>2]|0);i=j;return D|0}}while(0);if((a[n]&1)==0){H=M;I=N;break}J2(c[n+8>>2]|0);H=M;I=N}else{x=0;G=57}}while(0);if((G|0)==57){G=bQ(-1,-1)|0;H=K;I=G}if((a[t]&1)==0){w=H;y=I;z=y;A=0;B=z;C=w;be(B|0)}J2(c[l+8>>2]|0);w=H;y=I;z=y;A=0;B=z;C=w;be(B|0);return 0}function o9(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0;j=i;i=i+344|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;p=j+56|0;q=j+64|0;r=j+72|0;s=j+88|0;t=j+104|0;u=j+120|0;v=j+136|0;w=j+152|0;y=j+168|0;z=j+184|0;A=j+200|0;B=j+216|0;D=j+232|0;E=j+248|0;F=j+264|0;G=j+280|0;H=j+296|0;I=j+312|0;J=j+328|0;L=r;M=r;a[M]=10;N=L+1|0;a[N]=a[1488]|0;a[N+1|0]=a[1489]|0;a[N+2|0]=a[1490]|0;a[N+3|0]=a[1491]|0;a[N+4|0]=a[1492]|0;a[L+6|0]=0;L=(x=0,aK(88,b|0,r|0)|0);if(x){x=0;N=bQ(-1,-1)|0;O=N;N=K;if((a[M]&1)==0){P=O;Q=N;R=P;S=0;T=R;U=Q;be(T|0)}J2(c[r+8>>2]|0);P=O;Q=N;R=P;S=0;T=R;U=Q;be(T|0)}N=c[L>>2]|0;if((N|0)==0){V=0}else{V=JP(N,29912,30264,-1)|0}if((a[M]&1)!=0){J2(c[r+8>>2]|0)}r=s;M=s;a[M]=8;N=r+1|0;C=1818326564;a[N]=C;C=C>>8;a[N+1|0]=C;C=C>>8;a[N+2|0]=C;C=C>>8;a[N+3|0]=C;a[r+5|0]=0;r=t;N=g;c[r>>2]=c[N>>2];c[r+4>>2]=c[N+4>>2];c[r+8>>2]=c[N+8>>2];r=(x=0,ar(108,s|0,b|0,e|0,f|0,t|0,h|0)|0);if(x){x=0;t=bQ(-1,-1)|0;g=t;t=K;if((a[M]&1)==0){P=g;Q=t;R=P;S=0;T=R;U=Q;be(T|0)}J2(c[s+8>>2]|0);P=g;Q=t;R=P;S=0;T=R;U=Q;be(T|0)}if((a[M]&1)!=0){J2(c[s+8>>2]|0)}s=u;M=u;a[M]=20;Kb(s+1|0,720,10)|0;a[s+11|0]=0;s=v;c[s>>2]=c[N>>2];c[s+4>>2]=c[N+4>>2];c[s+8>>2]=c[N+8>>2];s=(x=0,ar(98,u|0,b|0,e|0,f|0,v|0,h|0)|0);if(x){x=0;v=bQ(-1,-1)|0;t=v;v=K;if((a[M]&1)==0){P=t;Q=v;R=P;S=0;T=R;U=Q;be(T|0)}J2(c[u+8>>2]|0);P=t;Q=v;R=P;S=0;T=R;U=Q;be(T|0)}if((a[M]&1)!=0){J2(c[u+8>>2]|0)}L34:do{if((V|0)==0){u=J0(60)|0;c[p>>2]=u;M=d+4|0;v=c[M>>2]|0;t=d+8|0;if((v|0)==(c[t>>2]|0)){ee(d|0,p);W=c[p>>2]|0}else{if((v|0)==0){X=0}else{c[v>>2]=u;X=c[M>>2]|0}c[M>>2]=X+4;W=u}u=W;v=W;g=f;L44:do{if((a[g]&1)==0){L=w;c[L>>2]=c[g>>2];c[L+4>>2]=c[g+4>>2];c[L+8>>2]=c[g+8>>2];Y=31}else{L=c[f+8>>2]|0;O=c[f+4>>2]|0;do{if(O>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(O>>>0<11>>>0){a[w]=O<<1;Z=w+1|0}else{_=O+16&-16;$=(x=0,as(230,_|0)|0);if(x){x=0;break}c[w+8>>2]=$;c[w>>2]=_|1;c[w+4>>2]=O;Z=$}Kb(Z|0,L|0,O)|0;a[Z+O|0]=0;Y=31;break L44}}while(0);O=bQ(-1,-1)|0;aa=O;ab=K}}while(0);do{if((Y|0)==31){g=o;c[g>>2]=c[N>>2];c[g+4>>2]=c[N+4>>2];c[g+8>>2]=c[N+8>>2];x=0;aB(34,v|0,w|0,o|0,1,0,0);if(x){x=0;g=bQ(-1,-1)|0;O=g;g=K;if((a[w]&1)==0){aa=O;ab=g;break}J2(c[w+8>>2]|0);aa=O;ab=g;break}if((a[w]&1)!=0){J2(c[w+8>>2]|0)}g=y;O=y;a[O]=10;L=g+1|0;a[L]=a[1488]|0;a[L+1|0]=a[1489]|0;a[L+2|0]=a[1490]|0;a[L+3|0]=a[1491]|0;a[L+4|0]=a[1492]|0;a[g+6|0]=0;g=z;c[g>>2]=c[N>>2];c[g+4>>2]=c[N+4>>2];c[g+8>>2]=c[N+8>>2];g=(x=0,ar(108,y|0,b|0,e|0,f|0,z|0,h|0)|0);do{if(!x){L=W+36|0;$=L;c[n>>2]=g;_=L+8|0;ac=_;ad=c[ac>>2]|0;if((ad|0)==(c[L+12>>2]|0)){x=0;aq(370,L+4|0,n|0);if(x){x=0;break}ae=c[n>>2]|0}else{if((ad|0)==0){af=0}else{c[ad>>2]=g;af=c[ac>>2]|0}c[_>>2]=af+4;ae=g}x=0;aq(c[c[L>>2]>>2]|0,$|0,ae|0);if(x){x=0;break}if((a[O]&1)==0){ag=v;ah=M;ai=t;break L34}J2(c[y+8>>2]|0);ag=v;ah=M;ai=t;break L34}else{x=0}}while(0);g=bQ(-1,-1)|0;$=g;g=K;if((a[O]&1)==0){P=$;Q=g;R=P;S=0;T=R;U=Q;be(T|0)}J2(c[y+8>>2]|0);P=$;Q=g;R=P;S=0;T=R;U=Q;be(T|0)}}while(0);t=c[d>>2]|0;v=c[M>>2]|0;g=t;while(1){if((g|0)==(v|0)){aj=v;break}if((c[g>>2]|0)==(W|0)){aj=g;break}else{g=g+4|0}}g=aj-t>>2;$=t+(g+1<<2)|0;L=v-$|0;Kc(t+(g<<2)|0,$|0,L|0)|0;$=t+((L>>2)+g<<2)|0;g=c[M>>2]|0;if(($|0)!=(g|0)){c[M>>2]=g+(~((g-4+(-$|0)|0)>>>2)<<2)}J2(u);P=aa;Q=ab;R=P;S=0;T=R;U=Q;be(T|0)}else{ag=V;ah=d+4|0;ai=d+8|0}}while(0);V=J0(60)|0;c[m>>2]=V;ab=c[ah>>2]|0;if((ab|0)==(c[ai>>2]|0)){ee(d|0,m);ak=c[m>>2]|0}else{if((ab|0)==0){al=0}else{c[ab>>2]=V;al=c[ah>>2]|0}c[ah>>2]=al+4;ak=V}V=ak;al=ak;ab=f;L100:do{if((a[ab]&1)==0){m=A;c[m>>2]=c[ab>>2];c[m+4>>2]=c[ab+4>>2];c[m+8>>2]=c[ab+8>>2];Y=74}else{m=c[f+8>>2]|0;ai=c[f+4>>2]|0;do{if(ai>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ai>>>0<11>>>0){a[A]=ai<<1;am=A+1|0}else{aa=ai+16&-16;aj=(x=0,as(230,aa|0)|0);if(x){x=0;break}c[A+8>>2]=aj;c[A>>2]=aa|1;c[A+4>>2]=ai;am=aj}Kb(am|0,m|0,ai)|0;a[am+ai|0]=0;Y=74;break L100}}while(0);ai=bQ(-1,-1)|0;an=ai;ao=K}}while(0);do{if((Y|0)==74){am=B;c[am>>2]=c[N>>2];c[am+4>>2]=c[N+4>>2];c[am+8>>2]=c[N+8>>2];ai=ag+36|0;m=((c[ag+44>>2]|0)-(c[ag+40>>2]|0)>>2)+1|0;u=l;c[u>>2]=c[am>>2];c[u+4>>2]=c[am+4>>2];c[u+8>>2]=c[am+8>>2];x=0;aB(34,al|0,A|0,l|0,m|0,0,0);if(x){x=0;m=bQ(-1,-1)|0;am=m;m=K;if((a[A]&1)==0){an=am;ao=m;break}J2(c[A+8>>2]|0);an=am;ao=m;break}if((a[A]&1)!=0){J2(c[A+8>>2]|0)}m=s+40|0;if((a[m]&1)==0){am=E;c[am>>2]=c[m>>2];c[am+4>>2]=c[m+4>>2];c[am+8>>2]=c[m+8>>2]}else{m=c[s+48>>2]|0;am=c[s+44>>2]|0;if(am>>>0>4294967279>>>0){CJ(0);return 0}if(am>>>0<11>>>0){a[E]=am<<1;at=E+1|0}else{u=am+16&-16;M=J0(u)|0;c[E+8>>2]=M;c[E>>2]=u|1;c[E+4>>2]=am;at=M}Kb(at|0,m|0,am)|0;a[at+am|0]=0}x=0;aq(180,D|0,E|0);if(x){x=0;am=bQ(-1,-1)|0;m=am;am=K;if((a[E]&1)==0){P=m;Q=am;R=P;S=0;T=R;U=Q;be(T|0)}J2(c[E+8>>2]|0);P=m;Q=am;R=P;S=0;T=R;U=Q;be(T|0)}if((a[E]&1)!=0){J2(c[E+8>>2]|0)}am=D;m=D;M=a[m]|0;u=M&255;t=(u&1|0)==0;if(t){au=u>>>1}else{au=c[D+4>>2]|0}v=(M&1)==0;if(v){av=am+1|0}else{av=c[D+8>>2]|0}M=au>>>0>5>>>0;do{if((Kd(av|0,640,(M?5:au)|0)|0)==0){if(!(au>>>0>4>>>0&(M^1))){Y=111;break}c[ak+52>>2]=0;Y=197}else{Y=111}}while(0);L154:do{if((Y|0)==111){if(t){aw=u>>>1}else{aw=c[D+4>>2]|0}if(v){ay=am+1|0}else{ay=c[D+8>>2]|0}M=aw>>>0>5>>>0;do{if((Kd(ay|0,608,(M?5:aw)|0)|0)==0){if(!(aw>>>0>4>>>0&(M^1))){break}c[ak+52>>2]=1;Y=197;break L154}}while(0);if(t){az=u>>>1}else{az=c[D+4>>2]|0}if(v){aA=am+1|0}else{aA=c[D+8>>2]|0}M=az>>>0>4>>>0;if((Kd(aA|0,552,(M?4:az)|0)|0)==0){if(az>>>0>3>>>0&(M^1)){Y=197;break}}M=Kf(e|0)|0;if(M>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Y=109;break}return 0}if(M>>>0<11>>>0){O=M<<1&255;aj=H;aa=H;a[aa]=O;aC=aj+1|0;aD=O;aE=aj;aF=aa}else{aa=M+16&-16;aj=(x=0,as(230,aa|0)|0);if(x){x=0;Y=109;break}c[H+8>>2]=aj;O=aa|1;c[H>>2]=O;c[H+4>>2]=M;aC=aj;aD=O&255;aE=H;aF=H}Kb(aC|0,e|0,M)|0;a[aC+M|0]=0;M=G;Ke(M|0,0,12)|0;O=aD&255;if((O&1|0)==0){aG=O>>>1}else{aG=c[H+4>>2]|0}O=aG+26|0;do{if(O>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Y=149;break}return 0}else{if(O>>>0<11>>>0){a[M]=52;aH=G+1|0}else{aj=aG+42&-16;aa=(x=0,as(230,aj|0)|0);if(x){x=0;Y=149;break}c[G+8>>2]=aa;c[G>>2]=aj|1;c[G+4>>2]=26;aH=aa}Kb(aH|0,464,26)|0;a[aH+26|0]=0;if((aD&1)==0){aI=aE+1|0}else{aI=c[H+8>>2]|0}x=0,ax(64,G|0,aI|0,aG|0)|0;if(x){x=0;Y=149;break}aa=F;Ke(aa|0,0,12)|0;aj=a[M]|0;W=aj&255;if((W&1|0)==0){aJ=W>>>1}else{aJ=c[G+4>>2]|0}if((aj&1)==0){aL=G+1|0}else{aL=c[G+8>>2]|0}aj=aJ+37|0;do{if(aj>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Y=165;break}return 0}else{if(aj>>>0<11>>>0){a[aa]=aJ<<1;aM=F+1|0}else{W=aJ+53&-16;y=(x=0,as(230,W|0)|0);if(x){x=0;Y=165;break}c[F+8>>2]=y;c[F>>2]=W|1;c[F+4>>2]=aJ;aM=y}Kb(aM|0,aL|0,aJ)|0;a[aM+aJ|0]=0;x=0,ax(64,F|0,400,37)|0;if(x){x=0;Y=165;break}L224:do{if((a[ab]&1)==0){y=I;c[y>>2]=c[ab>>2];c[y+4>>2]=c[ab+4>>2];c[y+8>>2]=c[ab+8>>2];Y=177}else{y=c[f+8>>2]|0;W=c[f+4>>2]|0;do{if(W>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(W>>>0<11>>>0){a[I]=W<<1;aN=I+1|0}else{ae=W+16&-16;af=(x=0,as(230,ae|0)|0);if(x){x=0;break}c[I+8>>2]=af;c[I>>2]=ae|1;c[I+4>>2]=W;aN=af}Kb(aN|0,y|0,W)|0;a[aN+W|0]=0;Y=177;break L224}}while(0);W=bQ(-1,-1)|0;aO=W;aQ=K}}while(0);do{if((Y|0)==177){W=J;c[W>>2]=c[N>>2];c[W+4>>2]=c[N+4>>2];c[W+8>>2]=c[N+8>>2];x=0;aP(362,F|0,I|0,J|0);if(x){x=0;W=bQ(-1,-1)|0;y=W;W=K;if((a[I]&1)==0){aO=y;aQ=W;break}J2(c[I+8>>2]|0);aO=y;aQ=W;break}if((a[I]&1)!=0){J2(c[I+8>>2]|0)}if((a[aa]&1)!=0){J2(c[F+8>>2]|0)}if((a[M]&1)!=0){J2(c[G+8>>2]|0)}if((a[aF]&1)==0){Y=197;break L154}J2(c[H+8>>2]|0);Y=197;break L154}}while(0);if((a[aa]&1)==0){aR=aO;aS=aQ;break}J2(c[F+8>>2]|0);aR=aO;aS=aQ}}while(0);if((Y|0)==165){aj=bQ(-1,-1)|0;W=K;if((a[aa]&1)!=0){J2(c[F+8>>2]|0)}aR=aj;aS=W}if((a[M]&1)==0){aT=aR;aU=aS;break}J2(c[G+8>>2]|0);aT=aR;aU=aS}}while(0);if((Y|0)==149){O=bQ(-1,-1)|0;W=K;if((a[M]&1)!=0){J2(c[G+8>>2]|0)}aT=O;aU=W}if((a[aF]&1)==0){aV=aT;aW=aU;break}J2(c[H+8>>2]|0);aV=aT;aW=aU}}while(0);L269:do{if((Y|0)==197){am=ak+36|0;v=am;u=(ag|0)==0?0:ai;t=u+4|0;W=c[t>>2]|0;O=(c[u+8>>2]|0)-W>>2;L271:do{if((O|0)==0){u=am+8|0;aX=u;aY=u;aZ=am+12|0}else{u=am+8|0;aj=u;y=am+12|0;af=am+4|0;ae=am;n=0;h=W;while(1){z=c[h+(n<<2)>>2]|0;c[k>>2]=z;b=c[aj>>2]|0;if((b|0)==(c[y>>2]|0)){x=0;aq(370,af|0,k|0);if(x){x=0;break}a_=c[k>>2]|0}else{if((b|0)==0){a$=0}else{c[b>>2]=z;a$=c[aj>>2]|0}c[u>>2]=a$+4;a_=z}x=0;aq(c[c[ae>>2]>>2]|0,v|0,a_|0);if(x){x=0;break}z=n+1|0;if(z>>>0>=O>>>0){aX=u;aY=aj;aZ=y;break L271}n=z;h=c[t>>2]|0}h=bQ(-1,-1)|0;a0=K;a1=h;Y=110;break L269}}while(0);c[q>>2]=r;t=c[aY>>2]|0;if((t|0)==(c[aZ>>2]|0)){x=0;aq(370,am+4|0,q|0);if(x){x=0;Y=109;break}a2=c[q>>2]|0}else{if((t|0)==0){a3=0}else{c[t>>2]=r;a3=c[aY>>2]|0}c[aX>>2]=a3+4;a2=r}x=0;aq(c[c[am>>2]>>2]|0,v|0,a2|0);if(x){x=0;Y=109;break}t=ak;if((a[m]&1)==0){i=j;return t|0}J2(c[D+8>>2]|0);i=j;return t|0}}while(0);if((Y|0)==109){ai=bQ(-1,-1)|0;a0=K;a1=ai;Y=110}if((Y|0)==110){aV=a1;aW=a0}if((a[m]&1)==0){P=aV;Q=aW;R=P;S=0;T=R;U=Q;be(T|0)}J2(c[D+8>>2]|0);P=aV;Q=aW;R=P;S=0;T=R;U=Q;be(T|0)}}while(0);aW=c[d>>2]|0;d=c[ah>>2]|0;aV=aW;while(1){if((aV|0)==(d|0)){a4=d;break}if((c[aV>>2]|0)==(ak|0)){a4=aV;break}else{aV=aV+4|0}}aV=a4-aW>>2;a4=aW+(aV+1<<2)|0;ak=d-a4|0;Kc(aW+(aV<<2)|0,a4|0,ak|0)|0;a4=aW+((ak>>2)+aV<<2)|0;aV=c[ah>>2]|0;if((a4|0)!=(aV|0)){c[ah>>2]=aV+(~((aV-4+(-a4|0)|0)>>>2)<<2)}J2(V);P=an;Q=ao;R=P;S=0;T=R;U=Q;be(T|0);return 0}function pa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0;j=i;i=i+184|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+16|0;n=j+32|0;o=j+40|0;p=j+56|0;q=j+64|0;r=j+72|0;s=j+88|0;t=j+96|0;u=j+104|0;v=j+120|0;w=j+136|0;y=j+152|0;z=j+168|0;A=J0(60)|0;c[t>>2]=A;B=d+4|0;C=c[B>>2]|0;D=d+8|0;if((C|0)==(c[D>>2]|0)){ee(d|0,t);E=c[t>>2]|0}else{if((C|0)==0){F=0}else{c[C>>2]=A;F=c[B>>2]|0}c[B>>2]=F+4;E=A}A=E;F=u;C=u;a[C]=12;t=F+1|0;a[t]=a[168]|0;a[t+1|0]=a[169]|0;a[t+2|0]=a[170]|0;a[t+3|0]=a[171]|0;a[t+4|0]=a[172]|0;a[t+5|0]=a[173]|0;a[F+7|0]=0;F=v;t=g;c[F>>2]=c[t>>2];c[F+4>>2]=c[t+4>>2];c[F+8>>2]=c[t+8>>2];F=(x=0,ar(50,u|0,b|0,e|0,f|0,v|0,h|0)|0);do{if(!x){h=E;v=E|0;c[v>>2]=16616;e=E+4|0;b=F+4|0;if((a[b]&1)==0){g=e;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2]}else{b=c[F+12>>2]|0;g=c[F+8>>2]|0;if(g>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=25;break}return 0}if(g>>>0<11>>>0){a[e]=g<<1;H=e+1|0}else{I=g+16&-16;J=(x=0,as(230,I|0)|0);if(x){x=0;G=25;break}c[E+12>>2]=J;c[e>>2]=I|1;c[E+8>>2]=g;H=J}Kb(H|0,b|0,g)|0;a[H+g|0]=0}g=E+16|0;b=F+16|0;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[v>>2]=21792;a[E+28|0]=a[F+28|0]&1;a[h+29|0]=a[F+29|0]&1;c[E+32>>2]=c[F+32>>2];h=E+36|0;c[h>>2]=21616;x=0;aq(678,E+40|0,F+40|0);if(x){x=0;b=bQ(-1,-1)|0;g=K;c[v>>2]=16616;if((a[e]&1)==0){L=g;M=b;break}J2(c[E+12>>2]|0);L=g;M=b;break}c[v>>2]=18696;c[h>>2]=18756;c[E+52>>2]=c[F+52>>2];a[E+56|0]=a[F+56|0]&1;if((a[C]&1)!=0){J2(c[u+8>>2]|0)}v=h+8|0;b=h+4|0;h=c[b>>2]|0;g=(c[v>>2]|0)-h>>2;L30:do{if((g|0)==0){N=0}else{e=d|0;J=f;I=w;O=w+8|0;P=f+8|0;Q=f+4|0;R=w+1|0;S=w|0;T=w+4|0;U=0;V=0;W=h;while(1){X=c[W+(V<<2)>>2]|0;if((X|0)==0){G=35}else{Y=JP(X,31088,30264,-1)|0;if((Y|0)==0){G=35}else{Z=Y}}if((G|0)==35){G=0;Y=J0(60)|0;c[s>>2]=Y;X=c[B>>2]|0;if((X|0)==(c[D>>2]|0)){ee(e,s);_=c[s>>2]|0}else{if((X|0)==0){$=0}else{c[X>>2]=Y;$=c[B>>2]|0}c[B>>2]=$+4;_=Y}aa=_;Y=_;if((a[J]&1)==0){c[I>>2]=c[J>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2]}else{X=c[P>>2]|0;ab=c[Q>>2]|0;if(ab>>>0>4294967279>>>0){G=43;break}if(ab>>>0<11>>>0){a[I]=ab<<1;ac=R}else{ad=ab+16&-16;ae=(x=0,as(230,ad|0)|0);if(x){x=0;G=59;break}c[O>>2]=ae;c[S>>2]=ad|1;c[T>>2]=ab;ac=ae}Kb(ac|0,X|0,ab)|0;a[ac+ab|0]=0}ab=r;c[ab>>2]=c[t>>2];c[ab+4>>2]=c[t+4>>2];c[ab+8>>2]=c[t+8>>2];x=0;aB(34,Y|0,w|0,r|0,1,0,0);if(x){x=0;G=62;break}if((a[I]&1)!=0){J2(c[O>>2]|0)}ab=_+36|0;X=ab;ae=c[(c[b>>2]|0)+(V<<2)>>2]|0;c[q>>2]=ae;ad=ab+8|0;af=ad;ag=c[af>>2]|0;if((ag|0)==(c[ab+12>>2]|0)){eq(ab+4|0,q);ah=c[q>>2]|0}else{if((ag|0)==0){ai=0}else{c[ag>>2]=ae;ai=c[af>>2]|0}c[ad>>2]=ai+4;ah=ae}cy[c[c[ab>>2]>>2]&1023](X,ah);c[(c[b>>2]|0)+(V<<2)>>2]=_;Z=Y}Y=(c[Z+44>>2]|0)-(c[Z+40>>2]|0)>>2;if((V|0)==0){aj=Y}else{aj=Y>>>0<U>>>0?Y:U}Y=V+1|0;if(Y>>>0>=g>>>0){N=aj;break L30}U=aj;V=Y;W=c[b>>2]|0}do{if((G|0)==62){W=bQ(-1,-1)|0;V=W;W=K;if((a[I]&1)==0){ak=V;al=W;break}J2(c[O>>2]|0);ak=V;al=W}else if((G|0)==43){x=0;ap(232,0);if(!x){return 0}else{x=0;W=bQ(-1,-1)|0;am=K;an=W;G=61;break}}else if((G|0)==59){W=bQ(-1,-1)|0;am=K;an=W;G=61}}while(0);if((G|0)==61){ak=an;al=am}O=c[d>>2]|0;I=c[B>>2]|0;W=O;while(1){if((W|0)==(I|0)){ao=I;break}if((c[W>>2]|0)==(_|0)){ao=W;break}else{W=W+4|0}}W=ao-O>>2;V=O+(W+1<<2)|0;U=I-V|0;Kc(O+(W<<2)|0,V|0,U|0)|0;V=O+((U>>2)+W<<2)|0;W=c[B>>2]|0;if((V|0)!=(W|0)){c[B>>2]=W+(~((W-4+(-V|0)|0)>>>2)<<2)}J2(aa);at=ak;au=al;av=at;aw=0;ax=av;ay=au;be(ax|0)}}while(0);g=J0(60)|0;c[p>>2]=g;h=c[B>>2]|0;if((h|0)==(c[D>>2]|0)){ee(d|0,p);az=c[p>>2]|0}else{if((h|0)==0){aA=0}else{c[h>>2]=g;aA=c[B>>2]|0}c[B>>2]=aA+4;az=g}g=az;h=f;L98:do{if((a[h]&1)==0){V=y;c[V>>2]=c[h>>2];c[V+4>>2]=c[h+4>>2];c[V+8>>2]=c[h+8>>2];G=89}else{V=c[f+8>>2]|0;W=c[f+4>>2]|0;do{if(W>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(W>>>0<11>>>0){a[y]=W<<1;aC=y+1|0}else{U=W+16&-16;T=(x=0,as(230,U|0)|0);if(x){x=0;break}c[y+8>>2]=T;c[y>>2]=U|1;c[y+4>>2]=W;aC=T}Kb(aC|0,V|0,W)|0;a[aC+W|0]=0;G=89;break L98}}while(0);W=bQ(-1,-1)|0;aD=W;aE=K}}while(0);do{if((G|0)==89){W=o;c[W>>2]=c[t>>2];c[W+4>>2]=c[t+4>>2];c[W+8>>2]=c[t+8>>2];x=0;aB(34,az|0,y|0,o|0,N|0,1,0);if(x){x=0;W=bQ(-1,-1)|0;V=W;W=K;if((a[y]&1)==0){aD=V;aE=W;break}J2(c[y+8>>2]|0);aD=V;aE=W;break}if((a[y]&1)!=0){J2(c[y+8>>2]|0)}W=(c[v>>2]|0)-(c[b>>2]|0)>>2;if((N|0)==0){aF=az;i=j;return aF|0}V=d|0;O=z;I=z+8|0;T=(W|0)==0;U=az+36|0;S=U;R=U+8|0;Q=R;P=U+12|0;J=U+4|0;e=U;U=f+8|0;Y=f+4|0;X=z+1|0;ab=z|0;ae=z+4|0;ad=0;while(1){af=J0(60)|0;c[n>>2]=af;ag=c[B>>2]|0;if((ag|0)==(c[D>>2]|0)){ee(V,n);aG=c[n>>2]|0}else{if((ag|0)==0){aH=0}else{c[ag>>2]=af;aH=c[B>>2]|0}c[B>>2]=aH+4;aG=af}aI=aG;if((a[h]&1)==0){c[O>>2]=c[h>>2];c[O+4>>2]=c[h+4>>2];c[O+8>>2]=c[h+8>>2]}else{af=c[U>>2]|0;ag=c[Y>>2]|0;if(ag>>>0>4294967279>>>0){G=102;break}if(ag>>>0<11>>>0){a[O]=ag<<1;aJ=X}else{aK=ag+16&-16;aL=(x=0,as(230,aK|0)|0);if(x){x=0;G=129;break}c[I>>2]=aL;c[ab>>2]=aK|1;c[ae>>2]=ag;aJ=aL}Kb(aJ|0,af|0,ag)|0;a[aJ+ag|0]=0}ag=m;c[ag>>2]=c[t>>2];c[ag+4>>2]=c[t+4>>2];c[ag+8>>2]=c[t+8>>2];x=0;aB(34,aG|0,z|0,m|0,W|0,0,0);if(x){x=0;G=132;break}if((a[O]&1)!=0){J2(c[I>>2]|0)}if(!T){ag=aG+36|0;af=ag;aL=ag+8|0;aK=aL;aM=ag+12|0;aN=ag+4|0;aO=ag;ag=0;do{aP=c[(c[(c[(c[b>>2]|0)+(ag<<2)>>2]|0)+40>>2]|0)+(ad<<2)>>2]|0;c[l>>2]=aP;aQ=c[aK>>2]|0;if((aQ|0)==(c[aM>>2]|0)){eq(aN,l);aR=c[l>>2]|0}else{if((aQ|0)==0){aS=0}else{c[aQ>>2]=aP;aS=c[aK>>2]|0}c[aL>>2]=aS+4;aR=aP}cy[c[c[aO>>2]>>2]&1023](af,aR);ag=ag+1|0;}while(ag>>>0<W>>>0)}ag=aG;c[k>>2]=ag;af=c[Q>>2]|0;if((af|0)==(c[P>>2]|0)){eq(J,k);aT=c[k>>2]|0}else{if((af|0)==0){aU=0}else{c[af>>2]=ag;aU=c[Q>>2]|0}c[R>>2]=aU+4;aT=ag}cy[c[c[e>>2]>>2]&1023](S,aT);ag=ad+1|0;if(ag>>>0<N>>>0){ad=ag}else{G=153;break}}do{if((G|0)==132){ad=bQ(-1,-1)|0;S=ad;ad=K;if((a[O]&1)==0){aV=S;aW=ad;break}J2(c[I>>2]|0);aV=S;aW=ad}else if((G|0)==153){aF=az;i=j;return aF|0}else if((G|0)==102){x=0;ap(232,0);if(!x){return 0}else{x=0;ad=bQ(-1,-1)|0;aX=K;aY=ad;G=131;break}}else if((G|0)==129){ad=bQ(-1,-1)|0;aX=K;aY=ad;G=131}}while(0);if((G|0)==131){aV=aY;aW=aX}I=c[d>>2]|0;O=c[B>>2]|0;ad=I;while(1){if((ad|0)==(O|0)){aZ=O;break}if((c[ad>>2]|0)==(aG|0)){aZ=ad;break}else{ad=ad+4|0}}ad=aZ-I>>2;S=I+(ad+1<<2)|0;e=O-S|0;Kc(I+(ad<<2)|0,S|0,e|0)|0;S=I+((e>>2)+ad<<2)|0;ad=c[B>>2]|0;if((S|0)!=(ad|0)){c[B>>2]=ad+(~((ad-4+(-S|0)|0)>>>2)<<2)}J2(aI);at=aV;au=aW;av=at;aw=0;ax=av;ay=au;be(ax|0)}}while(0);b=c[d>>2]|0;h=c[B>>2]|0;v=b;while(1){if((v|0)==(h|0)){a_=h;break}if((c[v>>2]|0)==(az|0)){a_=v;break}else{v=v+4|0}}v=a_-b>>2;S=b+(v+1<<2)|0;ad=h-S|0;Kc(b+(v<<2)|0,S|0,ad|0)|0;S=b+((ad>>2)+v<<2)|0;v=c[B>>2]|0;if((S|0)!=(v|0)){c[B>>2]=v+(~((v-4+(-S|0)|0)>>>2)<<2)}J2(g);at=aD;au=aE;av=at;aw=0;ax=av;ay=au;be(ax|0)}else{x=0;G=25}}while(0);if((G|0)==25){G=bQ(-1,-1)|0;L=K;M=G}G=M;M=L;if((a[C]&1)!=0){J2(c[u+8>>2]|0)}u=c[d>>2]|0;d=c[B>>2]|0;C=u;while(1){if((C|0)==(d|0)){a$=d;break}if((c[C>>2]|0)==(E|0)){a$=C;break}else{C=C+4|0}}C=a$-u>>2;a$=u+(C+1<<2)|0;E=d-a$|0;Kc(u+(C<<2)|0,a$|0,E|0)|0;a$=u+((E>>2)+C<<2)|0;C=c[B>>2]|0;if((a$|0)!=(C|0)){c[B>>2]=C+(~((C-4+(-a$|0)|0)>>>2)<<2)}J2(A);at=G;au=M;av=at;aw=0;ax=av;ay=au;be(ax|0);return 0}function pb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;j=i;i=i+128|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+32|0;o=j+48|0;p=j+56|0;q=j+64|0;r=j+80|0;s=j+96|0;t=j+112|0;u=q;a[u]=14;v=q+1|0;a[v]=a[12400]|0;a[v+1|0]=a[12401]|0;a[v+2|0]=a[12402]|0;a[v+3|0]=a[12403]|0;a[v+4|0]=a[12404]|0;a[v+5|0]=a[12405]|0;a[v+6|0]=a[12406]|0;v=q+8|0;a[v]=0;w=r;y=g;c[w>>2]=c[y>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];w=(x=0,ar(50,q|0,b|0,e|0,f|0,r|0,h|0)|0);if(x){x=0;h=bQ(-1,-1)|0;r=h;h=K;if((a[u]&1)==0){z=r;A=h;B=z;C=0;D=B;E=A;be(D|0)}J2(c[v>>2]|0);z=r;A=h;B=z;C=0;D=B;E=A;be(D|0)}if((a[u]&1)!=0){J2(c[v>>2]|0)}v=c[w+40>>2]|0;do{if(((c[w+44>>2]|0)-v|0)==4){u=c[v>>2]|0;if((u|0)!=0){h=JP(u,31088,30264,-1)|0;if((h|0)!=0){F=h;break}}h=J0(60)|0;c[o>>2]=h;r=d+4|0;e=c[r>>2]|0;if((e|0)==(c[d+8>>2]|0)){ee(d|0,o);G=c[o>>2]|0}else{if((e|0)==0){H=0}else{c[e>>2]=h;H=c[r>>2]|0}c[r>>2]=H+4;G=h}h=G;e=f;L23:do{if((a[e]&1)==0){b=s;c[b>>2]=c[e>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];I=24}else{b=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[s]=q<<1;J=s+1|0}else{g=q+16&-16;L=(x=0,as(230,g|0)|0);if(x){x=0;break}c[s+8>>2]=L;c[s>>2]=g|1;c[s+4>>2]=q;J=L}Kb(J|0,b|0,q)|0;a[J+q|0]=0;I=24;break L23}}while(0);q=bQ(-1,-1)|0;M=q;N=K}}while(0);do{if((I|0)==24){e=n;c[e>>2]=c[y>>2];c[e+4>>2]=c[y+4>>2];c[e+8>>2]=c[y+8>>2];x=0;aB(34,G|0,s|0,n|0,1,1,0);if(x){x=0;e=bQ(-1,-1)|0;q=e;e=K;if((a[s]&1)==0){M=q;N=e;break}J2(c[s+8>>2]|0);M=q;N=e;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}e=G+36|0;q=e;c[m>>2]=u;b=e+8|0;L=b;g=c[L>>2]|0;if((g|0)==(c[e+12>>2]|0)){eq(e+4|0,m);O=c[m>>2]|0}else{if((g|0)==0){P=0}else{c[g>>2]=u;P=c[L>>2]|0}c[b>>2]=P+4;O=u}cy[c[c[e>>2]>>2]&1023](q,O);Q=h;R=Q;i=j;return R|0}}while(0);u=c[d>>2]|0;q=c[r>>2]|0;e=u;while(1){if((e|0)==(q|0)){S=q;break}if((c[e>>2]|0)==(G|0)){S=e;break}else{e=e+4|0}}e=S-u>>2;b=u+(e+1<<2)|0;L=q-b|0;Kc(u+(e<<2)|0,b|0,L|0)|0;b=u+((L>>2)+e<<2)|0;e=c[r>>2]|0;if((b|0)!=(e|0)){c[r>>2]=e+(~((e-4+(-b|0)|0)>>>2)<<2)}J2(h);z=M;A=N;B=z;C=0;D=B;E=A;be(D|0)}else{F=w}}while(0);w=J0(60)|0;c[l>>2]=w;N=d+4|0;M=c[N>>2]|0;if((M|0)==(c[d+8>>2]|0)){ee(d|0,l);T=c[l>>2]|0}else{if((M|0)==0){U=0}else{c[M>>2]=w;U=c[N>>2]|0}c[N>>2]=U+4;T=w}w=T;U=f;L70:do{if((a[U]&1)==0){M=t;c[M>>2]=c[U>>2];c[M+4>>2]=c[U+4>>2];c[M+8>>2]=c[U+8>>2];I=57}else{M=c[f+8>>2]|0;l=c[f+4>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(l>>>0<11>>>0){a[t]=l<<1;V=t+1|0}else{S=l+16&-16;G=(x=0,as(230,S|0)|0);if(x){x=0;break}c[t+8>>2]=G;c[t>>2]=S|1;c[t+4>>2]=l;V=G}Kb(V|0,M|0,l)|0;a[V+l|0]=0;I=57;break L70}}while(0);l=bQ(-1,-1)|0;W=l;X=K}}while(0);do{if((I|0)==57){V=k;c[V>>2]=c[y>>2];c[V+4>>2]=c[y+4>>2];c[V+8>>2]=c[y+8>>2];x=0;aB(34,T|0,t|0,k|0,0,1,0);if(x){x=0;V=bQ(-1,-1)|0;f=V;V=K;if((a[t]&1)==0){W=f;X=V;break}J2(c[t+8>>2]|0);W=f;X=V;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}V=F+40|0;f=c[V>>2]|0;U=(c[F+44>>2]|0)-f>>2;if((U|0)==0){Q=w;R=Q;i=j;return R|0}l=T+36|0;M=l;h=l+8|0;r=h;u=l+12|0;q=l+4|0;G=l;l=0;S=f;while(1){f=c[S+(l<<2)>>2]|0;do{if((f|0)==0){I=74}else{O=JP(f,31088,30032,-1)|0;if((O|0)==0){I=74;break}if((a[O+36|0]&1)!=0){I=74}}}while(0);if((I|0)==74){I=0;f=c[(c[V>>2]|0)+(l<<2)>>2]|0;c[p>>2]=f;O=c[r>>2]|0;if((O|0)==(c[u>>2]|0)){eq(q,p);Y=c[p>>2]|0}else{if((O|0)==0){Z=0}else{c[O>>2]=f;Z=c[r>>2]|0}c[h>>2]=Z+4;Y=f}cy[c[c[G>>2]>>2]&1023](M,Y)}f=l+1|0;if(f>>>0>=U>>>0){Q=w;break}l=f;S=c[V>>2]|0}R=Q;i=j;return R|0}}while(0);R=c[d>>2]|0;d=c[N>>2]|0;j=R;while(1){if((j|0)==(d|0)){_=d;break}if((c[j>>2]|0)==(T|0)){_=j;break}else{j=j+4|0}}j=_-R>>2;_=R+(j+1<<2)|0;T=d-_|0;Kc(R+(j<<2)|0,_|0,T|0)|0;_=R+((T>>2)+j<<2)|0;j=c[N>>2]|0;if((_|0)!=(j|0)){c[N>>2]=j+(~((j-4+(-_|0)|0)>>>2)<<2)}J2(w);z=W;A=X;B=z;C=0;D=B;E=A;be(D|0);return 0}function pc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;j=i;i=i+200|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+48|0;p=j+64|0;q=j+80|0;r=j+88|0;s=j+104|0;t=j+120|0;u=j+136|0;v=j+152|0;w=j+168|0;y=j+184|0;z=o;A=o;a[A]=12;B=z+1|0;a[B]=a[2776]|0;a[B+1|0]=a[2777]|0;a[B+2|0]=a[2778]|0;a[B+3|0]=a[2779]|0;a[B+4|0]=a[2780]|0;a[B+5|0]=a[2781]|0;a[z+7|0]=0;z=p;B=g;c[z>>2]=c[B>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];z=(x=0,ar(108,o|0,b|0,e|0,f|0,p|0,h|0)|0);if(x){x=0;p=bQ(-1,-1)|0;g=p;p=K;if((a[A]&1)==0){C=p;D=g;E=D;F=0;G=E;H=C;be(G|0)}J2(c[o+8>>2]|0);C=p;D=g;E=D;F=0;G=E;H=C;be(G|0)}if((a[A]&1)!=0){J2(c[o+8>>2]|0)}L11:do{if((c[z+32>>2]|0)==4){Ac(q,0);x=0;aP(c[(c[z>>2]|0)+28>>2]|0,r|0,z|0,q|0);L13:do{if(!x){L16:do{if((iG(d+148|0,r)|0)==0){I=0;J=0}else{o=(x=0,as(230,52)|0);do{if(!x){A=o;c[n>>2]=A;g=d+4|0;p=c[g>>2]|0;if((p|0)==(c[d+8>>2]|0)){x=0;aq(376,d|0,n|0);if(x){x=0;L=31;break}M=c[n>>2]|0}else{if((p|0)==0){N=0}else{c[p>>2]=A;N=c[g>>2]|0}c[g>>2]=N+4;M=A}A=M;p=f;L28:do{if((a[p]&1)==0){O=s;c[O>>2]=c[p>>2];c[O+4>>2]=c[p+4>>2];c[O+8>>2]=c[p+8>>2];L=24}else{O=c[f+8>>2]|0;P=c[f+4>>2]|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(P>>>0<11>>>0){a[s]=P<<1;Q=s+1|0}else{R=P+16&-16;S=(x=0,as(230,R|0)|0);if(x){x=0;break}c[s+8>>2]=S;c[s>>2]=R|1;c[s+4>>2]=P;Q=S}Kb(Q|0,O|0,P)|0;a[Q+P|0]=0;L=24;break L28}}while(0);P=bQ(-1,-1)|0;T=K;U=P}}while(0);do{if((L|0)==24){p=m;c[p>>2]=c[B>>2];c[p+4>>2]=c[B+4>>2];c[p+8>>2]=c[B+8>>2];x=0;ao(34,M|0,s|0,m|0,12304,0);if(x){x=0;p=bQ(-1,-1)|0;P=p;p=K;if((a[s]&1)==0){T=p;U=P;break}J2(c[s+8>>2]|0);T=p;U=P;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}I=1;J=M;break L16}}while(0);P=c[d>>2]|0;p=c[g>>2]|0;O=P;while(1){if((O|0)==(p|0)){V=p;break}if((c[O>>2]|0)==(M|0)){V=O;break}else{O=O+4|0}}O=V-P>>2;S=P+(O+1<<2)|0;R=p-S|0;Kc(P+(O<<2)|0,S|0,R|0)|0;S=P+((R>>2)+O<<2)|0;O=c[g>>2]|0;if((S|0)!=(O|0)){c[g>>2]=O+(~((O-4+(-S|0)|0)>>>2)<<2)}J2(A);W=T;X=U}else{x=0;L=31}}while(0);if((L|0)==31){o=bQ(-1,-1)|0;W=K;X=o}if((a[r]&1)==0){Y=W;Z=X;break L13}J2(c[r+8>>2]|0);Y=W;Z=X;break L13}}while(0);if((a[r]&1)!=0){J2(c[r+8>>2]|0)}Ae(q);if((I|0)==1){_=J}else{break L11}i=j;return _|0}else{x=0;o=bQ(-1,-1)|0;Y=K;Z=o}}while(0);x=0;ap(436,q|0);if(!x){C=Y;D=Z;E=D;F=0;G=E;H=C;be(G|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);Z=J0(52)|0;c[l>>2]=Z;Y=d+4|0;q=c[Y>>2]|0;if((q|0)==(c[d+8>>2]|0)){ee(d|0,l);$=c[l>>2]|0}else{if((q|0)==0){aa=0}else{c[q>>2]=Z;aa=c[Y>>2]|0}c[Y>>2]=aa+4;$=Z}Z=$;aa=$;q=f;L79:do{if((a[q]&1)==0){l=t;c[l>>2]=c[q>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];L=62}else{l=c[f+8>>2]|0;J=c[f+4>>2]|0;do{if(J>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(J>>>0<11>>>0){a[t]=J<<1;ab=t+1|0}else{I=J+16&-16;r=(x=0,as(230,I|0)|0);if(x){x=0;break}c[t+8>>2]=r;c[t>>2]=I|1;c[t+4>>2]=J;ab=r}Kb(ab|0,l|0,J)|0;a[ab+J|0]=0;L=62;break L79}}while(0);J=bQ(-1,-1)|0;ac=K;ad=J}}while(0);do{if((L|0)==62){ab=u;c[ab>>2]=c[B>>2];c[ab+4>>2]=c[B+4>>2];c[ab+8>>2]=c[B+8>>2];q=w;J=w;a[J]=12;l=q+1|0;a[l]=a[2776]|0;a[l+1|0]=a[2777]|0;a[l+2|0]=a[2778]|0;a[l+3|0]=a[2779]|0;a[l+4|0]=a[2780]|0;a[l+5|0]=a[2781]|0;a[q+7|0]=0;q=y;c[q>>2]=c[B>>2];c[q+4>>2]=c[B+4>>2];c[q+8>>2]=c[B+8>>2];q=(x=0,ar(108,w|0,b|0,e|0,f|0,y|0,h|0)|0);do{if(!x){x=0;aq(c[(c[q>>2]|0)+40>>2]|0,v|0,q|0);if(x){x=0;L=72;break}l=k;c[l>>2]=c[ab>>2];c[l+4>>2]=c[ab+4>>2];c[l+8>>2]=c[ab+8>>2];x=0;ao(26,aa|0,t|0,k|0,v|0,0);if(x){x=0;l=bQ(-1,-1)|0;r=l;l=K;if((a[v]&1)==0){ae=l;af=r;break}J2(c[v+8>>2]|0);ae=l;af=r;break}r=$;if((a[v]&1)!=0){J2(c[v+8>>2]|0)}if((a[J]&1)!=0){J2(c[w+8>>2]|0)}if((a[t]&1)==0){_=r;i=j;return _|0}J2(c[t+8>>2]|0);_=r;i=j;return _|0}else{x=0;L=72}}while(0);if((L|0)==72){ab=bQ(-1,-1)|0;ae=K;af=ab}if((a[J]&1)!=0){J2(c[w+8>>2]|0)}if((a[t]&1)==0){ac=ae;ad=af;break}J2(c[t+8>>2]|0);ac=ae;ad=af}}while(0);af=c[d>>2]|0;d=c[Y>>2]|0;ae=af;while(1){if((ae|0)==(d|0)){ag=d;break}if((c[ae>>2]|0)==($|0)){ag=ae;break}else{ae=ae+4|0}}ae=ag-af>>2;ag=af+(ae+1<<2)|0;$=d-ag|0;Kc(af+(ae<<2)|0,ag|0,$|0)|0;ag=af+(($>>2)+ae<<2)|0;ae=c[Y>>2]|0;if((ag|0)!=(ae|0)){c[Y>>2]=ae+(~((ae-4+(-ag|0)|0)>>>2)<<2)}J2(Z);C=ac;D=ad;E=D;F=0;G=E;H=C;be(G|0);return 0}function pd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0;j=i;i=i+120|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+56|0;p=j+72|0;q=j+88|0;r=j+104|0;s=J0(52)|0;c[l>>2]=s;t=d+4|0;u=c[t>>2]|0;if((u|0)==(c[d+8>>2]|0)){ee(d|0,l);v=c[l>>2]|0}else{if((u|0)==0){w=0}else{c[u>>2]=s;w=c[t>>2]|0}c[t>>2]=w+4;v=s}s=v;w=v;u=f;L8:do{if((a[u]&1)==0){l=m;c[l>>2]=c[u>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];y=16}else{l=c[f+8>>2]|0;z=c[f+4>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[m]=z<<1;A=m+1|0}else{B=z+16&-16;C=(x=0,as(230,B|0)|0);if(x){x=0;break}c[m+8>>2]=C;c[m>>2]=B|1;c[m+4>>2]=z;A=C}Kb(A|0,l|0,z)|0;a[A+z|0]=0;y=16;break L8}}while(0);z=bQ(-1,-1)|0;D=K;E=z}}while(0);do{if((y|0)==16){A=n;u=g;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];z=q;a[z]=14;l=q+1|0;a[l]=a[12224]|0;a[l+1|0]=a[12225]|0;a[l+2|0]=a[12226]|0;a[l+3|0]=a[12227]|0;a[l+4|0]=a[12228]|0;a[l+5|0]=a[12229]|0;a[l+6|0]=a[12230]|0;l=q+8|0;a[l]=0;C=r;c[C>>2]=c[u>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];u=(x=0,ar(40,q|0,b|0,e|0,f|0,r|0,h|0)|0);do{if(!x){x=0;aq(248,p|0,u|0);if(x){x=0;y=30;break}x=0;aP(266,o|0,p|0,34);do{if(!x){C=k;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];x=0;ao(26,w|0,m|0,k|0,o|0,0);if(x){x=0;C=bQ(-1,-1)|0;B=C;C=K;if((a[o]&1)==0){F=C;G=B;break}J2(c[o+8>>2]|0);F=C;G=B;break}B=v;if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}if((a[z]&1)!=0){J2(c[l>>2]|0)}if((a[m]&1)==0){i=j;return B|0}J2(c[m+8>>2]|0);i=j;return B|0}else{x=0;B=bQ(-1,-1)|0;F=K;G=B}}while(0);if((a[p]&1)==0){H=F;I=G;break}J2(c[p+8>>2]|0);H=F;I=G}else{x=0;y=30}}while(0);if((y|0)==30){A=bQ(-1,-1)|0;H=K;I=A}if((a[z]&1)!=0){J2(c[l>>2]|0)}if((a[m]&1)==0){D=H;E=I;break}J2(c[m+8>>2]|0);D=H;E=I}}while(0);I=c[d>>2]|0;d=c[t>>2]|0;H=I;while(1){if((H|0)==(d|0)){J=d;break}if((c[H>>2]|0)==(v|0)){J=H;break}else{H=H+4|0}}H=J-I>>2;J=I+(H+1<<2)|0;v=d-J|0;Kc(I+(H<<2)|0,J|0,v|0)|0;J=I+((v>>2)+H<<2)|0;H=c[t>>2]|0;if((J|0)==(H|0)){J2(s);L=E;M=0;N=L;O=D;be(N|0)}c[t>>2]=H+(~((H-4+(-J|0)|0)>>>2)<<2);J2(s);L=E;M=0;N=L;O=D;be(N|0);return 0}function pe(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=i;i=i+72|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+24|0;n=j+40|0;o=j+56|0;p=J0(40)|0;c[k>>2]=p;q=d+4|0;r=c[q>>2]|0;if((r|0)==(c[d+8>>2]|0)){ee(d|0,k);s=c[k>>2]|0}else{if((r|0)==0){t=0}else{c[r>>2]=p;t=c[q>>2]|0}c[q>>2]=t+4;s=p}p=s;t=s;r=f;L8:do{if((a[r]&1)==0){k=l;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];u=16}else{k=c[f+8>>2]|0;v=c[f+4>>2]|0;do{if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(v>>>0<11>>>0){a[l]=v<<1;w=l+1|0}else{y=v+16&-16;z=(x=0,as(230,y|0)|0);if(x){x=0;break}c[l+8>>2]=z;c[l>>2]=y|1;c[l+4>>2]=v;w=z}Kb(w|0,k|0,v)|0;a[w+v|0]=0;u=16;break L8}}while(0);v=bQ(-1,-1)|0;A=K;B=v}}while(0);do{if((u|0)==16){w=m;r=g;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];w=n;a[w]=14;v=n+1|0;a[v]=a[12224]|0;a[v+1|0]=a[12225]|0;a[v+2|0]=a[12226]|0;a[v+3|0]=a[12227]|0;a[v+4|0]=a[12228]|0;a[v+5|0]=a[12229]|0;a[v+6|0]=a[12230]|0;v=n+8|0;a[v]=0;k=o;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];r=(x=0,ar(40,n|0,b|0,e|0,f|0,o|0,h|0)|0);do{if(!x){if((c[r+48>>2]|0)==(c[r+52>>2]|0)){C=(c[r+60>>2]|0)==(c[r+64>>2]|0)}else{C=0}x=0;aT(4,t|0,l|0,m|0,C|0);if(x){x=0;break}k=s;if((a[w]&1)!=0){J2(c[v>>2]|0)}if((a[l]&1)==0){i=j;return k|0}J2(c[l+8>>2]|0);i=j;return k|0}else{x=0}}while(0);r=bQ(-1,-1)|0;k=r;r=K;if((a[w]&1)!=0){J2(c[v>>2]|0)}if((a[l]&1)==0){A=r;B=k;break}J2(c[l+8>>2]|0);A=r;B=k}}while(0);l=c[d>>2]|0;d=c[q>>2]|0;j=l;while(1){if((j|0)==(d|0)){D=d;break}if((c[j>>2]|0)==(s|0)){D=j;break}else{j=j+4|0}}j=D-l>>2;D=l+(j+1<<2)|0;s=d-D|0;Kc(l+(j<<2)|0,D|0,s|0)|0;D=l+((s>>2)+j<<2)|0;j=c[q>>2]|0;if((D|0)==(j|0)){J2(p);E=B;F=0;G=E;H=A;be(G|0)}c[q>>2]=j+(~((j-4+(-D|0)|0)>>>2)<<2);J2(p);E=B;F=0;G=E;H=A;be(G|0);return 0}function pf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0;j=i;i=i+264|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+16|0;n=j+32|0;o=j+48|0;p=j+64|0;q=j+80|0;r=j+96|0;s=j+112|0;t=j+184|0;u=j+200|0;v=j+216|0;w=j+232|0;y=j+248|0;z=m;A=m;a[A]=18;Kb(z+1|0,12e3,9)|0;a[z+10|0]=0;z=n;B=g;c[z>>2]=c[B>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];z=(x=0,ar(40,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(x){x=0;n=bQ(-1,-1)|0;g=n;n=K;if((a[A]&1)==0){C=n;D=g;E=D;F=0;G=E;H=C;be(G|0)}J2(c[m+8>>2]|0);C=n;D=g;E=D;F=0;G=E;H=C;be(G|0)}if((a[A]&1)!=0){J2(c[m+8>>2]|0)}m=o;A=o;a[A]=18;Kb(m+1|0,11936,9)|0;a[m+10|0]=0;m=p;c[m>>2]=c[B>>2];c[m+4>>2]=c[B+4>>2];c[m+8>>2]=c[B+8>>2];m=(x=0,ar(40,o|0,b|0,e|0,f|0,p|0,h|0)|0);if(x){x=0;h=bQ(-1,-1)|0;p=h;h=K;if((a[A]&1)==0){C=h;D=p;E=D;F=0;G=E;H=C;be(G|0)}J2(c[o+8>>2]|0);C=h;D=p;E=D;F=0;G=E;H=C;be(G|0)}if((a[A]&1)!=0){J2(c[o+8>>2]|0)}if((c[z+48>>2]|0)==(c[z+52>>2]|0)){if((c[z+60>>2]|0)!=(c[z+64>>2]|0)){I=9}}else{I=9}do{if((I|0)==9){if((c[m+48>>2]|0)==(c[m+52>>2]|0)){if((c[m+60>>2]|0)==(c[m+64>>2]|0)){break}}kx(s,m);x=0;aq(324,t|0,z|0);do{if(!x){x=0;aq(752,s|0,t|0);if(x){x=0;o=bQ(-1,-1)|0;A=o;o=K;if((a[t]&1)==0){J=o;L=A;break}J2(c[t+8>>2]|0);J=o;L=A;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}A=(x=0,as(230,40)|0);if(x){x=0;I=91;break}o=A;c[k>>2]=o;A=d+4|0;p=c[A>>2]|0;if((p|0)==(c[d+8>>2]|0)){x=0;aq(376,d|0,k|0);if(x){x=0;I=91;break}M=c[k>>2]|0}else{if((p|0)==0){N=0}else{c[p>>2]=o;N=c[A>>2]|0}c[A>>2]=N+4;M=o}o=M;p=M;h=f;L46:do{if((a[h]&1)==0){e=u;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];I=63}else{e=c[f+8>>2]|0;b=c[f+4>>2]|0;do{if(b>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(b>>>0<11>>>0){a[u]=b<<1;O=u+1|0}else{g=b+16&-16;n=(x=0,as(230,g|0)|0);if(x){x=0;break}c[u+8>>2]=n;c[u>>2]=g|1;c[u+4>>2]=b;O=n}Kb(O|0,e|0,b)|0;a[O+b|0]=0;I=63;break L46}}while(0);b=bQ(-1,-1)|0;P=K;Q=b}}while(0);do{if((I|0)==63){h=v;c[h>>2]=c[B>>2];c[h+4>>2]=c[B+4>>2];c[h+8>>2]=c[B+8>>2];x=0;aq(248,w|0,z|0);do{if(!x){x=0;aq(248,y|0,s|0);do{if(!x){h=w;b=a[w]|0;e=b&255;if((e&1|0)==0){R=e>>>1}else{R=c[w+4>>2]|0}e=y;n=a[y]|0;g=n&255;if((g&1|0)==0){S=g>>>1}else{S=c[y+4>>2]|0}L75:do{if((R|0)==(S|0)){g=(b&1)==0;if(g){T=h+1|0}else{T=c[w+8>>2]|0}if((n&1)==0){U=e+1|0}else{U=c[y+8>>2]|0}if(!g){V=(Kd(T|0,U|0,R|0)|0)==0;break}if((R|0)==0){V=1;break}else{W=U;X=T;Y=R}while(1){if((a[X]|0)!=(a[W]|0)){V=0;break L75}g=Y-1|0;if((g|0)==0){V=1;break}else{W=W+1|0;X=X+1|0;Y=g}}}else{V=0}}while(0);x=0;aT(4,p|0,u|0,v|0,V|0);if(x){x=0;e=bQ(-1,-1)|0;h=e;e=K;if((n&1)==0){Z=e;_=h;$=b;break}J2(c[y+8>>2]|0);Z=e;_=h;$=b;break}if((n&1)!=0){J2(c[y+8>>2]|0)}if((b&1)!=0){J2(c[w+8>>2]|0)}if((a[u]&1)!=0){J2(c[u+8>>2]|0)}iW(s);aa=o;ab=aa;i=j;return ab|0}else{x=0;h=bQ(-1,-1)|0;Z=K;_=h;$=a[w]|0}}while(0);if(($&1)==0){ac=Z;ad=_;break}J2(c[w+8>>2]|0);ac=Z;ad=_}else{x=0;h=bQ(-1,-1)|0;ac=K;ad=h}}while(0);if((a[u]&1)==0){P=ac;Q=ad;break}J2(c[u+8>>2]|0);P=ac;Q=ad}}while(0);p=c[d>>2]|0;h=c[A>>2]|0;e=p;while(1){if((e|0)==(h|0)){ae=h;break}if((c[e>>2]|0)==(M|0)){ae=e;break}else{e=e+4|0}}e=ae-p>>2;g=p+(e+1<<2)|0;af=h-g|0;Kc(p+(e<<2)|0,g|0,af|0)|0;g=p+((af>>2)+e<<2)|0;e=c[A>>2]|0;if((g|0)!=(e|0)){c[A>>2]=e+(~((e-4+(-g|0)|0)>>>2)<<2)}J2(o);J=P;L=Q}else{x=0;I=91}}while(0);if((I|0)==91){g=bQ(-1,-1)|0;J=K;L=g}x=0;ap(486,s|0);if(!x){C=J;D=L;E=D;F=0;G=E;H=C;be(G|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}}while(0);L=J0(40)|0;c[l>>2]=L;J=d+4|0;s=c[J>>2]|0;if((s|0)==(c[d+8>>2]|0)){ee(d|0,l);ag=c[l>>2]|0}else{if((s|0)==0){ah=0}else{c[s>>2]=L;ah=c[J>>2]|0}c[J>>2]=ah+4;ag=L}L=ag;ah=f;L132:do{if((a[ah]&1)==0){s=q;c[s>>2]=c[ah>>2];c[s+4>>2]=c[ah+4>>2];c[s+8>>2]=c[ah+8>>2];I=26}else{s=c[f+8>>2]|0;l=c[f+4>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(l>>>0<11>>>0){a[q]=l<<1;ai=q+1|0}else{Q=l+16&-16;P=(x=0,as(230,Q|0)|0);if(x){x=0;break}c[q+8>>2]=P;c[q>>2]=Q|1;c[q+4>>2]=l;ai=P}Kb(ai|0,s|0,l)|0;a[ai+l|0]=0;I=26;break L132}}while(0);l=bQ(-1,-1)|0;aj=K;ak=l}}while(0);do{if((I|0)==26){ai=r;c[ai>>2]=c[B>>2];c[ai+4>>2]=c[B+4>>2];c[ai+8>>2]=c[B+8>>2];x=0;aT(4,ag|0,q|0,r|0,1);if(x){x=0;ai=bQ(-1,-1)|0;f=ai;ai=K;if((a[q]&1)==0){aj=ai;ak=f;break}J2(c[q+8>>2]|0);aj=ai;ak=f;break}if((a[q]&1)==0){aa=L;ab=aa;i=j;return ab|0}J2(c[q+8>>2]|0);aa=L;ab=aa;i=j;return ab|0}}while(0);ab=c[d>>2]|0;d=c[J>>2]|0;j=ab;while(1){if((j|0)==(d|0)){al=d;break}if((c[j>>2]|0)==(ag|0)){al=j;break}else{j=j+4|0}}j=al-ab>>2;al=ab+(j+1<<2)|0;ag=d-al|0;Kc(ab+(j<<2)|0,al|0,ag|0)|0;al=ab+((ag>>2)+j<<2)|0;j=c[J>>2]|0;if((al|0)!=(j|0)){c[J>>2]=j+(~((j-4+(-al|0)|0)>>>2)<<2)}J2(L);C=aj;D=ak;E=D;F=0;G=E;H=C;be(G|0);return 0}function pg(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;i=i+72|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+8|0;m=j+24|0;n=j+40|0;o=j+56|0;p=J0(40)|0;c[k>>2]=p;q=d+4|0;r=c[q>>2]|0;if((r|0)==(c[d+8>>2]|0)){ee(d|0,k);s=c[k>>2]|0}else{if((r|0)==0){t=0}else{c[r>>2]=p;t=c[q>>2]|0}c[q>>2]=t+4;s=p}p=s;t=s;r=f;L8:do{if((a[r]&1)==0){k=l;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];u=16}else{k=c[f+8>>2]|0;v=c[f+4>>2]|0;do{if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(v>>>0<11>>>0){a[l]=v<<1;w=l+1|0}else{y=v+16&-16;z=(x=0,as(230,y|0)|0);if(x){x=0;break}c[l+8>>2]=z;c[l>>2]=y|1;c[l+4>>2]=v;w=z}Kb(w|0,k|0,v)|0;a[w+v|0]=0;u=16;break L8}}while(0);v=bQ(-1,-1)|0;A=K;B=v}}while(0);do{if((u|0)==16){w=m;r=g;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];w=n;v=n;a[v]=12;k=w+1|0;a[k]=a[2776]|0;a[k+1|0]=a[2777]|0;a[k+2|0]=a[2778]|0;a[k+3|0]=a[2779]|0;a[k+4|0]=a[2780]|0;a[k+5|0]=a[2781]|0;a[w+7|0]=0;w=o;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];r=(x=0,ar(108,n|0,b|0,e|0,f|0,o|0,h|0)|0);do{if(!x){w=(x=0,as(c[(c[r>>2]|0)+48>>2]|0,r|0)|0);if(x){x=0;break}x=0;aT(4,t|0,l|0,m|0,w|0);if(x){x=0;break}w=s;if((a[v]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)==0){i=j;return w|0}J2(c[l+8>>2]|0);i=j;return w|0}else{x=0}}while(0);r=bQ(-1,-1)|0;w=r;r=K;if((a[v]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)==0){A=r;B=w;break}J2(c[l+8>>2]|0);A=r;B=w}}while(0);l=c[d>>2]|0;d=c[q>>2]|0;n=l;while(1){if((n|0)==(d|0)){C=d;break}if((c[n>>2]|0)==(s|0)){C=n;break}else{n=n+4|0}}n=C-l>>2;C=l+(n+1<<2)|0;s=d-C|0;Kc(l+(n<<2)|0,C|0,s|0)|0;C=l+((s>>2)+n<<2)|0;n=c[q>>2]|0;if((C|0)==(n|0)){J2(p);D=B;E=0;F=D;G=A;be(F|0)}c[q>>2]=n+(~((n-4+(-C|0)|0)>>>2)<<2);J2(p);D=B;E=0;F=D;G=A;be(F|0);return 0}function ph(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0;d=i;i=i+96|0;j=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=d|0;k=d+16|0;l=d+32|0;m=d+48|0;n=d+64|0;o=d+80|0;p=j;q=j;a[q]=20;Kb(p+1|0,11704,10)|0;a[p+11|0]=0;p=k;r=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];p=(x=0,ar(108,j|0,b|0,e|0,f|0,k|0,h|0)|0);L1:do{if(!x){k=(x=0,as(c[(c[p>>2]|0)+48>>2]|0,p|0)|0);if(x){x=0;s=13;break}do{if(k){g=l;t=l;a[t]=18;Kb(g+1|0,11592,9)|0;a[g+10|0]=0;g=m;c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];g=(x=0,ar(108,l|0,b|0,e|0,f|0,m|0,h|0)|0);if(!x){if((a[t]&1)==0){u=g;break}J2(c[l+8>>2]|0);u=g;break}else{x=0;g=bQ(-1,-1)|0;v=g;g=K;if((a[t]&1)==0){w=g;y=v;break L1}J2(c[l+8>>2]|0);w=g;y=v;break L1}}else{v=n;g=n;a[g]=16;t=v+1|0;z=t|0;C=761686308;a[z]=C;C=C>>8;a[z+1|0]=C;C=C>>8;a[z+2|0]=C;C=C>>8;a[z+3|0]=C;z=t+4|0;C=1702195828;a[z]=C;C=C>>8;a[z+1|0]=C;C=C>>8;a[z+2|0]=C;C=C>>8;a[z+3|0]=C;a[v+9|0]=0;v=o;c[v>>2]=c[r>>2];c[v+4>>2]=c[r+4>>2];c[v+8>>2]=c[r+8>>2];v=(x=0,ar(108,n|0,b|0,e|0,f|0,o|0,h|0)|0);if(!x){if((a[g]&1)==0){u=v;break}J2(c[n+8>>2]|0);u=v;break}else{x=0;v=bQ(-1,-1)|0;z=v;v=K;if((a[g]&1)==0){w=v;y=z;break L1}J2(c[n+8>>2]|0);w=v;y=z;break L1}}}while(0);if((a[q]&1)==0){i=d;return u|0}J2(c[j+8>>2]|0);i=d;return u|0}else{x=0;s=13}}while(0);if((s|0)==13){s=bQ(-1,-1)|0;w=K;y=s}if((a[q]&1)==0){A=y;B=0;D=A;E=w;be(D|0)}J2(c[j+8>>2]|0);A=y;B=0;D=A;E=w;be(D|0);return 0}function pi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,at=0,au=0,av=0,aw=0,ay=0;j=i;i=i+248|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+24|0;n=j+40|0;o=j+56|0;p=j+72|0;q=j+88|0;r=j+104|0;s=j+120|0;t=j+136|0;u=j+152|0;v=j+168|0;w=j+184|0;y=j+200|0;z=j+216|0;A=j+232|0;B=m;D=m;a[D]=10;E=B+1|0;a[E]=a[11352]|0;a[E+1|0]=a[11353]|0;a[E+2|0]=a[11354]|0;a[E+3|0]=a[11355]|0;a[E+4|0]=a[11356]|0;a[B+6|0]=0;B=n;E=g;c[B>>2]=c[E>>2];c[B+4>>2]=c[E+4>>2];c[B+8>>2]=c[E+8>>2];B=(x=0,ar(98,m|0,b|0,e|0,f|0,n|0,h|0)|0);if(x){x=0;n=bQ(-1,-1)|0;g=n;n=K;if((a[D]&1)==0){F=g;G=n;H=F;I=0;J=H;L=G;be(J|0)}J2(c[m+8>>2]|0);F=g;G=n;H=F;I=0;J=H;L=G;be(J|0)}if((a[D]&1)!=0){J2(c[m+8>>2]|0)}m=o;D=o;a[D]=20;Kb(m+1|0,11296,10)|0;a[m+11|0]=0;m=p;c[m>>2]=c[E>>2];c[m+4>>2]=c[E+4>>2];c[m+8>>2]=c[E+8>>2];m=(x=0,ar(108,o|0,b|0,e|0,f|0,p|0,h|0)|0);do{if(!x){h=(x=0,as(c[(c[m>>2]|0)+48>>2]|0,m|0)|0);if(x){x=0;break}if((a[D]&1)!=0){J2(c[o+8>>2]|0)}fh(s,d+116|0,11128);p=B+40|0;L17:do{if((a[p]&1)==0){e=u;c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];M=18}else{e=c[B+48>>2]|0;b=c[B+44>>2]|0;do{if(b>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(b>>>0<11>>>0){a[u]=b<<1;N=u+1|0}else{n=b+16&-16;g=(x=0,as(230,n|0)|0);if(x){x=0;break}c[u+8>>2]=g;c[u>>2]=n|1;c[u+4>>2]=b;N=g}Kb(N|0,e|0,b)|0;a[N+b|0]=0;M=18;break L17}}while(0);b=bQ(-1,-1)|0;O=b;P=K}}while(0);do{if((M|0)==18){x=0;aq(180,t|0,u|0);do{if(!x){x=0;aP(194,r|0,s|0,t|0);do{if(!x){x=0;aP(266,q|0,r|0,34);if(x){x=0;p=bQ(-1,-1)|0;b=p;p=K;if((a[r]&1)==0){Q=b;R=p;break}J2(c[r+8>>2]|0);Q=b;R=p;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}if((a[u]&1)!=0){J2(c[u+8>>2]|0)}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}L53:do{if(h){p=w;Ke(p|0,0,12)|0;b=q;e=a[q]|0;g=e&255;if((g&1|0)==0){S=g>>>1}else{S=c[q+4>>2]|0}g=S+4|0;do{if(g>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(g>>>0<11>>>0){a[p]=8;T=w+1|0}else{n=S+20&-16;U=(x=0,as(230,n|0)|0);if(x){x=0;break}c[w+8>>2]=U;c[w>>2]=n|1;c[w+4>>2]=4;T=U}U=T;C=678195829;a[U]=C;C=C>>8;a[U+1|0]=C;C=C>>8;a[U+2|0]=C;C=C>>8;a[U+3|0]=C;a[T+4|0]=0;if((e&1)==0){V=b+1|0}else{V=c[q+8>>2]|0}x=0,ax(64,w|0,V|0,S|0)|0;if(x){x=0;break}U=v;Ke(U|0,0,12)|0;n=a[p]|0;W=n&255;if((W&1|0)==0){X=W>>>1}else{X=c[w+4>>2]|0}if((n&1)==0){Y=w+1|0}else{Y=c[w+8>>2]|0}n=X+1|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;M=60;break}return 0}else{if(n>>>0<11>>>0){a[U]=X<<1;Z=v+1|0}else{W=X+17&-16;_=(x=0,as(230,W|0)|0);if(x){x=0;M=60;break}c[v+8>>2]=_;c[v>>2]=W|1;c[v+4>>2]=X;Z=_}Kb(Z|0,Y|0,X)|0;a[Z+X|0]=0;x=0,ax(64,v|0,5392,1)|0;if(x){x=0;M=60;break}x=0,aK(346,q|0,v|0)|0;if(x){x=0;_=bQ(-1,-1)|0;W=_;_=K;if((a[U]&1)==0){$=W;aa=_;break}J2(c[v+8>>2]|0);$=W;aa=_;break}if((a[U]&1)!=0){J2(c[v+8>>2]|0)}if((a[p]&1)==0){M=89;break L53}J2(c[w+8>>2]|0);M=89;break L53}}while(0);if((M|0)==60){n=bQ(-1,-1)|0;_=K;if((a[U]&1)!=0){J2(c[v+8>>2]|0)}$=n;aa=_}if((a[p]&1)==0){ab=$;ac=aa;break L53}J2(c[w+8>>2]|0);ab=$;ac=aa;break L53}}while(0);b=bQ(-1,-1)|0;e=K;if((a[p]&1)==0){ad=e;ae=b;M=83;break}J2(c[w+8>>2]|0);ad=e;ae=b;M=83}else{M=89}}while(0);L108:do{if((M|0)==89){b=(x=0,as(230,52)|0);do{if(!x){e=b;c[l>>2]=e;g=d+4|0;_=c[g>>2]|0;if((_|0)==(c[d+8>>2]|0)){x=0;aq(376,d|0,l|0);if(x){x=0;break}af=c[l>>2]|0}else{if((_|0)==0){ag=0}else{c[_>>2]=e;ag=c[g>>2]|0}c[g>>2]=ag+4;af=e}e=af;_=af;n=f;L120:do{if((a[n]&1)==0){W=y;c[W>>2]=c[n>>2];c[W+4>>2]=c[n+4>>2];c[W+8>>2]=c[n+8>>2];M=106}else{W=c[f+8>>2]|0;ah=c[f+4>>2]|0;do{if(ah>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ah>>>0<11>>>0){a[y]=ah<<1;ai=y+1|0}else{aj=ah+16&-16;ak=(x=0,as(230,aj|0)|0);if(x){x=0;break}c[y+8>>2]=ak;c[y>>2]=aj|1;c[y+4>>2]=ah;ai=ak}Kb(ai|0,W|0,ah)|0;a[ai+ah|0]=0;M=106;break L120}}while(0);ah=bQ(-1,-1)|0;al=ah;am=K}}while(0);do{if((M|0)==106){n=z;c[n>>2]=c[E>>2];c[n+4>>2]=c[E+4>>2];c[n+8>>2]=c[E+8>>2];U=q;L135:do{if((a[U]&1)==0){ah=A;c[ah>>2]=c[U>>2];c[ah+4>>2]=c[U+4>>2];c[ah+8>>2]=c[U+8>>2];M=116}else{ah=c[q+8>>2]|0;W=c[q+4>>2]|0;do{if(W>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(W>>>0<11>>>0){a[A]=W<<1;an=A+1|0}else{ak=W+16&-16;aj=(x=0,as(230,ak|0)|0);if(x){x=0;break}c[A+8>>2]=aj;c[A>>2]=ak|1;c[A+4>>2]=W;an=aj}Kb(an|0,ah|0,W)|0;a[an+W|0]=0;M=116;break L135}}while(0);W=bQ(-1,-1)|0;at=W;au=K}}while(0);do{if((M|0)==116){W=k;c[W>>2]=c[n>>2];c[W+4>>2]=c[n+4>>2];c[W+8>>2]=c[n+8>>2];x=0;ao(26,_|0,y|0,k|0,A|0,0);if(x){x=0;W=bQ(-1,-1)|0;ah=W;W=K;if((a[A]&1)==0){at=ah;au=W;break}J2(c[A+8>>2]|0);at=ah;au=W;break}W=af;if((a[A]&1)!=0){J2(c[A+8>>2]|0)}if((a[y]&1)!=0){J2(c[y+8>>2]|0)}if((a[U]&1)==0){i=j;return W|0}J2(c[q+8>>2]|0);i=j;return W|0}}while(0);if((a[y]&1)==0){al=at;am=au;break}J2(c[y+8>>2]|0);al=at;am=au}}while(0);_=c[d>>2]|0;U=c[g>>2]|0;n=_;while(1){if((n|0)==(U|0)){av=U;break}if((c[n>>2]|0)==(af|0)){av=n;break}else{n=n+4|0}}n=av-_>>2;W=_+(n+1<<2)|0;ah=U-W|0;Kc(_+(n<<2)|0,W|0,ah|0)|0;W=_+((ah>>2)+n<<2)|0;n=c[g>>2]|0;if((W|0)!=(n|0)){c[g>>2]=n+(~((n-4+(-W|0)|0)>>>2)<<2)}J2(e);ab=al;ac=am;break L108}else{x=0}}while(0);b=bQ(-1,-1)|0;ad=K;ae=b;M=83}}while(0);if((M|0)==83){ab=ae;ac=ad}if((a[q]&1)==0){F=ab;G=ac;H=F;I=0;J=H;L=G;be(J|0)}J2(c[q+8>>2]|0);F=ab;G=ac;H=F;I=0;J=H;L=G;be(J|0)}else{x=0;b=bQ(-1,-1)|0;Q=b;R=K}}while(0);if((a[t]&1)==0){aw=Q;ay=R;break}J2(c[t+8>>2]|0);aw=Q;ay=R}else{x=0;b=bQ(-1,-1)|0;aw=b;ay=K}}while(0);if((a[u]&1)==0){O=aw;P=ay;break}J2(c[u+8>>2]|0);O=aw;P=ay}}while(0);if((a[s]&1)==0){F=O;G=P;H=F;I=0;J=H;L=G;be(J|0)}J2(c[s+8>>2]|0);F=O;G=P;H=F;I=0;J=H;L=G;be(J|0)}else{x=0}}while(0);P=bQ(-1,-1)|0;O=P;P=K;if((a[D]&1)==0){F=O;G=P;H=F;I=0;J=H;L=G;be(J|0)}J2(c[o+8>>2]|0);F=O;G=P;H=F;I=0;J=H;L=G;be(J|0);return 0}function pj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a|0;c[d>>2]=0;e=a+4|0;c[e>>2]=0;f=a+8|0;c[f>>2]=0;a=b+4|0;g=b|0;b=(c[a>>2]|0)-(c[g>>2]|0)|0;h=b>>2;if((h|0)==0){return}do{if(h>>>0>1073741823>>>0){x=0;ap(152,0);if(x){x=0;break}}else{i=(x=0,as(230,b|0)|0);if(x){x=0;break}j=i;c[e>>2]=j;c[d>>2]=j;c[f>>2]=j+(h<<2);i=c[g>>2]|0;k=c[a>>2]|0;if((i|0)==(k|0)){return}else{l=i;m=j}do{if((m|0)==0){n=0}else{c[m>>2]=c[l>>2];n=c[e>>2]|0}m=n+4|0;c[e>>2]=m;l=l+4|0;}while((l|0)!=(k|0));return}}while(0);l=bQ(-1,-1)|0;m=c[d>>2]|0;if((m|0)==0){be(l|0)}d=c[e>>2]|0;if((m|0)!=(d|0)){c[e>>2]=d+(~((d-4+(-m|0)|0)>>>2)<<2)}J2(m);be(l|0)}function pk(b,d){b=b|0;d=d|0;var e=0;c[b>>2]=16936;e=b+4|0;a[e]=0;a[e+1|0]=0;c[b+16>>2]=0;c[b+20>>2]=d;return}function pl(b){b=b|0;var d=0;c[b>>2]=16936;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function pm(b){b=b|0;c[b>>2]=16936;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function pn(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+44|0;L1:do{if((a[k]&1)==0){l=f;a[l]=6;m=f+1|0;a[m]=a[9936]|0;a[m+1|0]=a[9937]|0;a[m+2|0]=a[9938]|0;a[f+4|0]=0;n=b+4|0;x=0,ax(64,n|0,m|0,3)|0;do{if(!x){m=c[b+20>>2]|0;if((m|0)!=0){x=0;ap(18,m+64|0);if(x){x=0;break}}if((a[l]&1)!=0){J2(c[f+8>>2]|0)}m=b+16|0;c[m>>2]=(c[m>>2]|0)+1;break L1}else{x=0}}while(0);m=bQ(-1,-1)|0;n=m;m=K;if((a[l]&1)==0){o=n;p=m;q=o;r=0;s=q;t=p;be(s|0)}J2(c[f+8>>2]|0);o=n;p=m;q=o;r=0;s=q;t=p;be(s|0)}}while(0);f=d+32|0;m=(c[d+36>>2]|0)-(c[f>>2]|0)>>2;L17:do{if((m|0)!=0){d=b|0;n=h;u=h;v=n+1|0;w=n+2|0;n=b+4|0;y=b+20|0;z=h+8|0;A=g;B=g;C=A+1|0;D=A+2|0;A=g+8|0;E=0;L19:while(1){po(b);F=c[(c[f>>2]|0)+(E<<2)>>2]|0;cy[c[(c[F>>2]|0)+8>>2]&1023](F|0,d);do{if((a[k]&1)!=0){a[B]=2;a[C]=10;a[D]=0;x=0,ax(64,n|0,C|0,1)|0;if(x){x=0;G=18;break L19}F=c[y>>2]|0;if((F|0)!=0){x=0;ap(18,F+64|0);if(x){x=0;G=18;break L19}}if((a[B]&1)==0){break}J2(c[A>>2]|0)}}while(0);a[u]=2;a[v]=10;a[w]=0;x=0,ax(64,n|0,v|0,1)|0;if(x){x=0;G=26;break}F=c[y>>2]|0;if((F|0)!=0){x=0;ap(18,F+64|0);if(x){x=0;G=26;break}}if((a[u]&1)!=0){J2(c[z>>2]|0)}E=E+1|0;if(E>>>0>=m>>>0){break L17}}if((G|0)==18){E=bQ(-1,-1)|0;y=E;E=K;if((a[B]&1)==0){o=y;p=E;q=o;r=0;s=q;t=p;be(s|0)}J2(c[A>>2]|0);o=y;p=E;q=o;r=0;s=q;t=p;be(s|0)}else if((G|0)==26){E=bQ(-1,-1)|0;y=E;E=K;if((a[u]&1)==0){o=y;p=E;q=o;r=0;s=q;t=p;be(s|0)}J2(c[z>>2]|0);o=y;p=E;q=o;r=0;s=q;t=p;be(s|0)}}}while(0);L48:do{if((a[k]&1)==0){G=b+16|0;c[G>>2]=(c[G>>2]|0)-1;po(b);G=j;m=j;a[m]=2;f=G+1|0;a[f]=125;a[G+2|0]=0;G=b+4|0;x=0,ax(64,G|0,f|0,1)|0;do{if(!x){f=c[b+20>>2]|0;if((f|0)!=0){x=0;aq(316,f+64|0,j|0);if(x){x=0;break}}if((a[m]&1)==0){break L48}J2(c[j+8>>2]|0);break L48}else{x=0}}while(0);z=bQ(-1,-1)|0;u=z;z=K;if((a[m]&1)==0){o=u;p=z;q=o;r=0;s=q;t=p;be(s|0)}J2(c[j+8>>2]|0);o=u;p=z;q=o;r=0;s=q;t=p;be(s|0)}}while(0);if((a[k]&1)==0){i=e;return}k=b+4|0;s=k;p=k;k=a[p]|0;t=k&255;q=(t&1|0)==0;if(q){H=t>>>1}else{H=c[b+8>>2]|0}if(H>>>0<=2>>>0){i=e;return}r=H-1|0;o=(k&1)==0;if(o){I=s+1|0}else{I=c[b+12>>2]|0}if((a[I+r|0]|0)!=10){i=e;return}if(o){J=s+1|0}else{J=c[b+12>>2]|0}if((a[J+(H-2)|0]|0)!=10){i=e;return}if(q){L=t>>>1}else{L=c[b+8>>2]|0}if(L>>>0<r>>>0){CK(0)}if(o){a[p]=r<<1;M=s+1|0}else{s=c[b+12>>2]|0;c[b+8>>2]=r;M=s}a[M+r|0]=0;r=c[b+20>>2]|0;if((r|0)==0){i=e;return}zj(r+64|0);i=e;return}function po(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d|0;f=c[b+16>>2]|0;g=f<<1;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){h=f<<2&255;f=e;a[f]=h;j=e+1|0;k=h;l=f}else{f=g+16&-16;h=J0(f)|0;c[e+8>>2]=h;m=f|1;c[e>>2]=m;c[e+4>>2]=g;j=h;k=m&255;l=e}Ke(j|0,32,g|0)|0;a[j+g|0]=0;if((k&1)==0){n=e+1|0}else{n=c[e+8>>2]|0}g=k&255;if((g&1|0)==0){o=g>>>1}else{o=c[e+4>>2]|0}x=0,ax(64,b+4|0,n|0,o|0)|0;do{if(!x){o=c[b+20>>2]|0;if((o|0)!=0){x=0;aq(316,o+64|0,e|0);if(x){x=0;break}}if((a[l]&1)==0){i=d;return}J2(c[e+8>>2]|0);i=d;return}else{x=0}}while(0);d=bQ(-1,-1)|0;if((a[l]&1)==0){be(d|0)}J2(c[e+8>>2]|0);be(d|0)}function pp(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+32>>2]|0;e=a|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d|0,e);d=c[b+28>>2]|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d,e);return}function pq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=c[d+32>>2]|0;h=b|0;cy[c[(c[g>>2]|0)+8>>2]&1023](g,h);g=f;j=f;a[j]=4;k=g+1|0;l=k;C=8250;a[l]=C;C=C>>8;a[l+1|0]=C;a[g+3|0]=0;x=0,ax(64,b+4|0,k|0,2)|0;do{if(!x){k=c[b+20>>2]|0;if((k|0)!=0){x=0;aq(316,k+64|0,f|0);if(x){x=0;break}}if((a[j]&1)==0){m=d+28|0;n=c[m>>2]|0;o=n;p=c[o>>2]|0;q=p+8|0;r=c[q>>2]|0;cy[r&1023](n,h);i=e;return}J2(c[f+8>>2]|0);m=d+28|0;n=c[m>>2]|0;o=n;p=c[o>>2]|0;q=p+8|0;r=c[q>>2]|0;cy[r&1023](n,h);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[j]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function pr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e|0;g=b+20|0;h=c[g>>2]|0;if((h|0)!=0){zl(h+64|0,d|0)}h=f;a[h]=14;j=f+1|0;a[j]=a[3984]|0;a[j+1|0]=a[3985]|0;a[j+2|0]=a[3986]|0;a[j+3|0]=a[3987]|0;a[j+4|0]=a[3988]|0;a[j+5|0]=a[3989]|0;a[j+6|0]=a[3990]|0;k=f+8|0;a[k]=0;x=0,ax(64,b+4|0,j|0,7)|0;do{if(!x){j=c[g>>2]|0;if((j|0)!=0){x=0;aq(316,j+64|0,f|0);if(x){x=0;break}}if((a[h]&1)!=0){J2(c[k>>2]|0)}j=c[d+32>>2]|0;l=b|0;cy[c[(c[j>>2]|0)+8>>2]&1023](j,l);j=c[d+28>>2]|0;cy[c[(c[j>>2]|0)+8>>2]&1023](j,l);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[h]&1)==0){be(e|0)}J2(c[k>>2]|0);be(e|0)}function ps(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+32|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+40>>2]|0;j=c[d+36>>2]|0;if(j>>>0>4294967279>>>0){CJ(0)}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=J0(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}Kb(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+4|0;if((l&1)==0){t=f+1|0}else{t=c[f+8>>2]|0}q=l&255;if((q&1|0)==0){u=q>>>1}else{u=c[f+4>>2]|0}x=0,ax(64,r|0,t|0,u|0)|0;do{if(!x){u=b+20|0;t=c[u>>2]|0;if((t|0)!=0){x=0;aq(316,t+64|0,f|0);if(x){x=0;break}}if((a[m]&1)!=0){J2(c[f+8>>2]|0)}t=d+44|0;L28:do{if((c[t>>2]|0)!=0){q=g;l=g;a[l]=2;j=q+1|0;a[j]=32;a[q+2|0]=0;x=0,ax(64,r|0,j|0,1)|0;do{if(!x){j=c[u>>2]|0;if((j|0)!=0){x=0;aq(316,j+64|0,g|0);if(x){x=0;break}}if((a[l]&1)!=0){J2(c[g+8>>2]|0)}j=c[t>>2]|0;cy[c[(c[j>>2]|0)+8>>2]&1023](j|0,b|0);break L28}else{x=0}}while(0);j=bQ(-1,-1)|0;q=j;j=K;if((a[l]&1)==0){v=j;w=q;y=w;z=0;A=y;B=v;be(A|0)}J2(c[g+8>>2]|0);v=j;w=q;y=w;z=0;A=y;B=v;be(A|0)}}while(0);t=c[d+28>>2]|0;if((t|0)!=0){cy[c[(c[t>>2]|0)+8>>2]&1023](t,b|0);i=e;return}t=h;q=h;a[q]=2;j=t+1|0;a[j]=59;a[t+2|0]=0;x=0,ax(64,r|0,j|0,1)|0;do{if(!x){j=c[u>>2]|0;if((j|0)!=0){x=0;aq(316,j+64|0,h|0);if(x){x=0;break}}if((a[q]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);u=bQ(-1,-1)|0;j=u;u=K;if((a[q]&1)==0){v=u;w=j;y=w;z=0;A=y;B=v;be(A|0)}J2(c[h+8>>2]|0);v=u;w=j;y=w;z=0;A=y;B=v;be(A|0)}else{x=0}}while(0);h=bQ(-1,-1)|0;e=h;h=K;if((a[m]&1)==0){v=h;w=e;y=w;z=0;A=y;B=v;be(A|0)}J2(c[f+8>>2]|0);v=h;w=e;y=w;z=0;A=y;B=v;be(A|0)}function pt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=b+20|0;k=c[j>>2]|0;if((k|0)==0){l=d+28|0}else{m=d+28|0;zl(k+64|0,c[m>>2]|0);l=m}m=c[l>>2]|0;l=b|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m,l);m=f;k=f;a[k]=4;n=m+1|0;o=n;C=8250;a[o]=C;C=C>>8;a[o+1|0]=C;a[m+3|0]=0;m=b+4|0;x=0,ax(64,m|0,n|0,2)|0;do{if(!x){n=c[j>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}n=c[j>>2]|0;if((n|0)==0){p=d+32|0}else{b=d+32|0;zl(n+64|0,c[b>>2]|0);p=b}b=c[p>>2]|0;cy[c[(c[b>>2]|0)+8>>2]&1023](b|0,l);L17:do{if((a[d+36|0]&1)!=0){b=J0(16)|0;n=g+8|0;c[n>>2]=b;c[g>>2]=17;c[g+4>>2]=11;Kb(b|0,960,11)|0;a[b+11|0]=0;o=g;x=0,ax(64,m|0,b|0,11)|0;do{if(!x){b=c[j>>2]|0;if((b|0)!=0){x=0;aq(316,b+64|0,g|0);if(x){x=0;break}}if((a[o]&1)==0){break L17}J2(c[n>>2]|0);break L17}else{x=0}}while(0);b=bQ(-1,-1)|0;q=b;b=K;if((a[o]&1)==0){r=b;s=q;t=s;u=0;v=t;w=r;be(v|0)}J2(c[n>>2]|0);r=b;s=q;t=s;u=0;v=t;w=r;be(v|0)}}while(0);q=h;b=h;a[b]=2;y=q+1|0;a[y]=59;a[q+2|0]=0;x=0,ax(64,m|0,y|0,1)|0;do{if(!x){y=c[j>>2]|0;if((y|0)!=0){x=0;aq(316,y+64|0,h|0);if(x){x=0;break}}if((a[b]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);y=bQ(-1,-1)|0;q=y;y=K;if((a[b]&1)==0){r=y;s=q;t=s;u=0;v=t;w=r;be(v|0)}J2(c[h+8>>2]|0);r=y;s=q;t=s;u=0;v=t;w=r;be(v|0)}else{x=0}}while(0);h=bQ(-1,-1)|0;e=h;h=K;if((a[k]&1)==0){r=h;s=e;t=s;u=0;v=t;w=r;be(v|0)}J2(c[f+8>>2]|0);r=h;s=e;t=s;u=0;v=t;w=r;be(v|0)}function pu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+28|0;if((a[k]&1)==0){l=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];m=a[l]|0;n=l}else{l=c[d+36>>2]|0;k=c[d+32>>2]|0;if(k>>>0>4294967279>>>0){CJ(0)}if(k>>>0<11>>>0){o=k<<1&255;p=f;a[p]=o;q=f+1|0;r=o;s=p}else{p=k+16&-16;o=J0(p)|0;c[f+8>>2]=o;t=p|1;c[f>>2]=t;c[f+4>>2]=k;q=o;r=t&255;s=f}Kb(q|0,l|0,k)|0;a[q+k|0]=0;m=r;n=s}s=b+4|0;if((m&1)==0){u=f+1|0}else{u=c[f+8>>2]|0}r=m&255;if((r&1|0)==0){v=r>>>1}else{v=c[f+4>>2]|0}x=0,ax(64,s|0,u|0,v|0)|0;do{if(!x){v=b+20|0;u=c[v>>2]|0;if((u|0)!=0){x=0;aq(316,u+64|0,f|0);if(x){x=0;break}}if((a[n]&1)!=0){J2(c[f+8>>2]|0)}u=g;r=g;a[r]=4;m=u+1|0;k=m;C=8250;a[k]=C;C=C>>8;a[k+1|0]=C;a[u+3|0]=0;x=0,ax(64,s|0,m|0,2)|0;do{if(!x){m=c[v>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,g|0);if(x){x=0;break}}if((a[r]&1)!=0){J2(c[g+8>>2]|0)}m=c[d+40>>2]|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m|0,b|0);L36:do{if((a[d+44|0]&1)!=0){m=h;u=h;a[u]=18;k=m+1|0;Kb(k|0,312,9)|0;a[m+10|0]=0;x=0,ax(64,s|0,k|0,9)|0;do{if(!x){k=c[v>>2]|0;if((k|0)!=0){x=0;aq(316,k+64|0,h|0);if(x){x=0;break}}if((a[u]&1)==0){break L36}J2(c[h+8>>2]|0);break L36}else{x=0}}while(0);k=bQ(-1,-1)|0;m=k;k=K;if((a[u]&1)==0){w=k;y=m;z=y;A=0;B=z;D=w;be(B|0)}J2(c[h+8>>2]|0);w=k;y=m;z=y;A=0;B=z;D=w;be(B|0)}}while(0);m=j;k=j;a[k]=2;q=m+1|0;a[q]=59;a[m+2|0]=0;x=0,ax(64,s|0,q|0,1)|0;do{if(!x){q=c[v>>2]|0;if((q|0)!=0){x=0;aq(316,q+64|0,j|0);if(x){x=0;break}}if((a[k]&1)==0){i=e;return}J2(c[j+8>>2]|0);i=e;return}else{x=0}}while(0);q=bQ(-1,-1)|0;m=q;q=K;if((a[k]&1)==0){w=q;y=m;z=y;A=0;B=z;D=w;be(B|0)}J2(c[j+8>>2]|0);w=q;y=m;z=y;A=0;B=z;D=w;be(B|0)}else{x=0}}while(0);v=bQ(-1,-1)|0;m=v;v=K;if((a[r]&1)==0){w=v;y=m;z=y;A=0;B=z;D=w;be(B|0)}J2(c[g+8>>2]|0);w=v;y=m;z=y;A=0;B=z;D=w;be(B|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;j=g;g=K;if((a[n]&1)==0){w=g;y=j;z=y;A=0;B=z;D=w;be(B|0)}J2(c[f+8>>2]|0);w=g;y=j;z=y;A=0;B=z;D=w;be(B|0)}function pv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=d+40|0;m=d+44|0;if((c[l>>2]|0)==(c[m>>2]|0)){i=e;return}n=b+20|0;o=c[n>>2]|0;if((o|0)!=0){zl(o+64|0,d|0)}o=f;p=f;a[p]=16;q=o+1|0;r=q;s=r|0;C=1886218560;a[s]=C;C=C>>8;a[s+1|0]=C;C=C>>8;a[s+2|0]=C;C=C>>8;a[s+3|0]=C;s=r+4|0;C=544502383;a[s]=C;C=C>>8;a[s+1|0]=C;C=C>>8;a[s+2|0]=C;C=C>>8;a[s+3|0]=C;a[o+9|0]=0;o=b+4|0;x=0,ax(64,o|0,q|0,8)|0;do{if(!x){q=c[n>>2]|0;if((q|0)!=0){x=0;aq(316,q+64|0,f|0);if(x){x=0;break}}if((a[p]&1)!=0){J2(c[f+8>>2]|0)}q=c[c[l>>2]>>2]|0;s=b|0;cy[c[(c[q>>2]|0)+8>>2]&1023](q|0,s);q=g;r=g;a[r]=2;t=q+1|0;a[t]=59;a[q+2|0]=0;x=0,ax(64,o|0,t|0,1)|0;do{if(!x){t=c[n>>2]|0;if((t|0)!=0){x=0;aq(316,t+64|0,g|0);if(x){x=0;break}}if((a[r]&1)!=0){J2(c[g+8>>2]|0)}t=(c[m>>2]|0)-(c[l>>2]|0)>>2;if(t>>>0<=1>>>0){i=e;return}q=h;u=h;v=q+1|0;w=q+2|0;q=j;y=j;z=q+1|0;A=z;B=q+9|0;q=k;D=k;E=q+1|0;F=q+2|0;q=k+8|0;G=j+8|0;H=d|0;I=h+8|0;J=1;while(1){a[u]=2;a[v]=10;a[w]=0;x=0,ax(64,o|0,v|0,1)|0;if(x){x=0;L=27;break}M=c[n>>2]|0;if((M|0)!=0){x=0;ap(18,M+64|0);if(x){x=0;L=27;break}}if((a[u]&1)!=0){J2(c[I>>2]|0)}M=c[n>>2]|0;if((M|0)!=0){zl(M+64|0,H)}a[y]=16;M=A|0;C=1886218560;a[M]=C;C=C>>8;a[M+1|0]=C;C=C>>8;a[M+2|0]=C;C=C>>8;a[M+3|0]=C;M=A+4|0;C=544502383;a[M]=C;C=C>>8;a[M+1|0]=C;C=C>>8;a[M+2|0]=C;C=C>>8;a[M+3|0]=C;a[B]=0;x=0,ax(64,o|0,z|0,8)|0;if(x){x=0;L=40;break}M=c[n>>2]|0;if((M|0)!=0){x=0;aq(316,M+64|0,j|0);if(x){x=0;L=40;break}}if((a[y]&1)!=0){J2(c[G>>2]|0)}M=c[(c[l>>2]|0)+(J<<2)>>2]|0;cy[c[(c[M>>2]|0)+8>>2]&1023](M|0,s);a[D]=2;a[E]=59;a[F]=0;x=0,ax(64,o|0,E|0,1)|0;if(x){x=0;L=42;break}M=c[n>>2]|0;if((M|0)!=0){x=0;aq(316,M+64|0,k|0);if(x){x=0;L=42;break}}if((a[D]&1)!=0){J2(c[q>>2]|0)}M=J+1|0;if(M>>>0<t>>>0){J=M}else{L=56;break}}if((L|0)==40){J=bQ(-1,-1)|0;t=J;J=K;if((a[y]&1)==0){N=t;O=J;P=N;Q=0;R=P;S=O;be(R|0)}J2(c[G>>2]|0);N=t;O=J;P=N;Q=0;R=P;S=O;be(R|0)}else if((L|0)==56){i=e;return}else if((L|0)==42){J=bQ(-1,-1)|0;t=J;J=K;if((a[D]&1)==0){N=t;O=J;P=N;Q=0;R=P;S=O;be(R|0)}J2(c[q>>2]|0);N=t;O=J;P=N;Q=0;R=P;S=O;be(R|0)}else if((L|0)==27){J=bQ(-1,-1)|0;t=J;J=K;if((a[u]&1)==0){N=t;O=J;P=N;Q=0;R=P;S=O;be(R|0)}J2(c[I>>2]|0);N=t;O=J;P=N;Q=0;R=P;S=O;be(R|0)}}else{x=0}}while(0);s=bQ(-1,-1)|0;J=s;s=K;if((a[r]&1)==0){N=J;O=s;P=N;Q=0;R=P;S=O;be(R|0)}J2(c[g+8>>2]|0);N=J;O=s;P=N;Q=0;R=P;S=O;be(R|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;L=g;g=K;if((a[p]&1)==0){N=L;O=g;P=N;Q=0;R=P;S=O;be(R|0)}J2(c[f+8>>2]|0);N=L;O=g;P=N;Q=0;R=P;S=O;be(R|0)}function pw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=b+20|0;k=c[j>>2]|0;if((k|0)!=0){zl(k+64|0,d|0)}k=f;l=f;a[l]=16;m=k+1|0;n=m;o=n|0;C=1886218560;a[o]=C;C=C>>8;a[o+1|0]=C;C=C>>8;a[o+2|0]=C;C=C>>8;a[o+3|0]=C;o=n+4|0;C=544502383;a[o]=C;C=C>>8;a[o+1|0]=C;C=C>>8;a[o+2|0]=C;C=C>>8;a[o+3|0]=C;a[k+9|0]=0;k=b+4|0;x=0,ax(64,k|0,m|0,8)|0;do{if(!x){m=c[j>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[l]&1)!=0){J2(c[f+8>>2]|0)}m=d+28|0;if((a[m]&1)==0){b=g;c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];p=a[b]|0;q=b}else{b=c[d+36>>2]|0;m=c[d+32>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){o=m<<1&255;n=g;a[n]=o;r=g+1|0;s=o;t=n}else{n=m+16&-16;o=J0(n)|0;c[g+8>>2]=o;u=n|1;c[g>>2]=u;c[g+4>>2]=m;r=o;s=u&255;t=g}Kb(r|0,b|0,m)|0;a[r+m|0]=0;p=s;q=t}if((p&1)==0){v=g+1|0}else{v=c[g+8>>2]|0}m=p&255;if((m&1|0)==0){w=m>>>1}else{w=c[g+4>>2]|0}x=0,ax(64,k|0,v|0,w|0)|0;do{if(!x){m=c[j>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,g|0);if(x){x=0;break}}if((a[q]&1)!=0){J2(c[g+8>>2]|0)}m=h;b=h;a[b]=2;u=m+1|0;a[u]=59;a[m+2|0]=0;x=0,ax(64,k|0,u|0,1)|0;do{if(!x){u=c[j>>2]|0;if((u|0)!=0){x=0;aq(316,u+64|0,h|0);if(x){x=0;break}}if((a[b]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);u=bQ(-1,-1)|0;m=u;u=K;if((a[b]&1)==0){y=u;z=m;A=z;B=0;D=A;E=y;be(D|0)}J2(c[h+8>>2]|0);y=u;z=m;A=z;B=0;D=A;E=y;be(D|0)}else{x=0}}while(0);m=bQ(-1,-1)|0;u=m;m=K;if((a[q]&1)==0){y=m;z=u;A=z;B=0;D=A;E=y;be(D|0)}J2(c[g+8>>2]|0);y=m;z=u;A=z;B=0;D=A;E=y;be(D|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;q=g;g=K;if((a[l]&1)==0){y=g;z=q;A=z;B=0;D=A;E=y;be(D|0)}J2(c[f+8>>2]|0);y=g;z=q;A=z;B=0;D=A;E=y;be(D|0)}function px(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=b+20|0;j=c[h>>2]|0;if((j|0)!=0){zl(j+64|0,d|0)}j=f;k=f;a[k]=12;l=j+1|0;a[l]=a[11344]|0;a[l+1|0]=a[11345]|0;a[l+2|0]=a[11346]|0;a[l+3|0]=a[11347]|0;a[l+4|0]=a[11348]|0;a[l+5|0]=a[11349]|0;a[j+7|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,6)|0;do{if(!x){l=c[h>>2]|0;if((l|0)!=0){x=0;aq(316,l+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}l=c[d+28>>2]|0;cy[c[(c[l>>2]|0)+8>>2]&1023](l|0,b|0);l=g;m=g;a[m]=2;n=l+1|0;a[n]=59;a[l+2|0]=0;x=0,ax(64,j|0,n|0,1)|0;do{if(!x){n=c[h>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,g|0);if(x){x=0;break}}if((a[m]&1)==0){i=e;return}J2(c[g+8>>2]|0);i=e;return}else{x=0}}while(0);n=bQ(-1,-1)|0;l=n;n=K;if((a[m]&1)==0){o=n;p=l;q=p;r=0;s=q;t=o;be(s|0)}J2(c[g+8>>2]|0);o=n;p=l;q=p;r=0;s=q;t=o;be(s|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;e=g;g=K;if((a[k]&1)==0){o=g;p=e;q=p;r=0;s=q;t=o;be(s|0)}J2(c[f+8>>2]|0);o=g;p=e;q=p;r=0;s=q;t=o;be(s|0)}function py(a,b){a=a|0;b=b|0;var d=0;d=c[b+28>>2]|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d,a|0);return}function pz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=8;l=j+1|0;m=l;C=543582528;a[m]=C;C=C>>8;a[m+1|0]=C;C=C>>8;a[m+2|0]=C;C=C>>8;a[m+3|0]=C;a[j+5|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,4)|0;do{if(!x){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}m=c[d+28>>2]|0;n=b|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m|0,n);m=c[d+32>>2]|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m,n);m=d+36|0;if((c[m>>2]|0)==0){i=e;return}o=g;p=g;a[p]=2;q=o+1|0;a[q]=10;a[o+2|0]=0;x=0,ax(64,j|0,q|0,1)|0;do{if(!x){q=c[l>>2]|0;if((q|0)!=0){x=0;ap(18,q+64|0);if(x){x=0;break}}if((a[p]&1)!=0){J2(c[g+8>>2]|0)}po(b);q=h;o=h;a[o]=8;r=q+1|0;s=r;C=1702063205;a[s]=C;C=C>>8;a[s+1|0]=C;C=C>>8;a[s+2|0]=C;C=C>>8;a[s+3|0]=C;a[q+5|0]=0;x=0,ax(64,j|0,r|0,4)|0;do{if(!x){r=c[l>>2]|0;if((r|0)!=0){x=0;aq(316,r+64|0,h|0);if(x){x=0;break}}if((a[o]&1)!=0){J2(c[h+8>>2]|0)}r=c[m>>2]|0;cy[c[(c[r>>2]|0)+8>>2]&1023](r,n);i=e;return}else{x=0}}while(0);r=bQ(-1,-1)|0;q=r;r=K;if((a[o]&1)==0){t=r;u=q;v=u;w=0;y=v;z=t;be(y|0)}J2(c[h+8>>2]|0);t=r;u=q;v=u;w=0;y=v;z=t;be(y|0)}else{x=0}}while(0);n=bQ(-1,-1)|0;m=n;n=K;if((a[p]&1)==0){t=n;u=m;v=u;w=0;y=v;z=t;be(y|0)}J2(c[g+8>>2]|0);t=n;u=m;v=u;w=0;y=v;z=t;be(y|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;h=g;g=K;if((a[k]&1)==0){t=g;u=h;v=u;w=0;y=v;z=t;be(y|0)}J2(c[f+8>>2]|0);t=g;u=h;v=u;w=0;y=v;z=t;be(y|0)}function pA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=f;l=f;a[l]=10;m=k+1|0;a[m]=a[10184]|0;a[m+1|0]=a[10185]|0;a[m+2|0]=a[10186]|0;a[m+3|0]=a[10187]|0;a[m+4|0]=a[10188]|0;a[k+6|0]=0;k=b+4|0;x=0,ax(64,k|0,m|0,5)|0;do{if(!x){m=b+20|0;n=c[m>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,f|0);if(x){x=0;break}}if((a[l]&1)!=0){J2(c[f+8>>2]|0)}n=d+32|0;if((a[n]&1)==0){o=g;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];p=a[o]|0;q=o}else{o=c[d+40>>2]|0;n=c[d+36>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){r=n<<1&255;s=g;a[s]=r;t=g+1|0;u=r;v=s}else{s=n+16&-16;r=J0(s)|0;c[g+8>>2]=r;w=s|1;c[g>>2]=w;c[g+4>>2]=n;t=r;u=w&255;v=g}Kb(t|0,o|0,n)|0;a[t+n|0]=0;p=u;q=v}if((p&1)==0){y=g+1|0}else{y=c[g+8>>2]|0}n=p&255;if((n&1|0)==0){z=n>>>1}else{z=c[g+4>>2]|0}x=0,ax(64,k|0,y|0,z|0)|0;do{if(!x){n=c[m>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,g|0);if(x){x=0;break}}if((a[q]&1)!=0){J2(c[g+8>>2]|0)}n=h;o=h;a[o]=12;w=n+1|0;a[w]=a[9960]|0;a[w+1|0]=a[9961]|0;a[w+2|0]=a[9962]|0;a[w+3|0]=a[9963]|0;a[w+4|0]=a[9964]|0;a[w+5|0]=a[9965]|0;a[n+7|0]=0;x=0,ax(64,k|0,w|0,6)|0;do{if(!x){w=c[m>>2]|0;if((w|0)!=0){x=0;aq(316,w+64|0,h|0);if(x){x=0;break}}if((a[o]&1)!=0){J2(c[h+8>>2]|0)}w=c[d+44>>2]|0;n=b|0;cy[c[(c[w>>2]|0)+8>>2]&1023](w|0,n);w=(a[d+52|0]&1)!=0?9752:9568;r=Kf(w|0)|0;if(r>>>0>4294967279>>>0){CJ(0)}if(r>>>0<11>>>0){s=r<<1&255;A=j;a[A]=s;B=j+1|0;C=s;D=A}else{A=r+16&-16;s=J0(A)|0;c[j+8>>2]=s;E=A|1;c[j>>2]=E;c[j+4>>2]=r;B=s;C=E&255;D=j}Kb(B|0,w|0,r)|0;a[B+r|0]=0;if((C&1)==0){F=j+1|0}else{F=c[j+8>>2]|0}r=C&255;if((r&1|0)==0){G=r>>>1}else{G=c[j+4>>2]|0}x=0,ax(64,k|0,F|0,G|0)|0;do{if(!x){r=c[m>>2]|0;if((r|0)!=0){x=0;aq(316,r+64|0,j|0);if(x){x=0;break}}if((a[D]&1)==0){H=d+48|0;I=c[H>>2]|0;J=I|0;L=I;M=c[L>>2]|0;N=M+8|0;O=c[N>>2]|0;cy[O&1023](J,n);P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;cy[U&1023](Q,n);i=e;return}J2(c[j+8>>2]|0);H=d+48|0;I=c[H>>2]|0;J=I|0;L=I;M=c[L>>2]|0;N=M+8|0;O=c[N>>2]|0;cy[O&1023](J,n);P=d+28|0;Q=c[P>>2]|0;R=Q;S=c[R>>2]|0;T=S+8|0;U=c[T>>2]|0;cy[U&1023](Q,n);i=e;return}else{x=0}}while(0);n=bQ(-1,-1)|0;r=n;n=K;if((a[D]&1)==0){V=n;W=r;X=W;Y=0;Z=X;_=V;be(Z|0)}J2(c[j+8>>2]|0);V=n;W=r;X=W;Y=0;Z=X;_=V;be(Z|0)}else{x=0}}while(0);r=bQ(-1,-1)|0;n=r;r=K;if((a[o]&1)==0){V=r;W=n;X=W;Y=0;Z=X;_=V;be(Z|0)}J2(c[h+8>>2]|0);V=r;W=n;X=W;Y=0;Z=X;_=V;be(Z|0)}else{x=0}}while(0);m=bQ(-1,-1)|0;n=m;m=K;if((a[q]&1)==0){V=m;W=n;X=W;Y=0;Z=X;_=V;be(Z|0)}J2(c[g+8>>2]|0);V=m;W=n;X=W;Y=0;Z=X;_=V;be(Z|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;q=g;g=K;if((a[l]&1)==0){V=g;W=q;X=W;Y=0;Z=X;_=V;be(Z|0)}J2(c[f+8>>2]|0);V=g;W=q;X=W;Y=0;Z=X;_=V;be(Z|0)}function pB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=12;l=j+1|0;a[l]=a[9384]|0;a[l+1|0]=a[9385]|0;a[l+2|0]=a[9386]|0;a[l+3|0]=a[9387]|0;a[l+4|0]=a[9388]|0;a[l+5|0]=a[9389]|0;a[j+7|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,6)|0;do{if(!x){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}m=d+32|0;if((a[m]&1)==0){n=g;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];o=a[n]|0;p=n}else{n=c[d+40>>2]|0;m=c[d+36>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){q=m<<1&255;r=g;a[r]=q;s=g+1|0;t=q;u=r}else{r=m+16&-16;q=J0(r)|0;c[g+8>>2]=q;v=r|1;c[g>>2]=v;c[g+4>>2]=m;s=q;t=v&255;u=g}Kb(s|0,n|0,m)|0;a[s+m|0]=0;o=t;p=u}if((o&1)==0){w=g+1|0}else{w=c[g+8>>2]|0}m=o&255;if((m&1|0)==0){y=m>>>1}else{y=c[g+4>>2]|0}x=0,ax(64,j|0,w|0,y|0)|0;do{if(!x){m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,g|0);if(x){x=0;break}}if((a[p]&1)!=0){J2(c[g+8>>2]|0)}m=h;n=h;a[n]=8;v=m+1|0;q=v;C=544106784;a[q]=C;C=C>>8;a[q+1|0]=C;C=C>>8;a[q+2|0]=C;C=C>>8;a[q+3|0]=C;a[m+5|0]=0;x=0,ax(64,j|0,v|0,4)|0;do{if(!x){v=c[l>>2]|0;if((v|0)!=0){x=0;aq(316,v+64|0,h|0);if(x){x=0;break}}if((a[n]&1)==0){z=d+44|0;A=c[z>>2]|0;B=A|0;D=A;E=c[D>>2]|0;F=E+8|0;G=c[F>>2]|0;H=b|0;cy[G&1023](B,H);I=d+28|0;J=c[I>>2]|0;L=J;M=c[L>>2]|0;N=M+8|0;O=c[N>>2]|0;cy[O&1023](J,H);i=e;return}J2(c[h+8>>2]|0);z=d+44|0;A=c[z>>2]|0;B=A|0;D=A;E=c[D>>2]|0;F=E+8|0;G=c[F>>2]|0;H=b|0;cy[G&1023](B,H);I=d+28|0;J=c[I>>2]|0;L=J;M=c[L>>2]|0;N=M+8|0;O=c[N>>2]|0;cy[O&1023](J,H);i=e;return}else{x=0}}while(0);v=bQ(-1,-1)|0;m=v;v=K;if((a[n]&1)==0){P=v;Q=m;R=Q;S=0;T=R;U=P;be(T|0)}J2(c[h+8>>2]|0);P=v;Q=m;R=Q;S=0;T=R;U=P;be(T|0)}else{x=0}}while(0);l=bQ(-1,-1)|0;m=l;l=K;if((a[p]&1)==0){P=l;Q=m;R=Q;S=0;T=R;U=P;be(T|0)}J2(c[g+8>>2]|0);P=l;Q=m;R=Q;S=0;T=R;U=P;be(T|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;p=g;g=K;if((a[k]&1)==0){P=g;Q=p;R=Q;S=0;T=R;U=P;be(T|0)}J2(c[f+8>>2]|0);P=g;Q=p;R=Q;S=0;T=R;U=P;be(T|0)}function pC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e|0;g=f;a[g]=14;h=f+1|0;a[h]=a[9216]|0;a[h+1|0]=a[9217]|0;a[h+2|0]=a[9218]|0;a[h+3|0]=a[9219]|0;a[h+4|0]=a[9220]|0;a[h+5|0]=a[9221]|0;a[h+6|0]=a[9222]|0;j=f+8|0;a[j]=0;x=0,ax(64,b+4|0,h|0,7)|0;do{if(!x){h=c[b+20>>2]|0;if((h|0)!=0){x=0;aq(316,h+64|0,f|0);if(x){x=0;break}}if((a[g]&1)!=0){J2(c[j>>2]|0)}h=c[d+32>>2]|0;k=b|0;cy[c[(c[h>>2]|0)+8>>2]&1023](h|0,k);h=c[d+28>>2]|0;cy[c[(c[h>>2]|0)+8>>2]&1023](h,k);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[g]&1)==0){be(e|0)}J2(c[j>>2]|0);be(e|0)}function pD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=f;j=f;a[j]=16;k=h+1|0;l=k;m=l|0;C=1952805440;a[m]=C;C=C>>8;a[m+1|0]=C;C=C>>8;a[m+2|0]=C;C=C>>8;a[m+3|0]=C;m=l+4|0;C=544109173;a[m]=C;C=C>>8;a[m+1|0]=C;C=C>>8;a[m+2|0]=C;C=C>>8;a[m+3|0]=C;a[h+9|0]=0;h=b+4|0;x=0,ax(64,h|0,k|0,8)|0;do{if(!x){k=b+20|0;m=c[k>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[j]&1)!=0){J2(c[f+8>>2]|0)}m=c[d+28>>2]|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m|0,b|0);m=g;l=g;a[l]=2;n=m+1|0;a[n]=59;a[m+2|0]=0;x=0,ax(64,h|0,n|0,1)|0;do{if(!x){n=c[k>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,g|0);if(x){x=0;break}}if((a[l]&1)==0){i=e;return}J2(c[g+8>>2]|0);i=e;return}else{x=0}}while(0);k=bQ(-1,-1)|0;n=k;k=K;if((a[l]&1)==0){o=k;p=n;q=p;r=0;s=q;t=o;be(s|0)}J2(c[g+8>>2]|0);o=k;p=n;q=p;r=0;s=q;t=o;be(s|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;e=g;g=K;if((a[j]&1)==0){o=g;p=e;q=p;r=0;s=q;t=o;be(s|0)}J2(c[f+8>>2]|0);o=g;p=e;q=p;r=0;s=q;t=o;be(s|0)}function pE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=f;j=f;a[j]=16;k=h+1|0;l=k;m=l|0;C=1954047296;a[m]=C;C=C>>8;a[m+1|0]=C;C=C>>8;a[m+2|0]=C;C=C>>8;a[m+3|0]=C;m=l+4|0;C=543452773;a[m]=C;C=C>>8;a[m+1|0]=C;C=C>>8;a[m+2|0]=C;C=C>>8;a[m+3|0]=C;a[h+9|0]=0;h=b+4|0;x=0,ax(64,h|0,k|0,8)|0;do{if(!x){k=b+20|0;m=c[k>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[j]&1)!=0){J2(c[f+8>>2]|0)}m=c[d+28>>2]|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m|0,b|0);m=g;l=g;a[l]=2;n=m+1|0;a[n]=59;a[m+2|0]=0;x=0,ax(64,h|0,n|0,1)|0;do{if(!x){n=c[k>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,g|0);if(x){x=0;break}}if((a[l]&1)==0){i=e;return}J2(c[g+8>>2]|0);i=e;return}else{x=0}}while(0);k=bQ(-1,-1)|0;n=k;k=K;if((a[l]&1)==0){o=k;p=n;q=p;r=0;s=q;t=o;be(s|0)}J2(c[g+8>>2]|0);o=k;p=n;q=p;r=0;s=q;t=o;be(s|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;e=g;g=K;if((a[j]&1)==0){o=g;p=e;q=p;r=0;s=q;t=o;be(s|0)}J2(c[f+8>>2]|0);o=g;p=e;q=p;r=0;s=q;t=o;be(s|0)}function pF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;L1:do{if((c[d+52>>2]|0)==0){j=f;a[j]=14;k=f+1|0;a[k]=a[8808]|0;a[k+1|0]=a[8809]|0;a[k+2|0]=a[8810]|0;a[k+3|0]=a[8811]|0;a[k+4|0]=a[8812]|0;a[k+5|0]=a[8813]|0;a[k+6|0]=a[8814]|0;l=f+8|0;a[l]=0;m=b+4|0;x=0,ax(64,m|0,k|0,7)|0;do{if(!x){k=c[b+20>>2]|0;if((k|0)!=0){x=0;aq(316,k+64|0,f|0);if(x){x=0;break}}if((a[j]&1)==0){break L1}J2(c[l>>2]|0);break L1}else{x=0}}while(0);k=bQ(-1,-1)|0;m=k;k=K;if((a[j]&1)==0){n=k;o=m;p=o;q=0;r=p;s=n;be(r|0)}J2(c[l>>2]|0);n=k;o=m;p=o;q=0;r=p;s=n;be(r|0)}else{m=g;k=g;a[k]=20;t=m+1|0;Kb(t|0,8688,10)|0;a[m+11|0]=0;m=b+4|0;x=0,ax(64,m|0,t|0,10)|0;do{if(!x){t=c[b+20>>2]|0;if((t|0)!=0){x=0;aq(316,t+64|0,g|0);if(x){x=0;break}}if((a[k]&1)==0){break L1}J2(c[g+8>>2]|0);break L1}else{x=0}}while(0);l=bQ(-1,-1)|0;j=l;l=K;if((a[k]&1)==0){n=l;o=j;p=o;q=0;r=p;s=n;be(r|0)}J2(c[g+8>>2]|0);n=l;o=j;p=o;q=0;r=p;s=n;be(r|0)}}while(0);g=d+32|0;if((a[g]&1)==0){f=h;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];u=a[f]|0;v=f}else{f=c[d+40>>2]|0;g=c[d+36>>2]|0;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){j=g<<1&255;l=h;a[l]=j;w=h+1|0;y=j;z=l}else{l=g+16&-16;j=J0(l)|0;c[h+8>>2]=j;t=l|1;c[h>>2]=t;c[h+4>>2]=g;w=j;y=t&255;z=h}Kb(w|0,f|0,g)|0;a[w+g|0]=0;u=y;v=z}if((u&1)==0){A=h+1|0}else{A=c[h+8>>2]|0}z=u&255;if((z&1|0)==0){B=z>>>1}else{B=c[h+4>>2]|0}x=0,ax(64,b+4|0,A|0,B|0)|0;do{if(!x){B=c[b+20>>2]|0;if((B|0)!=0){x=0;aq(316,B+64|0,h|0);if(x){x=0;break}}if((a[v]&1)==0){C=d+44|0;D=c[C>>2]|0;E=D;F=c[E>>2]|0;G=F+8|0;H=c[G>>2]|0;I=b|0;cy[H&1023](D,I);J=d+28|0;L=c[J>>2]|0;M=L;N=c[M>>2]|0;O=N+8|0;P=c[O>>2]|0;cy[P&1023](L,I);i=e;return}J2(c[h+8>>2]|0);C=d+44|0;D=c[C>>2]|0;E=D;F=c[E>>2]|0;G=F+8|0;H=c[G>>2]|0;I=b|0;cy[H&1023](D,I);J=d+28|0;L=c[J>>2]|0;M=L;N=c[M>>2]|0;O=N+8|0;P=c[O>>2]|0;cy[P&1023](L,I);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;I=e;e=K;if((a[v]&1)==0){n=e;o=I;p=o;q=0;r=p;s=n;be(r|0)}J2(c[h+8>>2]|0);n=e;o=I;p=o;q=0;r=p;s=n;be(r|0)}function pG(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0;f=i;i=i+64|0;g=f|0;h=f+16|0;j=f+32|0;k=f+48|0;l=g;m=g;a[m]=18;Kb(l+1|0,8536,9)|0;a[l+10|0]=0;l=e+32|0;L1:do{if((a[l]&1)==0){n=h;c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];o=a[n]|0;p=n;q=11}else{n=c[e+40>>2]|0;r=c[e+36>>2]|0;do{if(r>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(r>>>0<11>>>0){s=r<<1&255;t=h;a[t]=s;u=h+1|0;v=s;w=t}else{t=r+16&-16;s=(x=0,as(230,t|0)|0);if(x){x=0;break}c[h+8>>2]=s;y=t|1;c[h>>2]=y;c[h+4>>2]=r;u=s;v=y&255;w=h}Kb(u|0,n|0,r)|0;a[u+r|0]=0;o=v;p=w;q=11;break L1}}while(0);r=bQ(-1,-1)|0;z=K;A=r}}while(0);do{if((q|0)==11){if((o&1)==0){B=h+1|0}else{B=c[h+8>>2]|0}w=d[p]|0;if((w&1|0)==0){C=w>>>1}else{C=c[h+4>>2]|0}w=(x=0,ax(64,g|0,B|0,C|0)|0);do{if(!x){v=b+4|0;u=a[w]|0;if((u&1)==0){D=w+1|0}else{D=c[w+8>>2]|0}l=u&255;if((l&1|0)==0){E=l>>>1}else{E=c[w+4>>2]|0}x=0,ax(64,v|0,D|0,E|0)|0;if(x){x=0;break}l=b+20|0;u=c[l>>2]|0;if((u|0)!=0){x=0;aq(316,u+64|0,w|0);if(x){x=0;break}}if((a[p]&1)!=0){J2(c[h+8>>2]|0)}if((a[m]&1)!=0){J2(c[g+8>>2]|0)}u=c[e+44>>2]|0;if((u|0)!=0){cy[c[(c[u>>2]|0)+8>>2]&1023](u,b|0)}u=e+28|0;L47:do{if((c[u>>2]|0)!=0){r=j;n=j;a[n]=2;y=r+1|0;a[y]=32;a[r+2|0]=0;x=0,ax(64,v|0,y|0,1)|0;do{if(!x){y=c[l>>2]|0;if((y|0)!=0){x=0;aq(316,y+64|0,j|0);if(x){x=0;break}}if((a[n]&1)!=0){J2(c[j+8>>2]|0)}y=c[u>>2]|0;cy[c[(c[y>>2]|0)+8>>2]&1023](y,b|0);if((c[u>>2]|0)==0){break L47}i=f;return}else{x=0}}while(0);y=bQ(-1,-1)|0;r=y;y=K;if((a[n]&1)==0){F=y;G=r;H=G;I=0;J=H;L=F;be(J|0)}J2(c[j+8>>2]|0);F=y;G=r;H=G;I=0;J=H;L=F;be(J|0)}}while(0);u=k;r=k;a[r]=2;y=u+1|0;a[y]=59;a[u+2|0]=0;x=0,ax(64,v|0,y|0,1)|0;do{if(!x){y=c[l>>2]|0;if((y|0)!=0){x=0;aq(316,y+64|0,k|0);if(x){x=0;break}}if((a[r]&1)==0){i=f;return}J2(c[k+8>>2]|0);i=f;return}else{x=0}}while(0);l=bQ(-1,-1)|0;v=l;l=K;if((a[r]&1)==0){F=l;G=v;H=G;I=0;J=H;L=F;be(J|0)}J2(c[k+8>>2]|0);F=l;G=v;H=G;I=0;J=H;L=F;be(J|0)}else{x=0}}while(0);w=bQ(-1,-1)|0;v=w;w=K;if((a[p]&1)==0){z=w;A=v;break}J2(c[h+8>>2]|0);z=w;A=v}}while(0);if((a[m]&1)==0){F=z;G=A;H=G;I=0;J=H;L=F;be(J|0)}J2(c[g+8>>2]|0);F=z;G=A;H=G;I=0;J=H;L=F;be(J|0)}function pH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e|0;g=b+20|0;h=c[g>>2]|0;if((h|0)!=0){zl(h+64|0,d|0)}d=f;h=f;a[h]=18;j=d+1|0;Kb(j|0,8224,9)|0;a[d+10|0]=0;x=0,ax(64,b+4|0,j|0,9)|0;do{if(!x){j=c[g>>2]|0;if((j|0)!=0){x=0;aq(316,j+64|0,f|0);if(x){x=0;break}}if((a[h]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[h]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function pI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+16|0;f=e|0;g=(c[d+52>>2]|0)==0?2552:8024;h=Kf(g|0)|0;if(h>>>0>4294967279>>>0){CJ(0)}if(h>>>0<11>>>0){j=h<<1&255;a[f]=j;k=f+1|0;l=j}else{j=h+16&-16;m=J0(j)|0;c[f+8>>2]=m;n=j|1;c[f>>2]=n;c[f+4>>2]=h;k=m;l=n&255}Kb(k|0,g|0,h)|0;a[k+h|0]=0;h=d+40|0;k=c[h>>2]|0;g=c[d+44>>2]|0;do{if((k|0)==(g|0)){o=l}else{d=g-k>>2;if((d|0)==0){o=l;break}n=b+4|0;m=f;j=f+1|0;p=b+20|0;q=f+4|0;r=f+8|0;s=b|0;t=0;u=0;v=k;L11:while(1){w=c[v+(t<<2)>>2]|0;y=(x=0,as(c[(c[w>>2]|0)+44>>2]|0,w|0)|0);if(x){x=0;break}if(y){z=u}else{do{if(u){y=a[m]|0;A=(y&1)==0?j:c[r>>2]|0;B=y&255;y=(B&1|0)==0?B>>>1:c[q>>2]|0;x=0,ax(64,n|0,A|0,y|0)|0;if(x){x=0;break L11}y=c[p>>2]|0;if((y|0)==0){break}x=0;aq(316,y+64|0,f|0);if(x){x=0;break L11}}}while(0);x=0;aq(c[(c[w>>2]|0)+8>>2]|0,w|0,s|0);if(!x){z=1}else{x=0;break}}y=t+1|0;if(y>>>0>=d>>>0){C=20;break}t=y;u=z;v=c[h>>2]|0}if((C|0)==20){o=a[m]|0;break}v=bQ(-1,-1)|0;if((a[m]&1)==0){be(v|0)}J2(c[r>>2]|0);be(v|0)}}while(0);if((o&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}function pJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0;e=i;i=i+208|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=c[d+40>>2]|0;u=b|0;cy[c[(c[t>>2]|0)+8>>2]&1023](t|0,u);L1:do{switch(c[d+36>>2]|0){case 10:{t=q;a[t]=6;v=q+1|0;a[v]=a[5920]|0;a[v+1|0]=a[5921]|0;a[v+2|0]=a[5922]|0;a[q+4|0]=0;x=0,ax(64,b+4|0,v|0,3)|0;do{if(!x){v=c[b+20>>2]|0;if((v|0)!=0){x=0;aq(316,v+64|0,q|0);if(x){x=0;break}}if((a[t]&1)==0){break L1}J2(c[q+8>>2]|0);break L1}else{x=0}}while(0);v=bQ(-1,-1)|0;w=K;if((a[t]&1)==0){y=w;z=v;A=z;B=0;D=A;E=y;be(D|0)}J2(c[q+8>>2]|0);y=w;z=v;A=z;B=0;D=A;E=y;be(D|0);break};case 1:{v=g;w=g;a[w]=8;F=v+1|0;G=F;C=544370464;a[G]=C;C=C>>8;a[G+1|0]=C;C=C>>8;a[G+2|0]=C;C=C>>8;a[G+3|0]=C;a[v+5|0]=0;x=0,ax(64,b+4|0,F|0,4)|0;do{if(!x){F=c[b+20>>2]|0;if((F|0)!=0){x=0;aq(316,F+64|0,g|0);if(x){x=0;break}}if((a[w]&1)==0){break L1}J2(c[g+8>>2]|0);break L1}else{x=0}}while(0);t=bQ(-1,-1)|0;F=K;if((a[w]&1)==0){y=F;z=t;A=z;B=0;D=A;E=y;be(D|0)}J2(c[g+8>>2]|0);y=F;z=t;A=z;B=0;D=A;E=y;be(D|0);break};case 0:{t=f;F=f;a[F]=10;v=t+1|0;a[v]=a[7848]|0;a[v+1|0]=a[7849]|0;a[v+2|0]=a[7850]|0;a[v+3|0]=a[7851]|0;a[v+4|0]=a[7852]|0;a[t+6|0]=0;x=0,ax(64,b+4|0,v|0,5)|0;do{if(!x){v=c[b+20>>2]|0;if((v|0)!=0){x=0;aq(316,v+64|0,f|0);if(x){x=0;break}}if((a[F]&1)==0){break L1}J2(c[f+8>>2]|0);break L1}else{x=0}}while(0);w=bQ(-1,-1)|0;v=K;if((a[F]&1)==0){y=v;z=w;A=z;B=0;D=A;E=y;be(D|0)}J2(c[f+8>>2]|0);y=v;z=w;A=z;B=0;D=A;E=y;be(D|0);break};case 9:{w=p;a[w]=6;v=p+1|0;a[v]=a[6064]|0;a[v+1|0]=a[6065]|0;a[v+2|0]=a[6066]|0;a[p+4|0]=0;x=0,ax(64,b+4|0,v|0,3)|0;do{if(!x){v=c[b+20>>2]|0;if((v|0)!=0){x=0;aq(316,v+64|0,p|0);if(x){x=0;break}}if((a[w]&1)==0){break L1}J2(c[p+8>>2]|0);break L1}else{x=0}}while(0);F=bQ(-1,-1)|0;v=K;if((a[w]&1)==0){y=v;z=F;A=z;B=0;D=A;E=y;be(D|0)}J2(c[p+8>>2]|0);y=v;z=F;A=z;B=0;D=A;E=y;be(D|0);break};case 2:{F=h;v=h;a[v]=8;t=F+1|0;G=t;C=540884256;a[G]=C;C=C>>8;a[G+1|0]=C;C=C>>8;a[G+2|0]=C;C=C>>8;a[G+3|0]=C;a[F+5|0]=0;x=0,ax(64,b+4|0,t|0,4)|0;do{if(!x){t=c[b+20>>2]|0;if((t|0)!=0){x=0;aq(316,t+64|0,h|0);if(x){x=0;break}}if((a[v]&1)==0){break L1}J2(c[h+8>>2]|0);break L1}else{x=0}}while(0);w=bQ(-1,-1)|0;t=K;if((a[v]&1)==0){y=t;z=w;A=z;B=0;D=A;E=y;be(D|0)}J2(c[h+8>>2]|0);y=t;z=w;A=z;B=0;D=A;E=y;be(D|0);break};case 3:{w=j;t=j;a[t]=8;F=w+1|0;G=F;C=540877088;a[G]=C;C=C>>8;a[G+1|0]=C;C=C>>8;a[G+2|0]=C;C=C>>8;a[G+3|0]=C;a[w+5|0]=0;x=0,ax(64,b+4|0,F|0,4)|0;do{if(!x){F=c[b+20>>2]|0;if((F|0)!=0){x=0;aq(316,F+64|0,j|0);if(x){x=0;break}}if((a[t]&1)==0){break L1}J2(c[j+8>>2]|0);break L1}else{x=0}}while(0);v=bQ(-1,-1)|0;F=K;if((a[t]&1)==0){y=F;z=v;A=z;B=0;D=A;E=y;be(D|0)}J2(c[j+8>>2]|0);y=F;z=v;A=z;B=0;D=A;E=y;be(D|0);break};case 4:{v=k;a[v]=6;F=k+1|0;a[F]=a[7208]|0;a[F+1|0]=a[7209]|0;a[F+2|0]=a[7210]|0;a[k+4|0]=0;x=0,ax(64,b+4|0,F|0,3)|0;do{if(!x){F=c[b+20>>2]|0;if((F|0)!=0){x=0;aq(316,F+64|0,k|0);if(x){x=0;break}}if((a[v]&1)==0){break L1}J2(c[k+8>>2]|0);break L1}else{x=0}}while(0);t=bQ(-1,-1)|0;F=K;if((a[v]&1)==0){y=F;z=t;A=z;B=0;D=A;E=y;be(D|0)}J2(c[k+8>>2]|0);y=F;z=t;A=z;B=0;D=A;E=y;be(D|0);break};case 5:{t=l;F=l;a[F]=8;w=t+1|0;G=w;C=540884512;a[G]=C;C=C>>8;a[G+1|0]=C;C=C>>8;a[G+2|0]=C;C=C>>8;a[G+3|0]=C;a[t+5|0]=0;x=0,ax(64,b+4|0,w|0,4)|0;do{if(!x){w=c[b+20>>2]|0;if((w|0)!=0){x=0;aq(316,w+64|0,l|0);if(x){x=0;break}}if((a[F]&1)==0){break L1}J2(c[l+8>>2]|0);break L1}else{x=0}}while(0);v=bQ(-1,-1)|0;w=K;if((a[F]&1)==0){y=w;z=v;A=z;B=0;D=A;E=y;be(D|0)}J2(c[l+8>>2]|0);y=w;z=v;A=z;B=0;D=A;E=y;be(D|0);break};case 6:{v=m;a[v]=6;w=m+1|0;a[w]=a[6832]|0;a[w+1|0]=a[6833]|0;a[w+2|0]=a[6834]|0;a[m+4|0]=0;x=0,ax(64,b+4|0,w|0,3)|0;do{if(!x){w=c[b+20>>2]|0;if((w|0)!=0){x=0;aq(316,w+64|0,m|0);if(x){x=0;break}}if((a[v]&1)==0){break L1}J2(c[m+8>>2]|0);break L1}else{x=0}}while(0);F=bQ(-1,-1)|0;w=K;if((a[v]&1)==0){y=w;z=F;A=z;B=0;D=A;E=y;be(D|0)}J2(c[m+8>>2]|0);y=w;z=F;A=z;B=0;D=A;E=y;be(D|0);break};case 7:{F=n;w=n;a[w]=8;t=F+1|0;G=t;C=540884e3;a[G]=C;C=C>>8;a[G+1|0]=C;C=C>>8;a[G+2|0]=C;C=C>>8;a[G+3|0]=C;a[F+5|0]=0;x=0,ax(64,b+4|0,t|0,4)|0;do{if(!x){t=c[b+20>>2]|0;if((t|0)!=0){x=0;aq(316,t+64|0,n|0);if(x){x=0;break}}if((a[w]&1)==0){break L1}J2(c[n+8>>2]|0);break L1}else{x=0}}while(0);v=bQ(-1,-1)|0;t=K;if((a[w]&1)==0){y=t;z=v;A=z;B=0;D=A;E=y;be(D|0)}J2(c[n+8>>2]|0);y=t;z=v;A=z;B=0;D=A;E=y;be(D|0);break};case 11:{v=r;t=r;a[t]=2;F=v+1|0;a[F]=47;a[v+2|0]=0;x=0,ax(64,b+4|0,F|0,1)|0;do{if(!x){F=c[b+20>>2]|0;if((F|0)!=0){x=0;aq(316,F+64|0,r|0);if(x){x=0;break}}if((a[t]&1)==0){break L1}J2(c[r+8>>2]|0);break L1}else{x=0}}while(0);w=bQ(-1,-1)|0;F=K;if((a[t]&1)==0){y=F;z=w;A=z;B=0;D=A;E=y;be(D|0)}J2(c[r+8>>2]|0);y=F;z=w;A=z;B=0;D=A;E=y;be(D|0);break};case 12:{w=s;a[w]=6;F=s+1|0;a[F]=a[5696]|0;a[F+1|0]=a[5697]|0;a[F+2|0]=a[5698]|0;a[s+4|0]=0;x=0,ax(64,b+4|0,F|0,3)|0;do{if(!x){F=c[b+20>>2]|0;if((F|0)!=0){x=0;aq(316,F+64|0,s|0);if(x){x=0;break}}if((a[w]&1)==0){break L1}J2(c[s+8>>2]|0);break L1}else{x=0}}while(0);t=bQ(-1,-1)|0;F=K;if((a[w]&1)==0){y=F;z=t;A=z;B=0;D=A;E=y;be(D|0)}J2(c[s+8>>2]|0);y=F;z=t;A=z;B=0;D=A;E=y;be(D|0);break};case 8:{t=o;a[t]=6;F=o+1|0;a[F]=a[6264]|0;a[F+1|0]=a[6265]|0;a[F+2|0]=a[6266]|0;a[o+4|0]=0;x=0,ax(64,b+4|0,F|0,3)|0;do{if(!x){F=c[b+20>>2]|0;if((F|0)!=0){x=0;aq(316,F+64|0,o|0);if(x){x=0;break}}if((a[t]&1)==0){break L1}J2(c[o+8>>2]|0);break L1}else{x=0}}while(0);w=bQ(-1,-1)|0;F=K;if((a[t]&1)==0){y=F;z=w;A=z;B=0;D=A;E=y;be(D|0)}J2(c[o+8>>2]|0);y=F;z=w;A=z;B=0;D=A;E=y;be(D|0);break};default:{}}}while(0);D=c[d+44>>2]|0;cy[c[(c[D>>2]|0)+8>>2]&1023](D|0,u);i=e;return}function pK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e|0;g=e+16|0;L1:do{if((c[d+36>>2]|0)==0){h=f;j=f;a[j]=2;k=h+1|0;a[k]=43;a[h+2|0]=0;h=b+4|0;x=0,ax(64,h|0,k|0,1)|0;do{if(!x){k=c[b+20>>2]|0;if((k|0)!=0){x=0;aq(316,k+64|0,f|0);if(x){x=0;break}}if((a[j]&1)==0){break L1}J2(c[f+8>>2]|0);break L1}else{x=0}}while(0);k=bQ(-1,-1)|0;h=k;k=K;if((a[j]&1)==0){l=k;m=h;n=m;o=0;p=n;q=l;be(p|0)}J2(c[f+8>>2]|0);l=k;m=h;n=m;o=0;p=n;q=l;be(p|0)}else{h=g;k=g;a[k]=2;r=h+1|0;a[r]=45;a[h+2|0]=0;h=b+4|0;x=0,ax(64,h|0,r|0,1)|0;do{if(!x){r=c[b+20>>2]|0;if((r|0)!=0){x=0;aq(316,r+64|0,g|0);if(x){x=0;break}}if((a[k]&1)==0){break L1}J2(c[g+8>>2]|0);break L1}else{x=0}}while(0);j=bQ(-1,-1)|0;r=j;j=K;if((a[k]&1)==0){l=j;m=r;n=m;o=0;p=n;q=l;be(p|0)}J2(c[g+8>>2]|0);l=j;m=r;n=m;o=0;p=n;q=l;be(p|0)}}while(0);p=c[d+40>>2]|0;cy[c[(c[p>>2]|0)+8>>2]&1023](p|0,b|0);i=e;return}function pL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0;e=i;i=i+16|0;f=e|0;g=d+36|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[d+44>>2]|0;g=c[d+40>>2]|0;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){l=g<<1&255;m=f;a[m]=l;n=f+1|0;o=l;p=m}else{m=g+16&-16;l=J0(m)|0;c[f+8>>2]=l;q=m|1;c[f>>2]=q;c[f+4>>2]=g;n=l;o=q&255;p=f}Kb(n|0,h|0,g)|0;a[n+g|0]=0;j=o;k=p}if((j&1)==0){r=f+1|0}else{r=c[f+8>>2]|0}p=j&255;if((p&1|0)==0){s=p>>>1}else{s=c[f+4>>2]|0}x=0,ax(64,b+4|0,r|0,s|0)|0;do{if(!x){s=c[b+20>>2]|0;if((s|0)!=0){x=0;aq(316,s+64|0,f|0);if(x){x=0;break}}if((a[k]&1)==0){t=d+48|0;u=c[t>>2]|0;v=u;w=c[v>>2]|0;y=w+8|0;z=c[y>>2]|0;A=b|0;cy[z&1023](u,A);i=e;return}J2(c[f+8>>2]|0);t=d+48|0;u=c[t>>2]|0;v=u;w=c[v>>2]|0;y=w+8|0;z=c[y>>2]|0;A=b|0;cy[z&1023](u,A);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[k]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function pM(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+36>>2]|0;e=a|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d,e);d=c[b+40>>2]|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d,e);return}function pN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=d+36|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[d+44>>2]|0;g=c[d+40>>2]|0;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){d=g<<1&255;l=f;a[l]=d;m=f+1|0;n=d;o=l}else{l=g+16&-16;d=J0(l)|0;c[f+8>>2]=d;p=l|1;c[f>>2]=p;c[f+4>>2]=g;m=d;n=p&255;o=f}Kb(m|0,h|0,g)|0;a[m+g|0]=0;j=n;k=o}if((j&1)==0){q=f+1|0}else{q=c[f+8>>2]|0}o=j&255;if((o&1|0)==0){r=o>>>1}else{r=c[f+4>>2]|0}x=0,ax(64,b+4|0,q|0,r|0)|0;do{if(!x){r=c[b+20>>2]|0;if((r|0)!=0){x=0;aq(316,r+64|0,f|0);if(x){x=0;break}}if((a[k]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[k]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function pO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=d+40|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[d+48>>2]|0;g=c[d+44>>2]|0;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){d=g<<1&255;l=f;a[l]=d;m=f+1|0;n=d;o=l}else{l=g+16&-16;d=J0(l)|0;c[f+8>>2]=d;p=l|1;c[f>>2]=p;c[f+4>>2]=g;m=d;n=p&255;o=f}Kb(m|0,h|0,g)|0;a[m+g|0]=0;j=n;k=o}if((j&1)==0){q=f+1|0}else{q=c[f+8>>2]|0}o=j&255;if((o&1|0)==0){r=o>>>1}else{r=c[f+4>>2]|0}x=0,ax(64,b+4|0,q|0,r|0)|0;do{if(!x){r=c[b+20>>2]|0;if((r|0)!=0){x=0;aq(316,r+64|0,f|0);if(x){x=0;break}}if((a[k]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[k]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function pP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0;e=i;i=i+16|0;f=e|0;g=f;j=i;i=i+144|0;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=i;i=i+12|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;r=j;s=j+64|0;t=j|0;u=j+8|0;v=u|0;c[v>>2]=14576;w=j+12|0;y=j;c[t>>2]=31212;z=j+64|0;c[z>>2]=31232;c[j+4>>2]=0;x=0;aq(200,j+64|0,w|0);do{if(!x){c[j+136>>2]=0;c[j+140>>2]=-1;A=j+8|0;c[t>>2]=14556;c[s>>2]=14596;c[v>>2]=14576;B=w|0;c[B>>2]=14880;C=j+16|0;HA(C);Ke(j+20|0,0,24)|0;c[B>>2]=14736;D=j+44|0;Ke(j+44|0,0,16)|0;c[j+60>>2]=24;Ke(g|0,0,12)|0;x=0;aq(214,w|0,f|0);if(x){x=0;E=bQ(-1,-1)|0;F=K;if((a[g]&1)!=0){J2(c[f+8>>2]|0)}if((a[D]&1)!=0){J2(c[j+52>>2]|0)}c[B>>2]=14880;x=0;ap(388,C|0);if(!x){G=F;H=E;break}else{x=0}bQ(-1,-1,0)|0;bU()}if((a[g]&1)!=0){J2(c[f+8>>2]|0)}c[r+((c[(c[y>>2]|0)-12>>2]|0)+8)>>2]=5;E=u+((c[(c[u>>2]|0)-12>>2]|0)+4)|0;c[E>>2]=c[E>>2]&-261|4;E=u;I=+h[d+40>>3];x=0,aF(2,E|0,+I)|0;do{if(!x){x=0;aq(560,k|0,w|0);if(x){x=0;J=31;break}E=k;F=k;B=a[F]|0;L=B&255;if((L&1|0)==0){M=L>>>1;N=k+4|0}else{L=k+4|0;M=c[L>>2]|0;N=L}L=E+1|0;O=k+8|0;P=M;Q=B;L23:while(1){B=P-1|0;R=(Q&1)==0;S=Q&255;T=(S&1|0)==0;if((a[(R?L:c[O>>2]|0)+B|0]|0)!=48){J=35;break}if(T){U=S>>>1;V=S>>>1}else{W=c[N>>2]|0;U=W;V=W}W=V-1|0;do{if(U>>>0<W>>>0){X=W-U|0;x=0,ax(58,k|0,X|0,0)|0;if(x){x=0;J=32;break L23}}else{if(R){a[E+1+W|0]=0;a[F]=W<<1;break}else{a[(c[O>>2]|0)+W|0]=0;c[N>>2]=W;break}}}while(0);P=B;Q=a[F]|0}L37:do{if((J|0)==35){if(T){Y=S>>>1}else{Y=c[N>>2]|0}do{if((a[(R?L:c[O>>2]|0)+(Y-1)|0]|0)==46){if(T){Z=S>>>1;_=S>>>1}else{Q=c[N>>2]|0;Z=Q;_=Q}Q=_-1|0;if(Z>>>0<Q>>>0){P=Q-Z|0;x=0,ax(58,k|0,P|0,0)|0;if(!x){J=47;break}else{x=0;break}}if(R){a[E+1+Q|0]=0;a[F]=Q<<1;J=47;break}else{a[(c[O>>2]|0)+Q|0]=0;c[N>>2]=Q;J=47;break}}else{J=47}}while(0);L55:do{if((J|0)==47){if((((c[d+52>>2]|0)-(c[d+48>>2]|0)|0)/12|0)>>>0>1>>>0){J=49}else{if((c[d+64>>2]|0)!=(c[d+60>>2]|0)){J=49}}L59:do{if((J|0)==49){x=0;aq(248,n|0,d|0);if(x){x=0;break L55}x=0;aP(194,m|0,k|0,n|0);do{if(!x){B=l;Ke(B|0,0,12)|0;Q=m;P=a[Q]|0;W=P&255;if((W&1|0)==0){$=W>>>1}else{$=c[m+4>>2]|0}if((P&1)==0){aa=m+1|0}else{aa=c[m+8>>2]|0}P=$+25|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;J=65;break}}else{if(P>>>0<11>>>0){a[B]=$<<1;ab=l+1|0}else{W=$+41&-16;X=(x=0,as(230,W|0)|0);if(x){x=0;J=65;break}c[l+8>>2]=X;c[l>>2]=W|1;c[l+4>>2]=$;ab=X}Kb(ab|0,aa|0,$)|0;a[ab+$|0]=0;x=0,ax(64,l|0,5464,25)|0;if(x){x=0;J=65;break}X=d+4|0;L82:do{if((a[X]&1)==0){W=o;c[W>>2]=c[X>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];J=77}else{W=c[d+12>>2]|0;ac=c[d+8>>2]|0;do{if(ac>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(ac>>>0<11>>>0){a[o]=ac<<1;ad=o+1|0}else{ae=ac+16&-16;af=(x=0,as(230,ae|0)|0);if(x){x=0;break}c[o+8>>2]=af;c[o>>2]=ae|1;c[o+4>>2]=ac;ad=af}Kb(ad|0,W|0,ac)|0;a[ad+ac|0]=0;J=77;break L82}}while(0);ac=bQ(-1,-1)|0;ag=K;ah=ac}}while(0);do{if((J|0)==77){X=p;ac=d+16|0;c[X>>2]=c[ac>>2];c[X+4>>2]=c[ac+4>>2];c[X+8>>2]=c[ac+8>>2];x=0;aP(362,l|0,o|0,p|0);if(x){x=0;ac=bQ(-1,-1)|0;X=ac;ac=K;if((a[o]&1)==0){ag=ac;ah=X;break}J2(c[o+8>>2]|0);ag=ac;ah=X;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[B]&1)!=0){J2(c[l+8>>2]|0)}if((a[Q]&1)!=0){J2(c[m+8>>2]|0)}if((a[n]&1)==0){break L59}J2(c[n+8>>2]|0);break L59}}while(0);if((a[B]&1)==0){ai=ag;aj=ah;break}J2(c[l+8>>2]|0);ai=ag;aj=ah}}while(0);if((J|0)==65){P=bQ(-1,-1)|0;X=K;if((a[B]&1)!=0){J2(c[l+8>>2]|0)}ai=X;aj=P}if((a[Q]&1)==0){ak=ai;al=aj;break}J2(c[m+8>>2]|0);ak=ai;al=aj}else{x=0;P=bQ(-1,-1)|0;ak=K;al=P}}while(0);if((a[n]&1)==0){am=ak;an=al;break L37}J2(c[n+8>>2]|0);am=ak;an=al;break L37}}while(0);P=b+4|0;X=a[F]|0;ac=(X&1)==0?L:c[O>>2]|0;W=X&255;if((W&1|0)==0){ao=W>>>1}else{ao=c[N>>2]|0}x=0,ax(64,P|0,ac|0,ao|0)|0;if(x){x=0;break}ac=b+20|0;W=c[ac>>2]|0;if((W|0)!=0){x=0;aq(316,W+64|0,k|0);if(x){x=0;break}}x=0;aq(248,q|0,d|0);if(x){x=0;break}W=q;X=a[W]|0;if((X&1)==0){ar=q+1|0}else{ar=c[q+8>>2]|0}af=X&255;if((af&1|0)==0){at=af>>>1}else{at=c[q+4>>2]|0}x=0,ax(64,P|0,ar|0,at|0)|0;do{if(!x){P=c[ac>>2]|0;if((P|0)!=0){x=0;aq(316,P+64|0,q|0);if(x){x=0;break}}if((a[W]&1)!=0){J2(c[q+8>>2]|0)}if((a[F]&1)!=0){J2(c[O>>2]|0)}c[t>>2]=14556;c[z>>2]=14596;c[A>>2]=14576;P=j+12|0;c[P>>2]=14736;if((a[D]&1)!=0){J2(c[j+52>>2]|0)}c[P>>2]=14880;x=0;ap(388,C|0);if(!x){C7(j+64|0);i=e;return}else{x=0}P=bQ(-1,-1)|0;x=0;ap(268,j+64|0);if(!x){be(P|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}else{x=0}}while(0);ac=bQ(-1,-1)|0;P=ac;ac=K;if((a[W]&1)==0){am=ac;an=P;break L37}J2(c[q+8>>2]|0);am=ac;an=P;break L37}}while(0);P=bQ(-1,-1)|0;au=K;av=P;J=34}else if((J|0)==32){P=bQ(-1,-1)|0;au=K;av=P;J=34}}while(0);if((J|0)==34){am=au;an=av}if((a[F]&1)==0){aw=am;ay=an;break}J2(c[O>>2]|0);aw=am;ay=an}else{x=0;J=31}}while(0);if((J|0)==31){L=bQ(-1,-1)|0;aw=K;ay=L}c[t>>2]=14556;c[z>>2]=14596;c[A>>2]=14576;L=j+12|0;c[L>>2]=14736;if((a[D]&1)!=0){J2(c[j+52>>2]|0)}c[L>>2]=14880;x=0;ap(388,C|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,j+64|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,j+64|0);if(!x){be(ay|0)}else{x=0}bQ(-1,-1,0)|0;bU()}else{x=0;L=bQ(-1,-1)|0;G=K;H=L}}while(0);x=0;ap(268,s|0);if(!x){be(H|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function pQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=i;i=i+16|0;f=e|0;g=f;j=i;i=i+144|0;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+4|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=j+64|0;p=j|0;q=j+8|0;r=q|0;c[r>>2]=14576;s=j+12|0;c[p>>2]=31212;t=j+64|0;c[t>>2]=31232;c[j+4>>2]=0;x=0;aq(200,j+64|0,s|0);do{if(!x){c[j+136>>2]=0;c[j+140>>2]=-1;u=j+8|0;c[p>>2]=14556;c[o>>2]=14596;c[r>>2]=14576;v=s|0;c[v>>2]=14880;w=j+16|0;HA(w);Ke(j+20|0,0,24)|0;c[v>>2]=14736;y=j+44|0;Ke(j+44|0,0,16)|0;c[j+60>>2]=24;Ke(g|0,0,12)|0;x=0;aq(214,s|0,f|0);if(x){x=0;z=bQ(-1,-1)|0;A=K;if((a[g]&1)!=0){J2(c[f+8>>2]|0)}if((a[y]&1)!=0){J2(c[j+52>>2]|0)}c[v>>2]=14880;x=0;ap(388,w|0);if(!x){B=z;C=A;break}else{x=0}bQ(-1,-1,0)|0;bU()}if((a[g]&1)!=0){J2(c[f+8>>2]|0)}D=+h[d+40>>3];if(D>255.0){E=255.0}else{E=D<0.0?0.0:D}D=+h[d+48>>3];if(D>255.0){F=255.0}else{F=D<0.0?0.0:D}D=+h[d+56>>3];if(D>255.0){G=255.0}else{G=D<0.0?0.0:D}D=+h[d+64>>3];if(D>1.0){H=1.0}else{H=D<0.0?0.0:D}A=d+72|0;do{if((a[A]&1)==0){z=k;c[z>>2]=c[A>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];I=a[z]|0;J=z;L=33}else{z=c[d+80>>2]|0;v=c[d+76>>2]|0;if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;L=52;break}}if(v>>>0<11>>>0){M=v<<1&255;N=k;a[N]=M;O=k+1|0;P=M;Q=N}else{N=v+16&-16;M=(x=0,as(230,N|0)|0);if(x){x=0;L=52;break}c[k+8>>2]=M;R=N|1;c[k>>2]=R;c[k+4>>2]=v;O=M;P=R&255;Q=k}Kb(O|0,z|0,v)|0;a[O+v|0]=0;I=P;J=Q;L=33}}while(0);L40:do{if((L|0)==33){v=I&255;if((v&1|0)==0){S=v>>>1}else{S=c[k+4>>2]|0}if((a[J]&1)!=0){J2(c[k+8>>2]|0)}L49:do{if((S|0)==0){if(H<1.0){v=q;x=0,aK(112,v|0,5424)|0;if(x){x=0;L=52;break L40}z=(x=0,aK(310,v|0,~~E|0)|0);if(x){x=0;L=52;break L40}x=0,aK(112,z|0,8024)|0;if(x){x=0;L=52;break L40}z=(x=0,aK(310,v|0,~~F|0)|0);if(x){x=0;L=52;break L40}x=0,aK(112,z|0,8024)|0;if(x){x=0;L=52;break L40}z=(x=0,aK(310,v|0,~~G|0)|0);if(x){x=0;L=52;break L40}x=0,aK(112,z|0,8024)|0;if(x){x=0;L=52;break L40}z=(x=0,aF(2,v|0,+H)|0);if(x){x=0;L=52;break L40}x=0,aK(104,z|0,41)|0;if(!x){break}else{x=0;L=52;break L40}}z=~~(+(~~(+(~~(E*65536.0)|0)+F*256.0)|0)+G);c[m>>2]=z;v=c[b+20>>2]|0;L81:do{if((v|0)!=0){R=c[v+164>>2]|0;if((R|0)==0){break}else{T=R}while(1){R=c[T+16>>2]|0;if((z|0)<(R|0)){V=T|0}else{if((R|0)>=(z|0)){break}V=T+4|0}T=c[V>>2]|0;if((T|0)==0){break L81}}R=(x=0,aK(710,v+160|0,m|0)|0);if(x){x=0;L=52;break L40}x=0,aK(802,q|0,R|0)|0;if(!x){break L49}else{x=0;L=52;break L40}}}while(0);v=q;z=(x=0,aK(104,v|0,35)|0);if(x){x=0;L=52;break L40}R=z;M=z;c[M+((c[(c[R>>2]|0)-12>>2]|0)+12)>>2]=2;c[M+((c[(c[R>>2]|0)-12>>2]|0)+76)>>2]=48;R=q;M=q;z=M+((c[(c[R>>2]|0)-12>>2]|0)+4)|0;c[z>>2]=c[z>>2]&-75|8;c[M+((c[(c[R>>2]|0)-12>>2]|0)+12)>>2]=2;z=~~+U(E+.5);x=0,aK(310,v|0,z|0)|0;if(x){x=0;L=52;break L40}z=M+((c[(c[R>>2]|0)-12>>2]|0)+4)|0;c[z>>2]=c[z>>2]&-75|8;c[M+((c[(c[R>>2]|0)-12>>2]|0)+12)>>2]=2;z=~~+U(F+.5);x=0,aK(310,v|0,z|0)|0;if(x){x=0;L=52;break L40}z=M+((c[(c[R>>2]|0)-12>>2]|0)+4)|0;c[z>>2]=c[z>>2]&-75|8;c[M+((c[(c[R>>2]|0)-12>>2]|0)+12)>>2]=2;R=~~+U(G+.5);x=0,aK(310,v|0,R|0)|0;if(x){x=0;L=52;break L40}}else{if((a[A]&1)==0){R=l;c[R>>2]=c[A>>2];c[R+4>>2]=c[A+4>>2];c[R+8>>2]=c[A+8>>2]}else{R=c[d+80>>2]|0;v=c[d+76>>2]|0;if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;L=52;break L40}}if(v>>>0<11>>>0){a[l]=v<<1;W=l+1|0}else{M=v+16&-16;z=(x=0,as(230,M|0)|0);if(x){x=0;L=52;break L40}c[l+8>>2]=z;c[l>>2]=M|1;c[l+4>>2]=v;W=z}Kb(W|0,R|0,v)|0;a[W+v|0]=0}v=q;x=0,aK(802,v|0,l|0)|0;if(!x){if((a[l]&1)==0){break}J2(c[l+8>>2]|0);break}else{x=0;v=bQ(-1,-1)|0;R=v;v=K;if((a[l]&1)==0){X=v;Y=R;break L40}J2(c[l+8>>2]|0);X=v;Y=R;break L40}}}while(0);x=0;aq(560,n|0,s|0);if(x){x=0;L=52;break}R=b+4|0;v=n;z=a[v]|0;if((z&1)==0){Z=n+1|0}else{Z=c[n+8>>2]|0}M=z&255;if((M&1|0)==0){_=M>>>1}else{_=c[n+4>>2]|0}x=0,ax(64,R|0,Z|0,_|0)|0;do{if(!x){R=c[b+20>>2]|0;if((R|0)!=0){x=0;aq(316,R+64|0,n|0);if(x){x=0;break}}if((a[v]&1)!=0){J2(c[n+8>>2]|0)}c[p>>2]=14556;c[t>>2]=14596;c[u>>2]=14576;R=j+12|0;c[R>>2]=14736;if((a[y]&1)!=0){J2(c[j+52>>2]|0)}c[R>>2]=14880;x=0;ap(388,w|0);if(!x){C7(j+64|0);i=e;return}else{x=0}R=bQ(-1,-1)|0;x=0;ap(268,j+64|0);if(!x){be(R|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}else{x=0}}while(0);R=bQ(-1,-1)|0;M=R;R=K;if((a[v]&1)==0){X=R;Y=M;break}J2(c[n+8>>2]|0);X=R;Y=M}}while(0);if((L|0)==52){A=bQ(-1,-1)|0;X=K;Y=A}c[p>>2]=14556;c[t>>2]=14596;c[u>>2]=14576;A=j+12|0;c[A>>2]=14736;if((a[y]&1)!=0){J2(c[j+52>>2]|0)}c[A>>2]=14880;x=0;ap(388,w|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,j+64|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,j+64|0);if(!x){be(Y|0)}else{x=0}bQ(-1,-1,0)|0;bU()}else{x=0;A=bQ(-1,-1)|0;B=A;C=K}}while(0);x=0;ap(268,o|0);if(!x){be(B|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function pR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e|0;g=(a[d+36|0]&1)!=0?5384:5240;d=Kf(g|0)|0;if(d>>>0>4294967279>>>0){CJ(0)}if(d>>>0<11>>>0){h=d<<1&255;j=f;a[j]=h;k=f+1|0;l=h;m=j}else{j=d+16&-16;h=J0(j)|0;c[f+8>>2]=h;n=j|1;c[f>>2]=n;c[f+4>>2]=d;k=h;l=n&255;m=f}Kb(k|0,g|0,d)|0;a[k+d|0]=0;if((l&1)==0){o=f+1|0}else{o=c[f+8>>2]|0}d=l&255;if((d&1|0)==0){p=d>>>1}else{p=c[f+4>>2]|0}x=0,ax(64,b+4|0,o|0,p|0)|0;do{if(!x){p=c[b+20>>2]|0;if((p|0)!=0){x=0;aq(316,p+64|0,f|0);if(x){x=0;break}}if((a[m]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[m]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function pS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=d+44|0;j=c[h>>2]|0;k=(c[d+48>>2]|0)-j>>2;if((k|0)==0){i=e;return}d=b|0;l=g;m=g;n=l+1|0;o=l+2|0;l=b+4|0;p=b+20|0;b=g+8|0;q=f;r=f;s=q+1|0;t=s;u=q+3|0;q=f+8|0;v=0;w=j;L4:while(1){do{if((a[(c[w+(v<<2)>>2]|0)+29|0]&1)!=0){a[r]=4;C=31523;a[t]=C;C=C>>8;a[t+1|0]=C;a[u]=0;x=0,ax(64,l|0,s|0,2)|0;if(x){x=0;y=9;break L4}j=c[p>>2]|0;if((j|0)!=0){x=0;aq(316,j+64|0,f|0);if(x){x=0;y=9;break L4}}if((a[r]&1)==0){break}J2(c[q>>2]|0)}}while(0);j=c[(c[h>>2]|0)+(v<<2)>>2]|0;cy[c[(c[j>>2]|0)+8>>2]&1023](j|0,d);do{if((a[(c[(c[h>>2]|0)+(v<<2)>>2]|0)+29|0]&1)!=0){a[m]=2;a[n]=125;a[o]=0;x=0,ax(64,l|0,n|0,1)|0;if(x){x=0;y=17;break L4}j=c[p>>2]|0;if((j|0)!=0){x=0;aq(316,j+64|0,g|0);if(x){x=0;y=17;break L4}}if((a[m]&1)==0){break}J2(c[b>>2]|0)}}while(0);j=v+1|0;if(j>>>0>=k>>>0){y=23;break}v=j;w=c[h>>2]|0}if((y|0)==9){h=bQ(-1,-1)|0;w=h;h=K;if((a[r]&1)==0){z=h;A=w;B=A;D=0;E=B;F=z;be(E|0)}J2(c[q>>2]|0);z=h;A=w;B=A;D=0;E=B;F=z;be(E|0)}else if((y|0)==17){w=bQ(-1,-1)|0;h=w;w=K;if((a[m]&1)==0){z=w;A=h;B=A;D=0;E=B;F=z;be(E|0)}J2(c[b>>2]|0);z=w;A=h;B=A;D=0;E=B;F=z;be(E|0)}else if((y|0)==23){i=e;return}}function pT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=d+40|0;j=(a[h]&1)==0;L1:do{if((a[d+36|0]&1)==0){if(j){k=f;c[k>>2]=c[h>>2];c[k+4>>2]=c[h+4>>2];c[k+8>>2]=c[h+8>>2];l=1;m=0;n=21;break}k=c[d+48>>2]|0;o=c[d+44>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[f]=o<<1;p=f+1|0}else{q=o+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;break}c[f+8>>2]=r;c[f>>2]=q|1;c[f+4>>2]=o;p=r}Kb(p|0,k|0,o)|0;a[p+o|0]=0;l=1;m=0;n=21;break L1}}while(0);o=bQ(-1,-1)|0;s=o;t=K;u=s;v=0;w=u;y=t;be(w|0)}else{if(j){o=g;c[o>>2]=c[h>>2];c[o+4>>2]=c[h+4>>2];c[o+8>>2]=c[h+8>>2]}else{o=c[d+48>>2]|0;k=c[d+44>>2]|0;if(k>>>0>4294967279>>>0){CJ(0)}if(k>>>0<11>>>0){a[g]=k<<1;z=g+1|0}else{r=k+16&-16;q=J0(r)|0;c[g+8>>2]=q;c[g>>2]=r|1;c[g+4>>2]=k;z=q}Kb(z|0,o|0,k)|0;a[z+k|0]=0}x=0;aq(180,f|0,g|0);if(!x){l=0;m=1;n=21;break}else{x=0}k=bQ(-1,-1)|0;A=K;B=k}}while(0);do{if((n|0)==21){z=b+4|0;d=f;h=a[d]|0;if((h&1)==0){C=f+1|0}else{C=c[f+8>>2]|0}j=h&255;if((j&1|0)==0){D=j>>>1}else{D=c[f+4>>2]|0}x=0,ax(64,z|0,C|0,D|0)|0;do{if(!x){z=c[b+20>>2]|0;if((z|0)!=0){x=0;aq(316,z+64|0,f|0);if(x){x=0;break}}do{if(l){if((a[d]&1)==0){break}J2(c[f+8>>2]|0)}}while(0);if(!m){i=e;return}if((a[d]&1)!=0){J2(c[f+8>>2]|0)}if((a[g]&1)==0){i=e;return}J2(c[g+8>>2]|0);i=e;return}else{x=0}}while(0);z=bQ(-1,-1)|0;j=z;z=K;do{if(l){if((a[d]&1)==0){n=44;break}J2(c[f+8>>2]|0);if(m){break}else{s=j;t=z}u=s;v=0;w=u;y=t;be(w|0)}else{n=44}}while(0);do{if((n|0)==44){if(m){break}else{s=j;t=z}u=s;v=0;w=u;y=t;be(w|0)}}while(0);if((a[d]&1)==0){A=z;B=j;break}J2(c[f+8>>2]|0);A=z;B=j}}while(0);if((a[g]&1)==0){s=B;t=A;u=s;v=0;w=u;y=t;be(w|0)}J2(c[g+8>>2]|0);s=B;t=A;u=s;v=0;w=u;y=t;be(w|0)}function pU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=i;i=i+16|0;f=e|0;g=f;h=d;j=d;k=a[j]|0;l=k&255;m=(l&1|0)==0;if(m){n=l>>>1}else{n=c[d+4>>2]|0}if((n|0)==0){a[b]=0;a[b+1|0]=0;i=e;return}if(m){o=l>>>1}else{o=c[d+4>>2]|0}n=k&1;do{if((o|0)==1){k=n<<24>>24==0;if(k){p=h+1|0}else{p=c[d+8>>2]|0}if((a[p]|0)!=34){if(k){q=h+1|0}else{q=c[d+8>>2]|0}if((a[q]|0)!=39){break}}a[b]=0;a[b+1|0]=0;i=e;return}}while(0);q=n<<24>>24==0;if(q){r=h+1|0}else{r=c[d+8>>2]|0}if((a[r]|0)==34){if(q){s=h+1|0}else{s=c[d+8>>2]|0}if(m){t=l>>>1}else{t=c[d+4>>2]|0}if((a[s+(t-1)|0]|0)==34){u=34}else{v=30}}else{v=30}do{if((v|0)==30){if(q){w=h+1|0}else{w=c[d+8>>2]|0}if((a[w]|0)==39){if(q){y=h+1|0}else{y=c[d+8>>2]|0}if(m){z=l>>>1}else{z=c[d+4>>2]|0}if((a[y+(z-1)|0]|0)==39){u=39;break}}if(q){t=b;c[t>>2]=c[j>>2];c[t+4>>2]=c[j+4>>2];c[t+8>>2]=c[j+8>>2];i=e;return}t=c[d+8>>2]|0;s=c[d+4>>2]|0;if(s>>>0>4294967279>>>0){CJ(0)}if(s>>>0<11>>>0){a[b]=s<<1;A=b+1|0}else{r=s+16&-16;n=J0(r)|0;c[b+8>>2]=n;c[b>>2]=r|1;c[b+4>>2]=s;A=n}Kb(A|0,t|0,s)|0;a[A+s|0]=0;i=e;return}}while(0);Ke(g|0,0,12)|0;if(m){B=l>>>1}else{B=c[d+4>>2]|0}x=0;aq(602,f|0,B-2|0);L76:do{if(!x){B=a[j]|0;l=B&255;if((l&1|0)==0){C=l>>>1}else{C=c[d+4>>2]|0}l=C-1|0;L82:do{if(l>>>0>1>>>0){m=h+1|0;A=f+1|0;q=f+8|0;z=f+4|0;y=f|0;w=d+8|0;s=1;t=B;while(1){if((t&1)==0){D=m}else{D=c[w>>2]|0}if((a[D+s|0]|0)==(u|0)){n=a[g]|0;r=n&255;if((r&1|0)==0){E=r>>>1;F=r>>>1}else{r=c[z>>2]|0;E=r;F=r}r=F-1|0;if(E>>>0<r>>>0){v=65;break}if((n&1)==0){a[g]=r<<1;G=A}else{n=c[q>>2]|0;c[z>>2]=r;G=n}a[G+r|0]=0;H=a[j]|0}else{H=t}if((H&1)==0){I=m}else{I=c[w>>2]|0}r=a[I+s|0]|0;n=a[g]|0;if((n&1)==0){J=(n&255)>>>1;L=10;M=n}else{p=c[y>>2]|0;J=c[z>>2]|0;L=(p&-2)-1|0;M=p&255}if((J|0)==(L|0)){if((L|0)==-17){v=82;break}p=(M&1)==0?A:c[q>>2]|0;do{if(L>>>0<2147483623>>>0){o=L+1|0;k=L<<1;N=o>>>0<k>>>0?k:o;if(N>>>0<11>>>0){O=11;break}O=N+16&-16}else{O=-17}}while(0);N=(x=0,as(230,O|0)|0);if(x){x=0;v=71;break}Kb(N|0,p|0,L)|0;if((L|0)!=10){J2(p)}c[q>>2]=N;N=O|1;c[y>>2]=N;P=N&255}else{P=n}if((P&1)==0){a[g]=(J<<1)+2;Q=A;R=J+1|0}else{N=c[q>>2]|0;o=J+1|0;c[z>>2]=o;Q=N;R=o}a[Q+J|0]=r;a[Q+R|0]=0;o=s+1|0;if(o>>>0>=l>>>0){break L82}s=o;t=a[j]|0}if((v|0)==65){x=0;ap(238,0);if(x){x=0;v=72;break L76}}else if((v|0)==82){x=0;ap(232,0);if(x){x=0;v=72;break L76}}else if((v|0)==71){t=bQ(-1,-1)|0;S=K;T=t;U=M;break L76}}}while(0);l=(a[g]&1)==0;if(l){B=b;c[B>>2]=c[g>>2];c[B+4>>2]=c[g+4>>2];c[B+8>>2]=c[g+8>>2];i=e;return}B=c[f+8>>2]|0;t=c[f+4>>2]|0;if(t>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;v=72;break}}if(t>>>0<11>>>0){a[b]=t<<1;V=b+1|0}else{s=t+16&-16;z=(x=0,as(230,s|0)|0);if(x){x=0;v=72;break}c[b+8>>2]=z;c[b>>2]=s|1;c[b+4>>2]=t;V=z}Kb(V|0,B|0,t)|0;a[V+t|0]=0;if(l){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0;v=72}}while(0);if((v|0)==72){v=bQ(-1,-1)|0;S=K;T=v;U=a[g]|0}if((U&1)==0){be(T|0)}J2(c[f+8>>2]|0);be(T|0)}function pV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+52|0;if((c[j>>2]|0)==0){k=d+40|0;l=c[c[k>>2]>>2]|0;cy[c[(c[l>>2]|0)+8>>2]&1023](l,b|0);m=1;n=k}else{L4:do{if((a[d+56|0]&1)==0){if((a[d+57|0]&1)==0){break}k=g;l=g;a[l]=10;o=k+1|0;a[o]=a[5024]|0;a[o+1|0]=a[5025]|0;a[o+2|0]=a[5026]|0;a[o+3|0]=a[5027]|0;a[o+4|0]=a[5028]|0;a[k+6|0]=0;k=b+4|0;x=0,ax(64,k|0,o|0,5)|0;do{if(!x){o=c[b+20>>2]|0;if((o|0)!=0){x=0;aq(316,o+64|0,g|0);if(x){x=0;break}}if((a[l]&1)==0){break L4}J2(c[g+8>>2]|0);break L4}else{x=0}}while(0);o=bQ(-1,-1)|0;k=o;o=K;if((a[l]&1)==0){p=o;q=k;r=q;s=0;t=r;u=p;be(t|0)}J2(c[g+8>>2]|0);p=o;q=k;r=q;s=0;t=r;u=p;be(t|0)}else{k=f;o=f;a[o]=8;v=k+1|0;w=v;C=544501614;a[w]=C;C=C>>8;a[w+1|0]=C;C=C>>8;a[w+2|0]=C;C=C>>8;a[w+3|0]=C;a[k+5|0]=0;k=b+4|0;x=0,ax(64,k|0,v|0,4)|0;do{if(!x){v=c[b+20>>2]|0;if((v|0)!=0){x=0;aq(316,v+64|0,f|0);if(x){x=0;break}}if((a[o]&1)==0){break L4}J2(c[f+8>>2]|0);break L4}else{x=0}}while(0);l=bQ(-1,-1)|0;v=l;l=K;if((a[o]&1)==0){p=l;q=v;r=q;s=0;t=r;u=p;be(t|0)}J2(c[f+8>>2]|0);p=l;q=v;r=q;s=0;t=r;u=p;be(t|0)}}while(0);f=c[j>>2]|0;cy[c[(c[f>>2]|0)+8>>2]&1023](f,b|0);m=0;n=d+40|0}f=(c[d+44>>2]|0)-(c[n>>2]|0)>>2;if(m>>>0>=f>>>0){i=e;return}d=h;j=h;g=d+1|0;v=d+6|0;d=b+4|0;l=b+20|0;k=b|0;b=h+8|0;w=m;while(1){a[j]=10;a[g]=a[7848]|0;a[g+1|0]=a[7849]|0;a[g+2|0]=a[7850]|0;a[g+3|0]=a[7851]|0;a[g+4|0]=a[7852]|0;a[v]=0;x=0,ax(64,d|0,g|0,5)|0;if(x){x=0;break}m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,h|0);if(x){x=0;break}}if((a[j]&1)!=0){J2(c[b>>2]|0)}m=c[(c[n>>2]|0)+(w<<2)>>2]|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m,k);m=w+1|0;if(m>>>0<f>>>0){w=m}else{y=32;break}}if((y|0)==32){i=e;return}e=bQ(-1,-1)|0;y=e;e=K;if((a[j]&1)==0){p=e;q=y;r=q;s=0;t=r;u=p;be(t|0)}J2(c[b>>2]|0);p=e;q=y;r=q;s=0;t=r;u=p;be(t|0)}function pW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;if((a[d+44|0]&1)!=0){j=c[d+36>>2]|0;cy[c[(c[j>>2]|0)+8>>2]&1023](j|0,b|0);i=e;return}j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,1)|0;do{if(!x){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}m=c[d+36>>2]|0;n=b|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m|0,n);m=d+40|0;L13:do{if((c[m>>2]|0)!=0){o=g;p=g;a[p]=4;q=o+1|0;r=q;C=8250;a[r]=C;C=C>>8;a[r+1|0]=C;a[o+3|0]=0;x=0,ax(64,j|0,q|0,2)|0;do{if(!x){q=c[l>>2]|0;if((q|0)!=0){x=0;aq(316,q+64|0,g|0);if(x){x=0;break}}if((a[p]&1)!=0){J2(c[g+8>>2]|0)}q=c[m>>2]|0;cy[c[(c[q>>2]|0)+8>>2]&1023](q|0,n);break L13}else{x=0}}while(0);q=bQ(-1,-1)|0;o=q;q=K;if((a[p]&1)==0){s=q;t=o;u=t;v=0;w=u;y=s;be(w|0)}J2(c[g+8>>2]|0);s=q;t=o;u=t;v=0;w=u;y=s;be(w|0)}}while(0);n=h;m=h;a[m]=2;o=n+1|0;a[o]=41;a[n+2|0]=0;x=0,ax(64,j|0,o|0,1)|0;do{if(!x){o=c[l>>2]|0;if((o|0)!=0){x=0;aq(316,o+64|0,h|0);if(x){x=0;break}}if((a[m]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);l=bQ(-1,-1)|0;o=l;l=K;if((a[m]&1)==0){s=l;t=o;u=t;v=0;w=u;y=s;be(w|0)}J2(c[h+8>>2]|0);s=l;t=o;u=t;v=0;w=u;y=s;be(w|0)}else{x=0}}while(0);h=bQ(-1,-1)|0;e=h;h=K;if((a[k]&1)==0){s=h;t=e;u=t;v=0;w=u;y=s;be(w|0)}J2(c[f+8>>2]|0);s=h;t=e;u=t;v=0;w=u;y=s;be(w|0)}function pX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d|0;f=e;g=e;a[g]=8;h=f+1|0;j=h;C=1819047278;a[j]=C;C=C>>8;a[j+1|0]=C;C=C>>8;a[j+2|0]=C;C=C>>8;a[j+3|0]=C;a[f+5|0]=0;x=0,ax(64,b+4|0,h|0,4)|0;do{if(!x){h=c[b+20>>2]|0;if((h|0)!=0){x=0;aq(316,h+64|0,e|0);if(x){x=0;break}}if((a[g]&1)==0){i=d;return}J2(c[e+8>>2]|0);i=d;return}else{x=0}}while(0);d=bQ(-1,-1)|0;if((a[g]&1)==0){be(d|0)}J2(c[e+8>>2]|0);be(d|0)}function pY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=d+28|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+36>>2]|0;j=c[d+32>>2]|0;if(j>>>0>4294967279>>>0){CJ(0)}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=J0(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}Kb(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+4|0;if((l&1)==0){t=f+1|0}else{t=c[f+8>>2]|0}q=l&255;if((q&1|0)==0){u=q>>>1}else{u=c[f+4>>2]|0}x=0,ax(64,r|0,t|0,u|0)|0;do{if(!x){u=b+20|0;t=c[u>>2]|0;if((t|0)!=0){x=0;aq(316,t+64|0,f|0);if(x){x=0;break}}if((a[m]&1)!=0){J2(c[f+8>>2]|0)}t=d+40|0;if((c[t>>2]|0)!=0){q=g;l=g;a[l]=4;j=q+1|0;p=j;C=8250;a[p]=C;C=C>>8;a[p+1|0]=C;a[q+3|0]=0;x=0,ax(64,r|0,j|0,2)|0;do{if(!x){j=c[u>>2]|0;if((j|0)!=0){x=0;aq(316,j+64|0,g|0);if(x){x=0;break}}if((a[l]&1)!=0){J2(c[g+8>>2]|0)}j=c[t>>2]|0;cy[c[(c[j>>2]|0)+8>>2]&1023](j|0,b|0);i=e;return}else{x=0}}while(0);t=bQ(-1,-1)|0;j=t;t=K;if((a[l]&1)==0){v=t;w=j;y=w;z=0;A=y;B=v;be(A|0)}J2(c[g+8>>2]|0);v=t;w=j;y=w;z=0;A=y;B=v;be(A|0)}if((a[d+44|0]&1)==0){i=e;return}j=h;a[j]=6;t=h+1|0;a[t]=a[4272]|0;a[t+1|0]=a[4273]|0;a[t+2|0]=a[4274]|0;a[h+4|0]=0;x=0,ax(64,r|0,t|0,3)|0;do{if(!x){t=c[u>>2]|0;if((t|0)!=0){x=0;aq(316,t+64|0,h|0);if(x){x=0;break}}if((a[j]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);u=bQ(-1,-1)|0;l=u;u=K;if((a[j]&1)==0){v=u;w=l;y=w;z=0;A=y;B=v;be(A|0)}J2(c[h+8>>2]|0);v=u;w=l;y=w;z=0;A=y;B=v;be(A|0)}else{x=0}}while(0);h=bQ(-1,-1)|0;e=h;h=K;if((a[m]&1)==0){v=h;w=e;y=w;z=0;A=y;B=v;be(A|0)}J2(c[f+8>>2]|0);v=h;w=e;y=w;z=0;A=y;B=v;be(A|0)}function pZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,1)|0;do{if(!x){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}m=d+32|0;n=c[m>>2]|0;o=d+36|0;L9:do{if((n|0)!=(c[o>>2]|0)){p=c[n>>2]|0;q=b|0;cy[c[(c[p>>2]|0)+8>>2]&1023](p,q);p=(c[o>>2]|0)-(c[m>>2]|0)>>2;if(p>>>0<=1>>>0){break}r=g;s=g;t=r+1|0;u=t;v=r+3|0;r=g+8|0;w=1;while(1){a[s]=4;C=8236;a[u]=C;C=C>>8;a[u+1|0]=C;a[v]=0;x=0,ax(64,j|0,t|0,2)|0;if(x){x=0;break}y=c[l>>2]|0;if((y|0)!=0){x=0;aq(316,y+64|0,g|0);if(x){x=0;break}}if((a[s]&1)!=0){J2(c[r>>2]|0)}y=c[(c[m>>2]|0)+(w<<2)>>2]|0;cy[c[(c[y>>2]|0)+8>>2]&1023](y,q);w=w+1|0;if(w>>>0>=p>>>0){break L9}}p=bQ(-1,-1)|0;w=p;p=K;if((a[s]&1)==0){z=w;A=p;B=z;D=0;E=B;F=A;be(E|0)}J2(c[r>>2]|0);z=w;A=p;B=z;D=0;E=B;F=A;be(E|0)}}while(0);m=h;o=h;a[o]=2;n=m+1|0;a[n]=41;a[m+2|0]=0;x=0,ax(64,j|0,n|0,1)|0;do{if(!x){n=c[l>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,h|0);if(x){x=0;break}}if((a[o]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);l=bQ(-1,-1)|0;n=l;l=K;if((a[o]&1)==0){z=n;A=l;B=z;D=0;E=B;F=A;be(E|0)}J2(c[h+8>>2]|0);z=n;A=l;B=z;D=0;E=B;F=A;be(E|0)}else{x=0}}while(0);h=bQ(-1,-1)|0;e=h;h=K;if((a[k]&1)==0){z=e;A=h;B=z;D=0;E=B;F=A;be(E|0)}J2(c[f+8>>2]|0);z=e;A=h;B=z;D=0;E=B;F=A;be(E|0)}function p_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+40|0;if((a[k]&1)==0){l=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];m=a[l]|0;n=l}else{l=c[d+48>>2]|0;o=c[d+44>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){p=o<<1&255;q=f;a[q]=p;r=f+1|0;s=p;t=q}else{q=o+16&-16;p=J0(q)|0;c[f+8>>2]=p;u=q|1;c[f>>2]=u;c[f+4>>2]=o;r=p;s=u&255;t=f}Kb(r|0,l|0,o)|0;a[r+o|0]=0;m=s;n=t}t=m&255;if((t&1|0)==0){v=t>>>1}else{v=c[f+4>>2]|0}if((a[n]&1)!=0){J2(c[f+8>>2]|0)}L19:do{if((v|0)!=0){if((a[k]&1)==0){f=g;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];w=a[f]|0;y=f}else{f=c[d+48>>2]|0;n=c[d+44>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){t=n<<1&255;m=g;a[m]=t;z=g+1|0;A=t;B=m}else{m=n+16&-16;t=J0(m)|0;c[g+8>>2]=t;s=m|1;c[g>>2]=s;c[g+4>>2]=n;z=t;A=s&255;B=g}Kb(z|0,f|0,n)|0;a[z+n|0]=0;w=A;y=B}n=b+4|0;if((w&1)==0){D=g+1|0}else{D=c[g+8>>2]|0}f=w&255;if((f&1|0)==0){E=f>>>1}else{E=c[g+4>>2]|0}x=0,ax(64,n|0,D|0,E|0)|0;do{if(!x){f=b+20|0;s=c[f>>2]|0;if((s|0)!=0){x=0;aq(316,s+64|0,g|0);if(x){x=0;break}}if((a[y]&1)!=0){J2(c[g+8>>2]|0)}s=h;t=h;a[t]=4;m=s+1|0;o=m;C=8250;a[o]=C;C=C>>8;a[o+1|0]=C;a[s+3|0]=0;x=0,ax(64,n|0,m|0,2)|0;do{if(!x){m=c[f>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,h|0);if(x){x=0;break}}if((a[t]&1)==0){break L19}J2(c[h+8>>2]|0);break L19}else{x=0}}while(0);f=bQ(-1,-1)|0;m=f;f=K;if((a[t]&1)==0){F=f;G=m;H=G;I=0;J=H;L=F;be(J|0)}J2(c[h+8>>2]|0);F=f;G=m;H=G;I=0;J=H;L=F;be(J|0)}else{x=0}}while(0);n=bQ(-1,-1)|0;m=n;n=K;if((a[y]&1)==0){F=n;G=m;H=G;I=0;J=H;L=F;be(J|0)}J2(c[g+8>>2]|0);F=n;G=m;H=G;I=0;J=H;L=F;be(J|0)}}while(0);g=c[d+36>>2]|0;if((c[g+32>>2]|0)==6){i=e;return}cy[c[(c[g>>2]|0)+8>>2]&1023](g|0,b|0);if((a[d+52|0]&1)==0){i=e;return}d=j;a[d]=6;g=j+1|0;a[g]=a[4272]|0;a[g+1|0]=a[4273]|0;a[g+2|0]=a[4274]|0;a[j+4|0]=0;x=0,ax(64,b+4|0,g|0,3)|0;do{if(!x){g=c[b+20>>2]|0;if((g|0)!=0){x=0;aq(316,g+64|0,j|0);if(x){x=0;break}}if((a[d]&1)==0){i=e;return}J2(c[j+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;b=e;e=K;if((a[d]&1)==0){F=e;G=b;H=G;I=0;J=H;L=F;be(J|0)}J2(c[j+8>>2]|0);F=e;G=b;H=G;I=0;J=H;L=F;be(J|0)}function p$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,1)|0;do{if(!x){l=b+20|0;m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}m=d+40|0;n=c[m>>2]|0;o=d+44|0;L9:do{if((n|0)!=(c[o>>2]|0)){p=c[n>>2]|0;q=b|0;cy[c[(c[p>>2]|0)+8>>2]&1023](p,q);p=(c[o>>2]|0)-(c[m>>2]|0)>>2;if(p>>>0<=1>>>0){break}r=g;s=g;t=r+1|0;u=t;v=r+3|0;r=g+8|0;w=1;while(1){a[s]=4;C=8236;a[u]=C;C=C>>8;a[u+1|0]=C;a[v]=0;x=0,ax(64,j|0,t|0,2)|0;if(x){x=0;break}y=c[l>>2]|0;if((y|0)!=0){x=0;aq(316,y+64|0,g|0);if(x){x=0;break}}if((a[s]&1)!=0){J2(c[r>>2]|0)}y=c[(c[m>>2]|0)+(w<<2)>>2]|0;cy[c[(c[y>>2]|0)+8>>2]&1023](y,q);w=w+1|0;if(w>>>0>=p>>>0){break L9}}p=bQ(-1,-1)|0;w=p;p=K;if((a[s]&1)==0){z=w;A=p;B=z;D=0;E=B;F=A;be(E|0)}J2(c[r>>2]|0);z=w;A=p;B=z;D=0;E=B;F=A;be(E|0)}}while(0);m=h;o=h;a[o]=2;n=m+1|0;a[n]=41;a[m+2|0]=0;x=0,ax(64,j|0,n|0,1)|0;do{if(!x){n=c[l>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,h|0);if(x){x=0;break}}if((a[o]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);l=bQ(-1,-1)|0;n=l;l=K;if((a[o]&1)==0){z=n;A=l;B=z;D=0;E=B;F=A;be(E|0)}J2(c[h+8>>2]|0);z=n;A=l;B=z;D=0;E=B;F=A;be(E|0)}else{x=0}}while(0);h=bQ(-1,-1)|0;e=h;h=K;if((a[k]&1)==0){z=e;A=h;B=z;D=0;E=B;F=A;be(E|0)}J2(c[f+8>>2]|0);z=e;A=h;B=z;D=0;E=B;F=A;be(E|0)}function p0(a,b){a=a|0;b=b|0;var d=0;d=c[b+32>>2]|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d,a|0);return}function p1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e|0;g=c[d+32>>2]|0;if((g|0)!=0){cy[c[(c[g>>2]|0)+8>>2]&1023](g|0,b|0);i=e;return}g=f;d=f;a[d]=2;h=g+1|0;a[h]=38;a[g+2|0]=0;x=0,ax(64,b+4|0,h|0,1)|0;do{if(!x){h=c[b+20>>2]|0;if((h|0)!=0){x=0;aq(316,h+64|0,f|0);if(x){x=0;break}}if((a[d]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[d]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function p2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=d+32|0;if((a[g]&1)==0){h=f;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];j=a[h]|0;k=h}else{h=c[d+40>>2]|0;g=c[d+36>>2]|0;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){d=g<<1&255;l=f;a[l]=d;m=f+1|0;n=d;o=l}else{l=g+16&-16;d=J0(l)|0;c[f+8>>2]=d;p=l|1;c[f>>2]=p;c[f+4>>2]=g;m=d;n=p&255;o=f}Kb(m|0,h|0,g)|0;a[m+g|0]=0;j=n;k=o}if((j&1)==0){q=f+1|0}else{q=c[f+8>>2]|0}o=j&255;if((o&1|0)==0){r=o>>>1}else{r=c[f+4>>2]|0}x=0,ax(64,b+4|0,q|0,r|0)|0;do{if(!x){r=c[b+20>>2]|0;if((r|0)!=0){x=0;aq(316,r+64|0,f|0);if(x){x=0;break}}if((a[k]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[k]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function p3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e|0;g=b+20|0;h=c[g>>2]|0;if((h|0)!=0){zl(h+64|0,d|0)}h=d+32|0;if((a[h]&1)==0){j=f;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];k=a[j]|0;l=j}else{j=c[d+40>>2]|0;h=c[d+36>>2]|0;if(h>>>0>4294967279>>>0){CJ(0)}if(h>>>0<11>>>0){d=h<<1&255;m=f;a[m]=d;n=f+1|0;o=d;p=m}else{m=h+16&-16;d=J0(m)|0;c[f+8>>2]=d;q=m|1;c[f>>2]=q;c[f+4>>2]=h;n=d;o=q&255;p=f}Kb(n|0,j|0,h)|0;a[n+h|0]=0;k=o;l=p}if((k&1)==0){r=f+1|0}else{r=c[f+8>>2]|0}p=k&255;if((p&1|0)==0){s=p>>>1}else{s=c[f+4>>2]|0}x=0,ax(64,b+4|0,r|0,s|0)|0;do{if(!x){s=c[g>>2]|0;if((s|0)!=0){x=0;aq(316,s+64|0,f|0);if(x){x=0;break}}if((a[l]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[l]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function p4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+16|0;f=e|0;g=b+20|0;h=c[g>>2]|0;if((h|0)!=0){zl(h+64|0,d|0)}h=d+32|0;if((a[h]&1)==0){j=f;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];k=a[j]|0;l=j}else{j=c[d+40>>2]|0;h=c[d+36>>2]|0;if(h>>>0>4294967279>>>0){CJ(0)}if(h>>>0<11>>>0){d=h<<1&255;m=f;a[m]=d;n=f+1|0;o=d;p=m}else{m=h+16&-16;d=J0(m)|0;c[f+8>>2]=d;q=m|1;c[f>>2]=q;c[f+4>>2]=h;n=d;o=q&255;p=f}Kb(n|0,j|0,h)|0;a[n+h|0]=0;k=o;l=p}if((k&1)==0){r=f+1|0}else{r=c[f+8>>2]|0}p=k&255;if((p&1|0)==0){s=p>>>1}else{s=c[f+4>>2]|0}x=0,ax(64,b+4|0,r|0,s|0)|0;do{if(!x){s=c[g>>2]|0;if((s|0)!=0){x=0;aq(316,s+64|0,f|0);if(x){x=0;break}}if((a[l]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;if((a[l]&1)==0){be(e|0)}J2(c[f+8>>2]|0);be(e|0)}function p5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;e=i;i=i+96|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=b+20|0;n=c[m>>2]|0;if((n|0)!=0){zl(n+64|0,d|0)}n=f;o=f;a[o]=2;p=n+1|0;a[p]=91;a[n+2|0]=0;n=b+4|0;x=0,ax(64,n|0,p|0,1)|0;do{if(!x){p=c[m>>2]|0;if((p|0)!=0){x=0;aq(316,p+64|0,f|0);if(x){x=0;break}}if((a[o]&1)!=0){J2(c[f+8>>2]|0)}p=d+32|0;if((a[p]&1)==0){b=g;c[b>>2]=c[p>>2];c[b+4>>2]=c[p+4>>2];c[b+8>>2]=c[p+8>>2];q=a[b]|0;r=b}else{b=c[d+40>>2]|0;p=c[d+36>>2]|0;if(p>>>0>4294967279>>>0){CJ(0)}if(p>>>0<11>>>0){s=p<<1&255;t=g;a[t]=s;u=g+1|0;v=s;w=t}else{t=p+16&-16;s=J0(t)|0;c[g+8>>2]=s;y=t|1;c[g>>2]=y;c[g+4>>2]=p;u=s;v=y&255;w=g}Kb(u|0,b|0,p)|0;a[u+p|0]=0;q=v;r=w}if((q&1)==0){z=g+1|0}else{z=c[g+8>>2]|0}p=q&255;if((p&1|0)==0){A=p>>>1}else{A=c[g+4>>2]|0}x=0,ax(64,n|0,z|0,A|0)|0;do{if(!x){p=c[m>>2]|0;if((p|0)!=0){x=0;aq(316,p+64|0,g|0);if(x){x=0;break}}if((a[r]&1)!=0){J2(c[g+8>>2]|0)}p=d+44|0;if((a[p]&1)==0){b=h;c[b>>2]=c[p>>2];c[b+4>>2]=c[p+4>>2];c[b+8>>2]=c[p+8>>2];B=a[b]|0;C=b}else{b=c[d+52>>2]|0;y=c[d+48>>2]|0;if(y>>>0>4294967279>>>0){CJ(0)}if(y>>>0<11>>>0){s=y<<1&255;t=h;a[t]=s;D=h+1|0;E=s;F=t}else{t=y+16&-16;s=J0(t)|0;c[h+8>>2]=s;G=t|1;c[h>>2]=G;c[h+4>>2]=y;D=s;E=G&255;F=h}Kb(D|0,b|0,y)|0;a[D+y|0]=0;B=E;C=F}y=B&255;if((y&1|0)==0){H=y>>>1}else{H=c[h+4>>2]|0}if((a[C]&1)!=0){J2(c[h+8>>2]|0)}L57:do{if((H|0)!=0){if((a[p]&1)==0){y=j;c[y>>2]=c[p>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];I=a[y]|0;J=y}else{y=c[d+52>>2]|0;b=c[d+48>>2]|0;if(b>>>0>4294967279>>>0){CJ(0)}if(b>>>0<11>>>0){G=b<<1&255;s=j;a[s]=G;L=j+1|0;M=G;N=s}else{s=b+16&-16;G=J0(s)|0;c[j+8>>2]=G;t=s|1;c[j>>2]=t;c[j+4>>2]=b;L=G;M=t&255;N=j}Kb(L|0,y|0,b)|0;a[L+b|0]=0;I=M;J=N}if((I&1)==0){O=j+1|0}else{O=c[j+8>>2]|0}b=I&255;if((b&1|0)==0){P=b>>>1}else{P=c[j+4>>2]|0}x=0,ax(64,n|0,O|0,P|0)|0;do{if(!x){b=c[m>>2]|0;if((b|0)!=0){x=0;aq(316,b+64|0,j|0);if(x){x=0;break}}if((a[J]&1)!=0){J2(c[j+8>>2]|0)}b=d+56|0;if((a[b]&1)==0){y=k;c[y>>2]=c[b>>2];c[y+4>>2]=c[b+4>>2];c[y+8>>2]=c[b+8>>2];Q=a[y]|0;R=y}else{y=c[d+64>>2]|0;b=c[d+60>>2]|0;if(b>>>0>4294967279>>>0){CJ(0)}if(b>>>0<11>>>0){t=b<<1&255;G=k;a[G]=t;S=k+1|0;T=t;U=G}else{G=b+16&-16;t=J0(G)|0;c[k+8>>2]=t;s=G|1;c[k>>2]=s;c[k+4>>2]=b;S=t;T=s&255;U=k}Kb(S|0,y|0,b)|0;a[S+b|0]=0;Q=T;R=U}if((Q&1)==0){V=k+1|0}else{V=c[k+8>>2]|0}b=Q&255;if((b&1|0)==0){W=b>>>1}else{W=c[k+4>>2]|0}x=0,ax(64,n|0,V|0,W|0)|0;do{if(!x){b=c[m>>2]|0;if((b|0)!=0){x=0;aq(316,b+64|0,k|0);if(x){x=0;break}}if((a[R]&1)==0){break L57}J2(c[k+8>>2]|0);break L57}else{x=0}}while(0);b=bQ(-1,-1)|0;y=b;b=K;if((a[R]&1)==0){X=b;Y=y;Z=Y;_=0;$=Z;aa=X;be($|0)}J2(c[k+8>>2]|0);X=b;Y=y;Z=Y;_=0;$=Z;aa=X;be($|0)}else{x=0}}while(0);y=bQ(-1,-1)|0;b=y;y=K;if((a[J]&1)==0){X=y;Y=b;Z=Y;_=0;$=Z;aa=X;be($|0)}J2(c[j+8>>2]|0);X=y;Y=b;Z=Y;_=0;$=Z;aa=X;be($|0)}}while(0);p=l;b=l;a[b]=2;y=p+1|0;a[y]=93;a[p+2|0]=0;x=0,ax(64,n|0,y|0,1)|0;do{if(!x){y=c[m>>2]|0;if((y|0)!=0){x=0;aq(316,y+64|0,l|0);if(x){x=0;break}}if((a[b]&1)==0){i=e;return}J2(c[l+8>>2]|0);i=e;return}else{x=0}}while(0);y=bQ(-1,-1)|0;p=y;y=K;if((a[b]&1)==0){X=y;Y=p;Z=Y;_=0;$=Z;aa=X;be($|0)}J2(c[l+8>>2]|0);X=y;Y=p;Z=Y;_=0;$=Z;aa=X;be($|0)}else{x=0}}while(0);p=bQ(-1,-1)|0;y=p;p=K;if((a[r]&1)==0){X=p;Y=y;Z=Y;_=0;$=Z;aa=X;be($|0)}J2(c[g+8>>2]|0);X=p;Y=y;Z=Y;_=0;$=Z;aa=X;be($|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;r=g;g=K;if((a[o]&1)==0){X=g;Y=r;Z=Y;_=0;$=Z;aa=X;be($|0)}J2(c[f+8>>2]|0);X=g;Y=r;Z=Y;_=0;$=Z;aa=X;be($|0)}function p6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=b+20|0;j=c[h>>2]|0;if((j|0)!=0){zl(j+64|0,d|0)}j=d+32|0;if((a[j]&1)==0){k=f;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[d+40>>2]|0;j=c[d+36>>2]|0;if(j>>>0>4294967279>>>0){CJ(0)}if(j>>>0<11>>>0){n=j<<1&255;o=f;a[o]=n;p=f+1|0;q=n;r=o}else{o=j+16&-16;n=J0(o)|0;c[f+8>>2]=n;s=o|1;c[f>>2]=s;c[f+4>>2]=j;p=n;q=s&255;r=f}Kb(p|0,k|0,j)|0;a[p+j|0]=0;l=q;m=r}r=b+4|0;if((l&1)==0){t=f+1|0}else{t=c[f+8>>2]|0}q=l&255;if((q&1|0)==0){u=q>>>1}else{u=c[f+4>>2]|0}x=0,ax(64,r|0,t|0,u|0)|0;do{if(!x){u=c[h>>2]|0;if((u|0)!=0){x=0;aq(316,u+64|0,f|0);if(x){x=0;break}}if((a[m]&1)!=0){J2(c[f+8>>2]|0)}u=c[d+44>>2]|0;if((u|0)==0){i=e;return}cy[c[(c[u>>2]|0)+8>>2]&1023](u,b|0);u=g;t=g;a[t]=2;q=u+1|0;a[q]=41;a[u+2|0]=0;x=0,ax(64,r|0,q|0,1)|0;do{if(!x){q=c[h>>2]|0;if((q|0)!=0){x=0;aq(316,q+64|0,g|0);if(x){x=0;break}}if((a[t]&1)==0){i=e;return}J2(c[g+8>>2]|0);i=e;return}else{x=0}}while(0);q=bQ(-1,-1)|0;u=q;q=K;if((a[t]&1)==0){v=q;w=u;y=w;z=0;A=y;B=v;be(A|0)}J2(c[g+8>>2]|0);v=q;w=u;y=w;z=0;A=y;B=v;be(A|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;e=g;g=K;if((a[m]&1)==0){v=g;w=e;y=w;z=0;A=y;B=v;be(A|0)}J2(c[f+8>>2]|0);v=g;w=e;y=w;z=0;A=y;B=v;be(A|0)}function p7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=b+20|0;j=c[h>>2]|0;if((j|0)!=0){zl(j+64|0,d|0)}j=f;k=f;a[k]=10;l=j+1|0;a[l]=a[3640]|0;a[l+1|0]=a[3641]|0;a[l+2|0]=a[3642]|0;a[l+3|0]=a[3643]|0;a[l+4|0]=a[3644]|0;a[j+6|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,5)|0;do{if(!x){l=c[h>>2]|0;if((l|0)!=0){x=0;aq(316,l+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}l=c[d+32>>2]|0;cy[c[(c[l>>2]|0)+8>>2]&1023](l|0,b|0);l=g;m=g;a[m]=2;n=l+1|0;a[n]=41;a[l+2|0]=0;x=0,ax(64,j|0,n|0,1)|0;do{if(!x){n=c[h>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,g|0);if(x){x=0;break}}if((a[m]&1)==0){i=e;return}J2(c[g+8>>2]|0);i=e;return}else{x=0}}while(0);n=bQ(-1,-1)|0;l=n;n=K;if((a[m]&1)==0){o=n;p=l;q=p;r=0;s=q;t=o;be(s|0)}J2(c[g+8>>2]|0);o=n;p=l;q=p;r=0;s=q;t=o;be(s|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;e=g;g=K;if((a[k]&1)==0){o=g;p=e;q=p;r=0;s=q;t=o;be(s|0)}J2(c[f+8>>2]|0);o=g;p=e;q=p;r=0;s=q;t=o;be(s|0)}function p8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=b+36|0;e=c[d>>2]|0;f=(c[b+40>>2]|0)-e>>2;if((f|0)==0){return}b=a|0;a=0;g=e;while(1){e=c[g+(a<<2)>>2]|0;cy[c[(c[e>>2]|0)+8>>2]&1023](e|0,b);e=a+1|0;if(e>>>0>=f>>>0){break}a=e;g=c[d>>2]|0}return}function p9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=c[d+36>>2]|0;m=c[d+40>>2]|0;n=c[d+32>>2]|0;L1:do{if((l|0)!=0){cy[c[(c[l>>2]|0)+8>>2]&1023](l,b|0);if((m|0)==0){break}d=f;o=f;a[o]=2;p=d+1|0;a[p]=32;a[d+2|0]=0;d=b+4|0;x=0,ax(64,d|0,p|0,1)|0;do{if(!x){p=c[b+20>>2]|0;if((p|0)!=0){x=0;aq(316,p+64|0,f|0);if(x){x=0;break}}if((a[o]&1)==0){break L1}J2(c[f+8>>2]|0);break L1}else{x=0}}while(0);p=bQ(-1,-1)|0;d=p;p=K;if((a[o]&1)==0){q=p;r=d;s=r;t=0;u=s;v=q;be(u|0)}J2(c[f+8>>2]|0);q=p;r=d;s=r;t=0;u=s;v=q;be(u|0)}}while(0);L16:do{if((n|0)==2){f=h;l=h;a[l]=2;d=f+1|0;a[d]=126;a[f+2|0]=0;f=b+4|0;x=0,ax(64,f|0,d|0,1)|0;do{if(!x){d=c[b+20>>2]|0;if((d|0)!=0){x=0;aq(316,d+64|0,h|0);if(x){x=0;break}}if((a[l]&1)==0){break L16}J2(c[h+8>>2]|0);break L16}else{x=0}}while(0);o=bQ(-1,-1)|0;d=o;o=K;if((a[l]&1)==0){q=o;r=d;s=r;t=0;u=s;v=q;be(u|0)}J2(c[h+8>>2]|0);q=o;r=d;s=r;t=0;u=s;v=q;be(u|0)}else if((n|0)==3){d=j;o=j;a[o]=2;f=d+1|0;a[f]=43;a[d+2|0]=0;x=0,ax(64,b+4|0,f|0,1)|0;do{if(!x){f=c[b+20>>2]|0;if((f|0)!=0){x=0;aq(316,f+64|0,j|0);if(x){x=0;break}}if((a[o]&1)==0){break L16}J2(c[j+8>>2]|0);break L16}else{x=0}}while(0);l=bQ(-1,-1)|0;f=l;l=K;if((a[o]&1)==0){q=l;r=f;s=r;t=0;u=s;v=q;be(u|0)}J2(c[j+8>>2]|0);q=l;r=f;s=r;t=0;u=s;v=q;be(u|0)}else if((n|0)==1){f=g;l=g;a[l]=2;d=f+1|0;a[d]=62;a[f+2|0]=0;x=0,ax(64,b+4|0,d|0,1)|0;do{if(!x){d=c[b+20>>2]|0;if((d|0)!=0){x=0;aq(316,d+64|0,g|0);if(x){x=0;break}}if((a[l]&1)==0){break L16}J2(c[g+8>>2]|0);break L16}else{x=0}}while(0);o=bQ(-1,-1)|0;d=o;o=K;if((a[l]&1)==0){q=o;r=d;s=r;t=0;u=s;v=q;be(u|0)}J2(c[g+8>>2]|0);q=o;r=d;s=r;t=0;u=s;v=q;be(u|0)}}while(0);g=(m|0)!=0;L54:do{if(!((n|0)==0|g^1)){j=k;h=k;a[h]=2;d=j+1|0;a[d]=32;a[j+2|0]=0;j=b+4|0;x=0,ax(64,j|0,d|0,1)|0;do{if(!x){d=c[b+20>>2]|0;if((d|0)!=0){x=0;aq(316,d+64|0,k|0);if(x){x=0;break}}if((a[h]&1)==0){break L54}J2(c[k+8>>2]|0);break L54}else{x=0}}while(0);l=bQ(-1,-1)|0;d=l;l=K;if((a[h]&1)==0){q=l;r=d;s=r;t=0;u=s;v=q;be(u|0)}J2(c[k+8>>2]|0);q=l;r=d;s=r;t=0;u=s;v=q;be(u|0)}}while(0);if(!g){i=e;return}cy[c[(c[m>>2]|0)+8>>2]&1023](m,b|0);i=e;return}function qa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;g=d+36|0;h=c[g>>2]|0;j=d+40|0;if((h|0)==(c[j>>2]|0)){i=e;return}d=c[h>>2]|0;h=b|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d,h);d=(c[j>>2]|0)-(c[g>>2]|0)>>2;if(d>>>0<=1>>>0){i=e;return}j=f;k=f;l=j+1|0;m=l;n=j+3|0;j=b+4|0;o=b+20|0;b=f+8|0;p=1;while(1){a[k]=4;C=8236;a[m]=C;C=C>>8;a[m+1|0]=C;a[n]=0;x=0,ax(64,j|0,l|0,2)|0;if(x){x=0;break}q=c[o>>2]|0;if((q|0)!=0){x=0;aq(316,q+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[b>>2]|0)}q=c[(c[g>>2]|0)+(p<<2)>>2]|0;cy[c[(c[q>>2]|0)+8>>2]&1023](q,h);q=p+1|0;if(q>>>0<d>>>0){p=q}else{r=14;break}}if((r|0)==14){i=e;return}e=bQ(-1,-1)|0;if((a[k]&1)==0){be(e|0)}J2(c[b>>2]|0);be(e|0)}function qb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0;f=i;i=i+16|0;g=f|0;h=g;j=d;k=d;l=a[k]|0;m=l&255;n=(m&1|0)==0;if(n){o=m>>>1}else{o=c[d+4>>2]|0}if((o|0)==0){o=b;a[b]=4;Ke(o+1|0,e|0,2)|0;a[o+3|0]=0;i=f;return}o=l&1;do{if(e<<24>>24!=0){l=o<<24>>24==0;if(l){p=j+1|0}else{p=c[d+8>>2]|0}if((a[p]|0)==34){break}if(l){q=j+1|0}else{q=c[d+8>>2]|0}if((a[q]|0)==39){break}Ke(h|0,0,12)|0;if(n){r=m>>>1}else{r=c[d+4>>2]|0}x=0;aq(602,g|0,r+2|0);L25:do{if(!x){l=g;s=a[h]|0;if((s&1)==0){t=(s&255)>>>1;u=10;v=s}else{w=c[g>>2]|0;t=c[g+4>>2]|0;u=(w&-2)-1|0;v=w&255}if((t|0)==(u|0)){if((u|0)==-17){x=0;ap(232,0);if(x){x=0;y=74;break}}if((v&1)==0){z=l+1|0}else{z=c[g+8>>2]|0}do{if(u>>>0<2147483623>>>0){w=u+1|0;A=u<<1;B=w>>>0<A>>>0?A:w;if(B>>>0<11>>>0){C=11;break}C=B+16&-16}else{C=-17}}while(0);B=(x=0,as(230,C|0)|0);if(x){x=0;y=74;break}Kb(B|0,z|0,u)|0;if((u|0)!=10){J2(z)}c[g+8>>2]=B;B=C|1;c[g>>2]=B;D=B&255}else{D=s}if((D&1)==0){a[h]=(t<<1)+2;E=l+1|0;F=t+1|0}else{B=c[g+8>>2]|0;w=t+1|0;c[g+4>>2]=w;E=B;F=w}a[E+t|0]=e;a[E+F|0]=0;w=a[k]|0;B=w&255;if((B&1|0)==0){G=B>>>1}else{G=c[d+4>>2]|0}L58:do{if((G|0)!=0){B=j+1|0;A=l+1|0;H=g+8|0;I=g|0;J=g+4|0;L=d+8|0;M=0;N=w;while(1){if((N&1)==0){O=B}else{O=c[L>>2]|0}if((a[O+M|0]|0)==e<<24>>24){P=a[h]|0;if((P&1)==0){Q=(P&255)>>>1;R=10;S=P}else{T=c[I>>2]|0;Q=c[J>>2]|0;R=(T&-2)-1|0;S=T&255}if((Q|0)==(R|0)){if((R|0)==-17){y=60;break}T=(S&1)==0?A:c[H>>2]|0;do{if(R>>>0<2147483623>>>0){U=R+1|0;V=R<<1;W=U>>>0<V>>>0?V:U;if(W>>>0<11>>>0){X=11;break}X=W+16&-16}else{X=-17}}while(0);W=(x=0,as(230,X|0)|0);if(x){x=0;Y=S;y=73;break}Kb(W|0,T|0,R)|0;if((R|0)!=10){J2(T)}c[H>>2]=W;W=X|1;c[I>>2]=W;Z=W&255}else{Z=P}if((Z&1)==0){a[h]=(Q<<1)+2;_=A;$=Q+1|0}else{W=c[H>>2]|0;U=Q+1|0;c[J>>2]=U;_=W;$=U}a[_+Q|0]=92;a[_+$|0]=0;aa=a[k]|0}else{aa=N}if((aa&1)==0){ab=B}else{ab=c[L>>2]|0}U=a[ab+M|0]|0;W=a[h]|0;if((W&1)==0){ac=(W&255)>>>1;ad=10;ae=W}else{V=c[I>>2]|0;ac=c[J>>2]|0;ad=(V&-2)-1|0;ae=V&255}if((ac|0)==(ad|0)){if((ad|0)==-17){y=84;break}V=(ae&1)==0?A:c[H>>2]|0;do{if(ad>>>0<2147483623>>>0){af=ad+1|0;ag=ad<<1;ah=af>>>0<ag>>>0?ag:af;if(ah>>>0<11>>>0){ai=11;break}ai=ah+16&-16}else{ai=-17}}while(0);P=(x=0,as(230,ai|0)|0);if(x){x=0;Y=ae;y=73;break}Kb(P|0,V|0,ad)|0;if((ad|0)!=10){J2(V)}c[H>>2]=P;P=ai|1;c[I>>2]=P;aj=P&255}else{aj=W}if((aj&1)==0){a[h]=(ac<<1)+2;ak=A;al=ac+1|0}else{P=c[H>>2]|0;T=ac+1|0;c[J>>2]=T;ak=P;al=T}a[ak+ac|0]=U;a[ak+al|0]=0;T=M+1|0;if(T>>>0>=G>>>0){break L58}M=T;N=a[k]|0}if((y|0)==60){x=0;ap(232,0);if(x){x=0;y=74;break L25}}else if((y|0)==73){N=bQ(-1,-1)|0;am=K;an=N;ao=Y;break L25}else if((y|0)==84){x=0;ap(232,0);if(x){x=0;y=74;break L25}}}}while(0);w=a[h]|0;if((w&1)==0){ar=(w&255)>>>1;at=10;au=w}else{s=c[g>>2]|0;ar=c[g+4>>2]|0;at=(s&-2)-1|0;au=s&255}if((ar|0)==(at|0)){if((at|0)==-17){x=0;ap(232,0);if(x){x=0;y=74;break}}if((au&1)==0){av=l+1|0}else{av=c[g+8>>2]|0}do{if(at>>>0<2147483623>>>0){s=at+1|0;N=at<<1;M=s>>>0<N>>>0?N:s;if(M>>>0<11>>>0){aw=11;break}aw=M+16&-16}else{aw=-17}}while(0);M=(x=0,as(230,aw|0)|0);if(x){x=0;y=74;break}Kb(M|0,av|0,at)|0;if((at|0)!=10){J2(av)}c[g+8>>2]=M;M=aw|1;c[g>>2]=M;ax=M&255}else{ax=w}if((ax&1)==0){a[h]=(ar<<1)+2;ay=l+1|0;az=ar+1|0}else{M=c[g+8>>2]|0;s=ar+1|0;c[g+4>>2]=s;ay=M;az=s}a[ay+ar|0]=e;a[ay+az|0]=0;s=(a[h]&1)==0;if(s){M=b;c[M>>2]=c[h>>2];c[M+4>>2]=c[h+4>>2];c[M+8>>2]=c[h+8>>2];i=f;return}M=c[g+8>>2]|0;N=c[g+4>>2]|0;if(N>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;y=74;break}}if(N>>>0<11>>>0){a[b]=N<<1;aA=b+1|0}else{J=N+16&-16;H=(x=0,as(230,J|0)|0);if(x){x=0;y=74;break}c[b+8>>2]=H;c[b>>2]=J|1;c[b+4>>2]=N;aA=H}Kb(aA|0,M|0,N)|0;a[aA+N|0]=0;if(s){i=f;return}J2(c[g+8>>2]|0);i=f;return}else{x=0;y=74}}while(0);if((y|0)==74){s=bQ(-1,-1)|0;am=K;an=s;ao=a[h]|0}if((ao&1)==0){be(an|0)}J2(c[g+8>>2]|0);be(an|0)}}while(0);if(o<<24>>24==0){o=b;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];i=f;return}k=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[b]=o<<1;aB=b+1|0}else{d=o+16&-16;an=J0(d)|0;c[b+8>>2]=an;c[b>>2]=d|1;c[b+4>>2]=o;aB=an}Kb(aB|0,k|0,o)|0;a[aB+o|0]=0;i=f;return}function qc(a,b){a=a|0;b=b|0;return}function qd(b,d){b=b|0;d=d|0;var e=0;c[b>>2]=19576;e=b+4|0;a[e]=0;a[e+1|0]=0;c[b+16>>2]=d;return}function qe(b){b=b|0;var d=0;c[b>>2]=19576;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function qf(b){b=b|0;c[b>>2]=19576;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function qg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if((a[d+44|0]&1)==0){return}e=d+32|0;f=c[e>>2]|0;g=(c[d+36>>2]|0)-f>>2;if((g|0)==0){return}d=b|0;b=0;h=f;while(1){f=c[h+(b<<2)>>2]|0;cy[c[(c[f>>2]|0)+8>>2]&1023](f|0,d);f=b+1|0;if(f>>>0>=g>>>0){break}b=f;h=c[e>>2]|0}return}function qh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;e=i;i=i+32|0;f=e|0;g=e+16|0;h=c[d+32>>2]|0;j=c[d+28>>2]|0;if((a[h+29|0]&1)!=0){i=e;return}L4:do{if((a[j+46|0]&1)!=0){d=b|0;cy[c[(c[h>>2]|0)+8>>2]&1023](h|0,d);k=f;l=f;a[l]=2;m=k+1|0;a[m]=123;a[k+2|0]=0;k=b+4|0;x=0,ax(64,k|0,m|0,1)|0;do{if(!x){m=b+16|0;n=c[m>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,f|0);if(x){x=0;break}}if((a[l]&1)!=0){J2(c[f+8>>2]|0)}n=j+32|0;o=c[n>>2]|0;p=(c[j+36>>2]|0)-o>>2;L14:do{if((p|0)!=0){q=0;r=o;while(1){s=c[r+(q<<2)>>2]|0;if(!(cA[c[(c[s>>2]|0)+36>>2]&511](s)|0)){cy[c[(c[s>>2]|0)+8>>2]&1023](s|0,d)}s=q+1|0;if(s>>>0>=p>>>0){break L14}q=s;r=c[n>>2]|0}}}while(0);n=g;p=g;a[p]=2;o=n+1|0;a[o]=125;a[n+2|0]=0;x=0,ax(64,k|0,o|0,1)|0;do{if(!x){o=c[m>>2]|0;if((o|0)!=0){x=0;aq(316,o+64|0,g|0);if(x){x=0;break}}if((a[p]&1)==0){break L4}J2(c[g+8>>2]|0);break L4}else{x=0}}while(0);m=bQ(-1,-1)|0;o=m;m=K;if((a[p]&1)==0){t=o;u=m;v=t;w=0;y=v;z=u;be(y|0)}J2(c[g+8>>2]|0);t=o;u=m;v=t;w=0;y=v;z=u;be(y|0)}else{x=0}}while(0);k=bQ(-1,-1)|0;d=k;k=K;if((a[l]&1)==0){t=d;u=k;v=t;w=0;y=v;z=u;be(y|0)}J2(c[f+8>>2]|0);t=d;u=k;v=t;w=0;y=v;z=u;be(y|0)}}while(0);if((a[j+45|0]&1)==0){i=e;return}y=j+32|0;u=c[y>>2]|0;z=(c[j+36>>2]|0)-u>>2;if((z|0)==0){i=e;return}j=b|0;b=0;v=u;while(1){u=c[v+(b<<2)>>2]|0;if(cA[c[(c[u>>2]|0)+36>>2]&511](u)|0){cy[c[(c[u>>2]|0)+8>>2]&1023](u|0,j)}u=b+1|0;if(u>>>0>=z>>>0){break}b=u;v=c[y>>2]|0}i=e;return}function qi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=c[d+32>>2]|0;m=c[d+28>>2]|0;n=b+16|0;zl((c[n>>2]|0)+64|0,d|0);o=f;a[o]=14;p=f+1|0;a[p]=a[6376]|0;a[p+1|0]=a[6377]|0;a[p+2|0]=a[6378]|0;a[p+3|0]=a[6379]|0;a[p+4|0]=a[6380]|0;a[p+5|0]=a[6381]|0;a[p+6|0]=a[6382]|0;q=f+8|0;a[q]=0;r=b+4|0;x=0,ax(64,r|0,p|0,7)|0;do{if(!x){p=c[n>>2]|0;if((p|0)!=0){x=0;aq(316,p+64|0,f|0);if(x){x=0;break}}if((a[o]&1)!=0){J2(c[q>>2]|0)}p=b|0;cy[c[(c[l>>2]|0)+8>>2]&1023](l,p);s=g;t=g;a[t]=2;u=s+1|0;a[u]=123;a[s+2|0]=0;x=0,ax(64,r|0,u|0,1)|0;do{if(!x){u=c[n>>2]|0;if((u|0)!=0){x=0;aq(316,u+64|0,g|0);if(x){x=0;break}}if((a[t]&1)!=0){J2(c[g+8>>2]|0)}u=c[d+36>>2]|0;L17:do{if((u|0)==0){v=0}else{if((a[m+46|0]&1)==0){v=0;break}cy[c[(c[u>>2]|0)+8>>2]&1023](u|0,p);s=h;w=h;a[w]=2;y=s+1|0;a[y]=123;a[s+2|0]=0;x=0,ax(64,r|0,y|0,1)|0;do{if(!x){y=c[n>>2]|0;if((y|0)!=0){x=0;aq(316,y+64|0,h|0);if(x){x=0;break}}if((a[w]&1)==0){v=1;break L17}J2(c[h+8>>2]|0);v=1;break L17}else{x=0}}while(0);y=bQ(-1,-1)|0;s=y;y=K;if((a[w]&1)==0){z=s;A=y;B=z;C=0;D=B;E=A;be(D|0)}J2(c[h+8>>2]|0);z=s;A=y;B=z;C=0;D=B;E=A;be(D|0)}}while(0);u=m+36|0;y=m+32|0;s=c[y>>2]|0;F=(c[u>>2]|0)-s>>2;L32:do{if((F|0)!=0){G=0;H=s;while(1){I=c[H+(G<<2)>>2]|0;if(!(cA[c[(c[I>>2]|0)+36>>2]&511](I)|0)){cy[c[(c[I>>2]|0)+8>>2]&1023](I|0,p)}I=G+1|0;if(I>>>0>=F>>>0){break L32}G=I;H=c[y>>2]|0}}}while(0);L40:do{if(v){F=j;s=j;a[s]=2;H=F+1|0;a[H]=125;a[F+2|0]=0;x=0,ax(64,r|0,H|0,1)|0;do{if(!x){H=c[n>>2]|0;if((H|0)!=0){x=0;aq(316,H+64|0,j|0);if(x){x=0;break}}if((a[s]&1)==0){break L40}J2(c[j+8>>2]|0);break L40}else{x=0}}while(0);H=bQ(-1,-1)|0;F=H;H=K;if((a[s]&1)==0){z=F;A=H;B=z;C=0;D=B;E=A;be(D|0)}J2(c[j+8>>2]|0);z=F;A=H;B=z;C=0;D=B;E=A;be(D|0)}}while(0);H=c[y>>2]|0;F=(c[u>>2]|0)-H>>2;L54:do{if((F|0)!=0){G=0;w=H;while(1){I=c[w+(G<<2)>>2]|0;if(cA[c[(c[I>>2]|0)+36>>2]&511](I)|0){cy[c[(c[I>>2]|0)+8>>2]&1023](I|0,p)}I=G+1|0;if(I>>>0>=F>>>0){break L54}G=I;w=c[y>>2]|0}}}while(0);y=k;F=k;a[F]=2;H=y+1|0;a[H]=125;a[y+2|0]=0;x=0,ax(64,r|0,H|0,1)|0;do{if(!x){H=c[n>>2]|0;if((H|0)!=0){x=0;aq(316,H+64|0,k|0);if(x){x=0;break}}if((a[F]&1)==0){i=e;return}J2(c[k+8>>2]|0);i=e;return}else{x=0}}while(0);H=bQ(-1,-1)|0;y=H;H=K;if((a[F]&1)==0){z=y;A=H;B=z;C=0;D=B;E=A;be(D|0)}J2(c[k+8>>2]|0);z=y;A=H;B=z;C=0;D=B;E=A;be(D|0)}else{x=0}}while(0);p=bQ(-1,-1)|0;H=p;p=K;if((a[t]&1)==0){z=H;A=p;B=z;C=0;D=B;E=A;be(D|0)}J2(c[g+8>>2]|0);z=H;A=p;B=z;C=0;D=B;E=A;be(D|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;k=g;g=K;if((a[o]&1)==0){z=k;A=g;B=z;C=0;D=B;E=A;be(D|0)}J2(c[q>>2]|0);z=k;A=g;B=z;C=0;D=B;E=A;be(D|0)}function qj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;e=i;i=i+80|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=d+32|0;if((a[l]&1)==0){m=f;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];n=a[m]|0;o=m}else{m=c[d+40>>2]|0;l=c[d+36>>2]|0;if(l>>>0>4294967279>>>0){CJ(0)}if(l>>>0<11>>>0){p=l<<1&255;q=f;a[q]=p;r=f+1|0;s=p;t=q}else{q=l+16&-16;p=J0(q)|0;c[f+8>>2]=p;u=q|1;c[f>>2]=u;c[f+4>>2]=l;r=p;s=u&255;t=f}Kb(r|0,m|0,l)|0;a[r+l|0]=0;n=s;o=t}t=c[d+44>>2]|0;s=c[d+28>>2]|0;d=b+4|0;if((n&1)==0){v=f+1|0}else{v=c[f+8>>2]|0}l=n&255;if((l&1|0)==0){w=l>>>1}else{w=c[f+4>>2]|0}x=0,ax(64,d|0,v|0,w|0)|0;L20:do{if(!x){w=b+16|0;v=c[w>>2]|0;if((v|0)!=0){x=0;aq(316,v+64|0,f|0);if(x){x=0;y=27;break}}L25:do{if((t|0)!=0){v=g;l=g;a[l]=2;n=v+1|0;a[n]=32;a[v+2|0]=0;x=0,ax(64,d|0,n|0,1)|0;do{if(!x){n=c[w>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,g|0);if(x){x=0;break}}if((a[l]&1)!=0){J2(c[g+8>>2]|0)}x=0;aq(c[(c[t>>2]|0)+8>>2]|0,t|0,b|0);if(!x){break L25}else{x=0;y=27;break L20}}else{x=0}}while(0);n=bQ(-1,-1)|0;v=n;n=K;if((a[l]&1)==0){z=v;A=n;break L20}J2(c[g+8>>2]|0);z=v;A=n;break L20}}while(0);L38:do{if((s|0)==0){n=h;v=h;a[v]=2;r=n+1|0;a[r]=59;a[n+2|0]=0;x=0,ax(64,d|0,r|0,1)|0;do{if(!x){r=c[w>>2]|0;if((r|0)!=0){x=0;aq(316,r+64|0,h|0);if(x){x=0;break}}if((a[v]&1)==0){break L38}J2(c[h+8>>2]|0);break L38}else{x=0}}while(0);l=bQ(-1,-1)|0;r=l;l=K;if((a[v]&1)==0){z=r;A=l;break L20}J2(c[h+8>>2]|0);z=r;A=l;break L20}else{l=j;r=j;a[r]=2;n=l+1|0;a[n]=123;a[l+2|0]=0;x=0,ax(64,d|0,n|0,1)|0;do{if(!x){n=c[w>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,j|0);if(x){x=0;break}}if((a[r]&1)!=0){J2(c[j+8>>2]|0)}n=s+36|0;l=c[n>>2]|0;m=s+32|0;u=c[m>>2]|0;p=l-u>>2;do{if((p|0)==0){B=l;C=u}else{q=b|0;D=0;E=u;while(1){F=c[E+(D<<2)>>2]|0;G=(x=0,as(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(x){x=0;y=26;break}if(!G){x=0;aq(c[(c[F>>2]|0)+8>>2]|0,F|0,q|0);if(x){x=0;y=26;break}}F=D+1|0;if(F>>>0>=p>>>0){y=53;break}D=F;E=c[m>>2]|0}if((y|0)==26){E=bQ(-1,-1)|0;H=K;I=E;y=28;break L20}else if((y|0)==53){B=c[n>>2]|0;C=c[m>>2]|0;break}}}while(0);n=B-C>>2;L70:do{if((n|0)!=0){p=b|0;u=0;l=C;while(1){E=c[l+(u<<2)>>2]|0;D=(x=0,as(c[(c[E>>2]|0)+36>>2]|0,E|0)|0);if(x){x=0;break}if(D){x=0;aq(c[(c[E>>2]|0)+8>>2]|0,E|0,p|0);if(x){x=0;break}}E=u+1|0;if(E>>>0>=n>>>0){break L70}u=E;l=c[m>>2]|0}l=bQ(-1,-1)|0;H=K;I=l;y=28;break L20}}while(0);m=k;n=k;a[n]=2;l=m+1|0;a[l]=125;a[m+2|0]=0;x=0,ax(64,d|0,l|0,1)|0;do{if(!x){l=c[w>>2]|0;if((l|0)!=0){x=0;aq(316,l+64|0,k|0);if(x){x=0;break}}if((a[n]&1)==0){break L38}J2(c[k+8>>2]|0);break L38}else{x=0}}while(0);l=bQ(-1,-1)|0;m=l;l=K;if((a[n]&1)==0){z=m;A=l;break L20}J2(c[k+8>>2]|0);z=m;A=l;break L20}else{x=0}}while(0);v=bQ(-1,-1)|0;l=v;v=K;if((a[r]&1)==0){z=l;A=v;break L20}J2(c[j+8>>2]|0);z=l;A=v;break L20}}while(0);if((a[o]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0;y=27}}while(0);if((y|0)==27){e=bQ(-1,-1)|0;H=K;I=e;y=28}if((y|0)==28){z=I;A=H}if((a[o]&1)==0){J=z;L=0;M=J;N=A;be(M|0)}J2(c[f+8>>2]|0);J=z;L=0;M=J;N=A;be(M|0)}function qk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+32|0;l=c[k>>2]|0;m=c[l+32>>2]|0;n=(m|0)!=6;do{if((m|0)==4){o=l+40|0;if((a[o]&1)==0){p=f;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];q=a[p]|0;r=p}else{p=c[l+48>>2]|0;o=c[l+44>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){s=o<<1&255;t=f;a[t]=s;u=f+1|0;v=s;w=t}else{t=o+16&-16;s=J0(t)|0;c[f+8>>2]=s;y=t|1;c[f>>2]=y;c[f+4>>2]=o;u=s;v=y&255;w=f}Kb(u|0,p|0,o)|0;a[u+o|0]=0;q=v;r=w}o=q&255;if((o&1|0)==0){z=o>>>1}else{z=c[f+4>>2]|0}o=n&(z|0)!=0;if((a[r]&1)==0){A=o;B=15;break}J2(c[f+8>>2]|0);if(o){break}i=e;return}else{A=n;B=15}}while(0);do{if((B|0)==15){if(A){break}i=e;return}}while(0);A=b+16|0;B=c[A>>2]|0;if((B|0)==0){C=d+28|0}else{n=d+28|0;zl(B+64|0,c[n>>2]|0);C=n}n=c[C>>2]|0;C=b|0;cy[c[(c[n>>2]|0)+8>>2]&1023](n,C);n=g;B=g;a[B]=2;f=n+1|0;a[f]=58;a[n+2|0]=0;n=b+4|0;x=0,ax(64,n|0,f|0,1)|0;do{if(!x){f=c[A>>2]|0;if((f|0)!=0){x=0;aq(316,f+64|0,g|0);if(x){x=0;break}}if((a[B]&1)!=0){J2(c[g+8>>2]|0)}f=c[A>>2]|0;if((f|0)!=0){zl(f+64|0,c[k>>2]|0)}f=c[k>>2]|0;cy[c[(c[f>>2]|0)+8>>2]&1023](f|0,C);L39:do{if((a[d+36|0]&1)!=0){f=h;b=h;a[b]=20;r=f+1|0;Kb(r|0,1624,10)|0;a[f+11|0]=0;x=0,ax(64,n|0,r|0,10)|0;do{if(!x){r=c[A>>2]|0;if((r|0)!=0){x=0;aq(316,r+64|0,h|0);if(x){x=0;break}}if((a[b]&1)==0){break L39}J2(c[h+8>>2]|0);break L39}else{x=0}}while(0);r=bQ(-1,-1)|0;f=r;r=K;if((a[b]&1)==0){D=r;E=f;F=E;G=0;H=F;I=D;be(H|0)}J2(c[h+8>>2]|0);D=r;E=f;F=E;G=0;H=F;I=D;be(H|0)}}while(0);f=j;r=j;a[r]=2;z=f+1|0;a[z]=59;a[f+2|0]=0;x=0,ax(64,n|0,z|0,1)|0;do{if(!x){z=c[A>>2]|0;if((z|0)!=0){x=0;aq(316,z+64|0,j|0);if(x){x=0;break}}if((a[r]&1)==0){i=e;return}J2(c[j+8>>2]|0);i=e;return}else{x=0}}while(0);z=bQ(-1,-1)|0;f=z;z=K;if((a[r]&1)==0){D=z;E=f;F=E;G=0;H=F;I=D;be(H|0)}J2(c[j+8>>2]|0);D=z;E=f;F=E;G=0;H=F;I=D;be(H|0)}else{x=0}}while(0);j=bQ(-1,-1)|0;e=j;j=K;if((a[B]&1)==0){D=j;E=e;F=E;G=0;H=F;I=D;be(H|0)}J2(c[g+8>>2]|0);D=j;E=e;F=E;G=0;H=F;I=D;be(H|0)}function ql(a,b){a=a|0;b=b|0;return}function qm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+16|0;f=e|0;g=((c[d+52>>2]|0)==0?5336:936)|0;h=f;j=f;a[j]=2;k=h+1|0;a[k]=a[g]|0;a[h+2|0]=0;h=d+40|0;g=c[h>>2]|0;l=d+44|0;if((g|0)==(c[l>>2]|0)){i=e;return}d=c[g>>2]|0;g=(x=0,as(c[(c[d>>2]|0)+44>>2]|0,d|0)|0);L4:do{if(!x){if(!g){x=0;aq(c[(c[d>>2]|0)+8>>2]|0,d|0,b|0);if(x){x=0;m=3;break}}n=c[h>>2]|0;o=(c[l>>2]|0)-n>>2;L9:do{if(o>>>0>1>>>0){p=b+4|0;q=b+16|0;r=f+4|0;s=f+8|0;t=b|0;if(g){u=1;v=n;L12:while(1){w=c[v+(u<<2)>>2]|0;y=(x=0,as(c[(c[w>>2]|0)+44>>2]|0,w|0)|0);if(x){x=0;break}do{if(!y){z=a[j]|0;A=(z&1)==0?k:c[s>>2]|0;B=z&255;z=(B&1|0)==0?B>>>1:c[r>>2]|0;x=0,ax(64,p|0,A|0,z|0)|0;if(x){x=0;break L12}z=c[q>>2]|0;if((z|0)==0){break}x=0;aq(316,z+64|0,f|0);if(x){x=0;break L12}}}while(0);x=0;aq(c[(c[w>>2]|0)+8>>2]|0,w|0,t|0);if(x){x=0;break}y=u+1|0;if(y>>>0>=o>>>0){break L9}u=y;v=c[h>>2]|0}v=bQ(-1,-1)|0;C=K;D=v;break L4}else{E=1;F=n}L23:while(1){v=c[F+(E<<2)>>2]|0;u=(x=0,as(c[(c[v>>2]|0)+44>>2]|0,v|0)|0);if(x){x=0;break}do{if((E|0)!=1|u){if(u){break}y=a[j]|0;z=(y&1)==0?k:c[s>>2]|0;A=y&255;y=(A&1|0)==0?A>>>1:c[r>>2]|0;x=0,ax(64,p|0,z|0,y|0)|0;if(x){x=0;break L23}y=c[q>>2]|0;if((y|0)==0){break}x=0;aq(316,y+64|0,f|0);if(x){x=0;break L23}}else{y=a[j]|0;z=(y&1)==0?k:c[s>>2]|0;A=y&255;y=(A&1|0)==0?A>>>1:c[r>>2]|0;x=0,ax(64,p|0,z|0,y|0)|0;if(x){x=0;break L23}y=c[q>>2]|0;if((y|0)==0){break}x=0;aq(316,y+64|0,f|0);if(x){x=0;break L23}}}while(0);x=0;aq(c[(c[v>>2]|0)+8>>2]|0,v|0,t|0);if(x){x=0;break}u=E+1|0;if(u>>>0>=o>>>0){break L9}E=u;F=c[h>>2]|0}t=bQ(-1,-1)|0;C=K;D=t;break L4}}while(0);if((a[j]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0;m=3}}while(0);if((m|0)==3){m=bQ(-1,-1)|0;C=K;D=m}if((a[j]&1)==0){be(D|0)}J2(c[f+8>>2]|0);be(D|0)}function qn(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;if((a[d+44|0]&1)!=0){j=c[d+36>>2]|0;cy[c[(c[j>>2]|0)+8>>2]&1023](j|0,b|0);i=e;return}j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,1)|0;do{if(!x){l=b+16|0;m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}m=c[d+36>>2]|0;n=b|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m|0,n);m=d+40|0;L13:do{if((c[m>>2]|0)!=0){o=g;p=g;a[p]=2;q=o+1|0;a[q]=58;a[o+2|0]=0;x=0,ax(64,j|0,q|0,1)|0;do{if(!x){q=c[l>>2]|0;if((q|0)!=0){x=0;aq(316,q+64|0,g|0);if(x){x=0;break}}if((a[p]&1)!=0){J2(c[g+8>>2]|0)}q=c[m>>2]|0;cy[c[(c[q>>2]|0)+8>>2]&1023](q|0,n);break L13}else{x=0}}while(0);q=bQ(-1,-1)|0;o=q;q=K;if((a[p]&1)==0){r=q;s=o;t=s;u=0;v=t;w=r;be(v|0)}J2(c[g+8>>2]|0);r=q;s=o;t=s;u=0;v=t;w=r;be(v|0)}}while(0);n=h;m=h;a[m]=2;o=n+1|0;a[o]=41;a[n+2|0]=0;x=0,ax(64,j|0,o|0,1)|0;do{if(!x){o=c[l>>2]|0;if((o|0)!=0){x=0;aq(316,o+64|0,h|0);if(x){x=0;break}}if((a[m]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);l=bQ(-1,-1)|0;o=l;l=K;if((a[m]&1)==0){r=l;s=o;t=s;u=0;v=t;w=r;be(v|0)}J2(c[h+8>>2]|0);r=l;s=o;t=s;u=0;v=t;w=r;be(v|0)}else{x=0}}while(0);h=bQ(-1,-1)|0;e=h;h=K;if((a[k]&1)==0){r=h;s=e;t=s;u=0;v=t;w=r;be(v|0)}J2(c[f+8>>2]|0);r=h;s=e;t=s;u=0;v=t;w=r;be(v|0)}function qo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=d+40|0;if((a[k]&1)==0){l=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];m=a[l]|0;n=l}else{l=c[d+48>>2]|0;o=c[d+44>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){p=o<<1&255;q=f;a[q]=p;r=f+1|0;s=p;t=q}else{q=o+16&-16;p=J0(q)|0;c[f+8>>2]=p;u=q|1;c[f>>2]=u;c[f+4>>2]=o;r=p;s=u&255;t=f}Kb(r|0,l|0,o)|0;a[r+o|0]=0;m=s;n=t}t=m&255;if((t&1|0)==0){v=t>>>1}else{v=c[f+4>>2]|0}if((a[n]&1)!=0){J2(c[f+8>>2]|0)}L19:do{if((v|0)!=0){if((a[k]&1)==0){f=g;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];w=a[f]|0;y=f}else{f=c[d+48>>2]|0;n=c[d+44>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){t=n<<1&255;m=g;a[m]=t;z=g+1|0;A=t;B=m}else{m=n+16&-16;t=J0(m)|0;c[g+8>>2]=t;s=m|1;c[g>>2]=s;c[g+4>>2]=n;z=t;A=s&255;B=g}Kb(z|0,f|0,n)|0;a[z+n|0]=0;w=A;y=B}n=b+4|0;if((w&1)==0){C=g+1|0}else{C=c[g+8>>2]|0}f=w&255;if((f&1|0)==0){D=f>>>1}else{D=c[g+4>>2]|0}x=0,ax(64,n|0,C|0,D|0)|0;do{if(!x){f=b+16|0;s=c[f>>2]|0;if((s|0)!=0){x=0;aq(316,s+64|0,g|0);if(x){x=0;break}}if((a[y]&1)!=0){J2(c[g+8>>2]|0)}s=h;t=h;a[t]=2;m=s+1|0;a[m]=58;a[s+2|0]=0;x=0,ax(64,n|0,m|0,1)|0;do{if(!x){m=c[f>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,h|0);if(x){x=0;break}}if((a[t]&1)==0){break L19}J2(c[h+8>>2]|0);break L19}else{x=0}}while(0);f=bQ(-1,-1)|0;m=f;f=K;if((a[t]&1)==0){E=f;F=m;G=F;H=0;I=G;J=E;be(I|0)}J2(c[h+8>>2]|0);E=f;F=m;G=F;H=0;I=G;J=E;be(I|0)}else{x=0}}while(0);n=bQ(-1,-1)|0;m=n;n=K;if((a[y]&1)==0){E=n;F=m;G=F;H=0;I=G;J=E;be(I|0)}J2(c[g+8>>2]|0);E=n;F=m;G=F;H=0;I=G;J=E;be(I|0)}}while(0);g=c[d+36>>2]|0;cy[c[(c[g>>2]|0)+8>>2]&1023](g|0,b|0);if((a[d+52|0]&1)==0){i=e;return}d=j;a[d]=6;g=j+1|0;a[g]=a[11312]|0;a[g+1|0]=a[11313]|0;a[g+2|0]=a[11314]|0;a[j+4|0]=0;x=0,ax(64,b+4|0,g|0,3)|0;do{if(!x){g=c[b+16>>2]|0;if((g|0)!=0){x=0;aq(316,g+64|0,j|0);if(x){x=0;break}}if((a[d]&1)==0){i=e;return}J2(c[j+8>>2]|0);i=e;return}else{x=0}}while(0);e=bQ(-1,-1)|0;b=e;e=K;if((a[d]&1)==0){E=e;F=b;G=F;H=0;I=G;J=E;be(I|0)}J2(c[j+8>>2]|0);E=e;F=b;G=F;H=0;I=G;J=E;be(I|0)}function qp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+32|0;j=f;k=f;a[k]=2;l=j+1|0;a[l]=40;a[j+2|0]=0;j=b+4|0;x=0,ax(64,j|0,l|0,1)|0;do{if(!x){l=b+16|0;m=c[l>>2]|0;if((m|0)!=0){x=0;aq(316,m+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[f+8>>2]|0)}m=d+40|0;n=c[m>>2]|0;o=d+44|0;L9:do{if((n|0)!=(c[o>>2]|0)){p=c[n>>2]|0;q=b|0;cy[c[(c[p>>2]|0)+8>>2]&1023](p,q);p=(c[o>>2]|0)-(c[m>>2]|0)>>2;if(p>>>0<=1>>>0){break}r=g;s=g;t=r+1|0;u=r+2|0;r=g+8|0;v=1;while(1){a[s]=2;a[t]=44;a[u]=0;x=0,ax(64,j|0,t|0,1)|0;if(x){x=0;break}w=c[l>>2]|0;if((w|0)!=0){x=0;aq(316,w+64|0,g|0);if(x){x=0;break}}if((a[s]&1)!=0){J2(c[r>>2]|0)}w=c[(c[m>>2]|0)+(v<<2)>>2]|0;cy[c[(c[w>>2]|0)+8>>2]&1023](w,q);v=v+1|0;if(v>>>0>=p>>>0){break L9}}p=bQ(-1,-1)|0;v=p;p=K;if((a[s]&1)==0){y=v;z=p;A=y;B=0;C=A;D=z;be(C|0)}J2(c[r>>2]|0);y=v;z=p;A=y;B=0;C=A;D=z;be(C|0)}}while(0);m=h;o=h;a[o]=2;n=m+1|0;a[n]=41;a[m+2|0]=0;x=0,ax(64,j|0,n|0,1)|0;do{if(!x){n=c[l>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,h|0);if(x){x=0;break}}if((a[o]&1)==0){i=e;return}J2(c[h+8>>2]|0);i=e;return}else{x=0}}while(0);l=bQ(-1,-1)|0;n=l;l=K;if((a[o]&1)==0){y=n;z=l;A=y;B=0;C=A;D=z;be(C|0)}J2(c[h+8>>2]|0);y=n;z=l;A=y;B=0;C=A;D=z;be(C|0)}else{x=0}}while(0);h=bQ(-1,-1)|0;e=h;h=K;if((a[k]&1)==0){y=e;z=h;A=y;B=0;C=A;D=z;be(C|0)}J2(c[f+8>>2]|0);y=e;z=h;A=y;B=0;C=A;D=z;be(C|0)}function qq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+64|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=c[d+36>>2]|0;l=c[d+40>>2]|0;m=c[d+32>>2]|0;if((k|0)!=0){cy[c[(c[k>>2]|0)+8>>2]&1023](k,b|0)}L4:do{if((m|0)==0){k=f;d=f;a[d]=2;n=k+1|0;a[n]=32;a[k+2|0]=0;k=b+4|0;x=0,ax(64,k|0,n|0,1)|0;do{if(!x){n=c[b+16>>2]|0;if((n|0)!=0){x=0;aq(316,n+64|0,f|0);if(x){x=0;break}}if((a[d]&1)==0){break L4}J2(c[f+8>>2]|0);break L4}else{x=0}}while(0);n=bQ(-1,-1)|0;k=n;n=K;if((a[d]&1)==0){o=n;p=k;q=p;r=0;s=q;t=o;be(s|0)}J2(c[f+8>>2]|0);o=n;p=k;q=p;r=0;s=q;t=o;be(s|0)}else if((m|0)==3){k=j;n=j;a[n]=2;u=k+1|0;a[u]=43;a[k+2|0]=0;x=0,ax(64,b+4|0,u|0,1)|0;do{if(!x){u=c[b+16>>2]|0;if((u|0)!=0){x=0;aq(316,u+64|0,j|0);if(x){x=0;break}}if((a[n]&1)==0){break L4}J2(c[j+8>>2]|0);break L4}else{x=0}}while(0);d=bQ(-1,-1)|0;u=d;d=K;if((a[n]&1)==0){o=d;p=u;q=p;r=0;s=q;t=o;be(s|0)}J2(c[j+8>>2]|0);o=d;p=u;q=p;r=0;s=q;t=o;be(s|0)}else if((m|0)==2){u=h;d=h;a[d]=2;k=u+1|0;a[k]=126;a[u+2|0]=0;x=0,ax(64,b+4|0,k|0,1)|0;do{if(!x){k=c[b+16>>2]|0;if((k|0)!=0){x=0;aq(316,k+64|0,h|0);if(x){x=0;break}}if((a[d]&1)==0){break L4}J2(c[h+8>>2]|0);break L4}else{x=0}}while(0);n=bQ(-1,-1)|0;k=n;n=K;if((a[d]&1)==0){o=n;p=k;q=p;r=0;s=q;t=o;be(s|0)}J2(c[h+8>>2]|0);o=n;p=k;q=p;r=0;s=q;t=o;be(s|0)}else if((m|0)==1){k=g;n=g;a[n]=2;u=k+1|0;a[u]=62;a[k+2|0]=0;x=0,ax(64,b+4|0,u|0,1)|0;do{if(!x){u=c[b+16>>2]|0;if((u|0)!=0){x=0;aq(316,u+64|0,g|0);if(x){x=0;break}}if((a[n]&1)==0){break L4}J2(c[g+8>>2]|0);break L4}else{x=0}}while(0);d=bQ(-1,-1)|0;u=d;d=K;if((a[n]&1)==0){o=d;p=u;q=p;r=0;s=q;t=o;be(s|0)}J2(c[g+8>>2]|0);o=d;p=u;q=p;r=0;s=q;t=o;be(s|0)}}while(0);if((l|0)==0){i=e;return}cy[c[(c[l>>2]|0)+8>>2]&1023](l,b|0);i=e;return}function qr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e|0;g=d+36|0;h=c[g>>2]|0;j=d+40|0;if((h|0)==(c[j>>2]|0)){i=e;return}d=c[h>>2]|0;h=b|0;cy[c[(c[d>>2]|0)+8>>2]&1023](d,h);d=(c[j>>2]|0)-(c[g>>2]|0)>>2;if(d>>>0<=1>>>0){i=e;return}j=f;k=f;l=j+1|0;m=j+2|0;j=b+4|0;n=b+16|0;b=f+8|0;o=1;while(1){a[k]=2;a[l]=44;a[m]=0;x=0,ax(64,j|0,l|0,1)|0;if(x){x=0;break}p=c[n>>2]|0;if((p|0)!=0){x=0;aq(316,p+64|0,f|0);if(x){x=0;break}}if((a[k]&1)!=0){J2(c[b>>2]|0)}p=c[(c[g>>2]|0)+(o<<2)>>2]|0;cy[c[(c[p>>2]|0)+8>>2]&1023](p,h);p=o+1|0;if(p>>>0<d>>>0){o=p}else{q=14;break}}if((q|0)==14){i=e;return}e=bQ(-1,-1)|0;if((a[k]&1)==0){be(e|0)}J2(c[b>>2]|0);be(e|0)}function qs(a,b){a=a|0;b=b|0;q3(a,b);return}function qt(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qu(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qv(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qw(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qx(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qy(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qz(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qA(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qB(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qC(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qD(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qE(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qF(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qG(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qH(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qI(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qJ(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qK(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qL(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qM(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qN(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qO(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qP(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qQ(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qR(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qS(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qT(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qU(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qV(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qW(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qX(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qY(a,b){a=a|0;b=b|0;q3(a,b|0);return}function qZ(a,b){a=a|0;b=b|0;q3(a,b|0);return}function q_(a,b){a=a|0;b=b|0;q3(a,b|0);return}function q$(a,b){a=a|0;b=b|0;q3(a,b|0);return}function q0(a,b){a=a|0;b=b|0;q3(a,b|0);return}function q1(a,b){a=a|0;b=b|0;q3(a,b|0);return}function q2(a,b){a=a|0;b=b|0;q3(a,b|0);return}function q3(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;f=i;i=i+40|0;g=f|0;h=f+24|0;pk(g,c[b+16>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=b+4|0;j=g+4|0;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[g+12>>2]|0;j=c[g+8>>2]|0;if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;n=22;break}}if(j>>>0<11>>>0){o=j<<1&255;p=h;a[p]=o;q=h+1|0;r=o;s=p}else{p=j+16&-16;o=(x=0,as(230,p|0)|0);if(x){x=0;n=22;break}c[h+8>>2]=o;t=p|1;c[h>>2]=t;c[h+4>>2]=j;q=o;r=t&255;s=h}Kb(q|0,k|0,j)|0;a[q+j|0]=0;l=r;m=s}if((l&1)==0){u=h+1|0}else{u=c[h+8>>2]|0}j=d[m]|0;if((j&1|0)==0){v=j>>>1}else{v=c[h+4>>2]|0}x=0,ax(64,e|0,u|0,v|0)|0;if(x){x=0;e=bQ(-1,-1)|0;j=e;e=K;if((a[m]&1)==0){w=e;y=j;break}J2(c[h+8>>2]|0);w=e;y=j;break}if((a[m]&1)==0){pm(g);i=f;return}J2(c[h+8>>2]|0);pm(g);i=f;return}else{x=0;n=22}}while(0);if((n|0)==22){n=bQ(-1,-1)|0;w=K;y=n}x=0;ap(358,g|0);if(!x){be(y|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function q4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;c[b>>2]=20608;f=b+4|0;a[f]=0;a[f+1|0]=0;c[b+16>>2]=0;a[b+20|0]=d&1;c[b+24>>2]=e;return}function q5(b){b=b|0;var d=0;c[b>>2]=20608;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function q6(b){b=b|0;c[b>>2]=20608;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function q7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e|0;if((a[d+44|0]&1)==0){i=e;return}g=d+32|0;h=c[g>>2]|0;j=(c[d+36>>2]|0)-h>>2;if((j|0)==0){i=e;return}d=b|0;k=j-1|0;l=f;m=f;n=l+1|0;o=l+2|0;l=b+4|0;p=b+24|0;b=f+8|0;f=0;q=h;L7:while(1){h=c[q+(f<<2)>>2]|0;cy[c[(c[h>>2]|0)+8>>2]&1023](h|0,d);do{if(f>>>0<k>>>0){a[m]=2;a[n]=10;a[o]=0;x=0,ax(64,l|0,n|0,1)|0;if(x){x=0;break L7}h=c[p>>2]|0;if((h|0)!=0){x=0;ap(18,h+64|0);if(x){x=0;break L7}}if((a[m]&1)==0){break}J2(c[b>>2]|0)}}while(0);h=f+1|0;if(h>>>0>=j>>>0){r=16;break}f=h;q=c[g>>2]|0}if((r|0)==16){i=e;return}e=bQ(-1,-1)|0;if((a[m]&1)==0){be(e|0)}J2(c[b>>2]|0);be(e|0)}function q8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0;e=i;i=i+24|0;f=e|0;g=e+8|0;h=g;j=i;i=i+144|0;k=i;i=i+12|0;i=i+7&-8;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=i;i=i+12|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=c[d+32>>2]|0;r=c[d+28>>2]|0;if((a[q+29|0]&1)!=0){i=e;return}L4:do{if((a[r+46|0]&1)==0){s=0}else{q9(b);L6:do{if((a[b+20|0]&1)==0){t=b+4|0}else{u=j+64|0;v=j|0;w=j+8|0;y=w|0;c[y>>2]=14576;z=j+12|0;c[v>>2]=31212;A=j+64|0;c[A>>2]=31232;c[j+4>>2]=0;x=0;aq(200,j+64|0,z|0);do{if(!x){c[j+136>>2]=0;c[j+140>>2]=-1;B=j+8|0;c[v>>2]=14556;c[u>>2]=14596;c[y>>2]=14576;C=z|0;c[C>>2]=14880;D=j+16|0;HA(D);E=j+20|0;Ke(E|0,0,24)|0;c[C>>2]=14736;F=j+44|0;G=j+56|0;H=j+60|0;Ke(j+44|0,0,16)|0;c[H>>2]=24;Ke(h|0,0,12)|0;x=0;aq(214,z|0,g|0);if(x){x=0;I=bQ(-1,-1)|0;J=K;if((a[h]&1)!=0){J2(c[g+8>>2]|0)}if((a[F]&1)!=0){J2(c[j+52>>2]|0)}c[C>>2]=14880;x=0;ap(388,D|0);if(!x){L=I;M=J;break}else{x=0}bQ(-1,-1,0)|0;bU()}if((a[h]&1)!=0){J2(c[g+8>>2]|0)}J=(x=0,aK(112,w|0,8296)|0);L23:do{if(!x){I=(x=0,aK(312,J|0,c[d+20>>2]|0)|0);if(x){x=0;N=92;break}C=(x=0,aK(112,I|0,6328)|0);if(x){x=0;N=92;break}I=d+4|0;if((a[I]&1)==0){O=k;c[O>>2]=c[I>>2];c[O+4>>2]=c[I+4>>2];c[O+8>>2]=c[I+8>>2]}else{I=c[d+12>>2]|0;O=c[d+8>>2]|0;if(O>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;N=92;break}}if(O>>>0<11>>>0){a[k]=O<<1;P=k+1|0}else{Q=O+16&-16;R=(x=0,as(230,Q|0)|0);if(x){x=0;N=92;break}c[k+8>>2]=R;c[k>>2]=Q|1;c[k+4>>2]=O;P=R}Kb(P|0,I|0,O)|0;a[P+O|0]=0}O=(x=0,aK(802,C|0,k|0)|0);L40:do{if(!x){C=(x=0,aK(112,O|0,5296)|0);if(x){x=0;N=93;break}x=0;aq(346,f|0,C+(c[(c[C>>2]|0)-12>>2]|0)|0);if(x){x=0;N=93;break}I=(x=0,aK(196,f|0,40280)|0);do{if(!x){R=(x=0,aK(c[(c[I>>2]|0)+28>>2]|0,I|0,10)|0);if(x){x=0;break}x=0;ap(388,f|0);if(x){x=0;N=93;break L40}x=0,aK(240,C|0,R|0)|0;if(x){x=0;N=93;break L40}x=0,as(56,C|0)|0;if(x){x=0;N=93;break L40}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}R=l;Q=c[H>>2]|0;do{if((Q&16|0)==0){if((Q&8|0)==0){Ke(R|0,0,12)|0;break}S=c[E>>2]|0;T=c[j+28>>2]|0;U=S;V=T-U|0;if(V>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;N=92;break L23}}if(V>>>0<11>>>0){a[R]=V<<1;W=l+1|0}else{X=V+16&-16;Y=(x=0,as(230,X|0)|0);if(x){x=0;N=92;break L23}c[l+8>>2]=Y;c[l>>2]=X|1;c[l+4>>2]=V;W=Y}if((S|0)==(T|0)){Z=W}else{Y=T+(-U|0)|0;U=W;V=S;while(1){a[U]=a[V]|0;S=V+1|0;if((S|0)==(T|0)){break}else{U=U+1|0;V=S}}Z=W+Y|0}a[Z]=0}else{V=c[G>>2]|0;U=c[j+36>>2]|0;if(V>>>0<U>>>0){c[G>>2]=U;_=U}else{_=V}V=c[j+32>>2]|0;U=V;T=_-U|0;if(T>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;N=92;break L23}}if(T>>>0<11>>>0){a[R]=T<<1;$=l+1|0}else{S=T+16&-16;X=(x=0,as(230,S|0)|0);if(x){x=0;N=92;break L23}c[l+8>>2]=X;c[l>>2]=S|1;c[l+4>>2]=T;$=X}if((V|0)==(_|0)){aa=$}else{X=_+(-U|0)|0;U=$;T=V;while(1){a[U]=a[T]|0;V=T+1|0;if((V|0)==(_|0)){break}else{U=U+1|0;T=V}}aa=$+X|0}a[aa]=0}}while(0);Q=b+4|0;T=a[R]|0;if((T&1)==0){ab=l+1|0}else{ab=c[l+8>>2]|0}U=T&255;if((U&1|0)==0){ac=U>>>1}else{ac=c[l+4>>2]|0}x=0,ax(64,Q|0,ab|0,ac|0)|0;do{if(!x){U=c[b+24>>2]|0;if((U|0)!=0){x=0;aq(316,U+64|0,l|0);if(x){x=0;break}}if((a[R]&1)!=0){J2(c[l+8>>2]|0)}x=0;ap(40,b|0);if(x){x=0;N=92;break L23}c[v>>2]=14556;c[A>>2]=14596;c[B>>2]=14576;U=j+12|0;c[U>>2]=14736;if((a[F]&1)!=0){J2(c[j+52>>2]|0)}c[U>>2]=14880;x=0;ap(388,D|0);if(!x){C7(j+64|0);t=Q;break L6}else{x=0}U=bQ(-1,-1)|0;x=0;ap(268,j+64|0);if(!x){be(U|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}else{x=0}}while(0);Q=bQ(-1,-1)|0;U=Q;Q=K;if((a[R]&1)==0){ad=U;ae=Q;break L23}J2(c[l+8>>2]|0);ad=U;ae=Q;break L23}else{x=0}}while(0);C=bQ(-1,-1)|0;I=K;x=0;ap(388,f|0);if(!x){af=I;ag=C;break}else{x=0}bQ(-1,-1,0)|0;bU()}else{x=0;N=93}}while(0);if((N|0)==93){O=bQ(-1,-1)|0;af=K;ag=O}O=ag;C=af;if((a[k]&1)==0){ad=O;ae=C;break}J2(c[k+8>>2]|0);ad=O;ae=C}else{x=0;N=92}}while(0);if((N|0)==92){G=bQ(-1,-1)|0;ad=G;ae=K}c[v>>2]=14556;c[A>>2]=14596;c[B>>2]=14576;G=j+12|0;c[G>>2]=14736;if((a[F]&1)!=0){J2(c[j+52>>2]|0)}c[G>>2]=14880;x=0;ap(388,D|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,j+64|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,j+64|0);if(!x){ah=ad;ai=ae;aj=ah;ak=0;al=aj;am=ai;be(al|0)}else{x=0}bQ(-1,-1,0)|0;bU()}else{x=0;G=bQ(-1,-1)|0;L=G;M=K}}while(0);x=0;ap(268,u|0);if(!x){be(L|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);A=b|0;cy[c[(c[q>>2]|0)+8>>2]&1023](q|0,A);v=m;a[v]=6;w=m+1|0;a[w]=a[3824]|0;a[w+1|0]=a[3825]|0;a[w+2|0]=a[3826]|0;a[m+4|0]=0;x=0,ax(64,t|0,w|0,3)|0;do{if(!x){w=b+24|0;z=c[w>>2]|0;if((z|0)!=0){x=0;ap(18,z+64|0);if(x){x=0;break}}if((a[v]&1)!=0){J2(c[m+8>>2]|0)}z=b+16|0;y=(c[z>>2]|0)+1|0;c[z>>2]=y;G=r+32|0;E=c[G>>2]|0;H=(c[r+36>>2]|0)-E>>2;do{if((H|0)==0){an=y}else{J=n;C=n+8|0;O=n+4|0;I=n+1|0;Q=n|0;U=o;T=o;Y=U+1|0;V=U+2|0;U=o+8|0;S=0;ao=E;L160:while(1){ar=c[ao+(S<<2)>>2]|0;if((ar|0)==0){N=112;break}do{if((c[(c[(c[ar>>2]|0)-4>>2]|0)+4>>2]|0)==27432){at=c[ar+32>>2]|0;au=c[at+32>>2]|0;if((au|0)==5){av=at+40|0;aw=c[av>>2]|0;ay=(c[at+44>>2]|0)-aw>>2;if((ay|0)==0){az=0;break}else{aA=1;aB=0;aC=aw}while(1){aw=c[aC+(aB<<2)>>2]|0;aD=(cA[c[(c[aw>>2]|0)+44>>2]&511](aw)|0)&aA;aw=aB+1|0;if(aw>>>0>=ay>>>0){break}aA=aD;aB=aw;aC=c[av>>2]|0}az=aD^1;break}else if((au|0)!=4){az=1;break}av=at+40|0;if((a[av]&1)==0){c[J>>2]=c[av>>2];c[J+4>>2]=c[av+4>>2];c[J+8>>2]=c[av+8>>2];aE=a[J]|0}else{av=c[at+48>>2]|0;ay=c[at+44>>2]|0;if(ay>>>0>4294967279>>>0){N=118;break L160}if(ay>>>0<11>>>0){aw=ay<<1&255;a[J]=aw;aF=I;aG=aw}else{aw=ay+16&-16;aH=J0(aw)|0;c[C>>2]=aH;aI=aw|1;c[Q>>2]=aI;c[O>>2]=ay;aF=aH;aG=aI&255}Kb(aF|0,av|0,ay)|0;a[aF+ay|0]=0;aE=aG}ay=aE&255;av=(((ay&1|0)==0?ay>>>1:c[O>>2]|0)|0)!=0;if((aE&1)==0){az=av;break}J2(c[C>>2]|0);az=av}else{az=1}}while(0);do{if(!(cA[c[(c[ar>>2]|0)+36>>2]&511](ar)|0|az^1)){if((cA[c[(c[ar>>2]|0)+40>>2]&511](ar)|0)==0){q9(b)}cy[c[(c[ar>>2]|0)+8>>2]&1023](ar|0,A);a[T]=2;a[Y]=10;a[V]=0;x=0,ax(64,t|0,Y|0,1)|0;if(x){x=0;N=139;break L160}av=c[w>>2]|0;if((av|0)!=0){x=0;ap(18,av+64|0);if(x){x=0;N=139;break L160}}if((a[T]&1)==0){break}J2(c[U>>2]|0)}}while(0);ar=S+1|0;if(ar>>>0>=H>>>0){N=143;break}S=ar;ao=c[G>>2]|0}if((N|0)==139){ao=bQ(-1,-1)|0;S=ao;ao=K;if((a[T]&1)==0){ah=S;ai=ao;aj=ah;ak=0;al=aj;am=ai;be(al|0)}J2(c[U>>2]|0);ah=S;ai=ao;aj=ah;ak=0;al=aj;am=ai;be(al|0)}else if((N|0)==143){an=c[z>>2]|0;break}else if((N|0)==118){CJ(0)}else if((N|0)==112){cg()}}}while(0);c[z>>2]=an-1;G=t;H=a[G]|0;E=H&255;if((E&1|0)==0){aJ=E>>>1;aL=E>>>1}else{E=c[b+8>>2]|0;aJ=E;aL=E}E=aL-1|0;if(aJ>>>0<E>>>0){CK(0)}if((H&1)==0){a[G]=E<<1;aM=t+1|0}else{G=c[b+12>>2]|0;c[b+8>>2]=E;aM=G}a[aM+E|0]=0;E=c[w>>2]|0;if((E|0)!=0){zj(E+64|0)}E=p;a[E]=6;G=p+1|0;a[G]=a[2472]|0;a[G+1|0]=a[2473]|0;a[G+2|0]=a[2474]|0;a[p+4|0]=0;x=0,ax(64,t|0,G|0,3)|0;do{if(!x){G=c[w>>2]|0;if((G|0)!=0){x=0;ap(18,G+64|0);if(x){x=0;break}}if((a[E]&1)==0){s=1;break L4}J2(c[p+8>>2]|0);s=1;break L4}else{x=0}}while(0);w=bQ(-1,-1)|0;z=w;w=K;if((a[E]&1)==0){ah=z;ai=w;aj=ah;ak=0;al=aj;am=ai;be(al|0)}J2(c[p+8>>2]|0);ah=z;ai=w;aj=ah;ak=0;al=aj;am=ai;be(al|0)}else{x=0}}while(0);A=bQ(-1,-1)|0;w=A;A=K;if((a[v]&1)==0){ah=w;ai=A;aj=ah;ak=0;al=aj;am=ai;be(al|0)}J2(c[m+8>>2]|0);ah=w;ai=A;aj=ah;ak=0;al=aj;am=ai;be(al|0)}}while(0);if((a[r+45|0]&1)==0){i=e;return}if(s){al=b+16|0;c[al>>2]=(c[al>>2]|0)+1}al=r+32|0;ai=c[al>>2]|0;am=(c[r+36>>2]|0)-ai>>2;L242:do{if((am|0)!=0){r=b|0;aj=0;ak=ai;while(1){ah=c[ak+(aj<<2)>>2]|0;if(cA[c[(c[ah>>2]|0)+36>>2]&511](ah)|0){cy[c[(c[ah>>2]|0)+8>>2]&1023](ah|0,r)}ah=aj+1|0;if(ah>>>0>=am>>>0){break L242}aj=ah;ak=c[al>>2]|0}}}while(0);if(!s){i=e;return}s=b+16|0;c[s>>2]=(c[s>>2]|0)-1;i=e;return}function q9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d|0;f=c[b+16>>2]|0;g=f<<1;if(g>>>0>4294967279>>>0){CJ(0)}if(g>>>0<11>>>0){h=f<<2&255;f=e;a[f]=h;j=e+1|0;k=h;l=f}else{f=g+16&-16;h=J0(f)|0;c[e+8>>2]=h;m=f|1;c[e>>2]=m;c[e+4>>2]=g;j=h;k=m&255;l=e}Ke(j|0,32,g|0)|0;a[j+g|0]=0;if((k&1)==0){n=e+1|0}else{n=c[e+8>>2]|0}g=k&255;if((g&1|0)==0){o=g>>>1}else{o=c[e+4>>2]|0}x=0,ax(64,b+4|0,n|0,o|0)|0;do{if(!x){o=c[b+24>>2]|0;if((o|0)!=0){x=0;aq(316,o+64|0,e|0);if(x){x=0;break}}if((a[l]&1)==0){i=d;return}J2(c[e+8>>2]|0);i=d;return}else{x=0}}while(0);d=bQ(-1,-1)|0;if((a[l]&1)==0){be(d|0)}J2(c[e+8>>2]|0);be(d|0)}function ra(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=i;i=i+96|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=c[d+32>>2]|0;n=c[d+28>>2]|0;q9(b);o=b+24|0;zl((c[o>>2]|0)+64|0,d|0);p=f;a[p]=14;q=f+1|0;a[q]=a[1592]|0;a[q+1|0]=a[1593]|0;a[q+2|0]=a[1594]|0;a[q+3|0]=a[1595]|0;a[q+4|0]=a[1596]|0;a[q+5|0]=a[1597]|0;a[q+6|0]=a[1598]|0;r=f+8|0;a[r]=0;s=b+4|0;x=0,ax(64,s|0,q|0,7)|0;do{if(!x){q=c[o>>2]|0;if((q|0)!=0){x=0;aq(316,q+64|0,f|0);if(x){x=0;break}}if((a[p]&1)!=0){J2(c[r>>2]|0)}q=b|0;cy[c[(c[m>>2]|0)+8>>2]&1023](m,q);t=g;a[t]=6;u=g+1|0;a[u]=a[3824]|0;a[u+1|0]=a[3825]|0;a[u+2|0]=a[3826]|0;a[g+4|0]=0;x=0,ax(64,s|0,u|0,3)|0;do{if(!x){u=c[o>>2]|0;if((u|0)!=0){x=0;ap(18,u+64|0);if(x){x=0;break}}if((a[t]&1)!=0){J2(c[g+8>>2]|0)}u=c[d+36>>2]|0;L17:do{if((u|0)==0){v=0}else{if((a[n+46|0]&1)==0){v=0;break}w=b+16|0;c[w>>2]=(c[w>>2]|0)+1;q9(b);cy[c[(c[u>>2]|0)+8>>2]&1023](u|0,q);w=h;a[w]=6;y=h+1|0;a[y]=a[3824]|0;a[y+1|0]=a[3825]|0;a[y+2|0]=a[3826]|0;a[h+4|0]=0;x=0,ax(64,s|0,y|0,3)|0;do{if(!x){y=c[o>>2]|0;if((y|0)!=0){x=0;ap(18,y+64|0);if(x){x=0;break}}if((a[w]&1)==0){v=1;break L17}J2(c[h+8>>2]|0);v=1;break L17}else{x=0}}while(0);y=bQ(-1,-1)|0;z=y;y=K;if((a[w]&1)==0){A=z;B=y;C=A;D=0;E=C;F=B;be(E|0)}J2(c[h+8>>2]|0);A=z;B=y;C=A;D=0;E=C;F=B;be(E|0)}}while(0);u=b+16|0;y=(c[u>>2]|0)+1|0;c[u>>2]=y;z=n+36|0;G=n+32|0;H=c[G>>2]|0;I=(c[z>>2]|0)-H>>2;do{if((I|0)==0){J=y}else{L=j;M=j;N=L+1|0;O=L+2|0;L=j+8|0;P=0;Q=H;L34:while(1){R=c[Q+(P<<2)>>2]|0;do{if(!(cA[c[(c[R>>2]|0)+36>>2]&511](R)|0)){if((cA[c[(c[R>>2]|0)+40>>2]&511](R)|0)==0){q9(b)}cy[c[(c[R>>2]|0)+8>>2]&1023](R|0,q);a[M]=2;a[N]=10;a[O]=0;x=0,ax(64,s|0,N|0,1)|0;if(x){x=0;break L34}S=c[o>>2]|0;if((S|0)!=0){x=0;ap(18,S+64|0);if(x){x=0;break L34}}if((a[M]&1)==0){break}J2(c[L>>2]|0)}}while(0);R=P+1|0;if(R>>>0>=I>>>0){T=38;break}P=R;Q=c[G>>2]|0}if((T|0)==38){J=c[u>>2]|0;break}Q=bQ(-1,-1)|0;P=Q;Q=K;if((a[M]&1)==0){A=P;B=Q;C=A;D=0;E=C;F=B;be(E|0)}J2(c[L>>2]|0);A=P;B=Q;C=A;D=0;E=C;F=B;be(E|0)}}while(0);c[u>>2]=J-1;L56:do{if(v){I=s;H=a[I]|0;y=H&255;if((y&1|0)==0){U=y>>>1;V=y>>>1}else{y=c[b+8>>2]|0;U=y;V=y}y=V-1|0;if(U>>>0<y>>>0){CK(0)}if((H&1)==0){a[I]=y<<1;W=s+1|0}else{I=c[b+12>>2]|0;c[b+8>>2]=y;W=I}a[W+y|0]=0;y=c[o>>2]|0;if((y|0)!=0){zj(y+64|0)}y=k;a[y]=6;I=k+1|0;a[I]=a[2472]|0;a[I+1|0]=a[2473]|0;a[I+2|0]=a[2474]|0;a[k+4|0]=0;x=0,ax(64,s|0,I|0,3)|0;do{if(!x){I=c[o>>2]|0;if((I|0)!=0){x=0;ap(18,I+64|0);if(x){x=0;break}}if((a[y]&1)!=0){J2(c[k+8>>2]|0)}X=(c[u>>2]|0)+1|0;break L56}else{x=0}}while(0);L=bQ(-1,-1)|0;M=L;L=K;if((a[y]&1)==0){A=M;B=L;C=A;D=0;E=C;F=B;be(E|0)}J2(c[k+8>>2]|0);A=M;B=L;C=A;D=0;E=C;F=B;be(E|0)}else{X=J}}while(0);c[u>>2]=X;L=c[G>>2]|0;M=(c[z>>2]|0)-L>>2;L87:do{if((M|0)!=0){I=0;H=L;while(1){Q=c[H+(I<<2)>>2]|0;if(cA[c[(c[Q>>2]|0)+36>>2]&511](Q)|0){cy[c[(c[Q>>2]|0)+8>>2]&1023](Q|0,q)}Q=I+1|0;if(Q>>>0>=M>>>0){break L87}I=Q;H=c[G>>2]|0}}}while(0);G=c[u>>2]|0;if(v){M=G-1|0;c[u>>2]=M;Y=M}else{Y=G}c[u>>2]=Y-1;G=s;M=a[G]|0;L=M&255;if((L&1|0)==0){Z=L>>>1;_=L>>>1}else{L=c[b+8>>2]|0;Z=L;_=L}L=_-1|0;if(Z>>>0<L>>>0){CK(0)}if((M&1)==0){a[G]=L<<1;$=s+1|0}else{G=c[b+12>>2]|0;c[b+8>>2]=L;$=G}a[$+L|0]=0;L=c[o>>2]|0;if((L|0)!=0){zj(L+64|0)}L=l;a[L]=6;G=l+1|0;a[G]=a[2472]|0;a[G+1|0]=a[2473]|0;a[G+2|0]=a[2474]|0;a[l+4|0]=0;x=0,ax(64,s|0,G|0,3)|0;do{if(!x){G=c[o>>2]|0;if((G|0)!=0){x=0;ap(18,G+64|0);if(x){x=0;break}}if((a[L]&1)==0){i=e;return}J2(c[l+8>>2]|0);i=e;return}else{x=0}}while(0);u=bQ(-1,-1)|0;G=u;u=K;if((a[L]&1)==0){A=G;B=u;C=A;D=0;E=C;F=B;be(E|0)}J2(c[l+8>>2]|0);A=G;B=u;C=A;D=0;E=C;F=B;be(E|0)}else{x=0}}while(0);q=bQ(-1,-1)|0;u=q;q=K;if((a[t]&1)==0){A=u;B=q;C=A;D=0;E=C;F=B;be(E|0)}J2(c[g+8>>2]|0);A=u;B=q;C=A;D=0;E=C;F=B;be(E|0)}else{x=0}}while(0);g=bQ(-1,-1)|0;l=g;g=K;if((a[p]&1)==0){A=l;B=g;C=A;D=0;E=C;F=B;be(E|0)}J2(c[r>>2]|0);A=l;B=g;C=A;D=0;E=C;F=B;be(E|0)}function rb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=i;i=i+112|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=d+32|0;if((a[n]&1)==0){o=f;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];p=a[o]|0;q=o}else{o=c[d+40>>2]|0;n=c[d+36>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){r=n<<1&255;s=f;a[s]=r;t=f+1|0;u=r;v=s}else{s=n+16&-16;r=J0(s)|0;c[f+8>>2]=r;w=s|1;c[f>>2]=w;c[f+4>>2]=n;t=r;u=w&255;v=f}Kb(t|0,o|0,n)|0;a[t+n|0]=0;p=u;q=v}v=c[d+44>>2]|0;u=c[d+28>>2]|0;d=b+4|0;if((p&1)==0){y=f+1|0}else{y=c[f+8>>2]|0}n=p&255;if((n&1|0)==0){z=n>>>1}else{z=c[f+4>>2]|0}x=0,ax(64,d|0,y|0,z|0)|0;L20:do{if(!x){z=b+24|0;y=c[z>>2]|0;if((y|0)!=0){x=0;aq(316,y+64|0,f|0);if(x){x=0;A=27;break}}L25:do{if((v|0)!=0){y=g;n=g;a[n]=2;p=y+1|0;a[p]=32;a[y+2|0]=0;x=0,ax(64,d|0,p|0,1)|0;do{if(!x){p=c[z>>2]|0;if((p|0)!=0){x=0;aq(316,p+64|0,g|0);if(x){x=0;break}}if((a[n]&1)!=0){J2(c[g+8>>2]|0)}x=0;aq(c[(c[v>>2]|0)+8>>2]|0,v|0,b|0);if(!x){break L25}else{x=0;A=27;break L20}}else{x=0}}while(0);p=bQ(-1,-1)|0;y=p;p=K;if((a[n]&1)==0){B=y;C=p;break L20}J2(c[g+8>>2]|0);B=y;C=p;break L20}}while(0);L38:do{if((u|0)==0){p=h;y=h;a[y]=2;t=p+1|0;a[t]=59;a[p+2|0]=0;x=0,ax(64,d|0,t|0,1)|0;do{if(!x){t=c[z>>2]|0;if((t|0)!=0){x=0;aq(316,t+64|0,h|0);if(x){x=0;break}}if((a[y]&1)==0){break L38}J2(c[h+8>>2]|0);break L38}else{x=0}}while(0);n=bQ(-1,-1)|0;t=n;n=K;if((a[y]&1)==0){B=t;C=n;break L20}J2(c[h+8>>2]|0);B=t;C=n;break L20}else{n=j;a[n]=6;t=j+1|0;a[t]=a[3824]|0;a[t+1|0]=a[3825]|0;a[t+2|0]=a[3826]|0;a[j+4|0]=0;x=0,ax(64,d|0,t|0,3)|0;do{if(!x){t=c[z>>2]|0;if((t|0)!=0){x=0;ap(18,t+64|0);if(x){x=0;break}}if((a[n]&1)!=0){J2(c[j+8>>2]|0)}t=b+16|0;c[t>>2]=(c[t>>2]|0)+1;p=u+36|0;o=c[p>>2]|0;w=u+32|0;r=c[w>>2]|0;s=o-r>>2;do{if((s|0)==0){D=o;E=r}else{F=b|0;G=k;H=k;I=G+1|0;J=G+2|0;G=k+8|0;L=0;M=r;L50:while(1){N=c[M+(L<<2)>>2]|0;O=(x=0,as(c[(c[N>>2]|0)+36>>2]|0,N|0)|0);if(x){x=0;A=26;break}do{if(!O){P=(x=0,as(c[(c[N>>2]|0)+40>>2]|0,N|0)|0);if(x){x=0;A=26;break L50}if((P|0)==0){x=0;ap(40,b|0);if(x){x=0;A=26;break L50}}x=0;aq(c[(c[N>>2]|0)+8>>2]|0,N|0,F|0);if(x){x=0;A=26;break L50}a[H]=2;a[I]=10;a[J]=0;x=0,ax(64,d|0,I|0,1)|0;if(x){x=0;A=59;break L50}P=c[z>>2]|0;if((P|0)!=0){x=0;ap(18,P+64|0);if(x){x=0;A=59;break L50}}if((a[H]&1)==0){break}J2(c[G>>2]|0)}}while(0);N=L+1|0;if(N>>>0>=s>>>0){A=63;break}L=N;M=c[w>>2]|0}if((A|0)==63){D=c[p>>2]|0;E=c[w>>2]|0;break}else if((A|0)==26){M=bQ(-1,-1)|0;Q=K;R=M;A=28;break L20}else if((A|0)==59){M=bQ(-1,-1)|0;L=M;M=K;if((a[H]&1)==0){B=L;C=M;break L20}J2(c[G>>2]|0);B=L;C=M;break L20}}}while(0);p=D-E>>2;L73:do{if((p|0)!=0){s=b|0;r=l;o=l;M=r+1|0;L=r+2|0;r=l+8|0;I=0;J=E;L75:while(1){F=c[J+(I<<2)>>2]|0;N=(x=0,as(c[(c[F>>2]|0)+36>>2]|0,F|0)|0);if(x){x=0;A=25;break}do{if(N){x=0;aq(c[(c[F>>2]|0)+8>>2]|0,F|0,s|0);if(x){x=0;A=25;break L75}a[o]=2;a[M]=10;a[L]=0;x=0,ax(64,d|0,M|0,1)|0;if(x){x=0;break L75}O=c[z>>2]|0;if((O|0)!=0){x=0;ap(18,O+64|0);if(x){x=0;break L75}}if((a[o]&1)==0){break}J2(c[r>>2]|0)}}while(0);F=I+1|0;if(F>>>0>=p>>>0){break L73}I=F;J=c[w>>2]|0}if((A|0)==25){J=bQ(-1,-1)|0;Q=K;R=J;A=28;break L20}J=bQ(-1,-1)|0;I=J;J=K;if((a[o]&1)==0){B=I;C=J;break L20}J2(c[r>>2]|0);B=I;C=J;break L20}}while(0);c[t>>2]=(c[t>>2]|0)-1;w=d;p=a[w]|0;J=p&255;if((J&1|0)==0){S=J>>>1;T=J>>>1}else{J=c[b+8>>2]|0;S=J;T=J}J=T-1|0;I=d;if(S>>>0<J>>>0){x=0;ap(238,0);if(x){x=0;A=27;break L20}}if((p&1)==0){a[w]=J<<1;U=I+1|0}else{p=c[b+12>>2]|0;c[b+8>>2]=J;U=p}a[U+J|0]=0;J=c[z>>2]|0;if((J|0)!=0){x=0;ap(304,J+64|0);if(x){x=0;A=27;break L20}}do{if((a[u+45|0]&1)!=0){J=a[w]|0;p=J&255;if((p&1|0)==0){V=p>>>1;W=p>>>1}else{p=c[b+8>>2]|0;V=p;W=p}p=W-1|0;if(V>>>0<p>>>0){x=0;ap(238,0);if(x){x=0;A=27;break L20}}if((J&1)==0){a[w]=p<<1;X=I+1|0}else{J=c[b+12>>2]|0;c[b+8>>2]=p;X=J}a[X+p|0]=0;p=c[z>>2]|0;if((p|0)==0){break}x=0;ap(304,p+64|0);if(x){x=0;A=27;break L20}}}while(0);I=m;a[I]=6;w=m+1|0;a[w]=a[2472]|0;a[w+1|0]=a[2473]|0;a[w+2|0]=a[2474]|0;a[m+4|0]=0;x=0,ax(64,d|0,w|0,3)|0;do{if(!x){w=c[z>>2]|0;if((w|0)!=0){x=0;ap(18,w+64|0);if(x){x=0;break}}if((a[I]&1)==0){break L38}J2(c[m+8>>2]|0);break L38}else{x=0}}while(0);w=bQ(-1,-1)|0;t=w;w=K;if((a[I]&1)==0){B=t;C=w;break L20}J2(c[m+8>>2]|0);B=t;C=w;break L20}else{x=0}}while(0);y=bQ(-1,-1)|0;w=y;y=K;if((a[n]&1)==0){B=w;C=y;break L20}J2(c[j+8>>2]|0);B=w;C=y;break L20}}while(0);if((a[q]&1)==0){i=e;return}J2(c[f+8>>2]|0);i=e;return}else{x=0;A=27}}while(0);if((A|0)==27){e=bQ(-1,-1)|0;Q=K;R=e;A=28}if((A|0)==28){B=R;C=Q}if((a[q]&1)==0){Y=B;Z=0;_=Y;$=C;be(_|0)}J2(c[f+8>>2]|0);Y=B;Z=0;_=Y;$=C;be(_|0)}function rc(a,b){a=a|0;b=b|0;rX(a,b);return}function rd(a,b){a=a|0;b=b|0;rX(a,b|0);return}function re(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rf(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rg(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rh(a,b){a=a|0;b=b|0;rX(a,b|0);return}function ri(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rj(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rk(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rl(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rm(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rn(a,b){a=a|0;b=b|0;rX(a,b|0);return}function ro(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rp(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rq(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rr(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rs(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rt(a,b){a=a|0;b=b|0;rX(a,b|0);return}function ru(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rv(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rw(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rx(a,b){a=a|0;b=b|0;rX(a,b|0);return}function ry(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rz(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rA(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rB(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rC(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rD(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rE(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rF(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rG(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rH(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rI(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rJ(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rK(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rL(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rM(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rN(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rO(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rP(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rQ(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rR(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rS(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rT(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rU(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rV(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rW(a,b){a=a|0;b=b|0;rX(a,b|0);return}function rX(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;f=i;i=i+40|0;g=f|0;h=f+24|0;pk(g,c[b+24>>2]|0);x=0;aq(c[(c[e>>2]|0)+8>>2]|0,e|0,g|0);do{if(!x){e=b+4|0;j=g+4|0;if((a[j]&1)==0){k=h;c[k>>2]=c[j>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];l=a[k]|0;m=k}else{k=c[g+12>>2]|0;j=c[g+8>>2]|0;if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;n=22;break}}if(j>>>0<11>>>0){o=j<<1&255;p=h;a[p]=o;q=h+1|0;r=o;s=p}else{p=j+16&-16;o=(x=0,as(230,p|0)|0);if(x){x=0;n=22;break}c[h+8>>2]=o;t=p|1;c[h>>2]=t;c[h+4>>2]=j;q=o;r=t&255;s=h}Kb(q|0,k|0,j)|0;a[q+j|0]=0;l=r;m=s}if((l&1)==0){u=h+1|0}else{u=c[h+8>>2]|0}j=d[m]|0;if((j&1|0)==0){v=j>>>1}else{v=c[h+4>>2]|0}x=0,ax(64,e|0,u|0,v|0)|0;if(x){x=0;e=bQ(-1,-1)|0;j=e;e=K;if((a[m]&1)==0){w=e;y=j;break}J2(c[h+8>>2]|0);w=e;y=j;break}if((a[m]&1)==0){pm(g);i=f;return}J2(c[h+8>>2]|0);pm(g);i=f;return}else{x=0;n=22}}while(0);if((n|0)==22){n=bQ(-1,-1)|0;w=K;y=n}x=0;ap(358,g|0);if(!x){be(y|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}
function rY(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=f;if((a[l]&1)==0){m=k;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[f+8>>2]|0;m=c[f+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[k]=m<<1;n=k+1|0}else{f=m+16&-16;o=J0(f)|0;c[k+8>>2]=o;c[k>>2]=f|1;c[k+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=g;g=j;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];x=0;aT(28,b|0,e|0,k|0,j|0);if(!x){if((a[k]&1)==0){p=b+16|0;c[p>>2]=d;q=b+20|0;c[q>>2]=d;r=Kf(d|0)|0;s=d+r|0;t=b+24|0;c[t>>2]=s;i=h;return}J2(c[k+8>>2]|0);p=b+16|0;c[p>>2]=d;q=b+20|0;c[q>>2]=d;r=Kf(d|0)|0;s=d+r|0;t=b+24|0;c[t>>2]=s;i=h;return}else{x=0;h=bQ(-1,-1)|0;if((a[k]&1)==0){be(h|0)}J2(c[k+8>>2]|0);be(h|0)}}function rZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+32|0;j=d;d=i;i=i+8|0;c[d>>2]=c[j>>2];c[d+4>>2]=c[j+4>>2];j=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=f;if((a[l]&1)==0){m=k;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2]}else{l=c[f+8>>2]|0;m=c[f+4>>2]|0;if(m>>>0>4294967279>>>0){CJ(0)}if(m>>>0<11>>>0){a[k]=m<<1;n=k+1|0}else{f=m+16&-16;o=J0(f)|0;c[k+8>>2]=o;c[k>>2]=f|1;c[k+4>>2]=m;n=o}Kb(n|0,l|0,m)|0;a[n+m|0]=0}m=g;g=j;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];x=0;aT(28,b|0,e|0,k|0,j|0);if(!x){if((a[k]&1)==0){p=d|0;q=c[p>>2]|0;r=b+16|0;c[r>>2]=q;s=b+20|0;c[s>>2]=q;t=d+4|0;u=c[t>>2]|0;v=b+24|0;c[v>>2]=u;i=h;return}J2(c[k+8>>2]|0);p=d|0;q=c[p>>2]|0;r=b+16|0;c[r>>2]=q;s=b+20|0;c[s>>2]=q;t=d+4|0;u=c[t>>2]|0;v=b+24|0;c[v>>2]=u;i=h;return}else{x=0;h=bQ(-1,-1)|0;if((a[k]&1)==0){be(h|0)}J2(c[k+8>>2]|0);be(h|0)}}function r_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0;d=i;i=i+520|0;e=d|0;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=d+48|0;m=d+56|0;n=d+64|0;o=d+72|0;p=d+80|0;q=d+88|0;r=d+96|0;s=d+104|0;t=d+120|0;u=d+128|0;v=d+136|0;w=d+144|0;y=d+152|0;z=d+168|0;A=d+176|0;B=d+192|0;C=d+200|0;D=d+216|0;E=d+232|0;F=d+248|0;G=d+264|0;H=d+280|0;I=d+296|0;J=d+312|0;L=d+328|0;M=d+344|0;N=d+360|0;O=d+376|0;P=d+392|0;Q=d+408|0;R=d+424|0;S=d+440|0;T=d+456|0;U=d+472|0;V=d+480|0;W=d+488|0;X=d+504|0;Y=b|0;Z=c[Y>>2]|0;_=J0(48)|0;c[B>>2]=_;$=Z+4|0;aa=c[$>>2]|0;if((aa|0)==(c[Z+8>>2]|0)){ee(Z|0,B);ab=c[B>>2]|0}else{if((aa|0)==0){ac=0}else{c[aa>>2]=_;ac=c[$>>2]|0}c[$>>2]=ac+4;ab=_}_=ab;ac=ab;aa=b+28|0;L8:do{if((a[aa]&1)==0){B=C;c[B>>2]=c[aa>>2];c[B+4>>2]=c[aa+4>>2];c[B+8>>2]=c[aa+8>>2];ad=16}else{B=c[b+36>>2]|0;ae=c[b+32>>2]|0;do{if(ae>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ae>>>0<11>>>0){a[C]=ae<<1;af=C+1|0}else{ag=ae+16&-16;ah=(x=0,as(230,ag|0)|0);if(x){x=0;break}c[C+8>>2]=ah;c[C>>2]=ag|1;c[C+4>>2]=ae;af=ah}Kb(af|0,B|0,ae)|0;a[af+ae|0]=0;ad=16;break L8}}while(0);ae=bQ(-1,-1)|0;ai=ae;aj=K}}while(0);do{if((ad|0)==16){af=b+44|0;ae=A;c[ae>>2]=c[af>>2];c[ae+4>>2]=c[af+4>>2];c[ae+8>>2]=c[af+8>>2];x=0;ao(4,ac|0,C|0,A|0,0,0);if(x){x=0;ae=bQ(-1,-1)|0;B=ae;ae=K;if((a[C]&1)==0){ai=B;aj=ae;break}J2(c[C+8>>2]|0);ai=B;aj=ae;break}if((a[C]&1)!=0){J2(c[C+8>>2]|0)}a[ab+44|0]=1;r$(b);r0(b)|0;ae=b+20|0;B=b+24|0;if((c[ae>>2]|0)>>>0>=(c[B>>2]|0)>>>0){i=d;return ac|0}ah=U|0;ag=W+8|0;ak=W|0;al=W+4|0;am=X|0;an=X+4|0;ar=X+8|0;at=W;au=U+4|0;av=ab+28|0;aw=av;ax=V|0;ay=V+4|0;az=ab+36|0;aA=az;aB=ab+40|0;aC=ab+32|0;aD=av;av=S+8|0;aE=S|0;aF=S+4|0;aG=T|0;aH=T+4|0;aI=T+8|0;aJ=S;aK=b+48|0;aL=b+40|0;aM=b+52|0;aN=b+56|0;aO=aN;aQ=Q+8|0;aR=Q|0;aS=Q+4|0;aU=R|0;aV=R+4|0;aW=R+8|0;aX=Q;aY=O+8|0;aZ=O|0;a_=O+4|0;a$=P|0;a0=P+4|0;a1=P+8|0;a2=O;a3=M+8|0;a4=M|0;a5=M+4|0;a6=N|0;a7=N+4|0;a8=N+8|0;a9=M;ba=J+8|0;bb=J|0;bc=J+4|0;bd=L|0;bf=L+4|0;bg=L+8|0;bh=J;bi=G;bj=H;bk=I;bl=s;bm=G+8|0;bn=I+8|0;bo=I+1|0;bp=I|0;bq=I+4|0;br=b+36|0;bs=b+32|0;bt=G+1|0;bu=G|0;bv=G+4|0;bw=D;bx=E;by=F;bz=E+8|0;bA=E+1|0;bB=E|0;bC=E+4|0;bD=D+8|0;bE=D+1|0;bF=D|0;bG=D+4|0;L33:while(1){L35:do{if((r1(b)|0)==0){if((xV(xP(c[ae>>2]|0)|0)|0)!=0){bH=r3(b)|0;if((c[bH+40>>2]|0)!=(c[bH+44>>2]|0)){bI=bH|0;c[u>>2]=bI;bJ=c[aA>>2]|0;if((bJ|0)==(c[aB>>2]|0)){lM(aC,u);bK=c[u>>2]|0}else{if((bJ|0)==0){bL=0}else{c[bJ>>2]=bI;bL=c[aA>>2]|0}c[az>>2]=bL+4;bK=bI}cy[c[c[aD>>2]>>2]&1023](aw,bK)}bI=bH+28|0;bJ=c[bI>>2]|0;bM=c[bH+32>>2]|0;if((bJ|0)!=(bM|0)){bH=(bM-bJ|0)/12|0;bJ=0;do{bN=c[Y>>2]|0;bM=J0(40)|0;c[t>>2]=bM;bO=bN+4|0;bP=c[bO>>2]|0;if((bP|0)==(c[bN+8>>2]|0)){ee(bN|0,t);bR=c[t>>2]|0}else{if((bP|0)==0){bS=0}else{c[bP>>2]=bM;bS=c[bO>>2]|0}c[bO>>2]=bS+4;bR=bM}bT=bR;bM=bR;if((a[aa]&1)==0){c[bi>>2]=c[aa>>2];c[bi+4>>2]=c[aa+4>>2];c[bi+8>>2]=c[aa+8>>2]}else{bP=c[br>>2]|0;bU=c[bs>>2]|0;if(bU>>>0>4294967279>>>0){ad=113;break L33}if(bU>>>0<11>>>0){a[bi]=bU<<1;bV=bt}else{bW=bU+16&-16;bX=(x=0,as(230,bW|0)|0);if(x){x=0;ad=143;break L33}c[bm>>2]=bX;c[bu>>2]=bW|1;c[bv>>2]=bU;bV=bX}Kb(bV|0,bP|0,bU)|0;a[bV+bU|0]=0}c[bj>>2]=c[af>>2];c[bj+4>>2]=c[af+4>>2];c[bj+8>>2]=c[af+8>>2];bU=c[bI>>2]|0;bP=bU+(bJ*12|0)|0;if((a[bP]&1)==0){c[bk>>2]=c[bP>>2];c[bk+4>>2]=c[bP+4>>2];c[bk+8>>2]=c[bP+8>>2]}else{bP=c[bU+(bJ*12|0)+8>>2]|0;bX=c[bU+(bJ*12|0)+4>>2]|0;if(bX>>>0>4294967279>>>0){ad=123;break L33}if(bX>>>0<11>>>0){a[bk]=bX<<1;bY=bo}else{bU=bX+16&-16;bW=(x=0,as(230,bU|0)|0);if(x){x=0;ad=146;break L33}c[bn>>2]=bW;c[bp>>2]=bU|1;c[bq>>2]=bX;bY=bW}Kb(bY|0,bP|0,bX)|0;a[bY+bX|0]=0}c[bl>>2]=c[bj>>2];c[bl+4>>2]=c[bj+4>>2];c[bl+8>>2]=c[bj+8>>2];x=0;aT(26,bM|0,G|0,s|0,I|0);if(x){x=0;bZ=1;ad=149;break L33}bM=bR;c[r>>2]=bM;bX=c[aA>>2]|0;if((bX|0)==(c[aB>>2]|0)){x=0;aq(476,aC|0,r|0);if(x){x=0;bZ=0;ad=149;break L33}b_=c[r>>2]|0}else{if((bX|0)==0){b$=0}else{c[bX>>2]=bM;b$=c[aA>>2]|0}c[az>>2]=b$+4;b_=bM}x=0;aq(c[c[aD>>2]>>2]|0,aw|0,b_|0);if(x){x=0;bZ=0;ad=149;break L33}if((a[bk]&1)!=0){J2(c[bn>>2]|0)}if((a[bi]&1)!=0){J2(c[bm>>2]|0)}bJ=bJ+1|0;}while(bJ>>>0<bH>>>0)}bH=xP(c[ae>>2]|0)|0;bJ=(a[bH]|0)==59?bH+1|0:0;if((bJ|0)==0){bI=J0(64)|0;c[ba>>2]=bI;c[bb>>2]=65;c[bc>>2]=53;Kb(bI|0,2672,53)|0;a[bI+53|0]=0;c[bd>>2]=0;c[bf>>2]=0;c[bg>>2]=0;x=0;aP(466,b|0,J|0,L|0);if(x){x=0;ad=174;break L33}if((a[bh]&1)==0){break}J2(c[ba>>2]|0);break}bI=c[aK>>2]|0;bM=c[ae>>2]|0;L152:do{if(bM>>>0<bJ>>>0){bX=bM;bP=0;while(1){bW=a[bX]|0;if((bW<<24>>24|0)==10){b0=bP+1|0}else if((bW<<24>>24|0)==0){b1=bP;break L152}else{b0=bP}bW=bX+1|0;if(bW>>>0<bJ>>>0){bX=bW;bP=b0}else{b1=b0;break}}}else{b1=0}}while(0);c[aK>>2]=b1+bI;bP=bH;bX=0;while(1){bW=bP-1|0;if(bW>>>0<bM>>>0){break}if((a[bW]|0)==10){break}else{bP=bW;bX=bX+1|0}}if((b1|0)!=0){c[aL>>2]=1}bP=c[aL>>2]|0;c[aM>>2]=bP+bX;bM=bJ;bI=bH;c[aL>>2]=bM-bI+bX+bP;c[aO>>2]=bI;c[aO+4>>2]=bM;c[ae>>2]=bJ;break}do{if((xX(xP(c[ae>>2]|0)|0)|0)==0){if((xY(xP(c[ae>>2]|0)|0)|0)!=0){break}if((yH(xP(c[ae>>2]|0)|0)|0)!=0){bM=r6(b)|0;c[p>>2]=bM;bI=c[aA>>2]|0;if((bI|0)==(c[aB>>2]|0)){lM(aC,p);b2=c[p>>2]|0}else{if((bI|0)==0){b3=0}else{c[bI>>2]=bM;b3=c[aA>>2]|0}c[az>>2]=b3+4;b2=bM}cy[c[c[aD>>2]>>2]&1023](aw,b2);bM=xP(c[ae>>2]|0)|0;bI=(a[bM]|0)==59?bM+1|0:0;if((bI|0)==0){bP=J0(64)|0;c[a3>>2]=bP;c[a4>>2]=65;c[a5>>2]=52;Kb(bP|0,9768,52)|0;a[bP+52|0]=0;c[a6>>2]=0;c[a7>>2]=0;c[a8>>2]=0;x=0;aP(466,b|0,M|0,N|0);if(x){x=0;ad=204;break L33}if((a[a9]&1)==0){break L35}J2(c[a3>>2]|0);break L35}bP=c[aK>>2]|0;bW=c[ae>>2]|0;L184:do{if(bW>>>0<bI>>>0){bU=bW;b4=0;while(1){b5=a[bU]|0;if((b5<<24>>24|0)==10){b6=b4+1|0}else if((b5<<24>>24|0)==0){b7=b4;break L184}else{b6=b4}b5=bU+1|0;if(b5>>>0<bI>>>0){bU=b5;b4=b6}else{b7=b6;break}}}else{b7=0}}while(0);c[aK>>2]=b7+bP;b4=bM;bU=0;while(1){b5=b4-1|0;if(b5>>>0<bW>>>0){break}if((a[b5]|0)==10){break}else{b4=b5;bU=bU+1|0}}if((b7|0)!=0){c[aL>>2]=1}b4=c[aL>>2]|0;c[aM>>2]=b4+bU;bW=bI;bP=bM;c[aL>>2]=bW-bP+bU+b4;c[aO>>2]=bP;c[aO+4>>2]=bW;c[ae>>2]=bI;break L35}bW=xP(c[ae>>2]|0)|0;bP=(a[bW]|0)==42?bW+1|0:0;b4=(bP|0)!=0?bP:bW;do{if((b4|0)!=0){bW=xR(b4)|0;if((bW|0)==0){bP=xQ(b4)|0;if((bP|0)==0){break}else{b8=bP}}else{b8=bW}bW=xO(b8)|0;if((bW|0)==0){break}bP=(a[bW]|0)==58?bW+1|0:0;if((bP|0)==0){break}bW=xO(bP)|0;if((bW|0)==0){break}if((bW+1|0)==0|(a[bW]|0)!=123){break}bW=r7(b)|0;c[o>>2]=bW;bP=c[aA>>2]|0;if((bP|0)==(c[aB>>2]|0)){lM(aC,o);b9=c[o>>2]|0}else{if((bP|0)==0){ca=0}else{c[bP>>2]=bW;ca=c[aA>>2]|0}c[az>>2]=ca+4;b9=bW}cy[c[c[aD>>2]>>2]&1023](aw,b9);break L35}}while(0);if((x_(xP(c[ae>>2]|0)|0)|0)!=0){b4=r8(b)|0;bI=b4|0;c[n>>2]=bI;bU=c[aA>>2]|0;if((bU|0)==(c[aB>>2]|0)){lM(aC,n);cb=c[n>>2]|0}else{if((bU|0)==0){cc=0}else{c[bU>>2]=bI;cc=c[aA>>2]|0}c[az>>2]=cc+4;cb=bI}cy[c[c[aD>>2]>>2]&1023](aw,cb);if((c[b4+28>>2]|0)!=0){break L35}b4=xP(c[ae>>2]|0)|0;bI=(a[b4]|0)==59?b4+1|0:0;if((bI|0)==0){bU=J0(64)|0;c[aY>>2]=bU;c[aZ>>2]=65;c[a_>>2]=54;Kb(bU|0,8240,54)|0;a[bU+54|0]=0;c[a$>>2]=0;c[a0>>2]=0;c[a1>>2]=0;x=0;aP(466,b|0,O|0,P|0);if(x){x=0;ad=240;break L33}if((a[a2]&1)==0){break L35}J2(c[aY>>2]|0);break L35}bU=c[aK>>2]|0;bM=c[ae>>2]|0;L231:do{if(bM>>>0<bI>>>0){bW=bM;bP=0;while(1){b5=a[bW]|0;if((b5<<24>>24|0)==10){cd=bP+1|0}else if((b5<<24>>24|0)==0){ce=bP;break L231}else{cd=bP}b5=bW+1|0;if(b5>>>0<bI>>>0){bW=b5;bP=cd}else{ce=cd;break}}}else{ce=0}}while(0);c[aK>>2]=ce+bU;bP=b4;bW=0;while(1){b5=bP-1|0;if(b5>>>0<bM>>>0){break}if((a[b5]|0)==10){break}else{bP=b5;bW=bW+1|0}}if((ce|0)!=0){c[aL>>2]=1}bP=c[aL>>2]|0;c[aM>>2]=bP+bW;bM=bI;bU=b4;c[aL>>2]=bM-bU+bW+bP;c[aO>>2]=bU;c[aO+4>>2]=bM;c[ae>>2]=bI;break L35}if((x1(xP(c[ae>>2]|0)|0)|0)!=0){bM=r9(b,0)|0;c[m>>2]=bM;bU=c[aA>>2]|0;if((bU|0)==(c[aB>>2]|0)){lM(aC,m);cf=c[m>>2]|0}else{if((bU|0)==0){cg=0}else{c[bU>>2]=bM;cg=c[aA>>2]|0}c[az>>2]=cg+4;cf=bM}cy[c[c[aD>>2]>>2]&1023](aw,cf);break L35}if((x3(xP(c[ae>>2]|0)|0)|0)!=0){bM=sa(b)|0;c[l>>2]=bM;bU=c[aA>>2]|0;if((bU|0)==(c[aB>>2]|0)){lM(aC,l);ch=c[l>>2]|0}else{if((bU|0)==0){ci=0}else{c[bU>>2]=bM;ci=c[aA>>2]|0}c[az>>2]=ci+4;ch=bM}cy[c[c[aD>>2]>>2]&1023](aw,ch);break L35}if((x7(xP(c[ae>>2]|0)|0)|0)!=0){bM=sb(b)|0;c[k>>2]=bM;bU=c[aA>>2]|0;if((bU|0)==(c[aB>>2]|0)){lM(aC,k);cj=c[k>>2]|0}else{if((bU|0)==0){ck=0}else{c[bU>>2]=bM;ck=c[aA>>2]|0}c[az>>2]=ck+4;cj=bM}cy[c[c[aD>>2]>>2]&1023](aw,cj);break L35}if((x9(xP(c[ae>>2]|0)|0)|0)!=0){bM=sc(b)|0;c[j>>2]=bM;bU=c[aA>>2]|0;if((bU|0)==(c[aB>>2]|0)){lM(aC,j);cl=c[j>>2]|0}else{if((bU|0)==0){cm=0}else{c[bU>>2]=bM;cm=c[aA>>2]|0}c[az>>2]=cm+4;cl=bM}cy[c[c[aD>>2]>>2]&1023](aw,cl);break L35}if((xW(xP(c[ae>>2]|0)|0)|0)!=0){bM=sd(b)|0;c[h>>2]=bM;bU=c[aA>>2]|0;if((bU|0)==(c[aB>>2]|0)){lM(aC,h);cn=c[h>>2]|0}else{if((bU|0)==0){co=0}else{c[bU>>2]=bM;co=c[aA>>2]|0}c[az>>2]=co+4;cn=bM}cy[c[c[aD>>2]>>2]&1023](aw,cn);break L35}if((ya(xP(c[ae>>2]|0)|0)|0)!=0){bM=se(b)|0;c[g>>2]=bM;bU=c[aA>>2]|0;if((bU|0)==(c[aB>>2]|0)){lM(aC,g);cp=c[g>>2]|0}else{if((bU|0)==0){cq=0}else{c[bU>>2]=bM;cq=c[aA>>2]|0}c[az>>2]=cq+4;cp=bM}cy[c[c[aD>>2]>>2]&1023](aw,cp);bM=xP(c[ae>>2]|0)|0;bU=(a[bM]|0)==59?bM+1|0:0;if((bU|0)==0){bP=J0(64)|0;c[aQ>>2]=bP;c[aR>>2]=65;c[aS>>2]=51;Kb(bP|0,6272,51)|0;a[bP+51|0]=0;c[aU>>2]=0;c[aV>>2]=0;c[aW>>2]=0;x=0;aP(466,b|0,Q|0,R|0);if(x){x=0;ad=297;break L33}if((a[aX]&1)==0){break L35}J2(c[aQ>>2]|0);break L35}bP=c[aK>>2]|0;b5=c[ae>>2]|0;L310:do{if(b5>>>0<bU>>>0){cr=b5;cs=0;while(1){ct=a[cr]|0;if((ct<<24>>24|0)==10){cu=cs+1|0}else if((ct<<24>>24|0)==0){cv=cs;break L310}else{cu=cs}ct=cr+1|0;if(ct>>>0<bU>>>0){cr=ct;cs=cu}else{cv=cu;break}}}else{cv=0}}while(0);c[aK>>2]=cv+bP;bI=bM;bW=0;while(1){b4=bI-1|0;if(b4>>>0<b5>>>0){break}if((a[b4]|0)==10){break}else{bI=b4;bW=bW+1|0}}if((cv|0)!=0){c[aL>>2]=1}bI=c[aL>>2]|0;c[aM>>2]=bI+bW;b5=bU;bP=bM;c[aL>>2]=b5-bP+bW+bI;c[aO>>2]=bP;c[aO+4>>2]=b5;c[ae>>2]=bU;break L35}if((sf(b)|0)!=0){sg(b)|0;b5=xP(c[ae>>2]|0)|0;bP=(a[b5]|0)==59?b5+1|0:0;if((bP|0)==0){break L35}bI=c[aK>>2]|0;b4=c[ae>>2]|0;L328:do{if(b4>>>0<bP>>>0){cs=b4;cr=0;while(1){ct=a[cs]|0;if((ct<<24>>24|0)==10){cw=cr+1|0}else if((ct<<24>>24|0)==0){cx=cr;break L328}else{cw=cr}ct=cs+1|0;if(ct>>>0<bP>>>0){cs=ct;cr=cw}else{cx=cw;break}}}else{cx=0}}while(0);c[aK>>2]=cx+bI;bU=b5;bW=0;while(1){bM=bU-1|0;if(bM>>>0<b4>>>0){break}if((a[bM]|0)==10){break}else{bU=bM;bW=bW+1|0}}if((cx|0)!=0){c[aL>>2]=1}bU=c[aL>>2]|0;c[aM>>2]=bU+bW;b4=bP;bI=b5;c[aL>>2]=b4-bI+bW+bU;c[aO>>2]=bI;c[aO+4>>2]=b4;c[ae>>2]=bP;break L35}if((xU(xP(c[ae>>2]|0)|0)|0)==0){si(U,b,c[ae>>2]|0);b4=c[ah>>2]|0;if((b4|0)==0){sk(b)|0;if((c[ae>>2]|0)>>>0>=(c[B>>2]|0)>>>0){ad=351;break L33}bI=J0(32)|0;c[ag>>2]=bI;c[ak>>2]=33;c[al>>2]=28;Kb(bI|0,3792,28)|0;a[bI+28|0]=0;c[am>>2]=0;c[an>>2]=0;c[ar>>2]=0;x=0;aP(466,b|0,W|0,X|0);if(x){x=0;ad=345;break L33}if((a[at]&1)==0){break L35}J2(c[ag>>2]|0);break L35}bI=c[au>>2]|0;c[ax>>2]=b4;c[ay>>2]=bI;bI=sj(b,V)|0;c[e>>2]=bI;b4=c[aA>>2]|0;if((b4|0)==(c[aB>>2]|0)){lM(aC,e);cz=c[e>>2]|0}else{if((b4|0)==0){cA=0}else{c[b4>>2]=bI;cA=c[aA>>2]|0}c[az>>2]=cA+4;cz=bI}cy[c[c[aD>>2]>>2]&1023](aw,cz);break L35}bI=sh(b)|0;b4=bI|0;c[f>>2]=b4;bU=c[aA>>2]|0;if((bU|0)==(c[aB>>2]|0)){lM(aC,f);cB=c[f>>2]|0}else{if((bU|0)==0){cC=0}else{c[bU>>2]=b4;cC=c[aA>>2]|0}c[az>>2]=cC+4;cB=b4}cy[c[c[aD>>2]>>2]&1023](aw,cB);if((c[bI+28>>2]|0)!=0){break L35}bI=xP(c[ae>>2]|0)|0;b4=(a[bI]|0)==59?bI+1|0:0;if((b4|0)==0){bU=J0(48)|0;c[av>>2]=bU;c[aE>>2]=49;c[aF>>2]=45;Kb(bU|0,5248,45)|0;a[bU+45|0]=0;c[aG>>2]=0;c[aH>>2]=0;c[aI>>2]=0;x=0;aP(466,b|0,S|0,T|0);if(x){x=0;ad=332;break L33}if((a[aJ]&1)==0){break L35}J2(c[av>>2]|0);break L35}bU=c[aK>>2]|0;bM=c[ae>>2]|0;L372:do{if(bM>>>0<b4>>>0){cr=bM;cs=0;while(1){ct=a[cr]|0;if((ct<<24>>24|0)==10){cD=cs+1|0}else if((ct<<24>>24|0)==0){cE=cs;break L372}else{cD=cs}ct=cr+1|0;if(ct>>>0<b4>>>0){cr=ct;cs=cD}else{cE=cD;break}}}else{cE=0}}while(0);c[aK>>2]=cE+bU;bP=bI;bW=0;while(1){b5=bP-1|0;if(b5>>>0<bM>>>0){break}if((a[b5]|0)==10){break}else{bP=b5;bW=bW+1|0}}if((cE|0)!=0){c[aL>>2]=1}bP=c[aL>>2]|0;c[aM>>2]=bP+bW;bM=b4;bU=bI;c[aL>>2]=bM-bU+bW+bP;c[aO>>2]=bU;c[aO+4>>2]=bM;c[ae>>2]=b4;break L35}}while(0);bJ=r5(b)|0;c[q>>2]=bJ;bX=c[aA>>2]|0;if((bX|0)==(c[aB>>2]|0)){lM(aC,q);cF=c[q>>2]|0}else{if((bX|0)==0){cG=0}else{c[bX>>2]=bJ;cG=c[aA>>2]|0}c[az>>2]=cG+4;cF=bJ}cy[c[c[aD>>2]>>2]&1023](aw,cF)}else{cH=c[Y>>2]|0;bJ=J0(52)|0;c[z>>2]=bJ;cI=cH+4|0;bX=c[cI>>2]|0;if((bX|0)==(c[cH+8>>2]|0)){ee(cH|0,z);cJ=c[z>>2]|0}else{if((bX|0)==0){cK=0}else{c[bX>>2]=bJ;cK=c[cI>>2]|0}c[cI>>2]=cK+4;cJ=bJ}cL=cJ;if((a[aa]&1)==0){c[bw>>2]=c[aa>>2];c[bw+4>>2]=c[aa+4>>2];c[bw+8>>2]=c[aa+8>>2]}else{bJ=c[br>>2]|0;bX=c[bs>>2]|0;if(bX>>>0>4294967279>>>0){ad=30;break L33}if(bX>>>0<11>>>0){a[bw]=bX<<1;cM=bE}else{bH=bX+16&-16;bM=(x=0,as(230,bH|0)|0);if(x){x=0;ad=73;break L33}c[bD>>2]=bM;c[bF>>2]=bH|1;c[bG>>2]=bX;cM=bM}Kb(cM|0,bJ|0,bX)|0;a[cM+bX|0]=0}bX=y;c[bX>>2]=c[af>>2];c[bX+4>>2]=c[af+4>>2];c[bX+8>>2]=c[af+8>>2];x=0;ao(14,cJ|0,D|0,y|0,aN|0,0);if(x){x=0;ad=76;break L33}if((a[bw]&1)!=0){J2(c[bD>>2]|0)}cN=c[Y>>2]|0;bX=J0(32)|0;c[w>>2]=bX;cO=cN+4|0;bJ=c[cO>>2]|0;if((bJ|0)==(c[cN+8>>2]|0)){ee(cN|0,w);cP=c[w>>2]|0}else{if((bJ|0)==0){cQ=0}else{c[bJ>>2]=bX;cQ=c[cO>>2]|0}c[cO>>2]=cQ+4;cP=bX}cR=cP;if((a[aa]&1)==0){c[bx>>2]=c[aa>>2];c[bx+4>>2]=c[aa+4>>2];c[bx+8>>2]=c[aa+8>>2]}else{bX=c[br>>2]|0;bJ=c[bs>>2]|0;if(bJ>>>0>4294967279>>>0){ad=48;break L33}if(bJ>>>0<11>>>0){a[bx]=bJ<<1;cS=bA}else{bM=bJ+16&-16;bH=(x=0,as(230,bM|0)|0);if(x){x=0;ad=84;break L33}c[bz>>2]=bH;c[bB>>2]=bM|1;c[bC>>2]=bJ;cS=bH}Kb(cS|0,bX|0,bJ)|0;a[cS+bJ|0]=0}c[by>>2]=c[af>>2];c[by+4>>2]=c[af+4>>2];c[by+8>>2]=c[af+8>>2];x=0;aT(34,cP|0,E|0,F|0,cJ|0);if(x){x=0;ad=87;break L33}if((a[bx]&1)!=0){J2(c[bz>>2]|0)}bJ=cP;c[v>>2]=bJ;bX=c[aA>>2]|0;if((bX|0)==(c[aB>>2]|0)){lM(aC,v);cT=c[v>>2]|0}else{if((bX|0)==0){cU=0}else{c[bX>>2]=bJ;cU=c[aA>>2]|0}c[az>>2]=cU+4;cT=bJ}cy[c[c[aD>>2]>>2]&1023](aw,cT)}}while(0);r0(b)|0;if((c[ae>>2]|0)>>>0>=(c[B>>2]|0)>>>0){ad=352;break}}do{if((ad|0)==30){x=0;ap(232,0);if(!x){return 0}else{x=0;B=bQ(-1,-1)|0;cV=K;cW=B;ad=75;break}}else if((ad|0)==48){x=0;ap(232,0);if(!x){return 0}else{x=0;B=bQ(-1,-1)|0;cX=K;cY=B;ad=86;break}}else if((ad|0)==73){B=bQ(-1,-1)|0;cV=K;cW=B;ad=75}else if((ad|0)==76){B=bQ(-1,-1)|0;ae=B;B=K;if((a[bw]&1)==0){cZ=ae;c_=B;ad=78;break}J2(c[bD>>2]|0);cZ=ae;c_=B;ad=78}else if((ad|0)==84){B=bQ(-1,-1)|0;cX=K;cY=B;ad=86}else if((ad|0)==87){B=bQ(-1,-1)|0;ae=B;B=K;if((a[bx]&1)==0){c$=ae;c0=B;ad=89;break}J2(c[bz>>2]|0);c$=ae;c0=B;ad=89}else if((ad|0)==113){x=0;ap(232,0);if(!x){return 0}else{x=0;B=bQ(-1,-1)|0;c1=K;c2=B;ad=145;break}}else if((ad|0)==123){x=0;ap(232,0);if(!x){return 0}else{x=0;B=bQ(-1,-1)|0;c3=K;c4=B;ad=148;break}}else if((ad|0)==143){B=bQ(-1,-1)|0;c1=K;c2=B;ad=145}else if((ad|0)==146){B=bQ(-1,-1)|0;c3=K;c4=B;ad=148}else if((ad|0)==149){B=bQ(-1,-1)|0;ae=B;B=K;if((a[bk]&1)==0){c5=ae;c6=B;c7=bZ;ad=151;break}J2(c[bn>>2]|0);c5=ae;c6=B;c7=bZ;ad=151}else if((ad|0)==174){B=bQ(-1,-1)|0;ae=B;B=K;if((a[bh]&1)==0){c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}J2(c[ba>>2]|0);c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}else if((ad|0)==204){B=bQ(-1,-1)|0;ae=B;B=K;if((a[a9]&1)==0){c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}J2(c[a3>>2]|0);c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}else if((ad|0)==240){B=bQ(-1,-1)|0;ae=B;B=K;if((a[a2]&1)==0){c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}J2(c[aY>>2]|0);c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}else if((ad|0)==297){B=bQ(-1,-1)|0;ae=B;B=K;if((a[aX]&1)==0){c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}J2(c[aQ>>2]|0);c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}else if((ad|0)==332){B=bQ(-1,-1)|0;ae=B;B=K;if((a[aJ]&1)==0){c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}J2(c[av>>2]|0);c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}else if((ad|0)==345){B=bQ(-1,-1)|0;ae=B;B=K;if((a[at]&1)==0){c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}J2(c[ag>>2]|0);c8=ae;c9=B;da=c8;db=0;dc=da;dd=c9;be(dc|0)}else if((ad|0)==351){i=d;return ac|0}else if((ad|0)==352){i=d;return ac|0}}while(0);if((ad|0)==75){cZ=cW;c_=cV;ad=78}else if((ad|0)==86){c$=cY;c0=cX;ad=89}else if((ad|0)==145){de=c1;df=c2}else if((ad|0)==148){c5=c4;c6=c3;c7=1;ad=151}do{if((ad|0)==78){ag=c[cH>>2]|0;at=c[cI>>2]|0;av=ag;while(1){if((av|0)==(at|0)){dg=at;break}if((c[av>>2]|0)==(cJ|0)){dg=av;break}else{av=av+4|0}}av=dg-ag>>2;aJ=ag+(av+1<<2)|0;aQ=at-aJ|0;Kc(ag+(av<<2)|0,aJ|0,aQ|0)|0;aJ=ag+((aQ>>2)+av<<2)|0;av=c[cI>>2]|0;if((aJ|0)!=(av|0)){c[cI>>2]=av+(~((av-4+(-aJ|0)|0)>>>2)<<2)}J2(cL);c8=cZ;c9=c_;da=c8;db=0;dc=da;dd=c9;be(dc|0)}else if((ad|0)==89){aJ=c[cN>>2]|0;av=c[cO>>2]|0;aQ=aJ;while(1){if((aQ|0)==(av|0)){dh=av;break}if((c[aQ>>2]|0)==(cP|0)){dh=aQ;break}else{aQ=aQ+4|0}}aQ=dh-aJ>>2;ag=aJ+(aQ+1<<2)|0;at=av-ag|0;Kc(aJ+(aQ<<2)|0,ag|0,at|0)|0;ag=aJ+((at>>2)+aQ<<2)|0;aQ=c[cO>>2]|0;if((ag|0)!=(aQ|0)){c[cO>>2]=aQ+(~((aQ-4+(-ag|0)|0)>>>2)<<2)}J2(cR);c8=c$;c9=c0;da=c8;db=0;dc=da;dd=c9;be(dc|0)}else if((ad|0)==151){if((a[bi]&1)==0){if(c7){de=c6;df=c5;break}else{c8=c5;c9=c6}da=c8;db=0;dc=da;dd=c9;be(dc|0)}else{J2(c[bm>>2]|0);if(c7){de=c6;df=c5;break}else{c8=c5;c9=c6}da=c8;db=0;dc=da;dd=c9;be(dc|0)}}}while(0);bm=c[bN>>2]|0;bi=c[bO>>2]|0;ag=bm;while(1){if((ag|0)==(bi|0)){di=bi;break}if((c[ag>>2]|0)==(bR|0)){di=ag;break}else{ag=ag+4|0}}ag=di-bm>>2;aQ=bm+(ag+1<<2)|0;at=bi-aQ|0;Kc(bm+(ag<<2)|0,aQ|0,at|0)|0;aQ=bm+((at>>2)+ag<<2)|0;ag=c[bO>>2]|0;if((aQ|0)!=(ag|0)){c[bO>>2]=ag+(~((ag-4+(-aQ|0)|0)>>>2)<<2)}J2(bT);c8=df;c9=de;da=c8;db=0;dc=da;dd=c9;be(dc|0)}}while(0);de=c[Z>>2]|0;Z=c[$>>2]|0;df=de;while(1){if((df|0)==(Z|0)){dj=Z;break}if((c[df>>2]|0)==(ab|0)){dj=df;break}else{df=df+4|0}}df=dj-de>>2;dj=de+(df+1<<2)|0;ab=Z-dj|0;Kc(de+(df<<2)|0,dj|0,ab|0)|0;dj=de+((ab>>2)+df<<2)|0;df=c[$>>2]|0;if((dj|0)!=(df|0)){c[$>>2]=df+(~((df-4+(-dj|0)|0)>>>2)<<2)}J2(_);c8=ai;c9=aj;da=c8;db=0;dc=da;dd=c9;be(dc|0);return 0}function r$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=i;i=i+16|0;e=d|0;f=e;g=i;i=i+12|0;i=i+7&-8;h=i;i=i+12|0;i=i+7&-8;Ke(f|0,0,12)|0;j=c[b+16>>2]|0;k=a[j]|0;switch(k&255|0){case 0:{do{if((j+4|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[35568]|0)){if((a[j+1|0]|0)!=(a[35569]|0)){l=0;break}if((a[j+2|0]|0)!=(a[35570]|0)){l=0;break}l=(a[j+3|0]|0)==(a[35571]|0)?4:0}else{l=0}}while(0);x=0,aK(538,e|0,1840)|0;if(!x){m=l;n=44}else{x=0;n=5}break};case 254:{if((j+2|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[35584]|0)){o=(a[j+1|0]|0)==(a[35585]|0)?2:0}else{o=0}x=0,aK(538,e|0,2136)|0;if(!x){m=o;n=44}else{x=0;n=5}break};case 247:{do{if((j+3|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[35296]|0)){if((a[j+1|0]|0)!=(a[35297]|0)){p=0;break}p=(a[j+2|0]|0)==(a[35298]|0)?3:0}else{p=0}}while(0);x=0,aK(538,e|0,1752)|0;if(!x){m=p;n=44}else{x=0;n=5}break};case 221:{do{if((j+4|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[35544]|0)){if((a[j+1|0]|0)!=(a[35545]|0)){q=0;break}if((a[j+2|0]|0)!=(a[35546]|0)){q=0;break}q=(a[j+3|0]|0)==(a[35547]|0)?4:0}else{q=0}}while(0);x=0,aK(538,e|0,1672)|0;if(!x){m=q;n=44}else{x=0;n=5}break};case 14:{do{if((j+3|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[35344]|0)){if((a[j+1|0]|0)!=(a[35345]|0)){r=0;break}r=(a[j+2|0]|0)==(a[35346]|0)?3:0}else{r=0}}while(0);x=0,aK(538,e|0,1584)|0;if(!x){m=r;n=44}else{x=0;n=5}break};case 251:{do{if((j+3|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[35848]|0)){if((a[j+1|0]|0)!=(a[35849]|0)){s=0;break}s=(a[j+2|0]|0)==(a[35850]|0)?3:0}else{s=0}}while(0);x=0,aK(538,e|0,1528)|0;if(!x){m=s;n=44}else{x=0;n=5}break};case 132:{do{if((j+4|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[35608]|0)){if((a[j+1|0]|0)!=(a[35609]|0)){t=0;break}if((a[j+2|0]|0)!=(a[35610]|0)){t=0;break}t=(a[j+3|0]|0)==(a[35611]|0)?4:0}else{t=0}}while(0);x=0,aK(538,e|0,1472)|0;if(!x){m=t;n=44}else{x=0;n=5}break};case 255:{t=c[b+24>>2]|0;s=j+2|0;do{if(s>>>0<=t>>>0&k<<24>>24==(a[35576]|0)){r=a[j+1|0]|0;if(r<<24>>24!=(a[35577]|0)){u=0;v=0;break}if(!((j+4|0)>>>0<=t>>>0&k<<24>>24==(a[35560]|0))){u=0;v=2;break}if(r<<24>>24!=(a[35561]|0)){u=0;v=2;break}if((a[s]|0)!=(a[35562]|0)){u=0;v=2;break}u=(a[j+3|0]|0)==(a[35563]|0)?4:0;v=2}else{u=0;v=0}}while(0);s=u|v;x=0,aK(538,e|0,((s|0)==2?2048:1968)|0)|0;if(!x){m=s;n=44}else{x=0;n=5}break};case 43:{s=c[b+24>>2]|0;v=j+4|0;do{if(v>>>0>s>>>0){w=0;y=0}else{do{if(k<<24>>24==(a[35672]|0)){if((a[j+1|0]|0)!=(a[35673]|0)){z=0;break}if((a[j+2|0]|0)!=(a[35674]|0)){z=0;break}z=(a[j+3|0]|0)==(a[35675]|0)?4:0}else{z=0}}while(0);do{if(k<<24>>24==(a[35664]|0)){if((a[j+1|0]|0)!=(a[35665]|0)){A=0;break}if((a[j+2|0]|0)!=(a[35666]|0)){A=0;break}A=(a[j+3|0]|0)==(a[35667]|0)?4:0}else{A=0}}while(0);u=A|z;do{if(k<<24>>24==(a[35656]|0)){if((a[j+1|0]|0)!=(a[35657]|0)){B=0;break}if((a[j+2|0]|0)!=(a[35658]|0)){B=0;break}B=(a[j+3|0]|0)==(a[35659]|0)?4:0}else{B=0}}while(0);t=u|B;if(k<<24>>24!=(a[35648]|0)){w=0;y=t;break}if((a[j+1|0]|0)!=(a[35649]|0)){w=0;y=t;break}if((a[j+2|0]|0)!=(a[35650]|0)){w=0;y=t;break}w=(a[j+3|0]|0)==(a[35651]|0)?4:0;y=t}}while(0);B=y|w;do{if((j+5|0)>>>0<=s>>>0&k<<24>>24==(a[35640]|0)){if((a[j+1|0]|0)!=(a[35641]|0)){C=0;break}if((a[j+2|0]|0)!=(a[35642]|0)){C=0;break}if((a[j+3|0]|0)!=(a[35643]|0)){C=0;break}C=(a[v]|0)==(a[35644]|0)?5:0}else{C=0}}while(0);x=0,aK(538,e|0,1792)|0;if(!x){m=B|C;n=44}else{x=0;n=5}break};case 239:{do{if((j+3|0)>>>0<=(c[b+24>>2]|0)>>>0&k<<24>>24==(a[35288]|0)){if((a[j+1|0]|0)!=(a[35289]|0)){D=0;break}D=(a[j+2|0]|0)==(a[35290]|0)?3:0}else{D=0}}while(0);x=0,aK(538,e|0,2208)|0;if(!x){E=D;n=66}else{x=0;n=5}break};default:{E=0;n=66}}L80:do{if((n|0)==5){D=bQ(-1,-1)|0;F=K;G=D;n=6}else if((n|0)==44){if((m|0)==0){E=0;n=66;break}D=g;Ke(D|0,0,12)|0;j=e;k=a[f]|0;C=k&255;if((C&1|0)==0){H=C>>>1}else{H=c[e+4>>2]|0}C=H+74|0;do{if(C>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(C>>>0<11>>>0){a[D]=-108;I=g+1|0}else{B=H+90&-16;v=(x=0,as(230,B|0)|0);if(x){x=0;break}c[g+8>>2]=v;c[g>>2]=B|1;c[g+4>>2]=74;I=v}Kb(I|0,1344,74)|0;a[I+74|0]=0;if((k&1)==0){J=j+1|0}else{J=c[e+8>>2]|0}x=0,ax(64,g|0,J|0,H|0)|0;if(x){x=0;break}c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;x=0;aP(466,b|0,g|0,h|0);if(!x){if((a[D]&1)==0){E=m;n=66;break L80}J2(c[g+8>>2]|0);E=m;n=66;break L80}else{x=0;v=bQ(-1,-1)|0;B=v;v=K;if((a[D]&1)==0){L=v;M=B;break L80}J2(c[g+8>>2]|0);L=v;M=B;break L80}}}while(0);j=bQ(-1,-1)|0;k=K;if((a[D]&1)==0){F=k;G=j;n=6;break}J2(c[g+8>>2]|0);F=k;G=j;n=6}}while(0);if((n|0)==6){L=F;M=G}else if((n|0)==66){n=b+20|0;c[n>>2]=(c[n>>2]|0)+E;if((a[f]&1)==0){i=d;return}J2(c[e+8>>2]|0);i=d;return}if((a[f]&1)==0){N=M;O=0;P=N;Q=L;be(P|0)}J2(c[e+8>>2]|0);N=M;O=0;P=N;Q=L;be(P|0)}function r0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xO(c[d>>2]|0)|0;f=xO(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function r1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=c[d>>2]|0;f=xH(e)|0;if((f|0)==0){g=xJ(e)|0;if((g|0)==0){h=e}else{i=g;j=3}}else{i=f;j=3}if((j|0)==3){while(1){j=0;f=xH(i)|0;if((f|0)!=0){i=f;j=3;continue}f=xJ(i)|0;if((f|0)==0){h=i;break}else{i=f;j=3}}}j=xK(h)|0;if((j|0)==0){k=0;return k|0}i=b+48|0;f=c[i>>2]|0;g=c[d>>2]|0;L11:do{if(g>>>0<j>>>0){e=g;l=0;while(1){m=a[e]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L11}else{n=l}m=e+1|0;if(m>>>0<j>>>0){e=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[i>>2]=f+o;f=h;i=0;while(1){n=f-1|0;if(n>>>0<g>>>0){break}if((a[n]|0)==10){break}else{f=n;i=i+1|0}}f=b+40|0;if((o|0)!=0){c[f>>2]=1}o=c[f>>2]|0;c[b+52>>2]=o+i;g=j;n=h;c[f>>2]=g-n+i+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=g;c[d>>2]=j;k=j;return k|0}function r2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=g+32|0;Kb(k|0,e|0,12)|0;e=h;l=j;m=b|0;n=d;if((a[n]&1)==0){c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[e]=o<<1;p=h+1|0}else{d=o+16&-16;q=J0(d)|0;c[h+8>>2]=q;c[h>>2]=d|1;c[h+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];x=0;aP(402,m|0,h|0,j|0);if(!x){if((a[e]&1)==0){r=b|0;c[r>>2]=17232;s=b+28|0;c[s>>2]=f;i=g;return}J2(c[h+8>>2]|0);r=b|0;c[r>>2]=17232;s=b+28|0;c[s>>2]=f;i=g;return}else{x=0;g=bQ(-1,-1)|0;if((a[e]&1)==0){be(g|0)}J2(c[h+8>>2]|0);be(g|0)}}function r3(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0;e=i;i=i+496|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=e+72|0;n=e+80|0;o=e+96|0;p=e+104|0;q=e+120|0;r=e+128|0;s=e+144|0;t=e+160|0;u=e+176|0;v=e+192|0;w=e+208|0;y=e+224|0;z=e+240|0;A=e+256|0;B=e+272|0;C=e+288|0;D=e+304|0;E=e+312|0;F=e+328|0;G=e+344|0;H=e+360|0;I=e+376|0;J=e+392|0;L=e+408|0;M=e+424|0;N=e+432|0;O=e+448|0;P=e+464|0;Q=e+480|0;sl(b)|0;R=b|0;S=c[R>>2]|0;T=J0(52)|0;c[q>>2]=T;U=S+4|0;V=c[U>>2]|0;if((V|0)==(c[S+8>>2]|0)){ee(S|0,q);W=c[q>>2]|0}else{if((V|0)==0){X=0}else{c[V>>2]=T;X=c[U>>2]|0}c[U>>2]=X+4;W=T}T=W;X=W;V=b+28|0;L8:do{if((a[V]&1)==0){q=r;c[q>>2]=c[V>>2];c[q+4>>2]=c[V+4>>2];c[q+8>>2]=c[V+8>>2];Y=16}else{q=c[b+36>>2]|0;Z=c[b+32>>2]|0;do{if(Z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(Z>>>0<11>>>0){a[r]=Z<<1;_=r+1|0}else{$=Z+16&-16;aa=(x=0,as(230,$|0)|0);if(x){x=0;break}c[r+8>>2]=aa;c[r>>2]=$|1;c[r+4>>2]=Z;_=aa}Kb(_|0,q|0,Z)|0;a[_+Z|0]=0;Y=16;break L8}}while(0);Z=bQ(-1,-1)|0;ab=Z;ac=K}}while(0);do{if((Y|0)==16){_=b+44|0;Z=p;c[Z>>2]=c[_>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];x=0;aP(198,X|0,r|0,p|0);if(x){x=0;Z=bQ(-1,-1)|0;q=Z;Z=K;if((a[r]&1)==0){ab=q;ac=Z;break}J2(c[r+8>>2]|0);ab=q;ac=Z;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}Z=b+20|0;q=N+8|0;aa=N|0;$=N+4|0;ad=O|0;ae=O+4|0;af=O+8|0;ag=N;ah=P+8|0;ai=P|0;aj=P+4|0;ak=Q|0;al=Q+4|0;am=Q+8|0;an=P;ar=W+40|0;at=ar+4|0;au=ar+8|0;av=ar;ar=b+48|0;aw=b+40|0;ay=b+52|0;az=b+56|0;aA=b+56|0;aC=b+60|0;aD=s;aE=s+1|0;aF=F;aG=E;aH=H;aI=I;aJ=G;aK=J;aL=J+1|0;aM=L|0;aN=L+4|0;aO=L+8|0;aQ=J+8|0;aR=s+8|0;aS=J|0;aU=J+4|0;aV=s+4|0;aW=W+32|0;aX=aW;aY=W+36|0;aZ=W+28|0;a_=E+8|0;a$=G+8|0;a0=aW|0;aW=G+4|0;a1=H+8|0;a2=I+8|0;a3=E+4|0;a4=H+1|0;a5=H|0;a6=H+4|0;a7=F+8|0;a8=b+36|0;a9=b+32|0;ba=F+1|0;bb=F|0;bc=F+4|0;bd=t;bf=t+1|0;bg=u;bh=v;bi=w;bj=n;bk=y;bl=z;bm=z+1|0;bn=A;bo=B;bp=C;bq=C+1|0;br=C+4|0;bs=B+8|0;bt=C+8|0;bu=B+1|0;bv=B|0;bw=B+4|0;bx=A+8|0;by=A+1|0;bz=A|0;bA=A+4|0;bB=y+8|0;bC=z+8|0;bD=y+1|0;bE=y|0;bF=y+4|0;bG=u+8|0;bH=w+8|0;bI=w+1|0;bJ=w|0;bK=w+4|0;bL=u+1|0;bM=u|0;bN=u+4|0;bO=t+8|0;bP=t+4|0;bR=t|0;bS=s|0;bT=1;L30:while(1){do{if((sg(b)|0)==0){if((yq(xP(c[Z>>2]|0)|0)|0)!=0){bU=sm(b)|0;c[M>>2]=bU;bV=c[at>>2]|0;if((bV|0)==(c[au>>2]|0)){eq(av,M);break}if((bV|0)==0){bW=0}else{c[bV>>2]=bU;bW=c[at>>2]|0}c[at>>2]=bW+4;break}if(bT){bU=J0(48)|0;c[q>>2]=bU;c[aa>>2]=49;c[$>>2]=47;Kb(bU|0,12056,47)|0;a[bU+47|0]=0;c[ad>>2]=0;c[ae>>2]=0;c[af>>2]=0;x=0;aP(466,b|0,N|0,O|0);if(x){x=0;Y=315;break L30}if((a[ag]&1)==0){break}J2(c[q>>2]|0);break}else{bU=J0(64)|0;c[ah>>2]=bU;c[ai>>2]=65;c[aj>>2]=52;Kb(bU|0,11240,52)|0;a[bU+52|0]=0;c[ak>>2]=0;c[al>>2]=0;c[am>>2]=0;x=0;aP(466,b|0,P|0,Q|0);if(x){x=0;Y=320;break L30}if((a[an]&1)==0){break}J2(c[ah>>2]|0);break}}else{bU=c[aA>>2]|0;bV=(c[aC>>2]|0)-bU|0;if(bV>>>0>4294967279>>>0){Y=22;break L30}if(bV>>>0<11>>>0){bX=bV<<1&255;a[aD]=bX;bY=aE;bZ=bX}else{bX=bV+16&-16;b_=J0(bX)|0;c[aR>>2]=b_;b$=bX|1;c[bS>>2]=b$;c[aV>>2]=bV;bY=b_;bZ=b$&255}Kb(bY|0,bU|0,bV)|0;a[bY+bV|0]=0;bV=bZ&255;bU=(bV&1|0)==0?bV>>>1:c[aV>>2]|0;L39:do{if((bU|0)==0){Y=219}else{bV=(bZ&1)==0?aE:c[aR>>2]|0;b$=bV+bU|0;do{if((b$|0)==(bV|0)){Y=219;break L39}b$=b$-1|0;}while((a[b$]|0)!=46);b_=b$-bV|0;if((b_|0)==-1){Y=219;break}bX=bZ&255;b0=(bX&1|0)==0?bX>>>1:c[aV>>2]|0;if(b0>>>0<b_>>>0){Y=32;break L30}bX=((bZ&1)==0?aE:c[aR>>2]|0)+b_|0;b1=b0-b_|0;b_=b1>>>0<4>>>0?b1:4;if(b_>>>0>4294967279>>>0){Y=35;break L30}if(b_>>>0<11>>>0){b1=b_<<1&255;a[bd]=b1;b2=bf;b3=b1}else{b1=b_+16&-16;b0=(x=0,as(230,b1|0)|0);if(x){x=0;Y=163;break L30}c[bO>>2]=b0;b4=b1|1;c[bR>>2]=b4;c[bP>>2]=b_;b2=b0;b3=b4&255}Kb(b2|0,bX|0,b_)|0;a[b2+b_|0]=0;b_=b3&255;bX=(b_&1|0)==0?b_>>>1:c[bP>>2]|0;b_=bX>>>0>4>>>0;b4=Kd(((b3&1)==0?bf:c[bO>>2]|0)|0,2464,(b_?4:bX)|0)|0;if((b4|0)==0){b5=bX>>>0<4>>>0?-1:b_&1}else{b5=b4}b4=(b5|0)==0;if((b3&1)==0){if(!b4){Y=219;break}}else{J2(c[bO>>2]|0);if(!b4){Y=219;break}}b6=c[R>>2]|0;b4=(x=0,as(230,52)|0);if(x){x=0;Y=163;break L30}b_=b4;c[o>>2]=b_;b7=b6+4|0;b4=c[b7>>2]|0;if((b4|0)==(c[b6+8>>2]|0)){x=0;aq(376,b6|0,o|0);if(x){x=0;Y=163;break L30}b8=c[o>>2]|0}else{if((b4|0)==0){b9=0}else{c[b4>>2]=b_;b9=c[b7>>2]|0}c[b7>>2]=b9+4;b8=b_}ca=b8;b_=b8;if((a[V]&1)==0){c[bg>>2]=c[V>>2];c[bg+4>>2]=c[V+4>>2];c[bg+8>>2]=c[V+8>>2]}else{b4=c[a8>>2]|0;bX=c[a9>>2]|0;if(bX>>>0>4294967279>>>0){Y=56;break L30}if(bX>>>0<11>>>0){a[bg]=bX<<1;cb=bL}else{b0=bX+16&-16;b1=(x=0,as(230,b0|0)|0);if(x){x=0;Y=166;break L30}c[bG>>2]=b1;c[bM>>2]=b0|1;c[bN>>2]=bX;cb=b1}Kb(cb|0,b4|0,bX)|0;a[cb+bX|0]=0}c[bh>>2]=c[_>>2];c[bh+4>>2]=c[_+4>>2];c[bh+8>>2]=c[_+8>>2];if((a[aD]&1)==0){c[bi>>2]=c[aD>>2];c[bi+4>>2]=c[aD+4>>2];c[bi+8>>2]=c[aD+8>>2]}else{bX=c[aR>>2]|0;b4=c[aV>>2]|0;if(b4>>>0>4294967279>>>0){Y=66;break L30}if(b4>>>0<11>>>0){a[bi]=b4<<1;cc=bI}else{b1=b4+16&-16;b0=(x=0,as(230,b1|0)|0);if(x){x=0;Y=169;break L30}c[bH>>2]=b0;c[bJ>>2]=b1|1;c[bK>>2]=b4;cc=b0}Kb(cc|0,bX|0,b4)|0;a[cc+b4|0]=0}c[bj>>2]=c[bh>>2];c[bj+4>>2]=c[bh+4>>2];c[bj+8>>2]=c[bh+8>>2];x=0;ao(26,b_|0,u|0,n|0,w|0,0);if(x){x=0;Y=172;break L30}if((a[bi]&1)!=0){J2(c[bH>>2]|0)}if((a[bg]&1)!=0){J2(c[bG>>2]|0)}cd=c[R>>2]|0;b_=(x=0,as(230,56)|0);if(x){x=0;Y=163;break L30}b4=b_;c[m>>2]=b4;ce=cd+4|0;b_=c[ce>>2]|0;if((b_|0)==(c[cd+8>>2]|0)){x=0;aq(376,cd|0,m|0);if(x){x=0;Y=163;break L30}cf=c[m>>2]|0}else{if((b_|0)==0){cg=0}else{c[b_>>2]=b4;cg=c[ce>>2]|0}c[ce>>2]=cg+4;cf=b4}ch=cf;b4=cf;if((a[V]&1)==0){c[bk>>2]=c[V>>2];c[bk+4>>2]=c[V+4>>2];c[bk+8>>2]=c[V+8>>2]}else{b_=c[a8>>2]|0;bX=c[a9>>2]|0;if(bX>>>0>4294967279>>>0){Y=88;break L30}if(bX>>>0<11>>>0){a[bk]=bX<<1;ci=bD}else{b0=bX+16&-16;b1=(x=0,as(230,b0|0)|0);if(x){x=0;Y=182;break L30}c[bB>>2]=b1;c[bE>>2]=b0|1;c[bF>>2]=bX;ci=b1}Kb(ci|0,b_|0,bX)|0;a[ci+bX|0]=0}bX=l;c[bX>>2]=c[_>>2];c[bX+4>>2]=c[_+4>>2];c[bX+8>>2]=c[_+8>>2];a[bl]=0;a[bm]=0;x=0;aB(28,b4|0,y|0,l|0,b8|0,z|0,0);if(x){x=0;Y=185;break L30}if((a[bl]&1)!=0){J2(c[bC>>2]|0)}if((a[bk]&1)!=0){J2(c[bB>>2]|0)}cj=c[R>>2]|0;bX=(x=0,as(230,56)|0);if(x){x=0;Y=163;break L30}b_=bX;c[k>>2]=b_;ck=cj+4|0;bX=c[ck>>2]|0;if((bX|0)==(c[cj+8>>2]|0)){x=0;aq(376,cj|0,k|0);if(x){x=0;Y=163;break L30}cl=c[k>>2]|0}else{if((bX|0)==0){cm=0}else{c[bX>>2]=b_;cm=c[ck>>2]|0}c[ck>>2]=cm+4;cl=b_}cn=cl;b_=cl;if((a[V]&1)==0){c[bn>>2]=c[V>>2];c[bn+4>>2]=c[V+4>>2];c[bn+8>>2]=c[V+8>>2]}else{bX=c[a8>>2]|0;b1=c[a9>>2]|0;if(b1>>>0>4294967279>>>0){Y=110;break L30}if(b1>>>0<11>>>0){a[bn]=b1<<1;co=by}else{b0=b1+16&-16;cp=(x=0,as(230,b0|0)|0);if(x){x=0;Y=195;break L30}c[bx>>2]=cp;c[bz>>2]=b0|1;c[bA>>2]=b1;co=cp}Kb(co|0,bX|0,b1)|0;a[co+b1|0]=0}b1=j;c[b1>>2]=c[_>>2];c[b1+4>>2]=c[_+4>>2];c[b1+8>>2]=c[_+8>>2];x=0;aP(44,b_|0,A|0,j|0);if(x){x=0;Y=198;break L30}if((a[bn]&1)!=0){J2(c[bx>>2]|0)}b1=cl+36|0;bX=b1;c[h>>2]=b4;cp=b1+8|0;b0=cp;cq=c[b0>>2]|0;if((cq|0)==(c[b1+12>>2]|0)){x=0;aq(156,b1+4|0,h|0);if(x){x=0;Y=163;break L30}cr=c[h>>2]|0}else{if((cq|0)==0){cs=0}else{c[cq>>2]=b4;cs=c[b0>>2]|0}c[cp>>2]=cs+4;cr=b4}x=0;aq(c[c[b1>>2]>>2]|0,bX|0,cr|0);if(x){x=0;Y=163;break L30}ct=c[R>>2]|0;bX=(x=0,as(230,52)|0);if(x){x=0;Y=163;break L30}b1=bX;c[g>>2]=b1;cu=ct+4|0;bX=c[cu>>2]|0;if((bX|0)==(c[ct+8>>2]|0)){x=0;aq(376,ct|0,g|0);if(x){x=0;Y=163;break L30}cv=c[g>>2]|0}else{if((bX|0)==0){cw=0}else{c[bX>>2]=b1;cw=c[cu>>2]|0}c[cu>>2]=cw+4;cv=b1}cx=cv;b1=cv;if((a[V]&1)==0){c[bo>>2]=c[V>>2];c[bo+4>>2]=c[V+4>>2];c[bo+8>>2]=c[V+8>>2]}else{bX=c[a8>>2]|0;b4=c[a9>>2]|0;if(b4>>>0>4294967279>>>0){Y=137;break L30}if(b4>>>0<11>>>0){a[bo]=b4<<1;cy=bu}else{cp=b4+16&-16;b0=(x=0,as(230,cp|0)|0);if(x){x=0;Y=206;break L30}c[bs>>2]=b0;c[bv>>2]=cp|1;c[bw>>2]=b4;cy=b0}Kb(cy|0,bX|0,b4)|0;a[cy+b4|0]=0}b4=f;c[b4>>2]=c[_>>2];c[b4+4>>2]=c[_+4>>2];c[b4+8>>2]=c[_+8>>2];a[bp]=6;a[bq]=a[888]|0;a[bq+1|0]=a[889]|0;a[bq+2|0]=a[890]|0;a[br]=0;x=0;ao(10,b1|0,B|0,f|0,C|0,b_|0);if(x){x=0;Y=209;break L30}if((a[bp]&1)!=0){J2(c[bt>>2]|0)}if((a[bo]&1)!=0){J2(c[bs>>2]|0)}b_=cv;c[D>>2]=b_;b1=c[at>>2]|0;b4=b1;if((b1|0)==(c[au>>2]|0)){x=0;aq(370,av|0,D|0);if(!x){break}else{x=0;Y=163;break L30}}if((b1|0)==0){cz=0}else{c[b4>>2]=b_;cz=c[at>>2]|0}c[at>>2]=cz+4}}while(0);do{if((Y|0)==219){Y=0;if((a[V]&1)==0){c[aF>>2]=c[V>>2];c[aF+4>>2]=c[V+4>>2];c[aF+8>>2]=c[V+8>>2]}else{bU=c[a8>>2]|0;b_=c[a9>>2]|0;if(b_>>>0>4294967279>>>0){Y=222;break L30}if(b_>>>0<11>>>0){a[aF]=b_<<1;cA=ba}else{b4=b_+16&-16;b1=(x=0,as(230,b4|0)|0);if(x){x=0;Y=163;break L30}c[a7>>2]=b1;c[bb>>2]=b4|1;c[bc>>2]=b_;cA=b1}Kb(cA|0,bU|0,b_)|0;a[cA+b_|0]=0}x=0;aq(280,E|0,F|0);if(x){x=0;Y=264;break L30}if((a[aF]&1)!=0){J2(c[a7>>2]|0)}b_=c[R>>2]|0;if((a[aG]&1)==0){c[aH>>2]=c[aG>>2];c[aH+4>>2]=c[aG+4>>2];c[aH+8>>2]=c[aG+8>>2]}else{bU=c[a_>>2]|0;b1=c[a3>>2]|0;if(b1>>>0>4294967279>>>0){Y=235;break L30}if(b1>>>0<11>>>0){a[aH]=b1<<1;cB=a4}else{b4=b1+16&-16;bX=(x=0,as(230,b4|0)|0);if(x){x=0;Y=266;break L30}c[a1>>2]=bX;c[a5>>2]=b4|1;c[a6>>2]=b1;cB=bX}Kb(cB|0,bU|0,b1)|0;a[cB+b1|0]=0}x=0;aq(180,I|0,s|0);if(x){x=0;Y=269;break L30}x=0;aT(8,G|0,b_|0,H|0,I|0);if(x){x=0;Y=270;break L30}if((a[aI]&1)!=0){J2(c[a2>>2]|0)}if((a[aH]&1)!=0){J2(c[a1>>2]|0)}b_=d[aJ]|0;do{if((((b_&1|0)==0?b_>>>1:c[aW>>2]|0)|0)==0){Ke(aK|0,0,12)|0;b1=a[aD]|0;bU=b1&255;bX=(bU&1|0)==0?bU>>>1:c[aV>>2]|0;bU=bX+40|0;if(bU>>>0>4294967279>>>0){Y=250;break L30}if(bU>>>0<11>>>0){a[aK]=80;cC=aL}else{bU=bX+56&-16;b4=(x=0,as(230,bU|0)|0);if(x){x=0;Y=257;break L30}c[aQ>>2]=b4;c[aS>>2]=bU|1;c[aU>>2]=40;cC=b4}Kb(cC|0,240,40)|0;a[cC+40|0]=0;b4=(b1&1)==0?aE:c[aR>>2]|0;x=0,ax(64,J|0,b4|0,bX|0)|0;if(x){x=0;Y=257;break L30}c[aM>>2]=0;c[aN>>2]=0;c[aO>>2]=0;x=0;aP(466,b|0,J|0,L|0);if(x){x=0;Y=277;break L30}if((a[aK]&1)==0){break}J2(c[aQ>>2]|0)}}while(0);b_=c[aX>>2]|0;if((b_|0)==(c[aY>>2]|0)){x=0;aq(282,aZ|0,G|0);if(x){x=0;Y=274;break L30}}else{do{if((b_|0)!=0){if((a[aJ]&1)==0){bV=b_;c[bV>>2]=c[aJ>>2];c[bV+4>>2]=c[aJ+4>>2];c[bV+8>>2]=c[aJ+8>>2];break}bV=c[a$>>2]|0;b$=c[aW>>2]|0;if(b$>>>0>4294967279>>>0){Y=284;break L30}if(b$>>>0<11>>>0){a[b_]=b$<<1;cD=b_+1|0}else{bX=b$+16&-16;b4=(x=0,as(230,bX|0)|0);if(x){x=0;Y=274;break L30}c[b_+8>>2]=b4;c[b_>>2]=bX|1;c[b_+4>>2]=b$;cD=b4}Kb(cD|0,bV|0,b$)|0;a[cD+b$|0]=0}}while(0);c[a0>>2]=(c[aX>>2]|0)+12}if((a[aJ]&1)!=0){J2(c[a$>>2]|0)}if((a[aG]&1)==0){break}J2(c[a_>>2]|0)}}while(0);if((a[aD]&1)==0){break}J2(c[aR>>2]|0)}}while(0);b_=xP(c[Z>>2]|0)|0;b$=(a[b_]|0)==44?b_+1|0:0;if((b$|0)==0){Y=333;break}bV=c[ar>>2]|0;b4=c[Z>>2]|0;L273:do{if(b4>>>0<b$>>>0){bX=b4;b1=0;while(1){bU=a[bX]|0;if((bU<<24>>24|0)==10){cE=b1+1|0}else if((bU<<24>>24|0)==0){cF=b1;break L273}else{cE=b1}bU=bX+1|0;if(bU>>>0<b$>>>0){bX=bU;b1=cE}else{cF=cE;break}}}else{cF=0}}while(0);c[ar>>2]=cF+bV;b1=b_;bX=0;while(1){bU=b1-1|0;if(bU>>>0<b4>>>0){break}if((a[bU]|0)==10){break}else{b1=bU;bX=bX+1|0}}if((cF|0)!=0){c[aw>>2]=1}b1=c[aw>>2]|0;c[ay>>2]=b1+bX;b4=b$;bV=b_;c[aw>>2]=b4-bV+bX+b1;c[az>>2]=bV;c[az+4>>2]=b4;c[Z>>2]=b$;bT=0}do{if((Y|0)==22){CJ(0);return 0}else if((Y|0)==32){x=0;ap(238,0);if(x){x=0;Y=164;break}return 0}else if((Y|0)==35){x=0;ap(232,0);if(x){x=0;Y=164;break}return 0}else if((Y|0)==56){x=0;ap(232,0);if(!x){return 0}else{x=0;bT=bQ(-1,-1)|0;cG=K;cH=bT;Y=168;break}}else if((Y|0)==66){x=0;ap(232,0);if(!x){return 0}else{x=0;bT=bQ(-1,-1)|0;cI=K;cJ=bT;Y=171;break}}else if((Y|0)==88){x=0;ap(232,0);if(!x){return 0}else{x=0;bT=bQ(-1,-1)|0;cK=K;cL=bT;Y=184;break}}else if((Y|0)==110){x=0;ap(232,0);if(!x){return 0}else{x=0;bT=bQ(-1,-1)|0;cM=K;cN=bT;Y=197;break}}else if((Y|0)==137){x=0;ap(232,0);if(!x){return 0}else{x=0;bT=bQ(-1,-1)|0;cO=K;cP=bT;Y=208;break}}else if((Y|0)==163){bT=bQ(-1,-1)|0;cQ=K;cR=bT;Y=165}else if((Y|0)==166){bT=bQ(-1,-1)|0;cG=K;cH=bT;Y=168}else if((Y|0)==169){bT=bQ(-1,-1)|0;cI=K;cJ=bT;Y=171}else if((Y|0)==172){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[bi]&1)==0){cS=Z;cT=bT;Y=174;break}J2(c[bH>>2]|0);cS=Z;cT=bT;Y=174}else if((Y|0)==182){bT=bQ(-1,-1)|0;cK=K;cL=bT;Y=184}else if((Y|0)==185){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[bl]&1)!=0){J2(c[bC>>2]|0)}if((a[bk]&1)==0){cU=Z;cV=bT;Y=189;break}J2(c[bB>>2]|0);cU=Z;cV=bT;Y=189}else if((Y|0)==195){bT=bQ(-1,-1)|0;cM=K;cN=bT;Y=197}else if((Y|0)==198){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[bn]&1)==0){cW=Z;cX=bT;Y=200;break}J2(c[bx>>2]|0);cW=Z;cX=bT;Y=200}else if((Y|0)==206){bT=bQ(-1,-1)|0;cO=K;cP=bT;Y=208}else if((Y|0)==209){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[bp]&1)!=0){J2(c[bt>>2]|0)}if((a[bo]&1)==0){cY=Z;cZ=bT;Y=213;break}J2(c[bs>>2]|0);cY=Z;cZ=bT;Y=213}else if((Y|0)==222){x=0;ap(232,0);if(x){x=0;Y=164;break}return 0}else if((Y|0)==235){x=0;ap(232,0);if(!x){return 0}else{x=0;bT=bQ(-1,-1)|0;c_=K;c$=bT;Y=268;break}}else if((Y|0)==250){x=0;ap(232,0);if(!x){return 0}else{x=0;bT=bQ(-1,-1)|0;c0=K;c1=bT;Y=259;break}}else if((Y|0)==257){bT=bQ(-1,-1)|0;c0=K;c1=bT;Y=259}else if((Y|0)==264){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[aF]&1)==0){c2=Z;c3=bT;break}J2(c[a7>>2]|0);c2=Z;c3=bT}else if((Y|0)==266){bT=bQ(-1,-1)|0;c_=K;c$=bT;Y=268}else if((Y|0)==269){bT=bQ(-1,-1)|0;c4=bT;c5=K;Y=272}else if((Y|0)==270){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[aI]&1)==0){c4=Z;c5=bT;Y=272;break}J2(c[a2>>2]|0);c4=Z;c5=bT;Y=272}else if((Y|0)==274){bT=bQ(-1,-1)|0;c6=K;c7=bT;Y=276}else if((Y|0)==277){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[aK]&1)==0){c8=Z;c9=bT;Y=297;break}J2(c[aQ>>2]|0);c8=Z;c9=bT;Y=297}else if((Y|0)==284){x=0;ap(232,0);if(!x){return 0}else{x=0;bT=bQ(-1,-1)|0;c6=K;c7=bT;Y=276;break}}else if((Y|0)==315){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[ag]&1)==0){da=Z;db=bT;dc=da;dd=0;de=dc;df=db;be(de|0)}J2(c[q>>2]|0);da=Z;db=bT;dc=da;dd=0;de=dc;df=db;be(de|0)}else if((Y|0)==320){bT=bQ(-1,-1)|0;Z=bT;bT=K;if((a[an]&1)==0){da=Z;db=bT;dc=da;dd=0;de=dc;df=db;be(de|0)}J2(c[ah>>2]|0);da=Z;db=bT;dc=da;dd=0;de=dc;df=db;be(de|0)}else if((Y|0)==333){i=e;return X|0}}while(0);do{if((Y|0)==164){ah=bQ(-1,-1)|0;cQ=K;cR=ah;Y=165}else if((Y|0)==168){dg=cH;dh=cG;Y=176}else if((Y|0)==171){cS=cJ;cT=cI;Y=174}else if((Y|0)==184){cU=cL;cV=cK;Y=189}else if((Y|0)==197){cW=cN;cX=cM;Y=200}else if((Y|0)==208){cY=cP;cZ=cO;Y=213}else if((Y|0)==259){if((a[aK]&1)==0){c6=c0;c7=c1;Y=276;break}J2(c[aQ>>2]|0);c6=c0;c7=c1;Y=276}else if((Y|0)==268){di=c$;dj=c_;Y=299}else if((Y|0)==272){if((a[aH]&1)==0){di=c4;dj=c5;Y=299;break}J2(c[a1>>2]|0);di=c4;dj=c5;Y=299}}while(0);do{if((Y|0)==165){c2=cR;c3=cQ}else if((Y|0)==174){if((a[bg]&1)==0){dg=cS;dh=cT;Y=176;break}J2(c[bG>>2]|0);dg=cS;dh=cT;Y=176}else if((Y|0)==189){a1=c[cd>>2]|0;aH=c[ce>>2]|0;aQ=a1;while(1){if((aQ|0)==(aH|0)){dk=aH;break}if((c[aQ>>2]|0)==(cf|0)){dk=aQ;break}else{aQ=aQ+4|0}}aQ=dk-a1>>2;b$=a1+(aQ+1<<2)|0;bX=aH-b$|0;Kc(a1+(aQ<<2)|0,b$|0,bX|0)|0;b$=a1+((bX>>2)+aQ<<2)|0;aQ=c[ce>>2]|0;if((b$|0)!=(aQ|0)){c[ce>>2]=aQ+(~((aQ-4+(-b$|0)|0)>>>2)<<2)}J2(ch);c2=cU;c3=cV}else if((Y|0)==200){b$=c[cj>>2]|0;aQ=c[ck>>2]|0;bX=b$;while(1){if((bX|0)==(aQ|0)){dl=aQ;break}if((c[bX>>2]|0)==(cl|0)){dl=bX;break}else{bX=bX+4|0}}bX=dl-b$>>2;a1=b$+(bX+1<<2)|0;aH=aQ-a1|0;Kc(b$+(bX<<2)|0,a1|0,aH|0)|0;a1=b$+((aH>>2)+bX<<2)|0;bX=c[ck>>2]|0;if((a1|0)!=(bX|0)){c[ck>>2]=bX+(~((bX-4+(-a1|0)|0)>>>2)<<2)}J2(cn);c2=cW;c3=cX}else if((Y|0)==213){a1=c[ct>>2]|0;bX=c[cu>>2]|0;aH=a1;while(1){if((aH|0)==(bX|0)){dm=bX;break}if((c[aH>>2]|0)==(cv|0)){dm=aH;break}else{aH=aH+4|0}}aH=dm-a1>>2;b$=a1+(aH+1<<2)|0;aQ=bX-b$|0;Kc(a1+(aH<<2)|0,b$|0,aQ|0)|0;b$=a1+((aQ>>2)+aH<<2)|0;aH=c[cu>>2]|0;if((b$|0)!=(aH|0)){c[cu>>2]=aH+(~((aH-4+(-b$|0)|0)>>>2)<<2)}J2(cx);c2=cY;c3=cZ}else if((Y|0)==276){c8=c7;c9=c6;Y=297}}while(0);do{if((Y|0)==176){bG=c[b6>>2]|0;bg=c[b7>>2]|0;b$=bG;while(1){if((b$|0)==(bg|0)){dn=bg;break}if((c[b$>>2]|0)==(b8|0)){dn=b$;break}else{b$=b$+4|0}}b$=dn-bG>>2;a1=bG+(b$+1<<2)|0;bX=bg-a1|0;Kc(bG+(b$<<2)|0,a1|0,bX|0)|0;a1=bG+((bX>>2)+b$<<2)|0;b$=c[b7>>2]|0;if((a1|0)!=(b$|0)){c[b7>>2]=b$+(~((b$-4+(-a1|0)|0)>>>2)<<2)}J2(ca);c2=dg;c3=dh}else if((Y|0)==297){if((a[aJ]&1)==0){di=c8;dj=c9;Y=299;break}J2(c[a$>>2]|0);di=c8;dj=c9;Y=299}}while(0);do{if((Y|0)==299){if((a[aG]&1)==0){c2=di;c3=dj;break}J2(c[a_>>2]|0);c2=di;c3=dj}}while(0);if((a[aD]&1)==0){da=c2;db=c3;dc=da;dd=0;de=dc;df=db;be(de|0)}J2(c[aR>>2]|0);da=c2;db=c3;dc=da;dd=0;de=dc;df=db;be(de|0)}}while(0);c3=c[S>>2]|0;S=c[U>>2]|0;c2=c3;while(1){if((c2|0)==(S|0)){dp=S;break}if((c[c2>>2]|0)==(W|0)){dp=c2;break}else{c2=c2+4|0}}c2=dp-c3>>2;dp=c3+(c2+1<<2)|0;W=S-dp|0;Kc(c3+(c2<<2)|0,dp|0,W|0)|0;dp=c3+((W>>2)+c2<<2)|0;c2=c[U>>2]|0;if((dp|0)!=(c2|0)){c[U>>2]=c2+(~((c2-4+(-dp|0)|0)>>>2)<<2)}J2(T);da=ab;db=ac;dc=da;dd=0;de=dc;df=db;be(de|0);return 0}function r4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+48|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=f+32|0;f=ci(40)|0;k=f;l=b+28|0;L1:do{if((a[l]&1)==0){m=g;c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];n=11}else{m=c[b+36>>2]|0;o=c[b+32>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[g]=o<<1;p=g+1|0}else{q=o+16&-16;r=(x=0,as(230,q|0)|0);if(x){x=0;break}c[g+8>>2]=r;c[g>>2]=q|1;c[g+4>>2]=o;p=r}Kb(p|0,m|0,o)|0;a[p+o|0]=0;n=11;break L1}}while(0);o=bQ(-1,-1)|0;s=o;t=K}}while(0);do{if((n|0)==11){p=h;l=(c[e+4>>2]|0)!=0?e:b+44|0;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];l=d;L16:do{if((a[l]&1)==0){p=j;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];n=21}else{p=c[d+8>>2]|0;o=c[d+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[j]=o<<1;u=j+1|0}else{m=o+16&-16;r=(x=0,as(230,m|0)|0);if(x){x=0;break}c[j+8>>2]=r;c[j>>2]=m|1;c[j+4>>2]=o;u=r}Kb(u|0,p|0,o)|0;a[u+o|0]=0;n=21;break L16}}while(0);o=bQ(-1,-1)|0;v=1;w=K;y=o}}while(0);do{if((n|0)==21){x=0;ao(32,k|0,2,g|0,h|0,j|0);do{if(!x){x=0;aP(144,f|0,30176,350);if(x){x=0;z=0;break}}else{x=0;z=1}}while(0);l=bQ(-1,-1)|0;o=l;l=K;if((a[j]&1)==0){v=z;w=l;y=o;break}J2(c[j+8>>2]|0);v=z;w=l;y=o}}while(0);if((a[g]&1)==0){if(v){s=y;t=w;break}else{A=y;B=w}C=A;D=0;E=C;F=B;be(E|0)}else{J2(c[g+8>>2]|0);if(v){s=y;t=w;break}else{A=y;B=w}C=A;D=0;E=C;F=B;be(E|0)}}}while(0);bl(f|0);A=s;B=t;C=A;D=0;E=C;F=B;be(E|0)}function r5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0;d=i;i=i+264|0;e=d|0;f=d+8|0;g=d+24|0;h=d+40|0;j=d+56|0;k=d+72|0;l=d+88|0;m=d+104|0;n=d+120|0;o=d+136|0;p=d+152|0;q=d+168|0;r=d+184|0;s=d+200|0;t=d+208|0;u=d+216|0;v=d+232|0;w=d+248|0;if((sn(b)|0)==0){y=(so(b)|0)!=0|0}else{y=0}z=b+56|0;A=c[z>>2]|0;B=b+60|0;C=(c[B>>2]|0)-A|0;if(C>>>0>4294967279>>>0){CJ(0);return 0}if(C>>>0<11>>>0){D=C<<1&255;a[g]=D;E=g+1|0;F=D}else{D=C+16&-16;G=J0(D)|0;c[g+8>>2]=G;H=D|1;c[g>>2]=H;c[g+4>>2]=C;E=G;F=H&255}Kb(E|0,A|0,C)|0;a[E+C|0]=0;C=(x=0,as(128,b|0)|0);L11:do{if(!x){L13:do{if((C|0)==0){E=j;Ke(E|0,0,12)|0;A=g;H=F&255;if((H&1|0)==0){I=H>>>1}else{I=c[g+4>>2]|0}H=I+16|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(H>>>0<11>>>0){a[E]=32;J=j+1|0}else{G=I+32&-16;D=(x=0,as(230,G|0)|0);if(x){x=0;break}c[j+8>>2]=D;c[j>>2]=G|1;c[j+4>>2]=16;J=D}Kb(J|0,10704,16)|0;a[J+16|0]=0;if((F&1)==0){L=A+1|0}else{L=c[g+8>>2]|0}x=0,ax(64,j|0,L|0,I|0)|0;if(x){x=0;break}D=h;Ke(D|0,0,12)|0;G=a[E]|0;M=G&255;if((M&1|0)==0){N=M>>>1}else{N=c[j+4>>2]|0}if((G&1)==0){O=j+1|0}else{O=c[j+8>>2]|0}do{if((N+11|0)>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;P=40;break}return 0}else{if(N>>>0>4294967284>>>0){a[D]=N<<1;Q=h+1|0}else{G=N+27&-16;M=(x=0,as(230,G|0)|0);if(x){x=0;P=40;break}c[h+8>>2]=M;c[h>>2]=G|1;c[h+4>>2]=N;Q=M}Kb(Q|0,O|0,N)|0;a[Q+N|0]=0;x=0,ax(64,h|0,10392,11)|0;if(x){x=0;P=40;break}c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;x=0;aP(466,b|0,h|0,k|0);if(x){x=0;M=bQ(-1,-1)|0;G=M;M=K;if((a[D]&1)==0){R=G;S=M;break}J2(c[h+8>>2]|0);R=G;S=M;break}if((a[D]&1)!=0){J2(c[h+8>>2]|0)}if((a[E]&1)==0){break L13}J2(c[j+8>>2]|0);break L13}}while(0);if((P|0)==40){M=bQ(-1,-1)|0;G=K;if((a[D]&1)!=0){J2(c[h+8>>2]|0)}R=M;S=G}if((a[E]&1)==0){T=R;U=S;break L11}J2(c[j+8>>2]|0);T=R;U=S;break L11}}while(0);A=bQ(-1,-1)|0;H=K;if((a[E]&1)==0){V=H;W=A;P=48;break L11}J2(c[j+8>>2]|0);V=H;W=A;P=48;break L11}}while(0);A=c[z>>2]|0;H=(c[B>>2]|0)-A|0;if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;P=47;break}return 0}if(H>>>0<11>>>0){a[l]=H<<1;X=l+1|0}else{G=H+16&-16;M=(x=0,as(230,G|0)|0);if(x){x=0;P=47;break}c[l+8>>2]=M;c[l>>2]=G|1;c[l+4>>2]=H;X=M}Kb(X|0,A|0,H)|0;a[X+H|0]=0;H=m;A=b+44|0;c[H>>2]=c[A>>2];c[H+4>>2]=c[A+4>>2];c[H+8>>2]=c[A+8>>2];A=(x=0,as(112,b|0)|0);L78:do{if(!x){M=(x=0,as(60,c[b+20>>2]|0)|0);if(x){x=0;P=122;break}L81:do{if((M+1|0)==0|(a[M]|0)!=123){G=q;Ke(G|0,0,12)|0;Y=g;Z=a[g]|0;_=Z&255;if((_&1|0)==0){$=_>>>1}else{$=c[g+4>>2]|0}_=$+9|0;do{if(_>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(_>>>0<11>>>0){a[G]=18;aa=q+1|0}else{ab=$+25&-16;ac=(x=0,as(230,ab|0)|0);if(x){x=0;break}c[q+8>>2]=ac;c[q>>2]=ab|1;c[q+4>>2]=9;aa=ac}Kb(aa|0,10152,9)|0;a[aa+9|0]=0;if((Z&1)==0){ad=Y+1|0}else{ad=c[g+8>>2]|0}x=0,ax(64,q|0,ad|0,$|0)|0;if(x){x=0;break}ac=p;Ke(ac|0,0,12)|0;ab=a[G]|0;ae=ab&255;if((ae&1|0)==0){af=ae>>>1}else{af=c[q+4>>2]|0}if((ab&1)==0){ag=q+1|0}else{ag=c[q+8>>2]|0}ab=af+1|0;do{if(ab>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;P=94;break}return 0}else{if(ab>>>0<11>>>0){a[ac]=af<<1;ah=p+1|0}else{ae=af+17&-16;ai=(x=0,as(230,ae|0)|0);if(x){x=0;P=94;break}c[p+8>>2]=ai;c[p>>2]=ae|1;c[p+4>>2]=af;ah=ai}Kb(ah|0,ag|0,af)|0;a[ah+af|0]=0;x=0,ax(64,p|0,9952,1)|0;if(x){x=0;P=94;break}x=0;aP(194,o|0,p|0,l|0);do{if(!x){ai=n;Ke(ai|0,0,12)|0;ae=o;aj=a[ae]|0;ak=aj&255;if((ak&1|0)==0){al=ak>>>1}else{al=c[o+4>>2]|0}if((aj&1)==0){am=o+1|0}else{am=c[o+8>>2]|0}aj=al+22|0;do{if(aj>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;P=111;break}return 0}else{if(aj>>>0<11>>>0){a[ai]=al<<1;an=n+1|0}else{ak=al+38&-16;ao=(x=0,as(230,ak|0)|0);if(x){x=0;P=111;break}c[n+8>>2]=ao;c[n>>2]=ak|1;c[n+4>>2]=al;an=ao}Kb(an|0,am|0,al)|0;a[an+al|0]=0;x=0,ax(64,n|0,9728,22)|0;if(x){x=0;P=111;break}c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;x=0;aP(466,b|0,n|0,r|0);if(x){x=0;ao=bQ(-1,-1)|0;ak=ao;ao=K;if((a[ai]&1)==0){ar=ak;at=ao;break}J2(c[n+8>>2]|0);ar=ak;at=ao;break}if((a[ai]&1)!=0){J2(c[n+8>>2]|0)}if((a[ae]&1)!=0){J2(c[o+8>>2]|0)}if((a[ac]&1)!=0){J2(c[p+8>>2]|0)}if((a[G]&1)==0){break L81}J2(c[q+8>>2]|0);break L81}}while(0);if((P|0)==111){aj=bQ(-1,-1)|0;ao=K;if((a[ai]&1)!=0){J2(c[n+8>>2]|0)}ar=aj;at=ao}if((a[ae]&1)==0){au=ar;av=at;break}J2(c[o+8>>2]|0);au=ar;av=at}else{x=0;ao=bQ(-1,-1)|0;au=ao;av=K}}while(0);if((a[ac]&1)==0){aw=au;ay=av;break}J2(c[p+8>>2]|0);aw=au;ay=av}}while(0);if((P|0)==94){ab=bQ(-1,-1)|0;ao=K;if((a[ac]&1)!=0){J2(c[p+8>>2]|0)}aw=ab;ay=ao}if((a[G]&1)==0){az=aw;aA=ay;break L78}J2(c[q+8>>2]|0);az=aw;aA=ay;break L78}}while(0);Y=bQ(-1,-1)|0;Z=K;if((a[G]&1)==0){aB=Z;aC=Y;P=123;break L78}J2(c[q+8>>2]|0);aB=Z;aC=Y;P=123;break L78}}while(0);M=b+4|0;do{if((y|0)==0){c[s>>2]=1;E=b+8|0;Y=c[E>>2]|0;if((Y|0)==(c[b+12>>2]|0)){x=0;aq(74,M|0,s|0);if(!x){break}else{x=0;P=122;break L78}}if((Y|0)==0){aD=0}else{c[Y>>2]=1;aD=c[E>>2]|0}c[E>>2]=aD+4}else{c[t>>2]=2;E=b+8|0;Y=c[E>>2]|0;if((Y|0)==(c[b+12>>2]|0)){x=0;aq(74,M|0,t|0);if(!x){break}else{x=0;P=122;break L78}}if((Y|0)==0){aE=0}else{c[Y>>2]=2;aE=c[E>>2]|0}c[E>>2]=aE+4}}while(0);M=(x=0,as(228,b|0)|0);if(x){x=0;P=122;break}E=b+8|0;c[E>>2]=(c[E>>2]|0)-4;E=c[b>>2]|0;Y=(x=0,as(230,72)|0);if(x){x=0;P=122;break}Z=Y;c[e>>2]=Z;Y=E+4|0;_=c[Y>>2]|0;if((_|0)==(c[E+8>>2]|0)){x=0;aq(376,E|0,e|0);if(x){x=0;P=122;break}aF=c[e>>2]|0}else{if((_|0)==0){aH=0}else{c[_>>2]=Z;aH=c[Y>>2]|0}c[Y>>2]=aH+4;aF=Z}Z=aF;_=aF;D=b+28|0;L199:do{if((a[D]&1)==0){ao=u;c[ao>>2]=c[D>>2];c[ao+4>>2]=c[D+4>>2];c[ao+8>>2]=c[D+8>>2];P=164}else{ao=c[b+36>>2]|0;ab=c[b+32>>2]|0;do{if(ab>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ab>>>0<11>>>0){a[u]=ab<<1;aI=u+1|0}else{aj=ab+16&-16;ak=(x=0,as(230,aj|0)|0);if(x){x=0;break}c[u+8>>2]=ak;c[u>>2]=aj|1;c[u+4>>2]=ab;aI=ak}Kb(aI|0,ao|0,ab)|0;a[aI+ab|0]=0;P=164;break L199}}while(0);ab=bQ(-1,-1)|0;aJ=ab;aK=K}}while(0);do{if((P|0)==164){D=v;c[D>>2]=c[H>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];ab=l;ao=(a[ab]&1)==0;L214:do{if(ao){G=w;c[G>>2]=c[ab>>2];c[G+4>>2]=c[ab+4>>2];c[G+8>>2]=c[ab+8>>2];P=174}else{G=c[l+8>>2]|0;ak=c[l+4>>2]|0;do{if(ak>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ak>>>0<11>>>0){a[w]=ak<<1;aL=w+1|0}else{aj=ak+16&-16;aM=(x=0,as(230,aj|0)|0);if(x){x=0;break}c[w+8>>2]=aM;c[w>>2]=aj|1;c[w+4>>2]=ak;aL=aM}Kb(aL|0,G|0,ak)|0;a[aL+ak|0]=0;P=174;break L214}}while(0);ak=bQ(-1,-1)|0;aN=ak;aO=K}}while(0);do{if((P|0)==174){ab=f;c[ab>>2]=c[D>>2];c[ab+4>>2]=c[D+4>>2];c[ab+8>>2]=c[D+8>>2];x=0;aG(4,_|0,u|0,f|0,w|0,A|0,M|0,y|0);if(x){x=0;ab=bQ(-1,-1)|0;ak=ab;ab=K;if((a[w]&1)==0){aN=ak;aO=ab;break}J2(c[w+8>>2]|0);aN=ak;aO=ab;break}if((a[w]&1)!=0){J2(c[w+8>>2]|0)}if((a[u]&1)!=0){J2(c[u+8>>2]|0)}if(!ao){J2(c[l+8>>2]|0)}if((a[g]&1)==0){i=d;return _|0}J2(c[g+8>>2]|0);i=d;return _|0}}while(0);if((a[u]&1)==0){aJ=aN;aK=aO;break}J2(c[u+8>>2]|0);aJ=aN;aK=aO}}while(0);_=c[E>>2]|0;M=c[Y>>2]|0;ao=_;while(1){if((ao|0)==(M|0)){aQ=M;break}if((c[ao>>2]|0)==(aF|0)){aQ=ao;break}else{ao=ao+4|0}}ao=aQ-_>>2;E=_+(ao+1<<2)|0;D=M-E|0;Kc(_+(ao<<2)|0,E|0,D|0)|0;E=_+((D>>2)+ao<<2)|0;ao=c[Y>>2]|0;if((E|0)!=(ao|0)){c[Y>>2]=ao+(~((ao-4+(-E|0)|0)>>>2)<<2)}J2(Z);az=aJ;aA=aK}else{x=0;P=122}}while(0);if((P|0)==122){A=bQ(-1,-1)|0;aB=K;aC=A;P=123}if((P|0)==123){az=aC;aA=aB}if((a[l]&1)==0){T=az;U=aA;break}J2(c[l+8>>2]|0);T=az;U=aA}else{x=0;P=47}}while(0);if((P|0)==47){aA=bQ(-1,-1)|0;V=K;W=aA;P=48}if((P|0)==48){T=W;U=V}if((a[g]&1)==0){aR=T;aS=0;aT=aR;aU=U;be(aT|0)}J2(c[g+8>>2]|0);aR=T;aS=0;aT=aR;aU=U;be(aT|0);return 0}function r6(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0;d=i;i=i+152|0;e=d|0;f=d+16|0;g=d+24|0;h=d+56|0;j=d+72|0;k=d+88|0;l=d+104|0;m=d+120|0;n=d+136|0;st(b)|0;o=b+56|0;p=c[o>>2]|0;q=(c[b+60>>2]|0)-p|0;if(q>>>0>4294967279>>>0){CJ(0);return 0}if(q>>>0<11>>>0){r=q<<1&255;a[g]=r;s=g+1|0;t=r}else{r=q+16&-16;u=J0(r)|0;c[g+8>>2]=u;v=r|1;c[g>>2]=v;c[g+4>>2]=q;s=u;t=v&255}Kb(s|0,p|0,q)|0;a[s+q|0]=0;q=d+40|0;s=b+44|0;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];s=b+20|0;p=(x=0,as(60,c[s>>2]|0)|0);L8:do{if(!x){v=(a[p]|0)==58?p+1|0:0;L10:do{if((v|0)==0){u=j;Ke(u|0,0,12)|0;r=g;w=t&255;if((w&1|0)==0){y=w>>>1}else{y=c[g+4>>2]|0}w=y+19|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(w>>>0<11>>>0){a[u]=38;z=j+1|0}else{A=y+35&-16;B=(x=0,as(230,A|0)|0);if(x){x=0;break}c[j+8>>2]=B;c[j>>2]=A|1;c[j+4>>2]=19;z=B}Kb(z|0,9256,19)|0;a[z+19|0]=0;if((t&1)==0){C=r+1|0}else{C=c[g+8>>2]|0}x=0,ax(64,j|0,C|0,y|0)|0;if(x){x=0;break}B=h;Ke(B|0,0,12)|0;A=a[u]|0;D=A&255;if((D&1|0)==0){E=D>>>1}else{E=c[j+4>>2]|0}if((A&1)==0){F=j+1|0}else{F=c[j+8>>2]|0}A=E+24|0;do{if(A>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;G=48;break}return 0}else{if(A>>>0<11>>>0){a[B]=E<<1;H=h+1|0}else{D=E+40&-16;I=(x=0,as(230,D|0)|0);if(x){x=0;G=48;break}c[h+8>>2]=I;c[h>>2]=D|1;c[h+4>>2]=E;H=I}Kb(H|0,F|0,E)|0;a[H+E|0]=0;x=0,ax(64,h|0,9184,24)|0;if(x){x=0;G=48;break}c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;x=0;aP(466,b|0,h|0,k|0);if(x){x=0;I=bQ(-1,-1)|0;D=I;I=K;if((a[B]&1)==0){J=D;L=I;break}J2(c[h+8>>2]|0);J=D;L=I;break}if((a[B]&1)!=0){J2(c[h+8>>2]|0)}if((a[u]&1)==0){break L10}J2(c[j+8>>2]|0);break L10}}while(0);if((G|0)==48){A=bQ(-1,-1)|0;I=K;if((a[B]&1)!=0){J2(c[h+8>>2]|0)}J=A;L=I}if((a[u]&1)==0){M=J;N=L;break L8}J2(c[j+8>>2]|0);M=J;N=L;break L8}}while(0);r=bQ(-1,-1)|0;w=K;if((a[u]&1)==0){O=w;P=r;G=56;break L8}J2(c[j+8>>2]|0);O=w;P=r;G=56;break L8}else{r=b+48|0;w=c[r>>2]|0;I=c[s>>2]|0;L12:do{if(I>>>0<v>>>0){A=I;D=0;while(1){Q=a[A]|0;if((Q<<24>>24|0)==10){R=D+1|0}else if((Q<<24>>24|0)==0){S=D;break L12}else{R=D}Q=A+1|0;if(Q>>>0<v>>>0){A=Q;D=R}else{S=R;break}}}else{S=0}}while(0);c[r>>2]=S+w;u=p;D=0;while(1){A=u-1|0;if(A>>>0<I>>>0){break}if((a[A]|0)==10){break}else{u=A;D=D+1|0}}u=b+40|0;if((S|0)!=0){c[u>>2]=1}I=c[u>>2]|0;c[b+52>>2]=I+D;w=v;r=p;c[u>>2]=w-r+D+I;I=o;c[I>>2]=r;c[I+4>>2]=w;c[s>>2]=v}}while(0);v=(x=0,as(158,b|0)|0);if(x){x=0;G=55;break}a[v+28|0]=0;w=(x=0,as(216,b|0)|0);if(x){x=0;G=55;break}I=(w|0)!=0;w=c[b>>2]|0;r=(x=0,as(230,48)|0);if(x){x=0;G=55;break}u=r;c[f>>2]=u;r=w+4|0;A=c[r>>2]|0;if((A|0)==(c[w+8>>2]|0)){x=0;aq(376,w|0,f|0);if(x){x=0;G=55;break}T=c[f>>2]|0}else{if((A|0)==0){U=0}else{c[A>>2]=u;U=c[r>>2]|0}c[r>>2]=U+4;T=u}u=T;A=T;B=b+28|0;L92:do{if((a[B]&1)==0){Q=l;c[Q>>2]=c[B>>2];c[Q+4>>2]=c[B+4>>2];c[Q+8>>2]=c[B+8>>2];G=81}else{Q=c[b+36>>2]|0;V=c[b+32>>2]|0;do{if(V>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(V>>>0<11>>>0){a[l]=V<<1;W=l+1|0}else{X=V+16&-16;Y=(x=0,as(230,X|0)|0);if(x){x=0;break}c[l+8>>2]=Y;c[l>>2]=X|1;c[l+4>>2]=V;W=Y}Kb(W|0,Q|0,V)|0;a[W+V|0]=0;G=81;break L92}}while(0);V=bQ(-1,-1)|0;Z=V;_=K}}while(0);do{if((G|0)==81){B=m;c[B>>2]=c[q>>2];c[B+4>>2]=c[q+4>>2];c[B+8>>2]=c[q+8>>2];V=g;Q=(a[V]&1)==0;L107:do{if(Q){D=n;c[D>>2]=c[V>>2];c[D+4>>2]=c[V+4>>2];c[D+8>>2]=c[V+8>>2];G=91}else{D=c[g+8>>2]|0;Y=c[g+4>>2]|0;do{if(Y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(Y>>>0<11>>>0){a[n]=Y<<1;$=n+1|0}else{X=Y+16&-16;aa=(x=0,as(230,X|0)|0);if(x){x=0;break}c[n+8>>2]=aa;c[n>>2]=X|1;c[n+4>>2]=Y;$=aa}Kb($|0,D|0,Y)|0;a[$+Y|0]=0;G=91;break L107}}while(0);Y=bQ(-1,-1)|0;ab=Y;ac=K}}while(0);do{if((G|0)==91){V=e;c[V>>2]=c[B>>2];c[V+4>>2]=c[B+4>>2];c[V+8>>2]=c[B+8>>2];x=0;aB(16,A|0,l|0,e|0,n|0,v|0,I|0);if(x){x=0;V=bQ(-1,-1)|0;Y=V;V=K;if((a[n]&1)==0){ab=Y;ac=V;break}J2(c[n+8>>2]|0);ab=Y;ac=V;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}if(Q){i=d;return A|0}J2(c[g+8>>2]|0);i=d;return A|0}}while(0);if((a[l]&1)==0){Z=ab;_=ac;break}J2(c[l+8>>2]|0);Z=ab;_=ac}}while(0);A=c[w>>2]|0;I=c[r>>2]|0;v=A;while(1){if((v|0)==(I|0)){ad=I;break}if((c[v>>2]|0)==(T|0)){ad=v;break}else{v=v+4|0}}v=ad-A>>2;w=A+(v+1<<2)|0;Q=I-w|0;Kc(A+(v<<2)|0,w|0,Q|0)|0;w=A+((Q>>2)+v<<2)|0;v=c[r>>2]|0;if((w|0)!=(v|0)){c[r>>2]=v+(~((v-4+(-w|0)|0)>>>2)<<2)}J2(u);M=Z;N=_}else{x=0;G=55}}while(0);if((G|0)==55){_=bQ(-1,-1)|0;O=K;P=_;G=56}if((G|0)==56){M=P;N=O}if((a[g]&1)==0){ae=M;af=0;ag=ae;ah=N;be(ag|0)}J2(c[g+8>>2]|0);ae=M;af=0;ag=ae;ah=N;be(ag|0);return 0}function r7(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=i;i=i+112|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+48|0;k=d+64|0;l=d+80|0;m=d+96|0;n=b+20|0;o=xP(c[n>>2]|0)|0;p=(a[o]|0)==42?o+1|0:0;q=(p|0)!=0?p:o;do{if((q|0)==0){r=4}else{if((xR(q)|0)==0){r=4;break}s=sA(b)|0;t=b|0}}while(0);L4:do{if((r|0)==4){sB(b)|0;q=b|0;o=c[q>>2]|0;p=J0(52)|0;c[g>>2]=p;u=o+4|0;v=c[u>>2]|0;if((v|0)==(c[o+8>>2]|0)){ee(o|0,g);w=c[g>>2]|0}else{if((v|0)==0){y=0}else{c[v>>2]=p;y=c[u>>2]|0}c[u>>2]=y+4;w=p}p=w;v=b+28|0;L13:do{if((a[v]&1)==0){z=h;c[z>>2]=c[v>>2];c[z+4>>2]=c[v+4>>2];c[z+8>>2]=c[v+8>>2];r=19}else{z=c[b+36>>2]|0;A=c[b+32>>2]|0;do{if(A>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(A>>>0<11>>>0){a[h]=A<<1;B=h+1|0}else{C=A+16&-16;D=(x=0,as(230,C|0)|0);if(x){x=0;break}c[h+8>>2]=D;c[h>>2]=C|1;c[h+4>>2]=A;B=D}Kb(B|0,z|0,A)|0;a[B+A|0]=0;r=19;break L13}}while(0);A=bQ(-1,-1)|0;E=K;F=A}}while(0);do{if((r|0)==19){v=b+44|0;A=f;c[A>>2]=c[v>>2];c[A+4>>2]=c[v+4>>2];c[A+8>>2]=c[v+8>>2];x=0;ao(14,w|0,h|0,f|0,b+56|0,0);if(!x){v=w;if((a[h]&1)==0){s=v;t=q;break L4}J2(c[h+8>>2]|0);s=v;t=q;break L4}else{x=0;v=bQ(-1,-1)|0;A=v;v=K;if((a[h]&1)==0){E=v;F=A;break}J2(c[h+8>>2]|0);E=v;F=A;break}}}while(0);q=c[o>>2]|0;A=c[u>>2]|0;v=q;while(1){if((v|0)==(A|0)){G=A;break}if((c[v>>2]|0)==(w|0)){G=v;break}else{v=v+4|0}}v=G-q>>2;o=q+(v+1<<2)|0;z=A-o|0;Kc(q+(v<<2)|0,o|0,z|0)|0;o=q+((z>>2)+v<<2)|0;v=c[u>>2]|0;if((o|0)!=(v|0)){c[u>>2]=v+(~((v-4+(-o|0)|0)>>>2)<<2)}J2(p);H=E;I=F;J=I;L=0;M=J;N=H;be(M|0)}}while(0);F=c[t>>2]|0;t=J0(36)|0;c[e>>2]=t;E=F+4|0;G=c[E>>2]|0;if((G|0)==(c[F+8>>2]|0)){ee(F|0,e);O=c[e>>2]|0}else{if((G|0)==0){P=0}else{c[G>>2]=t;P=c[E>>2]|0}c[E>>2]=P+4;O=t}t=O;P=O;G=b+28|0;L50:do{if((a[G]&1)==0){e=j;c[e>>2]=c[G>>2];c[e+4>>2]=c[G+4>>2];c[e+8>>2]=c[G+8>>2];r=46}else{e=c[b+36>>2]|0;w=c[b+32>>2]|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(w>>>0<11>>>0){a[j]=w<<1;Q=j+1|0}else{h=w+16&-16;f=(x=0,as(230,h|0)|0);if(x){x=0;break}c[j+8>>2]=f;c[j>>2]=h|1;c[j+4>>2]=w;Q=f}Kb(Q|0,e|0,w)|0;a[Q+w|0]=0;r=46;break L50}}while(0);w=bQ(-1,-1)|0;R=K;S=w}}while(0);do{if((r|0)==46){Q=k;G=b+44|0;c[Q>>2]=c[G>>2];c[Q+4>>2]=c[G+4>>2];c[Q+8>>2]=c[G+8>>2];x=0;ao(12,P|0,j|0,k|0,s|0,0);if(x){x=0;G=bQ(-1,-1)|0;Q=G;G=K;if((a[j]&1)==0){R=G;S=Q;break}J2(c[j+8>>2]|0);R=G;S=Q;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}Q=xP(c[n>>2]|0)|0;G=(a[Q]|0)==58?Q+1|0:0;if((G|0)==0){T=c[n>>2]|0}else{w=b+48|0;e=c[w>>2]|0;p=c[n>>2]|0;L75:do{if(p>>>0<G>>>0){u=p;q=0;while(1){A=a[u]|0;if((A<<24>>24|0)==10){U=q+1|0}else if((A<<24>>24|0)==0){V=q;break L75}else{U=q}A=u+1|0;if(A>>>0<G>>>0){u=A;q=U}else{V=U;break}}}else{V=0}}while(0);c[w>>2]=V+e;q=Q;u=0;while(1){A=q-1|0;if(A>>>0<p>>>0){break}if((a[A]|0)==10){break}else{q=A;u=u+1|0}}q=b+40|0;if((V|0)!=0){c[q>>2]=1}p=c[q>>2]|0;c[b+52>>2]=p+u;e=G;w=Q;c[q>>2]=e-w+u+p;p=b+56|0;c[p>>2]=w;c[p+4>>2]=e;c[n>>2]=G;T=G}e=xP(T)|0;if(!((e+1|0)==0|(a[e]|0)!=123)){W=sr(b)|0;X=O+28|0;Y=W;c[X>>2]=Y;i=d;return P|0}e=J0(48)|0;p=l+8|0;c[p>>2]=e;c[l>>2]=49;c[l+4>>2]=40;Kb(e|0,9024,40)|0;a[e+40|0]=0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;x=0;aP(466,b|0,l|0,m|0);if(!x){if((a[l]&1)==0){W=sr(b)|0;X=O+28|0;Y=W;c[X>>2]=Y;i=d;return P|0}J2(c[p>>2]|0);W=sr(b)|0;X=O+28|0;Y=W;c[X>>2]=Y;i=d;return P|0}else{x=0;e=bQ(-1,-1)|0;w=e;e=K;if((a[l]&1)==0){H=e;I=w;J=I;L=0;M=J;N=H;be(M|0)}J2(c[p>>2]|0);H=e;I=w;J=I;L=0;M=J;N=H;be(M|0)}}}while(0);l=c[F>>2]|0;F=c[E>>2]|0;P=l;while(1){if((P|0)==(F|0)){Z=F;break}if((c[P>>2]|0)==(O|0)){Z=P;break}else{P=P+4|0}}P=Z-l>>2;Z=l+(P+1<<2)|0;O=F-Z|0;Kc(l+(P<<2)|0,Z|0,O|0)|0;Z=l+((O>>2)+P<<2)|0;P=c[E>>2]|0;if((Z|0)!=(P|0)){c[E>>2]=P+(~((P-4+(-Z|0)|0)>>>2)<<2)}J2(t);H=R;I=S;J=I;L=0;M=J;N=H;be(M|0);return 0}function r8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=i;i=i+136|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+56|0;k=d+72|0;l=d+88|0;m=d+104|0;n=d+120|0;sw(b)|0;do{if((sp(b)|0)==0){o=J0(48)|0;p=g+8|0;c[p>>2]=o;c[g>>2]=49;c[g+4>>2]=34;Kb(o|0,9344,34)|0;a[o+34|0]=0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;x=0;aP(466,b|0,g|0,h|0);if(!x){if((a[g]&1)==0){break}J2(c[p>>2]|0);break}else{x=0}o=bQ(-1,-1)|0;q=o;o=K;if((a[g]&1)==0){r=q;s=o;t=r;u=0;v=t;w=s;be(v|0)}J2(c[p>>2]|0);r=q;s=o;t=r;u=0;v=t;w=s;be(v|0)}}while(0);g=j;j=b+44|0;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=c[b+56>>2]|0;h=(c[b+60>>2]|0)-j|0;if(h>>>0>4294967279>>>0){CJ(0);return 0}if(h>>>0<11>>>0){o=h<<1&255;a[k]=o;y=k+1|0;z=o}else{o=h+16&-16;q=J0(o)|0;c[k+8>>2]=q;p=o|1;c[k>>2]=p;c[k+4>>2]=h;y=q;z=p&255}Kb(y|0,j|0,h)|0;a[y+h|0]=0;h=(x=0,as(84,b|0)|0);do{if(!x){y=(x=0,as(60,c[b+20>>2]|0)|0);if(x){x=0;A=16;break}if((y+1|0)==0|(a[y]|0)!=123){B=0}else{y=(x=0,as(228,b|0)|0);if(!x){B=y}else{x=0;A=16;break}}y=c[b>>2]|0;j=(x=0,as(230,48)|0);if(x){x=0;A=16;break}p=j;c[f>>2]=p;j=y+4|0;q=c[j>>2]|0;if((q|0)==(c[y+8>>2]|0)){x=0;aq(376,y|0,f|0);if(x){x=0;A=16;break}C=c[f>>2]|0}else{if((q|0)==0){D=0}else{c[q>>2]=p;D=c[j>>2]|0}c[j>>2]=D+4;C=p}p=C;q=C;o=b+28|0;L34:do{if((a[o]&1)==0){E=l;c[E>>2]=c[o>>2];c[E+4>>2]=c[o+4>>2];c[E+8>>2]=c[o+8>>2];A=34}else{E=c[b+36>>2]|0;F=c[b+32>>2]|0;do{if(F>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(F>>>0<11>>>0){a[l]=F<<1;G=l+1|0}else{H=F+16&-16;I=(x=0,as(230,H|0)|0);if(x){x=0;break}c[l+8>>2]=I;c[l>>2]=H|1;c[l+4>>2]=F;G=I}Kb(G|0,E|0,F)|0;a[G+F|0]=0;A=34;break L34}}while(0);F=bQ(-1,-1)|0;J=F;L=K}}while(0);do{if((A|0)==34){o=m;c[o>>2]=c[g>>2];c[o+4>>2]=c[g+4>>2];c[o+8>>2]=c[g+8>>2];L49:do{if((z&1)==0){F=k;E=n;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];A=44}else{F=c[k+8>>2]|0;E=c[k+4>>2]|0;do{if(E>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(E>>>0<11>>>0){a[n]=E<<1;M=n+1|0}else{I=E+16&-16;H=(x=0,as(230,I|0)|0);if(x){x=0;break}c[n+8>>2]=H;c[n>>2]=I|1;c[n+4>>2]=E;M=H}Kb(M|0,F|0,E)|0;a[M+E|0]=0;A=44;break L49}}while(0);E=bQ(-1,-1)|0;N=E;O=K}}while(0);do{if((A|0)==44){E=e;c[E>>2]=c[o>>2];c[E+4>>2]=c[o+4>>2];c[E+8>>2]=c[o+8>>2];x=0;aB(38,q|0,l|0,e|0,n|0,h|0,B|0);if(x){x=0;E=bQ(-1,-1)|0;F=E;E=K;if((a[n]&1)==0){N=F;O=E;break}J2(c[n+8>>2]|0);N=F;O=E;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}if((z&1)==0){i=d;return q|0}J2(c[k+8>>2]|0);i=d;return q|0}}while(0);if((a[l]&1)==0){J=N;L=O;break}J2(c[l+8>>2]|0);J=N;L=O}}while(0);q=c[y>>2]|0;o=c[j>>2]|0;E=q;while(1){if((E|0)==(o|0)){P=o;break}if((c[E>>2]|0)==(C|0)){P=E;break}else{E=E+4|0}}E=P-q>>2;y=q+(E+1<<2)|0;F=o-y|0;Kc(q+(E<<2)|0,y|0,F|0)|0;y=q+((F>>2)+E<<2)|0;E=c[j>>2]|0;if((y|0)!=(E|0)){c[j>>2]=E+(~((E-4+(-y|0)|0)>>>2)<<2)}J2(p);Q=J;R=L}else{x=0;A=16}}while(0);if((A|0)==16){A=bQ(-1,-1)|0;Q=A;R=K}if((z&1)==0){r=Q;s=R;t=r;u=0;v=t;w=s;be(v|0)}J2(c[k+8>>2]|0);r=Q;s=R;t=r;u=0;v=t;w=s;be(v|0);return 0}function r9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0;e=i;i=i+200|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+64|0;m=e+80|0;n=e+104|0;o=e+120|0;p=e+136|0;q=e+152|0;r=e+168|0;s=e+184|0;if(!((tR(b)|0)!=0|d^1)){tS(b)|0}d=e+88|0;t=b+44|0;c[d>>2]=c[t>>2];c[d+4>>2]=c[t+4>>2];c[d+8>>2]=c[t+8>>2];u=s6(b)|0;a[u+28|0]=0;v=b+20|0;w=xP(c[v>>2]|0)|0;do{if((w+1|0)==0|(a[w]|0)!=123){y=J0(48)|0;z=n+8|0;c[z>>2]=y;c[n>>2]=49;c[n+4>>2]=40;Kb(y|0,3992,40)|0;a[y+40|0]=0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;x=0;aP(466,b|0,n|0,o|0);if(!x){if((a[n]&1)==0){break}J2(c[z>>2]|0);break}else{x=0}y=bQ(-1,-1)|0;A=y;y=K;if((a[n]&1)==0){B=A;C=y;D=B;E=0;F=D;G=C;be(F|0)}J2(c[z>>2]|0);B=A;C=y;D=B;E=0;F=D;G=C;be(F|0)}}while(0);n=sr(b)|0;L15:do{if((tT(b)|0)==0){H=0}else{o=xP(c[v>>2]|0)|0;w=a[35536]|0;L17:do{if(w<<24>>24==0){I=o;J=13}else{y=o;A=35536;z=w;while(1){if((a[y]|0)!=z<<24>>24){break L17}L=y+1|0;M=A+1|0;N=a[M]|0;if(N<<24>>24==0){I=L;J=13;break}else{y=L;A=M;z=N}}}}while(0);do{if((J|0)==13){if((I|0)==0){break}w=c[b>>2]|0;o=J0(48)|0;c[m>>2]=o;z=w+4|0;A=c[z>>2]|0;if((A|0)==(c[w+8>>2]|0)){ee(w|0,m);O=c[m>>2]|0}else{if((A|0)==0){P=0}else{c[A>>2]=o;P=c[z>>2]|0}c[z>>2]=P+4;O=o}o=O;A=O;y=b+28|0;L31:do{if((a[y]&1)==0){N=p;c[N>>2]=c[y>>2];c[N+4>>2]=c[y+4>>2];c[N+8>>2]=c[y+8>>2];J=29}else{N=c[b+36>>2]|0;M=c[b+32>>2]|0;do{if(M>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(M>>>0<11>>>0){a[p]=M<<1;Q=p+1|0}else{L=M+16&-16;R=(x=0,as(230,L|0)|0);if(x){x=0;break}c[p+8>>2]=R;c[p>>2]=L|1;c[p+4>>2]=M;Q=R}Kb(Q|0,N|0,M)|0;a[Q+M|0]=0;J=29;break L31}}while(0);M=bQ(-1,-1)|0;S=M;T=K}}while(0);do{if((J|0)==29){y=l;c[y>>2]=c[t>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];x=0;ao(4,A|0,p|0,l|0,0,0);if(x){x=0;y=bQ(-1,-1)|0;M=y;y=K;if((a[p]&1)==0){S=M;T=y;break}J2(c[p+8>>2]|0);S=M;T=y;break}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}y=O+28|0;M=y;N=r9(b,1)|0;c[k>>2]=N;R=O+36|0;L=R;U=c[L>>2]|0;if((U|0)==(c[O+40>>2]|0)){lM(O+32|0,k);V=c[k>>2]|0}else{if((U|0)==0){W=0}else{c[U>>2]=N;W=c[L>>2]|0}c[R>>2]=W+4;V=N}cy[c[c[y>>2]>>2]&1023](M,V);H=A;break L15}}while(0);A=c[w>>2]|0;M=c[z>>2]|0;y=A;while(1){if((y|0)==(M|0)){X=M;break}if((c[y>>2]|0)==(O|0)){X=y;break}else{y=y+4|0}}y=X-A>>2;w=A+(y+1<<2)|0;N=M-w|0;Kc(A+(y<<2)|0,w|0,N|0)|0;w=A+((N>>2)+y<<2)|0;y=c[z>>2]|0;if((w|0)!=(y|0)){c[z>>2]=y+(~((y-4+(-w|0)|0)>>>2)<<2)}J2(o);B=S;C=T;D=B;E=0;F=D;G=C;be(F|0)}}while(0);w=xP(c[v>>2]|0)|0;if(!((w+1|0)==0|(a[w]|0)!=123)){H=sr(b)|0;break}w=J0(32)|0;y=q+8|0;c[y>>2]=w;c[q>>2]=33;c[q+4>>2]=24;Kb(w|0,3760,24)|0;a[w+24|0]=0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;x=0;aP(466,b|0,q|0,r|0);if(!x){if((a[q]&1)==0){H=0;break}J2(c[y>>2]|0);H=0;break}else{x=0}w=bQ(-1,-1)|0;N=w;w=K;if((a[q]&1)==0){B=N;C=w;D=B;E=0;F=D;G=C;be(F|0)}J2(c[y>>2]|0);B=N;C=w;D=B;E=0;F=D;G=C;be(F|0)}}while(0);q=c[b>>2]|0;r=J0(40)|0;c[j>>2]=r;v=q+4|0;T=c[v>>2]|0;if((T|0)==(c[q+8>>2]|0)){ee(q|0,j);Y=c[j>>2]|0}else{if((T|0)==0){Z=0}else{c[T>>2]=r;Z=c[v>>2]|0}c[v>>2]=Z+4;Y=r}r=Y;Z=Y;T=b+28|0;L89:do{if((a[T]&1)==0){j=s;c[j>>2]=c[T>>2];c[j+4>>2]=c[T+4>>2];c[j+8>>2]=c[T+8>>2];_=a[j]|0;$=j;J=69}else{j=c[b+36>>2]|0;S=c[b+32>>2]|0;do{if(S>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(S>>>0<11>>>0){X=S<<1&255;O=s;a[O]=X;aa=s+1|0;ab=X;ac=O}else{O=S+16&-16;X=(x=0,as(230,O|0)|0);if(x){x=0;break}c[s+8>>2]=X;V=O|1;c[s>>2]=V;c[s+4>>2]=S;aa=X;ab=V&255;ac=s}Kb(aa|0,j|0,S)|0;a[aa+S|0]=0;_=ab;$=ac;J=69;break L89}}while(0);S=bQ(-1,-1)|0;ad=S;ae=K}}while(0);do{if((J|0)==69){ac=h;c[ac>>2]=c[d>>2];c[ac+4>>2]=c[d+4>>2];c[ac+8>>2]=c[d+8>>2];ac=h;ab=f;aa=g;b=Y;L104:do{if((_&1)==0){c[ab>>2]=c[$>>2];c[ab+4>>2]=c[$+4>>2];c[ab+8>>2]=c[$+8>>2];J=79}else{T=c[s+8>>2]|0;S=c[s+4>>2]|0;do{if(S>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(S>>>0<11>>>0){a[ab]=S<<1;af=f+1|0}else{j=S+16&-16;V=(x=0,as(230,j|0)|0);if(x){x=0;break}c[f+8>>2]=V;c[f>>2]=j|1;c[f+4>>2]=S;af=V}Kb(af|0,T|0,S)|0;a[af+S|0]=0;J=79;break L104}}while(0);S=bQ(-1,-1)|0;ag=K;ah=S}}while(0);do{if((J|0)==79){c[aa>>2]=c[ac>>2];c[aa+4>>2]=c[ac+4>>2];c[aa+8>>2]=c[ac+8>>2];x=0;aP(402,b|0,f|0,g|0);if(x){x=0;S=bQ(-1,-1)|0;T=K;if((a[ab]&1)==0){ag=T;ah=S;break}J2(c[f+8>>2]|0);ag=T;ah=S;break}if((a[ab]&1)!=0){J2(c[f+8>>2]|0)}c[Y>>2]=19144;c[Y+28>>2]=u;c[Y+32>>2]=n;c[Y+36>>2]=H;if((a[$]&1)==0){i=e;return Z|0}J2(c[s+8>>2]|0);i=e;return Z|0}}while(0);ab=ah;b=ag;if((a[$]&1)==0){ad=ab;ae=b;break}J2(c[s+8>>2]|0);ad=ab;ae=b}}while(0);s=c[q>>2]|0;q=c[v>>2]|0;$=s;while(1){if(($|0)==(q|0)){ai=q;break}if((c[$>>2]|0)==(Y|0)){ai=$;break}else{$=$+4|0}}$=ai-s>>2;ai=s+($+1<<2)|0;Y=q-ai|0;Kc(s+($<<2)|0,ai|0,Y|0)|0;ai=s+((Y>>2)+$<<2)|0;$=c[v>>2]|0;if((ai|0)!=($|0)){c[v>>2]=$+(~(($-4+(-ai|0)|0)>>>2)<<2)}J2(r);B=ad;C=ae;D=B;E=0;F=D;G=C;be(F|0);return 0}function sa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+232|0;e=d|0;f=d+16|0;g=d+40|0;h=d+56|0;j=d+72|0;k=d+88|0;l=d+104|0;m=d+120|0;n=d+136|0;o=d+152|0;p=d+168|0;q=d+184|0;r=d+200|0;s=d+216|0;tU(b)|0;t=d+24|0;u=b+44|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];do{if((st(b)|0)==0){u=J0(48)|0;v=g+8|0;c[v>>2]=u;c[g>>2]=49;c[g+4>>2]=45;Kb(u|0,3592,45)|0;a[u+45|0]=0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;x=0;aP(466,b|0,g|0,h|0);if(!x){if((a[g]&1)==0){break}J2(c[v>>2]|0);break}else{x=0}u=bQ(-1,-1)|0;w=u;u=K;if((a[g]&1)==0){y=w;z=u;A=y;B=0;C=A;D=z;be(C|0)}J2(c[v>>2]|0);y=w;z=u;A=y;B=0;C=A;D=z;be(C|0)}}while(0);g=c[b+56>>2]|0;h=(c[b+60>>2]|0)-g|0;if(h>>>0>4294967279>>>0){CJ(0);return 0}if(h>>>0<11>>>0){u=h<<1&255;a[j]=u;E=j+1|0;F=u}else{u=h+16&-16;w=J0(u)|0;c[j+8>>2]=w;v=u|1;c[j>>2]=v;c[j+4>>2]=h;E=w;F=v&255}Kb(E|0,g|0,h)|0;a[E+h|0]=0;h=(x=0,as(182,b|0)|0);L19:do{if(!x){do{if((h|0)==0){E=(x=0,as(230,48)|0);if(x){x=0;G=18;break L19}g=k+8|0;c[g>>2]=E;c[k>>2]=49;c[k+4>>2]=41;Kb(E|0,3456,41)|0;a[E+41|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;x=0;aP(466,b|0,k|0,l|0);if(!x){if((a[k]&1)==0){break}J2(c[g>>2]|0);break}else{x=0;E=bQ(-1,-1)|0;v=E;E=K;if((a[k]&1)==0){H=v;I=E;break L19}J2(c[g>>2]|0);H=v;I=E;break L19}}}while(0);E=(x=0,as(186,b|0)|0);if(x){x=0;G=18;break}a[E+28|0]=0;v=(x=0,as(264,b|0)|0);if(x){x=0;G=18;break}do{if((v|0)==0){g=(x=0,as(178,b|0)|0);if(x){x=0;G=18;break L19}if((g|0)!=0){J=0;break}g=(x=0,as(230,64)|0);if(x){x=0;G=18;break L19}w=m+8|0;c[w>>2]=g;c[m>>2]=65;c[m+4>>2]=51;Kb(g|0,3328,51)|0;a[g+51|0]=0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;x=0;aP(466,b|0,m|0,n|0);if(!x){if((a[m]&1)==0){J=0;break}J2(c[w>>2]|0);J=0;break}else{x=0;g=bQ(-1,-1)|0;u=g;g=K;if((a[m]&1)==0){H=u;I=g;break L19}J2(c[w>>2]|0);H=u;I=g;break L19}}else{J=1}}while(0);v=(x=0,as(186,b|0)|0);if(x){x=0;G=18;break}a[v+28|0]=0;g=(x=0,as(60,c[b+20>>2]|0)|0);if(x){x=0;G=18;break}do{if((g+1|0)==0|(a[g]|0)!=123){u=(x=0,as(230,64)|0);if(x){x=0;G=18;break L19}w=o+8|0;c[w>>2]=u;c[o>>2]=65;c[o+4>>2]=52;Kb(u|0,3200,52)|0;a[u+52|0]=0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;x=0;aP(466,b|0,o|0,p|0);if(!x){if((a[o]&1)==0){break}J2(c[w>>2]|0);break}else{x=0;u=bQ(-1,-1)|0;L=u;u=K;if((a[o]&1)==0){H=L;I=u;break L19}J2(c[w>>2]|0);H=L;I=u;break L19}}}while(0);g=(x=0,as(228,b|0)|0);if(x){x=0;G=18;break}u=c[b>>2]|0;L=(x=0,as(230,56)|0);if(x){x=0;G=18;break}w=L;c[f>>2]=w;L=u+4|0;M=c[L>>2]|0;if((M|0)==(c[u+8>>2]|0)){x=0;aq(376,u|0,f|0);if(x){x=0;G=18;break}N=c[f>>2]|0}else{if((M|0)==0){O=0}else{c[M>>2]=w;O=c[L>>2]|0}c[L>>2]=O+4;N=w}w=N;M=N;P=b+28|0;L64:do{if((a[P]&1)==0){Q=q;c[Q>>2]=c[P>>2];c[Q+4>>2]=c[P+4>>2];c[Q+8>>2]=c[P+8>>2];G=59}else{Q=c[b+36>>2]|0;R=c[b+32>>2]|0;do{if(R>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(R>>>0<11>>>0){a[q]=R<<1;S=q+1|0}else{T=R+16&-16;U=(x=0,as(230,T|0)|0);if(x){x=0;break}c[q+8>>2]=U;c[q>>2]=T|1;c[q+4>>2]=R;S=U}Kb(S|0,Q|0,R)|0;a[S+R|0]=0;G=59;break L64}}while(0);R=bQ(-1,-1)|0;V=R;W=K}}while(0);do{if((G|0)==59){P=r;c[P>>2]=c[t>>2];c[P+4>>2]=c[t+4>>2];c[P+8>>2]=c[t+8>>2];L79:do{if((F&1)==0){R=j;Q=s;c[Q>>2]=c[R>>2];c[Q+4>>2]=c[R+4>>2];c[Q+8>>2]=c[R+8>>2];G=69}else{R=c[j+8>>2]|0;Q=c[j+4>>2]|0;do{if(Q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(Q>>>0<11>>>0){a[s]=Q<<1;X=s+1|0}else{U=Q+16&-16;T=(x=0,as(230,U|0)|0);if(x){x=0;break}c[s+8>>2]=T;c[s>>2]=U|1;c[s+4>>2]=Q;X=T}Kb(X|0,R|0,Q)|0;a[X+Q|0]=0;G=69;break L79}}while(0);Q=bQ(-1,-1)|0;Y=Q;Z=K}}while(0);do{if((G|0)==69){Q=e;c[Q>>2]=c[P>>2];c[Q+4>>2]=c[P+4>>2];c[Q+8>>2]=c[P+8>>2];x=0;aA(4,M|0,q|0,e|0,s|0,E|0,v|0,g|0,J|0);if(x){x=0;Q=bQ(-1,-1)|0;R=Q;Q=K;if((a[s]&1)==0){Y=R;Z=Q;break}J2(c[s+8>>2]|0);Y=R;Z=Q;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((F&1)==0){i=d;return M|0}J2(c[j+8>>2]|0);i=d;return M|0}}while(0);if((a[q]&1)==0){V=Y;W=Z;break}J2(c[q+8>>2]|0);V=Y;W=Z}}while(0);M=c[u>>2]|0;g=c[L>>2]|0;v=M;while(1){if((v|0)==(g|0)){_=g;break}if((c[v>>2]|0)==(N|0)){_=v;break}else{v=v+4|0}}v=_-M>>2;u=M+(v+1<<2)|0;E=g-u|0;Kc(M+(v<<2)|0,u|0,E|0)|0;u=M+((E>>2)+v<<2)|0;v=c[L>>2]|0;if((u|0)!=(v|0)){c[L>>2]=v+(~((v-4+(-u|0)|0)>>>2)<<2)}J2(w);H=V;I=W}else{x=0;G=18}}while(0);if((G|0)==18){G=bQ(-1,-1)|0;H=G;I=K}if((F&1)==0){y=H;z=I;A=y;B=0;C=A;D=z;be(C|0)}J2(c[j+8>>2]|0);y=H;z=I;A=y;B=0;C=A;D=z;be(C|0);return 0}function sb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+200|0;e=d|0;f=d+16|0;g=d+40|0;h=d+56|0;j=d+72|0;k=d+88|0;l=d+104|0;m=d+120|0;n=d+136|0;o=d+152|0;p=d+168|0;q=d+184|0;tY(b)|0;r=d+24|0;s=b+44|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];do{if((st(b)|0)==0){s=J0(48)|0;t=g+8|0;c[t>>2]=s;c[g>>2]=49;c[g+4>>2]=46;Kb(s|0,3136,46)|0;a[s+46|0]=0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;x=0;aP(466,b|0,g|0,h|0);if(!x){if((a[g]&1)==0){break}J2(c[t>>2]|0);break}else{x=0}s=bQ(-1,-1)|0;u=s;s=K;if((a[g]&1)==0){v=u;w=s;y=v;z=0;A=y;B=w;be(A|0)}J2(c[t>>2]|0);v=u;w=s;y=v;z=0;A=y;B=w;be(A|0)}}while(0);g=c[b+56>>2]|0;h=(c[b+60>>2]|0)-g|0;if(h>>>0>4294967279>>>0){CJ(0);return 0}if(h>>>0<11>>>0){s=h<<1&255;a[j]=s;C=j+1|0;D=s}else{s=h+16&-16;u=J0(s)|0;c[j+8>>2]=u;t=s|1;c[j>>2]=t;c[j+4>>2]=h;C=u;D=t&255}Kb(C|0,g|0,h)|0;a[C+h|0]=0;h=(x=0,as(142,b|0)|0);L19:do{if(!x){do{if((h|0)==0){C=(x=0,as(230,48)|0);if(x){x=0;E=18;break L19}g=k+8|0;c[g>>2]=C;c[k>>2]=49;c[k+4>>2]=40;Kb(C|0,2984,40)|0;a[C+40|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;x=0;aP(466,b|0,k|0,l|0);if(!x){if((a[k]&1)==0){break}J2(c[g>>2]|0);break}else{x=0;C=bQ(-1,-1)|0;t=C;C=K;if((a[k]&1)==0){F=t;G=C;break L19}J2(c[g>>2]|0);F=t;G=C;break L19}}}while(0);C=(x=0,as(158,b|0)|0);if(x){x=0;E=18;break}a[C+28|0]=0;L31:do{if((c[C+32>>2]|0)==5){t=C+40|0;g=c[t>>2]|0;u=(c[C+44>>2]|0)-g>>2;if((u|0)==0){break}else{H=0;I=g}while(1){a[(c[I+(H<<2)>>2]|0)+28|0]=0;g=H+1|0;if(g>>>0>=u>>>0){break L31}H=g;I=c[t>>2]|0}}}while(0);t=(x=0,as(60,c[b+20>>2]|0)|0);if(x){x=0;E=18;break}do{if((t+1|0)==0|(a[t]|0)!=123){u=(x=0,as(230,64)|0);if(x){x=0;E=18;break L19}g=m+8|0;c[g>>2]=u;c[m>>2]=65;c[m+4>>2]=53;Kb(u|0,2832,53)|0;a[u+53|0]=0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;x=0;aP(466,b|0,m|0,n|0);if(!x){if((a[m]&1)==0){break}J2(c[g>>2]|0);break}else{x=0;u=bQ(-1,-1)|0;s=u;u=K;if((a[m]&1)==0){F=s;G=u;break L19}J2(c[g>>2]|0);F=s;G=u;break L19}}}while(0);t=(x=0,as(228,b|0)|0);if(x){x=0;E=18;break}u=c[b>>2]|0;s=(x=0,as(230,48)|0);if(x){x=0;E=18;break}g=s;c[f>>2]=g;s=u+4|0;J=c[s>>2]|0;if((J|0)==(c[u+8>>2]|0)){x=0;aq(376,u|0,f|0);if(x){x=0;E=18;break}L=c[f>>2]|0}else{if((J|0)==0){M=0}else{c[J>>2]=g;M=c[s>>2]|0}c[s>>2]=M+4;L=g}g=L;J=L;N=b+28|0;L57:do{if((a[N]&1)==0){O=o;c[O>>2]=c[N>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];E=52}else{O=c[b+36>>2]|0;P=c[b+32>>2]|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(P>>>0<11>>>0){a[o]=P<<1;Q=o+1|0}else{R=P+16&-16;S=(x=0,as(230,R|0)|0);if(x){x=0;break}c[o+8>>2]=S;c[o>>2]=R|1;c[o+4>>2]=P;Q=S}Kb(Q|0,O|0,P)|0;a[Q+P|0]=0;E=52;break L57}}while(0);P=bQ(-1,-1)|0;T=P;U=K}}while(0);do{if((E|0)==52){N=p;c[N>>2]=c[r>>2];c[N+4>>2]=c[r+4>>2];c[N+8>>2]=c[r+8>>2];L72:do{if((D&1)==0){P=j;O=q;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];E=62}else{P=c[j+8>>2]|0;O=c[j+4>>2]|0;do{if(O>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(O>>>0<11>>>0){a[q]=O<<1;V=q+1|0}else{S=O+16&-16;R=(x=0,as(230,S|0)|0);if(x){x=0;break}c[q+8>>2]=R;c[q>>2]=S|1;c[q+4>>2]=O;V=R}Kb(V|0,P|0,O)|0;a[V+O|0]=0;E=62;break L72}}while(0);O=bQ(-1,-1)|0;W=O;X=K}}while(0);do{if((E|0)==62){O=e;c[O>>2]=c[N>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];x=0;aB(58,J|0,o|0,e|0,q|0,C|0,t|0);if(x){x=0;O=bQ(-1,-1)|0;P=O;O=K;if((a[q]&1)==0){W=P;X=O;break}J2(c[q+8>>2]|0);W=P;X=O;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((D&1)==0){i=d;return J|0}J2(c[j+8>>2]|0);i=d;return J|0}}while(0);if((a[o]&1)==0){T=W;U=X;break}J2(c[o+8>>2]|0);T=W;U=X}}while(0);J=c[u>>2]|0;t=c[s>>2]|0;C=J;while(1){if((C|0)==(t|0)){Y=t;break}if((c[C>>2]|0)==(L|0)){Y=C;break}else{C=C+4|0}}C=Y-J>>2;u=J+(C+1<<2)|0;N=t-u|0;Kc(J+(C<<2)|0,u|0,N|0)|0;u=J+((N>>2)+C<<2)|0;C=c[s>>2]|0;if((u|0)!=(C|0)){c[s>>2]=C+(~((C-4+(-u|0)|0)>>>2)<<2)}J2(g);F=T;G=U}else{x=0;E=18}}while(0);if((E|0)==18){E=bQ(-1,-1)|0;F=E;G=K}if((D&1)==0){v=F;w=G;y=v;z=0;A=y;B=w;be(A|0)}J2(c[j+8>>2]|0);v=F;w=G;y=v;z=0;A=y;B=w;be(A|0);return 0}function sc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0;d=i;i=i+88|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+72|0;t_(b)|0;k=d+56|0;l=b+44|0;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=s6(b)|0;a[l+28|0]=0;m=sr(b)|0;n=c[b>>2]|0;o=J0(36)|0;c[h>>2]=o;p=n+4|0;q=c[p>>2]|0;if((q|0)==(c[n+8>>2]|0)){ee(n|0,h);r=c[h>>2]|0}else{if((q|0)==0){s=0}else{c[q>>2]=o;s=c[p>>2]|0}c[p>>2]=s+4;r=o}o=r;s=r;q=b+28|0;L8:do{if((a[q]&1)==0){h=j;c[h>>2]=c[q>>2];c[h+4>>2]=c[q+4>>2];c[h+8>>2]=c[q+8>>2];t=a[h]|0;u=h;v=16}else{h=c[b+36>>2]|0;w=c[b+32>>2]|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(w>>>0<11>>>0){y=w<<1&255;z=j;a[z]=y;A=j+1|0;B=y;C=z}else{z=w+16&-16;y=(x=0,as(230,z|0)|0);if(x){x=0;break}c[j+8>>2]=y;D=z|1;c[j>>2]=D;c[j+4>>2]=w;A=y;B=D&255;C=j}Kb(A|0,h|0,w)|0;a[A+w|0]=0;t=B;u=C;v=16;break L8}}while(0);w=bQ(-1,-1)|0;E=K;F=w}}while(0);do{if((v|0)==16){C=g;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[C+8>>2]=c[k+8>>2];C=g;B=e;A=f;b=r;L23:do{if((t&1)==0){c[B>>2]=c[u>>2];c[B+4>>2]=c[u+4>>2];c[B+8>>2]=c[u+8>>2];v=26}else{q=c[j+8>>2]|0;w=c[j+4>>2]|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(w>>>0<11>>>0){a[B]=w<<1;G=e+1|0}else{h=w+16&-16;D=(x=0,as(230,h|0)|0);if(x){x=0;break}c[e+8>>2]=D;c[e>>2]=h|1;c[e+4>>2]=w;G=D}Kb(G|0,q|0,w)|0;a[G+w|0]=0;v=26;break L23}}while(0);w=bQ(-1,-1)|0;H=K;I=w}}while(0);do{if((v|0)==26){c[A>>2]=c[C>>2];c[A+4>>2]=c[C+4>>2];c[A+8>>2]=c[C+8>>2];x=0;aT(6,b|0,e|0,f|0,m|0);if(x){x=0;w=bQ(-1,-1)|0;q=K;if((a[B]&1)==0){H=q;I=w;break}J2(c[e+8>>2]|0);H=q;I=w;break}if((a[B]&1)!=0){J2(c[e+8>>2]|0)}c[r>>2]=18168;c[r+32>>2]=l;if((a[u]&1)==0){i=d;return s|0}J2(c[j+8>>2]|0);i=d;return s|0}}while(0);B=I;b=H;if((a[u]&1)==0){E=b;F=B;break}J2(c[j+8>>2]|0);E=b;F=B}}while(0);j=c[n>>2]|0;n=c[p>>2]|0;u=j;while(1){if((u|0)==(n|0)){J=n;break}if((c[u>>2]|0)==(r|0)){J=u;break}else{u=u+4|0}}u=J-j>>2;J=j+(u+1<<2)|0;r=n-J|0;Kc(j+(u<<2)|0,J|0,r|0)|0;J=j+((r>>2)+u<<2)|0;u=c[p>>2]|0;if((J|0)==(u|0)){J2(o);L=F;M=0;N=L;O=E;be(N|0)}c[p>>2]=u+(~((u-4+(-J|0)|0)>>>2)<<2);J2(o);L=F;M=0;N=L;O=E;be(N|0);return 0}function sd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=i;i=i+120|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+72|0;k=d+88|0;l=d+104|0;t$(b)|0;m=d+56|0;n=b+44|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];n=t0(b)|0;o=xP(c[b+20>>2]|0)|0;do{if((o+1|0)==0|(a[o]|0)!=123){p=J0(32)|0;q=j+8|0;c[q>>2]=p;c[j>>2]=33;c[j+4>>2]=27;Kb(p|0,2744,27)|0;a[p+27|0]=0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;x=0;aP(466,b|0,j|0,k|0);if(!x){if((a[j]&1)==0){break}J2(c[q>>2]|0);break}else{x=0}p=bQ(-1,-1)|0;r=p;p=K;if((a[j]&1)==0){s=r;t=p;u=s;v=0;w=u;y=t;be(w|0)}J2(c[q>>2]|0);s=r;t=p;u=s;v=0;w=u;y=t;be(w|0)}}while(0);j=sr(b)|0;k=c[b>>2]|0;o=J0(40)|0;c[h>>2]=o;p=k+4|0;r=c[p>>2]|0;if((r|0)==(c[k+8>>2]|0)){ee(k|0,h);z=c[h>>2]|0}else{if((r|0)==0){A=0}else{c[r>>2]=o;A=c[p>>2]|0}c[p>>2]=A+4;z=o}o=z;A=z;r=b+28|0;L19:do{if((a[r]&1)==0){h=l;c[h>>2]=c[r>>2];c[h+4>>2]=c[r+4>>2];c[h+8>>2]=c[r+8>>2];B=a[h]|0;C=h;D=22}else{h=c[b+36>>2]|0;q=c[b+32>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){E=q<<1&255;F=l;a[F]=E;G=l+1|0;H=E;I=F}else{F=q+16&-16;E=(x=0,as(230,F|0)|0);if(x){x=0;break}c[l+8>>2]=E;J=F|1;c[l>>2]=J;c[l+4>>2]=q;G=E;H=J&255;I=l}Kb(G|0,h|0,q)|0;a[G+q|0]=0;B=H;C=I;D=22;break L19}}while(0);q=bQ(-1,-1)|0;L=q;M=K}}while(0);do{if((D|0)==22){I=g;c[I>>2]=c[m>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];I=g;H=e;G=f;b=z;L34:do{if((B&1)==0){c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];D=32}else{r=c[l+8>>2]|0;q=c[l+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[H]=q<<1;N=e+1|0}else{h=q+16&-16;J=(x=0,as(230,h|0)|0);if(x){x=0;break}c[e+8>>2]=J;c[e>>2]=h|1;c[e+4>>2]=q;N=J}Kb(N|0,r|0,q)|0;a[N+q|0]=0;D=32;break L34}}while(0);q=bQ(-1,-1)|0;O=K;P=q}}while(0);do{if((D|0)==32){c[G>>2]=c[I>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];x=0;aT(6,b|0,e|0,f|0,j|0);if(x){x=0;q=bQ(-1,-1)|0;r=K;if((a[H]&1)==0){O=r;P=q;break}J2(c[e+8>>2]|0);O=r;P=q;break}if((a[H]&1)!=0){J2(c[e+8>>2]|0)}c[z>>2]=21232;c[z+32>>2]=n;c[z+36>>2]=0;if((a[C]&1)==0){i=d;return A|0}J2(c[l+8>>2]|0);i=d;return A|0}}while(0);H=P;b=O;if((a[C]&1)==0){L=H;M=b;break}J2(c[l+8>>2]|0);L=H;M=b}}while(0);l=c[k>>2]|0;k=c[p>>2]|0;C=l;while(1){if((C|0)==(k|0)){Q=k;break}if((c[C>>2]|0)==(z|0)){Q=C;break}else{C=C+4|0}}C=Q-l>>2;Q=l+(C+1<<2)|0;z=k-Q|0;Kc(l+(C<<2)|0,Q|0,z|0)|0;Q=l+((z>>2)+C<<2)|0;C=c[p>>2]|0;if((Q|0)!=(C|0)){c[p>>2]=C+(~((C-4+(-Q|0)|0)>>>2)<<2)}J2(o);s=L;t=M;u=s;v=0;w=u;y=t;be(w|0);return 0}function se(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0;d=i;i=i+88|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+56|0;k=d+72|0;t8(b)|0;l=c[b>>2]|0;m=J0(32)|0;c[h>>2]=m;n=l+4|0;o=c[n>>2]|0;if((o|0)==(c[l+8>>2]|0)){ee(l|0,h);p=c[h>>2]|0}else{if((o|0)==0){q=0}else{c[o>>2]=m;q=c[n>>2]|0}c[n>>2]=q+4;p=m}m=p;q=p;o=b+28|0;L8:do{if((a[o]&1)==0){h=j;c[h>>2]=c[o>>2];c[h+4>>2]=c[o+4>>2];c[h+8>>2]=c[o+8>>2];r=16}else{h=c[b+36>>2]|0;s=c[b+32>>2]|0;do{if(s>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(s>>>0<11>>>0){a[j]=s<<1;t=j+1|0}else{u=s+16&-16;v=(x=0,as(230,u|0)|0);if(x){x=0;break}c[j+8>>2]=v;c[j>>2]=u|1;c[j+4>>2]=s;t=v}Kb(t|0,h|0,s)|0;a[t+s|0]=0;r=16;break L8}}while(0);s=bQ(-1,-1)|0;w=K;y=s}}while(0);do{if((r|0)==16){t=k;o=b+44|0;c[t>>2]=c[o>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];o=(x=0,as(158,b|0)|0);do{if(!x){s=g;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];h=e;v=f;u=p;z=j;A=a[z]|0;B=(A&1)==0;if(B){c[h>>2]=c[z>>2];c[h+4>>2]=c[z+4>>2];c[h+8>>2]=c[z+8>>2]}else{z=c[j+8>>2]|0;C=c[j+4>>2]|0;if(C>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;r=36;break}return 0}if(C>>>0<11>>>0){a[h]=C<<1;D=e+1|0}else{E=C+16&-16;F=(x=0,as(230,E|0)|0);if(x){x=0;r=36;break}c[e+8>>2]=F;c[e>>2]=E|1;c[e+4>>2]=C;D=F}Kb(D|0,z|0,C)|0;a[D+C|0]=0}c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];x=0;aP(402,u|0,e|0,f|0);if(x){x=0;u=bQ(-1,-1)|0;s=K;if((a[h]&1)==0){G=s;H=u;I=A;break}J2(c[e+8>>2]|0);G=s;H=u;I=A;break}if((a[h]&1)!=0){J2(c[e+8>>2]|0)}c[p>>2]=16672;c[p+28>>2]=o;if(B){i=d;return q|0}J2(c[j+8>>2]|0);i=d;return q|0}else{x=0;r=36}}while(0);if((r|0)==36){o=bQ(-1,-1)|0;G=K;H=o;I=a[j]|0}o=H;t=G;if((I&1)==0){w=t;y=o;break}J2(c[j+8>>2]|0);w=t;y=o}}while(0);j=c[l>>2]|0;l=c[n>>2]|0;I=j;while(1){if((I|0)==(l|0)){J=l;break}if((c[I>>2]|0)==(p|0)){J=I;break}else{I=I+4|0}}I=J-j>>2;J=j+(I+1<<2)|0;p=l-J|0;Kc(j+(I<<2)|0,J|0,p|0)|0;J=j+((p>>2)+I<<2)|0;I=c[n>>2]|0;if((J|0)==(I|0)){J2(m);L=y;M=0;N=L;O=w;be(N|0)}c[n>>2]=I+(~((I-4+(-J|0)|0)>>>2)<<2);J2(m);L=y;M=0;N=L;O=w;be(N|0);return 0}function sf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=a[35752]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=35752;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==10){p=i+1|0}else if((n<<24>>24|0)==0){q=i;break L9}else{p=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=p}else{q=p;break}}}else{q=0}}while(0);c[g>>2]=h+q;h=e;g=0;while(1){p=h-1|0;if(p>>>0<k>>>0){break}if((a[p]|0)==10){break}else{h=p;g=g+1|0}}h=b+40|0;if((q|0)!=0){c[h>>2]=1}q=c[h>>2]|0;c[b+52>>2]=q+g;k=f;p=e;c[h>>2]=k-p+g+q;q=b+56|0;c[q>>2]=p;c[q+4>>2]=k;c[d>>2]=f;o=f;return o|0}function sg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xM(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=i;i=i+112|0;e=d|0;f=d+16|0;g=d+24|0;h=d+56|0;j=d+64|0;k=d+80|0;l=d+96|0;t7(b)|0;m=c[b+56>>2]|0;n=(c[b+60>>2]|0)-m|0;if(n>>>0>4294967279>>>0){CJ(0);return 0}if(n>>>0<11>>>0){o=n<<1&255;a[g]=o;p=g+1|0;q=o}else{o=n+16&-16;r=J0(o)|0;c[g+8>>2]=r;s=o|1;c[g>>2]=s;c[g+4>>2]=n;p=r;q=s&255}Kb(p|0,m|0,n)|0;a[p+n|0]=0;n=d+40|0;p=b+44|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];p=b+20|0;x=0;aP(412,h|0,b|0,c[p>>2]|0);L8:do{if(!x){m=c[h>>2]|0;do{if((m|0)==0){t=0}else{if((a[h+4|0]&1)==0){s=(x=0,as(44,b|0)|0);if(x){x=0;u=11;break L8}t=s|0;break}else{s=(x=0,aK(582,b|0,m|0)|0);if(x){x=0;u=11;break L8}t=s|0;break}}}while(0);m=(x=0,as(60,c[p>>2]|0)|0);if(x){x=0;u=11;break}if((m+1|0)==0|(a[m]|0)!=123){v=0}else{m=(x=0,as(228,b|0)|0);if(!x){v=m}else{x=0;u=11;break}}m=c[b>>2]|0;s=(x=0,as(230,48)|0);if(x){x=0;u=11;break}r=s;c[f>>2]=r;s=m+4|0;o=c[s>>2]|0;if((o|0)==(c[m+8>>2]|0)){x=0;aq(376,m|0,f|0);if(x){x=0;u=11;break}w=c[f>>2]|0}else{if((o|0)==0){y=0}else{c[o>>2]=r;y=c[s>>2]|0}c[s>>2]=y+4;w=r}r=w;o=w;z=b+28|0;L31:do{if((a[z]&1)==0){A=j;c[A>>2]=c[z>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];u=34}else{A=c[b+36>>2]|0;B=c[b+32>>2]|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(B>>>0<11>>>0){a[j]=B<<1;C=j+1|0}else{D=B+16&-16;E=(x=0,as(230,D|0)|0);if(x){x=0;break}c[j+8>>2]=E;c[j>>2]=D|1;c[j+4>>2]=B;C=E}Kb(C|0,A|0,B)|0;a[C+B|0]=0;u=34;break L31}}while(0);B=bQ(-1,-1)|0;F=K;G=B}}while(0);do{if((u|0)==34){z=k;c[z>>2]=c[n>>2];c[z+4>>2]=c[n+4>>2];c[z+8>>2]=c[n+8>>2];L46:do{if((q&1)==0){B=g;A=l;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];u=44}else{B=c[g+8>>2]|0;A=c[g+4>>2]|0;do{if(A>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(A>>>0<11>>>0){a[l]=A<<1;H=l+1|0}else{E=A+16&-16;D=(x=0,as(230,E|0)|0);if(x){x=0;break}c[l+8>>2]=D;c[l>>2]=E|1;c[l+4>>2]=A;H=D}Kb(H|0,B|0,A)|0;a[H+A|0]=0;u=44;break L46}}while(0);A=bQ(-1,-1)|0;I=K;J=A}}while(0);do{if((u|0)==44){A=e;c[A>>2]=c[z>>2];c[A+4>>2]=c[z+4>>2];c[A+8>>2]=c[z+8>>2];x=0;aB(8,o|0,j|0,e|0,l|0,t|0,v|0);if(x){x=0;A=bQ(-1,-1)|0;B=A;A=K;if((a[l]&1)==0){I=A;J=B;break}J2(c[l+8>>2]|0);I=A;J=B;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}if((q&1)==0){i=d;return o|0}J2(c[g+8>>2]|0);i=d;return o|0}}while(0);if((a[j]&1)==0){F=I;G=J;break}J2(c[j+8>>2]|0);F=I;G=J}}while(0);o=c[m>>2]|0;z=c[s>>2]|0;B=o;while(1){if((B|0)==(z|0)){L=z;break}if((c[B>>2]|0)==(w|0)){L=B;break}else{B=B+4|0}}B=L-o>>2;m=o+(B+1<<2)|0;A=z-m|0;Kc(o+(B<<2)|0,m|0,A|0)|0;m=o+((A>>2)+B<<2)|0;B=c[s>>2]|0;if((m|0)!=(B|0)){c[s>>2]=B+(~((B-4+(-m|0)|0)>>>2)<<2)}J2(r);M=F;N=G}else{x=0;u=11}}while(0);if((u|0)==11){u=bQ(-1,-1)|0;M=K;N=u}if((q&1)==0){O=N;P=0;Q=O;R=M;be(Q|0)}J2(c[g+8>>2]|0);O=N;P=0;Q=O;R=M;be(Q|0);return 0}function si(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;f=d+20|0;if((e|0)==0){g=0;h=c[f>>2]|0}else{g=0;h=e}L3:while(1){i=(h|0)==0;if(i){j=c[f>>2]|0}else{j=h}e=xQ(xP(j)|0)|0;L8:do{if((e|0)==0){if(i){k=c[f>>2]|0}else{k=h}d=yc(xP(k)|0)|0;if((d|0)!=0){l=d;break}if(i){m=c[f>>2]|0}else{m=h}d=ye(xP(m)|0)|0;if((d|0)!=0){l=d;break}if(i){n=c[f>>2]|0}else{n=h}d=yf(xP(n)|0)|0;if((d|0)!=0){l=d;break}if(i){o=c[f>>2]|0}else{o=h}d=yv(xP(o)|0)|0;if((d|0)!=0){p=xQ(d)|0;if((p|0)!=0){l=p;break}}if(i){q=c[f>>2]|0}else{q=h}p=ym(xP(q)|0)|0;if((p|0)!=0){l=p;break}if(i){r=c[f>>2]|0}else{r=h}p=yn(xP(r)|0)|0;if((p|0)!=0){l=p;break}if(i){s=c[f>>2]|0}else{s=h}p=xM(xP(s)|0)|0;if((p|0)!=0){l=p;break}if(i){t=c[f>>2]|0}else{t=h}p=xP(t)|0;d=(a[p]|0)==42?p+1|0:0;if((d|0)!=0){l=d;break}if(i){u=c[f>>2]|0}else{u=h}d=xP(u)|0;p=(a[d]|0)==40?d+1|0:0;if((p|0)!=0){l=p;break}if(i){v=c[f>>2]|0}else{v=h}p=xP(v)|0;d=(a[p]|0)==41?p+1|0:0;if((d|0)!=0){l=d;break}if(i){w=c[f>>2]|0}else{w=h}d=xP(w)|0;p=(a[d]|0)==91?d+1|0:0;if((p|0)!=0){l=p;break}if(i){x=c[f>>2]|0}else{x=h}p=xP(x)|0;d=(a[p]|0)==93?p+1|0:0;if((d|0)!=0){l=d;break}if(i){y=c[f>>2]|0}else{y=h}d=xP(y)|0;p=(a[d]|0)==43?d+1|0:0;if((p|0)!=0){l=p;break}if(i){z=c[f>>2]|0}else{z=h}p=xP(z)|0;d=(a[p]|0)==126?p+1|0:0;if((d|0)!=0){l=d;break}if(i){A=c[f>>2]|0}else{A=h}d=xP(A)|0;p=(a[d]|0)==62?d+1|0:0;if((p|0)!=0){l=p;break}if(i){B=c[f>>2]|0}else{B=h}p=xP(B)|0;d=(a[p]|0)==44?p+1|0:0;if((d|0)!=0){l=d;break}if(i){C=c[f>>2]|0}else{C=h}d=yk(xP(C)|0)|0;if((d|0)!=0){l=d;break}if(i){D=c[f>>2]|0}else{D=h}d=xP(D)|0;p=yh(d)|0;E=(p|0)!=0?p:d;do{if((E|0)!=0){d=xI(E)|0;p=(d|0)!=0?d:E;if((p|0)==0){break}d=(a[p]|0)==110?p+1|0:0;if((d|0)!=0){l=d;break L8}}}while(0);if(i){F=c[f>>2]|0}else{F=h}E=xP(F)|0;d=yh(E)|0;p=(d|0)!=0?d:E;if((p|0)!=0){E=xI(p)|0;if((E|0)!=0){l=E;break}}if(i){G=c[f>>2]|0}else{G=h}E=yi(xP(G)|0)|0;if((E|0)!=0){l=E;break}if(i){H=c[f>>2]|0}else{H=h}E=xP(H)|0;p=(a[E]|0)==38?E+1|0:0;if((p|0)!=0){l=p;break}if(i){I=c[f>>2]|0}else{I=h}p=xP(I)|0;E=(a[p]|0)==37?p+1|0:0;if((E|0)!=0){l=E;break}if(i){J=c[f>>2]|0}else{J=h}E=xP(J)|0;p=yB(E)|0;if((p|0)!=0){l=p;break}p=yC(E)|0;if((p|0)!=0){l=p;break}p=yD(E)|0;if((p|0)!=0){l=p;break}p=yE(E)|0;if((p|0)!=0){l=p;break}p=yF(E)|0;if((p|0)!=0){l=p;break}p=yG(E)|0;if((p|0)!=0){l=p;break}if(i){K=c[f>>2]|0}else{K=h}p=xP(K)|0;E=(a[p]|0)==46?p+1|0:0;if((E|0)!=0){p=xN(E)|0;if((p|0)!=0){l=p;break}}if(i){L=c[f>>2]|0}else{L=h}p=xP(L)|0;E=(a[p]|0)==35?p+1|0:0;if((E|0)!=0){p=xN(E)|0;if((p|0)!=0){l=p;break}}if(i){M=c[f>>2]|0}else{M=h}p=xP(M)|0;E=(a[p]|0)==45?p+1|0:0;if((E|0)!=0){p=xN(E)|0;if((p|0)!=0){l=p;break}}if(i){N=c[f>>2]|0}else{N=h}p=yv(xP(N)|0)|0;if((p|0)!=0){E=xN(p)|0;if((E|0)!=0){l=E;break}}if(i){O=c[f>>2]|0}else{O=h}E=xN(xP(O)|0)|0;if((E|0)==0){break L3}else{l=E}}else{l=e}}while(0);g=(a[l-1|0]|0)==125|g;h=l}if(!i){P=h;Q=xP(P)|0;R=a[Q]|0;S=R<<24>>24==123;T=Q+1|0;U=(T|0)!=0;V=S&U;W=V?h:0;X=b|0;c[X>>2]=W;Y=b+4|0;Z=g&1;a[Y]=Z;return}P=c[f>>2]|0;Q=xP(P)|0;R=a[Q]|0;S=R<<24>>24==123;T=Q+1|0;U=(T|0)!=0;V=S&U;W=V?h:0;X=b|0;c[X>>2]=W;Y=b+4|0;Z=g&1;a[Y]=Z;return}function sj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+120|0;f=d;d=i;i=i+8|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+72|0;l=e+88|0;m=e+104|0;if((a[d+4|0]&1)==0){n=sE(b)|0}else{n=sD(b,c[d>>2]|0)|0}d=e+56|0;o=b+44|0;c[d>>2]=c[o>>2];c[d+4>>2]=c[o+4>>2];c[d+8>>2]=c[o+8>>2];o=xP(c[b+20>>2]|0)|0;do{if((o+1|0)==0|(a[o]|0)!=123){p=J0(48)|0;q=k+8|0;c[q>>2]=p;c[k>>2]=49;c[k+4>>2]=33;Kb(p|0,8856,33)|0;a[p+33|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;x=0;aP(466,b|0,k|0,l|0);if(!x){if((a[k]&1)==0){break}J2(c[q>>2]|0);break}else{x=0}p=bQ(-1,-1)|0;r=p;p=K;if((a[k]&1)==0){s=r;t=p;u=s;v=0;w=u;y=t;be(w|0)}J2(c[q>>2]|0);s=r;t=p;u=s;v=0;w=u;y=t;be(w|0)}}while(0);k=sr(b)|0;l=c[b>>2]|0;o=J0(36)|0;c[j>>2]=o;p=l+4|0;r=c[p>>2]|0;if((r|0)==(c[l+8>>2]|0)){ee(l|0,j);z=c[j>>2]|0}else{if((r|0)==0){A=0}else{c[r>>2]=o;A=c[p>>2]|0}c[p>>2]=A+4;z=o}o=z;A=z;r=b+28|0;L23:do{if((a[r]&1)==0){j=m;c[j>>2]=c[r>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];B=a[j]|0;C=j;D=25}else{j=c[b+36>>2]|0;q=c[b+32>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){E=q<<1&255;F=m;a[F]=E;G=m+1|0;H=E;I=F}else{F=q+16&-16;E=(x=0,as(230,F|0)|0);if(x){x=0;break}c[m+8>>2]=E;J=F|1;c[m>>2]=J;c[m+4>>2]=q;G=E;H=J&255;I=m}Kb(G|0,j|0,q)|0;a[G+q|0]=0;B=H;C=I;D=25;break L23}}while(0);q=bQ(-1,-1)|0;L=q;M=K}}while(0);do{if((D|0)==25){I=h;c[I>>2]=c[d>>2];c[I+4>>2]=c[d+4>>2];c[I+8>>2]=c[d+8>>2];I=h;H=f;G=g;b=z;L38:do{if((B&1)==0){c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];D=35}else{r=c[m+8>>2]|0;q=c[m+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[H]=q<<1;N=f+1|0}else{j=q+16&-16;J=(x=0,as(230,j|0)|0);if(x){x=0;break}c[f+8>>2]=J;c[f>>2]=j|1;c[f+4>>2]=q;N=J}Kb(N|0,r|0,q)|0;a[N+q|0]=0;D=35;break L38}}while(0);q=bQ(-1,-1)|0;O=K;P=q}}while(0);do{if((D|0)==35){c[G>>2]=c[I>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];x=0;aT(6,b|0,f|0,g|0,k|0);if(x){x=0;q=bQ(-1,-1)|0;r=K;if((a[H]&1)==0){O=r;P=q;break}J2(c[f+8>>2]|0);O=r;P=q;break}if((a[H]&1)!=0){J2(c[f+8>>2]|0)}c[z>>2]=16808;c[z+32>>2]=n;if((a[C]&1)==0){i=e;return A|0}J2(c[m+8>>2]|0);i=e;return A|0}}while(0);H=P;b=O;if((a[C]&1)==0){L=H;M=b;break}J2(c[m+8>>2]|0);L=H;M=b}}while(0);m=c[l>>2]|0;l=c[p>>2]|0;C=m;while(1){if((C|0)==(l|0)){Q=l;break}if((c[C>>2]|0)==(z|0)){Q=C;break}else{C=C+4|0}}C=Q-m>>2;Q=m+(C+1<<2)|0;z=l-Q|0;Kc(m+(C<<2)|0,Q|0,z|0)|0;Q=m+((z>>2)+C<<2)|0;C=c[p>>2]|0;if((Q|0)!=(C|0)){c[p>>2]=C+(~((C-4+(-Q|0)|0)>>>2)<<2)}J2(o);s=L;t=M;u=s;v=0;w=u;y=t;be(w|0);return 0}function sk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xP(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xV(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0,eo=0,ep=0,eq=0,er=0,es=0,et=0,eu=0,ev=0,ew=0,ex=0,ey=0,ez=0,eA=0,eB=0,eC=0,eD=0,eE=0,eF=0,eG=0;d=i;i=i+648|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+72|0;m=d+88|0;n=d+104|0;o=d+120|0;p=d+128|0;q=d+136|0;r=d+144|0;s=d+152|0;t=d+168|0;u=d+176|0;v=d+184|0;w=d+200|0;y=d+208|0;z=d+216|0;A=d+232|0;B=d+240|0;C=d+256|0;D=d+264|0;E=d+272|0;F=d+288|0;G=d+296|0;H=d+312|0;I=d+320|0;J=d+328|0;L=d+344|0;M=d+352|0;N=d+360|0;O=d+376|0;P=d+384|0;Q=d+400|0;R=d+416|0;S=d+424|0;T=d+440|0;U=d+448|0;V=d+456|0;W=d+472|0;X=d+480|0;Y=d+496|0;Z=d+512|0;_=d+528|0;$=d+544|0;aa=d+560|0;ab=d+576|0;ac=d+640|0;ad=ac;ae=i;i=i+12|0;i=i+7&-8;af=i;i=i+12|0;i=i+7&-8;ag=i;i=i+12|0;i=i+7&-8;ah=i;i=i+12|0;i=i+7&-8;ai=i;i=i+12|0;i=i+7&-8;aj=i;i=i+12|0;i=i+7&-8;ak=i;i=i+12|0;i=i+7&-8;al=i;i=i+12|0;i=i+7&-8;am=i;i=i+12|0;i=i+7&-8;an=i;i=i+8|0;ar=i;i=i+12|0;i=i+7&-8;at=i;i=i+12|0;i=i+7&-8;au=i;i=i+12|0;i=i+7&-8;av=i;i=i+12|0;i=i+7&-8;aw=i;i=i+12|0;i=i+7&-8;ay=i;i=i+12|0;i=i+7&-8;az=i;i=i+12|0;i=i+7&-8;aA=i;i=i+12|0;i=i+7&-8;aC=i;i=i+12|0;i=i+7&-8;aD=i;i=i+12|0;i=i+7&-8;aE=i;i=i+64|0;aF=i;i=i+8|0;aG=aF;aH=i;i=i+12|0;i=i+7&-8;aI=i;i=i+12|0;i=i+7&-8;aJ=i;i=i+12|0;i=i+7&-8;aK=i;i=i+12|0;i=i+7&-8;aL=i;i=i+12|0;i=i+7&-8;aM=i;i=i+12|0;i=i+7&-8;aN=i;i=i+12|0;i=i+7&-8;aO=i;i=i+12|0;i=i+7&-8;aR=i;i=i+12|0;i=i+7&-8;aS=i;i=i+12|0;i=i+7&-8;aU=i;i=i+12|0;i=i+7&-8;aV=i;i=i+12|0;i=i+7&-8;aW=i;i=i+12|0;i=i+7&-8;aX=i;i=i+12|0;i=i+7&-8;aY=i;i=i+12|0;i=i+7&-8;a_=i;i=i+12|0;i=i+7&-8;a$=i;i=i+12|0;i=i+7&-8;a0=i;i=i+12|0;i=i+7&-8;a1=i;i=i+12|0;i=i+7&-8;a2=i;i=i+12|0;i=i+7&-8;a3=i;i=i+12|0;i=i+7&-8;a4=i;i=i+12|0;i=i+7&-8;a5=i;i=i+12|0;i=i+7&-8;a6=i;i=i+12|0;i=i+7&-8;a7=i;i=i+12|0;i=i+7&-8;a8=i;i=i+12|0;i=i+7&-8;if((ty(b)|0)!=0){a9=b|0;ba=c[a9>>2]|0;bb=J0(56)|0;c[T>>2]=bb;bc=ba+4|0;bd=c[bc>>2]|0;if((bd|0)==(c[ba+8>>2]|0)){ee(ba|0,T);bf=c[T>>2]|0}else{if((bd|0)==0){bg=0}else{c[bd>>2]=bb;bg=c[bc>>2]|0}c[bc>>2]=bg+4;bf=bb}bb=bf;bg=bf;bd=b+28|0;L10:do{if((a[bd]&1)==0){T=Y;c[T>>2]=c[bd>>2];c[T+4>>2]=c[bd+4>>2];c[T+8>>2]=c[bd+8>>2];bh=17}else{T=c[b+36>>2]|0;bi=c[b+32>>2]|0;do{if(bi>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bi>>>0<11>>>0){a[Y]=bi<<1;bj=Y+1|0}else{bk=bi+16&-16;bl=(x=0,as(230,bk|0)|0);if(x){x=0;break}c[Y+8>>2]=bl;c[Y>>2]=bk|1;c[Y+4>>2]=bi;bj=bl}Kb(bj|0,T|0,bi)|0;a[bj+bi|0]=0;bh=17;break L10}}while(0);bi=bQ(-1,-1)|0;bm=bi;bn=K}}while(0);do{if((bh|0)==17){bj=b+44|0;bi=S;c[bi>>2]=c[bj>>2];c[bi+4>>2]=c[bj+4>>2];c[bi+8>>2]=c[bj+8>>2];x=0;aP(44,bg|0,Y|0,S|0);if(x){x=0;bi=bQ(-1,-1)|0;T=bi;bi=K;if((a[Y]&1)==0){bm=T;bn=bi;break}J2(c[Y+8>>2]|0);bm=T;bn=bi;break}if((a[Y]&1)!=0){J2(c[Y+8>>2]|0)}bi=c[a9>>2]|0;T=J0(52)|0;c[R>>2]=T;bl=bi+4|0;bk=c[bl>>2]|0;if((bk|0)==(c[bi+8>>2]|0)){ee(bi|0,R);bo=c[R>>2]|0}else{if((bk|0)==0){bp=0}else{c[bk>>2]=T;bp=c[bl>>2]|0}c[bl>>2]=bp+4;bo=T}T=bo;bk=bo;L39:do{if((a[bd]&1)==0){bq=Z;c[bq>>2]=c[bd>>2];c[bq+4>>2]=c[bd+4>>2];c[bq+8>>2]=c[bd+8>>2];bh=35}else{bq=c[b+36>>2]|0;br=c[b+32>>2]|0;do{if(br>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(br>>>0<11>>>0){a[Z]=br<<1;bs=Z+1|0}else{bt=br+16&-16;bu=(x=0,as(230,bt|0)|0);if(x){x=0;break}c[Z+8>>2]=bu;c[Z>>2]=bt|1;c[Z+4>>2]=br;bs=bu}Kb(bs|0,bq|0,br)|0;a[bs+br|0]=0;bh=35;break L39}}while(0);br=bQ(-1,-1)|0;bv=br;bw=K}}while(0);do{if((bh|0)==35){br=Q;c[br>>2]=c[bj>>2];c[br+4>>2]=c[bj+4>>2];c[br+8>>2]=c[bj+8>>2];br=_;a[br]=6;bq=_+1|0;a[bq]=a[888]|0;a[bq+1|0]=a[889]|0;a[bq+2|0]=a[890]|0;a[_+4|0]=0;x=0;ao(10,bk|0,Z|0,Q|0,_|0,bg|0);if(x){x=0;bq=bQ(-1,-1)|0;bu=bq;bq=K;if((a[br]&1)!=0){J2(c[_+8>>2]|0)}if((a[Z]&1)==0){bv=bu;bw=bq;break}J2(c[Z+8>>2]|0);bv=bu;bw=bq;break}if((a[br]&1)!=0){J2(c[_+8>>2]|0)}if((a[Z]&1)!=0){J2(c[Z+8>>2]|0)}br=b+20|0;bq=c[br>>2]|0;bu=(x=0,as(60,bq|0)|0);L67:do{if(!x){bt=(x=0,as(220,bu|0)|0);if(x){x=0;bh=93;break}if((bt|0)!=0){bt=(x=0,as(136,b|0)|0);if(x){x=0;bh=93;break}bx=bf+36|0;by=bx;bz=c[a9>>2]|0;bB=(x=0,as(230,56)|0);if(x){x=0;bh=93;break}bC=bB;c[O>>2]=bC;bB=bz+4|0;bD=c[bB>>2]|0;if((bD|0)==(c[bz+8>>2]|0)){x=0;aq(376,bz|0,O|0);if(x){x=0;bh=93;break}bE=c[O>>2]|0}else{if((bD|0)==0){bF=0}else{c[bD>>2]=bC;bF=c[bB>>2]|0}c[bB>>2]=bF+4;bE=bC}bC=bE;bD=bE;L82:do{if((a[bd]&1)==0){bG=$;c[bG>>2]=c[bd>>2];c[bG+4>>2]=c[bd+4>>2];c[bG+8>>2]=c[bd+8>>2];bh=61}else{bG=c[b+36>>2]|0;bH=c[b+32>>2]|0;do{if(bH>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bH>>>0<11>>>0){a[$]=bH<<1;bI=$+1|0}else{bJ=bH+16&-16;bK=(x=0,as(230,bJ|0)|0);if(x){x=0;break}c[$+8>>2]=bK;c[$>>2]=bJ|1;c[$+4>>2]=bH;bI=bK}Kb(bI|0,bG|0,bH)|0;a[bI+bH|0]=0;bh=61;break L82}}while(0);bH=bQ(-1,-1,30176)|0;bL=K;bM=bH}}while(0);do{if((bh|0)==61){bH=N;c[bH>>2]=c[bj>>2];c[bH+4>>2]=c[bj+4>>2];c[bH+8>>2]=c[bj+8>>2];bH=aa;a[bH]=0;a[aa+1|0]=0;x=0;aB(28,bD|0,$|0,N|0,bt|0,aa|0,0);do{if(!x){c[M>>2]=bD;bG=bx+8|0;bK=bG;bJ=c[bK>>2]|0;if((bJ|0)==(c[bx+12>>2]|0)){x=0;aq(156,bx+4|0,M|0);if(x){x=0;bN=0;break}bO=c[M>>2]|0}else{if((bJ|0)==0){bP=0}else{c[bJ>>2]=bD;bP=c[bK>>2]|0}c[bG>>2]=bP+4;bO=bD}x=0;aq(c[c[bx>>2]>>2]|0,by|0,bO|0);if(x){x=0;bN=0;break}if((a[bH]&1)!=0){J2(c[aa+8>>2]|0)}if((a[$]&1)==0){break L67}J2(c[$+8>>2]|0);break L67}else{x=0;bN=1}}while(0);bG=bQ(-1,-1,30176)|0;bK=bG;bG=K;if((a[bH]&1)!=0){J2(c[aa+8>>2]|0)}if((a[$]&1)==0){if(bN){bL=bG;bM=bK;break}else{bR=bK;bS=bG;bh=341;break L67}}else{J2(c[$+8>>2]|0);if(bN){bL=bG;bM=bK;break}else{bR=bK;bS=bG;bh=341;break L67}}}}while(0);by=c[bz>>2]|0;bx=c[bB>>2]|0;bD=by;while(1){if((bD|0)==(bx|0)){bT=bx;break}if((c[bD>>2]|0)==(bE|0)){bT=bD;break}else{bD=bD+4|0}}bD=bT-by>>2;bz=by+(bD+1<<2)|0;bt=bx-bz|0;Kc(by+(bD<<2)|0,bz|0,bt|0)|0;bz=by+((bt>>2)+bD<<2)|0;bD=c[bB>>2]|0;if((bz|0)!=(bD|0)){c[bB>>2]=bD+(~((bD-4+(-bz|0)|0)>>>2)<<2)}J2(bC);bR=bM;bS=bL;bh=341;break}bz=(x=0,as(60,c[br>>2]|0)|0);if(x){x=0;bh=93;break}bD=(x=0,as(46,bz|0)|0);if(x){x=0;bh=93;break}do{if((bD|0)!=0){bz=(x=0,as(60,bD|0)|0);if(x){x=0;bh=93;break L67}if((bz|0)==0){break}if((bz+1|0)==0|(a[bz]|0)!=41){break}x=0,as(276,b|0)|0;if(x){x=0;bh=93;break L67}bz=b+56|0;bt=c[bz+4>>2]|0;c[ac>>2]=c[bz>>2];c[ac+4>>2]=bt;bt=c[a9>>2]|0;if((a[bd]&1)==0){bz=ae;c[bz>>2]=c[bd>>2];c[bz+4>>2]=c[bd+4>>2];c[bz+8>>2]=c[bd+8>>2]}else{bz=c[b+36>>2]|0;bG=c[b+32>>2]|0;if(bG>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bh=93;break L67}return 0}if(bG>>>0<11>>>0){a[ae]=bG<<1;bV=ae+1|0}else{bK=bG+16&-16;bJ=(x=0,as(230,bK|0)|0);if(x){x=0;bh=93;break L67}c[ae+8>>2]=bJ;c[ae>>2]=bK|1;c[ae+4>>2]=bG;bV=bJ}Kb(bV|0,bz|0,bG)|0;a[bV+bG|0]=0}bG=af;c[bG>>2]=c[bj>>2];c[bG+4>>2]=c[bj+4>>2];c[bG+8>>2]=c[bj+8>>2];x=0;ao(16,ab|0,ad|0,bt|0,ae|0,af|0);do{if(!x){bt=(x=0,as(282,ab|0)|0);if(x){x=0;bG=bQ(-1,-1,30176)|0;bz=bG;bG=K;if((a[ab+28|0]&1)!=0){J2(c[ab+36>>2]|0)}bJ=c[ab+4>>2]|0;if((bJ|0)==0){bW=bz;bX=bG;break}bK=ab+8|0;bY=c[bK>>2]|0;if((bJ|0)!=(bY|0)){c[bK>>2]=bY+(~((bY-4+(-bJ|0)|0)>>>2)<<2)}J2(bJ);bW=bz;bX=bG;break}if((a[ab+28|0]&1)!=0){J2(c[ab+36>>2]|0)}bG=c[ab+4>>2]|0;bz=bG;if((bG|0)!=0){bJ=ab+8|0;bY=c[bJ>>2]|0;if((bG|0)!=(bY|0)){c[bJ>>2]=bY+(~((bY-4+(-bz|0)|0)>>>2)<<2)}J2(bG)}if((a[ae]&1)!=0){J2(c[ae+8>>2]|0)}bG=bf+36|0;bz=bG;bY=c[a9>>2]|0;bJ=(x=0,as(230,56)|0);if(x){x=0;bh=93;break L67}bK=bJ;c[L>>2]=bK;bJ=bY+4|0;bZ=c[bJ>>2]|0;if((bZ|0)==(c[bY+8>>2]|0)){x=0;aq(376,bY|0,L|0);if(x){x=0;bh=93;break L67}b_=c[L>>2]|0}else{if((bZ|0)==0){b$=0}else{c[bZ>>2]=bK;b$=c[bJ>>2]|0}c[bJ>>2]=b$+4;b_=bK}bK=b_;bZ=b_;L182:do{if((a[bd]&1)==0){b0=ag;c[b0>>2]=c[bd>>2];c[b0+4>>2]=c[bd+4>>2];c[b0+8>>2]=c[bd+8>>2];bh=150}else{b0=c[b+36>>2]|0;b1=c[b+32>>2]|0;do{if(b1>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(b1>>>0<11>>>0){a[ag]=b1<<1;b2=ag+1|0}else{b3=b1+16&-16;b4=(x=0,as(230,b3|0)|0);if(x){x=0;break}c[ag+8>>2]=b4;c[ag>>2]=b3|1;c[ag+4>>2]=b1;b2=b4}Kb(b2|0,b0|0,b1)|0;a[b2+b1|0]=0;bh=150;break L182}}while(0);b1=bQ(-1,-1,30176)|0;b5=K;b6=b1}}while(0);do{if((bh|0)==150){b1=J;c[b1>>2]=c[bj>>2];c[b1+4>>2]=c[bj+4>>2];c[b1+8>>2]=c[bj+8>>2];b1=ah;a[b1]=0;a[ah+1|0]=0;x=0;aB(28,bZ|0,ag|0,J|0,bt|0,ah|0,0);do{if(!x){c[I>>2]=bZ;b0=bG+8|0;b4=b0;b3=c[b4>>2]|0;if((b3|0)==(c[bG+12>>2]|0)){x=0;aq(156,bG+4|0,I|0);if(x){x=0;b7=0;break}b8=c[I>>2]|0}else{if((b3|0)==0){b9=0}else{c[b3>>2]=bZ;b9=c[b4>>2]|0}c[b0>>2]=b9+4;b8=bZ}x=0;aq(c[c[bG>>2]>>2]|0,bz|0,b8|0);if(x){x=0;b7=0;break}if((a[b1]&1)!=0){J2(c[ah+8>>2]|0)}if((a[ag]&1)==0){break L67}J2(c[ag+8>>2]|0);break L67}else{x=0;b7=1}}while(0);b0=bQ(-1,-1,30176)|0;b4=b0;b0=K;if((a[b1]&1)!=0){J2(c[ah+8>>2]|0)}if((a[ag]&1)==0){if(b7){b5=b0;b6=b4;break}else{bR=b4;bS=b0;bh=341;break L67}}else{J2(c[ag+8>>2]|0);if(b7){b5=b0;b6=b4;break}else{bR=b4;bS=b0;bh=341;break L67}}}}while(0);bz=c[bY>>2]|0;bG=c[bJ>>2]|0;bZ=bz;while(1){if((bZ|0)==(bG|0)){ca=bG;break}if((c[bZ>>2]|0)==(b_|0)){ca=bZ;break}else{bZ=bZ+4|0}}bZ=ca-bz>>2;bY=bz+(bZ+1<<2)|0;bt=bG-bY|0;Kc(bz+(bZ<<2)|0,bY|0,bt|0)|0;bY=bz+((bt>>2)+bZ<<2)|0;bZ=c[bJ>>2]|0;if((bY|0)!=(bZ|0)){c[bJ>>2]=bZ+(~((bZ-4+(-bY|0)|0)>>>2)<<2)}J2(bK);bR=b6;bS=b5;bh=341;break L67}else{x=0;bY=bQ(-1,-1,30176)|0;bW=bY;bX=K}}while(0);if((a[ae]&1)==0){bR=bW;bS=bX;bh=341;break L67}J2(c[ae+8>>2]|0);bR=bW;bS=bX;bh=341;break L67}}while(0);bD=(x=0,as(60,c[br>>2]|0)|0);if(x){x=0;bh=93;break}bC=(x=0,as(272,bD|0)|0);if(x){x=0;bh=93;break}do{if((bC|0)!=0){bD=(x=0,as(60,bC|0)|0);if(x){x=0;bh=93;break L67}if((bD|0)==0){break}if((bD+1|0)==0|(a[bD]|0)!=41){break}x=0,as(138,b|0)|0;if(x){x=0;bh=93;break L67}bD=c[a9>>2]|0;bB=(x=0,as(230,52)|0);if(x){x=0;bh=93;break L67}by=bB;c[H>>2]=by;bB=bD+4|0;bx=c[bB>>2]|0;if((bx|0)==(c[bD+8>>2]|0)){x=0;aq(376,bD|0,H|0);if(x){x=0;bh=93;break L67}cb=c[H>>2]|0}else{if((bx|0)==0){cc=0}else{c[bx>>2]=by;cc=c[bB>>2]|0}c[bB>>2]=cc+4;cb=by}by=cb;L248:do{if((a[bd]&1)==0){bx=ai;c[bx>>2]=c[bd>>2];c[bx+4>>2]=c[bd+4>>2];c[bx+8>>2]=c[bd+8>>2];bh=207}else{bx=c[b+36>>2]|0;bH=c[b+32>>2]|0;do{if(bH>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bH>>>0<11>>>0){a[ai]=bH<<1;cd=ai+1|0}else{bY=bH+16&-16;bZ=(x=0,as(230,bY|0)|0);if(x){x=0;break}c[ai+8>>2]=bZ;c[ai>>2]=bY|1;c[ai+4>>2]=bH;cd=bZ}Kb(cd|0,bx|0,bH)|0;a[cd+bH|0]=0;bh=207;break L248}}while(0);bH=bQ(-1,-1,30176)|0;ce=bH;cf=K}}while(0);do{if((bh|0)==207){bH=G;c[bH>>2]=c[bj>>2];c[bH+4>>2]=c[bj+4>>2];c[bH+8>>2]=c[bj+8>>2];x=0;ao(14,cb|0,ai|0,G|0,b+56|0,0);if(x){x=0;bH=bQ(-1,-1,30176)|0;bx=bH;bH=K;if((a[ai]&1)==0){ce=bx;cf=bH;break}J2(c[ai+8>>2]|0);ce=bx;cf=bH;break}if((a[ai]&1)!=0){J2(c[ai+8>>2]|0)}bH=bf+36|0;bx=bH;bK=c[a9>>2]|0;bJ=(x=0,as(230,56)|0);if(x){x=0;bh=93;break L67}bz=bJ;c[F>>2]=bz;bJ=bK+4|0;bG=c[bJ>>2]|0;if((bG|0)==(c[bK+8>>2]|0)){x=0;aq(376,bK|0,F|0);if(x){x=0;bh=93;break L67}cg=c[F>>2]|0}else{if((bG|0)==0){ch=0}else{c[bG>>2]=bz;ch=c[bJ>>2]|0}c[bJ>>2]=ch+4;cg=bz}bz=cg;bG=cg;L279:do{if((a[bd]&1)==0){bZ=aj;c[bZ>>2]=c[bd>>2];c[bZ+4>>2]=c[bd+4>>2];c[bZ+8>>2]=c[bd+8>>2];bh=227}else{bZ=c[b+36>>2]|0;bY=c[b+32>>2]|0;do{if(bY>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bY>>>0<11>>>0){a[aj]=bY<<1;ci=aj+1|0}else{bt=bY+16&-16;b0=(x=0,as(230,bt|0)|0);if(x){x=0;break}c[aj+8>>2]=b0;c[aj>>2]=bt|1;c[aj+4>>2]=bY;ci=b0}Kb(ci|0,bZ|0,bY)|0;a[ci+bY|0]=0;bh=227;break L279}}while(0);bY=bQ(-1,-1,30176)|0;cj=K;ck=bY}}while(0);do{if((bh|0)==227){bY=E;c[bY>>2]=c[bj>>2];c[bY+4>>2]=c[bj+4>>2];c[bY+8>>2]=c[bj+8>>2];bY=ak;a[bY]=0;a[ak+1|0]=0;x=0;aB(28,bG|0,aj|0,E|0,cb|0,ak|0,0);do{if(!x){c[D>>2]=bG;bZ=bH+8|0;b1=bZ;b0=c[b1>>2]|0;if((b0|0)==(c[bH+12>>2]|0)){x=0;aq(156,bH+4|0,D|0);if(x){x=0;cl=0;break}cm=c[D>>2]|0}else{if((b0|0)==0){cn=0}else{c[b0>>2]=bG;cn=c[b1>>2]|0}c[bZ>>2]=cn+4;cm=bG}x=0;aq(c[c[bH>>2]>>2]|0,bx|0,cm|0);if(x){x=0;cl=0;break}if((a[bY]&1)!=0){J2(c[ak+8>>2]|0)}if((a[aj]&1)==0){break L67}J2(c[aj+8>>2]|0);break L67}else{x=0;cl=1}}while(0);bZ=bQ(-1,-1,30176)|0;b1=bZ;bZ=K;if((a[bY]&1)!=0){J2(c[ak+8>>2]|0)}if((a[aj]&1)==0){if(cl){cj=bZ;ck=b1;break}else{bR=b1;bS=bZ;bh=341;break L67}}else{J2(c[aj+8>>2]|0);if(cl){cj=bZ;ck=b1;break}else{bR=b1;bS=bZ;bh=341;break L67}}}}while(0);bx=c[bK>>2]|0;bH=c[bJ>>2]|0;bG=bx;while(1){if((bG|0)==(bH|0)){co=bH;break}if((c[bG>>2]|0)==(cg|0)){co=bG;break}else{bG=bG+4|0}}bG=co-bx>>2;bK=bx+(bG+1<<2)|0;bZ=bH-bK|0;Kc(bx+(bG<<2)|0,bK|0,bZ|0)|0;bK=bx+((bZ>>2)+bG<<2)|0;bG=c[bJ>>2]|0;if((bK|0)!=(bG|0)){c[bJ>>2]=bG+(~((bG-4+(-bK|0)|0)>>>2)<<2)}J2(bz);bR=ck;bS=cj;bh=341;break L67}}while(0);bK=c[bD>>2]|0;bG=c[bB>>2]|0;bZ=bK;while(1){if((bZ|0)==(bG|0)){cq=bG;break}if((c[bZ>>2]|0)==(cb|0)){cq=bZ;break}else{bZ=bZ+4|0}}bZ=cq-bK>>2;bD=bK+(bZ+1<<2)|0;b1=bG-bD|0;Kc(bK+(bZ<<2)|0,bD|0,b1|0)|0;bD=bK+((b1>>2)+bZ<<2)|0;bZ=c[bB>>2]|0;if((bD|0)!=(bZ|0)){c[bB>>2]=bZ+(~((bZ-4+(-bD|0)|0)>>>2)<<2)}J2(by);bR=ce;bS=cf;bh=341;break L67}}while(0);bC=c[br>>2]|0;bD=bC;while(1){bZ=a[bD]|0;if(bZ<<24>>24==0){bh=264;break}b1=bD+1|0;if((b1|0)==0|bZ<<24>>24!=41){bD=b1}else{bh=263;break}}if((bh|0)==263){if((bD|0)==0){bh=264}else{cr=bD}}do{if((bh|0)==264){b1=(x=0,as(230,32)|0);if(x){x=0;bh=93;break L67}bZ=al+8|0;c[bZ>>2]=b1;c[al>>2]=33;c[al+4>>2]=18;Kb(b1|0,5216,18)|0;a[b1+18|0]=0;c[am>>2]=0;c[am+4>>2]=0;c[am+8>>2]=0;x=0;aP(466,b|0,al|0,am|0);if(!x){if((a[al]&1)==0){cr=0;break}J2(c[bZ>>2]|0);cr=0;break}else{x=0;b1=bQ(-1,-1,30176)|0;b0=b1;b1=K;if((a[al]&1)==0){bR=b0;bS=b1;bh=341;break L67}J2(c[bZ>>2]|0);bR=b0;bS=b1;bh=341;break L67}}}while(0);c[an>>2]=bC;c[an+4>>2]=cr;bD=c[a9>>2]|0;b1=(x=0,as(230,52)|0);if(x){x=0;bh=93;break}b0=b1;c[C>>2]=b0;b1=bD+4|0;bZ=c[b1>>2]|0;if((bZ|0)==(c[bD+8>>2]|0)){x=0;aq(376,bD|0,C|0);if(x){x=0;bh=93;break}cs=c[C>>2]|0}else{if((bZ|0)==0){ct=0}else{c[bZ>>2]=b0;ct=c[b1>>2]|0}c[b1>>2]=ct+4;cs=b0}b0=cs;L356:do{if((a[bd]&1)==0){bZ=ar;c[bZ>>2]=c[bd>>2];c[bZ+4>>2]=c[bd+4>>2];c[bZ+8>>2]=c[bd+8>>2];bh=287}else{bZ=c[b+36>>2]|0;bt=c[b+32>>2]|0;do{if(bt>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bt>>>0<11>>>0){a[ar]=bt<<1;cu=ar+1|0}else{b4=bt+16&-16;b3=(x=0,as(230,b4|0)|0);if(x){x=0;break}c[ar+8>>2]=b3;c[ar>>2]=b4|1;c[ar+4>>2]=bt;cu=b3}Kb(cu|0,bZ|0,bt)|0;a[cu+bt|0]=0;bh=287;break L356}}while(0);bt=bQ(-1,-1,30176)|0;cv=bt;cw=K}}while(0);do{if((bh|0)==287){bC=B;c[bC>>2]=c[bj>>2];c[bC+4>>2]=c[bj+4>>2];c[bC+8>>2]=c[bj+8>>2];x=0;ao(14,cs|0,ar|0,B|0,an|0,0);if(x){x=0;bC=bQ(-1,-1,30176)|0;bt=bC;bC=K;if((a[ar]&1)==0){cv=bt;cw=bC;break}J2(c[ar+8>>2]|0);cv=bt;cw=bC;break}if((a[ar]&1)!=0){J2(c[ar+8>>2]|0)}bC=bf+36|0;bt=bC;bZ=c[a9>>2]|0;by=(x=0,as(230,56)|0);if(x){x=0;bh=93;break L67}bB=by;c[A>>2]=bB;by=bZ+4|0;bK=c[by>>2]|0;if((bK|0)==(c[bZ+8>>2]|0)){x=0;aq(376,bZ|0,A|0);if(x){x=0;bh=93;break L67}cx=c[A>>2]|0}else{if((bK|0)==0){cy=0}else{c[bK>>2]=bB;cy=c[by>>2]|0}c[by>>2]=cy+4;cx=bB}bB=cx;bK=cx;L387:do{if((a[bd]&1)==0){bG=at;c[bG>>2]=c[bd>>2];c[bG+4>>2]=c[bd+4>>2];c[bG+8>>2]=c[bd+8>>2];bh=307}else{bG=c[b+36>>2]|0;b3=c[b+32>>2]|0;do{if(b3>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(b3>>>0<11>>>0){a[at]=b3<<1;cz=at+1|0}else{b4=b3+16&-16;cA=(x=0,as(230,b4|0)|0);if(x){x=0;break}c[at+8>>2]=cA;c[at>>2]=b4|1;c[at+4>>2]=b3;cz=cA}Kb(cz|0,bG|0,b3)|0;a[cz+b3|0]=0;bh=307;break L387}}while(0);b3=bQ(-1,-1,30176)|0;cB=K;cC=b3}}while(0);do{if((bh|0)==307){b3=z;c[b3>>2]=c[bj>>2];c[b3+4>>2]=c[bj+4>>2];c[b3+8>>2]=c[bj+8>>2];b3=au;a[b3]=0;a[au+1|0]=0;x=0;aB(28,bK|0,at|0,z|0,cs|0,au|0,0);do{if(!x){c[y>>2]=bK;bG=bC+8|0;bz=bG;bJ=c[bz>>2]|0;if((bJ|0)==(c[bC+12>>2]|0)){x=0;aq(156,bC+4|0,y|0);if(x){x=0;cD=0;break}cE=c[y>>2]|0}else{if((bJ|0)==0){cF=0}else{c[bJ>>2]=bK;cF=c[bz>>2]|0}c[bG>>2]=cF+4;cE=bK}x=0;aq(c[c[bC>>2]>>2]|0,bt|0,cE|0);if(x){x=0;cD=0;break}if((a[b3]&1)!=0){J2(c[au+8>>2]|0)}if((a[at]&1)!=0){J2(c[at+8>>2]|0)}c[br>>2]=cr;break L67}else{x=0;cD=1}}while(0);bG=bQ(-1,-1,30176)|0;bz=bG;bG=K;if((a[b3]&1)!=0){J2(c[au+8>>2]|0)}if((a[at]&1)==0){if(cD){cB=bG;cC=bz;break}else{bR=bz;bS=bG;bh=341;break L67}}else{J2(c[at+8>>2]|0);if(cD){cB=bG;cC=bz;break}else{bR=bz;bS=bG;bh=341;break L67}}}}while(0);bt=c[bZ>>2]|0;bC=c[by>>2]|0;bK=bt;while(1){if((bK|0)==(bC|0)){cG=bC;break}if((c[bK>>2]|0)==(cx|0)){cG=bK;break}else{bK=bK+4|0}}bK=cG-bt>>2;bZ=bt+(bK+1<<2)|0;bG=bC-bZ|0;Kc(bt+(bK<<2)|0,bZ|0,bG|0)|0;bZ=bt+((bG>>2)+bK<<2)|0;bK=c[by>>2]|0;if((bZ|0)!=(bK|0)){c[by>>2]=bK+(~((bK-4+(-bZ|0)|0)>>>2)<<2)}J2(bB);bR=cC;bS=cB;bh=341;break L67}}while(0);bZ=c[bD>>2]|0;bK=c[b1>>2]|0;bG=bZ;while(1){if((bG|0)==(bK|0)){cH=bK;break}if((c[bG>>2]|0)==(cs|0)){cH=bG;break}else{bG=bG+4|0}}bG=cH-bZ>>2;bD=bZ+(bG+1<<2)|0;bz=bK-bD|0;Kc(bZ+(bG<<2)|0,bD|0,bz|0)|0;bD=bZ+((bz>>2)+bG<<2)|0;bG=c[b1>>2]|0;if((bD|0)!=(bG|0)){c[b1>>2]=bG+(~((bG-4+(-bD|0)|0)>>>2)<<2)}J2(b0);bR=cv;bS=cw;bh=341}else{x=0;bh=93}}while(0);if((bh|0)==93){bu=bQ(-1,-1,30176)|0;bR=bu;bS=K;bh=341}L444:do{if((bh|0)==341){bu=cp(30176)|0;L446:do{if((bS|0)==(bu|0)){bA(bR|0)|0;c[br>>2]=bq;bD=(x=0,as(158,b|0)|0);L448:do{if(!x){bG=bf+36|0;bz=bG;bJ=c[a9>>2]|0;bx=(x=0,as(230,56)|0);if(x){x=0;bh=373;break}bH=bx;c[w>>2]=bH;bx=bJ+4|0;cA=c[bx>>2]|0;if((cA|0)==(c[bJ+8>>2]|0)){x=0;aq(376,bJ|0,w|0);if(x){x=0;bh=373;break}cI=c[w>>2]|0}else{if((cA|0)==0){cJ=0}else{c[cA>>2]=bH;cJ=c[bx>>2]|0}c[bx>>2]=cJ+4;cI=bH}bH=cI;cA=cI;L459:do{if((a[bd]&1)==0){b4=av;c[b4>>2]=c[bd>>2];c[b4+4>>2]=c[bd+4>>2];c[b4+8>>2]=c[bd+8>>2];bh=360}else{b4=c[b+36>>2]|0;cK=c[b+32>>2]|0;do{if(cK>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(cK>>>0<11>>>0){a[av]=cK<<1;cL=av+1|0}else{cM=cK+16&-16;cN=(x=0,as(230,cM|0)|0);if(x){x=0;break}c[av+8>>2]=cN;c[av>>2]=cM|1;c[av+4>>2]=cK;cL=cN}Kb(cL|0,b4|0,cK)|0;a[cL+cK|0]=0;bh=360;break L459}}while(0);cK=bQ(-1,-1,30176)|0;cO=K;cP=cK}}while(0);do{if((bh|0)==360){b3=v;c[b3>>2]=c[bj>>2];c[b3+4>>2]=c[bj+4>>2];c[b3+8>>2]=c[bj+8>>2];b3=aw;a[b3]=0;a[aw+1|0]=0;x=0;aB(28,cA|0,av|0,v|0,bD|0,aw|0,0);do{if(!x){c[u>>2]=cA;cK=bG+8|0;b4=cK;bY=c[b4>>2]|0;if((bY|0)==(c[bG+12>>2]|0)){x=0;aq(156,bG+4|0,u|0);if(x){x=0;cQ=0;break}cR=c[u>>2]|0}else{if((bY|0)==0){cS=0}else{c[bY>>2]=cA;cS=c[b4>>2]|0}c[cK>>2]=cS+4;cR=cA}x=0;aq(c[c[bG>>2]>>2]|0,bz|0,cR|0);if(x){x=0;cQ=0;break}if((a[b3]&1)!=0){J2(c[aw+8>>2]|0)}if((a[av]&1)!=0){J2(c[av+8>>2]|0)}x=0;aQ(2);if(!x){break L444}else{x=0}cK=bQ(-1,-1,30176)|0;cT=cK;cU=K;break L446}else{x=0;cQ=1}}while(0);cK=bQ(-1,-1,30176)|0;b4=cK;cK=K;if((a[b3]&1)!=0){J2(c[aw+8>>2]|0)}if((a[av]&1)==0){if(cQ){cO=cK;cP=b4;break}else{cV=b4;cW=cK;break L448}}else{J2(c[av+8>>2]|0);if(cQ){cO=cK;cP=b4;break}else{cV=b4;cW=cK;break L448}}}}while(0);bz=c[bJ>>2]|0;bG=c[bx>>2]|0;cA=bz;while(1){if((cA|0)==(bG|0)){cX=bG;break}if((c[cA>>2]|0)==(cI|0)){cX=cA;break}else{cA=cA+4|0}}cA=cX-bz>>2;bJ=bz+(cA+1<<2)|0;cK=bG-bJ|0;Kc(bz+(cA<<2)|0,bJ|0,cK|0)|0;bJ=bz+((cK>>2)+cA<<2)|0;cA=c[bx>>2]|0;if((bJ|0)!=(cA|0)){c[bx>>2]=cA+(~((cA-4+(-bJ|0)|0)>>>2)<<2)}J2(bH);cV=cP;cW=cO}else{x=0;bh=373}}while(0);if((bh|0)==373){bD=bQ(-1,-1,30176)|0;cV=bD;cW=K}x=0;aQ(2);if(!x){cT=cV;cU=cW;break}else{x=0}cY=bQ(-1,-1,0)|0;cZ=K;bU();return 0}else{cT=bR;cU=bS}}while(0);if((cU|0)!=(bu|0)){c_=cT;c$=cU;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}bA(cT|0)|0;b0=(x=0,as(230,32)|0);do{if(!x){b1=ay+8|0;c[b1>>2]=b0;c[ay>>2]=33;c[ay+4>>2]=19;Kb(b0|0,5144,19)|0;a[b0+19|0]=0;c[az>>2]=0;c[az+4>>2]=0;c[az+8>>2]=0;x=0;aP(466,b|0,ay|0,az|0);if(x){x=0;bZ=bQ(-1,-1)|0;bK=bZ;bZ=K;if((a[ay]&1)==0){c4=bK;c5=bZ;break}J2(c[b1>>2]|0);c4=bK;c5=bZ;break}if((a[ay]&1)!=0){J2(c[b1>>2]|0)}aZ();break L444}else{x=0;b1=bQ(-1,-1)|0;c4=b1;c5=K}}while(0);x=0;aQ(2);if(!x){c_=c4;c$=c5;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}else{x=0;cY=bQ(-1,-1,0)|0;cZ=K;bU();return 0}}}while(0);bq=xP(c[br>>2]|0)|0;b0=(a[bq]|0)==41?bq+1|0:0;do{if((b0|0)==0){bu=J0(32)|0;b1=aA+8|0;c[b1>>2]=bu;c[aA>>2]=33;c[aA+4>>2]=18;Kb(bu|0,5216,18)|0;a[bu+18|0]=0;c[aC>>2]=0;c[aC+4>>2]=0;c[aC+8>>2]=0;x=0;aP(466,b|0,aA|0,aC|0);if(!x){if((a[aA]&1)==0){break}J2(c[b1>>2]|0);break}else{x=0}bu=bQ(-1,-1)|0;bZ=bu;bu=K;if((a[aA]&1)==0){c_=bZ;c$=bu;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}J2(c[b1>>2]|0);c_=bZ;c$=bu;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}else{bu=b+48|0;bZ=c[bu>>2]|0;b1=c[br>>2]|0;L532:do{if(b1>>>0<b0>>>0){bK=b1;bD=0;while(1){bB=a[bK]|0;if((bB<<24>>24|0)==10){c6=bD+1|0}else if((bB<<24>>24|0)==0){c7=bD;break L532}else{c6=bD}bB=bK+1|0;if(bB>>>0<b0>>>0){bK=bB;bD=c6}else{c7=c6;break}}}else{c7=0}}while(0);c[bu>>2]=c7+bZ;bD=bq;bK=0;while(1){bB=bD-1|0;if(bB>>>0<b1>>>0){break}if((a[bB]|0)==10){break}else{bD=bB;bK=bK+1|0}}bD=b+40|0;if((c7|0)!=0){c[bD>>2]=1}b1=c[bD>>2]|0;c[b+52>>2]=b1+bK;bZ=b0;bu=bq;c[bD>>2]=bZ-bu+bK+b1;b1=b+56|0;c[b1>>2]=bu;c[b1+4>>2]=bZ;c[br>>2]=b0}}while(0);c8=bo;i=d;return c8|0}}while(0);bj=c[bi>>2]|0;bk=c[bl>>2]|0;b0=bj;while(1){if((b0|0)==(bk|0)){c9=bk;break}if((c[b0>>2]|0)==(bo|0)){c9=b0;break}else{b0=b0+4|0}}b0=c9-bj>>2;bi=bj+(b0+1<<2)|0;br=bk-bi|0;Kc(bj+(b0<<2)|0,bi|0,br|0)|0;bi=bj+((br>>2)+b0<<2)|0;b0=c[bl>>2]|0;if((bi|0)!=(b0|0)){c[bl>>2]=b0+(~((b0-4+(-bi|0)|0)>>>2)<<2)}J2(T);c_=bv;c$=bw;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}}while(0);bw=c[ba>>2]|0;ba=c[bc>>2]|0;bv=bw;while(1){if((bv|0)==(ba|0)){da=ba;break}if((c[bv>>2]|0)==(bf|0)){da=bv;break}else{bv=bv+4|0}}bv=da-bw>>2;da=bw+(bv+1<<2)|0;bf=ba-da|0;Kc(bw+(bv<<2)|0,da|0,bf|0)|0;da=bw+((bf>>2)+bv<<2)|0;bv=c[bc>>2]|0;if((da|0)!=(bv|0)){c[bc>>2]=bv+(~((bv-4+(-da|0)|0)>>>2)<<2)}J2(bb);c_=bm;c$=bn;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((tD(b)|0)!=0){bn=c[b>>2]|0;bm=J0(52)|0;c[t>>2]=bm;bb=bn+4|0;da=c[bb>>2]|0;if((da|0)==(c[bn+8>>2]|0)){ee(bn|0,t);db=c[t>>2]|0}else{if((da|0)==0){dc=0}else{c[da>>2]=bm;dc=c[bb>>2]|0}c[bb>>2]=dc+4;db=bm}bm=db;dc=b+28|0;L585:do{if((a[dc]&1)==0){da=aD;c[da>>2]=c[dc>>2];c[da+4>>2]=c[dc+4>>2];c[da+8>>2]=c[dc+8>>2];bh=431}else{da=c[b+36>>2]|0;t=c[b+32>>2]|0;do{if(t>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(t>>>0<11>>>0){a[aD]=t<<1;dd=aD+1|0}else{bv=t+16&-16;bc=(x=0,as(230,bv|0)|0);if(x){x=0;break}c[aD+8>>2]=bc;c[aD>>2]=bv|1;c[aD+4>>2]=t;dd=bc}Kb(dd|0,da|0,t)|0;a[dd+t|0]=0;bh=431;break L585}}while(0);t=bQ(-1,-1)|0;de=t;df=K}}while(0);do{if((bh|0)==431){dd=b+44|0;dc=s;c[dc>>2]=c[dd>>2];c[dc+4>>2]=c[dd+4>>2];c[dc+8>>2]=c[dd+8>>2];x=0;ao(34,db|0,aD|0,s|0,5088,0);if(x){x=0;dd=bQ(-1,-1)|0;dc=dd;dd=K;if((a[aD]&1)==0){de=dc;df=dd;break}J2(c[aD+8>>2]|0);de=dc;df=dd;break}dd=db;if((a[aD]&1)==0){c8=dd;i=d;return c8|0}J2(c[aD+8>>2]|0);c8=dd;i=d;return c8|0}}while(0);aD=c[bn>>2]|0;bn=c[bb>>2]|0;s=aD;while(1){if((s|0)==(bn|0)){dg=bn;break}if((c[s>>2]|0)==(db|0)){dg=s;break}else{s=s+4|0}}s=dg-aD>>2;dg=aD+(s+1<<2)|0;db=bn-dg|0;Kc(aD+(s<<2)|0,dg|0,db|0)|0;dg=aD+((db>>2)+s<<2)|0;s=c[bb>>2]|0;if((dg|0)!=(s|0)){c[bb>>2]=s+(~((s-4+(-dg|0)|0)>>>2)<<2)}J2(bm);c_=de;c$=df;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((tE(b)|0)!=0){df=b+56|0;de=c[df+4>>2]|0;c[aF>>2]=c[df>>2];c[aF+4>>2]=de;de=c[b>>2]|0;aF=b+28|0;if((a[aF]&1)==0){df=aH;c[df>>2]=c[aF>>2];c[df+4>>2]=c[aF+4>>2];c[df+8>>2]=c[aF+8>>2]}else{aF=c[b+36>>2]|0;df=c[b+32>>2]|0;if(df>>>0>4294967279>>>0){CJ(0);return 0}if(df>>>0<11>>>0){a[aH]=df<<1;dh=aH+1|0}else{bm=df+16&-16;dg=J0(bm)|0;c[aH+8>>2]=dg;c[aH>>2]=bm|1;c[aH+4>>2]=df;dh=dg}Kb(dh|0,aF|0,df)|0;a[dh+df|0]=0}df=aI;dh=b+44|0;c[df>>2]=c[dh>>2];c[df+4>>2]=c[dh+4>>2];c[df+8>>2]=c[dh+8>>2];x=0;ao(16,aE|0,aG|0,de|0,aH|0,aI|0);do{if(!x){aI=(x=0,as(244,aE|0)|0);if(x){x=0;de=bQ(-1,-1)|0;aG=de;de=K;if((a[aE+28|0]&1)!=0){J2(c[aE+36>>2]|0)}dh=c[aE+4>>2]|0;if((dh|0)==0){di=aG;dj=de;break}df=aE+8|0;aF=c[df>>2]|0;if((dh|0)!=(aF|0)){c[df>>2]=aF+(~((aF-4+(-dh|0)|0)>>>2)<<2)}J2(dh);di=aG;dj=de;break}if((a[aE+28|0]&1)!=0){J2(c[aE+36>>2]|0)}de=c[aE+4>>2]|0;aG=de;if((de|0)!=0){dh=aE+8|0;aF=c[dh>>2]|0;if((de|0)!=(aF|0)){c[dh>>2]=aF+(~((aF-4+(-aG|0)|0)>>>2)<<2)}J2(de)}de=aI|0;if((a[aH]&1)==0){c8=de;i=d;return c8|0}J2(c[aH+8>>2]|0);c8=de;i=d;return c8|0}else{x=0;de=bQ(-1,-1)|0;di=de;dj=K}}while(0);if((a[aH]&1)==0){c_=di;c$=dj;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}J2(c[aH+8>>2]|0);c_=di;c$=dj;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((tG(b)|0)!=0){dj=c[b>>2]|0;di=J0(40)|0;c[q>>2]=di;aH=dj+4|0;aE=c[aH>>2]|0;if((aE|0)==(c[dj+8>>2]|0)){ee(dj|0,q);dk=c[q>>2]|0}else{if((aE|0)==0){dl=0}else{c[aE>>2]=di;dl=c[aH>>2]|0}c[aH>>2]=dl+4;dk=di}di=dk;dl=b+28|0;L672:do{if((a[dl]&1)==0){aE=aJ;c[aE>>2]=c[dl>>2];c[aE+4>>2]=c[dl+4>>2];c[aE+8>>2]=c[dl+8>>2];bh=487}else{aE=c[b+36>>2]|0;q=c[b+32>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[aJ]=q<<1;dm=aJ+1|0}else{de=q+16&-16;aI=(x=0,as(230,de|0)|0);if(x){x=0;break}c[aJ+8>>2]=aI;c[aJ>>2]=de|1;c[aJ+4>>2]=q;dm=aI}Kb(dm|0,aE|0,q)|0;a[dm+q|0]=0;bh=487;break L672}}while(0);q=bQ(-1,-1)|0;dn=q;dp=K}}while(0);do{if((bh|0)==487){dm=aK;dl=b+44|0;c[dm>>2]=c[dl>>2];c[dm+4>>2]=c[dl+4>>2];c[dm+8>>2]=c[dl+8>>2];x=0;aT(4,dk|0,aJ|0,aK|0,1);if(x){x=0;dl=bQ(-1,-1)|0;dm=dl;dl=K;if((a[aJ]&1)==0){dn=dm;dp=dl;break}J2(c[aJ+8>>2]|0);dn=dm;dp=dl;break}dl=dk;if((a[aJ]&1)==0){c8=dl;i=d;return c8|0}J2(c[aJ+8>>2]|0);c8=dl;i=d;return c8|0}}while(0);aJ=c[dj>>2]|0;dj=c[aH>>2]|0;aK=aJ;while(1){if((aK|0)==(dj|0)){dq=dj;break}if((c[aK>>2]|0)==(dk|0)){dq=aK;break}else{aK=aK+4|0}}aK=dq-aJ>>2;dq=aJ+(aK+1<<2)|0;dk=dj-dq|0;Kc(aJ+(aK<<2)|0,dq|0,dk|0)|0;dq=aJ+((dk>>2)+aK<<2)|0;aK=c[aH>>2]|0;if((dq|0)!=(aK|0)){c[aH>>2]=aK+(~((aK-4+(-dq|0)|0)>>>2)<<2)}J2(di);c_=dn;c$=dp;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((tH(b)|0)!=0){dp=c[b>>2]|0;dn=J0(40)|0;c[p>>2]=dn;di=dp+4|0;dq=c[di>>2]|0;if((dq|0)==(c[dp+8>>2]|0)){ee(dp|0,p);dr=c[p>>2]|0}else{if((dq|0)==0){ds=0}else{c[dq>>2]=dn;ds=c[di>>2]|0}c[di>>2]=ds+4;dr=dn}dn=dr;ds=b+28|0;L714:do{if((a[ds]&1)==0){dq=aL;c[dq>>2]=c[ds>>2];c[dq+4>>2]=c[ds+4>>2];c[dq+8>>2]=c[ds+8>>2];bh=515}else{dq=c[b+36>>2]|0;p=c[b+32>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(p>>>0<11>>>0){a[aL]=p<<1;dt=aL+1|0}else{aK=p+16&-16;aH=(x=0,as(230,aK|0)|0);if(x){x=0;break}c[aL+8>>2]=aH;c[aL>>2]=aK|1;c[aL+4>>2]=p;dt=aH}Kb(dt|0,dq|0,p)|0;a[dt+p|0]=0;bh=515;break L714}}while(0);p=bQ(-1,-1)|0;du=p;dv=K}}while(0);do{if((bh|0)==515){dt=aM;ds=b+44|0;c[dt>>2]=c[ds>>2];c[dt+4>>2]=c[ds+4>>2];c[dt+8>>2]=c[ds+8>>2];x=0;aT(4,dr|0,aL|0,aM|0,0);if(x){x=0;ds=bQ(-1,-1)|0;dt=ds;ds=K;if((a[aL]&1)==0){du=dt;dv=ds;break}J2(c[aL+8>>2]|0);du=dt;dv=ds;break}ds=dr;if((a[aL]&1)==0){c8=ds;i=d;return c8|0}J2(c[aL+8>>2]|0);c8=ds;i=d;return c8|0}}while(0);aL=c[dp>>2]|0;dp=c[di>>2]|0;aM=aL;while(1){if((aM|0)==(dp|0)){dw=dp;break}if((c[aM>>2]|0)==(dr|0)){dw=aM;break}else{aM=aM+4|0}}aM=dw-aL>>2;dw=aL+(aM+1<<2)|0;dr=dp-dw|0;Kc(aL+(aM<<2)|0,dw|0,dr|0)|0;dw=aL+((dr>>2)+aM<<2)|0;aM=c[di>>2]|0;if((dw|0)!=(aM|0)){c[di>>2]=aM+(~((aM-4+(-dw|0)|0)>>>2)<<2)}J2(dn);c_=du;c$=dv;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((tI(b)|0)!=0){dv=c[b>>2]|0;du=J0(36)|0;c[o>>2]=du;dn=dv+4|0;dw=c[dn>>2]|0;if((dw|0)==(c[dv+8>>2]|0)){ee(dv|0,o);dx=c[o>>2]|0}else{if((dw|0)==0){dy=0}else{c[dw>>2]=du;dy=c[dn>>2]|0}c[dn>>2]=dy+4;dx=du}du=dx;dy=b+28|0;L756:do{if((a[dy]&1)==0){dw=aN;c[dw>>2]=c[dy>>2];c[dw+4>>2]=c[dy+4>>2];c[dw+8>>2]=c[dy+8>>2];dz=a[dw]|0;dA=dw;bh=543}else{dw=c[b+36>>2]|0;o=c[b+32>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(o>>>0<11>>>0){aM=o<<1&255;di=aN;a[di]=aM;dB=aN+1|0;dC=aM;dD=di}else{di=o+16&-16;aM=(x=0,as(230,di|0)|0);if(x){x=0;break}c[aN+8>>2]=aM;dr=di|1;c[aN>>2]=dr;c[aN+4>>2]=o;dB=aM;dC=dr&255;dD=aN}Kb(dB|0,dw|0,o)|0;a[dB+o|0]=0;dz=dC;dA=dD;bh=543;break L756}}while(0);o=bQ(-1,-1)|0;dE=o;dF=K}}while(0);do{if((bh|0)==543){dD=b+44|0;dC=n;c[dC>>2]=c[dD>>2];c[dC+4>>2]=c[dD+4>>2];c[dC+8>>2]=c[dD+8>>2];dD=n;dC=l;dB=m;dy=dx;L771:do{if((dz&1)==0){c[dC>>2]=c[dA>>2];c[dC+4>>2]=c[dA+4>>2];c[dC+8>>2]=c[dA+8>>2];bh=553}else{o=c[aN+8>>2]|0;dw=c[aN+4>>2]|0;do{if(dw>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(dw>>>0<11>>>0){a[dC]=dw<<1;dG=l+1|0}else{dr=dw+16&-16;aM=(x=0,as(230,dr|0)|0);if(x){x=0;break}c[l+8>>2]=aM;c[l>>2]=dr|1;c[l+4>>2]=dw;dG=aM}Kb(dG|0,o|0,dw)|0;a[dG+dw|0]=0;bh=553;break L771}}while(0);dw=bQ(-1,-1)|0;dH=K;dI=dw}}while(0);do{if((bh|0)==553){c[dB>>2]=c[dD>>2];c[dB+4>>2]=c[dD+4>>2];c[dB+8>>2]=c[dD+8>>2];x=0;aB(6,dy|0,l|0,m|0,0,0,0);if(x){x=0;dw=bQ(-1,-1)|0;o=K;if((a[dC]&1)==0){dH=o;dI=dw;break}J2(c[l+8>>2]|0);dH=o;dI=dw;break}if((a[dC]&1)!=0){J2(c[l+8>>2]|0)}c[dx>>2]=18624;c[dx+32>>2]=6;if((a[dA]&1)==0){c8=dy;i=d;return c8|0}J2(c[aN+8>>2]|0);c8=dy;i=d;return c8|0}}while(0);dy=dI;dC=dH;if((a[dA]&1)==0){dE=dy;dF=dC;break}J2(c[aN+8>>2]|0);dE=dy;dF=dC}}while(0);aN=c[dv>>2]|0;dv=c[dn>>2]|0;dA=aN;while(1){if((dA|0)==(dv|0)){dJ=dv;break}if((c[dA>>2]|0)==(dx|0)){dJ=dA;break}else{dA=dA+4|0}}dA=dJ-aN>>2;dJ=aN+(dA+1<<2)|0;dx=dv-dJ|0;Kc(aN+(dA<<2)|0,dJ|0,dx|0)|0;dJ=aN+((dx>>2)+dA<<2)|0;dA=c[dn>>2]|0;if((dJ|0)!=(dA|0)){c[dn>>2]=dA+(~((dA-4+(-dJ|0)|0)>>>2)<<2)}J2(du);c_=dE;c$=dF;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((sp(b)|0)!=0){dF=c[b>>2]|0;dE=J0(52)|0;c[k>>2]=dE;du=dF+4|0;dJ=c[du>>2]|0;if((dJ|0)==(c[dF+8>>2]|0)){ee(dF|0,k);dK=c[k>>2]|0}else{if((dJ|0)==0){dL=0}else{c[dJ>>2]=dE;dL=c[du>>2]|0}c[du>>2]=dL+4;dK=dE}dE=dK;dL=b+28|0;L818:do{if((a[dL]&1)==0){dJ=aO;c[dJ>>2]=c[dL>>2];c[dJ+4>>2]=c[dL+4>>2];c[dJ+8>>2]=c[dL+8>>2];bh=586}else{dJ=c[b+36>>2]|0;k=c[b+32>>2]|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(k>>>0<11>>>0){a[aO]=k<<1;dM=aO+1|0}else{dA=k+16&-16;dn=(x=0,as(230,dA|0)|0);if(x){x=0;break}c[aO+8>>2]=dn;c[aO>>2]=dA|1;c[aO+4>>2]=k;dM=dn}Kb(dM|0,dJ|0,k)|0;a[dM+k|0]=0;bh=586;break L818}}while(0);k=bQ(-1,-1)|0;dN=k;dO=K}}while(0);do{if((bh|0)==586){dM=b+44|0;dL=j;c[dL>>2]=c[dM>>2];c[dL+4>>2]=c[dM+4>>2];c[dL+8>>2]=c[dM+8>>2];x=0;ao(14,dK|0,aO|0,j|0,b+56|0,0);if(x){x=0;dM=bQ(-1,-1)|0;dL=dM;dM=K;if((a[aO]&1)==0){dN=dL;dO=dM;break}J2(c[aO+8>>2]|0);dN=dL;dO=dM;break}if((a[aO]&1)!=0){J2(c[aO+8>>2]|0)}a[dK+28|0]=1;c8=dK;i=d;return c8|0}}while(0);aO=c[dF>>2]|0;dF=c[du>>2]|0;j=aO;while(1){if((j|0)==(dF|0)){dP=dF;break}if((c[j>>2]|0)==(dK|0)){dP=j;break}else{j=j+4|0}}j=dP-aO>>2;dP=aO+(j+1<<2)|0;dK=dF-dP|0;Kc(aO+(j<<2)|0,dP|0,dK|0)|0;dP=aO+((dK>>2)+j<<2)|0;j=c[du>>2]|0;if((dP|0)!=(j|0)){c[du>>2]=j+(~((j-4+(-dP|0)|0)>>>2)<<2)}J2(dE);c_=dN;c$=dO;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((tJ(b)|0)!=0){dO=c[b>>2]|0;dN=J0(52)|0;c[h>>2]=dN;dE=dO+4|0;dP=c[dE>>2]|0;if((dP|0)==(c[dO+8>>2]|0)){ee(dO|0,h);dQ=c[h>>2]|0}else{if((dP|0)==0){dR=0}else{c[dP>>2]=dN;dR=c[dE>>2]|0}c[dE>>2]=dR+4;dQ=dN}dN=dQ;dR=dQ;dP=b+28|0;L860:do{if((a[dP]&1)==0){h=aR;c[h>>2]=c[dP>>2];c[h+4>>2]=c[dP+4>>2];c[h+8>>2]=c[dP+8>>2];bh=615}else{h=c[b+36>>2]|0;j=c[b+32>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){a[aR]=j<<1;dS=aR+1|0}else{du=j+16&-16;dK=(x=0,as(230,du|0)|0);if(x){x=0;break}c[aR+8>>2]=dK;c[aR>>2]=du|1;c[aR+4>>2]=j;dS=dK}Kb(dS|0,h|0,j)|0;a[dS+j|0]=0;bh=615;break L860}}while(0);j=bQ(-1,-1)|0;dT=j;dU=K}}while(0);do{if((bh|0)==615){dS=aS;dP=b+44|0;c[dS>>2]=c[dP>>2];c[dS+4>>2]=c[dP+4>>2];c[dS+8>>2]=c[dP+8>>2];dP=c[b+56>>2]|0;j=(c[b+60>>2]|0)-dP|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bh=628;break}return 0}else{if(j>>>0<11>>>0){a[aU]=j<<1;dV=aU+1|0}else{h=j+16&-16;dK=(x=0,as(230,h|0)|0);if(x){x=0;bh=628;break}c[aU+8>>2]=dK;c[aU>>2]=h|1;c[aU+4>>2]=j;dV=dK}Kb(dV|0,dP|0,j)|0;a[dV+j|0]=0;dK=g;c[dK>>2]=c[dS>>2];c[dK+4>>2]=c[dS+4>>2];c[dK+8>>2]=c[dS+8>>2];x=0;ao(30,dR|0,aR|0,g|0,1,aU|0);if(x){x=0;dK=bQ(-1,-1)|0;h=dK;dK=K;if((a[aU]&1)==0){dW=h;dX=dK;break}J2(c[aU+8>>2]|0);dW=h;dX=dK;break}if((a[aU]&1)!=0){J2(c[aU+8>>2]|0)}dK=dQ;if((a[aR]&1)==0){c8=dK;i=d;return c8|0}J2(c[aR+8>>2]|0);c8=dK;i=d;return c8|0}}while(0);if((bh|0)==628){dS=bQ(-1,-1)|0;dW=dS;dX=K}if((a[aR]&1)==0){dT=dW;dU=dX;break}J2(c[aR+8>>2]|0);dT=dW;dU=dX}}while(0);dX=c[dO>>2]|0;dO=c[dE>>2]|0;dW=dX;while(1){if((dW|0)==(dO|0)){dY=dO;break}if((c[dW>>2]|0)==(dQ|0)){dY=dW;break}else{dW=dW+4|0}}dW=dY-dX>>2;dY=dX+(dW+1<<2)|0;dQ=dO-dY|0;Kc(dX+(dW<<2)|0,dY|0,dQ|0)|0;dY=dX+((dQ>>2)+dW<<2)|0;dW=c[dE>>2]|0;if((dY|0)!=(dW|0)){c[dE>>2]=dW+(~((dW-4+(-dY|0)|0)>>>2)<<2)}J2(dN);c_=dT;c$=dU;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((tK(b)|0)!=0){dU=c[b>>2]|0;dT=J0(52)|0;c[f>>2]=dT;dN=dU+4|0;dY=c[dN>>2]|0;if((dY|0)==(c[dU+8>>2]|0)){ee(dU|0,f);dZ=c[f>>2]|0}else{if((dY|0)==0){d_=0}else{c[dY>>2]=dT;d_=c[dN>>2]|0}c[dN>>2]=d_+4;dZ=dT}dT=dZ;d_=dZ;dY=b+28|0;L918:do{if((a[dY]&1)==0){f=aV;c[f>>2]=c[dY>>2];c[f+4>>2]=c[dY+4>>2];c[f+8>>2]=c[dY+8>>2];bh=655}else{f=c[b+36>>2]|0;dW=c[b+32>>2]|0;do{if(dW>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(dW>>>0<11>>>0){a[aV]=dW<<1;d$=aV+1|0}else{dE=dW+16&-16;dQ=(x=0,as(230,dE|0)|0);if(x){x=0;break}c[aV+8>>2]=dQ;c[aV>>2]=dE|1;c[aV+4>>2]=dW;d$=dQ}Kb(d$|0,f|0,dW)|0;a[d$+dW|0]=0;bh=655;break L918}}while(0);dW=bQ(-1,-1)|0;d0=dW;d1=K}}while(0);do{if((bh|0)==655){d$=aW;dY=b+44|0;c[d$>>2]=c[dY>>2];c[d$+4>>2]=c[dY+4>>2];c[d$+8>>2]=c[dY+8>>2];dY=c[b+56>>2]|0;dW=(c[b+60>>2]|0)-dY|0;do{if(dW>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bh=668;break}return 0}else{if(dW>>>0<11>>>0){a[aX]=dW<<1;d2=aX+1|0}else{f=dW+16&-16;dQ=(x=0,as(230,f|0)|0);if(x){x=0;bh=668;break}c[aX+8>>2]=dQ;c[aX>>2]=f|1;c[aX+4>>2]=dW;d2=dQ}Kb(d2|0,dY|0,dW)|0;a[d2+dW|0]=0;dQ=e;c[dQ>>2]=c[d$>>2];c[dQ+4>>2]=c[d$+4>>2];c[dQ+8>>2]=c[d$+8>>2];x=0;ao(30,d_|0,aV|0,e|0,2,aX|0);if(x){x=0;dQ=bQ(-1,-1)|0;f=dQ;dQ=K;if((a[aX]&1)==0){d3=f;d4=dQ;break}J2(c[aX+8>>2]|0);d3=f;d4=dQ;break}if((a[aX]&1)!=0){J2(c[aX+8>>2]|0)}dQ=dZ;if((a[aV]&1)==0){c8=dQ;i=d;return c8|0}J2(c[aV+8>>2]|0);c8=dQ;i=d;return c8|0}}while(0);if((bh|0)==668){d$=bQ(-1,-1)|0;d3=d$;d4=K}if((a[aV]&1)==0){d0=d3;d1=d4;break}J2(c[aV+8>>2]|0);d0=d3;d1=d4}}while(0);d4=c[dU>>2]|0;dU=c[dN>>2]|0;d3=d4;while(1){if((d3|0)==(dU|0)){d5=dU;break}if((c[d3>>2]|0)==(dZ|0)){d5=d3;break}else{d3=d3+4|0}}d3=d5-d4>>2;d5=d4+(d3+1<<2)|0;dZ=dU-d5|0;Kc(d4+(d3<<2)|0,d5|0,dZ|0)|0;d5=d4+((dZ>>2)+d3<<2)|0;d3=c[dN>>2]|0;if((d5|0)!=(d3|0)){c[dN>>2]=d3+(~((d3-4+(-d5|0)|0)>>>2)<<2)}J2(dT);c_=d0;c$=d1;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((sM(b)|0)!=0){d1=c[b>>2]|0;d0=J0(52)|0;c[r>>2]=d0;dT=d1+4|0;d5=c[dT>>2]|0;if((d5|0)==(c[d1+8>>2]|0)){ee(d1|0,r);d6=c[r>>2]|0}else{if((d5|0)==0){d7=0}else{c[d5>>2]=d0;d7=c[dT>>2]|0}c[dT>>2]=d7+4;d6=d0}d0=d6;d7=d6;d5=b+28|0;L976:do{if((a[d5]&1)==0){r=aY;c[r>>2]=c[d5>>2];c[r+4>>2]=c[d5+4>>2];c[r+8>>2]=c[d5+8>>2];bh=695}else{r=c[b+36>>2]|0;d3=c[b+32>>2]|0;do{if(d3>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(d3>>>0<11>>>0){a[aY]=d3<<1;d8=aY+1|0}else{dN=d3+16&-16;dZ=(x=0,as(230,dN|0)|0);if(x){x=0;break}c[aY+8>>2]=dZ;c[aY>>2]=dN|1;c[aY+4>>2]=d3;d8=dZ}Kb(d8|0,r|0,d3)|0;a[d8+d3|0]=0;bh=695;break L976}}while(0);d3=bQ(-1,-1)|0;d9=d3;ea=K}}while(0);do{if((bh|0)==695){d8=a_;d5=b+44|0;c[d8>>2]=c[d5>>2];c[d8+4>>2]=c[d5+4>>2];c[d8+8>>2]=c[d5+8>>2];d5=c[b+56>>2]|0;d3=(c[b+60>>2]|0)-d5|0;do{if(d3>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bh=708;break}return 0}else{if(d3>>>0<11>>>0){a[a$]=d3<<1;eb=a$+1|0}else{r=d3+16&-16;dZ=(x=0,as(230,r|0)|0);if(x){x=0;bh=708;break}c[a$+8>>2]=dZ;c[a$>>2]=r|1;c[a$+4>>2]=d3;eb=dZ}Kb(eb|0,d5|0,d3)|0;a[eb+d3|0]=0;dZ=P;c[dZ>>2]=c[d8>>2];c[dZ+4>>2]=c[d8+4>>2];c[dZ+8>>2]=c[d8+8>>2];x=0;ao(30,d7|0,aY|0,P|0,0,a$|0);if(x){x=0;dZ=bQ(-1,-1)|0;r=dZ;dZ=K;if((a[a$]&1)==0){ec=r;ed=dZ;break}J2(c[a$+8>>2]|0);ec=r;ed=dZ;break}if((a[a$]&1)!=0){J2(c[a$+8>>2]|0)}dZ=d6;if((a[aY]&1)==0){c8=dZ;i=d;return c8|0}J2(c[aY+8>>2]|0);c8=dZ;i=d;return c8|0}}while(0);if((bh|0)==708){d8=bQ(-1,-1)|0;ec=d8;ed=K}if((a[aY]&1)==0){d9=ec;ea=ed;break}J2(c[aY+8>>2]|0);d9=ec;ea=ed}}while(0);ed=c[d1>>2]|0;d1=c[dT>>2]|0;ec=ed;while(1){if((ec|0)==(d1|0)){ef=d1;break}if((c[ec>>2]|0)==(d6|0)){ef=ec;break}else{ec=ec+4|0}}ec=ef-ed>>2;ef=ed+(ec+1<<2)|0;d6=d1-ef|0;Kc(ed+(ec<<2)|0,ef|0,d6|0)|0;ef=ed+((d6>>2)+ec<<2)|0;ec=c[dT>>2]|0;if((ef|0)!=(ec|0)){c[dT>>2]=ec+(~((ec-4+(-ef|0)|0)>>>2)<<2)}J2(d0);c_=d9;c$=ea;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((tL(b)|0)!=0){ea=c[b>>2]|0;d9=J0(52)|0;c[U>>2]=d9;d0=ea+4|0;ef=c[d0>>2]|0;if((ef|0)==(c[ea+8>>2]|0)){ee(ea|0,U);eg=c[U>>2]|0}else{if((ef|0)==0){eh=0}else{c[ef>>2]=d9;eh=c[d0>>2]|0}c[d0>>2]=eh+4;eg=d9}d9=eg;eh=eg;ef=b+28|0;L1034:do{if((a[ef]&1)==0){U=a0;c[U>>2]=c[ef>>2];c[U+4>>2]=c[ef+4>>2];c[U+8>>2]=c[ef+8>>2];bh=735}else{U=c[b+36>>2]|0;ec=c[b+32>>2]|0;do{if(ec>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ec>>>0<11>>>0){a[a0]=ec<<1;ei=a0+1|0}else{dT=ec+16&-16;d6=(x=0,as(230,dT|0)|0);if(x){x=0;break}c[a0+8>>2]=d6;c[a0>>2]=dT|1;c[a0+4>>2]=ec;ei=d6}Kb(ei|0,U|0,ec)|0;a[ei+ec|0]=0;bh=735;break L1034}}while(0);ec=bQ(-1,-1)|0;ej=ec;ek=K}}while(0);do{if((bh|0)==735){ei=a1;ef=b+44|0;c[ei>>2]=c[ef>>2];c[ei+4>>2]=c[ef+4>>2];c[ei+8>>2]=c[ef+8>>2];ef=c[b+56>>2]|0;ec=(c[b+60>>2]|0)-ef|0;do{if(ec>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bh=748;break}return 0}else{if(ec>>>0<11>>>0){a[a2]=ec<<1;el=a2+1|0}else{U=ec+16&-16;d6=(x=0,as(230,U|0)|0);if(x){x=0;bh=748;break}c[a2+8>>2]=d6;c[a2>>2]=U|1;c[a2+4>>2]=ec;el=d6}Kb(el|0,ef|0,ec)|0;a[el+ec|0]=0;d6=V;c[d6>>2]=c[ei>>2];c[d6+4>>2]=c[ei+4>>2];c[d6+8>>2]=c[ei+8>>2];x=0;ao(30,eh|0,a0|0,V|0,3,a2|0);if(x){x=0;d6=bQ(-1,-1)|0;U=d6;d6=K;if((a[a2]&1)==0){em=U;en=d6;break}J2(c[a2+8>>2]|0);em=U;en=d6;break}if((a[a2]&1)!=0){J2(c[a2+8>>2]|0)}d6=eg;if((a[a0]&1)==0){c8=d6;i=d;return c8|0}J2(c[a0+8>>2]|0);c8=d6;i=d;return c8|0}}while(0);if((bh|0)==748){ei=bQ(-1,-1)|0;em=ei;en=K}if((a[a0]&1)==0){ej=em;ek=en;break}J2(c[a0+8>>2]|0);ej=em;ek=en}}while(0);en=c[ea>>2]|0;ea=c[d0>>2]|0;em=en;while(1){if((em|0)==(ea|0)){eo=ea;break}if((c[em>>2]|0)==(eg|0)){eo=em;break}else{em=em+4|0}}em=eo-en>>2;eo=en+(em+1<<2)|0;eg=ea-eo|0;Kc(en+(em<<2)|0,eo|0,eg|0)|0;eo=en+((eg>>2)+em<<2)|0;em=c[d0>>2]|0;if((eo|0)!=(em|0)){c[d0>>2]=em+(~((em-4+(-eo|0)|0)>>>2)<<2)}J2(d9);c_=ej;c$=ek;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}if((xM(xP(c[b+20>>2]|0)|0)|0)!=0){c8=tz(b)|0;i=d;return c8|0}if((st(b)|0)==0){ek=c[b+56>>2]|0;ej=(c[b+60>>2]|0)-ek|0;if(ej>>>0>4294967279>>>0){CJ(0);return 0}if(ej>>>0<11>>>0){d9=ej<<1&255;eo=a7;em=a7;a[em]=d9;ep=eo+1|0;eq=d9;er=eo;es=em}else{em=ej+16&-16;eo=J0(em)|0;c[a7+8>>2]=eo;d9=em|1;c[a7>>2]=d9;c[a7+4>>2]=ej;ep=eo;eq=d9&255;er=a7;es=a7}Kb(ep|0,ek|0,ej)|0;a[ep+ej|0]=0;ej=a6;Ke(ej|0,0,12)|0;ep=eq&255;if((ep&1|0)==0){et=ep>>>1}else{et=c[a7+4>>2]|0}ep=et+27|0;do{if(ep>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bh=820;break}return 0}else{if(ep>>>0<11>>>0){a[ej]=54;eu=a6+1|0}else{ek=et+43&-16;d9=(x=0,as(230,ek|0)|0);if(x){x=0;bh=820;break}c[a6+8>>2]=d9;c[a6>>2]=ek|1;c[a6+4>>2]=27;eu=d9}Kb(eu|0,4992,27)|0;a[eu+27|0]=0;if((eq&1)==0){ev=er+1|0}else{ev=c[a7+8>>2]|0}x=0,ax(64,a6|0,ev|0,et|0)|0;if(x){x=0;bh=820;break}c[a8>>2]=0;c[a8+4>>2]=0;c[a8+8>>2]=0;x=0;aP(466,b|0,a6|0,a8|0);if(x){x=0;d9=bQ(-1,-1)|0;ek=d9;d9=K;if((a[ej]&1)==0){ew=ek;ex=d9;break}J2(c[a6+8>>2]|0);ew=ek;ex=d9;break}if((a[ej]&1)!=0){J2(c[a6+8>>2]|0)}if((a[es]&1)==0){c8=0;i=d;return c8|0}J2(c[a7+8>>2]|0);c8=0;i=d;return c8|0}}while(0);if((bh|0)==820){a8=bQ(-1,-1)|0;et=K;if((a[ej]&1)!=0){J2(c[a6+8>>2]|0)}ew=a8;ex=et}if((a[es]&1)==0){c_=ew;c$=ex;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}J2(c[a7+8>>2]|0);c_=ew;c$=ex;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0)}ex=c[b>>2]|0;ew=J0(48)|0;c[W>>2]=ew;a7=ex+4|0;es=c[a7>>2]|0;if((es|0)==(c[ex+8>>2]|0)){ee(ex|0,W);ey=c[W>>2]|0}else{if((es|0)==0){ez=0}else{c[es>>2]=ew;ez=c[a7>>2]|0}c[a7>>2]=ez+4;ey=ew}ew=ey;ez=ey;es=b+28|0;L1143:do{if((a[es]&1)==0){W=a3;c[W>>2]=c[es>>2];c[W+4>>2]=c[es+4>>2];c[W+8>>2]=c[es+8>>2];bh=777}else{W=c[b+36>>2]|0;et=c[b+32>>2]|0;do{if(et>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(et>>>0<11>>>0){a[a3]=et<<1;eA=a3+1|0}else{a8=et+16&-16;a6=(x=0,as(230,a8|0)|0);if(x){x=0;break}c[a3+8>>2]=a6;c[a3>>2]=a8|1;c[a3+4>>2]=et;eA=a6}Kb(eA|0,W|0,et)|0;a[eA+et|0]=0;bh=777;break L1143}}while(0);et=bQ(-1,-1)|0;eB=et;eC=K}}while(0);do{if((bh|0)==777){eA=a4;es=b+44|0;c[eA>>2]=c[es>>2];c[eA+4>>2]=c[es+4>>2];c[eA+8>>2]=c[es+8>>2];es=c[b+56>>2]|0;et=(c[b+60>>2]|0)-es|0;do{if(et>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bh=790;break}return 0}else{if(et>>>0<11>>>0){a[a5]=et<<1;eD=a5+1|0}else{W=et+16&-16;a6=(x=0,as(230,W|0)|0);if(x){x=0;bh=790;break}c[a5+8>>2]=a6;c[a5>>2]=W|1;c[a5+4>>2]=et;eD=a6}Kb(eD|0,es|0,et)|0;a[eD+et|0]=0;a6=X;c[a6>>2]=c[eA>>2];c[a6+4>>2]=c[eA+4>>2];c[a6+8>>2]=c[eA+8>>2];x=0;aT(2,ez|0,a3|0,X|0,a5|0);if(x){x=0;a6=bQ(-1,-1)|0;W=a6;a6=K;if((a[a5]&1)==0){eE=W;eF=a6;break}J2(c[a5+8>>2]|0);eE=W;eF=a6;break}if((a[a5]&1)!=0){J2(c[a5+8>>2]|0)}a6=ey;if((a[a3]&1)==0){c8=a6;i=d;return c8|0}J2(c[a3+8>>2]|0);c8=a6;i=d;return c8|0}}while(0);if((bh|0)==790){eA=bQ(-1,-1)|0;eE=eA;eF=K}if((a[a3]&1)==0){eB=eE;eC=eF;break}J2(c[a3+8>>2]|0);eB=eE;eC=eF}}while(0);eF=c[ex>>2]|0;ex=c[a7>>2]|0;eE=eF;while(1){if((eE|0)==(ex|0)){eG=ex;break}if((c[eE>>2]|0)==(ey|0)){eG=eE;break}else{eE=eE+4|0}}eE=eG-eF>>2;eG=eF+(eE+1<<2)|0;ey=ex-eG|0;Kc(eF+(eE<<2)|0,eG|0,ey|0)|0;eG=eF+((ey>>2)+eE<<2)|0;eE=c[a7>>2]|0;if((eG|0)!=(eE|0)){c[a7>>2]=eE+(~((eE-4+(-eG|0)|0)>>>2)<<2)}J2(ew);c_=eB;c$=eC;c0=c_;c1=0;c2=c0;c3=c$;be(c2|0);return 0}function sn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xX(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function so(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xY(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xQ(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0;d=i;i=i+96|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+48|0;k=d+64|0;l=d+80|0;m=b+56|0;n=c[m>>2]|0;o=(c[b+60>>2]|0)-n|0;if(o>>>0>4294967279>>>0){CJ(0);return 0}if(o>>>0<11>>>0){p=o<<1&255;a[h]=p;q=h+1|0;r=p}else{p=o+16&-16;s=J0(p)|0;c[h+8>>2]=s;t=p|1;c[h>>2]=t;c[h+4>>2]=o;q=s;r=t&255}Kb(q|0,n|0,o)|0;a[q+o|0]=0;o=c[b>>2]|0;q=(x=0,as(230,48)|0);L8:do{if(!x){n=q;c[g>>2]=n;t=o+4|0;s=c[t>>2]|0;if((s|0)==(c[o+8>>2]|0)){x=0;aq(376,o|0,g|0);if(x){x=0;u=61;break}v=c[g>>2]|0}else{if((s|0)==0){w=0}else{c[s>>2]=n;w=c[t>>2]|0}c[t>>2]=w+4;v=n}n=v;s=v;p=b+28|0;L18:do{if((a[p]&1)==0){y=j;c[y>>2]=c[p>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];u=23}else{y=c[b+36>>2]|0;z=c[b+32>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[j]=z<<1;A=j+1|0}else{B=z+16&-16;C=(x=0,as(230,B|0)|0);if(x){x=0;break}c[j+8>>2]=C;c[j>>2]=B|1;c[j+4>>2]=z;A=C}Kb(A|0,y|0,z)|0;a[A+z|0]=0;u=23;break L18}}while(0);z=bQ(-1,-1)|0;D=z;E=K}}while(0);do{if((u|0)==23){p=b+44|0;z=f;c[z>>2]=c[p>>2];c[z+4>>2]=c[p+4>>2];c[z+8>>2]=c[p+8>>2];x=0;aP(452,s|0,j|0,f|0);if(x){x=0;p=bQ(-1,-1)|0;z=p;p=K;if((a[j]&1)==0){D=z;E=p;break}J2(c[j+8>>2]|0);D=z;E=p;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}p=b+20|0;z=(x=0,as(60,c[p>>2]|0)|0);if(x){x=0;u=61;break L8}y=(a[z]|0)==40?z+1|0:0;L41:do{if((y|0)!=0){C=b+48|0;B=c[C>>2]|0;F=c[p>>2]|0;L43:do{if(F>>>0<y>>>0){G=F;H=0;while(1){I=a[G]|0;if((I<<24>>24|0)==10){J=H+1|0}else if((I<<24>>24|0)==0){L=H;break L43}else{J=H}I=G+1|0;if(I>>>0<y>>>0){G=I;H=J}else{L=J;break}}}else{L=0}}while(0);c[C>>2]=L+B;H=z;G=0;while(1){I=H-1|0;if(I>>>0<F>>>0){break}if((a[I]|0)==10){break}else{H=I;G=G+1|0}}H=b+40|0;if((L|0)!=0){c[H>>2]=1}F=c[H>>2]|0;B=b+52|0;c[B>>2]=F+G;I=y;M=z;c[H>>2]=I-M+G+F;F=m;c[F>>2]=M;c[F+4>>2]=I;c[p>>2]=y;I=(x=0,as(60,y|0)|0);if(x){x=0;u=61;break L8}L58:do{if((I+1|0)==0|(a[I]|0)!=41){M=v+28|0;N=M;O=v+36|0;P=O;Q=v+40|0;R=v+32|0;S=M;while(1){M=(x=0,as(160,b|0)|0);if(x){x=0;break}c[e>>2]=M;T=c[P>>2]|0;if((T|0)==(c[Q>>2]|0)){x=0;aq(490,R|0,e|0);if(x){x=0;break}U=c[e>>2]|0}else{if((T|0)==0){V=0}else{c[T>>2]=M;V=c[P>>2]|0}c[O>>2]=V+4;U=M}x=0;aq(c[c[S>>2]>>2]|0,N|0,U|0);if(x){x=0;break}M=(x=0,as(60,c[p>>2]|0)|0);if(x){x=0;break}T=(a[M]|0)==44?M+1|0:0;if((T|0)==0){break L58}W=c[C>>2]|0;X=c[p>>2]|0;L74:do{if(X>>>0<T>>>0){Y=X;Z=0;while(1){_=a[Y]|0;if((_<<24>>24|0)==10){$=Z+1|0}else if((_<<24>>24|0)==0){aa=Z;break L74}else{$=Z}_=Y+1|0;if(_>>>0<T>>>0){Y=_;Z=$}else{aa=$;break}}}else{aa=0}}while(0);c[C>>2]=aa+W;Z=M;Y=0;while(1){_=Z-1|0;if(_>>>0<X>>>0){break}if((a[_]|0)==10){break}else{Z=_;Y=Y+1|0}}if((aa|0)!=0){c[H>>2]=1}Z=c[H>>2]|0;c[B>>2]=Z+Y;X=T;W=M;c[H>>2]=X-W+Y+Z;c[F>>2]=W;c[F+4>>2]=X;c[p>>2]=T}N=bQ(-1,-1)|0;ab=K;ac=N;u=62;break L8}}while(0);I=(x=0,as(60,c[p>>2]|0)|0);if(x){x=0;u=61;break L8}G=(a[I]|0)==41?I+1|0:0;if((G|0)!=0){N=c[C>>2]|0;S=c[p>>2]|0;L93:do{if(S>>>0<G>>>0){O=S;P=0;while(1){R=a[O]|0;if((R<<24>>24|0)==0){ad=P;break L93}else if((R<<24>>24|0)==10){ae=P+1|0}else{ae=P}R=O+1|0;if(R>>>0<G>>>0){O=R;P=ae}else{ad=ae;break}}}else{ad=0}}while(0);c[C>>2]=ad+N;P=I;O=0;while(1){R=P-1|0;if(R>>>0<S>>>0){break}if((a[R]|0)==10){break}else{P=R;O=O+1|0}}if((ad|0)!=0){c[H>>2]=1}P=c[H>>2]|0;c[B>>2]=P+O;S=G;N=I;c[H>>2]=S-N+O+P;c[F>>2]=N;c[F+4>>2]=S;c[p>>2]=G;break}S=k;Ke(S|0,0,12)|0;N=h;P=r&255;if((P&1|0)==0){af=P>>>1}else{af=c[h+4>>2]|0}P=af+69|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(P>>>0<11>>>0){a[S]=-118;ag=k+1|0}else{C=af+85&-16;R=(x=0,as(230,C|0)|0);if(x){x=0;break}c[k+8>>2]=R;c[k>>2]=C|1;c[k+4>>2]=69;ag=R}Kb(ag|0,9496,69)|0;a[ag+69|0]=0;if((r&1)==0){ah=N+1|0}else{ah=c[h+8>>2]|0}x=0,ax(64,k|0,ah|0,af|0)|0;if(x){x=0;break}c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;x=0;aP(466,b|0,k|0,l|0);if(!x){if((a[S]&1)==0){break L41}J2(c[k+8>>2]|0);break L41}else{x=0;R=bQ(-1,-1)|0;C=R;R=K;if((a[S]&1)==0){ai=C;aj=R;break L8}J2(c[k+8>>2]|0);ai=C;aj=R;break L8}}}while(0);N=bQ(-1,-1)|0;P=K;if((a[S]&1)==0){ab=P;ac=N;u=62;break L8}J2(c[k+8>>2]|0);ab=P;ac=N;u=62;break L8}}while(0);if((a[h]&1)==0){i=d;return s|0}J2(c[h+8>>2]|0);i=d;return s|0}}while(0);s=c[o>>2]|0;p=c[t>>2]|0;y=s;while(1){if((y|0)==(p|0)){ak=p;break}if((c[y>>2]|0)==(v|0)){ak=y;break}else{y=y+4|0}}y=ak-s>>2;z=s+(y+1<<2)|0;N=p-z|0;Kc(s+(y<<2)|0,z|0,N|0)|0;z=s+((N>>2)+y<<2)|0;y=c[t>>2]|0;if((z|0)!=(y|0)){c[t>>2]=y+(~((y-4+(-z|0)|0)>>>2)<<2)}J2(n);ai=D;aj=E}else{x=0;u=61}}while(0);if((u|0)==61){E=bQ(-1,-1)|0;ab=K;ac=E;u=62}if((u|0)==62){ai=ac;aj=ab}if((a[h]&1)==0){al=ai;am=0;an=al;ao=aj;be(an|0)}J2(c[h+8>>2]|0);al=ai;am=0;an=al;ao=aj;be(an|0);return 0}function sr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0,eo=0,ep=0,eq=0,er=0,es=0,et=0,eu=0,ev=0,ew=0,ex=0,ey=0,ez=0,eA=0,eB=0,eC=0,eD=0,eE=0,eF=0,eG=0,eH=0,eI=0,eJ=0,eK=0,eL=0,eM=0,eN=0,eO=0,eP=0,eQ=0,eR=0,eS=0,eT=0,eU=0,eV=0,eW=0,eX=0,eY=0,eZ=0,e_=0,e$=0,e0=0,e1=0,e2=0,e3=0,e4=0,e5=0,e6=0,e7=0,e8=0,e9=0,fa=0,fb=0,fc=0,fd=0,fe=0,ff=0,fg=0,fh=0,fi=0,fj=0,fk=0,fl=0,fm=0,fn=0,fo=0,fp=0,fq=0,fr=0,fs=0,ft=0,fu=0,fv=0,fw=0,fx=0,fy=0,fz=0,fA=0,fB=0,fC=0,fD=0,fE=0,fF=0,fG=0,fH=0,fI=0,fJ=0,fK=0,fL=0,fM=0,fN=0,fO=0,fP=0,fQ=0,fR=0,fS=0,fT=0,fU=0,fV=0,fW=0,fX=0,fY=0,fZ=0,f_=0,f$=0,f0=0,f1=0,f2=0,f3=0,f4=0,f5=0,f6=0,f7=0,f8=0,f9=0,ga=0,gb=0,gc=0,gd=0,ge=0,gf=0,gg=0,gh=0,gi=0,gj=0,gk=0,gl=0,gm=0,gn=0,go=0,gp=0,gq=0,gr=0,gs=0,gt=0,gu=0,gv=0,gw=0,gx=0,gy=0,gz=0,gA=0,gB=0,gC=0,gD=0,gE=0,gF=0,gG=0,gH=0,gI=0,gJ=0,gK=0,gL=0,gM=0,gN=0,gO=0,gP=0,gQ=0,gR=0,gS=0,gT=0,gU=0,gV=0,gW=0,gX=0,gY=0,gZ=0;d=i;i=i+1e3|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+64|0;n=d+72|0;o=d+80|0;p=d+88|0;q=d+96|0;r=d+104|0;s=d+112|0;t=d+120|0;u=d+136|0;v=d+152|0;w=d+168|0;y=d+176|0;z=d+184|0;A=d+200|0;B=d+216|0;C=d+232|0;D=d+240|0;E=d+248|0;F=d+256|0;G=d+264|0;H=d+272|0;I=d+288|0;J=d+304|0;L=d+320|0;M=d+328|0;N=d+336|0;O=d+344|0;P=d+352|0;Q=d+360|0;R=d+368|0;S=d+376|0;T=d+392|0;U=d+400|0;V=d+408|0;W=d+416|0;X=d+424|0;Y=d+440|0;Z=d+448|0;_=d+456|0;$=d+464|0;aa=d+480|0;ab=d+488|0;ac=d+504|0;ad=d+512|0;ae=d+528|0;af=d+544|0;ag=d+560|0;ah=d+576|0;ai=d+592|0;aj=d+608|0;ak=d+624|0;al=d+640|0;am=d+656|0;an=d+672|0;ar=d+688|0;at=d+704|0;au=d+720|0;av=d+736|0;aw=d+752|0;ax=d+768|0;ay=d+784|0;az=d+800|0;aA=d+816|0;aB=d+832|0;aC=d+848|0;aD=d+856|0;aE=d+872|0;aF=d+888|0;aG=d+904|0;aH=d+912|0;aI=d+920|0;aJ=d+936|0;aK=d+952|0;aL=d+968|0;aM=d+984|0;aN=b+20|0;aO=xP(c[aN>>2]|0)|0;aQ=(a[aO]|0)==123?aO+1|0:0;if((aQ|0)!=0){aR=b+48|0;aS=c[aR>>2]|0;aU=c[aN>>2]|0;L3:do{if(aU>>>0<aQ>>>0){aV=aU;aW=0;while(1){aX=a[aV]|0;if((aX<<24>>24|0)==10){aY=aW+1|0}else if((aX<<24>>24|0)==0){aZ=aW;break L3}else{aY=aW}aX=aV+1|0;if(aX>>>0<aQ>>>0){aV=aX;aW=aY}else{aZ=aY;break}}}else{aZ=0}}while(0);c[aR>>2]=aZ+aS;aS=aO;aR=0;while(1){aY=aS-1|0;if(aY>>>0<aU>>>0){break}if((a[aY]|0)==10){break}else{aS=aY;aR=aR+1|0}}aS=b+40|0;if((aZ|0)!=0){c[aS>>2]=1}aZ=c[aS>>2]|0;c[b+52>>2]=aZ+aR;aU=aQ;aY=aO;c[aS>>2]=aU-aY+aR+aZ;aZ=b+56|0;c[aZ>>2]=aY;c[aZ+4>>2]=aU;c[aN>>2]=aQ}aQ=b|0;aU=c[aQ>>2]|0;aZ=J0(48)|0;c[ac>>2]=aZ;aY=aU+4|0;aR=c[aY>>2]|0;if((aR|0)==(c[aU+8>>2]|0)){ee(aU|0,ac);a_=c[ac>>2]|0}else{if((aR|0)==0){a$=0}else{c[aR>>2]=aZ;a$=c[aY>>2]|0}c[aY>>2]=a$+4;a_=aZ}aZ=a_;a$=a_;aR=b+28|0;L25:do{if((a[aR]&1)==0){ac=ad;c[ac>>2]=c[aR>>2];c[ac+4>>2]=c[aR+4>>2];c[ac+8>>2]=c[aR+8>>2];a0=27}else{ac=c[b+36>>2]|0;aS=c[b+32>>2]|0;do{if(aS>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aS>>>0<11>>>0){a[ad]=aS<<1;a1=ad+1|0}else{aO=aS+16&-16;aW=(x=0,as(230,aO|0)|0);if(x){x=0;break}c[ad+8>>2]=aW;c[ad>>2]=aO|1;c[ad+4>>2]=aS;a1=aW}Kb(a1|0,ac|0,aS)|0;a[a1+aS|0]=0;a0=27;break L25}}while(0);aS=bQ(-1,-1)|0;a2=aS;a3=K}}while(0);do{if((a0|0)==27){a1=b+44|0;aS=ab;c[aS>>2]=c[a1>>2];c[aS+4>>2]=c[a1+4>>2];c[aS+8>>2]=c[a1+8>>2];x=0;ao(4,a$|0,ad|0,ab|0,0,0);if(x){x=0;aS=bQ(-1,-1)|0;ac=aS;aS=K;if((a[ad]&1)==0){a2=ac;a3=aS;break}J2(c[ad+8>>2]|0);a2=ac;a3=aS;break}if((a[ad]&1)!=0){J2(c[ad+8>>2]|0)}aS=ae+8|0;ac=ae|0;aW=ae+4|0;aO=af|0;aV=af+4|0;aX=af+8|0;a4=ae;a5=b+48|0;a6=b+40|0;a7=b+52|0;a8=b+56|0;a9=a8;ba=ag;bb=ah;bc=ai;bd=a_+28|0;bf=bd;bg=a_+36|0;bh=bg;bi=a_+40|0;bj=a_+32|0;bk=bd;bd=ah+8|0;bl=b+36|0;bm=b+32|0;bn=ah+1|0;bo=ah|0;bp=ah+4|0;bq=ag+8|0;br=ag+1|0;bs=ag|0;bt=ag+4|0;bu=b+8|0;bv=ax+8|0;bw=ax|0;bx=ax+4|0;by=ay|0;bz=ay+4|0;bA=ay+8|0;bB=ax;bC=aG|0;bD=aI;bE=aJ;bF=aI+8|0;bG=aI+1|0;bH=aI|0;bI=aI+4|0;bJ=aG+4|0;bK=aH|0;bL=aH+4|0;bM=aC|0;bN=aD+8|0;bO=aD|0;bP=aD+4|0;bR=aE|0;bS=aE+4|0;bT=aE+8|0;bU=aD;bV=aC+4|0;bW=aF;bX=v;bY=t;bZ=u;b_=aF+8|0;b$=t+8|0;b0=aF+4|0;b1=t+1|0;b2=t|0;b3=t+4|0;b4=aF+1|0;b5=aF|0;b6=aB;b7=B;b8=z;b9=A;ca=aB+8|0;cb=z+8|0;cc=aB+4|0;cd=z+1|0;ce=z|0;cf=z+4|0;cg=aB+1|0;ch=aB|0;ci=az+8|0;cj=az|0;ck=az+4|0;cl=aA|0;cm=aA+4|0;cn=aA+8|0;co=az;cp=av;cq=aw;cr=J;cs=H;ct=I;cu=av+8|0;cv=H+8|0;cw=av+4|0;cx=H+1|0;cz=H|0;cA=H+4|0;cB=av+1|0;cC=av|0;cD=am+8|0;cE=am|0;cF=am+4|0;cG=an|0;cH=an+4|0;cI=an+8|0;cJ=am;cK=ar;cL=at;cM=au;cN=S;cO=ar+8|0;cP=au+8|0;cQ=au+1|0;cR=au|0;cS=au+4|0;cT=ar+1|0;cU=ar|0;cV=ar+4|0;cW=aj;cX=ak;cY=al;cZ=ak+8|0;c_=ak+1|0;c$=ak|0;c0=ak+4|0;c1=aj+8|0;c2=aj+1|0;c3=aj|0;c4=aj+4|0;c5=aK;c6=aL;c7=aM;c8=aL+8|0;c9=aL+1|0;da=aL|0;db=aL+4|0;dc=aK+8|0;dd=aK+1|0;de=aK|0;df=aK+4|0;dg=0;L47:while(1){dh=xP(c[aN>>2]|0)|0;di=(a[dh]|0)==125?dh+1|0:0;if((di|0)!=0){a0=32;break}if(dg){dj=xP(c[aN>>2]|0)|0;dk=(a[dj]|0)==59?dj+1|0:0;do{if((dk|0)==0){dl=J0(64)|0;c[aS>>2]=dl;c[ac>>2]=65;c[aW>>2]=55;Kb(dl|0,6992,55)|0;a[dl+55|0]=0;c[aO>>2]=0;c[aV>>2]=0;c[aX>>2]=0;x=0;aP(466,b|0,ae|0,af|0);if(x){x=0;a0=67;break L47}if((a[a4]&1)==0){break}J2(c[aS>>2]|0)}else{dl=c[a5>>2]|0;dm=c[aN>>2]|0;L57:do{if(dm>>>0<dk>>>0){dn=dm;dp=0;while(1){dq=a[dn]|0;if((dq<<24>>24|0)==0){dr=dp;break L57}else if((dq<<24>>24|0)==10){ds=dp+1|0}else{ds=dp}dq=dn+1|0;if(dq>>>0<dk>>>0){dn=dq;dp=ds}else{dr=ds;break}}}else{dr=0}}while(0);c[a5>>2]=dr+dl;dp=dj;dn=0;while(1){dq=dp-1|0;if(dq>>>0<dm>>>0){break}if((a[dq]|0)==10){break}else{dp=dq;dn=dn+1|0}}if((dr|0)!=0){c[a6>>2]=1}dp=c[a6>>2]|0;c[a7>>2]=dp+dn;dm=dk;dl=dj;c[a6>>2]=dm-dl+dn+dp;c[a9>>2]=dl;c[a9+4>>2]=dm;c[aN>>2]=dk}}while(0);if((r1(b)|0)!=0){do{dt=c[aQ>>2]|0;dk=J0(52)|0;c[aa>>2]=dk;du=dt+4|0;dj=c[du>>2]|0;if((dj|0)==(c[dt+8>>2]|0)){ee(dt|0,aa);dv=c[aa>>2]|0}else{if((dj|0)==0){dw=0}else{c[dj>>2]=dk;dw=c[du>>2]|0}c[du>>2]=dw+4;dv=dk}dx=dv;if((a[aR]&1)==0){c[ba>>2]=c[aR>>2];c[ba+4>>2]=c[aR+4>>2];c[ba+8>>2]=c[aR+8>>2]}else{dk=c[bl>>2]|0;dj=c[bm>>2]|0;if(dj>>>0>4294967279>>>0){a0=77;break L47}if(dj>>>0<11>>>0){a[ba]=dj<<1;dy=br}else{dm=dj+16&-16;dl=(x=0,as(230,dm|0)|0);if(x){x=0;a0=111;break L47}c[bq>>2]=dl;c[bs>>2]=dm|1;c[bt>>2]=dj;dy=dl}Kb(dy|0,dk|0,dj)|0;a[dy+dj|0]=0}dj=$;c[dj>>2]=c[a1>>2];c[dj+4>>2]=c[a1+4>>2];c[dj+8>>2]=c[a1+8>>2];x=0;ao(14,dv|0,ag|0,$|0,a8|0,0);if(x){x=0;a0=114;break L47}if((a[ba]&1)!=0){J2(c[bq>>2]|0)}dz=c[aQ>>2]|0;dj=J0(32)|0;c[_>>2]=dj;dA=dz+4|0;dk=c[dA>>2]|0;if((dk|0)==(c[dz+8>>2]|0)){ee(dz|0,_);dB=c[_>>2]|0}else{if((dk|0)==0){dC=0}else{c[dk>>2]=dj;dC=c[dA>>2]|0}c[dA>>2]=dC+4;dB=dj}dD=dB;if((a[aR]&1)==0){c[bb>>2]=c[aR>>2];c[bb+4>>2]=c[aR+4>>2];c[bb+8>>2]=c[aR+8>>2]}else{dj=c[bl>>2]|0;dk=c[bm>>2]|0;if(dk>>>0>4294967279>>>0){a0=95;break L47}if(dk>>>0<11>>>0){a[bb]=dk<<1;dE=bn}else{dl=dk+16&-16;dm=(x=0,as(230,dl|0)|0);if(x){x=0;a0=122;break L47}c[bd>>2]=dm;c[bo>>2]=dl|1;c[bp>>2]=dk;dE=dm}Kb(dE|0,dj|0,dk)|0;a[dE+dk|0]=0}c[bc>>2]=c[a1>>2];c[bc+4>>2]=c[a1+4>>2];c[bc+8>>2]=c[a1+8>>2];x=0;aT(34,dB|0,ah|0,ai|0,dv|0);if(x){x=0;a0=125;break L47}if((a[bb]&1)!=0){J2(c[bd>>2]|0)}dk=dB;c[Z>>2]=dk;dj=c[bh>>2]|0;if((dj|0)==(c[bi>>2]|0)){lM(bj,Z);dF=c[Z>>2]|0}else{if((dj|0)==0){dG=0}else{c[dj>>2]=dk;dG=c[bh>>2]|0}c[bg>>2]=dG+4;dF=dk}cy[c[c[bk>>2]>>2]&1023](bf,dF);}while((r1(b)|0)!=0)}dH=xP(c[aN>>2]|0)|0;dI=(a[dH]|0)==125?dH+1|0:0;if((dI|0)!=0){a0=134;break}}L126:do{if((r1(b)|0)==0){if((xV(xP(c[aN>>2]|0)|0)|0)!=0){do{if(((c[(c[bu>>2]|0)-4>>2]|0)-1|0)>>>0<2>>>0){sl(b)|0;dk=J0(64)|0;c[cD>>2]=dk;c[cE>>2]=65;c[cF>>2]=62;Kb(dk|0,6768,62)|0;a[dk+62|0]=0;c[cG>>2]=0;c[cH>>2]=0;c[cI>>2]=0;x=0;aP(466,b|0,am|0,an|0);if(x){x=0;a0=214;break L47}if((a[cJ]&1)==0){break}J2(c[cD>>2]|0)}}while(0);dn=r3(b)|0;if((c[dn+40>>2]|0)!=(c[dn+44>>2]|0)){dk=dn|0;c[U>>2]=dk;dj=c[bh>>2]|0;if((dj|0)==(c[bi>>2]|0)){lM(bj,U);dJ=c[U>>2]|0}else{if((dj|0)==0){dK=0}else{c[dj>>2]=dk;dK=c[bh>>2]|0}c[bg>>2]=dK+4;dJ=dk}cy[c[c[bk>>2]>>2]&1023](bf,dJ)}dk=dn+28|0;dj=c[dk>>2]|0;dm=c[dn+32>>2]|0;if((dj|0)==(dm|0)){dL=1;break}dn=(dm-dj|0)/12|0;dj=0;while(1){dM=c[aQ>>2]|0;dm=J0(40)|0;c[T>>2]=dm;dN=dM+4|0;dl=c[dN>>2]|0;if((dl|0)==(c[dM+8>>2]|0)){ee(dM|0,T);dO=c[T>>2]|0}else{if((dl|0)==0){dP=0}else{c[dl>>2]=dm;dP=c[dN>>2]|0}c[dN>>2]=dP+4;dO=dm}dQ=dO;dm=dO;if((a[aR]&1)==0){c[cK>>2]=c[aR>>2];c[cK+4>>2]=c[aR+4>>2];c[cK+8>>2]=c[aR+8>>2]}else{dl=c[bl>>2]|0;dp=c[bm>>2]|0;if(dp>>>0>4294967279>>>0){a0=233;break L47}if(dp>>>0<11>>>0){a[cK]=dp<<1;dR=cT}else{dq=dp+16&-16;dS=(x=0,as(230,dq|0)|0);if(x){x=0;a0=263;break L47}c[cO>>2]=dS;c[cU>>2]=dq|1;c[cV>>2]=dp;dR=dS}Kb(dR|0,dl|0,dp)|0;a[dR+dp|0]=0}c[cL>>2]=c[a1>>2];c[cL+4>>2]=c[a1+4>>2];c[cL+8>>2]=c[a1+8>>2];dp=c[dk>>2]|0;dl=dp+(dj*12|0)|0;if((a[dl]&1)==0){c[cM>>2]=c[dl>>2];c[cM+4>>2]=c[dl+4>>2];c[cM+8>>2]=c[dl+8>>2]}else{dl=c[dp+(dj*12|0)+8>>2]|0;dS=c[dp+(dj*12|0)+4>>2]|0;if(dS>>>0>4294967279>>>0){a0=243;break L47}if(dS>>>0<11>>>0){a[cM]=dS<<1;dT=cQ}else{dp=dS+16&-16;dq=(x=0,as(230,dp|0)|0);if(x){x=0;a0=266;break L47}c[cP>>2]=dq;c[cR>>2]=dp|1;c[cS>>2]=dS;dT=dq}Kb(dT|0,dl|0,dS)|0;a[dT+dS|0]=0}c[cN>>2]=c[cL>>2];c[cN+4>>2]=c[cL+4>>2];c[cN+8>>2]=c[cL+8>>2];x=0;aT(26,dm|0,ar|0,S|0,au|0);if(x){x=0;dU=1;a0=269;break L47}dm=dO;c[R>>2]=dm;dS=c[bh>>2]|0;if((dS|0)==(c[bi>>2]|0)){x=0;aq(476,bj|0,R|0);if(x){x=0;dU=0;a0=269;break L47}dV=c[R>>2]|0}else{if((dS|0)==0){dW=0}else{c[dS>>2]=dm;dW=c[bh>>2]|0}c[bg>>2]=dW+4;dV=dm}x=0;aq(c[c[bk>>2]>>2]|0,bf|0,dV|0);if(x){x=0;dU=0;a0=269;break L47}if((a[cM]&1)!=0){J2(c[cP>>2]|0)}if((a[cK]&1)!=0){J2(c[cO>>2]|0)}dm=dj+1|0;if(dm>>>0<dn>>>0){dj=dm}else{dL=1;break L126}}}if((st(b)|0)!=0){dj=r6(b)|0;c[Q>>2]=dj;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){lM(bj,Q);dX=c[Q>>2]|0}else{if((dn|0)==0){dY=0}else{c[dn>>2]=dj;dY=c[bh>>2]|0}c[bg>>2]=dY+4;dX=dj}cy[c[c[bk>>2]>>2]&1023](bf,dX);dL=1;break}if((x1(xP(c[aN>>2]|0)|0)|0)!=0){dj=r9(b,0)|0;c[P>>2]=dj;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){lM(bj,P);dZ=c[P>>2]|0}else{if((dn|0)==0){d_=0}else{c[dn>>2]=dj;d_=c[bh>>2]|0}c[bg>>2]=d_+4;dZ=dj}cy[c[c[bk>>2]>>2]&1023](bf,dZ);dL=0;break}if((x3(xP(c[aN>>2]|0)|0)|0)!=0){dj=sa(b)|0;c[O>>2]=dj;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){lM(bj,O);d$=c[O>>2]|0}else{if((dn|0)==0){d0=0}else{c[dn>>2]=dj;d0=c[bh>>2]|0}c[bg>>2]=d0+4;d$=dj}cy[c[c[bk>>2]>>2]&1023](bf,d$);dL=0;break}if((x7(xP(c[aN>>2]|0)|0)|0)!=0){dj=sb(b)|0;c[N>>2]=dj;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){lM(bj,N);d1=c[N>>2]|0}else{if((dn|0)==0){d2=0}else{c[dn>>2]=dj;d2=c[bh>>2]|0}c[bg>>2]=d2+4;d1=dj}cy[c[c[bk>>2]>>2]&1023](bf,d1);dL=0;break}if((x9(xP(c[aN>>2]|0)|0)|0)!=0){dj=sc(b)|0;c[M>>2]=dj;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){lM(bj,M);d3=c[M>>2]|0}else{if((dn|0)==0){d4=0}else{c[dn>>2]=dj;d4=c[bh>>2]|0}c[bg>>2]=d4+4;d3=dj}cy[c[c[bk>>2]>>2]&1023](bf,d3);dL=0;break}if((s1(b)|0)!=0){d5=c[aQ>>2]|0;dj=J0(32)|0;c[L>>2]=dj;d6=d5+4|0;dn=c[d6>>2]|0;if((dn|0)==(c[d5+8>>2]|0)){ee(d5|0,L);d7=c[L>>2]|0}else{if((dn|0)==0){d8=0}else{c[dn>>2]=dj;d8=c[d6>>2]|0}c[d6>>2]=d8+4;d7=dj}d9=d7;if((a[aR]&1)==0){c[cp>>2]=c[aR>>2];c[cp+4>>2]=c[aR+4>>2];c[cp+8>>2]=c[aR+8>>2]}else{dj=c[bl>>2]|0;dn=c[bm>>2]|0;if(dn>>>0>4294967279>>>0){a0=324;break L47}if(dn>>>0<11>>>0){a[cp]=dn<<1;ea=cB}else{dk=dn+16&-16;dm=(x=0,as(230,dk|0)|0);if(x){x=0;a0=356;break L47}c[cu>>2]=dm;c[cC>>2]=dk|1;c[cw>>2]=dn;ea=dm}Kb(ea|0,dj|0,dn)|0;a[ea+dn|0]=0}c[cq>>2]=c[a1>>2];c[cq+4>>2]=c[a1+4>>2];c[cq+8>>2]=c[a1+8>>2];dn=(x=0,as(158,b|0)|0);if(x){x=0;eb=1;a0=359;break L47}c[cr>>2]=c[cq>>2];c[cr+4>>2]=c[cq+4>>2];c[cr+8>>2]=c[cq+8>>2];dj=d7;ec=a[cp]|0;dm=(ec&1)==0;if(dm){c[cs>>2]=c[cp>>2];c[cs+4>>2]=c[cp+4>>2];c[cs+8>>2]=c[cp+8>>2]}else{dk=c[cu>>2]|0;dS=c[cw>>2]|0;if(dS>>>0>4294967279>>>0){a0=335;break L47}if(dS>>>0<11>>>0){a[cs]=dS<<1;ed=cx}else{dl=dS+16&-16;dq=(x=0,as(230,dl|0)|0);if(x){x=0;eb=1;a0=359;break L47}c[cv>>2]=dq;c[cz>>2]=dl|1;c[cA>>2]=dS;ed=dq}Kb(ed|0,dk|0,dS)|0;a[ed+dS|0]=0}c[ct>>2]=c[cr>>2];c[ct+4>>2]=c[cr+4>>2];c[ct+8>>2]=c[cr+8>>2];x=0;aP(402,dj|0,H|0,I|0);if(x){x=0;a0=345;break L47}if((a[cs]&1)!=0){J2(c[cv>>2]|0)}c[d7>>2]=17504;c[d7+28>>2]=dn;c[G>>2]=dj;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){x=0;aq(476,bj|0,G|0);if(x){x=0;eb=0;a0=359;break L47}ef=c[G>>2]|0}else{if((dn|0)==0){eg=0}else{c[dn>>2]=dj;eg=c[bh>>2]|0}c[bg>>2]=eg+4;ef=dj}x=0;aq(c[c[bk>>2]>>2]|0,bf|0,ef|0);if(x){x=0;eb=0;a0=359;break L47}if(dm){dL=1;break}J2(c[cu>>2]|0);dL=1;break}if((ya(xP(c[aN>>2]|0)|0)|0)!=0){dm=se(b)|0;c[F>>2]=dm;dj=c[bh>>2]|0;if((dj|0)==(c[bi>>2]|0)){lM(bj,F);eh=c[F>>2]|0}else{if((dj|0)==0){ei=0}else{c[dj>>2]=dm;ei=c[bh>>2]|0}c[bg>>2]=ei+4;eh=dm}cy[c[c[bk>>2]>>2]&1023](bf,eh);dL=1;break}if((c[(c[bu>>2]|0)-4>>2]|0)==2){dm=J0(80)|0;c[bv>>2]=dm;c[bw>>2]=81;c[bx>>2]=78;Kb(dm|0,6480,78)|0;a[dm+78|0]=0;c[by>>2]=0;c[bz>>2]=0;c[bA>>2]=0;x=0;aP(466,b|0,ax|0,ay|0);if(x){x=0;a0=381;break L47}if((a[bB]&1)==0){dL=0;break}J2(c[bv>>2]|0);dL=0;break}do{if((xX(xP(c[aN>>2]|0)|0)|0)==0){if((xY(xP(c[aN>>2]|0)|0)|0)!=0){break}if((x_(xP(c[aN>>2]|0)|0)|0)!=0){dm=r8(b)|0;dj=dm|0;c[D>>2]=dj;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){lM(bj,D);ej=c[D>>2]|0}else{if((dn|0)==0){ek=0}else{c[dn>>2]=dj;ek=c[bh>>2]|0}c[bg>>2]=ek+4;ej=dj}cy[c[c[bk>>2]>>2]&1023](bf,ej);dL=(c[dm+28>>2]|0)==0;break L126}if((s2(b)|0)!=0){do{if((c[(c[bu>>2]|0)-4>>2]|0)!=1){dm=J0(48)|0;c[ci>>2]=dm;c[cj>>2]=49;c[ck>>2]=40;Kb(dm|0,6216,40)|0;a[dm+40|0]=0;c[cl>>2]=0;c[cm>>2]=0;c[cn>>2]=0;x=0;aP(466,b|0,az|0,aA|0);if(x){x=0;a0=403;break L47}if((a[co]&1)==0){break}J2(c[ci>>2]|0)}}while(0);el=c[aQ>>2]|0;dm=J0(28)|0;c[C>>2]=dm;em=el+4|0;dj=c[em>>2]|0;if((dj|0)==(c[el+8>>2]|0)){ee(el|0,C);en=c[C>>2]|0}else{if((dj|0)==0){eo=0}else{c[dj>>2]=dm;eo=c[em>>2]|0}c[em>>2]=eo+4;en=dm}ep=en;if((a[aR]&1)==0){c[b6>>2]=c[aR>>2];c[b6+4>>2]=c[aR+4>>2];c[b6+8>>2]=c[aR+8>>2];eq=a[b6]|0}else{dm=c[bl>>2]|0;dj=c[bm>>2]|0;if(dj>>>0>4294967279>>>0){a0=413;break L47}if(dj>>>0<11>>>0){dn=dj<<1&255;a[b6]=dn;er=cg;es=dn}else{dn=dj+16&-16;dS=(x=0,as(230,dn|0)|0);if(x){x=0;a0=444;break L47}c[ca>>2]=dS;dk=dn|1;c[ch>>2]=dk;c[cc>>2]=dj;er=dS;es=dk&255}Kb(er|0,dm|0,dj)|0;a[er+dj|0]=0;eq=es}dj=B;c[dj>>2]=c[a1>>2];c[dj+4>>2]=c[a1+4>>2];c[dj+8>>2]=c[a1+8>>2];dj=en;if((eq&1)==0){c[b8>>2]=c[b6>>2];c[b8+4>>2]=c[b6+4>>2];c[b8+8>>2]=c[b6+8>>2]}else{dm=c[ca>>2]|0;dk=c[cc>>2]|0;if(dk>>>0>4294967279>>>0){a0=423;break L47}if(dk>>>0<11>>>0){a[b8]=dk<<1;et=cd}else{dS=dk+16&-16;dn=(x=0,as(230,dS|0)|0);if(x){x=0;eu=1;a0=447;break L47}c[cb>>2]=dn;c[ce>>2]=dS|1;c[cf>>2]=dk;et=dn}Kb(et|0,dm|0,dk)|0;a[et+dk|0]=0}c[b9>>2]=c[b7>>2];c[b9+4>>2]=c[b7+4>>2];c[b9+8>>2]=c[b7+8>>2];x=0;aP(402,dj|0,z|0,A|0);if(x){x=0;a0=433;break L47}if((a[b8]&1)!=0){J2(c[cb>>2]|0)}c[en>>2]=17168;c[y>>2]=dj;dk=c[bh>>2]|0;if((dk|0)==(c[bi>>2]|0)){x=0;aq(476,bj|0,y|0);if(x){x=0;eu=0;a0=447;break L47}ev=c[y>>2]|0}else{if((dk|0)==0){ew=0}else{c[dk>>2]=dj;ew=c[bh>>2]|0}c[bg>>2]=ew+4;ev=dj}x=0;aq(c[c[bk>>2]>>2]|0,bf|0,ev|0);if(x){x=0;eu=0;a0=447;break L47}if((eq&1)==0){dL=1;break L126}J2(c[ca>>2]|0);dL=1;break L126}dj=(s3(b)|0)==0;dk=c[aN>>2]|0;if(!dj){s4(aC,b,dk);dj=c[bM>>2]|0;do{if((dj|0)==0){dm=J0(32)|0;c[bN>>2]=dm;c[bO>>2]=33;c[bP>>2]=28;Kb(dm|0,6032,28)|0;a[dm+28|0]=0;c[bR>>2]=0;c[bS>>2]=0;c[bT>>2]=0;x=0;aP(466,b|0,aD|0,aE|0);if(x){x=0;a0=463;break L47}if((a[bU]&1)==0){break}J2(c[bN>>2]|0)}}while(0);if((a[bV]&1)==0){ex=sE(b)|0}else{ex=sD(b,dj)|0}ey=c[aQ>>2]|0;dm=J0(32)|0;c[w>>2]=dm;ez=ey+4|0;dn=c[ez>>2]|0;if((dn|0)==(c[ey+8>>2]|0)){ee(ey|0,w);eA=c[w>>2]|0}else{if((dn|0)==0){eB=0}else{c[dn>>2]=dm;eB=c[ez>>2]|0}c[ez>>2]=eB+4;eA=dm}eC=eA;if((a[aR]&1)==0){c[bW>>2]=c[aR>>2];c[bW+4>>2]=c[aR+4>>2];c[bW+8>>2]=c[aR+8>>2];eD=a[bW]|0}else{dm=c[bl>>2]|0;dn=c[bm>>2]|0;if(dn>>>0>4294967279>>>0){a0=476;break L47}if(dn>>>0<11>>>0){dS=dn<<1&255;a[bW]=dS;eE=b4;eF=dS}else{dS=dn+16&-16;dq=(x=0,as(230,dS|0)|0);if(x){x=0;a0=507;break L47}c[b_>>2]=dq;dl=dS|1;c[b5>>2]=dl;c[b0>>2]=dn;eE=dq;eF=dl&255}Kb(eE|0,dm|0,dn)|0;a[eE+dn|0]=0;eD=eF}dn=v;c[dn>>2]=c[a1>>2];c[dn+4>>2]=c[a1+4>>2];c[dn+8>>2]=c[a1+8>>2];dn=eA;if((eD&1)==0){c[bY>>2]=c[bW>>2];c[bY+4>>2]=c[bW+4>>2];c[bY+8>>2]=c[bW+8>>2]}else{dm=c[b_>>2]|0;dl=c[b0>>2]|0;if(dl>>>0>4294967279>>>0){a0=486;break L47}if(dl>>>0<11>>>0){a[bY]=dl<<1;eG=b1}else{dq=dl+16&-16;dS=(x=0,as(230,dq|0)|0);if(x){x=0;eH=1;a0=510;break L47}c[b$>>2]=dS;c[b2>>2]=dq|1;c[b3>>2]=dl;eG=dS}Kb(eG|0,dm|0,dl)|0;a[eG+dl|0]=0}c[bZ>>2]=c[bX>>2];c[bZ+4>>2]=c[bX+4>>2];c[bZ+8>>2]=c[bX+8>>2];x=0;aP(402,dn|0,t|0,u|0);if(x){x=0;a0=496;break L47}if((a[bY]&1)!=0){J2(c[b$>>2]|0)}c[eA>>2]=16256;c[eA+28>>2]=ex;c[s>>2]=dn;dl=c[bh>>2]|0;if((dl|0)==(c[bi>>2]|0)){x=0;aq(476,bj|0,s|0);if(x){x=0;eH=0;a0=510;break L47}eI=c[s>>2]|0}else{if((dl|0)==0){eJ=0}else{c[dl>>2]=dn;eJ=c[bh>>2]|0}c[bg>>2]=eJ+4;eI=dn}x=0;aq(c[c[bk>>2]>>2]|0,bf|0,eI|0);if(x){x=0;eH=0;a0=510;break L47}if((eD&1)==0){dL=1;break L126}J2(c[b_>>2]|0);dL=1;break L126}if((xW(xP(dk)|0)|0)!=0){dn=sd(b)|0;c[r>>2]=dn;dl=c[bh>>2]|0;if((dl|0)==(c[bi>>2]|0)){lM(bj,r);eK=c[r>>2]|0}else{if((dl|0)==0){eL=0}else{c[dl>>2]=dn;eL=c[bh>>2]|0}c[bg>>2]=eL+4;eK=dn}cy[c[c[bk>>2]>>2]&1023](bf,eK);dL=0;break L126}if((sf(b)|0)!=0){sg(b)|0;dn=xP(c[aN>>2]|0)|0;dl=(a[dn]|0)==59?dn+1|0:0;if((dl|0)==0){dL=0;break L126}dm=c[a5>>2]|0;dS=c[aN>>2]|0;L480:do{if(dS>>>0<dl>>>0){dq=dS;dp=0;while(1){eM=a[dq]|0;if((eM<<24>>24|0)==10){eN=dp+1|0}else if((eM<<24>>24|0)==0){eO=dp;break L480}else{eN=dp}eM=dq+1|0;if(eM>>>0<dl>>>0){dq=eM;dp=eN}else{eO=eN;break}}}else{eO=0}}while(0);c[a5>>2]=eO+dm;dk=dn;dj=0;while(1){dp=dk-1|0;if(dp>>>0<dS>>>0){break}if((a[dp]|0)==10){break}else{dk=dp;dj=dj+1|0}}if((eO|0)!=0){c[a6>>2]=1}dk=c[a6>>2]|0;c[a7>>2]=dk+dj;dS=dl;dm=dn;c[a6>>2]=dS-dm+dj+dk;c[a9>>2]=dm;c[a9+4>>2]=dS;c[aN>>2]=dl;dL=0;break L126}if((xU(xP(c[aN>>2]|0)|0)|0)!=0){dS=sh(b)|0;dm=dS|0;c[q>>2]=dm;dk=c[bh>>2]|0;if((dk|0)==(c[bi>>2]|0)){lM(bj,q);eP=c[q>>2]|0}else{if((dk|0)==0){eQ=0}else{c[dk>>2]=dm;eQ=c[bh>>2]|0}c[bg>>2]=eQ+4;eP=dm}cy[c[c[bk>>2]>>2]&1023](bf,eP);dL=(c[dS+28>>2]|0)==0;break L126}si(aG,b,c[aN>>2]|0);dS=c[bC>>2]|0;if((dS|0)!=0){dm=c[bJ>>2]|0;c[bK>>2]=dS;c[bL>>2]=dm;dm=sj(b,aH)|0;c[p>>2]=dm;dS=c[bh>>2]|0;if((dS|0)==(c[bi>>2]|0)){lM(bj,p);eR=c[p>>2]|0}else{if((dS|0)==0){eS=0}else{c[dS>>2]=dm;eS=c[bh>>2]|0}c[bg>>2]=eS+4;eR=dm}cy[c[c[bk>>2]>>2]&1023](bf,eR);dL=0;break L126}dm=xP(c[aN>>2]|0)|0;dS=(a[dm]|0)==42?dm+1|0:0;dk=(dS|0)!=0?dS:dm;do{if((dk|0)!=0){dm=xR(dk)|0;if((dm|0)==0){dS=xQ(dk)|0;if((dS|0)==0){break}else{eT=dS}}else{eT=dm}dm=xO(eT)|0;if((dm|0)==0){break}dS=(a[dm]|0)==58?dm+1|0:0;if((dS|0)==0){break}dm=xO(dS)|0;if((dm|0)==0){break}if((dm+1|0)==0|(a[dm]|0)!=123){break}dm=r7(b)|0;c[o>>2]=dm;dS=c[bh>>2]|0;if((dS|0)==(c[bi>>2]|0)){lM(bj,o);eU=c[o>>2]|0}else{if((dS|0)==0){eV=0}else{c[dS>>2]=dm;eV=c[bh>>2]|0}c[bg>>2]=eV+4;eU=dm}cy[c[c[bk>>2]>>2]&1023](bf,eU);dL=0;break L126}}while(0);dk=xP(c[aN>>2]|0)|0;dl=(dk+1|0)==0|(a[dk]|0)!=59;dk=xP(c[aN>>2]|0)|0;dj=a[dk]|0;if(!dl){dl=dj<<24>>24==59?dk+1|0:0;if((dl|0)==0){dL=0;break L126}dn=c[a5>>2]|0;dm=c[aN>>2]|0;L535:do{if(dm>>>0<dl>>>0){dS=dm;dp=0;while(1){dq=a[dS]|0;if((dq<<24>>24|0)==10){eW=dp+1|0}else if((dq<<24>>24|0)==0){eX=dp;break L535}else{eW=dp}dq=dS+1|0;if(dq>>>0<dl>>>0){dS=dq;dp=eW}else{eX=eW;break}}}else{eX=0}}while(0);c[a5>>2]=eX+dn;dp=dk;dS=0;while(1){dq=dp-1|0;if(dq>>>0<dm>>>0){break}if((a[dq]|0)==10){break}else{dp=dq;dS=dS+1|0}}if((eX|0)!=0){c[a6>>2]=1}dp=c[a6>>2]|0;c[a7>>2]=dp+dS;dm=dl;dn=dk;c[a6>>2]=dm-dn+dS+dp;c[a9>>2]=dn;c[a9+4>>2]=dm;c[aN>>2]=dl;dL=0;break L126}dm=dj<<24>>24==42?dk+1|0:0;dn=(dm|0)!=0?dm:dk;do{if((dn|0)!=0){dm=xR(dn)|0;if((dm|0)==0){break}dp=(a[dm]|0)==58?dm+1|0:0;if((dp|0)==0){break}if((dp+1|0)==0|(a[dp]|0)!=123){break}dp=r7(b)|0;c[n>>2]=dp;dm=c[bh>>2]|0;if((dm|0)==(c[bi>>2]|0)){lM(bj,n);eY=c[n>>2]|0}else{if((dm|0)==0){eZ=0}else{c[dm>>2]=dp;eZ=c[bh>>2]|0}c[bg>>2]=eZ+4;eY=dp}cy[c[c[bk>>2]>>2]&1023](bf,eY);dL=0;break L126}}while(0);dn=xP(c[aN>>2]|0)|0;dk=(a[dn]|0)==42?dn+1|0:0;dj=(dk|0)!=0?dk:dn;do{if((dj|0)!=0){dn=xQ(dj)|0;if((dn|0)==0){break}dk=(a[dn]|0)==58?dn+1|0:0;if((dk|0)==0){break}if((dk+1|0)==0|(a[dk]|0)!=123){break}dk=r7(b)|0;c[m>>2]=dk;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){lM(bj,m);e_=c[m>>2]|0}else{if((dn|0)==0){e$=0}else{c[dn>>2]=dk;e$=c[bh>>2]|0}c[bg>>2]=e$+4;e_=dk}cy[c[c[bk>>2]>>2]&1023](bf,e_);dL=0;break L126}}while(0);dj=s5(b)|0;dk=dj|0;c[l>>2]=dk;dn=c[bh>>2]|0;if((dn|0)==(c[bi>>2]|0)){lM(bj,l);e0=c[l>>2]|0}else{if((dn|0)==0){e1=0}else{c[dn>>2]=dk;e1=c[bh>>2]|0}c[bg>>2]=e1+4;e0=dk}cy[c[c[bk>>2]>>2]&1023](bf,e0);dk=xP(c[aN>>2]|0)|0;if((dk+1|0)==0|(a[dk]|0)!=123){dL=1;break L126}e2=c[aQ>>2]|0;dk=J0(36)|0;c[k>>2]=dk;e3=e2+4|0;dn=c[e3>>2]|0;if((dn|0)==(c[e2+8>>2]|0)){ee(e2|0,k);e4=c[k>>2]|0}else{if((dn|0)==0){e5=0}else{c[dn>>2]=dk;e5=c[e3>>2]|0}c[e3>>2]=e5+4;e4=dk}e6=e4;dk=e4;if((a[aR]&1)==0){c[bD>>2]=c[aR>>2];c[bD+4>>2]=c[aR+4>>2];c[bD+8>>2]=c[aR+8>>2]}else{dn=c[bl>>2]|0;dl=c[bm>>2]|0;if(dl>>>0>4294967279>>>0){a0=602;break L47}if(dl>>>0<11>>>0){a[bD]=dl<<1;e7=bG}else{dS=dl+16&-16;dp=(x=0,as(230,dS|0)|0);if(x){x=0;a0=619;break L47}c[bF>>2]=dp;c[bH>>2]=dS|1;c[bI>>2]=dl;e7=dp}Kb(e7|0,dn|0,dl)|0;a[e7+dl|0]=0}c[bE>>2]=c[a1>>2];c[bE+4>>2]=c[a1+4>>2];c[bE+8>>2]=c[a1+8>>2];dl=c[dj+28>>2]|0;dj=(x=0,as(228,b|0)|0);if(x){x=0;a0=622;break L47}x=0;ao(12,dk|0,aI|0,aJ|0,dl|0,dj|0);if(x){x=0;a0=622;break L47}if((a[bD]&1)!=0){J2(c[bF>>2]|0)}dj=e4;c[j>>2]=dj;dl=c[bh>>2]|0;if((dl|0)==(c[bi>>2]|0)){lM(bj,j);e8=c[j>>2]|0}else{if((dl|0)==0){e9=0}else{c[dl>>2]=dj;e9=c[bh>>2]|0}c[bg>>2]=e9+4;e8=dj}cy[c[c[bk>>2]>>2]&1023](bf,e8);dL=0;break L126}}while(0);dj=r5(b)|0;c[E>>2]=dj;dl=c[bh>>2]|0;if((dl|0)==(c[bi>>2]|0)){lM(bj,E);fa=c[E>>2]|0}else{if((dl|0)==0){fb=0}else{c[dl>>2]=dj;fb=c[bh>>2]|0}c[bg>>2]=fb+4;fa=dj}cy[c[c[bk>>2]>>2]&1023](bf,fa);dL=0}else{fc=c[aQ>>2]|0;dj=J0(52)|0;c[Y>>2]=dj;fd=fc+4|0;dl=c[fd>>2]|0;if((dl|0)==(c[fc+8>>2]|0)){ee(fc|0,Y);fe=c[Y>>2]|0}else{if((dl|0)==0){ff=0}else{c[dl>>2]=dj;ff=c[fd>>2]|0}c[fd>>2]=ff+4;fe=dj}fg=fe;if((a[aR]&1)==0){c[cW>>2]=c[aR>>2];c[cW+4>>2]=c[aR+4>>2];c[cW+8>>2]=c[aR+8>>2]}else{dj=c[bl>>2]|0;dl=c[bm>>2]|0;if(dl>>>0>4294967279>>>0){a0=153;break L47}if(dl>>>0<11>>>0){a[cW]=dl<<1;fh=c2}else{dk=dl+16&-16;dn=(x=0,as(230,dk|0)|0);if(x){x=0;a0=187;break L47}c[c1>>2]=dn;c[c3>>2]=dk|1;c[c4>>2]=dl;fh=dn}Kb(fh|0,dj|0,dl)|0;a[fh+dl|0]=0}dl=X;c[dl>>2]=c[a1>>2];c[dl+4>>2]=c[a1+4>>2];c[dl+8>>2]=c[a1+8>>2];x=0;ao(14,fe|0,aj|0,X|0,a8|0,0);if(x){x=0;a0=190;break L47}if((a[cW]&1)!=0){J2(c[c1>>2]|0)}fi=c[aQ>>2]|0;dl=J0(32)|0;c[W>>2]=dl;fj=fi+4|0;dj=c[fj>>2]|0;if((dj|0)==(c[fi+8>>2]|0)){ee(fi|0,W);fk=c[W>>2]|0}else{if((dj|0)==0){fl=0}else{c[dj>>2]=dl;fl=c[fj>>2]|0}c[fj>>2]=fl+4;fk=dl}fm=fk;if((a[aR]&1)==0){c[cX>>2]=c[aR>>2];c[cX+4>>2]=c[aR+4>>2];c[cX+8>>2]=c[aR+8>>2]}else{dl=c[bl>>2]|0;dj=c[bm>>2]|0;if(dj>>>0>4294967279>>>0){a0=171;break L47}if(dj>>>0<11>>>0){a[cX]=dj<<1;fn=c_}else{dn=dj+16&-16;dk=(x=0,as(230,dn|0)|0);if(x){x=0;a0=198;break L47}c[cZ>>2]=dk;c[c$>>2]=dn|1;c[c0>>2]=dj;fn=dk}Kb(fn|0,dl|0,dj)|0;a[fn+dj|0]=0}c[cY>>2]=c[a1>>2];c[cY+4>>2]=c[a1+4>>2];c[cY+8>>2]=c[a1+8>>2];x=0;aT(34,fk|0,ak|0,al|0,fe|0);if(x){x=0;a0=201;break L47}if((a[cX]&1)!=0){J2(c[cZ>>2]|0)}dj=fk;c[V>>2]=dj;dl=c[bh>>2]|0;if((dl|0)==(c[bi>>2]|0)){lM(bj,V);fo=c[V>>2]|0}else{if((dl|0)==0){fp=0}else{c[dl>>2]=dj;fp=c[bh>>2]|0}c[bg>>2]=fp+4;fo=dj}cy[c[c[bk>>2]>>2]&1023](bf,fo);dL=0}}while(0);if((r1(b)|0)==0){dg=dL;continue}while(1){fq=c[aQ>>2]|0;dj=J0(52)|0;c[h>>2]=dj;fr=fq+4|0;dl=c[fr>>2]|0;if((dl|0)==(c[fq+8>>2]|0)){ee(fq|0,h);fs=c[h>>2]|0}else{if((dl|0)==0){ft=0}else{c[dl>>2]=dj;ft=c[fr>>2]|0}c[fr>>2]=ft+4;fs=dj}fu=fs;if((a[aR]&1)==0){c[c5>>2]=c[aR>>2];c[c5+4>>2]=c[aR+4>>2];c[c5+8>>2]=c[aR+8>>2]}else{dj=c[bl>>2]|0;dl=c[bm>>2]|0;if(dl>>>0>4294967279>>>0){a0=650;break L47}if(dl>>>0<11>>>0){a[c5]=dl<<1;fv=dd}else{dk=dl+16&-16;dn=(x=0,as(230,dk|0)|0);if(x){x=0;a0=684;break L47}c[dc>>2]=dn;c[de>>2]=dk|1;c[df>>2]=dl;fv=dn}Kb(fv|0,dj|0,dl)|0;a[fv+dl|0]=0}dl=g;c[dl>>2]=c[a1>>2];c[dl+4>>2]=c[a1+4>>2];c[dl+8>>2]=c[a1+8>>2];x=0;ao(14,fs|0,aK|0,g|0,a8|0,0);if(x){x=0;a0=687;break L47}if((a[c5]&1)!=0){J2(c[dc>>2]|0)}fw=c[aQ>>2]|0;dl=J0(32)|0;c[f>>2]=dl;fx=fw+4|0;dj=c[fx>>2]|0;if((dj|0)==(c[fw+8>>2]|0)){ee(fw|0,f);fy=c[f>>2]|0}else{if((dj|0)==0){fz=0}else{c[dj>>2]=dl;fz=c[fx>>2]|0}c[fx>>2]=fz+4;fy=dl}fA=fy;if((a[aR]&1)==0){c[c6>>2]=c[aR>>2];c[c6+4>>2]=c[aR+4>>2];c[c6+8>>2]=c[aR+8>>2]}else{dl=c[bl>>2]|0;dj=c[bm>>2]|0;if(dj>>>0>4294967279>>>0){a0=668;break L47}if(dj>>>0<11>>>0){a[c6]=dj<<1;fB=c9}else{dn=dj+16&-16;dk=(x=0,as(230,dn|0)|0);if(x){x=0;a0=695;break L47}c[c8>>2]=dk;c[da>>2]=dn|1;c[db>>2]=dj;fB=dk}Kb(fB|0,dl|0,dj)|0;a[fB+dj|0]=0}c[c7>>2]=c[a1>>2];c[c7+4>>2]=c[a1+4>>2];c[c7+8>>2]=c[a1+8>>2];x=0;aT(34,fy|0,aL|0,aM|0,fs|0);if(x){x=0;a0=698;break L47}if((a[c6]&1)!=0){J2(c[c8>>2]|0)}dj=fy;c[e>>2]=dj;dl=c[bh>>2]|0;if((dl|0)==(c[bi>>2]|0)){lM(bj,e);fC=c[e>>2]|0}else{if((dl|0)==0){fD=0}else{c[dl>>2]=dj;fD=c[bh>>2]|0}c[bg>>2]=fD+4;fC=dj}cy[c[c[bk>>2]>>2]&1023](bf,fC);if((r1(b)|0)==0){dg=dL;continue L47}}}do{if((a0|0)==77){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;fE=K;fF=dg;a0=113;break}}else if((a0|0)==122){dg=bQ(-1,-1)|0;fG=K;fH=dg;a0=124}else if((a0|0)==95){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;fG=K;fH=dg;a0=124;break}}else if((a0|0)==510){dg=bQ(-1,-1)|0;fI=K;fJ=dg;fK=eH;a0=512}else if((a0|0)==650){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;fL=K;fM=dg;a0=686;break}}else if((a0|0)==668){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;fN=K;fO=dg;a0=697;break}}else if((a0|0)==684){dg=bQ(-1,-1)|0;fL=K;fM=dg;a0=686}else if((a0|0)==687){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[c5]&1)==0){fP=bf;fQ=dg;a0=689;break}J2(c[dc>>2]|0);fP=bf;fQ=dg;a0=689}else if((a0|0)==695){dg=bQ(-1,-1)|0;fN=K;fO=dg;a0=697}else if((a0|0)==698){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[c6]&1)==0){fR=bf;fS=dg;a0=700;break}J2(c[c8>>2]|0);fR=bf;fS=dg;a0=700}else if((a0|0)==602){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;fT=K;fU=dg;a0=621;break}}else if((a0|0)==619){dg=bQ(-1,-1)|0;fT=K;fU=dg;a0=621}else if((a0|0)==622){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[bD]&1)==0){fV=bf;fW=dg;a0=624;break}J2(c[bF>>2]|0);fV=bf;fW=dg;a0=624}else if((a0|0)==381){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[bB]&1)==0){fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}J2(c[bv>>2]|0);fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==125){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[bb]&1)==0){f1=bf;f2=dg;a0=127;break}J2(c[bd>>2]|0);f1=bf;f2=dg;a0=127}else if((a0|0)==476){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;f3=K;f4=dg;a0=509;break}}else if((a0|0)==486){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;fI=K;fJ=dg;fK=1;a0=512;break}}else if((a0|0)==496){dg=bQ(-1,-1)|0;bf=K;if((a[bY]&1)==0){fI=bf;fJ=dg;fK=1;a0=512;break}J2(c[b$>>2]|0);fI=bf;fJ=dg;fK=1;a0=512}else if((a0|0)==507){dg=bQ(-1,-1)|0;f3=K;f4=dg;a0=509}else if((a0|0)==111){dg=bQ(-1,-1)|0;fE=K;fF=dg;a0=113}else if((a0|0)==114){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[ba]&1)==0){f5=bf;f6=dg;a0=116;break}J2(c[bq>>2]|0);f5=bf;f6=dg;a0=116}else if((a0|0)==423){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;f7=K;f8=dg;f9=1;a0=449;break}}else if((a0|0)==433){dg=bQ(-1,-1)|0;bf=K;if((a[b8]&1)==0){f7=bf;f8=dg;f9=1;a0=449;break}J2(c[cb>>2]|0);f7=bf;f8=dg;f9=1;a0=449}else if((a0|0)==444){dg=bQ(-1,-1)|0;ga=K;gb=dg;a0=446}else if((a0|0)==67){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[a4]&1)==0){fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}J2(c[aS>>2]|0);fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==269){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[cM]&1)==0){gc=bf;gd=dg;ge=dU;a0=271;break}J2(c[cP>>2]|0);gc=bf;gd=dg;ge=dU;a0=271}else if((a0|0)==198){dg=bQ(-1,-1)|0;gf=K;gg=dg;a0=200}else if((a0|0)==201){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[cX]&1)==0){gh=bf;gi=dg;a0=203;break}J2(c[cZ>>2]|0);gh=bf;gi=dg;a0=203}else if((a0|0)==403){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[co]&1)==0){fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}J2(c[ci>>2]|0);fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==413){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;ga=K;gb=dg;a0=446;break}}else if((a0|0)==447){dg=bQ(-1,-1)|0;f7=K;f8=dg;f9=eu;a0=449}else if((a0|0)==463){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[bU]&1)==0){fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}J2(c[bN>>2]|0);fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==153){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;gj=K;gk=dg;a0=189;break}}else if((a0|0)==214){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[cJ]&1)==0){fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}J2(c[cD>>2]|0);fX=bf;fY=dg;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==243){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;gl=K;gm=dg;a0=268;break}}else if((a0|0)==134){dg=c[a5>>2]|0;bf=c[aN>>2]|0;L772:do{if(bf>>>0<dI>>>0){bk=bf;bg=0;while(1){bh=a[bk]|0;if((bh<<24>>24|0)==0){gn=bg;break L772}else if((bh<<24>>24|0)==10){go=bg+1|0}else{go=bg}bh=bk+1|0;if(bh>>>0<dI>>>0){bk=bh;bg=go}else{gn=go;break}}}else{gn=0}}while(0);c[a5>>2]=gn+dg;bg=dH;bk=0;while(1){bh=bg-1|0;if(bh>>>0<bf>>>0){break}if((a[bh]|0)==10){break}else{bg=bh;bk=bk+1|0}}if((gn|0)!=0){c[a6>>2]=1}bg=c[a6>>2]|0;c[a7>>2]=bg+bk;bf=dI;dg=dH;c[a6>>2]=bf-dg+bk+bg;gp=dI;gq=bf|0;gr=dg|0;gs=a9|0;c[gs>>2]=gr;gt=a9+4|0;c[gt>>2]=gq;c[aN>>2]=gp;i=d;return a$|0}else if((a0|0)==233){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;gu=K;gv=dg;a0=265;break}}else if((a0|0)==263){dg=bQ(-1,-1)|0;gu=K;gv=dg;a0=265}else if((a0|0)==266){dg=bQ(-1,-1)|0;gl=K;gm=dg;a0=268}else if((a0|0)==187){dg=bQ(-1,-1)|0;gj=K;gk=dg;a0=189}else if((a0|0)==324){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;gw=K;gx=dg;a0=358;break}}else if((a0|0)==190){dg=bQ(-1,-1)|0;bf=dg;dg=K;if((a[cW]&1)==0){gy=bf;gz=dg;a0=192;break}J2(c[c1>>2]|0);gy=bf;gz=dg;a0=192}else if((a0|0)==356){dg=bQ(-1,-1)|0;gw=K;gx=dg;a0=358}else if((a0|0)==359){dg=bQ(-1,-1)|0;gA=K;gB=dg;gC=eb;gD=a[cp]|0;a0=361}else if((a0|0)==335){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;gA=K;gB=dg;gC=1;gD=ec;a0=361;break}}else if((a0|0)==345){dg=bQ(-1,-1)|0;bf=K;if((a[cs]&1)==0){gA=bf;gB=dg;gC=1;gD=ec;a0=361;break}J2(c[cv>>2]|0);gA=bf;gB=dg;gC=1;gD=ec;a0=361}else if((a0|0)==32){dg=c[a5>>2]|0;bf=c[aN>>2]|0;L809:do{if(bf>>>0<di>>>0){bg=bf;bh=0;while(1){bj=a[bg]|0;if((bj<<24>>24|0)==0){gE=bh;break L809}else if((bj<<24>>24|0)==10){gF=bh+1|0}else{gF=bh}bj=bg+1|0;if(bj>>>0<di>>>0){bg=bj;bh=gF}else{gE=gF;break}}}else{gE=0}}while(0);c[a5>>2]=gE+dg;bk=dh;bh=0;while(1){bg=bk-1|0;if(bg>>>0<bf>>>0){break}if((a[bg]|0)==10){break}else{bk=bg;bh=bh+1|0}}if((gE|0)!=0){c[a6>>2]=1}bk=c[a6>>2]|0;c[a7>>2]=bk+bh;bf=di;dg=dh;c[a6>>2]=bf-dg+bh+bk;gp=di;gq=bf|0;gr=dg|0;gs=a9|0;c[gs>>2]=gr;gt=a9+4|0;c[gt>>2]=gq;c[aN>>2]=gp;i=d;return a$|0}else if((a0|0)==171){x=0;ap(232,0);if(!x){return 0}else{x=0;dg=bQ(-1,-1)|0;gf=K;gg=dg;a0=200;break}}}while(0);do{if((a0|0)==509){gG=f3;gH=f4;a0=515}else if((a0|0)==512){a9=fJ;a6=fI;if((eD&1)==0){if(fK){gG=a6;gH=a9;a0=515;break}else{fX=a9;fY=a6}fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else{J2(c[b_>>2]|0);if(fK){gG=a6;gH=a9;a0=515;break}else{fX=a9;fY=a6}fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}}else if((a0|0)==686){fP=fM;fQ=fL;a0=689}else if((a0|0)==697){fR=fO;fS=fN;a0=700}else if((a0|0)==621){fV=fU;fW=fT;a0=624}else if((a0|0)==124){f1=fH;f2=fG;a0=127}else if((a0|0)==113){f5=fF;f6=fE;a0=116}else if((a0|0)==268){gc=gm;gd=gl;ge=1;a0=271}else if((a0|0)==200){gh=gg;gi=gf;a0=203}else if((a0|0)==446){gI=ga;gJ=gb;a0=452}else if((a0|0)==449){a6=f8;a9=f7;if((eq&1)==0){if(f9){gI=a9;gJ=a6;a0=452;break}else{fX=a6;fY=a9}fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else{J2(c[ca>>2]|0);if(f9){gI=a9;gJ=a6;a0=452;break}else{fX=a6;fY=a9}fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}}else if((a0|0)==265){gK=gu;gL=gv}else if((a0|0)==189){gy=gk;gz=gj;a0=192}else if((a0|0)==358){gM=gw;gN=gx;a0=364}else if((a0|0)==361){a9=gB;a6=gA;if((gD&1)==0){if(gC){gM=a6;gN=a9;a0=364;break}else{fX=a9;fY=a6}fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else{J2(c[cu>>2]|0);if(gC){gM=a6;gN=a9;a0=364;break}else{fX=a9;fY=a6}fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}}}while(0);do{if((a0|0)==116){cu=c[dt>>2]|0;ca=c[du>>2]|0;b_=cu;while(1){if((b_|0)==(ca|0)){gO=ca;break}if((c[b_>>2]|0)==(dv|0)){gO=b_;break}else{b_=b_+4|0}}b_=gO-cu>>2;bh=cu+(b_+1<<2)|0;a6=ca-bh|0;Kc(cu+(b_<<2)|0,bh|0,a6|0)|0;bh=cu+((a6>>2)+b_<<2)|0;b_=c[du>>2]|0;if((bh|0)!=(b_|0)){c[du>>2]=b_+(~((b_-4+(-bh|0)|0)>>>2)<<2)}J2(dx);fX=f5;fY=f6;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==515){bh=c[ey>>2]|0;b_=c[ez>>2]|0;a6=bh;while(1){if((a6|0)==(b_|0)){gP=b_;break}if((c[a6>>2]|0)==(eA|0)){gP=a6;break}else{a6=a6+4|0}}a6=gP-bh>>2;cu=bh+(a6+1<<2)|0;ca=b_-cu|0;Kc(bh+(a6<<2)|0,cu|0,ca|0)|0;cu=bh+((ca>>2)+a6<<2)|0;a6=c[ez>>2]|0;if((cu|0)!=(a6|0)){c[ez>>2]=a6+(~((a6-4+(-cu|0)|0)>>>2)<<2)}J2(eC);fX=gH;fY=gG;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==689){cu=c[fq>>2]|0;a6=c[fr>>2]|0;ca=cu;while(1){if((ca|0)==(a6|0)){gQ=a6;break}if((c[ca>>2]|0)==(fs|0)){gQ=ca;break}else{ca=ca+4|0}}ca=gQ-cu>>2;bh=cu+(ca+1<<2)|0;b_=a6-bh|0;Kc(cu+(ca<<2)|0,bh|0,b_|0)|0;bh=cu+((b_>>2)+ca<<2)|0;ca=c[fr>>2]|0;if((bh|0)!=(ca|0)){c[fr>>2]=ca+(~((ca-4+(-bh|0)|0)>>>2)<<2)}J2(fu);fX=fP;fY=fQ;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==700){bh=c[fw>>2]|0;ca=c[fx>>2]|0;b_=bh;while(1){if((b_|0)==(ca|0)){gR=ca;break}if((c[b_>>2]|0)==(fy|0)){gR=b_;break}else{b_=b_+4|0}}b_=gR-bh>>2;cu=bh+(b_+1<<2)|0;a6=ca-cu|0;Kc(bh+(b_<<2)|0,cu|0,a6|0)|0;cu=bh+((a6>>2)+b_<<2)|0;b_=c[fx>>2]|0;if((cu|0)!=(b_|0)){c[fx>>2]=b_+(~((b_-4+(-cu|0)|0)>>>2)<<2)}J2(fA);fX=fR;fY=fS;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==203){cu=c[fi>>2]|0;b_=c[fj>>2]|0;a6=cu;while(1){if((a6|0)==(b_|0)){gS=b_;break}if((c[a6>>2]|0)==(fk|0)){gS=a6;break}else{a6=a6+4|0}}a6=gS-cu>>2;bh=cu+(a6+1<<2)|0;ca=b_-bh|0;Kc(cu+(a6<<2)|0,bh|0,ca|0)|0;bh=cu+((ca>>2)+a6<<2)|0;a6=c[fj>>2]|0;if((bh|0)!=(a6|0)){c[fj>>2]=a6+(~((a6-4+(-bh|0)|0)>>>2)<<2)}J2(fm);fX=gh;fY=gi;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==624){bh=c[e2>>2]|0;a6=c[e3>>2]|0;ca=bh;while(1){if((ca|0)==(a6|0)){gT=a6;break}if((c[ca>>2]|0)==(e4|0)){gT=ca;break}else{ca=ca+4|0}}ca=gT-bh>>2;cu=bh+(ca+1<<2)|0;b_=a6-cu|0;Kc(bh+(ca<<2)|0,cu|0,b_|0)|0;cu=bh+((b_>>2)+ca<<2)|0;ca=c[e3>>2]|0;if((cu|0)!=(ca|0)){c[e3>>2]=ca+(~((ca-4+(-cu|0)|0)>>>2)<<2)}J2(e6);fX=fV;fY=fW;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==127){cu=c[dz>>2]|0;ca=c[dA>>2]|0;b_=cu;while(1){if((b_|0)==(ca|0)){gU=ca;break}if((c[b_>>2]|0)==(dB|0)){gU=b_;break}else{b_=b_+4|0}}b_=gU-cu>>2;bh=cu+(b_+1<<2)|0;a6=ca-bh|0;Kc(cu+(b_<<2)|0,bh|0,a6|0)|0;bh=cu+((a6>>2)+b_<<2)|0;b_=c[dA>>2]|0;if((bh|0)!=(b_|0)){c[dA>>2]=b_+(~((b_-4+(-bh|0)|0)>>>2)<<2)}J2(dD);fX=f1;fY=f2;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==271){if((a[cK]&1)==0){if(ge){gK=gd;gL=gc;break}else{fX=gc;fY=gd}fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else{J2(c[cO>>2]|0);if(ge){gK=gd;gL=gc;break}else{fX=gc;fY=gd}fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}}else if((a0|0)==452){bh=c[el>>2]|0;b_=c[em>>2]|0;a6=bh;while(1){if((a6|0)==(b_|0)){gV=b_;break}if((c[a6>>2]|0)==(en|0)){gV=a6;break}else{a6=a6+4|0}}a6=gV-bh>>2;cu=bh+(a6+1<<2)|0;ca=b_-cu|0;Kc(bh+(a6<<2)|0,cu|0,ca|0)|0;cu=bh+((ca>>2)+a6<<2)|0;a6=c[em>>2]|0;if((cu|0)!=(a6|0)){c[em>>2]=a6+(~((a6-4+(-cu|0)|0)>>>2)<<2)}J2(ep);fX=gJ;fY=gI;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==364){cu=c[d5>>2]|0;a6=c[d6>>2]|0;ca=cu;while(1){if((ca|0)==(a6|0)){gW=a6;break}if((c[ca>>2]|0)==(d7|0)){gW=ca;break}else{ca=ca+4|0}}ca=gW-cu>>2;bh=cu+(ca+1<<2)|0;b_=a6-bh|0;Kc(cu+(ca<<2)|0,bh|0,b_|0)|0;bh=cu+((b_>>2)+ca<<2)|0;ca=c[d6>>2]|0;if((bh|0)!=(ca|0)){c[d6>>2]=ca+(~((ca-4+(-bh|0)|0)>>>2)<<2)}J2(d9);fX=gN;fY=gM;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}else if((a0|0)==192){bh=c[fc>>2]|0;ca=c[fd>>2]|0;b_=bh;while(1){if((b_|0)==(ca|0)){gX=ca;break}if((c[b_>>2]|0)==(fe|0)){gX=b_;break}else{b_=b_+4|0}}b_=gX-bh>>2;cu=bh+(b_+1<<2)|0;a6=ca-cu|0;Kc(bh+(b_<<2)|0,cu|0,a6|0)|0;cu=bh+((a6>>2)+b_<<2)|0;b_=c[fd>>2]|0;if((cu|0)!=(b_|0)){c[fd>>2]=b_+(~((b_-4+(-cu|0)|0)>>>2)<<2)}J2(fg);fX=gy;fY=gz;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}}while(0);cO=c[dM>>2]|0;cK=c[dN>>2]|0;cu=cO;while(1){if((cu|0)==(cK|0)){gY=cK;break}if((c[cu>>2]|0)==(dO|0)){gY=cu;break}else{cu=cu+4|0}}cu=gY-cO>>2;b_=cO+(cu+1<<2)|0;a6=cK-b_|0;Kc(cO+(cu<<2)|0,b_|0,a6|0)|0;b_=cO+((a6>>2)+cu<<2)|0;cu=c[dN>>2]|0;if((b_|0)!=(cu|0)){c[dN>>2]=cu+(~((cu-4+(-b_|0)|0)>>>2)<<2)}J2(dQ);fX=gL;fY=gK;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0)}}while(0);gK=c[aU>>2]|0;aU=c[aY>>2]|0;gL=gK;while(1){if((gL|0)==(aU|0)){gZ=aU;break}if((c[gL>>2]|0)==(a_|0)){gZ=gL;break}else{gL=gL+4|0}}gL=gZ-gK>>2;gZ=gK+(gL+1<<2)|0;a_=aU-gZ|0;Kc(gK+(gL<<2)|0,gZ|0,a_|0)|0;gZ=gK+((a_>>2)+gL<<2)|0;gL=c[aY>>2]|0;if((gZ|0)!=(gL|0)){c[aY>>2]=gL+(~((gL-4+(-gZ|0)|0)>>>2)<<2)}J2(aZ);fX=a2;fY=a3;fZ=fX;f_=0;f$=fZ;f0=fY;be(f$|0);return 0}function ss(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=i;i=i+104|0;e=d|0;f=d+16|0;g=d+24|0;h=d+56|0;j=d+72|0;k=d+88|0;st(b)|0;l=b+56|0;m=c[l>>2]|0;n=(c[b+60>>2]|0)-m|0;if(n>>>0>4294967279>>>0){CJ(0);return 0}if(n>>>0<11>>>0){o=n<<1&255;a[g]=o;p=g+1|0;q=o}else{o=n+16&-16;r=J0(o)|0;c[g+8>>2]=r;s=o|1;c[g>>2]=s;c[g+4>>2]=n;p=r;q=s&255}Kb(p|0,m|0,n)|0;a[p+n|0]=0;n=d+40|0;p=b+44|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];p=b+20|0;m=(x=0,as(60,c[p>>2]|0)|0);do{if(!x){s=(a[m]|0)==58?m+1|0:0;if((s|0)==0){r=(x=0,as(262,b|0)|0);if(x){x=0;t=19;break}u=0;v=(r|0)!=0}else{r=b+48|0;o=c[r>>2]|0;w=c[p>>2]|0;L14:do{if(w>>>0<s>>>0){y=w;z=0;while(1){A=a[y]|0;if((A<<24>>24|0)==0){B=z;break L14}else if((A<<24>>24|0)==10){C=z+1|0}else{C=z}A=y+1|0;if(A>>>0<s>>>0){y=A;z=C}else{B=C;break}}}else{B=0}}while(0);c[r>>2]=B+o;z=m;y=0;while(1){A=z-1|0;if(A>>>0<w>>>0){break}if((a[A]|0)==10){break}else{z=A;y=y+1|0}}z=b+40|0;if((B|0)!=0){c[z>>2]=1}w=c[z>>2]|0;c[b+52>>2]=w+y;o=s;r=m;c[z>>2]=o-r+y+w;w=l;c[w>>2]=r;c[w+4>>2]=o;c[p>>2]=s;o=(x=0,as(256,b|0)|0);if(x){x=0;t=19;break}a[o+28|0]=0;u=o;v=0}o=c[b>>2]|0;w=(x=0,as(230,48)|0);if(x){x=0;t=19;break}r=w;c[f>>2]=r;w=o+4|0;z=c[w>>2]|0;if((z|0)==(c[o+8>>2]|0)){x=0;aq(376,o|0,f|0);if(x){x=0;t=19;break}D=c[f>>2]|0}else{if((z|0)==0){E=0}else{c[z>>2]=r;E=c[w>>2]|0}c[w>>2]=E+4;D=r}r=D;z=D;A=b+28|0;L39:do{if((a[A]&1)==0){F=h;c[F>>2]=c[A>>2];c[F+4>>2]=c[A+4>>2];c[F+8>>2]=c[A+8>>2];t=39}else{F=c[b+36>>2]|0;G=c[b+32>>2]|0;do{if(G>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(G>>>0<11>>>0){a[h]=G<<1;H=h+1|0}else{I=G+16&-16;J=(x=0,as(230,I|0)|0);if(x){x=0;break}c[h+8>>2]=J;c[h>>2]=I|1;c[h+4>>2]=G;H=J}Kb(H|0,F|0,G)|0;a[H+G|0]=0;t=39;break L39}}while(0);G=bQ(-1,-1)|0;L=K;M=G}}while(0);do{if((t|0)==39){A=j;c[A>>2]=c[n>>2];c[A+4>>2]=c[n+4>>2];c[A+8>>2]=c[n+8>>2];L54:do{if((q&1)==0){s=g;y=k;c[y>>2]=c[s>>2];c[y+4>>2]=c[s+4>>2];c[y+8>>2]=c[s+8>>2];t=49}else{s=c[g+8>>2]|0;y=c[g+4>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[k]=y<<1;N=k+1|0}else{G=y+16&-16;F=(x=0,as(230,G|0)|0);if(x){x=0;break}c[k+8>>2]=F;c[k>>2]=G|1;c[k+4>>2]=y;N=F}Kb(N|0,s|0,y)|0;a[N+y|0]=0;t=49;break L54}}while(0);y=bQ(-1,-1)|0;O=K;P=y}}while(0);do{if((t|0)==49){y=e;c[y>>2]=c[A>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];x=0;aB(24,z|0,h|0,e|0,k|0,u|0,v|0);if(x){x=0;y=bQ(-1,-1)|0;s=y;y=K;if((a[k]&1)==0){O=y;P=s;break}J2(c[k+8>>2]|0);O=y;P=s;break}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}if((q&1)==0){i=d;return z|0}J2(c[g+8>>2]|0);i=d;return z|0}}while(0);if((a[h]&1)==0){L=O;M=P;break}J2(c[h+8>>2]|0);L=O;M=P}}while(0);z=c[o>>2]|0;A=c[w>>2]|0;s=z;while(1){if((s|0)==(A|0)){Q=A;break}if((c[s>>2]|0)==(D|0)){Q=s;break}else{s=s+4|0}}s=Q-z>>2;o=z+(s+1<<2)|0;y=A-o|0;Kc(z+(s<<2)|0,o|0,y|0)|0;o=z+((y>>2)+s<<2)|0;s=c[w>>2]|0;if((o|0)!=(s|0)){c[w>>2]=s+(~((s-4+(-o|0)|0)>>>2)<<2)}J2(r);R=L;S=M}else{x=0;t=19}}while(0);if((t|0)==19){t=bQ(-1,-1)|0;R=K;S=t}if((q&1)==0){T=S;U=0;V=T;W=R;be(V|0)}J2(c[g+8>>2]|0);T=S;U=0;V=T;W=R;be(V|0);return 0}function st(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yH(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function su(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+56|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=s7(b)|0;l=b+20|0;m=xP(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=59)){n=k;i=d;return n|0}m=xP(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=125)){n=k;i=d;return n|0}m=xP(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=123)){n=k;i=d;return n|0}m=xP(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=41)){n=k;i=d;return n|0}m=xP(c[l>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=44)){n=k;i=d;return n|0}m=xP(c[l>>2]|0)|0;o=a[35392]|0;p=o<<24>>24==0;L16:do{if(p){q=m;r=9}else{s=m;t=35392;u=o;while(1){if((a[s]|0)!=u<<24>>24){break L16}v=s+1|0;w=t+1|0;y=a[w]|0;if(y<<24>>24==0){q=v;r=9;break}else{s=v;t=w;u=y}}}}while(0);do{if((r|0)==9){if((q|0)==0){break}else{n=k}i=d;return n|0}}while(0);if((yu(xP(c[l>>2]|0)|0)|0)!=0){n=k;i=d;return n|0}q=c[b>>2]|0;m=J0(60)|0;c[h>>2]=m;u=q+4|0;t=c[u>>2]|0;if((t|0)==(c[q+8>>2]|0)){ee(q|0,h);z=c[h>>2]|0}else{if((t|0)==0){A=0}else{c[t>>2]=m;A=c[u>>2]|0}c[u>>2]=A+4;z=m}m=z;A=b+28|0;L34:do{if((a[A]&1)==0){t=j;c[t>>2]=c[A>>2];c[t+4>>2]=c[A+4>>2];c[t+8>>2]=c[A+8>>2];r=26}else{t=c[b+36>>2]|0;h=c[b+32>>2]|0;do{if(h>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;B=j+1|0}else{s=h+16&-16;y=(x=0,as(230,s|0)|0);if(x){x=0;break}c[j+8>>2]=y;c[j>>2]=s|1;c[j+4>>2]=h;B=y}Kb(B|0,t|0,h)|0;a[B+h|0]=0;r=26;break L34}}while(0);h=bQ(-1,-1)|0;C=K;D=h}}while(0);do{if((r|0)==26){B=b+44|0;A=g;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];x=0;aB(34,z|0,j|0,g|0,2,0,0);if(x){x=0;B=bQ(-1,-1)|0;A=B;B=K;if((a[j]&1)==0){C=B;D=A;break}J2(c[j+8>>2]|0);C=B;D=A;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}A=z+36|0;B=A;c[f>>2]=k;h=A+8|0;t=h;y=c[t>>2]|0;s=A+12|0;if((y|0)==(c[s>>2]|0)){eq(A+4|0,f);E=c[f>>2]|0}else{if((y|0)==0){F=0}else{c[y>>2]=k;F=c[t>>2]|0}c[h>>2]=F+4;E=k}y=A;cy[c[c[y>>2]>>2]&1023](B,E);w=xP(c[l>>2]|0)|0;L63:do{if((w+1|0)==0|(a[w]|0)!=59){v=A+4|0;do{G=xP(c[l>>2]|0)|0;if(!((G+1|0)==0|(a[G]|0)!=125)){break L63}G=xP(c[l>>2]|0)|0;if(!((G+1|0)==0|(a[G]|0)!=123)){break L63}G=xP(c[l>>2]|0)|0;if(!((G+1|0)==0|(a[G]|0)!=41)){break L63}G=xP(c[l>>2]|0)|0;if(!((G+1|0)==0|(a[G]|0)!=44)){break L63}G=xP(c[l>>2]|0)|0;L71:do{if(p){H=G;r=43}else{I=G;J=35392;L=o;while(1){if((a[I]|0)!=L<<24>>24){break L71}M=I+1|0;N=J+1|0;O=a[N]|0;if(O<<24>>24==0){H=M;r=43;break}else{I=M;J=N;L=O}}}}while(0);if((r|0)==43){r=0;if((H|0)!=0){break L63}}if((yu(xP(c[l>>2]|0)|0)|0)!=0){break L63}G=s7(b)|0;c[e>>2]=G;L=c[t>>2]|0;if((L|0)==(c[s>>2]|0)){eq(v,e);P=c[e>>2]|0}else{if((L|0)==0){Q=0}else{c[L>>2]=G;Q=c[t>>2]|0}c[h>>2]=Q+4;P=G}cy[c[c[y>>2]>>2]&1023](B,P);G=xP(c[l>>2]|0)|0;}while((G+1|0)==0|(a[G]|0)!=59)}}while(0);n=z;i=d;return n|0}}while(0);n=c[q>>2]|0;q=c[u>>2]|0;d=n;while(1){if((d|0)==(q|0)){R=q;break}if((c[d>>2]|0)==(z|0)){R=d;break}else{d=d+4|0}}d=R-n>>2;R=n+(d+1<<2)|0;z=q-R|0;Kc(n+(d<<2)|0,R|0,z|0)|0;R=n+((z>>2)+d<<2)|0;d=c[u>>2]|0;if((R|0)==(d|0)){J2(m);S=D;T=0;U=S;V=C;be(U|0)}c[u>>2]=d+(~((d-4+(-R|0)|0)>>>2)<<2);J2(m);S=D;T=0;U=S;V=C;be(U|0);return 0}function sv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=a[35392]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=35392;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==10){p=i+1|0}else if((n<<24>>24|0)==0){q=i;break L9}else{p=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=p}else{q=p;break}}}else{q=0}}while(0);c[g>>2]=h+q;h=e;g=0;while(1){p=h-1|0;if(p>>>0<k>>>0){break}if((a[p]|0)==10){break}else{h=p;g=g+1|0}}h=b+40|0;if((q|0)!=0){c[h>>2]=1}q=c[h>>2]|0;c[b+52>>2]=q+g;k=f;p=e;c[h>>2]=k-p+g+q;q=b+56|0;c[q>>2]=p;c[q+4>>2]=k;c[d>>2]=f;o=f;return o|0}function sw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x_(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0;d=i;i=i+96|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+48|0;k=d+64|0;l=d+80|0;m=b+56|0;n=c[m>>2]|0;o=(c[b+60>>2]|0)-n|0;if(o>>>0>4294967279>>>0){CJ(0);return 0}if(o>>>0<11>>>0){p=o<<1&255;a[h]=p;q=h+1|0;r=p}else{p=o+16&-16;s=J0(p)|0;c[h+8>>2]=s;t=p|1;c[h>>2]=t;c[h+4>>2]=o;q=s;r=t&255}Kb(q|0,n|0,o)|0;a[q+o|0]=0;o=c[b>>2]|0;q=(x=0,as(230,56)|0);L8:do{if(!x){n=q;c[g>>2]=n;t=o+4|0;s=c[t>>2]|0;if((s|0)==(c[o+8>>2]|0)){x=0;aq(376,o|0,g|0);if(x){x=0;u=61;break}v=c[g>>2]|0}else{if((s|0)==0){w=0}else{c[s>>2]=n;w=c[t>>2]|0}c[t>>2]=w+4;v=n}n=v;s=v;p=b+28|0;L18:do{if((a[p]&1)==0){y=j;c[y>>2]=c[p>>2];c[y+4>>2]=c[p+4>>2];c[y+8>>2]=c[p+8>>2];u=23}else{y=c[b+36>>2]|0;z=c[b+32>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[j]=z<<1;A=j+1|0}else{B=z+16&-16;C=(x=0,as(230,B|0)|0);if(x){x=0;break}c[j+8>>2]=C;c[j>>2]=B|1;c[j+4>>2]=z;A=C}Kb(A|0,y|0,z)|0;a[A+z|0]=0;u=23;break L18}}while(0);z=bQ(-1,-1)|0;D=z;E=K}}while(0);do{if((u|0)==23){p=b+44|0;z=f;c[z>>2]=c[p>>2];c[z+4>>2]=c[p+4>>2];c[z+8>>2]=c[p+8>>2];x=0;aP(44,s|0,j|0,f|0);if(x){x=0;p=bQ(-1,-1)|0;z=p;p=K;if((a[j]&1)==0){D=z;E=p;break}J2(c[j+8>>2]|0);D=z;E=p;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}p=b+20|0;z=(x=0,as(60,c[p>>2]|0)|0);if(x){x=0;u=61;break L8}y=(a[z]|0)==40?z+1|0:0;L41:do{if((y|0)!=0){C=b+48|0;B=c[C>>2]|0;F=c[p>>2]|0;L43:do{if(F>>>0<y>>>0){G=F;H=0;while(1){I=a[G]|0;if((I<<24>>24|0)==0){J=H;break L43}else if((I<<24>>24|0)==10){L=H+1|0}else{L=H}I=G+1|0;if(I>>>0<y>>>0){G=I;H=L}else{J=L;break}}}else{J=0}}while(0);c[C>>2]=J+B;H=z;G=0;while(1){I=H-1|0;if(I>>>0<F>>>0){break}if((a[I]|0)==10){break}else{H=I;G=G+1|0}}H=b+40|0;if((J|0)!=0){c[H>>2]=1}F=c[H>>2]|0;B=b+52|0;c[B>>2]=F+G;I=y;M=z;c[H>>2]=I-M+G+F;F=m;c[F>>2]=M;c[F+4>>2]=I;c[p>>2]=y;I=(x=0,as(60,y|0)|0);if(x){x=0;u=61;break L8}L58:do{if((I+1|0)==0|(a[I]|0)!=41){M=v+36|0;N=M;O=M+8|0;P=O;Q=M+12|0;R=M+4|0;S=M;while(1){M=(x=0,as(154,b|0)|0);if(x){x=0;break}c[e>>2]=M;T=c[P>>2]|0;if((T|0)==(c[Q>>2]|0)){x=0;aq(156,R|0,e|0);if(x){x=0;break}U=c[e>>2]|0}else{if((T|0)==0){V=0}else{c[T>>2]=M;V=c[P>>2]|0}c[O>>2]=V+4;U=M}x=0;aq(c[c[S>>2]>>2]|0,N|0,U|0);if(x){x=0;break}M=(x=0,as(60,c[p>>2]|0)|0);if(x){x=0;break}T=(a[M]|0)==44?M+1|0:0;if((T|0)==0){break L58}W=c[C>>2]|0;X=c[p>>2]|0;L74:do{if(X>>>0<T>>>0){Y=X;Z=0;while(1){_=a[Y]|0;if((_<<24>>24|0)==10){$=Z+1|0}else if((_<<24>>24|0)==0){aa=Z;break L74}else{$=Z}_=Y+1|0;if(_>>>0<T>>>0){Y=_;Z=$}else{aa=$;break}}}else{aa=0}}while(0);c[C>>2]=aa+W;Z=M;Y=0;while(1){_=Z-1|0;if(_>>>0<X>>>0){break}if((a[_]|0)==10){break}else{Z=_;Y=Y+1|0}}if((aa|0)!=0){c[H>>2]=1}Z=c[H>>2]|0;c[B>>2]=Z+Y;X=T;W=M;c[H>>2]=X-W+Y+Z;c[F>>2]=W;c[F+4>>2]=X;c[p>>2]=T}N=bQ(-1,-1)|0;ab=K;ac=N;u=62;break L8}}while(0);I=(x=0,as(60,c[p>>2]|0)|0);if(x){x=0;u=61;break L8}G=(a[I]|0)==41?I+1|0:0;if((G|0)!=0){N=c[C>>2]|0;S=c[p>>2]|0;L93:do{if(S>>>0<G>>>0){O=S;P=0;while(1){R=a[O]|0;if((R<<24>>24|0)==10){ad=P+1|0}else if((R<<24>>24|0)==0){ae=P;break L93}else{ad=P}R=O+1|0;if(R>>>0<G>>>0){O=R;P=ad}else{ae=ad;break}}}else{ae=0}}while(0);c[C>>2]=ae+N;P=I;O=0;while(1){R=P-1|0;if(R>>>0<S>>>0){break}if((a[R]|0)==10){break}else{P=R;O=O+1|0}}if((ae|0)!=0){c[H>>2]=1}P=c[H>>2]|0;c[B>>2]=P+O;S=G;N=I;c[H>>2]=S-N+O+P;c[F>>2]=N;c[F+4>>2]=S;c[p>>2]=G;break}S=k;Ke(S|0,0,12)|0;N=h;P=r&255;if((P&1|0)==0){af=P>>>1}else{af=c[h+4>>2]|0}P=af+69|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(P>>>0<11>>>0){a[S]=-118;ag=k+1|0}else{C=af+85&-16;R=(x=0,as(230,C|0)|0);if(x){x=0;break}c[k+8>>2]=R;c[k>>2]=C|1;c[k+4>>2]=69;ag=R}Kb(ag|0,9496,69)|0;a[ag+69|0]=0;if((r&1)==0){ah=N+1|0}else{ah=c[h+8>>2]|0}x=0,ax(64,k|0,ah|0,af|0)|0;if(x){x=0;break}c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;x=0;aP(466,b|0,k|0,l|0);if(!x){if((a[S]&1)==0){break L41}J2(c[k+8>>2]|0);break L41}else{x=0;R=bQ(-1,-1)|0;C=R;R=K;if((a[S]&1)==0){ai=C;aj=R;break L8}J2(c[k+8>>2]|0);ai=C;aj=R;break L8}}}while(0);N=bQ(-1,-1)|0;P=K;if((a[S]&1)==0){ab=P;ac=N;u=62;break L8}J2(c[k+8>>2]|0);ab=P;ac=N;u=62;break L8}}while(0);if((a[h]&1)==0){i=d;return s|0}J2(c[h+8>>2]|0);i=d;return s|0}}while(0);s=c[o>>2]|0;p=c[t>>2]|0;y=s;while(1){if((y|0)==(p|0)){ak=p;break}if((c[y>>2]|0)==(v|0)){ak=y;break}else{y=y+4|0}}y=ak-s>>2;z=s+(y+1<<2)|0;N=p-z|0;Kc(s+(y<<2)|0,z|0,N|0)|0;z=s+((N>>2)+y<<2)|0;y=c[t>>2]|0;if((z|0)!=(y|0)){c[t>>2]=y+(~((y-4+(-z|0)|0)>>>2)<<2)}J2(n);ai=D;aj=E}else{x=0;u=61}}while(0);if((u|0)==61){E=bQ(-1,-1)|0;ab=K;ac=E;u=62}if((u|0)==62){ai=ac;aj=ab}if((a[h]&1)==0){al=ai;am=0;an=al;ao=aj;be(an|0)}J2(c[h+8>>2]|0);al=ai;am=0;an=al;ao=aj;be(an|0);return 0}function sy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0;d=i;i=i+160|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+80|0;m=d+96|0;n=d+112|0;o=d+128|0;p=d+144|0;q=b+20|0;r=yH(xP(c[q>>2]|0)|0)|0;do{if((r|0)!=0){s=xP(r)|0;if((s|0)==0){break}if((s+1|0)==0|(a[s]|0)!=58){break}st(b)|0;s=b+56|0;t=c[s>>2]|0;u=(c[b+60>>2]|0)-t|0;if(u>>>0>4294967279>>>0){CJ(0);return 0}if(u>>>0<11>>>0){v=u<<1&255;a[j]=v;w=j+1|0;y=v}else{v=u+16&-16;z=J0(v)|0;c[j+8>>2]=z;A=v|1;c[j>>2]=A;c[j+4>>2]=u;w=z;y=A&255}Kb(w|0,t|0,u)|0;a[w+u|0]=0;u=k;t=b+44|0;c[u>>2]=c[t>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];t=(x=0,as(60,c[q>>2]|0)|0);do{if(!x){A=(a[t]|0)==58?t+1|0:0;if((A|0)!=0){z=b+48|0;v=c[z>>2]|0;B=c[q>>2]|0;L16:do{if(B>>>0<A>>>0){C=B;D=0;while(1){E=a[C]|0;if((E<<24>>24|0)==0){F=D;break L16}else if((E<<24>>24|0)==10){G=D+1|0}else{G=D}E=C+1|0;if(E>>>0<A>>>0){C=E;D=G}else{F=G;break}}}else{F=0}}while(0);c[z>>2]=F+v;D=t;C=0;while(1){E=D-1|0;if(E>>>0<B>>>0){break}if((a[E]|0)==10){break}else{D=E;C=C+1|0}}D=b+40|0;if((F|0)!=0){c[D>>2]=1}B=c[D>>2]|0;c[b+52>>2]=B+C;v=A;z=t;c[D>>2]=v-z+C+B;B=s;c[B>>2]=z;c[B+4>>2]=v;c[q>>2]=A}v=(x=0,as(256,b|0)|0);if(x){x=0;H=56;break}a[v+28|0]=0;B=c[b>>2]|0;z=(x=0,as(230,56)|0);if(x){x=0;H=56;break}D=z;c[h>>2]=D;z=B+4|0;E=c[z>>2]|0;if((E|0)==(c[B+8>>2]|0)){x=0;aq(376,B|0,h|0);if(x){x=0;H=56;break}I=c[h>>2]|0}else{if((E|0)==0){J=0}else{c[E>>2]=D;J=c[z>>2]|0}c[z>>2]=J+4;I=D}D=I;E=I;L=b+28|0;L41:do{if((a[L]&1)==0){M=l;c[M>>2]=c[L>>2];c[M+4>>2]=c[L+4>>2];c[M+8>>2]=c[L+8>>2];H=39}else{M=c[b+36>>2]|0;N=c[b+32>>2]|0;do{if(N>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(N>>>0<11>>>0){a[l]=N<<1;O=l+1|0}else{P=N+16&-16;Q=(x=0,as(230,P|0)|0);if(x){x=0;break}c[l+8>>2]=Q;c[l>>2]=P|1;c[l+4>>2]=N;O=Q}Kb(O|0,M|0,N)|0;a[O+N|0]=0;H=39;break L41}}while(0);N=bQ(-1,-1)|0;R=N;S=K}}while(0);do{if((H|0)==39){L=m;c[L>>2]=c[u>>2];c[L+4>>2]=c[u+4>>2];c[L+8>>2]=c[u+8>>2];L56:do{if((y&1)==0){A=j;C=n;c[C>>2]=c[A>>2];c[C+4>>2]=c[A+4>>2];c[C+8>>2]=c[A+8>>2];H=49}else{A=c[j+8>>2]|0;C=c[j+4>>2]|0;do{if(C>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(C>>>0<11>>>0){a[n]=C<<1;T=n+1|0}else{N=C+16&-16;M=(x=0,as(230,N|0)|0);if(x){x=0;break}c[n+8>>2]=M;c[n>>2]=N|1;c[n+4>>2]=C;T=M}Kb(T|0,A|0,C)|0;a[T+C|0]=0;H=49;break L56}}while(0);C=bQ(-1,-1)|0;U=C;V=K}}while(0);do{if((H|0)==49){C=g;c[C>>2]=c[L>>2];c[C+4>>2]=c[L+4>>2];c[C+8>>2]=c[L+8>>2];x=0;aB(28,E|0,l|0,g|0,v|0,n|0,0);if(x){x=0;C=bQ(-1,-1)|0;A=C;C=K;if((a[n]&1)==0){U=A;V=C;break}J2(c[n+8>>2]|0);U=A;V=C;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}if((y&1)==0){W=E;i=d;return W|0}J2(c[j+8>>2]|0);W=E;i=d;return W|0}}while(0);if((a[l]&1)==0){R=U;S=V;break}J2(c[l+8>>2]|0);R=U;S=V}}while(0);E=c[B>>2]|0;v=c[z>>2]|0;L=E;while(1){if((L|0)==(v|0)){X=v;break}if((c[L>>2]|0)==(I|0)){X=L;break}else{L=L+4|0}}L=X-E>>2;B=E+(L+1<<2)|0;C=v-B|0;Kc(E+(L<<2)|0,B|0,C|0)|0;B=E+((C>>2)+L<<2)|0;L=c[z>>2]|0;if((B|0)!=(L|0)){c[z>>2]=L+(~((L-4+(-B|0)|0)>>>2)<<2)}J2(D);Y=R;Z=S}else{x=0;H=56}}while(0);if((H|0)==56){u=bQ(-1,-1)|0;Y=u;Z=K}if((y&1)==0){_=Y;$=Z;aa=_;ab=0;ac=aa;ad=$;be(ac|0)}J2(c[j+8>>2]|0);_=Y;$=Z;aa=_;ab=0;ac=aa;ad=$;be(ac|0)}}while(0);Z=su(b)|0;a[Z+28|0]=0;Y=(sv(b)|0)!=0;j=c[b>>2]|0;y=J0(56)|0;c[f>>2]=y;S=j+4|0;R=c[S>>2]|0;if((R|0)==(c[j+8>>2]|0)){ee(j|0,f);ae=c[f>>2]|0}else{if((R|0)==0){af=0}else{c[R>>2]=y;af=c[S>>2]|0}c[S>>2]=af+4;ae=y}y=ae;af=ae;R=b+28|0;L110:do{if((a[R]&1)==0){f=o;c[f>>2]=c[R>>2];c[f+4>>2]=c[R+4>>2];c[f+8>>2]=c[R+8>>2];H=86}else{f=c[b+36>>2]|0;X=c[b+32>>2]|0;do{if(X>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(X>>>0<11>>>0){a[o]=X<<1;ag=o+1|0}else{I=X+16&-16;V=(x=0,as(230,I|0)|0);if(x){x=0;break}c[o+8>>2]=V;c[o>>2]=I|1;c[o+4>>2]=X;ag=V}Kb(ag|0,f|0,X)|0;a[ag+X|0]=0;H=86;break L110}}while(0);X=bQ(-1,-1)|0;ah=X;ai=K}}while(0);do{if((H|0)==86){ag=b+44|0;R=e;c[R>>2]=c[ag>>2];c[R+4>>2]=c[ag+4>>2];c[R+8>>2]=c[ag+8>>2];ag=p;a[ag]=0;a[p+1|0]=0;x=0;aB(28,af|0,o|0,e|0,Z|0,p|0,Y|0);if(x){x=0;R=bQ(-1,-1)|0;X=R;R=K;if((a[ag]&1)!=0){J2(c[p+8>>2]|0)}if((a[o]&1)==0){ah=X;ai=R;break}J2(c[o+8>>2]|0);ah=X;ai=R;break}if((a[ag]&1)!=0){J2(c[p+8>>2]|0)}if((a[o]&1)==0){W=af;i=d;return W|0}J2(c[o+8>>2]|0);W=af;i=d;return W|0}}while(0);W=c[j>>2]|0;j=c[S>>2]|0;d=W;while(1){if((d|0)==(j|0)){aj=j;break}if((c[d>>2]|0)==(ae|0)){aj=d;break}else{d=d+4|0}}d=aj-W>>2;aj=W+(d+1<<2)|0;ae=j-aj|0;Kc(W+(d<<2)|0,aj|0,ae|0)|0;aj=W+((ae>>2)+d<<2)|0;d=c[S>>2]|0;if((aj|0)!=(d|0)){c[S>>2]=d+(~((d-4+(-aj|0)|0)>>>2)<<2)}J2(y);_=ah;$=ai;aa=_;ab=0;ac=aa;ad=$;be(ac|0);return 0}function sz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yu(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0;d=i;i=i+128|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+40|0;k=d+48|0;l=d+64|0;m=d+72|0;n=d+88|0;o=d+96|0;p=d+112|0;q=d+120|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+8|0;w=i;i=i+64|0;y=i;i=i+8|0;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+8|0;tQ(b)|0;G=b+56|0;H=c[G>>2]|0;I=c[G+4>>2]|0;c[q>>2]=H;c[q+4>>2]=I;q=H;H=q;G=I;I=G;L1:do{if(H>>>0<I>>>0){J=a[35720]|0;L=J<<24>>24==0;L3:do{if(L){M=H;while(1){N=a[M]|0;if(N<<24>>24==0){O=12;break L1}P=M+1|0;if(!(N<<24>>24==92&(P|0)!=0|(M|0)==0)){Q=M;break L3}if(P>>>0<I>>>0){M=P}else{O=12;break L1}}}else{M=H;while(1){P=a[M]|0;if(P<<24>>24==0){O=12;break L1}N=M+1|0;R=P<<24>>24==92&(N|0)!=0?0:M;if((R|0)!=0){P=R;R=35720;S=J;while(1){if((a[P]|0)!=S<<24>>24){T=P;U=S;break}V=P+1|0;W=R+1|0;X=a[W]|0;if(X<<24>>24==0){T=V;U=0;break}else{P=V;R=W;S=X}}if(!(U<<24>>24!=0|(T|0)==0)){Q=M;break L3}}if(N>>>0<I>>>0){M=N}else{O=12;break L1}}}}while(0);M=b|0;S=c[M>>2]|0;if((Q|0)==0){Y=S;break}R=J0(60)|0;c[n>>2]=R;P=S+4|0;X=c[P>>2]|0;if((X|0)==(c[S+8>>2]|0)){ee(S|0,n);Z=c[n>>2]|0}else{if((X|0)==0){_=0}else{c[X>>2]=R;_=c[P>>2]|0}c[P>>2]=_+4;Z=R}R=Z;X=b+28|0;L26:do{if((a[X]&1)==0){W=t;c[W>>2]=c[X>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];O=56}else{W=c[b+36>>2]|0;V=c[b+32>>2]|0;do{if(V>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(V>>>0<11>>>0){a[t]=V<<1;$=t+1|0}else{aa=V+16&-16;ab=(x=0,as(230,aa|0)|0);if(x){x=0;break}c[t+8>>2]=ab;c[t>>2]=aa|1;c[t+4>>2]=V;$=ab}Kb($|0,W|0,V)|0;a[$+V|0]=0;O=56;break L26}}while(0);V=bQ(-1,-1)|0;ac=K;ad=V}}while(0);do{if((O|0)==56){V=b+44|0;W=m;c[W>>2]=c[V>>2];c[W+4>>2]=c[V+4>>2];c[W+8>>2]=c[V+8>>2];x=0;aB(2,Z|0,t|0,m|0,0,0,0);if(x){x=0;W=bQ(-1,-1)|0;ab=W;W=K;if((a[t]&1)==0){ac=W;ad=ab;break}J2(c[t+8>>2]|0);ac=W;ad=ab;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}ab=Z+40|0;W=ab;aa=u;ae=v|0;af=v+4|0;ag=ab+8|0;ah=ab+12|0;ai=ab+4|0;aj=u+8|0;ak=b+36|0;al=b+32|0;am=u+1|0;an=u|0;ar=u+4|0;at=a[35456]|0;au=at<<24>>24==0;av=C;aw=C+1|0;ay=B;az=B+1|0;aA=D|0;aC=D+4|0;aD=D+8|0;aE=C+8|0;aF=B+8|0;aG=B|0;aH=B+4|0;aI=C+4|0;aJ=C|0;aK=y|0;aL=y+4|0;aM=z;aN=A;aO=w+28|0;aQ=w+4|0;aR=z+8|0;aS=w+8|0;aT=w+36|0;aU=z+1|0;aV=z|0;aW=z+4|0;aX=H;L48:while(1){L50:while(1){L52:do{if(L){aY=aX;while(1){aZ=a[aY]|0;if(aZ<<24>>24==0){O=191;break L48}a_=aY+1|0;if(!(aZ<<24>>24==92&(a_|0)!=0|(aY|0)==0)){a$=aY;break L52}if(a_>>>0<I>>>0){aY=a_}else{O=191;break L48}}}else{aY=aX;while(1){a_=a[aY]|0;if(a_<<24>>24==0){O=191;break L48}aZ=aY+1|0;a0=a_<<24>>24==92&(aZ|0)!=0?0:aY;if((a0|0)!=0){a_=a0;a0=35720;a1=J;while(1){if((a[a_]|0)!=a1<<24>>24){a2=a_;a3=a1;break}a4=a_+1|0;a5=a0+1|0;a6=a[a5]|0;if(a6<<24>>24==0){a2=a4;a3=0;break}else{a_=a4;a0=a5;a1=a6}}if(!(a3<<24>>24!=0|(a2|0)==0)){a$=aY;break L52}}if(aZ>>>0<I>>>0){aY=aZ}else{O=191;break L48}}}}while(0);if((a$|0)==0){O=191;break L48}do{if(aX>>>0<a$>>>0){a7=c[M>>2]|0;aY=J0(52)|0;c[l>>2]=aY;a8=a7+4|0;a1=c[a8>>2]|0;if((a1|0)==(c[a7+8>>2]|0)){ee(a7|0,l);a9=c[l>>2]|0}else{if((a1|0)==0){ba=0}else{c[a1>>2]=aY;ba=c[a8>>2]|0}c[a8>>2]=ba+4;a9=aY}bb=a9;aY=a9;if((a[X]&1)==0){c[aa>>2]=c[X>>2];c[aa+4>>2]=c[X+4>>2];c[aa+8>>2]=c[X+8>>2]}else{a1=c[ak>>2]|0;a0=c[al>>2]|0;if(a0>>>0>4294967279>>>0){O=81;break L48}if(a0>>>0<11>>>0){a[aa]=a0<<1;bc=am}else{a_=a0+16&-16;a6=(x=0,as(230,a_|0)|0);if(x){x=0;O=107;break L48}c[aj>>2]=a6;c[an>>2]=a_|1;c[ar>>2]=a0;bc=a6}Kb(bc|0,a1|0,a0)|0;a[bc+a0|0]=0}a0=k;c[a0>>2]=c[V>>2];c[a0+4>>2]=c[V+4>>2];c[a0+8>>2]=c[V+8>>2];c[ae>>2]=aX;c[af>>2]=a$;x=0;ao(14,aY|0,u|0,k|0,v|0,0);if(x){x=0;bd=1;O=110;break L48}aY=a9;c[j>>2]=aY;a0=c[ag>>2]|0;a1=a0;if((a0|0)==(c[ah>>2]|0)){x=0;aq(370,ai|0,j|0);if(x){x=0;bd=0;O=110;break L48}bf=c[j>>2]|0}else{if((a0|0)==0){bg=0}else{c[a1>>2]=aY;bg=c[ag>>2]|0}c[ag>>2]=bg+4;bf=aY}x=0;aq(c[c[ab>>2]>>2]|0,W|0,bf|0);if(x){x=0;bd=0;O=110;break L48}if((a[aa]&1)==0){break}J2(c[aj>>2]|0)}}while(0);L99:do{if(au){aY=a$;while(1){if(aY>>>0>=I>>>0){break L99}if((a[aY]|0)==0){break L99}if((aY|0)==0){aY=aY+1|0}else{bh=aY;break L50}}}else{aY=a$;while(1){if(aY>>>0>=I>>>0){break L99}a1=a[aY]|0;if(a1<<24>>24==0){break L99}L108:do{if(a1<<24>>24==at<<24>>24){a0=35456;a6=aY;while(1){a_=a6+1|0;a5=a0+1|0;a4=a[a5]|0;if(a4<<24>>24==0){bi=a_;bj=0;break L108}if((a[a_]|0)==a4<<24>>24){a0=a5;a6=a_}else{bi=a_;bj=a4;break}}}else{bi=aY;bj=at}}while(0);if(bj<<24>>24!=0|(bi|0)==0){aY=aY+1|0}else{break}}if((aY|0)!=0){bh=aY;break L50}}}while(0);a1=G-q|0;if(a1>>>0>4294967279>>>0){O=164;break L48}if(a1>>>0<11>>>0){aZ=a1<<1&255;a[av]=aZ;bk=aw;bl=aZ}else{aZ=a1+16&-16;a6=J0(aZ)|0;c[aE>>2]=a6;a0=aZ|1;c[aJ>>2]=a0;c[aI>>2]=a1;bk=a6;bl=a0&255}Kb(bk|0,H|0,a1)|0;a[bk+a1|0]=0;Ke(ay|0,0,12)|0;a1=bl&255;a0=(a1&1|0)==0?a1>>>1:c[aI>>2]|0;a1=a0+56|0;if(a1>>>0>4294967279>>>0){O=169;break L48}if(a1>>>0<11>>>0){a[ay]=112;bm=az}else{a1=a0+72&-16;a6=(x=0,as(230,a1|0)|0);if(x){x=0;O=176;break L48}c[aF>>2]=a6;c[aG>>2]=a1|1;c[aH>>2]=56;bm=a6}Kb(bm|0,4096,56)|0;a[bm+56|0]=0;x=0,ax(64,B|0,((bl&1)==0?aw:c[aE>>2]|0)|0,a0|0)|0;if(x){x=0;O=176;break L48}c[aA>>2]=0;c[aC>>2]=0;c[aD>>2]=0;x=0;aP(466,b|0,B|0,D|0);if(x){x=0;O=187;break L48}if((a[ay]&1)!=0){J2(c[aF>>2]|0)}if((a[av]&1)!=0){J2(c[aE>>2]|0)}if(aX>>>0>=I>>>0){bn=R;O=242;break L48}}c[aK>>2]=a$+2;c[aL>>2]=bh;N=c[M>>2]|0;if((a[X]&1)==0){c[aM>>2]=c[X>>2];c[aM+4>>2]=c[X+4>>2];c[aM+8>>2]=c[X+8>>2]}else{a0=c[ak>>2]|0;a6=c[al>>2]|0;if(a6>>>0>4294967279>>>0){O=133;break}if(a6>>>0<11>>>0){a[aM]=a6<<1;bo=aU}else{a1=a6+16&-16;aZ=J0(a1)|0;c[aR>>2]=aZ;c[aV>>2]=a1|1;c[aW>>2]=a6;bo=aZ}Kb(bo|0,a0|0,a6)|0;a[bo+a6|0]=0}c[aN>>2]=c[V>>2];c[aN+4>>2]=c[V+4>>2];c[aN+8>>2]=c[V+8>>2];x=0;ao(16,w|0,y|0,N|0,z|0,A|0);if(x){x=0;O=154;break}N=(x=0,as(158,w|0)|0);if(x){x=0;O=155;break}if((a[aO]&1)!=0){J2(c[aT>>2]|0)}a6=c[aQ>>2]|0;a0=a6;if((a6|0)!=0){aZ=c[aS>>2]|0;if((a6|0)!=(aZ|0)){c[aS>>2]=aZ+(~((aZ-4+(-a0|0)|0)>>>2)<<2)}J2(a6)}if((a[aM]&1)!=0){J2(c[aR>>2]|0)}a[N+29|0]=1;c[h>>2]=N;a6=c[ag>>2]|0;a0=a6;if((a6|0)==(c[ah>>2]|0)){eq(ai,h);bp=c[h>>2]|0}else{if((a6|0)==0){bq=0}else{c[a0>>2]=N;bq=c[ag>>2]|0}c[ag>>2]=bq+4;bp=N}cy[c[c[ab>>2]>>2]&1023](W,bp);N=bh+1|0;if(N>>>0<I>>>0){aX=N}else{bn=R;O=247;break}}do{if((O|0)==81){x=0;ap(232,0);if(!x){return 0}else{x=0;aN=bQ(-1,-1)|0;br=K;bs=aN;O=109;break}}else if((O|0)==247){bt=bn;i=d;return bt|0}else if((O|0)==176){aN=bQ(-1,-1)|0;bu=K;bv=aN;O=178}else if((O|0)==107){aN=bQ(-1,-1)|0;br=K;bs=aN;O=109}else if((O|0)==187){aN=bQ(-1,-1)|0;aW=aN;aN=K;if((a[ay]&1)==0){bw=aN;bx=aW;O=189;break}J2(c[aF>>2]|0);bw=aN;bx=aW;O=189}else if((O|0)==191){if(aX>>>0>=I>>>0){bn=R;bt=bn;i=d;return bt|0}aW=c[M>>2]|0;aN=J0(52)|0;c[g>>2]=aN;aV=aW+4|0;aU=c[aV>>2]|0;if((aU|0)==(c[aW+8>>2]|0)){ee(aW|0,g);by=c[g>>2]|0}else{if((aU|0)==0){bz=0}else{c[aU>>2]=aN;bz=c[aV>>2]|0}c[aV>>2]=bz+4;by=aN}aN=by;aU=by;L186:do{if((a[X]&1)==0){aL=E;c[aL>>2]=c[X>>2];c[aL+4>>2]=c[X+4>>2];c[aL+8>>2]=c[X+8>>2];O=207}else{aL=c[ak>>2]|0;aK=c[al>>2]|0;do{if(aK>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aK>>>0<11>>>0){a[E]=aK<<1;bA=E+1|0}else{aD=aK+16&-16;aC=(x=0,as(230,aD|0)|0);if(x){x=0;break}c[E+8>>2]=aC;c[E>>2]=aD|1;c[E+4>>2]=aK;bA=aC}Kb(bA|0,aL|0,aK)|0;a[bA+aK|0]=0;O=207;break L186}}while(0);aK=bQ(-1,-1)|0;bB=aK;bC=K}}while(0);do{if((O|0)==207){aK=f;c[aK>>2]=c[V>>2];c[aK+4>>2]=c[V+4>>2];c[aK+8>>2]=c[V+8>>2];c[F>>2]=aX;c[F+4>>2]=I;x=0;ao(14,aU|0,E|0,f|0,F|0,0);do{if(!x){aK=by;c[e>>2]=aK;aL=c[ag>>2]|0;aC=aL;if((aL|0)==(c[ah>>2]|0)){x=0;aq(370,ai|0,e|0);if(x){x=0;bD=0;break}bE=c[e>>2]|0}else{if((aL|0)==0){bF=0}else{c[aC>>2]=aK;bF=c[ag>>2]|0}c[ag>>2]=bF+4;bE=aK}x=0;aq(c[c[ab>>2]>>2]|0,W|0,bE|0);if(x){x=0;bD=0;break}if((a[E]&1)==0){bn=R;bt=bn;i=d;return bt|0}J2(c[E+8>>2]|0);bn=R;bt=bn;i=d;return bt|0}else{x=0;bD=1}}while(0);aK=bQ(-1,-1)|0;aC=aK;aK=K;if((a[E]&1)==0){if(bD){bB=aC;bC=aK;break}else{bG=aK;bH=aC}bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}else{J2(c[E+8>>2]|0);if(bD){bB=aC;bC=aK;break}else{bG=aK;bH=aC}bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}}}while(0);aU=c[aW>>2]|0;aC=c[aV>>2]|0;aK=aU;while(1){if((aK|0)==(aC|0)){bM=aC;break}if((c[aK>>2]|0)==(by|0)){bM=aK;break}else{aK=aK+4|0}}aK=bM-aU>>2;aW=aU+(aK+1<<2)|0;aL=aC-aW|0;Kc(aU+(aK<<2)|0,aW|0,aL|0)|0;aW=aU+((aL>>2)+aK<<2)|0;aK=c[aV>>2]|0;if((aW|0)!=(aK|0)){c[aV>>2]=aK+(~((aK-4+(-aW|0)|0)>>>2)<<2)}J2(aN);bG=bC;bH=bB;bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}else if((O|0)==110){aW=bQ(-1,-1)|0;aK=aW;aW=K;if((a[aa]&1)==0){if(bd){bN=aK;bO=aW;break}else{bG=aW;bH=aK}bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}else{J2(c[aj>>2]|0);if(bd){bN=aK;bO=aW;break}else{bG=aW;bH=aK}bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}}else if((O|0)==242){bt=bn;i=d;return bt|0}else if((O|0)==133){CJ(0);return 0}else if((O|0)==164){CJ(0);return 0}else if((O|0)==169){x=0;ap(232,0);if(!x){return 0}else{x=0;aK=bQ(-1,-1)|0;bu=K;bv=aK;O=178;break}}else if((O|0)==154){aK=bQ(-1,-1)|0;bP=K;bR=aK;O=161}else if((O|0)==155){aK=bQ(-1,-1)|0;aW=aK;aK=K;if((a[aO]&1)!=0){J2(c[aT>>2]|0)}aL=c[aQ>>2]|0;if((aL|0)==0){bP=aK;bR=aW;O=161;break}aD=c[aS>>2]|0;if((aL|0)!=(aD|0)){c[aS>>2]=aD+(~((aD-4+(-aL|0)|0)>>>2)<<2)}J2(aL);bP=aK;bR=aW;O=161}}while(0);if((O|0)==109){bN=bs;bO=br}else if((O|0)==161){if((a[aM]&1)==0){bG=bP;bH=bR;bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}J2(c[aR>>2]|0);bG=bP;bH=bR;bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}else if((O|0)==178){if((a[ay]&1)!=0){J2(c[aF>>2]|0)}bw=bu;bx=bv;O=189}if((O|0)==189){if((a[av]&1)==0){bG=bw;bH=bx;bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}J2(c[aE>>2]|0);bG=bw;bH=bx;bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}aS=c[a7>>2]|0;aQ=c[a8>>2]|0;aT=aS;while(1){if((aT|0)==(aQ|0)){bS=aQ;break}if((c[aT>>2]|0)==(a9|0)){bS=aT;break}else{aT=aT+4|0}}aT=bS-aS>>2;aE=aS+(aT+1<<2)|0;av=aQ-aE|0;Kc(aS+(aT<<2)|0,aE|0,av|0)|0;aE=aS+((av>>2)+aT<<2)|0;aT=c[a8>>2]|0;if((aE|0)!=(aT|0)){c[a8>>2]=aT+(~((aT-4+(-aE|0)|0)>>>2)<<2)}J2(bb);bG=bO;bH=bN;bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}}while(0);X=c[S>>2]|0;M=c[P>>2]|0;J=X;while(1){if((J|0)==(M|0)){bT=M;break}if((c[J>>2]|0)==(Z|0)){bT=J;break}else{J=J+4|0}}J=bT-X>>2;S=X+(J+1<<2)|0;L=M-S|0;Kc(X+(J<<2)|0,S|0,L|0)|0;S=X+((L>>2)+J<<2)|0;J=c[P>>2]|0;if((S|0)!=(J|0)){c[P>>2]=J+(~((J-4+(-S|0)|0)>>>2)<<2)}J2(R);bG=ac;bH=ad;bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0)}else{O=12}}while(0);if((O|0)==12){Y=c[b>>2]|0}ad=J0(52)|0;c[p>>2]=ad;ac=Y+4|0;bT=c[ac>>2]|0;if((bT|0)==(c[Y+8>>2]|0)){ee(Y|0,p);bU=c[p>>2]|0}else{if((bT|0)==0){bV=0}else{c[bT>>2]=ad;bV=c[ac>>2]|0}c[ac>>2]=bV+4;bU=ad}ad=bU;bV=b+28|0;L298:do{if((a[bV]&1)==0){bT=s;c[bT>>2]=c[bV>>2];c[bT+4>>2]=c[bV+4>>2];c[bT+8>>2]=c[bV+8>>2];O=29}else{bT=c[b+36>>2]|0;p=c[b+32>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(p>>>0<11>>>0){a[s]=p<<1;bW=s+1|0}else{Z=p+16&-16;bN=(x=0,as(230,Z|0)|0);if(x){x=0;break}c[s+8>>2]=bN;c[s>>2]=Z|1;c[s+4>>2]=p;bW=bN}Kb(bW|0,bT|0,p)|0;a[bW+p|0]=0;O=29;break L298}}while(0);p=bQ(-1,-1)|0;bX=K;bY=p}}while(0);do{if((O|0)==29){bW=b+44|0;bV=o;c[bV>>2]=c[bW>>2];c[bV+4>>2]=c[bW+4>>2];c[bV+8>>2]=c[bW+8>>2];x=0;ao(14,bU|0,s|0,o|0,r|0,0);if(x){x=0;bW=bQ(-1,-1)|0;bV=bW;bW=K;if((a[s]&1)==0){bX=bW;bY=bV;break}J2(c[s+8>>2]|0);bX=bW;bY=bV;break}if((a[s]&1)==0){bn=ad;bt=bn;i=d;return bt|0}J2(c[s+8>>2]|0);bn=ad;bt=bn;i=d;return bt|0}}while(0);bt=c[Y>>2]|0;Y=c[ac>>2]|0;d=bt;while(1){if((d|0)==(Y|0)){bZ=Y;break}if((c[d>>2]|0)==(bU|0)){bZ=d;break}else{d=d+4|0}}d=bZ-bt>>2;bZ=bt+(d+1<<2)|0;bU=Y-bZ|0;Kc(bt+(d<<2)|0,bZ|0,bU|0)|0;bZ=bt+((bU>>2)+d<<2)|0;d=c[ac>>2]|0;if((bZ|0)!=(d|0)){c[ac>>2]=d+(~((d-4+(-bZ|0)|0)>>>2)<<2)}J2(ad);bG=bX;bH=bY;bI=bH;bJ=0;bK=bI;bL=bG;be(bK|0);return 0}function sB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=(a[e]|0)==42?e+1|0:0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=xQ(g)|0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function sC(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=h+32|0;Kb(l|0,e|0,12)|0;e=j;m=k;n=b|0;o=d;if((a[o]&1)==0){c[e>>2]=c[o>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2]}else{o=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){CJ(0)}if(p>>>0<11>>>0){a[e]=p<<1;q=j+1|0}else{d=p+16&-16;r=J0(d)|0;c[j+8>>2]=r;c[j>>2]=d|1;c[j+4>>2]=p;q=r}Kb(q|0,o|0,p)|0;a[q+p|0]=0}c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];x=0;aT(6,n|0,j|0,k|0,g|0);if(!x){if((a[e]&1)==0){s=b|0;c[s>>2]=16872;t=b+32|0;c[t>>2]=f;i=h;return}J2(c[j+8>>2]|0);s=b|0;c[s>>2]=16872;t=b+32|0;c[t>>2]=f;i=h;return}else{x=0;h=bQ(-1,-1)|0;if((a[e]&1)==0){be(h|0)}J2(c[j+8>>2]|0);be(h|0)}}function sD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0;e=i;i=i+336|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+64|0;m=e+80|0;n=e+88|0;o=e+96|0;p=e+104|0;q=e+120|0;r=e+128|0;s=e+144|0;t=e+152|0;u=e+168|0;v=e+184|0;w=e+192|0;y=e+256|0;z=e+264|0;A=e+280|0;B=e+296|0;C=e+312|0;D=e+320|0;r0(b)|0;E=b+20|0;F=c[E>>2]|0;G=b|0;H=c[G>>2]|0;I=J0(60)|0;c[s>>2]=I;J=H+4|0;L=c[J>>2]|0;if((L|0)==(c[H+8>>2]|0)){ee(H|0,s);M=c[s>>2]|0}else{if((L|0)==0){N=0}else{c[L>>2]=I;N=c[J>>2]|0}c[J>>2]=N+4;M=I}I=M;N=b+28|0;L8:do{if((a[N]&1)==0){L=t;c[L>>2]=c[N>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];O=16}else{L=c[b+36>>2]|0;s=c[b+32>>2]|0;do{if(s>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(s>>>0<11>>>0){a[t]=s<<1;P=t+1|0}else{Q=s+16&-16;R=(x=0,as(230,Q|0)|0);if(x){x=0;break}c[t+8>>2]=R;c[t>>2]=Q|1;c[t+4>>2]=s;P=R}Kb(P|0,L|0,s)|0;a[P+s|0]=0;O=16;break L8}}while(0);s=bQ(-1,-1)|0;S=s;T=K}}while(0);do{if((O|0)==16){P=b+44|0;s=r;c[s>>2]=c[P>>2];c[s+4>>2]=c[P+4>>2];c[s+8>>2]=c[P+8>>2];x=0;aB(2,M|0,t|0,r|0,0,0,0);if(x){x=0;s=bQ(-1,-1)|0;L=s;s=K;if((a[t]&1)==0){S=L;T=s;break}J2(c[t+8>>2]|0);S=L;T=s;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}L30:do{if(F>>>0<d>>>0){s=a[35720]|0;L=s<<24>>24==0;R=M+40|0;Q=R;U=u;V=v|0;W=v+4|0;X=R+8|0;Y=R+12|0;Z=R+4|0;_=u+8|0;$=b+36|0;aa=b+32|0;ab=u+1|0;ac=u|0;ad=u+4|0;ae=a[35456]|0;af=ae<<24>>24==0;ag=y|0;ah=y+4|0;ai=z;aj=A;ak=w+28|0;al=w+4|0;am=z+8|0;an=w+8|0;ar=w+36|0;at=z+1|0;au=z|0;av=z+4|0;aw=F;L32:while(1){if(L){ax=aw;while(1){if(ax>>>0>=d>>>0){O=122;break L32}if((a[ax]|0)==0){O=122;break L32}if((ax|0)==0){ax=ax+1|0}else{ay=ax;break}}}else{ax=aw;while(1){if(ax>>>0>=d>>>0){O=122;break L32}az=a[ax]|0;if(az<<24>>24==0){O=122;break L32}L39:do{if(az<<24>>24==s<<24>>24){aA=35720;aC=ax;while(1){aD=aC+1|0;aE=aA+1|0;aF=a[aE]|0;if(aF<<24>>24==0){aG=aD;aH=0;break L39}if((a[aD]|0)==aF<<24>>24){aA=aE;aC=aD}else{aG=aD;aH=aF;break}}}else{aG=ax;aH=s}}while(0);if(aH<<24>>24!=0|(aG|0)==0){ax=ax+1|0}else{break}}if((ax|0)==0){O=122;break}else{ay=ax}}do{if(aw>>>0<ay>>>0){aI=c[G>>2]|0;az=J0(52)|0;c[q>>2]=az;aJ=aI+4|0;aC=c[aJ>>2]|0;if((aC|0)==(c[aI+8>>2]|0)){ee(aI|0,q);aK=c[q>>2]|0}else{if((aC|0)==0){aL=0}else{c[aC>>2]=az;aL=c[aJ>>2]|0}c[aJ>>2]=aL+4;aK=az}aM=aK;az=aK;if((a[N]&1)==0){c[U>>2]=c[N>>2];c[U+4>>2]=c[N+4>>2];c[U+8>>2]=c[N+8>>2]}else{aC=c[$>>2]|0;aA=c[aa>>2]|0;if(aA>>>0>4294967279>>>0){O=41;break L32}if(aA>>>0<11>>>0){a[U]=aA<<1;aN=ab}else{aF=aA+16&-16;aD=(x=0,as(230,aF|0)|0);if(x){x=0;O=67;break L32}c[_>>2]=aD;c[ac>>2]=aF|1;c[ad>>2]=aA;aN=aD}Kb(aN|0,aC|0,aA)|0;a[aN+aA|0]=0}aA=p;c[aA>>2]=c[P>>2];c[aA+4>>2]=c[P+4>>2];c[aA+8>>2]=c[P+8>>2];c[V>>2]=aw;c[W>>2]=ay;x=0;ao(14,az|0,u|0,p|0,v|0,0);if(x){x=0;aO=1;O=70;break L32}az=aK;c[o>>2]=az;aA=c[X>>2]|0;aC=aA;if((aA|0)==(c[Y>>2]|0)){x=0;aq(370,Z|0,o|0);if(x){x=0;aO=0;O=70;break L32}aP=c[o>>2]|0}else{if((aA|0)==0){aQ=0}else{c[aC>>2]=az;aQ=c[X>>2]|0}c[X>>2]=aQ+4;aP=az}x=0;aq(c[c[R>>2]>>2]|0,Q|0,aP|0);if(x){x=0;aO=0;O=70;break L32}if((a[U]&1)==0){break}J2(c[_>>2]|0)}}while(0);L81:do{if(af){ax=ay;while(1){if(ax>>>0>=d>>>0){aR=0;break L81}if((a[ax]|0)==0){aR=0;break L81}if((ax|0)==0){ax=ax+1|0}else{aR=ax;break}}}else{ax=ay;while(1){if(ax>>>0>=d>>>0){aR=0;break L81}az=a[ax]|0;if(az<<24>>24==0){aR=0;break L81}L90:do{if(az<<24>>24==ae<<24>>24){aC=35456;aA=ax;while(1){aD=aA+1|0;aF=aC+1|0;aE=a[aF]|0;if(aE<<24>>24==0){aS=aD;aT=0;break L90}if((a[aD]|0)==aE<<24>>24){aC=aF;aA=aD}else{aS=aD;aT=aE;break}}}else{aS=ax;aT=ae}}while(0);if(aT<<24>>24!=0|(aS|0)==0){ax=ax+1|0}else{aR=ax;break}}}}while(0);c[ag>>2]=ay+2;c[ah>>2]=aR;ax=c[G>>2]|0;if((a[N]&1)==0){c[ai>>2]=c[N>>2];c[ai+4>>2]=c[N+4>>2];c[ai+8>>2]=c[N+8>>2]}else{az=c[$>>2]|0;aA=c[aa>>2]|0;if(aA>>>0>4294967279>>>0){O=92;break}if(aA>>>0<11>>>0){a[ai]=aA<<1;aU=at}else{aC=aA+16&-16;aE=J0(aC)|0;c[am>>2]=aE;c[au>>2]=aC|1;c[av>>2]=aA;aU=aE}Kb(aU|0,az|0,aA)|0;a[aU+aA|0]=0}c[aj>>2]=c[P>>2];c[aj+4>>2]=c[P+4>>2];c[aj+8>>2]=c[P+8>>2];x=0;ao(16,w|0,y|0,ax|0,z|0,A|0);if(x){x=0;O=113;break}ax=(x=0,as(158,w|0)|0);if(x){x=0;O=114;break}if((a[ak]&1)!=0){J2(c[ar>>2]|0)}aA=c[al>>2]|0;az=aA;if((aA|0)!=0){aE=c[an>>2]|0;if((aA|0)!=(aE|0)){c[an>>2]=aE+(~((aE-4+(-az|0)|0)>>>2)<<2)}J2(aA)}if((a[ai]&1)!=0){J2(c[am>>2]|0)}a[ax+29|0]=1;c[n>>2]=ax;aA=c[X>>2]|0;az=aA;if((aA|0)==(c[Y>>2]|0)){eq(Z,n);aV=c[n>>2]|0}else{if((aA|0)==0){aW=0}else{c[az>>2]=ax;aW=c[X>>2]|0}c[X>>2]=aW+4;aV=ax}cy[c[c[R>>2]>>2]&1023](Q,aV);ax=aR+1|0;if(ax>>>0<d>>>0){aw=ax}else{break L30}}do{if((O|0)==67){aj=bQ(-1,-1)|0;aX=K;aY=aj;O=69}else if((O|0)==70){aj=bQ(-1,-1)|0;av=aj;aj=K;if((a[U]&1)==0){if(aO){aZ=aj;a_=av;break}else{a$=av;a0=aj}a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}else{J2(c[_>>2]|0);if(aO){aZ=aj;a_=av;break}else{a$=av;a0=aj}a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}}else if((O|0)==92){CJ(0);return 0}else if((O|0)==113){aj=bQ(-1,-1)|0;a5=aj;a6=K;O=120}else if((O|0)==114){aj=bQ(-1,-1)|0;av=aj;aj=K;if((a[ak]&1)!=0){J2(c[ar>>2]|0)}au=c[al>>2]|0;if((au|0)==0){a5=av;a6=aj;O=120;break}at=c[an>>2]|0;if((au|0)!=(at|0)){c[an>>2]=at+(~((at-4+(-au|0)|0)>>>2)<<2)}J2(au);a5=av;a6=aj;O=120}else if((O|0)==122){aj=c[G>>2]|0;av=J0(52)|0;c[m>>2]=av;au=aj+4|0;at=c[au>>2]|0;if((at|0)==(c[aj+8>>2]|0)){ee(aj|0,m);a7=c[m>>2]|0}else{if((at|0)==0){a8=0}else{c[at>>2]=av;a8=c[au>>2]|0}c[au>>2]=a8+4;a7=av}av=a7;at=a7;L152:do{if((a[N]&1)==0){ah=B;c[ah>>2]=c[N>>2];c[ah+4>>2]=c[N+4>>2];c[ah+8>>2]=c[N+8>>2];O=137}else{ah=c[$>>2]|0;ag=c[aa>>2]|0;do{if(ag>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ag>>>0<11>>>0){a[B]=ag<<1;a9=B+1|0}else{ae=ag+16&-16;af=(x=0,as(230,ae|0)|0);if(x){x=0;break}c[B+8>>2]=af;c[B>>2]=ae|1;c[B+4>>2]=ag;a9=af}Kb(a9|0,ah|0,ag)|0;a[a9+ag|0]=0;O=137;break L152}}while(0);ag=bQ(-1,-1)|0;ba=K;bb=ag}}while(0);do{if((O|0)==137){ag=l;c[ag>>2]=c[P>>2];c[ag+4>>2]=c[P+4>>2];c[ag+8>>2]=c[P+8>>2];c[C>>2]=aw;c[C+4>>2]=d;x=0;ao(14,at|0,B|0,l|0,C|0,0);do{if(!x){ag=a7;c[k>>2]=ag;ah=c[X>>2]|0;af=ah;if((ah|0)==(c[Y>>2]|0)){x=0;aq(370,Z|0,k|0);if(x){x=0;bc=0;break}bd=c[k>>2]|0}else{if((ah|0)==0){bf=0}else{c[af>>2]=ag;bf=c[X>>2]|0}c[X>>2]=bf+4;bd=ag}x=0;aq(c[c[R>>2]>>2]|0,Q|0,bd|0);if(x){x=0;bc=0;break}if((a[B]&1)==0){break L30}J2(c[B+8>>2]|0);break L30}else{x=0;bc=1}}while(0);ag=bQ(-1,-1)|0;af=ag;ag=K;if((a[B]&1)==0){if(bc){ba=ag;bb=af;break}else{a$=af;a0=ag}a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}else{J2(c[B+8>>2]|0);if(bc){ba=ag;bb=af;break}else{a$=af;a0=ag}a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}}}while(0);at=c[aj>>2]|0;ag=c[au>>2]|0;af=at;while(1){if((af|0)==(ag|0)){bg=ag;break}if((c[af>>2]|0)==(a7|0)){bg=af;break}else{af=af+4|0}}af=bg-at>>2;aj=at+(af+1<<2)|0;ah=ag-aj|0;Kc(at+(af<<2)|0,aj|0,ah|0)|0;aj=at+((ah>>2)+af<<2)|0;af=c[au>>2]|0;if((aj|0)!=(af|0)){c[au>>2]=af+(~((af-4+(-aj|0)|0)>>>2)<<2)}J2(av);a$=bb;a0=ba;a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}else if((O|0)==41){x=0;ap(232,0);if(!x){return 0}else{x=0;aj=bQ(-1,-1)|0;aX=K;aY=aj;O=69;break}}}while(0);if((O|0)==120){if((a[ai]&1)==0){a$=a5;a0=a6;a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}J2(c[am>>2]|0);a$=a5;a0=a6;a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}else if((O|0)==69){aZ=aX;a_=aY}Q=c[aI>>2]|0;R=c[aJ>>2]|0;X=Q;while(1){if((X|0)==(R|0)){bh=R;break}if((c[X>>2]|0)==(aK|0)){bh=X;break}else{X=X+4|0}}X=bh-Q>>2;am=Q+(X+1<<2)|0;ai=R-am|0;Kc(Q+(X<<2)|0,am|0,ai|0)|0;am=Q+((ai>>2)+X<<2)|0;X=c[aJ>>2]|0;if((am|0)!=(X|0)){c[aJ>>2]=X+(~((X-4+(-am|0)|0)>>>2)<<2)}J2(aM);a$=a_;a0=aZ;a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}}while(0);c[E>>2]=d;am=c[G>>2]|0;X=J0(36)|0;c[j>>2]=X;ai=am+4|0;Z=c[ai>>2]|0;if((Z|0)==(c[am+8>>2]|0)){ee(am|0,j);bi=c[j>>2]|0}else{if((Z|0)==0){bj=0}else{c[Z>>2]=X;bj=c[ai>>2]|0}c[ai>>2]=bj+4;bi=X}X=bi;Z=bi;L222:do{if((a[N]&1)==0){Y=D;c[Y>>2]=c[N>>2];c[Y+4>>2]=c[N+4>>2];c[Y+8>>2]=c[N+8>>2];bk=a[Y]|0;bl=Y;O=172}else{Y=c[b+36>>2]|0;aw=c[b+32>>2]|0;do{if(aw>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aw>>>0<11>>>0){aa=aw<<1&255;$=D;a[$]=aa;bm=D+1|0;bn=aa;bo=$}else{$=aw+16&-16;aa=(x=0,as(230,$|0)|0);if(x){x=0;break}c[D+8>>2]=aa;an=$|1;c[D>>2]=an;c[D+4>>2]=aw;bm=aa;bn=an&255;bo=D}Kb(bm|0,Y|0,aw)|0;a[bm+aw|0]=0;bk=bn;bl=bo;O=172;break L222}}while(0);aw=bQ(-1,-1)|0;bp=aw;bq=K}}while(0);do{if((O|0)==172){aw=h;c[aw>>2]=c[P>>2];c[aw+4>>2]=c[P+4>>2];c[aw+8>>2]=c[P+8>>2];aw=h;Y=f;Q=g;R=bi;L237:do{if((bk&1)==0){c[Y>>2]=c[bl>>2];c[Y+4>>2]=c[bl+4>>2];c[Y+8>>2]=c[bl+8>>2];O=182}else{an=c[D+8>>2]|0;aa=c[D+4>>2]|0;do{if(aa>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aa>>>0<11>>>0){a[Y]=aa<<1;br=f+1|0}else{$=aa+16&-16;al=(x=0,as(230,$|0)|0);if(x){x=0;break}c[f+8>>2]=al;c[f>>2]=$|1;c[f+4>>2]=aa;br=al}Kb(br|0,an|0,aa)|0;a[br+aa|0]=0;O=182;break L237}}while(0);aa=bQ(-1,-1)|0;bs=K;bt=aa}}while(0);do{if((O|0)==182){c[Q>>2]=c[aw>>2];c[Q+4>>2]=c[aw+4>>2];c[Q+8>>2]=c[aw+8>>2];x=0;ao(20,R|0,f|0,g|0,0,0);if(x){x=0;aa=bQ(-1,-1)|0;an=K;if((a[Y]&1)==0){bs=an;bt=aa;break}J2(c[f+8>>2]|0);bs=an;bt=aa;break}if((a[Y]&1)!=0){J2(c[f+8>>2]|0)}c[bi>>2]=20272;c[bi+32>>2]=M;if((a[bl]&1)==0){i=e;return Z|0}J2(c[D+8>>2]|0);i=e;return Z|0}}while(0);Y=bt;R=bs;if((a[bl]&1)==0){bp=Y;bq=R;break}J2(c[D+8>>2]|0);bp=Y;bq=R}}while(0);Z=c[am>>2]|0;P=c[ai>>2]|0;R=Z;while(1){if((R|0)==(P|0)){bu=P;break}if((c[R>>2]|0)==(bi|0)){bu=R;break}else{R=R+4|0}}R=bu-Z>>2;am=Z+(R+1<<2)|0;Y=P-am|0;Kc(Z+(R<<2)|0,am|0,Y|0)|0;am=Z+((Y>>2)+R<<2)|0;R=c[ai>>2]|0;if((am|0)!=(R|0)){c[ai>>2]=R+(~((R-4+(-am|0)|0)>>>2)<<2)}J2(X);a$=bp;a0=bq;a1=a$;a2=0;a3=a1;a4=a0;be(a3|0)}}while(0);bq=c[H>>2]|0;H=c[J>>2]|0;bp=bq;while(1){if((bp|0)==(H|0)){bv=H;break}if((c[bp>>2]|0)==(M|0)){bv=bp;break}else{bp=bp+4|0}}bp=bv-bq>>2;bv=bq+(bp+1<<2)|0;M=H-bv|0;Kc(bq+(bp<<2)|0,bv|0,M|0)|0;bv=bq+((M>>2)+bp<<2)|0;bp=c[J>>2]|0;if((bv|0)!=(bp|0)){c[J>>2]=bp+(~((bp-4+(-bv|0)|0)>>>2)<<2)}J2(I);a$=S;a0=T;a1=a$;a2=0;a3=a1;a4=a0;be(a3|0);return 0}
function sE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0;d=i;i=i+200|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=d+48|0;l=d+64|0;m=d+80|0;n=d+88|0;o=d+96|0;p=d+104|0;q=d+120|0;r=d+136|0;s=d+152|0;t=d+168|0;u=d+184|0;Ac(o,0);v=b|0;w=c[v>>2]|0;y=(x=0,as(230,48)|0);L1:do{if(!x){z=y;c[m>>2]=z;A=w+4|0;B=c[A>>2]|0;if((B|0)==(c[w+8>>2]|0)){x=0;aq(376,w|0,m|0);if(x){x=0;C=74;break}D=c[m>>2]|0}else{if((B|0)==0){E=0}else{c[B>>2]=z;E=c[A>>2]|0}c[A>>2]=E+4;D=z}z=D;B=D;F=b+28|0;L11:do{if((a[F]&1)==0){G=p;c[G>>2]=c[F>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];C=18}else{G=c[b+36>>2]|0;H=c[b+32>>2]|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(H>>>0<11>>>0){a[p]=H<<1;I=p+1|0}else{J=H+16&-16;L=(x=0,as(230,J|0)|0);if(x){x=0;break}c[p+8>>2]=L;c[p>>2]=J|1;c[p+4>>2]=H;I=L}Kb(I|0,G|0,H)|0;a[I+H|0]=0;C=18;break L11}}while(0);H=bQ(-1,-1)|0;M=H;N=K}}while(0);do{if((C|0)==18){H=b+44|0;G=l;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];x=0;aT(54,B|0,p|0,l|0,0);if(x){x=0;G=bQ(-1,-1)|0;L=G;G=K;if((a[p]&1)==0){M=L;N=G;break}J2(c[p+8>>2]|0);M=L;N=G;break}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}G=q;L=r;J=s;O=t;P=u;Q=u+8|0;R=b+36|0;S=b+32|0;T=u+1|0;U=u|0;V=u+4|0;W=t+8|0;X=t+1|0;Y=t|0;Z=t+4|0;_=r+8|0;$=r+1|0;aa=r|0;ab=r+4|0;ac=D+32|0;ad=ac;ae=D+40|0;af=ac+12|0;ag=D+36|0;ah=ac;ac=b+20|0;ai=b+48|0;aj=b+40|0;ak=b+52|0;al=b+56|0;L33:while(1){am=(x=0,as(34,b|0)|0);if(x){x=0;C=73;break}an=am+28|0;do{if((a[an]&1)==0){c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];ao=c[v>>2]|0;ar=(x=0,as(230,36)|0);if(x){x=0;C=73;break L33}at=ar;c[j>>2]=at;au=ao+4|0;ar=c[au>>2]|0;if((ar|0)==(c[ao+8>>2]|0)){x=0;aq(376,ao|0,j|0);if(x){x=0;C=73;break L33}av=c[j>>2]|0}else{if((ar|0)==0){aw=0}else{c[ar>>2]=at;aw=c[au>>2]|0}c[au>>2]=aw+4;av=at}ax=av;if((a[F]&1)==0){c[L>>2]=c[F>>2];c[L+4>>2]=c[F+4>>2];c[L+8>>2]=c[F+8>>2]}else{at=c[R>>2]|0;ar=c[S>>2]|0;if(ar>>>0>4294967279>>>0){C=34;break L33}if(ar>>>0<11>>>0){a[L]=ar<<1;ay=$}else{az=ar+16&-16;aA=(x=0,as(230,az|0)|0);if(x){x=0;C=85;break L33}c[_>>2]=aA;c[aa>>2]=az|1;c[ab>>2]=ar;ay=aA}Kb(ay|0,at|0,ar)|0;a[ay+ar|0]=0}c[J>>2]=c[G>>2];c[J+4>>2]=c[G+4>>2];c[J+8>>2]=c[G+8>>2];x=0;aT(50,av|0,r|0,s|0,0);if(x){x=0;C=88;break L33}if((a[L]&1)!=0){J2(c[_>>2]|0)}aC=c[v>>2]|0;ar=(x=0,as(230,48)|0);if(x){x=0;C=73;break L33}at=ar;c[h>>2]=at;aD=aC+4|0;ar=c[aD>>2]|0;if((ar|0)==(c[aC+8>>2]|0)){x=0;aq(376,aC|0,h|0);if(x){x=0;C=73;break L33}aE=c[h>>2]|0}else{if((ar|0)==0){aF=0}else{c[ar>>2]=at;aF=c[aD>>2]|0}c[aD>>2]=aF+4;aE=at}aG=aE;at=aE;if((a[F]&1)==0){c[O>>2]=c[F>>2];c[O+4>>2]=c[F+4>>2];c[O+8>>2]=c[F+8>>2]}else{ar=c[R>>2]|0;aA=c[S>>2]|0;if(aA>>>0>4294967279>>>0){C=54;break L33}if(aA>>>0<11>>>0){a[O]=aA<<1;aH=X}else{az=aA+16&-16;aI=(x=0,as(230,az|0)|0);if(x){x=0;C=96;break L33}c[W>>2]=aI;c[Y>>2]=az|1;c[Z>>2]=aA;aH=aI}Kb(aH|0,ar|0,aA)|0;a[aH+aA|0]=0}aA=g;c[aA>>2]=c[G>>2];c[aA+4>>2]=c[G+4>>2];c[aA+8>>2]=c[G+8>>2];x=0;aT(38,at|0,t|0,g|0,0);if(x){x=0;C=99;break L33}if((a[O]&1)!=0){J2(c[W>>2]|0)}aA=aE+32|0;ar=aA;aI=av;c[f>>2]=aI;az=aE+40|0;aJ=c[az>>2]|0;aK=aJ;if((aK|0)==(c[aA+12>>2]|0)){x=0;aq(722,aE+36|0,f|0);if(x){x=0;C=73;break L33}aL=c[f>>2]|0}else{if((aJ|0)==0){aM=0}else{c[aK>>2]=aI;aM=c[az>>2]|0}c[az>>2]=aM+4;aL=aI}x=0;aq(c[c[aA>>2]>>2]|0,ar|0,aL|0);if(x){x=0;C=73;break L33}ar=am+36|0;if((c[ar>>2]|0)==0){c[ar>>2]=at;a[an]=1;aN=am;break}aO=c[v>>2]|0;ar=(x=0,as(230,44)|0);if(x){x=0;C=73;break L33}aA=ar;c[e>>2]=aA;aP=aO+4|0;ar=c[aP>>2]|0;if((ar|0)==(c[aO+8>>2]|0)){x=0;aq(376,aO|0,e|0);if(x){x=0;C=73;break L33}aQ=c[e>>2]|0}else{if((ar|0)==0){aR=0}else{c[ar>>2]=aA;aR=c[aP>>2]|0}c[aP>>2]=aR+4;aQ=aA}aS=aQ;aA=aQ;if((a[F]&1)==0){c[P>>2]=c[F>>2];c[P+4>>2]=c[F+4>>2];c[P+8>>2]=c[F+8>>2]}else{ar=c[R>>2]|0;aI=c[S>>2]|0;if(aI>>>0>4294967279>>>0){C=117;break L33}if(aI>>>0<11>>>0){a[P]=aI<<1;aU=T}else{az=aI+16&-16;aK=(x=0,as(230,az|0)|0);if(x){x=0;C=128;break L33}c[Q>>2]=aK;c[U>>2]=az|1;c[V>>2]=aI;aU=aK}Kb(aU|0,ar|0,aI)|0;a[aU+aI|0]=0}aI=k;c[aI>>2]=c[G>>2];c[aI+4>>2]=c[G+4>>2];c[aI+8>>2]=c[G+8>>2];x=0;aB(18,aA|0,u|0,k|0,0,at|0,am|0);if(x){x=0;C=131;break L33}if((a[P]&1)!=0){J2(c[Q>>2]|0)}a[aQ+28|0]=1;aN=aA}else{aN=am}}while(0);c[n>>2]=aN;am=c[ae>>2]|0;an=am;if((an|0)==(c[af>>2]|0)){x=0;aq(270,ag|0,n|0);if(x){x=0;C=73;break}aV=c[n>>2]|0}else{if((am|0)==0){aW=0}else{c[an>>2]=aN;aW=c[ae>>2]|0}c[ae>>2]=aW+4;aV=aN}x=0;aq(c[c[ah>>2]>>2]|0,ad|0,aV|0);if(x){x=0;C=73;break}an=(x=0,as(60,c[ac>>2]|0)|0);if(x){x=0;C=73;break}am=(a[an]|0)==44?an+1|0:0;if((am|0)==0){C=158;break}aA=c[ai>>2]|0;at=c[ac>>2]|0;L131:do{if(at>>>0<am>>>0){aI=at;ar=0;while(1){aK=a[aI]|0;if((aK<<24>>24|0)==10){aX=ar+1|0}else if((aK<<24>>24|0)==0){aY=ar;break L131}else{aX=ar}aK=aI+1|0;if(aK>>>0<am>>>0){aI=aK;ar=aX}else{aY=aX;break}}}else{aY=0}}while(0);c[ai>>2]=aY+aA;ar=an;aI=0;while(1){aK=ar-1|0;if(aK>>>0<at>>>0){break}if((a[aK]|0)==10){break}else{ar=aK;aI=aI+1|0}}if((aY|0)!=0){c[aj>>2]=1}ar=c[aj>>2]|0;c[ak>>2]=ar+aI;at=am;aA=an;c[aj>>2]=at-aA+aI+ar;c[al>>2]=aA;c[al+4>>2]=at;c[ac>>2]=am}do{if((C|0)==117){x=0;ap(232,0);if(!x){return 0}else{x=0;ac=bQ(-1,-1)|0;aZ=K;a_=ac;C=130;break}}else if((C|0)==128){ac=bQ(-1,-1)|0;aZ=K;a_=ac;C=130}else if((C|0)==88){ac=bQ(-1,-1)|0;al=ac;ac=K;if((a[L]&1)==0){a$=al;a0=ac;C=90;break}J2(c[_>>2]|0);a$=al;a0=ac;C=90}else if((C|0)==34){x=0;ap(232,0);if(!x){return 0}else{x=0;ac=bQ(-1,-1)|0;a1=K;a2=ac;C=87;break}}else if((C|0)==99){ac=bQ(-1,-1)|0;al=ac;ac=K;if((a[O]&1)==0){a3=al;a4=ac;C=101;break}J2(c[W>>2]|0);a3=al;a4=ac;C=101}else if((C|0)==96){ac=bQ(-1,-1)|0;a5=K;a6=ac;C=98}else if((C|0)==85){ac=bQ(-1,-1)|0;a1=K;a2=ac;C=87}else if((C|0)==54){x=0;ap(232,0);if(!x){return 0}else{x=0;ac=bQ(-1,-1)|0;a5=K;a6=ac;C=98;break}}else if((C|0)==131){ac=bQ(-1,-1)|0;al=ac;ac=K;if((a[P]&1)==0){a7=al;a8=ac;C=133;break}J2(c[Q>>2]|0);a7=al;a8=ac;C=133}else if((C|0)==158){Ae(o);i=d;return B|0}else if((C|0)==73){ac=bQ(-1,-1)|0;a9=K;ba=ac;C=75;break L1}}while(0);if((C|0)==87){a$=a2;a0=a1;C=90}else if((C|0)==98){a3=a6;a4=a5;C=101}else if((C|0)==130){a7=a_;a8=aZ;C=133}if((C|0)==133){Q=c[aO>>2]|0;P=c[aP>>2]|0;W=Q;while(1){if((W|0)==(P|0)){bb=P;break}if((c[W>>2]|0)==(aQ|0)){bb=W;break}else{W=W+4|0}}W=bb-Q>>2;O=Q+(W+1<<2)|0;_=P-O|0;Kc(Q+(W<<2)|0,O|0,_|0)|0;O=Q+((_>>2)+W<<2)|0;W=c[aP>>2]|0;if((O|0)!=(W|0)){c[aP>>2]=W+(~((W-4+(-O|0)|0)>>>2)<<2)}J2(aS);bc=a7;bd=a8;break L1}else if((C|0)==90){O=c[ao>>2]|0;W=c[au>>2]|0;_=O;while(1){if((_|0)==(W|0)){bf=W;break}if((c[_>>2]|0)==(av|0)){bf=_;break}else{_=_+4|0}}_=bf-O>>2;Q=O+(_+1<<2)|0;P=W-Q|0;Kc(O+(_<<2)|0,Q|0,P|0)|0;Q=O+((P>>2)+_<<2)|0;_=c[au>>2]|0;if((Q|0)!=(_|0)){c[au>>2]=_+(~((_-4+(-Q|0)|0)>>>2)<<2)}J2(ax);bc=a$;bd=a0;break L1}else if((C|0)==101){Q=c[aC>>2]|0;_=c[aD>>2]|0;P=Q;while(1){if((P|0)==(_|0)){bg=_;break}if((c[P>>2]|0)==(aE|0)){bg=P;break}else{P=P+4|0}}P=bg-Q>>2;O=Q+(P+1<<2)|0;W=_-O|0;Kc(Q+(P<<2)|0,O|0,W|0)|0;O=Q+((W>>2)+P<<2)|0;P=c[aD>>2]|0;if((O|0)!=(P|0)){c[aD>>2]=P+(~((P-4+(-O|0)|0)>>>2)<<2)}J2(aG);bc=a3;bd=a4;break L1}}}while(0);B=c[w>>2]|0;F=c[A>>2]|0;O=B;while(1){if((O|0)==(F|0)){bh=F;break}if((c[O>>2]|0)==(D|0)){bh=O;break}else{O=O+4|0}}O=bh-B>>2;P=B+(O+1<<2)|0;W=F-P|0;Kc(B+(O<<2)|0,P|0,W|0)|0;P=B+((W>>2)+O<<2)|0;O=c[A>>2]|0;if((P|0)!=(O|0)){c[A>>2]=O+(~((O-4+(-P|0)|0)>>>2)<<2)}J2(z);bc=M;bd=N}else{x=0;C=74}}while(0);if((C|0)==74){N=bQ(-1,-1)|0;a9=K;ba=N;C=75}if((C|0)==75){bc=ba;bd=a9}x=0;ap(436,o|0);if(!x){be(bc|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function sF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=i;i=i+40|0;e=d|0;f=d+16|0;g=d+24|0;h=b+20|0;j=xP(c[h>>2]|0)|0;do{if((j+1|0)==0|(a[j]|0)!=43){k=xP(c[h>>2]|0)|0;if(!((k+1|0)==0|(a[k]|0)!=126)){l=0;m=0;n=0;o=0;break}k=xP(c[h>>2]|0)|0;if(!((k+1|0)==0|(a[k]|0)!=62)){l=0;m=0;n=0;o=0;break}k=sH(b)|0;l=k;m=c[b+44>>2]|0;n=c[b+48>>2]|0;o=c[b+52>>2]|0}else{l=0;m=0;n=0;o=0}}while(0);j=xP(c[h>>2]|0)|0;k=(a[j]|0)==43?j+1|0:0;do{if((k|0)==0){p=xP(c[h>>2]|0)|0;q=(a[p]|0)==126?p+1|0:0;if((q|0)!=0){r=b+48|0;s=c[r>>2]|0;t=c[h>>2]|0;L10:do{if(t>>>0<q>>>0){u=t;v=0;while(1){w=a[u]|0;if((w<<24>>24|0)==10){y=v+1|0}else if((w<<24>>24|0)==0){z=v;break L10}else{y=v}w=u+1|0;if(w>>>0<q>>>0){u=w;v=y}else{z=y;break}}}else{z=0}}while(0);c[r>>2]=z+s;v=p;u=0;while(1){w=v-1|0;if(w>>>0<t>>>0){break}if((a[w]|0)==10){break}else{v=w;u=u+1|0}}v=b+40|0;if((z|0)!=0){c[v>>2]=1}t=c[v>>2]|0;c[b+52>>2]=t+u;s=q;r=p;c[v>>2]=s-r+u+t;t=b+56|0;c[t>>2]=r;c[t+4>>2]=s;c[h>>2]=q;A=2;B=q;break}s=xP(c[h>>2]|0)|0;t=(a[s]|0)==62?s+1|0:0;if((t|0)==0){A=0;B=c[h>>2]|0;break}r=b+48|0;v=c[r>>2]|0;w=c[h>>2]|0;L28:do{if(w>>>0<t>>>0){C=w;D=0;while(1){E=a[C]|0;if((E<<24>>24|0)==0){F=D;break L28}else if((E<<24>>24|0)==10){G=D+1|0}else{G=D}E=C+1|0;if(E>>>0<t>>>0){C=E;D=G}else{F=G;break}}}else{F=0}}while(0);c[r>>2]=F+v;q=s;u=0;while(1){p=q-1|0;if(p>>>0<w>>>0){break}if((a[p]|0)==10){break}else{q=p;u=u+1|0}}q=b+40|0;if((F|0)!=0){c[q>>2]=1}w=c[q>>2]|0;c[b+52>>2]=w+u;v=t;r=s;c[q>>2]=v-r+u+w;w=b+56|0;c[w>>2]=r;c[w+4>>2]=v;c[h>>2]=t;A=1;B=t}else{v=b+48|0;w=c[v>>2]|0;r=c[h>>2]|0;L43:do{if(r>>>0<k>>>0){q=r;p=0;while(1){D=a[q]|0;if((D<<24>>24|0)==0){H=p;break L43}else if((D<<24>>24|0)==10){I=p+1|0}else{I=p}D=q+1|0;if(D>>>0<k>>>0){q=D;p=I}else{H=I;break}}}else{H=0}}while(0);c[v>>2]=H+w;t=j;u=0;while(1){s=t-1|0;if(s>>>0<r>>>0){break}if((a[s]|0)==10){break}else{t=s;u=u+1|0}}t=b+40|0;if((H|0)!=0){c[t>>2]=1}r=c[t>>2]|0;c[b+52>>2]=r+u;w=k;v=j;c[t>>2]=w-v+u+r;r=b+56|0;c[r>>2]=v;c[r+4>>2]=w;c[h>>2]=k;A=3;B=k}}while(0);k=xP(B)|0;do{if((k+1|0)==0|(a[k]|0)!=44){B=xP(c[h>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=41)){J=0;L=m;M=n;N=o;break}B=xP(c[h>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=123)){J=0;L=m;M=n;N=o;break}B=xP(c[h>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=125)){J=0;L=m;M=n;N=o;break}B=xP(c[h>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=59)){J=0;L=m;M=n;N=o;break}B=sF(b)|0;J=B;L=c[b+44>>2]|0;M=c[b+48>>2]|0;N=c[b+52>>2]|0}else{J=0;L=m;M=n;N=o}}while(0);if((M|0)==0){O=c[b+44>>2]|0;P=c[b+48>>2]|0;Q=c[b+52>>2]|0}else{O=L;P=M;Q=N}N=c[b>>2]|0;M=J0(44)|0;c[f>>2]=M;L=N+4|0;o=c[L>>2]|0;if((o|0)==(c[N+8>>2]|0)){ee(N|0,f);R=c[f>>2]|0}else{if((o|0)==0){S=0}else{c[o>>2]=M;S=c[L>>2]|0}c[L>>2]=S+4;R=M}M=R;S=R;o=b+28|0;L75:do{if((a[o]&1)==0){f=g;c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];T=62}else{f=c[b+36>>2]|0;n=c[b+32>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(n>>>0<11>>>0){a[g]=n<<1;U=g+1|0}else{m=n+16&-16;h=(x=0,as(230,m|0)|0);if(x){x=0;break}c[g+8>>2]=h;c[g>>2]=m|1;c[g+4>>2]=n;U=h}Kb(U|0,f|0,n)|0;a[U+n|0]=0;T=62;break L75}}while(0);n=bQ(-1,-1)|0;V=K;W=n}}while(0);do{if((T|0)==62){c[e>>2]=O;c[e+4>>2]=P;c[e+8>>2]=Q;x=0;aB(18,S|0,g|0,e|0,A|0,l|0,J|0);if(x){x=0;U=bQ(-1,-1)|0;b=U;U=K;if((a[g]&1)==0){V=U;W=b;break}J2(c[g+8>>2]|0);V=U;W=b;break}if((a[g]&1)==0){i=d;return S|0}J2(c[g+8>>2]|0);i=d;return S|0}}while(0);S=c[N>>2]|0;N=c[L>>2]|0;d=S;while(1){if((d|0)==(N|0)){X=N;break}if((c[d>>2]|0)==(R|0)){X=d;break}else{d=d+4|0}}d=X-S>>2;X=S+(d+1<<2)|0;R=N-X|0;Kc(S+(d<<2)|0,X|0,R|0)|0;X=S+((R>>2)+d<<2)|0;d=c[L>>2]|0;if((X|0)==(d|0)){J2(M);Y=W;Z=0;_=Y;$=V;be(_|0)}c[L>>2]=d+(~((d-4+(-X|0)|0)>>>2)<<2);J2(M);Y=W;Z=0;_=Y;$=V;be(_|0);return 0}function sG(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=g+32|0;Kb(k|0,e|0,12)|0;e=h;l=j;m=b|0;n=d;if((a[n]&1)==0){c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[e]=o<<1;p=h+1|0}else{d=o+16&-16;q=J0(d)|0;c[h+8>>2]=q;c[h>>2]=d|1;c[h+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];x=0;aP(282,m|0,h|0,j|0);if(!x){if((a[e]&1)==0){r=b|0;c[r>>2]=19408;s=b+32|0;c[s>>2]=f;t=b+28|0;a[t]=1;i=g;return}J2(c[h+8>>2]|0);r=b|0;c[r>>2]=19408;s=b+32|0;c[s>>2]=f;t=b+28|0;a[t]=1;i=g;return}else{x=0;g=bQ(-1,-1)|0;if((a[e]&1)==0){be(g|0)}J2(c[h+8>>2]|0);be(g|0)}}function sH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0;d=i;i=i+184|0;e=d|0;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+64|0;n=d+80|0;o=d+88|0;p=d+104|0;q=d+120|0;r=d+136|0;s=d+152|0;t=d+168|0;u=b|0;v=c[u>>2]|0;w=J0(48)|0;c[n>>2]=w;y=v+4|0;z=c[y>>2]|0;if((z|0)==(c[v+8>>2]|0)){ee(v|0,n);A=c[n>>2]|0}else{if((z|0)==0){B=0}else{c[z>>2]=w;B=c[y>>2]|0}c[y>>2]=B+4;A=w}w=A;B=A;z=b+28|0;L8:do{if((a[z]&1)==0){n=o;c[n>>2]=c[z>>2];c[n+4>>2]=c[z+4>>2];c[n+8>>2]=c[z+8>>2];C=16}else{n=c[b+36>>2]|0;D=c[b+32>>2]|0;do{if(D>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(D>>>0<11>>>0){a[o]=D<<1;E=o+1|0}else{F=D+16&-16;G=(x=0,as(230,F|0)|0);if(x){x=0;break}c[o+8>>2]=G;c[o>>2]=F|1;c[o+4>>2]=D;E=G}Kb(E|0,n|0,D)|0;a[E+D|0]=0;C=16;break L8}}while(0);D=bQ(-1,-1)|0;H=K;I=D}}while(0);do{if((C|0)==16){E=b+44|0;D=m;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];x=0;aT(38,B|0,o|0,m|0,0);if(x){x=0;D=bQ(-1,-1)|0;n=D;D=K;if((a[o]&1)==0){H=D;I=n;break}J2(c[o+8>>2]|0);H=D;I=n;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}n=b+20|0;D=xP(c[n>>2]|0)|0;G=(a[D]|0)==38?D+1|0:0;L30:do{if((G|0)==0){F=A+32|0;J=F;if((sI(b)|0)==0){L=sJ(b)|0;c[f>>2]=L;M=A+40|0;N=c[M>>2]|0;O=N;if((O|0)==(c[F+12>>2]|0)){g_(A+36|0,f);P=c[f>>2]|0}else{if((N|0)==0){Q=0}else{c[O>>2]=L;Q=c[M>>2]|0}c[M>>2]=Q+4;P=L}cy[c[c[F>>2]>>2]&1023](J,P);break}L=c[u>>2]|0;M=J0(44)|0;c[j>>2]=M;O=L+4|0;N=c[O>>2]|0;if((N|0)==(c[L+8>>2]|0)){ee(L|0,j);R=c[j>>2]|0}else{if((N|0)==0){S=0}else{c[N>>2]=M;S=c[O>>2]|0}c[O>>2]=S+4;R=M}M=R;N=R;L113:do{if((a[z]&1)==0){T=r;c[T>>2]=c[z>>2];c[T+4>>2]=c[z+4>>2];c[T+8>>2]=c[z+8>>2];C=89}else{T=c[b+36>>2]|0;U=c[b+32>>2]|0;do{if(U>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(U>>>0<11>>>0){a[r]=U<<1;V=r+1|0}else{W=U+16&-16;X=(x=0,as(230,W|0)|0);if(x){x=0;break}c[r+8>>2]=X;c[r>>2]=W|1;c[r+4>>2]=U;V=X}Kb(V|0,T|0,U)|0;a[V+U|0]=0;C=89;break L113}}while(0);U=bQ(-1,-1)|0;Y=U;Z=K}}while(0);do{if((C|0)==89){U=s;c[U>>2]=c[E>>2];c[U+4>>2]=c[E+4>>2];c[U+8>>2]=c[E+8>>2];T=c[b+56>>2]|0;X=(c[b+60>>2]|0)-T|0;do{if(X>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;C=109;break}return 0}else{if(X>>>0<11>>>0){a[t]=X<<1;_=t+1|0}else{W=X+16&-16;$=(x=0,as(230,W|0)|0);if(x){x=0;C=109;break}c[t+8>>2]=$;c[t>>2]=W|1;c[t+4>>2]=X;_=$}Kb(_|0,T|0,X)|0;a[_+X|0]=0;$=h;c[$>>2]=c[U>>2];c[$+4>>2]=c[U+4>>2];c[$+8>>2]=c[U+8>>2];x=0;aT(10,N|0,r|0,h|0,t|0);do{if(!x){$=R;c[g>>2]=$;W=A+40|0;aa=c[W>>2]|0;ab=aa;if((ab|0)==(c[F+12>>2]|0)){x=0;aq(722,A+36|0,g|0);if(x){x=0;ac=0;break}ad=c[g>>2]|0}else{if((aa|0)==0){ae=0}else{c[ab>>2]=$;ae=c[W>>2]|0}c[W>>2]=ae+4;ad=$}x=0;aq(c[c[F>>2]>>2]|0,J|0,ad|0);if(x){x=0;ac=0;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}if((a[r]&1)==0){break L30}J2(c[r+8>>2]|0);break L30}else{x=0;ac=1}}while(0);$=bQ(-1,-1)|0;W=$;$=K;if((a[t]&1)==0){af=ac;ag=$;ah=W;break}J2(c[t+8>>2]|0);af=ac;ag=$;ah=W}}while(0);if((C|0)==109){U=bQ(-1,-1)|0;af=1;ag=K;ah=U}if((a[r]&1)==0){if(af){Y=ah;Z=ag;break}else{ai=ag;aj=ah}ak=aj;al=0;am=ak;an=ai;be(am|0)}else{J2(c[r+8>>2]|0);if(af){Y=ah;Z=ag;break}else{ai=ag;aj=ah}ak=aj;al=0;am=ak;an=ai;be(am|0)}}}while(0);J=c[L>>2]|0;F=c[O>>2]|0;N=J;while(1){if((N|0)==(F|0)){ao=F;break}if((c[N>>2]|0)==(R|0)){ao=N;break}else{N=N+4|0}}N=ao-J>>2;L=J+(N+1<<2)|0;U=F-L|0;Kc(J+(N<<2)|0,L|0,U|0)|0;L=J+((U>>2)+N<<2)|0;N=c[O>>2]|0;if((L|0)!=(N|0)){c[O>>2]=N+(~((N-4+(-L|0)|0)>>>2)<<2)}J2(M);ai=Z;aj=Y;ak=aj;al=0;am=ak;an=ai;be(am|0)}else{L=b+48|0;N=c[L>>2]|0;U=c[n>>2]|0;L32:do{if(U>>>0<G>>>0){X=U;T=0;while(1){W=a[X]|0;if((W<<24>>24|0)==0){ar=T;break L32}else if((W<<24>>24|0)==10){at=T+1|0}else{at=T}W=X+1|0;if(W>>>0<G>>>0){X=W;T=at}else{ar=at;break}}}else{ar=0}}while(0);c[L>>2]=ar+N;M=D;O=0;while(1){J=M-1|0;if(J>>>0<U>>>0){break}if((a[J]|0)==10){break}else{M=J;O=O+1|0}}M=b+40|0;if((ar|0)!=0){c[M>>2]=1}U=c[M>>2]|0;c[b+52>>2]=U+O;N=G;L=D;c[M>>2]=N-L+O+U;U=b+56|0;c[U>>2]=L;c[U+4>>2]=N;c[n>>2]=G;N=A+32|0;U=N;L=c[u>>2]|0;M=J0(36)|0;c[l>>2]=M;J=L+4|0;F=c[J>>2]|0;if((F|0)==(c[L+8>>2]|0)){ee(L|0,l);au=c[l>>2]|0}else{if((F|0)==0){av=0}else{c[F>>2]=M;av=c[J>>2]|0}c[J>>2]=av+4;au=M}M=au;L53:do{if((a[z]&1)==0){F=p;c[F>>2]=c[z>>2];c[F+4>>2]=c[z+4>>2];c[F+8>>2]=c[z+8>>2];C=44}else{F=c[b+36>>2]|0;T=c[b+32>>2]|0;do{if(T>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(T>>>0<11>>>0){a[p]=T<<1;aw=p+1|0}else{X=T+16&-16;W=(x=0,as(230,X|0)|0);if(x){x=0;break}c[p+8>>2]=W;c[p>>2]=X|1;c[p+4>>2]=T;aw=W}Kb(aw|0,F|0,T)|0;a[aw+T|0]=0;C=44;break L53}}while(0);T=bQ(-1,-1)|0;ax=T;ay=K}}while(0);do{if((C|0)==44){O=q;c[O>>2]=c[E>>2];c[O+4>>2]=c[E+4>>2];c[O+8>>2]=c[E+8>>2];x=0;aT(50,au|0,p|0,q|0,0);do{if(!x){O=au;c[k>>2]=O;T=A+40|0;F=c[T>>2]|0;W=F;if((W|0)==(c[N+12>>2]|0)){x=0;aq(722,A+36|0,k|0);if(x){x=0;az=0;break}aA=c[k>>2]|0}else{if((F|0)==0){aB=0}else{c[W>>2]=O;aB=c[T>>2]|0}c[T>>2]=aB+4;aA=O}x=0;aq(c[c[N>>2]>>2]|0,U|0,aA|0);if(x){x=0;az=0;break}if((a[p]&1)==0){break L30}J2(c[p+8>>2]|0);break L30}else{x=0;az=1}}while(0);O=bQ(-1,-1)|0;T=O;O=K;if((a[p]&1)==0){if(az){ax=T;ay=O;break}else{ai=O;aj=T}ak=aj;al=0;am=ak;an=ai;be(am|0)}else{J2(c[p+8>>2]|0);if(az){ax=T;ay=O;break}else{ai=O;aj=T}ak=aj;al=0;am=ak;an=ai;be(am|0)}}}while(0);U=c[L>>2]|0;N=c[J>>2]|0;T=U;while(1){if((T|0)==(N|0)){aC=N;break}if((c[T>>2]|0)==(au|0)){aC=T;break}else{T=T+4|0}}T=aC-U>>2;L=U+(T+1<<2)|0;O=N-L|0;Kc(U+(T<<2)|0,L|0,O|0)|0;L=U+((O>>2)+T<<2)|0;T=c[J>>2]|0;if((L|0)!=(T|0)){c[J>>2]=T+(~((T-4+(-L|0)|0)>>>2)<<2)}J2(M);ai=ay;aj=ax;ak=aj;al=0;am=ak;an=ai;be(am|0)}}while(0);if((xH(c[n>>2]|0)|0)!=0){i=d;return B|0}E=A+32|0;G=E;D=A+40|0;L=E+12|0;T=A+36|0;O=E;while(1){E=xP(c[n>>2]|0)|0;if(!((E+1|0)==0|(a[E]|0)!=43)){C=152;break}E=xP(c[n>>2]|0)|0;if(!((E+1|0)==0|(a[E]|0)!=126)){C=147;break}E=xP(c[n>>2]|0)|0;if(!((E+1|0)==0|(a[E]|0)!=62)){C=148;break}E=xP(c[n>>2]|0)|0;if(!((E+1|0)==0|(a[E]|0)!=44)){C=145;break}E=xP(c[n>>2]|0)|0;if(!((E+1|0)==0|(a[E]|0)!=41)){C=146;break}E=xP(c[n>>2]|0)|0;if(!((E+1|0)==0|(a[E]|0)!=123)){C=153;break}E=xP(c[n>>2]|0)|0;if(!((E+1|0)==0|(a[E]|0)!=125)){C=154;break}E=xP(c[n>>2]|0)|0;if(!((E+1|0)==0|(a[E]|0)!=59)){C=150;break}E=sJ(b)|0;c[e>>2]=E;W=c[D>>2]|0;F=W;if((F|0)==(c[L>>2]|0)){g_(T,e);aD=c[e>>2]|0}else{if((W|0)==0){aE=0}else{c[F>>2]=E;aE=c[D>>2]|0}c[D>>2]=aE+4;aD=E}cy[c[c[O>>2]>>2]&1023](G,aD);if((xH(c[n>>2]|0)|0)!=0){C=149;break}}if((C|0)==145){i=d;return B|0}else if((C|0)==146){i=d;return B|0}else if((C|0)==147){i=d;return B|0}else if((C|0)==148){i=d;return B|0}else if((C|0)==149){i=d;return B|0}else if((C|0)==150){i=d;return B|0}else if((C|0)==152){i=d;return B|0}else if((C|0)==153){i=d;return B|0}else if((C|0)==154){i=d;return B|0}}}while(0);B=c[v>>2]|0;v=c[y>>2]|0;d=B;while(1){if((d|0)==(v|0)){aF=v;break}if((c[d>>2]|0)==(A|0)){aF=d;break}else{d=d+4|0}}d=aF-B>>2;aF=B+(d+1<<2)|0;A=v-aF|0;Kc(B+(d<<2)|0,aF|0,A|0)|0;aF=B+((A>>2)+d<<2)|0;d=c[y>>2]|0;if((aF|0)!=(d|0)){c[y>>2]=d+(~((d-4+(-aF|0)|0)>>>2)<<2)}J2(w);ai=H;aj=I;ak=aj;al=0;am=ak;an=ai;be(am|0);return 0}function sI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=(yx(e)|0)!=0;g=f?0:e;if((g|0)==0){h=0;return h|0}f=yc(g)|0;do{if((f|0)==0){i=yd(g)|0;if((i|0)!=0){j=i;break}i=xM(g)|0;if((i|0)!=0){j=i;break}i=yn(g)|0;if((i|0)!=0){j=i;break}i=ym(g)|0;if((i|0)!=0){j=i;break}i=yi(g)|0;if((i|0)==0){h=0}else{j=i;break}return h|0}else{j=f}}while(0);f=b+48|0;g=c[f>>2]|0;i=c[d>>2]|0;L12:do{if(i>>>0<j>>>0){k=i;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L12}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<j>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[f>>2]=g+n;g=e;f=0;while(1){o=g-1|0;if(o>>>0<i>>>0){break}if((a[o]|0)==10){break}else{g=o;f=f+1|0}}g=b+40|0;if((n|0)!=0){c[g>>2]=1}n=c[g>>2]|0;c[b+52>>2]=n+f;i=j;o=e;c[g>>2]=i-o+f+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=i;c[d>>2]=j;h=j;return h|0}function sJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,aq=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0;d=i;i=i+264|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+72|0;m=d+88|0;n=d+104|0;o=d+120|0;p=d+136|0;q=d+152|0;r=d+168|0;s=d+184|0;t=d+200|0;u=d+216|0;v=d+232|0;w=d+248|0;do{if((sK(b)|0)==0){if((sL(b)|0)!=0){break}do{if((sg(b)|0)==0){if((sM(b)|0)!=0){break}y=b+20|0;if((yy(xP(c[y>>2]|0)|0)|0)!=0){z=sN(b)|0;i=d;return z|0}A=xP(c[y>>2]|0)|0;do{if((A+1|0)==0|(a[A]|0)!=58){if((yx(xP(c[y>>2]|0)|0)|0)!=0){break}B=xP(c[y>>2]|0)|0;if(!((B+1|0)==0|(a[B]|0)!=91)){z=sP(b)|0;i=d;return z|0}if((sQ(b)|0)==0){B=c[b+56>>2]|0;C=(c[b+60>>2]|0)-B|0;if(C>>>0>4294967279>>>0){CJ(0);return 0}if(C>>>0<11>>>0){D=C<<1&255;E=v;F=v;a[F]=D;G=E+1|0;H=D;I=E;J=F}else{F=C+16&-16;E=J0(F)|0;c[v+8>>2]=E;D=F|1;c[v>>2]=D;c[v+4>>2]=C;G=E;H=D&255;I=v;J=v}Kb(G|0,B|0,C)|0;a[G+C|0]=0;C=u;Ke(C|0,0,12)|0;B=H&255;if((B&1|0)==0){L=B>>>1}else{L=c[v+4>>2]|0}B=L+23|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;M=149;break}return 0}else{if(B>>>0<11>>>0){a[C]=46;N=u+1|0}else{D=L+39&-16;E=(x=0,as(230,D|0)|0);if(x){x=0;M=149;break}c[u+8>>2]=E;c[u>>2]=D|1;c[u+4>>2]=23;N=E}Kb(N|0,8784,23)|0;a[N+23|0]=0;if((H&1)==0){O=I+1|0}else{O=c[v+8>>2]|0}x=0,ax(64,u|0,O|0,L|0)|0;if(x){x=0;M=149;break}c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;x=0;aP(466,b|0,u|0,w|0);if(x){x=0;E=bQ(-1,-1)|0;D=E;E=K;if((a[C]&1)==0){P=E;Q=D;break}J2(c[u+8>>2]|0);P=E;Q=D;break}if((a[C]&1)!=0){J2(c[u+8>>2]|0)}if((a[J]&1)==0){z=0;i=d;return z|0}J2(c[v+8>>2]|0);z=0;i=d;return z|0}}while(0);if((M|0)==149){B=bQ(-1,-1)|0;D=K;if((a[C]&1)!=0){J2(c[u+8>>2]|0)}P=D;Q=B}if((a[J]&1)==0){R=P;S=Q;T=S;U=0;V=T;W=R;be(V|0)}J2(c[v+8>>2]|0);R=P;S=Q;T=S;U=0;V=T;W=R;be(V|0)}B=c[b>>2]|0;D=J0(44)|0;c[f>>2]=D;E=B+4|0;F=c[E>>2]|0;if((F|0)==(c[B+8>>2]|0)){ee(B|0,f);X=c[f>>2]|0}else{if((F|0)==0){Y=0}else{c[F>>2]=D;Y=c[E>>2]|0}c[E>>2]=Y+4;X=D}D=X;F=X;Z=b+28|0;L74:do{if((a[Z]&1)==0){_=r;c[_>>2]=c[Z>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];M=106}else{_=c[b+36>>2]|0;$=c[b+32>>2]|0;do{if($>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if($>>>0<11>>>0){a[r]=$<<1;aa=r+1|0}else{ab=$+16&-16;ac=(x=0,as(230,ab|0)|0);if(x){x=0;break}c[r+8>>2]=ac;c[r>>2]=ab|1;c[r+4>>2]=$;aa=ac}Kb(aa|0,_|0,$)|0;a[aa+$|0]=0;M=106;break L74}}while(0);$=bQ(-1,-1)|0;ad=K;ae=$}}while(0);do{if((M|0)==106){Z=s;C=b+44|0;c[Z>>2]=c[C>>2];c[Z+4>>2]=c[C+4>>2];c[Z+8>>2]=c[C+8>>2];C=c[b+56>>2]|0;$=(c[b+60>>2]|0)-C|0;do{if($>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;M=119;break}return 0}else{if($>>>0<11>>>0){a[t]=$<<1;af=t+1|0}else{_=$+16&-16;ac=(x=0,as(230,_|0)|0);if(x){x=0;M=119;break}c[t+8>>2]=ac;c[t>>2]=_|1;c[t+4>>2]=$;af=ac}Kb(af|0,C|0,$)|0;a[af+$|0]=0;ac=e;c[ac>>2]=c[Z>>2];c[ac+4>>2]=c[Z+4>>2];c[ac+8>>2]=c[Z+8>>2];x=0;aT(46,F|0,r|0,e|0,t|0);if(x){x=0;ac=bQ(-1,-1)|0;_=ac;ac=K;if((a[t]&1)==0){ag=ac;ah=_;break}J2(c[t+8>>2]|0);ag=ac;ah=_;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}_=X;if((a[r]&1)==0){z=_;i=d;return z|0}J2(c[r+8>>2]|0);z=_;i=d;return z|0}}while(0);if((M|0)==119){Z=bQ(-1,-1)|0;ag=K;ah=Z}if((a[r]&1)==0){ad=ag;ae=ah;break}J2(c[r+8>>2]|0);ad=ag;ae=ah}}while(0);F=c[B>>2]|0;Z=c[E>>2]|0;$=F;while(1){if(($|0)==(Z|0)){ai=Z;break}if((c[$>>2]|0)==(X|0)){ai=$;break}else{$=$+4|0}}$=ai-F>>2;B=F+($+1<<2)|0;C=Z-B|0;Kc(F+($<<2)|0,B|0,C|0)|0;B=F+((C>>2)+$<<2)|0;$=c[E>>2]|0;if((B|0)!=($|0)){c[E>>2]=$+(~(($-4+(-B|0)|0)>>>2)<<2)}J2(D);R=ad;S=ae;T=S;U=0;V=T;W=R;be(V|0)}}while(0);z=sO(b)|0;i=d;return z|0}}while(0);y=c[b>>2]|0;A=J0(44)|0;c[h>>2]=A;B=y+4|0;$=c[B>>2]|0;if(($|0)==(c[y+8>>2]|0)){ee(y|0,h);aj=c[h>>2]|0}else{if(($|0)==0){ak=0}else{c[$>>2]=A;ak=c[B>>2]|0}c[B>>2]=ak+4;aj=A}A=aj;$=aj;C=b+28|0;L132:do{if((a[C]&1)==0){_=o;c[_>>2]=c[C>>2];c[_+4>>2]=c[C+4>>2];c[_+8>>2]=c[C+8>>2];M=59}else{_=c[b+36>>2]|0;ac=c[b+32>>2]|0;do{if(ac>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ac>>>0<11>>>0){a[o]=ac<<1;al=o+1|0}else{ab=ac+16&-16;am=(x=0,as(230,ab|0)|0);if(x){x=0;break}c[o+8>>2]=am;c[o>>2]=ab|1;c[o+4>>2]=ac;al=am}Kb(al|0,_|0,ac)|0;a[al+ac|0]=0;M=59;break L132}}while(0);ac=bQ(-1,-1)|0;an=K;ao=ac}}while(0);do{if((M|0)==59){C=p;ac=b+44|0;c[C>>2]=c[ac>>2];c[C+4>>2]=c[ac+4>>2];c[C+8>>2]=c[ac+8>>2];ac=c[b+56>>2]|0;_=(c[b+60>>2]|0)-ac|0;do{if(_>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;M=72;break}return 0}else{if(_>>>0<11>>>0){a[q]=_<<1;aq=q+1|0}else{am=_+16&-16;ab=(x=0,as(230,am|0)|0);if(x){x=0;M=72;break}c[q+8>>2]=ab;c[q>>2]=am|1;c[q+4>>2]=_;aq=ab}Kb(aq|0,ac|0,_)|0;a[aq+_|0]=0;ab=g;c[ab>>2]=c[C>>2];c[ab+4>>2]=c[C+4>>2];c[ab+8>>2]=c[C+8>>2];x=0;aT(10,$|0,o|0,g|0,q|0);if(x){x=0;ab=bQ(-1,-1)|0;am=ab;ab=K;if((a[q]&1)==0){ar=ab;at=am;break}J2(c[q+8>>2]|0);ar=ab;at=am;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}am=aj;if((a[o]&1)==0){z=am;i=d;return z|0}J2(c[o+8>>2]|0);z=am;i=d;return z|0}}while(0);if((M|0)==72){C=bQ(-1,-1)|0;ar=K;at=C}if((a[o]&1)==0){an=ar;ao=at;break}J2(c[o+8>>2]|0);an=ar;ao=at}}while(0);$=c[y>>2]|0;C=c[B>>2]|0;_=$;while(1){if((_|0)==(C|0)){au=C;break}if((c[_>>2]|0)==(aj|0)){au=_;break}else{_=_+4|0}}_=au-$>>2;y=$+(_+1<<2)|0;ac=C-y|0;Kc($+(_<<2)|0,y|0,ac|0)|0;y=$+((ac>>2)+_<<2)|0;_=c[B>>2]|0;if((y|0)!=(_|0)){c[B>>2]=_+(~((_-4+(-y|0)|0)>>>2)<<2)}J2(A);R=an;S=ao;T=S;U=0;V=T;W=R;be(V|0)}}while(0);ao=c[b>>2]|0;an=J0(44)|0;c[k>>2]=an;au=ao+4|0;aj=c[au>>2]|0;if((aj|0)==(c[ao+8>>2]|0)){ee(ao|0,k);av=c[k>>2]|0}else{if((aj|0)==0){aw=0}else{c[aj>>2]=an;aw=c[au>>2]|0}c[au>>2]=aw+4;av=an}an=av;aw=av;aj=b+28|0;L188:do{if((a[aj]&1)==0){k=l;c[k>>2]=c[aj>>2];c[k+4>>2]=c[aj+4>>2];c[k+8>>2]=c[aj+8>>2];M=18}else{k=c[b+36>>2]|0;at=c[b+32>>2]|0;do{if(at>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(at>>>0<11>>>0){a[l]=at<<1;ay=l+1|0}else{ar=at+16&-16;o=(x=0,as(230,ar|0)|0);if(x){x=0;break}c[l+8>>2]=o;c[l>>2]=ar|1;c[l+4>>2]=at;ay=o}Kb(ay|0,k|0,at)|0;a[ay+at|0]=0;M=18;break L188}}while(0);at=bQ(-1,-1)|0;az=K;aA=at}}while(0);do{if((M|0)==18){ay=m;aj=b+44|0;c[ay>>2]=c[aj>>2];c[ay+4>>2]=c[aj+4>>2];c[ay+8>>2]=c[aj+8>>2];aj=c[b+56>>2]|0;at=(c[b+60>>2]|0)-aj|0;do{if(at>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;M=31;break}return 0}else{if(at>>>0<11>>>0){a[n]=at<<1;aB=n+1|0}else{k=at+16&-16;A=(x=0,as(230,k|0)|0);if(x){x=0;M=31;break}c[n+8>>2]=A;c[n>>2]=k|1;c[n+4>>2]=at;aB=A}Kb(aB|0,aj|0,at)|0;a[aB+at|0]=0;A=j;c[A>>2]=c[ay>>2];c[A+4>>2]=c[ay+4>>2];c[A+8>>2]=c[ay+8>>2];x=0;aT(30,aw|0,l|0,j|0,n|0);if(x){x=0;A=bQ(-1,-1)|0;k=A;A=K;if((a[n]&1)==0){aC=A;aD=k;break}J2(c[n+8>>2]|0);aC=A;aD=k;break}if((a[n]&1)!=0){J2(c[n+8>>2]|0)}k=av;if((a[l]&1)==0){z=k;i=d;return z|0}J2(c[l+8>>2]|0);z=k;i=d;return z|0}}while(0);if((M|0)==31){ay=bQ(-1,-1)|0;aC=K;aD=ay}if((a[l]&1)==0){az=aC;aA=aD;break}J2(c[l+8>>2]|0);az=aC;aA=aD}}while(0);aD=c[ao>>2]|0;ao=c[au>>2]|0;aC=aD;while(1){if((aC|0)==(ao|0)){aE=ao;break}if((c[aC>>2]|0)==(av|0)){aE=aC;break}else{aC=aC+4|0}}aC=aE-aD>>2;aE=aD+(aC+1<<2)|0;av=ao-aE|0;Kc(aD+(aC<<2)|0,aE|0,av|0)|0;aE=aD+((av>>2)+aC<<2)|0;aC=c[au>>2]|0;if((aE|0)!=(aC|0)){c[au>>2]=aC+(~((aC-4+(-aE|0)|0)>>>2)<<2)}J2(an);R=az;S=aA;T=S;U=0;V=T;W=R;be(V|0);return 0}function sK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=ye(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yf(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yi(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+120|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+72|0;k=d+88|0;l=d+104|0;sR(b)|0;m=d+56|0;n=b+44|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];n=sE(b)|0;o=b+20|0;p=xP(c[o>>2]|0)|0;q=(a[p]|0)==41?p+1|0:0;do{if((q|0)==0){r=J0(32)|0;s=j+8|0;c[s>>2]=r;c[j>>2]=33;c[j+4>>2]=31;Kb(r|0,8656,31)|0;a[r+31|0]=0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;x=0;aP(466,b|0,j|0,k|0);if(!x){if((a[j]&1)==0){break}J2(c[s>>2]|0);break}else{x=0}r=bQ(-1,-1)|0;t=r;r=K;if((a[j]&1)==0){u=r;v=t;w=v;y=0;z=w;A=u;be(z|0)}J2(c[s>>2]|0);u=r;v=t;w=v;y=0;z=w;A=u;be(z|0)}else{t=b+48|0;r=c[t>>2]|0;s=c[o>>2]|0;L12:do{if(s>>>0<q>>>0){B=s;C=0;while(1){D=a[B]|0;if((D<<24>>24|0)==0){E=C;break L12}else if((D<<24>>24|0)==10){F=C+1|0}else{F=C}D=B+1|0;if(D>>>0<q>>>0){B=D;C=F}else{E=F;break}}}else{E=0}}while(0);c[t>>2]=E+r;C=p;B=0;while(1){D=C-1|0;if(D>>>0<s>>>0){break}if((a[D]|0)==10){break}else{C=D;B=B+1|0}}C=b+40|0;if((E|0)!=0){c[C>>2]=1}s=c[C>>2]|0;c[b+52>>2]=s+B;r=q;t=p;c[C>>2]=r-t+B+s;s=b+56|0;c[s>>2]=t;c[s+4>>2]=r;c[o>>2]=q}}while(0);q=c[b>>2]|0;o=J0(36)|0;c[h>>2]=o;p=q+4|0;E=c[p>>2]|0;if((E|0)==(c[q+8>>2]|0)){ee(q|0,h);G=c[h>>2]|0}else{if((E|0)==0){H=0}else{c[E>>2]=o;H=c[p>>2]|0}c[p>>2]=H+4;G=o}o=G;H=G;E=b+28|0;L34:do{if((a[E]&1)==0){h=l;c[h>>2]=c[E>>2];c[h+4>>2]=c[E+4>>2];c[h+8>>2]=c[E+8>>2];I=a[h]|0;J=h;L=32}else{h=c[b+36>>2]|0;F=c[b+32>>2]|0;do{if(F>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(F>>>0<11>>>0){j=F<<1&255;k=l;a[k]=j;M=l+1|0;N=j;O=k}else{k=F+16&-16;j=(x=0,as(230,k|0)|0);if(x){x=0;break}c[l+8>>2]=j;r=k|1;c[l>>2]=r;c[l+4>>2]=F;M=j;N=r&255;O=l}Kb(M|0,h|0,F)|0;a[M+F|0]=0;I=N;J=O;L=32;break L34}}while(0);F=bQ(-1,-1)|0;P=K;Q=F}}while(0);do{if((L|0)==32){O=g;c[O>>2]=c[m>>2];c[O+4>>2]=c[m+4>>2];c[O+8>>2]=c[m+8>>2];O=g;N=e;M=f;b=G;L49:do{if((I&1)==0){c[N>>2]=c[J>>2];c[N+4>>2]=c[J+4>>2];c[N+8>>2]=c[J+8>>2];L=42}else{E=c[l+8>>2]|0;F=c[l+4>>2]|0;do{if(F>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(F>>>0<11>>>0){a[N]=F<<1;R=e+1|0}else{h=F+16&-16;B=(x=0,as(230,h|0)|0);if(x){x=0;break}c[e+8>>2]=B;c[e>>2]=h|1;c[e+4>>2]=F;R=B}Kb(R|0,E|0,F)|0;a[R+F|0]=0;L=42;break L49}}while(0);F=bQ(-1,-1)|0;S=K;T=F}}while(0);do{if((L|0)==42){c[M>>2]=c[O>>2];c[M+4>>2]=c[O+4>>2];c[M+8>>2]=c[O+8>>2];x=0;aP(282,b|0,e|0,f|0);if(x){x=0;F=bQ(-1,-1)|0;E=K;if((a[N]&1)==0){S=E;T=F;break}J2(c[e+8>>2]|0);S=E;T=F;break}if((a[N]&1)!=0){J2(c[e+8>>2]|0)}c[G>>2]=20032;c[G+32>>2]=n;if((a[J]&1)==0){i=d;return H|0}J2(c[l+8>>2]|0);i=d;return H|0}}while(0);N=T;b=S;if((a[J]&1)==0){P=b;Q=N;break}J2(c[l+8>>2]|0);P=b;Q=N}}while(0);l=c[q>>2]|0;q=c[p>>2]|0;J=l;while(1){if((J|0)==(q|0)){U=q;break}if((c[J>>2]|0)==(G|0)){U=J;break}else{J=J+4|0}}J=U-l>>2;U=l+(J+1<<2)|0;G=q-U|0;Kc(l+(J<<2)|0,U|0,G|0)|0;U=l+((G>>2)+J<<2)|0;J=c[p>>2]|0;if((U|0)!=(J|0)){c[p>>2]=J+(~((J-4+(-U|0)|0)>>>2)<<2)}J2(o);u=P;v=Q;w=v;y=0;z=w;A=u;be(z|0);return 0}function sO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0;d=i;i=i+728|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+72|0;m=d+88|0;n=d+96|0;o=d+112|0;p=d+120|0;q=d+136|0;r=d+144|0;s=d+160|0;t=d+168|0;u=d+176|0;v=d+184|0;w=d+192|0;y=d+208|0;z=d+216|0;A=d+232|0;B=d+240|0;C=d+256|0;D=d+264|0;E=d+280|0;F=d+288|0;G=d+304|0;H=d+312|0;I=d+328|0;J=d+344|0;L=d+360|0;M=d+376|0;N=d+392|0;O=d+408|0;P=d+424|0;Q=d+440|0;R=d+456|0;S=d+472|0;T=d+488|0;U=d+504|0;V=d+520|0;W=d+536|0;X=d+552|0;Y=d+568|0;Z=d+584|0;_=d+600|0;$=d+616|0;aa=d+632|0;ab=d+648|0;ac=d+664|0;ad=d+680|0;ae=d+696|0;af=d+712|0;do{if((sS(b)|0)==0){if((sT(b)|0)!=0){break}if((s_(b)|0)==0){ag=J0(48)|0;ah=ae+8|0;c[ah>>2]=ag;c[ae>>2]=49;c[ae+4>>2]=43;Kb(ag|0,7800,43)|0;a[ag+43|0]=0;c[af>>2]=0;c[af+4>>2]=0;c[af+8>>2]=0;x=0;aP(466,b|0,ae|0,af|0);if(!x){if((a[ae]&1)==0){ai=0;i=d;return ai|0}J2(c[ah>>2]|0);ai=0;i=d;return ai|0}else{x=0;ag=bQ(-1,-1)|0;aj=ag;ag=K;if((a[ae]&1)==0){ak=aj;al=ag;am=ak;an=0;ar=am;at=al;be(ar|0)}J2(c[ah>>2]|0);ak=aj;al=ag;am=ak;an=0;ar=am;at=al;be(ar|0)}}ag=c[b>>2]|0;aj=J0(48)|0;c[f>>2]=aj;ah=ag+4|0;au=c[ah>>2]|0;if((au|0)==(c[ag+8>>2]|0)){ee(ag|0,f);av=c[f>>2]|0}else{if((au|0)==0){aw=0}else{c[au>>2]=aj;aw=c[ah>>2]|0}c[ah>>2]=aw+4;av=aj}aj=av;au=av;ay=b+28|0;L25:do{if((a[ay]&1)==0){az=ab;c[az>>2]=c[ay>>2];c[az+4>>2]=c[ay+4>>2];c[az+8>>2]=c[ay+8>>2];aA=500}else{az=c[b+36>>2]|0;aC=c[b+32>>2]|0;do{if(aC>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aC>>>0<11>>>0){a[ab]=aC<<1;aD=ab+1|0}else{aE=aC+16&-16;aF=(x=0,as(230,aE|0)|0);if(x){x=0;break}c[ab+8>>2]=aF;c[ab>>2]=aE|1;c[ab+4>>2]=aC;aD=aF}Kb(aD|0,az|0,aC)|0;a[aD+aC|0]=0;aA=500;break L25}}while(0);aC=bQ(-1,-1)|0;aG=aC;aH=K}}while(0);do{if((aA|0)==500){ay=ac;aC=b+44|0;c[ay>>2]=c[aC>>2];c[ay+4>>2]=c[aC+4>>2];c[ay+8>>2]=c[aC+8>>2];aC=c[b+56>>2]|0;az=(c[b+60>>2]|0)-aC|0;do{if(az>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;aA=513;break}return 0}else{if(az>>>0<11>>>0){a[ad]=az<<1;aI=ad+1|0}else{aF=az+16&-16;aE=(x=0,as(230,aF|0)|0);if(x){x=0;aA=513;break}c[ad+8>>2]=aE;c[ad>>2]=aF|1;c[ad+4>>2]=az;aI=aE}Kb(aI|0,aC|0,az)|0;a[aI+az|0]=0;aE=e;c[aE>>2]=c[ay>>2];c[aE+4>>2]=c[ay+4>>2];c[aE+8>>2]=c[ay+8>>2];x=0;ao(18,au|0,ab|0,e|0,ad|0,0);if(x){x=0;aE=bQ(-1,-1)|0;aF=aE;aE=K;if((a[ad]&1)==0){aJ=aF;aK=aE;break}J2(c[ad+8>>2]|0);aJ=aF;aK=aE;break}if((a[ad]&1)!=0){J2(c[ad+8>>2]|0)}if((a[ab]&1)==0){ai=au;i=d;return ai|0}J2(c[ab+8>>2]|0);ai=au;i=d;return ai|0}}while(0);if((aA|0)==513){ay=bQ(-1,-1)|0;aJ=ay;aK=K}if((a[ab]&1)==0){aG=aJ;aH=aK;break}J2(c[ab+8>>2]|0);aG=aJ;aH=aK}}while(0);au=c[ag>>2]|0;ay=c[ah>>2]|0;az=au;while(1){if((az|0)==(ay|0)){aL=ay;break}if((c[az>>2]|0)==(av|0)){aL=az;break}else{az=az+4|0}}az=aL-au>>2;ag=au+(az+1<<2)|0;aC=ay-ag|0;Kc(au+(az<<2)|0,ag|0,aC|0)|0;ag=au+((aC>>2)+az<<2)|0;az=c[ah>>2]|0;if((ag|0)!=(az|0)){c[ah>>2]=az+(~((az-4+(-ag|0)|0)>>>2)<<2)}J2(aj);ak=aG;al=aH;am=ak;an=0;ar=am;at=al;be(ar|0)}}while(0);aH=b+56|0;aG=c[aH>>2]|0;aL=(c[b+60>>2]|0)-aG|0;if(aL>>>0>4294967279>>>0){CJ(0);return 0}if(aL>>>0<11>>>0){av=aL<<1&255;a[H]=av;aM=H+1|0;aN=av}else{av=aL+16&-16;aK=J0(av)|0;c[H+8>>2]=aK;aJ=av|1;c[H>>2]=aJ;c[H+4>>2]=aL;aM=aK;aN=aJ&255}Kb(aM|0,aG|0,aL)|0;a[aM+aL|0]=0;aL=I;I=b+44|0;c[aL>>2]=c[I>>2];c[aL+4>>2]=c[I+4>>2];c[aL+8>>2]=c[I+8>>2];I=(x=0,as(8,b|0)|0);L81:do{if(!x){L83:do{if((I|0)==0){aM=b+20|0;aG=(x=0,as(60,c[aM>>2]|0)|0);if(x){x=0;aA=30;break L81}aJ=(x=0,as(174,aG|0)|0);if(x){x=0;aA=30;break L81}if((aJ|0)!=0){x=0,as(48,b|0)|0;if(x){x=0;aA=30;break L81}aJ=b|0;aG=c[aJ>>2]|0;aK=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}av=aK;c[E>>2]=av;aK=aG+4|0;ab=c[aK>>2]|0;if((ab|0)==(c[aG+8>>2]|0)){x=0;aq(376,aG|0,E|0);if(x){x=0;aA=30;break L81}aO=c[E>>2]|0}else{if((ab|0)==0){aQ=0}else{c[ab>>2]=av;aQ=c[aK>>2]|0}c[aK>>2]=aQ+4;aO=av}av=aO;ab=b+28|0;L99:do{if((a[ab]&1)==0){ad=L;c[ad>>2]=c[ab>>2];c[ad+4>>2]=c[ab+4>>2];c[ad+8>>2]=c[ab+8>>2];aA=62}else{ad=c[b+36>>2]|0;e=c[b+32>>2]|0;do{if(e>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(e>>>0<11>>>0){a[L]=e<<1;aR=L+1|0}else{aI=e+16&-16;ac=(x=0,as(230,aI|0)|0);if(x){x=0;break}c[L+8>>2]=ac;c[L>>2]=aI|1;c[L+4>>2]=e;aR=ac}Kb(aR|0,ad|0,e)|0;a[aR+e|0]=0;aA=62;break L99}}while(0);e=bQ(-1,-1)|0;aS=e;aT=K}}while(0);do{if((aA|0)==62){e=D;c[e>>2]=c[aL>>2];c[e+4>>2]=c[aL+4>>2];c[e+8>>2]=c[aL+8>>2];x=0;ao(14,aO|0,L|0,D|0,aH|0,0);if(x){x=0;e=bQ(-1,-1)|0;ad=e;e=K;if((a[L]&1)==0){aS=ad;aT=e;break}J2(c[L+8>>2]|0);aS=ad;aT=e;break}if((a[L]&1)!=0){J2(c[L+8>>2]|0)}x=0,as(40,b|0)|0;if(x){x=0;aA=30;break L81}e=c[aJ>>2]|0;ad=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}ac=ad;c[C>>2]=ac;ad=e+4|0;aI=c[ad>>2]|0;if((aI|0)==(c[e+8>>2]|0)){x=0;aq(376,e|0,C|0);if(x){x=0;aA=30;break L81}aU=c[C>>2]|0}else{if((aI|0)==0){aV=0}else{c[aI>>2]=ac;aV=c[ad>>2]|0}c[ad>>2]=aV+4;aU=ac}ac=aU;L131:do{if((a[ab]&1)==0){aI=M;c[aI>>2]=c[ab>>2];c[aI+4>>2]=c[ab+4>>2];c[aI+8>>2]=c[ab+8>>2];aA=83}else{aI=c[b+36>>2]|0;aD=c[b+32>>2]|0;do{if(aD>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aD>>>0<11>>>0){a[M]=aD<<1;aW=M+1|0}else{aw=aD+16&-16;f=(x=0,as(230,aw|0)|0);if(x){x=0;break}c[M+8>>2]=f;c[M>>2]=aw|1;c[M+4>>2]=aD;aW=f}Kb(aW|0,aI|0,aD)|0;a[aW+aD|0]=0;aA=83;break L131}}while(0);aD=bQ(-1,-1)|0;aX=aD;aY=K}}while(0);do{if((aA|0)==83){aD=B;c[aD>>2]=c[aL>>2];c[aD+4>>2]=c[aL+4>>2];c[aD+8>>2]=c[aL+8>>2];x=0;ao(14,aU|0,M|0,B|0,aH|0,0);if(x){x=0;aD=bQ(-1,-1)|0;aI=aD;aD=K;if((a[M]&1)==0){aX=aI;aY=aD;break}J2(c[M+8>>2]|0);aX=aI;aY=aD;break}if((a[M]&1)!=0){J2(c[M+8>>2]|0)}x=0,as(18,b|0)|0;if(x){x=0;aA=30;break L81}aD=c[aJ>>2]|0;aI=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}f=aI;c[A>>2]=f;aI=aD+4|0;aw=c[aI>>2]|0;if((aw|0)==(c[aD+8>>2]|0)){x=0;aq(376,aD|0,A|0);if(x){x=0;aA=30;break L81}aZ=c[A>>2]|0}else{if((aw|0)==0){a_=0}else{c[aw>>2]=f;a_=c[aI>>2]|0}c[aI>>2]=a_+4;aZ=f}f=aZ;L163:do{if((a[ab]&1)==0){aw=N;c[aw>>2]=c[ab>>2];c[aw+4>>2]=c[ab+4>>2];c[aw+8>>2]=c[ab+8>>2];aA=104}else{aw=c[b+36>>2]|0;ae=c[b+32>>2]|0;do{if(ae>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ae>>>0<11>>>0){a[N]=ae<<1;a$=N+1|0}else{af=ae+16&-16;ag=(x=0,as(230,af|0)|0);if(x){x=0;break}c[N+8>>2]=ag;c[N>>2]=af|1;c[N+4>>2]=ae;a$=ag}Kb(a$|0,aw|0,ae)|0;a[a$+ae|0]=0;aA=104;break L163}}while(0);ae=bQ(-1,-1)|0;a0=ae;a1=K}}while(0);do{if((aA|0)==104){ae=z;c[ae>>2]=c[aL>>2];c[ae+4>>2]=c[aL+4>>2];c[ae+8>>2]=c[aL+8>>2];x=0;ao(14,aZ|0,N|0,z|0,aH|0,0);if(x){x=0;ae=bQ(-1,-1)|0;aw=ae;ae=K;if((a[N]&1)==0){a0=aw;a1=ae;break}J2(c[N+8>>2]|0);a0=aw;a1=ae;break}if((a[N]&1)!=0){J2(c[N+8>>2]|0)}ae=c[aJ>>2]|0;aw=(x=0,as(230,60)|0);if(x){x=0;aA=30;break L81}ag=aw;c[y>>2]=ag;aw=ae+4|0;af=c[aw>>2]|0;if((af|0)==(c[ae+8>>2]|0)){x=0;aq(376,ae|0,y|0);if(x){x=0;aA=30;break L81}a2=c[y>>2]|0}else{if((af|0)==0){a3=0}else{c[af>>2]=ag;a3=c[aw>>2]|0}c[aw>>2]=a3+4;a2=ag}ag=a2;L194:do{if((a[ab]&1)==0){af=O;c[af>>2]=c[ab>>2];c[af+4>>2]=c[ab+4>>2];c[af+8>>2]=c[ab+8>>2];aA=124}else{af=c[b+36>>2]|0;az=c[b+32>>2]|0;do{if(az>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(az>>>0<11>>>0){a[O]=az<<1;a4=O+1|0}else{aC=az+16&-16;aE=(x=0,as(230,aC|0)|0);if(x){x=0;break}c[O+8>>2]=aE;c[O>>2]=aC|1;c[O+4>>2]=az;a4=aE}Kb(a4|0,af|0,az)|0;a[a4+az|0]=0;aA=124;break L194}}while(0);az=bQ(-1,-1)|0;a5=az;a6=K}}while(0);do{if((aA|0)==124){az=w;c[az>>2]=c[aL>>2];c[az+4>>2]=c[aL+4>>2];c[az+8>>2]=c[aL+8>>2];x=0;aB(2,a2|0,O|0,w|0,3,0,0);if(x){x=0;az=bQ(-1,-1)|0;af=az;az=K;if((a[O]&1)==0){a5=af;a6=az;break}J2(c[O+8>>2]|0);a5=af;a6=az;break}if((a[O]&1)!=0){J2(c[O+8>>2]|0)}az=a2+40|0;af=az;aE=aO;c[v>>2]=aE;aC=az+8|0;aF=c[aC>>2]|0;a7=aF;a8=az+12|0;if((aF|0)==(c[a8>>2]|0)){x=0;aq(370,az+4|0,v|0);if(x){x=0;aA=30;break L81}a9=c[v>>2]|0}else{if((aF|0)==0){ba=0}else{c[a7>>2]=aE;ba=c[aC>>2]|0}c[aC>>2]=ba+4;a9=aE}x=0;aq(c[c[az>>2]>>2]|0,af|0,a9|0);if(x){x=0;aA=30;break L81}aE=aU;c[u>>2]=aE;a7=c[aC>>2]|0;aF=a7;if((a7|0)==(c[a8>>2]|0)){x=0;aq(370,az+4|0,u|0);if(x){x=0;aA=30;break L81}bb=c[u>>2]|0}else{if((a7|0)==0){bc=0}else{c[aF>>2]=aE;bc=c[aC>>2]|0}c[aC>>2]=bc+4;bb=aE}x=0;aq(c[c[az>>2]>>2]|0,af|0,bb|0);if(x){x=0;aA=30;break L81}aE=aZ;c[t>>2]=aE;aF=c[aC>>2]|0;a7=aF;if((aF|0)==(c[a8>>2]|0)){x=0;aq(370,az+4|0,t|0);if(x){x=0;aA=30;break L81}bd=c[t>>2]|0}else{if((aF|0)==0){bf=0}else{c[a7>>2]=aE;bf=c[aC>>2]|0}c[aC>>2]=bf+4;bd=aE}x=0;aq(c[c[az>>2]>>2]|0,af|0,bd|0);if(x){x=0;aA=30;break L81}bg=a2;break L83}}while(0);af=c[ae>>2]|0;az=c[aw>>2]|0;aE=af;while(1){if((aE|0)==(az|0)){bh=az;break}if((c[aE>>2]|0)==(a2|0)){bh=aE;break}else{aE=aE+4|0}}aE=bh-af>>2;ae=af+(aE+1<<2)|0;aC=az-ae|0;Kc(af+(aE<<2)|0,ae|0,aC|0)|0;ae=af+((aC>>2)+aE<<2)|0;aE=c[aw>>2]|0;if((ae|0)!=(aE|0)){c[aw>>2]=aE+(~((aE-4+(-ae|0)|0)>>>2)<<2)}J2(ag);bi=a5;bj=a6;break L81}}while(0);ae=c[aD>>2]|0;aE=c[aI>>2]|0;aC=ae;while(1){if((aC|0)==(aE|0)){bk=aE;break}if((c[aC>>2]|0)==(aZ|0)){bk=aC;break}else{aC=aC+4|0}}aC=bk-ae>>2;aD=ae+(aC+1<<2)|0;a7=aE-aD|0;Kc(ae+(aC<<2)|0,aD|0,a7|0)|0;aD=ae+((a7>>2)+aC<<2)|0;aC=c[aI>>2]|0;if((aD|0)!=(aC|0)){c[aI>>2]=aC+(~((aC-4+(-aD|0)|0)>>>2)<<2)}J2(f);bi=a0;bj=a1;break L81}}while(0);aD=c[e>>2]|0;aC=c[ad>>2]|0;a7=aD;while(1){if((a7|0)==(aC|0)){bl=aC;break}if((c[a7>>2]|0)==(aU|0)){bl=a7;break}else{a7=a7+4|0}}a7=bl-aD>>2;e=aD+(a7+1<<2)|0;aF=aC-e|0;Kc(aD+(a7<<2)|0,e|0,aF|0)|0;e=aD+((aF>>2)+a7<<2)|0;a7=c[ad>>2]|0;if((e|0)!=(a7|0)){c[ad>>2]=a7+(~((a7-4+(-e|0)|0)>>>2)<<2)}J2(ac);bi=aX;bj=aY;break L81}}while(0);ab=c[aG>>2]|0;aJ=c[aK>>2]|0;e=ab;while(1){if((e|0)==(aJ|0)){bm=aJ;break}if((c[e>>2]|0)==(aO|0)){bm=e;break}else{e=e+4|0}}e=bm-ab>>2;aG=ab+(e+1<<2)|0;a7=aJ-aG|0;Kc(ab+(e<<2)|0,aG|0,a7|0)|0;aG=ab+((a7>>2)+e<<2)|0;e=c[aK>>2]|0;if((aG|0)!=(e|0)){c[aK>>2]=e+(~((e-4+(-aG|0)|0)>>>2)<<2)}J2(av);bi=aS;bj=aT;break L81}aG=(x=0,as(118,b|0)|0);if(x){x=0;aA=30;break L81}if((aG|0)!=0){aG=c[b>>2]|0;e=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}a7=e;c[s>>2]=a7;e=aG+4|0;aF=c[e>>2]|0;if((aF|0)==(c[aG+8>>2]|0)){x=0;aq(376,aG|0,s|0);if(x){x=0;aA=30;break L81}bn=c[s>>2]|0}else{if((aF|0)==0){bo=0}else{c[aF>>2]=a7;bo=c[e>>2]|0}c[e>>2]=bo+4;bn=a7}a7=bn;aF=b+28|0;L288:do{if((a[aF]&1)==0){a8=P;c[a8>>2]=c[aF>>2];c[a8+4>>2]=c[aF+4>>2];c[a8+8>>2]=c[aF+8>>2];aA=204}else{a8=c[b+36>>2]|0;bp=c[b+32>>2]|0;do{if(bp>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bp>>>0<11>>>0){a[P]=bp<<1;bq=P+1|0}else{br=bp+16&-16;bs=(x=0,as(230,br|0)|0);if(x){x=0;break}c[P+8>>2]=bs;c[P>>2]=br|1;c[P+4>>2]=bp;bq=bs}Kb(bq|0,a8|0,bp)|0;a[bq+bp|0]=0;aA=204;break L288}}while(0);bp=bQ(-1,-1)|0;bt=bp;bu=K}}while(0);do{if((aA|0)==204){aF=r;c[aF>>2]=c[aL>>2];c[aF+4>>2]=c[aL+4>>2];c[aF+8>>2]=c[aL+8>>2];x=0;ao(14,bn|0,P|0,r|0,aH|0,0);if(!x){aF=bn;if((a[P]&1)==0){bg=aF;break L83}J2(c[P+8>>2]|0);bg=aF;break L83}else{x=0;aF=bQ(-1,-1)|0;av=aF;aF=K;if((a[P]&1)==0){bt=av;bu=aF;break}J2(c[P+8>>2]|0);bt=av;bu=aF;break}}}while(0);aF=c[aG>>2]|0;av=c[e>>2]|0;aK=aF;while(1){if((aK|0)==(av|0)){bv=av;break}if((c[aK>>2]|0)==(bn|0)){bv=aK;break}else{aK=aK+4|0}}aK=bv-aF>>2;aG=aF+(aK+1<<2)|0;ab=av-aG|0;Kc(aF+(aK<<2)|0,aG|0,ab|0)|0;aG=aF+((ab>>2)+aK<<2)|0;aK=c[e>>2]|0;if((aG|0)!=(aK|0)){c[e>>2]=aK+(~((aK-4+(-aG|0)|0)>>>2)<<2)}J2(a7);bi=bt;bj=bu;break L81}aG=(x=0,as(36,b|0)|0);if(x){x=0;aA=30;break L81}if((aG|0)!=0){aG=c[b>>2]|0;aK=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}ab=aK;c[q>>2]=ab;aK=aG+4|0;aJ=c[aK>>2]|0;if((aJ|0)==(c[aG+8>>2]|0)){x=0;aq(376,aG|0,q|0);if(x){x=0;aA=30;break L81}bw=c[q>>2]|0}else{if((aJ|0)==0){bx=0}else{c[aJ>>2]=ab;bx=c[aK>>2]|0}c[aK>>2]=bx+4;bw=ab}ab=bw;aJ=b+28|0;L329:do{if((a[aJ]&1)==0){bp=Q;c[bp>>2]=c[aJ>>2];c[bp+4>>2]=c[aJ+4>>2];c[bp+8>>2]=c[aJ+8>>2];aA=235}else{bp=c[b+36>>2]|0;a8=c[b+32>>2]|0;do{if(a8>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(a8>>>0<11>>>0){a[Q]=a8<<1;by=Q+1|0}else{ac=a8+16&-16;ad=(x=0,as(230,ac|0)|0);if(x){x=0;break}c[Q+8>>2]=ad;c[Q>>2]=ac|1;c[Q+4>>2]=a8;by=ad}Kb(by|0,bp|0,a8)|0;a[by+a8|0]=0;aA=235;break L329}}while(0);a8=bQ(-1,-1)|0;bz=a8;bA=K}}while(0);do{if((aA|0)==235){aJ=p;c[aJ>>2]=c[aL>>2];c[aJ+4>>2]=c[aL+4>>2];c[aJ+8>>2]=c[aL+8>>2];x=0;ao(14,bw|0,Q|0,p|0,aH|0,0);if(!x){aJ=bw;if((a[Q]&1)==0){bg=aJ;break L83}J2(c[Q+8>>2]|0);bg=aJ;break L83}else{x=0;aJ=bQ(-1,-1)|0;a7=aJ;aJ=K;if((a[Q]&1)==0){bz=a7;bA=aJ;break}J2(c[Q+8>>2]|0);bz=a7;bA=aJ;break}}}while(0);aJ=c[aG>>2]|0;a7=c[aK>>2]|0;e=aJ;while(1){if((e|0)==(a7|0)){bB=a7;break}if((c[e>>2]|0)==(bw|0)){bB=e;break}else{e=e+4|0}}e=bB-aJ>>2;aG=aJ+(e+1<<2)|0;aF=a7-aG|0;Kc(aJ+(e<<2)|0,aG|0,aF|0)|0;aG=aJ+((aF>>2)+e<<2)|0;e=c[aK>>2]|0;if((aG|0)!=(e|0)){c[aK>>2]=e+(~((e-4+(-aG|0)|0)>>>2)<<2)}J2(ab);bi=bz;bj=bA;break L81}aG=(x=0,as(128,b|0)|0);if(x){x=0;aA=30;break L81}if((aG|0)!=0){aG=c[b>>2]|0;e=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}aF=e;c[o>>2]=aF;e=aG+4|0;av=c[e>>2]|0;if((av|0)==(c[aG+8>>2]|0)){x=0;aq(376,aG|0,o|0);if(x){x=0;aA=30;break L81}bC=c[o>>2]|0}else{if((av|0)==0){bD=0}else{c[av>>2]=aF;bD=c[e>>2]|0}c[e>>2]=bD+4;bC=aF}aF=bC;av=b+28|0;L370:do{if((a[av]&1)==0){a8=R;c[a8>>2]=c[av>>2];c[a8+4>>2]=c[av+4>>2];c[a8+8>>2]=c[av+8>>2];aA=266}else{a8=c[b+36>>2]|0;bp=c[b+32>>2]|0;do{if(bp>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bp>>>0<11>>>0){a[R]=bp<<1;bE=R+1|0}else{ad=bp+16&-16;ac=(x=0,as(230,ad|0)|0);if(x){x=0;break}c[R+8>>2]=ac;c[R>>2]=ad|1;c[R+4>>2]=bp;bE=ac}Kb(bE|0,a8|0,bp)|0;a[bE+bp|0]=0;aA=266;break L370}}while(0);bp=bQ(-1,-1)|0;bF=bp;bG=K}}while(0);do{if((aA|0)==266){av=n;c[av>>2]=c[aL>>2];c[av+4>>2]=c[aL+4>>2];c[av+8>>2]=c[aL+8>>2];x=0;ao(14,bC|0,R|0,n|0,aH|0,0);if(!x){av=bC;if((a[R]&1)==0){bg=av;break L83}J2(c[R+8>>2]|0);bg=av;break L83}else{x=0;av=bQ(-1,-1)|0;ab=av;av=K;if((a[R]&1)==0){bF=ab;bG=av;break}J2(c[R+8>>2]|0);bF=ab;bG=av;break}}}while(0);av=c[aG>>2]|0;ab=c[e>>2]|0;aK=av;while(1){if((aK|0)==(ab|0)){bH=ab;break}if((c[aK>>2]|0)==(bC|0)){bH=aK;break}else{aK=aK+4|0}}aK=bH-av>>2;aG=av+(aK+1<<2)|0;aJ=ab-aG|0;Kc(av+(aK<<2)|0,aG|0,aJ|0)|0;aG=av+((aJ>>2)+aK<<2)|0;aK=c[e>>2]|0;if((aG|0)!=(aK|0)){c[e>>2]=aK+(~((aK-4+(-aG|0)|0)>>>2)<<2)}J2(aF);bi=bF;bj=bG;break L81}aG=(x=0,as(192,b|0)|0);if(x){x=0;aA=30;break L81}if((aG|0)!=0){aG=c[b>>2]|0;aK=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}aJ=aK;c[m>>2]=aJ;aK=aG+4|0;a7=c[aK>>2]|0;if((a7|0)==(c[aG+8>>2]|0)){x=0;aq(376,aG|0,m|0);if(x){x=0;aA=30;break L81}bI=c[m>>2]|0}else{if((a7|0)==0){bJ=0}else{c[a7>>2]=aJ;bJ=c[aK>>2]|0}c[aK>>2]=bJ+4;bI=aJ}aJ=bI;a7=b+28|0;L411:do{if((a[a7]&1)==0){bp=S;c[bp>>2]=c[a7>>2];c[bp+4>>2]=c[a7+4>>2];c[bp+8>>2]=c[a7+8>>2];aA=297}else{bp=c[b+36>>2]|0;a8=c[b+32>>2]|0;do{if(a8>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(a8>>>0<11>>>0){a[S]=a8<<1;bK=S+1|0}else{ac=a8+16&-16;ad=(x=0,as(230,ac|0)|0);if(x){x=0;break}c[S+8>>2]=ad;c[S>>2]=ac|1;c[S+4>>2]=a8;bK=ad}Kb(bK|0,bp|0,a8)|0;a[bK+a8|0]=0;aA=297;break L411}}while(0);a8=bQ(-1,-1)|0;bL=a8;bM=K}}while(0);do{if((aA|0)==297){a7=l;c[a7>>2]=c[aL>>2];c[a7+4>>2]=c[aL+4>>2];c[a7+8>>2]=c[aL+8>>2];x=0;ao(14,bI|0,S|0,l|0,aH|0,0);if(!x){a7=bI;if((a[S]&1)==0){bg=a7;break L83}J2(c[S+8>>2]|0);bg=a7;break L83}else{x=0;a7=bQ(-1,-1)|0;aF=a7;a7=K;if((a[S]&1)==0){bL=aF;bM=a7;break}J2(c[S+8>>2]|0);bL=aF;bM=a7;break}}}while(0);a7=c[aG>>2]|0;aF=c[aK>>2]|0;e=a7;while(1){if((e|0)==(aF|0)){bN=aF;break}if((c[e>>2]|0)==(bI|0)){bN=e;break}else{e=e+4|0}}e=bN-a7>>2;aG=a7+(e+1<<2)|0;av=aF-aG|0;Kc(a7+(e<<2)|0,aG|0,av|0)|0;aG=a7+((av>>2)+e<<2)|0;e=c[aK>>2]|0;if((aG|0)!=(e|0)){c[aK>>2]=e+(~((e-4+(-aG|0)|0)>>>2)<<2)}J2(aJ);bi=bL;bj=bM;break L81}aG=(x=0,as(60,c[aM>>2]|0)|0);if(x){x=0;aA=30;break L81}if(!((aG+1|0)==0|(a[aG]|0)!=41)){aG=c[b>>2]|0;e=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}av=e;c[k>>2]=av;e=aG+4|0;ab=c[e>>2]|0;if((ab|0)==(c[aG+8>>2]|0)){x=0;aq(376,aG|0,k|0);if(x){x=0;aA=30;break L81}bO=c[k>>2]|0}else{if((ab|0)==0){bP=0}else{c[ab>>2]=av;bP=c[e>>2]|0}c[e>>2]=bP+4;bO=av}av=bO;ab=b+28|0;L452:do{if((a[ab]&1)==0){a8=T;c[a8>>2]=c[ab>>2];c[a8+4>>2]=c[ab+4>>2];c[a8+8>>2]=c[ab+8>>2];aA=328}else{a8=c[b+36>>2]|0;bp=c[b+32>>2]|0;do{if(bp>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bp>>>0<11>>>0){a[T]=bp<<1;bR=T+1|0}else{ad=bp+16&-16;ac=(x=0,as(230,ad|0)|0);if(x){x=0;break}c[T+8>>2]=ac;c[T>>2]=ad|1;c[T+4>>2]=bp;bR=ac}Kb(bR|0,a8|0,bp)|0;a[bR+bp|0]=0;aA=328;break L452}}while(0);bp=bQ(-1,-1)|0;bS=bp;bT=K}}while(0);do{if((aA|0)==328){ab=j;c[ab>>2]=c[aL>>2];c[ab+4>>2]=c[aL+4>>2];c[ab+8>>2]=c[aL+8>>2];x=0;ao(34,bO|0,T|0,j|0,36832,0);if(!x){ab=bO;if((a[T]&1)==0){bg=ab;break L83}J2(c[T+8>>2]|0);bg=ab;break L83}else{x=0;ab=bQ(-1,-1)|0;aM=ab;ab=K;if((a[T]&1)==0){bS=aM;bT=ab;break}J2(c[T+8>>2]|0);bS=aM;bT=ab;break}}}while(0);ab=c[aG>>2]|0;aM=c[e>>2]|0;aJ=ab;while(1){if((aJ|0)==(aM|0)){bU=aM;break}if((c[aJ>>2]|0)==(bO|0)){bU=aJ;break}else{aJ=aJ+4|0}}aJ=bU-ab>>2;aG=ab+(aJ+1<<2)|0;aK=aM-aG|0;Kc(ab+(aJ<<2)|0,aG|0,aK|0)|0;aG=ab+((aK>>2)+aJ<<2)|0;aJ=c[e>>2]|0;if((aG|0)!=(aJ|0)){c[e>>2]=aJ+(~((aJ-4+(-aG|0)|0)>>>2)<<2)}J2(av);bi=bS;bj=bT;break L81}aG=V;Ke(aG|0,0,12)|0;aJ=H;aK=aN&255;if((aK&1|0)==0){bV=aK>>>1}else{bV=c[H+4>>2]|0}aK=bV+20|0;do{if(aK>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aK>>>0<11>>>0){a[aG]=40;bW=V+1|0}else{a7=bV+36&-16;aF=(x=0,as(230,a7|0)|0);if(x){x=0;break}c[V+8>>2]=aF;c[V>>2]=a7|1;c[V+4>>2]=20;bW=aF}Kb(bW|0,8512,20)|0;a[bW+20|0]=0;if((aN&1)==0){bX=aJ+1|0}else{bX=c[H+8>>2]|0}x=0,ax(64,V|0,bX|0,bV|0)|0;if(x){x=0;break}aF=U;Ke(aF|0,0,12)|0;a7=a[aG]|0;bp=a7&255;if((bp&1|0)==0){bY=bp>>>1}else{bY=c[V+4>>2]|0}if((a7&1)==0){bZ=V+1|0}else{bZ=c[V+8>>2]|0}a7=bY+4|0;do{if(a7>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;aA=370;break}return 0}else{if(a7>>>0<11>>>0){a[aF]=bY<<1;b_=U+1|0}else{bp=bY+20&-16;a8=(x=0,as(230,bp|0)|0);if(x){x=0;aA=370;break}c[U+8>>2]=a8;c[U>>2]=bp|1;c[U+4>>2]=bY;b_=a8}Kb(b_|0,bZ|0,bY)|0;a[b_+bY|0]=0;x=0,ax(64,U|0,8216,4)|0;if(x){x=0;aA=370;break}c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;x=0;aP(466,b|0,U|0,W|0);if(x){x=0;a8=bQ(-1,-1)|0;bp=a8;a8=K;if((a[aF]&1)==0){b$=bp;b0=a8;break}J2(c[U+8>>2]|0);b$=bp;b0=a8;break}if((a[aF]&1)!=0){J2(c[U+8>>2]|0)}if((a[aG]&1)==0){bg=0;break L83}J2(c[V+8>>2]|0);bg=0;break L83}}while(0);if((aA|0)==370){a7=bQ(-1,-1)|0;a8=K;if((a[aF]&1)!=0){J2(c[U+8>>2]|0)}b$=a7;b0=a8}if((a[aG]&1)==0){bi=b$;bj=b0;break L81}J2(c[V+8>>2]|0);bi=b$;bj=b0;break L81}}while(0);aJ=bQ(-1,-1)|0;aK=K;if((a[aG]&1)==0){b1=aK;b2=aJ;aA=31;break L81}J2(c[V+8>>2]|0);b1=aK;b2=aJ;aA=31;break L81}else{aJ=c[b>>2]|0;aK=(x=0,as(230,52)|0);if(x){x=0;aA=30;break L81}av=aK;c[G>>2]=av;aK=aJ+4|0;e=c[aK>>2]|0;if((e|0)==(c[aJ+8>>2]|0)){x=0;aq(376,aJ|0,G|0);if(x){x=0;aA=30;break L81}b3=c[G>>2]|0}else{if((e|0)==0){b4=0}else{c[e>>2]=av;b4=c[aK>>2]|0}c[aK>>2]=b4+4;b3=av}av=b3;e=b+28|0;L544:do{if((a[e]&1)==0){ab=J;c[ab>>2]=c[e>>2];c[ab+4>>2]=c[e+4>>2];c[ab+8>>2]=c[e+8>>2];aA=27}else{ab=c[b+36>>2]|0;aM=c[b+32>>2]|0;do{if(aM>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aM>>>0<11>>>0){a[J]=aM<<1;b5=J+1|0}else{a8=aM+16&-16;a7=(x=0,as(230,a8|0)|0);if(x){x=0;break}c[J+8>>2]=a7;c[J>>2]=a8|1;c[J+4>>2]=aM;b5=a7}Kb(b5|0,ab|0,aM)|0;a[b5+aM|0]=0;aA=27;break L544}}while(0);aM=bQ(-1,-1)|0;b6=aM;b7=K}}while(0);do{if((aA|0)==27){e=F;c[e>>2]=c[aL>>2];c[e+4>>2]=c[aL+4>>2];c[e+8>>2]=c[aL+8>>2];x=0;ao(14,b3|0,J|0,F|0,aH|0,0);if(!x){e=b3;if((a[J]&1)==0){bg=e;break L83}J2(c[J+8>>2]|0);bg=e;break L83}else{x=0;e=bQ(-1,-1)|0;aG=e;e=K;if((a[J]&1)==0){b6=aG;b7=e;break}J2(c[J+8>>2]|0);b6=aG;b7=e;break}}}while(0);e=c[aJ>>2]|0;aG=c[aK>>2]|0;aM=e;while(1){if((aM|0)==(aG|0)){b8=aG;break}if((c[aM>>2]|0)==(b3|0)){b8=aM;break}else{aM=aM+4|0}}aM=b8-e>>2;aJ=e+(aM+1<<2)|0;ab=aG-aJ|0;Kc(e+(aM<<2)|0,aJ|0,ab|0)|0;aJ=e+((ab>>2)+aM<<2)|0;aM=c[aK>>2]|0;if((aJ|0)!=(aM|0)){c[aK>>2]=aM+(~((aM-4+(-aJ|0)|0)>>>2)<<2)}J2(av);bi=b6;bj=b7;break L81}}while(0);aj=b+20|0;ah=(x=0,as(60,c[aj>>2]|0)|0);if(x){x=0;aA=30;break}au=(a[ah]|0)==41?ah+1|0:0;L574:do{if((au|0)==0){ay=Y;Ke(ay|0,0,12)|0;aJ=H;aM=a[H]|0;ab=aM&255;if((ab&1|0)==0){b9=ab>>>1}else{b9=c[H+4>>2]|0}ab=b9+25|0;do{if(ab>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ab>>>0<11>>>0){a[ay]=50;ca=Y+1|0}else{aF=b9+41&-16;a7=(x=0,as(230,aF|0)|0);if(x){x=0;break}c[Y+8>>2]=a7;c[Y>>2]=aF|1;c[Y+4>>2]=25;ca=a7}Kb(ca|0,7992,25)|0;a[ca+25|0]=0;if((aM&1)==0){cb=aJ+1|0}else{cb=c[H+8>>2]|0}x=0,ax(64,Y|0,cb|0,b9|0)|0;if(x){x=0;break}a7=X;Ke(a7|0,0,12)|0;aF=a[ay]|0;a8=aF&255;if((a8&1|0)==0){cc=a8>>>1}else{cc=c[Y+4>>2]|0}if((aF&1)==0){cd=Y+1|0}else{cd=c[Y+8>>2]|0}aF=cc+4|0;do{if(aF>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;aA=424;break}return 0}else{if(aF>>>0<11>>>0){a[a7]=cc<<1;ce=X+1|0}else{a8=cc+20&-16;bp=(x=0,as(230,a8|0)|0);if(x){x=0;aA=424;break}c[X+8>>2]=bp;c[X>>2]=a8|1;c[X+4>>2]=cc;ce=bp}Kb(ce|0,cd|0,cc)|0;a[ce+cc|0]=0;x=0,ax(64,X|0,8216,4)|0;if(x){x=0;aA=424;break}c[Z>>2]=0;c[Z+4>>2]=0;c[Z+8>>2]=0;x=0;aP(466,b|0,X|0,Z|0);if(x){x=0;bp=bQ(-1,-1)|0;a8=bp;bp=K;if((a[a7]&1)==0){cf=a8;cg=bp;break}J2(c[X+8>>2]|0);cf=a8;cg=bp;break}if((a[a7]&1)!=0){J2(c[X+8>>2]|0)}if((a[ay]&1)==0){break L574}J2(c[Y+8>>2]|0);break L574}}while(0);if((aA|0)==424){aF=bQ(-1,-1)|0;bp=K;if((a[a7]&1)!=0){J2(c[X+8>>2]|0)}cf=aF;cg=bp}if((a[ay]&1)==0){bi=cf;bj=cg;break L81}J2(c[Y+8>>2]|0);bi=cf;bj=cg;break L81}}while(0);aJ=bQ(-1,-1)|0;aM=K;if((a[ay]&1)==0){b1=aM;b2=aJ;aA=31;break L81}J2(c[Y+8>>2]|0);b1=aM;b2=aJ;aA=31;break L81}else{aJ=b+48|0;aM=c[aJ>>2]|0;ab=c[aj>>2]|0;L576:do{if(ab>>>0<au>>>0){av=ab;aK=0;while(1){e=a[av]|0;if((e<<24>>24|0)==10){ch=aK+1|0}else if((e<<24>>24|0)==0){ci=aK;break L576}else{ch=aK}e=av+1|0;if(e>>>0<au>>>0){av=e;aK=ch}else{ci=ch;break}}}else{ci=0}}while(0);c[aJ>>2]=ci+aM;ay=ah;aK=0;while(1){av=ay-1|0;if(av>>>0<ab>>>0){break}if((a[av]|0)==10){break}else{ay=av;aK=aK+1|0}}ay=b+40|0;if((ci|0)!=0){c[ay>>2]=1}ab=c[ay>>2]|0;c[b+52>>2]=ab+aK;aM=au;aJ=ah;c[ay>>2]=aM-aJ+aK+ab;ab=aH;c[ab>>2]=aJ;c[ab+4>>2]=aM;c[aj>>2]=au}}while(0);au=c[b>>2]|0;aj=(x=0,as(230,48)|0);if(x){x=0;aA=30;break}ah=aj;c[h>>2]=ah;aj=au+4|0;aM=c[aj>>2]|0;if((aM|0)==(c[au+8>>2]|0)){x=0;aq(376,au|0,h|0);if(x){x=0;aA=30;break}cj=c[h>>2]|0}else{if((aM|0)==0){ck=0}else{c[aM>>2]=ah;ck=c[aj>>2]|0}c[aj>>2]=ck+4;cj=ah}ah=cj;aM=cj;ab=b+28|0;L654:do{if((a[ab]&1)==0){aJ=_;c[aJ>>2]=c[ab>>2];c[aJ+4>>2]=c[ab+4>>2];c[aJ+8>>2]=c[ab+8>>2];aA=453}else{aJ=c[b+36>>2]|0;ay=c[b+32>>2]|0;do{if(ay>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ay>>>0<11>>>0){a[_]=ay<<1;cl=_+1|0}else{av=ay+16&-16;a7=(x=0,as(230,av|0)|0);if(x){x=0;break}c[_+8>>2]=a7;c[_>>2]=av|1;c[_+4>>2]=ay;cl=a7}Kb(cl|0,aJ|0,ay)|0;a[cl+ay|0]=0;aA=453;break L654}}while(0);ay=bQ(-1,-1)|0;cm=ay;cn=K}}while(0);do{if((aA|0)==453){ab=$;c[ab>>2]=c[aL>>2];c[ab+4>>2]=c[aL+4>>2];c[ab+8>>2]=c[aL+8>>2];ay=H;aJ=(a[ay]&1)==0;L669:do{if(aJ){aK=aa;c[aK>>2]=c[ay>>2];c[aK+4>>2]=c[ay+4>>2];c[aK+8>>2]=c[ay+8>>2];aA=463}else{aK=c[H+8>>2]|0;a7=c[H+4>>2]|0;do{if(a7>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(a7>>>0<11>>>0){a[aa]=a7<<1;co=aa+1|0}else{av=a7+16&-16;e=(x=0,as(230,av|0)|0);if(x){x=0;break}c[aa+8>>2]=e;c[aa>>2]=av|1;c[aa+4>>2]=a7;co=e}Kb(co|0,aK|0,a7)|0;a[co+a7|0]=0;aA=463;break L669}}while(0);a7=bQ(-1,-1)|0;cp=a7;cq=K}}while(0);do{if((aA|0)==463){ay=g;c[ay>>2]=c[ab>>2];c[ay+4>>2]=c[ab+4>>2];c[ay+8>>2]=c[ab+8>>2];x=0;ao(18,aM|0,_|0,g|0,aa|0,bg|0);if(x){x=0;ay=bQ(-1,-1)|0;a7=ay;ay=K;if((a[aa]&1)==0){cp=a7;cq=ay;break}J2(c[aa+8>>2]|0);cp=a7;cq=ay;break}if((a[aa]&1)!=0){J2(c[aa+8>>2]|0)}if((a[_]&1)!=0){J2(c[_+8>>2]|0)}if(aJ){ai=aM;i=d;return ai|0}J2(c[H+8>>2]|0);ai=aM;i=d;return ai|0}}while(0);if((a[_]&1)==0){cm=cp;cn=cq;break}J2(c[_+8>>2]|0);cm=cp;cn=cq}}while(0);aM=c[au>>2]|0;aJ=c[aj>>2]|0;ab=aM;while(1){if((ab|0)==(aJ|0)){cr=aJ;break}if((c[ab>>2]|0)==(cj|0)){cr=ab;break}else{ab=ab+4|0}}ab=cr-aM>>2;au=aM+(ab+1<<2)|0;ay=aJ-au|0;Kc(aM+(ab<<2)|0,au|0,ay|0)|0;au=aM+((ay>>2)+ab<<2)|0;ab=c[aj>>2]|0;if((au|0)!=(ab|0)){c[aj>>2]=ab+(~((ab-4+(-au|0)|0)>>>2)<<2)}J2(ah);bi=cm;bj=cn}else{x=0;aA=30}}while(0);if((aA|0)==30){cn=bQ(-1,-1)|0;b1=K;b2=cn;aA=31}if((aA|0)==31){bi=b2;bj=b1}if((a[H]&1)==0){ak=bi;al=bj;am=ak;an=0;ar=am;at=al;be(ar|0)}J2(c[H+8>>2]|0);ak=bi;al=bj;am=ak;an=0;ar=am;at=al;be(ar|0);return 0}function sP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0;d=i;i=i+400|0;e=d|0;f=d+16|0;g=d+24|0;h=d+40|0;j=d+48|0;k=d+64|0;l=d+80|0;m=d+96|0;n=d+112|0;o=d+128|0;p=d+144|0;q=d+160|0;r=d+176|0;s=d+192|0;t=d+208|0;u=d+224|0;v=d+240|0;w=d+256|0;y=d+272|0;z=d+288|0;A=d+304|0;B=d+320|0;C=d+336|0;D=d+352|0;E=d+368|0;F=d+384|0;G=b+20|0;H=xP(c[G>>2]|0)|0;I=(a[H]|0)==91?H+1|0:0;if((I|0)!=0){J=b+48|0;L=c[J>>2]|0;M=c[G>>2]|0;L3:do{if(M>>>0<I>>>0){N=M;O=0;while(1){P=a[N]|0;if((P<<24>>24|0)==0){Q=O;break L3}else if((P<<24>>24|0)==10){R=O+1|0}else{R=O}P=N+1|0;if(P>>>0<I>>>0){N=P;O=R}else{Q=R;break}}}else{Q=0}}while(0);c[J>>2]=Q+L;L=H;J=0;while(1){R=L-1|0;if(R>>>0<M>>>0){break}if((a[R]|0)==10){break}else{L=R;J=J+1|0}}L=b+40|0;if((Q|0)!=0){c[L>>2]=1}Q=c[L>>2]|0;c[b+52>>2]=Q+J;M=I;R=H;c[L>>2]=M-R+J+Q;Q=b+56|0;c[Q>>2]=R;c[Q+4>>2]=M;c[G>>2]=I}I=j;j=b+44|0;c[I>>2]=c[j>>2];c[I+4>>2]=c[j+4>>2];c[I+8>>2]=c[j+8>>2];do{if((s$(b)|0)==0){j=J0(48)|0;M=k+8|0;c[M>>2]=j;c[k>>2]=49;c[k+4>>2]=44;Kb(j|0,7640,44)|0;a[j+44|0]=0;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;x=0;aP(466,b|0,k|0,l|0);if(!x){if((a[k]&1)==0){break}J2(c[M>>2]|0);break}else{x=0}j=bQ(-1,-1)|0;Q=j;j=K;if((a[k]&1)==0){S=j;T=Q;U=T;V=0;W=U;X=S;be(W|0)}J2(c[M>>2]|0);S=j;T=Q;U=T;V=0;W=U;X=S;be(W|0)}}while(0);k=b+56|0;l=k|0;Q=c[l>>2]|0;j=b+60|0;M=(c[j>>2]|0)-Q|0;if(M>>>0>4294967279>>>0){CJ(0);return 0}if(M>>>0<11>>>0){a[m]=M<<1;Y=m+1|0}else{R=M+16&-16;J=J0(R)|0;c[m+8>>2]=J;c[m>>2]=R|1;c[m+4>>2]=M;Y=J}Kb(Y|0,Q|0,M)|0;a[Y+M|0]=0;M=(x=0,as(60,c[G>>2]|0)|0);L36:do{if(!x){Y=(a[M]|0)==93?M+1|0:0;L38:do{if((Y|0)==0){Q=(x=0,as(72,b|0)|0);if(x){x=0;Z=70;break L36}L41:do{if((Q|0)==0){J=s;Ke(J|0,0,12)|0;R=m;L=a[m]|0;H=L&255;if((H&1|0)==0){_=H>>>1}else{_=c[m+4>>2]|0}H=_+43|0;do{if(H>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(H>>>0<11>>>0){a[J]=86;$=s+1|0}else{O=_+59&-16;N=(x=0,as(230,O|0)|0);if(x){x=0;break}c[s+8>>2]=N;c[s>>2]=O|1;c[s+4>>2]=43;$=N}Kb($|0,7544,43)|0;a[$+43|0]=0;if((L&1)==0){aa=R+1|0}else{aa=c[m+8>>2]|0}x=0,ax(64,s|0,aa|0,_|0)|0;if(x){x=0;break}c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;x=0;aP(466,b|0,s|0,t|0);if(!x){if((a[J]&1)==0){break L41}J2(c[s+8>>2]|0);break L41}else{x=0;N=bQ(-1,-1)|0;O=N;N=K;if((a[J]&1)==0){ab=N;ac=O;break L36}J2(c[s+8>>2]|0);ab=N;ac=O;break L36}}}while(0);R=bQ(-1,-1)|0;L=K;if((a[J]&1)==0){ad=L;ae=R;Z=71;break L36}J2(c[s+8>>2]|0);ad=L;ae=R;Z=71;break L36}}while(0);Q=c[l>>2]|0;R=(c[j>>2]|0)-Q|0;if(R>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=70;break L36}return 0}if(R>>>0<11>>>0){L=R<<1&255;a[u]=L;af=u+1|0;ag=L}else{L=R+16&-16;H=(x=0,as(230,L|0)|0);if(x){x=0;Z=70;break L36}c[u+8>>2]=H;O=L|1;c[u>>2]=O;c[u+4>>2]=R;af=H;ag=O&255}Kb(af|0,Q|0,R)|0;a[af+R|0]=0;R=(x=0,as(192,b|0)|0);L78:do{if(!x){L80:do{if((R|0)==0){Q=(x=0,as(128,b|0)|0);if(x){x=0;Z=141;break L78}if((Q|0)!=0){break}Q=v;Ke(Q|0,0,12)|0;O=m;H=a[m]|0;L=H&255;if((L&1|0)==0){ah=L>>>1}else{ah=c[m+4>>2]|0}L=ah+67|0;do{if(L>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(L>>>0<11>>>0){a[Q]=-122;ai=v+1|0}else{N=ah+83&-16;P=(x=0,as(230,N|0)|0);if(x){x=0;break}c[v+8>>2]=P;c[v>>2]=N|1;c[v+4>>2]=67;ai=P}Kb(ai|0,7368,67)|0;a[ai+67|0]=0;if((H&1)==0){aj=O+1|0}else{aj=c[m+8>>2]|0}x=0,ax(64,v|0,aj|0,ah|0)|0;if(x){x=0;break}c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;x=0;aP(466,b|0,v|0,w|0);if(!x){if((a[Q]&1)==0){break L80}J2(c[v+8>>2]|0);break L80}else{x=0;P=bQ(-1,-1)|0;N=P;P=K;if((a[Q]&1)==0){ak=P;al=N;break L78}J2(c[v+8>>2]|0);ak=P;al=N;break L78}}}while(0);O=bQ(-1,-1)|0;H=K;if((a[Q]&1)==0){am=H;an=O;Z=142;break L78}J2(c[v+8>>2]|0);am=H;an=O;Z=142;break L78}}while(0);J=c[l>>2]|0;O=(c[j>>2]|0)-J|0;if(O>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;Z=141;break}return 0}if(O>>>0<11>>>0){H=O<<1&255;a[y]=H;ao=y+1|0;ar=H}else{H=O+16&-16;L=(x=0,as(230,H|0)|0);if(x){x=0;Z=141;break}c[y+8>>2]=L;N=H|1;c[y>>2]=N;c[y+4>>2]=O;ao=L;ar=N&255}Kb(ao|0,J|0,O)|0;a[ao+O|0]=0;O=(x=0,as(60,c[G>>2]|0)|0);L119:do{if(!x){J=(a[O]|0)==93?O+1|0:0;L121:do{if((J|0)==0){N=z;Ke(N|0,0,12)|0;L=m;H=a[m]|0;P=H&255;if((P&1|0)==0){at=P>>>1}else{at=c[m+4>>2]|0}P=at+36|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(P>>>0<11>>>0){a[N]=72;au=z+1|0}else{av=at+52&-16;aw=(x=0,as(230,av|0)|0);if(x){x=0;break}c[z+8>>2]=aw;c[z>>2]=av|1;c[z+4>>2]=36;au=aw}Kb(au|0,7168,36)|0;a[au+36|0]=0;if((H&1)==0){ay=L+1|0}else{ay=c[m+8>>2]|0}x=0,ax(64,z|0,ay|0,at|0)|0;if(x){x=0;break}c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;x=0;aP(466,b|0,z|0,A|0);if(!x){if((a[N]&1)==0){break L121}J2(c[z+8>>2]|0);break L121}else{x=0;aw=bQ(-1,-1)|0;av=aw;aw=K;if((a[N]&1)==0){az=aw;aA=av;break L119}J2(c[z+8>>2]|0);az=aw;aA=av;break L119}}}while(0);L=bQ(-1,-1)|0;H=K;if((a[N]&1)==0){aC=H;aD=L;Z=184;break L119}J2(c[z+8>>2]|0);aC=H;aD=L;Z=184;break L119}else{L=b+48|0;H=c[L>>2]|0;P=c[G>>2]|0;L123:do{if(P>>>0<J>>>0){av=P;aw=0;while(1){aE=a[av]|0;if((aE<<24>>24|0)==10){aF=aw+1|0}else if((aE<<24>>24|0)==0){aG=aw;break L123}else{aF=aw}aE=av+1|0;if(aE>>>0<J>>>0){av=aE;aw=aF}else{aG=aF;break}}}else{aG=0}}while(0);c[L>>2]=aG+H;N=O;aw=0;while(1){av=N-1|0;if(av>>>0<P>>>0){break}if((a[av]|0)==10){break}else{N=av;aw=aw+1|0}}N=b+40|0;if((aG|0)!=0){c[N>>2]=1}P=c[N>>2]|0;c[b+52>>2]=P+aw;H=J;L=O;c[N>>2]=H-L+aw+P;P=k;c[P>>2]=L;c[P+4>>2]=H;c[G>>2]=J}}while(0);J=c[b>>2]|0;Q=(x=0,as(230,68)|0);if(x){x=0;Z=183;break}H=Q;c[f>>2]=H;Q=J+4|0;P=c[Q>>2]|0;if((P|0)==(c[J+8>>2]|0)){x=0;aq(376,J|0,f|0);if(x){x=0;Z=183;break}aH=c[f>>2]|0}else{if((P|0)==0){aI=0}else{c[P>>2]=H;aI=c[Q>>2]|0}c[Q>>2]=aI+4;aH=H}H=aH;P=aH;L=b+28|0;L173:do{if((a[L]&1)==0){N=B;c[N>>2]=c[L>>2];c[N+4>>2]=c[L+4>>2];c[N+8>>2]=c[L+8>>2];Z=204}else{N=c[b+36>>2]|0;av=c[b+32>>2]|0;do{if(av>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(av>>>0<11>>>0){a[B]=av<<1;aJ=B+1|0}else{aE=av+16&-16;aK=(x=0,as(230,aE|0)|0);if(x){x=0;break}c[B+8>>2]=aK;c[B>>2]=aE|1;c[B+4>>2]=av;aJ=aK}Kb(aJ|0,N|0,av)|0;a[aJ+av|0]=0;Z=204;break L173}}while(0);av=bQ(-1,-1)|0;aL=K;aM=av}}while(0);do{if((Z|0)==204){L=C;c[L>>2]=c[I>>2];c[L+4>>2]=c[I+4>>2];c[L+8>>2]=c[I+8>>2];av=m;L188:do{if((a[av]&1)==0){N=D;c[N>>2]=c[av>>2];c[N+4>>2]=c[av+4>>2];c[N+8>>2]=c[av+8>>2];Z=214}else{N=c[m+8>>2]|0;aw=c[m+4>>2]|0;do{if(aw>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aw>>>0<11>>>0){a[D]=aw<<1;aN=D+1|0}else{aK=aw+16&-16;aE=(x=0,as(230,aK|0)|0);if(x){x=0;break}c[D+8>>2]=aE;c[D>>2]=aK|1;c[D+4>>2]=aw;aN=aE}Kb(aN|0,N|0,aw)|0;a[aN+aw|0]=0;Z=214;break L188}}while(0);aw=bQ(-1,-1)|0;aO=K;aQ=aw}}while(0);do{if((Z|0)==214){L203:do{if((ag&1)==0){av=u;aw=E;c[aw>>2]=c[av>>2];c[aw+4>>2]=c[av+4>>2];c[aw+8>>2]=c[av+8>>2];Z=224}else{av=c[u+8>>2]|0;aw=c[u+4>>2]|0;do{if(aw>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aw>>>0<11>>>0){a[E]=aw<<1;aR=E+1|0}else{N=aw+16&-16;aE=(x=0,as(230,N|0)|0);if(x){x=0;break}c[E+8>>2]=aE;c[E>>2]=N|1;c[E+4>>2]=aw;aR=aE}Kb(aR|0,av|0,aw)|0;a[aR+aw|0]=0;Z=224;break L203}}while(0);aw=bQ(-1,-1)|0;aS=K;aT=aw}}while(0);do{if((Z|0)==224){L218:do{if((ar&1)==0){aw=y;av=F;c[av>>2]=c[aw>>2];c[av+4>>2]=c[aw+4>>2];c[av+8>>2]=c[aw+8>>2];Z=234}else{aw=c[y+8>>2]|0;av=c[y+4>>2]|0;do{if(av>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(av>>>0<11>>>0){a[F]=av<<1;aU=F+1|0}else{aE=av+16&-16;N=(x=0,as(230,aE|0)|0);if(x){x=0;break}c[F+8>>2]=N;c[F>>2]=aE|1;c[F+4>>2]=av;aU=N}Kb(aU|0,aw|0,av)|0;a[aU+av|0]=0;Z=234;break L218}}while(0);av=bQ(-1,-1)|0;aV=K;aW=av}}while(0);do{if((Z|0)==234){av=e;c[av>>2]=c[L>>2];c[av+4>>2]=c[L+4>>2];c[av+8>>2]=c[L+8>>2];x=0;aB(56,P|0,B|0,e|0,D|0,E|0,F|0);if(x){x=0;av=bQ(-1,-1)|0;aw=av;av=K;if((a[F]&1)==0){aV=av;aW=aw;break}J2(c[F+8>>2]|0);aV=av;aW=aw;break}if((a[F]&1)!=0){J2(c[F+8>>2]|0)}if((a[E]&1)!=0){J2(c[E+8>>2]|0)}if((a[D]&1)!=0){J2(c[D+8>>2]|0)}if((a[B]&1)!=0){J2(c[B+8>>2]|0)}if((ar&1)!=0){J2(c[y+8>>2]|0)}if((ag&1)==0){aX=P;break L38}J2(c[u+8>>2]|0);aX=P;break L38}}while(0);if((a[E]&1)==0){aS=aV;aT=aW;break}J2(c[E+8>>2]|0);aS=aV;aT=aW}}while(0);if((a[D]&1)==0){aO=aS;aQ=aT;break}J2(c[D+8>>2]|0);aO=aS;aQ=aT}}while(0);if((a[B]&1)==0){aL=aO;aM=aQ;break}J2(c[B+8>>2]|0);aL=aO;aM=aQ}}while(0);P=c[J>>2]|0;L=c[Q>>2]|0;aw=P;while(1){if((aw|0)==(L|0)){aY=L;break}if((c[aw>>2]|0)==(aH|0)){aY=aw;break}else{aw=aw+4|0}}aw=aY-P>>2;J=P+(aw+1<<2)|0;av=L-J|0;Kc(P+(aw<<2)|0,J|0,av|0)|0;J=P+((av>>2)+aw<<2)|0;aw=c[Q>>2]|0;if((J|0)!=(aw|0)){c[Q>>2]=aw+(~((aw-4+(-J|0)|0)>>>2)<<2)}J2(H);az=aL;aA=aM}else{x=0;Z=183}}while(0);if((Z|0)==183){O=bQ(-1,-1)|0;aC=K;aD=O;Z=184}if((Z|0)==184){az=aC;aA=aD}if((ar&1)==0){ak=az;al=aA;break}J2(c[y+8>>2]|0);ak=az;al=aA}else{x=0;Z=141}}while(0);if((Z|0)==141){R=bQ(-1,-1)|0;am=K;an=R;Z=142}if((Z|0)==142){ak=am;al=an}if((ag&1)==0){ab=ak;ac=al;break L36}J2(c[u+8>>2]|0);ab=ak;ac=al;break L36}else{R=b+48|0;O=c[R>>2]|0;J=c[G>>2]|0;L280:do{if(J>>>0<Y>>>0){aw=J;av=0;while(1){N=a[aw]|0;if((N<<24>>24|0)==10){aZ=av+1|0}else if((N<<24>>24|0)==0){a_=av;break L280}else{aZ=av}N=aw+1|0;if(N>>>0<Y>>>0){aw=N;av=aZ}else{a_=aZ;break}}}else{a_=0}}while(0);c[R>>2]=a_+O;av=M;aw=0;while(1){N=av-1|0;if(N>>>0<J>>>0){break}if((a[N]|0)==10){break}else{av=N;aw=aw+1|0}}av=b+40|0;if((a_|0)!=0){c[av>>2]=1}J=c[av>>2]|0;c[b+52>>2]=J+aw;O=Y;R=M;c[av>>2]=O-R+aw+J;J=k;c[J>>2]=R;c[J+4>>2]=O;c[G>>2]=Y;O=c[b>>2]|0;J=(x=0,as(230,68)|0);if(x){x=0;Z=70;break L36}R=J;c[h>>2]=R;J=O+4|0;av=c[J>>2]|0;if((av|0)==(c[O+8>>2]|0)){x=0;aq(376,O|0,h|0);if(x){x=0;Z=70;break L36}a$=c[h>>2]|0}else{if((av|0)==0){a0=0}else{c[av>>2]=R;a0=c[J>>2]|0}c[J>>2]=a0+4;a$=R}R=a$;av=a$;N=b+28|0;L303:do{if((a[N]&1)==0){aE=n;c[aE>>2]=c[N>>2];c[aE+4>>2]=c[N+4>>2];c[aE+8>>2]=c[N+8>>2];Z=51}else{aE=c[b+36>>2]|0;aK=c[b+32>>2]|0;do{if(aK>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aK>>>0<11>>>0){a[n]=aK<<1;a1=n+1|0}else{a2=aK+16&-16;a3=(x=0,as(230,a2|0)|0);if(x){x=0;break}c[n+8>>2]=a3;c[n>>2]=a2|1;c[n+4>>2]=aK;a1=a3}Kb(a1|0,aE|0,aK)|0;a[a1+aK|0]=0;Z=51;break L303}}while(0);aK=bQ(-1,-1)|0;a4=aK;a5=K}}while(0);do{if((Z|0)==51){N=o;c[N>>2]=c[I>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];aw=m;L318:do{if((a[aw]&1)==0){aK=p;c[aK>>2]=c[aw>>2];c[aK+4>>2]=c[aw+4>>2];c[aK+8>>2]=c[aw+8>>2];Z=61}else{aK=c[m+8>>2]|0;aE=c[m+4>>2]|0;do{if(aE>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aE>>>0<11>>>0){a[p]=aE<<1;a6=p+1|0}else{a3=aE+16&-16;a2=(x=0,as(230,a3|0)|0);if(x){x=0;break}c[p+8>>2]=a2;c[p>>2]=a3|1;c[p+4>>2]=aE;a6=a2}Kb(a6|0,aK|0,aE)|0;a[a6+aE|0]=0;Z=61;break L318}}while(0);aE=bQ(-1,-1)|0;a7=K;a8=aE}}while(0);do{if((Z|0)==61){aw=q;a[aw]=0;a[q+1|0]=0;aE=r;a[aE]=0;a[r+1|0]=0;aK=g;c[aK>>2]=c[N>>2];c[aK+4>>2]=c[N+4>>2];c[aK+8>>2]=c[N+8>>2];x=0;aB(56,av|0,n|0,g|0,p|0,q|0,r|0);if(x){x=0;aK=bQ(-1,-1)|0;H=aK;aK=K;if((a[aE]&1)!=0){J2(c[r+8>>2]|0)}if((a[aw]&1)!=0){J2(c[q+8>>2]|0)}if((a[p]&1)==0){a7=aK;a8=H;break}J2(c[p+8>>2]|0);a7=aK;a8=H;break}if((a[aE]&1)!=0){J2(c[r+8>>2]|0)}if((a[aw]&1)!=0){J2(c[q+8>>2]|0)}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}if((a[n]&1)==0){aX=av;break L38}J2(c[n+8>>2]|0);aX=av;break L38}}while(0);if((a[n]&1)==0){a4=a8;a5=a7;break}J2(c[n+8>>2]|0);a4=a8;a5=a7}}while(0);av=c[O>>2]|0;N=c[J>>2]|0;aw=av;while(1){if((aw|0)==(N|0)){a9=N;break}if((c[aw>>2]|0)==(a$|0)){a9=aw;break}else{aw=aw+4|0}}aw=a9-av>>2;O=av+(aw+1<<2)|0;aE=N-O|0;Kc(av+(aw<<2)|0,O|0,aE|0)|0;O=av+((aE>>2)+aw<<2)|0;aw=c[J>>2]|0;if((O|0)!=(aw|0)){c[J>>2]=aw+(~((aw-4+(-O|0)|0)>>>2)<<2)}J2(R);ab=a5;ac=a4;break L36}}while(0);if((a[m]&1)==0){i=d;return aX|0}J2(c[m+8>>2]|0);i=d;return aX|0}else{x=0;Z=70}}while(0);if((Z|0)==70){aX=bQ(-1,-1)|0;ad=K;ae=aX;Z=71}if((Z|0)==71){ab=ad;ac=ae}if((a[m]&1)==0){S=ab;T=ac;U=T;V=0;W=U;X=S;be(W|0)}J2(c[m+8>>2]|0);S=ab;T=ac;U=T;V=0;W=U;X=S;be(W|0);return 0}function sQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yg(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yy(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yv(e)|0;if((f|0)==0){g=0;return g|0}h=yx(f)|0;if((h|0)==0){g=0;return g|0}f=b+48|0;i=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=i+o;i=e;f=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;f=f+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[i>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;g=h;return g|0}function sT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yx(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yz(e)|0;do{if((f|0)==0){g=yA(e)|0;if((g|0)==0){h=0}else{i=g;break}return h|0}else{i=f}}while(0);f=b+48|0;g=c[f>>2]|0;j=c[d>>2]|0;L5:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L5}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=g+o;g=e;f=0;while(1){n=g-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{g=n;f=f+1|0}}g=b+40|0;if((o|0)!=0){c[g>>2]=1}o=c[g>>2]|0;c[b+52>>2]=o+f;j=i;n=e;c[g>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;h=i;return h|0}function sV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yj(e)|0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=(a[g]|0)==110?g+1|0:0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function sW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yh(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xI(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function sY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yh(e)|0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=xI(g)|0;i=(f|0)!=0?f:g;if((i|0)==0){h=0;return h|0}g=(a[i]|0)==110?i+1|0:0;if((g|0)==0){h=0;return h|0}i=b+48|0;f=c[i>>2]|0;j=c[d>>2]|0;L10:do{if(j>>>0<g>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L10}else{n=l}m=k+1|0;if(m>>>0<g>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[i>>2]=f+o;f=e;i=0;while(1){n=f-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{f=n;i=i+1|0}}f=b+40|0;if((o|0)!=0){c[f>>2]=1}o=c[f>>2]|0;c[b+52>>2]=o+i;j=g;n=e;c[f>>2]=j-n+i+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=g;h=g;return h|0}function sZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yh(e)|0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=xI(g)|0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function s_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yv(e)|0;if((f|0)==0){g=0;return g|0}h=xQ(f)|0;if((h|0)==0){g=0;return g|0}f=b+48|0;i=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=i+o;i=e;f=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;f=f+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[i>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;g=h;return g|0}function s$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yc(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function s0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yB(e)|0;do{if((f|0)==0){g=yC(e)|0;if((g|0)!=0){h=g;break}g=yD(e)|0;if((g|0)!=0){h=g;break}g=yE(e)|0;if((g|0)!=0){h=g;break}g=yF(e)|0;if((g|0)!=0){h=g;break}g=yG(e)|0;if((g|0)==0){i=0}else{h=g;break}return i|0}else{h=f}}while(0);f=b+48|0;g=c[f>>2]|0;j=c[d>>2]|0;L9:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L9}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=g+o;g=e;f=0;while(1){n=g-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{g=n;f=f+1|0}}g=b+40|0;if((o|0)!=0){c[g>>2]=1}o=c[g>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[g>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;i=h;return i|0}function s1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xZ(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function s2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x$(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function s3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x0(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function s4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=d+20|0;if((e|0)==0){g=0;h=0;i=c[f>>2]|0}else{g=0;h=0;i=e}L3:while(1){j=(i|0)==0;if(j){k=c[f>>2]|0}else{k=i}e=xQ(xP(k)|0)|0;L8:do{if((e|0)==0){if(j){l=c[f>>2]|0}else{l=i}d=yc(xP(l)|0)|0;if((d|0)!=0){m=d;break}if(j){n=c[f>>2]|0}else{n=i}d=ye(xP(n)|0)|0;if((d|0)!=0){m=d;break}if(j){o=c[f>>2]|0}else{o=i}d=yf(xP(o)|0)|0;if((d|0)!=0){m=d;break}if(j){p=c[f>>2]|0}else{p=i}d=yv(xP(p)|0)|0;if((d|0)!=0){q=xQ(d)|0;if((q|0)!=0){m=q;break}}if(j){r=c[f>>2]|0}else{r=i}q=ym(xP(r)|0)|0;if((q|0)!=0){m=q;break}if(j){s=c[f>>2]|0}else{s=i}q=yn(xP(s)|0)|0;if((q|0)!=0){m=q;break}if(j){t=c[f>>2]|0}else{t=i}q=xM(xP(t)|0)|0;if((q|0)!=0){m=q;break}if(j){u=c[f>>2]|0}else{u=i}q=xP(u)|0;d=(a[q]|0)==42?q+1|0:0;if((d|0)!=0){m=d;break}if(j){v=c[f>>2]|0}else{v=i}d=xP(v)|0;q=(a[d]|0)==40?d+1|0:0;if((q|0)!=0){m=q;break}if(j){w=c[f>>2]|0}else{w=i}q=xP(w)|0;d=(a[q]|0)==41?q+1|0:0;if((d|0)!=0){m=d;break}if(j){x=c[f>>2]|0}else{x=i}d=xP(x)|0;q=(a[d]|0)==91?d+1|0:0;if((q|0)!=0){m=q;break}if(j){y=c[f>>2]|0}else{y=i}q=xP(y)|0;d=(a[q]|0)==93?q+1|0:0;if((d|0)!=0){m=d;break}if(j){z=c[f>>2]|0}else{z=i}d=xP(z)|0;q=(a[d]|0)==43?d+1|0:0;if((q|0)!=0){m=q;break}if(j){A=c[f>>2]|0}else{A=i}q=xP(A)|0;d=(a[q]|0)==126?q+1|0:0;if((d|0)!=0){m=d;break}if(j){B=c[f>>2]|0}else{B=i}d=xP(B)|0;q=(a[d]|0)==62?d+1|0:0;if((q|0)!=0){m=q;break}if(j){C=c[f>>2]|0}else{C=i}q=xP(C)|0;d=(a[q]|0)==44?q+1|0:0;if((d|0)!=0){m=d;break}if(j){D=c[f>>2]|0}else{D=i}d=yk(xP(D)|0)|0;if((d|0)!=0){m=d;break}if(j){E=c[f>>2]|0}else{E=i}d=xP(E)|0;q=yh(d)|0;F=(q|0)!=0?q:d;do{if((F|0)!=0){d=xI(F)|0;q=(d|0)!=0?d:F;if((q|0)==0){break}d=(a[q]|0)==110?q+1|0:0;if((d|0)!=0){m=d;break L8}}}while(0);if(j){G=c[f>>2]|0}else{G=i}F=xP(G)|0;d=yh(F)|0;q=(d|0)!=0?d:F;if((q|0)!=0){F=xI(q)|0;if((F|0)!=0){m=F;break}}if(j){H=c[f>>2]|0}else{H=i}F=yi(xP(H)|0)|0;if((F|0)!=0){m=F;break}if(j){I=c[f>>2]|0}else{I=i}F=xP(I)|0;q=(a[F]|0)==38?F+1|0:0;if((q|0)!=0){m=q;break}if(j){J=c[f>>2]|0}else{J=i}q=xP(J)|0;F=(a[q]|0)==37?q+1|0:0;if((F|0)!=0){m=F;break}if(j){K=c[f>>2]|0}else{K=i}F=xP(K)|0;q=yB(F)|0;if((q|0)!=0){m=q;break}q=yC(F)|0;if((q|0)!=0){m=q;break}q=yD(F)|0;if((q|0)!=0){m=q;break}q=yE(F)|0;if((q|0)!=0){m=q;break}q=yF(F)|0;if((q|0)!=0){m=q;break}q=yG(F)|0;if((q|0)!=0){m=q;break}if(j){L=c[f>>2]|0}else{L=i}q=xP(L)|0;F=(a[q]|0)==46?q+1|0:0;if((F|0)!=0){q=xN(F)|0;if((q|0)!=0){m=q;break}}if(j){M=c[f>>2]|0}else{M=i}q=xP(M)|0;F=(a[q]|0)==35?q+1|0:0;if((F|0)!=0){q=xN(F)|0;if((q|0)!=0){m=q;break}}if(j){N=c[f>>2]|0}else{N=i}q=xP(N)|0;F=(a[q]|0)==45?q+1|0:0;if((F|0)!=0){q=xN(F)|0;if((q|0)!=0){m=q;break}}if(j){O=c[f>>2]|0}else{O=i}q=yv(xP(O)|0)|0;if((q|0)!=0){F=xN(q)|0;if((F|0)!=0){m=F;break}}if(j){P=c[f>>2]|0}else{P=i}F=xN(xP(P)|0)|0;if((F|0)==0){break L3}else{m=F}}else{m=e}}while(0);g=m;h=(a[m-1|0]|0)==125|h;i=m}if(j){Q=c[f>>2]|0}else{Q=i}i=xP(Q)|0;Q=a[i]|0;f=i+1|0;i=Q<<24>>24==59?f:0;if((i|0)!=0){R=i;S=(R|0)==0;T=S?0:g;U=b|0;c[U>>2]=T;V=b+4|0;W=h&1;a[V]=W;return}i=Q<<24>>24==125?f:0;if((i|0)!=0){R=i;S=(R|0)==0;T=S?0:g;U=b|0;c[U>>2]=T;V=b+4|0;W=h&1;a[V]=W;return}R=Q<<24>>24==123?f:0;S=(R|0)==0;T=S?0:g;U=b|0;c[U>>2]=T;V=b+4|0;W=h&1;a[V]=W;return}function s5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,aq=0,ar=0,at=0,au=0,av=0,aw=0,ay=0;d=i;i=i+240|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+56|0;k=d+72|0;l=d+80|0;m=d+96|0;n=d+112|0;o=d+128|0;p=d+144|0;q=d+160|0;r=d+176|0;s=d+192|0;t=d+208|0;u=d+224|0;v=b+20|0;w=xP(c[v>>2]|0)|0;y=(a[w]|0)==42?w+1|0:0;z=(y|0)!=0?y:w;do{if((z|0)==0){A=4}else{if((xR(z)|0)==0){A=4;break}B=sA(b)|0}}while(0);L4:do{if((A|0)==4){if((sB(b)|0)==0){z=J0(32)|0;w=m+8|0;c[w>>2]=z;c[m>>2]=33;c[m+4>>2]=21;Kb(z|0,5896,21)|0;a[z+21|0]=0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;x=0;aP(466,b|0,m|0,n|0);if(!x){if((a[m]&1)==0){B=0;break}J2(c[w>>2]|0);B=0;break}else{x=0}z=bQ(-1,-1)|0;y=z;z=K;if((a[m]&1)==0){C=z;D=y;E=D;F=0;G=E;H=C;be(G|0)}J2(c[w>>2]|0);C=z;D=y;E=D;F=0;G=E;H=C;be(G|0)}y=c[b>>2]|0;z=J0(52)|0;c[k>>2]=z;w=y+4|0;I=c[w>>2]|0;if((I|0)==(c[y+8>>2]|0)){ee(y|0,k);J=c[k>>2]|0}else{if((I|0)==0){L=0}else{c[I>>2]=z;L=c[w>>2]|0}c[w>>2]=L+4;J=z}z=J;I=b+28|0;L24:do{if((a[I]&1)==0){M=l;c[M>>2]=c[I>>2];c[M+4>>2]=c[I+4>>2];c[M+8>>2]=c[I+8>>2];A=20}else{M=c[b+36>>2]|0;N=c[b+32>>2]|0;do{if(N>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(N>>>0<11>>>0){a[l]=N<<1;O=l+1|0}else{P=N+16&-16;Q=(x=0,as(230,P|0)|0);if(x){x=0;break}c[l+8>>2]=Q;c[l>>2]=P|1;c[l+4>>2]=N;O=Q}Kb(O|0,M|0,N)|0;a[O+N|0]=0;A=20;break L24}}while(0);N=bQ(-1,-1)|0;R=K;S=N}}while(0);do{if((A|0)==20){I=b+44|0;N=j;c[N>>2]=c[I>>2];c[N+4>>2]=c[I+4>>2];c[N+8>>2]=c[I+8>>2];x=0;ao(14,J|0,l|0,j|0,b+56|0,0);if(!x){I=J;if((a[l]&1)==0){B=I;break L4}J2(c[l+8>>2]|0);B=I;break L4}else{x=0;I=bQ(-1,-1)|0;N=I;I=K;if((a[l]&1)==0){R=I;S=N;break}J2(c[l+8>>2]|0);R=I;S=N;break}}}while(0);N=c[y>>2]|0;I=c[w>>2]|0;M=N;while(1){if((M|0)==(I|0)){T=I;break}if((c[M>>2]|0)==(J|0)){T=M;break}else{M=M+4|0}}M=T-N>>2;y=N+(M+1<<2)|0;Q=I-y|0;Kc(N+(M<<2)|0,y|0,Q|0)|0;y=N+((Q>>2)+M<<2)|0;M=c[w>>2]|0;if((y|0)!=(M|0)){c[w>>2]=M+(~((M-4+(-y|0)|0)>>>2)<<2)}J2(z);C=R;D=S;E=D;F=0;G=E;H=C;be(G|0)}}while(0);S=xP(c[v>>2]|0)|0;R=(a[S]|0)==58?S+1|0:0;L54:do{if((R|0)==0){T=c[b+56>>2]|0;J=(c[b+60>>2]|0)-T|0;if(J>>>0>4294967279>>>0){CJ(0);return 0}if(J>>>0<11>>>0){l=J<<1&255;j=q;O=q;a[O]=l;U=j+1|0;V=l;W=j;X=O}else{O=J+16&-16;j=J0(O)|0;c[q+8>>2]=j;l=O|1;c[q>>2]=l;c[q+4>>2]=J;U=j;V=l&255;W=q;X=q}Kb(U|0,T|0,J)|0;a[U+J|0]=0;J=p;Ke(J|0,0,12)|0;T=V&255;if((T&1|0)==0){Y=T>>>1}else{Y=c[q+4>>2]|0}T=Y+10|0;do{if(T>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;A=67;break}return 0}else{if(T>>>0<11>>>0){a[J]=20;Z=p+1|0}else{l=Y+26&-16;j=(x=0,as(230,l|0)|0);if(x){x=0;A=67;break}c[p+8>>2]=j;c[p>>2]=l|1;c[p+4>>2]=10;Z=j}Kb(Z|0,5792,10)|0;a[Z+10|0]=0;if((V&1)==0){_=W+1|0}else{_=c[q+8>>2]|0}x=0,ax(64,p|0,_|0,Y|0)|0;if(x){x=0;A=67;break}j=o;Ke(j|0,0,12)|0;l=a[J]|0;O=l&255;if((O&1|0)==0){$=O>>>1}else{$=c[p+4>>2]|0}if((l&1)==0){aa=p+1|0}else{aa=c[p+8>>2]|0}l=$+27|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;A=83;break}return 0}else{if(l>>>0<11>>>0){a[j]=$<<1;ab=o+1|0}else{O=$+43&-16;L=(x=0,as(230,O|0)|0);if(x){x=0;A=83;break}c[o+8>>2]=L;c[o>>2]=O|1;c[o+4>>2]=$;ab=L}Kb(ab|0,aa|0,$)|0;a[ab+$|0]=0;x=0,ax(64,o|0,5664,27)|0;if(x){x=0;A=83;break}c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;x=0;aP(466,b|0,o|0,r|0);if(x){x=0;L=bQ(-1,-1)|0;O=L;L=K;if((a[j]&1)==0){ac=L;ad=O;break}J2(c[o+8>>2]|0);ac=L;ad=O;break}if((a[j]&1)!=0){J2(c[o+8>>2]|0)}if((a[J]&1)!=0){J2(c[p+8>>2]|0)}if((a[X]&1)==0){break L54}J2(c[q+8>>2]|0);break L54}}while(0);if((A|0)==83){l=bQ(-1,-1)|0;O=K;if((a[j]&1)!=0){J2(c[o+8>>2]|0)}ac=O;ad=l}if((a[J]&1)==0){ae=ac;af=ad;break}J2(c[p+8>>2]|0);ae=ac;af=ad}}while(0);if((A|0)==67){T=bQ(-1,-1)|0;z=K;if((a[J]&1)!=0){J2(c[p+8>>2]|0)}ae=z;af=T}if((a[X]&1)==0){C=ae;D=af;E=D;F=0;G=E;H=C;be(G|0)}J2(c[q+8>>2]|0);C=ae;D=af;E=D;F=0;G=E;H=C;be(G|0)}else{T=b+48|0;z=c[T>>2]|0;w=c[v>>2]|0;L56:do{if(w>>>0<R>>>0){N=w;I=0;while(1){l=a[N]|0;if((l<<24>>24|0)==10){ag=I+1|0}else if((l<<24>>24|0)==0){ah=I;break L56}else{ag=I}l=N+1|0;if(l>>>0<R>>>0){N=l;I=ag}else{ah=ag;break}}}else{ah=0}}while(0);c[T>>2]=ah+z;J=S;I=0;while(1){N=J-1|0;if(N>>>0<w>>>0){break}if((a[N]|0)==10){break}else{J=N;I=I+1|0}}J=b+40|0;if((ah|0)!=0){c[J>>2]=1}w=c[J>>2]|0;c[b+52>>2]=w+I;z=R;T=S;c[J>>2]=z-T+I+w;w=b+56|0;c[w>>2]=T;c[w+4>>2]=z;c[v>>2]=R}}while(0);R=xP(c[v>>2]|0)|0;do{if(!((R+1|0)==0|(a[R]|0)!=59)){v=J0(48)|0;S=s+8|0;c[S>>2]=v;c[s>>2]=49;c[s+4>>2]=38;Kb(v|0,5584,38)|0;a[v+38|0]=0;c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;x=0;aP(466,b|0,s|0,t|0);if(!x){if((a[s]&1)==0){break}J2(c[S>>2]|0);break}else{x=0}v=bQ(-1,-1)|0;ah=v;v=K;if((a[s]&1)==0){C=v;D=ah;E=D;F=0;G=E;H=C;be(G|0)}J2(c[S>>2]|0);C=v;D=ah;E=D;F=0;G=E;H=C;be(G|0)}}while(0);s=s6(b)|0;t=c[b>>2]|0;R=J0(40)|0;c[h>>2]=R;ah=t+4|0;v=c[ah>>2]|0;if((v|0)==(c[t+8>>2]|0)){ee(t|0,h);ai=c[h>>2]|0}else{if((v|0)==0){aj=0}else{c[v>>2]=R;aj=c[ah>>2]|0}c[ah>>2]=aj+4;ai=R}R=ai;aj=ai;v=b+28|0;L161:do{if((a[v]&1)==0){h=u;c[h>>2]=c[v>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];ak=a[h]|0;al=h;A=121}else{h=c[b+36>>2]|0;S=c[b+32>>2]|0;do{if(S>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(S>>>0<11>>>0){ag=S<<1&255;af=u;a[af]=ag;am=u+1|0;an=ag;aq=af}else{af=S+16&-16;ag=(x=0,as(230,af|0)|0);if(x){x=0;break}c[u+8>>2]=ag;ae=af|1;c[u>>2]=ae;c[u+4>>2]=S;am=ag;an=ae&255;aq=u}Kb(am|0,h|0,S)|0;a[am+S|0]=0;ak=an;al=aq;A=121;break L161}}while(0);S=bQ(-1,-1)|0;ar=K;at=S}}while(0);do{if((A|0)==121){aq=B+16|0;an=g;c[an>>2]=c[aq>>2];c[an+4>>2]=c[aq+4>>2];c[an+8>>2]=c[aq+8>>2];aq=g;an=e;am=f;b=ai;L176:do{if((ak&1)==0){c[an>>2]=c[al>>2];c[an+4>>2]=c[al+4>>2];c[an+8>>2]=c[al+8>>2];A=131}else{v=c[u+8>>2]|0;S=c[u+4>>2]|0;do{if(S>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(S>>>0<11>>>0){a[an]=S<<1;au=e+1|0}else{h=S+16&-16;I=(x=0,as(230,h|0)|0);if(x){x=0;break}c[e+8>>2]=I;c[e>>2]=h|1;c[e+4>>2]=S;au=I}Kb(au|0,v|0,S)|0;a[au+S|0]=0;A=131;break L176}}while(0);S=bQ(-1,-1)|0;av=K;aw=S}}while(0);do{if((A|0)==131){c[am>>2]=c[aq>>2];c[am+4>>2]=c[aq+4>>2];c[am+8>>2]=c[aq+8>>2];x=0;aP(402,b|0,e|0,f|0);if(x){x=0;S=bQ(-1,-1)|0;v=K;if((a[an]&1)==0){av=v;aw=S;break}J2(c[e+8>>2]|0);av=v;aw=S;break}if((a[an]&1)!=0){J2(c[e+8>>2]|0)}c[ai>>2]=21360;c[ai+28>>2]=B;c[ai+32>>2]=s;a[ai+36|0]=0;if((a[al]&1)==0){i=d;return aj|0}J2(c[u+8>>2]|0);i=d;return aj|0}}while(0);an=aw;b=av;if((a[al]&1)==0){ar=b;at=an;break}J2(c[u+8>>2]|0);ar=b;at=an}}while(0);u=c[t>>2]|0;t=c[ah>>2]|0;al=u;while(1){if((al|0)==(t|0)){ay=t;break}if((c[al>>2]|0)==(ai|0)){ay=al;break}else{al=al+4|0}}al=ay-u>>2;ay=u+(al+1<<2)|0;ai=t-ay|0;Kc(u+(al<<2)|0,ay|0,ai|0)|0;ay=u+((ai>>2)+al<<2)|0;al=c[ah>>2]|0;if((ay|0)!=(al|0)){c[ah>>2]=al+(~((al-4+(-ay|0)|0)>>>2)<<2)}J2(R);C=ar;D=at;E=D;F=0;G=E;H=C;be(G|0);return 0}function s6(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;d=i;i=i+96|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=d+56|0;l=d+64|0;m=d+80|0;n=b+20|0;o=xP(c[n>>2]|0)|0;do{if((o+1|0)==0|(a[o]|0)!=59){p=xP(c[n>>2]|0)|0;if(!((p+1|0)==0|(a[p]|0)!=125)){break}p=xP(c[n>>2]|0)|0;if(!((p+1|0)==0|(a[p]|0)!=123)){break}p=xP(c[n>>2]|0)|0;if(!((p+1|0)==0|(a[p]|0)!=41)){break}p=xP(c[n>>2]|0)|0;q=a[35392]|0;L6:do{if(q<<24>>24==0){r=p;s=8}else{t=p;u=35392;v=q;while(1){if((a[t]|0)!=v<<24>>24){break L6}w=t+1|0;y=u+1|0;z=a[y]|0;if(z<<24>>24==0){r=w;s=8;break}else{t=w;u=y;v=z}}}}while(0);if((s|0)==8){if((r|0)!=0){break}}q=su(b)|0;p=xP(c[n>>2]|0)|0;if((p+1|0)==0|(a[p]|0)!=44){A=q;i=d;return A|0}p=c[b>>2]|0;v=J0(60)|0;c[h>>2]=v;u=p+4|0;t=c[u>>2]|0;if((t|0)==(c[p+8>>2]|0)){ee(p|0,h);B=c[h>>2]|0}else{if((t|0)==0){C=0}else{c[t>>2]=v;C=c[u>>2]|0}c[u>>2]=C+4;B=v}v=B;t=b+28|0;L23:do{if((a[t]&1)==0){z=m;c[z>>2]=c[t>>2];c[z+4>>2]=c[t+4>>2];c[z+8>>2]=c[t+8>>2];s=52}else{z=c[b+36>>2]|0;y=c[b+32>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[m]=y<<1;D=m+1|0}else{w=y+16&-16;E=(x=0,as(230,w|0)|0);if(x){x=0;break}c[m+8>>2]=E;c[m>>2]=w|1;c[m+4>>2]=y;D=E}Kb(D|0,z|0,y)|0;a[D+y|0]=0;s=52;break L23}}while(0);y=bQ(-1,-1)|0;F=y;G=K}}while(0);do{if((s|0)==52){t=b+44|0;y=g;c[y>>2]=c[t>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];x=0;aB(34,B|0,m|0,g|0,2,1,0);if(x){x=0;t=bQ(-1,-1)|0;y=t;t=K;if((a[m]&1)==0){F=y;G=t;break}J2(c[m+8>>2]|0);F=y;G=t;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}t=B+36|0;y=t;c[f>>2]=q;z=t+8|0;E=z;w=c[E>>2]|0;H=t+12|0;if((w|0)==(c[H>>2]|0)){eq(t+4|0,f);I=c[f>>2]|0}else{if((w|0)==0){J=0}else{c[w>>2]=q;J=c[E>>2]|0}c[z>>2]=J+4;I=q}w=t;cy[c[c[w>>2]>>2]&1023](y,I);L=xP(c[n>>2]|0)|0;M=(a[L]|0)==44?L+1|0:0;L52:do{if((M|0)!=0){N=b+48|0;O=b+40|0;P=b+52|0;Q=b+56|0;R=t+4|0;S=L;T=M;do{U=c[N>>2]|0;V=c[n>>2]|0;L56:do{if(V>>>0<T>>>0){W=V;X=0;while(1){Y=a[W]|0;if((Y<<24>>24|0)==10){Z=X+1|0}else if((Y<<24>>24|0)==0){_=X;break L56}else{Z=X}Y=W+1|0;if(Y>>>0<T>>>0){W=Y;X=Z}else{_=Z;break}}}else{_=0}}while(0);c[N>>2]=_+U;X=S;W=0;while(1){Y=X-1|0;if(Y>>>0<V>>>0){break}if((a[Y]|0)==10){break}else{X=Y;W=W+1|0}}if((_|0)!=0){c[O>>2]=1}X=c[O>>2]|0;c[P>>2]=X+W;V=T;U=S;c[O>>2]=V-U+W+X;c[Q>>2]=U;c[Q+4>>2]=V;c[n>>2]=T;if((T|0)==0){break L52}V=su(b)|0;c[e>>2]=V;U=c[E>>2]|0;if((U|0)==(c[H>>2]|0)){eq(R,e);$=c[e>>2]|0}else{if((U|0)==0){aa=0}else{c[U>>2]=V;aa=c[E>>2]|0}c[z>>2]=aa+4;$=V}cy[c[c[w>>2]>>2]&1023](y,$);S=xP(c[n>>2]|0)|0;T=(a[S]|0)==44?S+1|0:0;}while((T|0)!=0)}}while(0);A=B;i=d;return A|0}}while(0);q=c[p>>2]|0;y=c[u>>2]|0;w=q;while(1){if((w|0)==(y|0)){ab=y;break}if((c[w>>2]|0)==(B|0)){ab=w;break}else{w=w+4|0}}w=ab-q>>2;p=q+(w+1<<2)|0;z=y-p|0;Kc(q+(w<<2)|0,p|0,z|0)|0;p=q+((z>>2)+w<<2)|0;w=c[u>>2]|0;if((p|0)!=(w|0)){c[u>>2]=w+(~((w-4+(-p|0)|0)>>>2)<<2)}J2(v);ac=F;ad=G;ae=ac;af=0;ag=ae;ah=ad;be(ag|0)}}while(0);G=c[b>>2]|0;F=J0(60)|0;c[k>>2]=F;ab=G+4|0;B=c[ab>>2]|0;if((B|0)==(c[G+8>>2]|0)){ee(G|0,k);ai=c[k>>2]|0}else{if((B|0)==0){aj=0}else{c[B>>2]=F;aj=c[ab>>2]|0}c[ab>>2]=aj+4;ai=F}F=ai;aj=b+28|0;L97:do{if((a[aj]&1)==0){B=l;c[B>>2]=c[aj>>2];c[B+4>>2]=c[aj+4>>2];c[B+8>>2]=c[aj+8>>2];s=24}else{B=c[b+36>>2]|0;k=c[b+32>>2]|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(k>>>0<11>>>0){a[l]=k<<1;ak=l+1|0}else{n=k+16&-16;$=(x=0,as(230,n|0)|0);if(x){x=0;break}c[l+8>>2]=$;c[l>>2]=n|1;c[l+4>>2]=k;ak=$}Kb(ak|0,B|0,k)|0;a[ak+k|0]=0;s=24;break L97}}while(0);k=bQ(-1,-1)|0;al=k;am=K}}while(0);do{if((s|0)==24){ak=b+44|0;aj=j;c[aj>>2]=c[ak>>2];c[aj+4>>2]=c[ak+4>>2];c[aj+8>>2]=c[ak+8>>2];x=0;aB(34,ai|0,l|0,j|0,0,0,0);if(x){x=0;ak=bQ(-1,-1)|0;aj=ak;ak=K;if((a[l]&1)==0){al=aj;am=ak;break}J2(c[l+8>>2]|0);al=aj;am=ak;break}ak=ai;if((a[l]&1)==0){A=ak;i=d;return A|0}J2(c[l+8>>2]|0);A=ak;i=d;return A|0}}while(0);A=c[G>>2]|0;G=c[ab>>2]|0;d=A;while(1){if((d|0)==(G|0)){an=G;break}if((c[d>>2]|0)==(ai|0)){an=d;break}else{d=d+4|0}}d=an-A>>2;an=A+(d+1<<2)|0;ai=G-an|0;Kc(A+(d<<2)|0,an|0,ai|0)|0;an=A+((ai>>2)+d<<2)|0;d=c[ab>>2]|0;if((an|0)!=(d|0)){c[ab>>2]=d+(~((d-4+(-an|0)|0)>>>2)<<2)}J2(F);ac=al;ad=am;ae=ac;af=0;ag=ae;ah=ad;be(ag|0);return 0}function s7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;b=i;i=i+16|0;d=b|0;e=s8(a)|0;f=yL(xP(c[a+20>>2]|0)|0)|0;if((f|0)==0){g=e;i=b;return g|0}if((xQ(f)|0)!=0){g=e;i=b;return g|0}f=d|0;c[f>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=0;while(1){l=(x=0,as(150,a|0)|0);if(x){x=0;m=22;break}if((l|0)==0){m=28;break}l=(x=0,as(82,a|0)|0);if(x){x=0;m=22;break}if((k|0)!=(c[j>>2]|0)){if((k|0)==0){n=0}else{c[k>>2]=l;n=c[h>>2]|0}o=n+4|0;c[h>>2]=o;k=o;continue}o=c[f>>2]|0;p=k-o|0;q=p>>2;r=q+1|0;if(r>>>0>1073741823>>>0){m=12;break}if(q>>>0>536870910>>>0){s=1073741823;m=16}else{t=p>>1;u=t>>>0<r>>>0?r:t;if((u|0)==0){v=0;w=0}else{s=u;m=16}}if((m|0)==16){m=0;u=(x=0,as(230,s<<2|0)|0);if(x){x=0;m=22;break}v=u;w=s}u=v+(q<<2)|0;if((u|0)!=0){c[u>>2]=l}l=v+(r<<2)|0;r=o;Kb(v|0,r|0,p)|0;c[f>>2]=v;c[h>>2]=l;c[j>>2]=v+(w<<2);if((o|0)==0){k=l;continue}J2(r);k=l}do{if((m|0)==12){x=0;ap(152,0);if(x){x=0;m=23;break}return 0}else if((m|0)==22){k=bQ(-1,-1)|0;y=K;z=k}else if((m|0)==28){k=(x=0,aS(30,a|0,e|0,d|0,1)|0);if(x){x=0;m=23;break}w=c[f>>2]|0;if((w|0)==0){g=k;i=b;return g|0}v=c[h>>2]|0;if((w|0)!=(v|0)){c[h>>2]=v+(~((v-4+(-w|0)|0)>>>2)<<2)}J2(w);g=k;i=b;return g|0}}while(0);if((m|0)==23){m=bQ(-1,-1)|0;y=K;z=m}m=c[f>>2]|0;if((m|0)==0){be(z|0)}f=c[h>>2]|0;if((m|0)!=(f|0)){c[h>>2]=f+(~((f-4+(-m|0)|0)>>>2)<<2)}J2(m);be(z|0);return 0}function s8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;b=i;i=i+16|0;d=b|0;e=tb(a)|0;f=yK(xP(c[a+20>>2]|0)|0)|0;if((f|0)==0){g=e;i=b;return g|0}if((xQ(f)|0)!=0){g=e;i=b;return g|0}f=d|0;c[f>>2]=0;h=d+4|0;c[h>>2]=0;j=d+8|0;c[j>>2]=0;k=0;while(1){l=(x=0,as(164,a|0)|0);if(x){x=0;m=22;break}if((l|0)==0){m=28;break}l=(x=0,as(62,a|0)|0);if(x){x=0;m=22;break}if((k|0)!=(c[j>>2]|0)){if((k|0)==0){n=0}else{c[k>>2]=l;n=c[h>>2]|0}o=n+4|0;c[h>>2]=o;k=o;continue}o=c[f>>2]|0;p=k-o|0;q=p>>2;r=q+1|0;if(r>>>0>1073741823>>>0){m=12;break}if(q>>>0>536870910>>>0){s=1073741823;m=16}else{t=p>>1;u=t>>>0<r>>>0?r:t;if((u|0)==0){v=0;w=0}else{s=u;m=16}}if((m|0)==16){m=0;u=(x=0,as(230,s<<2|0)|0);if(x){x=0;m=22;break}v=u;w=s}u=v+(q<<2)|0;if((u|0)!=0){c[u>>2]=l}l=v+(r<<2)|0;r=o;Kb(v|0,r|0,p)|0;c[f>>2]=v;c[h>>2]=l;c[j>>2]=v+(w<<2);if((o|0)==0){k=l;continue}J2(r);k=l}do{if((m|0)==22){k=bQ(-1,-1)|0;y=K;z=k}else if((m|0)==28){k=(x=0,aS(30,a|0,e|0,d|0,0)|0);if(x){x=0;m=23;break}w=c[f>>2]|0;if((w|0)==0){g=k;i=b;return g|0}v=c[h>>2]|0;if((w|0)!=(v|0)){c[h>>2]=v+(~((v-4+(-w|0)|0)>>>2)<<2)}J2(w);g=k;i=b;return g|0}else if((m|0)==12){x=0;ap(152,0);if(x){x=0;m=23;break}return 0}}while(0);if((m|0)==23){m=bQ(-1,-1)|0;y=K;z=m}m=c[f>>2]|0;if((m|0)==0){be(z|0)}f=c[h>>2]|0;if((m|0)!=(f|0)){c[h>>2]=f+(~((f-4+(-m|0)|0)>>>2)<<2)}J2(m);be(z|0);return 0}function s9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yL(e)|0;if((f|0)==0){g=0;return g|0}h=(xQ(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=h+o;h=e;f=0;while(1){n=h-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{h=n;f=f+1|0}}h=b+40|0;if((o|0)!=0){c[h>>2]=1}o=c[h>>2]|0;c[b+52>>2]=o+f;j=i;n=e;c[h>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function ta(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;g=i;i=i+40|0;h=g|0;j=g+8|0;k=g+24|0;l=e|0;m=(c[e+4>>2]|0)-(c[l>>2]|0)>>2;if((m|0)==0){n=d;i=g;return n|0}e=b|0;o=b+28|0;p=j;q=k;r=b+44|0;s=(f|0)==11;t=j+8|0;u=b+36|0;v=b+32|0;b=j+1|0;w=j|0;y=j+4|0;z=0;A=d;while(1){B=c[e>>2]|0;d=J0(48)|0;c[h>>2]=d;C=B+4|0;D=c[C>>2]|0;if((D|0)==(c[B+8>>2]|0)){ee(B|0,h);E=c[h>>2]|0}else{if((D|0)==0){F=0}else{c[D>>2]=d;F=c[C>>2]|0}c[C>>2]=F+4;E=d}G=E;if((a[o]&1)==0){c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{d=c[u>>2]|0;D=c[v>>2]|0;if(D>>>0>4294967279>>>0){H=11;break}if(D>>>0<11>>>0){a[p]=D<<1;I=b}else{J=D+16&-16;L=(x=0,as(230,J|0)|0);if(x){x=0;H=25;break}c[t>>2]=L;c[w>>2]=J|1;c[y>>2]=D;I=L}Kb(I|0,d|0,D)|0;a[I+D|0]=0}c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];x=0;aB(12,E|0,j|0,k|0,f|0,A|0,c[(c[l>>2]|0)+(z<<2)>>2]|0);if(x){x=0;H=28;break}D=E;if((a[p]&1)!=0){J2(c[t>>2]|0)}d=c[E+40>>2]|0;do{if(s){if((a[d+28|0]&1)==0){H=35;break}if((a[(c[E+44>>2]|0)+28|0]&1)==0){H=35;break}a[E+28|0]=1}else{H=35}}while(0);if((H|0)==35){H=0;a[d+28|0]=0;a[(c[E+44>>2]|0)+28|0]=0}L=z+1|0;if(L>>>0<m>>>0){z=L;A=D}else{n=D;H=42;break}}do{if((H|0)==11){x=0;ap(232,0);if(!x){return 0}else{x=0;A=bQ(-1,-1)|0;M=K;N=A;H=27;break}}else if((H|0)==28){A=bQ(-1,-1)|0;z=A;A=K;if((a[p]&1)==0){O=A;P=z;break}J2(c[t>>2]|0);O=A;P=z}else if((H|0)==42){i=g;return n|0}else if((H|0)==25){z=bQ(-1,-1)|0;M=K;N=z;H=27}}while(0);if((H|0)==27){O=M;P=N}N=c[B>>2]|0;B=c[C>>2]|0;M=N;while(1){if((M|0)==(B|0)){Q=B;break}if((c[M>>2]|0)==(E|0)){Q=M;break}else{M=M+4|0}}M=Q-N>>2;Q=N+(M+1<<2)|0;E=B-Q|0;Kc(N+(M<<2)|0,Q|0,E|0)|0;Q=N+((E>>2)+M<<2)|0;M=c[C>>2]|0;if((Q|0)==(M|0)){J2(G);R=P;S=0;T=R;U=O;be(T|0)}c[C>>2]=M+(~((M-4+(-Q|0)|0)>>>2)<<2);J2(G);R=P;S=0;T=R;U=O;be(T|0);return 0}function tb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;d=i;i=i+40|0;e=d|0;f=d+8|0;g=d+24|0;h=td(b)|0;j=b+20|0;do{if((yM(xP(c[j>>2]|0)|0)|0)==0){if((yN(xP(c[j>>2]|0)|0)|0)!=0){break}if((yP(xP(c[j>>2]|0)|0)|0)!=0){break}if((yO(xP(c[j>>2]|0)|0)|0)!=0){break}if((yR(xP(c[j>>2]|0)|0)|0)!=0){break}if((yQ(xP(c[j>>2]|0)|0)|0)==0){k=h}else{break}i=d;return k|0}}while(0);do{if((te(b)|0)==0){if((tf(b)|0)!=0){l=3;break}if((tg(b)|0)!=0){l=5;break}if((th(b)|0)!=0){l=7;break}if((ti(b)|0)!=0){l=4;break}tj(b)|0;l=6}else{l=2}}while(0);j=td(b)|0;m=c[b>>2]|0;n=J0(48)|0;c[e>>2]=n;o=m+4|0;p=c[o>>2]|0;if((p|0)==(c[m+8>>2]|0)){ee(m|0,e);q=c[e>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=n;r=c[o>>2]|0}c[o>>2]=r+4;q=n}n=q;r=b+28|0;L23:do{if((a[r]&1)==0){p=f;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];s=28}else{p=c[b+36>>2]|0;e=c[b+32>>2]|0;do{if(e>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(e>>>0<11>>>0){a[f]=e<<1;t=f+1|0}else{u=e+16&-16;v=(x=0,as(230,u|0)|0);if(x){x=0;break}c[f+8>>2]=v;c[f>>2]=u|1;c[f+4>>2]=e;t=v}Kb(t|0,p|0,e)|0;a[t+e|0]=0;s=28;break L23}}while(0);e=bQ(-1,-1)|0;w=K;y=e}}while(0);do{if((s|0)==28){t=g;b=h+16|0;c[t>>2]=c[b>>2];c[t+4>>2]=c[b+4>>2];c[t+8>>2]=c[b+8>>2];x=0;aB(12,q|0,f|0,g|0,l|0,h|0,j|0);if(x){x=0;b=bQ(-1,-1)|0;t=b;b=K;if((a[f]&1)==0){w=b;y=t;break}J2(c[f+8>>2]|0);w=b;y=t;break}t=q;if((a[f]&1)==0){k=t;i=d;return k|0}J2(c[f+8>>2]|0);k=t;i=d;return k|0}}while(0);k=c[m>>2]|0;m=c[o>>2]|0;d=k;while(1){if((d|0)==(m|0)){z=m;break}if((c[d>>2]|0)==(q|0)){z=d;break}else{d=d+4|0}}d=z-k>>2;z=k+(d+1<<2)|0;q=m-z|0;Kc(k+(d<<2)|0,z|0,q|0)|0;z=k+((q>>2)+d<<2)|0;d=c[o>>2]|0;if((z|0)==(d|0)){J2(n);A=y;B=0;C=A;D=w;be(C|0)}c[o>>2]=d+(~((d-4+(-z|0)|0)>>>2)<<2);J2(n);A=y;B=0;C=A;D=w;be(C|0);return 0}function tc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yK(e)|0;if((f|0)==0){g=0;return g|0}h=(xQ(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L7}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[f>>2]=h+n;h=e;f=0;while(1){o=h-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{h=o;f=f+1|0}}h=b+40|0;if((n|0)!=0){c[h>>2]=1}n=c[h>>2]|0;c[b+52>>2]=n+f;j=i;o=e;c[h>>2]=j-o+f+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=i;g=i;return g|0}function td(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;e=d|0;f=d+16|0;g=d+32|0;h=tl(b)|0;j=b+20|0;k=xP(c[j>>2]|0)|0;do{if((k+1|0)==0|(a[k]|0)!=43){l=xP(c[j>>2]|0)|0;m=(yi(l)|0)!=0;n=m?0:l;if((n|0)==0){o=h;i=d;return o|0}if((n+1|0)==0|(a[n]|0)!=45){o=h}else{break}i=d;return o|0}}while(0);k=e|0;c[k>>2]=0;n=e+4|0;c[n>>2]=0;l=e+8|0;c[l>>2]=0;m=f|0;c[m>>2]=0;p=f+4|0;c[p>>2]=0;q=f+8|0;c[q>>2]=0;r=g|0;s=g+4|0;t=b+56|0;u=b+48|0;v=b+40|0;w=b+52|0;y=t;z=0;L8:while(1){A=(x=0,as(60,c[j>>2]|0)|0);if(x){x=0;B=51;break}C=(a[A]|0)==43?A+1|0:0;if((C|0)==0){D=(x=0,as(144,b|0)|0);if(x){x=0;B=51;break}if((D|0)==0){B=57;break}}else{D=c[u>>2]|0;E=c[j>>2]|0;L13:do{if(E>>>0<C>>>0){F=E;G=0;while(1){H=a[F]|0;if((H<<24>>24|0)==10){I=G+1|0}else if((H<<24>>24|0)==0){J=G;break L13}else{I=G}H=F+1|0;if(H>>>0<C>>>0){F=H;G=I}else{J=I;break}}}else{J=0}}while(0);c[u>>2]=J+D;G=A;F=0;while(1){H=G-1|0;if(H>>>0<E>>>0){break}if((a[H]|0)==10){break}else{G=H;F=F+1|0}}if((J|0)!=0){c[v>>2]=1}G=c[v>>2]|0;c[w>>2]=G+F;E=C;D=A;c[v>>2]=E-D+F+G;c[y>>2]=D;c[y+4>>2]=E;c[j>>2]=C}c[r>>2]=5544;c[s>>2]=5545;E=(x=0,aK(496,t|0,g|0)|0);if(x){x=0;B=51;break}D=E?8:9;do{if((z|0)==(c[q>>2]|0)){E=c[m>>2]|0;G=z-E|0;H=G>>2;L=H+1|0;if(L>>>0>1073741823>>>0){B=25;break L8}if(H>>>0>536870910>>>0){M=1073741823;B=29}else{N=G>>1;O=N>>>0<L>>>0?L:N;if((O|0)==0){P=0;Q=0}else{M=O;B=29}}if((B|0)==29){B=0;O=(x=0,as(230,M<<2|0)|0);if(x){x=0;B=51;break L8}P=O;Q=M}O=P+(H<<2)|0;if((O|0)!=0){c[O>>2]=D}O=P+(L<<2)|0;L=E;Kb(P|0,L|0,G)|0;c[m>>2]=P;c[p>>2]=O;c[q>>2]=P+(Q<<2);if((E|0)==0){R=O;break}J2(L);R=O}else{if((z|0)==0){S=0}else{c[z>>2]=D;S=c[p>>2]|0}O=S+4|0;c[p>>2]=O;R=O}}while(0);D=(x=0,as(286,b|0)|0);if(x){x=0;B=51;break}C=c[n>>2]|0;if((C|0)!=(c[l>>2]|0)){if((C|0)!=0){c[C>>2]=D}c[n>>2]=C+4;z=R;continue}F=c[k>>2]|0;A=C-F|0;C=A>>2;O=C+1|0;if(O>>>0>1073741823>>>0){B=41;break}if(C>>>0>536870910>>>0){T=1073741823;B=45}else{L=A>>1;E=L>>>0<O>>>0?O:L;if((E|0)==0){U=0;V=0}else{T=E;B=45}}if((B|0)==45){B=0;E=(x=0,as(230,T<<2|0)|0);if(x){x=0;B=51;break}U=E;V=T}E=U+(C<<2)|0;if((E|0)!=0){c[E>>2]=D}D=F;Kb(U|0,D|0,A)|0;c[k>>2]=U;c[n>>2]=U+(O<<2);c[l>>2]=U+(V<<2);if((F|0)==0){z=R;continue}J2(D);z=R}do{if((B|0)==41){x=0;ap(152,0);if(x){x=0;B=52;break}return 0}else if((B|0)==25){x=0;ap(152,0);if(x){x=0;B=52;break}return 0}else if((B|0)==57){R=(x=0,aS(44,b|0,h|0,e|0,f|0)|0);if(x){x=0;B=52;break}z=c[m>>2]|0;V=z;if((z|0)!=0){U=c[p>>2]|0;if((z|0)!=(U|0)){c[p>>2]=U+(~((U-4+(-V|0)|0)>>>2)<<2)}J2(z)}z=c[k>>2]|0;if((z|0)==0){o=R;i=d;return o|0}V=c[n>>2]|0;if((z|0)!=(V|0)){c[n>>2]=V+(~((V-4+(-z|0)|0)>>>2)<<2)}J2(z);o=R;i=d;return o|0}else if((B|0)==51){R=bQ(-1,-1)|0;W=K;X=R}}while(0);if((B|0)==52){B=bQ(-1,-1)|0;W=K;X=B}B=c[m>>2]|0;m=B;if((B|0)!=0){W=c[p>>2]|0;if((B|0)!=(W|0)){c[p>>2]=W+(~((W-4+(-m|0)|0)>>>2)<<2)}J2(B)}B=c[k>>2]|0;if((B|0)==0){be(X|0)}k=c[n>>2]|0;if((B|0)!=(k|0)){c[n>>2]=k+(~((k-4+(-B|0)|0)>>>2)<<2)}J2(B);be(X|0);return 0}function te(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yM(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yN(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yP(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function th(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yR(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function ti(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yO(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yQ(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tk(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+48|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;Kb(m|0,e|0,12)|0;e=k;n=l;o=b|0;p=d;if((a[p]&1)==0){c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2]}else{p=c[d+8>>2]|0;q=c[d+4>>2]|0;if(q>>>0>4294967279>>>0){CJ(0)}if(q>>>0<11>>>0){a[e]=q<<1;r=k+1|0}else{d=q+16&-16;s=J0(d)|0;c[k+8>>2]=s;c[k>>2]=d|1;c[k+4>>2]=q;r=s}Kb(r|0,p|0,q)|0;a[r+q|0]=0}c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];x=0;aB(6,o|0,k|0,l|0,0,0,0);if(!x){if((a[e]&1)==0){t=b|0;c[t>>2]=19888;u=b+36|0;c[u>>2]=f;v=b+40|0;c[v>>2]=g;w=b+44|0;c[w>>2]=h;i=j;return}J2(c[k+8>>2]|0);t=b|0;c[t>>2]=19888;u=b+36|0;c[u>>2]=f;v=b+40|0;c[v>>2]=g;w=b+44|0;c[w>>2]=h;i=j;return}else{x=0;j=bQ(-1,-1)|0;if((a[e]&1)==0){be(j|0)}J2(c[k+8>>2]|0);be(j|0)}}function tl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;d=i;i=i+48|0;e=d|0;f=d+16|0;g=d+32|0;h=d+40|0;j=tp(b)|0;k=b+20|0;l=xP(c[k>>2]|0)|0;do{if((l+1|0)==0|(a[l]|0)!=42){m=xP(c[k>>2]|0)|0;if(!((m+1|0)==0|(a[m]|0)!=47)){break}m=xP(c[k>>2]|0)|0;if((m+1|0)==0|(a[m]|0)!=37){n=j}else{break}i=d;return n|0}}while(0);l=e|0;c[l>>2]=0;m=e+4|0;c[m>>2]=0;o=e+8|0;c[o>>2]=0;p=f|0;c[p>>2]=0;q=f+4|0;c[q>>2]=0;r=f+8|0;c[r>>2]=0;s=b+48|0;t=b+40|0;u=b+52|0;v=b+56|0;w=v;y=g|0;z=g+4|0;A=h|0;B=h+4|0;C=0;L6:while(1){D=(x=0,as(60,c[k>>2]|0)|0);if(x){x=0;E=58;break}F=(a[D]|0)==42?D+1|0:0;do{if((F|0)==0){G=(x=0,as(60,c[k>>2]|0)|0);if(x){x=0;E=58;break L6}H=(a[G]|0)==47?G+1|0:0;if((H|0)!=0){I=c[s>>2]|0;J=c[k>>2]|0;L14:do{if(J>>>0<H>>>0){L=J;M=0;while(1){N=a[L]|0;if((N<<24>>24|0)==0){O=M;break L14}else if((N<<24>>24|0)==10){P=M+1|0}else{P=M}N=L+1|0;if(N>>>0<H>>>0){L=N;M=P}else{O=P;break}}}else{O=0}}while(0);c[s>>2]=O+I;M=G;L=0;while(1){N=M-1|0;if(N>>>0<J>>>0){break}if((a[N]|0)==10){break}else{M=N;L=L+1|0}}if((O|0)!=0){c[t>>2]=1}M=c[t>>2]|0;c[u>>2]=M+L;J=H;I=G;c[t>>2]=J-I+L+M;c[w>>2]=I;c[w+4>>2]=J;c[k>>2]=H;break}J=(x=0,as(60,c[k>>2]|0)|0);if(x){x=0;E=58;break L6}I=(a[J]|0)==37?J+1|0:0;if((I|0)==0){E=112;break L6}M=c[s>>2]|0;N=c[k>>2]|0;L31:do{if(N>>>0<I>>>0){Q=N;R=0;while(1){S=a[Q]|0;if((S<<24>>24|0)==10){T=R+1|0}else if((S<<24>>24|0)==0){U=R;break L31}else{T=R}S=Q+1|0;if(S>>>0<I>>>0){Q=S;R=T}else{U=T;break}}}else{U=0}}while(0);c[s>>2]=U+M;H=J;L=0;while(1){G=H-1|0;if(G>>>0<N>>>0){break}if((a[G]|0)==10){break}else{H=G;L=L+1|0}}if((U|0)!=0){c[t>>2]=1}H=c[t>>2]|0;c[u>>2]=H+L;N=I;M=J;c[t>>2]=N-M+L+H;c[w>>2]=M;c[w+4>>2]=N;c[k>>2]=I}else{N=c[s>>2]|0;M=c[k>>2]|0;L46:do{if(M>>>0<F>>>0){H=M;G=0;while(1){R=a[H]|0;if((R<<24>>24|0)==10){V=G+1|0}else if((R<<24>>24|0)==0){W=G;break L46}else{V=G}R=H+1|0;if(R>>>0<F>>>0){H=R;G=V}else{W=V;break}}}else{W=0}}while(0);c[s>>2]=W+N;I=D;L=0;while(1){J=I-1|0;if(J>>>0<M>>>0){break}if((a[J]|0)==10){break}else{I=J;L=L+1|0}}if((W|0)!=0){c[t>>2]=1}I=c[t>>2]|0;c[u>>2]=I+L;M=F;N=D;c[t>>2]=M-N+L+I;c[w>>2]=N;c[w+4>>2]=M;c[k>>2]=F}}while(0);c[y>>2]=5456;c[z>>2]=5457;F=(x=0,aK(496,v|0,g|0)|0);if(x){x=0;E=58;break}do{if(F){if((C|0)!=(c[r>>2]|0)){if((C|0)==0){X=0}else{c[C>>2]=10;X=c[q>>2]|0}D=X+4|0;c[q>>2]=D;Y=D;break}D=c[p>>2]|0;M=C-D|0;N=M>>2;I=N+1|0;if(I>>>0>1073741823>>>0){E=48;break L6}if(N>>>0>536870910>>>0){Z=1073741823;E=52}else{J=M>>1;G=J>>>0<I>>>0?I:J;if((G|0)==0){_=0;$=0}else{Z=G;E=52}}if((E|0)==52){E=0;G=(x=0,as(230,Z<<2|0)|0);if(x){x=0;E=58;break L6}_=G;$=Z}G=_+(N<<2)|0;if((G|0)!=0){c[G>>2]=10}G=_+(I<<2)|0;I=D;Kb(_|0,I|0,M)|0;c[p>>2]=_;c[q>>2]=G;c[r>>2]=_+($<<2);if((D|0)==0){Y=G;break}J2(I);Y=G}else{c[A>>2]=5416;c[B>>2]=5417;G=(x=0,aK(496,v|0,h|0)|0);if(x){x=0;E=58;break L6}I=(C|0)==(c[r>>2]|0);if(G){if(!I){if((C|0)==0){aa=0}else{c[C>>2]=11;aa=c[q>>2]|0}G=aa+4|0;c[q>>2]=G;Y=G;break}G=c[p>>2]|0;D=C-G|0;M=D>>2;N=M+1|0;if(N>>>0>1073741823>>>0){E=71;break L6}if(M>>>0>536870910>>>0){ab=1073741823;E=75}else{J=D>>1;H=J>>>0<N>>>0?N:J;if((H|0)==0){ac=0;ad=0}else{ab=H;E=75}}if((E|0)==75){E=0;H=(x=0,as(230,ab<<2|0)|0);if(x){x=0;E=58;break L6}ac=H;ad=ab}H=ac+(M<<2)|0;if((H|0)!=0){c[H>>2]=11}H=ac+(N<<2)|0;N=G;Kb(ac|0,N|0,D)|0;c[p>>2]=ac;c[q>>2]=H;c[r>>2]=ac+(ad<<2);if((G|0)==0){Y=H;break}J2(N);Y=H;break}else{if(!I){if((C|0)==0){ae=0}else{c[C>>2]=12;ae=c[q>>2]|0}I=ae+4|0;c[q>>2]=I;Y=I;break}I=c[p>>2]|0;H=C-I|0;N=H>>2;G=N+1|0;if(G>>>0>1073741823>>>0){E=86;break L6}if(N>>>0>536870910>>>0){af=1073741823;E=90}else{D=H>>1;M=D>>>0<G>>>0?G:D;if((M|0)==0){ag=0;ah=0}else{af=M;E=90}}if((E|0)==90){E=0;M=(x=0,as(230,af<<2|0)|0);if(x){x=0;E=58;break L6}ag=M;ah=af}M=ag+(N<<2)|0;if((M|0)!=0){c[M>>2]=12}M=ag+(G<<2)|0;G=I;Kb(ag|0,G|0,H)|0;c[p>>2]=ag;c[q>>2]=M;c[r>>2]=ag+(ah<<2);if((I|0)==0){Y=M;break}J2(G);Y=M;break}}}while(0);F=(x=0,as(248,b|0)|0);if(x){x=0;E=58;break}M=c[m>>2]|0;if((M|0)!=(c[o>>2]|0)){if((M|0)!=0){c[M>>2]=F}c[m>>2]=M+4;C=Y;continue}G=c[l>>2]|0;I=M-G|0;M=I>>2;H=M+1|0;if(H>>>0>1073741823>>>0){E=102;break}if(M>>>0>536870910>>>0){ai=1073741823;E=106}else{N=I>>1;D=N>>>0<H>>>0?H:N;if((D|0)==0){aj=0;ak=0}else{ai=D;E=106}}if((E|0)==106){E=0;D=(x=0,as(230,ai<<2|0)|0);if(x){x=0;E=58;break}aj=D;ak=ai}D=aj+(M<<2)|0;if((D|0)!=0){c[D>>2]=F}F=G;Kb(aj|0,F|0,I)|0;c[l>>2]=aj;c[m>>2]=aj+(H<<2);c[o>>2]=aj+(ak<<2);if((G|0)==0){C=Y;continue}J2(F);C=Y}do{if((E|0)==102){x=0;ap(152,0);if(x){x=0;E=59;break}return 0}else if((E|0)==48){x=0;ap(152,0);if(x){x=0;E=59;break}return 0}else if((E|0)==86){x=0;ap(152,0);if(x){x=0;E=59;break}return 0}else if((E|0)==71){x=0;ap(152,0);if(x){x=0;E=59;break}return 0}else if((E|0)==112){Y=(x=0,aS(44,b|0,j|0,e|0,f|0)|0);if(x){x=0;E=59;break}C=c[p>>2]|0;ak=C;if((C|0)!=0){aj=c[q>>2]|0;if((C|0)!=(aj|0)){c[q>>2]=aj+(~((aj-4+(-ak|0)|0)>>>2)<<2)}J2(C)}C=c[l>>2]|0;if((C|0)==0){n=Y;i=d;return n|0}ak=c[m>>2]|0;if((C|0)!=(ak|0)){c[m>>2]=ak+(~((ak-4+(-C|0)|0)>>>2)<<2)}J2(C);n=Y;i=d;return n|0}else if((E|0)==58){Y=bQ(-1,-1)|0;al=K;am=Y}}while(0);if((E|0)==59){E=bQ(-1,-1)|0;al=K;am=E}E=c[p>>2]|0;p=E;if((E|0)!=0){al=c[q>>2]|0;if((E|0)!=(al|0)){c[q>>2]=al+(~((al-4+(-p|0)|0)>>>2)<<2)}J2(E)}E=c[l>>2]|0;if((E|0)==0){be(am|0)}l=c[m>>2]|0;if((E|0)!=(l|0)){c[m>>2]=l+(~((l-4+(-E|0)|0)>>>2)<<2)}J2(E);be(am|0);return 0}function tm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=(yi(e)|0)!=0;g=f?0:e;if((g|0)==0){h=0;return h|0}f=(a[g]|0)==45?g+1|0:0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[g>>2]=i+o;i=e;g=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;g=g+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+g;j=f;n=e;c[i>>2]=j-n+g+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;h=f;return h|0}function tn(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;e=i;i=i+32|0;f=d;d=i;i=i+8|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];f=e|0;g=e+16|0;h=c[b>>2]|0;j=(c[b+4>>2]|0)-h|0;if(j>>>0>4294967279>>>0){CJ(0);return 0}if(j>>>0<11>>>0){b=j<<1&255;a[f]=b;k=f+1|0;l=b}else{b=j+16&-16;m=J0(b)|0;c[f+8>>2]=m;n=b|1;c[f>>2]=n;c[f+4>>2]=j;k=m;l=n&255}Kb(k|0,h|0,j)|0;a[k+j|0]=0;j=c[d>>2]|0;k=(c[d+4>>2]|0)-j|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(k>>>0<11>>>0){d=k<<1&255;a[g]=d;o=g+1|0;p=d}else{d=k+16&-16;h=(x=0,as(230,d|0)|0);if(x){x=0;break}c[g+8>>2]=h;n=d|1;c[g>>2]=n;c[g+4>>2]=k;o=h;p=n&255}Kb(o|0,j|0,k)|0;a[o+k|0]=0;n=f;h=l&255;if((h&1|0)==0){q=h>>>1}else{q=c[f+4>>2]|0}h=g;d=p&255;if((d&1|0)==0){r=d>>>1}else{r=c[g+4>>2]|0}L25:do{if((q|0)==(r|0)){if((l&1)==0){s=n+1|0}else{s=c[f+8>>2]|0}if((p&1)==0){t=h+1|0}else{t=c[g+8>>2]|0}if((l&1)!=0){u=(Kd(s|0,t|0,q|0)|0)==0;break}if((q|0)==0){u=1;break}else{v=t;w=s;y=q}while(1){if((a[w]|0)!=(a[v]|0)){u=0;break L25}d=y-1|0;if((d|0)==0){u=1;break}else{v=v+1|0;w=w+1|0;y=d}}}else{u=0}}while(0);if((p&1)!=0){J2(c[g+8>>2]|0)}if((l&1)==0){i=e;return u|0}J2(c[f+8>>2]|0);i=e;return u|0}}while(0);u=bQ(-1,-1)|0;if((l&1)==0){be(u|0)}J2(c[f+8>>2]|0);be(u|0);return 0}function to(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=i;i=i+40|0;h=g|0;j=g+8|0;k=g+24|0;l=e|0;m=(c[e+4>>2]|0)-(c[l>>2]|0)>>2;if((m|0)==0){n=d;i=g;return n|0}e=b|0;o=b+28|0;p=j;q=k;r=f|0;f=j+8|0;s=b+36|0;t=b+32|0;b=j+1|0;u=j|0;v=j+4|0;w=0;y=d;while(1){z=c[e>>2]|0;d=J0(48)|0;c[h>>2]=d;A=z+4|0;B=c[A>>2]|0;if((B|0)==(c[z+8>>2]|0)){ee(z|0,h);C=c[h>>2]|0}else{if((B|0)==0){D=0}else{c[B>>2]=d;D=c[A>>2]|0}c[A>>2]=D+4;C=d}E=C;if((a[o]&1)==0){c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{d=c[s>>2]|0;B=c[t>>2]|0;if(B>>>0>4294967279>>>0){F=11;break}if(B>>>0<11>>>0){a[p]=B<<1;G=b}else{H=B+16&-16;I=(x=0,as(230,H|0)|0);if(x){x=0;F=25;break}c[f>>2]=I;c[u>>2]=H|1;c[v>>2]=B;G=I}Kb(G|0,d|0,B)|0;a[G+B|0]=0}B=y+16|0;c[q>>2]=c[B>>2];c[q+4>>2]=c[B+4>>2];c[q+8>>2]=c[B+8>>2];x=0;aB(12,C|0,j|0,k|0,c[(c[r>>2]|0)+(w<<2)>>2]|0,y|0,c[(c[l>>2]|0)+(w<<2)>>2]|0);if(x){x=0;F=28;break}B=C;if((a[p]&1)!=0){J2(c[f>>2]|0)}d=c[C+40>>2]|0;do{if((c[(c[r>>2]|0)+(w<<2)>>2]|0)==11){if((a[d+28|0]&1)==0){F=35;break}if((a[(c[C+44>>2]|0)+28|0]&1)==0){F=35;break}a[C+28|0]=1}else{F=35}}while(0);if((F|0)==35){F=0;a[d+28|0]=0;a[(c[C+44>>2]|0)+28|0]=0}I=w+1|0;if(I>>>0<m>>>0){w=I;y=B}else{n=B;F=39;break}}do{if((F|0)==28){y=bQ(-1,-1)|0;w=y;y=K;if((a[p]&1)==0){J=y;L=w;break}J2(c[f>>2]|0);J=y;L=w}else if((F|0)==11){x=0;ap(232,0);if(!x){return 0}else{x=0;w=bQ(-1,-1)|0;M=K;N=w;F=27;break}}else if((F|0)==39){i=g;return n|0}else if((F|0)==25){w=bQ(-1,-1)|0;M=K;N=w;F=27}}while(0);if((F|0)==27){J=M;L=N}N=c[z>>2]|0;z=c[A>>2]|0;M=N;while(1){if((M|0)==(z|0)){O=z;break}if((c[M>>2]|0)==(C|0)){O=M;break}else{M=M+4|0}}M=O-N>>2;O=N+(M+1<<2)|0;C=z-O|0;Kc(N+(M<<2)|0,O|0,C|0)|0;O=N+((C>>2)+M<<2)|0;M=c[A>>2]|0;if((O|0)==(M|0)){J2(E);P=L;Q=0;R=P;S=J;be(R|0)}c[A>>2]=M+(~((M-4+(-O|0)|0)>>>2)<<2);J2(E);P=L;Q=0;R=P;S=J;be(R|0);return 0}function tp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0;d=i;i=i+456|0;e=d|0;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+80|0;o=d+88|0;p=d+104|0;q=d+112|0;r=d+120|0;s=d+136|0;t=d+144|0;u=d+152|0;v=d+168|0;w=d+176|0;y=d+192|0;z=d+200|0;A=d+216|0;B=d+232|0;C=d+248|0;D=d+264|0;E=d+280|0;F=d+296|0;G=d+312|0;H=d+328|0;I=d+344|0;J=d+360|0;L=d+376|0;M=d+392|0;N=d+408|0;O=d+424|0;P=d+440|0;Q=b+20|0;R=xP(c[Q>>2]|0)|0;S=(a[R]|0)==40?R+1|0:0;if((S|0)!=0){T=b+48|0;U=c[T>>2]|0;V=c[Q>>2]|0;L3:do{if(V>>>0<S>>>0){W=V;X=0;while(1){Y=a[W]|0;if((Y<<24>>24|0)==0){Z=X;break L3}else if((Y<<24>>24|0)==10){_=X+1|0}else{_=X}Y=W+1|0;if(Y>>>0<S>>>0){W=Y;X=_}else{Z=_;break}}}else{Z=0}}while(0);c[T>>2]=Z+U;U=R;_=0;while(1){X=U-1|0;if(X>>>0<V>>>0){break}if((a[X]|0)==10){break}else{U=X;_=_+1|0}}U=b+40|0;if((Z|0)!=0){c[U>>2]=1}Z=c[U>>2]|0;V=b+52|0;c[V>>2]=Z+_;X=S;W=R;c[U>>2]=X-W+_+Z;Z=b+56|0;c[Z>>2]=W;c[Z+4>>2]=X;c[Q>>2]=S;S=s6(b)|0;X=xP(c[Q>>2]|0)|0;W=(a[X]|0)==41?X+1|0:0;do{if((W|0)==0){_=J0(32)|0;R=z+8|0;c[R>>2]=_;c[z>>2]=33;c[z+4>>2]=20;Kb(_|0,5360,20)|0;a[_+20|0]=0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;x=0;aP(466,b|0,z|0,A|0);if(!x){if((a[z]&1)==0){break}J2(c[R>>2]|0);break}else{x=0}_=bQ(-1,-1)|0;Y=_;_=K;if((a[z]&1)==0){$=Y;aa=_;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}J2(c[R>>2]|0);$=Y;aa=_;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}else{_=c[T>>2]|0;Y=c[Q>>2]|0;L28:do{if(Y>>>0<W>>>0){R=Y;af=0;while(1){ag=a[R]|0;if((ag<<24>>24|0)==0){ah=af;break L28}else if((ag<<24>>24|0)==10){ai=af+1|0}else{ai=af}ag=R+1|0;if(ag>>>0<W>>>0){R=ag;af=ai}else{ah=ai;break}}}else{ah=0}}while(0);c[T>>2]=ah+_;af=X;R=0;while(1){ag=af-1|0;if(ag>>>0<Y>>>0){break}if((a[ag]|0)==10){break}else{af=ag;R=R+1|0}}if((ah|0)!=0){c[U>>2]=1}af=c[U>>2]|0;c[V>>2]=af+R;Y=W;_=X;c[U>>2]=Y-_+R+af;c[Z>>2]=_;c[Z+4>>2]=Y;c[Q>>2]=W}}while(0);a[S+28|0]=0;if((c[S+32>>2]|0)==5){W=c[S+40>>2]|0;if((W|0)==(c[S+44>>2]|0)){aj=S;i=d;return aj|0}a[(c[W>>2]|0)+28|0]=0;aj=S;i=d;return aj|0}if((S|0)==0){cg();return 0}if((c[(c[(c[S>>2]|0)-4>>2]|0)+4>>2]|0)!=26448){aj=S;i=d;return aj|0}W=c[S+40>>2]|0;if((W|0)==0){aj=S;i=d;return aj|0}if((c[W+36>>2]|0)!=11){aj=S;i=d;return aj|0}a[W+28|0]=0;aj=S;i=d;return aj|0}if((yS(xP(c[Q>>2]|0)|0)|0)!=0){aj=tq(b)|0;i=d;return aj|0}if((yU(xP(c[Q>>2]|0)|0)|0)==0){if((yw(xP(c[Q>>2]|0)|0)|0)!=0){aj=tt(b)|0;i=d;return aj|0}if((xR(xP(c[Q>>2]|0)|0)|0)!=0){aj=sA(b)|0;i=d;return aj|0}do{if((yx(xP(c[Q>>2]|0)|0)|0)!=0){if((yq(xP(c[Q>>2]|0)|0)|0)!=0){break}aj=tu(b)|0;i=d;return aj|0}}while(0);if((tv(b)|0)!=0){S=c[b>>2]|0;W=J0(44)|0;c[f>>2]=W;Z=S+4|0;U=c[Z>>2]|0;if((U|0)==(c[S+8>>2]|0)){ee(S|0,f);ak=c[f>>2]|0}else{if((U|0)==0){al=0}else{c[U>>2]=W;al=c[Z>>2]|0}c[Z>>2]=al+4;ak=W}W=ak;al=ak;U=b+28|0;L92:do{if((a[U]&1)==0){f=M;c[f>>2]=c[U>>2];c[f+4>>2]=c[U+4>>2];c[f+8>>2]=c[U+8>>2];am=302}else{f=c[b+36>>2]|0;X=c[b+32>>2]|0;do{if(X>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(X>>>0<11>>>0){a[M]=X<<1;an=M+1|0}else{V=X+16&-16;ah=(x=0,as(230,V|0)|0);if(x){x=0;break}c[M+8>>2]=ah;c[M>>2]=V|1;c[M+4>>2]=X;an=ah}Kb(an|0,f|0,X)|0;a[an+X|0]=0;am=302;break L92}}while(0);X=bQ(-1,-1)|0;ar=X;at=K}}while(0);do{if((am|0)==302){an=N;U=b+44|0;c[an>>2]=c[U>>2];c[an+4>>2]=c[U+4>>2];c[an+8>>2]=c[U+8>>2];U=(x=0,as(248,b|0)|0);do{if(!x){x=0;ao(36,al|0,M|0,N|0,0,U|0);if(x){x=0;break}an=ak;if((a[M]&1)==0){aj=an;i=d;return aj|0}J2(c[M+8>>2]|0);aj=an;i=d;return aj|0}else{x=0}}while(0);U=bQ(-1,-1)|0;an=U;U=K;if((a[M]&1)==0){ar=an;at=U;break}J2(c[M+8>>2]|0);ar=an;at=U}}while(0);M=c[S>>2]|0;S=c[Z>>2]|0;N=M;while(1){if((N|0)==(S|0)){au=S;break}if((c[N>>2]|0)==(ak|0)){au=N;break}else{N=N+4|0}}N=au-M>>2;au=M+(N+1<<2)|0;ak=S-au|0;Kc(M+(N<<2)|0,au|0,ak|0)|0;au=M+((ak>>2)+N<<2)|0;N=c[Z>>2]|0;if((au|0)!=(N|0)){c[Z>>2]=N+(~((N-4+(-au|0)|0)>>>2)<<2)}J2(W);$=ar;aa=at;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}if((tx(b)|0)==0){aj=sm(b)|0;i=d;return aj|0}at=c[b>>2]|0;ar=J0(44)|0;c[e>>2]=ar;W=at+4|0;au=c[W>>2]|0;if((au|0)==(c[at+8>>2]|0)){ee(at|0,e);av=c[e>>2]|0}else{if((au|0)==0){aw=0}else{c[au>>2]=ar;aw=c[W>>2]|0}c[W>>2]=aw+4;av=ar}ar=av;aw=av;au=b+28|0;L137:do{if((a[au]&1)==0){e=O;c[e>>2]=c[au>>2];c[e+4>>2]=c[au+4>>2];c[e+8>>2]=c[au+8>>2];am=331}else{e=c[b+36>>2]|0;N=c[b+32>>2]|0;do{if(N>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(N>>>0<11>>>0){a[O]=N<<1;ax=O+1|0}else{Z=N+16&-16;ak=(x=0,as(230,Z|0)|0);if(x){x=0;break}c[O+8>>2]=ak;c[O>>2]=Z|1;c[O+4>>2]=N;ax=ak}Kb(ax|0,e|0,N)|0;a[ax+N|0]=0;am=331;break L137}}while(0);N=bQ(-1,-1)|0;ay=N;az=K}}while(0);do{if((am|0)==331){ax=P;au=b+44|0;c[ax>>2]=c[au>>2];c[ax+4>>2]=c[au+4>>2];c[ax+8>>2]=c[au+8>>2];au=(x=0,as(248,b|0)|0);do{if(!x){x=0;ao(36,aw|0,O|0,P|0,1,au|0);if(x){x=0;break}ax=av;if((a[O]&1)==0){aj=ax;i=d;return aj|0}J2(c[O+8>>2]|0);aj=ax;i=d;return aj|0}else{x=0}}while(0);au=bQ(-1,-1)|0;ax=au;au=K;if((a[O]&1)==0){ay=ax;az=au;break}J2(c[O+8>>2]|0);ay=ax;az=au}}while(0);O=c[at>>2]|0;at=c[W>>2]|0;P=O;while(1){if((P|0)==(at|0)){aA=at;break}if((c[P>>2]|0)==(av|0)){aA=P;break}else{P=P+4|0}}P=aA-O>>2;aA=O+(P+1<<2)|0;av=at-aA|0;Kc(O+(P<<2)|0,aA|0,av|0)|0;aA=O+((av>>2)+P<<2)|0;P=c[W>>2]|0;if((aA|0)!=(P|0)){c[W>>2]=P+(~((P-4+(-aA|0)|0)>>>2)<<2)}J2(ar);$=ay;aa=az;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}az=b|0;ay=c[az>>2]|0;ar=J0(60)|0;c[y>>2]=ar;aA=ay+4|0;P=c[aA>>2]|0;if((P|0)==(c[ay+8>>2]|0)){ee(ay|0,y);aC=c[y>>2]|0}else{if((P|0)==0){aD=0}else{c[P>>2]=ar;aD=c[aA>>2]|0}c[aA>>2]=aD+4;aC=ar}ar=aC;aD=b+28|0;L178:do{if((a[aD]&1)==0){P=B;c[P>>2]=c[aD>>2];c[P+4>>2]=c[aD+4>>2];c[P+8>>2]=c[aD+8>>2];am=54}else{P=c[b+36>>2]|0;y=c[b+32>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[B]=y<<1;aE=B+1|0}else{W=y+16&-16;av=(x=0,as(230,W|0)|0);if(x){x=0;break}c[B+8>>2]=av;c[B>>2]=W|1;c[B+4>>2]=y;aE=av}Kb(aE|0,P|0,y)|0;a[aE+y|0]=0;am=54;break L178}}while(0);y=bQ(-1,-1)|0;aF=y;aG=K}}while(0);do{if((am|0)==54){aE=b+44|0;y=w;c[y>>2]=c[aE>>2];c[y+4>>2]=c[aE+4>>2];c[y+8>>2]=c[aE+8>>2];x=0;aB(2,aC|0,B|0,w|0,3,0,0);if(x){x=0;y=bQ(-1,-1)|0;P=y;y=K;if((a[B]&1)==0){aF=P;aG=y;break}J2(c[B+8>>2]|0);aF=P;aG=y;break}if((a[B]&1)!=0){J2(c[B+8>>2]|0)}L200:do{if((st(b)|0)==0){tr(b)|0;y=aC+40|0;P=y;av=c[az>>2]|0;W=J0(52)|0;c[s>>2]=W;O=av+4|0;at=c[O>>2]|0;if((at|0)==(c[av+8>>2]|0)){ee(av|0,s);aH=c[s>>2]|0}else{if((at|0)==0){aI=0}else{c[at>>2]=W;aI=c[O>>2]|0}c[O>>2]=aI+4;aH=W}W=aH;L275:do{if((a[aD]&1)==0){at=F;c[at>>2]=c[aD>>2];c[at+4>>2]=c[aD+4>>2];c[at+8>>2]=c[aD+8>>2];am=129}else{at=c[b+36>>2]|0;aw=c[b+32>>2]|0;do{if(aw>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aw>>>0<11>>>0){a[F]=aw<<1;aJ=F+1|0}else{au=aw+16&-16;ax=(x=0,as(230,au|0)|0);if(x){x=0;break}c[F+8>>2]=ax;c[F>>2]=au|1;c[F+4>>2]=aw;aJ=ax}Kb(aJ|0,at|0,aw)|0;a[aJ+aw|0]=0;am=129;break L275}}while(0);aw=bQ(-1,-1)|0;aK=K;aL=aw}}while(0);do{if((am|0)==129){aw=r;c[aw>>2]=c[aE>>2];c[aw+4>>2]=c[aE+4>>2];c[aw+8>>2]=c[aE+8>>2];x=0;ao(14,aH|0,F|0,r|0,b+56|0,0);do{if(!x){aw=aH;c[q>>2]=aw;at=y+8|0;ax=c[at>>2]|0;au=ax;if((ax|0)==(c[y+12>>2]|0)){x=0;aq(370,y+4|0,q|0);if(x){x=0;aM=0;break}aN=c[q>>2]|0}else{if((ax|0)==0){aO=0}else{c[au>>2]=aw;aO=c[at>>2]|0}c[at>>2]=aO+4;aN=aw}x=0;aq(c[c[y>>2]>>2]|0,P|0,aN|0);if(x){x=0;aM=0;break}if((a[F]&1)==0){break L200}J2(c[F+8>>2]|0);break L200}else{x=0;aM=1}}while(0);aw=bQ(-1,-1)|0;at=aw;aw=K;if((a[F]&1)==0){if(aM){aK=aw;aL=at;break}else{$=at;aa=aw}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}else{J2(c[F+8>>2]|0);if(aM){aK=aw;aL=at;break}else{$=at;aa=aw}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}}}while(0);P=c[av>>2]|0;y=c[O>>2]|0;aw=P;while(1){if((aw|0)==(y|0)){aQ=y;break}if((c[aw>>2]|0)==(aH|0)){aQ=aw;break}else{aw=aw+4|0}}aw=aQ-P>>2;av=P+(aw+1<<2)|0;at=y-av|0;Kc(P+(aw<<2)|0,av|0,at|0)|0;av=P+((at>>2)+aw<<2)|0;aw=c[O>>2]|0;if((av|0)!=(aw|0)){c[O>>2]=aw+(~((aw-4+(-av|0)|0)>>>2)<<2)}J2(W);$=aL;aa=aK;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}else{av=aC+40|0;aw=av;at=c[az>>2]|0;au=J0(48)|0;c[v>>2]=au;ax=at+4|0;N=c[ax>>2]|0;if((N|0)==(c[at+8>>2]|0)){ee(at|0,v);aR=c[v>>2]|0}else{if((N|0)==0){aS=0}else{c[N>>2]=au;aS=c[ax>>2]|0}c[ax>>2]=aS+4;aR=au}au=aR;N=aR;L209:do{if((a[aD]&1)==0){e=C;c[e>>2]=c[aD>>2];c[e+4>>2]=c[aD+4>>2];c[e+8>>2]=c[aD+8>>2];am=73}else{e=c[b+36>>2]|0;ak=c[b+32>>2]|0;do{if(ak>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ak>>>0<11>>>0){a[C]=ak<<1;aU=C+1|0}else{Z=ak+16&-16;M=(x=0,as(230,Z|0)|0);if(x){x=0;break}c[C+8>>2]=M;c[C>>2]=Z|1;c[C+4>>2]=ak;aU=M}Kb(aU|0,e|0,ak)|0;a[aU+ak|0]=0;am=73;break L209}}while(0);ak=bQ(-1,-1)|0;aV=K;aW=ak}}while(0);do{if((am|0)==73){W=D;c[W>>2]=c[aE>>2];c[W+4>>2]=c[aE+4>>2];c[W+8>>2]=c[aE+8>>2];O=c[b+56>>2]|0;P=(c[b+60>>2]|0)-O|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;am=102;break}return 0}else{if(P>>>0<11>>>0){a[E]=P<<1;aX=E+1|0}else{y=P+16&-16;ak=(x=0,as(230,y|0)|0);if(x){x=0;am=102;break}c[E+8>>2]=ak;c[E>>2]=y|1;c[E+4>>2]=P;aX=ak}Kb(aX|0,O|0,P)|0;a[aX+P|0]=0;ak=u;c[ak>>2]=c[W>>2];c[ak+4>>2]=c[W+4>>2];c[ak+8>>2]=c[W+8>>2];x=0;aT(2,N|0,C|0,u|0,E|0);do{if(!x){ak=aR;c[t>>2]=ak;y=av+8|0;e=c[y>>2]|0;M=e;if((e|0)==(c[av+12>>2]|0)){x=0;aq(370,av+4|0,t|0);if(x){x=0;aY=0;break}aZ=c[t>>2]|0}else{if((e|0)==0){a_=0}else{c[M>>2]=ak;a_=c[y>>2]|0}c[y>>2]=a_+4;aZ=ak}x=0;aq(c[c[av>>2]>>2]|0,aw|0,aZ|0);if(x){x=0;aY=0;break}if((a[E]&1)!=0){J2(c[E+8>>2]|0)}if((a[C]&1)==0){break L200}J2(c[C+8>>2]|0);break L200}else{x=0;aY=1}}while(0);ak=bQ(-1,-1)|0;y=ak;ak=K;if((a[E]&1)==0){a$=aY;a0=y;a1=ak;break}J2(c[E+8>>2]|0);a$=aY;a0=y;a1=ak}}while(0);if((am|0)==102){W=bQ(-1,-1)|0;a$=1;a0=W;a1=K}if((a[C]&1)==0){if(a$){aV=a1;aW=a0;break}else{$=a0;aa=a1}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}else{J2(c[C+8>>2]|0);if(a$){aV=a1;aW=a0;break}else{$=a0;aa=a1}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}}}while(0);aw=c[at>>2]|0;av=c[ax>>2]|0;N=aw;while(1){if((N|0)==(av|0)){a2=av;break}if((c[N>>2]|0)==(aR|0)){a2=N;break}else{N=N+4|0}}N=a2-aw>>2;at=aw+(N+1<<2)|0;W=av-at|0;Kc(aw+(N<<2)|0,at|0,W|0)|0;at=aw+((W>>2)+N<<2)|0;N=c[ax>>2]|0;if((at|0)!=(N|0)){c[ax>>2]=N+(~((N-4+(-at|0)|0)>>>2)<<2)}J2(au);$=aW;aa=aV;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}}while(0);at=xP(c[Q>>2]|0)|0;N=(a[at]|0)==61?at+1|0:0;if((N|0)!=0){W=b+48|0;P=c[W>>2]|0;O=c[Q>>2]|0;L320:do{if(O>>>0<N>>>0){ak=O;y=0;while(1){M=a[ak]|0;if((M<<24>>24|0)==10){a3=y+1|0}else if((M<<24>>24|0)==0){a4=y;break L320}else{a3=y}M=ak+1|0;if(M>>>0<N>>>0){ak=M;y=a3}else{a4=a3;break}}}else{a4=0}}while(0);c[W>>2]=a4+P;y=at;ak=0;while(1){au=y-1|0;if(au>>>0<O>>>0){break}if((a[au]|0)==10){break}else{y=au;ak=ak+1|0}}y=b+40|0;if((a4|0)!=0){c[y>>2]=1}O=c[y>>2]|0;c[b+52>>2]=O+ak;P=N;W=at;c[y>>2]=P-W+ak+O;O=b+56|0;c[O>>2]=W;c[O+4>>2]=P;c[Q>>2]=N}P=aC+40|0;O=P;W=c[az>>2]|0;y=J0(52)|0;c[p>>2]=y;au=W+4|0;ax=c[au>>2]|0;if((ax|0)==(c[W+8>>2]|0)){ee(W|0,p);a5=c[p>>2]|0}else{if((ax|0)==0){a6=0}else{c[ax>>2]=y;a6=c[au>>2]|0}c[au>>2]=a6+4;a5=y}y=a5;L342:do{if((a[aD]&1)==0){ax=G;c[ax>>2]=c[aD>>2];c[ax+4>>2]=c[aD+4>>2];c[ax+8>>2]=c[aD+8>>2];am=175}else{ax=c[b+36>>2]|0;aw=c[b+32>>2]|0;do{if(aw>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aw>>>0<11>>>0){a[G]=aw<<1;a7=G+1|0}else{av=aw+16&-16;M=(x=0,as(230,av|0)|0);if(x){x=0;break}c[G+8>>2]=M;c[G>>2]=av|1;c[G+4>>2]=aw;a7=M}Kb(a7|0,ax|0,aw)|0;a[a7+aw|0]=0;am=175;break L342}}while(0);aw=bQ(-1,-1)|0;a8=K;a9=aw}}while(0);do{if((am|0)==175){N=o;c[N>>2]=c[aE>>2];c[N+4>>2]=c[aE+4>>2];c[N+8>>2]=c[aE+8>>2];N=b+56|0;x=0;ao(14,a5|0,G|0,o|0,N|0,0);do{if(!x){ak=a5;c[n>>2]=ak;at=P+8|0;aw=c[at>>2]|0;ax=aw;M=P+12|0;if((aw|0)==(c[M>>2]|0)){x=0;aq(370,P+4|0,n|0);if(x){x=0;ba=0;break}bb=c[n>>2]|0}else{if((aw|0)==0){bc=0}else{c[ax>>2]=ak;bc=c[at>>2]|0}c[at>>2]=bc+4;bb=ak}x=0;aq(c[c[P>>2]>>2]|0,O|0,bb|0);if(x){x=0;ba=0;break}if((a[G]&1)!=0){J2(c[G+8>>2]|0)}L371:do{if((st(b)|0)==0){ts(b)|0;ak=c[az>>2]|0;ax=J0(52)|0;c[j>>2]=ax;aw=ak+4|0;av=c[aw>>2]|0;if((av|0)==(c[ak+8>>2]|0)){ee(ak|0,j);bd=c[j>>2]|0}else{if((av|0)==0){bf=0}else{c[av>>2]=ax;bf=c[aw>>2]|0}c[aw>>2]=bf+4;bd=ax}ax=bd;L380:do{if((a[aD]&1)==0){av=L;c[av>>2]=c[aD>>2];c[av+4>>2]=c[aD+4>>2];c[av+8>>2]=c[aD+8>>2];am=258}else{av=c[b+36>>2]|0;e=c[b+32>>2]|0;do{if(e>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(e>>>0<11>>>0){a[L]=e<<1;bg=L+1|0}else{Z=e+16&-16;S=(x=0,as(230,Z|0)|0);if(x){x=0;break}c[L+8>>2]=S;c[L>>2]=Z|1;c[L+4>>2]=e;bg=S}Kb(bg|0,av|0,e)|0;a[bg+e|0]=0;am=258;break L380}}while(0);e=bQ(-1,-1)|0;bh=K;bi=e}}while(0);do{if((am|0)==258){e=h;c[e>>2]=c[aE>>2];c[e+4>>2]=c[aE+4>>2];c[e+8>>2]=c[aE+8>>2];x=0;ao(14,bd|0,L|0,h|0,N|0,0);do{if(!x){e=bd;c[g>>2]=e;av=c[at>>2]|0;S=av;if((av|0)==(c[M>>2]|0)){x=0;aq(370,P+4|0,g|0);if(x){x=0;bj=0;break}bk=c[g>>2]|0}else{if((av|0)==0){bl=0}else{c[S>>2]=e;bl=c[at>>2]|0}c[at>>2]=bl+4;bk=e}x=0;aq(c[c[P>>2]>>2]|0,O|0,bk|0);if(x){x=0;bj=0;break}if((a[L]&1)==0){break L371}J2(c[L+8>>2]|0);break L371}else{x=0;bj=1}}while(0);e=bQ(-1,-1)|0;S=e;e=K;if((a[L]&1)==0){if(bj){bh=e;bi=S;break}else{$=S;aa=e}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}else{J2(c[L+8>>2]|0);if(bj){bh=e;bi=S;break}else{$=S;aa=e}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}}}while(0);e=c[ak>>2]|0;S=c[aw>>2]|0;av=e;while(1){if((av|0)==(S|0)){bm=S;break}if((c[av>>2]|0)==(bd|0)){bm=av;break}else{av=av+4|0}}av=bm-e>>2;ak=e+(av+1<<2)|0;Z=S-ak|0;Kc(e+(av<<2)|0,ak|0,Z|0)|0;ak=e+((Z>>2)+av<<2)|0;av=c[aw>>2]|0;if((ak|0)!=(av|0)){c[aw>>2]=av+(~((av-4+(-ak|0)|0)>>>2)<<2)}J2(ax);$=bi;aa=bh;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}else{ak=c[az>>2]|0;av=J0(48)|0;c[m>>2]=av;Z=ak+4|0;al=c[Z>>2]|0;if((al|0)==(c[ak+8>>2]|0)){ee(ak|0,m);bn=c[m>>2]|0}else{if((al|0)==0){bo=0}else{c[al>>2]=av;bo=c[Z>>2]|0}c[Z>>2]=bo+4;bn=av}av=bn;al=bn;L430:do{if((a[aD]&1)==0){U=H;c[U>>2]=c[aD>>2];c[U+4>>2]=c[aD+4>>2];c[U+8>>2]=c[aD+8>>2];am=201}else{U=c[b+36>>2]|0;an=c[b+32>>2]|0;do{if(an>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(an>>>0<11>>>0){a[H]=an<<1;bp=H+1|0}else{X=an+16&-16;f=(x=0,as(230,X|0)|0);if(x){x=0;break}c[H+8>>2]=f;c[H>>2]=X|1;c[H+4>>2]=an;bp=f}Kb(bp|0,U|0,an)|0;a[bp+an|0]=0;am=201;break L430}}while(0);an=bQ(-1,-1)|0;bq=K;br=an}}while(0);do{if((am|0)==201){ax=I;c[ax>>2]=c[aE>>2];c[ax+4>>2]=c[aE+4>>2];c[ax+8>>2]=c[aE+8>>2];aw=c[N>>2]|0;e=(c[b+60>>2]|0)-aw|0;do{if(e>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;am=231;break}return 0}else{if(e>>>0<11>>>0){a[J]=e<<1;bs=J+1|0}else{S=e+16&-16;an=(x=0,as(230,S|0)|0);if(x){x=0;am=231;break}c[J+8>>2]=an;c[J>>2]=S|1;c[J+4>>2]=e;bs=an}Kb(bs|0,aw|0,e)|0;a[bs+e|0]=0;an=l;c[an>>2]=c[ax>>2];c[an+4>>2]=c[ax+4>>2];c[an+8>>2]=c[ax+8>>2];x=0;aT(2,al|0,H|0,l|0,J|0);do{if(!x){an=bn;c[k>>2]=an;S=c[at>>2]|0;U=S;if((S|0)==(c[M>>2]|0)){x=0;aq(370,P+4|0,k|0);if(x){x=0;bt=0;break}bu=c[k>>2]|0}else{if((S|0)==0){bv=0}else{c[U>>2]=an;bv=c[at>>2]|0}c[at>>2]=bv+4;bu=an}x=0;aq(c[c[P>>2]>>2]|0,O|0,bu|0);if(x){x=0;bt=0;break}if((a[J]&1)!=0){J2(c[J+8>>2]|0)}if((a[H]&1)==0){break L371}J2(c[H+8>>2]|0);break L371}else{x=0;bt=1}}while(0);an=bQ(-1,-1)|0;U=an;an=K;if((a[J]&1)==0){bw=bt;bx=U;by=an;break}J2(c[J+8>>2]|0);bw=bt;bx=U;by=an}}while(0);if((am|0)==231){ax=bQ(-1,-1)|0;bw=1;bx=ax;by=K}if((a[H]&1)==0){if(bw){bq=by;br=bx;break}else{$=bx;aa=by}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}else{J2(c[H+8>>2]|0);if(bw){bq=by;br=bx;break}else{$=bx;aa=by}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}}}while(0);al=c[ak>>2]|0;ax=c[Z>>2]|0;e=al;while(1){if((e|0)==(ax|0)){bz=ax;break}if((c[e>>2]|0)==(bn|0)){bz=e;break}else{e=e+4|0}}e=bz-al>>2;ak=al+(e+1<<2)|0;aw=ax-ak|0;Kc(al+(e<<2)|0,ak|0,aw|0)|0;ak=al+((aw>>2)+e<<2)|0;e=c[Z>>2]|0;if((ak|0)!=(e|0)){c[Z>>2]=e+(~((e-4+(-ak|0)|0)>>>2)<<2)}J2(av);$=br;aa=bq;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}}while(0);aj=aC;i=d;return aj|0}else{x=0;ba=1}}while(0);N=bQ(-1,-1)|0;at=N;N=K;if((a[G]&1)==0){if(ba){a8=N;a9=at;break}else{$=at;aa=N}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}else{J2(c[G+8>>2]|0);if(ba){a8=N;a9=at;break}else{$=at;aa=N}ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}}}while(0);O=c[W>>2]|0;P=c[au>>2]|0;aE=O;while(1){if((aE|0)==(P|0)){bA=P;break}if((c[aE>>2]|0)==(a5|0)){bA=aE;break}else{aE=aE+4|0}}aE=bA-O>>2;W=O+(aE+1<<2)|0;N=P-W|0;Kc(O+(aE<<2)|0,W|0,N|0)|0;W=O+((N>>2)+aE<<2)|0;aE=c[au>>2]|0;if((W|0)!=(aE|0)){c[au>>2]=aE+(~((aE-4+(-W|0)|0)>>>2)<<2)}J2(y);$=a9;aa=a8;ab=$;ac=0;ad=ab;ae=aa;be(ad|0)}}while(0);a8=c[ay>>2]|0;ay=c[aA>>2]|0;a9=a8;while(1){if((a9|0)==(ay|0)){bB=ay;break}if((c[a9>>2]|0)==(aC|0)){bB=a9;break}else{a9=a9+4|0}}a9=bB-a8>>2;bB=a8+(a9+1<<2)|0;aC=ay-bB|0;Kc(a8+(a9<<2)|0,bB|0,aC|0)|0;bB=a8+((aC>>2)+a9<<2)|0;a9=c[aA>>2]|0;if((bB|0)!=(a9|0)){c[aA>>2]=a9+(~((a9-4+(-bB|0)|0)>>>2)<<2)}J2(ar);$=aF;aa=aG;ab=$;ac=0;ad=ab;ae=aa;be(ad|0);return 0}function tq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0;d=i;i=i+128|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+40|0;k=d+48|0;l=d+64|0;m=d+72|0;n=d+88|0;o=d+96|0;p=d+112|0;q=d+120|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+8|0;w=i;i=i+64|0;y=i;i=i+8|0;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+8|0;tM(b)|0;G=b+56|0;H=c[G>>2]|0;I=c[G+4>>2]|0;c[q>>2]=H;c[q+4>>2]=I;q=I-1|0;c[r+4>>2]=q;I=b+20|0;c[I>>2]=(c[I>>2]|0)-1;I=H;H=I;L1:do{if(H>>>0<q>>>0){G=a[35720]|0;J=G<<24>>24==0;L3:do{if(J){L=H;while(1){M=a[L]|0;if(M<<24>>24==0){N=12;break L1}O=L+1|0;if(!(M<<24>>24==92&(O|0)!=0|(L|0)==0)){P=L;break L3}if(O>>>0<q>>>0){L=O}else{N=12;break L1}}}else{L=H;while(1){O=a[L]|0;if(O<<24>>24==0){N=12;break L1}M=L+1|0;Q=O<<24>>24==92&(M|0)!=0?0:L;if((Q|0)!=0){O=Q;Q=35720;R=G;while(1){if((a[O]|0)!=R<<24>>24){S=O;T=R;break}U=O+1|0;V=Q+1|0;W=a[V]|0;if(W<<24>>24==0){S=U;T=0;break}else{O=U;Q=V;R=W}}if(!(T<<24>>24!=0|(S|0)==0)){P=L;break L3}}if(M>>>0<q>>>0){L=M}else{N=12;break L1}}}}while(0);L=b|0;R=c[L>>2]|0;if((P|0)==0){X=R;break}Q=J0(60)|0;c[n>>2]=Q;O=R+4|0;W=c[O>>2]|0;if((W|0)==(c[R+8>>2]|0)){ee(R|0,n);Y=c[n>>2]|0}else{if((W|0)==0){Z=0}else{c[W>>2]=Q;Z=c[O>>2]|0}c[O>>2]=Z+4;Y=Q}Q=Y;W=b+28|0;L26:do{if((a[W]&1)==0){V=t;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];N=57}else{V=c[b+36>>2]|0;U=c[b+32>>2]|0;do{if(U>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(U>>>0<11>>>0){a[t]=U<<1;_=t+1|0}else{$=U+16&-16;aa=(x=0,as(230,$|0)|0);if(x){x=0;break}c[t+8>>2]=aa;c[t>>2]=$|1;c[t+4>>2]=U;_=aa}Kb(_|0,V|0,U)|0;a[_+U|0]=0;N=57;break L26}}while(0);U=bQ(-1,-1)|0;ab=K;ac=U}}while(0);do{if((N|0)==57){U=b+44|0;V=m;c[V>>2]=c[U>>2];c[V+4>>2]=c[U+4>>2];c[V+8>>2]=c[U+8>>2];x=0;aB(2,Y|0,t|0,m|0,0,0,0);if(x){x=0;V=bQ(-1,-1)|0;aa=V;V=K;if((a[t]&1)==0){ab=V;ac=aa;break}J2(c[t+8>>2]|0);ab=V;ac=aa;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}aa=Y+40|0;V=aa;$=u;ad=v|0;ae=v+4|0;af=aa+8|0;ag=aa+12|0;ah=aa+4|0;ai=u+8|0;aj=b+36|0;ak=b+32|0;al=u+1|0;am=u|0;an=u+4|0;ar=a[35456]|0;at=ar<<24>>24==0;au=C;av=C+1|0;aw=B;ay=B+1|0;az=D|0;aA=D+4|0;aC=D+8|0;aD=C+8|0;aE=B+8|0;aF=B|0;aG=B+4|0;aH=C+4|0;aI=C|0;aJ=y|0;aK=y+4|0;aL=z;aM=A;aN=w+28|0;aO=w+4|0;aQ=z+8|0;aR=w+8|0;aS=w+36|0;aT=z+1|0;aU=z|0;aV=z+4|0;aW=H;L48:while(1){L50:while(1){L52:do{if(J){aX=aW;while(1){aY=a[aX]|0;if(aY<<24>>24==0){N=192;break L48}aZ=aX+1|0;if(!(aY<<24>>24==92&(aZ|0)!=0|(aX|0)==0)){a_=aX;break L52}if(aZ>>>0<q>>>0){aX=aZ}else{N=192;break L48}}}else{aX=aW;while(1){aZ=a[aX]|0;if(aZ<<24>>24==0){N=192;break L48}aY=aX+1|0;a$=aZ<<24>>24==92&(aY|0)!=0?0:aX;if((a$|0)!=0){aZ=a$;a$=35720;a0=G;while(1){if((a[aZ]|0)!=a0<<24>>24){a1=aZ;a2=a0;break}a3=aZ+1|0;a4=a$+1|0;a5=a[a4]|0;if(a5<<24>>24==0){a1=a3;a2=0;break}else{aZ=a3;a$=a4;a0=a5}}if(!(a2<<24>>24!=0|(a1|0)==0)){a_=aX;break L52}}if(aY>>>0<q>>>0){aX=aY}else{N=192;break L48}}}}while(0);if((a_|0)==0){N=192;break L48}do{if(aW>>>0<a_>>>0){a6=c[L>>2]|0;aX=J0(52)|0;c[l>>2]=aX;a7=a6+4|0;a0=c[a7>>2]|0;if((a0|0)==(c[a6+8>>2]|0)){ee(a6|0,l);a8=c[l>>2]|0}else{if((a0|0)==0){a9=0}else{c[a0>>2]=aX;a9=c[a7>>2]|0}c[a7>>2]=a9+4;a8=aX}ba=a8;aX=a8;if((a[W]&1)==0){c[$>>2]=c[W>>2];c[$+4>>2]=c[W+4>>2];c[$+8>>2]=c[W+8>>2]}else{a0=c[aj>>2]|0;a$=c[ak>>2]|0;if(a$>>>0>4294967279>>>0){N=82;break L48}if(a$>>>0<11>>>0){a[$]=a$<<1;bb=al}else{aZ=a$+16&-16;a5=(x=0,as(230,aZ|0)|0);if(x){x=0;N=108;break L48}c[ai>>2]=a5;c[am>>2]=aZ|1;c[an>>2]=a$;bb=a5}Kb(bb|0,a0|0,a$)|0;a[bb+a$|0]=0}a$=k;c[a$>>2]=c[U>>2];c[a$+4>>2]=c[U+4>>2];c[a$+8>>2]=c[U+8>>2];c[ad>>2]=aW;c[ae>>2]=a_;x=0;ao(14,aX|0,u|0,k|0,v|0,0);if(x){x=0;bc=1;N=111;break L48}aX=a8;c[j>>2]=aX;a$=c[af>>2]|0;a0=a$;if((a$|0)==(c[ag>>2]|0)){x=0;aq(370,ah|0,j|0);if(x){x=0;bc=0;N=111;break L48}bd=c[j>>2]|0}else{if((a$|0)==0){bf=0}else{c[a0>>2]=aX;bf=c[af>>2]|0}c[af>>2]=bf+4;bd=aX}x=0;aq(c[c[aa>>2]>>2]|0,V|0,bd|0);if(x){x=0;bc=0;N=111;break L48}if((a[$]&1)==0){break}J2(c[ai>>2]|0)}}while(0);L99:do{if(at){aX=a_;while(1){if(aX>>>0>=q>>>0){break L99}if((a[aX]|0)==0){break L99}if((aX|0)==0){aX=aX+1|0}else{bg=aX;break L50}}}else{aX=a_;while(1){if(aX>>>0>=q>>>0){break L99}a0=a[aX]|0;if(a0<<24>>24==0){break L99}L108:do{if(a0<<24>>24==ar<<24>>24){a$=35456;a5=aX;while(1){aZ=a5+1|0;a4=a$+1|0;a3=a[a4]|0;if(a3<<24>>24==0){bh=aZ;bi=0;break L108}if((a[aZ]|0)==a3<<24>>24){a$=a4;a5=aZ}else{bh=aZ;bi=a3;break}}}else{bh=aX;bi=ar}}while(0);if(bi<<24>>24!=0|(bh|0)==0){aX=aX+1|0}else{break}}if((aX|0)!=0){bg=aX;break L50}}}while(0);a0=q-I|0;if(a0>>>0>4294967279>>>0){N=165;break L48}if(a0>>>0<11>>>0){aY=a0<<1&255;a[au]=aY;bj=av;bk=aY}else{aY=a0+16&-16;a5=J0(aY)|0;c[aD>>2]=a5;a$=aY|1;c[aI>>2]=a$;c[aH>>2]=a0;bj=a5;bk=a$&255}Kb(bj|0,H|0,a0)|0;a[bj+a0|0]=0;Ke(aw|0,0,12)|0;a0=bk&255;a$=(a0&1|0)==0?a0>>>1:c[aH>>2]|0;a0=a$+44|0;if(a0>>>0>4294967279>>>0){N=170;break L48}if(a0>>>0<11>>>0){a[aw]=88;bl=ay}else{a0=a$+60&-16;a5=(x=0,as(230,a0|0)|0);if(x){x=0;N=177;break L48}c[aE>>2]=a5;c[aF>>2]=a0|1;c[aG>>2]=44;bl=a5}Kb(bl|0,4608,44)|0;a[bl+44|0]=0;x=0,ax(64,B|0,((bk&1)==0?av:c[aD>>2]|0)|0,a$|0)|0;if(x){x=0;N=177;break L48}c[az>>2]=0;c[aA>>2]=0;c[aC>>2]=0;x=0;aP(466,b|0,B|0,D|0);if(x){x=0;N=188;break L48}if((a[aw]&1)!=0){J2(c[aE>>2]|0)}if((a[au]&1)!=0){J2(c[aD>>2]|0)}if(aW>>>0>=q>>>0){bm=Q;N=232;break L48}}c[aJ>>2]=a_+2;c[aK>>2]=bg;M=c[L>>2]|0;if((a[W]&1)==0){c[aL>>2]=c[W>>2];c[aL+4>>2]=c[W+4>>2];c[aL+8>>2]=c[W+8>>2]}else{a$=c[aj>>2]|0;a5=c[ak>>2]|0;if(a5>>>0>4294967279>>>0){N=134;break}if(a5>>>0<11>>>0){a[aL]=a5<<1;bn=aT}else{a0=a5+16&-16;aY=J0(a0)|0;c[aQ>>2]=aY;c[aU>>2]=a0|1;c[aV>>2]=a5;bn=aY}Kb(bn|0,a$|0,a5)|0;a[bn+a5|0]=0}c[aM>>2]=c[U>>2];c[aM+4>>2]=c[U+4>>2];c[aM+8>>2]=c[U+8>>2];x=0;ao(16,w|0,y|0,M|0,z|0,A|0);if(x){x=0;N=155;break}M=(x=0,as(158,w|0)|0);if(x){x=0;N=156;break}if((a[aN]&1)!=0){J2(c[aS>>2]|0)}a5=c[aO>>2]|0;a$=a5;if((a5|0)!=0){aY=c[aR>>2]|0;if((a5|0)!=(aY|0)){c[aR>>2]=aY+(~((aY-4+(-a$|0)|0)>>>2)<<2)}J2(a5)}if((a[aL]&1)!=0){J2(c[aQ>>2]|0)}a[M+29|0]=1;c[h>>2]=M;a5=c[af>>2]|0;a$=a5;if((a5|0)==(c[ag>>2]|0)){eq(ah,h);bo=c[h>>2]|0}else{if((a5|0)==0){bp=0}else{c[a$>>2]=M;bp=c[af>>2]|0}c[af>>2]=bp+4;bo=M}cy[c[c[aa>>2]>>2]&1023](V,bo);M=bg+1|0;if(M>>>0<q>>>0){aW=M}else{bm=Q;N=231;break}}do{if((N|0)==82){x=0;ap(232,0);if(!x){return 0}else{x=0;aM=bQ(-1,-1)|0;bq=K;br=aM;N=110;break}}else if((N|0)==108){aM=bQ(-1,-1)|0;bq=K;br=aM;N=110}else if((N|0)==111){aM=bQ(-1,-1)|0;aV=aM;aM=K;if((a[$]&1)==0){if(bc){bs=aV;bt=aM;break}else{bu=aM;bv=aV}bw=bv;bx=0;by=bw;bz=bu;be(by|0)}else{J2(c[ai>>2]|0);if(bc){bs=aV;bt=aM;break}else{bu=aM;bv=aV}bw=bv;bx=0;by=bw;bz=bu;be(by|0)}}else if((N|0)==134){CJ(0);return 0}else if((N|0)==155){aV=bQ(-1,-1)|0;bA=K;bB=aV;N=162}else if((N|0)==156){aV=bQ(-1,-1)|0;aM=aV;aV=K;if((a[aN]&1)!=0){J2(c[aS>>2]|0)}aU=c[aO>>2]|0;if((aU|0)==0){bA=aV;bB=aM;N=162;break}aT=c[aR>>2]|0;if((aU|0)!=(aT|0)){c[aR>>2]=aT+(~((aT-4+(-aU|0)|0)>>>2)<<2)}J2(aU);bA=aV;bB=aM;N=162}else if((N|0)==165){CJ(0);return 0}else if((N|0)==170){x=0;ap(232,0);if(!x){return 0}else{x=0;aM=bQ(-1,-1)|0;bC=K;bD=aM;N=179;break}}else if((N|0)==177){aM=bQ(-1,-1)|0;bC=K;bD=aM;N=179}else if((N|0)==188){aM=bQ(-1,-1)|0;aV=aM;aM=K;if((a[aw]&1)==0){bE=aM;bF=aV;N=190;break}J2(c[aE>>2]|0);bE=aM;bF=aV;N=190}else if((N|0)==192){if(aW>>>0>=q>>>0){bm=Q;bG=bm;i=d;return bG|0}aV=c[L>>2]|0;aM=J0(52)|0;c[g>>2]=aM;aU=aV+4|0;aT=c[aU>>2]|0;if((aT|0)==(c[aV+8>>2]|0)){ee(aV|0,g);bH=c[g>>2]|0}else{if((aT|0)==0){bI=0}else{c[aT>>2]=aM;bI=c[aU>>2]|0}c[aU>>2]=bI+4;bH=aM}aM=bH;aT=bH;L206:do{if((a[W]&1)==0){aK=E;c[aK>>2]=c[W>>2];c[aK+4>>2]=c[W+4>>2];c[aK+8>>2]=c[W+8>>2];N=208}else{aK=c[aj>>2]|0;aJ=c[ak>>2]|0;do{if(aJ>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aJ>>>0<11>>>0){a[E]=aJ<<1;bJ=E+1|0}else{aC=aJ+16&-16;aA=(x=0,as(230,aC|0)|0);if(x){x=0;break}c[E+8>>2]=aA;c[E>>2]=aC|1;c[E+4>>2]=aJ;bJ=aA}Kb(bJ|0,aK|0,aJ)|0;a[bJ+aJ|0]=0;N=208;break L206}}while(0);aJ=bQ(-1,-1)|0;bK=aJ;bL=K}}while(0);do{if((N|0)==208){aJ=f;c[aJ>>2]=c[U>>2];c[aJ+4>>2]=c[U+4>>2];c[aJ+8>>2]=c[U+8>>2];c[F>>2]=aW;c[F+4>>2]=q;x=0;ao(14,aT|0,E|0,f|0,F|0,0);do{if(!x){aJ=bH;c[e>>2]=aJ;aK=c[af>>2]|0;aA=aK;if((aK|0)==(c[ag>>2]|0)){x=0;aq(370,ah|0,e|0);if(x){x=0;bM=0;break}bN=c[e>>2]|0}else{if((aK|0)==0){bO=0}else{c[aA>>2]=aJ;bO=c[af>>2]|0}c[af>>2]=bO+4;bN=aJ}x=0;aq(c[c[aa>>2]>>2]|0,V|0,bN|0);if(x){x=0;bM=0;break}if((a[E]&1)==0){bm=Q;bG=bm;i=d;return bG|0}J2(c[E+8>>2]|0);bm=Q;bG=bm;i=d;return bG|0}else{x=0;bM=1}}while(0);aJ=bQ(-1,-1)|0;aA=aJ;aJ=K;if((a[E]&1)==0){if(bM){bK=aA;bL=aJ;break}else{bu=aJ;bv=aA}bw=bv;bx=0;by=bw;bz=bu;be(by|0)}else{J2(c[E+8>>2]|0);if(bM){bK=aA;bL=aJ;break}else{bu=aJ;bv=aA}bw=bv;bx=0;by=bw;bz=bu;be(by|0)}}}while(0);aT=c[aV>>2]|0;aA=c[aU>>2]|0;aJ=aT;while(1){if((aJ|0)==(aA|0)){bP=aA;break}if((c[aJ>>2]|0)==(bH|0)){bP=aJ;break}else{aJ=aJ+4|0}}aJ=bP-aT>>2;aV=aT+(aJ+1<<2)|0;aK=aA-aV|0;Kc(aT+(aJ<<2)|0,aV|0,aK|0)|0;aV=aT+((aK>>2)+aJ<<2)|0;aJ=c[aU>>2]|0;if((aV|0)!=(aJ|0)){c[aU>>2]=aJ+(~((aJ-4+(-aV|0)|0)>>>2)<<2)}J2(aM);bu=bL;bv=bK;bw=bv;bx=0;by=bw;bz=bu;be(by|0)}else if((N|0)==231){bG=bm;i=d;return bG|0}else if((N|0)==232){bG=bm;i=d;return bG|0}}while(0);if((N|0)==110){bs=br;bt=bq}else if((N|0)==162){if((a[aL]&1)==0){bu=bA;bv=bB;bw=bv;bx=0;by=bw;bz=bu;be(by|0)}J2(c[aQ>>2]|0);bu=bA;bv=bB;bw=bv;bx=0;by=bw;bz=bu;be(by|0)}else if((N|0)==179){if((a[aw]&1)!=0){J2(c[aE>>2]|0)}bE=bC;bF=bD;N=190}if((N|0)==190){if((a[au]&1)==0){bu=bE;bv=bF;bw=bv;bx=0;by=bw;bz=bu;be(by|0)}J2(c[aD>>2]|0);bu=bE;bv=bF;bw=bv;bx=0;by=bw;bz=bu;be(by|0)}V=c[a6>>2]|0;aa=c[a7>>2]|0;af=V;while(1){if((af|0)==(aa|0)){bR=aa;break}if((c[af>>2]|0)==(a8|0)){bR=af;break}else{af=af+4|0}}af=bR-V>>2;aD=V+(af+1<<2)|0;au=aa-aD|0;Kc(V+(af<<2)|0,aD|0,au|0)|0;aD=V+((au>>2)+af<<2)|0;af=c[a7>>2]|0;if((aD|0)!=(af|0)){c[a7>>2]=af+(~((af-4+(-aD|0)|0)>>>2)<<2)}J2(ba);bu=bt;bv=bs;bw=bv;bx=0;by=bw;bz=bu;be(by|0)}}while(0);W=c[R>>2]|0;L=c[O>>2]|0;G=W;while(1){if((G|0)==(L|0)){bS=L;break}if((c[G>>2]|0)==(Y|0)){bS=G;break}else{G=G+4|0}}G=bS-W>>2;R=W+(G+1<<2)|0;J=L-R|0;Kc(W+(G<<2)|0,R|0,J|0)|0;R=W+((J>>2)+G<<2)|0;G=c[O>>2]|0;if((R|0)!=(G|0)){c[O>>2]=G+(~((G-4+(-R|0)|0)>>>2)<<2)}J2(Q);bu=ab;bv=ac;bw=bv;bx=0;by=bw;bz=bu;be(by|0)}else{N=12}}while(0);if((N|0)==12){X=c[b>>2]|0}ac=J0(52)|0;c[p>>2]=ac;ab=X+4|0;bS=c[ab>>2]|0;if((bS|0)==(c[X+8>>2]|0)){ee(X|0,p);bT=c[p>>2]|0}else{if((bS|0)==0){bU=0}else{c[bS>>2]=ac;bU=c[ab>>2]|0}c[ab>>2]=bU+4;bT=ac}ac=bT;bU=b+28|0;L298:do{if((a[bU]&1)==0){bS=s;c[bS>>2]=c[bU>>2];c[bS+4>>2]=c[bU+4>>2];c[bS+8>>2]=c[bU+8>>2];N=29}else{bS=c[b+36>>2]|0;p=c[b+32>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(p>>>0<11>>>0){a[s]=p<<1;bV=s+1|0}else{Y=p+16&-16;bs=(x=0,as(230,Y|0)|0);if(x){x=0;break}c[s+8>>2]=bs;c[s>>2]=Y|1;c[s+4>>2]=p;bV=bs}Kb(bV|0,bS|0,p)|0;a[bV+p|0]=0;N=29;break L298}}while(0);p=bQ(-1,-1)|0;bW=K;bX=p}}while(0);do{if((N|0)==29){bV=b+44|0;bU=o;c[bU>>2]=c[bV>>2];c[bU+4>>2]=c[bV+4>>2];c[bU+8>>2]=c[bV+8>>2];x=0;ao(14,bT|0,s|0,o|0,r|0,0);if(x){x=0;bV=bQ(-1,-1)|0;bU=bV;bV=K;if((a[s]&1)==0){bW=bV;bX=bU;break}J2(c[s+8>>2]|0);bW=bV;bX=bU;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}a[bT+28|0]=1;bm=ac;bG=bm;i=d;return bG|0}}while(0);bG=c[X>>2]|0;X=c[ab>>2]|0;d=bG;while(1){if((d|0)==(X|0)){bY=X;break}if((c[d>>2]|0)==(bT|0)){bY=d;break}else{d=d+4|0}}d=bY-bG>>2;bY=bG+(d+1<<2)|0;bT=X-bY|0;Kc(bG+(d<<2)|0,bY|0,bT|0)|0;bY=bG+((bT>>2)+d<<2)|0;d=c[ab>>2]|0;if((bY|0)!=(d|0)){c[ab>>2]=d+(~((d-4+(-bY|0)|0)>>>2)<<2)}J2(ac);bu=bW;bv=bX;bw=bv;bx=0;by=bw;bz=bu;be(by|0);return 0}function tr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xR(e)|0;do{if((f|0)==0){g=xQ(e)|0;if((g|0)==0){h=0}else{i=g;break}return h|0}else{i=f}}while(0);f=b+48|0;g=c[f>>2]|0;j=c[d>>2]|0;L5:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L5}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=g+o;g=e;f=0;while(1){n=g-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{g=n;f=f+1|0}}g=b+40|0;if((o|0)!=0){c[g>>2]=1}o=c[g>>2]|0;c[b+52>>2]=o+f;j=i;n=e;c[g>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;h=i;return h|0}function ts(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xR(e)|0;do{if((f|0)==0){g=xQ(e)|0;if((g|0)!=0){h=g;break}g=yi(e)|0;if((g|0)==0){i=0}else{h=g;break}return i|0}else{h=f}}while(0);f=b+48|0;g=c[f>>2]|0;j=c[d>>2]|0;L6:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L6}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=g+o;g=e;f=0;while(1){n=g-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{g=n;f=f+1|0}}g=b+40|0;if((o|0)!=0){c[g>>2]=1}o=c[g>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[g>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;i=h;return i|0}function tt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=i;i=i+104|0;e=d|0;f=d+16|0;g=d+32|0;h=d+48|0;j=d+72|0;k=d+88|0;l=sA(b)|0;m=d+56|0;n=b+44|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];n=c[b>>2]|0;o=J0(44)|0;c[h>>2]=o;p=n+4|0;q=c[p>>2]|0;if((q|0)==(c[n+8>>2]|0)){ee(n|0,h);r=c[h>>2]|0}else{if((q|0)==0){s=0}else{c[q>>2]=o;s=c[p>>2]|0}c[p>>2]=s+4;r=o}o=r;s=r;q=b+28|0;L8:do{if((a[q]&1)==0){h=j;c[h>>2]=c[q>>2];c[h+4>>2]=c[q+4>>2];c[h+8>>2]=c[q+8>>2];t=16}else{h=c[b+36>>2]|0;u=c[b+32>>2]|0;do{if(u>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(u>>>0<11>>>0){a[j]=u<<1;v=j+1|0}else{w=u+16&-16;y=(x=0,as(230,w|0)|0);if(x){x=0;break}c[j+8>>2]=y;c[j>>2]=w|1;c[j+4>>2]=u;v=y}Kb(v|0,h|0,u)|0;a[v+u|0]=0;t=16;break L8}}while(0);u=bQ(-1,-1)|0;z=K;A=u}}while(0);do{if((t|0)==16){v=k;c[v>>2]=c[m>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];q=(x=0,as(84,b|0)|0);do{if(!x){u=g;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];h=e;y=f;w=r;B=j;C=a[B]|0;D=(C&1)==0;if(D){c[h>>2]=c[B>>2];c[h+4>>2]=c[B+4>>2];c[h+8>>2]=c[B+8>>2]}else{B=c[j+8>>2]|0;E=c[j+4>>2]|0;if(E>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;t=36;break}return 0}if(E>>>0<11>>>0){a[h]=E<<1;F=e+1|0}else{G=E+16&-16;H=(x=0,as(230,G|0)|0);if(x){x=0;t=36;break}c[e+8>>2]=H;c[e>>2]=G|1;c[e+4>>2]=E;F=H}Kb(F|0,B|0,E)|0;a[F+E|0]=0}c[y>>2]=c[u>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];x=0;aB(6,w|0,e|0,f|0,0,0,0);if(x){x=0;w=bQ(-1,-1)|0;u=K;if((a[h]&1)==0){I=u;J=w;L=C;break}J2(c[e+8>>2]|0);I=u;J=w;L=C;break}if((a[h]&1)!=0){J2(c[e+8>>2]|0)}c[r>>2]=19336;c[r+36>>2]=l;c[r+40>>2]=q;c[r+32>>2]=4;if(D){i=d;return s|0}J2(c[j+8>>2]|0);i=d;return s|0}else{x=0;t=36}}while(0);if((t|0)==36){q=bQ(-1,-1)|0;I=K;J=q;L=a[j]|0}q=J;v=I;if((L&1)==0){z=v;A=q;break}J2(c[j+8>>2]|0);z=v;A=q}}while(0);j=c[n>>2]|0;n=c[p>>2]|0;L=j;while(1){if((L|0)==(n|0)){M=n;break}if((c[L>>2]|0)==(r|0)){M=L;break}else{L=L+4|0}}L=M-j>>2;M=j+(L+1<<2)|0;r=n-M|0;Kc(j+(L<<2)|0,M|0,r|0)|0;M=j+((r>>2)+L<<2)|0;L=c[p>>2]|0;if((M|0)==(L|0)){J2(o);N=A;O=0;P=N;Q=z;be(P|0)}c[p>>2]=L+(~((L-4+(-M|0)|0)>>>2)<<2);J2(o);N=A;O=0;P=N;Q=z;be(P|0);return 0}function tu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0;d=i;i=i+104|0;e=d|0;f=d+16|0;g=d+24|0;h=d+56|0;j=d+72|0;k=d+88|0;sp(b)|0;l=c[b+56>>2]|0;m=(c[b+60>>2]|0)-l|0;if(m>>>0>4294967279>>>0){CJ(0);return 0}if(m>>>0<11>>>0){n=m<<1&255;a[g]=n;o=g+1|0;p=n}else{n=m+16&-16;q=J0(n)|0;c[g+8>>2]=q;r=n|1;c[g>>2]=r;c[g+4>>2]=m;o=q;p=r&255}Kb(o|0,l|0,m)|0;a[o+m|0]=0;m=d+40|0;o=b+44|0;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];o=c[b>>2]|0;l=(x=0,as(230,52)|0);do{if(!x){r=l;c[f>>2]=r;q=o+4|0;n=c[q>>2]|0;if((n|0)==(c[o+8>>2]|0)){x=0;aq(376,o|0,f|0);if(x){x=0;s=42;break}t=c[f>>2]|0}else{if((n|0)==0){u=0}else{c[n>>2]=r;u=c[q>>2]|0}c[q>>2]=u+4;t=r}r=t;n=t;v=b+28|0;L18:do{if((a[v]&1)==0){w=h;c[w>>2]=c[v>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];s=23}else{w=c[b+36>>2]|0;y=c[b+32>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[h]=y<<1;z=h+1|0}else{A=y+16&-16;B=(x=0,as(230,A|0)|0);if(x){x=0;break}c[h+8>>2]=B;c[h>>2]=A|1;c[h+4>>2]=y;z=B}Kb(z|0,w|0,y)|0;a[z+y|0]=0;s=23;break L18}}while(0);y=bQ(-1,-1)|0;C=y;D=K}}while(0);do{if((s|0)==23){v=j;c[v>>2]=c[m>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];L33:do{if((p&1)==0){y=g;w=k;c[w>>2]=c[y>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];s=33}else{y=c[g+8>>2]|0;w=c[g+4>>2]|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(w>>>0<11>>>0){a[k]=w<<1;E=k+1|0}else{B=w+16&-16;A=(x=0,as(230,B|0)|0);if(x){x=0;break}c[k+8>>2]=A;c[k>>2]=B|1;c[k+4>>2]=w;E=A}Kb(E|0,y|0,w)|0;a[E+w|0]=0;s=33;break L33}}while(0);w=bQ(-1,-1)|0;F=w;G=K}}while(0);do{if((s|0)==33){w=(x=0,as(84,b|0)|0);do{if(!x){y=e;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];x=0;ao(10,n|0,h|0,e|0,k|0,w|0);if(x){x=0;break}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}if((p&1)==0){i=d;return n|0}J2(c[g+8>>2]|0);i=d;return n|0}else{x=0}}while(0);w=bQ(-1,-1)|0;y=w;w=K;if((a[k]&1)==0){F=y;G=w;break}J2(c[k+8>>2]|0);F=y;G=w}}while(0);if((a[h]&1)==0){C=F;D=G;break}J2(c[h+8>>2]|0);C=F;D=G}}while(0);n=c[o>>2]|0;v=c[q>>2]|0;w=n;while(1){if((w|0)==(v|0)){H=v;break}if((c[w>>2]|0)==(t|0)){H=w;break}else{w=w+4|0}}w=H-n>>2;y=n+(w+1<<2)|0;A=v-y|0;Kc(n+(w<<2)|0,y|0,A|0)|0;y=n+((A>>2)+w<<2)|0;w=c[q>>2]|0;if((y|0)!=(w|0)){c[q>>2]=w+(~((w-4+(-y|0)|0)>>>2)<<2)}J2(r);I=C;J=D}else{x=0;s=42}}while(0);if((s|0)==42){s=bQ(-1,-1)|0;I=s;J=K}if((p&1)==0){L=I;M=0;N=L;O=J;be(N|0)}J2(c[g+8>>2]|0);L=I;M=0;N=L;O=J;be(N|0);return 0}function tv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=(a[e]|0)==43?e+1|0:0;if((f|0)==0){g=0;return g|0}h=xP(f)|0;if((h|0)==0){g=0;return g|0}f=(yi(h)|0)!=0;i=f?0:h;if((i|0)==0){g=0;return g|0}h=b+48|0;f=c[h>>2]|0;j=c[d>>2]|0;L10:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L10}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=f+o;f=e;h=0;while(1){n=f-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{f=n;h=h+1|0}}f=b+40|0;if((o|0)!=0){c[f>>2]=1}o=c[f>>2]|0;c[b+52>>2]=o+h;j=i;n=e;c[f>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function tw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=h+32|0;Kb(l|0,e|0,12)|0;e=j;m=k;n=b|0;o=d;if((a[o]&1)==0){c[e>>2]=c[o>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2]}else{o=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){CJ(0)}if(p>>>0<11>>>0){a[e]=p<<1;q=j+1|0}else{d=p+16&-16;r=J0(d)|0;c[j+8>>2]=r;c[j>>2]=d|1;c[j+4>>2]=p;q=r}Kb(q|0,o|0,p)|0;a[q+p|0]=0}c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];x=0;aB(6,n|0,j|0,k|0,0,0,0);if(!x){if((a[e]&1)==0){s=b|0;c[s>>2]=19960;t=b+36|0;c[t>>2]=f;u=b+40|0;c[u>>2]=g;i=h;return}J2(c[j+8>>2]|0);s=b|0;c[s>>2]=19960;t=b+36|0;c[t>>2]=f;u=b+40|0;c[u>>2]=g;i=h;return}else{x=0;h=bQ(-1,-1)|0;if((a[e]&1)==0){be(h|0)}J2(c[j+8>>2]|0);be(h|0)}}function tx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=(a[e]|0)==45?e+1|0:0;if((f|0)==0){g=0;return g|0}h=xP(f)|0;if((h|0)==0){g=0;return g|0}f=(yi(h)|0)!=0;i=f?0:h;if((i|0)==0){g=0;return g|0}h=b+48|0;f=c[h>>2]|0;j=c[d>>2]|0;L10:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L10}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=f+o;f=e;h=0;while(1){n=f-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{f=n;h=h+1|0}}f=b+40|0;if((o|0)!=0){c[f>>2]=1}o=c[f>>2]|0;c[b+52>>2]=o+h;j=i;n=e;c[f>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function ty(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yq(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0;d=i;i=i+128|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+40|0;k=d+48|0;l=d+64|0;m=d+72|0;n=d+88|0;o=d+96|0;p=d+112|0;q=d+120|0;r=q;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+8|0;w=i;i=i+64|0;y=i;i=i+8|0;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+8|0;sg(b)|0;G=b+56|0;H=c[G>>2]|0;I=c[G+4>>2]|0;c[q>>2]=H;c[q+4>>2]=I;q=H;H=q;G=I;I=G;L1:do{if(H>>>0<I>>>0){J=a[35720]|0;L=J<<24>>24==0;L3:do{if(L){M=H;while(1){N=a[M]|0;if(N<<24>>24==0){O=12;break L1}P=M+1|0;if(!(N<<24>>24==92&(P|0)!=0|(M|0)==0)){Q=M;break L3}if(P>>>0<I>>>0){M=P}else{O=12;break L1}}}else{M=H;while(1){P=a[M]|0;if(P<<24>>24==0){O=12;break L1}N=M+1|0;R=P<<24>>24==92&(N|0)!=0?0:M;if((R|0)!=0){P=R;R=35720;S=J;while(1){if((a[P]|0)!=S<<24>>24){T=P;U=S;break}V=P+1|0;W=R+1|0;X=a[W]|0;if(X<<24>>24==0){T=V;U=0;break}else{P=V;R=W;S=X}}if(!(U<<24>>24!=0|(T|0)==0)){Q=M;break L3}}if(N>>>0<I>>>0){M=N}else{O=12;break L1}}}}while(0);M=b|0;S=c[M>>2]|0;if((Q|0)==0){Y=S;break}R=J0(60)|0;c[n>>2]=R;P=S+4|0;X=c[P>>2]|0;if((X|0)==(c[S+8>>2]|0)){ee(S|0,n);Z=c[n>>2]|0}else{if((X|0)==0){_=0}else{c[X>>2]=R;_=c[P>>2]|0}c[P>>2]=_+4;Z=R}R=Z;X=Z;W=b+28|0;L26:do{if((a[W]&1)==0){V=t;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];O=57}else{V=c[b+36>>2]|0;$=c[b+32>>2]|0;do{if($>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if($>>>0<11>>>0){a[t]=$<<1;aa=t+1|0}else{ab=$+16&-16;ac=(x=0,as(230,ab|0)|0);if(x){x=0;break}c[t+8>>2]=ac;c[t>>2]=ab|1;c[t+4>>2]=$;aa=ac}Kb(aa|0,V|0,$)|0;a[aa+$|0]=0;O=57;break L26}}while(0);$=bQ(-1,-1)|0;ad=K;ae=$}}while(0);do{if((O|0)==57){$=b+44|0;V=m;c[V>>2]=c[$>>2];c[V+4>>2]=c[$+4>>2];c[V+8>>2]=c[$+8>>2];x=0;aB(2,X|0,t|0,m|0,0,0,0);if(x){x=0;V=bQ(-1,-1)|0;ac=V;V=K;if((a[t]&1)==0){ad=V;ae=ac;break}J2(c[t+8>>2]|0);ad=V;ae=ac;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}a[Z+56|0]=a[H]|0;ac=Z+40|0;V=ac;ab=u;af=v|0;ag=v+4|0;ah=ac+8|0;ai=ac+12|0;aj=ac+4|0;ak=u+8|0;al=b+36|0;am=b+32|0;an=u+1|0;ar=u|0;at=u+4|0;au=a[35456]|0;av=au<<24>>24==0;aw=C;ay=C+1|0;az=B;aA=B+1|0;aC=D|0;aD=D+4|0;aE=D+8|0;aF=C+8|0;aG=B+8|0;aH=B|0;aI=B+4|0;aJ=C+4|0;aK=C|0;aL=y|0;aM=y+4|0;aN=z;aO=A;aQ=w+28|0;aR=w+4|0;aS=z+8|0;aT=w+8|0;aU=w+36|0;aV=z+1|0;aW=z|0;aX=z+4|0;aY=H;L48:while(1){L50:while(1){L52:do{if(L){aZ=aY;while(1){a_=a[aZ]|0;if(a_<<24>>24==0){O=192;break L48}a$=aZ+1|0;if(!(a_<<24>>24==92&(a$|0)!=0|(aZ|0)==0)){a0=aZ;break L52}if(a$>>>0<I>>>0){aZ=a$}else{O=192;break L48}}}else{aZ=aY;while(1){a$=a[aZ]|0;if(a$<<24>>24==0){O=192;break L48}a_=aZ+1|0;a1=a$<<24>>24==92&(a_|0)!=0?0:aZ;if((a1|0)!=0){a$=a1;a1=35720;a2=J;while(1){if((a[a$]|0)!=a2<<24>>24){a3=a$;a4=a2;break}a5=a$+1|0;a6=a1+1|0;a7=a[a6]|0;if(a7<<24>>24==0){a3=a5;a4=0;break}else{a$=a5;a1=a6;a2=a7}}if(!(a4<<24>>24!=0|(a3|0)==0)){a0=aZ;break L52}}if(a_>>>0<I>>>0){aZ=a_}else{O=192;break L48}}}}while(0);if((a0|0)==0){O=192;break L48}do{if(aY>>>0<a0>>>0){a8=c[M>>2]|0;aZ=J0(52)|0;c[l>>2]=aZ;a9=a8+4|0;a2=c[a9>>2]|0;if((a2|0)==(c[a8+8>>2]|0)){ee(a8|0,l);ba=c[l>>2]|0}else{if((a2|0)==0){bb=0}else{c[a2>>2]=aZ;bb=c[a9>>2]|0}c[a9>>2]=bb+4;ba=aZ}bc=ba;aZ=ba;if((a[W]&1)==0){c[ab>>2]=c[W>>2];c[ab+4>>2]=c[W+4>>2];c[ab+8>>2]=c[W+8>>2]}else{a2=c[al>>2]|0;a1=c[am>>2]|0;if(a1>>>0>4294967279>>>0){O=82;break L48}if(a1>>>0<11>>>0){a[ab]=a1<<1;bd=an}else{a$=a1+16&-16;a7=(x=0,as(230,a$|0)|0);if(x){x=0;O=108;break L48}c[ak>>2]=a7;c[ar>>2]=a$|1;c[at>>2]=a1;bd=a7}Kb(bd|0,a2|0,a1)|0;a[bd+a1|0]=0}a1=k;c[a1>>2]=c[$>>2];c[a1+4>>2]=c[$+4>>2];c[a1+8>>2]=c[$+8>>2];c[af>>2]=aY;c[ag>>2]=a0;x=0;ao(14,aZ|0,u|0,k|0,v|0,0);if(x){x=0;bf=1;O=111;break L48}aZ=ba;c[j>>2]=aZ;a1=c[ah>>2]|0;a2=a1;if((a1|0)==(c[ai>>2]|0)){x=0;aq(370,aj|0,j|0);if(x){x=0;bf=0;O=111;break L48}bg=c[j>>2]|0}else{if((a1|0)==0){bh=0}else{c[a2>>2]=aZ;bh=c[ah>>2]|0}c[ah>>2]=bh+4;bg=aZ}x=0;aq(c[c[ac>>2]>>2]|0,V|0,bg|0);if(x){x=0;bf=0;O=111;break L48}if((a[ab]&1)==0){break}J2(c[ak>>2]|0)}}while(0);L99:do{if(av){aZ=a0;while(1){if(aZ>>>0>=I>>>0){break L99}if((a[aZ]|0)==0){break L99}if((aZ|0)==0){aZ=aZ+1|0}else{bi=aZ;break L50}}}else{aZ=a0;while(1){if(aZ>>>0>=I>>>0){break L99}a2=a[aZ]|0;if(a2<<24>>24==0){break L99}L108:do{if(a2<<24>>24==au<<24>>24){a1=35456;a7=aZ;while(1){a$=a7+1|0;a6=a1+1|0;a5=a[a6]|0;if(a5<<24>>24==0){bj=a$;bk=0;break L108}if((a[a$]|0)==a5<<24>>24){a1=a6;a7=a$}else{bj=a$;bk=a5;break}}}else{bj=aZ;bk=au}}while(0);if(bk<<24>>24!=0|(bj|0)==0){aZ=aZ+1|0}else{break}}if((aZ|0)!=0){bi=aZ;break L50}}}while(0);a2=G-q|0;if(a2>>>0>4294967279>>>0){O=165;break L48}if(a2>>>0<11>>>0){a_=a2<<1&255;a[aw]=a_;bl=ay;bm=a_}else{a_=a2+16&-16;a7=J0(a_)|0;c[aF>>2]=a7;a1=a_|1;c[aK>>2]=a1;c[aJ>>2]=a2;bl=a7;bm=a1&255}Kb(bl|0,H|0,a2)|0;a[bl+a2|0]=0;Ke(az|0,0,12)|0;a2=bm&255;a1=(a2&1|0)==0?a2>>>1:c[aJ>>2]|0;a2=a1+48|0;if(a2>>>0>4294967279>>>0){O=170;break L48}if(a2>>>0<11>>>0){a[az]=96;bn=aA}else{a2=a1+64&-16;a7=(x=0,as(230,a2|0)|0);if(x){x=0;O=177;break L48}c[aG>>2]=a7;c[aH>>2]=a2|1;c[aI>>2]=48;bn=a7}Kb(bn|0,4752,48)|0;a[bn+48|0]=0;x=0,ax(64,B|0,((bm&1)==0?ay:c[aF>>2]|0)|0,a1|0)|0;if(x){x=0;O=177;break L48}c[aC>>2]=0;c[aD>>2]=0;c[aE>>2]=0;x=0;aP(466,b|0,B|0,D|0);if(x){x=0;O=188;break L48}if((a[az]&1)!=0){J2(c[aG>>2]|0)}if((a[aw]&1)!=0){J2(c[aF>>2]|0)}if(aY>>>0>=I>>>0){bo=R;O=231;break L48}}c[aL>>2]=a0+2;c[aM>>2]=bi;N=c[M>>2]|0;if((a[W]&1)==0){c[aN>>2]=c[W>>2];c[aN+4>>2]=c[W+4>>2];c[aN+8>>2]=c[W+8>>2]}else{a1=c[al>>2]|0;a7=c[am>>2]|0;if(a7>>>0>4294967279>>>0){O=134;break}if(a7>>>0<11>>>0){a[aN]=a7<<1;bp=aV}else{a2=a7+16&-16;a_=J0(a2)|0;c[aS>>2]=a_;c[aW>>2]=a2|1;c[aX>>2]=a7;bp=a_}Kb(bp|0,a1|0,a7)|0;a[bp+a7|0]=0}c[aO>>2]=c[$>>2];c[aO+4>>2]=c[$+4>>2];c[aO+8>>2]=c[$+8>>2];x=0;ao(16,w|0,y|0,N|0,z|0,A|0);if(x){x=0;O=155;break}N=(x=0,as(158,w|0)|0);if(x){x=0;O=156;break}if((a[aQ]&1)!=0){J2(c[aU>>2]|0)}a7=c[aR>>2]|0;a1=a7;if((a7|0)!=0){a_=c[aT>>2]|0;if((a7|0)!=(a_|0)){c[aT>>2]=a_+(~((a_-4+(-a1|0)|0)>>>2)<<2)}J2(a7)}if((a[aN]&1)!=0){J2(c[aS>>2]|0)}a[N+29|0]=1;c[h>>2]=N;a7=c[ah>>2]|0;a1=a7;if((a7|0)==(c[ai>>2]|0)){eq(aj,h);bq=c[h>>2]|0}else{if((a7|0)==0){br=0}else{c[a1>>2]=N;br=c[ah>>2]|0}c[ah>>2]=br+4;bq=N}cy[c[c[ac>>2]>>2]&1023](V,bq);N=bi+1|0;if(N>>>0<I>>>0){aY=N}else{bo=R;O=230;break}}do{if((O|0)==188){aO=bQ(-1,-1)|0;aX=aO;aO=K;if((a[az]&1)==0){bs=aO;bt=aX;O=190;break}J2(c[aG>>2]|0);bs=aO;bt=aX;O=190}else if((O|0)==230){bu=bo;i=d;return bu|0}else if((O|0)==231){bu=bo;i=d;return bu|0}else if((O|0)==134){CJ(0);return 0}else if((O|0)==111){aX=bQ(-1,-1)|0;aO=aX;aX=K;if((a[ab]&1)==0){if(bf){bv=aO;bw=aX;break}else{bx=aX;by=aO}bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}else{J2(c[ak>>2]|0);if(bf){bv=aO;bw=aX;break}else{bx=aX;by=aO}bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}}else if((O|0)==192){if(aY>>>0>=I>>>0){bo=R;bu=bo;i=d;return bu|0}aO=c[M>>2]|0;aX=J0(52)|0;c[g>>2]=aX;aW=aO+4|0;aV=c[aW>>2]|0;if((aV|0)==(c[aO+8>>2]|0)){ee(aO|0,g);bD=c[g>>2]|0}else{if((aV|0)==0){bE=0}else{c[aV>>2]=aX;bE=c[aW>>2]|0}c[aW>>2]=bE+4;bD=aX}aX=bD;aV=bD;L188:do{if((a[W]&1)==0){aM=E;c[aM>>2]=c[W>>2];c[aM+4>>2]=c[W+4>>2];c[aM+8>>2]=c[W+8>>2];O=208}else{aM=c[al>>2]|0;aL=c[am>>2]|0;do{if(aL>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aL>>>0<11>>>0){a[E]=aL<<1;bF=E+1|0}else{aE=aL+16&-16;aD=(x=0,as(230,aE|0)|0);if(x){x=0;break}c[E+8>>2]=aD;c[E>>2]=aE|1;c[E+4>>2]=aL;bF=aD}Kb(bF|0,aM|0,aL)|0;a[bF+aL|0]=0;O=208;break L188}}while(0);aL=bQ(-1,-1)|0;bG=aL;bH=K}}while(0);do{if((O|0)==208){aL=f;c[aL>>2]=c[$>>2];c[aL+4>>2]=c[$+4>>2];c[aL+8>>2]=c[$+8>>2];c[F>>2]=aY;c[F+4>>2]=I;x=0;ao(14,aV|0,E|0,f|0,F|0,0);do{if(!x){aL=bD;c[e>>2]=aL;aM=c[ah>>2]|0;aD=aM;if((aM|0)==(c[ai>>2]|0)){x=0;aq(370,aj|0,e|0);if(x){x=0;bI=0;break}bJ=c[e>>2]|0}else{if((aM|0)==0){bK=0}else{c[aD>>2]=aL;bK=c[ah>>2]|0}c[ah>>2]=bK+4;bJ=aL}x=0;aq(c[c[ac>>2]>>2]|0,V|0,bJ|0);if(x){x=0;bI=0;break}if((a[E]&1)==0){bo=R;bu=bo;i=d;return bu|0}J2(c[E+8>>2]|0);bo=R;bu=bo;i=d;return bu|0}else{x=0;bI=1}}while(0);aL=bQ(-1,-1)|0;aD=aL;aL=K;if((a[E]&1)==0){if(bI){bG=aD;bH=aL;break}else{bx=aL;by=aD}bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}else{J2(c[E+8>>2]|0);if(bI){bG=aD;bH=aL;break}else{bx=aL;by=aD}bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}}}while(0);aV=c[aO>>2]|0;aD=c[aW>>2]|0;aL=aV;while(1){if((aL|0)==(aD|0)){bL=aD;break}if((c[aL>>2]|0)==(bD|0)){bL=aL;break}else{aL=aL+4|0}}aL=bL-aV>>2;aO=aV+(aL+1<<2)|0;aM=aD-aO|0;Kc(aV+(aL<<2)|0,aO|0,aM|0)|0;aO=aV+((aM>>2)+aL<<2)|0;aL=c[aW>>2]|0;if((aO|0)!=(aL|0)){c[aW>>2]=aL+(~((aL-4+(-aO|0)|0)>>>2)<<2)}J2(aX);bx=bH;by=bG;bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}else if((O|0)==108){aO=bQ(-1,-1)|0;bM=K;bN=aO;O=110}else if((O|0)==155){aO=bQ(-1,-1)|0;bO=K;bP=aO;O=162}else if((O|0)==156){aO=bQ(-1,-1)|0;aL=aO;aO=K;if((a[aQ]&1)!=0){J2(c[aU>>2]|0)}aM=c[aR>>2]|0;if((aM|0)==0){bO=aO;bP=aL;O=162;break}aE=c[aT>>2]|0;if((aM|0)!=(aE|0)){c[aT>>2]=aE+(~((aE-4+(-aM|0)|0)>>>2)<<2)}J2(aM);bO=aO;bP=aL;O=162}else if((O|0)==82){x=0;ap(232,0);if(!x){return 0}else{x=0;aL=bQ(-1,-1)|0;bM=K;bN=aL;O=110;break}}else if((O|0)==165){CJ(0);return 0}else if((O|0)==170){x=0;ap(232,0);if(!x){return 0}else{x=0;aL=bQ(-1,-1)|0;bR=K;bS=aL;O=179;break}}else if((O|0)==177){aL=bQ(-1,-1)|0;bR=K;bS=aL;O=179}}while(0);if((O|0)==110){bv=bN;bw=bM}else if((O|0)==162){if((a[aN]&1)==0){bx=bO;by=bP;bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}J2(c[aS>>2]|0);bx=bO;by=bP;bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}else if((O|0)==179){if((a[az]&1)!=0){J2(c[aG>>2]|0)}bs=bR;bt=bS;O=190}if((O|0)==190){if((a[aw]&1)==0){bx=bs;by=bt;bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}J2(c[aF>>2]|0);bx=bs;by=bt;bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}aT=c[a8>>2]|0;aR=c[a9>>2]|0;aU=aT;while(1){if((aU|0)==(aR|0)){bT=aR;break}if((c[aU>>2]|0)==(ba|0)){bT=aU;break}else{aU=aU+4|0}}aU=bT-aT>>2;aF=aT+(aU+1<<2)|0;aw=aR-aF|0;Kc(aT+(aU<<2)|0,aF|0,aw|0)|0;aF=aT+((aw>>2)+aU<<2)|0;aU=c[a9>>2]|0;if((aF|0)!=(aU|0)){c[a9>>2]=aU+(~((aU-4+(-aF|0)|0)>>>2)<<2)}J2(bc);bx=bw;by=bv;bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}}while(0);W=c[S>>2]|0;M=c[P>>2]|0;J=W;while(1){if((J|0)==(M|0)){bU=M;break}if((c[J>>2]|0)==(Z|0)){bU=J;break}else{J=J+4|0}}J=bU-W>>2;S=W+(J+1<<2)|0;L=M-S|0;Kc(W+(J<<2)|0,S|0,L|0)|0;S=W+((L>>2)+J<<2)|0;J=c[P>>2]|0;if((S|0)!=(J|0)){c[P>>2]=J+(~((J-4+(-S|0)|0)>>>2)<<2)}J2(R);bx=ad;by=ae;bz=by;bA=0;bB=bz;bC=bx;be(bB|0)}else{O=12}}while(0);if((O|0)==12){Y=c[b>>2]|0}ae=J0(52)|0;c[p>>2]=ae;ad=Y+4|0;bU=c[ad>>2]|0;if((bU|0)==(c[Y+8>>2]|0)){ee(Y|0,p);bV=c[p>>2]|0}else{if((bU|0)==0){bW=0}else{c[bU>>2]=ae;bW=c[ad>>2]|0}c[ad>>2]=bW+4;bV=ae}ae=bV;bW=b+28|0;L298:do{if((a[bW]&1)==0){bU=s;c[bU>>2]=c[bW>>2];c[bU+4>>2]=c[bW+4>>2];c[bU+8>>2]=c[bW+8>>2];O=29}else{bU=c[b+36>>2]|0;p=c[b+32>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(p>>>0<11>>>0){a[s]=p<<1;bX=s+1|0}else{Z=p+16&-16;bv=(x=0,as(230,Z|0)|0);if(x){x=0;break}c[s+8>>2]=bv;c[s>>2]=Z|1;c[s+4>>2]=p;bX=bv}Kb(bX|0,bU|0,p)|0;a[bX+p|0]=0;O=29;break L298}}while(0);p=bQ(-1,-1)|0;bY=K;bZ=p}}while(0);do{if((O|0)==29){bX=b+44|0;bW=o;c[bW>>2]=c[bX>>2];c[bW+4>>2]=c[bX+4>>2];c[bW+8>>2]=c[bX+8>>2];x=0;ao(14,bV|0,s|0,o|0,r|0,0);if(x){x=0;bX=bQ(-1,-1)|0;bW=bX;bX=K;if((a[s]&1)==0){bY=bX;bZ=bW;break}J2(c[s+8>>2]|0);bY=bX;bZ=bW;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}a[bV+28|0]=1;bo=ae;bu=bo;i=d;return bu|0}}while(0);bu=c[Y>>2]|0;Y=c[ad>>2]|0;d=bu;while(1){if((d|0)==(Y|0)){b_=Y;break}if((c[d>>2]|0)==(bV|0)){b_=d;break}else{d=d+4|0}}d=b_-bu>>2;b_=bu+(d+1<<2)|0;bV=Y-b_|0;Kc(bu+(d<<2)|0,b_|0,bV|0)|0;b_=bu+((bV>>2)+d<<2)|0;d=c[ad>>2]|0;if((b_|0)!=(d|0)){c[ad>>2]=d+(~((d-4+(-b_|0)|0)>>>2)<<2)}J2(ae);bx=bY;by=bZ;bz=by;bA=0;bB=bz;bC=bx;be(bB|0);return 0}function tA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=ys(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0;d=i;i=i+232|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+40|0;k=d+56|0;l=d+64|0;m=d+72|0;n=d+80|0;o=d+96|0;p=d+104|0;q=d+120|0;r=d+128|0;s=d+144|0;t=d+160|0;u=d+224|0;v=u;w=i;i=i+12|0;i=i+7&-8;y=i;i=i+12|0;i=i+7&-8;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=b|0;E=c[D>>2]|0;F=J0(60)|0;c[q>>2]=F;G=E+4|0;H=c[G>>2]|0;if((H|0)==(c[E+8>>2]|0)){ee(E|0,q);I=c[q>>2]|0}else{if((H|0)==0){J=0}else{c[H>>2]=F;J=c[G>>2]|0}c[G>>2]=J+4;I=F}F=I;J=I;H=b+28|0;L8:do{if((a[H]&1)==0){q=r;c[q>>2]=c[H>>2];c[q+4>>2]=c[H+4>>2];c[q+8>>2]=c[H+8>>2];L=16}else{q=c[b+36>>2]|0;M=c[b+32>>2]|0;do{if(M>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(M>>>0<11>>>0){a[r]=M<<1;N=r+1|0}else{O=M+16&-16;P=(x=0,as(230,O|0)|0);if(x){x=0;break}c[r+8>>2]=P;c[r>>2]=O|1;c[r+4>>2]=M;N=P}Kb(N|0,q|0,M)|0;a[N+M|0]=0;L=16;break L8}}while(0);M=bQ(-1,-1)|0;Q=M;R=K}}while(0);do{if((L|0)==16){N=b+44|0;M=p;c[M>>2]=c[N>>2];c[M+4>>2]=c[N+4>>2];c[M+8>>2]=c[N+8>>2];x=0;aB(2,J|0,r|0,p|0,0,0,0);if(x){x=0;M=bQ(-1,-1)|0;q=M;M=K;if((a[r]&1)==0){Q=q;R=M;break}J2(c[r+8>>2]|0);Q=q;R=M;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}M=b+20|0;q=c[M>>2]|0;P=b+24|0;if(q>>>0>=(c[P>>2]|0)>>>0){i=d;return J|0}O=b+56|0;S=O;T=I+40|0;U=T;V=s;W=T+8|0;X=T+12|0;Y=T+4|0;Z=s+8|0;_=b+36|0;$=b+32|0;aa=s+1|0;ab=s|0;ac=s+4|0;ad=B+8|0;ae=B|0;af=B+4|0;ag=C|0;ah=C+4|0;ai=C+8|0;aj=B;ak=A;al=A+8|0;am=A+1|0;an=A|0;ar=A+4|0;at=z;au=z+8|0;av=z+1|0;aw=z|0;ax=z+4|0;ay=b+56|0;az=b+60|0;aA=w;aC=y;aD=t+28|0;aE=t+4|0;aF=w+8|0;aG=t+8|0;aH=t+36|0;aI=w+1|0;aJ=w|0;aK=w+4|0;aL=q;L33:while(1){do{if((a[aL]|0)==47){c[S>>2]=aL;c[S+4>>2]=aL+1;aM=c[D>>2]|0;q=J0(52)|0;c[o>>2]=q;aN=aM+4|0;aO=c[aN>>2]|0;if((aO|0)==(c[aM+8>>2]|0)){ee(aM|0,o);aQ=c[o>>2]|0}else{if((aO|0)==0){aR=0}else{c[aO>>2]=q;aR=c[aN>>2]|0}c[aN>>2]=aR+4;aQ=q}aS=aQ;if((a[H]&1)==0){c[V>>2]=c[H>>2];c[V+4>>2]=c[H+4>>2];c[V+8>>2]=c[H+8>>2]}else{q=c[_>>2]|0;aO=c[$>>2]|0;if(aO>>>0>4294967279>>>0){L=30;break L33}if(aO>>>0<11>>>0){a[V]=aO<<1;aT=aa}else{aU=aO+16&-16;aV=(x=0,as(230,aU|0)|0);if(x){x=0;L=57;break L33}c[Z>>2]=aV;c[ab>>2]=aU|1;c[ac>>2]=aO;aT=aV}Kb(aT|0,q|0,aO)|0;a[aT+aO|0]=0}aO=n;c[aO>>2]=c[N>>2];c[aO+4>>2]=c[N+4>>2];c[aO+8>>2]=c[N+8>>2];x=0;ao(14,aQ|0,s|0,n|0,O|0,0);if(x){x=0;aW=1;L=60;break L33}aO=aQ;c[m>>2]=aO;q=c[W>>2]|0;aV=q;if((q|0)==(c[X>>2]|0)){x=0;aq(370,Y|0,m|0);if(x){x=0;aW=0;L=60;break L33}aX=c[m>>2]|0}else{if((q|0)==0){aY=0}else{c[aV>>2]=aO;aY=c[W>>2]|0}c[W>>2]=aY+4;aX=aO}x=0;aq(c[c[T>>2]>>2]|0,U|0,aX|0);if(x){x=0;aW=0;L=60;break L33}if((a[V]&1)!=0){J2(c[Z>>2]|0)}c[M>>2]=(c[M>>2]|0)+1}else{if((tN(b)|0)!=0){aO=(c[az>>2]|0)-1|0;c[u>>2]=(c[ay>>2]|0)+2;c[u+4>>2]=aO;aO=c[D>>2]|0;if((a[H]&1)==0){c[aA>>2]=c[H>>2];c[aA+4>>2]=c[H+4>>2];c[aA+8>>2]=c[H+8>>2]}else{aV=c[_>>2]|0;q=c[$>>2]|0;if(q>>>0>4294967279>>>0){L=73;break L33}if(q>>>0<11>>>0){a[aA]=q<<1;aZ=aI}else{aU=q+16&-16;a_=J0(aU)|0;c[aF>>2]=a_;c[aJ>>2]=aU|1;c[aK>>2]=q;aZ=a_}Kb(aZ|0,aV|0,q)|0;a[aZ+q|0]=0}c[aC>>2]=c[N>>2];c[aC+4>>2]=c[N+4>>2];c[aC+8>>2]=c[N+8>>2];x=0;ao(16,t|0,v|0,aO|0,w|0,y|0);if(x){x=0;L=95;break L33}aO=(x=0,as(158,t|0)|0);if(x){x=0;L=96;break L33}if((a[aD]&1)!=0){J2(c[aH>>2]|0)}q=c[aE>>2]|0;aV=q;if((q|0)!=0){a_=c[aG>>2]|0;if((q|0)!=(a_|0)){c[aG>>2]=a_+(~((a_-4+(-aV|0)|0)>>>2)<<2)}J2(q)}if((a[aA]&1)!=0){J2(c[aF>>2]|0)}a[aO+29|0]=1;c[l>>2]=aO;q=c[W>>2]|0;aV=q;if((q|0)==(c[X>>2]|0)){eq(Y,l);a$=c[l>>2]|0}else{if((q|0)==0){a0=0}else{c[aV>>2]=aO;a0=c[W>>2]|0}c[W>>2]=a0+4;a$=aO}cy[c[c[T>>2]>>2]&1023](U,a$);break}if((tO(b)|0)!=0){a1=c[D>>2]|0;aO=J0(52)|0;c[k>>2]=aO;a2=a1+4|0;aV=c[a2>>2]|0;if((aV|0)==(c[a1+8>>2]|0)){ee(a1|0,k);a3=c[k>>2]|0}else{if((aV|0)==0){a4=0}else{c[aV>>2]=aO;a4=c[a2>>2]|0}c[a2>>2]=a4+4;a3=aO}a5=a3;if((a[H]&1)==0){c[at>>2]=c[H>>2];c[at+4>>2]=c[H+4>>2];c[at+8>>2]=c[H+8>>2]}else{aO=c[_>>2]|0;aV=c[$>>2]|0;if(aV>>>0>4294967279>>>0){L=113;break L33}if(aV>>>0<11>>>0){a[at]=aV<<1;a6=av}else{q=aV+16&-16;a_=(x=0,as(230,q|0)|0);if(x){x=0;L=130;break L33}c[au>>2]=a_;c[aw>>2]=q|1;c[ax>>2]=aV;a6=a_}Kb(a6|0,aO|0,aV)|0;a[a6+aV|0]=0}aV=j;c[aV>>2]=c[N>>2];c[aV+4>>2]=c[N+4>>2];c[aV+8>>2]=c[N+8>>2];x=0;ao(14,a3|0,z|0,j|0,O|0,0);if(x){x=0;a7=1;L=133;break L33}aV=a3;c[h>>2]=aV;aO=c[W>>2]|0;a_=aO;if((aO|0)==(c[X>>2]|0)){x=0;aq(370,Y|0,h|0);if(x){x=0;a7=0;L=133;break L33}a8=c[h>>2]|0}else{if((aO|0)==0){a9=0}else{c[a_>>2]=aV;a9=c[W>>2]|0}c[W>>2]=a9+4;a8=aV}x=0;aq(c[c[T>>2]>>2]|0,U|0,a8|0);if(x){x=0;a7=0;L=133;break L33}if((a[at]&1)==0){break}J2(c[au>>2]|0);break}if((tP(b)|0)==0){aV=J0(32)|0;c[ad>>2]=aV;c[ae>>2]=33;c[af>>2]=30;Kb(aV|0,4240,30)|0;a[aV+30|0]=0;c[ag>>2]=0;c[ah>>2]=0;c[ai>>2]=0;x=0;aP(466,b|0,B|0,C|0);if(x){x=0;L=183;break L33}if((a[aj]&1)==0){break}J2(c[ad>>2]|0);break}ba=c[D>>2]|0;aV=J0(52)|0;c[g>>2]=aV;bb=ba+4|0;a_=c[bb>>2]|0;if((a_|0)==(c[ba+8>>2]|0)){ee(ba|0,g);bc=c[g>>2]|0}else{if((a_|0)==0){bd=0}else{c[a_>>2]=aV;bd=c[bb>>2]|0}c[bb>>2]=bd+4;bc=aV}bf=bc;if((a[H]&1)==0){c[ak>>2]=c[H>>2];c[ak+4>>2]=c[H+4>>2];c[ak+8>>2]=c[H+8>>2]}else{aV=c[_>>2]|0;a_=c[$>>2]|0;if(a_>>>0>4294967279>>>0){L=151;break L33}if(a_>>>0<11>>>0){a[ak]=a_<<1;bg=am}else{aO=a_+16&-16;q=(x=0,as(230,aO|0)|0);if(x){x=0;L=168;break L33}c[al>>2]=q;c[an>>2]=aO|1;c[ar>>2]=a_;bg=q}Kb(bg|0,aV|0,a_)|0;a[bg+a_|0]=0}a_=f;c[a_>>2]=c[N>>2];c[a_+4>>2]=c[N+4>>2];c[a_+8>>2]=c[N+8>>2];x=0;ao(14,bc|0,A|0,f|0,O|0,0);if(x){x=0;bh=1;L=171;break L33}a_=bc;c[e>>2]=a_;aV=c[W>>2]|0;q=aV;if((aV|0)==(c[X>>2]|0)){x=0;aq(370,Y|0,e|0);if(x){x=0;bh=0;L=171;break L33}bi=c[e>>2]|0}else{if((aV|0)==0){bj=0}else{c[q>>2]=a_;bj=c[W>>2]|0}c[W>>2]=bj+4;bi=a_}x=0;aq(c[c[T>>2]>>2]|0,U|0,bi|0);if(x){x=0;bh=0;L=171;break L33}if((a[ak]&1)==0){break}J2(c[al>>2]|0)}}while(0);a_=c[M>>2]|0;if(a_>>>0<(c[P>>2]|0)>>>0){aL=a_}else{L=188;break}}do{if((L|0)==171){aL=bQ(-1,-1)|0;P=aL;aL=K;if((a[ak]&1)==0){if(bh){bk=aL;bl=P;L=174;break}else{bm=P;bn=aL}bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}else{J2(c[al>>2]|0);if(bh){bk=aL;bl=P;L=174;break}else{bm=P;bn=aL}bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}}else if((L|0)==168){aL=bQ(-1,-1)|0;bs=K;bt=aL;L=170}else if((L|0)==188){i=d;return J|0}else if((L|0)==183){aL=bQ(-1,-1)|0;P=aL;aL=K;if((a[aj]&1)==0){bm=P;bn=aL;bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}J2(c[ad>>2]|0);bm=P;bn=aL;bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}else if((L|0)==30){x=0;ap(232,0);if(!x){return 0}else{x=0;aL=bQ(-1,-1)|0;bu=K;bv=aL;L=59;break}}else if((L|0)==57){aL=bQ(-1,-1)|0;bu=K;bv=aL;L=59}else if((L|0)==60){aL=bQ(-1,-1)|0;P=aL;aL=K;if((a[V]&1)==0){if(aW){bw=aL;bx=P;L=63;break}else{bm=P;bn=aL}bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}else{J2(c[Z>>2]|0);if(aW){bw=aL;bx=P;L=63;break}else{bm=P;bn=aL}bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}}else if((L|0)==73){CJ(0);return 0}else if((L|0)==95){aL=bQ(-1,-1)|0;by=aL;bz=K;L=102}else if((L|0)==96){aL=bQ(-1,-1)|0;P=aL;aL=K;if((a[aD]&1)!=0){J2(c[aH>>2]|0)}M=c[aE>>2]|0;if((M|0)==0){by=P;bz=aL;L=102;break}U=c[aG>>2]|0;if((M|0)!=(U|0)){c[aG>>2]=U+(~((U-4+(-M|0)|0)>>>2)<<2)}J2(M);by=P;bz=aL;L=102}else if((L|0)==113){x=0;ap(232,0);if(!x){return 0}else{x=0;aL=bQ(-1,-1)|0;bA=K;bB=aL;L=132;break}}else if((L|0)==130){aL=bQ(-1,-1)|0;bA=K;bB=aL;L=132}else if((L|0)==133){aL=bQ(-1,-1)|0;P=aL;aL=K;if((a[at]&1)==0){if(a7){bC=aL;bD=P;L=136;break}else{bm=P;bn=aL}bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}else{J2(c[au>>2]|0);if(a7){bC=aL;bD=P;L=136;break}else{bm=P;bn=aL}bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}}else if((L|0)==151){x=0;ap(232,0);if(!x){return 0}else{x=0;aL=bQ(-1,-1)|0;bs=K;bt=aL;L=170;break}}}while(0);if((L|0)==170){bk=bs;bl=bt;L=174}else if((L|0)==59){bw=bu;bx=bv;L=63}else if((L|0)==102){if((a[aA]&1)==0){bm=by;bn=bz;bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}J2(c[aF>>2]|0);bm=by;bn=bz;bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}else if((L|0)==132){bC=bA;bD=bB;L=136}if((L|0)==63){au=c[aM>>2]|0;at=c[aN>>2]|0;aG=au;while(1){if((aG|0)==(at|0)){bE=at;break}if((c[aG>>2]|0)==(aQ|0)){bE=aG;break}else{aG=aG+4|0}}aG=bE-au>>2;aF=au+(aG+1<<2)|0;aA=at-aF|0;Kc(au+(aG<<2)|0,aF|0,aA|0)|0;aF=au+((aA>>2)+aG<<2)|0;aG=c[aN>>2]|0;if((aF|0)!=(aG|0)){c[aN>>2]=aG+(~((aG-4+(-aF|0)|0)>>>2)<<2)}J2(aS);bm=bx;bn=bw;bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}else if((L|0)==136){aF=c[a1>>2]|0;aG=c[a2>>2]|0;aA=aF;while(1){if((aA|0)==(aG|0)){bF=aG;break}if((c[aA>>2]|0)==(a3|0)){bF=aA;break}else{aA=aA+4|0}}aA=bF-aF>>2;au=aF+(aA+1<<2)|0;at=aG-au|0;Kc(aF+(aA<<2)|0,au|0,at|0)|0;au=aF+((at>>2)+aA<<2)|0;aA=c[a2>>2]|0;if((au|0)!=(aA|0)){c[a2>>2]=aA+(~((aA-4+(-au|0)|0)>>>2)<<2)}J2(a5);bm=bD;bn=bC;bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}else if((L|0)==174){au=c[ba>>2]|0;aA=c[bb>>2]|0;at=au;while(1){if((at|0)==(aA|0)){bG=aA;break}if((c[at>>2]|0)==(bc|0)){bG=at;break}else{at=at+4|0}}at=bG-au>>2;aF=au+(at+1<<2)|0;aG=aA-aF|0;Kc(au+(at<<2)|0,aF|0,aG|0)|0;aF=au+((aG>>2)+at<<2)|0;at=c[bb>>2]|0;if((aF|0)!=(at|0)){c[bb>>2]=at+(~((at-4+(-aF|0)|0)>>>2)<<2)}J2(bf);bm=bl;bn=bk;bo=bm;bp=0;bq=bo;br=bn;be(bq|0)}}}while(0);bk=c[E>>2]|0;E=c[G>>2]|0;bl=bk;while(1){if((bl|0)==(E|0)){bH=E;break}if((c[bl>>2]|0)==(I|0)){bH=bl;break}else{bl=bl+4|0}}bl=bH-bk>>2;bH=bk+(bl+1<<2)|0;I=E-bH|0;Kc(bk+(bl<<2)|0,bH|0,I|0)|0;bH=bk+((I>>2)+bl<<2)|0;bl=c[G>>2]|0;if((bH|0)!=(bl|0)){c[G>>2]=bl+(~((bl-4+(-bH|0)|0)>>>2)<<2)}J2(F);bm=Q;bn=R;bo=bm;bp=0;bq=bo;br=bn;be(bq|0);return 0}function tC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yr(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yt(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xS(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cS=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0,eo=0;d=i;i=i+344|0;e=d|0;f=d+8|0;g=d+24|0;h=d+32|0;j=d+40|0;k=d+56|0;l=d+64|0;m=d+72|0;n=d+88|0;o=d+96|0;p=d+104|0;q=d+120|0;r=d+128|0;s=d+136|0;t=d+152|0;u=d+160|0;v=d+168|0;w=d+184|0;y=d+192|0;z=d+200|0;A=d+216|0;B=d+224|0;C=d+232|0;D=d+248|0;E=d+256|0;F=d+272|0;G=d+336|0;H=G;I=i;i=i+12|0;i=i+7&-8;J=i;i=i+12|0;i=i+7&-8;L=i;i=i+12|0;i=i+7&-8;M=i;i=i+12|0;i=i+7&-8;N=i;i=i+12|0;i=i+7&-8;O=i;i=i+12|0;i=i+7&-8;P=i;i=i+12|0;i=i+7&-8;Q=i;i=i+12|0;i=i+7&-8;R=i;i=i+12|0;i=i+7&-8;S=i;i=i+12|0;i=i+7&-8;T=i;i=i+12|0;i=i+7&-8;U=i;i=i+12|0;i=i+7&-8;V=i;i=i+12|0;i=i+7&-8;W=i;i=i+12|0;i=i+7&-8;X=i;i=i+12|0;i=i+7&-8;Y=i;i=i+12|0;i=i+7&-8;Z=i;i=i+12|0;i=i+7&-8;_=i;i=i+12|0;i=i+7&-8;$=i;i=i+12|0;i=i+7&-8;aa=i;i=i+12|0;i=i+7&-8;ab=i;i=i+12|0;i=i+7&-8;ac=b|0;ad=c[ac>>2]|0;ae=J0(60)|0;c[D>>2]=ae;af=ad+4|0;ag=c[af>>2]|0;if((ag|0)==(c[ad+8>>2]|0)){ee(ad|0,D);ah=c[D>>2]|0}else{if((ag|0)==0){ai=0}else{c[ag>>2]=ae;ai=c[af>>2]|0}c[af>>2]=ai+4;ah=ae}ae=ah;ai=ah;ag=b+28|0;L8:do{if((a[ag]&1)==0){D=E;c[D>>2]=c[ag>>2];c[D+4>>2]=c[ag+4>>2];c[D+8>>2]=c[ag+8>>2];aj=16}else{D=c[b+36>>2]|0;ak=c[b+32>>2]|0;do{if(ak>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ak>>>0<11>>>0){a[E]=ak<<1;al=E+1|0}else{am=ak+16&-16;an=(x=0,as(230,am|0)|0);if(x){x=0;break}c[E+8>>2]=an;c[E>>2]=am|1;c[E+4>>2]=ak;al=an}Kb(al|0,D|0,ak)|0;a[al+ak|0]=0;aj=16;break L8}}while(0);ak=bQ(-1,-1)|0;ar=ak;at=K}}while(0);do{if((aj|0)==16){al=b+44|0;ak=C;c[ak>>2]=c[al>>2];c[ak+4>>2]=c[al+4>>2];c[ak+8>>2]=c[al+8>>2];x=0;aB(2,ai|0,E|0,C|0,0,0,0);if(x){x=0;ak=bQ(-1,-1)|0;D=ak;ak=K;if((a[E]&1)==0){ar=D;at=ak;break}J2(c[E+8>>2]|0);ar=D;at=ak;break}if((a[E]&1)!=0){J2(c[E+8>>2]|0)}ak=b+20|0;D=b+24|0;if((c[ak>>2]|0)>>>0>=(c[D>>2]|0)>>>0){i=d;return ai|0}an=aa+8|0;am=aa|0;au=aa+4|0;av=ab|0;aw=ab+4|0;ax=ab+8|0;ay=aa;az=ah+40|0;aA=az;aC=Z;aD=_;aE=b+56|0;aF=b+60|0;aG=$;aH=$+1|0;aI=f;aJ=az+8|0;aK=az+12|0;aL=az+4|0;aM=Z+8|0;aN=$+8|0;aO=$|0;aQ=$+4|0;aR=b+36|0;aS=b+32|0;aU=Z+1|0;aV=Z|0;aW=Z+4|0;aX=Y;aY=b+56|0;aZ=aY|0;a_=ah+56|0;a$=Y+8|0;a0=Y+1|0;a1=Y|0;a2=Y+4|0;a3=V;a4=W;a5=X;a6=X+1|0;a7=m;a8=V+8|0;a9=X+8|0;ba=X|0;bb=X+4|0;bc=V+1|0;bd=V|0;bf=V+4|0;bg=S;bh=T;bi=U;bj=U+1|0;bk=p;bl=S+8|0;bm=U+8|0;bn=U|0;bo=U+4|0;bp=S+1|0;bq=S|0;br=S+4|0;bs=P;bt=Q;bu=R;bv=R+1|0;bw=s;bx=P+8|0;by=R+8|0;bz=R|0;bA=R+4|0;bB=P+1|0;bC=P|0;bD=P+4|0;bE=M;bF=N;bG=O;bH=O+1|0;bI=v;bJ=M+8|0;bK=O+8|0;bL=O|0;bM=O+4|0;bN=M+1|0;bO=M|0;bP=M+4|0;bR=L;bS=L+8|0;bT=L+1|0;bU=L|0;bV=L+4|0;bW=I;bX=J;bY=F+28|0;bZ=F+4|0;b_=I+8|0;b$=F+8|0;b0=F+36|0;b1=I+1|0;b2=I|0;b3=I+4|0;b4=0;L33:while(1){do{if((tN(b)|0)==0){if((sp(b)|0)!=0){b5=c[ac>>2]|0;b6=J0(52)|0;c[A>>2]=b6;b7=b5+4|0;b8=c[b7>>2]|0;if((b8|0)==(c[b5+8>>2]|0)){ee(b5|0,A);b9=c[A>>2]|0}else{if((b8|0)==0){ca=0}else{c[b8>>2]=b6;ca=c[b7>>2]|0}c[b7>>2]=ca+4;b9=b6}cb=b9;if((a[ag]&1)==0){c[bR>>2]=c[ag>>2];c[bR+4>>2]=c[ag+4>>2];c[bR+8>>2]=c[ag+8>>2]}else{b6=c[aR>>2]|0;b8=c[aS>>2]|0;if(b8>>>0>4294967279>>>0){aj=73;break L33}if(b8>>>0<11>>>0){a[bR]=b8<<1;cc=bT}else{cd=b8+16&-16;ce=(x=0,as(230,cd|0)|0);if(x){x=0;aj=90;break L33}c[bS>>2]=ce;c[bU>>2]=cd|1;c[bV>>2]=b8;cc=ce}Kb(cc|0,b6|0,b8)|0;a[cc+b8|0]=0}b8=z;c[b8>>2]=c[al>>2];c[b8+4>>2]=c[al+4>>2];c[b8+8>>2]=c[al+8>>2];x=0;ao(14,b9|0,L|0,z|0,aY|0,0);if(x){x=0;cf=1;aj=93;break L33}b8=b9;c[y>>2]=b8;b6=c[aJ>>2]|0;ce=b6;if((b6|0)==(c[aK>>2]|0)){x=0;aq(370,aL|0,y|0);if(x){x=0;cf=0;aj=93;break L33}cg=c[y>>2]|0}else{if((b6|0)==0){ch=0}else{c[ce>>2]=b8;ch=c[aJ>>2]|0}c[aJ>>2]=ch+4;cg=b8}x=0;aq(c[c[az>>2]>>2]|0,aA|0,cg|0);if(x){x=0;cf=0;aj=93;break L33}if((a[bR]&1)==0){break}J2(c[bS>>2]|0);break}if((tJ(b)|0)!=0){ci=c[ac>>2]|0;b8=J0(52)|0;c[w>>2]=b8;cj=ci+4|0;ce=c[cj>>2]|0;if((ce|0)==(c[ci+8>>2]|0)){ee(ci|0,w);ck=c[w>>2]|0}else{if((ce|0)==0){cl=0}else{c[ce>>2]=b8;cl=c[cj>>2]|0}c[cj>>2]=cl+4;ck=b8}cm=ck;b8=ck;if((a[ag]&1)==0){c[bE>>2]=c[ag>>2];c[bE+4>>2]=c[ag+4>>2];c[bE+8>>2]=c[ag+8>>2]}else{ce=c[aR>>2]|0;b6=c[aS>>2]|0;if(b6>>>0>4294967279>>>0){aj=111;break L33}if(b6>>>0<11>>>0){a[bE]=b6<<1;cn=bN}else{cd=b6+16&-16;co=(x=0,as(230,cd|0)|0);if(x){x=0;aj=137;break L33}c[bJ>>2]=co;c[bO>>2]=cd|1;c[bP>>2]=b6;cn=co}Kb(cn|0,ce|0,b6)|0;a[cn+b6|0]=0}c[bF>>2]=c[al>>2];c[bF+4>>2]=c[al+4>>2];c[bF+8>>2]=c[al+8>>2];b6=c[aE>>2]|0;ce=(c[aF>>2]|0)-b6|0;if(ce>>>0>4294967279>>>0){aj=119;break L33}if(ce>>>0<11>>>0){a[bG]=ce<<1;cp=bH}else{co=ce+16&-16;cd=(x=0,as(230,co|0)|0);if(x){x=0;aj=140;break L33}c[bK>>2]=cd;c[bL>>2]=co|1;c[bM>>2]=ce;cp=cd}Kb(cp|0,b6|0,ce)|0;a[cp+ce|0]=0;c[bI>>2]=c[bF>>2];c[bI+4>>2]=c[bF+4>>2];c[bI+8>>2]=c[bF+8>>2];x=0;ao(30,b8|0,M|0,v|0,1,O|0);if(x){x=0;cq=1;aj=143;break L33}b8=ck;c[u>>2]=b8;ce=c[aJ>>2]|0;b6=ce;if((ce|0)==(c[aK>>2]|0)){x=0;aq(370,aL|0,u|0);if(x){x=0;cq=0;aj=143;break L33}cr=c[u>>2]|0}else{if((ce|0)==0){cs=0}else{c[b6>>2]=b8;cs=c[aJ>>2]|0}c[aJ>>2]=cs+4;cr=b8}x=0;aq(c[c[az>>2]>>2]|0,aA|0,cr|0);if(x){x=0;cq=0;aj=143;break L33}if((a[bG]&1)!=0){J2(c[bK>>2]|0)}if((a[bE]&1)==0){break}J2(c[bJ>>2]|0);break}if((tK(b)|0)!=0){ct=c[ac>>2]|0;b8=J0(52)|0;c[t>>2]=b8;cu=ct+4|0;b6=c[cu>>2]|0;if((b6|0)==(c[ct+8>>2]|0)){ee(ct|0,t);cv=c[t>>2]|0}else{if((b6|0)==0){cw=0}else{c[b6>>2]=b8;cw=c[cu>>2]|0}c[cu>>2]=cw+4;cv=b8}cx=cv;b8=cv;if((a[ag]&1)==0){c[bs>>2]=c[ag>>2];c[bs+4>>2]=c[ag+4>>2];c[bs+8>>2]=c[ag+8>>2]}else{b6=c[aR>>2]|0;ce=c[aS>>2]|0;if(ce>>>0>4294967279>>>0){aj=163;break L33}if(ce>>>0<11>>>0){a[bs]=ce<<1;cz=bB}else{cd=ce+16&-16;co=(x=0,as(230,cd|0)|0);if(x){x=0;aj=189;break L33}c[bx>>2]=co;c[bC>>2]=cd|1;c[bD>>2]=ce;cz=co}Kb(cz|0,b6|0,ce)|0;a[cz+ce|0]=0}c[bt>>2]=c[al>>2];c[bt+4>>2]=c[al+4>>2];c[bt+8>>2]=c[al+8>>2];ce=c[aE>>2]|0;b6=(c[aF>>2]|0)-ce|0;if(b6>>>0>4294967279>>>0){aj=171;break L33}if(b6>>>0<11>>>0){a[bu]=b6<<1;cA=bv}else{co=b6+16&-16;cd=(x=0,as(230,co|0)|0);if(x){x=0;aj=192;break L33}c[by>>2]=cd;c[bz>>2]=co|1;c[bA>>2]=b6;cA=cd}Kb(cA|0,ce|0,b6)|0;a[cA+b6|0]=0;c[bw>>2]=c[bt>>2];c[bw+4>>2]=c[bt+4>>2];c[bw+8>>2]=c[bt+8>>2];x=0;ao(30,b8|0,P|0,s|0,2,R|0);if(x){x=0;cB=1;aj=195;break L33}b8=cv;c[r>>2]=b8;b6=c[aJ>>2]|0;ce=b6;if((b6|0)==(c[aK>>2]|0)){x=0;aq(370,aL|0,r|0);if(x){x=0;cB=0;aj=195;break L33}cC=c[r>>2]|0}else{if((b6|0)==0){cD=0}else{c[ce>>2]=b8;cD=c[aJ>>2]|0}c[aJ>>2]=cD+4;cC=b8}x=0;aq(c[c[az>>2]>>2]|0,aA|0,cC|0);if(x){x=0;cB=0;aj=195;break L33}if((a[bu]&1)!=0){J2(c[by>>2]|0)}if((a[bs]&1)==0){break}J2(c[bx>>2]|0);break}if((sM(b)|0)!=0){cE=c[ac>>2]|0;b8=J0(52)|0;c[q>>2]=b8;cF=cE+4|0;ce=c[cF>>2]|0;if((ce|0)==(c[cE+8>>2]|0)){ee(cE|0,q);cG=c[q>>2]|0}else{if((ce|0)==0){cH=0}else{c[ce>>2]=b8;cH=c[cF>>2]|0}c[cF>>2]=cH+4;cG=b8}cI=cG;b8=cG;if((a[ag]&1)==0){c[bg>>2]=c[ag>>2];c[bg+4>>2]=c[ag+4>>2];c[bg+8>>2]=c[ag+8>>2]}else{ce=c[aR>>2]|0;b6=c[aS>>2]|0;if(b6>>>0>4294967279>>>0){aj=215;break L33}if(b6>>>0<11>>>0){a[bg]=b6<<1;cJ=bp}else{cd=b6+16&-16;co=(x=0,as(230,cd|0)|0);if(x){x=0;aj=241;break L33}c[bl>>2]=co;c[bq>>2]=cd|1;c[br>>2]=b6;cJ=co}Kb(cJ|0,ce|0,b6)|0;a[cJ+b6|0]=0}c[bh>>2]=c[al>>2];c[bh+4>>2]=c[al+4>>2];c[bh+8>>2]=c[al+8>>2];b6=c[aE>>2]|0;ce=(c[aF>>2]|0)-b6|0;if(ce>>>0>4294967279>>>0){aj=223;break L33}if(ce>>>0<11>>>0){a[bi]=ce<<1;cK=bj}else{co=ce+16&-16;cd=(x=0,as(230,co|0)|0);if(x){x=0;aj=244;break L33}c[bm>>2]=cd;c[bn>>2]=co|1;c[bo>>2]=ce;cK=cd}Kb(cK|0,b6|0,ce)|0;a[cK+ce|0]=0;c[bk>>2]=c[bh>>2];c[bk+4>>2]=c[bh+4>>2];c[bk+8>>2]=c[bh+8>>2];x=0;ao(30,b8|0,S|0,p|0,0,U|0);if(x){x=0;cL=1;aj=247;break L33}b8=cG;c[o>>2]=b8;ce=c[aJ>>2]|0;b6=ce;if((ce|0)==(c[aK>>2]|0)){x=0;aq(370,aL|0,o|0);if(x){x=0;cL=0;aj=247;break L33}cM=c[o>>2]|0}else{if((ce|0)==0){cN=0}else{c[b6>>2]=b8;cN=c[aJ>>2]|0}c[aJ>>2]=cN+4;cM=b8}x=0;aq(c[c[az>>2]>>2]|0,aA|0,cM|0);if(x){x=0;cL=0;aj=247;break L33}if((a[bi]&1)!=0){J2(c[bm>>2]|0)}if((a[bg]&1)==0){break}J2(c[bl>>2]|0);break}if((tL(b)|0)!=0){cO=c[ac>>2]|0;b8=J0(52)|0;c[n>>2]=b8;cP=cO+4|0;b6=c[cP>>2]|0;if((b6|0)==(c[cO+8>>2]|0)){ee(cO|0,n);cQ=c[n>>2]|0}else{if((b6|0)==0){cR=0}else{c[b6>>2]=b8;cR=c[cP>>2]|0}c[cP>>2]=cR+4;cQ=b8}cS=cQ;b8=cQ;if((a[ag]&1)==0){c[a3>>2]=c[ag>>2];c[a3+4>>2]=c[ag+4>>2];c[a3+8>>2]=c[ag+8>>2]}else{b6=c[aR>>2]|0;ce=c[aS>>2]|0;if(ce>>>0>4294967279>>>0){aj=267;break L33}if(ce>>>0<11>>>0){a[a3]=ce<<1;cT=bc}else{cd=ce+16&-16;co=(x=0,as(230,cd|0)|0);if(x){x=0;aj=293;break L33}c[a8>>2]=co;c[bd>>2]=cd|1;c[bf>>2]=ce;cT=co}Kb(cT|0,b6|0,ce)|0;a[cT+ce|0]=0}c[a4>>2]=c[al>>2];c[a4+4>>2]=c[al+4>>2];c[a4+8>>2]=c[al+8>>2];ce=c[aE>>2]|0;b6=(c[aF>>2]|0)-ce|0;if(b6>>>0>4294967279>>>0){aj=275;break L33}if(b6>>>0<11>>>0){a[a5]=b6<<1;cU=a6}else{co=b6+16&-16;cd=(x=0,as(230,co|0)|0);if(x){x=0;aj=296;break L33}c[a9>>2]=cd;c[ba>>2]=co|1;c[bb>>2]=b6;cU=cd}Kb(cU|0,ce|0,b6)|0;a[cU+b6|0]=0;c[a7>>2]=c[a4>>2];c[a7+4>>2]=c[a4+4>>2];c[a7+8>>2]=c[a4+8>>2];x=0;ao(30,b8|0,V|0,m|0,3,X|0);if(x){x=0;cV=1;aj=299;break L33}b8=cQ;c[l>>2]=b8;b6=c[aJ>>2]|0;ce=b6;if((b6|0)==(c[aK>>2]|0)){x=0;aq(370,aL|0,l|0);if(x){x=0;cV=0;aj=299;break L33}cW=c[l>>2]|0}else{if((b6|0)==0){cX=0}else{c[ce>>2]=b8;cX=c[aJ>>2]|0}c[aJ>>2]=cX+4;cW=b8}x=0;aq(c[c[az>>2]>>2]|0,aA|0,cW|0);if(x){x=0;cV=0;aj=299;break L33}if((a[a5]&1)!=0){J2(c[a9>>2]|0)}if((a[a3]&1)==0){break}J2(c[a8>>2]|0);break}if((sg(b)|0)!=0){cY=c[ac>>2]|0;b8=J0(52)|0;c[k>>2]=b8;cZ=cY+4|0;ce=c[cZ>>2]|0;if((ce|0)==(c[cY+8>>2]|0)){ee(cY|0,k);c_=c[k>>2]|0}else{if((ce|0)==0){c$=0}else{c[ce>>2]=b8;c$=c[cZ>>2]|0}c[cZ>>2]=c$+4;c_=b8}c0=c_;if((a[ag]&1)==0){c[aX>>2]=c[ag>>2];c[aX+4>>2]=c[ag+4>>2];c[aX+8>>2]=c[ag+8>>2]}else{b8=c[aR>>2]|0;ce=c[aS>>2]|0;if(ce>>>0>4294967279>>>0){aj=319;break L33}if(ce>>>0<11>>>0){a[aX]=ce<<1;c1=a0}else{b6=ce+16&-16;cd=(x=0,as(230,b6|0)|0);if(x){x=0;aj=338;break L33}c[a$>>2]=cd;c[a1>>2]=b6|1;c[a2>>2]=ce;c1=cd}Kb(c1|0,b8|0,ce)|0;a[c1+ce|0]=0}ce=j;c[ce>>2]=c[al>>2];c[ce+4>>2]=c[al+4>>2];c[ce+8>>2]=c[al+8>>2];x=0;ao(14,c_|0,Y|0,j|0,aY|0,0);if(x){x=0;c2=1;aj=341;break L33}ce=c_;c[h>>2]=ce;b8=c[aJ>>2]|0;cd=b8;if((b8|0)==(c[aK>>2]|0)){x=0;aq(370,aL|0,h|0);if(x){x=0;c2=0;aj=341;break L33}c3=c[h>>2]|0}else{if((b8|0)==0){c4=0}else{c[cd>>2]=ce;c4=c[aJ>>2]|0}c[aJ>>2]=c4+4;c3=ce}x=0;aq(c[c[az>>2]>>2]|0,aA|0,c3|0);if(x){x=0;c2=0;aj=341;break L33}if((a[aX]&1)!=0){J2(c[a$>>2]|0)}if((b4|0)!=0){break}a[a_]=a[c[aZ>>2]|0]|0;break}if((st(b)|0)==0){ce=J0(48)|0;c[an>>2]=ce;c[am>>2]=49;c[au>>2]=32;Kb(ce|0,4432,32)|0;a[ce+32|0]=0;c[av>>2]=0;c[aw>>2]=0;c[ax>>2]=0;x=0;aP(466,b|0,aa|0,ab|0);if(x){x=0;aj=405;break L33}if((a[ay]&1)==0){break}J2(c[an>>2]|0);break}c5=c[ac>>2]|0;ce=J0(48)|0;c[g>>2]=ce;c6=c5+4|0;cd=c[c6>>2]|0;if((cd|0)==(c[c5+8>>2]|0)){ee(c5|0,g);c7=c[g>>2]|0}else{if((cd|0)==0){c8=0}else{c[cd>>2]=ce;c8=c[c6>>2]|0}c[c6>>2]=c8+4;c7=ce}c9=c7;ce=c7;if((a[ag]&1)==0){c[aC>>2]=c[ag>>2];c[aC+4>>2]=c[ag+4>>2];c[aC+8>>2]=c[ag+8>>2]}else{cd=c[aR>>2]|0;b8=c[aS>>2]|0;if(b8>>>0>4294967279>>>0){aj=359;break L33}if(b8>>>0<11>>>0){a[aC]=b8<<1;da=aU}else{b6=b8+16&-16;co=(x=0,as(230,b6|0)|0);if(x){x=0;aj=385;break L33}c[aM>>2]=co;c[aV>>2]=b6|1;c[aW>>2]=b8;da=co}Kb(da|0,cd|0,b8)|0;a[da+b8|0]=0}c[aD>>2]=c[al>>2];c[aD+4>>2]=c[al+4>>2];c[aD+8>>2]=c[al+8>>2];b8=c[aE>>2]|0;cd=(c[aF>>2]|0)-b8|0;if(cd>>>0>4294967279>>>0){aj=367;break L33}if(cd>>>0<11>>>0){a[aG]=cd<<1;db=aH}else{co=cd+16&-16;b6=(x=0,as(230,co|0)|0);if(x){x=0;aj=388;break L33}c[aN>>2]=b6;c[aO>>2]=co|1;c[aQ>>2]=cd;db=b6}Kb(db|0,b8|0,cd)|0;a[db+cd|0]=0;c[aI>>2]=c[aD>>2];c[aI+4>>2]=c[aD+4>>2];c[aI+8>>2]=c[aD+8>>2];x=0;aT(2,ce|0,Z|0,f|0,$|0);if(x){x=0;dc=1;aj=391;break L33}ce=c7;c[e>>2]=ce;cd=c[aJ>>2]|0;b8=cd;if((cd|0)==(c[aK>>2]|0)){x=0;aq(370,aL|0,e|0);if(x){x=0;dc=0;aj=391;break L33}dd=c[e>>2]|0}else{if((cd|0)==0){de=0}else{c[b8>>2]=ce;de=c[aJ>>2]|0}c[aJ>>2]=de+4;dd=ce}x=0;aq(c[c[az>>2]>>2]|0,aA|0,dd|0);if(x){x=0;dc=0;aj=391;break L33}if((a[aG]&1)!=0){J2(c[aN>>2]|0)}if((a[aC]&1)==0){break}J2(c[aM>>2]|0)}else{ce=(c[aF>>2]|0)-1|0;c[G>>2]=(c[aE>>2]|0)+2;c[G+4>>2]=ce;ce=c[ac>>2]|0;if((a[ag]&1)==0){c[bW>>2]=c[ag>>2];c[bW+4>>2]=c[ag+4>>2];c[bW+8>>2]=c[ag+8>>2]}else{b8=c[aR>>2]|0;cd=c[aS>>2]|0;if(cd>>>0>4294967279>>>0){aj=25;break L33}if(cd>>>0<11>>>0){a[bW]=cd<<1;df=b1}else{b6=cd+16&-16;co=J0(b6)|0;c[b_>>2]=co;c[b2>>2]=b6|1;c[b3>>2]=cd;df=co}Kb(df|0,b8|0,cd)|0;a[df+cd|0]=0}c[bX>>2]=c[al>>2];c[bX+4>>2]=c[al+4>>2];c[bX+8>>2]=c[al+8>>2];x=0;ao(16,F|0,H|0,ce|0,I|0,J|0);if(x){x=0;aj=55;break L33}ce=(x=0,as(158,F|0)|0);if(x){x=0;aj=56;break L33}if((a[bY]&1)!=0){J2(c[b0>>2]|0)}cd=c[bZ>>2]|0;b8=cd;if((cd|0)!=0){co=c[b$>>2]|0;if((cd|0)!=(co|0)){c[b$>>2]=co+(~((co-4+(-b8|0)|0)>>>2)<<2)}J2(cd)}if((a[bW]&1)!=0){J2(c[b_>>2]|0)}a[ce+29|0]=1;c[B>>2]=ce;cd=c[aJ>>2]|0;b8=cd;if((cd|0)==(c[aK>>2]|0)){eq(aL,B);dg=c[B>>2]|0}else{if((cd|0)==0){dh=0}else{c[b8>>2]=ce;dh=c[aJ>>2]|0}c[aJ>>2]=dh+4;dg=ce}cy[c[c[az>>2]>>2]&1023](aA,dg)}}while(0);if((c[ak>>2]|0)>>>0<(c[D>>2]|0)>>>0){b4=b4+1|0}else{aj=410;break}}do{if((aj|0)==192){b4=bQ(-1,-1)|0;di=K;dj=b4;aj=194}else if((aj|0)==391){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[aG]&1)==0){dk=dc;dl=D;dm=b4;aj=393;break}J2(c[aN>>2]|0);dk=dc;dl=D;dm=b4;aj=393}else if((aj|0)==137){b4=bQ(-1,-1)|0;dn=K;dp=b4;aj=139}else if((aj|0)==367){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dq=K;dr=b4;aj=390;break}}else if((aj|0)==405){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[ay]&1)==0){ds=D;dt=b4;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}J2(c[an>>2]|0);ds=D;dt=b4;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else if((aj|0)==163){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dy=K;dz=b4;aj=191;break}}else if((aj|0)==385){b4=bQ(-1,-1)|0;dA=K;dB=b4;aj=387}else if((aj|0)==388){b4=bQ(-1,-1)|0;dq=K;dr=b4;aj=390}else if((aj|0)==171){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;di=K;dj=b4;aj=194;break}}else if((aj|0)==189){b4=bQ(-1,-1)|0;dy=K;dz=b4;aj=191}else if((aj|0)==73){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dC=K;dD=b4;aj=92;break}}else if((aj|0)==56){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[bY]&1)!=0){J2(c[b0>>2]|0)}ak=c[bZ>>2]|0;if((ak|0)==0){dE=D;dF=b4;aj=62;break}aA=c[b$>>2]|0;if((ak|0)!=(aA|0)){c[b$>>2]=aA+(~((aA-4+(-ak|0)|0)>>>2)<<2)}J2(ak);dE=D;dF=b4;aj=62}else if((aj|0)==267){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dG=K;dH=b4;aj=295;break}}else if((aj|0)==90){b4=bQ(-1,-1)|0;dC=K;dD=b4;aj=92}else if((aj|0)==275){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dI=K;dJ=b4;aj=298;break}}else if((aj|0)==293){b4=bQ(-1,-1)|0;dG=K;dH=b4;aj=295}else if((aj|0)==296){b4=bQ(-1,-1)|0;dI=K;dJ=b4;aj=298}else if((aj|0)==299){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[a5]&1)==0){dK=cV;dL=D;dM=b4;aj=301;break}J2(c[a9>>2]|0);dK=cV;dL=D;dM=b4;aj=301}else if((aj|0)==319){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dN=K;dO=b4;aj=340;break}}else if((aj|0)==223){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dP=K;dQ=b4;aj=246;break}}else if((aj|0)==241){b4=bQ(-1,-1)|0;dR=K;dS=b4;aj=243}else if((aj|0)==244){b4=bQ(-1,-1)|0;dP=K;dQ=b4;aj=246}else if((aj|0)==247){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[bi]&1)==0){dT=cL;dU=D;dV=b4;aj=249;break}J2(c[bm>>2]|0);dT=cL;dU=D;dV=b4;aj=249}else if((aj|0)==359){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dA=K;dB=b4;aj=387;break}}else if((aj|0)==25){CJ(0);return 0}else if((aj|0)==195){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[bu]&1)==0){dW=cB;dX=D;dY=b4;aj=197;break}J2(c[by>>2]|0);dW=cB;dX=D;dY=b4;aj=197}else if((aj|0)==93){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[bR]&1)==0){if(cf){dZ=b4;d_=D;aj=96;break}else{ds=D;dt=b4}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else{J2(c[bS>>2]|0);if(cf){dZ=b4;d_=D;aj=96;break}else{ds=D;dt=b4}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}}else if((aj|0)==140){b4=bQ(-1,-1)|0;d$=K;d0=b4;aj=142}else if((aj|0)==143){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[bG]&1)==0){d1=cq;d2=D;d3=b4;aj=145;break}J2(c[bK>>2]|0);d1=cq;d2=D;d3=b4;aj=145}else if((aj|0)==215){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dR=K;dS=b4;aj=243;break}}else if((aj|0)==338){b4=bQ(-1,-1)|0;dN=K;dO=b4;aj=340}else if((aj|0)==341){b4=bQ(-1,-1)|0;D=b4;b4=K;if((a[aX]&1)==0){if(c2){d4=b4;d5=D;aj=344;break}else{ds=D;dt=b4}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else{J2(c[a$>>2]|0);if(c2){d4=b4;d5=D;aj=344;break}else{ds=D;dt=b4}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}}else if((aj|0)==119){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;d$=K;d0=b4;aj=142;break}}else if((aj|0)==111){x=0;ap(232,0);if(!x){return 0}else{x=0;b4=bQ(-1,-1)|0;dn=K;dp=b4;aj=139;break}}else if((aj|0)==55){b4=bQ(-1,-1)|0;dE=b4;dF=K;aj=62}else if((aj|0)==410){i=d;return ai|0}}while(0);if((aj|0)==191){d6=dy;d7=dz;aj=200}else if((aj|0)==194){dW=1;dX=dj;dY=di;aj=197}else if((aj|0)==390){dk=1;dl=dr;dm=dq;aj=393}else if((aj|0)==139){d8=dn;d9=dp;aj=148}else if((aj|0)==387){ea=dA;eb=dB;aj=396}else if((aj|0)==62){if((a[bW]&1)==0){ds=dE;dt=dF;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}J2(c[b_>>2]|0);ds=dE;dt=dF;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else if((aj|0)==295){ec=dG;ed=dH;aj=304}else if((aj|0)==298){dK=1;dL=dJ;dM=dI;aj=301}else if((aj|0)==243){ef=dR;eg=dS;aj=252}else if((aj|0)==246){dT=1;dU=dQ;dV=dP;aj=249}else if((aj|0)==92){dZ=dC;d_=dD;aj=96}else if((aj|0)==142){d1=1;d2=d0;d3=d$;aj=145}else if((aj|0)==340){d4=dN;d5=dO;aj=344}do{if((aj|0)==393){if((a[aC]&1)==0){if(dk){ea=dm;eb=dl;aj=396;break}else{ds=dl;dt=dm}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else{J2(c[aM>>2]|0);if(dk){ea=dm;eb=dl;aj=396;break}else{ds=dl;dt=dm}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}}else if((aj|0)==301){if((a[a3]&1)==0){if(dK){ec=dM;ed=dL;aj=304;break}else{ds=dL;dt=dM}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else{J2(c[a8>>2]|0);if(dK){ec=dM;ed=dL;aj=304;break}else{ds=dL;dt=dM}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}}else if((aj|0)==197){if((a[bs]&1)==0){if(dW){d6=dY;d7=dX;aj=200;break}else{ds=dX;dt=dY}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else{J2(c[bx>>2]|0);if(dW){d6=dY;d7=dX;aj=200;break}else{ds=dX;dt=dY}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}}else if((aj|0)==96){a$=c[b5>>2]|0;aX=c[b7>>2]|0;bK=a$;while(1){if((bK|0)==(aX|0)){eh=aX;break}if((c[bK>>2]|0)==(b9|0)){eh=bK;break}else{bK=bK+4|0}}bK=eh-a$>>2;bG=a$+(bK+1<<2)|0;bS=aX-bG|0;Kc(a$+(bK<<2)|0,bG|0,bS|0)|0;bG=a$+((bS>>2)+bK<<2)|0;bK=c[b7>>2]|0;if((bG|0)!=(bK|0)){c[b7>>2]=bK+(~((bK-4+(-bG|0)|0)>>>2)<<2)}J2(cb);ds=d_;dt=dZ;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else if((aj|0)==145){if((a[bE]&1)==0){if(d1){d8=d3;d9=d2;aj=148;break}else{ds=d2;dt=d3}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else{J2(c[bJ>>2]|0);if(d1){d8=d3;d9=d2;aj=148;break}else{ds=d2;dt=d3}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}}else if((aj|0)==344){bG=c[cY>>2]|0;bK=c[cZ>>2]|0;bS=bG;while(1){if((bS|0)==(bK|0)){ei=bK;break}if((c[bS>>2]|0)==(c_|0)){ei=bS;break}else{bS=bS+4|0}}bS=ei-bG>>2;a$=bG+(bS+1<<2)|0;aX=bK-a$|0;Kc(bG+(bS<<2)|0,a$|0,aX|0)|0;a$=bG+((aX>>2)+bS<<2)|0;bS=c[cZ>>2]|0;if((a$|0)!=(bS|0)){c[cZ>>2]=bS+(~((bS-4+(-a$|0)|0)>>>2)<<2)}J2(c0);ds=d5;dt=d4;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else if((aj|0)==249){if((a[bg]&1)==0){if(dT){ef=dV;eg=dU;aj=252;break}else{ds=dU;dt=dV}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else{J2(c[bl>>2]|0);if(dT){ef=dV;eg=dU;aj=252;break}else{ds=dU;dt=dV}du=ds;dv=0;dw=du;dx=dt;be(dw|0)}}}while(0);if((aj|0)==396){bl=c[c5>>2]|0;bg=c[c6>>2]|0;bJ=bl;while(1){if((bJ|0)==(bg|0)){ej=bg;break}if((c[bJ>>2]|0)==(c7|0)){ej=bJ;break}else{bJ=bJ+4|0}}bJ=ej-bl>>2;bE=bl+(bJ+1<<2)|0;bx=bg-bE|0;Kc(bl+(bJ<<2)|0,bE|0,bx|0)|0;bE=bl+((bx>>2)+bJ<<2)|0;bJ=c[c6>>2]|0;if((bE|0)!=(bJ|0)){c[c6>>2]=bJ+(~((bJ-4+(-bE|0)|0)>>>2)<<2)}J2(c9);ds=eb;dt=ea;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else if((aj|0)==304){bE=c[cO>>2]|0;bJ=c[cP>>2]|0;bx=bE;while(1){if((bx|0)==(bJ|0)){ek=bJ;break}if((c[bx>>2]|0)==(cQ|0)){ek=bx;break}else{bx=bx+4|0}}bx=ek-bE>>2;bl=bE+(bx+1<<2)|0;bg=bJ-bl|0;Kc(bE+(bx<<2)|0,bl|0,bg|0)|0;bl=bE+((bg>>2)+bx<<2)|0;bx=c[cP>>2]|0;if((bl|0)!=(bx|0)){c[cP>>2]=bx+(~((bx-4+(-bl|0)|0)>>>2)<<2)}J2(cS);ds=ed;dt=ec;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else if((aj|0)==200){bl=c[ct>>2]|0;bx=c[cu>>2]|0;bg=bl;while(1){if((bg|0)==(bx|0)){el=bx;break}if((c[bg>>2]|0)==(cv|0)){el=bg;break}else{bg=bg+4|0}}bg=el-bl>>2;bE=bl+(bg+1<<2)|0;bJ=bx-bE|0;Kc(bl+(bg<<2)|0,bE|0,bJ|0)|0;bE=bl+((bJ>>2)+bg<<2)|0;bg=c[cu>>2]|0;if((bE|0)!=(bg|0)){c[cu>>2]=bg+(~((bg-4+(-bE|0)|0)>>>2)<<2)}J2(cx);ds=d7;dt=d6;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else if((aj|0)==148){bE=c[ci>>2]|0;bg=c[cj>>2]|0;bJ=bE;while(1){if((bJ|0)==(bg|0)){em=bg;break}if((c[bJ>>2]|0)==(ck|0)){em=bJ;break}else{bJ=bJ+4|0}}bJ=em-bE>>2;bl=bE+(bJ+1<<2)|0;bx=bg-bl|0;Kc(bE+(bJ<<2)|0,bl|0,bx|0)|0;bl=bE+((bx>>2)+bJ<<2)|0;bJ=c[cj>>2]|0;if((bl|0)!=(bJ|0)){c[cj>>2]=bJ+(~((bJ-4+(-bl|0)|0)>>>2)<<2)}J2(cm);ds=d9;dt=d8;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}else if((aj|0)==252){bl=c[cE>>2]|0;bJ=c[cF>>2]|0;bx=bl;while(1){if((bx|0)==(bJ|0)){en=bJ;break}if((c[bx>>2]|0)==(cG|0)){en=bx;break}else{bx=bx+4|0}}bx=en-bl>>2;bE=bl+(bx+1<<2)|0;bg=bJ-bE|0;Kc(bl+(bx<<2)|0,bE|0,bg|0)|0;bE=bl+((bg>>2)+bx<<2)|0;bx=c[cF>>2]|0;if((bE|0)!=(bx|0)){c[cF>>2]=bx+(~((bx-4+(-bE|0)|0)>>>2)<<2)}J2(cI);ds=eg;dt=ef;du=ds;dv=0;dw=du;dx=dt;be(dw|0)}}}while(0);ef=c[ad>>2]|0;ad=c[af>>2]|0;eg=ef;while(1){if((eg|0)==(ad|0)){eo=ad;break}if((c[eg>>2]|0)==(ah|0)){eo=eg;break}else{eg=eg+4|0}}eg=eo-ef>>2;eo=ef+(eg+1<<2)|0;ah=ad-eo|0;Kc(ef+(eg<<2)|0,eo|0,ah|0)|0;eo=ef+((ah>>2)+eg<<2)|0;eg=c[af>>2]|0;if((eo|0)!=(eg|0)){c[af>>2]=eg+(~((eg-4+(-eo|0)|0)>>>2)<<2)}J2(ae);ds=ar;dt=at;du=ds;dv=0;dw=du;dx=dt;be(dw|0);return 0}function tG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yI(e)|0;if((f|0)==0){g=0;return g|0}h=(xQ(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=h+o;h=e;f=0;while(1){n=h-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{h=n;f=f+1|0}}h=b+40|0;if((o|0)!=0){c[h>>2]=1}o=c[h>>2]|0;c[b+52>>2]=o+f;j=i;n=e;c[h>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function tH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yJ(e)|0;if((f|0)==0){g=0;return g|0}h=(xQ(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=h+o;h=e;f=0;while(1){n=h-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{h=n;f=f+1|0}}h=b+40|0;if((o|0)!=0){c[h>>2]=1}o=c[h>>2]|0;c[b+52>>2]=o+f;j=i;n=e;c[h>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=i;g=i;return g|0}function tI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yb(e)|0;if((f|0)==0){g=0;return g|0}h=(xQ(f)|0)!=0;i=h?0:f;if((i|0)==0){g=0;return g|0}f=b+48|0;h=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<i>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L7}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<i>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[f>>2]=h+n;h=e;f=0;while(1){o=h-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{h=o;f=f+1|0}}h=b+40|0;if((n|0)!=0){c[h>>2]=1}n=c[h>>2]|0;c[b+52>>2]=n+f;j=i;o=e;c[h>>2]=j-o+f+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=i;g=i;return g|0}function tJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=ym(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yn(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yp(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=yS(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xN(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xQ(e)|0;if((f|0)==0){g=0;return g|0}h=(a[f]|0)==58?f+1|0:0;if((h|0)==0){g=0;return g|0}f=b+48|0;i=c[f>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<h>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L7}else{n=l}m=k+1|0;if(m>>>0<h>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[f>>2]=i+o;i=e;f=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;f=f+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+f;j=h;n=e;c[i>>2]=j-n+f+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=h;g=h;return g|0}function tP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xT(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=(a[e]|0)==42?e+1|0:0;g=(f|0)!=0?f:e;if((g|0)==0){h=0;return h|0}f=xR(g)|0;if((f|0)==0){h=0;return h|0}g=b+48|0;i=c[g>>2]|0;j=c[d>>2]|0;L7:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L7}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[g>>2]=i+n;i=e;g=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;g=g+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+g;j=f;o=e;c[i>>2]=j-o+g+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;h=f;return h|0}function tR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x1(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=a[35536]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=35536;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==10){p=i+1|0}else if((n<<24>>24|0)==0){q=i;break L9}else{p=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=p}else{q=p;break}}}else{q=0}}while(0);c[g>>2]=h+q;h=e;g=0;while(1){p=h-1|0;if(p>>>0<k>>>0){break}if((a[p]|0)==10){break}else{h=p;g=g+1|0}}h=b+40|0;if((q|0)!=0){c[h>>2]=1}q=c[h>>2]|0;c[b+52>>2]=q+g;k=f;p=e;c[h>>2]=k-p+g+q;q=b+56|0;c[q>>2]=p;c[q+4>>2]=k;c[d>>2]=f;o=f;return o|0}function tT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x2(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x3(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x4(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x6(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x5(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x7(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function tZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x8(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function t_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=x9(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==10){n=l+1|0}else if((m<<24>>24|0)==0){o=l;break L4}else{n=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=n}else{o=n;break}}}else{o=0}}while(0);c[h>>2]=i+o;i=e;h=0;while(1){n=i-1|0;if(n>>>0<j>>>0){break}if((a[n]|0)==10){break}else{i=n;h=h+1|0}}i=b+40|0;if((o|0)!=0){c[i>>2]=1}o=c[i>>2]|0;c[b+52>>2]=o+h;j=f;n=e;c[i>>2]=j-n+h+o;o=b+56|0;c[o>>2]=n;c[o+4>>2]=j;c[d>>2]=f;g=f;return g|0}function t$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=xW(e)|0;if((f|0)==0){g=0;return g|0}h=b+48|0;i=c[h>>2]|0;j=c[d>>2]|0;L4:do{if(j>>>0<f>>>0){k=j;l=0;while(1){m=a[k]|0;if((m<<24>>24|0)==0){n=l;break L4}else if((m<<24>>24|0)==10){o=l+1|0}else{o=l}m=k+1|0;if(m>>>0<f>>>0){k=m;l=o}else{n=o;break}}}else{n=0}}while(0);c[h>>2]=i+n;i=e;h=0;while(1){o=i-1|0;if(o>>>0<j>>>0){break}if((a[o]|0)==10){break}else{i=o;h=h+1|0}}i=b+40|0;if((n|0)!=0){c[i>>2]=1}n=c[i>>2]|0;c[b+52>>2]=n+h;j=f;o=e;c[i>>2]=j-o+h+n;n=b+56|0;c[n>>2]=o;c[n+4>>2]=j;c[d>>2]=f;g=f;return g|0}function t0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+56|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=c[b>>2]|0;l=J0(60)|0;c[h>>2]=l;m=k+4|0;n=c[m>>2]|0;if((n|0)==(c[k+8>>2]|0)){ee(k|0,h);o=c[h>>2]|0}else{if((n|0)==0){p=0}else{c[n>>2]=l;p=c[m>>2]|0}c[m>>2]=p+4;o=l}l=o;p=o;n=b+28|0;L8:do{if((a[n]&1)==0){h=j;c[h>>2]=c[n>>2];c[h+4>>2]=c[n+4>>2];c[h+8>>2]=c[n+8>>2];q=16}else{h=c[b+36>>2]|0;r=c[b+32>>2]|0;do{if(r>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(r>>>0<11>>>0){a[j]=r<<1;s=j+1|0}else{t=r+16&-16;u=(x=0,as(230,t|0)|0);if(x){x=0;break}c[j+8>>2]=u;c[j>>2]=t|1;c[j+4>>2]=r;s=u}Kb(s|0,h|0,r)|0;a[s+r|0]=0;q=16;break L8}}while(0);r=bQ(-1,-1)|0;v=K;w=r}}while(0);do{if((q|0)==16){s=b+44|0;n=g;c[n>>2]=c[s>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];x=0;aB(34,p|0,j|0,g|0,0,1,0);if(x){x=0;s=bQ(-1,-1)|0;n=s;s=K;if((a[j]&1)==0){v=s;w=n;break}J2(c[j+8>>2]|0);v=s;w=n;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}n=b+20|0;s=xP(c[n>>2]|0)|0;if((s+1|0)==0|(a[s]|0)!=123){s=o+36|0;r=s;h=t1(b)|0;c[f>>2]=h;u=s+8|0;t=u;y=c[t>>2]|0;if((y|0)==(c[s+12>>2]|0)){eq(s+4|0,f);z=c[f>>2]|0}else{if((y|0)==0){A=0}else{c[y>>2]=h;A=c[t>>2]|0}c[u>>2]=A+4;z=h}cy[c[c[s>>2]>>2]&1023](r,z)}r=xP(c[n>>2]|0)|0;s=(a[r]|0)==44?r+1|0:0;if((s|0)==0){i=d;return p|0}h=b+48|0;u=b+40|0;t=b+52|0;y=b+56|0;B=o+36|0;C=B;D=B+8|0;E=D;F=B+12|0;G=B+4|0;H=B;B=r;r=s;while(1){s=c[h>>2]|0;I=c[n>>2]|0;L45:do{if(I>>>0<r>>>0){J=I;L=0;while(1){M=a[J]|0;if((M<<24>>24|0)==0){N=L;break L45}else if((M<<24>>24|0)==10){O=L+1|0}else{O=L}M=J+1|0;if(M>>>0<r>>>0){J=M;L=O}else{N=O;break}}}else{N=0}}while(0);c[h>>2]=N+s;L=B;J=0;while(1){M=L-1|0;if(M>>>0<I>>>0){break}if((a[M]|0)==10){break}else{L=M;J=J+1|0}}if((N|0)!=0){c[u>>2]=1}L=c[u>>2]|0;c[t>>2]=L+J;I=r;s=B;c[u>>2]=I-s+J+L;c[y>>2]=s;c[y+4>>2]=I;c[n>>2]=r;if((r|0)==0){q=58;break}I=t1(b)|0;c[e>>2]=I;s=c[E>>2]|0;if((s|0)==(c[F>>2]|0)){eq(G,e);P=c[e>>2]|0}else{if((s|0)==0){Q=0}else{c[s>>2]=I;Q=c[E>>2]|0}c[D>>2]=Q+4;P=I}cy[c[c[H>>2]>>2]&1023](C,P);I=xP(c[n>>2]|0)|0;s=(a[I]|0)==44?I+1|0:0;if((s|0)==0){q=57;break}else{B=I;r=s}}if((q|0)==58){i=d;return p|0}else if((q|0)==57){i=d;return p|0}}}while(0);p=c[k>>2]|0;k=c[m>>2]|0;d=p;while(1){if((d|0)==(k|0)){R=k;break}if((c[d>>2]|0)==(o|0)){R=d;break}else{d=d+4|0}}d=R-p>>2;R=p+(d+1<<2)|0;o=k-R|0;Kc(p+(d<<2)|0,R|0,o|0)|0;R=p+((o>>2)+d<<2)|0;d=c[m>>2]|0;if((R|0)==(d|0)){J2(l);S=w;T=0;U=S;V=v;be(U|0)}c[m>>2]=d+(~((d-4+(-R|0)|0)>>>2)<<2);J2(l);S=w;T=0;U=S;V=v;be(U|0);return 0}function t1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+96|0;e=d|0;f=d+8|0;g=d+16|0;h=d+32|0;j=d+40|0;k=d+56|0;l=d+64|0;m=d+80|0;n=b|0;o=c[n>>2]|0;p=J0(60)|0;c[k>>2]=p;q=o+4|0;r=c[q>>2]|0;if((r|0)==(c[o+8>>2]|0)){ee(o|0,k);s=c[k>>2]|0}else{if((r|0)==0){t=0}else{c[r>>2]=p;t=c[q>>2]|0}c[q>>2]=t+4;s=p}p=s;t=s;r=b+28|0;L8:do{if((a[r]&1)==0){k=l;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];u=16}else{k=c[b+36>>2]|0;v=c[b+32>>2]|0;do{if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(v>>>0<11>>>0){a[l]=v<<1;w=l+1|0}else{y=v+16&-16;z=(x=0,as(230,y|0)|0);if(x){x=0;break}c[l+8>>2]=z;c[l>>2]=y|1;c[l+4>>2]=v;w=z}Kb(w|0,k|0,v)|0;a[w+v|0]=0;u=16;break L8}}while(0);v=bQ(-1,-1)|0;A=K;B=v}}while(0);do{if((u|0)==16){w=b+44|0;v=j;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];x=0;aG(88,t|0,l|0,j|0,0,0,0,0);if(x){x=0;v=bQ(-1,-1)|0;k=v;v=K;if((a[l]&1)==0){A=v;B=k;break}J2(c[l+8>>2]|0);A=v;B=k;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}do{if((t2(b)|0)==0){if((t3(b)|0)==0){break}a[t+57|0]=1}else{a[s+56|0]=1}}while(0);L35:do{if((xR(xP(c[b+20>>2]|0)|0)|0)==0){if((sp(b)|0)==0){k=s+36|0;v=k;z=t4(b)|0;c[f>>2]=z;y=k+8|0;C=y;D=c[C>>2]|0;if((D|0)==(c[k+12>>2]|0)){iF(k+4|0,f);E=c[f>>2]|0}else{if((D|0)==0){F=0}else{c[D>>2]=z;F=c[C>>2]|0}c[y>>2]=F+4;E=z}cy[c[c[k>>2]>>2]&1023](v,E);break}v=c[n>>2]|0;k=J0(52)|0;c[h>>2]=k;z=v+4|0;y=c[z>>2]|0;if((y|0)==(c[v+8>>2]|0)){ee(v|0,h);G=c[h>>2]|0}else{if((y|0)==0){H=0}else{c[y>>2]=k;H=c[z>>2]|0}c[z>>2]=H+4;G=k}k=G;L55:do{if((a[r]&1)==0){y=m;c[y>>2]=c[r>>2];c[y+4>>2]=c[r+4>>2];c[y+8>>2]=c[r+8>>2];u=50}else{y=c[b+36>>2]|0;C=c[b+32>>2]|0;do{if(C>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(C>>>0<11>>>0){a[m]=C<<1;I=m+1|0}else{D=C+16&-16;J=(x=0,as(230,D|0)|0);if(x){x=0;break}c[m+8>>2]=J;c[m>>2]=D|1;c[m+4>>2]=C;I=J}Kb(I|0,y|0,C)|0;a[I+C|0]=0;u=50;break L55}}while(0);C=bQ(-1,-1)|0;L=K;M=C}}while(0);do{if((u|0)==50){C=g;c[C>>2]=c[w>>2];c[C+4>>2]=c[w+4>>2];c[C+8>>2]=c[w+8>>2];x=0;ao(14,G|0,m|0,g|0,b+56|0,0);if(!x){c[s+52>>2]=G;if((a[m]&1)==0){break L35}J2(c[m+8>>2]|0);break L35}else{x=0;C=bQ(-1,-1)|0;y=C;C=K;if((a[m]&1)==0){L=C;M=y;break}J2(c[m+8>>2]|0);L=C;M=y;break}}}while(0);y=c[v>>2]|0;C=c[z>>2]|0;J=y;while(1){if((J|0)==(C|0)){N=C;break}if((c[J>>2]|0)==(G|0)){N=J;break}else{J=J+4|0}}J=N-y>>2;v=y+(J+1<<2)|0;D=C-v|0;Kc(y+(J<<2)|0,v|0,D|0)|0;v=y+((D>>2)+J<<2)|0;J=c[z>>2]|0;if((v|0)!=(J|0)){c[z>>2]=J+(~((J-4+(-v|0)|0)>>>2)<<2)}J2(k);O=L;P=M;Q=P;R=0;S=Q;T=O;be(S|0)}else{c[s+52>>2]=sA(b)|0}}while(0);if((t5(b)|0)==0){i=d;return t|0}w=s+36|0;v=w;J=w+8|0;D=J;U=w+12|0;V=w+4|0;W=w;do{w=t4(b)|0;c[e>>2]=w;X=c[D>>2]|0;if((X|0)==(c[U>>2]|0)){iF(V,e);Y=c[e>>2]|0}else{if((X|0)==0){Z=0}else{c[X>>2]=w;Z=c[D>>2]|0}c[J>>2]=Z+4;Y=w}cy[c[c[W>>2]>>2]&1023](v,Y);}while((t5(b)|0)!=0);i=d;return t|0}}while(0);t=c[o>>2]|0;o=c[q>>2]|0;d=t;while(1){if((d|0)==(o|0)){_=o;break}if((c[d>>2]|0)==(s|0)){_=d;break}else{d=d+4|0}}d=_-t>>2;_=t+(d+1<<2)|0;s=o-_|0;Kc(t+(d<<2)|0,_|0,s|0)|0;_=t+((s>>2)+d<<2)|0;d=c[q>>2]|0;if((_|0)!=(d|0)){c[q>>2]=d+(~((d-4+(-_|0)|0)>>>2)<<2)}J2(p);O=A;P=B;Q=P;R=0;S=Q;T=O;be(S|0);return 0}function t2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=a[35424]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=35424;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==0){p=i;break L9}else if((n<<24>>24|0)==10){q=i+1|0}else{q=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=q}else{p=q;break}}}else{p=0}}while(0);c[g>>2]=h+p;h=e;g=0;while(1){q=h-1|0;if(q>>>0<k>>>0){break}if((a[q]|0)==10){break}else{h=q;g=g+1|0}}h=b+40|0;if((p|0)!=0){c[h>>2]=1}p=c[h>>2]|0;c[b+52>>2]=p+g;k=f;q=e;c[h>>2]=k-q+g+p;p=b+56|0;c[p>>2]=q;c[p+4>>2]=k;c[d>>2]=f;o=f;return o|0}function t3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=b+20|0;e=xP(c[d>>2]|0)|0;f=a[35352]|0;L1:do{if(f<<24>>24==0){g=e;h=0}else{i=e;j=35352;k=f;while(1){if((a[i]|0)!=k<<24>>24){g=i;h=k;break L1}l=i+1|0;m=j+1|0;n=a[m]|0;if(n<<24>>24==0){g=l;h=0;break}else{i=l;j=m;k=n}}}}while(0);f=h<<24>>24!=0?0:g;if((f|0)==0){o=0;return o|0}g=b+48|0;h=c[g>>2]|0;k=c[d>>2]|0;L9:do{if(k>>>0<f>>>0){j=k;i=0;while(1){n=a[j]|0;if((n<<24>>24|0)==10){p=i+1|0}else if((n<<24>>24|0)==0){q=i;break L9}else{p=i}n=j+1|0;if(n>>>0<f>>>0){j=n;i=p}else{q=p;break}}}else{q=0}}while(0);c[g>>2]=h+q;h=e;g=0;while(1){p=h-1|0;if(p>>>0<k>>>0){break}if((a[p]|0)==10){break}else{h=p;g=g+1|0}}h=b+40|0;if((q|0)!=0){c[h>>2]=1}q=c[h>>2]|0;c[b+52>>2]=q+g;k=f;p=e;c[h>>2]=k-p+g+q;q=b+56|0;c[q>>2]=p;c[q+4>>2]=k;c[d>>2]=f;o=f;return o|0}
function hI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+176|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=e+56|0;m=e+72|0;n=e+88|0;o=e+128|0;p=e+144|0;q=e+160|0;r=c[d+28>>2]|0;s=cS[c[(c[r>>2]|0)+20>>2]&1023](r|0,b|0)|0;Ac(j,0);r=k;t=k;a[t]=18;Kb(r+1|0,7352,9)|0;a[r+10|0]=0;x=0;aP(c[(c[s>>2]|0)+28>>2]|0,m|0,s|0,j|0);do{if(!x){x=0;aq(180,l|0,m|0);if(x){x=0;s=bQ(-1,-1)|0;r=s;s=K;if((a[m]&1)==0){u=r;v=s;break}J2(c[m+8>>2]|0);u=r;v=s;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}s=(x=0,aK(802,40552,k|0)|0);do{if(!x){x=0,aK(802,s|0,l|0)|0;if(x){x=0;w=49;break}r=c[b+12>>2]|0;y=d+4|0;if((a[y]&1)==0){z=o;c[z>>2]=c[y>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2]}else{y=c[d+12>>2]|0;z=c[d+8>>2]|0;if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;w=49;break}return 0}if(z>>>0<11>>>0){a[o]=z<<1;A=o+1|0}else{B=z+16&-16;C=(x=0,as(230,B|0)|0);if(x){x=0;w=49;break}c[o+8>>2]=C;c[o>>2]=B|1;c[o+4>>2]=z;A=C}Kb(A|0,y|0,z)|0;a[A+z|0]=0}z=d+16|0;y=h;c[y>>2]=c[z>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];z=p;a[z]=0;a[p+1|0]=0;x=0;ao(24,n|0,r|0,o|0,h|0,p|0);if(x){x=0;r=bQ(-1,-1)|0;y=r;r=K;if((a[z]&1)!=0){J2(c[p+8>>2]|0)}if((a[o]&1)==0){D=y;E=r;break}J2(c[o+8>>2]|0);D=y;E=r;break}if((a[z]&1)!=0){J2(c[p+8>>2]|0)}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}x=0;aP(54,q|0,n|0,1);L39:do{if(!x){x=0,aK(802,40552,q|0)|0;if(x){x=0;z=bQ(-1,-1)|0;r=z;z=K;if((a[q]&1)==0){F=r;G=z;break}J2(c[q+8>>2]|0);F=r;G=z;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}x=0;aq(346,g|0,40552+(c[(c[10138]|0)-12>>2]|0)|0);if(x){x=0;w=54;break}z=(x=0,aK(196,g|0,40280)|0);do{if(!x){r=(x=0,aK(c[(c[z>>2]|0)+28>>2]|0,z|0,10)|0);if(x){x=0;break}x=0;ap(388,g|0);if(x){x=0;w=54;break L39}x=0,aK(240,40552,r|0)|0;if(x){x=0;w=54;break L39}x=0,as(56,40552)|0;if(x){x=0;w=54;break L39}x=0;aq(346,f|0,40552+(c[(c[10138]|0)-12>>2]|0)|0);if(x){x=0;w=54;break L39}r=(x=0,aK(196,f|0,40280)|0);do{if(!x){y=(x=0,aK(c[(c[r>>2]|0)+28>>2]|0,r|0,10)|0);if(x){x=0;break}x=0;ap(388,f|0);if(x){x=0;w=54;break L39}x=0,aK(240,40552,y|0)|0;if(x){x=0;w=54;break L39}x=0,as(56,40552)|0;if(x){x=0;w=54;break L39}if((a[n+28|0]&1)!=0){J2(c[n+36>>2]|0)}if((a[n+4|0]&1)!=0){J2(c[n+12>>2]|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}if((a[t]&1)==0){Ae(j);i=e;return 0}J2(c[k+8>>2]|0);Ae(j);i=e;return 0}else{x=0}}while(0);r=bQ(-1,-1)|0;y=K;x=0;ap(388,f|0);if(!x){H=y;I=r;w=55;break L39}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{x=0}}while(0);z=bQ(-1,-1)|0;r=K;x=0;ap(388,g|0);if(!x){H=r;I=z;w=55;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{x=0;w=54}}while(0);if((w|0)==54){z=bQ(-1,-1)|0;H=K;I=z;w=55}if((w|0)==55){F=I;G=H}if((a[n+28|0]&1)!=0){J2(c[n+36>>2]|0)}if((a[n+4|0]&1)==0){D=F;E=G;break}J2(c[n+12>>2]|0);D=F;E=G}else{x=0;w=49}}while(0);if((w|0)==49){s=bQ(-1,-1)|0;D=s;E=K}if((a[l]&1)==0){u=D;v=E;break}J2(c[l+8>>2]|0);u=D;v=E}else{x=0;s=bQ(-1,-1)|0;u=s;v=K}}while(0);if((a[t]&1)!=0){J2(c[k+8>>2]|0)}x=0;ap(436,j|0);if(!x){be(u|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function hJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;e=i;i=i+48|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=c[b+4>>2]|0;l=J0(60)|0;c[h>>2]=l;m=k+4|0;n=c[m>>2]|0;if((n|0)==(c[k+8>>2]|0)){ee(k|0,h);o=c[h>>2]|0}else{if((n|0)==0){p=0}else{c[n>>2]=l;p=c[m>>2]|0}c[m>>2]=p+4;o=l}l=o;p=d+4|0;L8:do{if((a[p]&1)==0){n=j;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];q=16}else{n=c[d+12>>2]|0;h=c[d+8>>2]|0;do{if(h>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;r=j+1|0}else{s=h+16&-16;t=(x=0,as(230,s|0)|0);if(x){x=0;break}c[j+8>>2]=t;c[j>>2]=s|1;c[j+4>>2]=h;r=t}Kb(r|0,n|0,h)|0;a[r+h|0]=0;q=16;break L8}}while(0);h=bQ(-1,-1)|0;u=h;v=K}}while(0);do{if((q|0)==16){r=d+16|0;p=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];r=d+44|0;p=d+40|0;x=0;aB(34,o|0,j|0,g|0,(c[r>>2]|0)-(c[p>>2]|0)>>2|0,c[d+52>>2]|0,(a[d+56|0]&1)!=0|0);if(x){x=0;h=bQ(-1,-1)|0;n=h;h=K;if((a[j]&1)==0){u=n;v=h;break}J2(c[j+8>>2]|0);u=n;v=h;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}h=c[p>>2]|0;n=(c[r>>2]|0)-h>>2;if((n|0)==0){w=o;i=e;return w|0}r=o+36|0;t=r;s=b|0;y=r+8|0;z=y;A=r+12|0;B=r+4|0;C=r;r=0;D=h;while(1){h=c[D+(r<<2)>>2]|0;E=cS[c[(c[h>>2]|0)+20>>2]&1023](h|0,s)|0;c[f>>2]=E;h=c[z>>2]|0;if((h|0)==(c[A>>2]|0)){eq(B,f);F=c[f>>2]|0}else{if((h|0)==0){G=0}else{c[h>>2]=E;G=c[z>>2]|0}c[y>>2]=G+4;F=E}cy[c[c[C>>2]>>2]&1023](t,F);E=r+1|0;if(E>>>0>=n>>>0){break}r=E;D=c[p>>2]|0}w=o;i=e;return w|0}}while(0);w=c[k>>2]|0;k=c[m>>2]|0;e=w;while(1){if((e|0)==(k|0)){H=k;break}if((c[e>>2]|0)==(o|0)){H=e;break}else{e=e+4|0}}e=H-w>>2;H=w+(e+1<<2)|0;o=k-H|0;Kc(w+(e<<2)|0,H|0,o|0)|0;H=w+((o>>2)+e<<2)|0;e=c[m>>2]|0;if((H|0)==(e|0)){J2(l);I=u;J=0;L=I;M=v;be(L|0)}c[m>>2]=e+(~((e-4+(-H|0)|0)>>>2)<<2);J2(l);I=u;J=0;L=I;M=v;be(L|0);return 0}function hK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,aq=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0;e=i;i=i+240|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=e+48|0;n=e+64|0;o=e+80|0;p=e+96|0;q=e+112|0;r=e+128|0;s=e+144|0;t=e+160|0;u=e+176|0;v=e+192|0;w=e+208|0;y=e+224|0;z=c[d+36>>2]|0;L1:do{if((z|0)==11){if((a[d+28|0]&1)==0){A=c[d+40>>2]|0;B=b|0;C=cS[c[(c[A>>2]|0)+20>>2]&1023](A|0,B)|0;A=c[d+44>>2]|0;D=C;E=cS[c[(c[A>>2]|0)+20>>2]&1023](A|0,B)|0;break}else{F=d|0;i=e;return F|0}}else{B=c[d+40>>2]|0;A=b|0;C=cS[c[(c[B>>2]|0)+20>>2]&1023](B|0,A)|0;if((z|0)==0){if(!(cA[c[(c[C>>2]|0)+36>>2]&511](C)|0)){F=C;i=e;return F|0}B=c[d+44>>2]|0;F=cS[c[(c[B>>2]|0)+20>>2]&1023](B|0,A)|0;i=e;return F|0}else if((z|0)==1){if(cA[c[(c[C>>2]|0)+36>>2]&511](C)|0){F=C;i=e;return F|0}B=c[d+44>>2]|0;F=cS[c[(c[B>>2]|0)+20>>2]&1023](B|0,A)|0;i=e;return F|0}else{B=c[d+44>>2]|0;G=cS[c[(c[B>>2]|0)+20>>2]&1023](B|0,A)|0;switch(z|0){case 2:{A=b+4|0;B=c[A>>2]|0;H=J0(40)|0;c[l>>2]=H;I=B+4|0;J=c[I>>2]|0;if((J|0)==(c[B+8>>2]|0)){ee(B|0,l);L=c[l>>2]|0}else{if((J|0)==0){M=0}else{c[J>>2]=H;M=c[I>>2]|0}c[I>>2]=M+4;L=H}H=L;J=L;N=d+4|0;L28:do{if((a[N]&1)==0){O=m;c[O>>2]=c[N>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];P=25}else{O=c[d+12>>2]|0;Q=c[d+8>>2]|0;do{if(Q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(Q>>>0<11>>>0){a[m]=Q<<1;R=m+1|0}else{S=Q+16&-16;T=(x=0,as(230,S|0)|0);if(x){x=0;break}c[m+8>>2]=T;c[m>>2]=S|1;c[m+4>>2]=Q;R=T}Kb(R|0,O|0,Q)|0;a[R+Q|0]=0;P=25;break L28}}while(0);Q=bQ(-1,-1)|0;U=Q;V=K}}while(0);do{if((P|0)==25){N=n;Q=d+16|0;c[N>>2]=c[Q>>2];c[N+4>>2]=c[Q+4>>2];c[N+8>>2]=c[Q+8>>2];Q=(x=0,ax(20,C|0,G|0,c[A>>2]|0)|0);do{if(!x){x=0;aT(4,J|0,m|0,n|0,Q|0);if(x){x=0;break}N=L;if((a[m]&1)==0){F=N;i=e;return F|0}J2(c[m+8>>2]|0);F=N;i=e;return F|0}else{x=0}}while(0);Q=bQ(-1,-1)|0;N=Q;Q=K;if((a[m]&1)==0){U=N;V=Q;break}J2(c[m+8>>2]|0);U=N;V=Q}}while(0);J=c[B>>2]|0;A=c[I>>2]|0;Q=J;while(1){if((Q|0)==(A|0)){W=A;break}if((c[Q>>2]|0)==(L|0)){W=Q;break}else{Q=Q+4|0}}Q=W-J>>2;B=J+(Q+1<<2)|0;N=A-B|0;Kc(J+(Q<<2)|0,B|0,N|0)|0;B=J+((N>>2)+Q<<2)|0;Q=c[I>>2]|0;if((B|0)!=(Q|0)){c[I>>2]=Q+(~((Q-4+(-B|0)|0)>>>2)<<2)}J2(H);X=U;Y=V;Z=X;_=0;$=Z;aa=Y;be($|0);break};case 3:{B=b+4|0;Q=c[B>>2]|0;N=J0(40)|0;c[k>>2]=N;O=Q+4|0;T=c[O>>2]|0;if((T|0)==(c[Q+8>>2]|0)){ee(Q|0,k);ab=c[k>>2]|0}else{if((T|0)==0){ac=0}else{c[T>>2]=N;ac=c[O>>2]|0}c[O>>2]=ac+4;ab=N}N=ab;T=ab;S=d+4|0;L69:do{if((a[S]&1)==0){ad=o;c[ad>>2]=c[S>>2];c[ad+4>>2]=c[S+4>>2];c[ad+8>>2]=c[S+8>>2];P=53}else{ad=c[d+12>>2]|0;ae=c[d+8>>2]|0;do{if(ae>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ae>>>0<11>>>0){a[o]=ae<<1;af=o+1|0}else{ag=ae+16&-16;ah=(x=0,as(230,ag|0)|0);if(x){x=0;break}c[o+8>>2]=ah;c[o>>2]=ag|1;c[o+4>>2]=ae;af=ah}Kb(af|0,ad|0,ae)|0;a[af+ae|0]=0;P=53;break L69}}while(0);ae=bQ(-1,-1)|0;ai=ae;aj=K}}while(0);do{if((P|0)==53){S=p;H=d+16|0;c[S>>2]=c[H>>2];c[S+4>>2]=c[H+4>>2];c[S+8>>2]=c[H+8>>2];H=(x=0,ax(20,C|0,G|0,c[B>>2]|0)|0);do{if(!x){x=0;aT(4,T|0,o|0,p|0,H^1|0);if(x){x=0;break}S=ab;if((a[o]&1)==0){F=S;i=e;return F|0}J2(c[o+8>>2]|0);F=S;i=e;return F|0}else{x=0}}while(0);H=bQ(-1,-1)|0;S=H;H=K;if((a[o]&1)==0){ai=S;aj=H;break}J2(c[o+8>>2]|0);ai=S;aj=H}}while(0);T=c[Q>>2]|0;B=c[O>>2]|0;H=T;while(1){if((H|0)==(B|0)){ak=B;break}if((c[H>>2]|0)==(ab|0)){ak=H;break}else{H=H+4|0}}H=ak-T>>2;Q=T+(H+1<<2)|0;S=B-Q|0;Kc(T+(H<<2)|0,Q|0,S|0)|0;Q=T+((S>>2)+H<<2)|0;H=c[O>>2]|0;if((Q|0)!=(H|0)){c[O>>2]=H+(~((H-4+(-Q|0)|0)>>>2)<<2)}J2(N);X=ai;Y=aj;Z=X;_=0;$=Z;aa=Y;be($|0);break};case 4:{Q=b+4|0;H=c[Q>>2]|0;S=J0(40)|0;c[j>>2]=S;I=H+4|0;J=c[I>>2]|0;if((J|0)==(c[H+8>>2]|0)){ee(H|0,j);al=c[j>>2]|0}else{if((J|0)==0){am=0}else{c[J>>2]=S;am=c[I>>2]|0}c[I>>2]=am+4;al=S}S=al;J=al;A=d+4|0;L110:do{if((a[A]&1)==0){ae=q;c[ae>>2]=c[A>>2];c[ae+4>>2]=c[A+4>>2];c[ae+8>>2]=c[A+8>>2];P=81}else{ae=c[d+12>>2]|0;ad=c[d+8>>2]|0;do{if(ad>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ad>>>0<11>>>0){a[q]=ad<<1;an=q+1|0}else{ah=ad+16&-16;ag=(x=0,as(230,ah|0)|0);if(x){x=0;break}c[q+8>>2]=ag;c[q>>2]=ah|1;c[q+4>>2]=ad;an=ag}Kb(an|0,ae|0,ad)|0;a[an+ad|0]=0;P=81;break L110}}while(0);ad=bQ(-1,-1)|0;ao=ad;aq=K}}while(0);do{if((P|0)==81){A=r;N=d+16|0;c[A>>2]=c[N>>2];c[A+4>>2]=c[N+4>>2];c[A+8>>2]=c[N+8>>2];N=(x=0,ax(28,C|0,G|0,0)|0);do{if(!x){if(N){ar=0}else{A=(x=0,ax(20,C|0,G|0,c[Q>>2]|0)|0);if(x){x=0;break}ar=A^1}x=0;aT(4,J|0,q|0,r|0,ar|0);if(x){x=0;break}A=al;if((a[q]&1)==0){F=A;i=e;return F|0}J2(c[q+8>>2]|0);F=A;i=e;return F|0}else{x=0}}while(0);N=bQ(-1,-1)|0;A=N;N=K;if((a[q]&1)==0){ao=A;aq=N;break}J2(c[q+8>>2]|0);ao=A;aq=N}}while(0);J=c[H>>2]|0;Q=c[I>>2]|0;N=J;while(1){if((N|0)==(Q|0)){at=Q;break}if((c[N>>2]|0)==(al|0)){at=N;break}else{N=N+4|0}}N=at-J>>2;H=J+(N+1<<2)|0;A=Q-H|0;Kc(J+(N<<2)|0,H|0,A|0)|0;H=J+((A>>2)+N<<2)|0;N=c[I>>2]|0;if((H|0)!=(N|0)){c[I>>2]=N+(~((N-4+(-H|0)|0)>>>2)<<2)}J2(S);X=ao;Y=aq;Z=X;_=0;$=Z;aa=Y;be($|0);break};case 6:{H=c[b+4>>2]|0;N=J0(40)|0;c[g>>2]=N;A=H+4|0;O=c[A>>2]|0;if((O|0)==(c[H+8>>2]|0)){ee(H|0,g);au=c[g>>2]|0}else{if((O|0)==0){av=0}else{c[O>>2]=N;av=c[A>>2]|0}c[A>>2]=av+4;au=N}N=au;O=au;T=d+4|0;L155:do{if((a[T]&1)==0){B=u;c[B>>2]=c[T>>2];c[B+4>>2]=c[T+4>>2];c[B+8>>2]=c[T+8>>2];P=140}else{B=c[d+12>>2]|0;ad=c[d+8>>2]|0;do{if(ad>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ad>>>0<11>>>0){a[u]=ad<<1;aw=u+1|0}else{ae=ad+16&-16;ag=(x=0,as(230,ae|0)|0);if(x){x=0;break}c[u+8>>2]=ag;c[u>>2]=ae|1;c[u+4>>2]=ad;aw=ag}Kb(aw|0,B|0,ad)|0;a[aw+ad|0]=0;P=140;break L155}}while(0);ad=bQ(-1,-1)|0;ay=ad;az=K}}while(0);do{if((P|0)==140){T=v;S=d+16|0;c[T>>2]=c[S>>2];c[T+4>>2]=c[S+4>>2];c[T+8>>2]=c[S+8>>2];S=(x=0,ax(28,C|0,G|0,0)|0);do{if(!x){x=0;aT(4,O|0,u|0,v|0,S|0);if(x){x=0;break}T=au;if((a[u]&1)==0){F=T;i=e;return F|0}J2(c[u+8>>2]|0);F=T;i=e;return F|0}else{x=0}}while(0);S=bQ(-1,-1)|0;T=S;S=K;if((a[u]&1)==0){ay=T;az=S;break}J2(c[u+8>>2]|0);ay=T;az=S}}while(0);O=c[H>>2]|0;S=c[A>>2]|0;T=O;while(1){if((T|0)==(S|0)){aA=S;break}if((c[T>>2]|0)==(au|0)){aA=T;break}else{T=T+4|0}}T=aA-O>>2;H=O+(T+1<<2)|0;I=S-H|0;Kc(O+(T<<2)|0,H|0,I|0)|0;H=O+((I>>2)+T<<2)|0;T=c[A>>2]|0;if((H|0)!=(T|0)){c[A>>2]=T+(~((T-4+(-H|0)|0)>>>2)<<2)}J2(N);X=ay;Y=az;Z=X;_=0;$=Z;aa=Y;be($|0);break};case 5:{H=c[b+4>>2]|0;T=J0(40)|0;c[h>>2]=T;I=H+4|0;J=c[I>>2]|0;if((J|0)==(c[H+8>>2]|0)){ee(H|0,h);aB=c[h>>2]|0}else{if((J|0)==0){aC=0}else{c[J>>2]=T;aC=c[I>>2]|0}c[I>>2]=aC+4;aB=T}T=aB;J=aB;Q=d+4|0;L196:do{if((a[Q]&1)==0){ad=s;c[ad>>2]=c[Q>>2];c[ad+4>>2]=c[Q+4>>2];c[ad+8>>2]=c[Q+8>>2];P=112}else{ad=c[d+12>>2]|0;B=c[d+8>>2]|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(B>>>0<11>>>0){a[s]=B<<1;aD=s+1|0}else{ag=B+16&-16;ae=(x=0,as(230,ag|0)|0);if(x){x=0;break}c[s+8>>2]=ae;c[s>>2]=ag|1;c[s+4>>2]=B;aD=ae}Kb(aD|0,ad|0,B)|0;a[aD+B|0]=0;P=112;break L196}}while(0);B=bQ(-1,-1)|0;aE=B;aF=K}}while(0);do{if((P|0)==112){Q=t;N=d+16|0;c[Q>>2]=c[N>>2];c[Q+4>>2]=c[N+4>>2];c[Q+8>>2]=c[N+8>>2];N=(x=0,ax(28,C|0,G|0,0)|0);do{if(!x){x=0;aT(4,J|0,s|0,t|0,N^1|0);if(x){x=0;break}Q=aB;if((a[s]&1)==0){F=Q;i=e;return F|0}J2(c[s+8>>2]|0);F=Q;i=e;return F|0}else{x=0}}while(0);N=bQ(-1,-1)|0;Q=N;N=K;if((a[s]&1)==0){aE=Q;aF=N;break}J2(c[s+8>>2]|0);aE=Q;aF=N}}while(0);J=c[H>>2]|0;N=c[I>>2]|0;Q=J;while(1){if((Q|0)==(N|0)){aG=N;break}if((c[Q>>2]|0)==(aB|0)){aG=Q;break}else{Q=Q+4|0}}Q=aG-J>>2;H=J+(Q+1<<2)|0;A=N-H|0;Kc(J+(Q<<2)|0,H|0,A|0)|0;H=J+((A>>2)+Q<<2)|0;Q=c[I>>2]|0;if((H|0)!=(Q|0)){c[I>>2]=Q+(~((Q-4+(-H|0)|0)>>>2)<<2)}J2(T);X=aE;Y=aF;Z=X;_=0;$=Z;aa=Y;be($|0);break};case 7:{H=b+4|0;Q=c[H>>2]|0;A=J0(40)|0;c[f>>2]=A;O=Q+4|0;S=c[O>>2]|0;if((S|0)==(c[Q+8>>2]|0)){ee(Q|0,f);aH=c[f>>2]|0}else{if((S|0)==0){aI=0}else{c[S>>2]=A;aI=c[O>>2]|0}c[O>>2]=aI+4;aH=A}A=aH;S=aH;B=d+4|0;L237:do{if((a[B]&1)==0){ad=w;c[ad>>2]=c[B>>2];c[ad+4>>2]=c[B+4>>2];c[ad+8>>2]=c[B+8>>2];P=168}else{ad=c[d+12>>2]|0;ae=c[d+8>>2]|0;do{if(ae>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ae>>>0<11>>>0){a[w]=ae<<1;aJ=w+1|0}else{ag=ae+16&-16;ah=(x=0,as(230,ag|0)|0);if(x){x=0;break}c[w+8>>2]=ah;c[w>>2]=ag|1;c[w+4>>2]=ae;aJ=ah}Kb(aJ|0,ad|0,ae)|0;a[aJ+ae|0]=0;P=168;break L237}}while(0);ae=bQ(-1,-1)|0;aK=ae;aL=K}}while(0);do{if((P|0)==168){B=y;T=d+16|0;c[B>>2]=c[T>>2];c[B+4>>2]=c[T+4>>2];c[B+8>>2]=c[T+8>>2];T=(x=0,ax(28,C|0,G|0,0)|0);do{if(!x){if(T){aM=1}else{B=(x=0,ax(20,C|0,G|0,c[H>>2]|0)|0);if(!x){aM=B}else{x=0;break}}x=0;aT(4,S|0,w|0,y|0,aM|0);if(x){x=0;break}B=aH;if((a[w]&1)==0){F=B;i=e;return F|0}J2(c[w+8>>2]|0);F=B;i=e;return F|0}else{x=0}}while(0);T=bQ(-1,-1)|0;B=T;T=K;if((a[w]&1)==0){aK=B;aL=T;break}J2(c[w+8>>2]|0);aK=B;aL=T}}while(0);S=c[Q>>2]|0;H=c[O>>2]|0;T=S;while(1){if((T|0)==(H|0)){aN=H;break}if((c[T>>2]|0)==(aH|0)){aN=T;break}else{T=T+4|0}}T=aN-S>>2;Q=S+(T+1<<2)|0;B=H-Q|0;Kc(S+(T<<2)|0,Q|0,B|0)|0;Q=S+((B>>2)+T<<2)|0;T=c[O>>2]|0;if((Q|0)!=(T|0)){c[O>>2]=T+(~((T-4+(-Q|0)|0)>>>2)<<2)}J2(A);X=aK;Y=aL;Z=X;_=0;$=Z;aa=Y;be($|0);break};default:{D=C;E=G;break L1}}}}}while(0);$=c[D+32>>2]|0;Y=c[E+32>>2]|0;aa=($|0)==2;Z=(Y|0)==2;if(aa&Z){F=hO(c[b+4>>2]|0,d,D,E)|0;i=e;return F|0}d=(Y|0)==3;if(aa&d){F=hP(c[b+4>>2]|0,z,D,E)|0;i=e;return F|0}aa=($|0)==3;if(aa&Z){F=hQ(c[b+4>>2]|0,z,D,E)|0;i=e;return F|0}Z=c[b+4>>2]|0;if(aa&d){F=hR(Z,z,D,E)|0;i=e;return F|0}else{F=hS(Z,z,D,E)|0;i=e;return F|0}return 0}function hL(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];h=g|0;j=g+16|0;k=g+32|0;Kb(k|0,e|0,12)|0;e=h;l=j;m=b|0;n=d;if((a[n]&1)==0){c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[e]=o<<1;p=h+1|0}else{d=o+16&-16;q=J0(d)|0;c[h+8>>2]=q;c[h>>2]=d|1;c[h+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];x=0;aB(6,m|0,h|0,j|0,0,0,0);if(!x){if((a[e]&1)==0){r=b|0;c[r>>2]=17296;s=b+36|0;t=f&1;a[s]=t;u=b+32|0;c[u>>2]=1;i=g;return}J2(c[h+8>>2]|0);r=b|0;c[r>>2]=17296;s=b+36|0;t=f&1;a[s]=t;u=b+32|0;c[u>>2]=1;i=g;return}else{x=0;g=bQ(-1,-1)|0;if((a[e]&1)==0){be(g|0)}J2(c[h+8>>2]|0);be(g|0)}}function hM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0;f=i;i=i+184|0;g=f|0;j=f+72|0;k=f+88|0;l=f+104|0;m=f+120|0;n=f+136|0;o=f+152|0;p=f+168|0;q=c[b+32>>2]|0;if((q|0)!=(c[d+32>>2]|0)){r=0;i=f;return r|0}switch(q|0){case 1:{r=(a[b+36|0]&1)!=0^(a[d+36|0]&1)!=0^1;i=f;return r|0};case 2:{q=b;kx(g,d);x=0;aq(324,j|0,q|0);do{if(!x){x=0;aq(752,g|0,j|0);if(x){x=0;s=bQ(-1,-1)|0;t=s;s=K;if((a[j]&1)==0){u=s;v=t;break}J2(c[j+8>>2]|0);u=s;v=t;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}x=0;aq(248,k|0,q|0);if(x){x=0;w=35;break}x=0;aq(248,l|0,g|0);if(x){x=0;t=bQ(-1,-1)|0;s=t;t=K;if((a[k]&1)==0){u=t;v=s;break}J2(c[k+8>>2]|0);u=t;v=s;break}s=k;t=a[k]|0;y=t&255;if((y&1|0)==0){z=y>>>1}else{z=c[k+4>>2]|0}y=l;A=a[l]|0;B=A&255;if((B&1|0)==0){C=B>>>1}else{C=c[l+4>>2]|0}L30:do{if((z|0)==(C|0)){B=(t&1)==0;if(B){D=s+1|0}else{D=c[k+8>>2]|0}E=A&1;if(E<<24>>24==0){F=y+1|0}else{F=c[l+8>>2]|0}do{if(B){if((z|0)==0){break}else{G=F;H=D;I=z}while(1){if((a[H]|0)!=(a[G]|0)){J=0;L=E;break L30}M=I-1|0;if((M|0)==0){break}else{G=G+1|0;H=H+1|0;I=M}}}else{if((Kd(D|0,F|0,z|0)|0)!=0){J=0;L=E;break L30}}}while(0);J=+h[b+40>>3]==+h[g+40>>3];L=E}else{J=0;L=A&1}}while(0);if(L<<24>>24!=0){J2(c[l+8>>2]|0)}if((t&1)!=0){J2(c[k+8>>2]|0)}iW(g);r=J;i=f;return r|0}else{x=0;w=35}}while(0);if((w|0)==35){J=bQ(-1,-1)|0;u=K;v=J}x=0;ap(486,g|0);if(!x){N=u;O=v;P=O;Q=0;R=P;S=N;be(R|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}break};case 6:{r=1;i=f;return r|0};case 3:{if(+h[b+40>>3]!=+h[d+40>>3]){r=0;i=f;return r|0}if(+h[b+48>>3]!=+h[d+48>>3]){r=0;i=f;return r|0}if(+h[b+56>>3]!=+h[d+56>>3]){r=0;i=f;return r|0}r=+h[b+64>>3]==+h[d+64>>3];i=f;return r|0};case 4:{v=b+40|0;if((a[v]&1)==0){u=n;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2]}else{v=c[b+48>>2]|0;u=c[b+44>>2]|0;if(u>>>0>4294967279>>>0){CJ(0);return 0}if(u>>>0<11>>>0){a[n]=u<<1;T=n+1|0}else{g=u+16&-16;J=J0(g)|0;c[n+8>>2]=J;c[n>>2]=g|1;c[n+4>>2]=u;T=J}Kb(T|0,v|0,u)|0;a[T+u|0]=0}x=0;aq(180,m|0,n|0);do{if(!x){u=d+40|0;L88:do{if((a[u]&1)==0){T=p;c[T>>2]=c[u>>2];c[T+4>>2]=c[u+4>>2];c[T+8>>2]=c[u+8>>2];w=64}else{T=c[d+48>>2]|0;v=c[d+44>>2]|0;do{if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(v>>>0<11>>>0){a[p]=v<<1;U=p+1|0}else{J=v+16&-16;g=(x=0,as(230,J|0)|0);if(x){x=0;break}c[p+8>>2]=g;c[p>>2]=J|1;c[p+4>>2]=v;U=g}Kb(U|0,T|0,v)|0;a[U+v|0]=0;w=64;break L88}}while(0);v=bQ(-1,-1)|0;V=K;W=v}}while(0);do{if((w|0)==64){x=0;aq(180,o|0,p|0);if(x){x=0;u=bQ(-1,-1)|0;t=u;u=K;if((a[p]&1)==0){V=u;W=t;break}J2(c[p+8>>2]|0);V=u;W=t;break}t=m;u=m;v=a[u]|0;T=v&255;if((T&1|0)==0){X=T>>>1}else{X=c[m+4>>2]|0}T=o;E=a[o]|0;g=E&255;if((g&1|0)==0){Y=g>>>1}else{Y=c[o+4>>2]|0}L115:do{if((X|0)==(Y|0)){g=(v&1)==0;if(g){Z=t+1|0}else{Z=c[m+8>>2]|0}J=E&1;if(J<<24>>24==0){_=T+1|0}else{_=c[o+8>>2]|0}if(!g){$=(Kd(Z|0,_|0,X|0)|0)==0;aa=J;break}if((X|0)==0){$=1;aa=J;break}else{ab=_;ac=Z;ad=X}while(1){if((a[ac]|0)!=(a[ab]|0)){$=0;aa=J;break L115}g=ad-1|0;if((g|0)==0){$=1;aa=J;break}else{ab=ab+1|0;ac=ac+1|0;ad=g}}}else{$=0;aa=E&1}}while(0);if(aa<<24>>24!=0){J2(c[o+8>>2]|0)}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}if((a[u]&1)!=0){J2(c[m+8>>2]|0)}if((a[n]&1)==0){r=$;i=f;return r|0}J2(c[n+8>>2]|0);r=$;i=f;return r|0}}while(0);if((a[m]&1)==0){ae=V;af=W;break}J2(c[m+8>>2]|0);ae=V;af=W}else{x=0;E=bQ(-1,-1)|0;ae=K;af=E}}while(0);if((a[n]&1)==0){N=ae;O=af;P=O;Q=0;R=P;S=N;be(R|0)}J2(c[n+8>>2]|0);N=ae;O=af;P=O;Q=0;R=P;S=N;be(R|0);break};case 5:{R=b+40|0;N=(c[b+44>>2]|0)-(c[R>>2]|0)>>2;S=d+40|0;if((N|0)!=((c[d+44>>2]|0)-(c[S>>2]|0)>>2|0)){r=0;i=f;return r|0}if((c[b+52>>2]|0)==(c[d+52>>2]|0)){ag=0}else{r=0;i=f;return r|0}while(1){if(ag>>>0>=N>>>0){r=1;w=118;break}if(hM(c[(c[R>>2]|0)+(ag<<2)>>2]|0,c[(c[S>>2]|0)+(ag<<2)>>2]|0,e)|0){ag=ag+1|0}else{r=0;w=119;break}}if((w|0)==118){i=f;return r|0}else if((w|0)==119){i=f;return r|0}break};default:{r=0;i=f;return r|0}}return 0}function hN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0;e=i;i=i+248|0;f=e|0;g=e+16|0;j=e+32|0;k=e+48|0;l=e+120|0;m=e+136|0;n=e+152|0;o=e+168|0;p=e+184|0;q=e+200|0;r=e+216|0;s=e+232|0;if((c[b+32>>2]|0)==2){if((c[d+32>>2]|0)!=2){t=3}}else{t=3}L3:do{if((t|0)==3){u=J0(32)|0;v=f+8|0;c[v>>2]=u;c[f>>2]=33;c[f+4>>2]=24;Kb(u|0,9632,24)|0;a[u+24|0]=0;u=b+4|0;L5:do{if((a[u]&1)==0){w=g;c[w>>2]=c[u>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];t=13}else{w=c[b+12>>2]|0;y=c[b+8>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[g]=y<<1;z=g+1|0}else{A=y+16&-16;B=(x=0,as(230,A|0)|0);if(x){x=0;break}c[g+8>>2]=B;c[g>>2]=A|1;c[g+4>>2]=y;z=B}Kb(z|0,w|0,y)|0;a[z+y|0]=0;t=13;break L5}}while(0);y=bQ(-1,-1)|0;C=K;D=y}}while(0);do{if((t|0)==13){u=j;y=b+16|0;c[u>>2]=c[y>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2];x=0;aP(362,f|0,g|0,j|0);if(x){x=0;y=bQ(-1,-1)|0;u=y;y=K;if((a[g]&1)==0){C=y;D=u;break}J2(c[g+8>>2]|0);C=y;D=u;break}if((a[g]&1)!=0){J2(c[g+8>>2]|0)}if((a[f]&1)==0){break L3}J2(c[v>>2]|0);break L3}}while(0);if((a[f]&1)==0){E=C;F=D;G=F;H=0;I=G;J=E;be(I|0)}J2(c[v>>2]|0);E=C;F=D;G=F;H=0;I=G;J=E;be(I|0)}}while(0);D=b;kx(k,d);x=0;aq(324,l|0,D|0);do{if(!x){x=0;aq(752,k|0,l|0);if(x){x=0;d=bQ(-1,-1)|0;C=d;d=K;if((a[l]&1)==0){L=d;M=C;break}J2(c[l+8>>2]|0);L=d;M=C;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}x=0;aq(248,m|0,D|0);if(x){x=0;t=79;break}x=0;aq(248,n|0,k|0);L44:do{if(!x){C=a[m]|0;d=C&255;if((d&1|0)==0){N=d>>>1}else{N=c[m+4>>2]|0}d=a[n]|0;L50:do{if((N|0)!=0){f=d&255;if((f&1|0)==0){O=f>>>1}else{O=c[n+4>>2]|0}if((O|0)==0){break}x=0;aq(248,o|0,D|0);do{if(!x){x=0;aq(248,p|0,k|0);if(x){x=0;f=bQ(-1,-1)|0;g=f;f=K;if((a[o]&1)==0){P=f;Q=g;break}J2(c[o+8>>2]|0);P=f;Q=g;break}g=o;f=a[o]|0;j=f&255;if((j&1|0)==0){R=j>>>1}else{R=c[o+4>>2]|0}j=p;z=a[p]|0;u=z&255;if((u&1|0)==0){S=u>>>1}else{S=c[p+4>>2]|0}L71:do{if((R|0)==(S|0)){u=(f&1)==0;if(u){T=g+1|0}else{T=c[o+8>>2]|0}y=z&1;if(y<<24>>24==0){U=j+1|0}else{U=c[p+8>>2]|0}if(!u){V=(Kd(T|0,U|0,R|0)|0)!=0;W=y;break}if((R|0)==0){V=0;W=y;break}else{X=U;Y=T;Z=R}while(1){if((a[Y]|0)!=(a[X]|0)){V=1;W=y;break L71}u=Z-1|0;if((u|0)==0){V=0;W=y;break}else{X=X+1|0;Y=Y+1|0;Z=u}}}else{V=1;W=z&1}}while(0);if(W<<24>>24!=0){J2(c[p+8>>2]|0)}if((f&1)==0){if(!V){break L50}}else{J2(c[o+8>>2]|0);if(!V){break L50}}z=(x=0,as(230,48)|0);if(x){x=0;t=83;break}j=q+8|0;c[j>>2]=z;c[q>>2]=49;c[q+4>>2]=46;Kb(z|0,9432,46)|0;a[z+46|0]=0;z=b+4|0;L97:do{if((a[z]&1)==0){g=r;c[g>>2]=c[z>>2];c[g+4>>2]=c[z+4>>2];c[g+8>>2]=c[z+8>>2];t=74}else{g=c[b+12>>2]|0;y=c[b+8>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[r]=y<<1;_=r+1|0}else{u=y+16&-16;w=(x=0,as(230,u|0)|0);if(x){x=0;break}c[r+8>>2]=w;c[r>>2]=u|1;c[r+4>>2]=y;_=w}Kb(_|0,g|0,y)|0;a[_+y|0]=0;t=74;break L97}}while(0);y=bQ(-1,-1)|0;$=K;aa=y}}while(0);do{if((t|0)==74){z=s;f=b+16|0;c[z>>2]=c[f>>2];c[z+4>>2]=c[f+4>>2];c[z+8>>2]=c[f+8>>2];x=0;aP(362,q|0,r|0,s|0);if(x){x=0;f=bQ(-1,-1)|0;z=f;f=K;if((a[r]&1)==0){$=f;aa=z;break}J2(c[r+8>>2]|0);$=f;aa=z;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){break L50}J2(c[j>>2]|0);break L50}}while(0);if((a[q]&1)==0){P=$;Q=aa;break}J2(c[j>>2]|0);P=$;Q=aa}else{x=0;t=83}}while(0);if((t|0)==83){z=bQ(-1,-1)|0;P=K;Q=z}if((d&1)==0){ab=P;ac=Q;ad=C;break L44}J2(c[n+8>>2]|0);ab=P;ac=Q;ad=C;break L44}}while(0);z=+h[b+40>>3]<+h[k+40>>3];if((d&1)!=0){J2(c[n+8>>2]|0)}if((C&1)==0){iW(k);i=e;return z|0}J2(c[m+8>>2]|0);iW(k);i=e;return z|0}else{x=0;z=bQ(-1,-1)|0;ab=K;ac=z;ad=a[m]|0}}while(0);if((ad&1)==0){L=ab;M=ac;break}J2(c[m+8>>2]|0);L=ab;M=ac}else{x=0;t=79}}while(0);if((t|0)==79){t=bQ(-1,-1)|0;L=K;M=t}x=0;ap(486,k|0);if(!x){E=L;F=M;G=F;H=0;I=G;J=E;be(I|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function hO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0.0,aB=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0;g=i;i=i+280|0;j=g|0;k=g+8|0;l=g+24|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+168|0;s=g+184|0;t=g+200|0;u=g+216|0;v=g+232|0;w=g+248|0;y=g+264|0;z=e;A=f;B=+h[e+40>>3];C=+h[f+40>>3];D=c[d+36>>2]|0;E=(D|0)==11;F=C!=0.0;if(!(F|E^1)){G=J0(52)|0;c[l>>2]=G;H=b+4|0;I=c[H>>2]|0;if((I|0)==(c[b+8>>2]|0)){ee(b|0,l);J=c[l>>2]|0}else{if((I|0)==0){L=0}else{c[I>>2]=G;L=c[H>>2]|0}c[H>>2]=L+4;J=G}G=J;L=e+4|0;L10:do{if((a[L]&1)==0){I=m;c[I>>2]=c[L>>2];c[I+4>>2]=c[L+4>>2];c[I+8>>2]=c[L+8>>2];M=17}else{I=c[e+12>>2]|0;l=c[e+8>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(l>>>0<11>>>0){a[m]=l<<1;N=m+1|0}else{O=l+16&-16;P=(x=0,as(230,O|0)|0);if(x){x=0;break}c[m+8>>2]=P;c[m>>2]=O|1;c[m+4>>2]=l;N=P}Kb(N|0,I|0,l)|0;a[N+l|0]=0;M=17;break L10}}while(0);l=bQ(-1,-1)|0;Q=l;R=K}}while(0);do{if((M|0)==17){N=d+16|0;L=k;c[L>>2]=c[N>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];x=0;ao(34,J|0,m|0,k|0,9288,0);if(x){x=0;N=bQ(-1,-1)|0;L=N;N=K;if((a[m]&1)==0){Q=L;R=N;break}J2(c[m+8>>2]|0);Q=L;R=N;break}if((a[m]&1)==0){S=G;T=S;i=g;return T|0}J2(c[m+8>>2]|0);S=G;T=S;i=g;return T|0}}while(0);m=c[b>>2]|0;k=c[H>>2]|0;N=m;while(1){if((N|0)==(k|0)){U=k;break}if((c[N>>2]|0)==(J|0)){U=N;break}else{N=N+4|0}}N=U-m>>2;U=m+(N+1<<2)|0;J=k-U|0;Kc(m+(N<<2)|0,U|0,J|0)|0;U=m+((J>>2)+N<<2)|0;N=c[H>>2]|0;if((U|0)!=(N|0)){c[H>>2]=N+(~((N-4+(-U|0)|0)>>>2)<<2)}J2(G);V=Q;W=R;X=V;Y=0;Z=X;_=W;be(Z|0)}L43:do{if(!((D|0)!=12|F)){R=J0(32)|0;Q=n+8|0;c[Q>>2]=R;c[n>>2]=33;c[n+4>>2]=16;Kb(R|0,9224,16)|0;a[R+16|0]=0;R=f+4|0;L45:do{if((a[R]&1)==0){G=o;c[G>>2]=c[R>>2];c[G+4>>2]=c[R+4>>2];c[G+8>>2]=c[R+8>>2];M=40}else{G=c[f+12>>2]|0;U=c[f+8>>2]|0;do{if(U>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(U>>>0<11>>>0){a[o]=U<<1;$=o+1|0}else{N=U+16&-16;H=(x=0,as(230,N|0)|0);if(x){x=0;break}c[o+8>>2]=H;c[o>>2]=N|1;c[o+4>>2]=U;$=H}Kb($|0,G|0,U)|0;a[$+U|0]=0;M=40;break L45}}while(0);U=bQ(-1,-1)|0;aa=U;ab=K}}while(0);do{if((M|0)==40){R=p;U=f+16|0;c[R>>2]=c[U>>2];c[R+4>>2]=c[U+4>>2];c[R+8>>2]=c[U+8>>2];x=0;aP(362,n|0,o|0,p|0);if(x){x=0;U=bQ(-1,-1)|0;R=U;U=K;if((a[o]&1)==0){aa=R;ab=U;break}J2(c[o+8>>2]|0);aa=R;ab=U;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)==0){break L43}J2(c[Q>>2]|0);break L43}}while(0);if((a[n]&1)==0){V=aa;W=ab;X=V;Y=0;Z=X;_=W;be(Z|0)}J2(c[Q>>2]|0);V=aa;W=ab;X=V;Y=0;Z=X;_=W;be(Z|0)}}while(0);kx(q,A);x=0;aq(324,r|0,z|0);do{if(!x){x=0;aq(752,q|0,r|0);if(x){x=0;A=bQ(-1,-1)|0;ab=A;A=K;if((a[r]&1)==0){ac=ab;ad=A;break}J2(c[r+8>>2]|0);ac=ab;ad=A;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}x=0;aq(248,s|0,z|0);if(x){x=0;M=99;break}x=0;aq(248,t|0,q|0);do{if(!x){A=s;ab=s;aa=a[ab]|0;n=aa&255;o=(n&1|0)==0;if(o){ae=n>>>1}else{ae=c[s+4>>2]|0}p=t;$=t;F=a[$]|0;U=F&255;R=(U&1|0)==0;if(R){af=U>>>1}else{af=c[t+4>>2]|0}L94:do{if((ae|0)==(af|0)){G=(aa&1)==0;if(G){ag=A+1|0}else{ag=c[s+8>>2]|0}if((F&1)==0){ah=p+1|0}else{ah=c[t+8>>2]|0}if(!G){if((Kd(ag|0,ah|0,ae|0)|0)==0){M=114;break}else{M=74;break}}if((ae|0)==0){M=114;break}else{ai=ah;aj=ag;ak=ae}while(1){if((a[aj]|0)!=(a[ai]|0)){M=74;break L94}G=ak-1|0;if((G|0)==0){M=114;break}else{ai=ai+1|0;aj=aj+1|0;ak=G}}}else{M=74}}while(0);L110:do{if((M|0)==74){if(o){al=n>>>1}else{al=c[s+4>>2]|0}if((al|0)==0){M=114;break}if(R){am=U>>>1}else{am=c[t+4>>2]|0}if((am|0)==0){M=114;break}if((D-8|0)>>>0>=2>>>0){M=114;break}p=(x=0,as(230,64)|0);if(x){x=0;M=107;break}F=u+8|0;c[F>>2]=p;c[u>>2]=65;c[u+4>>2]=54;Kb(p|0,9112,54)|0;a[p+54|0]=0;p=e+4|0;L124:do{if((a[p]&1)==0){A=v;c[A>>2]=c[p>>2];c[A+4>>2]=c[p+4>>2];c[A+8>>2]=c[p+8>>2];M=94}else{A=c[e+12>>2]|0;aa=c[e+8>>2]|0;do{if(aa>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aa>>>0<11>>>0){a[v]=aa<<1;an=v+1|0}else{G=aa+16&-16;H=(x=0,as(230,G|0)|0);if(x){x=0;break}c[v+8>>2]=H;c[v>>2]=G|1;c[v+4>>2]=aa;an=H}Kb(an|0,A|0,aa)|0;a[an+aa|0]=0;M=94;break L124}}while(0);aa=bQ(-1,-1)|0;ar=aa;at=K}}while(0);do{if((M|0)==94){p=w;aa=e+16|0;c[p>>2]=c[aa>>2];c[p+4>>2]=c[aa+4>>2];c[p+8>>2]=c[aa+8>>2];x=0;aP(362,u|0,v|0,w|0);if(x){x=0;aa=bQ(-1,-1)|0;p=aa;aa=K;if((a[v]&1)==0){ar=p;at=aa;break}J2(c[v+8>>2]|0);ar=p;at=aa;break}if((a[v]&1)!=0){J2(c[v+8>>2]|0)}if((a[u]&1)==0){M=114;break L110}J2(c[F>>2]|0);M=114;break L110}}while(0);if((a[u]&1)==0){au=ar;av=at;break}J2(c[F>>2]|0);au=ar;av=at}}while(0);L149:do{if((M|0)==114){U=(x=0,as(230,72)|0);if(x){x=0;M=107;break}R=U;c[j>>2]=R;U=b+4|0;aa=c[U>>2]|0;if((aa|0)==(c[b+8>>2]|0)){x=0;aq(376,b|0,j|0);if(x){x=0;M=107;break}aw=c[j>>2]|0}else{if((aa|0)==0){ax=0}else{c[aa>>2]=R;ax=c[U>>2]|0}c[U>>2]=ax+4;aw=R}R=aw;aa=aw;x=0;aq(550,aa|0,z|0);if(x){x=0;p=bQ(-1,-1)|0;A=p;p=K;H=c[b>>2]|0;G=c[U>>2]|0;N=H;while(1){if((N|0)==(G|0)){ay=G;break}if((c[N>>2]|0)==(aw|0)){ay=N;break}else{N=N+4|0}}N=ay-H>>2;F=H+(N+1<<2)|0;J=G-F|0;Kc(H+(N<<2)|0,F|0,J|0)|0;F=H+((J>>2)+N<<2)|0;N=c[U>>2]|0;if((F|0)!=(N|0)){c[U>>2]=N+(~((N-4+(-F|0)|0)>>>2)<<2)}J2(R);au=A;av=p;break}Kc(aw+16|0,d+16|0,12)|0;if(o){az=n>>>1}else{az=c[s+4>>2]|0}do{if((az|0)==0){if((D-8|0)>>>0>=2>>>0){break}F=aw+48|0;N=f+48|0;if((F|0)!=(N|0)){x=0;aP(140,F|0,c[N>>2]|0,c[N+4>>2]|0);if(x){x=0;M=107;break L149}}N=aw+60|0;F=f+60|0;if((N|0)==(F|0)){break}x=0;aP(140,N|0,c[F>>2]|0,c[F+4>>2]|0);if(x){x=0;M=107;break L149}}}while(0);aA=(x=0,+(+aC(c[35856+(D<<2)>>2]|0,+B,+C)));if(x){x=0;M=107;break}h[aw+40>>3]=aA;L183:do{if((D|0)==10){p=f+48|0;A=c[p+4>>2]|0;U=c[p>>2]|0;H=(A-U|0)/12|0;L237:do{if((A|0)!=(U|0)){G=aw+48|0;F=G+4|0;N=F;J=G+8|0;m=G;G=0;k=U;L239:while(1){L=k;l=L+(G*12|0)|0;I=c[N>>2]|0;if((I|0)==(c[J>>2]|0)){x=0;aq(282,m|0,l|0);if(x){x=0;M=104;break}}else{do{if((I|0)!=0){P=l;if((a[P]&1)==0){O=I;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];break}P=c[L+(G*12|0)+8>>2]|0;O=c[L+(G*12|0)+4>>2]|0;if(O>>>0>4294967279>>>0){break L239}if(O>>>0<11>>>0){a[I]=O<<1;aB=I+1|0}else{aD=O+16&-16;aE=(x=0,as(230,aD|0)|0);if(x){x=0;M=104;break L239}c[I+8>>2]=aE;c[I>>2]=aD|1;c[I+4>>2]=O;aB=aE}Kb(aB|0,P|0,O)|0;a[aB+O|0]=0}}while(0);c[F>>2]=(c[N>>2]|0)+12}I=G+1|0;if(I>>>0>=H>>>0){break L237}G=I;k=c[p>>2]|0}if((M|0)==104){k=bQ(-1,-1)|0;aF=K;aG=k;M=108;break L149}x=0;ap(232,0);if(x){x=0;M=107;break L149}return 0}}while(0);p=f+60|0;H=c[p+4>>2]|0;U=p;p=c[U>>2]|0;A=(H-p|0)/12|0;if((H|0)==(p|0)){break}H=aw+64|0;k=H;G=aw+68|0;N=aw+60|0;F=0;m=p;L264:while(1){p=m+(F*12|0)|0;J=c[k>>2]|0;if((J|0)==(c[G>>2]|0)){x=0;aq(282,N|0,p|0);if(x){x=0;M=103;break}}else{do{if((J|0)!=0){I=p;if((a[I]&1)==0){L=J;c[L>>2]=c[I>>2];c[L+4>>2]=c[I+4>>2];c[L+8>>2]=c[I+8>>2];break}I=c[m+(F*12|0)+8>>2]|0;L=c[m+(F*12|0)+4>>2]|0;if(L>>>0>4294967279>>>0){break L264}if(L>>>0<11>>>0){a[J]=L<<1;aH=J+1|0}else{l=L+16&-16;O=(x=0,as(230,l|0)|0);if(x){x=0;M=103;break L264}c[J+8>>2]=O;c[J>>2]=l|1;c[J+4>>2]=L;aH=O}Kb(aH|0,I|0,L)|0;a[aH+L|0]=0}}while(0);c[H>>2]=(c[k>>2]|0)+12}J=F+1|0;if(J>>>0>=A>>>0){break L183}F=J;m=c[U>>2]|0}if((M|0)==103){U=bQ(-1,-1)|0;aF=K;aG=U;M=108;break L149}x=0;ap(232,0);if(x){x=0;M=107;break L149}return 0}else{if(!E){break}U=f+48|0;m=c[U+4>>2]|0;F=c[U>>2]|0;A=(m-F|0)/12|0;L186:do{if((m|0)!=(F|0)){k=aw+64|0;H=k;N=aw+68|0;G=aw+60|0;J=0;p=F;L188:while(1){L=p;I=L+(J*12|0)|0;O=c[H>>2]|0;if((O|0)==(c[N>>2]|0)){x=0;aq(282,G|0,I|0);if(x){x=0;M=106;break}}else{do{if((O|0)!=0){l=I;if((a[l]&1)==0){P=O;c[P>>2]=c[l>>2];c[P+4>>2]=c[l+4>>2];c[P+8>>2]=c[l+8>>2];break}l=c[L+(J*12|0)+8>>2]|0;P=c[L+(J*12|0)+4>>2]|0;if(P>>>0>4294967279>>>0){break L188}if(P>>>0<11>>>0){a[O]=P<<1;aI=O+1|0}else{aE=P+16&-16;aD=(x=0,as(230,aE|0)|0);if(x){x=0;M=106;break L188}c[O+8>>2]=aD;c[O>>2]=aE|1;c[O+4>>2]=P;aI=aD}Kb(aI|0,l|0,P)|0;a[aI+P|0]=0}}while(0);c[k>>2]=(c[H>>2]|0)+12}O=J+1|0;if(O>>>0>=A>>>0){break L186}J=O;p=c[U>>2]|0}if((M|0)==106){p=bQ(-1,-1)|0;aF=K;aG=p;M=108;break L149}x=0;ap(232,0);if(x){x=0;M=107;break L149}return 0}}while(0);U=f+60|0;A=c[U+4>>2]|0;F=U;U=c[F>>2]|0;m=(A-U|0)/12|0;if((A|0)==(U|0)){break}A=aw+48|0;p=A+4|0;J=p;H=A+8|0;k=A;A=0;G=U;L213:while(1){U=G+(A*12|0)|0;N=c[J>>2]|0;if((N|0)==(c[H>>2]|0)){x=0;aq(282,k|0,U|0);if(x){x=0;M=105;break}}else{do{if((N|0)!=0){O=U;if((a[O]&1)==0){L=N;c[L>>2]=c[O>>2];c[L+4>>2]=c[O+4>>2];c[L+8>>2]=c[O+8>>2];break}O=c[G+(A*12|0)+8>>2]|0;L=c[G+(A*12|0)+4>>2]|0;if(L>>>0>4294967279>>>0){break L213}if(L>>>0<11>>>0){a[N]=L<<1;aJ=N+1|0}else{I=L+16&-16;P=(x=0,as(230,I|0)|0);if(x){x=0;M=105;break L213}c[N+8>>2]=P;c[N>>2]=I|1;c[N+4>>2]=L;aJ=P}Kb(aJ|0,O|0,L)|0;a[aJ+L|0]=0}}while(0);c[p>>2]=(c[J>>2]|0)+12}N=A+1|0;if(N>>>0>=m>>>0){break L183}A=N;G=c[F>>2]|0}if((M|0)==105){F=bQ(-1,-1)|0;aF=K;aG=F;M=108;break L149}x=0;ap(232,0);if(x){x=0;M=107;break L149}return 0}}while(0);F=y;a[F]=0;a[y+1|0]=0;x=0;aq(752,aa|0,y|0);if(x){x=0;G=bQ(-1,-1)|0;A=G;G=K;if((a[F]&1)==0){au=A;av=G;break}J2(c[y+8>>2]|0);au=A;av=G;break}if((a[F]&1)!=0){J2(c[y+8>>2]|0)}if((a[$]&1)!=0){J2(c[t+8>>2]|0)}if((a[ab]&1)!=0){J2(c[s+8>>2]|0)}iW(q);S=R;T=S;i=g;return T|0}}while(0);if((M|0)==107){n=bQ(-1,-1)|0;aF=K;aG=n;M=108}if((M|0)==108){au=aG;av=aF}if((a[$]&1)==0){aK=au;aL=av;aM=ab;break}J2(c[t+8>>2]|0);aK=au;aL=av;aM=ab}else{x=0;n=bQ(-1,-1)|0;aK=n;aL=K;aM=s}}while(0);if((a[aM]&1)==0){ac=aK;ad=aL;break}J2(c[s+8>>2]|0);ac=aK;ad=aL}else{x=0;M=99}}while(0);if((M|0)==99){M=bQ(-1,-1)|0;ac=M;ad=K}x=0;ap(486,q|0);if(!x){V=ac;W=ad;X=V;Y=0;Z=X;_=W;be(Z|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function hP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0.0,aO=0.0,aQ=0.0,aR=0.0,aS=0,aT=0,aU=0;g=i;i=i+296|0;j=g|0;k=g+16|0;l=g+24|0;m=g+40|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+152|0;v=g+168|0;w=g+184|0;y=g+200|0;z=g+216|0;A=g+232|0;B=g+248|0;C=g+264|0;D=g+280|0;E=e;F=f;G=o;a[G]=0;a[o+1|0]=0;H=(x=0,aK(346,f+72|0,o|0)|0);do{if(!x){I=H;if((a[I]&1)==0){J=n;c[J>>2]=c[I>>2];c[J+4>>2]=c[I+4>>2];c[J+8>>2]=c[I+8>>2];L=a[J]|0}else{J=c[H+8>>2]|0;I=c[H+4>>2]|0;if(I>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(I>>>0<11>>>0){M=I<<1&255;a[n]=M;N=n+1|0;O=M}else{M=I+16&-16;P=(x=0,as(230,M|0)|0);if(x){x=0;break}c[n+8>>2]=P;Q=M|1;c[n>>2]=Q;c[n+4>>2]=I;N=P;O=Q&255}Kb(N|0,J|0,I)|0;a[N+I|0]=0;L=O}if((L&1)!=0){J2(c[n+8>>2]|0)}if((a[G]&1)!=0){J2(c[o+8>>2]|0)}R=+h[e+40>>3];switch(d|0){case 12:{I=J0(48)|0;J=B+8|0;c[J>>2]=I;c[B>>2]=49;c[B+4>>2]=33;Kb(I|0,8720,33)|0;a[I+33|0]=0;I=f+4|0;L25:do{if((a[I]&1)==0){Q=C;c[Q>>2]=c[I>>2];c[Q+4>>2]=c[I+4>>2];c[Q+8>>2]=c[I+8>>2];S=126}else{Q=c[f+12>>2]|0;P=c[f+8>>2]|0;do{if(P>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(P>>>0<11>>>0){a[C]=P<<1;T=C+1|0}else{M=P+16&-16;U=(x=0,as(230,M|0)|0);if(x){x=0;break}c[C+8>>2]=U;c[C>>2]=M|1;c[C+4>>2]=P;T=U}Kb(T|0,Q|0,P)|0;a[T+P|0]=0;S=126;break L25}}while(0);P=bQ(-1,-1)|0;V=P;W=K}}while(0);do{if((S|0)==126){I=D;P=f+16|0;c[I>>2]=c[P>>2];c[I+4>>2]=c[P+4>>2];c[I+8>>2]=c[P+8>>2];x=0;aP(362,B|0,C|0,D|0);if(x){x=0;P=bQ(-1,-1)|0;I=P;P=K;if((a[C]&1)==0){V=I;W=P;break}J2(c[C+8>>2]|0);V=I;W=P;break}if((a[C]&1)!=0){J2(c[C+8>>2]|0)}if((a[B]&1)==0){X=e;i=g;return X|0}J2(c[J>>2]|0);X=e;i=g;return X|0}}while(0);if((a[B]&1)==0){Y=V;Z=W;_=Y;$=0;aa=_;ab=Z;be(aa|0)}J2(c[J>>2]|0);Y=V;Z=W;_=Y;$=0;aa=_;ab=Z;be(aa|0);break};case 9:case 11:{P=s;I=s;a[I]=2;a[P+1|0]=a[((d|0)==9?8984:8816)|0]|0;a[P+2|0]=0;x=0;aq(276,t|0,0);L57:do{if(!x){P=(x=0,as(230,52)|0);do{if(!x){Q=P;c[k>>2]=Q;U=b+4|0;M=c[U>>2]|0;if((M|0)==(c[b+8>>2]|0)){x=0;aq(376,b|0,k|0);if(x){x=0;S=89;break}ac=c[k>>2]|0}else{if((M|0)==0){ad=0}else{c[M>>2]=Q;ad=c[U>>2]|0}c[U>>2]=ad+4;ac=Q}Q=ac;M=ac;ae=e+4|0;L69:do{if((a[ae]&1)==0){af=u;c[af>>2]=c[ae>>2];c[af+4>>2]=c[ae+4>>2];c[af+8>>2]=c[ae+8>>2];S=72}else{af=c[e+12>>2]|0;ag=c[e+8>>2]|0;do{if(ag>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ag>>>0<11>>>0){a[u]=ag<<1;ah=u+1|0}else{ai=ag+16&-16;aj=(x=0,as(230,ai|0)|0);if(x){x=0;break}c[u+8>>2]=aj;c[u>>2]=ai|1;c[u+4>>2]=ag;ah=aj}Kb(ah|0,af|0,ag)|0;a[ah+ag|0]=0;S=72;break L69}}while(0);ag=bQ(-1,-1)|0;ak=ag;al=K}}while(0);do{if((S|0)==72){ae=v;ag=e+16|0;c[ae>>2]=c[ag>>2];c[ae+4>>2]=c[ag+4>>2];c[ae+8>>2]=c[ag+8>>2];ag=t|0;x=0;aP(c[(c[e>>2]|0)+28>>2]|0,z|0,E|0,ag|0);do{if(!x){x=0;aP(194,y|0,z|0,s|0);do{if(!x){x=0;aP(c[(c[f>>2]|0)+28>>2]|0,A|0,F|0,ag|0);do{if(!x){x=0;aP(194,w|0,y|0,A|0);do{if(!x){af=j;c[af>>2]=c[ae>>2];c[af+4>>2]=c[ae+4>>2];c[af+8>>2]=c[ae+8>>2];x=0;ao(26,M|0,u|0,j|0,w|0,0);if(x){x=0;af=bQ(-1,-1)|0;aj=af;af=K;if((a[w]&1)==0){am=aj;an=af;break}J2(c[w+8>>2]|0);am=aj;an=af;break}af=ac;if((a[w]&1)!=0){J2(c[w+8>>2]|0)}if((a[A]&1)!=0){J2(c[A+8>>2]|0)}if((a[y]&1)!=0){J2(c[y+8>>2]|0)}if((a[z]&1)!=0){J2(c[z+8>>2]|0)}if((a[u]&1)!=0){J2(c[u+8>>2]|0)}x=0;ap(436,t|0);if(x){x=0;S=88;break L57}if((a[I]&1)==0){X=af;i=g;return X|0}J2(c[s+8>>2]|0);X=af;i=g;return X|0}else{x=0;af=bQ(-1,-1)|0;am=af;an=K}}while(0);if((a[A]&1)==0){ar=am;au=an;break}J2(c[A+8>>2]|0);ar=am;au=an}else{x=0;af=bQ(-1,-1)|0;ar=af;au=K}}while(0);if((a[y]&1)==0){av=ar;aw=au;break}J2(c[y+8>>2]|0);av=ar;aw=au}else{x=0;af=bQ(-1,-1)|0;av=af;aw=K}}while(0);if((a[z]&1)==0){ax=av;ay=aw;break}J2(c[z+8>>2]|0);ax=av;ay=aw}else{x=0;af=bQ(-1,-1)|0;ax=af;ay=K}}while(0);if((a[u]&1)==0){ak=ax;al=ay;break}J2(c[u+8>>2]|0);ak=ax;al=ay}}while(0);M=c[b>>2]|0;ae=c[U>>2]|0;ag=M;while(1){if((ag|0)==(ae|0)){az=ae;break}if((c[ag>>2]|0)==(ac|0)){az=ag;break}else{ag=ag+4|0}}ag=az-M>>2;af=M+(ag+1<<2)|0;aj=ae-af|0;Kc(M+(ag<<2)|0,af|0,aj|0)|0;af=M+((aj>>2)+ag<<2)|0;ag=c[U>>2]|0;if((af|0)!=(ag|0)){c[U>>2]=ag+(~((ag-4+(-af|0)|0)>>>2)<<2)}J2(Q);aA=ak;aB=al}else{x=0;S=89}}while(0);if((S|0)==89){P=bQ(-1,-1)|0;aA=P;aB=K}x=0;ap(436,t|0);if(!x){aD=aA;aE=aB;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{x=0;S=88}}while(0);if((S|0)==88){J=bQ(-1,-1)|0;aD=J;aE=K}if((a[I]&1)==0){Y=aD;Z=aE;_=Y;$=0;aa=_;ab=Z;be(aa|0)}J2(c[s+8>>2]|0);Y=aD;Z=aE;_=Y;$=0;aa=_;ab=Z;be(aa|0);break};case 8:case 10:{J=J0(88)|0;c[m>>2]=J;P=b+4|0;af=c[P>>2]|0;if((af|0)==(c[b+8>>2]|0)){ee(b|0,m);aF=c[m>>2]|0}else{if((af|0)==0){aG=0}else{c[af>>2]=J;aG=c[P>>2]|0}c[P>>2]=aG+4;aF=J}J=aF;af=aF;ag=e+4|0;L155:do{if((a[ag]&1)==0){aj=p;c[aj>>2]=c[ag>>2];c[aj+4>>2]=c[ag+4>>2];c[aj+8>>2]=c[ag+8>>2];S=34}else{aj=c[e+12>>2]|0;ai=c[e+8>>2]|0;do{if(ai>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ai>>>0<11>>>0){a[p]=ai<<1;aH=p+1|0}else{aI=ai+16&-16;aJ=(x=0,as(230,aI|0)|0);if(x){x=0;break}c[p+8>>2]=aJ;c[p>>2]=aI|1;c[p+4>>2]=ai;aH=aJ}Kb(aH|0,aj|0,ai)|0;a[aH+ai|0]=0;S=34;break L155}}while(0);ai=bQ(-1,-1)|0;aL=ai;aM=K}}while(0);do{if((S|0)==34){ag=q;I=e+16|0;c[ag>>2]=c[I>>2];c[ag+4>>2]=c[I+4>>2];c[ag+8>>2]=c[I+8>>2];I=35856+(d<<2)|0;aN=(x=0,+(+aC(c[I>>2]|0,+R,+(+h[f+40>>3]))));do{if(!x){aO=(x=0,+(+aC(c[I>>2]|0,+R,+(+h[f+48>>3]))));if(x){x=0;S=43;break}aQ=(x=0,+(+aC(c[I>>2]|0,+R,+(+h[f+56>>3]))));if(x){x=0;S=43;break}aR=+h[f+64>>3];ai=r;a[ai]=0;a[r+1|0]=0;aj=l;c[aj>>2]=c[ag>>2];c[aj+4>>2]=c[ag+4>>2];c[aj+8>>2]=c[ag+8>>2];x=0;at(2,af|0,p|0,l|0,+aN,+aO,+aQ,+aR,r|0);if(x){x=0;aj=bQ(-1,-1)|0;aJ=aj;aj=K;if((a[ai]&1)==0){aS=aJ;aT=aj;break}J2(c[r+8>>2]|0);aS=aJ;aT=aj;break}if((a[ai]&1)!=0){J2(c[r+8>>2]|0)}ai=aF;if((a[p]&1)==0){X=ai;i=g;return X|0}J2(c[p+8>>2]|0);X=ai;i=g;return X|0}else{x=0;S=43}}while(0);if((S|0)==43){ag=bQ(-1,-1)|0;aS=ag;aT=K}if((a[p]&1)==0){aL=aS;aM=aT;break}J2(c[p+8>>2]|0);aL=aS;aM=aT}}while(0);af=c[b>>2]|0;ag=c[P>>2]|0;I=af;while(1){if((I|0)==(ag|0)){aU=ag;break}if((c[I>>2]|0)==(aF|0)){aU=I;break}else{I=I+4|0}}I=aU-af>>2;ai=af+(I+1<<2)|0;aj=ag-ai|0;Kc(af+(I<<2)|0,ai|0,aj|0)|0;ai=af+((aj>>2)+I<<2)|0;I=c[P>>2]|0;if((ai|0)!=(I|0)){c[P>>2]=I+(~((I-4+(-ai|0)|0)>>>2)<<2)}J2(J);Y=aL;Z=aM;_=Y;$=0;aa=_;ab=Z;be(aa|0);break};default:{X=e;i=g;return X|0}}}else{x=0}}while(0);X=bQ(-1,-1)|0;g=X;X=K;if((a[G]&1)==0){Y=g;Z=X;_=Y;$=0;aa=_;ab=Z;be(aa|0)}J2(c[o+8>>2]|0);Y=g;Z=X;_=Y;$=0;aa=_;ab=Z;be(aa|0);return 0}function hQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0;g=i;i=i+120|0;j=g|0;k=g+16|0;l=g+24|0;m=g+40|0;n=g+56|0;o=g+72|0;p=g+88|0;q=g+104|0;r=+h[f+40>>3];L1:do{if(!((d|0)!=11|r!=0.0)){s=J0(32)|0;t=l+8|0;c[t>>2]=s;c[l>>2]=33;c[l+4>>2]=16;Kb(s|0,9224,16)|0;a[s+16|0]=0;s=f+4|0;L3:do{if((a[s]&1)==0){u=m;c[u>>2]=c[s>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];v=12}else{u=c[f+12>>2]|0;w=c[f+8>>2]|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(w>>>0<11>>>0){a[m]=w<<1;y=m+1|0}else{z=w+16&-16;A=(x=0,as(230,z|0)|0);if(x){x=0;break}c[m+8>>2]=A;c[m>>2]=z|1;c[m+4>>2]=w;y=A}Kb(y|0,u|0,w)|0;a[y+w|0]=0;v=12;break L3}}while(0);w=bQ(-1,-1)|0;B=K;C=w}}while(0);do{if((v|0)==12){s=n;w=f+16|0;c[s>>2]=c[w>>2];c[s+4>>2]=c[w+4>>2];c[s+8>>2]=c[w+8>>2];x=0;aP(362,l|0,m|0,n|0);if(x){x=0;w=bQ(-1,-1)|0;s=w;w=K;if((a[m]&1)==0){B=w;C=s;break}J2(c[m+8>>2]|0);B=w;C=s;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}if((a[l]&1)==0){break L1}J2(c[t>>2]|0);break L1}}while(0);if((a[l]&1)==0){D=B;E=C;F=E;G=0;H=F;I=D;be(H|0)}J2(c[t>>2]|0);D=B;E=C;F=E;G=0;H=F;I=D;be(H|0)}}while(0);C=J0(88)|0;c[k>>2]=C;B=b+4|0;l=c[B>>2]|0;if((l|0)==(c[b+8>>2]|0)){ee(b|0,k);J=c[k>>2]|0}else{if((l|0)==0){L=0}else{c[l>>2]=C;L=c[B>>2]|0}c[B>>2]=L+4;J=C}C=J;L=J;l=e+4|0;L39:do{if((a[l]&1)==0){k=o;c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];v=37}else{k=c[e+12>>2]|0;m=c[e+8>>2]|0;do{if(m>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(m>>>0<11>>>0){a[o]=m<<1;M=o+1|0}else{n=m+16&-16;f=(x=0,as(230,n|0)|0);if(x){x=0;break}c[o+8>>2]=f;c[o>>2]=n|1;c[o+4>>2]=m;M=f}Kb(M|0,k|0,m)|0;a[M+m|0]=0;v=37;break L39}}while(0);m=bQ(-1,-1)|0;N=K;O=m}}while(0);do{if((v|0)==37){M=p;l=e+16|0;c[M>>2]=c[l>>2];c[M+4>>2]=c[l+4>>2];c[M+8>>2]=c[l+8>>2];l=35856+(d<<2)|0;P=(x=0,+(+aC(c[l>>2]|0,+(+h[e+40>>3]),+r)));do{if(!x){Q=(x=0,+(+aC(c[l>>2]|0,+(+h[e+48>>3]),+r)));if(x){x=0;v=47;break}R=(x=0,+(+aC(c[l>>2]|0,+(+h[e+56>>3]),+r)));if(x){x=0;v=47;break}S=+h[e+64>>3];m=q;a[m]=0;a[q+1|0]=0;k=j;c[k>>2]=c[M>>2];c[k+4>>2]=c[M+4>>2];c[k+8>>2]=c[M+8>>2];x=0;at(2,L|0,o|0,j|0,+P,+Q,+R,+S,q|0);if(x){x=0;k=bQ(-1,-1)|0;t=k;k=K;if((a[m]&1)==0){T=k;U=t;break}J2(c[q+8>>2]|0);T=k;U=t;break}t=J;if((a[m]&1)!=0){J2(c[q+8>>2]|0)}if((a[o]&1)==0){i=g;return t|0}J2(c[o+8>>2]|0);i=g;return t|0}else{x=0;v=47}}while(0);if((v|0)==47){M=bQ(-1,-1)|0;T=K;U=M}if((a[o]&1)==0){N=T;O=U;break}J2(c[o+8>>2]|0);N=T;O=U}}while(0);U=c[b>>2]|0;b=c[B>>2]|0;T=U;while(1){if((T|0)==(b|0)){V=b;break}if((c[T>>2]|0)==(J|0)){V=T;break}else{T=T+4|0}}T=V-U>>2;V=U+(T+1<<2)|0;J=b-V|0;Kc(U+(T<<2)|0,V|0,J|0)|0;V=U+((J>>2)+T<<2)|0;T=c[B>>2]|0;if((V|0)!=(T|0)){c[B>>2]=T+(~((T-4+(-V|0)|0)>>>2)<<2)}J2(C);D=N;E=O;F=E;G=0;H=F;I=D;be(H|0);return 0}function hR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0,$=0;g=i;i=i+168|0;j=g|0;k=g+16|0;l=g+24|0;m=g+40|0;n=g+56|0;o=g+72|0;p=g+88|0;q=g+104|0;r=g+120|0;s=g+136|0;t=g+152|0;u=e+64|0;L1:do{if(+h[u>>3]!=+h[f+64>>3]){v=J0(64)|0;w=l+8|0;c[w>>2]=v;c[l>>2]=65;c[l+4>>2]=50;Kb(v|0,8592,50)|0;a[v+50|0]=0;v=f+4|0;L3:do{if((a[v]&1)==0){y=m;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];z=12}else{y=c[f+12>>2]|0;A=c[f+8>>2]|0;do{if(A>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(A>>>0<11>>>0){a[m]=A<<1;B=m+1|0}else{C=A+16&-16;D=(x=0,as(230,C|0)|0);if(x){x=0;break}c[m+8>>2]=D;c[m>>2]=C|1;c[m+4>>2]=A;B=D}Kb(B|0,y|0,A)|0;a[B+A|0]=0;z=12;break L3}}while(0);A=bQ(-1,-1)|0;E=K;F=A}}while(0);do{if((z|0)==12){v=n;A=f+16|0;c[v>>2]=c[A>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];x=0;aP(362,l|0,m|0,n|0);if(x){x=0;A=bQ(-1,-1)|0;v=A;A=K;if((a[m]&1)==0){E=A;F=v;break}J2(c[m+8>>2]|0);E=A;F=v;break}if((a[m]&1)!=0){J2(c[m+8>>2]|0)}if((a[l]&1)==0){break L1}J2(c[w>>2]|0);break L1}}while(0);if((a[l]&1)==0){G=E;H=F;I=H;J=0;L=I;M=G;be(L|0)}J2(c[w>>2]|0);G=E;H=F;I=H;J=0;L=I;M=G;be(L|0)}}while(0);L32:do{if((d-11|0)>>>0<2>>>0){do{if(+h[f+40>>3]!=0.0){if(+h[f+48>>3]==0.0){break}if(+h[f+56>>3]!=0.0){break L32}}}while(0);w=J0(32)|0;F=o+8|0;c[F>>2]=w;c[o>>2]=33;c[o+4>>2]=16;Kb(w|0,9224,16)|0;a[w+16|0]=0;w=f+4|0;L38:do{if((a[w]&1)==0){E=p;c[E>>2]=c[w>>2];c[E+4>>2]=c[w+4>>2];c[E+8>>2]=c[w+8>>2];z=36}else{E=c[f+12>>2]|0;l=c[f+8>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(l>>>0<11>>>0){a[p]=l<<1;N=p+1|0}else{m=l+16&-16;n=(x=0,as(230,m|0)|0);if(x){x=0;break}c[p+8>>2]=n;c[p>>2]=m|1;c[p+4>>2]=l;N=n}Kb(N|0,E|0,l)|0;a[N+l|0]=0;z=36;break L38}}while(0);l=bQ(-1,-1)|0;O=K;P=l}}while(0);do{if((z|0)==36){w=q;l=f+16|0;c[w>>2]=c[l>>2];c[w+4>>2]=c[l+4>>2];c[w+8>>2]=c[l+8>>2];x=0;aP(362,o|0,p|0,q|0);if(x){x=0;l=bQ(-1,-1)|0;w=l;l=K;if((a[p]&1)==0){O=l;P=w;break}J2(c[p+8>>2]|0);O=l;P=w;break}if((a[p]&1)!=0){J2(c[p+8>>2]|0)}if((a[o]&1)==0){break L32}J2(c[F>>2]|0);break L32}}while(0);if((a[o]&1)==0){G=O;H=P;I=H;J=0;L=I;M=G;be(L|0)}J2(c[F>>2]|0);G=O;H=P;I=H;J=0;L=I;M=G;be(L|0)}}while(0);P=J0(88)|0;c[k>>2]=P;O=b+4|0;o=c[O>>2]|0;if((o|0)==(c[b+8>>2]|0)){ee(b|0,k);Q=c[k>>2]|0}else{if((o|0)==0){R=0}else{c[o>>2]=P;R=c[O>>2]|0}c[O>>2]=R+4;Q=P}P=Q;R=Q;o=e+4|0;L74:do{if((a[o]&1)==0){k=r;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];z=61}else{k=c[e+12>>2]|0;p=c[e+8>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(p>>>0<11>>>0){a[r]=p<<1;S=r+1|0}else{q=p+16&-16;N=(x=0,as(230,q|0)|0);if(x){x=0;break}c[r+8>>2]=N;c[r>>2]=q|1;c[r+4>>2]=p;S=N}Kb(S|0,k|0,p)|0;a[S+p|0]=0;z=61;break L74}}while(0);p=bQ(-1,-1)|0;T=K;U=p}}while(0);do{if((z|0)==61){S=s;o=e+16|0;c[S>>2]=c[o>>2];c[S+4>>2]=c[o+4>>2];c[S+8>>2]=c[o+8>>2];o=35856+(d<<2)|0;V=(x=0,+(+aC(c[o>>2]|0,+(+h[e+40>>3]),+(+h[f+40>>3]))));do{if(!x){W=(x=0,+(+aC(c[o>>2]|0,+(+h[e+48>>3]),+(+h[f+48>>3]))));if(x){x=0;z=71;break}X=(x=0,+(+aC(c[o>>2]|0,+(+h[e+56>>3]),+(+h[f+56>>3]))));if(x){x=0;z=71;break}Y=+h[u>>3];p=t;a[p]=0;a[t+1|0]=0;k=j;c[k>>2]=c[S>>2];c[k+4>>2]=c[S+4>>2];c[k+8>>2]=c[S+8>>2];x=0;at(2,R|0,r|0,j|0,+V,+W,+X,+Y,t|0);if(x){x=0;k=bQ(-1,-1)|0;F=k;k=K;if((a[p]&1)==0){Z=k;_=F;break}J2(c[t+8>>2]|0);Z=k;_=F;break}F=Q;if((a[p]&1)!=0){J2(c[t+8>>2]|0)}if((a[r]&1)==0){i=g;return F|0}J2(c[r+8>>2]|0);i=g;return F|0}else{x=0;z=71}}while(0);if((z|0)==71){S=bQ(-1,-1)|0;Z=K;_=S}if((a[r]&1)==0){T=Z;U=_;break}J2(c[r+8>>2]|0);T=Z;U=_}}while(0);_=c[b>>2]|0;b=c[O>>2]|0;Z=_;while(1){if((Z|0)==(b|0)){$=b;break}if((c[Z>>2]|0)==(Q|0)){$=Z;break}else{Z=Z+4|0}}Z=$-_>>2;$=_+(Z+1<<2)|0;Q=b-$|0;Kc(_+(Z<<2)|0,$|0,Q|0)|0;$=_+((Q>>2)+Z<<2)|0;Z=c[O>>2]|0;if(($|0)!=(Z|0)){c[O>>2]=Z+(~((Z-4+(-$|0)|0)>>>2)<<2)}J2(P);G=T;H=U;I=H;J=0;L=I;M=G;be(L|0);return 0}function hS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aO=0,aQ=0;g=i;i=i+240|0;h=g|0;j=g+16|0;k=g+24|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=g+112|0;r=g+128|0;s=g+144|0;t=g+160|0;u=g+176|0;v=g+192|0;w=g+208|0;y=g+224|0;z=y;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+12|0;i=i+7&-8;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+12|0;i=i+7&-8;G=i;i=i+12|0;i=i+7&-8;Ac(k,0);H=c[e+32>>2]|0;I=c[f+32>>2]|0;L1:do{if((H|0)==3){J=m;a[J]=0;a[m+1|0]=0;L=(x=0,aK(346,e+72|0,m|0)|0);do{if(!x){M=L;if((a[M]&1)==0){N=l;c[N>>2]=c[M>>2];c[N+4>>2]=c[M+4>>2];c[N+8>>2]=c[M+8>>2];O=a[N]|0}else{N=c[L+8>>2]|0;M=c[L+4>>2]|0;if(M>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(M>>>0<11>>>0){P=M<<1&255;a[l]=P;Q=l+1|0;R=P}else{P=M+16&-16;S=(x=0,as(230,P|0)|0);if(x){x=0;break}c[l+8>>2]=S;T=P|1;c[l>>2]=T;c[l+4>>2]=M;Q=S;R=T&255}Kb(Q|0,N|0,M)|0;a[Q+M|0]=0;O=R}if((O&1)!=0){J2(c[l+8>>2]|0)}if((a[J]&1)==0){U=20;break L1}J2(c[m+8>>2]|0);U=20;break L1}else{x=0}}while(0);L=bQ(-1,-1)|0;M=L;L=K;if((a[J]&1)==0){V=L;W=M;break}J2(c[m+8>>2]|0);V=L;W=M}else{U=20}}while(0);L24:do{if((U|0)==20){L26:do{if((I|0)==3){m=o;a[m]=0;a[o+1|0]=0;l=(x=0,aK(346,f+72|0,o|0)|0);do{if(!x){O=l;if((a[O]&1)==0){R=n;c[R>>2]=c[O>>2];c[R+4>>2]=c[O+4>>2];c[R+8>>2]=c[O+8>>2];X=a[R]|0}else{R=c[l+8>>2]|0;O=c[l+4>>2]|0;if(O>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(O>>>0<11>>>0){Q=O<<1&255;a[n]=Q;Y=n+1|0;Z=Q}else{Q=O+16&-16;M=(x=0,as(230,Q|0)|0);if(x){x=0;break}c[n+8>>2]=M;L=Q|1;c[n>>2]=L;c[n+4>>2]=O;Y=M;Z=L&255}Kb(Y|0,R|0,O)|0;a[Y+O|0]=0;X=Z}if((X&1)!=0){J2(c[n+8>>2]|0)}if((a[m]&1)==0){break L26}J2(c[o+8>>2]|0);break L26}else{x=0}}while(0);l=bQ(-1,-1)|0;O=l;l=K;if((a[m]&1)==0){V=l;W=O;break L24}J2(c[o+8>>2]|0);V=l;W=O;break L24}}while(0);J=k|0;x=0;aP(c[(c[e>>2]|0)+28>>2]|0,p|0,e|0,J|0);if(x){x=0;O=bQ(-1,-1)|0;V=K;W=O;break}x=0;aP(c[(c[f>>2]|0)+28>>2]|0,q|0,f|0,J|0);do{if(!x){L56:do{if((H|0)==4){J=p;O=(a[p]&1)==0;if(O){_=J+1|0}else{_=c[p+8>>2]|0}if((a[_]|0)==34){$=0}else{if(O){aa=J+1|0}else{aa=c[p+8>>2]|0}$=(a[aa]|0)!=39}J=(a[e+28|0]&1)==0;if(!J){ab=$;U=62;break}O=b+148|0;l=O|0;if((iG(l,p)|0)!=0&(I|0)==4){do{if((a[f+28|0]&1)==0){if((iG(l,q)|0)==0){break}R=(x=0,aK(262,O|0,p|0)|0);if(x){x=0;U=50;break L56}L=c[R>>2]|0;R=(x=0,aK(262,O|0,q|0)|0);if(x){x=0;U=50;break L56}M=(x=0,aS(42,b|0,d|0,L|0,c[R>>2]|0)|0);if(!x){ac=M;U=211;break L56}else{x=0;U=50;break L56}}}while(0);if(!J){ab=$;U=62;break}}O=b+148|0;if(!((iG(O|0,p)|0)!=0&(I|0)==2)){ab=$;U=62;break}l=(x=0,aK(262,O|0,p|0)|0);if(x){x=0;U=50;break}O=(x=0,aS(20,b|0,d|0,c[l>>2]|0,f|0)|0);if(!x){ac=O;U=211}else{x=0;U=50}}else{ab=0;U=62}}while(0);L81:do{if((U|0)==62){do{if((H|0)==2&(I|0)==4){if((a[f+28|0]&1)!=0){break}m=b+148|0;if((iG(m|0,q)|0)==0){break}O=(x=0,aK(262,m|0,q|0)|0);if(x){x=0;U=50;break L81}m=(x=0,aS(10,b|0,d|0,f|0,c[O>>2]|0)|0);if(!x){ac=m;U=211;break L81}else{x=0;U=50;break L81}}}while(0);L89:do{if((d|0)==10){J=(x=0,as(230,48)|0);if(x){x=0;U=50;break L81}m=r+8|0;c[m>>2]=J;c[r>>2]=49;c[r+4>>2]=35;Kb(J|0,8456,35)|0;a[J+35|0]=0;J=e+4|0;L92:do{if((a[J]&1)==0){O=s;c[O>>2]=c[J>>2];c[O+4>>2]=c[J+4>>2];c[O+8>>2]=c[J+8>>2];U=79}else{O=c[e+12>>2]|0;l=c[e+8>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(l>>>0<11>>>0){a[s]=l<<1;ad=s+1|0}else{M=l+16&-16;R=(x=0,as(230,M|0)|0);if(x){x=0;break}c[s+8>>2]=R;c[s>>2]=M|1;c[s+4>>2]=l;ad=R}Kb(ad|0,O|0,l)|0;a[ad+l|0]=0;U=79;break L92}}while(0);l=bQ(-1,-1)|0;ae=K;af=l}}while(0);do{if((U|0)==79){J=t;l=e+16|0;c[J>>2]=c[l>>2];c[J+4>>2]=c[l+4>>2];c[J+8>>2]=c[l+8>>2];x=0;aP(362,r|0,s|0,t|0);if(x){x=0;l=bQ(-1,-1)|0;J=l;l=K;if((a[s]&1)==0){ae=l;af=J;break}J2(c[s+8>>2]|0);ae=l;af=J;break}if((a[s]&1)!=0){J2(c[s+8>>2]|0)}if((a[r]&1)==0){break L89}J2(c[m>>2]|0);break L89}}while(0);if((a[r]&1)==0){ag=ae;ah=af;break L81}J2(c[m>>2]|0);ag=ae;ah=af;break L81}else if((d|0)==12){J=(x=0,as(230,32)|0);if(x){x=0;U=50;break L81}l=u+8|0;c[l>>2]=J;c[u>>2]=33;c[u+4>>2]=27;Kb(J|0,8144,27)|0;a[J+27|0]=0;J=e+4|0;L119:do{if((a[J]&1)==0){O=v;c[O>>2]=c[J>>2];c[O+4>>2]=c[J+4>>2];c[O+8>>2]=c[J+8>>2];U=100}else{O=c[e+12>>2]|0;R=c[e+8>>2]|0;do{if(R>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(R>>>0<11>>>0){a[v]=R<<1;ai=v+1|0}else{M=R+16&-16;L=(x=0,as(230,M|0)|0);if(x){x=0;break}c[v+8>>2]=L;c[v>>2]=M|1;c[v+4>>2]=R;ai=L}Kb(ai|0,O|0,R)|0;a[ai+R|0]=0;U=100;break L119}}while(0);R=bQ(-1,-1)|0;aj=K;ak=R}}while(0);do{if((U|0)==100){J=w;m=e+16|0;c[J>>2]=c[m>>2];c[J+4>>2]=c[m+4>>2];c[J+8>>2]=c[m+8>>2];x=0;aP(362,u|0,v|0,w|0);if(x){x=0;m=bQ(-1,-1)|0;J=m;m=K;if((a[v]&1)==0){aj=m;ak=J;break}J2(c[v+8>>2]|0);aj=m;ak=J;break}if((a[v]&1)!=0){J2(c[v+8>>2]|0)}if((a[u]&1)==0){break L89}J2(c[l>>2]|0);break L89}}while(0);if((a[u]&1)==0){ag=aj;ah=ak;break L81}J2(c[l>>2]|0);ag=aj;ah=ak;break L81}}while(0);Ke(z|0,0,12)|0;if((d|0)==9){x=0,aK(538,y|0,8984)|0;if(!x){U=114}else{x=0;U=112}}else if((d|0)==11){x=0,aK(538,y|0,8816)|0;if(!x){U=114}else{x=0;U=112}}else{U=114}L148:do{if((U|0)==114){J=p;m=(a[p]&1)==0;if(m){al=J+1|0}else{al=c[p+8>>2]|0}do{if((a[al]|0)==34){U=122}else{if(m){am=J+1|0}else{am=c[p+8>>2]|0}if((a[am]|0)==39){U=122;break}R=q;O=(a[q]&1)==0;if(O){an=R+1|0}else{an=c[q+8>>2]|0}if((a[an]|0)!=34){if(O){ar=R+1|0}else{ar=c[q+8>>2]|0}if((a[ar]|0)!=39){at=0;break}}if(O){au=R+1|0}else{au=c[q+8>>2]|0}at=a[au]|0}}while(0);if((U|0)==122){if(m){av=J+1|0}else{av=c[p+8>>2]|0}at=a[av]|0}x=0;aq(180,C|0,p|0);if(x){x=0;U=112;break}x=0;aP(194,B|0,C|0,y|0);do{if(!x){x=0;aq(180,D|0,q|0);do{if(!x){x=0;aP(194,A|0,B|0,D|0);if(x){x=0;l=bQ(-1,-1)|0;R=l;l=K;if((a[D]&1)==0){aw=l;ax=R;break}J2(c[D+8>>2]|0);aw=l;ax=R;break}if((a[D]&1)!=0){J2(c[D+8>>2]|0)}if((a[B]&1)!=0){J2(c[B+8>>2]|0)}if((a[C]&1)!=0){J2(c[C+8>>2]|0)}R=(x=0,as(230,52)|0);do{if(!x){l=R;c[j>>2]=l;O=b+4|0;L=c[O>>2]|0;if((L|0)==(c[b+8>>2]|0)){x=0;aq(376,b|0,j|0);if(x){x=0;U=192;break}ay=c[j>>2]|0}else{if((L|0)==0){az=0}else{c[L>>2]=l;az=c[O>>2]|0}c[O>>2]=az+4;ay=l}l=ay;L=ay;M=e+4|0;L213:do{if((a[M]&1)==0){Q=E;c[Q>>2]=c[M>>2];c[Q+4>>2]=c[M+4>>2];c[Q+8>>2]=c[M+8>>2];U=165}else{Q=c[e+12>>2]|0;N=c[e+8>>2]|0;do{if(N>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(N>>>0<11>>>0){a[E]=N<<1;aA=E+1|0}else{T=N+16&-16;S=(x=0,as(230,T|0)|0);if(x){x=0;break}c[E+8>>2]=S;c[E>>2]=T|1;c[E+4>>2]=N;aA=S}Kb(aA|0,Q|0,N)|0;a[aA+N|0]=0;U=165;break L213}}while(0);N=bQ(-1,-1)|0;aB=K;aC=N}}while(0);do{if((U|0)==165){M=F;N=e+16|0;c[M>>2]=c[N>>2];c[M+4>>2]=c[N+4>>2];c[M+8>>2]=c[N+8>>2];do{if(ab){N=A;if((a[N]&1)==0){Q=G;c[Q>>2]=c[N>>2];c[Q+4>>2]=c[N+4>>2];c[Q+8>>2]=c[N+8>>2];U=177;break}N=c[A+8>>2]|0;Q=c[A+4>>2]|0;if(Q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;U=194;break}return 0}if(Q>>>0<11>>>0){a[G]=Q<<1;aD=G+1|0}else{S=Q+16&-16;T=(x=0,as(230,S|0)|0);if(x){x=0;U=194;break}c[G+8>>2]=T;c[G>>2]=S|1;c[G+4>>2]=Q;aD=T}Kb(aD|0,N|0,Q)|0;a[aD+Q|0]=0;U=177}else{x=0;aP(266,G|0,A|0,at|0);if(!x){U=177}else{x=0;U=194}}}while(0);do{if((U|0)==177){Q=h;c[Q>>2]=c[M>>2];c[Q+4>>2]=c[M+4>>2];c[Q+8>>2]=c[M+8>>2];x=0;ao(26,L|0,E|0,h|0,G|0,0);if(x){x=0;Q=bQ(-1,-1)|0;N=Q;Q=K;if((a[G]&1)==0){aE=Q;aF=N;break}J2(c[G+8>>2]|0);aE=Q;aF=N;break}N=ay;if((a[G]&1)!=0){J2(c[G+8>>2]|0)}if((a[E]&1)!=0){J2(c[E+8>>2]|0)}if((a[A]&1)!=0){J2(c[A+8>>2]|0)}if((a[z]&1)==0){ac=N;U=211;break L81}J2(c[y+8>>2]|0);ac=N;U=211;break L81}else if((U|0)==194){N=bQ(-1,-1)|0;aE=K;aF=N}}while(0);if((a[E]&1)==0){aB=aE;aC=aF;break}J2(c[E+8>>2]|0);aB=aE;aC=aF}}while(0);L=c[b>>2]|0;M=c[O>>2]|0;N=L;while(1){if((N|0)==(M|0)){aG=M;break}if((c[N>>2]|0)==(ay|0)){aG=N;break}else{N=N+4|0}}N=aG-L>>2;Q=L+(N+1<<2)|0;T=M-Q|0;Kc(L+(N<<2)|0,Q|0,T|0)|0;Q=L+((T>>2)+N<<2)|0;N=c[O>>2]|0;if((Q|0)!=(N|0)){c[O>>2]=N+(~((N-4+(-Q|0)|0)>>>2)<<2)}J2(l);aH=aB;aI=aC}else{x=0;U=192}}while(0);if((U|0)==192){R=bQ(-1,-1)|0;aH=K;aI=R}if((a[A]&1)==0){aJ=aH;aL=aI;break L148}J2(c[A+8>>2]|0);aJ=aH;aL=aI;break L148}else{x=0;R=bQ(-1,-1)|0;aw=K;ax=R}}while(0);if((a[B]&1)==0){aM=aw;aN=ax;break}J2(c[B+8>>2]|0);aM=aw;aN=ax}else{x=0;R=bQ(-1,-1)|0;aM=K;aN=R}}while(0);if((a[C]&1)==0){aJ=aM;aL=aN;break}J2(c[C+8>>2]|0);aJ=aM;aL=aN}}while(0);if((U|0)==112){J=bQ(-1,-1)|0;aJ=K;aL=J}if((a[z]&1)==0){ag=aJ;ah=aL;break}J2(c[y+8>>2]|0);ag=aJ;ah=aL}}while(0);if((U|0)==211){if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((a[p]&1)==0){Ae(k);i=g;return ac|0}J2(c[p+8>>2]|0);Ae(k);i=g;return ac|0}else if((U|0)==50){J=bQ(-1,-1)|0;ag=K;ah=J}if((a[q]&1)==0){aO=ag;aQ=ah;break}J2(c[q+8>>2]|0);aO=ag;aQ=ah}else{x=0;J=bQ(-1,-1)|0;aO=K;aQ=J}}while(0);if((a[p]&1)==0){V=aO;W=aQ;break}J2(c[p+8>>2]|0);V=aO;W=aQ}}while(0);x=0;ap(436,k|0);if(!x){be(W|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function hT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0;e=i;i=i+128|0;f=e|0;g=e+8|0;j=e+24|0;k=e+32|0;l=e+48|0;m=e+56|0;n=e+64|0;o=e+80|0;p=e+96|0;q=e+112|0;r=d+40|0;s=c[r>>2]|0;t=cS[c[(c[s>>2]|0)+20>>2]&1023](s|0,b|0)|0;s=t+32|0;if((c[s>>2]|0)==2){u=c[b+4>>2]|0;v=J0(72)|0;c[l>>2]=v;w=u+4|0;y=c[w>>2]|0;if((y|0)==(c[u+8>>2]|0)){ee(u|0,l);z=c[l>>2]|0}else{if((y|0)==0){A=0}else{c[y>>2]=v;A=c[w>>2]|0}c[w>>2]=A+4;z=v}v=z;x=0;aq(550,z|0,t|0);if(!x){t=z+40|0;B=+h[t>>3];if((c[d+36>>2]|0)==1){C=-0.0-B}else{C=B}h[t>>3]=C;D=v;E=D;i=e;return E|0}else{x=0}t=bQ(-1,-1)|0;A=t;t=K;y=c[u>>2]|0;u=c[w>>2]|0;l=y;while(1){if((l|0)==(u|0)){F=u;break}if((c[l>>2]|0)==(z|0)){F=l;break}else{l=l+4|0}}l=F-y>>2;F=y+(l+1<<2)|0;z=u-F|0;Kc(y+(l<<2)|0,F|0,z|0)|0;F=y+((z>>2)+l<<2)|0;l=c[w>>2]|0;if((F|0)!=(l|0)){c[w>>2]=l+(~((l-4+(-F|0)|0)>>>2)<<2)}J2(v);G=A;H=t;I=G;J=0;L=I;M=H;be(L|0)}Ac(m,0);L26:do{if((c[s>>2]|0)==6){t=c[r>>2]|0;if((t|0)==0){x=0;aQ(10);if(x){x=0;N=42;break}return 0}if((c[(c[(c[t>>2]|0)-4>>2]|0)+4>>2]|0)!=25680){N=52;break}t=c[b+4>>2]|0;A=(x=0,as(230,52)|0);if(x){x=0;N=42;break}v=A;c[j>>2]=v;A=t+4|0;F=c[A>>2]|0;if((F|0)==(c[t+8>>2]|0)){x=0;aq(376,t|0,j|0);if(x){x=0;N=42;break}O=c[j>>2]|0}else{if((F|0)==0){P=0}else{c[F>>2]=v;P=c[A>>2]|0}c[A>>2]=P+4;O=v}v=O;F=d+4|0;L42:do{if((a[F]&1)==0){l=n;c[l>>2]=c[F>>2];c[l+4>>2]=c[F+4>>2];c[l+8>>2]=c[F+8>>2];N=39}else{l=c[d+12>>2]|0;w=c[d+8>>2]|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(w>>>0<11>>>0){a[n]=w<<1;Q=n+1|0}else{z=w+16&-16;y=(x=0,as(230,z|0)|0);if(x){x=0;break}c[n+8>>2]=y;c[n>>2]=z|1;c[n+4>>2]=w;Q=y}Kb(Q|0,l|0,w)|0;a[Q+w|0]=0;N=39;break L42}}while(0);w=bQ(-1,-1)|0;R=w;S=K}}while(0);do{if((N|0)==39){F=d+16|0;w=g;c[w>>2]=c[F>>2];c[w+4>>2]=c[F+4>>2];c[w+8>>2]=c[F+8>>2];x=0;ao(34,O|0,n|0,g|0,36840,0);if(!x){c[r>>2]=O;if((a[n]&1)==0){N=52;break L26}J2(c[n+8>>2]|0);N=52;break L26}else{x=0;F=bQ(-1,-1)|0;w=F;F=K;if((a[n]&1)==0){R=w;S=F;break}J2(c[n+8>>2]|0);R=w;S=F;break}}}while(0);F=c[t>>2]|0;w=c[A>>2]|0;l=F;while(1){if((l|0)==(w|0)){T=w;break}if((c[l>>2]|0)==(O|0)){T=l;break}else{l=l+4|0}}l=T-F>>2;t=F+(l+1<<2)|0;y=w-t|0;Kc(F+(l<<2)|0,t|0,y|0)|0;t=F+((y>>2)+l<<2)|0;l=c[A>>2]|0;if((t|0)!=(l|0)){c[A>>2]=l+(~((l-4+(-t|0)|0)>>>2)<<2)}J2(v);U=R;V=S}else{N=52}}while(0);do{if((N|0)==52){S=c[b+4>>2]|0;R=(x=0,as(230,52)|0);if(x){x=0;N=42;break}T=R;c[f>>2]=T;R=S+4|0;O=c[R>>2]|0;if((O|0)==(c[S+8>>2]|0)){x=0;aq(376,S|0,f|0);if(x){x=0;N=42;break}W=c[f>>2]|0}else{if((O|0)==0){X=0}else{c[O>>2]=T;X=c[R>>2]|0}c[R>>2]=X+4;W=T}T=W;O=W;n=d+4|0;L81:do{if((a[n]&1)==0){r=o;c[r>>2]=c[n>>2];c[r+4>>2]=c[n+4>>2];c[r+8>>2]=c[n+8>>2];N=69}else{r=c[d+12>>2]|0;g=c[d+8>>2]|0;do{if(g>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(g>>>0<11>>>0){a[o]=g<<1;Y=o+1|0}else{Q=g+16&-16;P=(x=0,as(230,Q|0)|0);if(x){x=0;break}c[o+8>>2]=P;c[o>>2]=Q|1;c[o+4>>2]=g;Y=P}Kb(Y|0,r|0,g)|0;a[Y+g|0]=0;N=69;break L81}}while(0);g=bQ(-1,-1)|0;Z=g;_=K}}while(0);do{if((N|0)==69){n=p;v=d+16|0;c[n>>2]=c[v>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];x=0;aP(c[(c[d>>2]|0)+28>>2]|0,q|0,d|0,m|0);do{if(!x){v=k;c[v>>2]=c[n>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];x=0;ao(26,O|0,o|0,k|0,q|0,0);if(x){x=0;v=bQ(-1,-1)|0;A=v;v=K;if((a[q]&1)==0){$=A;aa=v;break}J2(c[q+8>>2]|0);$=A;aa=v;break}if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}Ae(m);D=T;E=D;i=e;return E|0}else{x=0;v=bQ(-1,-1)|0;$=v;aa=K}}while(0);if((a[o]&1)==0){Z=$;_=aa;break}J2(c[o+8>>2]|0);Z=$;_=aa}}while(0);O=c[S>>2]|0;n=c[R>>2]|0;v=O;while(1){if((v|0)==(n|0)){ab=n;break}if((c[v>>2]|0)==(W|0)){ab=v;break}else{v=v+4|0}}v=ab-O>>2;S=O+(v+1<<2)|0;A=n-S|0;Kc(O+(v<<2)|0,S|0,A|0)|0;S=O+((A>>2)+v<<2)|0;v=c[R>>2]|0;if((S|0)!=(v|0)){c[R>>2]=v+(~((v-4+(-S|0)|0)>>>2)<<2)}J2(T);U=Z;V=_}}while(0);if((N|0)==42){N=bQ(-1,-1)|0;U=N;V=K}x=0;ap(436,m|0);if(!x){G=U;H=V;I=G;J=0;L=I;M=H;be(L|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}function hU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aE=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aL=0,aM=0,aN=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0,b9=0,ca=0,cb=0,cc=0,cd=0,ce=0,cf=0,cg=0,ch=0,ci=0,cj=0,ck=0,cl=0,cm=0,cn=0,co=0,cp=0,cq=0,cr=0,cs=0,ct=0,cu=0,cv=0,cw=0,cx=0,cy=0,cz=0,cA=0,cB=0,cC=0,cD=0,cE=0,cF=0,cG=0,cH=0,cI=0,cJ=0,cK=0,cL=0,cM=0,cN=0,cO=0,cP=0,cQ=0,cR=0,cT=0,cU=0,cV=0,cW=0,cX=0,cY=0,cZ=0,c_=0,c$=0,c0=0,c1=0,c2=0,c3=0,c4=0,c5=0,c6=0,c7=0,c8=0,c9=0,da=0,db=0,dc=0,dd=0,de=0,df=0,dg=0,dh=0,di=0,dj=0,dk=0,dl=0,dm=0,dn=0,dp=0,dq=0,dr=0,ds=0,dt=0,du=0,dv=0,dw=0,dx=0,dy=0,dz=0,dA=0,dB=0,dC=0,dD=0,dE=0,dF=0,dG=0,dH=0,dI=0,dJ=0,dK=0,dL=0,dM=0,dN=0,dO=0,dP=0,dQ=0,dR=0,dS=0,dT=0,dU=0,dV=0,dW=0,dX=0,dY=0,dZ=0,d_=0,d$=0,d0=0,d1=0,d2=0,d3=0,d4=0,d5=0,d6=0,d7=0,d8=0,d9=0,ea=0,eb=0,ec=0,ed=0,ee=0,ef=0,eg=0,eh=0,ei=0,ej=0,ek=0,el=0,em=0,en=0,eo=0,ep=0,eq=0,er=0,es=0,et=0,eu=0,ev=0,ew=0,ex=0,ey=0,ez=0,eA=0,eB=0,eC=0,eD=0,eE=0,eF=0,eG=0,eH=0,eI=0,eJ=0,eK=0,eL=0,eM=0,eN=0,eO=0,eP=0,eQ=0,eR=0,eS=0,eT=0,eU=0,eV=0,eW=0,eX=0,eY=0,eZ=0,e_=0,e$=0,e0=0,e1=0,e2=0,e3=0,e4=0,e5=0,e6=0,e7=0,e8=0,e9=0,fa=0,fb=0,fc=0,fd=0,fe=0,ff=0,fg=0,fh=0,fi=0,fj=0,fk=0,fl=0,fm=0,fn=0,fo=0,fp=0,fq=0,fr=0,fs=0,ft=0,fu=0,fv=0,fw=0,fx=0,fy=0,fz=0;e=i;i=i+128|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+88|0;n=e+104|0;o=e+112|0;p=o;q=i;i=i+12|0;i=i+7&-8;r=i;i=i+12|0;i=i+7&-8;s=i;i=i+12|0;i=i+7&-8;t=i;i=i+12|0;i=i+7&-8;u=i;i=i+12|0;i=i+7&-8;v=i;i=i+12|0;i=i+7&-8;w=i;i=i+12|0;i=i+7&-8;y=i;i=i+8|0;z=i;i=i+12|0;i=i+7&-8;A=i;i=i+12|0;i=i+7&-8;B=i;i=i+12|0;i=i+7&-8;C=i;i=i+12|0;i=i+7&-8;D=i;i=i+16|0;E=i;i=i+12|0;i=i+7&-8;F=i;i=i+12|0;i=i+7&-8;G=i;i=i+40|0;H=i;i=i+12|0;i=i+7&-8;I=i;i=i+12|0;i=i+7&-8;J=i;i=i+12|0;i=i+7&-8;L=i;i=i+12|0;i=i+7&-8;M=i;i=i+12|0;i=i+7&-8;N=i;i=i+12|0;i=i+7&-8;O=i;i=i+12|0;i=i+7&-8;P=i;i=i+12|0;i=i+7&-8;Q=i;i=i+12|0;i=i+7&-8;R=i;i=i+12|0;i=i+7&-8;S=i;i=i+12|0;i=i+7&-8;T=i;i=i+12|0;i=i+7&-8;U=i;i=i+12|0;i=i+7&-8;V=i;i=i+40|0;W=i;i=i+12|0;i=i+7&-8;X=i;i=i+12|0;i=i+7&-8;Y=i;i=i+12|0;i=i+7&-8;Z=i;i=i+12|0;i=i+7&-8;_=i;i=i+12|0;i=i+7&-8;$=i;i=i+12|0;i=i+7&-8;aa=i;i=i+12|0;i=i+7&-8;ab=i;i=i+12|0;i=i+7&-8;ac=i;i=i+12|0;i=i+7&-8;ad=i;i=i+40|0;ae=i;i=i+12|0;i=i+7&-8;af=i;i=i+12|0;i=i+7&-8;ag=i;i=i+12|0;i=i+7&-8;ah=i;i=i+12|0;i=i+7&-8;ai=i;i=i+12|0;i=i+7&-8;aj=i;i=i+4|0;i=i+7&-8;ak=i;i=i+40|0;al=i;i=i+40|0;am=i;i=i+12|0;i=i+7&-8;an=i;i=i+12|0;i=i+7&-8;at=i;i=i+12|0;i=i+7&-8;au=i;i=i+12|0;i=i+7&-8;av=i;i=i+12|0;i=i+7&-8;aw=i;i=i+12|0;i=i+7&-8;ay=i;i=i+40|0;az=i;i=i+12|0;i=i+7&-8;aA=i;i=i+12|0;i=i+7&-8;aC=i;i=i+144|0;aD=i;i=i+12|0;i=i+7&-8;aE=i;i=i+12|0;i=i+7&-8;aF=i;i=i+12|0;i=i+7&-8;aG=i;i=i+12|0;i=i+7&-8;aH=i;i=i+12|0;i=i+7&-8;aI=i;i=i+12|0;i=i+7&-8;aJ=i;i=i+12|0;i=i+7&-8;aL=i;i=i+12|0;i=i+7&-8;aM=i;i=i+16|0;aN=i;i=i+12|0;i=i+7&-8;aQ=i;i=i+12|0;i=i+7&-8;aR=i;i=i+40|0;aS=i;i=i+12|0;i=i+7&-8;aU=i;i=i+12|0;i=i+7&-8;aV=i;i=i+12|0;i=i+7&-8;aW=i;i=i+12|0;i=i+7&-8;aX=i;i=i+12|0;i=i+7&-8;aY=i;i=i+12|0;i=i+7&-8;aZ=i;i=i+12|0;i=i+7&-8;a_=d+36|0;if((a[a_]&1)==0){a$=q;c[a$>>2]=c[a_>>2];c[a$+4>>2]=c[a_+4>>2];c[a$+8>>2]=c[a_+8>>2];a0=a[a$]|0;a1=a$}else{a$=c[d+44>>2]|0;a2=c[d+40>>2]|0;if(a2>>>0>4294967279>>>0){CJ(0);return 0}if(a2>>>0<11>>>0){a3=a2<<1&255;a4=q;a[a4]=a3;a5=q+1|0;a6=a3;a7=a4}else{a4=a2+16&-16;a3=J0(a4)|0;c[q+8>>2]=a3;a8=a4|1;c[q>>2]=a8;c[q+4>>2]=a2;a5=a3;a6=a8&255;a7=q}Kb(a5|0,a$|0,a2)|0;a[a5+a2|0]=0;a0=a6;a1=a7}a7=a0&255;if((a7&1|0)==0){a9=a7>>>1}else{a9=c[q+4>>2]|0}if((a0&1)==0){ba=q+1|0}else{ba=c[q+8>>2]|0}a0=a9>>>0>4>>>0;a7=Kd(ba|0,4600,(a0?4:a9)|0)|0;if((a7|0)==0){bb=a9>>>0<4>>>0?-1:a0&1}else{bb=a7}if((a[a1]&1)!=0){J2(c[q+8>>2]|0)}if((bb|0)==0){bc=d|0;i=e;return bc|0}bb=c[d+48>>2]|0;q=b|0;a1=cS[c[(c[bb>>2]|0)+20>>2]&1023](bb,q)|0;bb=a1;if((a[a_]&1)==0){a7=s;c[a7>>2]=c[a_>>2];c[a7+4>>2]=c[a_+4>>2];c[a7+8>>2]=c[a_+8>>2];bd=a[a7]|0;bf=a7}else{a7=c[d+44>>2]|0;a0=c[d+40>>2]|0;if(a0>>>0>4294967279>>>0){CJ(0);return 0}if(a0>>>0<11>>>0){a9=a0<<1&255;ba=s;a[ba]=a9;bg=s+1|0;bh=a9;bi=ba}else{ba=a0+16&-16;a9=J0(ba)|0;c[s+8>>2]=a9;a6=ba|1;c[s>>2]=a6;c[s+4>>2]=a0;bg=a9;bh=a6&255;bi=s}Kb(bg|0,a7|0,a0)|0;a[bg+a0|0]=0;bd=bh;bf=bi}bi=r;Ke(bi|0,0,12)|0;bh=bd&255;if((bh&1|0)==0){bj=bh>>>1}else{bj=c[s+4>>2]|0}if((bd&1)==0){bk=s+1|0}else{bk=c[s+8>>2]|0}bd=bj+3|0;do{if(bd>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bd>>>0<11>>>0){a[bi]=bj<<1;bl=r+1|0}else{bh=bj+19&-16;a0=(x=0,as(230,bh|0)|0);if(x){x=0;break}c[r+8>>2]=a0;c[r>>2]=bh|1;c[r+4>>2]=bj;bl=a0}Kb(bl|0,bk|0,bj)|0;a[bl+bj|0]=0;x=0,ax(64,r|0,3128,3)|0;if(x){x=0;break}if((a[bf]&1)!=0){J2(c[s+8>>2]|0)}a0=b+8|0;bh=c[a0>>2]|0;do{if((a[bi]&1)==0){bg=t;c[bg>>2]=c[bi>>2];c[bg+4>>2]=c[bi+4>>2];c[bg+8>>2]=c[bi+8>>2];bm=57}else{bg=c[r+8>>2]|0;a7=c[r+4>>2]|0;if(a7>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=121;break}return 0}if(a7>>>0<11>>>0){a[t]=a7<<1;bn=t+1|0}else{a6=a7+16&-16;a9=(x=0,as(230,a6|0)|0);if(x){x=0;bm=121;break}c[t+8>>2]=a9;c[t>>2]=a6|1;c[t+4>>2]=a7;bn=a9}Kb(bn|0,bg|0,a7)|0;a[bn+a7|0]=0;bm=57}}while(0);L74:do{if((bm|0)==57){a7=(x=0,aK(556,bh|0,t|0)|0);if(x){x=0;bg=bQ(-1,-1)|0;a9=bg;bg=K;if((a[t]&1)==0){bo=a9;bp=bg;break}J2(c[t+8>>2]|0);bo=a9;bp=bg;break}if((a[t]&1)!=0){J2(c[t+8>>2]|0)}L83:do{if(a7){bg=d|0;a9=c[a0>>2]|0;if((a[bi]&1)==0){a6=C;c[a6>>2]=c[bi>>2];c[a6+4>>2]=c[bi+4>>2];c[a6+8>>2]=c[bi+8>>2]}else{a6=c[r+8>>2]|0;ba=c[r+4>>2]|0;if(ba>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=121;break L74}return 0}if(ba>>>0<11>>>0){a[C]=ba<<1;bq=C+1|0}else{a2=ba+16&-16;a5=(x=0,as(230,a2|0)|0);if(x){x=0;bm=121;break L74}c[C+8>>2]=a5;c[C>>2]=a2|1;c[C+4>>2]=ba;bq=a5}Kb(bq|0,a6|0,ba)|0;a[bq+ba|0]=0}ba=(x=0,aK(88,a9|0,C|0)|0);if(x){x=0;a9=bQ(-1,-1)|0;a6=a9;a9=K;if((a[C]&1)==0){bo=a6;bp=a9;break L74}J2(c[C+8>>2]|0);bo=a6;bp=a9;break L74}a9=c[ba>>2]|0;if((a[C]&1)!=0){J2(c[C+8>>2]|0)}ba=c[a9+28>>2]|0;a6=c[a9+56>>2]|0;a5=c[a9+60>>2]|0;a2=a1+44|0;a$=a1+40|0;a8=c[a$>>2]|0;a3=(c[a2>>2]|0)-a8>>2;L217:do{if((a3|0)!=0){a4=0;br=a8;while(1){bs=(c[br+(a4<<2)>>2]|0)+36|0;bt=c[bs>>2]|0;bu=(x=0,aK(c[(c[bt>>2]|0)+20>>2]|0,bt|0,q|0)|0);if(x){x=0;break}c[bs>>2]=bu;bu=a4+1|0;if(bu>>>0>=a3>>>0){break L217}a4=bu;br=c[a$>>2]|0}br=bQ(-1,-1)|0;bv=K;bw=br;bm=122;break L74}}while(0);a3=c[a9+44>>2]|0;a8=D+4|0;c[a8>>2]=0;c[D+8>>2]=0;c[D>>2]=a8;a8=D+12|0;c[a8>>2]=0;c[a8>>2]=c[a9+48>>2];L224:do{if((ba|0)==0){if((a6|0)!=0){if((a[a_]&1)==0){a8=U;c[a8>>2]=c[a_>>2];c[a8+4>>2]=c[a_+4>>2];c[a8+8>>2]=c[a_+8>>2];bx=a[a8]|0;by=a8}else{a8=c[d+44>>2]|0;br=c[d+40>>2]|0;if(br>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=313;break}return 0}if(br>>>0<11>>>0){a4=br<<1&255;bu=U;a[bu]=a4;bz=U+1|0;bA=a4;bB=bu}else{bu=br+16&-16;a4=(x=0,as(230,bu|0)|0);if(x){x=0;bm=313;break}c[U+8>>2]=a4;bs=bu|1;c[U>>2]=bs;c[U+4>>2]=br;bz=a4;bA=bs&255;bB=U}Kb(bz|0,a8|0,br)|0;a[bz+br|0]=0;bx=bA;by=bB}br=T;Ke(br|0,0,12)|0;a8=U;bs=bx&255;if((bs&1|0)==0){bC=bs>>>1}else{bC=c[U+4>>2]|0}bs=bC+9|0;do{if(bs>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=379;break}return 0}else{if(bs>>>0<11>>>0){a[br]=18;bD=T+1|0}else{a4=bC+25&-16;bu=(x=0,as(230,a4|0)|0);if(x){x=0;bm=379;break}c[T+8>>2]=bu;c[T>>2]=a4|1;c[T+4>>2]=9;bD=bu}Kb(bD|0,1952,9)|0;a[bD+9|0]=0;if((a[by]&1)==0){bE=a8+1|0}else{bE=c[U+8>>2]|0}x=0,ax(64,T|0,bE|0,bC|0)|0;if(x){x=0;bm=379;break}bu=b+4|0;x=0;aB(22,T|0,a3|0,bb|0,c[bu>>2]|0,D|0,b|0);if(x){x=0;a4=bQ(-1,-1)|0;bt=a4;a4=K;if((a[br]&1)==0){bF=bt;bG=a4;break}J2(c[T+8>>2]|0);bF=bt;bG=a4;break}if((a[br]&1)!=0){J2(c[T+8>>2]|0)}if((a[by]&1)!=0){J2(c[U+8>>2]|0)}a4=c[a0>>2]|0;c[a0>>2]=D;bt=b+12|0;bH=c[bt>>2]|0;bI=d+4|0;if((a[bI]&1)==0){bJ=W;c[bJ>>2]=c[bI>>2];c[bJ+4>>2]=c[bI+4>>2];c[bJ+8>>2]=c[bI+8>>2]}else{bJ=c[d+12>>2]|0;bK=c[d+8>>2]|0;if(bK>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=313;break L224}return 0}if(bK>>>0<11>>>0){a[W]=bK<<1;bL=W+1|0}else{bM=bK+16&-16;bN=(x=0,as(230,bM|0)|0);if(x){x=0;bm=313;break L224}c[W+8>>2]=bN;c[W>>2]=bM|1;c[W+4>>2]=bK;bL=bN}Kb(bL|0,bJ|0,bK)|0;a[bL+bK|0]=0}bK=X;bJ=d+16|0;c[bK>>2]=c[bJ>>2];c[bK+4>>2]=c[bJ+4>>2];c[bK+8>>2]=c[bJ+8>>2];L523:do{if((a[a_]&1)==0){bN=_;c[bN>>2]=c[a_>>2];c[bN+4>>2]=c[a_+4>>2];c[bN+8>>2]=c[a_+8>>2];bO=a[bN]|0;bP=bN;bm=406}else{bN=c[d+44>>2]|0;bM=c[d+40>>2]|0;do{if(bM>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bM>>>0<11>>>0){bR=bM<<1&255;bS=_;a[bS]=bR;bT=_+1|0;bV=bR;bW=bS}else{bS=bM+16&-16;bR=(x=0,as(230,bS|0)|0);if(x){x=0;break}c[_+8>>2]=bR;bX=bS|1;c[_>>2]=bX;c[_+4>>2]=bM;bT=bR;bV=bX&255;bW=_}Kb(bT|0,bN|0,bM)|0;a[bT+bM|0]=0;bO=bV;bP=bW;bm=406;break L523}}while(0);bM=bQ(-1,-1)|0;bY=bM;bZ=K}}while(0);do{if((bm|0)==406){bM=Z;Ke(bM|0,0,12)|0;bN=_;bX=bO&255;if((bX&1|0)==0){b_=bX>>>1}else{b_=c[_+4>>2]|0}bX=b_+15|0;do{if(bX>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=420;break}return 0}else{if(bX>>>0<11>>>0){a[bM]=30;b$=Z+1|0}else{bR=b_+31&-16;bS=(x=0,as(230,bR|0)|0);if(x){x=0;bm=420;break}c[Z+8>>2]=bS;c[Z>>2]=bR|1;c[Z+4>>2]=15;b$=bS}Kb(b$|0,1216,15)|0;a[b$+15|0]=0;if((a[bP]&1)==0){b0=bN+1|0}else{b0=c[_+8>>2]|0}x=0,ax(64,Z|0,b0|0,b_|0)|0;if(x){x=0;bm=420;break}bS=Y;Ke(bS|0,0,12)|0;bR=a[bM]|0;b1=bR&255;if((b1&1|0)==0){b2=b1>>>1}else{b2=c[Z+4>>2]|0}if((bR&1)==0){b3=Z+1|0}else{b3=c[Z+8>>2]|0}bR=b2+1|0;do{if(bR>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=436;break}return 0}else{if(bR>>>0<11>>>0){a[bS]=b2<<1;b4=Y+1|0}else{b1=b2+17&-16;b5=(x=0,as(230,b1|0)|0);if(x){x=0;bm=436;break}c[Y+8>>2]=b5;c[Y>>2]=b1|1;c[Y+4>>2]=b2;b4=b5}Kb(b4|0,b3|0,b2)|0;a[b4+b2|0]=0;x=0,ax(64,Y|0,600,1)|0;if(x){x=0;bm=436;break}b5=h;c[b5>>2]=c[bK>>2];c[b5+4>>2]=c[bK+4>>2];c[b5+8>>2]=c[bK+8>>2];x=0;ao(24,V|0,bH|0,W|0,h|0,Y|0);if(x){x=0;b5=bQ(-1,-1)|0;b1=b5;b5=K;if((a[bS]&1)==0){b6=b1;b7=b5;break}J2(c[Y+8>>2]|0);b6=b1;b7=b5;break}if((a[bS]&1)!=0){J2(c[Y+8>>2]|0)}if((a[bM]&1)!=0){J2(c[Z+8>>2]|0)}if((a[bP]&1)!=0){J2(c[_+8>>2]|0)}if((a[W]&1)!=0){J2(c[W+8>>2]|0)}c[bt>>2]=V;b5=c[a0>>2]|0;b1=c[bu>>2]|0;b8=c[a9+68>>2]|0;L590:do{if((a[bI]&1)==0){b9=$;c[b9>>2]=c[bI>>2];c[b9+4>>2]=c[bI+4>>2];c[b9+8>>2]=c[bI+8>>2];bm=457}else{b9=c[d+12>>2]|0;ca=c[d+8>>2]|0;do{if(ca>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(ca>>>0<11>>>0){a[$]=ca<<1;cb=$+1|0}else{cc=ca+16&-16;cd=(x=0,as(230,cc|0)|0);if(x){x=0;break}c[$+8>>2]=cd;c[$>>2]=cc|1;c[$+4>>2]=ca;cb=cd}Kb(cb|0,b9|0,ca)|0;a[cb+ca|0]=0;bm=457;break L590}}while(0);ca=bQ(-1,-1)|0;ce=ca;cf=K}}while(0);do{if((bm|0)==457){ca=aa;c[ca>>2]=c[bJ>>2];c[ca+4>>2]=c[bJ+4>>2];c[ca+8>>2]=c[bJ+8>>2];ca=(x=0,ar(a6|0,b5|0,b1|0,b8|0,$|0,aa|0,V|0)|0);if(x){x=0;b9=bQ(-1,-1)|0;cd=b9;b9=K;if((a[$]&1)==0){ce=cd;cf=b9;break}J2(c[$+8>>2]|0);ce=cd;cf=b9;break}if((a[$]&1)!=0){J2(c[$+8>>2]|0)}c[bt>>2]=c[V>>2];c[a0>>2]=a4;if((a[V+28|0]&1)!=0){J2(c[V+36>>2]|0)}if((a[V+4|0]&1)==0){cg=ca;ch=bJ;bm=990;break L224}J2(c[V+12>>2]|0);cg=ca;ch=bJ;bm=990;break L224}}while(0);if((a[V+28|0]&1)!=0){J2(c[V+36>>2]|0)}if((a[V+4|0]&1)==0){ci=ce;cj=cf;break L224}J2(c[V+12>>2]|0);ci=ce;cj=cf;break L224}}while(0);if((bm|0)==436){bR=bQ(-1,-1)|0;b8=K;if((a[bS]&1)!=0){J2(c[Y+8>>2]|0)}b6=bR;b7=b8}if((a[bM]&1)==0){ck=b6;cl=b7;break}J2(c[Z+8>>2]|0);ck=b6;cl=b7}}while(0);if((bm|0)==420){bN=bQ(-1,-1)|0;bX=K;if((a[bM]&1)!=0){J2(c[Z+8>>2]|0)}ck=bN;cl=bX}if((a[bP]&1)==0){bY=ck;bZ=cl;break}J2(c[_+8>>2]|0);bY=ck;bZ=cl}}while(0);if((a[W]&1)==0){ci=bY;cj=bZ;break L224}J2(c[W+8>>2]|0);ci=bY;cj=bZ;break L224}}while(0);if((bm|0)==379){a8=bQ(-1,-1)|0;bs=K;if((a[br]&1)!=0){J2(c[T+8>>2]|0)}bF=a8;bG=bs}if((a[by]&1)==0){ci=bF;cj=bG;break}J2(c[U+8>>2]|0);ci=bF;cj=bG;break}if((a5|0)!=0){if((a[a_]&1)==0){bs=ac;c[bs>>2]=c[a_>>2];c[bs+4>>2]=c[a_+4>>2];c[bs+8>>2]=c[a_+8>>2];cm=a[bs]|0;cn=bs}else{bs=c[d+44>>2]|0;a8=c[d+40>>2]|0;if(a8>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=313;break}return 0}if(a8>>>0<11>>>0){bJ=a8<<1&255;a4=ac;a[a4]=bJ;co=ac+1|0;cp=bJ;cq=a4}else{a4=a8+16&-16;bJ=(x=0,as(230,a4|0)|0);if(x){x=0;bm=313;break}c[ac+8>>2]=bJ;bt=a4|1;c[ac>>2]=bt;c[ac+4>>2]=a8;co=bJ;cp=bt&255;cq=ac}Kb(co|0,bs|0,a8)|0;a[co+a8|0]=0;cm=cp;cn=cq}a8=ab;Ke(a8|0,0,12)|0;bs=ac;bt=cm&255;if((bt&1|0)==0){cr=bt>>>1}else{cr=c[ac+4>>2]|0}bt=cr+9|0;do{if(bt>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=512;break}return 0}else{if(bt>>>0<11>>>0){a[a8]=18;cs=ab+1|0}else{bJ=cr+25&-16;a4=(x=0,as(230,bJ|0)|0);if(x){x=0;bm=512;break}c[ab+8>>2]=a4;c[ab>>2]=bJ|1;c[ab+4>>2]=9;cs=a4}Kb(cs|0,1952,9)|0;a[cs+9|0]=0;if((a[cn]&1)==0){ct=bs+1|0}else{ct=c[ac+8>>2]|0}x=0,ax(64,ab|0,ct|0,cr|0)|0;if(x){x=0;bm=512;break}a4=b+4|0;x=0;aB(22,ab|0,a3|0,bb|0,c[a4>>2]|0,D|0,b|0);if(x){x=0;bJ=bQ(-1,-1)|0;bI=bJ;bJ=K;if((a[a8]&1)==0){cu=bI;cv=bJ;break}J2(c[ab+8>>2]|0);cu=bI;cv=bJ;break}if((a[a8]&1)!=0){J2(c[ab+8>>2]|0)}if((a[cn]&1)!=0){J2(c[ac+8>>2]|0)}bJ=c[a0>>2]|0;c[a0>>2]=D;bI=b+12|0;bu=c[bI>>2]|0;bH=d+4|0;if((a[bH]&1)==0){bK=ae;c[bK>>2]=c[bH>>2];c[bK+4>>2]=c[bH+4>>2];c[bK+8>>2]=c[bH+8>>2]}else{bK=c[d+12>>2]|0;bX=c[d+8>>2]|0;if(bX>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=313;break L224}return 0}if(bX>>>0<11>>>0){a[ae]=bX<<1;cw=ae+1|0}else{bN=bX+16&-16;b8=(x=0,as(230,bN|0)|0);if(x){x=0;bm=313;break L224}c[ae+8>>2]=b8;c[ae>>2]=bN|1;c[ae+4>>2]=bX;cw=b8}Kb(cw|0,bK|0,bX)|0;a[cw+bX|0]=0}bX=af;bK=d+16|0;c[bX>>2]=c[bK>>2];c[bX+4>>2]=c[bK+4>>2];c[bX+8>>2]=c[bK+8>>2];L701:do{if((a[a_]&1)==0){b8=ai;c[b8>>2]=c[a_>>2];c[b8+4>>2]=c[a_+4>>2];c[b8+8>>2]=c[a_+8>>2];cx=a[b8]|0;cy=b8;bm=539}else{b8=c[d+44>>2]|0;bN=c[d+40>>2]|0;do{if(bN>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bN>>>0<11>>>0){bR=bN<<1&255;b1=ai;a[b1]=bR;cz=ai+1|0;cA=bR;cB=b1}else{b1=bN+16&-16;bR=(x=0,as(230,b1|0)|0);if(x){x=0;break}c[ai+8>>2]=bR;b5=b1|1;c[ai>>2]=b5;c[ai+4>>2]=bN;cz=bR;cA=b5&255;cB=ai}Kb(cz|0,b8|0,bN)|0;a[cz+bN|0]=0;cx=cA;cy=cB;bm=539;break L701}}while(0);bN=bQ(-1,-1)|0;cC=bN;cD=K}}while(0);do{if((bm|0)==539){bN=ah;Ke(bN|0,0,12)|0;b8=ai;bM=cx&255;if((bM&1|0)==0){cE=bM>>>1}else{cE=c[ai+4>>2]|0}bM=cE+15|0;do{if(bM>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=553;break}return 0}else{if(bM>>>0<11>>>0){a[bN]=30;cF=ah+1|0}else{b5=cE+31&-16;bR=(x=0,as(230,b5|0)|0);if(x){x=0;bm=553;break}c[ah+8>>2]=bR;c[ah>>2]=b5|1;c[ah+4>>2]=15;cF=bR}Kb(cF|0,1216,15)|0;a[cF+15|0]=0;if((a[cy]&1)==0){cG=b8+1|0}else{cG=c[ai+8>>2]|0}x=0,ax(64,ah|0,cG|0,cE|0)|0;if(x){x=0;bm=553;break}bR=ag;Ke(bR|0,0,12)|0;b5=a[bN]|0;b1=b5&255;if((b1&1|0)==0){cH=b1>>>1}else{cH=c[ah+4>>2]|0}if((b5&1)==0){cI=ah+1|0}else{cI=c[ah+8>>2]|0}b5=cH+1|0;do{if(b5>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=569;break}return 0}else{if(b5>>>0<11>>>0){a[bR]=cH<<1;cJ=ag+1|0}else{b1=cH+17&-16;ca=(x=0,as(230,b1|0)|0);if(x){x=0;bm=569;break}c[ag+8>>2]=ca;c[ag>>2]=b1|1;c[ag+4>>2]=cH;cJ=ca}Kb(cJ|0,cI|0,cH)|0;a[cJ+cH|0]=0;x=0,ax(64,ag|0,600,1)|0;if(x){x=0;bm=569;break}ca=g;c[ca>>2]=c[bX>>2];c[ca+4>>2]=c[bX+4>>2];c[ca+8>>2]=c[bX+8>>2];x=0;ao(24,ad|0,bu|0,ae|0,g|0,ag|0);if(x){x=0;ca=bQ(-1,-1)|0;b1=ca;ca=K;if((a[bR]&1)==0){cK=b1;cL=ca;break}J2(c[ag+8>>2]|0);cK=b1;cL=ca;break}if((a[bR]&1)!=0){J2(c[ag+8>>2]|0)}if((a[bN]&1)!=0){J2(c[ah+8>>2]|0)}if((a[cy]&1)!=0){J2(c[ai+8>>2]|0)}if((a[ae]&1)!=0){J2(c[ae+8>>2]|0)}c[bI>>2]=ad;c[aj>>2]=18392;x=0;aP(c[(c[a1>>2]|0)+32>>2]|0,al|0,bb|0,aj|0);L768:do{if(!x){x=0;aq(a5|0,ak|0,al|0);if(x){x=0;bm=678;break}L771:do{if((c[ak>>2]|0)==6){if((a[a_]&1)==0){ca=au;c[ca>>2]=c[a_>>2];c[ca+4>>2]=c[a_+4>>2];c[ca+8>>2]=c[a_+8>>2];cM=a[ca]|0;cN=ca}else{ca=c[d+44>>2]|0;b1=c[d+40>>2]|0;if(b1>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=678;break L768}return 0}if(b1>>>0<11>>>0){b9=b1<<1&255;cd=au;a[cd]=b9;cO=au+1|0;cP=b9;cQ=cd}else{cd=b1+16&-16;b9=(x=0,as(230,cd|0)|0);if(x){x=0;bm=678;break L768}c[au+8>>2]=b9;cc=cd|1;c[au>>2]=cc;c[au+4>>2]=b1;cO=b9;cP=cc&255;cQ=au}Kb(cO|0,ca|0,b1)|0;a[cO+b1|0]=0;cM=cP;cN=cQ}b1=at;Ke(b1|0,0,12)|0;ca=au;cc=cM&255;if((cc&1|0)==0){cR=cc>>>1}else{cR=c[au+4>>2]|0}cc=cR+20|0;do{if(cc>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=607;break}return 0}else{if(cc>>>0<11>>>0){a[b1]=40;cT=at+1|0}else{b9=cR+36&-16;cd=(x=0,as(230,b9|0)|0);if(x){x=0;bm=607;break}c[at+8>>2]=cd;c[at>>2]=b9|1;c[at+4>>2]=20;cT=cd}Kb(cT|0,11680,20)|0;a[cT+20|0]=0;if((a[cN]&1)==0){cU=ca+1|0}else{cU=c[au+8>>2]|0}x=0,ax(64,at|0,cU|0,cR|0)|0;if(x){x=0;bm=607;break}cd=an;Ke(cd|0,0,12)|0;b9=a[b1]|0;cV=b9&255;if((cV&1|0)==0){cW=cV>>>1}else{cW=c[at+4>>2]|0}if((b9&1)==0){cX=at+1|0}else{cX=c[at+8>>2]|0}b9=cW+2|0;do{if(b9>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=623;break}return 0}else{if(b9>>>0<11>>>0){a[cd]=cW<<1;cY=an+1|0}else{cV=cW+18&-16;cZ=(x=0,as(230,cV|0)|0);if(x){x=0;bm=623;break}c[an+8>>2]=cZ;c[an>>2]=cV|1;c[an+4>>2]=cW;cY=cZ}Kb(cY|0,cX|0,cW)|0;a[cY+cW|0]=0;x=0,ax(64,an|0,10992,2)|0;if(x){x=0;bm=623;break}cZ=c[ak+4>>2]|0;cV=am;Ke(cV|0,0,12)|0;c_=a[cd]|0;c$=c_&255;if((c$&1|0)==0){c0=c$>>>1}else{c0=c[an+4>>2]|0}c$=Kf(cZ|0)|0;if((c_&1)==0){c1=an+1|0}else{c1=c[an+8>>2]|0}c_=c$+c0|0;do{if(c_>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=639;break}return 0}else{if(c_>>>0<11>>>0){a[cV]=c0<<1;c2=am+1|0}else{c3=c_+16&-16;c4=(x=0,as(230,c3|0)|0);if(x){x=0;bm=639;break}c[am+8>>2]=c4;c[am>>2]=c3|1;c[am+4>>2]=c0;c2=c4}Kb(c2|0,c1|0,c0)|0;a[c2+c0|0]=0;x=0,ax(64,am|0,cZ|0,c$|0)|0;if(x){x=0;bm=639;break}L840:do{if((a[bH]&1)==0){c4=av;c[c4>>2]=c[bH>>2];c[c4+4>>2]=c[bH+4>>2];c[c4+8>>2]=c[bH+8>>2];bm=651}else{c4=c[d+12>>2]|0;c3=c[d+8>>2]|0;do{if(c3>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(c3>>>0<11>>>0){a[av]=c3<<1;c5=av+1|0}else{c6=c3+16&-16;c7=(x=0,as(230,c6|0)|0);if(x){x=0;break}c[av+8>>2]=c7;c[av>>2]=c6|1;c[av+4>>2]=c3;c5=c7}Kb(c5|0,c4|0,c3)|0;a[c5+c3|0]=0;bm=651;break L840}}while(0);c3=bQ(-1,-1)|0;c8=c3;c9=K}}while(0);do{if((bm|0)==651){c3=aw;c[c3>>2]=c[bK>>2];c[c3+4>>2]=c[bK+4>>2];c[c3+8>>2]=c[bK+8>>2];x=0;aT(42,am|0,av|0,aw|0,c[bI>>2]|0);if(x){x=0;c3=bQ(-1,-1)|0;c4=c3;c3=K;if((a[av]&1)==0){c8=c4;c9=c3;break}J2(c[av+8>>2]|0);c8=c4;c9=c3;break}if((a[av]&1)!=0){J2(c[av+8>>2]|0)}if((a[cV]&1)!=0){J2(c[am+8>>2]|0)}if((a[cd]&1)!=0){J2(c[an+8>>2]|0)}if((a[b1]&1)!=0){J2(c[at+8>>2]|0)}if((a[cN]&1)==0){break L771}J2(c[au+8>>2]|0);break L771}}while(0);if((a[cV]&1)==0){da=c8;db=c9;break}J2(c[am+8>>2]|0);da=c8;db=c9}}while(0);if((bm|0)==639){c$=bQ(-1,-1)|0;cZ=K;if((a[cV]&1)!=0){J2(c[am+8>>2]|0)}da=c$;db=cZ}if((a[cd]&1)==0){dc=da;dd=db;break}J2(c[an+8>>2]|0);dc=da;dd=db}}while(0);if((bm|0)==623){b9=bQ(-1,-1)|0;cZ=K;if((a[cd]&1)!=0){J2(c[an+8>>2]|0)}dc=b9;dd=cZ}if((a[b1]&1)==0){de=dc;df=dd;break}J2(c[at+8>>2]|0);de=dc;df=dd}}while(0);if((bm|0)==607){ca=bQ(-1,-1)|0;cc=K;if((a[b1]&1)!=0){J2(c[at+8>>2]|0)}de=ca;df=cc}if((a[cN]&1)==0){dg=de;dh=df;break L768}J2(c[au+8>>2]|0);dg=de;dh=df;break L768}}while(0);cc=ay;ca=ak;c[cc>>2]=c[ca>>2];c[cc+4>>2]=c[ca+4>>2];c[cc+8>>2]=c[ca+8>>2];c[cc+12>>2]=c[ca+12>>2];c[cc+16>>2]=c[ca+16>>2];c[cc+20>>2]=c[ca+20>>2];c[cc+24>>2]=c[ca+24>>2];c[cc+28>>2]=c[ca+28>>2];c[cc+32>>2]=c[ca+32>>2];c[cc+36>>2]=c[ca+36>>2];ca=c[a4>>2]|0;cc=c[bI>>2]|0;if((a[bH]&1)==0){cZ=az;c[cZ>>2]=c[bH>>2];c[cZ+4>>2]=c[bH+4>>2];c[cZ+8>>2]=c[bH+8>>2]}else{cZ=c[d+12>>2]|0;b9=c[d+8>>2]|0;if(b9>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=678;break}return 0}if(b9>>>0<11>>>0){a[az]=b9<<1;di=az+1|0}else{c$=b9+16&-16;c_=(x=0,as(230,c$|0)|0);if(x){x=0;bm=678;break}c[az+8>>2]=c_;c[az>>2]=c$|1;c[az+4>>2]=b9;di=c_}Kb(di|0,cZ|0,b9)|0;a[di+b9|0]=0}b9=aA;c[b9>>2]=c[bK>>2];c[b9+4>>2]=c[bK+4>>2];c[b9+8>>2]=c[bK+8>>2];b9=(x=0,aO(22,ay|0,ca|0,cc|0,az|0,aA|0)|0);if(x){x=0;cc=bQ(-1,-1)|0;ca=cc;cc=K;if((a[az]&1)==0){dg=ca;dh=cc;break}J2(c[az+8>>2]|0);dg=ca;dh=cc;break}if((a[az]&1)!=0){J2(c[az+8>>2]|0)}c[bI>>2]=c[ad>>2];c[a0>>2]=bJ;if((a[ad+28|0]&1)!=0){J2(c[ad+36>>2]|0)}if((a[ad+4|0]&1)==0){cg=b9;ch=bK;bm=990;break L224}J2(c[ad+12>>2]|0);cg=b9;ch=bK;bm=990;break L224}else{x=0;bm=678}}while(0);if((bm|0)==678){b9=bQ(-1,-1)|0;dg=b9;dh=K}if((a[ad+28|0]&1)!=0){J2(c[ad+36>>2]|0)}if((a[ad+4|0]&1)==0){ci=dg;cj=dh;break L224}J2(c[ad+12>>2]|0);ci=dg;cj=dh;break L224}}while(0);if((bm|0)==569){b5=bQ(-1,-1)|0;bS=K;if((a[bR]&1)!=0){J2(c[ag+8>>2]|0)}cK=b5;cL=bS}if((a[bN]&1)==0){dj=cK;dk=cL;break}J2(c[ah+8>>2]|0);dj=cK;dk=cL}}while(0);if((bm|0)==553){b8=bQ(-1,-1)|0;bM=K;if((a[bN]&1)!=0){J2(c[ah+8>>2]|0)}dj=b8;dk=bM}if((a[cy]&1)==0){cC=dj;cD=dk;break}J2(c[ai+8>>2]|0);cC=dj;cD=dk}}while(0);if((a[ae]&1)==0){ci=cC;cj=cD;break L224}J2(c[ae+8>>2]|0);ci=cC;cj=cD;break L224}}while(0);if((bm|0)==512){bs=bQ(-1,-1)|0;bt=K;if((a[a8]&1)!=0){J2(c[ab+8>>2]|0)}cu=bs;cv=bt}if((a[cn]&1)==0){ci=cu;cj=cv;break}J2(c[ac+8>>2]|0);ci=cu;cj=cv;break}if((a[a9+64|0]&1)==0){cg=bg;ch=d+16|0;bm=990;break}bt=(c[a2>>2]|0)-(c[a$>>2]|0)>>2;bs=aC+64|0;br=aC|0;bK=aC+8|0;bJ=bK|0;c[bJ>>2]=14576;bI=aC+12|0;c[br>>2]=31212;bH=aC+64|0;c[bH>>2]=31232;c[aC+4>>2]=0;x=0;aq(200,aC+64|0,bI|0);do{if(!x){c[aC+136>>2]=0;c[aC+140>>2]=-1;a4=aC+8|0;c[br>>2]=14556;c[bs>>2]=14596;c[bJ>>2]=14576;bu=bI|0;c[bu>>2]=14880;bX=aC+16|0;HA(bX);Ke(aC+20|0,0,24)|0;c[bu>>2]=14736;bM=aC+44|0;Ke(aC+44|0,0,16)|0;c[aC+60>>2]=24;Ke(p|0,0,12)|0;x=0;aq(214,bI|0,o|0);if(x){x=0;b8=bQ(-1,-1)|0;bS=K;if((a[p]&1)!=0){J2(c[o+8>>2]|0)}if((a[bM]&1)!=0){J2(c[aC+52>>2]|0)}c[bu>>2]=14880;x=0;ap(388,bX|0);if(!x){dl=b8;dm=bS;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}if((a[p]&1)!=0){J2(c[o+8>>2]|0)}bS=(x=0,aK(802,bK|0,r|0)|0);do{if(!x){x=0,aK(312,bS|0,bt|0)|0;if(x){x=0;bm=810;break}x=0;aq(560,aD|0,bI|0);if(x){x=0;bm=810;break}b8=c[a0>>2]|0;bu=aD;b5=(a[bu]&1)==0;do{if(b5){b9=aE;c[b9>>2]=c[bu>>2];c[b9+4>>2]=c[bu+4>>2];c[b9+8>>2]=c[bu+8>>2];bm=745}else{b9=c[aD+8>>2]|0;cc=c[aD+4>>2]|0;if(cc>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=811;break}return 0}if(cc>>>0<11>>>0){a[aE]=cc<<1;dn=aE+1|0}else{ca=cc+16&-16;cZ=(x=0,as(230,ca|0)|0);if(x){x=0;bm=811;break}c[aE+8>>2]=cZ;c[aE>>2]=ca|1;c[aE+4>>2]=cc;dn=cZ}Kb(dn|0,b9|0,cc)|0;a[dn+cc|0]=0;bm=745}}while(0);L985:do{if((bm|0)==745){bN=(x=0,aK(556,b8|0,aE|0)|0);if(x){x=0;cc=bQ(-1,-1)|0;b9=cc;cc=K;if((a[aE]&1)==0){dp=b9;dq=cc;break}J2(c[aE+8>>2]|0);dp=b9;dq=cc;break}if((a[aE]&1)!=0){J2(c[aE+8>>2]|0)}L994:do{if(!bN){if((a[a_]&1)==0){cc=aH;c[cc>>2]=c[a_>>2];c[cc+4>>2]=c[a_+4>>2];c[cc+8>>2]=c[a_+8>>2];dr=a[cc]|0;ds=cc}else{cc=c[d+44>>2]|0;b9=c[d+40>>2]|0;if(b9>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=811;break L985}return 0}if(b9>>>0<11>>>0){cZ=b9<<1&255;ca=aH;a[ca]=cZ;dt=aH+1|0;du=cZ;dv=ca}else{ca=b9+16&-16;cZ=(x=0,as(230,ca|0)|0);if(x){x=0;bm=811;break L985}c[aH+8>>2]=cZ;c_=ca|1;c[aH>>2]=c_;c[aH+4>>2]=b9;dt=cZ;du=c_&255;dv=aH}Kb(dt|0,cc|0,b9)|0;a[dt+b9|0]=0;dr=du;ds=dv}b9=aG;Ke(b9|0,0,12)|0;cc=aH;c_=dr&255;if((c_&1|0)==0){dw=c_>>>1}else{dw=c[aH+4>>2]|0}c_=dw+21|0;do{if(c_>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=773;break}return 0}else{if(c_>>>0<11>>>0){a[b9]=42;dx=aG+1|0}else{cZ=dw+37&-16;ca=(x=0,as(230,cZ|0)|0);if(x){x=0;bm=773;break}c[aG+8>>2]=ca;c[aG>>2]=cZ|1;c[aG+4>>2]=21;dx=ca}Kb(dx|0,10576,21)|0;a[dx+21|0]=0;if((a[ds]&1)==0){dy=cc+1|0}else{dy=c[aH+8>>2]|0}x=0,ax(64,aG|0,dy|0,dw|0)|0;if(x){x=0;bm=773;break}ca=aF;Ke(ca|0,0,12)|0;cZ=a[b9]|0;c$=cZ&255;if((c$&1|0)==0){dz=c$>>>1}else{dz=c[aG+4>>2]|0}if((cZ&1)==0){dA=aG+1|0}else{dA=c[aG+8>>2]|0}cZ=dz+33|0;do{if(cZ>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=789;break}return 0}else{if(cZ>>>0<11>>>0){a[ca]=dz<<1;dB=aF+1|0}else{c$=dz+49&-16;c3=(x=0,as(230,c$|0)|0);if(x){x=0;bm=789;break}c[aF+8>>2]=c3;c[aF>>2]=c$|1;c[aF+4>>2]=dz;dB=c3}Kb(dB|0,dA|0,dz)|0;a[dB+dz|0]=0;x=0,ax(64,aF|0,10288,33)|0;if(x){x=0;bm=789;break}c3=d+4|0;L1045:do{if((a[c3]&1)==0){c$=aI;c[c$>>2]=c[c3>>2];c[c$+4>>2]=c[c3+4>>2];c[c$+8>>2]=c[c3+8>>2];bm=801}else{c$=c[d+12>>2]|0;c4=c[d+8>>2]|0;do{if(c4>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(c4>>>0<11>>>0){a[aI]=c4<<1;dC=aI+1|0}else{c7=c4+16&-16;c6=(x=0,as(230,c7|0)|0);if(x){x=0;break}c[aI+8>>2]=c6;c[aI>>2]=c7|1;c[aI+4>>2]=c4;dC=c6}Kb(dC|0,c$|0,c4)|0;a[dC+c4|0]=0;bm=801;break L1045}}while(0);c4=bQ(-1,-1)|0;dD=c4;dE=K}}while(0);do{if((bm|0)==801){c3=aJ;b1=d+16|0;c[c3>>2]=c[b1>>2];c[c3+4>>2]=c[b1+4>>2];c[c3+8>>2]=c[b1+8>>2];x=0;aP(362,aF|0,aI|0,aJ|0);if(x){x=0;b1=bQ(-1,-1)|0;c3=b1;b1=K;if((a[aI]&1)==0){dD=c3;dE=b1;break}J2(c[aI+8>>2]|0);dD=c3;dE=b1;break}if((a[aI]&1)!=0){J2(c[aI+8>>2]|0)}if((a[ca]&1)!=0){J2(c[aF+8>>2]|0)}if((a[b9]&1)!=0){J2(c[aG+8>>2]|0)}if((a[ds]&1)==0){break L994}J2(c[aH+8>>2]|0);break L994}}while(0);if((a[ca]&1)==0){dF=dD;dG=dE;break}J2(c[aF+8>>2]|0);dF=dD;dG=dE}}while(0);if((bm|0)==789){cZ=bQ(-1,-1)|0;b1=K;if((a[ca]&1)!=0){J2(c[aF+8>>2]|0)}dF=cZ;dG=b1}if((a[b9]&1)==0){dH=dF;dI=dG;break}J2(c[aG+8>>2]|0);dH=dF;dI=dG}}while(0);if((bm|0)==773){cc=bQ(-1,-1)|0;c_=K;if((a[b9]&1)!=0){J2(c[aG+8>>2]|0)}dH=cc;dI=c_}if((a[ds]&1)==0){dp=dH;dq=dI;break L985}J2(c[aH+8>>2]|0);dp=dH;dq=dI;break L985}}while(0);bN=c[a0>>2]|0;if(b5){bR=aL;c[bR>>2]=c[bu>>2];c[bR+4>>2]=c[bu+4>>2];c[bR+8>>2]=c[bu+8>>2]}else{bR=c[aD+8>>2]|0;c_=c[aD+4>>2]|0;if(c_>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=811;break}return 0}if(c_>>>0<11>>>0){a[aL]=c_<<1;dJ=aL+1|0}else{cc=c_+16&-16;b1=(x=0,as(230,cc|0)|0);if(x){x=0;bm=811;break}c[aL+8>>2]=b1;c[aL>>2]=cc|1;c[aL+4>>2]=c_;dJ=b1}Kb(dJ|0,bR|0,c_)|0;a[dJ+c_|0]=0}c_=(x=0,aK(88,bN|0,aL|0)|0);if(x){x=0;bN=bQ(-1,-1)|0;bR=bN;bN=K;if((a[aL]&1)==0){dp=bR;dq=bN;break}J2(c[aL+8>>2]|0);dp=bR;dq=bN;break}bN=c[c_>>2]|0;if((a[aL]&1)!=0){J2(c[aL+8>>2]|0)}c_=c[bN+44>>2]|0;bR=aM+4|0;c[bR>>2]=0;c[aM+8>>2]=0;c[aM>>2]=bR;bR=aM+12|0;c[bR>>2]=0;c[bR>>2]=c[bN+48>>2];do{if((a[a_]&1)==0){bR=aQ;c[bR>>2]=c[a_>>2];c[bR+4>>2]=c[a_+4>>2];c[bR+8>>2]=c[a_+8>>2];dK=a[bR]|0;dL=bR;bm=848}else{bR=c[d+44>>2]|0;b1=c[d+40>>2]|0;if(b1>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=957;break}return 0}if(b1>>>0<11>>>0){cc=b1<<1&255;cZ=aQ;a[cZ]=cc;dM=aQ+1|0;dN=cc;dO=cZ}else{cZ=b1+16&-16;cc=(x=0,as(230,cZ|0)|0);if(x){x=0;bm=957;break}c[aQ+8>>2]=cc;c3=cZ|1;c[aQ>>2]=c3;c[aQ+4>>2]=b1;dM=cc;dN=c3&255;dO=aQ}Kb(dM|0,bR|0,b1)|0;a[dM+b1|0]=0;dK=dN;dL=dO;bm=848}}while(0);L1123:do{if((bm|0)==848){b1=aN;Ke(b1|0,0,12)|0;bR=aQ;c3=dK&255;if((c3&1|0)==0){dP=c3>>>1}else{dP=c[aQ+4>>2]|0}c3=dP+9|0;do{if(c3>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=862;break}return 0}else{if(c3>>>0<11>>>0){a[b1]=18;dQ=aN+1|0}else{cc=dP+25&-16;cZ=(x=0,as(230,cc|0)|0);if(x){x=0;bm=862;break}c[aN+8>>2]=cZ;c[aN>>2]=cc|1;c[aN+4>>2]=9;dQ=cZ}Kb(dQ|0,1952,9)|0;a[dQ+9|0]=0;if((a[dL]&1)==0){dR=bR+1|0}else{dR=c[aQ+8>>2]|0}x=0,ax(64,aN|0,dR|0,dP|0)|0;if(x){x=0;bm=862;break}cZ=b+4|0;x=0;aB(22,aN|0,c_|0,bb|0,c[cZ>>2]|0,aM|0,b|0);if(x){x=0;cc=bQ(-1,-1)|0;c4=cc;cc=K;if((a[b1]&1)==0){dS=c4;dT=cc;break}J2(c[aN+8>>2]|0);dS=c4;dT=cc;break}if((a[b1]&1)!=0){J2(c[aN+8>>2]|0)}if((a[dL]&1)!=0){J2(c[aQ+8>>2]|0)}cc=c[a0>>2]|0;c[a0>>2]=aM;c4=b+12|0;c$=c[c4>>2]|0;cd=d+4|0;if((a[cd]&1)==0){c6=aS;c[c6>>2]=c[cd>>2];c[c6+4>>2]=c[cd+4>>2];c[c6+8>>2]=c[cd+8>>2]}else{c6=c[d+12>>2]|0;c7=c[d+8>>2]|0;if(c7>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=957;break L1123}return 0}if(c7>>>0<11>>>0){a[aS]=c7<<1;dU=aS+1|0}else{dV=c7+16&-16;dW=(x=0,as(230,dV|0)|0);if(x){x=0;bm=957;break L1123}c[aS+8>>2]=dW;c[aS>>2]=dV|1;c[aS+4>>2]=c7;dU=dW}Kb(dU|0,c6|0,c7)|0;a[dU+c7|0]=0}c7=aU;c6=d+16|0;c[c7>>2]=c[c6>>2];c[c7+4>>2]=c[c6+4>>2];c[c7+8>>2]=c[c6+8>>2];L1166:do{if((a[a_]&1)==0){dW=aX;c[dW>>2]=c[a_>>2];c[dW+4>>2]=c[a_+4>>2];c[dW+8>>2]=c[a_+8>>2];dX=a[dW]|0;dY=dW;bm=889}else{dW=c[d+44>>2]|0;dV=c[d+40>>2]|0;do{if(dV>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(dV>>>0<11>>>0){dZ=dV<<1&255;d_=aX;a[d_]=dZ;d$=aX+1|0;d0=dZ;d1=d_}else{d_=dV+16&-16;dZ=(x=0,as(230,d_|0)|0);if(x){x=0;break}c[aX+8>>2]=dZ;d2=d_|1;c[aX>>2]=d2;c[aX+4>>2]=dV;d$=dZ;d0=d2&255;d1=aX}Kb(d$|0,dW|0,dV)|0;a[d$+dV|0]=0;dX=d0;dY=d1;bm=889;break L1166}}while(0);dV=bQ(-1,-1)|0;d3=dV;d4=K}}while(0);do{if((bm|0)==889){ca=aW;Ke(ca|0,0,12)|0;dV=aX;dW=dX&255;if((dW&1|0)==0){d5=dW>>>1}else{d5=c[aX+4>>2]|0}dW=d5+15|0;do{if(dW>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=903;break}return 0}else{if(dW>>>0<11>>>0){a[ca]=30;d6=aW+1|0}else{d2=d5+31&-16;dZ=(x=0,as(230,d2|0)|0);if(x){x=0;bm=903;break}c[aW+8>>2]=dZ;c[aW>>2]=d2|1;c[aW+4>>2]=15;d6=dZ}Kb(d6|0,1216,15)|0;a[d6+15|0]=0;if((a[dY]&1)==0){d7=dV+1|0}else{d7=c[aX+8>>2]|0}x=0,ax(64,aW|0,d7|0,d5|0)|0;if(x){x=0;bm=903;break}dZ=aV;Ke(dZ|0,0,12)|0;d2=a[ca]|0;d_=d2&255;if((d_&1|0)==0){d8=d_>>>1}else{d8=c[aW+4>>2]|0}if((d2&1)==0){d9=aW+1|0}else{d9=c[aW+8>>2]|0}d2=d8+1|0;do{if(d2>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=919;break}return 0}else{if(d2>>>0<11>>>0){a[dZ]=d8<<1;ea=aV+1|0}else{d_=d8+17&-16;eb=(x=0,as(230,d_|0)|0);if(x){x=0;bm=919;break}c[aV+8>>2]=eb;c[aV>>2]=d_|1;c[aV+4>>2]=d8;ea=eb}Kb(ea|0,d9|0,d8)|0;a[ea+d8|0]=0;x=0,ax(64,aV|0,600,1)|0;if(x){x=0;bm=919;break}eb=f;c[eb>>2]=c[c7>>2];c[eb+4>>2]=c[c7+4>>2];c[eb+8>>2]=c[c7+8>>2];x=0;ao(24,aR|0,c$|0,aS|0,f|0,aV|0);if(x){x=0;eb=bQ(-1,-1)|0;d_=eb;eb=K;if((a[dZ]&1)==0){ec=d_;ed=eb;break}J2(c[aV+8>>2]|0);ec=d_;ed=eb;break}if((a[dZ]&1)!=0){J2(c[aV+8>>2]|0)}if((a[ca]&1)!=0){J2(c[aW+8>>2]|0)}if((a[dY]&1)!=0){J2(c[aX+8>>2]|0)}if((a[aS]&1)!=0){J2(c[aS+8>>2]|0)}c[c4>>2]=aR;eb=c[bN+56>>2]|0;d_=c[a0>>2]|0;ee=c[cZ>>2]|0;ef=c[bN+68>>2]|0;L1233:do{if((a[cd]&1)==0){eg=aY;c[eg>>2]=c[cd>>2];c[eg+4>>2]=c[cd+4>>2];c[eg+8>>2]=c[cd+8>>2];bm=940}else{eg=c[d+12>>2]|0;eh=c[d+8>>2]|0;do{if(eh>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(eh>>>0<11>>>0){a[aY]=eh<<1;ei=aY+1|0}else{ej=eh+16&-16;ek=(x=0,as(230,ej|0)|0);if(x){x=0;break}c[aY+8>>2]=ek;c[aY>>2]=ej|1;c[aY+4>>2]=eh;ei=ek}Kb(ei|0,eg|0,eh)|0;a[ei+eh|0]=0;bm=940;break L1233}}while(0);eh=bQ(-1,-1)|0;el=eh;em=K}}while(0);do{if((bm|0)==940){cV=aZ;c[cV>>2]=c[c6>>2];c[cV+4>>2]=c[c6+4>>2];c[cV+8>>2]=c[c6+8>>2];cV=(x=0,ar(eb|0,d_|0,ee|0,ef|0,aY|0,aZ|0,aR|0)|0);if(x){x=0;eh=bQ(-1,-1)|0;eg=eh;eh=K;if((a[aY]&1)==0){el=eg;em=eh;break}J2(c[aY+8>>2]|0);el=eg;em=eh;break}if((a[aY]&1)!=0){J2(c[aY+8>>2]|0)}c[c4>>2]=c[aR>>2];c[a0>>2]=cc;if((a[aR+28|0]&1)!=0){J2(c[aR+36>>2]|0)}if((a[aR+4|0]&1)!=0){J2(c[aR+12>>2]|0)}fQ(aM|0,c[aM+4>>2]|0);if(!b5){J2(c[aD+8>>2]|0)}c[br>>2]=14556;c[bH>>2]=14596;c[a4>>2]=14576;eh=aC+12|0;c[eh>>2]=14736;if((a[bM]&1)!=0){J2(c[aC+52>>2]|0)}c[eh>>2]=14880;x=0;ap(388,bX|0);if(!x){x=0;ap(268,aC+64|0);if(!x){cg=cV;ch=c6;bm=990;break L224}else{x=0;bm=313;break L224}}else{x=0}cV=bQ(-1,-1)|0;eh=K;x=0;ap(268,aC+64|0);if(!x){en=eh;eo=cV;bm=314;break L224}else{x=0}bQ(-1,-1,0)|0;bU();return 0}}while(0);if((a[aR+28|0]&1)!=0){J2(c[aR+36>>2]|0)}if((a[aR+4|0]&1)==0){ep=el;eq=em;break L1123}J2(c[aR+12>>2]|0);ep=el;eq=em;break L1123}}while(0);if((bm|0)==919){d2=bQ(-1,-1)|0;ef=K;if((a[dZ]&1)!=0){J2(c[aV+8>>2]|0)}ec=d2;ed=ef}if((a[ca]&1)==0){er=ec;es=ed;break}J2(c[aW+8>>2]|0);er=ec;es=ed}}while(0);if((bm|0)==903){dV=bQ(-1,-1)|0;dW=K;if((a[ca]&1)!=0){J2(c[aW+8>>2]|0)}er=dV;es=dW}if((a[dY]&1)==0){d3=er;d4=es;break}J2(c[aX+8>>2]|0);d3=er;d4=es}}while(0);if((a[aS]&1)==0){ep=d3;eq=d4;break L1123}J2(c[aS+8>>2]|0);ep=d3;eq=d4;break L1123}}while(0);if((bm|0)==862){bR=bQ(-1,-1)|0;c3=K;if((a[b1]&1)!=0){J2(c[aN+8>>2]|0)}dS=bR;dT=c3}if((a[dL]&1)==0){ep=dS;eq=dT;break}J2(c[aQ+8>>2]|0);ep=dS;eq=dT}}while(0);if((bm|0)==957){bN=bQ(-1,-1)|0;ep=bN;eq=K}fQ(aM|0,c[aM+4>>2]|0);dp=ep;dq=eq}}while(0);if((bm|0)==811){bu=bQ(-1,-1)|0;dp=bu;dq=K}if(b5){et=dp;eu=dq;break}J2(c[aD+8>>2]|0);et=dp;eu=dq}else{x=0;bm=810}}while(0);if((bm|0)==810){bS=bQ(-1,-1)|0;et=bS;eu=K}c[br>>2]=14556;c[bH>>2]=14596;c[a4>>2]=14576;bS=aC+12|0;c[bS>>2]=14736;if((a[bM]&1)!=0){J2(c[aC+52>>2]|0)}c[bS>>2]=14880;x=0;ap(388,bX|0);if(!x){x=0;ap(268,aC+64|0);if(!x){ci=et;cj=eu;break L224}else{x=0;bm=998;break L83}}else{x=0}bQ(-1,-1,0)|0;x=0;ap(268,aC+64|0);if(!x){bU();return 0}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{x=0;bS=bQ(-1,-1)|0;dl=bS;dm=K}}while(0);x=0;ap(268,bs|0);if(!x){en=dm;eo=dl;bm=314;break}else{x=0;bQ(-1,-1,0)|0;bU();return 0}}else{if((a[a_]&1)==0){bH=F;c[bH>>2]=c[a_>>2];c[bH+4>>2]=c[a_+4>>2];c[bH+8>>2]=c[a_+8>>2];ev=a[bH]|0;ew=bH}else{bH=c[d+44>>2]|0;br=c[d+40>>2]|0;if(br>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=313;break}return 0}if(br>>>0<11>>>0){bI=br<<1&255;bt=F;a[bt]=bI;ex=F+1|0;ey=bI;ez=bt}else{bt=br+16&-16;bI=(x=0,as(230,bt|0)|0);if(x){x=0;bm=313;break}c[F+8>>2]=bI;bK=bt|1;c[F>>2]=bK;c[F+4>>2]=br;ex=bI;ey=bK&255;ez=F}Kb(ex|0,bH|0,br)|0;a[ex+br|0]=0;ev=ey;ew=ez}br=E;Ke(br|0,0,12)|0;bH=F;bK=ev&255;if((bK&1|0)==0){eA=bK>>>1}else{eA=c[F+4>>2]|0}bK=eA+9|0;do{if(bK>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=195;break}return 0}else{if(bK>>>0<11>>>0){a[br]=18;eB=E+1|0}else{bI=eA+25&-16;bt=(x=0,as(230,bI|0)|0);if(x){x=0;bm=195;break}c[E+8>>2]=bt;c[E>>2]=bI|1;c[E+4>>2]=9;eB=bt}Kb(eB|0,1952,9)|0;a[eB+9|0]=0;if((a[ew]&1)==0){eC=bH+1|0}else{eC=c[F+8>>2]|0}x=0,ax(64,E|0,eC|0,eA|0)|0;if(x){x=0;bm=195;break}x=0;aB(22,E|0,a3|0,bb|0,c[b+4>>2]|0,D|0,b|0);if(x){x=0;bt=bQ(-1,-1)|0;bI=bt;bt=K;if((a[br]&1)==0){eD=bI;eE=bt;break}J2(c[E+8>>2]|0);eD=bI;eE=bt;break}if((a[br]&1)!=0){J2(c[E+8>>2]|0)}if((a[ew]&1)!=0){J2(c[F+8>>2]|0)}bt=c[a0>>2]|0;c[a0>>2]=D;bI=b+12|0;bJ=c[bI>>2]|0;a8=d+4|0;if((a[a8]&1)==0){bS=H;c[bS>>2]=c[a8>>2];c[bS+4>>2]=c[a8+4>>2];c[bS+8>>2]=c[a8+8>>2]}else{bS=c[d+12>>2]|0;bu=c[d+8>>2]|0;if(bu>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=313;break L224}return 0}if(bu>>>0<11>>>0){a[H]=bu<<1;eF=H+1|0}else{b8=bu+16&-16;bN=(x=0,as(230,b8|0)|0);if(x){x=0;bm=313;break L224}c[H+8>>2]=bN;c[H>>2]=b8|1;c[H+4>>2]=bu;eF=bN}Kb(eF|0,bS|0,bu)|0;a[eF+bu|0]=0}bu=I;bS=d+16|0;c[bu>>2]=c[bS>>2];c[bu+4>>2]=c[bS+4>>2];c[bu+8>>2]=c[bS+8>>2];L280:do{if((a[a_]&1)==0){bN=M;c[bN>>2]=c[a_>>2];c[bN+4>>2]=c[a_+4>>2];c[bN+8>>2]=c[a_+8>>2];eG=a[bN]|0;eH=bN;bm=222}else{bN=c[d+44>>2]|0;b8=c[d+40>>2]|0;do{if(b8>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(b8>>>0<11>>>0){c_=b8<<1&255;c3=M;a[c3]=c_;eI=M+1|0;eJ=c_;eK=c3}else{c3=b8+16&-16;c_=(x=0,as(230,c3|0)|0);if(x){x=0;break}c[M+8>>2]=c_;bR=c3|1;c[M>>2]=bR;c[M+4>>2]=b8;eI=c_;eJ=bR&255;eK=M}Kb(eI|0,bN|0,b8)|0;a[eI+b8|0]=0;eG=eJ;eH=eK;bm=222;break L280}}while(0);b8=bQ(-1,-1)|0;eL=b8;eM=K}}while(0);do{if((bm|0)==222){bX=L;Ke(bX|0,0,12)|0;bM=M;a4=eG&255;if((a4&1|0)==0){eN=a4>>>1}else{eN=c[M+4>>2]|0}a4=eN+15|0;do{if(a4>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=236;break}return 0}else{if(a4>>>0<11>>>0){a[bX]=30;eO=L+1|0}else{b8=eN+31&-16;bN=(x=0,as(230,b8|0)|0);if(x){x=0;bm=236;break}c[L+8>>2]=bN;c[L>>2]=b8|1;c[L+4>>2]=15;eO=bN}Kb(eO|0,1216,15)|0;a[eO+15|0]=0;if((a[eH]&1)==0){eP=bM+1|0}else{eP=c[M+8>>2]|0}x=0,ax(64,L|0,eP|0,eN|0)|0;if(x){x=0;bm=236;break}bN=J;Ke(bN|0,0,12)|0;b8=a[bX]|0;b5=b8&255;if((b5&1|0)==0){eQ=b5>>>1}else{eQ=c[L+4>>2]|0}if((b8&1)==0){eR=L+1|0}else{eR=c[L+8>>2]|0}b8=eQ+1|0;do{if(b8>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=252;break}return 0}else{if(b8>>>0<11>>>0){a[bN]=eQ<<1;eS=J+1|0}else{b5=eQ+17&-16;bR=(x=0,as(230,b5|0)|0);if(x){x=0;bm=252;break}c[J+8>>2]=bR;c[J>>2]=b5|1;c[J+4>>2]=eQ;eS=bR}Kb(eS|0,eR|0,eQ)|0;a[eS+eQ|0]=0;x=0,ax(64,J|0,600,1)|0;if(x){x=0;bm=252;break}bR=j;c[bR>>2]=c[bu>>2];c[bR+4>>2]=c[bu+4>>2];c[bR+8>>2]=c[bu+8>>2];x=0;ao(24,G|0,bJ|0,H|0,j|0,J|0);if(x){x=0;bR=bQ(-1,-1)|0;b5=bR;bR=K;if((a[bN]&1)==0){eT=b5;eU=bR;break}J2(c[J+8>>2]|0);eT=b5;eU=bR;break}if((a[bN]&1)!=0){J2(c[J+8>>2]|0)}if((a[bX]&1)!=0){J2(c[L+8>>2]|0)}if((a[eH]&1)!=0){J2(c[M+8>>2]|0)}if((a[H]&1)!=0){J2(c[H+8>>2]|0)}c[bI>>2]=G;bR=(x=0,aK(c[(c[ba>>2]|0)+20>>2]|0,ba|0,q|0)|0);L347:do{if(!x){L349:do{if((bR|0)==0){b5=P;c_=P;a[c_]=18;Kb(b5+1|0,1952,9)|0;a[b5+10|0]=0;L351:do{if((a[a_]&1)==0){b5=Q;c[b5>>2]=c[a_>>2];c[b5+4>>2]=c[a_+4>>2];c[b5+8>>2]=c[a_+8>>2];bm=275}else{b5=c[d+44>>2]|0;c3=c[d+40>>2]|0;do{if(c3>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(c3>>>0<11>>>0){a[Q]=c3<<1;eV=Q+1|0}else{b9=c3+16&-16;c6=(x=0,as(230,b9|0)|0);if(x){x=0;break}c[Q+8>>2]=c6;c[Q>>2]=b9|1;c[Q+4>>2]=c3;eV=c6}Kb(eV|0,b5|0,c3)|0;a[eV+c3|0]=0;bm=275;break L351}}while(0);c3=bQ(-1,-1)|0;eW=c3;eX=K}}while(0);do{if((bm|0)==275){x=0;aP(194,O|0,P|0,Q|0);do{if(!x){ca=N;Ke(ca|0,0,12)|0;c3=O;b5=a[c3]|0;dZ=b5&255;if((dZ&1|0)==0){eY=dZ>>>1}else{eY=c[O+4>>2]|0}if((b5&1)==0){eZ=O+1|0}else{eZ=c[O+8>>2]|0}b5=eY+23|0;do{if(b5>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;bm=290;break}return 0}else{if(b5>>>0<11>>>0){a[ca]=eY<<1;e_=N+1|0}else{dZ=eY+39&-16;c6=(x=0,as(230,dZ|0)|0);if(x){x=0;bm=290;break}c[N+8>>2]=c6;c[N>>2]=dZ|1;c[N+4>>2]=eY;e_=c6}Kb(e_|0,eZ|0,eY)|0;a[e_+eY|0]=0;x=0,ax(64,N|0,12344,23)|0;if(x){x=0;bm=290;break}L386:do{if((a[a8]&1)==0){c6=R;c[c6>>2]=c[a8>>2];c[c6+4>>2]=c[a8+4>>2];c[c6+8>>2]=c[a8+8>>2];bm=302}else{c6=c[d+12>>2]|0;dZ=c[d+8>>2]|0;do{if(dZ>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(dZ>>>0<11>>>0){a[R]=dZ<<1;e$=R+1|0}else{b9=dZ+16&-16;cc=(x=0,as(230,b9|0)|0);if(x){x=0;break}c[R+8>>2]=cc;c[R>>2]=b9|1;c[R+4>>2]=dZ;e$=cc}Kb(e$|0,c6|0,dZ)|0;a[e$+dZ|0]=0;bm=302;break L386}}while(0);dZ=bQ(-1,-1)|0;e0=dZ;e1=K}}while(0);do{if((bm|0)==302){dZ=S;c[dZ>>2]=c[bS>>2];c[dZ+4>>2]=c[bS+4>>2];c[dZ+8>>2]=c[bS+8>>2];x=0;aP(362,N|0,R|0,S|0);if(x){x=0;dZ=bQ(-1,-1)|0;c6=dZ;dZ=K;if((a[R]&1)==0){e0=c6;e1=dZ;break}J2(c[R+8>>2]|0);e0=c6;e1=dZ;break}if((a[R]&1)!=0){J2(c[R+8>>2]|0)}if((a[ca]&1)!=0){J2(c[N+8>>2]|0)}if((a[c3]&1)!=0){J2(c[O+8>>2]|0)}if((a[Q]&1)!=0){J2(c[Q+8>>2]|0)}if((a[c_]&1)==0){break L349}J2(c[P+8>>2]|0);break L349}}while(0);if((a[ca]&1)==0){e2=e0;e3=e1;break}J2(c[N+8>>2]|0);e2=e0;e3=e1}}while(0);if((bm|0)==290){b5=bQ(-1,-1)|0;dZ=K;if((a[ca]&1)!=0){J2(c[N+8>>2]|0)}e2=b5;e3=dZ}if((a[c3]&1)==0){e4=e2;e5=e3;break}J2(c[O+8>>2]|0);e4=e2;e5=e3}else{x=0;dZ=bQ(-1,-1)|0;e4=dZ;e5=K}}while(0);if((a[Q]&1)==0){eW=e4;eX=e5;break}J2(c[Q+8>>2]|0);eW=e4;eX=e5}}while(0);if((a[c_]&1)==0){e6=eW;e7=eX;break L347}J2(c[P+8>>2]|0);e6=eW;e7=eX;break L347}}while(0);c[bI>>2]=c[G>>2];c[a0>>2]=bt;if((a[G+28|0]&1)!=0){J2(c[G+36>>2]|0)}if((a[G+4|0]&1)==0){cg=bR;ch=bS;bm=990;break L224}J2(c[G+12>>2]|0);cg=bR;ch=bS;bm=990;break L224}else{x=0;dZ=bQ(-1,-1)|0;e6=dZ;e7=K}}while(0);if((a[G+28|0]&1)!=0){J2(c[G+36>>2]|0)}if((a[G+4|0]&1)==0){ci=e6;cj=e7;break L224}J2(c[G+12>>2]|0);ci=e6;cj=e7;break L224}}while(0);if((bm|0)==252){b8=bQ(-1,-1)|0;bR=K;if((a[bN]&1)!=0){J2(c[J+8>>2]|0)}eT=b8;eU=bR}if((a[bX]&1)==0){e8=eT;e9=eU;break}J2(c[L+8>>2]|0);e8=eT;e9=eU}}while(0);if((bm|0)==236){bM=bQ(-1,-1)|0;a4=K;if((a[bX]&1)!=0){J2(c[L+8>>2]|0)}e8=bM;e9=a4}if((a[eH]&1)==0){eL=e8;eM=e9;break}J2(c[M+8>>2]|0);eL=e8;eM=e9}}while(0);if((a[H]&1)==0){ci=eL;cj=eM;break L224}J2(c[H+8>>2]|0);ci=eL;cj=eM;break L224}}while(0);if((bm|0)==195){bH=bQ(-1,-1)|0;bK=K;if((a[br]&1)!=0){J2(c[E+8>>2]|0)}eD=bH;eE=bK}if((a[ew]&1)==0){ci=eD;cj=eE;break}J2(c[F+8>>2]|0);ci=eD;cj=eE}}while(0);if((bm|0)==313){ba=bQ(-1,-1)|0;en=K;eo=ba;bm=314}else if((bm|0)==990){Kc(cg+16|0,ch|0,12)|0;fQ(D|0,c[D+4>>2]|0);fa=cg;break}if((bm|0)==314){ci=eo;cj=en}fQ(D|0,c[D+4>>2]|0);bo=ci;bp=cj;break L74}else{ba=b+4|0;a3=c[ba>>2]|0;a$=(x=0,as(230,52)|0);if(x){x=0;bm=121;break L74}a2=a$;c[n>>2]=a2;a$=a3+4|0;bg=c[a$>>2]|0;if((bg|0)==(c[a3+8>>2]|0)){x=0;aq(376,a3|0,n|0);if(x){x=0;bm=121;break L74}fb=c[n>>2]|0}else{if((bg|0)==0){fc=0}else{c[bg>>2]=a2;fc=c[a$>>2]|0}c[a$>>2]=fc+4;fb=a2}a2=fb;bg=fb;a9=d+4|0;L94:do{if((a[a9]&1)==0){a5=u;c[a5>>2]=c[a9>>2];c[a5+4>>2]=c[a9+4>>2];c[a5+8>>2]=c[a9+8>>2];bm=78}else{a5=c[d+12>>2]|0;a6=c[d+8>>2]|0;do{if(a6>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(a6>>>0<11>>>0){a[u]=a6<<1;fd=u+1|0}else{bK=a6+16&-16;bH=(x=0,as(230,bK|0)|0);if(x){x=0;break}c[u+8>>2]=bH;c[u>>2]=bK|1;c[u+4>>2]=a6;fd=bH}Kb(fd|0,a5|0,a6)|0;a[fd+a6|0]=0;bm=78;break L94}}while(0);a6=bQ(-1,-1)|0;fe=a6;ff=K}}while(0);do{if((bm|0)==78){a6=v;a5=d+16|0;c[a6>>2]=c[a5>>2];c[a6+4>>2]=c[a5+4>>2];c[a6+8>>2]=c[a5+8>>2];L109:do{if((a[a_]&1)==0){br=w;c[br>>2]=c[a_>>2];c[br+4>>2]=c[a_+4>>2];c[br+8>>2]=c[a_+8>>2];bm=88}else{br=c[d+44>>2]|0;bH=c[d+40>>2]|0;do{if(bH>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bH>>>0<11>>>0){a[w]=bH<<1;fg=w+1|0}else{bK=bH+16&-16;bs=(x=0,as(230,bK|0)|0);if(x){x=0;break}c[w+8>>2]=bs;c[w>>2]=bK|1;c[w+4>>2]=bH;fg=bs}Kb(fg|0,br|0,bH)|0;a[fg+bH|0]=0;bm=88;break L109}}while(0);bH=bQ(-1,-1)|0;fh=bH;fi=K}}while(0);do{if((bm|0)==88){bH=m;c[bH>>2]=c[a6>>2];c[bH+4>>2]=c[a6+4>>2];c[bH+8>>2]=c[a6+8>>2];x=0;ao(10,bg|0,u|0,m|0,w|0,bb|0);if(x){x=0;bH=bQ(-1,-1)|0;br=bH;bH=K;if((a[w]&1)==0){fh=br;fi=bH;break}J2(c[w+8>>2]|0);fh=br;fi=bH;break}if((a[w]&1)!=0){J2(c[w+8>>2]|0)}if((a[u]&1)!=0){J2(c[u+8>>2]|0)}x=0;aq(276,y|0,0);if(x){x=0;bm=121;break L74}bH=c[ba>>2]|0;br=(x=0,as(230,52)|0);do{if(!x){bs=br;c[l>>2]=bs;bK=bH+4|0;bS=c[bK>>2]|0;if((bS|0)==(c[bH+8>>2]|0)){x=0;aq(376,bH|0,l|0);if(x){x=0;bm=137;break}fj=c[l>>2]|0}else{if((bS|0)==0){fk=0}else{c[bS>>2]=bs;fk=c[bK>>2]|0}c[bK>>2]=fk+4;fj=bs}bs=fj;bS=fj;L145:do{if((a[a9]&1)==0){bt=z;c[bt>>2]=c[a9>>2];c[bt+4>>2]=c[a9+4>>2];c[bt+8>>2]=c[a9+8>>2];bm=111}else{bt=c[d+12>>2]|0;bI=c[d+8>>2]|0;do{if(bI>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(bI>>>0<11>>>0){a[z]=bI<<1;fl=z+1|0}else{a8=bI+16&-16;bJ=(x=0,as(230,a8|0)|0);if(x){x=0;break}c[z+8>>2]=bJ;c[z>>2]=a8|1;c[z+4>>2]=bI;fl=bJ}Kb(fl|0,bt|0,bI)|0;a[fl+bI|0]=0;bm=111;break L145}}while(0);bI=bQ(-1,-1)|0;fm=bI;fn=K}}while(0);do{if((bm|0)==111){bX=A;c[bX>>2]=c[a5>>2];c[bX+4>>2]=c[a5+4>>2];c[bX+8>>2]=c[a5+8>>2];x=0;aP(c[(c[fb>>2]|0)+28>>2]|0,B|0,bg|0,y|0);do{if(!x){bI=k;c[bI>>2]=c[bX>>2];c[bI+4>>2]=c[bX+4>>2];c[bI+8>>2]=c[bX+8>>2];x=0;ao(26,bS|0,z|0,k|0,B|0,0);if(x){x=0;bI=bQ(-1,-1)|0;bt=bI;bI=K;if((a[B]&1)==0){fo=bt;fp=bI;break}J2(c[B+8>>2]|0);fo=bt;fp=bI;break}if((a[B]&1)!=0){J2(c[B+8>>2]|0)}if((a[z]&1)!=0){J2(c[z+8>>2]|0)}x=0;ap(436,y|0);if(!x){fa=fj;break L83}else{x=0;bm=121;break L74}}else{x=0;bI=bQ(-1,-1)|0;fo=bI;fp=K}}while(0);if((a[z]&1)==0){fm=fo;fn=fp;break}J2(c[z+8>>2]|0);fm=fo;fn=fp}}while(0);bS=c[bH>>2]|0;bX=c[bK>>2]|0;bI=bS;while(1){if((bI|0)==(bX|0)){fq=bX;break}if((c[bI>>2]|0)==(fj|0)){fq=bI;break}else{bI=bI+4|0}}bI=fq-bS>>2;bt=bS+(bI+1<<2)|0;bN=bX-bt|0;Kc(bS+(bI<<2)|0,bt|0,bN|0)|0;bt=bS+((bN>>2)+bI<<2)|0;bI=c[bK>>2]|0;if((bt|0)!=(bI|0)){c[bK>>2]=bI+(~((bI-4+(-bt|0)|0)>>>2)<<2)}J2(bs);fr=fm;fs=fn}else{x=0;bm=137}}while(0);if((bm|0)==137){bH=bQ(-1,-1)|0;fr=bH;fs=K}x=0;ap(436,y|0);if(!x){bo=fr;bp=fs;break L74}else{x=0;bm=998;break L83}}}while(0);if((a[u]&1)==0){fe=fh;ff=fi;break}J2(c[u+8>>2]|0);fe=fh;ff=fi}}while(0);bg=c[a3>>2]|0;a9=c[a$>>2]|0;ba=bg;while(1){if((ba|0)==(a9|0)){ft=a9;break}if((c[ba>>2]|0)==(fb|0)){ft=ba;break}else{ba=ba+4|0}}ba=ft-bg>>2;a3=bg+(ba+1<<2)|0;a5=a9-a3|0;Kc(bg+(ba<<2)|0,a3|0,a5|0)|0;a3=bg+((a5>>2)+ba<<2)|0;ba=c[a$>>2]|0;if((a3|0)!=(ba|0)){c[a$>>2]=ba+(~((ba-4+(-a3|0)|0)>>>2)<<2)}J2(a2);bo=fe;bp=ff;break L74}}while(0);if((bm|0)==998){bQ(-1,-1,0)|0;bU();return 0}if((a[bi]&1)==0){bc=fa;i=e;return bc|0}J2(c[r+8>>2]|0);bc=fa;i=e;return bc|0}}while(0);if((bm|0)==121){a0=bQ(-1,-1)|0;bv=K;bw=a0;bm=122}if((bm|0)==122){bo=bw;bp=bv}if((a[bi]&1)==0){fu=bo;fv=bp;fw=fu;fx=0;fy=fw;fz=fv;be(fy|0)}J2(c[r+8>>2]|0);fu=bo;fv=bp;fw=fu;fx=0;fy=fw;fz=fv;be(fy|0)}}while(0);bp=bQ(-1,-1)|0;bo=K;if((a[bi]&1)!=0){J2(c[r+8>>2]|0)}r=bp;bp=bo;if((a[bf]&1)==0){fu=r;fv=bp;fw=fu;fx=0;fy=fw;fz=fv;be(fy|0)}J2(c[s+8>>2]|0);fu=r;fv=bp;fw=fu;fx=0;fy=fw;fz=fv;be(fy|0);return 0}function hV(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=b;Ke(g|0,0,12)|0;h=a[e]|0;i=h&255;if((i&1|0)==0){j=i>>>1}else{j=c[e+4>>2]|0}i=f;k=f;l=d[k]|0;if((l&1|0)==0){m=l>>>1}else{m=c[f+4>>2]|0}if((h&1)==0){n=e+1|0}else{n=c[e+8>>2]|0}e=m+j|0;do{if(e>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(e>>>0<11>>>0){a[g]=j<<1;o=b+1|0}else{h=e+16&-16;l=(x=0,as(230,h|0)|0);if(x){x=0;break}c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;o=l}Kb(o|0,n|0,j)|0;a[o+j|0]=0;if((a[k]&1)==0){p=i+1|0}else{p=c[f+8>>2]|0}x=0,ax(64,b|0,p|0,m|0)|0;if(x){x=0;break}return}}while(0);m=bQ(-1,-1)|0;if((a[g]&1)==0){be(m|0)}J2(c[b+8>>2]|0);be(m|0)}function hW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0.0,ac=0.0,ad=0.0,ae=0.0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aC=0,aD=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aP=0,aQ=0,aR=0,aS=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a0=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0;j=i;i=i+464|0;k=b;b=i;i=i+40|0;Kb(b,k,40)|0;k=g;g=i;i=i+12|0;i=i+7&-8;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=j+32|0;n=j+48|0;o=j+56|0;p=j+64|0;q=j+80|0;r=j+88|0;s=j+104|0;t=j+112|0;u=j+128|0;v=j+136|0;w=j+152|0;y=j+160|0;z=j+168|0;A=j+184|0;B=j+200|0;C=j+216|0;D=j+232|0;E=j+248|0;F=j+264|0;G=j+280|0;H=j+296|0;I=j+312|0;J=j+352|0;L=j+368|0;M=j+384|0;N=j+400|0;O=j+416|0;P=j+432|0;Q=j+448|0;switch(c[b>>2]|0){case 2:{R=J0(88)|0;c[u>>2]=R;S=d+4|0;T=c[S>>2]|0;if((T|0)==(c[d+8>>2]|0)){ee(d|0,u);U=c[u>>2]|0}else{if((T|0)==0){V=0}else{c[T>>2]=R;V=c[S>>2]|0}c[S>>2]=V+4;U=R}R=U;V=U;T=f;L10:do{if((a[T]&1)==0){u=E;c[u>>2]=c[T>>2];c[u+4>>2]=c[T+4>>2];c[u+8>>2]=c[T+8>>2];W=83}else{u=c[f+8>>2]|0;X=c[f+4>>2]|0;do{if(X>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(X>>>0<11>>>0){a[E]=X<<1;Y=E+1|0}else{Z=X+16&-16;_=(x=0,as(230,Z|0)|0);if(x){x=0;break}c[E+8>>2]=_;c[E>>2]=Z|1;c[E+4>>2]=X;Y=_}Kb(Y|0,u|0,X)|0;a[Y+X|0]=0;W=83;break L10}}while(0);X=bQ(-1,-1)|0;$=X;aa=K}}while(0);do{if((W|0)==83){Y=g;T=t;c[T>>2]=c[Y>>2];c[T+4>>2]=c[Y+4>>2];c[T+8>>2]=c[Y+8>>2];ab=+h[b+8>>3];ac=+h[b+16>>3];ad=+h[b+24>>3];ae=+h[b+32>>3];Y=F;a[Y]=0;a[F+1|0]=0;x=0;at(2,V|0,E|0,t|0,+ab,+ac,+ad,+ae,F|0);if(x){x=0;T=bQ(-1,-1)|0;X=T;T=K;if((a[Y]&1)!=0){J2(c[F+8>>2]|0)}if((a[E]&1)==0){$=X;aa=T;break}J2(c[E+8>>2]|0);$=X;aa=T;break}if((a[Y]&1)!=0){J2(c[F+8>>2]|0)}Y=U;if((a[E]&1)==0){af=Y;i=j;return af|0}J2(c[E+8>>2]|0);af=Y;i=j;return af|0}}while(0);E=c[d>>2]|0;F=c[S>>2]|0;t=E;while(1){if((t|0)==(F|0)){ag=F;break}if((c[t>>2]|0)==(U|0)){ag=t;break}else{t=t+4|0}}t=ag-E>>2;ag=E+(t+1<<2)|0;U=F-ag|0;Kc(E+(t<<2)|0,ag|0,U|0)|0;ag=E+((U>>2)+t<<2)|0;t=c[S>>2]|0;if((ag|0)!=(t|0)){c[S>>2]=t+(~((t-4+(-ag|0)|0)>>>2)<<2)}J2(R);ah=$;ai=aa;aj=ah;ak=0;al=aj;am=ai;be(al|0);break};case 4:{aa=J0(60)|0;c[q>>2]=aa;$=d+4|0;R=c[$>>2]|0;if((R|0)==(c[d+8>>2]|0)){ee(d|0,q);an=c[q>>2]|0}else{if((R|0)==0){ar=0}else{c[R>>2]=aa;ar=c[$>>2]|0}c[$>>2]=ar+4;an=aa}aa=an;ar=f;L56:do{if((a[ar]&1)==0){R=H;c[R>>2]=c[ar>>2];c[R+4>>2]=c[ar+4>>2];c[R+8>>2]=c[ar+8>>2];W=141}else{R=c[f+8>>2]|0;q=c[f+4>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(q>>>0<11>>>0){a[H]=q<<1;au=H+1|0}else{ag=q+16&-16;t=(x=0,as(230,ag|0)|0);if(x){x=0;break}c[H+8>>2]=t;c[H>>2]=ag|1;c[H+4>>2]=q;au=t}Kb(au|0,R|0,q)|0;a[au+q|0]=0;W=141;break L56}}while(0);q=bQ(-1,-1)|0;av=q;aw=K}}while(0);do{if((W|0)==141){au=g;q=p;c[q>>2]=c[au>>2];c[q+4>>2]=c[au+4>>2];c[q+8>>2]=c[au+8>>2];q=b;R=c[b+8>>2]|0;x=0;aB(34,an|0,H|0,p|0,R|0,(c[q+4>>2]|0)==0|0,0);if(x){x=0;t=bQ(-1,-1)|0;ag=t;t=K;if((a[H]&1)==0){av=ag;aw=t;break}J2(c[H+8>>2]|0);av=ag;aw=t;break}if((a[H]&1)!=0){J2(c[H+8>>2]|0)}L78:do{if((R|0)!=0){t=I;ag=J;S=L;U=an+36|0;E=U;F=U+8|0;V=F;Y=U+12|0;T=U+4|0;X=U;U=J+8|0;u=f+8|0;_=f+4|0;Z=J+1|0;ay=J|0;az=J+4|0;aA=c[q+12>>2]|0;aC=0;while(1){aD=aA+(aC*40|0)|0;c[t>>2]=c[aD>>2];c[t+4>>2]=c[aD+4>>2];c[t+8>>2]=c[aD+8>>2];c[t+12>>2]=c[aD+12>>2];c[t+16>>2]=c[aD+16>>2];c[t+20>>2]=c[aD+20>>2];c[t+24>>2]=c[aD+24>>2];c[t+28>>2]=c[aD+28>>2];c[t+32>>2]=c[aD+32>>2];c[t+36>>2]=c[aD+36>>2];if((a[ar]&1)==0){c[ag>>2]=c[ar>>2];c[ag+4>>2]=c[ar+4>>2];c[ag+8>>2]=c[ar+8>>2]}else{aD=c[u>>2]|0;aF=c[_>>2]|0;if(aF>>>0>4294967279>>>0){W=149;break}if(aF>>>0<11>>>0){a[ag]=aF<<1;aG=Z}else{aH=aF+16&-16;aI=J0(aH)|0;c[U>>2]=aI;c[ay>>2]=aH|1;c[az>>2]=aF;aG=aI}Kb(aG|0,aD|0,aF)|0;a[aG+aF|0]=0}c[S>>2]=c[au>>2];c[S+4>>2]=c[au+4>>2];c[S+8>>2]=c[au+8>>2];aF=(x=0,aO(22,I|0,d|0,e|0,J|0,L|0)|0);if(x){x=0;break}c[o>>2]=aF;aD=c[V>>2]|0;if((aD|0)==(c[Y>>2]|0)){x=0;aq(370,T|0,o|0);if(x){x=0;break}aJ=c[o>>2]|0}else{if((aD|0)==0){aK=0}else{c[aD>>2]=aF;aK=c[V>>2]|0}c[F>>2]=aK+4;aJ=aF}x=0;aq(c[c[X>>2]>>2]|0,E|0,aJ|0);if(x){x=0;break}if((a[ag]&1)!=0){J2(c[U>>2]|0)}aC=aC+1|0;if(aC>>>0>=R>>>0){break L78}}if((W|0)==149){CJ(0);return 0}aC=bQ(-1,-1)|0;E=aC;aC=K;if((a[ag]&1)==0){ah=E;ai=aC;aj=ah;ak=0;al=aj;am=ai;be(al|0)}J2(c[U>>2]|0);ah=E;ai=aC;aj=ah;ak=0;al=aj;am=ai;be(al|0)}}while(0);af=an;i=j;return af|0}}while(0);aJ=c[d>>2]|0;aK=c[$>>2]|0;o=aJ;while(1){if((o|0)==(aK|0)){aL=aK;break}if((c[o>>2]|0)==(an|0)){aL=o;break}else{o=o+4|0}}o=aL-aJ>>2;aL=aJ+(o+1<<2)|0;an=aK-aL|0;Kc(aJ+(o<<2)|0,aL|0,an|0)|0;aL=aJ+((an>>2)+o<<2)|0;o=c[$>>2]|0;if((aL|0)!=(o|0)){c[$>>2]=o+(~((o-4+(-aL|0)|0)>>>2)<<2)}J2(aa);ah=av;ai=aw;aj=ah;ak=0;al=aj;am=ai;be(al|0);break};case 1:{aw=J0(72)|0;c[w>>2]=aw;av=d+4|0;aa=c[av>>2]|0;if((aa|0)==(c[d+8>>2]|0)){ee(d|0,w);aM=c[w>>2]|0}else{if((aa|0)==0){aN=0}else{c[aa>>2]=aw;aN=c[av>>2]|0}c[av>>2]=aN+4;aM=aw}aw=aM;aN=aM;aa=f;L130:do{if((a[aa]&1)==0){w=B;c[w>>2]=c[aa>>2];c[w+4>>2]=c[aa+4>>2];c[w+8>>2]=c[aa+8>>2];W=44}else{w=c[f+8>>2]|0;aL=c[f+4>>2]|0;do{if(aL>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aL>>>0<11>>>0){a[B]=aL<<1;aP=B+1|0}else{o=aL+16&-16;$=(x=0,as(230,o|0)|0);if(x){x=0;break}c[B+8>>2]=$;c[B>>2]=o|1;c[B+4>>2]=aL;aP=$}Kb(aP|0,w|0,aL)|0;a[aP+aL|0]=0;W=44;break L130}}while(0);aL=bQ(-1,-1)|0;aQ=aL;aR=K}}while(0);do{if((W|0)==44){aP=C;aa=g;c[aP>>2]=c[aa>>2];c[aP+4>>2]=c[aa+4>>2];c[aP+8>>2]=c[aa+8>>2];ae=+h[b+8>>3];aa=c[b+16>>2]|0;aL=Kf(aa|0)|0;do{if(aL>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;W=57;break}return 0}else{if(aL>>>0<11>>>0){a[D]=aL<<1;aS=D+1|0}else{w=aL+16&-16;$=(x=0,as(230,w|0)|0);if(x){x=0;W=57;break}c[D+8>>2]=$;c[D>>2]=w|1;c[D+4>>2]=aL;aS=$}Kb(aS|0,aa|0,aL)|0;a[aS+aL|0]=0;$=v;c[$>>2]=c[aP>>2];c[$+4>>2]=c[aP+4>>2];c[$+8>>2]=c[aP+8>>2];x=0;aE(2,aN|0,B|0,v|0,+ae,D|0);if(x){x=0;$=bQ(-1,-1)|0;w=$;$=K;if((a[D]&1)==0){aU=w;aV=$;break}J2(c[D+8>>2]|0);aU=w;aV=$;break}if((a[D]&1)!=0){J2(c[D+8>>2]|0)}$=aM;if((a[B]&1)==0){af=$;i=j;return af|0}J2(c[B+8>>2]|0);af=$;i=j;return af|0}}while(0);if((W|0)==57){aP=bQ(-1,-1)|0;aU=aP;aV=K}if((a[B]&1)==0){aQ=aU;aR=aV;break}J2(c[B+8>>2]|0);aQ=aU;aR=aV}}while(0);aV=c[d>>2]|0;aU=c[av>>2]|0;B=aV;while(1){if((B|0)==(aU|0)){aW=aU;break}if((c[B>>2]|0)==(aM|0)){aW=B;break}else{B=B+4|0}}B=aW-aV>>2;aW=aV+(B+1<<2)|0;aM=aU-aW|0;Kc(aV+(B<<2)|0,aW|0,aM|0)|0;aW=aV+((aM>>2)+B<<2)|0;B=c[av>>2]|0;if((aW|0)!=(B|0)){c[av>>2]=B+(~((B-4+(-aW|0)|0)>>>2)<<2)}J2(aw);ah=aQ;ai=aR;aj=ah;ak=0;al=aj;am=ai;be(al|0);break};case 0:{aR=J0(40)|0;c[y>>2]=aR;aQ=d+4|0;aw=c[aQ>>2]|0;if((aw|0)==(c[d+8>>2]|0)){ee(d|0,y);aX=c[y>>2]|0}else{if((aw|0)==0){aY=0}else{c[aw>>2]=aR;aY=c[aQ>>2]|0}c[aQ>>2]=aY+4;aX=aR}aR=aX;aY=f;L186:do{if((a[aY]&1)==0){aw=z;c[aw>>2]=c[aY>>2];c[aw+4>>2]=c[aY+4>>2];c[aw+8>>2]=c[aY+8>>2];W=17}else{aw=c[f+8>>2]|0;y=c[f+4>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[z]=y<<1;aZ=z+1|0}else{aW=y+16&-16;B=(x=0,as(230,aW|0)|0);if(x){x=0;break}c[z+8>>2]=B;c[z>>2]=aW|1;c[z+4>>2]=y;aZ=B}Kb(aZ|0,aw|0,y)|0;a[aZ+y|0]=0;W=17;break L186}}while(0);y=bQ(-1,-1)|0;a_=y;a$=K}}while(0);do{if((W|0)==17){aZ=A;aY=g;c[aZ>>2]=c[aY>>2];c[aZ+4>>2]=c[aY+4>>2];c[aZ+8>>2]=c[aY+8>>2];x=0;aT(4,aX|0,z|0,A|0,(c[b+4>>2]|0)!=0|0);if(x){x=0;aY=bQ(-1,-1)|0;aZ=aY;aY=K;if((a[z]&1)==0){a_=aZ;a$=aY;break}J2(c[z+8>>2]|0);a_=aZ;a$=aY;break}aY=aX;if((a[z]&1)==0){af=aY;i=j;return af|0}J2(c[z+8>>2]|0);af=aY;i=j;return af|0}}while(0);z=c[d>>2]|0;A=c[aQ>>2]|0;aY=z;while(1){if((aY|0)==(A|0)){a0=A;break}if((c[aY>>2]|0)==(aX|0)){a0=aY;break}else{aY=aY+4|0}}aY=a0-z>>2;a0=z+(aY+1<<2)|0;aX=A-a0|0;Kc(z+(aY<<2)|0,a0|0,aX|0)|0;a0=z+((aX>>2)+aY<<2)|0;aY=c[aQ>>2]|0;if((a0|0)!=(aY|0)){c[aQ>>2]=aY+(~((aY-4+(-a0|0)|0)>>>2)<<2)}J2(aR);ah=a_;ai=a$;aj=ah;ak=0;al=aj;am=ai;be(al|0);break};case 5:{a$=J0(36)|0;c[n>>2]=a$;a_=d+4|0;aR=c[a_>>2]|0;if((aR|0)==(c[d+8>>2]|0)){ee(d|0,n);a1=c[n>>2]|0}else{if((aR|0)==0){a2=0}else{c[aR>>2]=a$;a2=c[a_>>2]|0}c[a_>>2]=a2+4;a1=a$}a$=a1;a2=f;L226:do{if((a[a2]&1)==0){aR=M;c[aR>>2]=c[a2>>2];c[aR+4>>2]=c[a2+4>>2];c[aR+8>>2]=c[a2+8>>2];a3=a[aR]|0;a4=aR;W=192}else{aR=c[f+8>>2]|0;n=c[f+4>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(n>>>0<11>>>0){a0=n<<1&255;aY=M;a[aY]=a0;a5=M+1|0;a6=a0;a7=aY}else{aY=n+16&-16;a0=(x=0,as(230,aY|0)|0);if(x){x=0;break}c[M+8>>2]=a0;aQ=aY|1;c[M>>2]=aQ;c[M+4>>2]=n;a5=a0;a6=aQ&255;a7=M}Kb(a5|0,aR|0,n)|0;a[a5+n|0]=0;a3=a6;a4=a7;W=192;break L226}}while(0);n=bQ(-1,-1)|0;a8=n;a9=K}}while(0);do{if((W|0)==192){a7=g;a6=m;c[a6>>2]=c[a7>>2];c[a6+4>>2]=c[a7+4>>2];c[a6+8>>2]=c[a7+8>>2];a7=m;a6=k;a5=l;a2=a1;L241:do{if((a3&1)==0){c[a6>>2]=c[a4>>2];c[a6+4>>2]=c[a4+4>>2];c[a6+8>>2]=c[a4+8>>2];W=202}else{n=c[M+8>>2]|0;aR=c[M+4>>2]|0;do{if(aR>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aR>>>0<11>>>0){a[a6]=aR<<1;ba=k+1|0}else{aQ=aR+16&-16;a0=(x=0,as(230,aQ|0)|0);if(x){x=0;break}c[k+8>>2]=a0;c[k>>2]=aQ|1;c[k+4>>2]=aR;ba=a0}Kb(ba|0,n|0,aR)|0;a[ba+aR|0]=0;W=202;break L241}}while(0);aR=bQ(-1,-1)|0;bb=K;bc=aR}}while(0);do{if((W|0)==202){c[a5>>2]=c[a7>>2];c[a5+4>>2]=c[a7+4>>2];c[a5+8>>2]=c[a7+8>>2];x=0;aB(6,a2|0,k|0,l|0,0,0,0);if(x){x=0;aR=bQ(-1,-1)|0;n=K;if((a[a6]&1)==0){bb=n;bc=aR;break}J2(c[k+8>>2]|0);bb=n;bc=aR;break}if((a[a6]&1)!=0){J2(c[k+8>>2]|0)}c[a1>>2]=18624;c[a1+32>>2]=6;if((a[a4]&1)==0){af=a2;i=j;return af|0}J2(c[M+8>>2]|0);af=a2;i=j;return af|0}}while(0);a2=bc;a6=bb;if((a[a4]&1)==0){a8=a2;a9=a6;break}J2(c[M+8>>2]|0);a8=a2;a9=a6}}while(0);M=c[d>>2]|0;a4=c[a_>>2]|0;bb=M;while(1){if((bb|0)==(a4|0)){bd=a4;break}if((c[bb>>2]|0)==(a1|0)){bd=bb;break}else{bb=bb+4|0}}bb=bd-M>>2;bd=M+(bb+1<<2)|0;a1=a4-bd|0;Kc(M+(bb<<2)|0,bd|0,a1|0)|0;bd=M+((a1>>2)+bb<<2)|0;bb=c[a_>>2]|0;if((bd|0)!=(bb|0)){c[a_>>2]=bb+(~((bb-4+(-bd|0)|0)>>>2)<<2)}J2(a$);ah=a8;ai=a9;aj=ah;ak=0;al=aj;am=ai;be(al|0);break};case 3:{a9=J0(52)|0;c[s>>2]=a9;a8=d+4|0;a$=c[a8>>2]|0;if((a$|0)==(c[d+8>>2]|0)){ee(d|0,s);bf=c[s>>2]|0}else{if((a$|0)==0){bg=0}else{c[a$>>2]=a9;bg=c[a8>>2]|0}c[a8>>2]=bg+4;bf=a9}a9=bf;bg=f;L286:do{if((a[bg]&1)==0){a$=G;c[a$>>2]=c[bg>>2];c[a$+4>>2]=c[bg+4>>2];c[a$+8>>2]=c[bg+8>>2];W=114}else{a$=c[f+8>>2]|0;s=c[f+4>>2]|0;do{if(s>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(s>>>0<11>>>0){a[G]=s<<1;bh=G+1|0}else{bd=s+16&-16;bb=(x=0,as(230,bd|0)|0);if(x){x=0;break}c[G+8>>2]=bb;c[G>>2]=bd|1;c[G+4>>2]=s;bh=bb}Kb(bh|0,a$|0,s)|0;a[bh+s|0]=0;W=114;break L286}}while(0);s=bQ(-1,-1)|0;bi=s;bj=K}}while(0);do{if((W|0)==114){bh=g;bg=r;c[bg>>2]=c[bh>>2];c[bg+4>>2]=c[bh+4>>2];c[bg+8>>2]=c[bh+8>>2];x=0;ao(34,bf|0,G|0,r|0,c[b+4>>2]|0,0);if(x){x=0;bh=bQ(-1,-1)|0;bg=bh;bh=K;if((a[G]&1)==0){bi=bg;bj=bh;break}J2(c[G+8>>2]|0);bi=bg;bj=bh;break}bh=bf;if((a[G]&1)==0){af=bh;i=j;return af|0}J2(c[G+8>>2]|0);af=bh;i=j;return af|0}}while(0);G=c[d>>2]|0;d=c[a8>>2]|0;r=G;while(1){if((r|0)==(d|0)){bk=d;break}if((c[r>>2]|0)==(bf|0)){bk=r;break}else{r=r+4|0}}r=bk-G>>2;bk=G+(r+1<<2)|0;bf=d-bk|0;Kc(G+(r<<2)|0,bk|0,bf|0)|0;bk=G+((bf>>2)+r<<2)|0;r=c[a8>>2]|0;if((bk|0)!=(r|0)){c[a8>>2]=r+(~((r-4+(-bk|0)|0)>>>2)<<2)}J2(a9);ah=bi;ai=bj;aj=ah;ak=0;al=aj;am=ai;be(al|0);break};case 6:{bj=c[b+4>>2]|0;b=Kf(bj|0)|0;if(b>>>0>4294967279>>>0){CJ(0);return 0}if(b>>>0<11>>>0){bi=b<<1&255;a9=O;bk=O;a[bk]=bi;bl=a9+1|0;bm=bi;bn=a9;bo=bk}else{bk=b+16&-16;a9=J0(bk)|0;c[O+8>>2]=a9;bi=bk|1;c[O>>2]=bi;c[O+4>>2]=b;bl=a9;bm=bi&255;bn=O;bo=O}Kb(bl|0,bj|0,b)|0;a[bl+b|0]=0;b=N;Ke(b|0,0,12)|0;bl=bm&255;if((bl&1|0)==0){bp=bl>>>1}else{bp=c[O+4>>2]|0}bl=bp+21|0;do{if(bl>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;W=238;break}return 0}else{if(bl>>>0<11>>>0){a[b]=42;bq=N+1|0}else{bj=bp+37&-16;bi=(x=0,as(230,bj|0)|0);if(x){x=0;W=238;break}c[N+8>>2]=bi;c[N>>2]=bj|1;c[N+4>>2]=21;bq=bi}Kb(bq|0,7928,21)|0;a[bq+21|0]=0;if((bm&1)==0){br=bn+1|0}else{br=c[O+8>>2]|0}x=0,ax(64,N|0,br|0,bp|0)|0;if(x){x=0;W=238;break}bi=f;L344:do{if((a[bi]&1)==0){bj=P;c[bj>>2]=c[bi>>2];c[bj+4>>2]=c[bi+4>>2];c[bj+8>>2]=c[bi+8>>2];W=250}else{bj=c[f+8>>2]|0;a9=c[f+4>>2]|0;do{if(a9>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(a9>>>0<11>>>0){a[P]=a9<<1;bs=P+1|0}else{bk=a9+16&-16;r=(x=0,as(230,bk|0)|0);if(x){x=0;break}c[P+8>>2]=r;c[P>>2]=bk|1;c[P+4>>2]=a9;bs=r}Kb(bs|0,bj|0,a9)|0;a[bs+a9|0]=0;W=250;break L344}}while(0);a9=bQ(-1,-1)|0;bt=a9;bu=K}}while(0);do{if((W|0)==250){bi=Q;a9=g;c[bi>>2]=c[a9>>2];c[bi+4>>2]=c[a9+4>>2];c[bi+8>>2]=c[a9+8>>2];x=0;aT(42,N|0,P|0,Q|0,e|0);if(x){x=0;a9=bQ(-1,-1)|0;bi=a9;a9=K;if((a[P]&1)==0){bt=bi;bu=a9;break}J2(c[P+8>>2]|0);bt=bi;bu=a9;break}if((a[P]&1)!=0){J2(c[P+8>>2]|0)}if((a[b]&1)!=0){J2(c[N+8>>2]|0)}if((a[bo]&1)==0){af=0;i=j;return af|0}J2(c[O+8>>2]|0);af=0;i=j;return af|0}}while(0);if((a[b]&1)==0){bv=bt;bw=bu;break}J2(c[N+8>>2]|0);bv=bt;bw=bu}}while(0);if((W|0)==238){W=bQ(-1,-1)|0;bu=K;if((a[b]&1)!=0){J2(c[N+8>>2]|0)}bv=W;bw=bu}if((a[bo]&1)==0){ah=bv;ai=bw;aj=ah;ak=0;al=aj;am=ai;be(al|0)}J2(c[O+8>>2]|0);ah=bv;ai=bw;aj=ah;ak=0;al=aj;am=ai;be(al|0);break};default:{af=0;i=j;return af|0}}return 0}function hX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+56|0;f=e|0;g=e+8|0;h=e+16|0;j=e+32|0;k=e+40|0;l=c[d+36>>2]|0;m=b|0;n=cS[c[(c[l>>2]|0)+20>>2]&1023](l,m)|0;l=c[d+40>>2]|0;o=cS[c[(c[l>>2]|0)+20>>2]&1023](l,m)|0;l=c[b+4>>2]|0;b=J0(60)|0;c[j>>2]=b;p=l+4|0;q=c[p>>2]|0;if((q|0)==(c[l+8>>2]|0)){ee(l|0,j);r=c[j>>2]|0}else{if((q|0)==0){s=0}else{c[q>>2]=b;s=c[p>>2]|0}c[p>>2]=s+4;r=b}b=r;s=r;q=d+4|0;L8:do{if((a[q]&1)==0){j=k;c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];t=16}else{j=c[d+12>>2]|0;u=c[d+8>>2]|0;do{if(u>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(u>>>0<11>>>0){a[k]=u<<1;v=k+1|0}else{w=u+16&-16;y=(x=0,as(230,w|0)|0);if(x){x=0;break}c[k+8>>2]=y;c[k>>2]=w|1;c[k+4>>2]=u;v=y}Kb(v|0,j|0,u)|0;a[v+u|0]=0;t=16;break L8}}while(0);u=bQ(-1,-1)|0;z=K;A=u}}while(0);do{if((t|0)==16){v=d+16|0;q=h;c[q>>2]=c[v>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2];x=0;aB(2,s|0,k|0,h|0,2,0,0);if(x){x=0;v=bQ(-1,-1)|0;q=v;v=K;if((a[k]&1)==0){z=v;A=q;break}J2(c[k+8>>2]|0);z=v;A=q;break}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}q=r+40|0;v=q;c[g>>2]=n;u=q+8|0;j=c[u>>2]|0;y=j;w=q+12|0;if((j|0)==(c[w>>2]|0)){eq(q+4|0,g);B=c[g>>2]|0}else{if((j|0)==0){C=0}else{c[y>>2]=n;C=c[u>>2]|0}c[u>>2]=C+4;B=n}cy[c[c[q>>2]>>2]&1023](v,B);c[f>>2]=o;y=c[u>>2]|0;if((y|0)==(c[w>>2]|0)){eq(q+4|0,f);D=c[f>>2]|0;E=c[q>>2]|0;F=E;G=c[F>>2]|0;cy[G&1023](v,D);H=r;I=c[H>>2]|0;J=I+20|0;L=c[J>>2]|0;M=cS[L&1023](s,m)|0;i=e;return M|0}if((y|0)==0){N=0}else{c[y>>2]=o;N=c[u>>2]|0}c[u>>2]=N+4;D=o;E=c[q>>2]|0;F=E;G=c[F>>2]|0;cy[G&1023](v,D);H=r;I=c[H>>2]|0;J=I+20|0;L=c[J>>2]|0;M=cS[L&1023](s,m)|0;i=e;return M|0}}while(0);M=c[l>>2]|0;l=c[p>>2]|0;e=M;while(1){if((e|0)==(l|0)){O=l;break}if((c[e>>2]|0)==(r|0)){O=e;break}else{e=e+4|0}}e=O-M>>2;O=M+(e+1<<2)|0;r=l-O|0;Kc(M+(e<<2)|0,O|0,r|0)|0;O=M+((r>>2)+e<<2)|0;e=c[p>>2]|0;if((O|0)==(e|0)){J2(b);P=A;Q=0;R=P;S=z;be(R|0)}c[p>>2]=e+(~((e-4+(-O|0)|0)>>>2)<<2);J2(b);P=A;Q=0;R=P;S=z;be(R|0);return 0}function hY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=i;i=i+112|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=d+36|0;if((a[n]&1)==0){o=f;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];p=a[o]|0;q=o}else{o=c[d+44>>2]|0;r=c[d+40>>2]|0;if(r>>>0>4294967279>>>0){CJ(0);return 0}if(r>>>0<11>>>0){s=r<<1&255;t=f;a[t]=s;u=f+1|0;v=s;w=t}else{t=r+16&-16;s=J0(t)|0;c[f+8>>2]=s;y=t|1;c[f>>2]=y;c[f+4>>2]=r;u=s;v=y&255;w=f}Kb(u|0,o|0,r)|0;a[u+r|0]=0;p=v;q=w}w=b+8|0;b=c[w>>2]|0;do{if((p&1)==0){v=g;c[v>>2]=c[q>>2];c[v+4>>2]=c[q+4>>2];c[v+8>>2]=c[q+8>>2];z=19}else{v=c[f+8>>2]|0;r=c[f+4>>2]|0;if(r>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;z=36;break}return 0}if(r>>>0<11>>>0){a[g]=r<<1;A=g+1|0}else{u=r+16&-16;o=(x=0,as(230,u|0)|0);if(x){x=0;z=36;break}c[g+8>>2]=o;c[g>>2]=u|1;c[g+4>>2]=r;A=o}Kb(A|0,v|0,r)|0;a[A+r|0]=0;z=19}}while(0);L24:do{if((z|0)==19){A=(x=0,aK(556,b|0,g|0)|0);if(x){x=0;p=bQ(-1,-1)|0;r=p;p=K;if((a[g]&1)==0){B=p;C=r;break}J2(c[g+8>>2]|0);B=p;C=r;break}if((a[g]&1)!=0){J2(c[g+8>>2]|0)}L33:do{if(A){r=c[w>>2]|0;if((a[q]&1)==0){p=h;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2]}else{p=c[f+8>>2]|0;v=c[f+4>>2]|0;if(v>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;z=36;break L24}return 0}if(v>>>0<11>>>0){a[h]=v<<1;D=h+1|0}else{o=v+16&-16;u=(x=0,as(230,o|0)|0);if(x){x=0;z=36;break L24}c[h+8>>2]=u;c[h>>2]=o|1;c[h+4>>2]=v;D=u}Kb(D|0,p|0,v)|0;a[D+v|0]=0}v=(x=0,aK(88,r|0,h|0)|0);if(!x){r=c[v>>2]|0;if((a[h]&1)==0){E=r;break}J2(c[h+8>>2]|0);E=r;break}else{x=0;r=bQ(-1,-1)|0;v=r;r=K;if((a[h]&1)==0){B=r;C=v;break L24}J2(c[h+8>>2]|0);B=r;C=v;break L24}}else{if((a[n]&1)==0){v=k;c[v>>2]=c[n>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];F=a[v]|0;G=v}else{v=c[d+44>>2]|0;r=c[d+40>>2]|0;if(r>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;z=36;break L24}return 0}if(r>>>0<11>>>0){p=r<<1&255;u=k;a[u]=p;H=k+1|0;I=p;J=u}else{u=r+16&-16;p=(x=0,as(230,u|0)|0);if(x){x=0;z=36;break L24}c[k+8>>2]=p;o=u|1;c[k>>2]=o;c[k+4>>2]=r;H=p;I=o&255;J=k}Kb(H|0,v|0,r)|0;a[H+r|0]=0;F=I;G=J}r=j;Ke(r|0,0,12)|0;v=k;o=F&255;if((o&1|0)==0){L=o>>>1}else{L=c[k+4>>2]|0}o=L+17|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;z=65;break}return 0}else{if(o>>>0<11>>>0){a[r]=34;M=j+1|0}else{p=L+33&-16;u=(x=0,as(230,p|0)|0);if(x){x=0;z=65;break}c[j+8>>2]=u;c[j>>2]=p|1;c[j+4>>2]=17;M=u}Kb(M|0,10064,17)|0;a[M+17|0]=0;if((a[G]&1)==0){N=v+1|0}else{N=c[k+8>>2]|0}x=0,ax(64,j|0,N|0,L|0)|0;if(x){x=0;z=65;break}u=d+4|0;L85:do{if((a[u]&1)==0){p=l;c[p>>2]=c[u>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];z=77}else{p=c[d+12>>2]|0;y=c[d+8>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[l]=y<<1;O=l+1|0}else{s=y+16&-16;t=(x=0,as(230,s|0)|0);if(x){x=0;break}c[l+8>>2]=t;c[l>>2]=s|1;c[l+4>>2]=y;O=t}Kb(O|0,p|0,y)|0;a[O+y|0]=0;z=77;break L85}}while(0);y=bQ(-1,-1)|0;P=K;Q=y}}while(0);do{if((z|0)==77){u=m;y=d+16|0;c[u>>2]=c[y>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2];x=0;aP(362,j|0,l|0,m|0);if(x){x=0;y=bQ(-1,-1)|0;u=y;y=K;if((a[l]&1)==0){P=y;Q=u;break}J2(c[l+8>>2]|0);P=y;Q=u;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}if((a[r]&1)!=0){J2(c[j+8>>2]|0)}if((a[G]&1)==0){E=0;break L33}J2(c[k+8>>2]|0);E=0;break L33}}while(0);if((a[r]&1)==0){R=P;S=Q;break}J2(c[j+8>>2]|0);R=P;S=Q}}while(0);if((z|0)==65){v=bQ(-1,-1)|0;o=K;if((a[r]&1)!=0){J2(c[j+8>>2]|0)}R=o;S=v}if((a[G]&1)==0){B=R;C=S;break L24}J2(c[k+8>>2]|0);B=R;C=S;break L24}}while(0);if((a[q]&1)==0){i=e;return E|0}J2(c[f+8>>2]|0);i=e;return E|0}}while(0);if((z|0)==36){z=bQ(-1,-1)|0;B=K;C=z}if((a[q]&1)==0){T=C;U=0;V=T;W=B;be(V|0)}J2(c[f+8>>2]|0);T=C;U=0;V=T;W=B;be(V|0);return 0}function hZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0.0,ar=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aF=0,aG=0,aH=0,aI=0,aJ=0,aK=0,aL=0,aM=0,aN=0,aO=0,aP=0,aQ=0,aR=0,aS=0,aT=0,aU=0,aV=0,aW=0,aX=0,aY=0,aZ=0,a_=0,a$=0,a1=0,a2=0,a3=0,a4=0,a5=0,a6=0,a7=0,a8=0,a9=0,ba=0,bb=0,bc=0,bd=0,bf=0,bg=0,bh=0,bi=0,bj=0,bk=0,bl=0,bm=0,bn=0,bo=0,bp=0,bq=0,br=0,bs=0,bt=0,bu=0,bv=0,bw=0,bx=0,by=0,bz=0,bA=0,bB=0,bC=0,bD=0,bE=0,bF=0,bG=0,bH=0,bI=0.0,bJ=0,bK=0,bL=0,bM=0,bN=0,bO=0,bP=0,bR=0,bS=0,bT=0,bU=0,bV=0,bW=0,bX=0,bY=0,bZ=0,b_=0,b$=0,b0=0,b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0,b8=0;e=i;i=i+552|0;f=e|0;g=e+16|0;h=e+24|0;j=e+40|0;k=e+48|0;l=e+64|0;m=e+72|0;n=e+88|0;o=e+96|0;p=e+112|0;q=e+120|0;r=e+136|0;s=e+152|0;t=e+168|0;u=e+184|0;v=e+200|0;w=e+216|0;y=e+232|0;z=e+248|0;A=e+264|0;B=e+280|0;C=e+296|0;D=e+312|0;E=e+328|0;F=e+344|0;G=e+360|0;H=e+376|0;I=e+392|0;J=e+408|0;L=e+424|0;M=e+440|0;N=e+456|0;O=e+472|0;P=e+488|0;Q=e+504|0;R=e+520|0;S=e+536|0;T=c[d+36>>2]|0;if((T|0)==0){U=c[b+4>>2]|0;V=J0(72)|0;c[p>>2]=V;W=U+4|0;X=c[W>>2]|0;if((X|0)==(c[U+8>>2]|0)){ee(U|0,p);Y=c[p>>2]|0}else{if((X|0)==0){Z=0}else{c[X>>2]=V;Z=c[W>>2]|0}c[W>>2]=Z+4;Y=V}V=Y;Z=Y;X=d+4|0;L10:do{if((a[X]&1)==0){p=q;c[p>>2]=c[X>>2];c[p+4>>2]=c[X+4>>2];c[p+8>>2]=c[X+8>>2];_=17}else{p=c[d+12>>2]|0;$=c[d+8>>2]|0;do{if($>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if($>>>0<11>>>0){a[q]=$<<1;aa=q+1|0}else{ab=$+16&-16;ac=(x=0,as(230,ab|0)|0);if(x){x=0;break}c[q+8>>2]=ac;c[q>>2]=ab|1;c[q+4>>2]=$;aa=ac}Kb(aa|0,p|0,$)|0;a[aa+$|0]=0;_=17;break L10}}while(0);$=bQ(-1,-1)|0;ad=K;ae=$}}while(0);do{if((_|0)==17){aa=r;X=d+16|0;c[aa>>2]=c[X>>2];c[aa+4>>2]=c[X+4>>2];c[aa+8>>2]=c[X+8>>2];X=d+40|0;L25:do{if((a[X]&1)==0){$=s;c[$>>2]=c[X>>2];c[$+4>>2]=c[X+4>>2];c[$+8>>2]=c[X+8>>2];af=a[$]|0;ag=$;_=27}else{$=c[d+48>>2]|0;p=c[d+44>>2]|0;do{if(p>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(p>>>0<11>>>0){ac=p<<1&255;ab=s;a[ab]=ac;ah=s+1|0;ai=ac;aj=ab}else{ab=p+16&-16;ac=(x=0,as(230,ab|0)|0);if(x){x=0;break}c[s+8>>2]=ac;ak=ab|1;c[s>>2]=ak;c[s+4>>2]=p;ah=ac;ai=ak&255;aj=s}Kb(ah|0,$|0,p)|0;a[ah+p|0]=0;af=ai;ag=aj;_=27;break L25}}while(0);p=bQ(-1,-1)|0;al=K;am=p}}while(0);do{if((_|0)==27){if((af&1)==0){an=s+1|0}else{an=c[s+8>>2]|0}ao=+Ka(an);X=t;a[X]=0;a[t+1|0]=0;p=o;c[p>>2]=c[aa>>2];c[p+4>>2]=c[aa+4>>2];c[p+8>>2]=c[aa+8>>2];x=0;aE(2,Z|0,q|0,o|0,+ao,t|0);if(x){x=0;p=bQ(-1,-1)|0;$=p;p=K;if((a[X]&1)!=0){J2(c[t+8>>2]|0)}if((a[ag]&1)==0){al=p;am=$;break}J2(c[s+8>>2]|0);al=p;am=$;break}$=Y;if((a[X]&1)!=0){J2(c[t+8>>2]|0)}if((a[ag]&1)!=0){J2(c[s+8>>2]|0)}if((a[q]&1)==0){ar=$;i=e;return ar|0}J2(c[q+8>>2]|0);ar=$;i=e;return ar|0}}while(0);if((a[q]&1)==0){ad=al;ae=am;break}J2(c[q+8>>2]|0);ad=al;ae=am}}while(0);am=c[U>>2]|0;U=c[W>>2]|0;al=am;while(1){if((al|0)==(U|0)){au=U;break}if((c[al>>2]|0)==(Y|0)){au=al;break}else{al=al+4|0}}al=au-am>>2;au=am+(al+1<<2)|0;Y=U-au|0;Kc(am+(al<<2)|0,au|0,Y|0)|0;au=am+((Y>>2)+al<<2)|0;al=c[W>>2]|0;if((au|0)!=(al|0)){c[W>>2]=al+(~((al-4+(-au|0)|0)>>>2)<<2)}J2(V);av=ad;aw=ae;ax=aw;ay=0;az=ax;aA=av;be(az|0)}else if((T|0)==1){ae=c[b+4>>2]|0;ad=J0(72)|0;c[n>>2]=ad;V=ae+4|0;au=c[V>>2]|0;if((au|0)==(c[ae+8>>2]|0)){ee(ae|0,n);aB=c[n>>2]|0}else{if((au|0)==0){aC=0}else{c[au>>2]=ad;aC=c[V>>2]|0}c[V>>2]=aC+4;aB=ad}ad=aB;aC=aB;au=d+4|0;L81:do{if((a[au]&1)==0){n=u;c[n>>2]=c[au>>2];c[n+4>>2]=c[au+4>>2];c[n+8>>2]=c[au+8>>2];_=66}else{n=c[d+12>>2]|0;al=c[d+8>>2]|0;do{if(al>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(al>>>0<11>>>0){a[u]=al<<1;aD=u+1|0}else{W=al+16&-16;Y=(x=0,as(230,W|0)|0);if(x){x=0;break}c[u+8>>2]=Y;c[u>>2]=W|1;c[u+4>>2]=al;aD=Y}Kb(aD|0,n|0,al)|0;a[aD+al|0]=0;_=66;break L81}}while(0);al=bQ(-1,-1)|0;aF=K;aG=al}}while(0);do{if((_|0)==66){aD=v;au=d+16|0;c[aD>>2]=c[au>>2];c[aD+4>>2]=c[au+4>>2];c[aD+8>>2]=c[au+8>>2];au=d+40|0;L96:do{if((a[au]&1)==0){al=w;c[al>>2]=c[au>>2];c[al+4>>2]=c[au+4>>2];c[al+8>>2]=c[au+8>>2];aH=a[al]|0;aI=al;_=76}else{al=c[d+48>>2]|0;n=c[d+44>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(n>>>0<11>>>0){Y=n<<1&255;W=w;a[W]=Y;aJ=w+1|0;aK=Y;aL=W}else{W=n+16&-16;Y=(x=0,as(230,W|0)|0);if(x){x=0;break}c[w+8>>2]=Y;am=W|1;c[w>>2]=am;c[w+4>>2]=n;aJ=Y;aK=am&255;aL=w}Kb(aJ|0,al|0,n)|0;a[aJ+n|0]=0;aH=aK;aI=aL;_=76;break L96}}while(0);n=bQ(-1,-1)|0;aM=K;aN=n}}while(0);do{if((_|0)==76){if((aH&1)==0){aO=w+1|0}else{aO=c[w+8>>2]|0}ao=+Ka(aO);au=y;n=y;a[n]=2;a[au+1|0]=37;a[au+2|0]=0;au=m;c[au>>2]=c[aD>>2];c[au+4>>2]=c[aD+4>>2];c[au+8>>2]=c[aD+8>>2];x=0;aE(2,aC|0,u|0,m|0,+ao,y|0);if(x){x=0;au=bQ(-1,-1)|0;al=au;au=K;if((a[n]&1)!=0){J2(c[y+8>>2]|0)}if((a[aI]&1)==0){aM=au;aN=al;break}J2(c[w+8>>2]|0);aM=au;aN=al;break}al=aB;if((a[n]&1)!=0){J2(c[y+8>>2]|0)}if((a[aI]&1)!=0){J2(c[w+8>>2]|0)}if((a[u]&1)==0){ar=al;i=e;return ar|0}J2(c[u+8>>2]|0);ar=al;i=e;return ar|0}}while(0);if((a[u]&1)==0){aF=aM;aG=aN;break}J2(c[u+8>>2]|0);aF=aM;aG=aN}}while(0);aN=c[ae>>2]|0;ae=c[V>>2]|0;aM=aN;while(1){if((aM|0)==(ae|0)){aP=ae;break}if((c[aM>>2]|0)==(aB|0)){aP=aM;break}else{aM=aM+4|0}}aM=aP-aN>>2;aP=aN+(aM+1<<2)|0;aB=ae-aP|0;Kc(aN+(aM<<2)|0,aP|0,aB|0)|0;aP=aN+((aB>>2)+aM<<2)|0;aM=c[V>>2]|0;if((aP|0)!=(aM|0)){c[V>>2]=aM+(~((aM-4+(-aP|0)|0)>>>2)<<2)}J2(ad);av=aF;aw=aG;ax=aw;ay=0;az=ax;aA=av;be(az|0)}else if((T|0)==2){aG=c[b+4>>2]|0;aF=J0(72)|0;c[l>>2]=aF;ad=aG+4|0;aP=c[ad>>2]|0;if((aP|0)==(c[aG+8>>2]|0)){ee(aG|0,l);aQ=c[l>>2]|0}else{if((aP|0)==0){aR=0}else{c[aP>>2]=aF;aR=c[ad>>2]|0}c[ad>>2]=aR+4;aQ=aF}aF=aQ;aR=aQ;aP=d+4|0;L151:do{if((a[aP]&1)==0){l=z;c[l>>2]=c[aP>>2];c[l+4>>2]=c[aP+4>>2];c[l+8>>2]=c[aP+8>>2];_=115}else{l=c[d+12>>2]|0;aM=c[d+8>>2]|0;do{if(aM>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aM>>>0<11>>>0){a[z]=aM<<1;aS=z+1|0}else{V=aM+16&-16;aB=(x=0,as(230,V|0)|0);if(x){x=0;break}c[z+8>>2]=aB;c[z>>2]=V|1;c[z+4>>2]=aM;aS=aB}Kb(aS|0,l|0,aM)|0;a[aS+aM|0]=0;_=115;break L151}}while(0);aM=bQ(-1,-1)|0;aT=K;aU=aM}}while(0);do{if((_|0)==115){aS=A;aP=d+16|0;c[aS>>2]=c[aP>>2];c[aS+4>>2]=c[aP+4>>2];c[aS+8>>2]=c[aP+8>>2];aP=d+40|0;aM=(a[aP]&1)==0;L166:do{if(aM){l=B;c[l>>2]=c[aP>>2];c[l+4>>2]=c[aP+4>>2];c[l+8>>2]=c[aP+8>>2];aV=a[l]|0;aW=l;_=125}else{l=c[d+48>>2]|0;aB=c[d+44>>2]|0;do{if(aB>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aB>>>0<11>>>0){V=aB<<1&255;aN=B;a[aN]=V;aX=B+1|0;aY=V;aZ=aN}else{aN=aB+16&-16;V=(x=0,as(230,aN|0)|0);if(x){x=0;break}c[B+8>>2]=V;ae=aN|1;c[B>>2]=ae;c[B+4>>2]=aB;aX=V;aY=ae&255;aZ=B}Kb(aX|0,l|0,aB)|0;a[aX+aB|0]=0;aV=aY;aW=aZ;_=125;break L166}}while(0);aB=bQ(-1,-1)|0;a_=K;a$=aB}}while(0);do{if((_|0)==125){if((aV&1)==0){a1=B+1|0}else{a1=c[B+8>>2]|0}ao=+Ka(a1);L185:do{if(aM){aB=D;c[aB>>2]=c[aP>>2];c[aB+4>>2]=c[aP+4>>2];c[aB+8>>2]=c[aP+8>>2];a2=a[aB]|0;a3=aB;_=138}else{aB=c[d+48>>2]|0;l=c[d+44>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(l>>>0<11>>>0){ae=l<<1&255;V=D;a[V]=ae;a4=D+1|0;a5=ae;a6=V}else{V=l+16&-16;ae=(x=0,as(230,V|0)|0);if(x){x=0;break}c[D+8>>2]=ae;aN=V|1;c[D>>2]=aN;c[D+4>>2]=l;a4=ae;a5=aN&255;a6=D}Kb(a4|0,aB|0,l)|0;a[a4+l|0]=0;a2=a5;a3=a6;_=138;break L185}}while(0);l=bQ(-1,-1)|0;a7=K;a8=l}}while(0);do{if((_|0)==138){if((a2&1)==0){a9=D+1|0}else{a9=c[D+8>>2]|0}l=(x=0,as(266,a9|0)|0);do{if(!x){aB=Kf(l|0)|0;if(aB>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;_=161;break}return 0}if(aB>>>0<11>>>0){a[C]=aB<<1;ba=C+1|0}else{aN=aB+16&-16;ae=(x=0,as(230,aN|0)|0);if(x){x=0;_=161;break}c[C+8>>2]=ae;c[C>>2]=aN|1;c[C+4>>2]=aB;ba=ae}Kb(ba|0,l|0,aB)|0;a[ba+aB|0]=0;aB=k;c[aB>>2]=c[aS>>2];c[aB+4>>2]=c[aS+4>>2];c[aB+8>>2]=c[aS+8>>2];x=0;aE(2,aR|0,z|0,k|0,+ao,C|0);if(x){x=0;aB=bQ(-1,-1)|0;ae=aB;aB=K;if((a[C]&1)==0){bb=aB;bc=ae;break}J2(c[C+8>>2]|0);bb=aB;bc=ae;break}ae=aQ;if((a[C]&1)!=0){J2(c[C+8>>2]|0)}if((a[a3]&1)!=0){J2(c[D+8>>2]|0)}if((a[aW]&1)!=0){J2(c[B+8>>2]|0)}if((a[z]&1)==0){ar=ae;i=e;return ar|0}J2(c[z+8>>2]|0);ar=ae;i=e;return ar|0}else{x=0;_=161}}while(0);if((_|0)==161){l=bQ(-1,-1)|0;bb=K;bc=l}if((a[a3]&1)==0){a7=bb;a8=bc;break}J2(c[D+8>>2]|0);a7=bb;a8=bc}}while(0);if((a[aW]&1)==0){a_=a7;a$=a8;break}J2(c[B+8>>2]|0);a_=a7;a$=a8}}while(0);if((a[z]&1)==0){aT=a_;aU=a$;break}J2(c[z+8>>2]|0);aT=a_;aU=a$}}while(0);a$=c[aG>>2]|0;aG=c[ad>>2]|0;a_=a$;while(1){if((a_|0)==(aG|0)){bd=aG;break}if((c[a_>>2]|0)==(aQ|0)){bd=a_;break}else{a_=a_+4|0}}a_=bd-a$>>2;bd=a$+(a_+1<<2)|0;aQ=aG-bd|0;Kc(a$+(a_<<2)|0,bd|0,aQ|0)|0;bd=a$+((aQ>>2)+a_<<2)|0;a_=c[ad>>2]|0;if((bd|0)!=(a_|0)){c[ad>>2]=a_+(~((a_-4+(-bd|0)|0)>>>2)<<2)}J2(aF);av=aT;aw=aU;ax=aw;ay=0;az=ax;aA=av;be(az|0)}else if((T|0)==3){T=d+40|0;if((a[T]&1)==0){aU=F;c[aU>>2]=c[T>>2];c[aU+4>>2]=c[T+4>>2];c[aU+8>>2]=c[T+8>>2];bf=a[aU]|0;bg=aU}else{aU=c[d+48>>2]|0;aT=c[d+44>>2]|0;if(aT>>>0>4294967279>>>0){CJ(0);return 0}if(aT>>>0<11>>>0){aF=aT<<1&255;bd=F;a[bd]=aF;bh=F+1|0;bi=aF;bj=bd}else{bd=aT+16&-16;aF=J0(bd)|0;c[F+8>>2]=aF;a_=bd|1;c[F>>2]=a_;c[F+4>>2]=aT;bh=aF;bi=a_&255;bj=F}Kb(bh|0,aU|0,aT)|0;a[bh+aT|0]=0;bf=bi;bg=bj}bj=F;bi=bf&255;if((bi&1|0)==0){bk=bi>>>1}else{bk=c[F+4>>2]|0}do{if((bk|0)==0){x=0;ap(238,0);if(x){x=0;break}return 0}else{if((bf&1)==0){bl=bj+1|0}else{bl=c[F+8>>2]|0}bi=bl+1|0;aT=bk-1|0;if(aT>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(aT>>>0<11>>>0){bh=aT<<1&255;a[E]=bh;bm=E+1|0;bn=bh}else{bh=bk+15&-16;aU=(x=0,as(230,bh|0)|0);if(x){x=0;break}c[E+8>>2]=aU;a_=bh|1;c[E>>2]=a_;c[E+4>>2]=aT;bm=aU;bn=a_&255}Kb(bm|0,bi|0,aT)|0;a[bm+aT|0]=0;if((a[bg]&1)!=0){J2(c[F+8>>2]|0)}aT=E;bi=bn&255;if((bi&1|0)==0){bo=bi>>>1}else{bo=c[E+4>>2]|0}L289:do{if((bo|0)==6){bi=bn&255;if((bi&1|0)==0){bp=bi>>>1}else{bp=c[E+4>>2]|0}if((bn&1)==0){bq=aT+1|0}else{bq=c[E+8>>2]|0}bi=bp>>>0<2>>>0?bp:2;if(bi>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;_=300;break}return 0}if(bi>>>0<11>>>0){a_=bi<<1&255;a[G]=a_;br=G+1|0;bs=a_}else{a_=bi+16&-16;aU=(x=0,as(230,a_|0)|0);if(x){x=0;_=300;break}c[G+8>>2]=aU;bh=a_|1;c[G>>2]=bh;c[G+4>>2]=bi;br=aU;bs=bh&255}Kb(br|0,bq|0,bi)|0;a[br+bi|0]=0;bi=bn&255;if((bi&1|0)==0){bt=bi>>>1}else{bt=c[E+4>>2]|0}do{if(bt>>>0<2>>>0){x=0;ap(238,0);if(x){x=0;_=301;break}return 0}else{if((bn&1)==0){bu=aT+1|0}else{bu=c[E+8>>2]|0}bi=bu+2|0;bh=bt-2|0;aU=bh>>>0<2>>>0?bh:2;if(aU>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;_=301;break}return 0}if(aU>>>0<11>>>0){bh=aU<<1&255;a[H]=bh;bv=H+1|0;bw=bh}else{bh=aU+16&-16;a_=(x=0,as(230,bh|0)|0);if(x){x=0;_=301;break}c[H+8>>2]=a_;aF=bh|1;c[H>>2]=aF;c[H+4>>2]=aU;bv=a_;bw=aF&255}Kb(bv|0,bi|0,aU)|0;a[bv+aU|0]=0;aU=bn&255;if((aU&1|0)==0){bx=aU>>>1}else{bx=c[E+4>>2]|0}do{if(bx>>>0<4>>>0){x=0;ap(238,0);if(x){x=0;_=302;break}return 0}else{if((bn&1)==0){by=aT+1|0}else{by=c[E+8>>2]|0}aU=by+4|0;bi=bx-4|0;aF=bi>>>0<2>>>0?bi:2;if(aF>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;_=302;break}return 0}if(aF>>>0<11>>>0){bi=aF<<1&255;a[I]=bi;bz=I+1|0;bA=bi}else{bi=aF+16&-16;a_=(x=0,as(230,bi|0)|0);if(x){x=0;_=302;break}c[I+8>>2]=a_;bh=bi|1;c[I>>2]=bh;c[I+4>>2]=aF;bz=a_;bA=bh&255}Kb(bz|0,aU|0,aF)|0;a[bz+aF|0]=0;aF=c[b+4>>2]|0;aU=(x=0,as(230,88)|0);do{if(!x){bh=aU;c[j>>2]=bh;a_=aF+4|0;bi=c[a_>>2]|0;if((bi|0)==(c[aF+8>>2]|0)){x=0;aq(376,aF|0,j|0);if(x){x=0;_=303;break}bB=c[j>>2]|0}else{if((bi|0)==0){bC=0}else{c[bi>>2]=bh;bC=c[a_>>2]|0}c[a_>>2]=bC+4;bB=bh}bh=bB;bi=bB;bd=d+4|0;L360:do{if((a[bd]&1)==0){ad=J;c[ad>>2]=c[bd>>2];c[ad+4>>2]=c[bd+4>>2];c[ad+8>>2]=c[bd+8>>2];_=268}else{ad=c[d+12>>2]|0;aQ=c[d+8>>2]|0;do{if(aQ>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(aQ>>>0<11>>>0){a[J]=aQ<<1;bD=J+1|0}else{a$=aQ+16&-16;aG=(x=0,as(230,a$|0)|0);if(x){x=0;break}c[J+8>>2]=aG;c[J>>2]=a$|1;c[J+4>>2]=aQ;bD=aG}Kb(bD|0,ad|0,aQ)|0;a[bD+aQ|0]=0;_=268;break L360}}while(0);aQ=bQ(-1,-1)|0;bE=K;bF=aQ}}while(0);do{if((_|0)==268){bd=L;aQ=d+16|0;c[bd>>2]=c[aQ>>2];c[bd+4>>2]=c[aQ+4>>2];c[bd+8>>2]=c[aQ+8>>2];aQ=G;if((bs&1)==0){bG=G+1|0}else{bG=c[G+8>>2]|0}ao=+(a0(bG|0,0,16)|0);ad=H;if((bw&1)==0){bH=H+1|0}else{bH=c[H+8>>2]|0}bI=+(a0(bH|0,0,16)|0);aG=I;if((bA&1)==0){bJ=I+1|0}else{bJ=c[I+8>>2]|0}a$=a0(bJ|0,0,16)|0;L387:do{if((a[T]&1)==0){z=M;c[z>>2]=c[T>>2];c[z+4>>2]=c[T+4>>2];c[z+8>>2]=c[T+8>>2];_=287}else{z=c[d+48>>2]|0;a8=c[d+44>>2]|0;do{if(a8>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(a8>>>0<11>>>0){a[M]=a8<<1;bK=M+1|0}else{a7=a8+16&-16;B=(x=0,as(230,a7|0)|0);if(x){x=0;break}c[M+8>>2]=B;c[M>>2]=a7|1;c[M+4>>2]=a8;bK=B}Kb(bK|0,z|0,a8)|0;a[bK+a8|0]=0;_=287;break L387}}while(0);a8=bQ(-1,-1)|0;bL=K;bM=a8}}while(0);do{if((_|0)==287){a8=h;c[a8>>2]=c[bd>>2];c[a8+4>>2]=c[bd+4>>2];c[a8+8>>2]=c[bd+8>>2];x=0;at(2,bi|0,J|0,h|0,+ao,+bI,+(+(a$|0)),+1.0,M|0);if(x){x=0;a8=bQ(-1,-1)|0;z=a8;a8=K;if((a[M]&1)==0){bL=a8;bM=z;break}J2(c[M+8>>2]|0);bL=a8;bM=z;break}if((a[M]&1)!=0){J2(c[M+8>>2]|0)}if((a[J]&1)!=0){J2(c[J+8>>2]|0)}if((a[aG]&1)!=0){J2(c[I+8>>2]|0)}if((a[ad]&1)!=0){J2(c[H+8>>2]|0)}if((a[aQ]&1)==0){bN=bh;_=387;break L289}J2(c[G+8>>2]|0);bN=bh;_=387;break L289}}while(0);if((a[J]&1)==0){bE=bL;bF=bM;break}J2(c[J+8>>2]|0);bE=bL;bF=bM}}while(0);bi=c[aF>>2]|0;aQ=c[a_>>2]|0;ad=bi;while(1){if((ad|0)==(aQ|0)){bO=aQ;break}if((c[ad>>2]|0)==(bB|0)){bO=ad;break}else{ad=ad+4|0}}ad=bO-bi>>2;aG=bi+(ad+1<<2)|0;a$=aQ-aG|0;Kc(bi+(ad<<2)|0,aG|0,a$|0)|0;aG=bi+((a$>>2)+ad<<2)|0;ad=c[a_>>2]|0;if((aG|0)!=(ad|0)){c[a_>>2]=ad+(~((ad-4+(-aG|0)|0)>>>2)<<2)}J2(bh);bP=bE;bR=bF;bS=a[I]|0}else{x=0;_=303}}while(0);if((_|0)==303){aF=bQ(-1,-1)|0;bP=K;bR=aF;bS=bA}if((bS&1)==0){bT=bP;bU=bR;break}J2(c[I+8>>2]|0);bT=bP;bU=bR}}while(0);if((_|0)==302){aF=bQ(-1,-1)|0;bT=K;bU=aF}if((a[H]&1)==0){bV=bT;bW=bU;break}J2(c[H+8>>2]|0);bV=bT;bW=bU}}while(0);if((_|0)==301){aF=bQ(-1,-1)|0;bV=K;bW=aF}if((a[G]&1)==0){bX=bV;bY=bW;break}J2(c[G+8>>2]|0);bX=bV;bY=bW}else{aF=c[b+4>>2]|0;aU=(x=0,as(230,88)|0);if(x){x=0;_=300;break}aG=aU;c[g>>2]=aG;aU=aF+4|0;ad=c[aU>>2]|0;if((ad|0)==(c[aF+8>>2]|0)){x=0;aq(376,aF|0,g|0);if(x){x=0;_=300;break}bZ=c[g>>2]|0}else{if((ad|0)==0){b_=0}else{c[ad>>2]=aG;b_=c[aU>>2]|0}c[aU>>2]=b_+4;bZ=aG}aG=bZ;ad=bZ;a$=d+4|0;L451:do{if((a[a$]&1)==0){bd=N;c[bd>>2]=c[a$>>2];c[bd+4>>2]=c[a$+4>>2];c[bd+8>>2]=c[a$+8>>2];_=339}else{bd=c[d+12>>2]|0;z=c[d+8>>2]|0;do{if(z>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(z>>>0<11>>>0){a[N]=z<<1;b$=N+1|0}else{a8=z+16&-16;B=(x=0,as(230,a8|0)|0);if(x){x=0;break}c[N+8>>2]=B;c[N>>2]=a8|1;c[N+4>>2]=z;b$=B}Kb(b$|0,bd|0,z)|0;a[b$+z|0]=0;_=339;break L451}}while(0);z=bQ(-1,-1)|0;b0=K;b1=z}}while(0);do{if((_|0)==339){a$=O;z=d+16|0;c[a$>>2]=c[z>>2];c[a$+4>>2]=c[z+4>>2];c[a$+8>>2]=c[z+8>>2];if((bn&1)==0){b2=aT+1|0}else{b2=c[E+8>>2]|0}z=a[b2]|0;bd=P;B=P;a[B]=4;a8=bd+1|0;Ke(a8|0,z|0,2)|0;a[bd+3|0]=0;bI=+(a0(a8|0,0,16)|0);if((bn&1)==0){b3=aT+1|0}else{b3=c[E+8>>2]|0}a8=a[b3+1|0]|0;bd=Q;z=Q;a[z]=4;a7=bd+1|0;Ke(a7|0,a8|0,2)|0;a[bd+3|0]=0;ao=+(a0(a7|0,0,16)|0);if((bn&1)==0){b4=aT+1|0}else{b4=c[E+8>>2]|0}a7=a[b4+2|0]|0;bd=R;a8=R;a[a8]=4;aW=bd+1|0;Ke(aW|0,a7|0,2)|0;a[bd+3|0]=0;bd=a0(aW|0,0,16)|0;L478:do{if((a[T]&1)==0){aW=S;c[aW>>2]=c[T>>2];c[aW+4>>2]=c[T+4>>2];c[aW+8>>2]=c[T+8>>2];_=358}else{aW=c[d+48>>2]|0;a7=c[d+44>>2]|0;do{if(a7>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(a7>>>0<11>>>0){a[S]=a7<<1;b5=S+1|0}else{bc=a7+16&-16;bb=(x=0,as(230,bc|0)|0);if(x){x=0;break}c[S+8>>2]=bb;c[S>>2]=bc|1;c[S+4>>2]=a7;b5=bb}Kb(b5|0,aW|0,a7)|0;a[b5+a7|0]=0;_=358;break L478}}while(0);a7=bQ(-1,-1)|0;b6=K;b7=a7}}while(0);do{if((_|0)==358){a7=f;c[a7>>2]=c[a$>>2];c[a7+4>>2]=c[a$+4>>2];c[a7+8>>2]=c[a$+8>>2];x=0;at(2,ad|0,N|0,f|0,+bI,+ao,+(+(bd|0)),+1.0,S|0);if(x){x=0;a7=bQ(-1,-1)|0;aW=a7;a7=K;if((a[S]&1)==0){b6=a7;b7=aW;break}J2(c[S+8>>2]|0);b6=a7;b7=aW;break}if((a[S]&1)!=0){J2(c[S+8>>2]|0)}if((a[a8]&1)!=0){J2(c[R+8>>2]|0)}if((a[z]&1)!=0){J2(c[Q+8>>2]|0)}if((a[B]&1)!=0){J2(c[P+8>>2]|0)}if((a[N]&1)==0){bN=aG;_=387;break L289}J2(c[N+8>>2]|0);bN=aG;_=387;break L289}}while(0);if((a[a8]&1)!=0){J2(c[R+8>>2]|0)}if((a[z]&1)!=0){J2(c[Q+8>>2]|0)}if((a[B]&1)!=0){J2(c[P+8>>2]|0)}if((a[N]&1)==0){b0=b6;b1=b7;break}J2(c[N+8>>2]|0);b0=b6;b1=b7}}while(0);ad=c[aF>>2]|0;bd=c[aU>>2]|0;a$=ad;while(1){if((a$|0)==(bd|0)){b8=bd;break}if((c[a$>>2]|0)==(bZ|0)){b8=a$;break}else{a$=a$+4|0}}a$=b8-ad>>2;aF=ad+(a$+1<<2)|0;aW=bd-aF|0;Kc(ad+(a$<<2)|0,aF|0,aW|0)|0;aF=ad+((aW>>2)+a$<<2)|0;a$=c[aU>>2]|0;if((aF|0)!=(a$|0)){c[aU>>2]=a$+(~((a$-4+(-aF|0)|0)>>>2)<<2)}J2(aG);bX=b0;bY=b1}}while(0);if((_|0)==300){aT=bQ(-1,-1)|0;bX=K;bY=aT}else if((_|0)==387){aT=bN;if((bn&1)==0){ar=aT;i=e;return ar|0}J2(c[E+8>>2]|0);ar=aT;i=e;return ar|0}if((bn&1)==0){av=bX;aw=bY;ax=aw;ay=0;az=ax;aA=av;be(az|0)}J2(c[E+8>>2]|0);av=bX;aw=bY;ax=aw;ay=0;az=ax;aA=av;be(az|0)}}while(0);bY=bQ(-1,-1)|0;bX=bY;bY=K;if((a[bg]&1)==0){av=bY;aw=bX;ax=aw;ay=0;az=ax;aA=av;be(az|0)}J2(c[F+8>>2]|0);av=bY;aw=bX;ax=aw;ay=0;az=ax;aA=av;be(az|0)}else{ar=0;i=e;return ar|0}return 0}function h_(a,b){a=a|0;b=b|0;return b|0}function h$(a,b){a=a|0;b=b|0;return b|0}function h0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ar=0,at=0,au=0,av=0,aw=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0;e=i;i=i+40|0;f=e|0;g=e+16|0;h=e+24|0;j=h;k=i;i=i+8|0;l=i;i=i+12|0;i=i+7&-8;m=i;i=i+12|0;i=i+7&-8;n=i;i=i+12|0;i=i+7&-8;o=i;i=i+12|0;i=i+7&-8;p=i;i=i+12|0;i=i+7&-8;q=i;i=i+12|0;i=i+7&-8;Ke(j|0,0,12)|0;x=0;aq(276,k|0,0);L1:do{if(!x){r=d+44|0;s=c[r>>2]|0;t=(c[d+48>>2]|0)-s>>2;L3:do{if((t|0)==0){u=47}else{v=b|0;w=k|0;y=d+56|0;z=m;A=m+8|0;B=n;C=n+1|0;D=n+8|0;E=n+4|0;F=l;G=l+8|0;H=l+1|0;I=l+4|0;J=m+1|0;L=m+4|0;M=m|0;N=0;O=0;P=s;L5:while(1){Q=c[P+(N<<2)>>2]|0;R=(x=0,aK(c[(c[Q>>2]|0)+20>>2]|0,Q|0,v|0)|0);if(x){x=0;u=32;break}x=0;aP(c[(c[R>>2]|0)+28>>2]|0,l|0,R|0,w|0);if(x){x=0;u=32;break}do{if((a[y]|0)==0){S=0;T=O;u=23}else{if((a[F]&1)==0){c[z>>2]=c[F>>2];c[z+4>>2]=c[F+4>>2];c[z+8>>2]=c[F+8>>2];U=a[z]|0}else{R=c[G>>2]|0;Q=c[I>>2]|0;if(Q>>>0>4294967279>>>0){u=10;break L5}if(Q>>>0<11>>>0){V=Q<<1&255;a[z]=V;W=J;X=V}else{V=Q+16&-16;Y=(x=0,as(230,V|0)|0);if(x){x=0;u=35;break L5}c[A>>2]=Y;Z=V|1;c[M>>2]=Z;c[L>>2]=Q;W=Y;X=Z&255}Kb(W|0,R|0,Q)|0;a[W+Q|0]=0;U=X}Q=U&255;R=(Q&1|0)==0?Q>>>1:c[L>>2]|0;if(R>>>0<2>>>0){_=0;$=U;u=24;break}Q=(U&1)==0;if((a[Q?J:c[A>>2]|0]|0)==34){if((a[(Q?J:c[A>>2]|0)+(R-1)|0]|0)!=34){u=20}}else{u=20}if((u|0)==20){u=0;if((a[Q?J:c[A>>2]|0]|0)!=39){_=0;$=U;u=24;break}if((a[(Q?J:c[A>>2]|0)+(R-1)|0]|0)!=39){_=0;$=U;u=24;break}}if((a[Q?J:c[A>>2]|0]|0)==0){_=0;$=U;u=24}else{S=1;T=U;u=23}}}while(0);if((u|0)==23){u=0;Q=(a[(c[(c[r>>2]|0)+(N<<2)>>2]|0)+29|0]&1)!=0;if(S){_=Q;$=T;u=24}else{aa=Q;ab=T;u=26}}do{if((u|0)==24){u=0;if(($&1)==0){aa=_;ab=$;u=26;break}J2(c[A>>2]|0);if(_){ac=$;u=27}else{ad=$;u=40}}}while(0);if((u|0)==26){u=0;if(aa){ac=ab;u=27}else{ad=ab;u=40}}do{if((u|0)==27){u=0;x=0;aq(180,n|0,l|0);if(x){x=0;u=35;break L5}Q=a[B]|0;R=(Q&1)==0?C:c[D>>2]|0;Z=Q&255;Q=(Z&1|0)==0?Z>>>1:c[E>>2]|0;x=0,ax(64,h|0,R|0,Q|0)|0;if(x){x=0;u=38;break L5}if((a[B]&1)==0){ae=ac;break}J2(c[D>>2]|0);ae=ac}else if((u|0)==40){u=0;Q=a[F]|0;R=Q&255;x=0,ax(64,h|0,((Q&1)==0?H:c[G>>2]|0)|0,((R&1|0)==0?R>>>1:c[I>>2]|0)|0)|0;if(!x){ae=ad}else{x=0;u=35;break L5}}}while(0);if((a[F]&1)!=0){J2(c[G>>2]|0)}R=N+1|0;if(R>>>0>=t>>>0){u=47;break L3}N=R;O=ae;P=c[r>>2]|0}do{if((u|0)==10){x=0;ap(232,0);if(!x){return 0}else{x=0;P=bQ(-1,-1)|0;af=K;ag=P;u=37;break}}else if((u|0)==32){P=bQ(-1,-1)|0;ah=K;ai=P;u=34;break L3}else if((u|0)==35){P=bQ(-1,-1)|0;af=K;ag=P;u=37}else if((u|0)==38){P=bQ(-1,-1)|0;O=P;P=K;if((a[B]&1)==0){aj=O;ak=P;break}J2(c[D>>2]|0);aj=O;ak=P}}while(0);if((u|0)==37){aj=ag;ak=af}if((a[F]&1)==0){al=aj;am=ak;break}J2(c[G>>2]|0);al=aj;am=ak}}while(0);L59:do{if((u|0)==47){r=c[b+4>>2]|0;t=(x=0,as(230,52)|0);do{if(!x){s=t;c[g>>2]=s;D=r+4|0;B=c[D>>2]|0;if((B|0)==(c[r+8>>2]|0)){x=0;aq(376,r|0,g|0);if(x){x=0;break}an=c[g>>2]|0}else{if((B|0)==0){ar=0}else{c[B>>2]=s;ar=c[D>>2]|0}c[D>>2]=ar+4;an=s}s=an;B=an;P=d+4|0;L71:do{if((a[P]&1)==0){O=o;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];u=64}else{O=c[d+12>>2]|0;N=c[d+8>>2]|0;do{if(N>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(N>>>0<11>>>0){a[o]=N<<1;at=o+1|0}else{I=N+16&-16;H=(x=0,as(230,I|0)|0);if(x){x=0;break}c[o+8>>2]=H;c[o>>2]=I|1;c[o+4>>2]=N;at=H}Kb(at|0,O|0,N)|0;a[at+N|0]=0;u=64;break L71}}while(0);N=bQ(-1,-1)|0;au=N;av=K}}while(0);do{if((u|0)==64){P=p;N=d+16|0;c[P>>2]=c[N>>2];c[P+4>>2]=c[N+4>>2];c[P+8>>2]=c[N+8>>2];L86:do{if((a[j]&1)==0){N=q;c[N>>2]=c[j>>2];c[N+4>>2]=c[j+4>>2];c[N+8>>2]=c[j+8>>2];u=74}else{N=c[h+8>>2]|0;O=c[h+4>>2]|0;do{if(O>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(O>>>0<11>>>0){a[q]=O<<1;aw=q+1|0}else{H=O+16&-16;I=(x=0,as(230,H|0)|0);if(x){x=0;break}c[q+8>>2]=I;c[q>>2]=H|1;c[q+4>>2]=O;aw=I}Kb(aw|0,N|0,O)|0;a[aw+O|0]=0;u=74;break L86}}while(0);O=bQ(-1,-1)|0;ay=O;az=K}}while(0);do{if((u|0)==74){O=f;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];x=0;ao(26,B|0,o|0,f|0,q|0,0);if(x){x=0;O=bQ(-1,-1)|0;N=O;O=K;if((a[q]&1)==0){ay=N;az=O;break}J2(c[q+8>>2]|0);ay=N;az=O;break}O=an;if((a[q]&1)!=0){J2(c[q+8>>2]|0)}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}x=0;ap(436,k|0);if(x){x=0;u=31;break L1}if((a[j]&1)==0){i=e;return O|0}J2(c[h+8>>2]|0);i=e;return O|0}}while(0);if((a[o]&1)==0){au=ay;av=az;break}J2(c[o+8>>2]|0);au=ay;av=az}}while(0);B=c[r>>2]|0;P=c[D>>2]|0;O=B;while(1){if((O|0)==(P|0)){aA=P;break}if((c[O>>2]|0)==(an|0)){aA=O;break}else{O=O+4|0}}O=aA-B>>2;N=B+(O+1<<2)|0;I=P-N|0;Kc(B+(O<<2)|0,N|0,I|0)|0;N=B+((I>>2)+O<<2)|0;O=c[D>>2]|0;if((N|0)!=(O|0)){c[D>>2]=O+(~((O-4+(-N|0)|0)>>>2)<<2)}J2(s);al=au;am=av;break L59}else{x=0}}while(0);r=bQ(-1,-1)|0;ah=K;ai=r;u=34}}while(0);if((u|0)==34){al=ai;am=ah}x=0;ap(436,k|0);if(!x){aB=al;aC=am;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{x=0;u=31}}while(0);if((u|0)==31){u=bQ(-1,-1)|0;aB=u;aC=K}if((a[j]&1)==0){aD=aB;aE=0;aF=aD;aG=aC;be(aF|0)}J2(c[h+8>>2]|0);aD=aB;aE=0;aF=aD;aG=aC;be(aF|0);return 0}function h1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;i=i+72|0;f=e|0;g=e+8|0;h=e+24|0;j=e+40|0;k=e+56|0;l=d|0;if((a[d+28|0]&1)!=0){m=l;i=e;return m|0}n=b+4|0;b=c[n>>2]|0;o=d+40|0;if((a[o]&1)==0){p=g;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];q=a[p]|0}else{p=c[d+48>>2]|0;r=c[d+44>>2]|0;if(r>>>0>4294967279>>>0){CJ(0);return 0}if(r>>>0<11>>>0){s=r<<1&255;a[g]=s;t=g+1|0;u=s}else{s=r+16&-16;v=J0(s)|0;c[g+8>>2]=v;w=s|1;c[g>>2]=w;c[g+4>>2]=r;t=v;u=w&255}Kb(t|0,p|0,r)|0;a[t+r|0]=0;q=u}u=(iG(b+148|0,g)|0)!=0;do{if((q&1)==0){if(u){y=b;break}else{m=l}i=e;return m|0}else{J2(c[g+8>>2]|0);if(u){y=c[n>>2]|0;break}else{m=l;i=e;return m|0}}}while(0);l=J0(88)|0;c[f>>2]=l;u=y+4|0;g=c[u>>2]|0;if((g|0)==(c[y+8>>2]|0)){ee(y|0,f);z=c[f>>2]|0}else{if((g|0)==0){A=0}else{c[g>>2]=l;A=c[u>>2]|0}c[u>>2]=A+4;z=l}l=z;A=z;g=c[n>>2]|0;L30:do{if((a[o]&1)==0){n=h;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];B=29}else{n=c[d+48>>2]|0;f=c[d+44>>2]|0;do{if(f>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(f>>>0<11>>>0){a[h]=f<<1;C=h+1|0}else{b=f+16&-16;q=(x=0,as(230,b|0)|0);if(x){x=0;break}c[h+8>>2]=q;c[h>>2]=b|1;c[h+4>>2]=f;C=q}Kb(C|0,n|0,f)|0;a[C+f|0]=0;B=29;break L30}}while(0);f=bQ(-1,-1)|0;D=K;E=f}}while(0);do{if((B|0)==29){C=(x=0,aK(262,g+148|0,h|0)|0);do{if(!x){x=0;aq(600,A|0,c[C>>2]|0);if(x){x=0;break}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}o=d+4|0;if((a[o]&1)==0){f=k;c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2]}else{o=c[d+12>>2]|0;f=c[d+8>>2]|0;if(f>>>0>4294967279>>>0){CJ(0);return 0}if(f>>>0<11>>>0){a[k]=f<<1;F=k+1|0}else{n=f+16&-16;q=J0(n)|0;c[k+8>>2]=q;c[k>>2]=n|1;c[k+4>>2]=f;F=q}Kb(F|0,o|0,f)|0;a[F+f|0]=0}f=(x=0,aK(346,z+4|0,k|0)|0);do{if(!x){o=f;if((a[o]&1)==0){q=j;c[q>>2]=c[o>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];G=a[q]|0}else{q=c[f+8>>2]|0;o=c[f+4>>2]|0;if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}if(o>>>0<11>>>0){n=o<<1&255;a[j]=n;H=j+1|0;I=n}else{n=o+16&-16;b=(x=0,as(230,n|0)|0);if(x){x=0;break}c[j+8>>2]=b;r=n|1;c[j>>2]=r;c[j+4>>2]=o;H=b;I=r&255}Kb(H|0,q|0,o)|0;a[H+o|0]=0;G=I}if((G&1)!=0){J2(c[j+8>>2]|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}Kc(z+16|0,d+16|0,12)|0;m=z;i=e;return m|0}else{x=0}}while(0);f=bQ(-1,-1)|0;o=f;f=K;if((a[k]&1)==0){J=f;L=o;M=L;N=0;O=M;P=J;be(O|0)}J2(c[k+8>>2]|0);J=f;L=o;M=L;N=0;O=M;P=J;be(O|0)}else{x=0}}while(0);C=bQ(-1,-1)|0;o=C;C=K;if((a[h]&1)==0){D=C;E=o;break}J2(c[h+8>>2]|0);D=C;E=o}}while(0);h=c[y>>2]|0;y=c[u>>2]|0;k=h;while(1){if((k|0)==(y|0)){Q=y;break}if((c[k>>2]|0)==(z|0)){Q=k;break}else{k=k+4|0}}k=Q-h>>2;Q=h+(k+1<<2)|0;z=y-Q|0;Kc(h+(k<<2)|0,Q|0,z|0)|0;Q=h+((z>>2)+k<<2)|0;k=c[u>>2]|0;if((Q|0)!=(k|0)){c[u>>2]=k+(~((k-4+(-Q|0)|0)>>>2)<<2)}J2(l);J=D;L=E;M=L;N=0;O=M;P=J;be(O|0);return 0}function h2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0;e=i;i=i+48|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=c[d+52>>2]|0;if((k|0)==0){l=0}else{l=cS[c[(c[k>>2]|0)+20>>2]&1023](k,b|0)|0}k=c[b+4>>2]|0;m=J0(60)|0;c[h>>2]=m;n=k+4|0;o=c[n>>2]|0;if((o|0)==(c[k+8>>2]|0)){ee(k|0,h);p=c[h>>2]|0}else{if((o|0)==0){q=0}else{c[o>>2]=m;q=c[n>>2]|0}c[n>>2]=q+4;p=m}m=p;q=d+4|0;L11:do{if((a[q]&1)==0){o=j;c[o>>2]=c[q>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];r=18}else{o=c[d+12>>2]|0;h=c[d+8>>2]|0;do{if(h>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;s=j+1|0}else{t=h+16&-16;u=(x=0,as(230,t|0)|0);if(x){x=0;break}c[j+8>>2]=u;c[j>>2]=t|1;c[j+4>>2]=h;s=u}Kb(s|0,o|0,h)|0;a[s+h|0]=0;r=18;break L11}}while(0);h=bQ(-1,-1)|0;v=K;w=h}}while(0);do{if((r|0)==18){s=d+16|0;q=f;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];s=d+44|0;q=d+40|0;x=0;aG(88,p|0,j|0,f|0,l|0,(c[s>>2]|0)-(c[q>>2]|0)>>2|0,(a[d+56|0]&1)!=0|0,(a[d+57|0]&1)!=0|0);if(x){x=0;h=bQ(-1,-1)|0;o=h;h=K;if((a[j]&1)==0){v=h;w=o;break}J2(c[j+8>>2]|0);v=h;w=o;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}o=c[q>>2]|0;h=(c[s>>2]|0)-o>>2;if((h|0)==0){y=p;i=e;return y|0}s=p+36|0;u=s;t=b|0;z=s+8|0;A=z;B=s+12|0;C=s+4|0;D=s;s=0;E=o;while(1){o=c[E+(s<<2)>>2]|0;F=cS[c[(c[o>>2]|0)+20>>2]&1023](o,t)|0;c[g>>2]=F;o=c[A>>2]|0;if((o|0)==(c[B>>2]|0)){iF(C,g);G=c[g>>2]|0}else{if((o|0)==0){H=0}else{c[o>>2]=F;H=c[A>>2]|0}c[z>>2]=H+4;G=F}cy[c[c[D>>2]>>2]&1023](u,G);F=s+1|0;if(F>>>0>=h>>>0){break}s=F;E=c[q>>2]|0}y=p;i=e;return y|0}}while(0);y=c[k>>2]|0;k=c[n>>2]|0;e=y;while(1){if((e|0)==(k|0)){I=k;break}if((c[e>>2]|0)==(p|0)){I=e;break}else{e=e+4|0}}e=I-y>>2;I=y+(e+1<<2)|0;p=k-I|0;Kc(y+(e<<2)|0,I|0,p|0)|0;I=y+((p>>2)+e<<2)|0;e=c[n>>2]|0;if((I|0)==(e|0)){J2(m);J=w;L=0;M=J;N=v;be(M|0)}c[n>>2]=e+(~((e-4+(-I|0)|0)>>>2)<<2);J2(m);J=w;L=0;M=J;N=v;be(M|0);return 0}function h3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;e=i;i=i+72|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=c[d+36>>2]|0;if((l|0)==0){m=0}else{m=cS[c[(c[l>>2]|0)+20>>2]&1023](l|0,b|0)|0}l=c[d+40>>2]|0;if((l|0)==0){n=0}else{n=cS[c[(c[l>>2]|0)+20>>2]&1023](l|0,b|0)|0}l=c[b+4>>2]|0;b=J0(48)|0;c[j>>2]=b;o=l+4|0;p=c[o>>2]|0;if((p|0)==(c[l+8>>2]|0)){ee(l|0,j);q=c[j>>2]|0}else{if((p|0)==0){r=0}else{c[p>>2]=b;r=c[o>>2]|0}c[o>>2]=r+4;q=b}b=q;r=d+4|0;L14:do{if((a[r]&1)==0){p=k;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];s=a[p]|0;t=p;u=20}else{p=c[d+12>>2]|0;j=c[d+8>>2]|0;do{if(j>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(j>>>0<11>>>0){v=j<<1&255;w=k;a[w]=v;y=k+1|0;z=v;A=w}else{w=j+16&-16;v=(x=0,as(230,w|0)|0);if(x){x=0;break}c[k+8>>2]=v;B=w|1;c[k>>2]=B;c[k+4>>2]=j;y=v;z=B&255;A=k}Kb(y|0,p|0,j)|0;a[y+j|0]=0;s=z;t=A;u=20;break L14}}while(0);j=bQ(-1,-1)|0;C=K;D=j}}while(0);do{if((u|0)==20){A=d+16|0;z=h;c[z>>2]=c[A>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];A=a[d+44|0]&1;z=h;y=f;r=g;j=q;L29:do{if((s&1)==0){c[y>>2]=c[t>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];u=30}else{p=c[k+8>>2]|0;B=c[k+4>>2]|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(B>>>0<11>>>0){a[y]=B<<1;E=f+1|0}else{v=B+16&-16;w=(x=0,as(230,v|0)|0);if(x){x=0;break}c[f+8>>2]=w;c[f>>2]=v|1;c[f+4>>2]=B;E=w}Kb(E|0,p|0,B)|0;a[E+B|0]=0;u=30;break L29}}while(0);B=bQ(-1,-1)|0;F=K;G=B}}while(0);do{if((u|0)==30){c[r>>2]=c[z>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];x=0;aB(6,j|0,f|0,g|0,0,0,0);if(x){x=0;B=bQ(-1,-1)|0;p=K;if((a[y]&1)==0){F=p;G=B;break}J2(c[f+8>>2]|0);F=p;G=B;break}if((a[y]&1)!=0){J2(c[f+8>>2]|0)}c[q>>2]=19208;c[q+36>>2]=m;c[q+40>>2]=n;a[q+44|0]=A;if((a[t]&1)==0){i=e;return j|0}J2(c[k+8>>2]|0);i=e;return j|0}}while(0);j=G;A=F;if((a[t]&1)==0){C=A;D=j;break}J2(c[k+8>>2]|0);C=A;D=j}}while(0);k=c[l>>2]|0;l=c[o>>2]|0;t=k;while(1){if((t|0)==(l|0)){H=l;break}if((c[t>>2]|0)==(q|0)){H=t;break}else{t=t+4|0}}t=H-k>>2;H=k+(t+1<<2)|0;q=l-H|0;Kc(k+(t<<2)|0,H|0,q|0)|0;H=k+((q>>2)+t<<2)|0;t=c[o>>2]|0;if((H|0)==(t|0)){J2(b);I=D;J=0;L=I;M=C;be(L|0)}c[o>>2]=t+(~((t-4+(-H|0)|0)>>>2)<<2);J2(b);I=D;J=0;L=I;M=C;be(L|0);return 0}function h4(a,b){a=a|0;b=b|0;return b|0}function h5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=i;i=i+120|0;f=e|0;g=e+16|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=e+72|0;n=e+88|0;o=e+104|0;p=c[d+36>>2]|0;a[p+28|0]=0;q=cS[c[(c[p>>2]|0)+20>>2]&1023](p|0,b|0)|0;a[q+28|0]=0;p=d+52|0;L1:do{if((a[p]&1)==0){r=q}else{if((c[q+32>>2]|0)==5){r=q;break}s=c[b+4>>2]|0;t=J0(60)|0;c[k>>2]=t;u=s+4|0;v=c[u>>2]|0;if((v|0)==(c[s+8>>2]|0)){ee(s|0,k);w=c[k>>2]|0}else{if((v|0)==0){y=0}else{c[v>>2]=t;y=c[u>>2]|0}c[u>>2]=y+4;w=t}t=w;v=q+4|0;L11:do{if((a[v]&1)==0){z=l;c[z>>2]=c[v>>2];c[z+4>>2]=c[v+4>>2];c[z+8>>2]=c[v+8>>2];A=18}else{z=c[q+12>>2]|0;B=c[q+8>>2]|0;do{if(B>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(B>>>0<11>>>0){a[l]=B<<1;C=l+1|0}else{D=B+16&-16;E=(x=0,as(230,D|0)|0);if(x){x=0;break}c[l+8>>2]=E;c[l>>2]=D|1;c[l+4>>2]=B;C=E}Kb(C|0,z|0,B)|0;a[C+B|0]=0;A=18;break L11}}while(0);B=bQ(-1,-1)|0;F=K;G=B}}while(0);do{if((A|0)==18){v=q+16|0;B=j;c[B>>2]=c[v>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];x=0;aB(34,w|0,l|0,j|0,0,1,1);if(x){x=0;v=bQ(-1,-1)|0;B=v;v=K;if((a[l]&1)==0){F=v;G=B;break}J2(c[l+8>>2]|0);F=v;G=B;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}B=w+36|0;v=B;c[h>>2]=q;z=B+8|0;E=z;D=c[E>>2]|0;if((D|0)==(c[B+12>>2]|0)){eq(B+4|0,h);H=c[h>>2]|0}else{if((D|0)==0){I=0}else{c[D>>2]=q;I=c[E>>2]|0}c[z>>2]=I+4;H=q}cy[c[c[B>>2]>>2]&1023](v,H);r=w;break L1}}while(0);v=c[s>>2]|0;B=c[u>>2]|0;z=v;while(1){if((z|0)==(B|0)){J=B;break}if((c[z>>2]|0)==(w|0)){J=z;break}else{z=z+4|0}}z=J-v>>2;s=v+(z+1<<2)|0;E=B-s|0;Kc(v+(z<<2)|0,s|0,E|0)|0;s=v+((E>>2)+z<<2)|0;z=c[u>>2]|0;if((s|0)!=(z|0)){c[u>>2]=z+(~((z-4+(-s|0)|0)>>>2)<<2)}J2(t);L=F;M=G;N=M;O=0;P=N;Q=L;be(P|0)}}while(0);G=c[b+4>>2]|0;b=J0(56)|0;c[g>>2]=b;F=G+4|0;J=c[F>>2]|0;if((J|0)==(c[G+8>>2]|0)){ee(G|0,g);R=c[g>>2]|0}else{if((J|0)==0){S=0}else{c[J>>2]=b;S=c[F>>2]|0}c[F>>2]=S+4;R=b}b=R;S=R;J=d+4|0;L57:do{if((a[J]&1)==0){g=m;c[g>>2]=c[J>>2];c[g+4>>2]=c[J+4>>2];c[g+8>>2]=c[J+8>>2];A=51}else{g=c[d+12>>2]|0;w=c[d+8>>2]|0;do{if(w>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(w>>>0<11>>>0){a[m]=w<<1;T=m+1|0}else{H=w+16&-16;q=(x=0,as(230,H|0)|0);if(x){x=0;break}c[m+8>>2]=q;c[m>>2]=H|1;c[m+4>>2]=w;T=q}Kb(T|0,g|0,w)|0;a[T+w|0]=0;A=51;break L57}}while(0);w=bQ(-1,-1)|0;U=K;V=w}}while(0);do{if((A|0)==51){T=n;J=d+16|0;c[T>>2]=c[J>>2];c[T+4>>2]=c[J+4>>2];c[T+8>>2]=c[J+8>>2];J=d+40|0;L72:do{if((a[J]&1)==0){w=o;c[w>>2]=c[J>>2];c[w+4>>2]=c[J+4>>2];c[w+8>>2]=c[J+8>>2];A=61}else{w=c[d+48>>2]|0;g=c[d+44>>2]|0;do{if(g>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(g>>>0<11>>>0){a[o]=g<<1;W=o+1|0}else{t=g+16&-16;u=(x=0,as(230,t|0)|0);if(x){x=0;break}c[o+8>>2]=u;c[o>>2]=t|1;c[o+4>>2]=g;W=u}Kb(W|0,w|0,g)|0;a[W+g|0]=0;A=61;break L72}}while(0);g=bQ(-1,-1)|0;X=K;Y=g}}while(0);do{if((A|0)==61){J=(a[p]&1)!=0;g=f;c[g>>2]=c[T>>2];c[g+4>>2]=c[T+4>>2];c[g+8>>2]=c[T+8>>2];x=0;aB(28,S|0,m|0,f|0,r|0,o|0,J|0);if(x){x=0;J=bQ(-1,-1)|0;g=J;J=K;if((a[o]&1)==0){X=J;Y=g;break}J2(c[o+8>>2]|0);X=J;Y=g;break}g=R;if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[m]&1)==0){i=e;return g|0}J2(c[m+8>>2]|0);i=e;return g|0}}while(0);if((a[m]&1)==0){U=X;V=Y;break}J2(c[m+8>>2]|0);U=X;V=Y}}while(0);Y=c[G>>2]|0;G=c[F>>2]|0;X=Y;while(1){if((X|0)==(G|0)){Z=G;break}if((c[X>>2]|0)==(R|0)){Z=X;break}else{X=X+4|0}}X=Z-Y>>2;Z=Y+(X+1<<2)|0;R=G-Z|0;Kc(Y+(X<<2)|0,Z|0,R|0)|0;Z=Y+((R>>2)+X<<2)|0;X=c[F>>2]|0;if((Z|0)!=(X|0)){c[F>>2]=X+(~((X-4+(-Z|0)|0)>>>2)<<2)}J2(b);L=U;M=V;N=M;O=0;P=N;Q=L;be(P|0);return 0}function h6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;e=i;i=i+48|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=c[b+4>>2]|0;l=J0(56)|0;c[h>>2]=l;m=k+4|0;n=c[m>>2]|0;if((n|0)==(c[k+8>>2]|0)){ee(k|0,h);o=c[h>>2]|0}else{if((n|0)==0){p=0}else{c[n>>2]=l;p=c[m>>2]|0}c[m>>2]=p+4;o=l}l=o;p=d+4|0;L8:do{if((a[p]&1)==0){n=j;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];q=16}else{n=c[d+12>>2]|0;h=c[d+8>>2]|0;do{if(h>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(h>>>0<11>>>0){a[j]=h<<1;r=j+1|0}else{s=h+16&-16;t=(x=0,as(230,s|0)|0);if(x){x=0;break}c[j+8>>2]=t;c[j>>2]=s|1;c[j+4>>2]=h;r=t}Kb(r|0,n|0,h)|0;a[r+h|0]=0;q=16;break L8}}while(0);h=bQ(-1,-1)|0;u=h;v=K}}while(0);do{if((q|0)==16){r=d+16|0;p=g;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];x=0;aP(44,o|0,j|0,g|0);if(x){x=0;r=bQ(-1,-1)|0;p=r;r=K;if((a[j]&1)==0){u=p;v=r;break}J2(c[j+8>>2]|0);u=p;v=r;break}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}r=d+40|0;p=c[r>>2]|0;h=(c[d+44>>2]|0)-p>>2;if((h|0)==0){w=o;i=e;return w|0}n=o+36|0;t=n;s=b|0;y=n+8|0;z=y;A=n+12|0;B=n+4|0;C=n;n=0;D=p;while(1){p=c[D+(n<<2)>>2]|0;E=cS[c[(c[p>>2]|0)+20>>2]&1023](p,s)|0;c[f>>2]=E;p=c[z>>2]|0;if((p|0)==(c[A>>2]|0)){iE(B,f);F=c[f>>2]|0}else{if((p|0)==0){G=0}else{c[p>>2]=E;G=c[z>>2]|0}c[y>>2]=G+4;F=E}cy[c[c[C>>2]>>2]&1023](t,F);E=n+1|0;if(E>>>0>=h>>>0){break}n=E;D=c[r>>2]|0}w=o;i=e;return w|0}}while(0);w=c[k>>2]|0;k=c[m>>2]|0;e=w;while(1){if((e|0)==(k|0)){H=k;break}if((c[e>>2]|0)==(o|0)){H=e;break}else{e=e+4|0}}e=H-w>>2;H=w+(e+1<<2)|0;o=k-H|0;Kc(w+(e<<2)|0,H|0,o|0)|0;H=w+((o>>2)+e<<2)|0;e=c[m>>2]|0;if((H|0)==(e|0)){J2(l);I=u;J=0;L=I;M=v;be(L|0)}c[m>>2]=e+(~((e-4+(-H|0)|0)>>>2)<<2);J2(l);I=u;J=0;L=I;M=v;be(L|0);return 0}function h7(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0;f=i;i=i+96|0;g=f|0;j=f+8|0;k=f+16|0;l=f+32|0;m=f+48|0;n=f+64|0;o=f+80|0;p=e;q=d[p]|0;if((q&1|0)==0){r=q>>>1}else{r=c[e+4>>2]|0}L5:do{if((r|0)==0){q=c[b+52>>2]|0;s=b+48|0;t=c[s>>2]|0;u=(q-t|0)/12|0;if((q|0)==(t|0)){break}q=k;v=k+8|0;w=k+1|0;y=k|0;z=k+4|0;A=0;B=t;while(1){t=B+(A*12|0)|0;if((a[t]&1)==0){c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2]}else{t=c[B+(A*12|0)+8>>2]|0;C=c[B+(A*12|0)+4>>2]|0;if(C>>>0>4294967279>>>0){D=10;break}if(C>>>0<11>>>0){a[q]=C<<1;E=w}else{F=C+16&-16;G=J0(F)|0;c[v>>2]=G;c[y>>2]=F|1;c[z>>2]=C;E=G}Kb(E|0,t|0,C)|0;a[E+C|0]=0}C=(x=0,as(42,k|0)|0);if(x){x=0;D=17;break}if((C|0)!=6){D=21;break}if((a[q]&1)!=0){J2(c[v>>2]|0)}C=A+1|0;if(C>>>0>=u>>>0){break L5}A=C;B=c[s>>2]|0}do{if((D|0)==10){CJ(0)}else if((D|0)==17){s=bQ(-1,-1)|0;H=K;I=s}else if((D|0)==21){x=0,aK(346,e|0,k|0)|0;if(x){x=0;s=bQ(-1,-1)|0;H=K;I=s;break}if((a[q]&1)==0){break L5}J2(c[v>>2]|0);break L5}}while(0);s=I;B=H;if((a[q]&1)==0){J=B;L=s;M=L;N=0;O=M;P=J;be(O|0)}J2(c[v>>2]|0);J=B;L=s;M=L;N=0;O=M;P=J;be(O|0)}}while(0);H=d[p]|0;if((H&1|0)==0){Q=H>>>1}else{Q=c[e+4>>2]|0}L43:do{if((Q|0)==0){H=c[b+64>>2]|0;p=b+60|0;I=c[p>>2]|0;k=(H-I|0)/12|0;if((H|0)==(I|0)){break}H=l;E=l+8|0;r=l+1|0;s=l|0;B=l+4|0;A=0;u=I;while(1){I=u+(A*12|0)|0;if((a[I]&1)==0){c[H>>2]=c[I>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2]}else{I=c[u+(A*12|0)+8>>2]|0;z=c[u+(A*12|0)+4>>2]|0;if(z>>>0>4294967279>>>0){D=37;break}if(z>>>0<11>>>0){a[H]=z<<1;R=r}else{y=z+16&-16;w=J0(y)|0;c[E>>2]=w;c[s>>2]=y|1;c[B>>2]=z;R=w}Kb(R|0,I|0,z)|0;a[R+z|0]=0}z=(x=0,as(42,l|0)|0);if(x){x=0;D=44;break}if((z|0)!=6){D=48;break}if((a[H]&1)!=0){J2(c[E>>2]|0)}z=A+1|0;if(z>>>0>=k>>>0){break L43}A=z;u=c[p>>2]|0}do{if((D|0)==37){CJ(0)}else if((D|0)==44){p=bQ(-1,-1)|0;S=K;T=p}else if((D|0)==48){x=0,aK(346,e|0,l|0)|0;if(x){x=0;p=bQ(-1,-1)|0;S=K;T=p;break}if((a[H]&1)==0){break L43}J2(c[E>>2]|0);break L43}}while(0);p=T;u=S;if((a[H]&1)==0){J=u;L=p;M=L;N=0;O=M;P=J;be(O|0)}J2(c[E>>2]|0);J=u;L=p;M=L;N=0;O=M;P=J;be(O|0)}}while(0);S=b+48|0;T=b+52|0;l=c[T>>2]|0;R=S|0;Q=c[R>>2]|0;p=(l-Q|0)/12|0;L77:do{if((l|0)!=(Q|0)){u=m;A=m+8|0;k=b+40|0;B=m+1|0;s=m|0;r=m+4|0;v=0;q=Q;while(1){z=q+(v*12|0)|0;if((a[z]&1)==0){c[u>>2]=c[z>>2];c[u+4>>2]=c[z+4>>2];c[u+8>>2]=c[z+8>>2]}else{z=c[q+(v*12|0)+8>>2]|0;I=c[q+(v*12|0)+4>>2]|0;if(I>>>0>4294967279>>>0){D=60;break}if(I>>>0<11>>>0){a[u]=I<<1;U=B}else{w=I+16&-16;y=J0(w)|0;c[A>>2]=y;c[s>>2]=w|1;c[r>>2]=I;U=y}Kb(U|0,z|0,I)|0;a[U+I|0]=0}I=(x=0,as(42,m|0)|0);if(x){x=0;break}if((I|0)!=6){V=(x=0,+(+aM(2,m|0,e|0)));if(x){x=0;break}h[k>>3]=V*+h[k>>3];I=(c[R>>2]|0)+(v*12|0)|0;x=0,aK(346,I|0,e|0)|0;if(x){x=0;break}}if((a[u]&1)!=0){J2(c[A>>2]|0)}I=v+1|0;if(I>>>0>=p>>>0){break L77}v=I;q=c[R>>2]|0}if((D|0)==60){CJ(0)}q=bQ(-1,-1)|0;v=q;q=K;if((a[u]&1)==0){J=q;L=v;M=L;N=0;O=M;P=J;be(O|0)}J2(c[A>>2]|0);J=q;L=v;M=L;N=0;O=M;P=J;be(O|0)}}while(0);p=b+64|0;m=c[p>>2]|0;U=b+60|0;Q=c[U>>2]|0;l=(m-Q|0)/12|0;L107:do{if((m|0)!=(Q|0)){v=n;q=n+8|0;k=b+40|0;r=n+1|0;s=n|0;B=n+4|0;E=0;H=Q;while(1){I=H+(E*12|0)|0;if((a[I]&1)==0){c[v>>2]=c[I>>2];c[v+4>>2]=c[I+4>>2];c[v+8>>2]=c[I+8>>2]}else{I=c[H+(E*12|0)+8>>2]|0;z=c[H+(E*12|0)+4>>2]|0;if(z>>>0>4294967279>>>0){D=80;break}if(z>>>0<11>>>0){a[v]=z<<1;W=r}else{y=z+16&-16;w=J0(y)|0;c[q>>2]=w;c[s>>2]=y|1;c[B>>2]=z;W=w}Kb(W|0,I|0,z)|0;a[W+z|0]=0}z=(x=0,as(42,n|0)|0);if(x){x=0;break}if((z|0)!=6){V=(x=0,+(+aM(2,n|0,e|0)));if(x){x=0;break}h[k>>3]=+h[k>>3]/V;z=(c[U>>2]|0)+(E*12|0)|0;x=0,aK(346,z|0,e|0)|0;if(x){x=0;break}}if((a[v]&1)!=0){J2(c[q>>2]|0)}z=E+1|0;if(z>>>0>=l>>>0){break L107}E=z;H=c[U>>2]|0}if((D|0)==80){CJ(0)}H=bQ(-1,-1)|0;E=H;H=K;if((a[v]&1)==0){J=H;L=E;M=L;N=0;O=M;P=J;be(O|0)}J2(c[q>>2]|0);J=H;L=E;M=L;N=0;O=M;P=J;be(O|0)}}while(0);l=o|0;c[l>>2]=0;e=o+4|0;c[e>>2]=0;n=o+8|0;c[n>>2]=0;x=0;aq(462,o|0,((c[T>>2]|0)-(c[R>>2]|0)|0)/12|0|0);L137:do{if(!x){W=c[R>>2]|0;L139:do{if((W|0)!=(c[T>>2]|0)){Q=W;L140:while(1){b=c[U>>2]|0;m=c[p>>2]|0;L142:do{if((b|0)==(m|0)){X=b;D=116}else{E=a[Q]|0;H=E&255;k=(H&1|0)==0;B=H>>>1;H=Q+1|0;s=Q+8|0;r=Q+4|0;A=b;while(1){u=A;z=a[A]|0;I=z&255;if((I&1|0)==0){Y=I>>>1}else{Y=c[A+4>>2]|0}if(k){Z=B}else{Z=c[r>>2]|0}L153:do{if((Y|0)==(Z|0)){I=(z&1)==0;if(I){_=u+1|0}else{_=c[A+8>>2]|0}if((E&1)==0){$=H}else{$=c[s>>2]|0}if(!I){if((Kd(_|0,$|0,Y|0)|0)==0){X=A;D=116;break L142}else{break}}if((Y|0)==0){X=A;D=116;break L142}else{aa=$;ab=_;ac=Y}while(1){if((a[ab]|0)!=(a[aa]|0)){break L153}I=ac-1|0;if((I|0)==0){X=A;D=116;break L142}else{aa=aa+1|0;ab=ab+1|0;ac=I}}}}while(0);u=A+12|0;if((u|0)==(m|0)){D=135;break}else{A=u}}}}while(0);do{if((D|0)==116){D=0;if((X|0)==(m|0)){D=135;break}A=(X-b|0)/12|0;s=b+(A*12|0)|0;H=b+((A+1|0)*12|0)|0;if((H|0)==(m|0)){ad=s;ae=m}else{A=s;s=H;do{x=0,aK(346,A|0,s|0)|0;if(x){x=0;D=125;break L140}s=s+12|0;A=A+12|0;}while((s|0)!=(m|0));ad=A;ae=c[p>>2]|0}if((ad|0)==(ae|0)){break}else{af=ae}while(1){s=af-12|0;c[p>>2]=s;if((a[s]&1)==0){ag=s}else{J2(c[af-12+8>>2]|0);ag=c[p>>2]|0}if((ad|0)==(ag|0)){break}else{af=ag}}}}while(0);do{if((D|0)==135){D=0;m=c[e>>2]|0;if((m|0)==(c[n>>2]|0)){x=0;aq(282,o|0,Q|0);if(!x){break}else{x=0;D=126;break L140}}do{if((m|0)!=0){b=Q;if((a[b]&1)==0){A=m;c[A>>2]=c[b>>2];c[A+4>>2]=c[b+4>>2];c[A+8>>2]=c[b+8>>2];break}b=c[Q+8>>2]|0;A=c[Q+4>>2]|0;if(A>>>0>4294967279>>>0){D=140;break L140}if(A>>>0<11>>>0){a[m]=A<<1;ah=m+1|0}else{s=A+16&-16;H=(x=0,as(230,s|0)|0);if(x){x=0;D=126;break L140}c[m+8>>2]=H;c[m>>2]=s|1;c[m+4>>2]=A;ah=H}Kb(ah|0,b|0,A)|0;a[ah+A|0]=0}}while(0);c[e>>2]=(c[e>>2]|0)+12}}while(0);Q=Q+12|0;if((Q|0)==(c[T>>2]|0)){break L139}}if((D|0)==125){Q=bQ(-1,-1)|0;ai=K;aj=Q;break L137}else if((D|0)==126){Q=bQ(-1,-1)|0;ai=K;aj=Q;break L137}else if((D|0)==140){x=0;ap(232,0);if(x){x=0;D=127;break L137}}}}while(0);x=0;aP(140,S|0,c[l>>2]|0,c[e>>2]|0);if(x){x=0;D=127;break}x=0;aP(394,c[R>>2]|0,c[T>>2]|0,g|0);if(x){x=0;D=127;break}x=0;aP(394,c[U>>2]|0,c[p>>2]|0,j|0);if(x){x=0;D=127;break}W=c[l>>2]|0;if((W|0)==0){i=f;return}q=c[e>>2]|0;if((W|0)==(q|0)){ak=W}else{v=q;while(1){q=v-12|0;c[e>>2]=q;if((a[q]&1)==0){al=q}else{J2(c[v-12+8>>2]|0);al=c[e>>2]|0}if((W|0)==(al|0)){break}else{v=al}}ak=c[l>>2]|0}J2(ak);i=f;return}else{x=0;D=127}}while(0);if((D|0)==127){D=bQ(-1,-1)|0;ai=K;aj=D}D=aj;aj=ai;ai=c[l>>2]|0;if((ai|0)==0){J=aj;L=D;M=L;N=0;O=M;P=J;be(O|0)}f=c[e>>2]|0;if((ai|0)==(f|0)){am=ai}else{ak=f;while(1){f=ak-12|0;c[e>>2]=f;if((a[f]&1)==0){an=f}else{J2(c[ak-12+8>>2]|0);an=c[e>>2]|0}if((ai|0)==(an|0)){break}else{ak=an}}am=c[l>>2]|0}J2(am);J=aj;L=D;M=L;N=0;O=M;P=J;be(O|0)}function h8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=i;f=b;g=i;i=i+12|0;i=i+7&-8;h=i;i=i+12|0;i=i+7&-8;j=c[d+52>>2]|0;k=d+48|0;l=c[k>>2]|0;m=(j-l|0)/12|0;L1:do{if((j|0)!=(l|0)){n=g;o=g+8|0;p=g+1|0;q=g|0;r=g+4|0;s=0;t=l;while(1){u=t+(s*12|0)|0;if((a[u]&1)==0){c[n>>2]=c[u>>2];c[n+4>>2]=c[u+4>>2];c[n+8>>2]=c[u+8>>2]}else{u=c[t+(s*12|0)+8>>2]|0;v=c[t+(s*12|0)+4>>2]|0;if(v>>>0>4294967279>>>0){w=6;break}if(v>>>0<11>>>0){a[n]=v<<1;y=p}else{z=v+16&-16;A=J0(z)|0;c[o>>2]=A;c[q>>2]=z|1;c[r>>2]=v;y=A}Kb(y|0,u|0,v)|0;a[y+v|0]=0}v=(x=0,as(42,g|0)|0);if(x){x=0;w=22;break}B=(a[n]&1)==0;if((v|0)!=6){w=13;break}if(!B){J2(c[o>>2]|0)}v=s+1|0;if(v>>>0>=m>>>0){break L1}s=v;t=c[k>>2]|0}if((w|0)==22){t=bQ(-1,-1)|0;C=K;D=t}else if((w|0)==6){CJ(0)}else if((w|0)==13){if(B){c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];i=e;return}t=c[o>>2]|0;s=c[r>>2]|0;do{if(s>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(s>>>0<11>>>0){a[f]=s<<1;E=b+1|0}else{q=s+16&-16;p=(x=0,as(230,q|0)|0);if(x){x=0;break}c[b+8>>2]=p;c[b>>2]=q|1;c[b+4>>2]=s;E=p}Kb(E|0,t|0,s)|0;a[E+s|0]=0;if(B){i=e;return}J2(c[o>>2]|0);i=e;return}}while(0);s=bQ(-1,-1)|0;C=K;D=s}s=D;t=C;if((a[n]&1)==0){F=t;G=s;H=G;I=0;J=H;L=F;be(J|0)}J2(c[o>>2]|0);F=t;G=s;H=G;I=0;J=H;L=F;be(J|0)}}while(0);C=c[d+64>>2]|0;D=d+60|0;d=c[D>>2]|0;B=(C-d|0)/12|0;L48:do{if((C|0)!=(d|0)){E=h;k=h+8|0;m=h+1|0;g=h|0;y=h+4|0;l=0;j=d;while(1){s=j+(l*12|0)|0;if((a[s]&1)==0){c[E>>2]=c[s>>2];c[E+4>>2]=c[s+4>>2];c[E+8>>2]=c[s+8>>2]}else{s=c[j+(l*12|0)+8>>2]|0;t=c[j+(l*12|0)+4>>2]|0;if(t>>>0>4294967279>>>0){w=35;break}if(t>>>0<11>>>0){a[E]=t<<1;M=m}else{r=t+16&-16;p=J0(r)|0;c[k>>2]=p;c[g>>2]=r|1;c[y>>2]=t;M=p}Kb(M|0,s|0,t)|0;a[M+t|0]=0}t=(x=0,as(42,h|0)|0);if(x){x=0;w=51;break}N=(a[E]&1)==0;if((t|0)!=6){w=42;break}if(!N){J2(c[k>>2]|0)}t=l+1|0;if(t>>>0>=B>>>0){break L48}l=t;j=c[D>>2]|0}if((w|0)==42){if(N){c[f>>2]=c[E>>2];c[f+4>>2]=c[E+4>>2];c[f+8>>2]=c[E+8>>2];i=e;return}j=c[k>>2]|0;l=c[y>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(l>>>0<11>>>0){a[f]=l<<1;O=b+1|0}else{g=l+16&-16;m=(x=0,as(230,g|0)|0);if(x){x=0;break}c[b+8>>2]=m;c[b>>2]=g|1;c[b+4>>2]=l;O=m}Kb(O|0,j|0,l)|0;a[O+l|0]=0;if(N){i=e;return}J2(c[k>>2]|0);i=e;return}}while(0);l=bQ(-1,-1)|0;P=K;Q=l}else if((w|0)==51){l=bQ(-1,-1)|0;P=K;Q=l}else if((w|0)==35){CJ(0)}l=Q;j=P;if((a[E]&1)==0){F=j;G=l;H=G;I=0;J=H;L=F;be(J|0)}J2(c[k>>2]|0);F=j;G=l;H=G;I=0;J=H;L=F;be(J|0)}}while(0);Ke(f|0,0,12)|0;i=e;return}function h9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+16|0;f=e|0;g=f;h=i;i=i+144|0;j=h+64|0;k=h|0;l=h+8|0;m=l|0;c[m>>2]=14576;n=h+12|0;c[k>>2]=31212;o=h+64|0;c[o>>2]=31232;c[h+4>>2]=0;x=0;aq(200,h+64|0,n|0);do{if(!x){c[h+136>>2]=0;c[h+140>>2]=-1;p=h+8|0;c[k>>2]=14556;c[j>>2]=14596;c[m>>2]=14576;q=n|0;c[q>>2]=14880;r=h+16|0;HA(r);Ke(h+20|0,0,24)|0;c[q>>2]=14736;s=h+44|0;Ke(h+44|0,0,16)|0;c[h+60>>2]=24;Ke(g|0,0,12)|0;x=0;aq(214,n|0,f|0);if(x){x=0;t=bQ(-1,-1)|0;u=K;if((a[g]&1)!=0){J2(c[f+8>>2]|0)}if((a[s]&1)!=0){J2(c[h+52>>2]|0)}c[q>>2]=14880;x=0;ap(388,r|0);if(!x){v=t;w=u;break}else{x=0}bQ(-1,-1,0)|0;bU()}if((a[g]&1)!=0){J2(c[f+8>>2]|0)}u=c[d+52>>2]|0;t=d+48|0;q=c[t>>2]|0;y=(u-q|0)/12|0;L17:do{if((u|0)==(q|0)){z=30}else{A=l;B=0;while(1){if((B|0)!=0){x=0,aK(104,A|0,42)|0;if(x){x=0;break}}x=0,aK(802,A|0,(c[t>>2]|0)+(B*12|0)|0)|0;if(x){x=0;break}C=B+1|0;if(C>>>0<y>>>0){B=C}else{z=30;break L17}}B=bQ(-1,-1)|0;D=K;E=B}}while(0);L26:do{if((z|0)==30){y=d+60|0;t=d+64|0;L28:do{if((c[y>>2]|0)==(c[t>>2]|0)){z=38}else{q=l;x=0,aK(104,q|0,47)|0;if(x){x=0;break}q=c[t>>2]|0;u=c[y>>2]|0;B=(q-u|0)/12|0;if((q|0)==(u|0)){z=38;break}u=l;q=0;while(1){if((q|0)!=0){x=0,aK(104,u|0,42)|0;if(x){x=0;break}}x=0,aK(802,u|0,(c[y>>2]|0)+(q*12|0)|0)|0;if(x){x=0;break}A=q+1|0;if(A>>>0<B>>>0){q=A}else{z=38;break L28}}q=bQ(-1,-1)|0;D=K;E=q;break L26}}while(0);do{if((z|0)==38){x=0;aq(560,b|0,n|0);if(x){x=0;break}c[k>>2]=14556;c[o>>2]=14596;c[p>>2]=14576;y=h+12|0;c[y>>2]=14736;if((a[s]&1)!=0){J2(c[h+52>>2]|0)}c[y>>2]=14880;x=0;ap(388,r|0);if(!x){C7(h+64|0);i=e;return}else{x=0}y=bQ(-1,-1)|0;x=0;ap(268,h+64|0);if(!x){be(y|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}}while(0);y=bQ(-1,-1)|0;D=K;E=y}}while(0);c[k>>2]=14556;c[o>>2]=14596;c[p>>2]=14576;y=h+12|0;c[y>>2]=14736;if((a[s]&1)!=0){J2(c[h+52>>2]|0)}c[y>>2]=14880;x=0;ap(388,r|0);if(x){x=0;bQ(-1,-1,0)|0;x=0;ap(268,h+64|0);if(!x){bU()}else{x=0;bQ(-1,-1,0)|0;bU()}}x=0;ap(268,h+64|0);if(!x){be(E|0)}else{x=0}bQ(-1,-1,0)|0;bU()}else{x=0;y=bQ(-1,-1)|0;v=y;w=K}}while(0);x=0;ap(268,j|0);if(!x){be(v|0)}else{x=0;bQ(-1,-1,0)|0;bU()}}function ia(a){a=a|0;iW(a);return}function ib(a,b){a=a|0;b=b|0;return b|0}function ic(a,b){a=a|0;b=b|0;return b|0}function id(a,b){a=a|0;b=b|0;return b|0}function ie(a,b){a=a|0;b=b|0;return b|0}function ig(a,b){a=a|0;b=b|0;return b|0}function ih(a,b){a=a|0;b=b|0;return b|0}function ii(a,b){a=a|0;b=b|0;return b|0}function ij(a,b){a=a|0;b=b|0;return b|0}function ik(a,b){a=a|0;b=b|0;return b|0}function il(a,b){a=a|0;b=b|0;return b|0}function im(a,b){a=a|0;b=b|0;return b|0}function io(a,b){a=a|0;b=b|0;return b|0}function ip(a,b){a=a|0;b=b|0;return b|0}function iq(a,b){a=a|0;b=b|0;return b|0}function ir(a,b){a=a|0;b=b|0;return b|0}function is(a,b){a=a|0;b=b|0;return b|0}function it(a,b){a=a|0;b=b|0;return b|0}function iu(a,b){a=a|0;b=b|0;return b|0}function iv(a,b){a=a|0;b=b|0;return b|0}function iw(a,b){a=a|0;b=b|0;return b|0}function ix(a,b){a=a|0;b=b|0;return b|0}function iy(a,b){a=a|0;b=b|0;return b|0}function iz(a,b){a=a|0;b=b|0;return b|0}function iA(a,b){a=a|0;b=b|0;return b|0}function iB(a,b){a=a|0;b=b|0;return b|0}function iC(a,b){a=a|0;b=b|0;return b|0}function iD(a,b){a=a|0;b=b|0;return b|0}function iE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function iF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=a|0;f=c[e>>2]|0;g=f;h=(c[d>>2]|0)-g|0;i=h>>2;j=i+1|0;if(j>>>0>1073741823>>>0){Hu(0)}k=a+8|0;a=(c[k>>2]|0)-g|0;if(a>>2>>>0>536870910>>>0){l=1073741823;m=5}else{g=a>>1;a=g>>>0<j>>>0?j:g;if((a|0)==0){n=0;o=0}else{l=a;m=5}}if((m|0)==5){n=J0(l<<2)|0;o=l}l=n+(i<<2)|0;if((l|0)!=0){c[l>>2]=c[b>>2]}b=f;Kb(n|0,b|0,h)|0;c[e>>2]=n;c[d>>2]=n+(j<<2);c[k>>2]=n+(o<<2);if((f|0)==0){return}J2(b);return}function iG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c[b+4>>2]|0;if((e|0)==0){f=0;return f|0}b=a[d]|0;g=b&255;h=(g&1|0)==0;i=g>>>1;g=(b&1)==0;b=d+1|0;j=d+8|0;k=d+4|0;d=e;while(1){e=d+16|0;if(h){l=i}else{l=c[k>>2]|0}m=e;n=a[e]|0;e=n&255;o=(e&1|0)==0;if(o){p=e>>>1}else{p=c[d+20>>2]|0}if(g){q=b}else{q=c[j>>2]|0}r=(n&1)==0;if(r){s=m+1|0}else{s=c[d+24>>2]|0}n=Kd(q|0,s|0,(p>>>0<l>>>0?p:l)|0)|0;if((n|0)==0){if(l>>>0<p>>>0){t=16}else{t=17}}else{if((n|0)<0){t=16}else{t=17}}if((t|0)==17){t=0;if(o){u=e>>>1}else{u=c[d+20>>2]|0}if(h){v=i}else{v=c[k>>2]|0}if(r){w=m+1|0}else{w=c[d+24>>2]|0}if(g){x=b}else{x=c[j>>2]|0}m=Kd(w|0,x|0,(v>>>0<u>>>0?v:u)|0)|0;if((m|0)==0){if(u>>>0>=v>>>0){f=1;t=33;break}}else{if((m|0)>=0){f=1;t=36;break}}y=d+4|0}else if((t|0)==16){t=0;y=d|0}m=c[y>>2]|0;if((m|0)==0){f=0;t=34;break}else{d=m}}if((t|0)==34){return f|0}else if((t|0)==36){return f|0}else if((t|0)==33){return f|0}return 0}function iH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=d;g=(e-f|0)/12|0;h=b+8|0;i=c[h>>2]|0;j=b|0;k=c[j>>2]|0;l=k;if(g>>>0>((i-l|0)/12|0)>>>0){if((k|0)==0){m=i}else{i=b+4|0;n=c[i>>2]|0;if((k|0)==(n|0)){o=k}else{p=n;while(1){n=p-12|0;c[i>>2]=n;if((a[n]&1)==0){q=n}else{J2(c[p-12+8>>2]|0);q=c[i>>2]|0}if((k|0)==(q|0)){break}else{p=q}}o=c[j>>2]|0}J2(o);c[h>>2]=0;c[i>>2]=0;c[j>>2]=0;m=0}if(g>>>0>357913941>>>0){Hu(0)}i=(m|0)/12|0;do{if(i>>>0>178956969>>>0){r=357913941}else{m=i<<1;o=m>>>0<g>>>0?g:m;if(o>>>0<=357913941>>>0){r=o;break}Hu(0)}}while(0);i=J0(r*12|0)|0;o=b+4|0;c[o>>2]=i;c[j>>2]=i;c[h>>2]=i+(r*12|0);if((d|0)==(e|0)){return}else{s=d;t=i}L23:while(1){do{if((t|0)!=0){i=s;if((a[i]&1)==0){r=t;c[r>>2]=c[i>>2];c[r+4>>2]=c[i+4>>2];c[r+8>>2]=c[i+8>>2];break}i=c[s+8>>2]|0;r=c[s+4>>2]|0;if(r>>>0>4294967279>>>0){u=42;break L23}if(r>>>0<11>>>0){a[t]=r<<1;v=t+1|0}else{h=r+16&-16;j=J0(h)|0;c[t+8>>2]=j;c[t>>2]=h|1;c[t+4>>2]=r;v=j}Kb(v|0,i|0,r)|0;a[v+r|0]=0}}while(0);r=(c[o>>2]|0)+12|0;c[o>>2]=r;i=s+12|0;if((i|0)==(e|0)){u=50;break}else{s=i;t=r}}if((u|0)==50){return}else if((u|0)==42){CJ(0)}}t=b+4|0;b=((c[t>>2]|0)-l|0)/12|0;if(g>>>0>b>>>0){w=1;x=d+(b*12|0)|0}else{w=0;x=e}if((x|0)==(d|0)){y=k}else{b=(((x-12+(-f|0)|0)>>>0)/12|0)+1|0;f=k;g=d;while(1){CQ(f,g)|0;d=g+12|0;if((d|0)==(x|0)){break}else{f=f+12|0;g=d}}y=k+(b*12|0)|0}if(!w){w=c[t>>2]|0;if((y|0)==(w|0)){return}else{z=w}while(1){w=z-12|0;c[t>>2]=w;if((a[w]&1)==0){A=w}else{J2(c[z-12+8>>2]|0);A=c[t>>2]|0}if((y|0)==(A|0)){break}else{z=A}}return}if((x|0)==(e|0)){return}A=x;x=c[t>>2]|0;L63:while(1){do{if((x|0)!=0){z=A;if((a[z]&1)==0){y=x;c[y>>2]=c[z>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];break}z=c[A+8>>2]|0;y=c[A+4>>2]|0;if(y>>>0>4294967279>>>0){u=16;break L63}if(y>>>0<11>>>0){a[x]=y<<1;B=x+1|0}else{w=y+16&-16;b=J0(w)|0;c[x+8>>2]=b;c[x>>2]=w|1;c[x+4>>2]=y;B=b}Kb(B|0,z|0,y)|0;a[B+y|0]=0}}while(0);y=(c[t>>2]|0)+12|0;c[t>>2]=y;z=A+12|0;if((z|0)==(e|0)){u=54;break}else{A=z;x=y}}if((u|0)==54){return}else if((u|0)==16){CJ(0)}}function iI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=b|0;f=c[e>>2]|0;g=b+4|0;h=c[g>>2]|0;i=d+4|0;j=c[i>>2]|0;do{if((h|0)==(f|0)){k=f;l=j}else{m=h;n=j;L2:while(1){o=n-12|0;p=m-12|0;do{if((o|0)!=0){q=p;if((a[q]&1)==0){r=o;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];break}q=c[m-12+8>>2]|0;r=c[m-12+4>>2]|0;if(r>>>0>4294967279>>>0){s=6;break L2}if(r>>>0<11>>>0){a[o]=r<<1;t=o+1|0}else{u=r+16&-16;v=J0(u)|0;c[n-12+8>>2]=v;c[o>>2]=u|1;c[n-12+4>>2]=r;t=v}Kb(t|0,q|0,r)|0;a[t+r|0]=0}}while(0);w=(c[i>>2]|0)-12|0;c[i>>2]=w;if((p|0)==(f|0)){s=12;break}else{m=p;n=w}}if((s|0)==6){CJ(0)}else if((s|0)==12){k=c[e>>2]|0;l=w;break}}}while(0);c[e>>2]=l;c[i>>2]=k;k=d+8|0;l=c[g>>2]|0;c[g>>2]=c[k>>2];c[k>>2]=l;l=b+8|0;b=d+12|0;k=c[l>>2]|0;c[l>>2]=c[b>>2];c[b>>2]=k;c[d>>2]=c[i>>2];return}function iJ(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function iK(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function iL(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+148>>2]&1023](b,a);return}function iM(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+148>>2]&1023](b,a)|0}function iN(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+148>>2]&1023](b,a)|0}function iO(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+148>>2]&1023](b,a)|0}function iP(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+148>>2]&1023](b,a)|0}function iQ(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+148>>2]&511](a,d,b);return}function iR(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+148>>2]&511](a,d,b);return}function iS(a){a=a|0;return 0}function iT(b,c){b=b|0;c=c|0;c=b;a[b]=8;b=c+1|0;C=1819047278;a[b]=C;C=C>>8;a[b+1|0]=C;C=C>>8;a[b+2|0]=C;C=C>>8;a[b+3|0]=C;a[c+5|0]=0;return}function iU(a){a=a|0;return 1}function iV(a){a=a|0;return 1}function iW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=b|0;c[d>>2]=17568;e=b+60|0;f=c[e>>2]|0;if((f|0)!=0){g=b+64|0;h=c[g>>2]|0;if((f|0)==(h|0)){i=f}else{j=h;while(1){h=j-12|0;c[g>>2]=h;if((a[h]&1)==0){k=h}else{J2(c[j-12+8>>2]|0);k=c[g>>2]|0}if((f|0)==(k|0)){break}else{j=k}}i=c[e>>2]|0}J2(i)}i=b+48|0;e=c[i>>2]|0;if((e|0)!=0){k=b+52|0;j=c[k>>2]|0;if((e|0)==(j|0)){l=e}else{f=j;while(1){j=f-12|0;c[k>>2]=j;if((a[j]&1)==0){m=j}else{J2(c[f-12+8>>2]|0);m=c[k>>2]|0}if((e|0)==(m|0)){break}else{f=m}}l=c[i>>2]|0}J2(l)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function iX(a){a=a|0;var b=0;x=0;ap(486,a|0);if(!x){J2(a);return}else{x=0;b=bQ(-1,-1)|0;J2(a);be(b|0)}}function iY(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+120>>2]&1023](b,a);return}function iZ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+120>>2]&1023](b,a)|0}function i_(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+120>>2]&1023](b,a)|0}function i$(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+120>>2]&1023](b,a)|0}function i0(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+120>>2]&1023](b,a)|0}function i1(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+120>>2]&511](a,d,b);return}function i2(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+120>>2]&511](a,d,b);return}function i3(b,c){b=b|0;c=c|0;c=b;a[b]=12;b=c+1|0;a[b]=a[7304]|0;a[b+1|0]=a[7305]|0;a[b+2|0]=a[7306]|0;a[b+3|0]=a[7307]|0;a[b+4|0]=a[7308]|0;a[b+5|0]=a[7309]|0;a[c+7|0]=0;return}function i4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+40|0;f=e|0;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;a[g]=d;d=h|0;a[d]=0;c[h+4>>2]=b;l=b;m=c[(c[l>>2]|0)-12>>2]|0;n=b;L1:do{if((c[n+(m+16)>>2]|0)==0){o=c[n+(m+72)>>2]|0;if((o|0)!=0){x=0,as(56,o|0)|0;if(x){x=0;p=15;break}}a[d]=1;o=c[(c[l>>2]|0)-12>>2]|0;c[j>>2]=c[n+(o+24)>>2];q=n+o|0;r=g+1|0;s=(c[n+(o+4)>>2]&176|0)==32?r:g;t=n+(o+76)|0;o=c[t>>2]|0;u=o&255;L6:do{if((o|0)==-1){x=0;aq(346,f|0,q|0);if(x){x=0;p=16;break}v=(x=0,aK(196,f|0,40280)|0);do{if(!x){w=(x=0,aK(c[(c[v>>2]|0)+28>>2]|0,v|0,32)|0);if(x){x=0;break}x=0;ap(388,f|0);if(x){x=0;p=16;break L6}c[t>>2]=w<<24>>24;y=w;p=12;break L6}else{x=0}}while(0);v=bQ(-1,-1,0)|0;w=K;x=0;ap(388,f|0);if(!x){z=w;A=v;break}else{x=0}bQ(-1,-1,0)|0;bU();return 0}else{y=u;p=12}}while(0);do{if((p|0)==12){x=0;aG(56,k|0,j|0,g|0,s|0,r|0,q|0,y|0);if(x){x=0;p=16;break}if((c[k>>2]|0)!=0){p=18;break L1}u=c[(c[l>>2]|0)-12>>2]|0;x=0;aq(362,n+u|0,c[n+(u+16)>>2]|5|0);if(!x){p=18;break L1}else{x=0;p=16}}}while(0);if((p|0)==16){q=bQ(-1,-1,0)|0;z=K;A=q}x=0;ap(138,h|0);if(!x){B=A;break}else{x=0}C=bQ(-1,-1,0)|0;D=K;bU();return 0}else{p=18}}while(0);do{if((p|0)==18){x=0;ap(138,h|0);if(x){x=0;p=15;break}i=e;return b|0}}while(0);if((p|0)==15){p=bQ(-1,-1,0)|0;B=p}bA(B|0)|0;x=0;ap(178,n+(c[(c[l>>2]|0)-12>>2]|0)|0);if(!x){aZ();i=e;return b|0}else{x=0}b=bQ(-1,-1)|0;x=0;aQ(2);if(!x){be(b|0)}else{x=0;C=bQ(-1,-1,0)|0;D=K;bU();return 0}return 0}function i5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=e|0;g=b+8|0;h=c[b>>2]|0;if((((c[g>>2]|0)-h|0)/12|0)>>>0>=d>>>0){i=e;return}j=((c[b+4>>2]|0)-h|0)/12|0;h=f+12|0;c[h>>2]=0;c[f+16>>2]=g;if((d|0)==0){k=0}else{k=J0(d*12|0)|0}g=f|0;c[g>>2]=k;l=k+(j*12|0)|0;j=f+8|0;c[j>>2]=l;m=f+4|0;c[m>>2]=l;c[h>>2]=k+(d*12|0);x=0;aq(466,b|0,f|0);if(!x){f=c[m>>2]|0;b=c[j>>2]|0;if((f|0)!=(b|0)){d=b;while(1){b=d-12|0;c[j>>2]=b;if((a[b]&1)!=0){J2(c[d-12+8>>2]|0)}if((f|0)==(b|0)){break}else{d=b}}}d=c[g>>2]|0;if((d|0)==0){i=e;return}J2(d);i=e;return}else{x=0;e=bQ(-1,-1)|0;d=c[m>>2]|0;m=c[j>>2]|0;if((d|0)!=(m|0)){f=m;while(1){m=f-12|0;c[j>>2]=m;if((a[m]&1)!=0){J2(c[f-12+8>>2]|0)}if((d|0)==(m|0)){break}else{f=m}}}f=c[g>>2]|0;if((f|0)==0){be(e|0)}J2(f);be(e|0)}}function i6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+32|0;g=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];g=f|0;h=f+16|0;j=b|0;k=d;if((a[k]&1)==0){l=g;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2]}else{k=c[d+8>>2]|0;l=c[d+4>>2]|0;if(l>>>0>4294967279>>>0){CJ(0)}if(l>>>0<11>>>0){a[g]=l<<1;m=g+1|0}else{d=l+16&-16;n=J0(d)|0;c[g+8>>2]=n;c[g>>2]=d|1;c[g+4>>2]=l;m=n}Kb(m|0,k|0,l)|0;a[m+l|0]=0}l=h;m=e;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];x=0;aB(6,j|0,g|0,h|0,0,0,0);if(!x){if((a[g]&1)==0){o=b+36|0;p=b+40|0;c[p>>2]=0;q=b+44|0;c[q>>2]=0;r=b+48|0;c[r>>2]=0;s=b|0;c[s>>2]=16320;c[o>>2]=16384;t=b+52|0;a[t]=0;u=b+53|0;a[u]=0;i=f;return}J2(c[g+8>>2]|0);o=b+36|0;p=b+40|0;c[p>>2]=0;q=b+44|0;c[q>>2]=0;r=b+48|0;c[r>>2]=0;s=b|0;c[s>>2]=16320;c[o>>2]=16384;t=b+52|0;a[t]=0;u=b+53|0;a[u]=0;i=f;return}else{x=0;f=bQ(-1,-1)|0;if((a[g]&1)==0){be(f|0)}J2(c[g+8>>2]|0);be(f|0)}}function i7(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+36>>2]=21488;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function i8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+36>>2]=21488;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){h=b;J2(h);return}J2(c[b+12>>2]|0);h=b;J2(h);return}function i9(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+164>>2]&1023](b,a);return}function ja(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+164>>2]&1023](b,a)|0}function jb(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+164>>2]&1023](b,a)|0}function jc(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+164>>2]&1023](b,a)|0}function jd(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+164>>2]&1023](b,a)|0}function je(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+164>>2]&511](a,d,b);return}function jf(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+164>>2]&511](a,d,b);return}function jg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0;e=i;i=i+256|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=d+40|0;if((a[w]&1)==0){y=f;c[y>>2]=c[w>>2];c[y+4>>2]=c[w+4>>2];c[y+8>>2]=c[w+8>>2];z=a[y]|0;A=y}else{y=c[d+48>>2]|0;w=c[d+44>>2]|0;if(w>>>0>4294967279>>>0){CJ(0)}if(w>>>0<11>>>0){B=w<<1&255;C=f;a[C]=B;D=f+1|0;E=B;F=C}else{C=w+16&-16;B=J0(C)|0;c[f+8>>2]=B;G=C|1;c[f>>2]=G;c[f+4>>2]=w;D=B;E=G&255;F=f}Kb(D|0,y|0,w)|0;a[D+w|0]=0;z=E;A=F}F=z&255;if((F&1|0)==0){H=F>>>1}else{H=c[f+4>>2]|0}if((a[A]&1)!=0){J2(c[f+8>>2]|0)}if((H|0)!=0){L21:do{if((a[b+53|0]&1)!=0){H=J0(64)|0;f=g+8|0;c[f>>2]=H;c[g>>2]=65;c[g+4>>2]=53;Kb(H|0,7048,53)|0;a[H+53|0]=0;H=d+4|0;L23:do{if((a[H]&1)==0){A=h;c[A>>2]=c[H>>2];c[A+4>>2]=c[H+4>>2];c[A+8>>2]=c[H+8>>2];I=26}else{A=c[d+12>>2]|0;F=c[d+8>>2]|0;do{if(F>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(F>>>0<11>>>0){a[h]=F<<1;J=h+1|0}else{z=F+16&-16;E=(x=0,as(230,z|0)|0);if(x){x=0;break}c[h+8>>2]=E;c[h>>2]=z|1;c[h+4>>2]=F;J=E}Kb(J|0,A|0,F)|0;a[J+F|0]=0;I=26;break L23}}while(0);F=bQ(-1,-1)|0;L=K;M=F}}while(0);do{if((I|0)==26){H=j;F=d+16|0;c[H>>2]=c[F>>2];c[H+4>>2]=c[F+4>>2];c[H+8>>2]=c[F+8>>2];x=0;aP(362,g|0,h|0,j|0);if(x){x=0;F=bQ(-1,-1)|0;H=F;F=K;if((a[h]&1)==0){L=F;M=H;break}J2(c[h+8>>2]|0);L=F;M=H;break}if((a[h]&1)!=0){J2(c[h+8>>2]|0)}if((a[g]&1)==0){break L21}J2(c[f>>2]|0);break L21}}while(0);if((a[g]&1)==0){N=L;O=M;P=O;Q=0;R=P;S=N;be(R|0)}J2(c[f>>2]|0);N=L;O=M;P=O;Q=0;R=P;S=N;be(R|0)}}while(0);a[b+52|0]=1;i=e;return}M=b+53|0;L=(a[M]&1)!=0;if((a[d+52|0]&1)!=0){L56:do{if(L){g=J0(80)|0;h=k+8|0;c[h>>2]=g;c[k>>2]=81;c[k+4>>2]=73;Kb(g|0,6872,73)|0;a[g+73|0]=0;g=d+4|0;L58:do{if((a[g]&1)==0){j=l;c[j>>2]=c[g>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];I=49}else{j=c[d+12>>2]|0;J=c[d+8>>2]|0;do{if(J>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(J>>>0<11>>>0){a[l]=J<<1;T=l+1|0}else{H=J+16&-16;F=(x=0,as(230,H|0)|0);if(x){x=0;break}c[l+8>>2]=F;c[l>>2]=H|1;c[l+4>>2]=J;T=F}Kb(T|0,j|0,J)|0;a[T+J|0]=0;I=49;break L58}}while(0);J=bQ(-1,-1)|0;U=K;V=J}}while(0);do{if((I|0)==49){g=m;f=d+16|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];x=0;aP(362,k|0,l|0,m|0);if(x){x=0;f=bQ(-1,-1)|0;g=f;f=K;if((a[l]&1)==0){U=f;V=g;break}J2(c[l+8>>2]|0);U=f;V=g;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}if((a[k]&1)==0){break L56}J2(c[h>>2]|0);break L56}}while(0);if((a[k]&1)==0){N=U;O=V;P=O;Q=0;R=P;S=N;be(R|0)}J2(c[h>>2]|0);N=U;O=V;P=O;Q=0;R=P;S=N;be(R|0)}}while(0);L87:do{if((a[b+52|0]&1)!=0){V=J0(96)|0;U=n+8|0;c[U>>2]=V;c[n>>2]=97;c[n+4>>2]=94;Kb(V|0,6568,94)|0;a[V+94|0]=0;V=d+4|0;L89:do{if((a[V]&1)==0){k=o;c[k>>2]=c[V>>2];c[k+4>>2]=c[V+4>>2];c[k+8>>2]=c[V+8>>2];I=70}else{k=c[d+12>>2]|0;l=c[d+8>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(l>>>0<11>>>0){a[o]=l<<1;W=o+1|0}else{m=l+16&-16;T=(x=0,as(230,m|0)|0);if(x){x=0;break}c[o+8>>2]=T;c[o>>2]=m|1;c[o+4>>2]=l;W=T}Kb(W|0,k|0,l)|0;a[W+l|0]=0;I=70;break L89}}while(0);l=bQ(-1,-1)|0;X=K;Y=l}}while(0);do{if((I|0)==70){V=p;h=d+16|0;c[V>>2]=c[h>>2];c[V+4>>2]=c[h+4>>2];c[V+8>>2]=c[h+8>>2];x=0;aP(362,n|0,o|0,p|0);if(x){x=0;h=bQ(-1,-1)|0;V=h;h=K;if((a[o]&1)==0){X=h;Y=V;break}J2(c[o+8>>2]|0);X=h;Y=V;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)==0){break L87}J2(c[U>>2]|0);break L87}}while(0);if((a[n]&1)==0){N=X;O=Y;P=O;Q=0;R=P;S=N;be(R|0)}J2(c[U>>2]|0);N=X;O=Y;P=O;Q=0;R=P;S=N;be(R|0)}}while(0);a[M]=1;i=e;return}L120:do{if(L){M=J0(64)|0;Y=q+8|0;c[Y>>2]=M;c[q>>2]=65;c[q+4>>2]=56;Kb(M|0,6384,56)|0;a[M+56|0]=0;M=d+4|0;L122:do{if((a[M]&1)==0){X=r;c[X>>2]=c[M>>2];c[X+4>>2]=c[M+4>>2];c[X+8>>2]=c[M+8>>2];I=92}else{X=c[d+12>>2]|0;n=c[d+8>>2]|0;do{if(n>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(n>>>0<11>>>0){a[r]=n<<1;Z=r+1|0}else{o=n+16&-16;p=(x=0,as(230,o|0)|0);if(x){x=0;break}c[r+8>>2]=p;c[r>>2]=o|1;c[r+4>>2]=n;Z=p}Kb(Z|0,X|0,n)|0;a[Z+n|0]=0;I=92;break L122}}while(0);n=bQ(-1,-1)|0;_=K;$=n}}while(0);do{if((I|0)==92){M=s;U=d+16|0;c[M>>2]=c[U>>2];c[M+4>>2]=c[U+4>>2];c[M+8>>2]=c[U+8>>2];x=0;aP(362,q|0,r|0,s|0);if(x){x=0;U=bQ(-1,-1)|0;M=U;U=K;if((a[r]&1)==0){_=U;$=M;break}J2(c[r+8>>2]|0);_=U;$=M;break}if((a[r]&1)!=0){J2(c[r+8>>2]|0)}if((a[q]&1)==0){break L120}J2(c[Y>>2]|0);break L120}}while(0);if((a[q]&1)==0){N=_;O=$;P=O;Q=0;R=P;S=N;be(R|0)}J2(c[Y>>2]|0);N=_;O=$;P=O;Q=0;R=P;S=N;be(R|0)}}while(0);if((a[b+52|0]&1)==0){i=e;return}b=J0(48)|0;$=t+8|0;c[$>>2]=b;c[t>>2]=49;c[t+4>>2]=46;Kb(b|0,6152,46)|0;a[b+46|0]=0;b=d+4|0;L154:do{if((a[b]&1)==0){_=u;c[_>>2]=c[b>>2];c[_+4>>2]=c[b+4>>2];c[_+8>>2]=c[b+8>>2];I=113}else{_=c[d+12>>2]|0;q=c[d+8>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(q>>>0<11>>>0){a[u]=q<<1;aa=u+1|0}else{r=q+16&-16;s=(x=0,as(230,r|0)|0);if(x){x=0;break}c[u+8>>2]=s;c[u>>2]=r|1;c[u+4>>2]=q;aa=s}Kb(aa|0,_|0,q)|0;a[aa+q|0]=0;I=113;break L154}}while(0);q=bQ(-1,-1)|0;ab=K;ac=q}}while(0);do{if((I|0)==113){aa=v;b=d+16|0;c[aa>>2]=c[b>>2];c[aa+4>>2]=c[b+4>>2];c[aa+8>>2]=c[b+8>>2];x=0;aP(362,t|0,u|0,v|0);if(x){x=0;b=bQ(-1,-1)|0;aa=b;b=K;if((a[u]&1)==0){ab=b;ac=aa;break}J2(c[u+8>>2]|0);ab=b;ac=aa;break}if((a[u]&1)!=0){J2(c[u+8>>2]|0)}if((a[t]&1)==0){i=e;return}J2(c[$>>2]|0);i=e;return}}while(0);if((a[t]&1)==0){N=ab;O=ac;P=O;Q=0;R=P;S=N;be(R|0)}J2(c[$>>2]|0);N=ab;O=ac;P=O;Q=0;R=P;S=N;be(R|0)}function jh(a,b){a=a|0;b=b|0;jg(a-56+20|0,b);return}function ji(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-56+20|0;c[d+36>>2]=21488;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){return}J2(c[d+12>>2]|0);return}function jj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-56+20|0;c[d+36>>2]=21488;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){h=d;J2(h);return}J2(c[d+12>>2]|0);h=d;J2(h);return}function jk(a,b){a=a|0;b=b|0;return}function jl(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0;k=i;i=i+80|0;l=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[l>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=k+32|0;o=k+48|0;p=k+64|0;q=b|0;r=e;if((a[r]&1)==0){s=l;c[s>>2]=c[r>>2];c[s+4>>2]=c[r+4>>2];c[s+8>>2]=c[r+8>>2]}else{r=c[e+8>>2]|0;s=c[e+4>>2]|0;if(s>>>0>4294967279>>>0){CJ(0)}if(s>>>0<11>>>0){a[l]=s<<1;t=l+1|0}else{e=s+16&-16;u=J0(e)|0;c[l+8>>2]=u;c[l>>2]=e|1;c[l+4>>2]=s;t=u}Kb(t|0,r|0,s)|0;a[t+s|0]=0}s=m;t=f;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];x=0;aB(6,q|0,l|0,m|0,0,0,0);if(x){x=0;m=bQ(-1,-1)|0;q=m;m=K;if((a[l]&1)==0){v=m;w=q;y=w;z=0;A=y;B=v;be(A|0)}J2(c[l+8>>2]|0);v=m;w=q;y=w;z=0;A=y;B=v;be(A|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}l=b|0;c[l>>2]=16544;c[b+36>>2]=g;g=b+40|0;q=h;L22:do{if((a[q]&1)==0){m=g;c[m>>2]=c[q>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];C=m;D=22}else{m=c[h+8>>2]|0;t=c[h+4>>2]|0;do{if(t>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(t>>>0<11>>>0){s=g;a[s]=t<<1;E=g+1|0;F=s}else{s=t+16&-16;f=(x=0,as(230,s|0)|0);if(x){x=0;break}c[b+48>>2]=f;c[g>>2]=s|1;c[b+44>>2]=t;E=f;F=g}Kb(E|0,m|0,t)|0;a[E+t|0]=0;C=F;D=22;break L22}}while(0);t=bQ(-1,-1)|0;G=K;H=t}}while(0);do{if((D|0)==22){a[b+52|0]=j&1;F=d[C]|0;if((F&1|0)==0){I=F>>>1}else{I=c[b+44>>2]|0}if((I|0)==0|j^1){i=k;return}F=(x=0,as(230,64)|0);do{if(!x){E=n+8|0;c[E>>2]=F;c[n>>2]=65;c[n+4>>2]=50;Kb(F|0,5960,50)|0;a[F+50|0]=0;g=b+4|0;L46:do{if((a[g]&1)==0){h=o;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];D=37}else{h=c[b+12>>2]|0;q=c[b+8>>2]|0;do{if(q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(q>>>0<11>>>0){a[o]=q<<1;J=o+1|0}else{t=q+16&-16;m=(x=0,as(230,t|0)|0);if(x){x=0;break}c[o+8>>2]=m;c[o>>2]=t|1;c[o+4>>2]=q;J=m}Kb(J|0,h|0,q)|0;a[J+q|0]=0;D=37;break L46}}while(0);q=bQ(-1,-1)|0;L=K;M=q}}while(0);do{if((D|0)==37){g=p;q=b+16|0;c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];x=0;aP(362,n|0,o|0,p|0);if(x){x=0;q=bQ(-1,-1)|0;g=q;q=K;if((a[o]&1)==0){L=q;M=g;break}J2(c[o+8>>2]|0);L=q;M=g;break}if((a[o]&1)!=0){J2(c[o+8>>2]|0)}if((a[n]&1)==0){i=k;return}J2(c[E>>2]|0);i=k;return}}while(0);if((a[n]&1)==0){N=L;O=M;break}J2(c[E>>2]|0);N=L;O=M}else{x=0;g=bQ(-1,-1)|0;N=K;O=g}}while(0);if((a[C]&1)==0){G=N;H=O;break}J2(c[b+48>>2]|0);G=N;H=O}}while(0);c[l>>2]=16616;if((a[b+4|0]&1)==0){v=G;w=H;y=w;z=0;A=y;B=v;be(A|0)}J2(c[b+12>>2]|0);v=G;w=H;y=w;z=0;A=y;B=v;be(A|0)}function jm(b){b=b|0;var d=0;d=b|0;c[d>>2]=16544;if((a[b+40|0]&1)!=0){J2(c[b+48>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function jn(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=16544;if((a[b+40|0]&1)!=0){J2(c[b+48>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function jo(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+160>>2]&1023](b,a);return}function jp(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+160>>2]&1023](b,a)|0}function jq(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+160>>2]&1023](b,a)|0}function jr(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+160>>2]&1023](b,a)|0}function js(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+160>>2]&1023](b,a)|0}function jt(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+160>>2]&511](a,d,b);return}function ju(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+160>>2]&511](a,d,b);return}function jv(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function jw(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function jx(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+144>>2]&1023](b,a);return}function jy(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+144>>2]&1023](b,a)|0}function jz(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+144>>2]&1023](b,a)|0}function jA(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+144>>2]&1023](b,a)|0}function jB(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+144>>2]&1023](b,a)|0}function jC(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+144>>2]&511](a,d,b);return}function jD(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+144>>2]&511](a,d,b);return}function jE(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+32|0;l=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=b|0;o=d;if((a[o]&1)==0){p=l;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{o=c[d+8>>2]|0;p=c[d+4>>2]|0;if(p>>>0>4294967279>>>0){CJ(0)}if(p>>>0<11>>>0){a[l]=p<<1;q=l+1|0}else{d=p+16&-16;r=J0(d)|0;c[l+8>>2]=r;c[l>>2]=d|1;c[l+4>>2]=p;q=r}Kb(q|0,o|0,p)|0;a[q+p|0]=0}p=m;q=e;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];x=0;aB(6,n|0,l|0,m|0,0,0,0);if(x){x=0;m=bQ(-1,-1)|0;n=m;m=K;if((a[l]&1)==0){s=m;t=n;u=t;v=0;w=u;y=s;be(w|0)}J2(c[l+8>>2]|0);s=m;t=n;u=t;v=0;w=u;y=s;be(w|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}l=b+36|0;c[l>>2]=21520;n=b+40|0;c[n>>2]=0;m=b+44|0;c[m>>2]=0;q=b+48|0;c[q>>2]=0;if((g|0)==0){z=b|0;c[z>>2]=21144;c[l>>2]=21204;A=b+52|0;c[A>>2]=f;B=b+56|0;C=h&1;a[B]=C;D=b+57|0;E=j&1;a[D]=E;i=k;return}p=(x=0,as(230,g<<2|0)|0);if(!x){e=p;c[n>>2]=e;c[m>>2]=e;c[q>>2]=e+(g<<2);z=b|0;c[z>>2]=21144;c[l>>2]=21204;A=b+52|0;c[A>>2]=f;B=b+56|0;C=h&1;a[B]=C;D=b+57|0;E=j&1;a[D]=E;i=k;return}else{x=0}k=bQ(-1,-1)|0;E=k;k=K;c[b>>2]=16616;if((a[b+4|0]&1)==0){s=k;t=E;u=t;v=0;w=u;y=s;be(w|0)}J2(c[b+12>>2]|0);s=k;t=E;u=t;v=0;w=u;y=s;be(w|0)}function jF(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+36>>2]=21520;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function jG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+36>>2]=21520;d=c[b+40>>2]|0;e=d;if((d|0)!=0){f=b+44|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){h=b;J2(h);return}J2(c[b+12>>2]|0);h=b;J2(h);return}function jH(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+140>>2]&1023](b,a);return}function jI(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+140>>2]&1023](b,a)|0}function jJ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+140>>2]&1023](b,a)|0}function jK(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+140>>2]&1023](b,a)|0}function jL(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+140>>2]&1023](b,a)|0}function jM(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+140>>2]&511](a,d,b);return}function jN(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+140>>2]&511](a,d,b);return}function jO(a,b){a=a|0;b=b|0;return}function jP(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-60+24|0;c[d+36>>2]=21520;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){return}J2(c[d+12>>2]|0);return}function jQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-60+24|0;c[d+36>>2]=21520;b=c[d+40>>2]|0;e=b;if((b|0)!=0){f=d+44|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){h=d;J2(h);return}J2(c[d+12>>2]|0);h=d;J2(h);return}function jR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0;e=b|0;c[e>>2]=16616;f=b+4|0;g=d+4|0;if((a[g]&1)==0){i=f;c[i>>2]=c[g>>2];c[i+4>>2]=c[g+4>>2];c[i+8>>2]=c[g+8>>2]}else{g=c[d+12>>2]|0;i=c[d+8>>2]|0;if(i>>>0>4294967279>>>0){CJ(0)}if(i>>>0<11>>>0){a[f]=i<<1;j=f+1|0}else{k=i+16&-16;l=J0(k)|0;c[b+12>>2]=l;c[f>>2]=k|1;c[b+8>>2]=i;j=l}Kb(j|0,g|0,i)|0;a[j+i|0]=0}i=b+16|0;j=d+16|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];c[e>>2]=21792;a[b+28|0]=a[d+28|0]&1;a[b+29|0]=a[d+29|0]&1;c[b+32>>2]=c[d+32>>2];c[e>>2]=18232;h[b+40>>3]=+h[d+40>>3];h[b+48>>3]=+h[d+48>>3];h[b+56>>3]=+h[d+56>>3];h[b+64>>3]=+h[d+64>>3];j=b+72|0;i=d+72|0;if((a[i]&1)==0){g=j;c[g>>2]=c[i>>2];c[g+4>>2]=c[i+4>>2];c[g+8>>2]=c[i+8>>2];return}i=c[d+80>>2]|0;g=c[d+76>>2]|0;do{if(g>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(g>>>0<11>>>0){a[j]=g<<1;m=j+1|0}else{d=g+16&-16;l=(x=0,as(230,d|0)|0);if(x){x=0;break}c[b+80>>2]=l;c[j>>2]=d|1;c[b+76>>2]=g;m=l}Kb(m|0,i|0,g)|0;a[m+g|0]=0;return}}while(0);g=bQ(-1,-1)|0;c[e>>2]=16616;if((a[f]&1)==0){be(g|0)}J2(c[b+12>>2]|0);be(g|0)}function jS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;j=i;i=i+32|0;k=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];k=j|0;l=j+16|0;m=b|0;n=d;if((a[n]&1)==0){o=k;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2]}else{n=c[d+8>>2]|0;o=c[d+4>>2]|0;if(o>>>0>4294967279>>>0){CJ(0)}if(o>>>0<11>>>0){a[k]=o<<1;p=k+1|0}else{d=o+16&-16;q=J0(d)|0;c[k+8>>2]=q;c[k>>2]=d|1;c[k+4>>2]=o;p=q}Kb(p|0,n|0,o)|0;a[p+o|0]=0}o=l;p=e;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];x=0;ao(8,m|0,k|0,l|0,g|0,0);if(x){x=0;g=bQ(-1,-1)|0;l=g;g=K;if((a[k]&1)==0){r=g;s=l;t=s;u=0;v=t;w=r;be(v|0)}J2(c[k+8>>2]|0);r=g;s=l;t=s;u=0;v=t;w=r;be(v|0)}if((a[k]&1)!=0){J2(c[k+8>>2]|0)}k=b+40|0;c[k>>2]=21616;l=b+44|0;c[l>>2]=0;g=b+48|0;c[g>>2]=0;m=b+52|0;c[m>>2]=0;if((f|0)==0){y=b|0;c[y>>2]=20440;c[k>>2]=20500;z=b+56|0;a[z]=h;i=j;return}p=(x=0,as(230,f<<2|0)|0);if(!x){o=p;c[l>>2]=o;c[g>>2]=o;c[m>>2]=o+(f<<2);y=b|0;c[y>>2]=20440;c[k>>2]=20500;z=b+56|0;a[z]=h;i=j;return}else{x=0}j=bQ(-1,-1)|0;h=j;j=K;c[b>>2]=16616;if((a[b+4|0]&1)==0){r=j;s=h;t=s;u=0;v=t;w=r;be(v|0)}J2(c[b+12>>2]|0);r=j;s=h;t=s;u=0;v=t;w=r;be(v|0)}function jT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=J0(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}Kb(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];x=0;aB(6,l|0,j|0,k|0,g|0,0,0);if(!x){if((a[j]&1)==0){q=b|0;c[q>>2]=17432;r=b+36|0;s=f&1;a[r]=s;t=b+32|0;c[t>>2]=4;i=h;return}J2(c[j+8>>2]|0);q=b|0;c[q>>2]=17432;r=b+36|0;s=f&1;a[r]=s;t=b+32|0;c[t>>2]=4;i=h;return}else{x=0;h=bQ(-1,-1)|0;if((a[j]&1)==0){be(h|0)}J2(c[j+8>>2]|0);be(h|0)}}function jU(b){b=b|0;var d=0,e=0,f=0,g=0;c[b+40>>2]=21616;d=c[b+44>>2]|0;e=d;if((d|0)!=0){f=b+48|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function jV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;c[b+40>>2]=21616;d=c[b+44>>2]|0;e=d;if((d|0)!=0){f=b+48|0;g=c[f>>2]|0;if((d|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(d)}c[b>>2]=16616;if((a[b+4|0]&1)==0){h=b;J2(h);return}J2(c[b+12>>2]|0);h=b;J2(h);return}function jW(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+132>>2]&1023](b,a);return}function jX(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+132>>2]&1023](b,a)|0}function jY(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+132>>2]&1023](b,a)|0}function jZ(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+132>>2]&1023](b,a)|0}function j_(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+132>>2]&1023](b,a)|0}function j$(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+132>>2]&511](a,d,b);return}function j0(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+132>>2]&511](a,d,b);return}function j1(b,c){b=b|0;c=c|0;c=b;a[b]=12;b=c+1|0;a[b]=a[5728]|0;a[b+1|0]=a[5729]|0;a[b+2|0]=a[5730]|0;a[b+3|0]=a[5731]|0;a[b+4|0]=a[5732]|0;a[b+5|0]=a[5733]|0;a[c+7|0]=0;return}function j2(b){b=b|0;var d=0,e=0,f=0,g=0;d=b-60+20|0;c[d+40>>2]=21616;b=c[d+44>>2]|0;e=b;if((b|0)!=0){f=d+48|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){return}J2(c[d+12>>2]|0);return}function j3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=b-60+20|0;c[d+40>>2]=21616;b=c[d+44>>2]|0;e=b;if((b|0)!=0){f=d+48|0;g=c[f>>2]|0;if((b|0)!=(g|0)){c[f>>2]=g+(~((g-4+(-e|0)|0)>>>2)<<2)}J2(b)}c[d>>2]=16616;if((a[d+4|0]&1)==0){h=d;J2(h);return}J2(c[d+12>>2]|0);h=d;J2(h);return}function j4(a,b){a=a|0;b=b|0;cy[c[c[b>>2]>>2]&1023](b,a|0);return}function j5(a,b){a=a|0;b=b|0;return cS[c[c[b>>2]>>2]&1023](b,a|0)|0}function j6(a,b){a=a|0;b=b|0;return cS[c[c[b>>2]>>2]&1023](b,a|0)|0}function j7(a,b){a=a|0;b=b|0;return cS[c[c[b>>2]>>2]&1023](b,a|0)|0}function j8(a,b){a=a|0;b=b|0;return cS[c[c[b>>2]>>2]&1023](b,a|0)|0}function j9(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[c[d>>2]>>2]&511](a,d,b|0);return}function ka(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[c[d>>2]>>2]&511](a,d,b|0);return}function kb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=J0(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}Kb(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];x=0;aB(6,l|0,j|0,k|0,0,0,0);if(x){x=0;k=bQ(-1,-1)|0;l=k;k=K;if((a[j]&1)==0){q=k;r=l;s=r;t=0;u=s;v=q;be(u|0)}J2(c[j+8>>2]|0);q=k;r=l;s=r;t=0;u=s;v=q;be(u|0)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}j=b|0;c[j>>2]=20840;l=b+36|0;k=f;if((a[k]&1)==0){o=l;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];w=b+48|0;c[w>>2]=g;y=b+32|0;c[y>>2]=4;i=h;return}k=c[f+8>>2]|0;o=c[f+4>>2]|0;do{if(o>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(o>>>0<11>>>0){a[l]=o<<1;z=l+1|0}else{f=o+16&-16;n=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+44>>2]=n;c[l>>2]=f|1;c[b+40>>2]=o;z=n}Kb(z|0,k|0,o)|0;a[z+o|0]=0;w=b+48|0;c[w>>2]=g;y=b+32|0;c[y>>2]=4;i=h;return}}while(0);h=bQ(-1,-1)|0;y=h;h=K;c[j>>2]=16616;if((a[b+4|0]&1)==0){q=h;r=y;s=r;t=0;u=s;v=q;be(u|0)}J2(c[b+12>>2]|0);q=h;r=y;s=r;t=0;u=s;v=q;be(u|0)}function kc(b){b=b|0;var d=0;d=b|0;c[d>>2]=20840;if((a[b+36|0]&1)!=0){J2(c[b+44>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function kd(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=20840;if((a[b+36|0]&1)!=0){J2(c[b+44>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function ke(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+104>>2]&1023](b,a);return}function kf(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+104>>2]&1023](b,a)|0}function kg(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+104>>2]&1023](b,a)|0}function kh(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+104>>2]&1023](b,a)|0}function ki(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+104>>2]&1023](b,a)|0}function kj(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+104>>2]&511](a,d,b);return}function kk(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+104>>2]&511](a,d,b);return}function kl(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=J0(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}Kb(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];x=0;ao(8,l|0,j|0,k|0,g|0,1);if(x){x=0;g=bQ(-1,-1)|0;k=g;g=K;if((a[j]&1)==0){q=g;r=k;s=r;t=0;u=s;v=q;be(u|0)}J2(c[j+8>>2]|0);q=g;r=k;s=r;t=0;u=s;v=q;be(u|0)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}j=b|0;c[j>>2]=20144;k=b+40|0;g=f;if((a[g]&1)==0){l=k;c[l>>2]=c[g>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];i=h;return}g=c[f+8>>2]|0;l=c[f+4>>2]|0;do{if(l>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(l>>>0<11>>>0){a[k]=l<<1;w=k+1|0}else{f=l+16&-16;o=(x=0,as(230,f|0)|0);if(x){x=0;break}c[b+48>>2]=o;c[k>>2]=f|1;c[b+44>>2]=l;w=o}Kb(w|0,g|0,l)|0;a[w+l|0]=0;i=h;return}}while(0);h=bQ(-1,-1)|0;l=h;h=K;c[j>>2]=16616;if((a[b+4|0]&1)==0){q=h;r=l;s=r;t=0;u=s;v=q;be(u|0)}J2(c[b+12>>2]|0);q=h;r=l;s=r;t=0;u=s;v=q;be(u|0)}function km(b){b=b|0;var d=0;d=b|0;c[d>>2]=20144;if((a[b+40|0]&1)!=0){J2(c[b+48>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function kn(b){b=b|0;var d=0,e=0;d=b|0;c[d>>2]=20144;if((a[b+40|0]&1)!=0){J2(c[b+48>>2]|0)}c[d>>2]=16616;if((a[b+4|0]&1)==0){e=b;J2(e);return}J2(c[b+12>>2]|0);e=b;J2(e);return}function ko(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+136>>2]&1023](b,a);return}function kp(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+136>>2]&1023](b,a)|0}function kq(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+136>>2]&1023](b,a)|0}function kr(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+136>>2]&1023](b,a)|0}function ks(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+136>>2]&1023](b,a)|0}function kt(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+136>>2]&511](a,d,b);return}function ku(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+136>>2]&511](a,d,b);return}function kv(b,c){b=b|0;c=c|0;c=b;a[b]=12;b=c+1|0;a[b]=a[5728]|0;a[b+1|0]=a[5729]|0;a[b+2|0]=a[5730]|0;a[b+3|0]=a[5731]|0;a[b+4|0]=a[5732]|0;a[b+5|0]=a[5733]|0;a[c+7|0]=0;return}function kw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0;h=i;i=i+32|0;j=e;e=i;i=i+12|0;i=i+7&-8;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];j=h|0;k=h+16|0;l=b|0;m=d;if((a[m]&1)==0){n=j;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2]}else{m=c[d+8>>2]|0;n=c[d+4>>2]|0;if(n>>>0>4294967279>>>0){CJ(0)}if(n>>>0<11>>>0){a[j]=n<<1;o=j+1|0}else{d=n+16&-16;p=J0(d)|0;c[j+8>>2]=p;c[j>>2]=d|1;c[j+4>>2]=n;o=p}Kb(o|0,m|0,n)|0;a[o+n|0]=0}n=k;o=e;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];x=0;ao(8,l|0,j|0,k|0,g|0,1);if(x){x=0;g=bQ(-1,-1)|0;k=g;g=K;if((a[j]&1)==0){q=g;r=k;s=r;t=0;u=s;v=q;be(u|0)}J2(c[j+8>>2]|0);q=g;r=k;s=r;t=0;u=s;v=q;be(u|0)}if((a[j]&1)!=0){J2(c[j+8>>2]|0)}j=b|0;c[j>>2]=20144;k=Kf(f|0)|0;g=b+40|0;do{if(k>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}}else{if(k>>>0<11>>>0){a[g]=k<<1;w=g+1|0;Kb(w|0,f|0,k)|0;y=w+k|0;a[y]=0;i=h;return}l=k+16&-16;o=(x=0,as(230,l|0)|0);if(x){x=0;break}c[b+48>>2]=o;c[g>>2]=l|1;c[b+44>>2]=k;w=o;Kb(w|0,f|0,k)|0;y=w+k|0;a[y]=0;i=h;return}}while(0);h=bQ(-1,-1)|0;y=h;h=K;c[j>>2]=16616;if((a[b+4|0]&1)==0){q=h;r=y;s=r;t=0;u=s;v=q;be(u|0)}J2(c[b+12>>2]|0);q=h;r=y;s=r;t=0;u=s;v=q;be(u|0)}function kx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=b|0;c[e>>2]=16616;f=b+4|0;g=d+4|0;if((a[g]&1)==0){i=f;c[i>>2]=c[g>>2];c[i+4>>2]=c[g+4>>2];c[i+8>>2]=c[g+8>>2]}else{g=c[d+12>>2]|0;i=c[d+8>>2]|0;if(i>>>0>4294967279>>>0){CJ(0)}if(i>>>0<11>>>0){a[f]=i<<1;j=f+1|0}else{k=i+16&-16;l=J0(k)|0;c[b+12>>2]=l;c[f>>2]=k|1;c[b+8>>2]=i;j=l}Kb(j|0,g|0,i)|0;a[j+i|0]=0}i=b+16|0;j=d+16|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];c[e>>2]=21792;a[b+28|0]=a[d+28|0]&1;a[b+29|0]=a[d+29|0]&1;c[b+32>>2]=c[d+32>>2];c[e>>2]=17568;h[b+40>>3]=+h[d+40>>3];j=b+48|0;x=0;aq(292,j|0,d+48|0);do{if(!x){x=0;aq(292,b+60|0,d+60|0);if(!x){return}else{x=0}i=bQ(-1,-1)|0;g=i;i=K;l=j|0;k=c[l>>2]|0;if((k|0)==0){m=i;n=g;break}o=b+52|0;p=c[o>>2]|0;if((k|0)==(p|0)){q=k}else{r=p;while(1){p=r-12|0;c[o>>2]=p;if((a[p]&1)==0){s=p}else{J2(c[r-12+8>>2]|0);s=c[o>>2]|0}if((k|0)==(s|0)){break}else{r=s}}q=c[l>>2]|0}J2(q);m=i;n=g}else{x=0;r=bQ(-1,-1)|0;m=K;n=r}}while(0);c[e>>2]=16616;if((a[f]&1)==0){t=n;u=0;v=t;w=m;be(v|0)}J2(c[b+12>>2]|0);t=n;u=0;v=t;w=m;be(v|0)}function ky(b){b=b|0;c[b>>2]=16616;if((a[b+4|0]&1)==0){return}J2(c[b+12>>2]|0);return}function kz(b){b=b|0;var d=0;c[b>>2]=16616;if((a[b+4|0]&1)==0){d=b;J2(d);return}J2(c[b+12>>2]|0);d=b;J2(d);return}function kA(a,b){a=a|0;b=b|0;cy[c[(c[b>>2]|0)+128>>2]&1023](b,a);return}function kB(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+128>>2]&1023](b,a)|0}function kC(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+128>>2]&1023](b,a)|0}function kD(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+128>>2]&1023](b,a)|0}function kE(a,b){a=a|0;b=b|0;return cS[c[(c[b>>2]|0)+128>>2]&1023](b,a)|0}function kF(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+128>>2]&511](a,d,b);return}function kG(a,b,d){a=a|0;b=b|0;d=d|0;cX[c[(c[d>>2]|0)+128>>2]&511](a,d,b);return}function kH(b){b=b|0;return(a[b+36|0]&1)!=0|0}function kI(b,c){b=b|0;c=c|0;c=b;a[b]=8;b=c+1|0;C=1819242338;a[b]=C;C=C>>8;a[b+1|0]=C;C=C>>8;a[b+2|0]=C;C=C>>8;a[b+3|0]=C;a[c+5|0]=0;return}function kJ(b){b=b|0;return(a[b+36|0]&1)==0|0}function kK(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+32|0;l=f;f=i;i=i+12|0;i=i+7&-8;c[f>>2]=c[l>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=k|0;m=k+16|0;n=b|0;o=e;if((a[o]&1)==0){p=l;c[p>>2]=c[o>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2]}else{o=c[e+8>>2]|0;p=c[e+4>>2]|0;if(p>>>0>4294967279>>>0){CJ(0)}if(p>>>0<11>>>0){a[l]=p<<1;q=l+1|0}else{e=p+16&-16;r=J0(e)|0;c[l+8>>2]=r;c[l>>2]=e|1;c[l+4>>2]=p;q=r}Kb(q|0,o|0,p)|0;a[q+p|0]=0}p=m;q=f;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];x=0;aB(6,n|0,l|0,m|0,0,0,0);if(x){x=0;m=bQ(-1,-1)|0;n=m;m=K;if((a[l]&1)==0){s=m;t=n;u=t;v=0;w=u;y=s;be(w|0)}J2(c[l+8>>2]|0);s=m;t=n;u=t;v=0;w=u;y=s;be(w|0)}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}l=b|0;c[l>>2]=17568;h[b+40>>3]=g;n=b+48|0;m=n|0;q=b+52|0;p=b+60|0;f=b+64|0;Ke(n|0,0,24)|0;o=d[j]|0;if((o&1|0)==0){z=o>>>1}else{z=c[j+4>>2]|0}if((z|0)==0){A=b+32|0;c[A>>2]=2;i=k;return}x=0;aq(282,n|0,j|0);if(!x){A=b+32|0;c[A>>2]=2;i=k;return}else{x=0}k=bQ(-1,-1)|0;A=k;k=K;j=c[p>>2]|0;if((j|0)!=0){n=c[f>>2]|0;if((j|0)==(n|0)){B=j}else{z=n;while(1){n=z-12|0;c[f>>2]=n;if((a[n]&1)==0){C=n}else{J2(c[z-12+8>>2]|0);C=c[f>>2]|0}if((j|0)==(C|0)){break}else{z=C}}B=c[p>>2]|0}J2(B)}B=c[m>>2]|0;if((B|0)!=0){p=c[q>>2]|0;if((B|0)==(p|0)){D=B}else{C=p;while(1){p=C-12|0;c[q>>2]=p;if((a[p]&1)==0){E=p}else{J2(c[C-12+8>>2]|0);E=c[q>>2]|0}if((B|0)==(E|0)){break}else{C=E}}D=c[m>>2]|0}J2(D)}c[l>>2]=16616;if((a[b+4|0]&1)==0){s=k;t=A;u=t;v=0;w=u;y=s;be(w|0)}J2(c[b+12>>2]|0);s=k;t=A;u=t;v=0;w=u;y=s;be(w|0)}function kL(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h|0;c[a>>2]=17936;c[a+4>>2]=b;c[a+8>>2]=d;c[a+12>>2]=e;c[a+16>>2]=f;f=a+20|0;e=a+24|0;d=a+32|0;b=a+36|0;k=a+44|0;l=a+48|0;Ke(f|0,0,36)|0;c[a+56>>2]=g;g=a+60|0;m=a+64|0;c[m>>2]=0;c[a+68>>2]=0;c[g>>2]=m;c[j>>2]=0;x=0;aq(6,k|0,j|0);if(!x){i=h;return}else{x=0}h=bQ(-1,-1)|0;fS(g|0,c[a+64>>2]|0);a=c[k>>2]|0;k=a;if((a|0)!=0){g=c[l>>2]|0;if((a|0)!=(g|0)){c[l>>2]=g+(~((g-4+(-k|0)|0)>>>2)<<2)}J2(a)}a=c[d>>2]|0;d=a;if((a|0)!=0){k=c[b>>2]|0;if((a|0)!=(k|0)){c[b>>2]=k+(~((k-4+(-d|0)|0)>>>2)<<2)}J2(a)}a=c[f>>2]|0;if((a|0)==0){be(h|0)}f=c[e>>2]|0;if((a|0)!=(f|0)){c[e>>2]=f+(~((f-4+(-a|0)|0)>>>2)<<2)}J2(a);be(h|0)}function kM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0;e=i;i=i+72|0;f=e|0;g=e+8|0;h=e+24|0;j=e+32|0;k=e+48|0;l=e+56|0;m=j+4|0;c[m>>2]=0;c[j+8>>2]=0;c[j>>2]=m;m=b+16|0;c[j+12>>2]=c[m>>2];c[m>>2]=j;n=c[b+4>>2]|0;o=(x=0,as(230,48)|0);L1:do{if(!x){p=o;c[h>>2]=p;q=n+4|0;r=c[q>>2]|0;if((r|0)==(c[n+8>>2]|0)){x=0;aq(376,n|0,h|0);if(x){x=0;s=43;break}t=c[h>>2]|0}else{if((r|0)==0){u=0}else{c[r>>2]=p;u=c[q>>2]|0}c[q>>2]=u+4;t=p}p=t;r=t;v=d+4|0;L11:do{if((a[v]&1)==0){w=l;c[w>>2]=c[v>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];s=18}else{w=c[d+12>>2]|0;y=c[d+8>>2]|0;do{if(y>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(y>>>0<11>>>0){a[l]=y<<1;z=l+1|0}else{A=y+16&-16;B=(x=0,as(230,A|0)|0);if(x){x=0;break}c[l+8>>2]=B;c[l>>2]=A|1;c[l+4>>2]=y;z=B}Kb(z|0,w|0,y)|0;a[z+y|0]=0;s=18;break L11}}while(0);y=bQ(-1,-1)|0;C=y;D=K}}while(0);do{if((s|0)==18){v=d+16|0;y=g;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];v=d+36|0;y=d+32|0;x=0;ao(4,r|0,l|0,g|0,(c[v>>2]|0)-(c[y>>2]|0)>>2|0,(a[d+44|0]&1)!=0|0);if(x){x=0;w=bQ(-1,-1)|0;B=w;w=K;if((a[l]&1)==0){C=B;D=w;break}J2(c[l+8>>2]|0);C=B;D=w;break}if((a[l]&1)!=0){J2(c[l+8>>2]|0)}c[k>>2]=r;w=b+24|0;B=c[w>>2]|0;if((B|0)==(c[b+28>>2]|0)){x=0;aq(398,b+20|0,k|0);if(x){x=0;s=43;break L1}E=c[w>>2]|0}else{if((B|0)==0){F=0}else{c[B>>2]=r;F=c[w>>2]|0}B=F+4|0;c[w>>2]=B;E=B}B=c[E-4>>2]|0;A=c[y>>2]|0;G=(c[v>>2]|0)-A>>2;if((G|0)==0){H=E;I=H-4|0;c[w>>2]=I;J=c[m>>2]|0;L=J+12|0;M=c[L>>2]|0;c[m>>2]=M;N=c[k>>2]|0;O=N|0;P=j|0;Q=j+4|0;R=c[Q>>2]|0;S=R;fQ(P,S);i=e;return O|0}v=b|0;T=B+28|0;U=B+36|0;V=B+40|0;W=B+32|0;B=T;X=0;Y=A;while(1){A=c[Y+(X<<2)>>2]|0;Z=(x=0,aK(c[(c[A>>2]|0)+16>>2]|0,A|0,v|0)|0);if(x){x=0;s=42;break}if((Z|0)!=0){c[f>>2]=Z;A=c[U>>2]|0;if((A|0)==(c[V>>2]|0)){x=0;aq(476,W|0,f|0);if(x){x=0;s=42;break}_=c[f>>2]|0}else{if((A|0)==0){$=0}else{c[A>>2]=Z;$=c[U>>2]|0}c[U>>2]=$+4;_=Z}x=0;aq(c[c[B>>2]>>2]|0,T|0,_|0);if(x){x=0;s=42;break}}Z=X+1|0;if(Z>>>0>=G>>>0){break}X=Z;Y=c[y>>2]|0}if((s|0)==42){y=bQ(-1,-1)|0;aa=K;ab=y;break L1}H=c[w>>2]|0;I=H-4|0;c[w>>2]=I;J=c[m>>2]|0;L=J+12|0;M=c[L>>2]|0;c[m>>2]=M;N=c[k>>2]|0;O=N|0;P=j|0;Q=j+4|0;R=c[Q>>2]|0;S=R;fQ(P,S);i=e;return O|0}}while(0);r=c[n>>2]|0;y=c[q>>2]|0;Y=r;while(1){if((Y|0)==(y|0)){ac=y;break}if((c[Y>>2]|0)==(t|0)){ac=Y;break}else{Y=Y+4|0}}Y=ac-r>>2;X=r+(Y+1<<2)|0;G=y-X|0;Kc(r+(Y<<2)|0,X|0,G|0)|0;X=r+((G>>2)+Y<<2)|0;Y=c[q>>2]|0;if((X|0)!=(Y|0)){c[q>>2]=Y+(~((Y-4+(-X|0)|0)>>>2)<<2)}J2(p);ad=C;ae=D;af=j|0;ag=j+4|0;ah=c[ag>>2]|0;ai=ah;fQ(af,ai);aj=ad;ak=0;al=aj;am=ae;be(al|0)}else{x=0;s=43}}while(0);if((s|0)==43){s=bQ(-1,-1)|0;aa=K;ab=s}ad=ab;ae=aa;af=j|0;ag=j+4|0;ah=c[ag>>2]|0;ai=ah;fQ(af,ai);aj=ad;ak=0;al=aj;am=ae;be(al|0);return 0}function kN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;e=i;i=i+104|0;f=e|0;g=e+16|0;h=e+32|0;j=e+48|0;k=e+56|0;l=e+64|0;m=e+72|0;n=e+88|0;Ac(k,0);o=c[d+32>>2]|0;p=c[(c[o>>2]|0)+24>>2]|0;q=b+44|0;r=b+48|0;s=(x=0,ar(102,c[b+12>>2]|0,c[(c[r>>2]|0)-4>>2]|0,c[b+16>>2]|0,c[b+56>>2]|0,0,0)|0);do{if(!x){t=(x=0,aK(p|0,o|0,s|0)|0);if(x){x=0;u=45;break}c[l>>2]=t;v=c[r>>2]|0;if((v|0)==(c[b+52>>2]|0)){x=0;aq(6,q|0,l|0);if(x){x=0;u=45;break}}else{if((v|0)==0){w=0}else{c[v>>2]=t;w=c[r>>2]|0}c[r>>2]=w+4}t=c[b+4>>2]|0;v=(x=0,as(230,36)|0);if(x){x=0;u=45;break}y=v;c[j>>2]=y;v=t+4|0;z=c[v>>2]|0;if((z|0)==(c[t+8>>2]|0)){x=0;aq(376,t|0,j|0);if(x){x=0;u=45;break}A=c[j>>2]|0}else{if((z|0)==0){B=0}else{c[z>>2]=y;B=c[v>>2]|0}c[v>>2]=B+4;A=y}y=A;z=d+4|0;L20:do{if((a[z]&1)==0){C=m;c[C>>2]=c[z>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];u=25}else{C=c[d+12>>2]|0;D=c[d+8>>2]|0;do{if(D>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;break}return 0}else{if(D>>>0<11>>>0){a[m]=D<<1;E=m+1|0}else{F=D+16&-16;G=(x=0,as(230,F|0)|0);if(x){x=0;break}c[m+8>>2]=G;c[m>>2]=F|1;c[m+4>>2]=D;E=G}Kb(E|0,C|0,D)|0;a[E+D|0]=0;u=25;break L20}}while(0);D=bQ(-1,-1)|0;H=D;I=K}}while(0);do{if((u|0)==25){z=n;D=d+16|0;c[z>>2]=c[D>>2];c[z+4>>2]=c[D+4>>2];c[z+8>>2]=c[D+8>>2];D=c[l>>2]|0;C=c[d+28>>2]|0;G=(x=0,aK(c[(c[C>>2]|0)+16>>2]|0,C|0,b|0)|0);do{if(!x){C=(x=0,as(c[(c[G>>2]|0)+40>>2]|0,G|0)|0);if(x){x=0;u=47;break}F=h;c[F>>2]=c[z>>2];c[F+4>>2]=c[z+4>>2];c[F+8>>2]=c[z+8>>2];J=f;L=g;M=A;N=m;O=a[N]|0;P=(O&1)==0;if(P){c[J>>2]=c[N>>2];c[J+4>>2]=c[N+4>>2];c[J+8>>2]=c[N+8>>2]}else{N=c[m+8>>2]|0;Q=c[m+4>>2]|0;if(Q>>>0>4294967279>>>0){x=0;ap(232,0);if(x){x=0;u=47;break}return 0}if(Q>>>0<11>>>0){a[J]=Q<<1;R=f+1|0}else{S=Q+16&-16;T=(x=0,as(230,S|0)|0);if(x){x=0;u=47;break}c[f+8>>2]=T;c[f>>2]=S|1;c[f+4>>2]=Q;R=T}Kb(R|0,N|0,Q)|0;a[R+Q|0]=0}c[L>>2]=c[F>>2];c[L+4>>2]=c[F+4>>2];c[L+8>>2]=c[F+8>>2];x=0;aT(6,M|0,f|0,g|0,C|0);if(x){x=0;C=bQ(-1,-1)|0;M=K;if((a[J]&1)==0){U=M;V=C;W=O;break}J2(c[f+8>>2]|0);U=M;V=C;W=O;break}if((a[J]&1)!=0){J2(c[f+8>>2]|0)}c[A>>2]=16808;c[A+32>>2]=D;if(P){X=c[r>>2]|0;Y=X-4|0;c[r>>2]=Y;Z=A;Ae(k);i=e;return Z|0}J2(c[m+8>>2]|0);X=c[r>>2]|0;Y=X-4|0;c[r>>2]=Y;Z=A;Ae(k);i=e;return Z|0}else{x=0;u=47}}while(0);if((u|0)==47){D=bQ(-1,-1)|0;U=K;V=D;W=a[m]|0}D=V;z=U;if((W&1)==0){H=D;I=z;break}J2(c[m+8>>2]|0);H=D;I=z}}while(0);z=c[t>>2]|0;D=c[v>>2]|0;G=z;while(1){if((G|0)==(D|0)){_=D;break}if((c[G>>2]|0)==(A|0)){_=G;break}else{G=G+4|0}}G=_-z>>2;t=z+(G+1<<2)|0;P=D-t|0;Kc(z+(G<<2)|0,t|0,P|0)|0;t=z+((P>>2)+G<<2)|0;G=c[v>>2]|0;if((t|0)!=(G|0)){c[v>>2]=G+(~((G-4+(-t|0)|0)>>>2)<<2)}J2(y);$=H;aa=I}else{x=0;u=45}}while(0);if((u|0)==45){u=bQ(-1,-1)|0;$=u;aa=K}x=0;ap(436,k|0);if(!x){be($|0)}else{x=0;bQ(-1,-1,0)|0;bU();return 0}return 0}
function Jq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=i;i=i+1032|0;h=g|0;j=g+1024|0;k=c[b>>2]|0;c[j>>2]=k;l=(a|0)!=0;m=l?e:256;e=l?a:h|0;L1:do{if((k|0)==0|(m|0)==0){n=0;o=d;p=m;q=e;r=k}else{a=h|0;s=m;t=d;u=0;v=e;w=k;while(1){x=t>>>2;y=x>>>0>=s>>>0;if(!(y|t>>>0>131>>>0)){n=u;o=t;p=s;q=v;r=w;break L1}z=y?s:x;A=t-z|0;x=Jr(v,j,z,f)|0;if((x|0)==-1){break}if((v|0)==(a|0)){B=a;C=s}else{B=v+(x<<2)|0;C=s-x|0}z=x+u|0;x=c[j>>2]|0;if((x|0)==0|(C|0)==0){n=z;o=A;p=C;q=B;r=x;break L1}else{s=C;t=A;u=z;v=B;w=x}}n=-1;o=A;p=0;q=v;r=c[j>>2]|0}}while(0);L12:do{if((r|0)==0){D=n}else{if((p|0)==0|(o|0)==0){D=n;break}else{E=p;F=o;G=n;H=q;I=r}while(1){J=Jp(H,I,F,f)|0;if((J+2|0)>>>0<3>>>0){break}A=(c[j>>2]|0)+J|0;c[j>>2]=A;B=E-1|0;C=G+1|0;if((B|0)==0|(F|0)==(J|0)){D=C;break L12}else{E=B;F=F-J|0;G=C;H=H+4|0;I=A}}if((J|0)==0){c[j>>2]=0;D=G;break}else if((J|0)==(-1|0)){D=-1;break}else{c[f>>2]=0;D=G;break}}}while(0);if(!l){i=g;return D|0}c[b>>2]=c[j>>2];i=g;return D|0}function Jr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0;h=c[e>>2]|0;do{if((g|0)==0){i=5}else{j=g|0;k=c[j>>2]|0;if((k|0)==0){i=5;break}if((b|0)==0){l=k;m=h;n=f;i=16;break}c[j>>2]=0;p=k;q=h;r=b;s=f;i=36}}while(0);if((i|0)==5){if((b|0)==0){t=h;u=f;i=7}else{v=h;w=b;x=f;i=6}}L7:while(1){if((i|0)==36){i=0;h=d[q]|0;g=h>>>3;if((g-16|g+(p>>26))>>>0>7>>>0){i=37;break}g=q+1|0;y=h-128|p<<6;do{if((y|0)<0){h=(d[g]|0)-128|0;if(h>>>0>63>>>0){i=40;break L7}k=q+2|0;z=h|y<<6;if((z|0)>=0){A=z;B=k;break}h=(d[k]|0)-128|0;if(h>>>0>63>>>0){i=43;break L7}A=h|z<<6;B=q+3|0}else{A=y;B=g}}while(0);c[r>>2]=A;v=B;w=r+4|0;x=s-1|0;i=6;continue}else if((i|0)==16){i=0;g=(d[m]|0)>>>3;if((g-16|g+(l>>26))>>>0>7>>>0){i=17;break}g=m+1|0;do{if((l&33554432|0)==0){C=g}else{if(((d[g]|0)-128|0)>>>0>63>>>0){i=20;break L7}h=m+2|0;if((l&524288|0)==0){C=h;break}if(((d[h]|0)-128|0)>>>0>63>>>0){i=23;break L7}C=m+3|0}}while(0);t=C;u=n-1|0;i=7;continue}else if((i|0)==6){i=0;if((x|0)==0){D=f;i=56;break}else{E=x;F=w;G=v}while(1){g=a[G]|0;do{if(((g&255)-1|0)>>>0<127>>>0){if((G&3|0)==0&E>>>0>3>>>0){H=E;I=F;J=G}else{K=G;L=F;M=E;N=g;break}while(1){O=c[J>>2]|0;if(((O-16843009|O)&-2139062144|0)!=0){i=30;break}c[I>>2]=O&255;c[I+4>>2]=d[J+1|0]|0;c[I+8>>2]=d[J+2|0]|0;P=J+4|0;Q=I+16|0;c[I+12>>2]=d[J+3|0]|0;R=H-4|0;if(R>>>0>3>>>0){H=R;I=Q;J=P}else{i=31;break}}if((i|0)==31){i=0;K=P;L=Q;M=R;N=a[P]|0;break}else if((i|0)==30){i=0;K=J;L=I;M=H;N=O&255;break}}else{K=G;L=F;M=E;N=g}}while(0);S=N&255;if((S-1|0)>>>0>=127>>>0){break}c[L>>2]=S;g=M-1|0;if((g|0)==0){D=f;i=57;break L7}else{E=g;F=L+4|0;G=K+1|0}}g=S-194|0;if(g>>>0>50>>>0){T=M;U=L;V=K;i=47;break}p=c[o+(g<<2)>>2]|0;q=K+1|0;r=L;s=M;i=36;continue}else if((i|0)==7){i=0;g=a[t]|0;do{if(((g&255)-1|0)>>>0<127>>>0){if((t&3|0)!=0){W=t;X=u;Y=g;break}h=c[t>>2]|0;if(((h-16843009|h)&-2139062144|0)==0){Z=u;_=t}else{W=t;X=u;Y=h&255;break}do{_=_+4|0;Z=Z-4|0;$=c[_>>2]|0;}while((($-16843009|$)&-2139062144|0)==0);W=_;X=Z;Y=$&255}else{W=t;X=u;Y=g}}while(0);g=Y&255;if((g-1|0)>>>0<127>>>0){t=W+1|0;u=X-1|0;i=7;continue}h=g-194|0;if(h>>>0>50>>>0){T=X;U=b;V=W;i=47;break}l=c[o+(h<<2)>>2]|0;m=W+1|0;n=X;i=16;continue}}if((i|0)==17){aa=l;ab=m-1|0;ac=b;ad=n;i=46}else if((i|0)==40){aa=y;ab=q-1|0;ac=r;ad=s;i=46}else if((i|0)==56){return D|0}else if((i|0)==57){return D|0}else if((i|0)==37){aa=p;ab=q-1|0;ac=r;ad=s;i=46}else if((i|0)==23){aa=l;ab=m-1|0;ac=b;ad=n;i=46}else if((i|0)==43){aa=z;ab=q-1|0;ac=r;ad=s;i=46}else if((i|0)==20){aa=l;ab=m-1|0;ac=b;ad=n;i=46}if((i|0)==46){if((aa|0)==0){T=ad;U=ac;V=ab;i=47}else{ae=ac;af=ab}}do{if((i|0)==47){if((a[V]|0)!=0){ae=U;af=V;break}if((U|0)!=0){c[U>>2]=0;c[e>>2]=0}D=f-T|0;return D|0}}while(0);c[(bY()|0)>>2]=84;if((ae|0)==0){D=-1;return D|0}c[e>>2]=af;D=-1;return D|0}function Js(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g|0;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m-194|0;if(k>>>0>50>>>0){break}m=e+1|0;n=c[o+(k<<2)>>2]|0;if(f>>>0<4>>>0){if((n&-2147483648>>>(((f*6|0)-6|0)>>>0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m-16|m+(n>>26))>>>0>7>>>0){break}m=k-128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)-128|0;if(n>>>0>63>>>0){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)-128|0;if(m>>>0>63>>>0){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(bY()|0)>>2]=84;j=-1;i=g;return j|0}function Jt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((b|0)==0){f=1;return f|0}if(d>>>0<128>>>0){a[b]=d;f=1;return f|0}if(d>>>0<2048>>>0){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;return f|0}if(d>>>0<55296>>>0|(d-57344|0)>>>0<8192>>>0){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;return f|0}if((d-65536|0)>>>0<1048576>>>0){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;return f|0}else{c[(bY()|0)>>2]=84;f=-1;return f|0}return 0}function Ju(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;f=i;i=i+264|0;g=f|0;h=f+256|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:g|0;L1:do{if((j|0)==0|(l|0)==0){m=0;n=d;o=l;p=e;q=j}else{a=g|0;r=l;s=d;t=0;u=e;v=j;while(1){w=s>>>0>=r>>>0;if(!(w|s>>>0>32>>>0)){m=t;n=s;o=r;p=u;q=v;break L1}x=w?r:s;y=s-x|0;w=Jv(u,h,x,0)|0;if((w|0)==-1){break}if((u|0)==(a|0)){z=a;A=r}else{z=u+w|0;A=r-w|0}x=w+t|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){m=x;n=y;o=A;p=z;q=w;break L1}else{r=A;s=y;t=x;u=z;v=w}}m=-1;n=y;o=0;p=u;q=c[h>>2]|0}}while(0);L12:do{if((q|0)==0){B=m}else{if((o|0)==0|(n|0)==0){B=m;break}else{C=o;D=n;E=m;F=p;G=q}while(1){H=Jt(F,c[G>>2]|0,0)|0;if((H+1|0)>>>0<2>>>0){break}y=(c[h>>2]|0)+4|0;c[h>>2]=y;z=D-1|0;A=E+1|0;if((C|0)==(H|0)|(z|0)==0){B=A;break L12}else{C=C-H|0;D=z;E=A;F=F+H|0;G=y}}if((H|0)!=0){B=-1;break}c[h>>2]=0;B=E}}while(0);if(!k){i=f;return B|0}c[b>>2]=c[h>>2];i=f;return B|0}function Jv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f|0;if((b|0)==0){h=c[d>>2]|0;j=g|0;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=h;o=k}while(1){if(o>>>0>127>>>0){k=Jt(j,o,0)|0;if((k|0)==-1){l=-1;p=30;break}else{q=k}}else{q=1}k=q+m|0;h=n+4|0;r=c[h>>2]|0;if((r|0)==0){l=k;p=33;break}else{m=k;n=h;o=r}}if((p|0)==33){i=f;return l|0}else if((p|0)==30){i=f;return l|0}}L14:do{if(e>>>0>3>>>0){o=e;n=b;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break L14}if(q>>>0>127>>>0){j=Jt(n,q,0)|0;if((j|0)==-1){l=-1;break}u=n+j|0;v=o-j|0;w=m}else{a[n]=q;u=n+1|0;v=o-1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3>>>0){o=v;n=u;m=q}else{s=v;t=u;break L14}}i=f;return l|0}else{s=e;t=b}}while(0);L26:do{if((s|0)==0){x=0}else{b=g|0;u=s;v=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127>>>0){n=Jt(b,m,0)|0;if((n|0)==-1){l=-1;p=29;break}if(n>>>0>u>>>0){p=20;break}Jt(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u-1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break L26}else{u=z;v=y;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==29){i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function Jw(a){a=a|0;var b=0;b=a;while(1){if((c[b>>2]|0)==0){break}else{b=b+4|0}}return b-a>>2|0}function Jx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)==0){return a|0}else{e=b;f=d;g=a}while(1){d=f-1|0;c[g>>2]=c[e>>2];if((d|0)==0){break}else{e=e+4|0;f=d;g=g+4|0}}return a|0}function Jy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(e){return a|0}else{f=d}do{f=f-1|0;c[a+(f<<2)>>2]=c[b+(f<<2)>>2];}while((f|0)!=0);return a|0}else{if(e){return a|0}else{g=b;h=d;i=a}while(1){d=h-1|0;c[i>>2]=c[g>>2];if((d|0)==0){break}else{g=g+4|0;h=d;i=i+4|0}}return a|0}return 0}function Jz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;if((d|0)==0){return a|0}else{e=d;f=a}while(1){d=e-1|0;c[f>>2]=b;if((d|0)==0){break}else{e=d;f=f+4|0}}return a|0}function JA(a){a=a|0;return}function JB(a){a=a|0;c[a>>2]=12912;return}function JC(a){a=a|0;J2(a);return}function JD(a){a=a|0;return}function JE(a){a=a|0;return 10456}function JF(a){a=a|0;JA(a|0);return}function JG(a){a=a|0;return}function JH(a){a=a|0;return}function JI(a){a=a|0;JA(a|0);J2(a);return}function JJ(a){a=a|0;JA(a|0);J2(a);return}function JK(a){a=a|0;JA(a|0);J2(a);return}function JL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+56|0;f=e|0;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=JP(b,31184,31168,-1)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}Ke(f|0,0,56)|0;c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;c$[c[(c[h>>2]|0)+28>>2]&63](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function JM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if((c[d+8>>2]|0)!=(b|0)){return}b=d+16|0;g=c[b>>2]|0;if((g|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((g|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}e=d+24|0;if((c[e>>2]|0)!=2){return}c[e>>2]=f;return}function JN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if((b|0)!=(c[d+8>>2]|0)){g=c[b+8>>2]|0;c$[c[(c[g>>2]|0)+28>>2]&63](g,d,e,f);return}g=d+16|0;b=c[g>>2]|0;if((b|0)==0){c[g>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}e=d+24|0;if((c[e>>2]|0)!=2){return}c[e>>2]=f;return}function JO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((b|0)==(c[d+8>>2]|0)){g=d+16|0;h=c[g>>2]|0;if((h|0)==0){c[g>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;return}if((h|0)!=(e|0)){h=d+36|0;c[h>>2]=(c[h>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;return}h=d+24|0;if((c[h>>2]|0)!=2){return}c[h>>2]=f;return}h=c[b+12>>2]|0;g=b+16+(h<<3)|0;i=c[b+20>>2]|0;j=i>>8;if((i&1|0)==0){k=j}else{k=c[(c[e>>2]|0)+j>>2]|0}j=c[b+16>>2]|0;c$[c[(c[j>>2]|0)+28>>2]&63](j,d,e+k|0,(i&2|0)!=0?f:2);if((h|0)<=1){return}h=d+54|0;i=e;k=b+24|0;while(1){b=c[k+4>>2]|0;j=b>>8;if((b&1|0)==0){l=j}else{l=c[(c[i>>2]|0)+j>>2]|0}j=c[k>>2]|0;c$[c[(c[j>>2]|0)+28>>2]&63](j,d,e+l|0,(b&2|0)!=0?f:2);if((a[h]&1)!=0){m=20;break}b=k+8|0;if(b>>>0<g>>>0){k=b}else{m=22;break}}if((m|0)==22){return}else if((m|0)==20){return}}function JP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+56|0;g=f|0;h=c[a>>2]|0;j=a+(c[h-8>>2]|0)|0;k=c[h-4>>2]|0;h=k;c[g>>2]=d;c[g+4>>2]=a;c[g+8>>2]=b;c[g+12>>2]=e;e=g+16|0;b=g+20|0;a=g+24|0;l=g+28|0;m=g+32|0;n=g+40|0;Ke(e|0,0,39)|0;if((k|0)==(d|0)){c[g+48>>2]=1;cJ[c[(c[k>>2]|0)+20>>2]&127](h,g,j,j,1,0);i=f;return((c[a>>2]|0)==1?j:0)|0}cw[c[(c[k>>2]|0)+24>>2]&63](h,g,j,1,0);j=c[g+36>>2]|0;if((j|0)==1){do{if((c[a>>2]|0)!=1){if((c[n>>2]|0)!=0){o=0;i=f;return o|0}if((c[l>>2]|0)!=1){o=0;i=f;return o|0}if((c[m>>2]|0)==1){break}else{o=0}i=f;return o|0}}while(0);o=c[e>>2]|0;i=f;return o|0}else if((j|0)==0){if((c[n>>2]|0)!=1){o=0;i=f;return o|0}if((c[l>>2]|0)!=1){o=0;i=f;return o|0}o=(c[m>>2]|0)==1?c[b>>2]|0:0;i=f;return o|0}else{o=0;i=f;return o|0}return 0}function JQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=b|0;if((h|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){return}i=d+28|0;if((c[i>>2]|0)==1){return}c[i>>2]=f;return}if((h|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){h=d+20|0;if((c[h>>2]|0)==(e|0)){break}c[d+32>>2]=f;i=d+44|0;if((c[i>>2]|0)==4){return}j=c[b+12>>2]|0;k=b+16+(j<<3)|0;L19:do{if((j|0)>0){l=d+52|0;m=d+53|0;n=d+54|0;o=b+8|0;p=d+24|0;q=e;r=0;s=b+16|0;t=0;L21:while(1){a[l]=0;a[m]=0;u=c[s+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[q>>2]|0)+v>>2]|0}v=c[s>>2]|0;cJ[c[(c[v>>2]|0)+20>>2]&127](v,d,e,e+w|0,2-(u>>>1&1)|0,g);if((a[n]&1)!=0){x=t;y=r;break}do{if((a[m]&1)==0){z=t;A=r}else{if((a[l]&1)==0){if((c[o>>2]&1|0)==0){x=1;y=r;break L21}else{z=1;A=r;break}}if((c[p>>2]|0)==1){B=27;break L19}if((c[o>>2]&2|0)==0){B=27;break L19}else{z=1;A=1}}}while(0);u=s+8|0;if(u>>>0<k>>>0){r=A;s=u;t=z}else{x=z;y=A;break}}if(y){C=x;B=26}else{D=x;B=23}}else{D=0;B=23}}while(0);do{if((B|0)==23){c[h>>2]=e;k=d+40|0;c[k>>2]=(c[k>>2]|0)+1;if((c[d+36>>2]|0)!=1){C=D;B=26;break}if((c[d+24>>2]|0)!=2){C=D;B=26;break}a[d+54|0]=1;if(D){B=27}else{B=28}}}while(0);if((B|0)==26){if(C){B=27}else{B=28}}if((B|0)==27){c[i>>2]=3;return}else if((B|0)==28){c[i>>2]=4;return}}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}C=c[b+12>>2]|0;D=b+16+(C<<3)|0;x=c[b+20>>2]|0;y=x>>8;if((x&1|0)==0){E=y}else{E=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;cw[c[(c[y>>2]|0)+24>>2]&63](y,d,e+E|0,(x&2|0)!=0?f:2,g);x=b+24|0;if((C|0)<=1){return}C=c[b+8>>2]|0;do{if((C&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((C&1|0)==0){E=d+54|0;y=e;A=x;while(1){if((a[E]&1)!=0){B=66;break}if((c[b>>2]|0)==1){B=67;break}z=c[A+4>>2]|0;w=z>>8;if((z&1|0)==0){F=w}else{F=c[(c[y>>2]|0)+w>>2]|0}w=c[A>>2]|0;cw[c[(c[w>>2]|0)+24>>2]&63](w,d,e+F|0,(z&2|0)!=0?f:2,g);z=A+8|0;if(z>>>0<D>>>0){A=z}else{B=70;break}}if((B|0)==66){return}else if((B|0)==67){return}else if((B|0)==70){return}}A=d+24|0;y=d+54|0;E=e;i=x;while(1){if((a[y]&1)!=0){B=55;break}if((c[b>>2]|0)==1){if((c[A>>2]|0)==1){B=56;break}}z=c[i+4>>2]|0;w=z>>8;if((z&1|0)==0){G=w}else{G=c[(c[E>>2]|0)+w>>2]|0}w=c[i>>2]|0;cw[c[(c[w>>2]|0)+24>>2]&63](w,d,e+G|0,(z&2|0)!=0?f:2,g);z=i+8|0;if(z>>>0<D>>>0){i=z}else{B=68;break}}if((B|0)==55){return}else if((B|0)==56){return}else if((B|0)==68){return}}}while(0);G=d+54|0;F=e;C=x;while(1){if((a[G]&1)!=0){B=59;break}x=c[C+4>>2]|0;i=x>>8;if((x&1|0)==0){H=i}else{H=c[(c[F>>2]|0)+i>>2]|0}i=c[C>>2]|0;cw[c[(c[i>>2]|0)+24>>2]&63](i,d,e+H|0,(x&2|0)!=0?f:2,g);x=C+8|0;if(x>>>0<D>>>0){C=x}else{B=65;break}}if((B|0)==59){return}else if((B|0)==65){return}}function JR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=b|0;if((h|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){return}i=d+28|0;if((c[i>>2]|0)==1){return}c[i>>2]=f;return}if((h|0)!=(c[d>>2]|0)){h=c[b+8>>2]|0;cw[c[(c[h>>2]|0)+24>>2]&63](h,d,e,f,g);return}do{if((c[d+16>>2]|0)!=(e|0)){h=d+20|0;if((c[h>>2]|0)==(e|0)){break}c[d+32>>2]=f;i=d+44|0;if((c[i>>2]|0)==4){return}j=d+52|0;a[j]=0;k=d+53|0;a[k]=0;l=c[b+8>>2]|0;cJ[c[(c[l>>2]|0)+20>>2]&127](l,d,e,e,1,g);if((a[k]&1)==0){m=0;n=13}else{if((a[j]&1)==0){m=1;n=13}}L23:do{if((n|0)==13){c[h>>2]=e;j=d+40|0;c[j>>2]=(c[j>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){n=16;break}a[d+54|0]=1;if(m){break L23}}else{n=16}}while(0);if((n|0)==16){if(m){break}}c[i>>2]=4;return}}while(0);c[i>>2]=3;return}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}function JS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){return}g=d+28|0;if((c[g>>2]|0)==1){return}c[g>>2]=f;return}if((c[d>>2]|0)!=(b|0)){return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;return}}while(0);if((f|0)!=1){return}c[d+32>>2]=1;return}function JT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((b|0)!=(c[d+8>>2]|0)){i=d+52|0;j=a[i]&1;k=d+53|0;l=a[k]&1;m=c[b+12>>2]|0;n=b+16+(m<<3)|0;a[i]=0;a[k]=0;o=c[b+20>>2]|0;p=o>>8;if((o&1|0)==0){q=p}else{q=c[(c[f>>2]|0)+p>>2]|0}p=c[b+16>>2]|0;cJ[c[(c[p>>2]|0)+20>>2]&127](p,d,e,f+q|0,(o&2|0)!=0?g:2,h);L6:do{if((m|0)>1){o=d+24|0;q=b+8|0;p=d+54|0;r=f;s=b+24|0;do{if((a[p]&1)!=0){break L6}do{if((a[i]&1)==0){if((a[k]&1)==0){break}if((c[q>>2]&1|0)==0){break L6}}else{if((c[o>>2]|0)==1){break L6}if((c[q>>2]&2|0)==0){break L6}}}while(0);a[i]=0;a[k]=0;t=c[s+4>>2]|0;u=t>>8;if((t&1|0)==0){v=u}else{v=c[(c[r>>2]|0)+u>>2]|0}u=c[s>>2]|0;cJ[c[(c[u>>2]|0)+20>>2]&127](u,d,e,f+v|0,(t&2|0)!=0?g:2,h);s=s+8|0;}while(s>>>0<n>>>0)}}while(0);a[i]=j;a[k]=l;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;l=c[f>>2]|0;if((l|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((l|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;l=c[e>>2]|0;if((l|0)==2){c[e>>2]=g;w=g}else{w=l}if(!((c[d+48>>2]|0)==1&(w|0)==1)){return}a[d+54|0]=1;return}function JU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;if((b|0)!=(c[d+8>>2]|0)){i=c[b+8>>2]|0;cJ[c[(c[i>>2]|0)+20>>2]&127](i,d,e,f,g,h);return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;j=g}else{j=h}if(!((c[d+48>>2]|0)==1&(j|0)==1)){return}a[d+54|0]=1;return}function JV(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;if((c[d+8>>2]|0)!=(b|0)){return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){return}a[d+54|0]=1;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;i=g}else{i=b}if(!((c[d+48>>2]|0)==1&(i|0)==1)){return}a[d+54|0]=1;return}function JW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ab=0,ac=0,ad=0,ae=0,af=0,ag=0,ah=0,ai=0,aj=0,ak=0,al=0,am=0,an=0,ao=0,ap=0,aq=0,ar=0,as=0,at=0,au=0,av=0,aw=0,ax=0,ay=0,az=0,aA=0,aB=0,aC=0,aD=0,aE=0,aF=0,aG=0;do{if(a>>>0<245>>>0){if(a>>>0<11>>>0){b=16}else{b=a+11&-8}d=b>>>3;e=c[9214]|0;f=e>>>(d>>>0);if((f&3|0)!=0){g=(f&1^1)+d|0;h=g<<1;i=36896+(h<<2)|0;j=36896+(h+2<<2)|0;h=c[j>>2]|0;k=h+8|0;l=c[k>>2]|0;do{if((i|0)==(l|0)){c[9214]=e&~(1<<g)}else{if(l>>>0<(c[9218]|0)>>>0){b8();return 0}m=l+12|0;if((c[m>>2]|0)==(h|0)){c[m>>2]=i;c[j>>2]=l;break}else{b8();return 0}}}while(0);l=g<<3;c[h+4>>2]=l|3;j=h+(l|4)|0;c[j>>2]=c[j>>2]|1;n=k;return n|0}if(b>>>0<=(c[9216]|0)>>>0){o=b;break}if((f|0)!=0){j=2<<d;l=f<<d&(j|-j);j=(l&-l)-1|0;l=j>>>12&16;i=j>>>(l>>>0);j=i>>>5&8;m=i>>>(j>>>0);i=m>>>2&4;p=m>>>(i>>>0);m=p>>>1&2;q=p>>>(m>>>0);p=q>>>1&1;r=(j|l|i|m|p)+(q>>>(p>>>0))|0;p=r<<1;q=36896+(p<<2)|0;m=36896+(p+2<<2)|0;p=c[m>>2]|0;i=p+8|0;l=c[i>>2]|0;do{if((q|0)==(l|0)){c[9214]=e&~(1<<r)}else{if(l>>>0<(c[9218]|0)>>>0){b8();return 0}j=l+12|0;if((c[j>>2]|0)==(p|0)){c[j>>2]=q;c[m>>2]=l;break}else{b8();return 0}}}while(0);l=r<<3;m=l-b|0;c[p+4>>2]=b|3;q=p;e=q+b|0;c[q+(b|4)>>2]=m|1;c[q+l>>2]=m;l=c[9216]|0;if((l|0)!=0){q=c[9219]|0;d=l>>>3;l=d<<1;f=36896+(l<<2)|0;k=c[9214]|0;h=1<<d;do{if((k&h|0)==0){c[9214]=k|h;s=f;t=36896+(l+2<<2)|0}else{d=36896+(l+2<<2)|0;g=c[d>>2]|0;if(g>>>0>=(c[9218]|0)>>>0){s=g;t=d;break}b8();return 0}}while(0);c[t>>2]=q;c[s+12>>2]=q;c[q+8>>2]=s;c[q+12>>2]=f}c[9216]=m;c[9219]=e;n=i;return n|0}l=c[9215]|0;if((l|0)==0){o=b;break}h=(l&-l)-1|0;l=h>>>12&16;k=h>>>(l>>>0);h=k>>>5&8;p=k>>>(h>>>0);k=p>>>2&4;r=p>>>(k>>>0);p=r>>>1&2;d=r>>>(p>>>0);r=d>>>1&1;g=c[37160+((h|l|k|p|r)+(d>>>(r>>>0))<<2)>>2]|0;r=g;d=g;p=(c[g+4>>2]&-8)-b|0;while(1){g=c[r+16>>2]|0;if((g|0)==0){k=c[r+20>>2]|0;if((k|0)==0){break}else{u=k}}else{u=g}g=(c[u+4>>2]&-8)-b|0;k=g>>>0<p>>>0;r=u;d=k?u:d;p=k?g:p}r=d;i=c[9218]|0;if(r>>>0<i>>>0){b8();return 0}e=r+b|0;m=e;if(r>>>0>=e>>>0){b8();return 0}e=c[d+24>>2]|0;f=c[d+12>>2]|0;do{if((f|0)==(d|0)){q=d+20|0;g=c[q>>2]|0;if((g|0)==0){k=d+16|0;l=c[k>>2]|0;if((l|0)==0){v=0;break}else{w=l;x=k}}else{w=g;x=q}while(1){q=w+20|0;g=c[q>>2]|0;if((g|0)!=0){w=g;x=q;continue}q=w+16|0;g=c[q>>2]|0;if((g|0)==0){break}else{w=g;x=q}}if(x>>>0<i>>>0){b8();return 0}else{c[x>>2]=0;v=w;break}}else{q=c[d+8>>2]|0;if(q>>>0<i>>>0){b8();return 0}g=q+12|0;if((c[g>>2]|0)!=(d|0)){b8();return 0}k=f+8|0;if((c[k>>2]|0)==(d|0)){c[g>>2]=f;c[k>>2]=q;v=f;break}else{b8();return 0}}}while(0);L201:do{if((e|0)!=0){f=d+28|0;i=37160+(c[f>>2]<<2)|0;do{if((d|0)==(c[i>>2]|0)){c[i>>2]=v;if((v|0)!=0){break}c[9215]=c[9215]&~(1<<c[f>>2]);break L201}else{if(e>>>0<(c[9218]|0)>>>0){b8();return 0}q=e+16|0;if((c[q>>2]|0)==(d|0)){c[q>>2]=v}else{c[e+20>>2]=v}if((v|0)==0){break L201}}}while(0);if(v>>>0<(c[9218]|0)>>>0){b8();return 0}c[v+24>>2]=e;f=c[d+16>>2]|0;do{if((f|0)!=0){if(f>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[v+16>>2]=f;c[f+24>>2]=v;break}}}while(0);f=c[d+20>>2]|0;if((f|0)==0){break}if(f>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[v+20>>2]=f;c[f+24>>2]=v;break}}}while(0);if(p>>>0<16>>>0){e=p+b|0;c[d+4>>2]=e|3;f=r+(e+4)|0;c[f>>2]=c[f>>2]|1}else{c[d+4>>2]=b|3;c[r+(b|4)>>2]=p|1;c[r+(p+b)>>2]=p;f=c[9216]|0;if((f|0)!=0){e=c[9219]|0;i=f>>>3;f=i<<1;q=36896+(f<<2)|0;k=c[9214]|0;g=1<<i;do{if((k&g|0)==0){c[9214]=k|g;y=q;z=36896+(f+2<<2)|0}else{i=36896+(f+2<<2)|0;l=c[i>>2]|0;if(l>>>0>=(c[9218]|0)>>>0){y=l;z=i;break}b8();return 0}}while(0);c[z>>2]=e;c[y+12>>2]=e;c[e+8>>2]=y;c[e+12>>2]=q}c[9216]=p;c[9219]=m}f=d+8|0;if((f|0)==0){o=b;break}else{n=f}return n|0}else{if(a>>>0>4294967231>>>0){o=-1;break}f=a+11|0;g=f&-8;k=c[9215]|0;if((k|0)==0){o=g;break}r=-g|0;i=f>>>8;do{if((i|0)==0){A=0}else{if(g>>>0>16777215>>>0){A=31;break}f=(i+1048320|0)>>>16&8;l=i<<f;h=(l+520192|0)>>>16&4;j=l<<h;l=(j+245760|0)>>>16&2;B=14-(h|f|l)+(j<<l>>>15)|0;A=g>>>((B+7|0)>>>0)&1|B<<1}}while(0);i=c[37160+(A<<2)>>2]|0;L9:do{if((i|0)==0){C=0;D=r;E=0}else{if((A|0)==31){F=0}else{F=25-(A>>>1)|0}d=0;m=r;p=i;q=g<<F;e=0;while(1){B=c[p+4>>2]&-8;l=B-g|0;if(l>>>0<m>>>0){if((B|0)==(g|0)){C=p;D=l;E=p;break L9}else{G=p;H=l}}else{G=d;H=m}l=c[p+20>>2]|0;B=c[p+16+(q>>>31<<2)>>2]|0;j=(l|0)==0|(l|0)==(B|0)?e:l;if((B|0)==0){C=G;D=H;E=j;break}else{d=G;m=H;p=B;q=q<<1;e=j}}}}while(0);if((E|0)==0&(C|0)==0){i=2<<A;r=k&(i|-i);if((r|0)==0){o=g;break}i=(r&-r)-1|0;r=i>>>12&16;e=i>>>(r>>>0);i=e>>>5&8;q=e>>>(i>>>0);e=q>>>2&4;p=q>>>(e>>>0);q=p>>>1&2;m=p>>>(q>>>0);p=m>>>1&1;I=c[37160+((i|r|e|q|p)+(m>>>(p>>>0))<<2)>>2]|0}else{I=E}if((I|0)==0){J=D;K=C}else{p=I;m=D;q=C;while(1){e=(c[p+4>>2]&-8)-g|0;r=e>>>0<m>>>0;i=r?e:m;e=r?p:q;r=c[p+16>>2]|0;if((r|0)!=0){p=r;m=i;q=e;continue}r=c[p+20>>2]|0;if((r|0)==0){J=i;K=e;break}else{p=r;m=i;q=e}}}if((K|0)==0){o=g;break}if(J>>>0>=((c[9216]|0)-g|0)>>>0){o=g;break}q=K;m=c[9218]|0;if(q>>>0<m>>>0){b8();return 0}p=q+g|0;k=p;if(q>>>0>=p>>>0){b8();return 0}e=c[K+24>>2]|0;i=c[K+12>>2]|0;do{if((i|0)==(K|0)){r=K+20|0;d=c[r>>2]|0;if((d|0)==0){j=K+16|0;B=c[j>>2]|0;if((B|0)==0){L=0;break}else{M=B;N=j}}else{M=d;N=r}while(1){r=M+20|0;d=c[r>>2]|0;if((d|0)!=0){M=d;N=r;continue}r=M+16|0;d=c[r>>2]|0;if((d|0)==0){break}else{M=d;N=r}}if(N>>>0<m>>>0){b8();return 0}else{c[N>>2]=0;L=M;break}}else{r=c[K+8>>2]|0;if(r>>>0<m>>>0){b8();return 0}d=r+12|0;if((c[d>>2]|0)!=(K|0)){b8();return 0}j=i+8|0;if((c[j>>2]|0)==(K|0)){c[d>>2]=i;c[j>>2]=r;L=i;break}else{b8();return 0}}}while(0);L59:do{if((e|0)!=0){i=K+28|0;m=37160+(c[i>>2]<<2)|0;do{if((K|0)==(c[m>>2]|0)){c[m>>2]=L;if((L|0)!=0){break}c[9215]=c[9215]&~(1<<c[i>>2]);break L59}else{if(e>>>0<(c[9218]|0)>>>0){b8();return 0}r=e+16|0;if((c[r>>2]|0)==(K|0)){c[r>>2]=L}else{c[e+20>>2]=L}if((L|0)==0){break L59}}}while(0);if(L>>>0<(c[9218]|0)>>>0){b8();return 0}c[L+24>>2]=e;i=c[K+16>>2]|0;do{if((i|0)!=0){if(i>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[L+16>>2]=i;c[i+24>>2]=L;break}}}while(0);i=c[K+20>>2]|0;if((i|0)==0){break}if(i>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[L+20>>2]=i;c[i+24>>2]=L;break}}}while(0);do{if(J>>>0<16>>>0){e=J+g|0;c[K+4>>2]=e|3;i=q+(e+4)|0;c[i>>2]=c[i>>2]|1}else{c[K+4>>2]=g|3;c[q+(g|4)>>2]=J|1;c[q+(J+g)>>2]=J;i=J>>>3;if(J>>>0<256>>>0){e=i<<1;m=36896+(e<<2)|0;r=c[9214]|0;j=1<<i;do{if((r&j|0)==0){c[9214]=r|j;O=m;P=36896+(e+2<<2)|0}else{i=36896+(e+2<<2)|0;d=c[i>>2]|0;if(d>>>0>=(c[9218]|0)>>>0){O=d;P=i;break}b8();return 0}}while(0);c[P>>2]=k;c[O+12>>2]=k;c[q+(g+8)>>2]=O;c[q+(g+12)>>2]=m;break}e=p;j=J>>>8;do{if((j|0)==0){Q=0}else{if(J>>>0>16777215>>>0){Q=31;break}r=(j+1048320|0)>>>16&8;i=j<<r;d=(i+520192|0)>>>16&4;B=i<<d;i=(B+245760|0)>>>16&2;l=14-(d|r|i)+(B<<i>>>15)|0;Q=J>>>((l+7|0)>>>0)&1|l<<1}}while(0);j=37160+(Q<<2)|0;c[q+(g+28)>>2]=Q;c[q+(g+20)>>2]=0;c[q+(g+16)>>2]=0;m=c[9215]|0;l=1<<Q;if((m&l|0)==0){c[9215]=m|l;c[j>>2]=e;c[q+(g+24)>>2]=j;c[q+(g+12)>>2]=e;c[q+(g+8)>>2]=e;break}if((Q|0)==31){R=0}else{R=25-(Q>>>1)|0}l=J<<R;m=c[j>>2]|0;while(1){if((c[m+4>>2]&-8|0)==(J|0)){break}S=m+16+(l>>>31<<2)|0;j=c[S>>2]|0;if((j|0)==0){T=151;break}else{l=l<<1;m=j}}if((T|0)==151){if(S>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[S>>2]=e;c[q+(g+24)>>2]=m;c[q+(g+12)>>2]=e;c[q+(g+8)>>2]=e;break}}l=m+8|0;j=c[l>>2]|0;i=c[9218]|0;if(m>>>0<i>>>0){b8();return 0}if(j>>>0<i>>>0){b8();return 0}else{c[j+12>>2]=e;c[l>>2]=e;c[q+(g+8)>>2]=j;c[q+(g+12)>>2]=m;c[q+(g+24)>>2]=0;break}}}while(0);q=K+8|0;if((q|0)==0){o=g;break}else{n=q}return n|0}}while(0);K=c[9216]|0;if(o>>>0<=K>>>0){S=K-o|0;J=c[9219]|0;if(S>>>0>15>>>0){R=J;c[9219]=R+o;c[9216]=S;c[R+(o+4)>>2]=S|1;c[R+K>>2]=S;c[J+4>>2]=o|3}else{c[9216]=0;c[9219]=0;c[J+4>>2]=K|3;S=J+(K+4)|0;c[S>>2]=c[S>>2]|1}n=J+8|0;return n|0}J=c[9217]|0;if(o>>>0<J>>>0){S=J-o|0;c[9217]=S;J=c[9220]|0;K=J;c[9220]=K+o;c[K+(o+4)>>2]=S|1;c[J+4>>2]=o|3;n=J+8|0;return n|0}do{if((c[9198]|0)==0){J=b6(30)|0;if((J-1&J|0)==0){c[9200]=J;c[9199]=J;c[9201]=-1;c[9202]=-1;c[9203]=0;c[9325]=0;c[9198]=(cs(0)|0)&-16^1431655768;break}else{b8();return 0}}}while(0);J=o+48|0;S=c[9200]|0;K=o+47|0;R=S+K|0;Q=-S|0;S=R&Q;if(S>>>0<=o>>>0){n=0;return n|0}O=c[9324]|0;do{if((O|0)!=0){P=c[9322]|0;L=P+S|0;if(L>>>0<=P>>>0|L>>>0>O>>>0){n=0}else{break}return n|0}}while(0);L268:do{if((c[9325]&4|0)==0){O=c[9220]|0;L270:do{if((O|0)==0){T=181}else{L=O;P=37304;while(1){U=P|0;M=c[U>>2]|0;if(M>>>0<=L>>>0){V=P+4|0;if((M+(c[V>>2]|0)|0)>>>0>L>>>0){break}}M=c[P+8>>2]|0;if((M|0)==0){T=181;break L270}else{P=M}}if((P|0)==0){T=181;break}L=R-(c[9217]|0)&Q;if(L>>>0>=2147483647>>>0){W=0;break}m=bX(L|0)|0;e=(m|0)==((c[U>>2]|0)+(c[V>>2]|0)|0);X=e?m:-1;Y=e?L:0;Z=m;_=L;T=190}}while(0);do{if((T|0)==181){O=bX(0)|0;if((O|0)==-1){W=0;break}g=O;L=c[9199]|0;m=L-1|0;if((m&g|0)==0){$=S}else{$=S-g+(m+g&-L)|0}L=c[9322]|0;g=L+$|0;if(!($>>>0>o>>>0&$>>>0<2147483647>>>0)){W=0;break}m=c[9324]|0;if((m|0)!=0){if(g>>>0<=L>>>0|g>>>0>m>>>0){W=0;break}}m=bX($|0)|0;g=(m|0)==(O|0);X=g?O:-1;Y=g?$:0;Z=m;_=$;T=190}}while(0);L290:do{if((T|0)==190){m=-_|0;if((X|0)!=-1){aa=Y;ab=X;T=201;break L268}do{if((Z|0)!=-1&_>>>0<2147483647>>>0&_>>>0<J>>>0){g=c[9200]|0;O=K-_+g&-g;if(O>>>0>=2147483647>>>0){ac=_;break}if((bX(O|0)|0)==-1){bX(m|0)|0;W=Y;break L290}else{ac=O+_|0;break}}else{ac=_}}while(0);if((Z|0)==-1){W=Y}else{aa=ac;ab=Z;T=201;break L268}}}while(0);c[9325]=c[9325]|4;ad=W;T=198}else{ad=0;T=198}}while(0);do{if((T|0)==198){if(S>>>0>=2147483647>>>0){break}W=bX(S|0)|0;Z=bX(0)|0;if(!((Z|0)!=-1&(W|0)!=-1&W>>>0<Z>>>0)){break}ac=Z-W|0;Z=ac>>>0>(o+40|0)>>>0;Y=Z?W:-1;if((Y|0)!=-1){aa=Z?ac:ad;ab=Y;T=201}}}while(0);do{if((T|0)==201){ad=(c[9322]|0)+aa|0;c[9322]=ad;if(ad>>>0>(c[9323]|0)>>>0){c[9323]=ad}ad=c[9220]|0;L310:do{if((ad|0)==0){S=c[9218]|0;if((S|0)==0|ab>>>0<S>>>0){c[9218]=ab}c[9326]=ab;c[9327]=aa;c[9329]=0;c[9223]=c[9198];c[9222]=-1;S=0;do{Y=S<<1;ac=36896+(Y<<2)|0;c[36896+(Y+3<<2)>>2]=ac;c[36896+(Y+2<<2)>>2]=ac;S=S+1|0;}while(S>>>0<32>>>0);S=ab+8|0;if((S&7|0)==0){ae=0}else{ae=-S&7}S=aa-40-ae|0;c[9220]=ab+ae;c[9217]=S;c[ab+(ae+4)>>2]=S|1;c[ab+(aa-36)>>2]=40;c[9221]=c[9202]}else{S=37304;while(1){af=c[S>>2]|0;ag=S+4|0;ah=c[ag>>2]|0;if((ab|0)==(af+ah|0)){T=213;break}ac=c[S+8>>2]|0;if((ac|0)==0){break}else{S=ac}}do{if((T|0)==213){if((c[S+12>>2]&8|0)!=0){break}ac=ad;if(!(ac>>>0>=af>>>0&ac>>>0<ab>>>0)){break}c[ag>>2]=ah+aa;ac=c[9220]|0;Y=(c[9217]|0)+aa|0;Z=ac;W=ac+8|0;if((W&7|0)==0){ai=0}else{ai=-W&7}W=Y-ai|0;c[9220]=Z+ai;c[9217]=W;c[Z+(ai+4)>>2]=W|1;c[Z+(Y+4)>>2]=40;c[9221]=c[9202];break L310}}while(0);if(ab>>>0<(c[9218]|0)>>>0){c[9218]=ab}S=ab+aa|0;Y=37304;while(1){aj=Y|0;if((c[aj>>2]|0)==(S|0)){T=223;break}Z=c[Y+8>>2]|0;if((Z|0)==0){break}else{Y=Z}}do{if((T|0)==223){if((c[Y+12>>2]&8|0)!=0){break}c[aj>>2]=ab;S=Y+4|0;c[S>>2]=(c[S>>2]|0)+aa;S=ab+8|0;if((S&7|0)==0){ak=0}else{ak=-S&7}S=ab+(aa+8)|0;if((S&7|0)==0){al=0}else{al=-S&7}S=ab+(al+aa)|0;Z=S;W=ak+o|0;ac=ab+W|0;_=ac;K=S-(ab+ak)-o|0;c[ab+(ak+4)>>2]=o|3;do{if((Z|0)==(c[9220]|0)){J=(c[9217]|0)+K|0;c[9217]=J;c[9220]=_;c[ab+(W+4)>>2]=J|1}else{if((Z|0)==(c[9219]|0)){J=(c[9216]|0)+K|0;c[9216]=J;c[9219]=_;c[ab+(W+4)>>2]=J|1;c[ab+(J+W)>>2]=J;break}J=aa+4|0;X=c[ab+(J+al)>>2]|0;if((X&3|0)==1){$=X&-8;V=X>>>3;L355:do{if(X>>>0<256>>>0){U=c[ab+((al|8)+aa)>>2]|0;Q=c[ab+(aa+12+al)>>2]|0;R=36896+(V<<1<<2)|0;do{if((U|0)!=(R|0)){if(U>>>0<(c[9218]|0)>>>0){b8();return 0}if((c[U+12>>2]|0)==(Z|0)){break}b8();return 0}}while(0);if((Q|0)==(U|0)){c[9214]=c[9214]&~(1<<V);break}do{if((Q|0)==(R|0)){am=Q+8|0}else{if(Q>>>0<(c[9218]|0)>>>0){b8();return 0}m=Q+8|0;if((c[m>>2]|0)==(Z|0)){am=m;break}b8();return 0}}while(0);c[U+12>>2]=Q;c[am>>2]=U}else{R=S;m=c[ab+((al|24)+aa)>>2]|0;P=c[ab+(aa+12+al)>>2]|0;do{if((P|0)==(R|0)){O=al|16;g=ab+(J+O)|0;L=c[g>>2]|0;if((L|0)==0){e=ab+(O+aa)|0;O=c[e>>2]|0;if((O|0)==0){an=0;break}else{ao=O;ap=e}}else{ao=L;ap=g}while(1){g=ao+20|0;L=c[g>>2]|0;if((L|0)!=0){ao=L;ap=g;continue}g=ao+16|0;L=c[g>>2]|0;if((L|0)==0){break}else{ao=L;ap=g}}if(ap>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[ap>>2]=0;an=ao;break}}else{g=c[ab+((al|8)+aa)>>2]|0;if(g>>>0<(c[9218]|0)>>>0){b8();return 0}L=g+12|0;if((c[L>>2]|0)!=(R|0)){b8();return 0}e=P+8|0;if((c[e>>2]|0)==(R|0)){c[L>>2]=P;c[e>>2]=g;an=P;break}else{b8();return 0}}}while(0);if((m|0)==0){break}P=ab+(aa+28+al)|0;U=37160+(c[P>>2]<<2)|0;do{if((R|0)==(c[U>>2]|0)){c[U>>2]=an;if((an|0)!=0){break}c[9215]=c[9215]&~(1<<c[P>>2]);break L355}else{if(m>>>0<(c[9218]|0)>>>0){b8();return 0}Q=m+16|0;if((c[Q>>2]|0)==(R|0)){c[Q>>2]=an}else{c[m+20>>2]=an}if((an|0)==0){break L355}}}while(0);if(an>>>0<(c[9218]|0)>>>0){b8();return 0}c[an+24>>2]=m;R=al|16;P=c[ab+(R+aa)>>2]|0;do{if((P|0)!=0){if(P>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[an+16>>2]=P;c[P+24>>2]=an;break}}}while(0);P=c[ab+(J+R)>>2]|0;if((P|0)==0){break}if(P>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[an+20>>2]=P;c[P+24>>2]=an;break}}}while(0);aq=ab+(($|al)+aa)|0;ar=$+K|0}else{aq=Z;ar=K}J=aq+4|0;c[J>>2]=c[J>>2]&-2;c[ab+(W+4)>>2]=ar|1;c[ab+(ar+W)>>2]=ar;J=ar>>>3;if(ar>>>0<256>>>0){V=J<<1;X=36896+(V<<2)|0;P=c[9214]|0;m=1<<J;do{if((P&m|0)==0){c[9214]=P|m;as=X;at=36896+(V+2<<2)|0}else{J=36896+(V+2<<2)|0;U=c[J>>2]|0;if(U>>>0>=(c[9218]|0)>>>0){as=U;at=J;break}b8();return 0}}while(0);c[at>>2]=_;c[as+12>>2]=_;c[ab+(W+8)>>2]=as;c[ab+(W+12)>>2]=X;break}V=ac;m=ar>>>8;do{if((m|0)==0){au=0}else{if(ar>>>0>16777215>>>0){au=31;break}P=(m+1048320|0)>>>16&8;$=m<<P;J=($+520192|0)>>>16&4;U=$<<J;$=(U+245760|0)>>>16&2;Q=14-(J|P|$)+(U<<$>>>15)|0;au=ar>>>((Q+7|0)>>>0)&1|Q<<1}}while(0);m=37160+(au<<2)|0;c[ab+(W+28)>>2]=au;c[ab+(W+20)>>2]=0;c[ab+(W+16)>>2]=0;X=c[9215]|0;Q=1<<au;if((X&Q|0)==0){c[9215]=X|Q;c[m>>2]=V;c[ab+(W+24)>>2]=m;c[ab+(W+12)>>2]=V;c[ab+(W+8)>>2]=V;break}if((au|0)==31){av=0}else{av=25-(au>>>1)|0}Q=ar<<av;X=c[m>>2]|0;while(1){if((c[X+4>>2]&-8|0)==(ar|0)){break}aw=X+16+(Q>>>31<<2)|0;m=c[aw>>2]|0;if((m|0)==0){T=296;break}else{Q=Q<<1;X=m}}if((T|0)==296){if(aw>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[aw>>2]=V;c[ab+(W+24)>>2]=X;c[ab+(W+12)>>2]=V;c[ab+(W+8)>>2]=V;break}}Q=X+8|0;m=c[Q>>2]|0;$=c[9218]|0;if(X>>>0<$>>>0){b8();return 0}if(m>>>0<$>>>0){b8();return 0}else{c[m+12>>2]=V;c[Q>>2]=V;c[ab+(W+8)>>2]=m;c[ab+(W+12)>>2]=X;c[ab+(W+24)>>2]=0;break}}}while(0);n=ab+(ak|8)|0;return n|0}}while(0);Y=ad;W=37304;while(1){ax=c[W>>2]|0;if(ax>>>0<=Y>>>0){ay=c[W+4>>2]|0;az=ax+ay|0;if(az>>>0>Y>>>0){break}}W=c[W+8>>2]|0}W=ax+(ay-39)|0;if((W&7|0)==0){aA=0}else{aA=-W&7}W=ax+(ay-47+aA)|0;ac=W>>>0<(ad+16|0)>>>0?Y:W;W=ac+8|0;_=ab+8|0;if((_&7|0)==0){aB=0}else{aB=-_&7}_=aa-40-aB|0;c[9220]=ab+aB;c[9217]=_;c[ab+(aB+4)>>2]=_|1;c[ab+(aa-36)>>2]=40;c[9221]=c[9202];c[ac+4>>2]=27;c[W>>2]=c[9326];c[W+4>>2]=c[9327];c[W+8>>2]=c[9328];c[W+12>>2]=c[9329];c[9326]=ab;c[9327]=aa;c[9329]=0;c[9328]=W;W=ac+28|0;c[W>>2]=7;if((ac+32|0)>>>0<az>>>0){_=W;while(1){W=_+4|0;c[W>>2]=7;if((_+8|0)>>>0<az>>>0){_=W}else{break}}}if((ac|0)==(Y|0)){break}_=ac-ad|0;W=Y+(_+4)|0;c[W>>2]=c[W>>2]&-2;c[ad+4>>2]=_|1;c[Y+_>>2]=_;W=_>>>3;if(_>>>0<256>>>0){K=W<<1;Z=36896+(K<<2)|0;S=c[9214]|0;m=1<<W;do{if((S&m|0)==0){c[9214]=S|m;aC=Z;aD=36896+(K+2<<2)|0}else{W=36896+(K+2<<2)|0;Q=c[W>>2]|0;if(Q>>>0>=(c[9218]|0)>>>0){aC=Q;aD=W;break}b8();return 0}}while(0);c[aD>>2]=ad;c[aC+12>>2]=ad;c[ad+8>>2]=aC;c[ad+12>>2]=Z;break}K=ad;m=_>>>8;do{if((m|0)==0){aE=0}else{if(_>>>0>16777215>>>0){aE=31;break}S=(m+1048320|0)>>>16&8;Y=m<<S;ac=(Y+520192|0)>>>16&4;W=Y<<ac;Y=(W+245760|0)>>>16&2;Q=14-(ac|S|Y)+(W<<Y>>>15)|0;aE=_>>>((Q+7|0)>>>0)&1|Q<<1}}while(0);m=37160+(aE<<2)|0;c[ad+28>>2]=aE;c[ad+20>>2]=0;c[ad+16>>2]=0;Z=c[9215]|0;Q=1<<aE;if((Z&Q|0)==0){c[9215]=Z|Q;c[m>>2]=K;c[ad+24>>2]=m;c[ad+12>>2]=ad;c[ad+8>>2]=ad;break}if((aE|0)==31){aF=0}else{aF=25-(aE>>>1)|0}Q=_<<aF;Z=c[m>>2]|0;while(1){if((c[Z+4>>2]&-8|0)==(_|0)){break}aG=Z+16+(Q>>>31<<2)|0;m=c[aG>>2]|0;if((m|0)==0){T=331;break}else{Q=Q<<1;Z=m}}if((T|0)==331){if(aG>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[aG>>2]=K;c[ad+24>>2]=Z;c[ad+12>>2]=ad;c[ad+8>>2]=ad;break}}Q=Z+8|0;_=c[Q>>2]|0;m=c[9218]|0;if(Z>>>0<m>>>0){b8();return 0}if(_>>>0<m>>>0){b8();return 0}else{c[_+12>>2]=K;c[Q>>2]=K;c[ad+8>>2]=_;c[ad+12>>2]=Z;c[ad+24>>2]=0;break}}}while(0);ad=c[9217]|0;if(ad>>>0<=o>>>0){break}_=ad-o|0;c[9217]=_;ad=c[9220]|0;Q=ad;c[9220]=Q+o;c[Q+(o+4)>>2]=_|1;c[ad+4>>2]=o|3;n=ad+8|0;return n|0}}while(0);c[(bY()|0)>>2]=12;n=0;return n|0}function JX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;if((a|0)==0){return}b=a-8|0;d=b;e=c[9218]|0;if(b>>>0<e>>>0){b8()}f=c[a-4>>2]|0;g=f&3;if((g|0)==1){b8()}h=f&-8;i=a+(h-8)|0;j=i;L10:do{if((f&1|0)==0){k=c[b>>2]|0;if((g|0)==0){return}l=-8-k|0;m=a+l|0;n=m;o=k+h|0;if(m>>>0<e>>>0){b8()}if((n|0)==(c[9219]|0)){p=a+(h-4)|0;if((c[p>>2]&3|0)!=3){q=n;r=o;break}c[9216]=o;c[p>>2]=c[p>>2]&-2;c[a+(l+4)>>2]=o|1;c[i>>2]=o;return}p=k>>>3;if(k>>>0<256>>>0){k=c[a+(l+8)>>2]|0;s=c[a+(l+12)>>2]|0;t=36896+(p<<1<<2)|0;do{if((k|0)!=(t|0)){if(k>>>0<e>>>0){b8()}if((c[k+12>>2]|0)==(n|0)){break}b8()}}while(0);if((s|0)==(k|0)){c[9214]=c[9214]&~(1<<p);q=n;r=o;break}do{if((s|0)==(t|0)){u=s+8|0}else{if(s>>>0<e>>>0){b8()}v=s+8|0;if((c[v>>2]|0)==(n|0)){u=v;break}b8()}}while(0);c[k+12>>2]=s;c[u>>2]=k;q=n;r=o;break}t=m;p=c[a+(l+24)>>2]|0;v=c[a+(l+12)>>2]|0;do{if((v|0)==(t|0)){w=a+(l+20)|0;x=c[w>>2]|0;if((x|0)==0){y=a+(l+16)|0;z=c[y>>2]|0;if((z|0)==0){A=0;break}else{B=z;C=y}}else{B=x;C=w}while(1){w=B+20|0;x=c[w>>2]|0;if((x|0)!=0){B=x;C=w;continue}w=B+16|0;x=c[w>>2]|0;if((x|0)==0){break}else{B=x;C=w}}if(C>>>0<e>>>0){b8()}else{c[C>>2]=0;A=B;break}}else{w=c[a+(l+8)>>2]|0;if(w>>>0<e>>>0){b8()}x=w+12|0;if((c[x>>2]|0)!=(t|0)){b8()}y=v+8|0;if((c[y>>2]|0)==(t|0)){c[x>>2]=v;c[y>>2]=w;A=v;break}else{b8()}}}while(0);if((p|0)==0){q=n;r=o;break}v=a+(l+28)|0;m=37160+(c[v>>2]<<2)|0;do{if((t|0)==(c[m>>2]|0)){c[m>>2]=A;if((A|0)!=0){break}c[9215]=c[9215]&~(1<<c[v>>2]);q=n;r=o;break L10}else{if(p>>>0<(c[9218]|0)>>>0){b8()}k=p+16|0;if((c[k>>2]|0)==(t|0)){c[k>>2]=A}else{c[p+20>>2]=A}if((A|0)==0){q=n;r=o;break L10}}}while(0);if(A>>>0<(c[9218]|0)>>>0){b8()}c[A+24>>2]=p;t=c[a+(l+16)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[9218]|0)>>>0){b8()}else{c[A+16>>2]=t;c[t+24>>2]=A;break}}}while(0);t=c[a+(l+20)>>2]|0;if((t|0)==0){q=n;r=o;break}if(t>>>0<(c[9218]|0)>>>0){b8()}else{c[A+20>>2]=t;c[t+24>>2]=A;q=n;r=o;break}}else{q=d;r=h}}while(0);d=q;if(d>>>0>=i>>>0){b8()}A=a+(h-4)|0;e=c[A>>2]|0;if((e&1|0)==0){b8()}do{if((e&2|0)==0){if((j|0)==(c[9220]|0)){B=(c[9217]|0)+r|0;c[9217]=B;c[9220]=q;c[q+4>>2]=B|1;if((q|0)!=(c[9219]|0)){return}c[9219]=0;c[9216]=0;return}if((j|0)==(c[9219]|0)){B=(c[9216]|0)+r|0;c[9216]=B;c[9219]=q;c[q+4>>2]=B|1;c[d+B>>2]=B;return}B=(e&-8)+r|0;C=e>>>3;L112:do{if(e>>>0<256>>>0){u=c[a+h>>2]|0;g=c[a+(h|4)>>2]|0;b=36896+(C<<1<<2)|0;do{if((u|0)!=(b|0)){if(u>>>0<(c[9218]|0)>>>0){b8()}if((c[u+12>>2]|0)==(j|0)){break}b8()}}while(0);if((g|0)==(u|0)){c[9214]=c[9214]&~(1<<C);break}do{if((g|0)==(b|0)){D=g+8|0}else{if(g>>>0<(c[9218]|0)>>>0){b8()}f=g+8|0;if((c[f>>2]|0)==(j|0)){D=f;break}b8()}}while(0);c[u+12>>2]=g;c[D>>2]=u}else{b=i;f=c[a+(h+16)>>2]|0;t=c[a+(h|4)>>2]|0;do{if((t|0)==(b|0)){p=a+(h+12)|0;v=c[p>>2]|0;if((v|0)==0){m=a+(h+8)|0;k=c[m>>2]|0;if((k|0)==0){E=0;break}else{F=k;G=m}}else{F=v;G=p}while(1){p=F+20|0;v=c[p>>2]|0;if((v|0)!=0){F=v;G=p;continue}p=F+16|0;v=c[p>>2]|0;if((v|0)==0){break}else{F=v;G=p}}if(G>>>0<(c[9218]|0)>>>0){b8()}else{c[G>>2]=0;E=F;break}}else{p=c[a+h>>2]|0;if(p>>>0<(c[9218]|0)>>>0){b8()}v=p+12|0;if((c[v>>2]|0)!=(b|0)){b8()}m=t+8|0;if((c[m>>2]|0)==(b|0)){c[v>>2]=t;c[m>>2]=p;E=t;break}else{b8()}}}while(0);if((f|0)==0){break}t=a+(h+20)|0;u=37160+(c[t>>2]<<2)|0;do{if((b|0)==(c[u>>2]|0)){c[u>>2]=E;if((E|0)!=0){break}c[9215]=c[9215]&~(1<<c[t>>2]);break L112}else{if(f>>>0<(c[9218]|0)>>>0){b8()}g=f+16|0;if((c[g>>2]|0)==(b|0)){c[g>>2]=E}else{c[f+20>>2]=E}if((E|0)==0){break L112}}}while(0);if(E>>>0<(c[9218]|0)>>>0){b8()}c[E+24>>2]=f;b=c[a+(h+8)>>2]|0;do{if((b|0)!=0){if(b>>>0<(c[9218]|0)>>>0){b8()}else{c[E+16>>2]=b;c[b+24>>2]=E;break}}}while(0);b=c[a+(h+12)>>2]|0;if((b|0)==0){break}if(b>>>0<(c[9218]|0)>>>0){b8()}else{c[E+20>>2]=b;c[b+24>>2]=E;break}}}while(0);c[q+4>>2]=B|1;c[d+B>>2]=B;if((q|0)!=(c[9219]|0)){H=B;break}c[9216]=B;return}else{c[A>>2]=e&-2;c[q+4>>2]=r|1;c[d+r>>2]=r;H=r}}while(0);r=H>>>3;if(H>>>0<256>>>0){d=r<<1;e=36896+(d<<2)|0;A=c[9214]|0;E=1<<r;do{if((A&E|0)==0){c[9214]=A|E;I=e;J=36896+(d+2<<2)|0}else{r=36896+(d+2<<2)|0;h=c[r>>2]|0;if(h>>>0>=(c[9218]|0)>>>0){I=h;J=r;break}b8()}}while(0);c[J>>2]=q;c[I+12>>2]=q;c[q+8>>2]=I;c[q+12>>2]=e;return}e=q;I=H>>>8;do{if((I|0)==0){K=0}else{if(H>>>0>16777215>>>0){K=31;break}J=(I+1048320|0)>>>16&8;d=I<<J;E=(d+520192|0)>>>16&4;A=d<<E;d=(A+245760|0)>>>16&2;r=14-(E|J|d)+(A<<d>>>15)|0;K=H>>>((r+7|0)>>>0)&1|r<<1}}while(0);I=37160+(K<<2)|0;c[q+28>>2]=K;c[q+20>>2]=0;c[q+16>>2]=0;r=c[9215]|0;d=1<<K;do{if((r&d|0)==0){c[9215]=r|d;c[I>>2]=e;c[q+24>>2]=I;c[q+12>>2]=q;c[q+8>>2]=q}else{if((K|0)==31){L=0}else{L=25-(K>>>1)|0}A=H<<L;J=c[I>>2]|0;while(1){if((c[J+4>>2]&-8|0)==(H|0)){break}M=J+16+(A>>>31<<2)|0;E=c[M>>2]|0;if((E|0)==0){N=129;break}else{A=A<<1;J=E}}if((N|0)==129){if(M>>>0<(c[9218]|0)>>>0){b8()}else{c[M>>2]=e;c[q+24>>2]=J;c[q+12>>2]=q;c[q+8>>2]=q;break}}A=J+8|0;B=c[A>>2]|0;E=c[9218]|0;if(J>>>0<E>>>0){b8()}if(B>>>0<E>>>0){b8()}else{c[B+12>>2]=e;c[A>>2]=e;c[q+8>>2]=B;c[q+12>>2]=J;c[q+24>>2]=0;break}}}while(0);q=(c[9222]|0)-1|0;c[9222]=q;if((q|0)==0){O=37312}else{return}while(1){q=c[O>>2]|0;if((q|0)==0){break}else{O=q+8|0}}c[9222]=-1;return}function JY(a,b){a=a|0;b=b|0;var d=0,e=0;do{if((a|0)==0){d=0}else{e=ag(b,a)|0;if((b|a)>>>0<=65535>>>0){d=e;break}d=((e>>>0)/(a>>>0)|0|0)==(b|0)?e:-1}}while(0);b=JW(d)|0;if((b|0)==0){return b|0}if((c[b-4>>2]&3|0)==0){return b|0}Ke(b|0,0,d|0)|0;return b|0}function JZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;if((a|0)==0){d=JW(b)|0;return d|0}if(b>>>0>4294967231>>>0){c[(bY()|0)>>2]=12;d=0;return d|0}if(b>>>0<11>>>0){e=16}else{e=b+11&-8}f=J_(a-8|0,e)|0;if((f|0)!=0){d=f+8|0;return d|0}f=JW(b)|0;if((f|0)==0){d=0;return d|0}e=c[a-4>>2]|0;g=(e&-8)-((e&3|0)==0?8:4)|0;Kb(f|0,a|0,g>>>0<b>>>0?g:b)|0;JX(a);d=f;return d|0}function J_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=a+4|0;e=c[d>>2]|0;f=e&-8;g=a;h=g+f|0;i=h;j=c[9218]|0;if(g>>>0<j>>>0){b8();return 0}k=e&3;if(!((k|0)!=1&g>>>0<h>>>0)){b8();return 0}l=g+(f|4)|0;m=c[l>>2]|0;if((m&1|0)==0){b8();return 0}if((k|0)==0){if(b>>>0<256>>>0){n=0;return n|0}do{if(f>>>0>=(b+4|0)>>>0){if((f-b|0)>>>0>c[9200]<<1>>>0){break}else{n=a}return n|0}}while(0);n=0;return n|0}if(f>>>0>=b>>>0){k=f-b|0;if(k>>>0<=15>>>0){n=a;return n|0}c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=k|3;c[l>>2]=c[l>>2]|1;J$(g+b|0,k);n=a;return n|0}if((i|0)==(c[9220]|0)){k=(c[9217]|0)+f|0;if(k>>>0<=b>>>0){n=0;return n|0}l=k-b|0;c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=l|1;c[9220]=g+b;c[9217]=l;n=a;return n|0}if((i|0)==(c[9219]|0)){l=(c[9216]|0)+f|0;if(l>>>0<b>>>0){n=0;return n|0}k=l-b|0;if(k>>>0>15>>>0){c[d>>2]=e&1|b|2;c[g+(b+4)>>2]=k|1;c[g+l>>2]=k;o=g+(l+4)|0;c[o>>2]=c[o>>2]&-2;p=g+b|0;q=k}else{c[d>>2]=e&1|l|2;e=g+(l+4)|0;c[e>>2]=c[e>>2]|1;p=0;q=0}c[9216]=q;c[9219]=p;n=a;return n|0}if((m&2|0)!=0){n=0;return n|0}p=(m&-8)+f|0;if(p>>>0<b>>>0){n=0;return n|0}q=p-b|0;e=m>>>3;L52:do{if(m>>>0<256>>>0){l=c[g+(f+8)>>2]|0;k=c[g+(f+12)>>2]|0;o=36896+(e<<1<<2)|0;do{if((l|0)!=(o|0)){if(l>>>0<j>>>0){b8();return 0}if((c[l+12>>2]|0)==(i|0)){break}b8();return 0}}while(0);if((k|0)==(l|0)){c[9214]=c[9214]&~(1<<e);break}do{if((k|0)==(o|0)){r=k+8|0}else{if(k>>>0<j>>>0){b8();return 0}s=k+8|0;if((c[s>>2]|0)==(i|0)){r=s;break}b8();return 0}}while(0);c[l+12>>2]=k;c[r>>2]=l}else{o=h;s=c[g+(f+24)>>2]|0;t=c[g+(f+12)>>2]|0;do{if((t|0)==(o|0)){u=g+(f+20)|0;v=c[u>>2]|0;if((v|0)==0){w=g+(f+16)|0;x=c[w>>2]|0;if((x|0)==0){y=0;break}else{z=x;A=w}}else{z=v;A=u}while(1){u=z+20|0;v=c[u>>2]|0;if((v|0)!=0){z=v;A=u;continue}u=z+16|0;v=c[u>>2]|0;if((v|0)==0){break}else{z=v;A=u}}if(A>>>0<j>>>0){b8();return 0}else{c[A>>2]=0;y=z;break}}else{u=c[g+(f+8)>>2]|0;if(u>>>0<j>>>0){b8();return 0}v=u+12|0;if((c[v>>2]|0)!=(o|0)){b8();return 0}w=t+8|0;if((c[w>>2]|0)==(o|0)){c[v>>2]=t;c[w>>2]=u;y=t;break}else{b8();return 0}}}while(0);if((s|0)==0){break}t=g+(f+28)|0;l=37160+(c[t>>2]<<2)|0;do{if((o|0)==(c[l>>2]|0)){c[l>>2]=y;if((y|0)!=0){break}c[9215]=c[9215]&~(1<<c[t>>2]);break L52}else{if(s>>>0<(c[9218]|0)>>>0){b8();return 0}k=s+16|0;if((c[k>>2]|0)==(o|0)){c[k>>2]=y}else{c[s+20>>2]=y}if((y|0)==0){break L52}}}while(0);if(y>>>0<(c[9218]|0)>>>0){b8();return 0}c[y+24>>2]=s;o=c[g+(f+16)>>2]|0;do{if((o|0)!=0){if(o>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[y+16>>2]=o;c[o+24>>2]=y;break}}}while(0);o=c[g+(f+20)>>2]|0;if((o|0)==0){break}if(o>>>0<(c[9218]|0)>>>0){b8();return 0}else{c[y+20>>2]=o;c[o+24>>2]=y;break}}}while(0);if(q>>>0<16>>>0){c[d>>2]=p|c[d>>2]&1|2;y=g+(p|4)|0;c[y>>2]=c[y>>2]|1;n=a;return n|0}else{c[d>>2]=c[d>>2]&1|b|2;c[g+(b+4)>>2]=q|3;d=g+(p|4)|0;c[d>>2]=c[d>>2]|1;J$(g+b|0,q);n=a;return n|0}return 0}function J$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=a;e=d+b|0;f=e;g=c[a+4>>2]|0;L1:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){return}i=d+(-h|0)|0;j=i;k=h+b|0;l=c[9218]|0;if(i>>>0<l>>>0){b8()}if((j|0)==(c[9219]|0)){m=d+(b+4)|0;if((c[m>>2]&3|0)!=3){n=j;o=k;break}c[9216]=k;c[m>>2]=c[m>>2]&-2;c[d+(4-h)>>2]=k|1;c[e>>2]=k;return}m=h>>>3;if(h>>>0<256>>>0){p=c[d+(8-h)>>2]|0;q=c[d+(12-h)>>2]|0;r=36896+(m<<1<<2)|0;do{if((p|0)!=(r|0)){if(p>>>0<l>>>0){b8()}if((c[p+12>>2]|0)==(j|0)){break}b8()}}while(0);if((q|0)==(p|0)){c[9214]=c[9214]&~(1<<m);n=j;o=k;break}do{if((q|0)==(r|0)){s=q+8|0}else{if(q>>>0<l>>>0){b8()}t=q+8|0;if((c[t>>2]|0)==(j|0)){s=t;break}b8()}}while(0);c[p+12>>2]=q;c[s>>2]=p;n=j;o=k;break}r=i;m=c[d+(24-h)>>2]|0;t=c[d+(12-h)>>2]|0;do{if((t|0)==(r|0)){u=16-h|0;v=d+(u+4)|0;w=c[v>>2]|0;if((w|0)==0){x=d+u|0;u=c[x>>2]|0;if((u|0)==0){y=0;break}else{z=u;A=x}}else{z=w;A=v}while(1){v=z+20|0;w=c[v>>2]|0;if((w|0)!=0){z=w;A=v;continue}v=z+16|0;w=c[v>>2]|0;if((w|0)==0){break}else{z=w;A=v}}if(A>>>0<l>>>0){b8()}else{c[A>>2]=0;y=z;break}}else{v=c[d+(8-h)>>2]|0;if(v>>>0<l>>>0){b8()}w=v+12|0;if((c[w>>2]|0)!=(r|0)){b8()}x=t+8|0;if((c[x>>2]|0)==(r|0)){c[w>>2]=t;c[x>>2]=v;y=t;break}else{b8()}}}while(0);if((m|0)==0){n=j;o=k;break}t=d+(28-h)|0;l=37160+(c[t>>2]<<2)|0;do{if((r|0)==(c[l>>2]|0)){c[l>>2]=y;if((y|0)!=0){break}c[9215]=c[9215]&~(1<<c[t>>2]);n=j;o=k;break L1}else{if(m>>>0<(c[9218]|0)>>>0){b8()}i=m+16|0;if((c[i>>2]|0)==(r|0)){c[i>>2]=y}else{c[m+20>>2]=y}if((y|0)==0){n=j;o=k;break L1}}}while(0);if(y>>>0<(c[9218]|0)>>>0){b8()}c[y+24>>2]=m;r=16-h|0;t=c[d+r>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[9218]|0)>>>0){b8()}else{c[y+16>>2]=t;c[t+24>>2]=y;break}}}while(0);t=c[d+(r+4)>>2]|0;if((t|0)==0){n=j;o=k;break}if(t>>>0<(c[9218]|0)>>>0){b8()}else{c[y+20>>2]=t;c[t+24>>2]=y;n=j;o=k;break}}else{n=a;o=b}}while(0);a=c[9218]|0;if(e>>>0<a>>>0){b8()}y=d+(b+4)|0;z=c[y>>2]|0;do{if((z&2|0)==0){if((f|0)==(c[9220]|0)){A=(c[9217]|0)+o|0;c[9217]=A;c[9220]=n;c[n+4>>2]=A|1;if((n|0)!=(c[9219]|0)){return}c[9219]=0;c[9216]=0;return}if((f|0)==(c[9219]|0)){A=(c[9216]|0)+o|0;c[9216]=A;c[9219]=n;c[n+4>>2]=A|1;c[n+A>>2]=A;return}A=(z&-8)+o|0;s=z>>>3;L100:do{if(z>>>0<256>>>0){g=c[d+(b+8)>>2]|0;t=c[d+(b+12)>>2]|0;h=36896+(s<<1<<2)|0;do{if((g|0)!=(h|0)){if(g>>>0<a>>>0){b8()}if((c[g+12>>2]|0)==(f|0)){break}b8()}}while(0);if((t|0)==(g|0)){c[9214]=c[9214]&~(1<<s);break}do{if((t|0)==(h|0)){B=t+8|0}else{if(t>>>0<a>>>0){b8()}m=t+8|0;if((c[m>>2]|0)==(f|0)){B=m;break}b8()}}while(0);c[g+12>>2]=t;c[B>>2]=g}else{h=e;m=c[d+(b+24)>>2]|0;l=c[d+(b+12)>>2]|0;do{if((l|0)==(h|0)){i=d+(b+20)|0;p=c[i>>2]|0;if((p|0)==0){q=d+(b+16)|0;v=c[q>>2]|0;if((v|0)==0){C=0;break}else{D=v;E=q}}else{D=p;E=i}while(1){i=D+20|0;p=c[i>>2]|0;if((p|0)!=0){D=p;E=i;continue}i=D+16|0;p=c[i>>2]|0;if((p|0)==0){break}else{D=p;E=i}}if(E>>>0<a>>>0){b8()}else{c[E>>2]=0;C=D;break}}else{i=c[d+(b+8)>>2]|0;if(i>>>0<a>>>0){b8()}p=i+12|0;if((c[p>>2]|0)!=(h|0)){b8()}q=l+8|0;if((c[q>>2]|0)==(h|0)){c[p>>2]=l;c[q>>2]=i;C=l;break}else{b8()}}}while(0);if((m|0)==0){break}l=d+(b+28)|0;g=37160+(c[l>>2]<<2)|0;do{if((h|0)==(c[g>>2]|0)){c[g>>2]=C;if((C|0)!=0){break}c[9215]=c[9215]&~(1<<c[l>>2]);break L100}else{if(m>>>0<(c[9218]|0)>>>0){b8()}t=m+16|0;if((c[t>>2]|0)==(h|0)){c[t>>2]=C}else{c[m+20>>2]=C}if((C|0)==0){break L100}}}while(0);if(C>>>0<(c[9218]|0)>>>0){b8()}c[C+24>>2]=m;h=c[d+(b+16)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[9218]|0)>>>0){b8()}else{c[C+16>>2]=h;c[h+24>>2]=C;break}}}while(0);h=c[d+(b+20)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[9218]|0)>>>0){b8()}else{c[C+20>>2]=h;c[h+24>>2]=C;break}}}while(0);c[n+4>>2]=A|1;c[n+A>>2]=A;if((n|0)!=(c[9219]|0)){F=A;break}c[9216]=A;return}else{c[y>>2]=z&-2;c[n+4>>2]=o|1;c[n+o>>2]=o;F=o}}while(0);o=F>>>3;if(F>>>0<256>>>0){z=o<<1;y=36896+(z<<2)|0;C=c[9214]|0;b=1<<o;do{if((C&b|0)==0){c[9214]=C|b;G=y;H=36896+(z+2<<2)|0}else{o=36896+(z+2<<2)|0;d=c[o>>2]|0;if(d>>>0>=(c[9218]|0)>>>0){G=d;H=o;break}b8()}}while(0);c[H>>2]=n;c[G+12>>2]=n;c[n+8>>2]=G;c[n+12>>2]=y;return}y=n;G=F>>>8;do{if((G|0)==0){I=0}else{if(F>>>0>16777215>>>0){I=31;break}H=(G+1048320|0)>>>16&8;z=G<<H;b=(z+520192|0)>>>16&4;C=z<<b;z=(C+245760|0)>>>16&2;o=14-(b|H|z)+(C<<z>>>15)|0;I=F>>>((o+7|0)>>>0)&1|o<<1}}while(0);G=37160+(I<<2)|0;c[n+28>>2]=I;c[n+20>>2]=0;c[n+16>>2]=0;o=c[9215]|0;z=1<<I;if((o&z|0)==0){c[9215]=o|z;c[G>>2]=y;c[n+24>>2]=G;c[n+12>>2]=n;c[n+8>>2]=n;return}if((I|0)==31){J=0}else{J=25-(I>>>1)|0}I=F<<J;J=c[G>>2]|0;while(1){if((c[J+4>>2]&-8|0)==(F|0)){break}K=J+16+(I>>>31<<2)|0;G=c[K>>2]|0;if((G|0)==0){L=126;break}else{I=I<<1;J=G}}if((L|0)==126){if(K>>>0<(c[9218]|0)>>>0){b8()}c[K>>2]=y;c[n+24>>2]=J;c[n+12>>2]=n;c[n+8>>2]=n;return}K=J+8|0;L=c[K>>2]|0;I=c[9218]|0;if(J>>>0<I>>>0){b8()}if(L>>>0<I>>>0){b8()}c[L+12>>2]=y;c[K>>2]=y;c[n+8>>2]=L;c[n+12>>2]=J;c[n+24>>2]=0;return}function J0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=(a|0)==0?1:a;while(1){d=JW(b)|0;if((d|0)!=0){e=10;break}a=(I=c[10192]|0,c[10192]=I+0,I);if((a|0)==0){e=9;break}x=0;aQ(a|0);if(x){x=0;e=5;break}}do{if((e|0)==5){b=bQ(-1,-1)|0;f=K;g=b}else if((e|0)==9){b=ci(4)|0;c[b>>2]=12880;x=0;aP(144,b|0,28064,464);if(!x){return 0}else{x=0;b=bQ(-1,-1)|0;f=K;g=b;break}}else if((e|0)==10){return d|0}}while(0);if((f|0)<0){bE(g|0);return 0}else{be(g|0)}return 0}function J1(a){a=a|0;var b=0;b=(x=0,as(230,a|0)|0);if(!x){return b|0}else{x=0}b=bQ(-1,-1)|0;if((K|0)<0){bE(b|0);return 0}else{be(b|0)}return 0}function J2(a){a=a|0;if((a|0)==0){return}JX(a);return}function J3(a){a=a|0;J2(a);return}function J4(a){a=a|0;J2(a);return}function J5(a){a=a|0;return}function J6(a){a=a|0;return 7448}function J7(){var a=0;a=ci(4)|0;c[a>>2]=12880;bH(a|0,28064,464)}function J8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0.0;e=b;while(1){f=e+1|0;if((a4(a[e]|0)|0)==0){break}else{e=f}}g=a[e]|0;if((g<<24>>24|0)==45){i=f;j=1}else if((g<<24>>24|0)==43){i=f;j=0}else{i=e;j=0}e=-1;f=0;g=i;while(1){k=a[g]|0;if(((k<<24>>24)-48|0)>>>0<10>>>0){l=e}else{if(k<<24>>24!=46|(e|0)>-1){break}else{l=f}}e=l;f=f+1|0;g=g+1|0}l=g+(-f|0)|0;i=(e|0)<0;m=((i^1)<<31>>31)+f|0;n=(m|0)>18;o=(n?-18:-m|0)+(i?f:e)|0;e=n?18:m;do{if((e|0)==0){p=b;q=0.0}else{if((e|0)>9){m=l;n=e;f=0;while(1){i=a[m]|0;r=m+1|0;if(i<<24>>24==46){s=a[r]|0;t=m+2|0}else{s=i;t=r}u=(f*10|0)-48+(s<<24>>24)|0;r=n-1|0;if((r|0)>9){m=t;n=r;f=u}else{break}}v=+(u|0)*1.0e9;w=9;x=t;y=14}else{if((e|0)>0){v=0.0;w=e;x=l;y=14}else{z=0.0;A=0.0}}if((y|0)==14){f=x;n=w;m=0;while(1){r=a[f]|0;i=f+1|0;if(r<<24>>24==46){B=a[i]|0;C=f+2|0}else{B=r;C=i}D=(m*10|0)-48+(B<<24>>24)|0;i=n-1|0;if((i|0)>0){f=C;n=i;m=D}else{break}}z=+(D|0);A=v}E=A+z;do{if((k<<24>>24|0)==69|(k<<24>>24|0)==101){m=g+1|0;n=a[m]|0;if((n<<24>>24|0)==43){F=g+2|0;G=0}else if((n<<24>>24|0)==45){F=g+2|0;G=1}else{F=m;G=0}m=a[F]|0;if(((m<<24>>24)-48|0)>>>0<10>>>0){H=F;I=0;J=m}else{K=0;L=F;M=G;break}while(1){m=(I*10|0)-48+(J<<24>>24)|0;n=H+1|0;f=a[n]|0;if(((f<<24>>24)-48|0)>>>0<10>>>0){H=n;I=m;J=f}else{K=m;L=n;M=G;break}}}else{K=0;L=g;M=0}}while(0);n=o+((M|0)==0?K:-K|0)|0;m=(n|0)<0?-n|0:n;if((m|0)>511){c[(bY()|0)>>2]=34;N=1.0;O=8;P=511;y=31}else{if((m|0)==0){Q=1.0}else{N=1.0;O=8;P=m;y=31}}if((y|0)==31){while(1){y=0;if((P&1|0)==0){R=N}else{R=N*+h[O>>3]}m=P>>1;if((m|0)==0){Q=R;break}else{N=R;O=O+8|0;P=m;y=31}}}if((n|0)>-1){p=L;q=E*Q;break}else{p=L;q=E/Q;break}}}while(0);if((d|0)!=0){c[d>>2]=p}if((j|0)==0){S=q;return+S}S=-0.0-q;return+S}function J9(a,b,c){a=a|0;b=b|0;c=c|0;return+(+J8(a,b))}function Ka(a){a=a|0;return+(+J8(a,0))}function Kb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function Kc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{Kb(b,c,d)|0}return b|0}function Kd(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0;while((e|0)<(c|0)){f=d[a+e|0]|0;g=d[b+e|0]|0;if((f|0)!=(g|0))return((f|0)>(g|0)?1:-1)|0;e=e+1|0}return 0}function Ke(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function Kf(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function Kg(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function Kh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(K=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function Ki(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(K=e,a-c>>>0|0)|0}function Kj(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){K=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}K=a<<c-32;return 0}function Kk(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){K=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}K=0;return b>>>c-32|0}function Kl(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){K=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}K=(b|0)<0?-1:0;return b>>c-32|0}function Km(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function Kn(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function Ko(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=ag(d,c)|0;f=a>>>16;a=(e>>>16)+(ag(d,f)|0)|0;d=b>>>16;b=ag(d,c)|0;return(K=(a>>>16)+(ag(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function Kp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=Ki(e^a,f^b,e,f)|0;b=K;a=g^e;e=h^f;f=Ki((Ku(i,b,Ki(g^c,h^d,g,h)|0,K,0)|0)^a,K^e,a,e)|0;return(K=K,f)|0}function Kq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=Ki(h^a,j^b,h,j)|0;b=K;Ku(m,b,Ki(k^d,l^e,k,l)|0,K,g)|0;l=Ki(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=K;i=f;return(K=j,l)|0}function Kr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=Ko(e,a)|0;f=K;return(K=(ag(b,a)|0)+(ag(d,e)|0)+f|f&0,c|0|0)|0}function Ks(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Ku(a,b,c,d,0)|0;return(K=K,e)|0}function Kt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;Ku(a,b,d,e,g)|0;i=f;return(K=c[g+4>>2]|0,c[g>>2]|0)|0}function Ku(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(K=n,o)|0}else{if(!m){n=0;o=0;return(K=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(K=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(K=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(K=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((Kn(l|0)|0)>>>0);return(K=n,o)|0}p=(Km(l|0)|0)-(Km(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(K=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(K=n,o)|0}else{if(!m){r=(Km(l|0)|0)-(Km(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(K=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(K=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(Km(j|0)|0)+33-(Km(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(K=n,o)|0}else{p=Kn(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(K=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=Kh(g,d,-1,-1)|0;k=K;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;Ki(e,k,j,a)|0;b=K;h=b>>31|((b|0)<0?-1:0)<<1;J=h&1;L=Ki(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=K;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=J}}B=H;C=I;D=M;E=L;F=0;G=J}J=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(J|0)>>>31|(B|C)<<1|(C<<1|J>>>31)&0|F;o=(J<<1|0>>>31)&-2|G;return(K=n,o)|0}function Kv(a){a=a|0;bu(a|0)}function Kw(a){a=a|0;return aY(a|0)|0}function Kx(a){a=a|0;return b3(a|0)|0}function Ky(a){a=a|0;return bT(a|0)|0}function Kz(a){a=a|0;return bW(a|0)|0}function KA(a){a=a|0;return bV(a|0)|0}function KB(a){a=a|0;return bJ(a|0)|0}function KC(a,b,c){a=a|0;b=b|0;c=c|0;return cl(a|0,b|0,c|0)|0}function KD(a,b,c){a=a|0;b=b|0;c=c|0;return a9(a|0,b|0,c|0)|0}function KE(a,b){a=+a;b=+b;return+bd(+a,+b)}function KF(a,b){a=a|0;b=b|0;return b9(a|0,b|0)|0}function KG(a,b){a=a|0;b=b|0;return bo(a|0,b|0)|0}function KH(){return co()|0}function KI(){return cn()|0}function KJ(){return bt()|0}function KK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bv(a|0,b|0,c|0,d|0)|0}function KL(a,b,c){a=a|0;b=b|0;c=c|0;bH(a|0,b|0,c|0)}function KM(){aZ()}function KN(){bc()}function KO(){ck()}function KP(){cg()}function KQ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return cu[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function KR(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;return cv[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)|0}function KS(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cw[a&63](b|0,c|0,d|0,e|0,f|0)}function KT(a,b){a=a|0;b=b|0;cx[a&1023](b|0)}function KU(a,b,c){a=a|0;b=b|0;c=c|0;cy[a&1023](b|0,c|0)}function KV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return cz[a&127](b|0,c|0,d|0,e|0,f|0,g|0)|0}function KW(a,b){a=a|0;b=b|0;return cA[a&511](b|0)|0}function KX(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;cB[a&3](b|0,c|0,d|0,+e,+f,+g,+h,i|0)}function KY(a,b,c,d,e,f,g,h){a=a|0;b=+b;c=+c;d=+d;e=+e;f=f|0;g=g|0;h=h|0;return cC[a&3](+b,+c,+d,+e,f|0,g|0,h|0)|0}function KZ(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;return cD[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)|0}function K_(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;cE[a&3](b|0,+c,d|0)}function K$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cF[a&127](b|0,c|0,d|0)|0}function K0(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;cG[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0)}function K1(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;cH[a&15](b|0,c|0,d|0,e|0,f|0,+g)}function K2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cI[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function K3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cJ[a&127](b|0,c|0,d|0,e|0,f|0,g|0)}function K4(a,b,c){a=a|0;b=+b;c=+c;return+cK[a&15](+b,+c)}function K5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return+cL[a&3](b|0,c|0,d|0)}function K6(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;cM[a&3](b|0,c|0,d|0,+e,f|0)}function K7(a,b,c){a=a|0;b=b|0;c=+c;return cN[a&3](b|0,+c)|0}function K8(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;cO[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function K9(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;cP[a&7](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function La(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;cQ[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Lb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;cR[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function Lc(a,b,c){a=a|0;b=b|0;c=c|0;return cS[a&1023](b|0,c|0)|0}function Ld(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return+cT[a&7](b|0,c|0,d|0)}function Le(a,b,c){a=a|0;b=b|0;c=c|0;return+cU[a&3](b|0,c|0)}function Lf(a){a=a|0;return cV[a&15]()|0}function Lg(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return cW[a&31](b|0,c|0,d|0,e|0,f|0)|0}function Lh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cX[a&511](b|0,c|0,d|0)}function Li(a){a=a|0;cY[a&15]()}function Lj(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return cZ[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function Lk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return c_[a&63](b|0,c|0,d|0,e|0)|0}function Ll(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;c$[a&63](b|0,c|0,d|0,e|0)}function Lm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ah(0);return 0}function Ln(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;ah(1);return 0}function Lo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ah(2)}function Lp(a){a=a|0;ah(3)}function Lq(a,b){a=a|0;b=b|0;ah(4)}function Lr(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ah(5);return 0}function Ls(a){a=a|0;ah(6);return 0}function Lt(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;ah(7)}function Lu(a,b,c,d,e,f,g){a=+a;b=+b;c=+c;d=+d;e=e|0;f=f|0;g=g|0;ah(8);return 0}function Lv(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;ah(9);return 0}function Lw(a,b,c){a=a|0;b=+b;c=c|0;ah(10)}function Lx(a,b,c){a=a|0;b=b|0;c=c|0;ah(11);return 0}function Ly(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;ah(12)}function Lz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ah(13)}function LA(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ah(14)}function LB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ah(15)}function LC(a,b){a=+a;b=+b;ah(16);return 0.0}function LD(a,b,c){a=a|0;b=b|0;c=c|0;ah(17);return 0.0}function LE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ah(18)}function LF(a,b){a=a|0;b=+b;ah(19);return 0}function LG(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ah(20)}function LH(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ah(21)}function LI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ah(22)}function LJ(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ah(23)}function LK(a,b){a=a|0;b=b|0;ah(24);return 0}function LL(a,b,c){a=a|0;b=b|0;c=c|0;ah(25);return 0.0}function LM(a,b){a=a|0;b=b|0;ah(26);return 0.0}function LN(){ah(27);return 0}function LO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ah(28);return 0}function LP(a,b,c){a=a|0;b=b|0;c=c|0;ah(29)}function LQ(){ah(30)}function LR(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ah(31);return 0}function LS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ah(32);return 0}function LT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ah(33)}
// EMSCRIPTEN_END_FUNCS
var cu=[Lm,Lm,EM,Lm,En,Lm,Lm,Lm];var cv=[Ln,Ln,op,Ln];var cw=[Lo,Lo,rY,Lo,mV,Lo,JS,Lo,jT,Lo,kb,Lo,sC,Lo,xF,Lo,rZ,Lo,v6,Lo,ei,Lo,JR,Lo,fT,Lo,kl,Lo,JQ,Lo,uW,Lo,hn,Lo,kw,Lo,tw,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo,Lo];var cx=[Lp,Lp,Ho,Lp,ed,Lp,on,Lp,Ef,Lp,Cq,Lp,Cd,Lp,Ij,Lp,j3,Lp,zi,Lp,vn,Lp,Ea,Lp,f9,Lp,jP,Lp,Fc,Lp,l1,Lp,jG,Lp,HG,Lp,Fq,Lp,Gv,Lp,q9,Lp,vG,Lp,ez,Lp,kn,Lp,JG,Lp,IH,Lp,GW,Lp,xl,Lp,Cv,Lp,Eg,Lp,nh,Lp,IG,Lp,v_,Lp,uO,Lp,Fb,Lp,lC,Lp,vf,Lp,fW,Lp,F2,Lp,m6,Lp,u4,Lp,i7,Lp,Jj,Lp,Jk,Lp,Dp,Lp,mi,Lp,zx,Lp,jv,Lp,ul,Lp,JD,Lp,lS,Lp,BT,Lp,D0,Lp,Ad,Lp,v7,Lp,uE,Lp,G0,Lp,dI,Lp,He,Lp,B7,Lp,f8,Lp,jV,Lp,vo,Lp,mB,Lp,wi,Lp,mc,Lp,wB,Lp,xd,Lp,DN,Lp,DU,Lp,vP,Lp,FE,Lp,JI,Lp,ng,Lp,HW,Lp,fV,Lp,Hu,Lp,f4,Lp,Cy,Lp,e$,Lp,D6,Lp,kc,Lp,v8,Lp,uv,Lp,hy,Lp,ha,Lp,zw,Lp,ec,Lp,fF,Lp,DH,Lp,D4,Lp,jQ,Lp,IK,Lp,Hd,Lp,DM,Lp,Cq,Lp,II,Lp,w3,Lp,uN,Lp,jn,Lp,Gw,Lp,FR,Lp,Gk,Lp,Da,Lp,m7,Lp,JJ,Lp,dT,Lp,H3,Lp,od,Lp,D5,Lp,GR,Lp,i8,Lp,mW,Lp,Hx,Lp,xc,Lp,xx,Lp,CJ,Lp,JC,Lp,F3,Lp,CK,Lp,ji,Lp,D9,Lp,dH,Lp,uF,Lp,G$,Lp,qf,Lp,DS,Lp,CH,Lp,e0,Lp,DC,Lp,kd,Lp,oa,Lp,uw,Lp,e7,Lp,C7,Lp,DR,Lp,HA,Lp,hb,Lp,vF,Lp,GH,Lp,wU,Lp,Ji,Lp,vw,Lp,fu,Lp,BU,Lp,mt,Lp,JF,Lp,G8,Lp,CP,Lp,Cu,Lp,u5,Lp,Cx,Lp,zj,Lp,EJ,Lp,jm,Lp,um,Lp,HV,Lp,e9,Lp,FS,Lp,D_,Lp,vO,Lp,Hk,Lp,k6,Lp,mX,Lp,xw,Lp,d2,Lp,HI,Lp,hx,Lp,Cv,Lp,D8,Lp,B$,Lp,F5,Lp,ob,Lp,ws,Lp,wK,Lp,hp,Lp,DT,Lp,J4,Lp,g1,Lp,pm,Lp,iJ,Lp,ub,Lp,oc,Lp,eN,Lp,GG,Lp,w2,Lp,xn,Lp,mL,Lp,JH,Lp,dS,Lp,dy,Lp,l0,Lp,B6,Lp,n8,Lp,HC,Lp,F9,Lp,Fp,Lp,vx,Lp,Eb,Lp,BV,Lp,dV,Lp,G7,Lp,C$,Lp,JD,Lp,JK,Lp,pl,Lp,q5,Lp,en,Lp,eB,Lp,DZ,Lp,Hj,Lp,uX,Lp,Ht,Lp,Ce,Lp,k5,Lp,q6,Lp,Do,Lp,DQ,Lp,Ae,Lp,Hp,Lp,F6,Lp,wV,Lp,Jn,Lp,Ek,Lp,ms,Lp,Db,Lp,DE,Lp,HH,Lp,B0,Lp,Cp,Lp,wt,Lp,jF,Lp,J5,Lp,Cq,Lp,HF,Lp,EK,Lp,JB,Lp,ia,Lp,mM,Lp,ey,Lp,eC,Lp,km,Lp,kz,Lp,iW,Lp,Hy,Lp,jj,Lp,mC,Lp,oe,Lp,xo,Lp,vZ,Lp,lD,Lp,Ga,Lp,JX,Lp,Gl,Lp,ve,Lp,fE,Lp,Jg,Lp,dU,Lp,j2,Lp,Iu,Lp,DD,Lp,D7,Lp,mj,Lp,wL,Lp,D$,Lp,fR,Lp,uY,Lp,DF,Lp,iK,Lp,uc,Lp,Jm,Lp,eO,Lp,jU,Lp,qe,Lp,GU,Lp,Jl,Lp,DO,Lp,d1,Lp,Ib,Lp,IJ,Lp,El,Lp,g0,Lp,wj,Lp,mb,Lp,ky,Lp,dz,Lp,eA,Lp,jw,Lp,wC,Lp,iX,Lp,lT,Lp,n9,Lp,Kv,Lp,eD,Lp,CG,Lp,FD,Lp,ex,Lp,IF,Lp,GS,Lp,DL,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp,Lp];var cy=[Lq,Lq,q7,Lq,IT,Lq,lP,Lq,fG,Lq,BW,Lq,zh,Lq,fj,Lq,xe,Lq,ri,Lq,pS,Lq,B1,Lq,rd,Lq,fr,Lq,pJ,Lq,d3,Lq,nt,Lq,qB,Lq,q1,Lq,jH,Lq,nq,Lq,nb,Lq,qc,Lq,pp,Lq,q2,Lq,mY,Lq,pn,Lq,qT,Lq,eP,Lq,ry,Lq,v9,Lq,rC,Lq,p7,Lq,eb,Lq,rc,Lq,nn,Lq,GC,Lq,ua,Lq,pQ,Lq,xp,Lq,pu,Lq,qO,Lq,rf,Lq,HB,Lq,iY,Lq,qx,Lq,rU,Lq,jk,Lq,B8,Lq,Cs,Lq,nF,Lq,pt,Lq,rg,Lq,n1,Lq,iT,Lq,p1,Lq,nJ,Lq,GK,Lq,rk,Lq,qt,Lq,rO,Lq,qG,Lq,nu,Lq,Gr,Lq,wM,Lq,pk,Lq,nx,Lq,i9,Lq,jo,Lq,ux,Lq,nN,Lq,Dc,Lq,p_,Lq,qE,Lq,w4,Lq,rA,Lq,rh,Lq,Hs,Lq,iE,Lq,uZ,Lq,nV,Lq,nR,Lq,pB,Lq,p6,Lq,eg,Lq,qw,Lq,wk,Lq,ns,Lq,qN,Lq,Ge,Lq,pU,Lq,qW,Lq,Jh,Lq,ny,Lq,rT,Lq,dQ,Lq,pF,Lq,rK,Lq,wu,Lq,un,Lq,C9,Lq,rn,Lq,qF,Lq,pN,Lq,n_,Lq,GL,Lq,mk,Lq,eJ,Lq,pq,Lq,np,Lq,jW,Lq,nQ,Lq,nG,Lq,nK,Lq,pG,Lq,nS,Lq,u6,Lq,mh,Lq,mN,Lq,qk,Lq,q_,Lq,Hv,Lq,nM,Lq,IQ,Lq,h9,Lq,qh,Lq,C3,Lq,IP,Lq,e_,Lq,pK,Lq,pL,Lq,Hn,Lq,e6,Lq,Dq,Lq,Cf,Lq,g$,Lq,qS,Lq,e4,Lq,Ac,Lq,Gf,Lq,n2,Lq,fB,Lq,g2,Lq,rv,Lq,qd,Lq,qm,Lq,fC,Lq,GN,Lq,qM,Lq,p3,Lq,rq,Lq,rV,Lq,ma,Lq,p2,Lq,vp,Lq,pz,Lq,nO,Lq,ra,Lq,zk,Lq,qz,Lq,q$,Lq,mg,Lq,h8,Lq,rm,Lq,qq,Lq,v$,Lq,rb,Lq,pX,Lq,qP,Lq,IR,Lq,Gt,Lq,f2,Lq,rM,Lq,C8,Lq,rR,Lq,l9,Lq,qL,Lq,nj,Lq,zc,Lq,pv,Lq,p8,Lq,C6,Lq,nZ,Lq,Gz,Lq,qy,Lq,eq,Lq,ef,Lq,Gj,Lq,ee,Lq,qi,Lq,nE,Lq,m8,Lq,nX,Lq,qj,Lq,qD,Lq,GB,Lq,pr,Lq,vg,Lq,rL,Lq,lO,Lq,nC,Lq,qH,Lq,re,Lq,vy,Lq,uG,Lq,GM,Lq,ro,Lq,qu,Lq,rr,Lq,nl,Lq,jO,Lq,pV,Lq,nv,Lq,GF,Lq,xy,Lq,lU,Lq,qR,Lq,dr,Lq,dJ,Lq,rE,Lq,m4,Lq,qr,Lq,nk,Lq,nI,Lq,rp,Lq,hc,Lq,rS,Lq,Ct,Lq,qV,Lq,wD,Lq,pR,Lq,i5,Lq,qQ,Lq,iI,Lq,Gd,Lq,rF,Lq,ko,Lq,na,Lq,lM,Lq,kA,Lq,qJ,Lq,q8,Lq,lE,Lq,nm,Lq,pH,Lq,t9,Lq,IS,Lq,qg,Lq,e5,Lq,C2,Lq,rG,Lq,rt,Lq,Gp,Lq,e1,Lq,p9,Lq,qs,Lq,Go,Lq,ea,Lq,qp,Lq,fq,Lq,GE,Lq,qY,Lq,rI,Lq,qI,Lq,rs,Lq,e3,Lq,ud,Lq,kv,Lq,y9,Lq,ff,Lq,ne,Lq,pZ,Lq,fX,Lq,nw,Lq,rx,Lq,kx,Lq,j1,Lq,rD,Lq,dW,Lq,pw,Lq,ew,Lq,pP,Lq,nW,Lq,m5,Lq,qa,Lq,eX,Lq,CV,Lq,GA,Lq,ru,Lq,n$,Lq,jx,Lq,px,Lq,nA,Lq,qn,Lq,Gq,Lq,nf,Lq,ke,Lq,nz,Lq,pC,Lq,j4,Lq,jR,Lq,CU,Lq,Co,Lq,nY,Lq,jh,Lq,mD,Lq,p4,Lq,qZ,Lq,qo,Lq,qX,Lq,ps,Lq,i3,Lq,pD,Lq,mf,Lq,pY,Lq,ql,Lq,Gu,Lq,rw,Lq,Gg,Lq,kI,Lq,GP,Lq,qA,Lq,uP,Lq,rW,Lq,rH,Lq,dA,Lq,p0,Lq,nD,Lq,nB,Lq,qC,Lq,vH,Lq,rj,Lq,wW,Lq,jg,Lq,pA,Lq,GQ,Lq,iL,Lq,pM,Lq,nH,Lq,pj,Lq,mu,Lq,l2,Lq,nd,Lq,of,Lq,qv,Lq,rN,Lq,pI,Lq,p5,Lq,qK,Lq,IU,Lq,rz,Lq,pW,Lq,qU,Lq,rl,Lq,rQ,Lq,vQ,Lq,rP,Lq,pE,Lq,DJ,Lq,rJ,Lq,Gi,Lq,g_,Lq,ni,Lq,md,Lq,py,Lq,pO,Lq,no,Lq,q0,Lq,nL,Lq,pT,Lq,dR,Lq,nr,Lq,rB,Lq,nP,Lq,p$,Lq,nU,Lq,h7,Lq,nT,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq,Lq];var cz=[Lr,Lr,oB,Lr,o2,Lr,oC,Lr,ox,Lr,oM,Lr,pi,Lr,pb,Lr,oU,Lr,oL,Lr,oX,Lr,os,Lr,oQ,Lr,oW,Lr,oG,Lr,o6,Lr,oN,Lr,pe,Lr,ow,Lr,oH,Lr,oq,Lr,oJ,Lr,o$,Lr,pc,Lr,oy,Lr,o1,Lr,oR,Lr,o_,Lr,oE,Lr,ov,Lr,o7,Lr,pf,Lr,oS,Lr,oI,Lr,oD,Lr,oF,Lr,o4,Lr,oV,Lr,ph,Lr,oK,Lr,oO,Lr,pg,Lr,pa,Lr,o0,Lr,oY,Lr,ot,Lr,pd,Lr,oZ,Lr,oT,Lr,o8,Lr,ou,Lr,ga,Lr,or,Lr,o3,Lr,o5,Lr,oP,Lr,o9,Lr,Lr,Lr,Lr,Lr,Lr,Lr,Lr,Lr,Lr,Lr,Lr,Lr,Lr,Lr];var cA=[Ls,Ls,I6,Ls,IN,Ls,IY,Ls,sU,Ls,I4,Ls,B9,Ls,Kw,Ls,Gm,Ls,sX,Ls,FF,Ls,Ch,Ls,Dx,Ls,kJ,Ls,IO,Ls,dn,Ls,Kx,Ls,sF,Ls,sZ,Ls,IM,Ls,sW,Ls,BQ,Ls,sE,Ls,ys,Ls,sV,Ls,dm,Ls,GI,Ls,IV,Ls,DG,Ls,D2,Ls,xP,Ls,tb,Ls,Du,Ls,Gs,Ls,I5,Ls,fN,Ls,s0,Ls,Dv,Ls,di,Ls,I2,Ls,J1,Ls,s8,Ls,sx,Ls,e2,Ls,dl,Ls,FT,Ls,I_,Ls,JE,Ls,Cw,Ls,GO,Ls,I1,Ls,Gn,Ls,Iq,Ls,kH,Ls,eZ,Ls,Jw,Ls,sq,Ls,Gh,Ls,B3,Ls,sY,Ls,Ip,Ls,Ig,Ls,iS,Ls,dk,Ls,sp,Ls,fi,Ls,Gy,Ls,GJ,Ls,tz,Ls,tC,Ls,IE,Ls,tZ,Ls,tm,Ls,Dk,Ls,IB,Ls,s9,Ls,dp,Ls,sy,Ls,DP,Ls,s6,Ls,ss,Ls,IL,Ls,tc,Ls,Dg,Ls,Ia,Ls,H7,Ls,eW,Ls,yk,Ls,B2,Ls,tX,Ls,iV,Ls,tV,Ls,Dh,Ls,td,Ls,ok,Ls,mU,Ls,sg,Ls,Cg,Ls,xQ,Ls,Gb,Ls,IX,Ls,Gc,Ls,Gx,Ls,Ii,Ls,Cr,Ls,IW,Ls,I3,Ls,Ky,Ls,sz,Ls,Dj,Ls,xM,Ls,H8,Ls,eY,Ls,Dy,Ls,sr,Ls,J0,Ls,hl,Ls,IA,Ls,I0,Ls,I$,Ls,oj,Ls,fO,Ls,tF,Ls,BX,Ls,tp,Ls,Kz,Ls,KA,Ls,iU,Ls,su,Ls,m3,Ls,r_,Ls,sv,Ls,tW,Ls,yi,Ls,n7,Ls,dq,Ls,yr,Ls,J6,Ls,tA,Ls,GD,Ls,IZ,Ls,tB,Ls,If,Ls,tl,Ls,eG,Ls,KB,Ls,It,Ls,mK,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls,Ls];var cB=[Lt,Lt,fU,Lt];var cC=[Lu,Lu,oA,Lu];var cD=[Lv,Lv,G2,Lv,GV,Lv,Lv,Lv];var cE=[Lw,Lw,y7,Lw];var cF=[Lx,Lx,Jo,Lx,JL,Lx,HJ,Lx,H1,Lx,BY,Lx,CC,Lx,Hl,Lx,nc,Lx,Ee,Lx,hM,Lx,HT,Lx,Dr,Lx,KC,Lx,hN,Lx,HO,Lx,hz,Lx,HQ,Lx,HY,Lx,Js,Lx,Ej,Lx,Dm,Lx,Hq,Lx,H_,Lx,KD,Lx,G4,Lx,DI,Lx,Jt,Lx,og,Lx,CT,Lx,CB,Lx,Di,Lx,CW,Lx,GY,Lx,Dw,Lx,Dd,Lx,Ca,Lx,DA,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx,Lx];var cG=[Ly,Ly,Hb,Ly,Hh,Ly,Ly,Ly];var cH=[Lz,Lz,Fn,Lz,Fk,Lz,FA,Lz,Fy,Lz,Lz,Lz,Lz,Lz,Lz,Lz];var cI=[LA,LA,F7,LA,uu,LA,F4,LA,CX,LA,G3,LA,GT,LA,GX,LA,fD,LA,G1,LA,LA,LA,LA,LA,LA,LA,LA,LA,LA,LA,LA,LA];var cJ=[LB,LB,jS,LB,JU,LB,eM,LB,mr,LB,Ds,LB,tk,LB,JV,LB,wT,LB,eh,LB,De,LB,ej,LB,w1,LB,eE,LB,jl,LB,JT,LB,oh,LB,eL,LB,t6,LB,lQ,LB,Fw,LB,Fd,LB,Fi,LB,Fe,LB,kL,LB,Fs,LB,Fr,LB,FB,LB,vX,LB,uk,LB,Fo,LB,Hm,LB,Hr,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB,LB];var cK=[LC,LC,KE,LC,hs,LC,hu,LC,ht,LC,hv,LC,LC,LC,LC,LC];var cL=[LD,LD,I9,LD];var cM=[LE,LE,kK,LE];var cN=[LF,LF,DX,LF];var cO=[LG,LG,FK,LG,me,LG,FX,LG,EX,LG,EP,LG,ER,LG,EV,LG,EN,LG,EL,LG,E1,LG,E$,LG,EZ,LG,FY,LG,Ey,LG,Eq,LG,Es,LG,Ew,LG,EE,LG,EC,LG,EA,LG,FW,LG,Hi,LG,CY,LG,Ft,LG,FI,LG,Fu,LG,Eo,LG,eu,LG,f7,LG,Eu,LG,FU,LG,Hc,LG,FG,LG,FJ,LG,Fz,LG,E3,LG,Fj,LG,Fh,LG,EG,LG,Fg,LG,Fx,LG,Fv,LG,Fm,LG,jE,LG,ET,LG,FV,LG,Em,LG,FH,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG];var cP=[LH,LH,G9,LH,Hf,LH,LH,LH];var cQ=[LI,LI,FL,LI,FZ,LI,LI,LI];var cR=[LJ,LJ,Hg,LJ,GZ,LJ,G5,LJ,Ha,LJ,LJ,LJ,LJ,LJ,LJ,LJ];var cS=[LK,LK,w_,LK,vj,LK,jA,LK,dM,LK,dt,LK,vT,LK,kY,LK,kO,LK,wy,LK,hJ,LK,iv,LK,lA,LK,gD,LK,gl,LK,jq,LK,ki,LK,mo,LK,w5,LK,mP,LK,v3,LK,dK,LK,kg,LK,uI,LK,eQ,LK,dj,LK,gq,LK,kq,LK,fJ,LK,ij,LK,mO,LK,xr,LK,lv,LK,KF,LK,mR,LK,gU,LK,iZ,LK,v0,LK,gg,LK,dh,LK,gK,LK,h0,LK,hI,LK,ln,LK,fl,LK,iy,LK,kP,LK,h$,LK,lI,LK,h2,LK,uT,LK,gi,LK,i4,LK,ks,LK,gI,LK,gH,LK,el,LK,lg,LK,ll,LK,lp,LK,fY,LK,jY,LK,hA,LK,ug,LK,mw,LK,lz,LK,ld,LK,fI,LK,w8,LK,gY,LK,wP,LK,ek,LK,i_,LK,uH,LK,gw,LK,ww,LK,la,LK,k0,LK,wQ,LK,gm,LK,wX,LK,KG,LK,vh,LK,uB,LK,du,LK,HD,LK,kM,LK,k3,LK,eo,LK,gv,LK,gJ,LK,vS,LK,dv,LK,mv,LK,kf,LK,kV,LK,vL,LK,hB,LK,HE,LK,xz,LK,gf,LK,lx,LK,gc,LK,mH,LK,it,LK,ip,LK,gP,LK,k4,LK,k7,LK,vr,LK,C0,LK,ly,LK,xh,LK,d4,LK,uQ,LK,wH,LK,k8,LK,uA,LK,vB,LK,vs,LK,DY,LK,dN,LK,H$,LK,h1,LK,Dz,LK,u9,LK,wG,LK,hg,LK,uq,LK,xC,LK,hT,LK,fa,LK,gW,LK,Cb,LK,lh,LK,lq,LK,l6,LK,gE,LK,lF,LK,im,LK,gC,LK,dL,LK,gj,LK,d7,LK,eI,LK,wN,LK,gn,LK,d6,LK,lk,LK,iN,LK,iA,LK,lr,LK,li,LK,vq,LK,my,LK,DW,LK,DV,LK,wl,LK,gV,LK,hU,LK,lu,LK,mG,LK,m_,LK,is,LK,n6,LK,dD,LK,gN,LK,ue,LK,mE,LK,gp,LK,u1,LK,h4,LK,wO,LK,CQ,LK,ur,LK,wx,LK,wF,LK,m$,LK,xg,LK,vI,LK,hH,LK,lf,LK,kZ,LK,gd,LK,iB,LK,f_,LK,wd,LK,vU,LK,hE,LK,vK,LK,k$,LK,uR,LK,uz,LK,gZ,LK,j_,LK,kS,LK,eH,LK,vt,LK,hd,LK,lV,LK,wZ,LK,uf,LK,gS,LK,uK,LK,xi,LK,k_,LK,dE,LK,eS,LK,jb,LK,ii,LK,il,LK,wc,LK,lG,LK,j8,LK,gh,LK,n0,LK,gG,LK,hD,LK,lw,LK,lX,LK,mn,LK,hX,LK,gt,LK,Ci,LK,dY,LK,hZ,LK,ic,LK,gQ,LK,fZ,LK,v1,LK,uy,LK,kB,LK,vC,LK,u8,LK,gA,LK,j6,LK,gL,LK,h6,LK,jX,LK,ls,LK,ie,LK,hG,LK,g5,LK,gT,LK,fK,LK,ig,LK,le,LK,gO,LK,tn,LK,xt,LK,HN,LK,u$,LK,kN,LK,fc,LK,jL,LK,ix,LK,gr,LK,xf,LK,vA,LK,l5,LK,kh,LK,wv,LK,ih,LK,vJ,LK,ik,LK,ds,LK,gB,LK,v2,LK,ml,LK,CR,LK,mF,LK,k1,LK,u7,LK,lY,LK,va,LK,wo,LK,kW,LK,jc,LK,hC,LK,iC,LK,lo,LK,l4,LK,mm,LK,ja,LK,uh,LK,ib,LK,gz,LK,w7,LK,DB,LK,eR,LK,iP,LK,sD,LK,dB,LK,wb,LK,dZ,LK,mx,LK,jz,LK,w6,LK,lb,LK,k9,LK,dC,LK,lH,LK,u_,LK,wE,LK,gs,LK,mQ,LK,jK,LK,wn,LK,gy,LK,i$,LK,lj,LK,mZ,LK,kr,LK,f$,LK,vk,LK,kT,LK,iw,LK,Dl,LK,BZ,LK,uo,LK,eT,LK,ge,LK,iO,LK,hK,LK,lc,LK,wY,LK,kX,LK,l3,LK,gF,LK,jI,LK,iD,LK,lm,LK,jJ,LK,hf,LK,HX,LK,vR,LK,hY,LK,jy,LK,jr,LK,lt,LK,kE,LK,xq,LK,wm,LK,fH,LK,up,LK,k2,LK,HR,LK,d5,LK,h_,LK,u0,LK,vi,LK,gb,LK,js,LK,hF,LK,B4,LK,fb,LK,xs,LK,wa,LK,d_,LK,xB,LK,kC,LK,gu,LK,gX,LK,he,LK,lW,LK,j7,LK,io,LK,m0,LK,g6,LK,iu,LK,iz,LK,uS,LK,gM,LK,kD,LK,ol,LK,go,LK,jB,LK,iq,LK,HZ,LK,gx,LK,kQ,LK,g4,LK,g3,LK,gk,LK,kp,LK,j5,LK,ir,LK,jp,LK,h5,LK,HP,LK,iM,LK,jd,LK,id,LK,vz,LK,i0,LK,kU,LK,jZ,LK,kR,LK,Dn,LK,om,LK,uJ,LK,em,LK,h3,LK,xA,LK,dX,LK,gR,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK,LK];var cT=[LL,LL,I7,LL,I8,LL,LL,LL];var cU=[LM,LM,BR,LM];var cV=[LN,LN,KH,LN,Hz,LN,KI,LN,KJ,LN,LN,LN,LN,LN,LN,LN];var cW=[LO,LO,HU,LO,Ec,LO,Jq,LO,H9,LO,Ih,LO,IC,LO,Ir,LO,Ju,LO,Io,LO,Eh,LO,hW,LO,Iz,LO,H2,LO,H6,LO,Ie,LO];var cX=[LP,LP,CI,LP,j9,LP,d0,LP,dO,LP,Az,LP,AR,LP,q4,LP,mq,LP,fM,LP,vm,LP,n3,LP,Aj,LP,ku,LP,fg,LP,zA,LP,A$,LP,kt,LP,uL,LP,jN,LP,wR,LP,AJ,LP,i6,LP,i2,LP,l8,LP,Ah,LP,vu,LP,hr,LP,z0,LP,Ao,LP,kk,LP,z1,LP,zD,LP,CZ,LP,xa,LP,zT,LP,ui,LP,Am,LP,uD,LP,vD,LP,CS,LP,zQ,LP,dx,LP,Al,LP,CM,LP,G6,LP,zJ,LP,z2,LP,zY,LP,An,LP,g7,LP,dF,LP,vE,LP,wS,LP,hi,LP,zz,LP,mJ,LP,Aw,LP,xv,LP,j$,LP,AU,LP,zq,LP,vN,LP,AG,LP,Af,LP,AI,LP,uC,LP,As,LP,Ax,LP,f1,LP,iH,LP,zV,LP,KL,LP,z4,LP,AK,LP,zZ,LP,zO,LP,ka,LP,zt,LP,zM,LP,kG,LP,Av,LP,zu,LP,Au,LP,xE,LP,xD,LP,Ak,LP,zE,LP,z7,LP,vl,LP,kj,LP,uU,LP,mS,LP,kF,LP,vb,LP,AW,LP,jf,LP,hV,LP,AB,LP,xb,LP,zR,LP,AF,LP,vW,LP,jD,LP,jC,LP,zv,LP,z8,LP,vM,LP,Ai,LP,zS,LP,zp,LP,AD,LP,m1,LP,v5,LP,zG,LP,xk,LP,mz,LP,AN,LP,AL,LP,zP,LP,iQ,LP,CE,LP,jM,LP,v4,LP,je,LP,Hw,LP,l_,LP,Ap,LP,j0,LP,g8,LP,mI,LP,u3,LP,z5,LP,qb,LP,iR,LP,AX,LP,vV,LP,zX,LP,A1,LP,vc,LP,w$,LP,vY,LP,AH,LP,xj,LP,lK,LP,uV,LP,AA,LP,AV,LP,AM,LP,uj,LP,xu,LP,hh,LP,z6,LP,d9,LP,ju,LP,m2,LP,z9,LP,zs,LP,wA,LP,Ay,LP,AC,LP,eV,LP,n4,LP,AY,LP,Aq,LP,zL,LP,Aa,LP,we,LP,lZ,LP,CA,LP,dP,LP,zK,LP,zH,LP,AO,LP,zy,LP,uM,LP,zo,LP,wq,LP,vv,LP,d$,LP,zB,LP,ho,LP,e8,LP,Ag,LP,w0,LP,A0,LP,Ar,LP,AQ,LP,dG,LP,fn,LP,f0,LP,u2,LP,wf,LP,dw,LP,fh,LP,zr,LP,z$,LP,fv,LP,wp,LP,Ab,LP,lL,LP,fP,LP,fL,LP,zF,LP,d8,LP,lJ,LP,s4,LP,z3,LP,AP,LP,CF,LP,AT,LP,zC,LP,AZ,LP,AS,LP,zU,LP,zN,LP,w9,LP,zW,LP,AE,LP,zn,LP,zI,LP,mA,LP,wJ,LP,A_,LP,At,LP,jt,LP,l$,LP,mT,LP,eU,LP,D3,LP,i1,LP,ut,LP,us,LP,r4,LP,l7,LP,z_,LP,wI,LP,wz,LP,mp,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP,LP];var cY=[LQ,LQ,KM,LQ,J7,LQ,KN,LQ,KO,LQ,KP,LQ,LQ,LQ,LQ,LQ];var cZ=[LR,LR,Iv,LR,H5,LR,Ix,LR,H4,LR,Ik,LR,Ic,LR,Im,LR,Id,LR,LR,LR,LR,LR,LR,LR,LR,LR,LR,LR,LR,LR,LR,LR];var c_=[LS,LS,Jc,LS,Je,LS,Jd,LS,HL,LS,hP,LS,HM,LS,HK,LS,Jr,LS,EI,LS,hQ,LS,Ja,LS,DK,LS,Fl,LS,Jb,LS,ta,LS,KK,LS,HS,LS,Jp,LS,Jf,LS,H0,LS,hR,LS,to,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS,LS];var c$=[LT,LT,vd,LT,hL,LT,lR,LT,fd,LT,wr,LT,Ei,LT,Dt,LT,Ed,LT,eF,LT,JN,LT,JO,LT,Df,LT,xm,LT,xG,LT,wh,LT,m9,LT,r2,LT,oi,LT,hj,LT,n5,LT,hq,LT,JM,LT,wg,LT,hw,LT,sG,LT,g9,LT,hk,LT,LT,LT,LT,LT,LT,LT,LT,LT];return{_memcmp:Kd,_strlen:Kf,_free:JX,_realloc:JZ,_sass_compile_emscripten:hm,_memmove:Kc,__GLOBAL__I_a:Ck,_memset:Ke,_malloc:JW,_memcpy:Kb,_strcpy:Kg,_calloc:JY,runPostSets:dg,stackAlloc:c0,stackSave:c1,stackRestore:c2,setThrew:c3,setTempRet0:c6,setTempRet1:c7,setTempRet2:c8,setTempRet3:c9,setTempRet4:da,setTempRet5:db,setTempRet6:dc,setTempRet7:dd,setTempRet8:de,setTempRet9:df,dynCall_iiiiiiii:KQ,dynCall_iiiiiiddi:KR,dynCall_viiiii:KS,dynCall_vi:KT,dynCall_vii:KU,dynCall_iiiiiii:KV,dynCall_ii:KW,dynCall_viiiddddi:KX,dynCall_iddddiii:KY,dynCall_iiiiiiiiiiii:KZ,dynCall_vidi:K_,dynCall_iiii:K$,dynCall_viiiiiiiiiiiiiii:K0,dynCall_viiiiid:K1,dynCall_viiiiiiii:K2,dynCall_viiiiii:K3,dynCall_ddd:K4,dynCall_fiii:K5,dynCall_viiidi:K6,dynCall_iid:K7,dynCall_viiiiiii:K8,dynCall_viiiiiid:K9,dynCall_viiiiiiiii:La,dynCall_viiiiiiiiii:Lb,dynCall_iii:Lc,dynCall_diii:Ld,dynCall_dii:Le,dynCall_i:Lf,dynCall_iiiiii:Lg,dynCall_viii:Lh,dynCall_v:Li,dynCall_iiiiiiiii:Lj,dynCall_iiiii:Lk,dynCall_viiii:Ll}})
// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_iiiiiiddi": invoke_iiiiiiddi, "invoke_viiiii": invoke_viiiii, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiii": invoke_iiiiiii, "invoke_ii": invoke_ii, "invoke_viiiddddi": invoke_viiiddddi, "invoke_iddddiii": invoke_iddddiii, "invoke_iiiiiiiiiiii": invoke_iiiiiiiiiiii, "invoke_vidi": invoke_vidi, "invoke_iiii": invoke_iiii, "invoke_viiiiiiiiiiiiiii": invoke_viiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_ddd": invoke_ddd, "invoke_fiii": invoke_fiii, "invoke_viiidi": invoke_viiidi, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_viiiiiiiiii": invoke_viiiiiiiiii, "invoke_iii": invoke_iii, "invoke_diii": invoke_diii, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiii": invoke_iiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_llvm_lifetime_end": _llvm_lifetime_end, "_lseek": _lseek, "__scanString": __scanString, "_fclose": _fclose, "_pthread_mutex_lock": _pthread_mutex_lock, "___cxa_end_catch": ___cxa_end_catch, "_strtoull": _strtoull, "_fflush": _fflush, "_strtol": _strtol, "__isLeapYear": __isLeapYear, "_fwrite": _fwrite, "_send": _send, "_isspace": _isspace, "_read": _read, "_ceil": _ceil, "_fsync": _fsync, "___cxa_guard_abort": ___cxa_guard_abort, "_newlocale": _newlocale, "___gxx_personality_v0": ___gxx_personality_v0, "_pthread_cond_wait": _pthread_cond_wait, "___cxa_rethrow": ___cxa_rethrow, "_fmod": _fmod, "___resumeException": ___resumeException, "_llvm_va_end": _llvm_va_end, "_vsscanf": _vsscanf, "_snprintf": _snprintf, "_fgetc": _fgetc, "__getFloat": __getFloat, "_atexit": _atexit, "___cxa_free_exception": ___cxa_free_exception, "_close": _close, "___setErrNo": ___setErrNo, "_isxdigit": _isxdigit, "_ftell": _ftell, "_exit": _exit, "_sprintf": _sprintf, "_asprintf": _asprintf, "___ctype_b_loc": ___ctype_b_loc, "_freelocale": _freelocale, "_catgets": _catgets, "___cxa_is_number_type": ___cxa_is_number_type, "_getcwd": _getcwd, "___cxa_does_inherit": ___cxa_does_inherit, "___cxa_guard_acquire": ___cxa_guard_acquire, "___cxa_begin_catch": ___cxa_begin_catch, "_recv": _recv, "__parseInt64": __parseInt64, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "___cxa_call_unexpected": ___cxa_call_unexpected, "__exit": __exit, "_strftime": _strftime, "___cxa_throw": ___cxa_throw, "_llvm_eh_exception": _llvm_eh_exception, "_toupper": _toupper, "_pread": _pread, "_fopen": _fopen, "_open": _open, "__arraySum": __arraySum, "_isalnum": _isalnum, "_isalpha": _isalpha, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_strdup": _strdup, "__formatString": __formatString, "_pthread_cond_broadcast": _pthread_cond_broadcast, "__ZSt9terminatev": __ZSt9terminatev, "_isascii": _isascii, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_sbrk": _sbrk, "___errno_location": ___errno_location, "_strerror": _strerror, "_catclose": _catclose, "_llvm_lifetime_start": _llvm_lifetime_start, "__parseInt": __parseInt, "___cxa_guard_release": ___cxa_guard_release, "_ungetc": _ungetc, "_uselocale": _uselocale, "_vsnprintf": _vsnprintf, "_sscanf": _sscanf, "_sysconf": _sysconf, "_fread": _fread, "_abort": _abort, "_isdigit": _isdigit, "_strtoll": _strtoll, "__addDays": __addDays, "_fabs": _fabs, "_floor": _floor, "__reallyNegative": __reallyNegative, "_fseek": _fseek, "___cxa_bad_typeid": ___cxa_bad_typeid, "_write": _write, "___cxa_allocate_exception": ___cxa_allocate_exception, "_stat": _stat, "___cxa_pure_virtual": ___cxa_pure_virtual, "_vasprintf": _vasprintf, "_catopen": _catopen, "___ctype_toupper_loc": ___ctype_toupper_loc, "___ctype_tolower_loc": ___ctype_tolower_loc, "_llvm_eh_typeid_for": _llvm_eh_typeid_for, "_pwrite": _pwrite, "_strerror_r": _strerror_r, "_time": _time, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "NaN": NaN, "Infinity": Infinity, "___fsmu8": ___fsmu8, "__ZTVN10__cxxabiv117__class_type_infoE": __ZTVN10__cxxabiv117__class_type_infoE, "_stdout": _stdout, "___dso_handle": ___dso_handle, "_stdin": _stdin, "__ZTVN10__cxxabiv120__si_class_type_infoE": __ZTVN10__cxxabiv120__si_class_type_infoE, "_stderr": _stderr }, buffer);
var _memcmp = Module["_memcmp"] = asm["_memcmp"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _free = Module["_free"] = asm["_free"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _sass_compile_emscripten = Module["_sass_compile_emscripten"] = asm["_sass_compile_emscripten"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_iiiiiiddi = Module["dynCall_iiiiiiddi"] = asm["dynCall_iiiiiiddi"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiii = Module["dynCall_iiiiiii"] = asm["dynCall_iiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viiiddddi = Module["dynCall_viiiddddi"] = asm["dynCall_viiiddddi"];
var dynCall_iddddiii = Module["dynCall_iddddiii"] = asm["dynCall_iddddiii"];
var dynCall_iiiiiiiiiiii = Module["dynCall_iiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiii"];
var dynCall_vidi = Module["dynCall_vidi"] = asm["dynCall_vidi"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viiiiiiiiiiiiiii = Module["dynCall_viiiiiiiiiiiiiii"] = asm["dynCall_viiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_ddd = Module["dynCall_ddd"] = asm["dynCall_ddd"];
var dynCall_fiii = Module["dynCall_fiii"] = asm["dynCall_fiii"];
var dynCall_viiidi = Module["dynCall_viiidi"] = asm["dynCall_viiidi"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_viiiiiiiiii = Module["dynCall_viiiiiiiiii"] = asm["dynCall_viiiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_diii = Module["dynCall_diii"] = asm["dynCall_diii"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };
// TODO: strip out parts of this we do not need
//======= begin closure i64 code =======
// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */
var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };
  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.
    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };
  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.
  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};
  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }
    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };
  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };
  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };
  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }
    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }
    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));
    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };
  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.
  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;
  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;
  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);
  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);
  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);
  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);
  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);
  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);
  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };
  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };
  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }
    if (this.isZero()) {
      return '0';
    }
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }
    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));
    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);
      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };
  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };
  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };
  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };
  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };
  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };
  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };
  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };
  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };
  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }
    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }
    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };
  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };
  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.
    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;
    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;
    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };
  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };
  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }
    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }
    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }
    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.
    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;
    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;
    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };
  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }
    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }
    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));
      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);
      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }
      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }
      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };
  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };
  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };
  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };
  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };
  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };
  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };
  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };
  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };
  //======= begin jsbn =======
  var navigator = { appName: 'Modern Browser' }; // polyfill a little
  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/
  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */
  // Basic JavaScript BN library - subset useful for RSA encryption.
  // Bits per digit
  var dbits;
  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);
  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }
  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }
  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.
  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }
  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);
  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;
  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }
  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }
  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }
  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }
  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }
  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }
  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }
  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }
  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }
  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }
  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }
  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }
  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }
  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }
  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }
  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }
  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }
  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }
  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }
  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }
  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }
  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }
  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;
  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }
  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }
  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }
  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }
  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }
  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }
  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;
  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }
  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }
  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }
  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;
  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;
  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);
  // jsbn2 stuff
  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }
  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }
  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }
  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }
  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }
  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }
  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }
  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }
  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;
  //======= end jsbn =======
  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();
//======= end closure i64 code =======
// === Auto-generated postamble setup entry stuff ===
if (memoryInitializer) {
  function applyData(data) {
    HEAPU8.set(data, STATIC_BASE);
  }
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    applyData(Module['readBinary'](memoryInitializer));
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      applyData(data);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}
function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;
var initialStackTop;
var preloadStartTime = null;
var calledMain = false;
dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}
Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');
  args = args || [];
  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }
  ensureInitRuntime();
  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);
  initialStackTop = STACKTOP;
  try {
    var ret = Module['_main'](argc, argv, 0);
    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}
function run(args) {
  args = args || Module['arguments'];
  if (preloadStartTime === null) preloadStartTime = Date.now();
  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }
  preRun();
  if (runDependencies > 0) {
    // a preRun added a dependency, run will be called later
    return;
  }
  function doRun() {
    ensureInitRuntime();
    preMain();
    Module['calledRun'] = true;
    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }
    postRun();
  }
  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;
function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;
  // exit the runtime
  exitRuntime();
  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371
  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;
function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }
  ABORT = true;
  EXITSTATUS = 1;
  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;
// {{PRE_RUN_ADDITIONS}}
if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}
// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}
run();
// {{POST_RUN_ADDITIONS}}
// {{MODULE_ADDITIONS}}
